/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ce){for(var e=[],r=0,h=ce.length;r<h;r++)e[r]=Ee[ce[r]];return e};define(Ee[173],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=e.LoaderEventType=e.$U=void 0,e.$U=!1;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,L=new Map,T=new Map,$=new Map;function l(p,c){p.has(c.detail)||p.set(c.detail,-c.timestamp)}function C(p,c){const g=p.get(c.detail);g&&(g>=0||p.set(c.detail,g+c.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((p,c)=>p.timestamp-c.timestamp));for(const p of E)switch(p.type){case r.BeginLoadingScript:l(R,p);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:C(R,p);break;case r.BeginInvokeFactory:l(L,p);break;case r.EndInvokeFactory:C(L,p);break;case r.NodeBeginNativeRequire:l(T,p);break;case r.NodeEndNativeRequire:C(T,p);break;case r.NodeBeginEvaluatingScript:l($,p);break;case r.NodeEndEvaluatingScript:C($,p);break}let u=0;T.forEach(p=>u+=p);function P(p){const c=[];return p.forEach((g,f)=>c.push([f,g])),c}return{amdLoad:P(R),amdInvoke:P(L),nodeRequire:P(T),nodeEval:P($),nodeRequireTotal:u}}static toMarkdownTable(R,L){let T="";const $=[];return R.forEach((l,C)=>{$[C]=l.length}),L.forEach(l=>{l.forEach((C,E)=>{typeof C>"u"&&(C=l[E]="-");const u=C.toString().length;$[E]=Math.max(u,$[E])})}),R.forEach((l,C)=>{T+=`| ${l+" ".repeat($[C]-l.toString().length)} `}),T+=`|
`,R.forEach((l,C)=>{T+=`| ${"-".repeat($[C])} `}),T+=`|
`,L.forEach(l=>{l.forEach((C,E)=>{typeof C<"u"&&(T+=`| ${C+" ".repeat($[E]-C.toString().length)} `)}),T+=`|
`}),T}}e.$V=h}),define(Ee[132],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nb=void 0,e.$gb=r,e.$hb=h,e.$ib=A,e.$jb=R,e.$kb=L,e.$lb=T,e.$mb=$,e.$ob=C,e.$pb=E,e.$qb=u,e.$rb=P,e.$sb=p;function r(c,g){const f=h(c,g);if(f!==-1)return c[f]}function h(c,g,f=c.length-1){for(let m=f;m>=0;m--){const n=c[m];if(g(n))return m}return-1}function A(c,g){const f=R(c,g);return f===-1?void 0:c[f]}function R(c,g,f=0,m=c.length){let n=f,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?n=i+1:o=i}return n-1}function L(c,g){const f=T(c,g);return f===c.length?void 0:c[f]}function T(c,g,f=0,m=c.length){let n=f,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?o=i:n=i+1}return n}function $(c,g,f=0,m=c.length){const n=T(c,g,f,m);return n===c.length?-1:n}class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const f=R(this.e,g,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$nb=l;function C(c,g){if(c.length===0)return;let f=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,f)>0&&(f=n)}return f}function E(c,g){if(c.length===0)return;let f=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,f)>=0&&(f=n)}return f}function u(c,g){return C(c,(f,m)=>-g(f,m))}function P(c,g){if(c.length===0)return-1;let f=0;for(let m=1;m<c.length;m++){const n=c[m];g(n,c[f])>0&&(f=m)}return f}function p(c,g){for(const f of c){const m=g(f);if(m!==void 0)return m}}}),define(Ee[27],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ee[79],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=r,e.$L=h,e.$M=A,e.$N=R;function r(L,T){const $=Object.create(null);for(const l of L){const C=T(l);let E=$[C];E||(E=$[C]=[]),E.push(l)}return $}function h(L,T){const $=[],l=[];for(const C of L)T.has(C)||$.push(C);for(const C of T)L.has(C)||l.push(C);return{removed:$,added:l}}function A(L,T){const $=[],l=[];for(const[C,E]of L)T.has(C)||$.push(E);for(const[C,E]of T)L.has(C)||l.push(E);return{removed:$,added:l}}function R(L,T){const $=new Set;for(const l of T)L.has(l)&&$.add(l);return $}}),define(Ee[59],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=h,e.$8h=A,e.$9h=R;function r(L){return(T,$,l)=>{let C=null,E=null;if(typeof l.value=="function"?(C="value",E=l.value):typeof l.get=="function"&&(C="get",E=l.get),!E)throw new Error("not supported");l[C]=L(E,$)}}function h(L,T,$){let l=null,C=null;if(typeof $.value=="function"?(l="value",C=$.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(l="get",C=$.get),!C)throw new Error("not supported");const E=`$memoize$${T}`;$[l]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,u)}),this[E]}}function A(L,T,$){return r((l,C)=>{const E=`$debounce$${C}`,u=`$debounce$result$${C}`;return function(...P){this[u]||(this[u]=$?$():void 0),clearTimeout(this[E]),T&&(this[u]=T(this[u],...P),P=[this[u]]),this[E]=setTimeout(()=>{l.apply(this,P),this[u]=$?$():void 0},L)}})}function R(L,T,$){return r((l,C)=>{const E=`$throttle$timer$${C}`,u=`$throttle$result$${C}`,P=`$throttle$lastRun$${C}`,p=`$throttle$pending$${C}`;return function(...c){if(this[u]||(this[u]=$?$():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[u]=T(this[u],...c)),this[p])return;const g=this[P]+L;g<=Date.now()?(this[P]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[P]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0},g-Date.now()))}})}}),define(Ee[14],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=e.$cb=e.$bb=e.$ab=e.$_=e.$0=e.$6=e.$Y=e.$X=void 0,e.setUnexpectedErrorHandler=h,e.$1=A,e.$2=R,e.$3=L,e.$4=T,e.$5=l,e.$7=E,e.$8=u,e.$9=P,e.$$=c;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$X=r,e.$Y=new r;function h(i){e.$Y.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(i){l(i)||e.$Y.onUnexpectedError(i)}function L(i){l(i)||e.$Y.onUnexpectedExternalError(i)}function T(i){if(i instanceof Error){const{name:t,message:s}=i,d=i.stacktrace||i.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const $="Canceled";function l(i){return i instanceof C?!0:i instanceof Error&&i.name===$&&i.message===$}class C extends Error{constructor(){super($),this.name=this.message}}e.$6=C;function E(){const i=new Error($);return i.name=i.message,i}function u(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function P(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class p extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$0=p;function c(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$_=g;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$ab=f;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$bb=m;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$cb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$db=o}),define(Ee[19],Se([1,0,14,132]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$tb=A,e.$ub=R,e.$vb=L,e.$wb=T,e.$xb=$,e.$yb=l,e.$zb=C,e.$Ab=E,e.$Bb=u,e.$Cb=P,e.$Db=p,e.$Eb=c,e.$Fb=g,e.top=f,e.$Hb=m,e.$Ib=o,e.$Jb=i,e.$Kb=t,e.$Lb=s,e.$Mb=d,e.$Nb=a,e.$Ob=w,e.$Pb=y,e.$Qb=D,e.$Rb=S,e.$Sb=I,e.$Tb=k,e.$Ub=b,e.$Vb=v,e.$Wb=N,e.$Xb=O,e.$Yb=F,e.$Zb=j,e.$1b=B,e.$2b=M,e.$3b=W,e.$4b=_,e.$5b=re,e.$6b=z,e.$7b=ee,e.$8b=ue,e.$$b=$e;function A(oe,te=0){return oe[oe.length-(1+te)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function L(oe,te,le=(he,X)=>he===X){if(oe===te)return!0;if(!oe||!te||oe.length!==te.length)return!1;for(let he=0,X=oe.length;he<X;he++)if(!le(oe[he],te[he]))return!1;return!0}function T(oe,te){const le=oe.length-1;te<le&&(oe[te]=oe[le]),oe.pop()}function $(oe,te,le){return l(oe.length,he=>le(oe[he],te))}function l(oe,te){let le=0,he=oe-1;for(;le<=he;){const X=(le+he)/2|0,ae=te(X);if(ae<0)le=X+1;else if(ae>0)he=X-1;else return X}return-(le+1)}function C(oe,te,le){if(oe=oe|0,oe>=te.length)throw new TypeError("invalid index");const he=te[Math.floor(te.length*Math.random())],X=[],ae=[],pe=[];for(const be of te){const Me=le(be,he);Me<0?X.push(be):Me>0?ae.push(be):pe.push(be)}return oe<X.length?C(oe,X,le):oe<X.length+pe.length?pe[0]:C(oe-(X.length+pe.length),ae,le)}function E(oe,te){const le=[];let he;for(const X of oe.slice(0).sort(te))!he||te(he[0],X)!==0?(he=[X],le.push(he)):he.push(X);return le}function*u(oe,te){let le,he;for(const X of oe)he!==void 0&&te(he,X)?le.push(X):(le&&(yield le),le=[X]),he=X;le&&(yield le)}function P(oe,te){for(let le=0;le<=oe.length;le++)te(le===0?void 0:oe[le-1],le===oe.length?void 0:oe[le])}function p(oe,te){for(let le=0;le<oe.length;le++)te(le===0?void 0:oe[le-1],oe[le],le+1===oe.length?void 0:oe[le+1])}function c(oe,te,le){const he=[];function X(be,Me,We){if(Me===0&&We.length===0)return;const ke=he[he.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Me,ke.toInsert.push(...We)):he.push({start:be,deleteCount:Me,toInsert:We})}let ae=0,pe=0;for(;;){if(ae===oe.length){X(ae,0,te.slice(pe));break}if(pe===te.length){X(ae,oe.length-ae,[]);break}const be=oe[ae],Me=te[pe],We=le(be,Me);We===0?(ae+=1,pe+=1):We<0?(X(ae,1,[]),ae+=1):We>0&&(X(ae,0,[Me]),pe+=1)}return he}function g(oe,te,le){const he=c(oe,te,le),X=[],ae=[];for(const pe of he)X.push(...oe.slice(pe.start,pe.start+pe.deleteCount)),ae.push(...pe.toInsert);return{removed:X,added:ae}}function f(oe,te,le){if(le===0)return[];const he=oe.slice(0,le).sort(te);return n(oe,te,he,le,oe.length),he}function m(oe,te,le,he,X){return le===0?Promise.resolve([]):new Promise((ae,pe)=>{(async()=>{const be=oe.length,Me=oe.slice(0,le).sort(te);for(let We=le,ke=Math.min(le+he,be);We<be;We=ke,ke=Math.min(ke+he,be)){if(We>le&&await new Promise(Ie=>setTimeout(Ie)),X&&X.isCancellationRequested)throw new r.$6;n(oe,te,Me,We,ke)}return Me})().then(ae,pe)})}function n(oe,te,le,he,X){for(const ae=le.length;he<X;he++){const pe=oe[he];if(te(pe,le[ae-1])<0){le.pop();const be=(0,h.$lb)(le,Me=>te(pe,Me)<0);le.splice(be,0,pe)}}}function o(oe){return oe.filter(te=>!!te)}function i(oe){let te=0;for(let le=0;le<oe.length;le++)oe[le]&&(oe[te]=oe[le],te+=1);oe.length=te}function t(oe,te,le){oe.splice(le,0,oe.splice(te,1)[0])}function s(oe){return!Array.isArray(oe)||oe.length===0}function d(oe){return Array.isArray(oe)&&oe.length>0}function a(oe,te=le=>le){const le=new Set;return oe.filter(he=>{const X=te(he);return le.has(X)?!1:(le.add(X),!0)})}function w(oe){const te=new Set;return le=>{const he=oe(le);return te.has(he)?!1:(te.add(he),!0)}}function y(oe,te){return oe.length>0?oe[0]:te}function D(oe,te){return oe.length>0?oe[oe.length-1]:te}function S(oe,te,le=(he,X)=>he===X){let he=0;for(let X=0,ae=Math.min(oe.length,te.length);X<ae&&le(oe[X],te[X]);X++)he++;return he}function I(oe,te){let le=typeof te=="number"?oe:0;typeof te=="number"?le=oe:(le=0,te=oe);const he=[];if(le<=te)for(let X=le;X<te;X++)he.push(X);else for(let X=le;X>te;X--)he.push(X);return he}function k(oe,te,le){return oe.reduce((he,X)=>(he[te(X)]=le?le(X):X,he),Object.create(null))}function b(oe,te){return oe.push(te),()=>v(oe,te)}function v(oe,te){const le=oe.indexOf(te);if(le>-1)return oe.splice(le,1),te}function N(oe,te,le){const he=oe.slice(0,te),X=oe.slice(te);return he.concat(le,X)}function O(oe,te){let le;if(typeof te=="number"){let he=te;le=()=>{const X=Math.sin(he++)*179426549;return X-Math.floor(X)}}else le=Math.random;for(let he=oe.length-1;he>0;he-=1){const X=Math.floor(le()*(he+1)),ae=oe[he];oe[he]=oe[X],oe[X]=ae}}function F(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.unshift(te))}function j(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.push(te))}function B(oe,te){for(const le of te)oe.push(le)}function M(oe,te){return Array.isArray(oe)?oe.map(te):te(oe)}function W(oe){return Array.isArray(oe)?oe:[oe]}function _(oe){return oe[Math.floor(Math.random()*oe.length)]}function re(oe,te,le){const he=G(oe,te),X=oe.length,ae=le.length;oe.length=X+ae;for(let pe=X-1;pe>=he;pe--)oe[pe+ae]=oe[pe];for(let pe=0;pe<ae;pe++)oe[pe+he]=le[pe]}function z(oe,te,le,he){const X=G(oe,te);let ae=oe.splice(X,le);return ae===void 0&&(ae=[]),re(oe,X,he),ae}function G(oe,te){return te<0?Math.max(te+oe.length,0):Math.min(te,oe.length)}var J;(function(oe){function te(ae){return ae<0}oe.isLessThan=te;function le(ae){return ae<=0}oe.isLessThanOrEqual=le;function he(ae){return ae>0}oe.isGreaterThan=he;function X(ae){return ae===0}oe.isNeitherLessOrGreaterThan=X,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function ee(oe,te){return(le,he)=>te(oe(le),oe(he))}function ue(...oe){return(te,le)=>{for(const he of oe){const X=he(te,le);if(!J.isNeitherLessOrGreaterThan(X))return X}return J.neitherLessOrGreaterThan}}const ne=(oe,te)=>oe-te;e.$9b=ne;const De=(oe,te)=>(0,e.$9b)(oe?1:0,te?1:0);e.$0b=De;function $e(oe){return(te,le)=>-oe(te,le)}class Q{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const he=le===this.c?null:this.g.slice(this.c,le);return this.c=le,he}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const he=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,he}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$_b=Q;class U{static{this.empty=new U(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new U(le=>this.iterate(he=>te(he)?le(he):!0))}map(te){return new U(le=>this.iterate(he=>le(te(he))))}some(te){let le=!1;return this.iterate(he=>(le=te(he),!le)),le}findFirst(te){let le;return this.iterate(he=>te(he)?(le=he,!1):!0),le}findLast(te){let le;return this.iterate(he=>(te(he)&&(le=he),!0)),le}findLastMaxBy(te){let le,he=!0;return this.iterate(X=>((he||J.isGreaterThan(te(X,le)))&&(he=!1,le=X),!0)),le}}e.$ac=U;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const he=Array.from(te.keys()).sort((X,ae)=>le(te[X],te[ae]));return new se(he)}apply(te){return te.map((le,he)=>te[this.c[he]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$bc=se}),define(Ee[66],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$fd=A,e.$gd=R,e.$hd=L,e.$id=T,e.$jd=$;function h(l,C){if(!l)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function A(l,C="Unreachable"){throw new Error(C)}function R(l,C="unexpected state"){if(!l)throw new r.$db(`Assertion Failed: ${C}`)}function L(l){l||(0,r.$2)(new r.$db("Soft Assertion Failed"))}function T(l){if(!l()){debugger;l(),(0,r.$2)(new r.$db("Assertion Failed"))}}function $(l,C){let E=0;for(;E<l.length-1;){const u=l[E],P=l[E+1];if(!C(u,P))return!1;E++}return!0}});var zn=this&&this.__createBinding||(Object.create?function(ce,e,r,h){h===void 0&&(h=r);var A=Object.getOwnPropertyDescriptor(e,r);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ce,h,A)}:function(ce,e,r,h){h===void 0&&(h=r),ce[h]=e[r]}),Un=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),Ue=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var r in ce)r!=="default"&&Object.prototype.hasOwnProperty.call(ce,r)&&zn(e,ce,r);return Un(e,ce),e};define(Ee[174],Se([1,0,19]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=A,e.$9c=R,e.$0c=L,e.$$c=T,e.$_c=$,e.$ad=l,r=Ue(r);const h=(P,p)=>P===p;e.$7c=h;function A(P=e.$7c){return(p,c)=>r.$vb(p,c,P)}function R(){return(P,p)=>JSON.stringify(P)===JSON.stringify(p)}function L(){return(P,p)=>P.equals(p)}function T(P,p,c){if(c!==void 0){const g=P;return g==null||p===void 0||p===null?p===g:c(g,p)}else{const g=P;return(f,m)=>f==null||m===void 0||m===null?m===f:g(f,m)}}function $(P,p){if(P===p)return!0;if(Array.isArray(P)&&Array.isArray(p)){if(P.length!==p.length)return!1;for(let c=0;c<P.length;c++)if(!$(P[c],p[c]))return!1;return!0}if(P&&typeof P=="object"&&p&&typeof p=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(p)===Object.prototype){const c=P,g=p,f=Object.keys(c),m=Object.keys(g),n=new Set(m);if(f.length!==m.length)return!1;for(const o of f)if(!n.has(o)||!$(c[o],g[o]))return!1;return!0}return!1}function l(P){return JSON.stringify(u(P))}let C=0;const E=new WeakMap;function u(P){if(Array.isArray(P))return P.map(u);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const p=P,c=Object.create(null);for(const g of Object.keys(p).sort())c[g]=u(p[g]);return c}else{let p=E.get(P);return p===void 0&&(p=C++,E.set(P,p)),p+"----2b76a038c20c4bcc"}return P}}),define(Ee[80],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=r;function r(h,A){const R=this;let L=!1,T;return function(){if(L)return T;if(L=!0,A)try{T=h.apply(R,arguments)}finally{A()}else T=h.apply(R,arguments);return T}}}),define(Ee[133],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$xP=r,e.$yP=new r("id#")}),define(Ee[40],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=A;const R=Object.freeze([]);function L(){return R}h.empty=L;function*T(s){yield s}h.single=T;function $(s){return A(s)?s:T(s)}h.wrap=$;function l(s){return s||R}h.from=l;function*C(s){for(let d=s.length-1;d>=0;d--)yield s[d]}h.reverse=C;function E(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=E;function u(s){return s[Symbol.iterator]().next().value}h.first=u;function P(s,d){let a=0;for(const w of s)if(d(w,a++))return!0;return!1}h.some=P;function p(s,d){for(const a of s)if(d(a))return a}h.find=p;function*c(s,d){for(const a of s)d(a)&&(yield a)}h.filter=c;function*g(s,d){let a=0;for(const w of s)yield d(w,a++)}h.map=g;function*f(s,d){let a=0;for(const w of s)yield*d(w,a++)}h.flatMap=f;function*m(...s){for(const d of s)yield*d}h.concat=m;function n(s,d,a){let w=a;for(const y of s)w=d(w,y);return w}h.reduce=n;function*o(s,d,a=s.length){for(d<0&&(d+=s.length),a<0?a+=s.length:a>s.length&&(a=s.length);d<a;d++)yield s[d]}h.slice=o;function i(s,d=Number.POSITIVE_INFINITY){const a=[];if(d===0)return[a,s];const w=s[Symbol.iterator]();for(let y=0;y<d;y++){const D=w.next();if(D.done)return[a,h.empty()];a.push(D.value)}return[a,{[Symbol.iterator](){return w}}]}h.consume=i;async function t(s){const d=[];for await(const a of s)d.push(a);return Promise.resolve(d)}h.asyncToArray=t})(r||(e.Iterable=r={}))}),define(Ee[175],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=L,e.$Rn=E,e.$Sn=u,e.$Tn=P,e.$Un=p,e.$Vn=c,e.$Wn=g,e.$Xn=f,e.$Yn=m,e.$Zn=n,e.$1n=o,e.$2n=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,s=!1){let d=0;const a=t.length;let w="",y=0,D=h.Unknown,S=r.None;function I(j){let B=0,M=0;for(;B<j;){const W=t.charCodeAt(d);if(W>=C._0&&W<=C._9)M=M*16+W-C._0;else if(W>=C.A&&W<=C.F)M=M*16+W-C.A+10;else if(W>=C.a&&W<=C.f)M=M*16+W-C.a+10;else break;d++,B++}return B<j&&(M=-1),M}function k(j){d=j,w="",y=0,D=h.Unknown,S=r.None}function b(){const j=d;if(t.charCodeAt(d)===C._0)d++;else for(d++;d<t.length&&l(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===C.dot)if(d++,d<t.length&&l(t.charCodeAt(d)))for(d++;d<t.length&&l(t.charCodeAt(d));)d++;else return S=r.UnexpectedEndOfNumber,t.substring(j,d);let B=d;if(d<t.length&&(t.charCodeAt(d)===C.E||t.charCodeAt(d)===C.e))if(d++,(d<t.length&&t.charCodeAt(d)===C.plus||t.charCodeAt(d)===C.minus)&&d++,d<t.length&&l(t.charCodeAt(d))){for(d++;d<t.length&&l(t.charCodeAt(d));)d++;B=d}else S=r.UnexpectedEndOfNumber;return t.substring(j,B)}function v(){let j="",B=d;for(;;){if(d>=a){j+=t.substring(B,d),S=r.UnexpectedEndOfString;break}const M=t.charCodeAt(d);if(M===C.doubleQuote){j+=t.substring(B,d),d++;break}if(M===C.backslash){if(j+=t.substring(B,d),d++,d>=a){S=r.UnexpectedEndOfString;break}switch(t.charCodeAt(d++)){case C.doubleQuote:j+='"';break;case C.backslash:j+="\\";break;case C.slash:j+="/";break;case C.b:j+="\b";break;case C.f:j+="\f";break;case C.n:j+=`
`;break;case C.r:j+="\r";break;case C.t:j+="	";break;case C.u:{const _=I(4);_>=0?j+=String.fromCharCode(_):S=r.InvalidUnicode;break}default:S=r.InvalidEscapeCharacter}B=d;continue}if(M>=0&&M<=31)if($(M)){j+=t.substring(B,d),S=r.UnexpectedEndOfString;break}else S=r.InvalidCharacter;d++}return j}function N(){if(w="",S=r.None,y=d,d>=a)return y=a,D=h.EOF;let j=t.charCodeAt(d);if(T(j)){do d++,w+=String.fromCharCode(j),j=t.charCodeAt(d);while(T(j));return D=h.Trivia}if($(j))return d++,w+=String.fromCharCode(j),j===C.carriageReturn&&t.charCodeAt(d)===C.lineFeed&&(d++,w+=`
`),D=h.LineBreakTrivia;switch(j){case C.openBrace:return d++,D=h.OpenBraceToken;case C.closeBrace:return d++,D=h.CloseBraceToken;case C.openBracket:return d++,D=h.OpenBracketToken;case C.closeBracket:return d++,D=h.CloseBracketToken;case C.colon:return d++,D=h.ColonToken;case C.comma:return d++,D=h.CommaToken;case C.doubleQuote:return d++,w=v(),D=h.StringLiteral;case C.slash:{const B=d-1;if(t.charCodeAt(d+1)===C.slash){for(d+=2;d<a&&!$(t.charCodeAt(d));)d++;return w=t.substring(B,d),D=h.LineCommentTrivia}if(t.charCodeAt(d+1)===C.asterisk){d+=2;const M=a-1;let W=!1;for(;d<M;){if(t.charCodeAt(d)===C.asterisk&&t.charCodeAt(d+1)===C.slash){d+=2,W=!0;break}d++}return W||(d++,S=r.UnexpectedEndOfComment),w=t.substring(B,d),D=h.BlockCommentTrivia}return w+=String.fromCharCode(j),d++,D=h.Unknown}case C.minus:if(w+=String.fromCharCode(j),d++,d===a||!l(t.charCodeAt(d)))return D=h.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return w+=b(),D=h.NumericLiteral;default:for(;d<a&&O(j);)d++,j=t.charCodeAt(d);if(y!==d){switch(w=t.substring(y,d),w){case"true":return D=h.TrueKeyword;case"false":return D=h.FalseKeyword;case"null":return D=h.NullKeyword}return D=h.Unknown}return w+=String.fromCharCode(j),d++,D=h.Unknown}}function O(j){if(T(j)||$(j))return!1;switch(j){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function F(){let j;do j=N();while(j>=h.LineCommentTrivia&&j<=h.Trivia);return j}return{setPosition:k,getPosition:()=>d,scan:s?F:N,getToken:()=>D,getTokenValue:()=>w,getTokenOffset:()=>y,getTokenLength:()=>d-y,getTokenError:()=>S}}function T(t){return t===C.space||t===C.tab||t===C.verticalTab||t===C.formFeed||t===C.nonBreakingSpace||t===C.ogham||t>=C.enQuad&&t<=C.zeroWidthSpace||t===C.narrowNoBreakSpace||t===C.mathematicalSpace||t===C.ideographicSpace||t===C.byteOrderMark}function $(t){return t===C.lineFeed||t===C.carriageReturn||t===C.lineSeparator||t===C.paragraphSeparator}function l(t){return t>=C._0&&t<=C._9}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function E(t,s){const d=[],a=new Object;let w;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function S(I,k,b,v){y.value=I,y.offset=k,y.length=b,y.type=v,y.colonOffset=void 0,w=y}try{n(t,{onObjectBegin:(I,k)=>{if(s<=I)throw a;w=void 0,D=s>I,d.push("")},onObjectProperty:(I,k,b)=>{if(s<k||(S(I,k,b,"property"),d[d.length-1]=I,s<=k+b))throw a},onObjectEnd:(I,k)=>{if(s<=I)throw a;w=void 0,d.pop()},onArrayBegin:(I,k)=>{if(s<=I)throw a;w=void 0,d.push(0)},onArrayEnd:(I,k)=>{if(s<=I)throw a;w=void 0,d.pop()},onLiteralValue:(I,k,b)=>{if(s<k||(S(I,k,b,i(I)),s<=k+b))throw a},onSeparator:(I,k,b)=>{if(s<=k)throw a;if(I===":"&&w&&w.type==="property")w.colonOffset=k,D=!1,w=void 0;else if(I===","){const v=d[d.length-1];typeof v=="number"?d[d.length-1]=v+1:(D=!0,d[d.length-1]=""),w=void 0}}})}catch(I){if(I!==a)throw I}return{path:d,previousNode:w,isAtPropertyKey:D,matches:I=>{let k=0;for(let b=0;k<I.length&&b<d.length;b++)if(I[k]===d[b]||I[k]==="*")k++;else if(I[k]!=="**")return!1;return k===I.length}}}function u(t,s=[],d=R.DEFAULT){let a=null,w=[];const y=[];function D(I){Array.isArray(w)?w.push(I):a!==null&&(w[a]=I)}return n(t,{onObjectBegin:()=>{const I={};D(I),y.push(w),w=I,a=null},onObjectProperty:I=>{a=I},onObjectEnd:()=>{w=y.pop()},onArrayBegin:()=>{const I=[];D(I),y.push(w),w=I,a=null},onArrayEnd:()=>{w=y.pop()},onLiteralValue:D,onError:(I,k,b)=>{s.push({error:I,offset:k,length:b})}},d),w[0]}function P(t,s=[],d=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(I){a.type==="property"&&(a.length=I-a.offset,a=a.parent)}function y(I){return a.children.push(I),I}n(t,{onObjectBegin:I=>{a=y({type:"object",offset:I,length:-1,parent:a,children:[]})},onObjectProperty:(I,k,b)=>{a=y({type:"property",offset:k,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:I,offset:k,length:b,parent:a})},onObjectEnd:(I,k)=>{a.length=I+k-a.offset,a=a.parent,w(I+k)},onArrayBegin:(I,k)=>{a=y({type:"array",offset:I,length:-1,parent:a,children:[]})},onArrayEnd:(I,k)=>{a.length=I+k-a.offset,a=a.parent,w(I+k)},onLiteralValue:(I,k,b)=>{y({type:i(I),offset:k,length:b,parent:a,value:I}),w(k+b)},onSeparator:(I,k,b)=>{a.type==="property"&&(I===":"?a.colonOffset=k:I===","&&w(k))},onError:(I,k,b)=>{s.push({error:I,offset:k,length:b})}},d);const S=a.children[0];return S&&delete S.parent,S}function p(t,s){if(!t)return;let d=t;for(const a of s)if(typeof a=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let w=!1;for(const y of d.children)if(Array.isArray(y.children)&&y.children[0].value===a){d=y.children[1],w=!0;break}if(!w)return}else{const w=a;if(d.type!=="array"||w<0||!Array.isArray(d.children)||w>=d.children.length)return;d=d.children[w]}return d}function c(t){if(!t.parent||!t.parent.children)return[];const s=c(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const s=Object.create(null);for(const d of t.children){const a=d.children[1];a&&(s[d.children[0].value]=g(a))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}function m(t,s,d=!1){if(f(t,s,d)){const a=t.children;if(Array.isArray(a))for(let w=0;w<a.length&&a[w].offset<=s;w++){const y=m(a[w],s,d);if(y)return y}return t}}function n(t,s,d=R.DEFAULT){const a=L(t,!1);function w(ue){return ue?()=>ue(a.getTokenOffset(),a.getTokenLength()):()=>!0}function y(ue){return ue?ne=>ue(ne,a.getTokenOffset(),a.getTokenLength()):()=>!0}const D=w(s.onObjectBegin),S=y(s.onObjectProperty),I=w(s.onObjectEnd),k=w(s.onArrayBegin),b=w(s.onArrayEnd),v=y(s.onLiteralValue),N=y(s.onSeparator),O=w(s.onComment),F=y(s.onError),j=d&&d.disallowComments,B=d&&d.allowTrailingComma;function M(){for(;;){const ue=a.scan();switch(a.getTokenError()){case r.InvalidUnicode:W(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:W(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:W(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||W(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:W(A.UnexpectedEndOfString);break;case r.InvalidCharacter:W(A.InvalidCharacter);break}switch(ue){case h.LineCommentTrivia:case h.BlockCommentTrivia:j?W(A.InvalidCommentToken):O();break;case h.Unknown:W(A.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ue}}}function W(ue,ne=[],De=[]){if(F(ue),ne.length+De.length>0){let $e=a.getToken();for(;$e!==h.EOF;){if(ne.indexOf($e)!==-1){M();break}else if(De.indexOf($e)!==-1)break;$e=M()}}}function _(ue){const ne=a.getTokenValue();return ue?v(ne):S(ne),M(),!0}function re(){switch(a.getToken()){case h.NumericLiteral:{let ue=0;try{ue=JSON.parse(a.getTokenValue()),typeof ue!="number"&&(W(A.InvalidNumberFormat),ue=0)}catch{W(A.InvalidNumberFormat)}v(ue);break}case h.NullKeyword:v(null);break;case h.TrueKeyword:v(!0);break;case h.FalseKeyword:v(!1);break;default:return!1}return M(),!0}function z(){return a.getToken()!==h.StringLiteral?(W(A.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(_(!1),a.getToken()===h.ColonToken?(N(":"),M(),ee()||W(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):W(A.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function G(){D(),M();let ue=!1;for(;a.getToken()!==h.CloseBraceToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||W(A.ValueExpected,[],[]),N(","),M(),a.getToken()===h.CloseBraceToken&&B)break}else ue&&W(A.CommaExpected,[],[]);z()||W(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ue=!0}return I(),a.getToken()!==h.CloseBraceToken?W(A.CloseBraceExpected,[h.CloseBraceToken],[]):M(),!0}function J(){k(),M();let ue=!1;for(;a.getToken()!==h.CloseBracketToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||W(A.ValueExpected,[],[]),N(","),M(),a.getToken()===h.CloseBracketToken&&B)break}else ue&&W(A.CommaExpected,[],[]);ee()||W(A.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ue=!0}return b(),a.getToken()!==h.CloseBracketToken?W(A.CloseBracketExpected,[h.CloseBracketToken],[]):M(),!0}function ee(){switch(a.getToken()){case h.OpenBracketToken:return J();case h.OpenBraceToken:return G();case h.StringLiteral:return _(!0);default:return re()}}return M(),a.getToken()===h.EOF?d.allowEmptyContent?!0:(W(A.ValueExpected,[],[]),!1):ee()?(a.getToken()!==h.EOF&&W(A.EndOfFileExpected,[],[]),!0):(W(A.ValueExpected,[],[]),!1)}function o(t,s){const d=L(t),a=[];let w,y=0,D;do switch(D=d.getPosition(),w=d.scan(),w){case h.LineCommentTrivia:case h.BlockCommentTrivia:case h.EOF:y!==D&&a.push(t.substring(y,D)),s!==void 0&&a.push(d.getTokenValue().replace(/[^\r\n]/g,s)),y=d.getPosition();break}while(w!==h.EOF);return a.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$W=r}),define(Ee[81],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const L=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(L){const l=this.b;this.b=T,T.prev=l,l.next=T}else{const l=this.a;this.a=T,T.next=l,l.prev=T}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$6c=h}),define(Ee[29],Se([1,0]),function(ce,e){"use strict";var r,h,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=L,e.$Ac=T,e.$Jc=o;function R(i,t,s){let d=i.get(t);return d===void 0&&(d=s,i.set(t,d)),d}function L(i){const t=[];return i.forEach((s,d)=>{t.push(`${d} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}function T(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}class ${constructor(t,s){this.uri=t,this.value=s}}function l(i){return Array.isArray(i)}class C{static{this.c=t=>t.toString()}constructor(t,s){if(this[r]="ResourceMap",t instanceof C)this.d=new Map(t.d),this.e=s??C.c;else if(l(t)){this.d=new Map,this.e=s??C.c;for(const[d,a]of t)this.set(d,a)}else this.d=new Map,this.e=t??C.c}set(t,s){return this.d.set(this.e(t),new $(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[d,a]of this.d)t(a.value,a.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=C;class E{constructor(t,s){this[h]="ResourceSet",!t||typeof t=="function"?this.c=new C(t):(this.c=new C(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((d,a)=>t.call(s,a,a,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=E;var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class P{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=u.None){const d=this.c.get(t);if(d)return s!==u.None&&this.m(d,s),d.value}set(t,s,d=u.None){let a=this.c.get(t);if(a)a.value=s,d!==u.None&&this.m(a,d);else{switch(a={key:t,value:s,next:void 0,previous:void 0},d){case u.None:this.k(a);break;case u.AsOld:this.j(a);break;case u.AsNew:this.k(a);break;default:this.k(a);break}this.c.set(t,a),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const d=this.g;let a=this.d;for(;a;){if(s?t.bind(s)(a.value,a.key,this):t(a.value,a.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.key,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}values(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.value,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}entries(){const t=this,s=this.g;let d=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:[d.key,d.value],done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,d=this.size;for(;s&&d>t;)this.c.delete(s.key),s=s.next,d--;this.d=s,this.f=d,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,d=this.size;for(;s&&d>t;)this.c.delete(s.key),s=s.previous,d--;this.e=s,this.f=d,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,d=t.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==u.AsOld&&s!==u.AsNew)){if(s===u.AsOld){if(t===this.d)return;const d=t.next,a=t.previous;t===this.e?(a.next=void 0,this.e=a):(d.previous=a,a.next=d),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===u.AsNew){if(t===this.e)return;const d=t.next,a=t.previous;t===this.d?(d.previous=void 0,this.d=d):(d.previous=a,a.next=d),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,d)=>{t.push([d,s])}),t}fromJSON(t){this.clear();for(const[s,d]of t)this.set(s,d)}}e.$Dc=P;class p extends P{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=u.AsNew){return super.get(t,s)}peek(t){return super.get(t,u.None)}set(t,s){return super.set(t,s,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends p{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=c;class g extends p{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=g;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=f;class m{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,d]of t)this.set(s,d)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((d,a)=>{t.call(s,d,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=m;class n{constructor(){this.c=new Map}add(t,s){let d=this.c.get(t);d||(d=new Set,this.c.set(t,d)),d.add(s)}delete(t,s){const d=this.c.get(t);d&&(d.delete(s),d.size===0&&this.c.delete(t))}forEach(t,s){const d=this.c.get(t);d&&d.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=n;function o(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[s,d]of i)if(!t.has(s)||t.get(s)!==d)return!1;for(const[s]of t)if(!i.has(s))return!1;return!0}}),define(Ee[3],Se([1,0,19,79,29,80,40]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=C,e.$Mc=E,e.$Nc=u,e.$Oc=c,e.$Pc=g,e.$Qc=f,e.$Rc=m,e.$Sc=n,e.$Tc=o,e.$4c=I;const T=!1;let $=null;class l{constructor(){this.b=new Map}static{this.a=0}c(v){let N=this.b.get(v);return N||(N={parent:null,source:null,isSingleton:!1,value:v,idx:l.a++},this.b.set(v,N)),N}trackDisposable(v){const N=this.c(v);N.source||(N.source=new Error().stack)}setParent(v,N){const O=this.c(v);O.parent=N}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,N){const O=N.get(v);if(O)return O;const F=v.parent?this.f(this.c(v.parent),N):v;return N.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,v).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(v=10,N){let O;if(N)O=N;else{const W=new Map,_=[...this.b.values()].filter(z=>z.source!==null&&!this.f(z,W).isSingleton);if(_.length===0)return;const re=new Set(_.map(z=>z.value));if(O=_.filter(z=>!(z.parent&&re.has(z.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function F(W){function _(z,G){for(;z.length>0&&G.some(J=>typeof J=="string"?J===z[0]:z[0].match(J));)z.shift()}const re=W.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return _(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new A.$Ic;for(const W of O){const _=F(W);for(let re=0;re<=_.length;re++)j.add(_.slice(0,re).join(`
`),W)}O.sort((0,r.$7b)(W=>W.idx,r.$9b));let B="",M=0;for(const W of O.slice(0,v)){M++;const _=F(W),re=[];for(let z=0;z<_.length;z++){let G=_[z];G=`(shared with ${j.get(_.slice(0,z+1).join(`
`)).size}/${O.length} leaks) at ${G}`;const ee=j.get(_.slice(0,z).join(`
`)),ue=(0,h.$K)([...ee].map(ne=>F(ne)[z]),ne=>ne);delete ue[_[z]];for(const[ne,De]of Object.entries(ue))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}B+=`


==================== Leaking disposable ${M}/${O.length}: ${W.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return O.length>v&&(B+=`


... and ${O.length-v} more leaking disposables

`),{leaks:O,details:B}}}e.$Kc=l;function C(b){$=b}if(T){const b="__is_disposable_tracked__";C(new class{trackDisposable(v){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(N)},3e3)}setParent(v,N){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function E(b){return $?.trackDisposable(b),b}function u(b){$?.markAsDisposed(b)}function P(b,v){$?.setParent(b,v)}function p(b,v){if($)for(const N of b)$.setParent(N,v)}function c(b){return $?.markAsSingleton(b),b}function g(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function f(b){if(L.Iterable.is(b)){const v=[];for(const N of b)if(N)try{N.dispose()}catch(O){v.push(O)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function m(b){for(const v of b)g(v)&&v.dispose();return[]}function n(...b){const v=o(()=>f(b));return p(b,v),v}function o(b){const v=E({dispose:(0,R.$eb)(()=>{u(v),b()})});return v}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return P(v,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),P(v,null))}}e.$Uc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,E(this),P(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Vc=t;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&P(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&P(v,null),v}}e.$Wc=s;class d{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=d;class a{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=a;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let N=v;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,u(this))},this}}e.$Zc=w;class y{constructor(){this.a=new Map}acquire(v,...N){let O=this.a.get(v);O||(O={counter:0,object:this.b(v,...N)},this.a.set(v,O));const{object:F}=O,j=(0,R.$eb)(()=>{--O.counter===0&&(this.c(v,O.object),this.a.delete(v))});return O.counter++,{object:F,dispose:j}}}e.$1c=y;class D{constructor(v){this.a=v}async acquire(v,...N){const O=this.a.acquire(v,...N);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(F){throw O.dispose(),F}}}e.$2c=D;class S{constructor(v){this.object=v}dispose(){}}e.$3c=S;function I(b){const v=new i;try{b(v)}finally{v.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,N,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(v)?.dispose(),this.a.set(v,N)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const N=this.a.get(v);return this.a.delete(v),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=k}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[176],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var he=0;he<le.length;he++){var X=le[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(te,X.key,X)}}function r(te,le,he){return le&&e(te.prototype,le),he&&e(te,he),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return A(te,le);var he=Object.prototype.toString.call(te).slice(8,-1);if(he==="Object"&&te.constructor&&(he=te.constructor.name),he==="Map"||he==="Set")return Array.from(te);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return A(te,le)}}function A(te,le){(le==null||le>te.length)&&(le=te.length);for(var he=0,X=new Array(le);he<le;he++)X[he]=te[he];return X}function R(te,le){var he=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(he)return(he=he.call(te)).next.bind(he);if(Array.isArray(te)||(he=h(te))||le&&te&&typeof te.length=="number"){he&&(te=he);var X=0;return function(){return X>=te.length?{done:!0}:{done:!1,value:te[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=L();function T(te){ce.defaults=te}var $=/[&<>"']/,l=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(le){return u[le]};function p(te,le){if(le){if($.test(te))return te.replace(l,P)}else if(C.test(te))return te.replace(E,P);return te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(te){return te.replace(c,function(le,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var f=/(^|[^\[])\^/g;function m(te,le){te=typeof te=="string"?te:te.source,le=le||"";var he={replace:function(ae,pe){return pe=pe.source||pe,pe=pe.replace(f,"$1"),te=te.replace(ae,pe),he},getRegex:function(){return new RegExp(te,le)}};return he}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(te,le,he){if(te){var X;try{X=decodeURIComponent(g(he)).replace(n,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}le&&!o.test(he)&&(he=w(le,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){t[" "+te]||(s.test(te)?t[" "+te]=te+"/":t[" "+te]=I(te,"/",!0)),te=t[" "+te];var he=te.indexOf(":")===-1;return le.substring(0,2)==="//"?he?le:te.replace(d,"$1")+le:le.charAt(0)==="/"?he?le:te.replace(a,"$1")+le:te+le}var y={exec:function(){}};function D(te){for(var le=1,he,X;le<arguments.length;le++){he=arguments[le];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(te[X]=he[X])}return te}function S(te,le){var he=te.replace(/\|/g,function(pe,be,Me){for(var We=!1,ke=be;--ke>=0&&Me[ke]==="\\";)We=!We;return We?"|":" |"}),X=he.split(/ \|/),ae=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>le)X.splice(le);else for(;X.length<le;)X.push("");for(;ae<X.length;ae++)X[ae]=X[ae].trim().replace(/\\\|/g,"|");return X}function I(te,le,he){var X=te.length;if(X===0)return"";for(var ae=0;ae<X;){var pe=te.charAt(X-ae-1);if(pe===le&&!he)ae++;else if(pe!==le&&he)ae++;else break}return te.slice(0,X-ae)}function k(te,le){if(te.indexOf(le[1])===-1)return-1;for(var he=te.length,X=0,ae=0;ae<he;ae++)if(te[ae]==="\\")ae++;else if(te[ae]===le[0])X++;else if(te[ae]===le[1]&&(X--,X<0))return ae;return-1}function b(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var he="";le>1;)le&1&&(he+=te),le>>=1,te+=te;return he+te}function N(te,le,he,X){var ae=le.href,pe=le.title?p(le.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){X.state.inLink=!0;var Me={type:"link",raw:he,href:ae,title:pe,text:be,tokens:X.inlineTokens(be)};return X.state.inLink=!1,Me}return{type:"image",raw:he,href:ae,title:pe,text:p(be)}}function O(te,le){var he=te.match(/^(\s+)(?:```)/);if(he===null)return le;var X=he[1];return le.split(`
`).map(function(ae){var pe=ae.match(/^\s+/);if(pe===null)return ae;var be=pe[0];return be.length>=X.length?ae.slice(X.length):ae}).join(`
`)}var F=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.space=function(X){var ae=this.rules.block.newline.exec(X);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(X){var ae=this.rules.block.code.exec(X);if(ae){var pe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:I(pe,`
`)}}},le.fences=function(X){var ae=this.rules.block.fences.exec(X);if(ae){var pe=ae[0],be=O(pe,ae[3]||"");return{type:"code",raw:pe,lang:ae[2]?ae[2].trim():ae[2],text:be}}},le.heading=function(X){var ae=this.rules.block.heading.exec(X);if(ae){var pe=ae[2].trim();if(/#$/.test(pe)){var be=I(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(X){var ae=this.rules.block.hr.exec(X);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(X){var ae=this.rules.block.blockquote.exec(X);if(ae){var pe=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(X){var ae=this.rules.block.list.exec(X);if(ae){var pe,be,Me,We,ke,Ie,Te,V,q,Y,x,fe,we=ae[1].trim(),Ne=we.length>1,Ge={type:"list",raw:"",ordered:Ne,start:Ne?+we.slice(0,-1):"",loose:!1,items:[]};we=Ne?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Ne?we:"[*+-]");for(var Je=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(fe=!1,!(!(ae=Je.exec(X))||this.rules.block.hr.test(X)));){if(pe=ae[0],X=X.substring(pe.length),V=ae[2].split(`
`,1)[0],q=X.split(`
`,1)[0],this.options.pedantic?(We=2,x=V.trimLeft()):(We=ae[2].search(/[^ ]/),We=We>4?1:We,x=V.slice(We),We+=ae[1].length),Ie=!1,!V&&/^ *$/.test(q)&&(pe+=q+`
`,X=X.substring(q.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,We-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,We-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,We-1)+"}#");X&&(Y=X.split(`
`,1)[0],V=Y,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(V)||nt.test(V)||tt.test(V)||rt.test(X)));){if(V.search(/[^ ]/)>=We||!V.trim())x+=`
`+V.slice(We);else if(!Ie)x+=`
`+V;else break;!Ie&&!V.trim()&&(Ie=!0),pe+=Y+`
`,X=X.substring(Y.length+1)}Ge.loose||(Te?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Me=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!be,checked:Me,loose:!1,text:x}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=x.trimRight(),Ge.raw=Ge.raw.trimRight();var ct=Ge.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var $t=Ge.items[ke].tokens.filter(function(at){return at.type==="space"}),ht=$t.every(function(at){for(var Pe=at.raw.split(""),Be=0,Ke=R(Pe),Oe;!(Oe=Ke()).done;){var Fe=Oe.value;if(Fe===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&$t.length&&ht&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},le.html=function(X){var ae=this.rules.block.html.exec(X);if(ae){var pe={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},le.def=function(X){var ae=this.rules.block.def.exec(X);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var pe=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(X){var ae=this.rules.block.table.exec(X);if(ae){var pe={type:"table",header:S(ae[1]).map(function(Te){return{text:Te}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ae[0];var be=pe.align.length,Me,We,ke,Ie;for(Me=0;Me<be;Me++)/^ *-+: *$/.test(pe.align[Me])?pe.align[Me]="right":/^ *:-+: *$/.test(pe.align[Me])?pe.align[Me]="center":/^ *:-+ *$/.test(pe.align[Me])?pe.align[Me]="left":pe.align[Me]=null;for(be=pe.rows.length,Me=0;Me<be;Me++)pe.rows[Me]=S(pe.rows[Me],pe.header.length).map(function(Te){return{text:Te}});for(be=pe.header.length,We=0;We<be;We++)pe.header[We].tokens=this.lexer.inline(pe.header[We].text);for(be=pe.rows.length,We=0;We<be;We++)for(Ie=pe.rows[We],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return pe}}},le.lheading=function(X){var ae=this.rules.block.lheading.exec(X);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(X){var ae=this.rules.block.paragraph.exec(X);if(ae){var pe=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(X){var ae=this.rules.block.text.exec(X);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(X){var ae=this.rules.inline.escape.exec(X);if(ae)return{type:"escape",raw:ae[0],text:p(ae[1])}},le.tag=function(X){var ae=this.rules.inline.tag.exec(X);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):p(ae[0]):ae[0]}},le.link=function(X){var ae=this.rules.inline.link.exec(X);if(ae){var pe=ae[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=I(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Me=k(ae[2],"()");if(Me>-1){var We=ae[0].indexOf("!")===0?5:4,ke=We+ae[1].length+Me;ae[2]=ae[2].substring(0,Me),ae[0]=ae[0].substring(0,ke).trim(),ae[3]=""}}var Ie=ae[2],Te="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);V&&(Ie=V[1],Te=V[3])}else Te=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(X,ae){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ae[be.toLowerCase()],!be||!be.href){var Me=pe[0].charAt(0);return{type:"text",raw:Me,text:Me}}return N(pe,be,pe[0],this.lexer)}},le.emStrong=function(X,ae,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(X);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=be[1]||be[2]||"";if(!Me||Me&&(pe===""||this.rules.inline.punctuation.exec(pe))){var We=be[0].length-1,ke,Ie,Te=We,V=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ae=ae.slice(-1*X.length+We);(be=q.exec(ae))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(Ie=ke.length,be[3]||be[4]){Te+=Ie;continue}else if((be[5]||be[6])&&We%3&&!((We+Ie)%3)){V+=Ie;continue}if(Te-=Ie,!(Te>0)){if(Ie=Math.min(Ie,Ie+Te+V),Math.min(We,Ie)%2){var Y=X.slice(1,We+be.index+Ie);return{type:"em",raw:X.slice(0,We+be.index+Ie+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var x=X.slice(2,We+be.index+Ie-1);return{type:"strong",raw:X.slice(0,We+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(X){var ae=this.rules.inline.code.exec(X);if(ae){var pe=ae[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Me=/^ /.test(pe)&&/ $/.test(pe);return be&&Me&&(pe=pe.substring(1,pe.length-1)),pe=p(pe,!0),{type:"codespan",raw:ae[0],text:pe}}},le.br=function(X){var ae=this.rules.inline.br.exec(X);if(ae)return{type:"br",raw:ae[0]}},le.del=function(X){var ae=this.rules.inline.del.exec(X);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(X,ae){var pe=this.rules.inline.autolink.exec(X);if(pe){var be,Me;return pe[2]==="@"?(be=p(this.options.mangle?ae(pe[1]):pe[1]),Me="mailto:"+be):(be=p(pe[1]),Me=be),{type:"link",raw:pe[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.url=function(X,ae){var pe;if(pe=this.rules.inline.url.exec(X)){var be,Me;if(pe[2]==="@")be=p(this.options.mangle?ae(pe[0]):pe[0]),Me="mailto:"+be;else{var We;do We=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(We!==pe[0]);be=p(pe[0]),pe[1]==="www."?Me="http://"+be:Me=be}return{type:"link",raw:pe[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},le.inlineText=function(X,ae){var pe=this.rules.inline.text.exec(X);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):p(pe[0]):pe[0]:be=p(this.options.smartypants?ae(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=m(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=m(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=m(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=m(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=m(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=m(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=m(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=m(B.reflink).replace("label",B._label).replace("ref",j._label).getRegex(),B.nolink=m(B.nolink).replace("ref",j._label).getRegex(),B.reflinkSearch=m(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=D({},B),B.pedantic=D({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=D({},B.normal,{escape:m(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=m(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=D({},B.gfm,{br:m(B.br).replace("{2,}","*").getRegex(),text:m(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(te){var le="",he,X,ae=te.length;for(he=0;he<ae;he++)X=te.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),le+="&#"+X+";";return le}var _=function(){function te(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ce.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:j.normal,inline:B.normal};this.options.pedantic?(X.block=j.pedantic,X.inline=B.pedantic):this.options.gfm&&(X.block=j.gfm,this.options.breaks?X.inline=B.breaks:X.inline=B.gfm),this.tokenizer.rules=X}te.lex=function(X,ae){var pe=new te(ae);return pe.lex(X)},te.lexInline=function(X,ae){var pe=new te(ae);return pe.inlineTokens(X)};var le=te.prototype;return le.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Te,V,q){return V+"    ".repeat(q.length)});for(var be,Me,We,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(be=Te.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.space(X)){X=X.substring(be.raw.length),be.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(be);continue}if(be=this.tokenizer.code(X)){X=X.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(be=this.tokenizer.fences(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.heading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.hr(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.blockquote(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.list(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.html(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.def(X)){X=X.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.lheading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(We=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,V=X.slice(1),q=void 0;pe.options.extensions.startBlock.forEach(function(Y){q=Y.call({lexer:this},V),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(We=X.substring(0,Te+1))}(),this.state.top&&(be=this.tokenizer.paragraph(We))){Me=ae[ae.length-1],ke&&Me.type==="paragraph"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be),ke=We.length!==X.length,X=X.substring(be.raw.length);continue}if(be=this.tokenizer.text(X)){X=X.substring(be.raw.length),Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(X){var Ie="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ae},le.inline=function(X,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:X,tokens:ae}),ae},le.inlineTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]);var be,Me,We,ke=X,Ie,Te,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Te||(V=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.escape(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.tag(X)){X=X.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.link(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.emStrong(X,ke,V)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.codespan(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.br(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.del(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.autolink(X,W)){X=X.substring(be.raw.length),ae.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(X,W))){X=X.substring(be.raw.length),ae.push(be);continue}if(We=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=X.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(Ne){we=Ne.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(We=X.substring(0,x+1))}(),be=this.tokenizer.inlineText(We,M)){X=X.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(V=be.raw.slice(-1)),Te=!0,Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(X){var Y="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ae},r(te,null,[{key:"rules",get:function(){return{block:j,inline:B}}}]),te}(),re=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.code=function(X,ae,pe){var be=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(X,be);Me!=null&&Me!==X&&(pe=!0,X=Me)}return X=X.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+p(be,!0)+'">'+(pe?X:p(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:p(X,!0))+`</code></pre>
`},le.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},le.html=function(X){return X},le.heading=function(X,ae,pe,be){if(this.options.headerIds){var Me=this.options.headerPrefix+be.slug(pe);return"<h"+ae+' id="'+Me+'">'+X+"</h"+ae+`>
`}return"<h"+ae+">"+X+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(X,ae,pe){var be=ae?"ol":"ul",Me=ae&&pe!==1?' start="'+pe+'"':"";return"<"+be+Me+`>
`+X+"</"+be+`>
`},le.listitem=function(X){return"<li>"+X+`</li>
`},le.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(X){return"<p>"+X+`</p>
`},le.table=function(X,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ae+`</table>
`},le.tablerow=function(X){return`<tr>
`+X+`</tr>
`},le.tablecell=function(X,ae){var pe=ae.header?"th":"td",be=ae.align?"<"+pe+' align="'+ae.align+'">':"<"+pe+">";return be+X+("</"+pe+`>
`)},le.strong=function(X){return"<strong>"+X+"</strong>"},le.em=function(X){return"<em>"+X+"</em>"},le.codespan=function(X){return"<code>"+X+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(X){return"<del>"+X+"</del>"},le.link=function(X,ae,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<a href="'+p(X)+'"';return ae&&(be+=' title="'+ae+'"'),be+=">"+pe+"</a>",be},le.image=function(X,ae,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<img src="'+X+'" alt="'+pe+'"';return ae&&(be+=' title="'+ae+'"'),be+=this.options.xhtml?"/>":">",be},le.text=function(X){return X},te}(),z=function(){function te(){}var le=te.prototype;return le.strong=function(X){return X},le.em=function(X){return X},le.codespan=function(X){return X},le.del=function(X){return X},le.html=function(X){return X},le.text=function(X){return X},le.link=function(X,ae,pe){return""+pe},le.image=function(X,ae,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(X,ae){var pe=X,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[X];do be++,pe=X+"-"+be;while(this.seen.hasOwnProperty(pe))}return ae||(this.seen[X]=be,this.seen[pe]=0),pe},le.slug=function(X,ae){ae===void 0&&(ae={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,ae.dryrun)},te}(),J=function(){function te(he){this.options=he||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new z,this.slugger=new G}te.parse=function(X,ae){var pe=new te(ae);return pe.parse(X)},te.parseInline=function(X,ae){var pe=new te(ae);return pe.parseInline(X)};var le=te.prototype;return le.parse=function(X,ae){ae===void 0&&(ae=!0);var pe="",be,Me,We,ke,Ie,Te,V,q,Y,x,fe,we,Ne,Ge,Je,tt,rt,ot,nt,ct=X.length;for(be=0;be<ct;be++){if(x=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(nt=this.options.extensions.renderers[x.type].call({parser:this},x),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=nt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,g(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(q="",V="",ke=x.header.length,Me=0;Me<ke;Me++)V+=this.renderer.tablecell(this.parseInline(x.header[Me].tokens),{header:!0,align:x.align[Me]});for(q+=this.renderer.tablerow(V),Y="",ke=x.rows.length,Me=0;Me<ke;Me++){for(Te=x.rows[Me],V="",Ie=Te.length,We=0;We<Ie;We++)V+=this.renderer.tablecell(this.parseInline(Te[We].tokens),{header:!1,align:x.align[We]});Y+=this.renderer.tablerow(V)}pe+=this.renderer.table(q,Y);continue}case"blockquote":{Y=this.parse(x.tokens),pe+=this.renderer.blockquote(Y);continue}case"list":{for(fe=x.ordered,we=x.start,Ne=x.loose,ke=x.items.length,Y="",Me=0;Me<ke;Me++)Je=x.items[Me],tt=Je.checked,rt=Je.task,Ge="",Je.task&&(ot=this.renderer.checkbox(tt),Ne?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=ot+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=ot+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Je.tokens,Ne),Y+=this.renderer.listitem(Ge,rt,tt);pe+=this.renderer.list(Y,fe,we);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Y=x.tokens?this.parseInline(x.tokens):x.text;be+1<ct&&X[be+1].type==="text";)x=X[++be],Y+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=ae?this.renderer.paragraph(Y):Y;continue}default:{var $t='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},le.parseInline=function(X,ae){ae=ae||this.renderer;var pe="",be,Me,We,ke=X.length;for(be=0;be<ke;be++){if(Me=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(We=this.options.extensions.renderers[Me.type].call({parser:this},Me),We!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){pe+=We||"";continue}switch(Me.type){case"escape":{pe+=ae.text(Me.text);break}case"html":{pe+=ae.html(Me.text);break}case"link":{pe+=ae.link(Me.href,Me.title,this.parseInline(Me.tokens,ae));break}case"image":{pe+=ae.image(Me.href,Me.title,Me.text);break}case"strong":{pe+=ae.strong(this.parseInline(Me.tokens,ae));break}case"em":{pe+=ae.em(this.parseInline(Me.tokens,ae));break}case"codespan":{pe+=ae.codespan(Me.text);break}case"br":{pe+=ae.br();break}case"del":{pe+=ae.del(this.parseInline(Me.tokens,ae));break}case"text":{pe+=ae.text(Me.text);break}default:{var Ie='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,le,he){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(he=le,le=null),le=D({},ee.defaults,le||{}),b(le),he){var X=le.highlight,ae;try{ae=_.lex(te,le)}catch(ke){return he(ke)}var pe=function(Ie){var Te;if(!Ie)try{le.walkTokens&&ee.walkTokens(ae,le.walkTokens),Te=J.parse(ae,le)}catch(V){Ie=V}return le.highlight=X,Ie?he(Ie):he(null,Te)};if(!X||X.length<3||(delete le.highlight,!ae.length))return pe();var be=0;ee.walkTokens(ae,function(ke){ke.type==="code"&&(be++,setTimeout(function(){X(ke.text,ke.lang,function(Ie,Te){if(Ie)return pe(Ie);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Me(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ke.message+"",!0)+"</pre>";throw ke}try{var We=_.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(We,le.walkTokens)).then(function(){return J.parse(We,le)}).catch(Me);ee.walkTokens(We,le.walkTokens)}return J.parse(We,le)}catch(ke){Me(ke)}}ee.options=ee.setOptions=function(te){return D(ee.defaults,te),T(ee.defaults),ee},ee.getDefaults=L,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),he=0;he<te;he++)le[he]=arguments[he];var X=D.apply(void 0,[{}].concat(le)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var ke=ae.renderers?ae.renderers[We.name]:null;ke?ae.renderers[We.name]=function(){for(var Ie=arguments.length,Te=new Array(Ie),V=0;V<Ie;V++)Te[V]=arguments[V];var q=We.renderer.apply(this,Te);return q===!1&&(q=ke.apply(this,Te)),q}:ae.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[We.level]?ae[We.level].unshift(We.tokenizer):ae[We.level]=[We.tokenizer],We.start&&(We.level==="block"?ae.startBlock?ae.startBlock.push(We.start):ae.startBlock=[We.start]:We.level==="inline"&&(ae.startInline?ae.startInline.push(We.start):ae.startInline=[We.start]))}We.childTokens&&(ae.childTokens[We.name]=We.childTokens)})),be.renderer&&function(){var We=ee.defaults.renderer||new re,ke=function(V){var q=We[V];We[V]=function(){for(var Y=arguments.length,x=new Array(Y),fe=0;fe<Y;fe++)x[fe]=arguments[fe];var we=be.renderer[V].apply(We,x);return we===!1&&(we=q.apply(We,x)),we}};for(var Ie in be.renderer)ke(Ie);X.renderer=We}(),be.tokenizer&&function(){var We=ee.defaults.tokenizer||new F,ke=function(V){var q=We[V];We[V]=function(){for(var Y=arguments.length,x=new Array(Y),fe=0;fe<Y;fe++)x[fe]=arguments[fe];var we=be.tokenizer[V].apply(We,x);return we===!1&&(we=q.apply(We,x)),we}};for(var Ie in be.tokenizer)ke(Ie);X.tokenizer=We}(),be.walkTokens){var Me=ee.defaults.walkTokens;X.walkTokens=function(We){var ke=[];return ke.push(be.walkTokens.call(this,We)),Me&&(ke=ke.concat(Me.call(this,We))),ke}}pe&&(X.extensions=ae),ee.setOptions(X)})},ee.walkTokens=function(te,le){for(var he=[],X=function(){var Me=pe.value;switch(he=he.concat(le.call(ee,Me)),Me.type){case"table":{for(var We=R(Me.header),ke;!(ke=We()).done;){var Ie=ke.value;he=he.concat(ee.walkTokens(Ie.tokens,le))}for(var Te=R(Me.rows),V;!(V=Te()).done;)for(var q=V.value,Y=R(q),x;!(x=Y()).done;){var fe=x.value;he=he.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{he=he.concat(ee.walkTokens(Me.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Me.type]?ee.defaults.extensions.childTokens[Me.type].forEach(function(we){he=he.concat(ee.walkTokens(Me[we],le))}):Me.tokens&&(he=he.concat(ee.walkTokens(Me.tokens,le)))}},ae=R(te),pe;!(pe=ae()).done;)X();return he},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=D({},ee.defaults,le||{}),b(le);try{var he=_.lexInline(te,le);return le.walkTokens&&ee.walkTokens(he,le.walkTokens),J.parseInline(he,le)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(X.message+"",!0)+"</pre>";throw X}},ee.Parser=J,ee.parser=J.parse,ee.Renderer=re,ee.TextRenderer=z,ee.Lexer=_,ee.lexer=_.lex,ee.Tokenizer=F,ee.Slugger=G,ee.parse=ee;var ue=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,Q=ee.parseInline,U=ee,se=J.parse,oe=_.lex;ce.Lexer=_,ce.Parser=J,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=z,ce.Tokenizer=F,ce.getDefaults=L,ce.lexer=oe,ce.marked=ee,ce.options=ue,ce.parse=U,ce.parseInline=Q,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[41],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ee[177],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=r;function r(c){const g=R(c);if(g&&g.length>0)return new Uint32Array(g)}let h=0;const A=new Uint32Array(10);function R(c){if(h=0,L(c,E,$.InitialConsonant),h>0||(L(c,u,$.Vowel),h>0)||(L(c,P,$.FinalConsonant),h>0)||(L(c,p,$.CompatibilityJamo),h))return A.subarray(0,h);if(c>=44032&&c<=55203){const g=c-44032,f=g%588,m=Math.floor(g/588),n=Math.floor(f/28),o=f%28-1;if(m<E.length?L(m,E,0):$.InitialConsonant+m-$.CompatibilityJamo<p.length&&L($.InitialConsonant+m,p,$.CompatibilityJamo),n<u.length?L(n,u,0):$.Vowel+n-$.CompatibilityJamo<p.length&&L($.Vowel+n-$.CompatibilityJamo,p,$.CompatibilityJamo),o>=0&&(o<P.length?L(o,P,0):$.FinalConsonant+o-$.CompatibilityJamo<p.length&&L($.FinalConsonant+o-$.CompatibilityJamo,p,$.CompatibilityJamo)),h>0)return A.subarray(0,h)}}function L(c,g,f){c>=f&&c<f+g.length&&T(g[c-f])}function T(c){c!==l.NUL&&(A[h++]=c&255,c>>8&&(A[h++]=c>>8&255),c>>16&&(A[h++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var l;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(l||(l={}));var C;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(C||(C={}));const E=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),u=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l]),P=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,C.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),p=new Uint16Array([l.r,l.R,C.rt,l.s,C.sw,C.sg,l.e,l.E,l.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,l.a,l.q,l.Q,C.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,C.hk,C.ho,C.hl,l.y,l.n,C.nj,C.np,C.nl,l.b,l.m,C.ml,l.l])}),define(Ee[82],Se([1,0,29]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=void 0,e.$jm=A,e.$km=L;const h=new r.$Ec(1e4);function A(l){return $(l,"NFC",h)}const R=new r.$Ec(1e4);function L(l){return $(l,"NFD",R)}const T=/[^\u0000-\u0080]/;function $(l,C,E){if(!l)return l;const u=E.get(l);if(u)return u;let P;return T.test(l)?P=l.normalize(C):P=l,E.set(l,P),P}e.$lm=function(){const l=/[\u0300-\u036f]/g;return function(C){return L(C).replace(l,"")}}()}),define(Ee[134],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=r,e.rot=h,e.$Mm=T;function r($,l,C){return Math.min(Math.max($,l),C)}function h($,l){return(l+$%l)%l}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=A;class R{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=R;class L{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const C=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=L;function T($,l,C,E,u,P,p,c){const g=p-C,f=c-E,m=u-C,n=P-E,o=$-C,i=l-E,t=g*g+f*f,s=g*m+f*n,d=g*o+f*i,a=m*m+n*n,w=m*o+n*i,y=1/(t*a-s*s),D=(a*d-s*w)*y,S=(t*w-s*d)*y;return D>=0&&S>=0&&D+S<1}}),define(Ee[178],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=R,e.$dd=u;class r{constructor(p,c,g){this.owner=p,this.debugNameSource=c,this.referenceFn=g}getDebugName(p){return R(p,this)}}e.$bd=r;const h=new Map,A=new WeakMap;function R(P,p){const c=A.get(P);if(c)return c;const g=L(P,p);if(g){let f=h.get(g)??0;f++,h.set(g,f);const m=f===1?g:`${g}#${f}`;return A.set(P,m),m}}function L(P,p){const c=A.get(P);if(c)return c;const g=p.owner?C(p.owner)+".":"";let f;const m=p.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(f=m(),f!==void 0)return g+f}else return g+m;const n=p.referenceFn;if(n!==void 0&&(f=u(n),f!==void 0))return g+f;if(p.owner!==void 0){const o=T(p.owner,P);if(o!==void 0)return g+o}}function T(P,p){for(const c in P)if(P[c]===p)return c}const $=new Map,l=new WeakMap;function C(P){const p=l.get(P);if(p)return p;const c=E(P);let g=$.get(c)??0;g++,$.set(c,g);const f=g===1?c:`${c}#${g}`;return l.set(P,f),f}function E(P){const p=P.constructor;return p?p.name:"Object"}function u(P){const p=P.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(p);return(g?g[1]:void 0)?.trim()}}),define(Ee[179],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=h,e.$Jd=A;let r;function h(c){r=c}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return L([T(P("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[T(" "),l(C(g.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),l(C(g.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),l(C(g.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(g,f){console.log(...this.b([$("observable value changed"),l(g.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(g){if(g.size!==0)return l(" (changed deps: "+[...g].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const f=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),f.apply(g,[m,n]))}handleDerivedRecomputed(g,f){const m=this.d.get(g);console.log(...this.b([$("derived recomputed"),l(g.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(m),{data:[{fn:g._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(g,f){console.log(...this.b([$("observable from event triggered"),l(g.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const f=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),f.apply(g,[m,n]))}handleAutorunTriggered(g){const f=this.d.get(g);console.log(...this.b([$("autorun"),l(g.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:g._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let f=g.getDebugName();f===void 0&&(f=""),console.log(...this.b([$("transaction"),l(f,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=R;function L(c){const g=new Array,f=[];let m="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(m+=`%c${i.text}`,g.push(i.style),i.data&&f.push(...i.data)):"data"in i&&f.push(...i.data)}n(c);const o=[m,...g];return o.push(...f),o}function T(c){return l(c,{color:"black"})}function $(c){return l(p(`${c}: `,10),{color:"black",bold:!0})}function l(c,g={color:"black"}){function f(n){return Object.entries(n).reduce((o,[i,t])=>`${o}${i}:${t};`,"")}const m={color:g.color};return g.strikeThrough&&(m["text-decoration"]="line-through"),g.bold&&(m["font-weight"]="bold"),{text:c,style:f(m)}}function C(c,g){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=g?`"${c}"`:`"${c.substr(0,g-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?E(c,g):u(c,g);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function E(c,g){let f="[ ",m=!0;for(const n of c){if(m||(f+=", "),f.length-5>g){f+="...";break}m=!1,f+=`${C(n,g-f.length)}`}return f+=" ]",f}function u(c,g){let f="{ ",m=!0;for(const[n,o]of Object.entries(c)){if(m||(f+=", "),f.length-5>g){f+="...";break}m=!1,f+=`${n}: ${C(o,g-f.length)}`}return f+=" }",f}function P(c,g){let f="";for(let m=1;m<=g;m++)f+=c;return f}function p(c,g){for(;c.length<g;)c+=" ";return c}}),define(Ee[180],Se([1,0,174,178,179]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=L,e.$Ud=$,e.$Vd=C,e.$Yd=P,e.$Zd=c,e.$1d=g,e.$2d=f,e.$4d=n,e.$6d=i;let R;function L(s){R=s}let T;function $(s){T=s}let l;function C(s){l=s}class E{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,a){const w=a===void 0?void 0:d,y=a===void 0?d:a;return l({owner:w,debugName:()=>{const D=(0,h.$dd)(y);if(D!==void 0)return D;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(I)return`${this.debugName}.${I[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:y},D=>y(this.read(D),D))}recomputeInitiallyAndOnChange(d,a){return d.add(R(this,a)),this}keepObserved(d){return d.add(T(this)),this}get a(){return this.get()}}e.$Wd=E;class u extends E{constructor(){super(...arguments),this.b=new Set}addObserver(d){const a=this.b.size;this.b.add(d),a===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function P(s,d){const a=new m(s,d);try{s(a)}finally{a.finish()}}let p;function c(s){if(p)s(p);else{const d=new m(s,void 0);p=d;try{s(d)}finally{d.finish(),p=void 0}}}async function g(s,d){const a=new m(s,d);try{await s(a)}finally{a.finish()}}function f(s,d,a){s?d(s):P(d,a)}class m{constructor(d,a){this._fn=d,this.b=a,this.a=[],(0,A.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$dd)(this._fn)}updateObserver(d,a){this.a.push({observer:d,observable:a}),d.beginUpdate(a)}finish(){const d=this.a;for(let a=0;a<d.length;a++){const{observer:w,observable:y}=d[a];w.endUpdate(y)}this.a=null,(0,A.$Jd)()?.handleEndTransaction()}}e.$3d=m;function n(s,d){let a;return typeof s=="string"?a=new h.$bd(void 0,s,void 0):a=new h.$bd(s,void 0,void 0),new o(a,d,r.$7c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,a,w){super(),this.e=d,this.g=w,this.d=a}get(){return this.d}set(d,a,w){if(w===void 0&&this.g(this.d,d))return;let y;a||(a=y=new m(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,A.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:w,didChange:!0,hadValue:!0});for(const S of this.b)a.updateObserver(S,this),S.handleChange(this,w)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=o;function i(s,d){let a;return typeof s=="string"?a=new h.$bd(void 0,s,void 0):a=new h.$bd(s,void 0,void 0),new t(a,d,r.$7c)}class t extends o{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=t}),function(){function ce(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function L($){R.push($,Date.now())}function T(){const $=[];for(let l=0;l<R.length;l+=2)$.push({name:R[l],startTime:R[l+1]});return $}return{mark:L,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(A+L.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(Ee[181],Se([1,0,40]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=void 0;const h=Symbol("unset");class A{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,l,C){this.d($,E=>E._value=l,C)}mutate($,l){this.d($,C=>C._value=l(C._value===h?void 0:C._value))}mutatePath($,l){this.d($,()=>{},C=>l(C))}delete($){const l=this.c($);if(!l)return;let C=l.length-1;const E=l[C].node._value;if(E!==h){for(this.b--,l[C].node._value=h;C>0;C--){const{node:u,part:P}=l[C];if(u.children?.size||u._value!==h)break;l[C-1].node.children.delete(P)}return E}}*deleteRecursive($){const l=this.c($);if(!l)return;const C=l[l.length-1].node;for(let E=l.length-1;E>0;E--){const u=l[E-1];if(u.node.children.delete(l[E].part),u.node.children.size>0||u.node._value!==h)break}for(const E of R(C))E._value!==h&&(this.b--,yield E._value)}find($){let l=this.a;for(const C of $){const E=l.children?.get(C);if(!E)return;l=E}return l._value===h?void 0:l._value}hasKeyOrParent($){let l=this.a;for(const C of $){const E=l.children?.get(C);if(!E)return!1;if(E._value!==h)return!0;l=E}return!1}hasKeyOrChildren($){let l=this.a;for(const C of $){const E=l.children?.get(C);if(!E)return!1;l=E}return!0}hasKey($){let l=this.a;for(const C of $){const E=l.children?.get(C);if(!E)return!1;l=E}return l._value!==h}c($){const l=[{part:"",node:this.a}];let C=0;for(const E of $){const u=l[C].node.children?.get(E);if(!u)return;l.push({part:E,node:u}),C++}return l}d($,l,C){let E=this.a;for(const p of $){if(E.children)if(E.children.has(p))E=E.children.get(p);else{const c=new L;E.children.set(p,c),E=c}else{const c=new L;E.children=new Map([[p,c]]),E=c}C?.(E)}const u=E._value===h?0:1;l(E);const P=E._value===h?0:1;this.b+=P-u}*values(){for(const{_value:$}of R(this.a))$!==h&&(yield $)}}e.$LI=A;function*R(T){const $=[T];for(;$.length>0;){const l=$.pop();if(yield l,l.children)for(const C of l.children.values())$.push(C)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ce)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function r(h){if(e[h])return e[h].exports;var A=e[h]={i:h,l:!1,exports:{}};return ce[h].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=ce,r.c=e,r.d=function(h,A,R){r.o(h,A)||Object.defineProperty(h,A,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,A){if(1&A&&(h=r(h)),8&A||4&A&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&A&&typeof h!="string")for(var L in h)r.d(R,L,function(T){return h[T]}.bind(null,L));return R},r.n=function(h){var A=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(A,"a",A),A},r.o=function(h,A){return Object.prototype.hasOwnProperty.call(h,A)},r.p="",r(r.s=0)}([function(ce,e,r){(function(h){var A;e=ce.exports=De,A=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],$=e.src=[],l=0,C=l++;$[C]="0|[1-9]\\d*";var E=l++;$[E]="[0-9]+";var u=l++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=l++;$[P]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var p=l++;$[p]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var c=l++;$[c]="(?:"+$[C]+"|"+$[u]+")";var g=l++;$[g]="(?:"+$[E]+"|"+$[u]+")";var f=l++;$[f]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var m=l++;$[m]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var n=l++;$[n]="[0-9A-Za-z-]+";var o=l++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var i=l++,t="v?"+$[P]+$[f]+"?"+$[o]+"?";$[i]="^"+t+"$";var s="[v=\\s]*"+$[p]+$[m]+"?"+$[o]+"?",d=l++;$[d]="^"+s+"$";var a=l++;$[a]="((?:<|>)?=?)";var w=l++;$[w]=$[E]+"|x|X|\\*";var y=l++;$[y]=$[C]+"|x|X|\\*";var D=l++;$[D]="[v=\\s]*("+$[y]+")(?:\\.("+$[y]+")(?:\\.("+$[y]+")(?:"+$[f]+")?"+$[o]+"?)?)?";var S=l++;$[S]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[m]+")?"+$[o]+"?)?)?";var I=l++;$[I]="^"+$[a]+"\\s*"+$[D]+"$";var k=l++;$[k]="^"+$[a]+"\\s*"+$[S]+"$";var b=l++;$[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=l++;$[v]="(?:~>?)";var N=l++;$[N]="(\\s*)"+$[v]+"\\s+",T[N]=new RegExp($[N],"g");var O=l++;$[O]="^"+$[v]+$[D]+"$";var F=l++;$[F]="^"+$[v]+$[S]+"$";var j=l++;$[j]="(?:\\^)";var B=l++;$[B]="(\\s*)"+$[j]+"\\s+",T[B]=new RegExp($[B],"g");var M=l++;$[M]="^"+$[j]+$[D]+"$";var W=l++;$[W]="^"+$[j]+$[S]+"$";var _=l++;$[_]="^"+$[a]+"\\s*("+s+")$|^$";var re=l++;$[re]="^"+$[a]+"\\s*("+t+")$|^$";var z=l++;$[z]="(\\s*)"+$[a]+"\\s*("+s+"|"+$[D]+")",T[z]=new RegExp($[z],"g");var G=l++;$[G]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var J=l++;$[J]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var ee=l++;$[ee]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)A(ue,$[ue]),T[ue]||(T[ue]=new RegExp($[ue]));function ne(q,Y){if(q instanceof De)return q;if(typeof q!="string"||q.length>R||!(Y?T[d]:T[i]).test(q))return null;try{return new De(q,Y)}catch{return null}}function De(q,Y){if(q instanceof De){if(q.loose===Y)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof De))return new De(q,Y);A("SemVer",q,Y),this.loose=Y;var x=q.trim().match(Y?T[d]:T[i]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<L)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(q,Y){var x=ne(q,Y);return x?x.version:null},e.clean=function(q,Y){var x=ne(q.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof De||(q=new De(q,this.loose)),this.compareMain(q)||this.comparePre(q)},De.prototype.compareMain=function(q){return q instanceof De||(q=new De(q,this.loose)),Q(this.major,q.major)||Q(this.minor,q.minor)||Q(this.patch,q.patch)},De.prototype.comparePre=function(q){if(q instanceof De||(q=new De(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],fe=q.prerelease[Y];if(A("prerelease compare",Y,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return Q(x,fe)}while(++Y)},De.prototype.inc=function(q,Y){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Y,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new De(q,x).inc(Y,fe).version}catch{return null}},e.diff=function(q,Y){if(te(q,Y))return null;var x=ne(q),fe=ne(Y);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=Q;var $e=/^[0-9]+$/;function Q(q,Y){var x=$e.test(q),fe=$e.test(Y);return x&&fe&&(q=+q,Y=+Y),x&&!fe?-1:fe&&!x?1:q<Y?-1:q>Y?1:0}function U(q,Y,x){return new De(q,x).compare(new De(Y,x))}function se(q,Y,x){return U(q,Y,x)>0}function oe(q,Y,x){return U(q,Y,x)<0}function te(q,Y,x){return U(q,Y,x)===0}function le(q,Y,x){return U(q,Y,x)!==0}function he(q,Y,x){return U(q,Y,x)>=0}function X(q,Y,x){return U(q,Y,x)<=0}function ae(q,Y,x,fe){var we;switch(Y){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q!==x;break;case"":case"=":case"==":we=te(q,x,fe);break;case"!=":we=le(q,x,fe);break;case">":we=se(q,x,fe);break;case">=":we=he(q,x,fe);break;case"<":we=oe(q,x,fe);break;case"<=":we=X(q,x,fe);break;default:throw new TypeError("Invalid operator: "+Y)}return we}function pe(q,Y){if(q instanceof pe){if(q.loose===Y)return q;q=q.value}if(!(this instanceof pe))return new pe(q,Y);A("comparator",q,Y),this.loose=Y,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,Y){return Q(Y,q)},e.major=function(q,Y){return new De(q,Y).major},e.minor=function(q,Y){return new De(q,Y).minor},e.patch=function(q,Y){return new De(q,Y).patch},e.compare=U,e.compareLoose=function(q,Y){return U(q,Y,!0)},e.rcompare=function(q,Y,x){return U(Y,q,x)},e.sort=function(q,Y){return q.sort(function(x,fe){return e.compare(x,fe,Y)})},e.rsort=function(q,Y){return q.sort(function(x,fe){return e.rcompare(x,fe,Y)})},e.gt=se,e.lt=oe,e.eq=te,e.neq=le,e.gte=he,e.lte=X,e.cmp=ae,e.Comparator=pe;var be={};function Me(q,Y){if(q instanceof Me)return q.loose===Y?q:new Me(q.raw,Y);if(q instanceof pe)return new Me(q.value,Y);if(!(this instanceof Me))return new Me(q,Y);if(this.loose=Y,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function We(q){return!q||q.toLowerCase()==="x"||q==="*"}function ke(q,Y,x,fe,we,Ne,Ge,Je,tt,rt,ot,nt,ct){return((Y=We(x)?"":We(fe)?">="+x+".0.0":We(we)?">="+x+"."+fe+".0":">="+Y)+" "+(Je=We(tt)?"":We(rt)?"<"+(+tt+1)+".0.0":We(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+Je)).trim()}function Ie(q,Y){for(var x=0;x<q.length;x++)if(!q[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<q.length;x++)if(A(q[x].semver),q[x].semver!==be&&q[x].semver.prerelease.length>0){var fe=q[x].semver;if(fe.major===Y.major&&fe.minor===Y.minor&&fe.patch===Y.patch)return!0}return!1}return!0}function Te(q,Y,x){try{Y=new Me(Y,x)}catch{return!1}return Y.test(q)}function V(q,Y,x,fe){var we,Ne,Ge,Je,tt;switch(q=new De(q,fe),Y=new Me(Y,fe),x){case">":we=se,Ne=X,Ge=oe,Je=">",tt=">=";break;case"<":we=oe,Ne=he,Ge=se,Je="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,Y,fe))return!1;for(var rt=0;rt<Y.set.length;++rt){var ot=Y.set[rt],nt=null,ct=null;if(ot.forEach(function($t){$t.semver===be&&($t=new pe(">=0.0.0")),nt=nt||$t,ct=ct||$t,we($t.semver,nt.semver,fe)?nt=$t:Ge($t.semver,ct.semver,fe)&&(ct=$t)}),nt.operator===Je||nt.operator===tt||(!ct.operator||ct.operator===Je)&&Ne(q,ct.semver)||ct.operator===tt&&Ge(q,ct.semver))return!1}return!0}pe.prototype.parse=function(q){var Y=this.loose?T[_]:T[re],x=q.match(Y);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new De(x[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new De(q,this.loose)),ae(q,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(q,Y){if(!(q instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Me(q.value,Y),Te(this.value,x,Y);if(q.operator==="")return x=new Me(this.value,Y),Te(q.semver,x,Y);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ne=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Je=ae(this.semver,"<",q.semver,Y)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=ae(this.semver,">",q.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||we||Ne&&Ge||Je||tt},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(q){var Y=this.loose;q=q.trim(),A("range",q,Y);var x=Y?T[J]:T[G];q=q.replace(x,ke),A("hyphen replace",q),q=q.replace(T[z],"$1$2$3"),A("comparator trim",q,T[z]),q=(q=(q=q.replace(T[N],"$1~")).replace(T[B],"$1^")).split(/\s+/).join(" ");var fe=Y?T[_]:T[re],we=q.split(" ").map(function(Ne){return function(Ge,Je){return A("comp",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){A("caret",nt,ct);var $t=ct?T[W]:T[M];return nt.replace($t,function(ht,at,Pe,Be,Ke){var Oe;return A("caret",nt,ht,at,Pe,Be,Ke),We(at)?Oe="":We(Pe)?Oe=">="+at+".0.0 <"+(+at+1)+".0.0":We(Be)?Oe=at==="0"?">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+".0 <"+(+at+1)+".0.0":Ke?(A("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Oe=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+Be+Ke+" <"+at+"."+Pe+"."+(+Be+1):">="+at+"."+Pe+"."+Be+Ke+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+Be+Ke+" <"+(+at+1)+".0.0"):(A("no pr"),Oe=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+Be+" <"+at+"."+Pe+"."+(+Be+1):">="+at+"."+Pe+"."+Be+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+Be+" <"+(+at+1)+".0.0"),A("caret return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Je),A("caret",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){var $t=ct?T[F]:T[O];return nt.replace($t,function(ht,at,Pe,Be,Ke){var Oe;return A("tilde",nt,ht,at,Pe,Be,Ke),We(at)?Oe="":We(Pe)?Oe=">="+at+".0.0 <"+(+at+1)+".0.0":We(Be)?Oe=">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":Ke?(A("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Oe=">="+at+"."+Pe+"."+Be+Ke+" <"+at+"."+(+Pe+1)+".0"):Oe=">="+at+"."+Pe+"."+Be+" <"+at+"."+(+Pe+1)+".0",A("tilde return",Oe),Oe})}(ot,rt)}).join(" ")}(Ge,Je),A("tildes",Ge),Ge=function(tt,rt){return A("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,ct){nt=nt.trim();var $t=ct?T[k]:T[I];return nt.replace($t,function(ht,at,Pe,Be,Ke,Oe){A("xRange",nt,ht,at,Pe,Be,Ke,Oe);var Fe=We(Pe),Z=Fe||We(Be),de=Z||We(Ke);return at==="="&&de&&(at=""),Fe?ht=at===">"||at==="<"?"<0.0.0":"*":at&&de?(Z&&(Be=0),de&&(Ke=0),at===">"?(at=">=",Z?(Pe=+Pe+1,Be=0,Ke=0):de&&(Be=+Be+1,Ke=0)):at==="<="&&(at="<",Z?Pe=+Pe+1:Be=+Be+1),ht=at+Pe+"."+Be+"."+Ke):Z?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de&&(ht=">="+Pe+"."+Be+".0 <"+Pe+"."+(+Be+1)+".0"),A("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Je),A("xrange",Ge),Ge=function(tt,rt){return A("replaceStars",tt,rt),tt.trim().replace(T[ee],"")}(Ge,Je),A("stars",Ge),Ge}(Ne,Y)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Ne){return!!Ne.match(fe)})),we=we.map(function(Ne){return new pe(Ne,Y)})},Me.prototype.intersects=function(q,Y){if(!(q instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return q.set.some(function(we){return we.every(function(Ne){return fe.intersects(Ne,Y)})})})})},e.toComparators=function(q,Y){return new Me(q,Y).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new De(q,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Ie(this.set[Y],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,Y,x){var fe=null,we=null;try{var Ne=new Me(Y,x)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(fe&&we.compare(Ge)!==-1||(we=new De(fe=Ge,x)))}),fe},e.minSatisfying=function(q,Y,x){var fe=null,we=null;try{var Ne=new Me(Y,x)}catch{return null}return q.forEach(function(Ge){Ne.test(Ge)&&(fe&&we.compare(Ge)!==1||(we=new De(fe=Ge,x)))}),fe},e.validRange=function(q,Y){try{return new Me(q,Y).range||"*"}catch{return null}},e.ltr=function(q,Y,x){return V(q,Y,"<",x)},e.gtr=function(q,Y,x){return V(q,Y,">",x)},e.outside=V,e.prerelease=function(q,Y){var x=ne(q,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,Y,x){return q=new Me(q,x),Y=new Me(Y,x),q.intersects(Y)},e.coerce=function(q){if(q instanceof De)return q;if(typeof q!="string")return null;var Y=q.match(T[b]);return Y==null?null:ne((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,r(1))},function(ce,e){var r,h,A=ce.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function T(g){if(r===setTimeout)return setTimeout(g,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(g,0);try{return r(g,0)}catch{try{return r.call(null,g,0)}catch{return r.call(this,g,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var $,l=[],C=!1,E=-1;function u(){C&&$&&(C=!1,$.length?l=$.concat(l):E=-1,l.length&&P())}function P(){if(!C){var g=T(u);C=!0;for(var f=l.length;f;){for($=l,l=[];++E<f;)$&&$[E].run();E=-1,f=l.length}$=null,C=!1,function(m){if(h===clearTimeout)return clearTimeout(m);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(m);try{h(m)}catch{try{return h.call(null,m)}catch{return h.call(this,m)}}}(g)}}function p(g,f){this.fun=g,this.array=f}function c(){}A.nextTick=function(g){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];l.push(new p(g,f)),l.length!==1||C||T(P)},p.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=c,A.addListener=c,A.once=c,A.off=c,A.removeListener=c,A.removeAllListeners=c,A.emit=c,A.prependListener=c,A.prependOnceListener=c,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ee[43],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=h}),define(Ee[4],Se([1,0,14,80,3,81,43]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=P;const T=!1,$=!1,l=!1;var C;(function(F){F.None=()=>A.$Vc.None;function j(ke){if(l){const{onDidAddListener:Ie}=ke,Te=c.create();let V=0;ke.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),Ie?.()}}}function B(ke,Ie){return ne(ke,()=>{},0,void 0,!0,void 0,Ie)}F.defer=B;function M(ke){return(Ie,Te=null,V)=>{let q=!1,Y;return Y=ke(x=>{if(!q)return Y?Y.dispose():q=!0,Ie.call(Te,x)},null,V),q&&Y.dispose(),Y}}F.once=M;function W(ke,Ie,Te){return ee((V,q=null,Y)=>ke(x=>V.call(q,Ie(x)),null,Y),Te)}F.map=W;function _(ke,Ie,Te){return ee((V,q=null,Y)=>ke(x=>{Ie(x),V.call(q,x)},null,Y),Te)}F.forEach=_;function re(ke,Ie,Te){return ee((V,q=null,Y)=>ke(x=>Ie(x)&&V.call(q,x),null,Y),Te)}F.filter=re;function z(ke){return ke}F.signal=z;function G(...ke){return(Ie,Te=null,V)=>{const q=(0,A.$Sc)(...ke.map(Y=>Y(x=>Ie.call(Te,x))));return ue(q,V)}}F.any=G;function J(ke,Ie,Te,V){let q=Te;return W(ke,Y=>(q=Ie(q,Y),q),V)}F.reduce=J;function ee(ke,Ie){let Te;const V={onWillAddFirstListener(){Te=ke(q.fire,q)},onDidRemoveLastListener(){Te?.dispose()}};Ie||j(V);const q=new s(V);return Ie?.add(q),q.event}function ue(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function ne(ke,Ie,Te=100,V=!1,q=!1,Y,x){let fe,we,Ne,Ge=0,Je;const tt={leakWarningThreshold:Y,onWillAddFirstListener(){fe=ke(ot=>{Ge++,we=Ie(we,ot),V&&!Ne&&(rt.fire(we),we=void 0),Je=()=>{const nt=we;we=void 0,Ne=void 0,(!V||Ge>1)&&rt.fire(nt),Ge=0},typeof Te=="number"?(clearTimeout(Ne),Ne=setTimeout(Je,Te)):Ne===void 0&&(Ne=0,queueMicrotask(Je))})},onWillRemoveListener(){q&&Ge>0&&Je?.()},onDidRemoveLastListener(){Je=void 0,fe.dispose()}};x||j(tt);const rt=new s(tt);return x?.add(rt),rt.event}F.debounce=ne;function De(ke,Ie=0,Te){return F.debounce(ke,(V,q)=>V?(V.push(q),V):[q],Ie,void 0,!0,void 0,Te)}F.accumulate=De;function $e(ke,Ie=(V,q)=>V===q,Te){let V=!0,q;return re(ke,Y=>{const x=V||!Ie(Y,q);return V=!1,q=Y,x},Te)}F.latch=$e;function Q(ke,Ie,Te){return[F.filter(ke,Ie,Te),F.filter(ke,V=>!Ie(V),Te)]}F.split=Q;function U(ke,Ie=!1,Te=[],V){let q=Te.slice(),Y=ke(we=>{q?q.push(we):fe.fire(we)});V&&V.add(Y);const x=()=>{q?.forEach(we=>fe.fire(we)),q=null},fe=new s({onWillAddFirstListener(){Y||(Y=ke(we=>fe.fire(we)),V&&V.add(Y))},onDidAddFirstListener(){q&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return V&&V.add(fe),fe.event}F.buffer=U;function se(ke,Ie){return(V,q,Y)=>{const x=Ie(new te);return ke(function(fe){const we=x.evaluate(fe);we!==oe&&V.call(q,we)},void 0,Y)}}F.chain=se;const oe=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Te=>(Ie(Te),Te)),this}filter(Ie){return this.f.push(Te=>Ie(Te)?Te:oe),this}reduce(Ie,Te){let V=Te;return this.f.push(q=>(V=Ie(V,q),V)),this}latch(Ie=(Te,V)=>Te===V){let Te=!0,V;return this.f.push(q=>{const Y=Te||!Ie(q,V);return Te=!1,V=q,Y?q:oe}),this}evaluate(Ie){for(const Te of this.f)if(Ie=Te(Ie),Ie===oe)break;return Ie}}function le(ke,Ie,Te=V=>V){const V=(...fe)=>x.fire(Te(...fe)),q=()=>ke.on(Ie,V),Y=()=>ke.removeListener(Ie,V),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return x.event}F.fromNodeEventEmitter=le;function he(ke,Ie,Te=V=>V){const V=(...fe)=>x.fire(Te(...fe)),q=()=>ke.addEventListener(Ie,V),Y=()=>ke.removeEventListener(Ie,V),x=new s({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return x.event}F.fromDOMEventEmitter=he;function X(ke){return new Promise(Ie=>M(ke)(Ie))}F.toPromise=X;function ae(ke){const Ie=new s;return ke.then(Te=>{Ie.fire(Te)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}F.fromPromise=ae;function pe(ke,Ie,Te){return Ie(Te),ke(V=>Ie(V))}F.runAndSubscribe=pe;class be{constructor(Ie,Te){this._observable=Ie,this.f=0,this.g=!1;const V={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Te||j(V),this.emitter=new s(V),Te&&Te.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Te){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Me(ke,Ie){return new be(ke,Ie).emitter.event}F.fromObservable=Me;function We(ke){return(Ie,Te,V)=>{let q=0,Y=!1;const x={beginUpdate(){q++},endUpdate(){q--,q===0&&(ke.reportChanges(),Y&&(Y=!1,Ie.call(Te)))},handlePossibleChange(){},handleChange(){Y=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return V instanceof A.$Uc?V.add(fe):Array.isArray(V)&&V.push(fe),fe}}F.fromObservableLight=We})(C||(e.Event=C={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new L.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=E;let u=-1;function P(F){const j=u;return u=F,{dispose(){u=j}}}class p{constructor(j,B,M=Math.random().toString(18).slice(2,5)){this.h=j,this.threshold=B,this.name=M,this.g=0}dispose(){this.f?.clear()}check(j,B){const M=this.threshold;if(M<=0||B<M)return;this.f||(this.f=new Map);const W=this.f.get(j.value)||0;if(this.f.set(j.value,W+1),this.g-=1,this.g<=0){this.g=M*.5;const[_,re]=this.getMostFrequentStack(),z=`[${this.name}] potential listener LEAK detected, having ${B} listeners already. MOST frequent listener (${re}):`;console.warn(z),console.warn(_);const G=new g(z,_);this.h(G)}return()=>{const _=this.f.get(j.value)||0;this.f.set(j.value,_-1)}}getMostFrequentStack(){if(!this.f)return;let j,B=0;for(const[M,W]of this.f)(!j||B<W)&&(j=[M,W],B=W);return j}}class c{static create(){const j=new Error;return new c(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(j,B){super(j),this.name="ListenerLeakError",this.stack=B}}e.$he=g;class f extends Error{constructor(j,B){super(j),this.name="ListenerRefusalError",this.stack=B}}e.$ie=f;let m=0;class n{constructor(j){this.value=j,this.id=m++}}const o=2,i=(F,j)=>{if(F instanceof n)j(F);else for(let B=0;B<F.length;B++){const M=F[B];M&&j(M)}};let t;if(T){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),t=new FinalizationRegistry(j=>{typeof j=="string"&&F.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new p(j?.onListenerError??r.$2,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{i(j,B=>B.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,B,M)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const J=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new f(`${G}. HINT: Stack shows most frequent listener (${J[1]}-times)`,J[0]);return(this.f?.onListenerError||r.$2)(ee),A.$Vc.None}if(this.m)return A.$Vc.None;B&&(j=j.bind(B));const W=new n(j);let _,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(W.stack=c.create(),_=this.g.check(W.stack,this.z+1)),$&&(W.stack=re??c.create()),this.u?this.u instanceof n?(this.w??=new a,this.u=[this.u,W]):this.u.push(W):(this.f?.onWillAddFirstListener?.(this),this.u=W,this.f?.onDidAddFirstListener?.(this)),this.z++;const z=(0,A.$Tc)(()=>{t?.unregister(z),_?.(),this.A(W)});if(M instanceof A.$Uc?M.add(z):Array.isArray(M)&&M.push(z),t){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),J=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);t.register(z,J?.[2]??G,z)}return z},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const B=this.u,M=B.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,B[M]=void 0;const W=this.w.current===this;if(this.z*o<=B.length){let _=0;for(let re=0;re<B.length;re++)B[re]?B[_++]=B[re]:W&&(this.w.end--,_<this.w.i&&this.w.i--);B.length=_}}B(j,B){if(!j)return;const M=this.f?.onListenerError||r.$2;if(!M){j.value(B);return}try{j.value(B)}catch(W){M(W)}}C(j){const B=j.current.u;for(;j.i<j.end;)this.B(B[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const B=this.w;B.enqueue(this,j,this.u.length),this.C(B)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=s;const d=()=>new a;e.$ke=d;class a{constructor(){this.i=-1,this.end=0}enqueue(j,B,M){this.i=0,this.end=M,this.current=j,this.value=B}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends s{async fireAsync(j,B,M){if(this.u)for(this.h||(this.h=new R.$6c),i(this.u,W=>this.h.push([W.value,j]));this.h.size>0&&!B.isCancellationRequested;){const[W,_]=this.h.shift(),re=[],z={..._,token:B,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");M&&(G=M(G,W)),re.push(G)}};try{W(z)}catch(G){(0,r.$2)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const J of G)J.status==="rejected"&&(0,r.$2)(J.reason)})}}}e.$le=w;class y extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$6c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=y;class D extends y{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=D;class S extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(B=>super.fire(B)),this.h=[]}))}}e.$oe=S;class I{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const B={event:j,listener:null};this.h.push(B),this.g&&this.m(B);const M=()=>{this.g&&this.o(B);const W=this.h.indexOf(B);this.h.splice(W,1)};return(0,A.$Tc)((0,h.$eb)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(B=>this.f.fire(B))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=I;class k{constructor(j,B,M,W){this.f=new A.$Uc;const _=this.f.add(new I),re=this.f.add(new A.$5c);function z(G){re.set(G,_.add(W(G)))}for(const G of j)z(G);this.f.add(B(G=>{z(G)})),this.f.add(M(G=>{re.deleteAndDispose(G)})),this.event=_.event}dispose(){this.f.dispose()}}e.$qe=k;class b{constructor(){this.f=[]}wrapEvent(j,B,M){return(W,_,re)=>j(z=>{const G=this.f[this.f.length-1];if(!B){G?G.buffers.push(()=>W.call(_,z)):W.call(_,z);return}const J=G;if(!J){W.call(_,B(M,z));return}J.items??=[],J.items.push(z),J.buffers.length===0&&G.buffers.push(()=>{J.reducedResult??=M?J.items.reduce(B,M):J.items.reduce(B),W.call(_,J.reducedResult)})},void 0,re)}bufferEvents(j){const B={buffers:new Array};this.f.push(B);const M=j();return this.f.pop(),B.buffers.forEach(W=>W()),M}}e.$re=b;class v{constructor(){this.f=!1,this.g=C.None,this.h=A.$Vc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=v;class N{static const(j){return new O(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=N;class O{constructor(j){this.value=j,this.onDidChange=C.None}}}),define(Ee[21],Se([1,0,4]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=T;const h=Object.freeze(function($,l){const C=setTimeout($.bind(l),0);return{dispose(){clearTimeout(C)}}});var A;(function($){function l(C){return C===$.None||C===$.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}$.isCancellationToken=l,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$ue=L;function T($){const l=new L;return $.add({dispose(){l.cancel()}}),l.token}}),define(Ee[182],Se([1,0,21]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=A;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$ue,l=this.b($.token);return this.a={promise:l,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$7e=h;function A(T){return T}class R{constructor($,l){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);return this.b!==l&&(this.b=l,this.a=this.c($)),this.a}}e.$9e=R;class L{get cachedValues(){return this.a}constructor($,l){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);if(this.b.has(l))return this.b.get(l);const C=this.c($);return this.a.set($,C),this.b.set(l,C),C}}e.$0e=L}),define(Ee[183],Se([1,0,4,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.ScrollbarVisibility=void 0;var A;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(p,c,g,f,m,n,o){this.c=p,this._scrollStateBrand=void 0,this.c&&(c=c|0,g=g|0,f=f|0,m=m|0,n=n|0,o=o|0),this.rawScrollLeft=f,this.rawScrollTop=o,c<0&&(c=0),f+c>g&&(f=g-c),f<0&&(f=0),m<0&&(m=0),o+m>n&&(o=n-m),o<0&&(o=0),this.width=c,this.scrollWidth=g,this.scrollLeft=f,this.height=m,this.scrollHeight=n,this.scrollTop=o}equals(p){return this.rawScrollLeft===p.rawScrollLeft&&this.rawScrollTop===p.rawScrollTop&&this.width===p.width&&this.scrollWidth===p.scrollWidth&&this.scrollLeft===p.scrollLeft&&this.height===p.height&&this.scrollHeight===p.scrollHeight&&this.scrollTop===p.scrollTop}withScrollDimensions(p,c){return new R(this.c,typeof p.width<"u"?p.width:this.width,typeof p.scrollWidth<"u"?p.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof p.height<"u"?p.height:this.height,typeof p.scrollHeight<"u"?p.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(p){return new R(this.c,this.width,this.scrollWidth,typeof p.scrollLeft<"u"?p.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof p.scrollTop<"u"?p.scrollTop:this.rawScrollTop)}createScrollEvent(p,c){const g=this.width!==p.width,f=this.scrollWidth!==p.scrollWidth,m=this.scrollLeft!==p.scrollLeft,n=this.height!==p.height,o=this.scrollHeight!==p.scrollHeight,i=this.scrollTop!==p.scrollTop;return{inSmoothScrolling:c,oldWidth:p.width,oldScrollWidth:p.scrollWidth,oldScrollLeft:p.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:p.height,oldScrollHeight:p.scrollHeight,oldScrollTop:p.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:f,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:i}}}e.$7s=R;class L extends h.$Vc{constructor(p){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$je),this.onScroll=this.j.event,this.c=p.smoothScrollDuration,this.f=p.scheduleAtNextAnimationFrame,this.g=new R(p.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(p){this.c=p}validateScrollPosition(p){return this.g.withScrollPosition(p)}getScrollDimensions(){return this.g}setScrollDimensions(p,c){const g=this.g.withScrollDimensions(p,c);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(p){const c=this.g.withScrollPosition(p);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(p,c){if(this.c===0)return this.setScrollPositionNow(p);if(this.h){p={scrollLeft:typeof p.scrollLeft>"u"?this.h.to.scrollLeft:p.scrollLeft,scrollTop:typeof p.scrollTop>"u"?this.h.to.scrollTop:p.scrollTop};const g=this.g.withScrollPosition(p);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let f;c?f=new C(this.h.from,g,this.h.startTime,this.h.duration):f=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=f}else{const g=this.g.withScrollPosition(p);this.h=C.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const p=this.h.tick(),c=this.g.withScrollPosition(p);if(this.n(c,!0),!!this.h){if(p.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(p,c){const g=this.g;g.equals(p)||(this.g=p,this.j.fire(this.g.createScrollEvent(g,c)))}}e.$8s=L;class T{constructor(p,c,g){this.scrollLeft=p,this.scrollTop=c,this.isDone=g}}e.$9s=T;function $(P,p){const c=p-P;return function(g){return P+c*u(g)}}function l(P,p,c){return function(g){return g<c?P(g/c):p((g-c)/(1-c))}}class C{constructor(p,c,g,f){this.from=p,this.to=c,this.duration=f,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(p,c,g){if(Math.abs(p-c)>2.5*g){let m,n;return p<c?(m=p+.75*g,n=c-.75*g):(m=p-.75*g,n=c+.75*g),l($(p,m),$(n,c),.33)}return $(p,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(p){this.to=p.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(p){const c=(p-this.startTime)/this.duration;if(c<1){const g=this.c(c),f=this.d(c);return new T(g,f,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(p,c,g){return C.start(p,c,g)}static start(p,c,g){g=g+10;const f=Date.now()-10;return new C(p,c,f,g)}}e.$0s=C;function E(P){return Math.pow(P,3)}function u(P){return 1-E(1-P)}}),define(Ee[104],Se([1,0,14,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=A,e.$xe=R,e.$ye=L,e.$ze=T,e.$Ae=l,e.$Be=C,e.$Ce=E,e.$De=u,e.$Ee=P,e.$Fe=p,e.$Ge=c,e.$He=g,e.$Ie=f,e.$Je=m,e.$Ke=n;function A(o){const i=o;return i?typeof i.read=="function":!1}function R(o){const i=o;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function L(o){const i=o;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function T(o,i){return new $(o,i)}class ${constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,r.$2)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let s;switch(i){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(o,i){const t=[];let s;for(;(s=o.read())!==null;)t.push(s);return i(t)}function C(o,i,t){const s=[];let d;for(;(d=o.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?i(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const a=d;return d=void 0,a}return o.read()}}}function E(o,i){return new Promise((t,s)=>{const d=[];u(o,{onData:a=>{i&&d.push(a)},onError:a=>{i?s(a):t(void 0)},onEnd:()=>{t(i?i(d):void 0)}})})}function u(o,i,t){o.on("error",s=>{t?.isCancellationRequested||i.onError(s)}),o.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),o.on("data",s=>{t?.isCancellationRequested||i.onData(s)})}function P(o,i){return new Promise((t,s)=>{const d=new h.$Uc,a=[],w=S=>{if(a.push(S),a.length>i)return d.dispose(),o.pause(),t({stream:o,buffer:a,ended:!1})},y=S=>(d.dispose(),s(S)),D=()=>(d.dispose(),t({stream:o,buffer:a,ended:!0}));d.add((0,h.$Tc)(()=>o.removeListener("error",y))),o.on("error",y),d.add((0,h.$Tc)(()=>o.removeListener("end",D))),o.on("end",D),d.add((0,h.$Tc)(()=>o.removeListener("data",w))),o.on("data",w)})}function p(o,i){const t=T(i);return t.end(o),t}function c(){const o=T(()=>{throw new Error("not supported")});return o.end(),o}function g(o){let i=!1;return{read:()=>i?null:(i=!0,o)}}function f(o,i,t){const s=T(t);return u(o,{onData:d=>s.write(i.data(d)),onError:d=>s.error(i.error?i.error(d):d),onEnd:()=>s.end()}),s}function m(o,i,t){let s=!1;return{read:()=>{const d=i.read();return s?d:(s=!0,d!==null?t([o,d]):o)}}}function n(o,i,t){let s=!1;const d=T(t);return u(i,{onData:a=>s?d.write(a):(s=!0,d.write(t([o,a]))),onError:a=>d.error(a),onEnd:()=>{s||(s=!0,d.write(o)),d.end()}}),d}}),define(Ee[22],Se([1,0,49,104]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=l,e.$Ne=C,e.$Oe=E,e.$Pe=u,e.$Qe=P,e.$Re=p,e.$Se=c,e.$Te=g,e.$Ue=f,e.$Ve=m,e.$We=n,e.$Xe=o,e.$Ye=i,e.$Ze=t,e.$1e=s,e.$2e=d,e.$3e=a,e.$4e=w,e.$5e=y,e.$6e=I,h=Ue(h);const A=typeof Buffer<"u",R=new r.$W(()=>new Uint8Array(256));let L,T;class ${static alloc(b){return A?new $(Buffer.allocUnsafe(b)):new $(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new $(b)}static fromString(b,v){return!(v?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(b)):(L||(L=new TextEncoder),new $(L.encode(b)))}static fromByteArray(b){const v=$.alloc(b.length);for(let N=0,O=b.length;N<O;N++)v.buffer[N]=b[N];return v}static concat(b,v){if(typeof v>"u"){v=0;for(let F=0,j=b.length;F<j;F++)v+=b[F].byteLength}const N=$.alloc(v);let O=0;for(let F=0,j=b.length;F<j;F++){const B=b[F];N.set(B,O),O+=B.byteLength}return N}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=$.alloc(this.byteLength);return b.set(this),b}toString(){return A?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(b,v){return new $(this.buffer.subarray(b,v))}set(b,v){if(b instanceof $)this.buffer.set(b.buffer,v);else if(b instanceof Uint8Array)this.buffer.set(b,v);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),v);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,v){P(this.buffer,b,v)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,v){c(this.buffer,b,v)}readUInt8(b){return g(this.buffer,b)}writeUInt8(b,v){f(this.buffer,b,v)}indexOf(b,v=0){return l(this.buffer,b instanceof $?b.buffer:b,v)}}e.$Le=$;function l(k,b,v=0){const N=b.byteLength,O=k.byteLength;if(N===0)return 0;if(N===1)return k.indexOf(b[0]);if(N>O-v)return-1;const F=R.value;F.fill(b.length);for(let W=0;W<b.length;W++)F[b[W]]=b.length-W-1;let j=v+b.length-1,B=j,M=-1;for(;j<O;)if(k[j]===b[B]){if(B===0){M=j;break}j--,B--}else j+=Math.max(b.length-B,F[k[j]]),B=b.length-1;return M}function C(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0}function E(k,b,v){k[v+0]=b&255,b=b>>>8,k[v+1]=b&255}function u(k,b){return k[b]*2**24+k[b+1]*2**16+k[b+2]*2**8+k[b+3]}function P(k,b,v){k[v+3]=b,b=b>>>8,k[v+2]=b,b=b>>>8,k[v+1]=b,b=b>>>8,k[v]=b}function p(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0|k[b+2]<<16>>>0|k[b+3]<<24>>>0}function c(k,b,v){k[v+0]=b&255,b=b>>>8,k[v+1]=b&255,b=b>>>8,k[v+2]=b&255,b=b>>>8,k[v+3]=b&255}function g(k,b){return k[b]}function f(k,b,v){k[v]=b}function m(k){return h.$Ae(k,b=>$.concat(b))}function n(k){return h.$He(k)}function o(k){return h.$Ce(k,b=>$.concat(b))}async function i(k){return k.ended?$.concat(k.buffer):$.concat([...k.buffer,await o(k.stream)])}function t(k){return h.$Fe(k,b=>$.concat(b))}function s(k){return h.$Ie(k,{data:b=>typeof b=="string"?$.fromString(b):$.wrap(b)},b=>$.concat(b))}function d(k){return h.$ze(b=>$.concat(b),k)}function a(k,b){return h.$Je(k,b,v=>$.concat(v))}function w(k,b){return h.$Ke(k,b,v=>$.concat(v))}function y(k){let b=0,v=0,N=0;const O=new Uint8Array(Math.floor(k.length/4*3)),F=B=>{switch(v){case 3:O[N++]=b|B,v=0;break;case 2:O[N++]=b|B>>>2,b=B<<6,v=3;break;case 1:O[N++]=b|B>>>4,b=B<<4,v=2;break;default:b=B<<2,v=1}};for(let B=0;B<k.length;B++){const M=k.charCodeAt(B);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${k[B]}`)}}const j=N;for(;v>0;)F(0);return $.wrap(O).slice(0,j)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:k},b=!0,v=!1){const N=v?S:D;let O="";const F=k.byteLength%3;let j=0;for(;j<k.byteLength-F;j+=3){const B=k[j+0],M=k[j+1],W=k[j+2];O+=N[B>>>2],O+=N[(B<<4|M>>>4)&63],O+=N[(M<<2|W>>>6)&63],O+=N[W&63]}if(F===1){const B=k[j+0];O+=N[B>>>2],O+=N[B<<4&63],b&&(O+="==")}else if(F===2){const B=k[j+0],M=k[j+1];O+=N[B>>>2],O+=N[(B<<4|M>>>4)&63],O+=N[M<<2&63],b&&(O+="=")}return O}}),define(Ee[184],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Ee[18],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=r,e.$dg=h,e.$eg=A,e.$fg=R,e.$gg=L,e.$hg=T,e.$ig=$,e.$jg=l,e.$kg=C,e.$lg=E,e.$mg=u,e.$ng=P,e.$og=p,e.$pg=g,e.$qg=f,e.$rg=m,e.$sg=n,e.$tg=o;function r(i){return typeof i=="string"}function h(i){return Array.isArray(i)&&i.every(t=>r(t))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function R(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function L(i){return typeof i=="number"&&!isNaN(i)}function T(i){return!!i&&typeof i[Symbol.iterator]=="function"}function $(i){return i===!0||i===!1}function l(i){return typeof i>"u"}function C(i){return!E(i)}function E(i){return l(i)||i===null}function u(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function P(i){if(E(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function p(...i){const t=[];for(let s=0;s<i.length;s++){const d=i[s];if(E(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}const c=Object.prototype.hasOwnProperty;function g(i){if(!A(i))return!1;for(const t in i)if(c.call(i,t))return!1;return!0}function f(i){return typeof i=="function"}function m(...i){return i.length>0&&i.every(f)}function n(i,t){const s=Math.min(i.length,t.length);for(let d=0;d<s;d++)o(i[d],t[d])}function o(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(i instanceof t)return}catch{}if(!E(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[105],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=A,e.$Xj=R;const h=Object.create(null);function A(L,T){if((0,r.$cg)(T)){const $=h[T];if($===void 0)throw new Error(`${L} references an unknown codicon: ${T}`);T=$}return h[L]=T,{id:L}}function R(){return h}}),define(Ee[185],Se([1,0,105]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,r.$Wj)("add",6e4),plus:(0,r.$Wj)("plus",6e4),gistNew:(0,r.$Wj)("gist-new",6e4),repoCreate:(0,r.$Wj)("repo-create",6e4),lightbulb:(0,r.$Wj)("lightbulb",60001),lightBulb:(0,r.$Wj)("light-bulb",60001),repo:(0,r.$Wj)("repo",60002),repoDelete:(0,r.$Wj)("repo-delete",60002),gistFork:(0,r.$Wj)("gist-fork",60003),repoForked:(0,r.$Wj)("repo-forked",60003),gitPullRequest:(0,r.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Wj)("record-keys",60005),keyboard:(0,r.$Wj)("keyboard",60005),tag:(0,r.$Wj)("tag",60006),gitPullRequestLabel:(0,r.$Wj)("git-pull-request-label",60006),tagAdd:(0,r.$Wj)("tag-add",60006),tagRemove:(0,r.$Wj)("tag-remove",60006),person:(0,r.$Wj)("person",60007),personFollow:(0,r.$Wj)("person-follow",60007),personOutline:(0,r.$Wj)("person-outline",60007),personFilled:(0,r.$Wj)("person-filled",60007),gitBranch:(0,r.$Wj)("git-branch",60008),gitBranchCreate:(0,r.$Wj)("git-branch-create",60008),gitBranchDelete:(0,r.$Wj)("git-branch-delete",60008),sourceControl:(0,r.$Wj)("source-control",60008),mirror:(0,r.$Wj)("mirror",60009),mirrorPublic:(0,r.$Wj)("mirror-public",60009),star:(0,r.$Wj)("star",60010),starAdd:(0,r.$Wj)("star-add",60010),starDelete:(0,r.$Wj)("star-delete",60010),starEmpty:(0,r.$Wj)("star-empty",60010),comment:(0,r.$Wj)("comment",60011),commentAdd:(0,r.$Wj)("comment-add",60011),alert:(0,r.$Wj)("alert",60012),warning:(0,r.$Wj)("warning",60012),search:(0,r.$Wj)("search",60013),searchSave:(0,r.$Wj)("search-save",60013),logOut:(0,r.$Wj)("log-out",60014),signOut:(0,r.$Wj)("sign-out",60014),logIn:(0,r.$Wj)("log-in",60015),signIn:(0,r.$Wj)("sign-in",60015),eye:(0,r.$Wj)("eye",60016),eyeUnwatch:(0,r.$Wj)("eye-unwatch",60016),eyeWatch:(0,r.$Wj)("eye-watch",60016),circleFilled:(0,r.$Wj)("circle-filled",60017),primitiveDot:(0,r.$Wj)("primitive-dot",60017),closeDirty:(0,r.$Wj)("close-dirty",60017),debugBreakpoint:(0,r.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Wj)("primitive-square",60018),edit:(0,r.$Wj)("edit",60019),pencil:(0,r.$Wj)("pencil",60019),info:(0,r.$Wj)("info",60020),issueOpened:(0,r.$Wj)("issue-opened",60020),gistPrivate:(0,r.$Wj)("gist-private",60021),gitForkPrivate:(0,r.$Wj)("git-fork-private",60021),lock:(0,r.$Wj)("lock",60021),mirrorPrivate:(0,r.$Wj)("mirror-private",60021),close:(0,r.$Wj)("close",60022),removeClose:(0,r.$Wj)("remove-close",60022),x:(0,r.$Wj)("x",60022),repoSync:(0,r.$Wj)("repo-sync",60023),sync:(0,r.$Wj)("sync",60023),clone:(0,r.$Wj)("clone",60024),desktopDownload:(0,r.$Wj)("desktop-download",60024),beaker:(0,r.$Wj)("beaker",60025),microscope:(0,r.$Wj)("microscope",60025),vm:(0,r.$Wj)("vm",60026),deviceDesktop:(0,r.$Wj)("device-desktop",60026),file:(0,r.$Wj)("file",60027),fileText:(0,r.$Wj)("file-text",60027),more:(0,r.$Wj)("more",60028),ellipsis:(0,r.$Wj)("ellipsis",60028),kebabHorizontal:(0,r.$Wj)("kebab-horizontal",60028),mailReply:(0,r.$Wj)("mail-reply",60029),reply:(0,r.$Wj)("reply",60029),organization:(0,r.$Wj)("organization",60030),organizationFilled:(0,r.$Wj)("organization-filled",60030),organizationOutline:(0,r.$Wj)("organization-outline",60030),newFile:(0,r.$Wj)("new-file",60031),fileAdd:(0,r.$Wj)("file-add",60031),newFolder:(0,r.$Wj)("new-folder",60032),fileDirectoryCreate:(0,r.$Wj)("file-directory-create",60032),trash:(0,r.$Wj)("trash",60033),trashcan:(0,r.$Wj)("trashcan",60033),history:(0,r.$Wj)("history",60034),clock:(0,r.$Wj)("clock",60034),folder:(0,r.$Wj)("folder",60035),fileDirectory:(0,r.$Wj)("file-directory",60035),symbolFolder:(0,r.$Wj)("symbol-folder",60035),logoGithub:(0,r.$Wj)("logo-github",60036),markGithub:(0,r.$Wj)("mark-github",60036),github:(0,r.$Wj)("github",60036),terminal:(0,r.$Wj)("terminal",60037),console:(0,r.$Wj)("console",60037),repl:(0,r.$Wj)("repl",60037),zap:(0,r.$Wj)("zap",60038),symbolEvent:(0,r.$Wj)("symbol-event",60038),error:(0,r.$Wj)("error",60039),stop:(0,r.$Wj)("stop",60039),variable:(0,r.$Wj)("variable",60040),symbolVariable:(0,r.$Wj)("symbol-variable",60040),array:(0,r.$Wj)("array",60042),symbolArray:(0,r.$Wj)("symbol-array",60042),symbolModule:(0,r.$Wj)("symbol-module",60043),symbolPackage:(0,r.$Wj)("symbol-package",60043),symbolNamespace:(0,r.$Wj)("symbol-namespace",60043),symbolObject:(0,r.$Wj)("symbol-object",60043),symbolMethod:(0,r.$Wj)("symbol-method",60044),symbolFunction:(0,r.$Wj)("symbol-function",60044),symbolConstructor:(0,r.$Wj)("symbol-constructor",60044),symbolBoolean:(0,r.$Wj)("symbol-boolean",60047),symbolNull:(0,r.$Wj)("symbol-null",60047),symbolNumeric:(0,r.$Wj)("symbol-numeric",60048),symbolNumber:(0,r.$Wj)("symbol-number",60048),symbolStructure:(0,r.$Wj)("symbol-structure",60049),symbolStruct:(0,r.$Wj)("symbol-struct",60049),symbolParameter:(0,r.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Wj)("symbol-type-parameter",60050),symbolKey:(0,r.$Wj)("symbol-key",60051),symbolText:(0,r.$Wj)("symbol-text",60051),symbolReference:(0,r.$Wj)("symbol-reference",60052),goToFile:(0,r.$Wj)("go-to-file",60052),symbolEnum:(0,r.$Wj)("symbol-enum",60053),symbolValue:(0,r.$Wj)("symbol-value",60053),symbolRuler:(0,r.$Wj)("symbol-ruler",60054),symbolUnit:(0,r.$Wj)("symbol-unit",60054),activateBreakpoints:(0,r.$Wj)("activate-breakpoints",60055),archive:(0,r.$Wj)("archive",60056),arrowBoth:(0,r.$Wj)("arrow-both",60057),arrowDown:(0,r.$Wj)("arrow-down",60058),arrowLeft:(0,r.$Wj)("arrow-left",60059),arrowRight:(0,r.$Wj)("arrow-right",60060),arrowSmallDown:(0,r.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Wj)("arrow-small-up",60064),arrowUp:(0,r.$Wj)("arrow-up",60065),bell:(0,r.$Wj)("bell",60066),bold:(0,r.$Wj)("bold",60067),book:(0,r.$Wj)("book",60068),bookmark:(0,r.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Wj)("briefcase",60076),broadcast:(0,r.$Wj)("broadcast",60077),browser:(0,r.$Wj)("browser",60078),bug:(0,r.$Wj)("bug",60079),calendar:(0,r.$Wj)("calendar",60080),caseSensitive:(0,r.$Wj)("case-sensitive",60081),check:(0,r.$Wj)("check",60082),checklist:(0,r.$Wj)("checklist",60083),chevronDown:(0,r.$Wj)("chevron-down",60084),chevronLeft:(0,r.$Wj)("chevron-left",60085),chevronRight:(0,r.$Wj)("chevron-right",60086),chevronUp:(0,r.$Wj)("chevron-up",60087),chromeClose:(0,r.$Wj)("chrome-close",60088),chromeMaximize:(0,r.$Wj)("chrome-maximize",60089),chromeMinimize:(0,r.$Wj)("chrome-minimize",60090),chromeRestore:(0,r.$Wj)("chrome-restore",60091),circleOutline:(0,r.$Wj)("circle-outline",60092),circle:(0,r.$Wj)("circle",60092),debugBreakpointUnverified:(0,r.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Wj)("circle-slash",60093),circuitBoard:(0,r.$Wj)("circuit-board",60094),clearAll:(0,r.$Wj)("clear-all",60095),clippy:(0,r.$Wj)("clippy",60096),closeAll:(0,r.$Wj)("close-all",60097),cloudDownload:(0,r.$Wj)("cloud-download",60098),cloudUpload:(0,r.$Wj)("cloud-upload",60099),code:(0,r.$Wj)("code",60100),collapseAll:(0,r.$Wj)("collapse-all",60101),colorMode:(0,r.$Wj)("color-mode",60102),commentDiscussion:(0,r.$Wj)("comment-discussion",60103),creditCard:(0,r.$Wj)("credit-card",60105),dash:(0,r.$Wj)("dash",60108),dashboard:(0,r.$Wj)("dashboard",60109),database:(0,r.$Wj)("database",60110),debugContinue:(0,r.$Wj)("debug-continue",60111),debugDisconnect:(0,r.$Wj)("debug-disconnect",60112),debugPause:(0,r.$Wj)("debug-pause",60113),debugRestart:(0,r.$Wj)("debug-restart",60114),debugStart:(0,r.$Wj)("debug-start",60115),debugStepInto:(0,r.$Wj)("debug-step-into",60116),debugStepOut:(0,r.$Wj)("debug-step-out",60117),debugStepOver:(0,r.$Wj)("debug-step-over",60118),debugStop:(0,r.$Wj)("debug-stop",60119),debug:(0,r.$Wj)("debug",60120),deviceCameraVideo:(0,r.$Wj)("device-camera-video",60121),deviceCamera:(0,r.$Wj)("device-camera",60122),deviceMobile:(0,r.$Wj)("device-mobile",60123),diffAdded:(0,r.$Wj)("diff-added",60124),diffIgnored:(0,r.$Wj)("diff-ignored",60125),diffModified:(0,r.$Wj)("diff-modified",60126),diffRemoved:(0,r.$Wj)("diff-removed",60127),diffRenamed:(0,r.$Wj)("diff-renamed",60128),diff:(0,r.$Wj)("diff",60129),diffSidebyside:(0,r.$Wj)("diff-sidebyside",60129),discard:(0,r.$Wj)("discard",60130),editorLayout:(0,r.$Wj)("editor-layout",60131),emptyWindow:(0,r.$Wj)("empty-window",60132),exclude:(0,r.$Wj)("exclude",60133),extensions:(0,r.$Wj)("extensions",60134),eyeClosed:(0,r.$Wj)("eye-closed",60135),fileBinary:(0,r.$Wj)("file-binary",60136),fileCode:(0,r.$Wj)("file-code",60137),fileMedia:(0,r.$Wj)("file-media",60138),filePdf:(0,r.$Wj)("file-pdf",60139),fileSubmodule:(0,r.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Wj)("file-symlink-file",60142),fileZip:(0,r.$Wj)("file-zip",60143),files:(0,r.$Wj)("files",60144),filter:(0,r.$Wj)("filter",60145),flame:(0,r.$Wj)("flame",60146),foldDown:(0,r.$Wj)("fold-down",60147),foldUp:(0,r.$Wj)("fold-up",60148),fold:(0,r.$Wj)("fold",60149),folderActive:(0,r.$Wj)("folder-active",60150),folderOpened:(0,r.$Wj)("folder-opened",60151),gear:(0,r.$Wj)("gear",60152),gift:(0,r.$Wj)("gift",60153),gistSecret:(0,r.$Wj)("gist-secret",60154),gist:(0,r.$Wj)("gist",60155),gitCommit:(0,r.$Wj)("git-commit",60156),gitCompare:(0,r.$Wj)("git-compare",60157),compareChanges:(0,r.$Wj)("compare-changes",60157),gitMerge:(0,r.$Wj)("git-merge",60158),githubAction:(0,r.$Wj)("github-action",60159),githubAlt:(0,r.$Wj)("github-alt",60160),globe:(0,r.$Wj)("globe",60161),grabber:(0,r.$Wj)("grabber",60162),graph:(0,r.$Wj)("graph",60163),gripper:(0,r.$Wj)("gripper",60164),heart:(0,r.$Wj)("heart",60165),home:(0,r.$Wj)("home",60166),horizontalRule:(0,r.$Wj)("horizontal-rule",60167),hubot:(0,r.$Wj)("hubot",60168),inbox:(0,r.$Wj)("inbox",60169),issueReopened:(0,r.$Wj)("issue-reopened",60171),issues:(0,r.$Wj)("issues",60172),italic:(0,r.$Wj)("italic",60173),jersey:(0,r.$Wj)("jersey",60174),json:(0,r.$Wj)("json",60175),kebabVertical:(0,r.$Wj)("kebab-vertical",60176),key:(0,r.$Wj)("key",60177),law:(0,r.$Wj)("law",60178),lightbulbAutofix:(0,r.$Wj)("lightbulb-autofix",60179),linkExternal:(0,r.$Wj)("link-external",60180),link:(0,r.$Wj)("link",60181),listOrdered:(0,r.$Wj)("list-ordered",60182),listUnordered:(0,r.$Wj)("list-unordered",60183),liveShare:(0,r.$Wj)("live-share",60184),loading:(0,r.$Wj)("loading",60185),location:(0,r.$Wj)("location",60186),mailRead:(0,r.$Wj)("mail-read",60187),mail:(0,r.$Wj)("mail",60188),markdown:(0,r.$Wj)("markdown",60189),megaphone:(0,r.$Wj)("megaphone",60190),mention:(0,r.$Wj)("mention",60191),milestone:(0,r.$Wj)("milestone",60192),gitPullRequestMilestone:(0,r.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Wj)("mortar-board",60193),move:(0,r.$Wj)("move",60194),multipleWindows:(0,r.$Wj)("multiple-windows",60195),mute:(0,r.$Wj)("mute",60196),noNewline:(0,r.$Wj)("no-newline",60197),note:(0,r.$Wj)("note",60198),octoface:(0,r.$Wj)("octoface",60199),openPreview:(0,r.$Wj)("open-preview",60200),package:(0,r.$Wj)("package",60201),paintcan:(0,r.$Wj)("paintcan",60202),pin:(0,r.$Wj)("pin",60203),play:(0,r.$Wj)("play",60204),run:(0,r.$Wj)("run",60204),plug:(0,r.$Wj)("plug",60205),preserveCase:(0,r.$Wj)("preserve-case",60206),preview:(0,r.$Wj)("preview",60207),project:(0,r.$Wj)("project",60208),pulse:(0,r.$Wj)("pulse",60209),question:(0,r.$Wj)("question",60210),quote:(0,r.$Wj)("quote",60211),radioTower:(0,r.$Wj)("radio-tower",60212),reactions:(0,r.$Wj)("reactions",60213),references:(0,r.$Wj)("references",60214),refresh:(0,r.$Wj)("refresh",60215),regex:(0,r.$Wj)("regex",60216),remoteExplorer:(0,r.$Wj)("remote-explorer",60217),remote:(0,r.$Wj)("remote",60218),remove:(0,r.$Wj)("remove",60219),replaceAll:(0,r.$Wj)("replace-all",60220),replace:(0,r.$Wj)("replace",60221),repoClone:(0,r.$Wj)("repo-clone",60222),repoForcePush:(0,r.$Wj)("repo-force-push",60223),repoPull:(0,r.$Wj)("repo-pull",60224),repoPush:(0,r.$Wj)("repo-push",60225),report:(0,r.$Wj)("report",60226),requestChanges:(0,r.$Wj)("request-changes",60227),rocket:(0,r.$Wj)("rocket",60228),rootFolderOpened:(0,r.$Wj)("root-folder-opened",60229),rootFolder:(0,r.$Wj)("root-folder",60230),rss:(0,r.$Wj)("rss",60231),ruby:(0,r.$Wj)("ruby",60232),saveAll:(0,r.$Wj)("save-all",60233),saveAs:(0,r.$Wj)("save-as",60234),save:(0,r.$Wj)("save",60235),screenFull:(0,r.$Wj)("screen-full",60236),screenNormal:(0,r.$Wj)("screen-normal",60237),searchStop:(0,r.$Wj)("search-stop",60238),server:(0,r.$Wj)("server",60240),settingsGear:(0,r.$Wj)("settings-gear",60241),settings:(0,r.$Wj)("settings",60242),shield:(0,r.$Wj)("shield",60243),smiley:(0,r.$Wj)("smiley",60244),sortPrecedence:(0,r.$Wj)("sort-precedence",60245),splitHorizontal:(0,r.$Wj)("split-horizontal",60246),splitVertical:(0,r.$Wj)("split-vertical",60247),squirrel:(0,r.$Wj)("squirrel",60248),starFull:(0,r.$Wj)("star-full",60249),starHalf:(0,r.$Wj)("star-half",60250),symbolClass:(0,r.$Wj)("symbol-class",60251),symbolColor:(0,r.$Wj)("symbol-color",60252),symbolConstant:(0,r.$Wj)("symbol-constant",60253),symbolEnumMember:(0,r.$Wj)("symbol-enum-member",60254),symbolField:(0,r.$Wj)("symbol-field",60255),symbolFile:(0,r.$Wj)("symbol-file",60256),symbolInterface:(0,r.$Wj)("symbol-interface",60257),symbolKeyword:(0,r.$Wj)("symbol-keyword",60258),symbolMisc:(0,r.$Wj)("symbol-misc",60259),symbolOperator:(0,r.$Wj)("symbol-operator",60260),symbolProperty:(0,r.$Wj)("symbol-property",60261),wrench:(0,r.$Wj)("wrench",60261),wrenchSubaction:(0,r.$Wj)("wrench-subaction",60261),symbolSnippet:(0,r.$Wj)("symbol-snippet",60262),tasklist:(0,r.$Wj)("tasklist",60263),telescope:(0,r.$Wj)("telescope",60264),textSize:(0,r.$Wj)("text-size",60265),threeBars:(0,r.$Wj)("three-bars",60266),thumbsdown:(0,r.$Wj)("thumbsdown",60267),thumbsup:(0,r.$Wj)("thumbsup",60268),tools:(0,r.$Wj)("tools",60269),triangleDown:(0,r.$Wj)("triangle-down",60270),triangleLeft:(0,r.$Wj)("triangle-left",60271),triangleRight:(0,r.$Wj)("triangle-right",60272),triangleUp:(0,r.$Wj)("triangle-up",60273),twitter:(0,r.$Wj)("twitter",60274),unfold:(0,r.$Wj)("unfold",60275),unlock:(0,r.$Wj)("unlock",60276),unmute:(0,r.$Wj)("unmute",60277),unverified:(0,r.$Wj)("unverified",60278),verified:(0,r.$Wj)("verified",60279),versions:(0,r.$Wj)("versions",60280),vmActive:(0,r.$Wj)("vm-active",60281),vmOutline:(0,r.$Wj)("vm-outline",60282),vmRunning:(0,r.$Wj)("vm-running",60283),watch:(0,r.$Wj)("watch",60284),whitespace:(0,r.$Wj)("whitespace",60285),wholeWord:(0,r.$Wj)("whole-word",60286),window:(0,r.$Wj)("window",60287),wordWrap:(0,r.$Wj)("word-wrap",60288),zoomIn:(0,r.$Wj)("zoom-in",60289),zoomOut:(0,r.$Wj)("zoom-out",60290),listFilter:(0,r.$Wj)("list-filter",60291),listFlat:(0,r.$Wj)("list-flat",60292),listSelection:(0,r.$Wj)("list-selection",60293),selection:(0,r.$Wj)("selection",60293),listTree:(0,r.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Wj)("symbol-string",60301),debugReverseContinue:(0,r.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Wj)("debug-step-back",60303),debugRestartFrame:(0,r.$Wj)("debug-restart-frame",60304),debugAlt:(0,r.$Wj)("debug-alt",60305),callIncoming:(0,r.$Wj)("call-incoming",60306),callOutgoing:(0,r.$Wj)("call-outgoing",60307),menu:(0,r.$Wj)("menu",60308),expandAll:(0,r.$Wj)("expand-all",60309),feedback:(0,r.$Wj)("feedback",60310),gitPullRequestReviewer:(0,r.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Wj)("ungroup-by-ref-type",60312),account:(0,r.$Wj)("account",60313),gitPullRequestAssignee:(0,r.$Wj)("git-pull-request-assignee",60313),bellDot:(0,r.$Wj)("bell-dot",60314),debugConsole:(0,r.$Wj)("debug-console",60315),library:(0,r.$Wj)("library",60316),output:(0,r.$Wj)("output",60317),runAll:(0,r.$Wj)("run-all",60318),syncIgnored:(0,r.$Wj)("sync-ignored",60319),pinned:(0,r.$Wj)("pinned",60320),githubInverted:(0,r.$Wj)("github-inverted",60321),serverProcess:(0,r.$Wj)("server-process",60322),serverEnvironment:(0,r.$Wj)("server-environment",60323),pass:(0,r.$Wj)("pass",60324),issueClosed:(0,r.$Wj)("issue-closed",60324),stopCircle:(0,r.$Wj)("stop-circle",60325),playCircle:(0,r.$Wj)("play-circle",60326),record:(0,r.$Wj)("record",60327),debugAltSmall:(0,r.$Wj)("debug-alt-small",60328),vmConnect:(0,r.$Wj)("vm-connect",60329),cloud:(0,r.$Wj)("cloud",60330),merge:(0,r.$Wj)("merge",60331),export:(0,r.$Wj)("export",60332),graphLeft:(0,r.$Wj)("graph-left",60333),magnet:(0,r.$Wj)("magnet",60334),notebook:(0,r.$Wj)("notebook",60335),redo:(0,r.$Wj)("redo",60336),checkAll:(0,r.$Wj)("check-all",60337),pinnedDirty:(0,r.$Wj)("pinned-dirty",60338),passFilled:(0,r.$Wj)("pass-filled",60339),circleLargeFilled:(0,r.$Wj)("circle-large-filled",60340),circleLarge:(0,r.$Wj)("circle-large",60341),circleLargeOutline:(0,r.$Wj)("circle-large-outline",60341),combine:(0,r.$Wj)("combine",60342),gather:(0,r.$Wj)("gather",60342),table:(0,r.$Wj)("table",60343),variableGroup:(0,r.$Wj)("variable-group",60344),typeHierarchy:(0,r.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Wj)("git-pull-request-create",60348),runAbove:(0,r.$Wj)("run-above",60349),runBelow:(0,r.$Wj)("run-below",60350),notebookTemplate:(0,r.$Wj)("notebook-template",60351),debugRerun:(0,r.$Wj)("debug-rerun",60352),workspaceTrusted:(0,r.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Wj)("workspace-unknown",60355),terminalCmd:(0,r.$Wj)("terminal-cmd",60356),terminalDebian:(0,r.$Wj)("terminal-debian",60357),terminalLinux:(0,r.$Wj)("terminal-linux",60358),terminalPowershell:(0,r.$Wj)("terminal-powershell",60359),terminalTmux:(0,r.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Wj)("terminal-ubuntu",60361),terminalBash:(0,r.$Wj)("terminal-bash",60362),arrowSwap:(0,r.$Wj)("arrow-swap",60363),copy:(0,r.$Wj)("copy",60364),personAdd:(0,r.$Wj)("person-add",60365),filterFilled:(0,r.$Wj)("filter-filled",60366),wand:(0,r.$Wj)("wand",60367),debugLineByLine:(0,r.$Wj)("debug-line-by-line",60368),inspect:(0,r.$Wj)("inspect",60369),layers:(0,r.$Wj)("layers",60370),layersDot:(0,r.$Wj)("layers-dot",60371),layersActive:(0,r.$Wj)("layers-active",60372),compass:(0,r.$Wj)("compass",60373),compassDot:(0,r.$Wj)("compass-dot",60374),compassActive:(0,r.$Wj)("compass-active",60375),azure:(0,r.$Wj)("azure",60376),issueDraft:(0,r.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Wj)("git-pull-request-draft",60379),debugAll:(0,r.$Wj)("debug-all",60380),debugCoverage:(0,r.$Wj)("debug-coverage",60381),runErrors:(0,r.$Wj)("run-errors",60382),folderLibrary:(0,r.$Wj)("folder-library",60383),debugContinueSmall:(0,r.$Wj)("debug-continue-small",60384),beakerStop:(0,r.$Wj)("beaker-stop",60385),graphLine:(0,r.$Wj)("graph-line",60386),graphScatter:(0,r.$Wj)("graph-scatter",60387),pieChart:(0,r.$Wj)("pie-chart",60388),bracket:(0,r.$Wj)("bracket",60175),bracketDot:(0,r.$Wj)("bracket-dot",60389),bracketError:(0,r.$Wj)("bracket-error",60390),lockSmall:(0,r.$Wj)("lock-small",60391),azureDevops:(0,r.$Wj)("azure-devops",60392),verifiedFilled:(0,r.$Wj)("verified-filled",60393),newline:(0,r.$Wj)("newline",60394),layout:(0,r.$Wj)("layout",60395),layoutActivitybarLeft:(0,r.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Wj)("layout-panel-right",60401),layoutPanel:(0,r.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Wj)("layout-statusbar",60405),layoutMenubar:(0,r.$Wj)("layout-menubar",60406),layoutCentered:(0,r.$Wj)("layout-centered",60407),target:(0,r.$Wj)("target",60408),indent:(0,r.$Wj)("indent",60409),recordSmall:(0,r.$Wj)("record-small",60410),errorSmall:(0,r.$Wj)("error-small",60411),terminalDecorationError:(0,r.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Wj)("layout-sidebar-left-off",60418),blank:(0,r.$Wj)("blank",60419),heartFilled:(0,r.$Wj)("heart-filled",60420),map:(0,r.$Wj)("map",60421),mapHorizontal:(0,r.$Wj)("map-horizontal",60421),foldHorizontal:(0,r.$Wj)("fold-horizontal",60421),mapFilled:(0,r.$Wj)("map-filled",60422),mapHorizontalFilled:(0,r.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Wj)("circle-small",60423),bellSlash:(0,r.$Wj)("bell-slash",60424),bellSlashDot:(0,r.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Wj)("search-fuzzy",60429),commentDraft:(0,r.$Wj)("comment-draft",60430),send:(0,r.$Wj)("send",60431),sparkle:(0,r.$Wj)("sparkle",60432),insert:(0,r.$Wj)("insert",60433),mic:(0,r.$Wj)("mic",60434),thumbsdownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Wj)("thumbsup-filled",60436),coffee:(0,r.$Wj)("coffee",60437),snake:(0,r.$Wj)("snake",60438),game:(0,r.$Wj)("game",60439),vr:(0,r.$Wj)("vr",60440),chip:(0,r.$Wj)("chip",60441),piano:(0,r.$Wj)("piano",60442),music:(0,r.$Wj)("music",60443),micFilled:(0,r.$Wj)("mic-filled",60444),repoFetch:(0,r.$Wj)("repo-fetch",60445),copilot:(0,r.$Wj)("copilot",60446),lightbulbSparkle:(0,r.$Wj)("lightbulb-sparkle",60447),robot:(0,r.$Wj)("robot",60448),sparkleFilled:(0,r.$Wj)("sparkle-filled",60449),diffSingle:(0,r.$Wj)("diff-single",60450),diffMultiple:(0,r.$Wj)("diff-multiple",60451),surroundWith:(0,r.$Wj)("surround-with",60452),share:(0,r.$Wj)("share",60453),gitStash:(0,r.$Wj)("git-stash",60454),gitStashApply:(0,r.$Wj)("git-stash-apply",60455),gitStashPop:(0,r.$Wj)("git-stash-pop",60456),vscode:(0,r.$Wj)("vscode",60457),vscodeInsiders:(0,r.$Wj)("vscode-insiders",60458),codeOss:(0,r.$Wj)("code-oss",60459),runCoverage:(0,r.$Wj)("run-coverage",60460),runAllCoverage:(0,r.$Wj)("run-all-coverage",60461),coverage:(0,r.$Wj)("coverage",60462),githubProject:(0,r.$Wj)("github-project",60463),mapVertical:(0,r.$Wj)("map-vertical",60464),foldVertical:(0,r.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Wj)("fold-vertical-filled",60465),goToSearch:(0,r.$Wj)("go-to-search",60466),percentage:(0,r.$Wj)("percentage",60467),sortPercentage:(0,r.$Wj)("sort-percentage",60467),attach:(0,r.$Wj)("attach",60468)}}),define(Ee[83],Se([1,0,105,185]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=A;function A(){return Object.values(e.$2j)}e.$1j={dialogError:(0,r.$Wj)("dialog-error","error"),dialogWarning:(0,r.$Wj)("dialog-warning","warning"),dialogInfo:(0,r.$Wj)("dialog-info","info"),dialogClose:(0,r.$Wj)("dialog-close","close"),treeItemExpanded:(0,r.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Wj)("tree-item-loading","loading"),menuSelection:(0,r.$Wj)("menu-selection","check"),menuSubmenu:(0,r.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Wj)("toolbar-more","more"),quickInputBack:(0,r.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Wj)("drop-down-button",60084),symbolCustomColor:(0,r.$Wj)("symbol-customcolor",60252),exportIcon:(0,r.$Wj)("export",60332),workspaceUnspecified:(0,r.$Wj)("workspace-unspecified",60355),newLine:(0,r.$Wj)("newline",60394),thumbsDownFilled:(0,r.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Wj)("thumbsup-filled",60436),gitFetch:(0,r.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...h.$Yj,...e.$1j}}),define(Ee[25],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=h,e.$ao=A,e.$bo=L,e.$co=$,e.$do=l,e.$eo=C,e.$fo=E,e.$go=u,e.$ho=P,e.$io=p,e.$jo=c,e.$ko=g,e.$lo=f;function h(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([o,i])=>{n[o]=i&&typeof i=="object"?h(i):i}),n}function A(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const i in o)if(R.call(o,i)){const t=o[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$fg)(t)&&n.push(t)}}return m}const R=Object.prototype.hasOwnProperty;function L(m,n){return T(m,n,new Set)}function T(m,n,o){if((0,r.$lg)(m))return m;const i=n(m);if(typeof i<"u")return i;if(Array.isArray(m)){const t=[];for(const s of m)t.push(T(s,n,o));return t}if((0,r.$eg)(m)){if(o.has(m))throw new Error("Cannot clone recursive data-structure");o.add(m);const t={};for(const s in m)R.call(m,s)&&(t[s]=T(m[s],n,o));return o.delete(m),t}return m}function $(m,n,o=!0){return(0,r.$eg)(m)?((0,r.$eg)(n)&&Object.keys(n).forEach(i=>{i in m?o&&((0,r.$eg)(m[i])&&(0,r.$eg)(n[i])?$(m[i],n[i],o):m[i]=n[i]):m[i]=n[i]}),m):n}function l(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let o,i;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(o=0;o<m.length;o++)if(!l(m[o],n[o]))return!1}else{const t=[];for(i in m)t.push(i);t.sort();const s=[];for(i in n)s.push(i);if(s.sort(),!l(t,s))return!1;for(o=0;o<t.length;o++)if(!l(m[t[o]],n[t[o]]))return!1}return!0}function C(m){const n=new Set;return JSON.stringify(m,(o,i)=>{if((0,r.$eg)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function E(m,n){const o=Object.create(null);return!m||!n||Object.keys(n).forEach(t=>{const s=m[t],d=n[t];l(s,d)||(o[t]=d)}),o}function u(m,n){const o=n.toLowerCase(),i=Object.keys(m).find(t=>t.toLowerCase()===o);return i?m[i]:m[n]}function P(m,n){const o=Object.create(null);for(const[i,t]of Object.entries(m))n(i,t)&&(o[i]=t);return o}function p(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function c(m){const n=[];for(const o of p(m))typeof m[o]=="function"&&n.push(o);return n}function g(m,n){const o=t=>function(){const s=Array.prototype.slice.call(arguments,0);return n(t,s)},i={};for(const t of m)i[t]=o(t);return i}function f(m,n){const o={};for(const[i,t]of Object.entries(m))o[i]=n(t,i);return o}}),define(Ee[50],Se([1,0,83]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=A;var h;(function(L){function T($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=T})(h||(e.ThemeColor=h={}));function A(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(m){const n=T.exec(m.id);if(!n)return $(r.$2j.error);const[,o,i]=n,t=["codicon","codicon-"+o];return i&&t.push("codicon-modifier-"+i.substring(1)),t}L.asClassNameArray=$;function l(m){return $(m).join(" ")}L.asClassName=l;function C(m){return"."+$(m).join(".")}L.asCSSSelector=C;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||h.isThemeColor(m.color))}L.isThemeIcon=E;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(m){const n=u.exec(m);if(!n)return;const[,o]=n;return{id:o}}L.fromString=P;function p(m){return{id:m}}L.fromId=p;function c(m,n){let o=m.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}L.modify=c;function g(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}L.getModifier=g;function f(m,n){return m.id===n.id&&m.color?.id===n.color?.id}L.isEqual=f})(R||(e.ThemeIcon=R={}))}),define(Ee[84],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=h,e.$_e=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(Ee[13],Se([1,0,182,27,49,84]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=L,e.$bf=$,e.$cf=C,e.$df=E,e.$ef=u,e.$ff=P,e.$gf=p,e.$hf=c,e.$if=g,e.$jf=f,e.$kf=m,e.$lf=n,e.$mf=o,e.$nf=i,e.$of=t,e.$pf=s,e.$qf=d,e.$rf=a,e.$sf=w,e.$tf=y,e.$uf=D,e.$vf=S,e.$wf=I,e.$xf=k,e.$yf=b,e.$zf=v,e.$Af=N,e.$Bf=O,e.$Cf=F,e.$Df=j,e.$Ef=B,e.$Ff=M,e.$Gf=W,e.$Hf=_,e.$If=re,e.$Jf=z,e.$Kf=G,e.$Nf=ne,e.$Of=De,e.$Pf=$e,e.$Qf=Q,e.$Rf=oe,e.$Sf=le,e.$Uf=he,e.$Vf=X,e.$Wf=ae,e.$Xf=pe,e.$Yf=Me,e.$Zf=We,e.$1f=Ie,e.$3f=Te,e.$4f=V,e.$5f=q,e.$6f=Y,e.$7f=x,e.$8f=fe,e.$9f=we,e.$0f=Ne,e.$$f=ot;function L(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const T=/{(\d+)}/g;function $(Pe,...Be){return Be.length===0?Pe:Pe.replace(T,function(Ke,Oe){const Fe=parseInt(Oe,10);return isNaN(Fe)||Fe<0||Fe>=Be.length?Ke:Be[Fe]})}const l=/{([^}]+)}/g;function C(Pe,Be){return Object.keys(Be).length===0?Pe:Pe.replace(l,(Ke,Oe)=>Be[Oe]??Ke)}function E(Pe){return Pe.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function u(Pe){return Pe.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Pe,Be){let Ke=0,Oe=Pe.indexOf(Be);for(;Oe!==-1;)Ke++,Oe=Pe.indexOf(Be,Oe+Be.length);return Ke}function c(Pe,Be,Ke="\u2026"){return Pe.length<=Be?Pe:`${Pe.substr(0,Be)}${Ke}`}function g(Pe,Be,Ke="\u2026"){if(Pe.length<=Be)return Pe;const Oe=Math.ceil(Be/2)-Ke.length/2,Fe=Math.floor(Be/2)-Ke.length/2;return`${Pe.substr(0,Oe)}${Ke}${Pe.substr(Pe.length-Fe)}`}function f(Pe,Be=" "){const Ke=m(Pe,Be);return n(Ke,Be)}function m(Pe,Be){if(!Pe||!Be)return Pe;const Ke=Be.length;if(Ke===0||Pe.length===0)return Pe;let Oe=0;for(;Pe.indexOf(Be,Oe)===Oe;)Oe=Oe+Ke;return Pe.substring(Oe)}function n(Pe,Be){if(!Pe||!Be)return Pe;const Ke=Be.length,Oe=Pe.length;if(Ke===0||Oe===0)return Pe;let Fe=Oe,Z=-1;for(;Z=Pe.lastIndexOf(Be,Fe-1),!(Z===-1||Z+Ke!==Fe);){if(Z===0)return"";Fe=Z}return Pe.substring(0,Fe)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function t(Pe,Be,Ke={}){if(!Pe)throw new Error("Cannot create regex from empty string");Be||(Pe=P(Pe)),Ke.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Oe="";return Ke.global&&(Oe+="g"),Ke.matchCase||(Oe+="i"),Ke.multiline&&(Oe+="m"),Ke.unicode&&(Oe+="u"),new RegExp(Pe,Oe)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function d(Pe){return Pe.split(/\r\n|\r|\n/)}function a(Pe){const Be=[],Ke=Pe.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(Ke.length/2);Oe++)Be.push(Ke[2*Oe]+(Ke[2*Oe+1]??""));return Be}function w(Pe){for(let Be=0,Ke=Pe.length;Be<Ke;Be++){const Oe=Pe.charCodeAt(Be);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return Be}return-1}function y(Pe,Be=0,Ke=Pe.length){for(let Oe=Be;Oe<Ke;Oe++){const Fe=Pe.charCodeAt(Oe);if(Fe!==h.CharCode.Space&&Fe!==h.CharCode.Tab)return Pe.substring(Be,Oe)}return Pe.substring(Be,Ke)}function D(Pe,Be=Pe.length-1){for(let Ke=Be;Ke>=0;Ke--){const Oe=Pe.charCodeAt(Ke);if(Oe!==h.CharCode.Space&&Oe!==h.CharCode.Tab)return Ke}return-1}function S(Pe,Be,Ke){const Oe=[];let Fe=0;for(const Z of Pe.matchAll(Be)){if(Oe.push(Pe.slice(Fe,Z.index)),Z.index===void 0)throw new Error("match.index should be defined");Fe=Z.index+Z[0].length,Oe.push(Ke(Z[0],...Z.slice(1),Z.index,Pe,Z.groups))}return Oe.push(Pe.slice(Fe)),Promise.all(Oe).then(Z=>Z.join(""))}function I(Pe,Be){return Pe<Be?-1:Pe>Be?1:0}function k(Pe,Be,Ke=0,Oe=Pe.length,Fe=0,Z=Be.length){for(;Ke<Oe&&Fe<Z;Ke++,Fe++){const Xe=Pe.charCodeAt(Ke),_e=Be.charCodeAt(Fe);if(Xe<_e)return-1;if(Xe>_e)return 1}const de=Oe-Ke,Ce=Z-Fe;return de<Ce?-1:de>Ce?1:0}function b(Pe,Be){return v(Pe,Be,0,Pe.length,0,Be.length)}function v(Pe,Be,Ke=0,Oe=Pe.length,Fe=0,Z=Be.length){for(;Ke<Oe&&Fe<Z;Ke++,Fe++){let Xe=Pe.charCodeAt(Ke),_e=Be.charCodeAt(Fe);if(Xe===_e)continue;if(Xe>=128||_e>=128)return k(Pe.toLowerCase(),Be.toLowerCase(),Ke,Oe,Fe,Z);O(Xe)&&(Xe-=32),O(_e)&&(_e-=32);const lt=Xe-_e;if(lt!==0)return lt}const de=Oe-Ke,Ce=Z-Fe;return de<Ce?-1:de>Ce?1:0}function N(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function O(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function F(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,Be){return Pe.length===Be.length&&v(Pe,Be)===0}function B(Pe,Be){const Ke=Be.length;return Be.length>Pe.length?!1:v(Pe,Be,0,Ke)===0}function M(Pe,Be){const Ke=Math.min(Pe.length,Be.length);let Oe;for(Oe=0;Oe<Ke;Oe++)if(Pe.charCodeAt(Oe)!==Be.charCodeAt(Oe))return Oe;return Ke}function W(Pe,Be){const Ke=Math.min(Pe.length,Be.length);let Oe;const Fe=Pe.length-1,Z=Be.length-1;for(Oe=0;Oe<Ke;Oe++)if(Pe.charCodeAt(Fe-Oe)!==Be.charCodeAt(Z-Oe))return Oe;return Ke}function _(Pe){return 55296<=Pe&&Pe<=56319}function re(Pe){return 56320<=Pe&&Pe<=57343}function z(Pe,Be){return(Pe-55296<<10)+(Be-56320)+65536}function G(Pe,Be,Ke){const Oe=Pe.charCodeAt(Ke);if(_(Oe)&&Ke+1<Be){const Fe=Pe.charCodeAt(Ke+1);if(re(Fe))return z(Oe,Fe)}return Oe}function J(Pe,Be){const Ke=Pe.charCodeAt(Be-1);if(re(Ke)&&Be>1){const Oe=Pe.charCodeAt(Be-2);if(_(Oe))return z(Oe,Ke)}return Ke}class ee{get offset(){return this.e}constructor(Be,Ke=0){this.c=Be,this.d=Be.length,this.e=Ke}setOffset(Be){this.e=Be}prevCodePoint(){const Be=J(this.c,this.e);return this.e-=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}nextCodePoint(){const Be=G(this.c,this.d,this.e);return this.e+=Be>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Be}eol(){return this.e>=this.d}}e.$Lf=ee;class ue{get offset(){return this.c.offset}constructor(Be,Ke=0){this.c=new ee(Be,Ke)}nextGraphemeLength(){const Be=tt.getInstance(),Ke=this.c,Oe=Ke.offset;let Fe=Be.getGraphemeBreakType(Ke.nextCodePoint());for(;!Ke.eol();){const Z=Ke.offset,de=Be.getGraphemeBreakType(Ke.nextCodePoint());if(Ge(Fe,de)){Ke.setOffset(Z);break}Fe=de}return Ke.offset-Oe}prevGraphemeLength(){const Be=tt.getInstance(),Ke=this.c,Oe=Ke.offset;let Fe=Be.getGraphemeBreakType(Ke.prevCodePoint());for(;Ke.offset>0;){const Z=Ke.offset,de=Be.getGraphemeBreakType(Ke.prevCodePoint());if(Ge(de,Fe)){Ke.setOffset(Z);break}Fe=de}return Oe-Ke.offset}eol(){return this.c.eol()}}e.$Mf=ue;function ne(Pe,Be){return new ue(Pe,Be).nextGraphemeLength()}function De(Pe,Be){return new ue(Pe,Be).prevGraphemeLength()}function $e(Pe,Be){Be>0&&re(Pe.charCodeAt(Be))&&Be--;const Ke=Be+ne(Pe,Be);return[Ke-De(Pe,Ke),Ke]}function Q(Pe){const Be=new ue(Pe);let Ke=0;for(;!Be.eol();)Ke++,Be.nextGraphemeLength();return Ke}let U;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Pe){return U||(U=se()),U.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return te.test(Pe)}e.$Tf=/[\u2028\u2029]/;function he(Pe){return e.$Tf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function ae(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,Be,Ke=""){const Oe=Pe.trimStart();if(Oe.length<Be)return Oe;const Fe=/\b/g;let Z=0;for(;Fe.test(Oe)&&!(Oe.length-Fe.lastIndex<Be);)Z=Fe.lastIndex,Fe.lastIndex+=1;return Z===0?Oe:Ke+Oe.substring(Z).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Me(Pe){let Be=0;for(const Ke of Pe.matchAll(be))Be!==Ke.index&&(yield{isCode:!1,str:Pe.substring(Be,Ke.index)}),yield{isCode:!0,str:Ke[0]},Be=Ke.index+Ke[0].length;Be!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Be)})}function We(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return We(Pe).replace(ke,"")}e.$2f=String.fromCharCode(h.CharCode.UTF8_BOM);function Te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function V(Pe){return Te(Pe)?Pe.substr(1):Pe}function q(Pe,Be){if(!Pe||!Be||Pe.length<Be.length)return!1;const Ke=Be.length,Oe=Pe.toLowerCase();let Fe=0,Z=-1;for(;Fe<Ke;){const de=Oe.indexOf(Be[Fe],Z+1);if(de<0)return!1;Z=de,Fe++}return!0}function Y(Pe,Be=!1){return Pe?(Be&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,Be=1){if(Be===0)return"";let Ke=-1;do Ke=Pe.indexOf(`
`,Ke+1),Be--;while(Be>0&&Ke>=0);return Ke===-1?Pe:(Pe[Ke-1]==="\r"&&Ke--,Pe.substr(0,Ke))}function we(Pe){const Be=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*Be),Pe<Be?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-Be)}function Ne(Pe){return tt.getInstance().getGraphemeBreakType(Pe)}function Ge(Pe,Be){return Pe===Je.Other?Be!==Je.Extend&&Be!==Je.SpacingMark:Pe===Je.CR&&Be===Je.LF?!1:Pe===Je.Control||Pe===Je.CR||Pe===Je.LF||Be===Je.Control||Be===Je.CR||Be===Je.LF?!0:!(Pe===Je.L&&(Be===Je.L||Be===Je.V||Be===Je.LV||Be===Je.LVT)||(Pe===Je.LV||Pe===Je.V)&&(Be===Je.V||Be===Je.T)||(Pe===Je.LVT||Pe===Je.T)&&Be===Je.T||Be===Je.Extend||Be===Je.ZWJ||Be===Je.SpacingMark||Pe===Je.Prepend||Pe===Je.ZWJ&&Be===Je.Extended_Pictographic||Pe===Je.Regional_Indicator&&Be===Je.Regional_Indicator)}var Je;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Je||(e.GraphemeBreakType=Je={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=rt()}getGraphemeBreakType(Be){if(Be<32)return Be===h.CharCode.LineFeed?Je.LF:Be===h.CharCode.CarriageReturn?Je.CR:Je.Control;if(Be<127)return Je.Other;const Ke=this.d,Oe=Ke.length/3;let Fe=1;for(;Fe<=Oe;)if(Be<Ke[3*Fe])Fe=2*Fe;else if(Be>Ke[3*Fe+1])Fe=2*Fe+1;else return Ke[3*Fe+2];return Je.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,Be){if(Pe===0)return 0;const Ke=nt(Pe,Be);if(Ke!==void 0)return Ke;const Oe=new ee(Be,Pe);return Oe.prevCodePoint(),Oe.offset}function nt(Pe,Be){const Ke=new ee(Be,Pe);let Oe=Ke.prevCodePoint();for(;ct(Oe)||Oe===$t.emojiVariantSelector||Oe===$t.enclosingKeyCap;){if(Ke.offset===0)return;Oe=Ke.prevCodePoint()}if(!ae(Oe))return;let Fe=Ke.offset;return Fe>0&&Ke.prevCodePoint()===$t.zwj&&(Fe=Ke.offset),Fe}function ct(Pe){return 127995<=Pe&&Pe<=127999}var $t;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})($t||($t={})),e.$_f="\xA0";class ht{static{this.c=new A.$W(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$9e({getCacheKey:JSON.stringify},Be=>{function Ke(lt){const ft=new Map;for(let kt=0;kt<lt.length;kt+=2)ft.set(lt[kt],lt[kt+1]);return ft}function Oe(lt,ft){const kt=new Map(lt);for(const[Tt,zt]of ft)kt.set(Tt,zt);return kt}function Fe(lt,ft){if(!lt)return ft;const kt=new Map;for(const[Tt,zt]of lt)ft.has(Tt)&&kt.set(Tt,zt);return kt}const Z=this.c.value;let de=Be.filter(lt=>!lt.startsWith("_")&&lt in Z);de.length===0&&(de=["_default"]);let Ce;for(const lt of de){const ft=Ke(Z[lt]);Ce=Fe(Ce,ft)}const Xe=Ke(Z._common),_e=Oe(Xe,Ce);return new ht(_e)})}static getInstance(Be){return ht.d.get(Array.from(Be))}static{this.e=new A.$W(()=>Object.keys(ht.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ht.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}containsAmbiguousCharacter(Be){for(let Ke=0;Ke<Be.length;Ke++){const Oe=Be.codePointAt(Ke);if(typeof Oe=="number"&&this.isAmbiguous(Oe))return!0}return!1}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=ht;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(Be){return at.e().has(Be)}static containsInvisibleCharacter(Be){for(let Ke=0;Ke<Be.length;Ke++){const Oe=Be.codePointAt(Ke);if(typeof Oe=="number"&&at.isInvisibleCharacter(Oe))return!0}return!1}static get codePoints(){return at.e()}}e.$bg=at}),define(Ee[135],Se([1,0,27,29,177,13]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=L,e.$Fk=$,e.$Gk=l,e.$Hk=u,e.$Ik=D,e.$Jk=S,e.$Kk=O,e.$Lk=F,e.$Mk=j,e.$Nk=B,e.$Ok=se,e.$Qk=he,e.$Rk=pe,e.$Sk=be,R=Ue(R);function L(...ke){return function(Ie,Te){for(let V=0,q=ke.length;V<q;V++){const Y=ke[V](Ie,Te);if(Y)return Y}return null}}e.$Dk=T.bind(void 0,!1),e.$Ek=T.bind(void 0,!0);function T(ke,Ie,Te){if(!Te||Te.length<Ie.length)return null;let V;return ke?V=R.$Ef(Te,Ie):V=Te.indexOf(Ie)===0,V?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Te=Ie.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function l(ke,Ie){return C(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function C(ke,Ie,Te,V){if(Te===ke.length)return[];if(V===Ie.length)return null;if(ke[Te]===Ie[V]){let q=null;return(q=C(ke,Ie,Te+1,V+1))?i({start:V,end:V+1},q):null}return C(ke,Ie,Te,V+1)}function E(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function P(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function p(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>c.add(ke.charCodeAt(0)));function g(ke){return p(ke)||c.has(ke)}function f(ke,Ie){return ke===Ie||g(ke)&&g(Ie)}const m=new Map;function n(ke){if(m.has(ke))return m.get(ke);let Ie;const Te=(0,A.$Bk)(ke);return Te&&(Ie=Te),m.set(ke,Ie),Ie}function o(ke){return E(ke)||u(ke)||P(ke)}function i(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function t(ke,Ie){for(let Te=Ie;Te<ke.length;Te++){const V=ke.charCodeAt(Te);if(u(V)||P(V)||Te>0&&!o(ke.charCodeAt(Te-1)))return Te}return ke.length}function s(ke,Ie,Te,V){if(Te===ke.length)return[];if(V===Ie.length)return null;if(ke[Te]!==Ie[V].toLowerCase())return null;{let q=null,Y=V+1;for(q=s(ke,Ie,Te+1,V+1);!q&&(Y=t(Ie,Y))<Ie.length;)q=s(ke,Ie,Te+1,Y),Y++;return q===null?null:i({start:V,end:V+1},q)}}function d(ke){let Ie=0,Te=0,V=0,q=0,Y=0;for(let Ge=0;Ge<ke.length;Ge++)Y=ke.charCodeAt(Ge),u(Y)&&Ie++,E(Y)&&Te++,o(Y)&&V++,P(Y)&&q++;const x=Ie/ke.length,fe=Te/ke.length,we=V/ke.length,Ne=q/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Ne}}function a(ke){const{upperPercent:Ie,lowerPercent:Te}=ke;return Te===0&&Ie>.6}function w(ke){const{upperPercent:Ie,lowerPercent:Te,alphaPercent:V,numericPercent:q}=ke;return Te>.2&&Ie<.8&&V>.6&&q<.2}function y(ke){let Ie=0,Te=0,V=0,q=0;for(let Y=0;Y<ke.length;Y++)V=ke.charCodeAt(Y),u(V)&&Ie++,E(V)&&Te++,p(V)&&q++;return(Ie===0||Te===0)&&q===0?ke.length<=30:Ie<=5}function D(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!y(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Te=d(Ie);if(!w(Te)){if(!a(Te))return null;Ie=Ie.toLowerCase()}let V=null,q=0;for(ke=ke.toLowerCase();q<Ie.length&&(V=s(ke,Ie,0,q))===null;)q=t(Ie,q+1);return V}function S(ke,Ie,Te=!1){if(!Ie||Ie.length===0)return null;let V=null,q=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(V=I(ke,Ie,0,q,Te),V===null);)q=k(Ie,q+1);return V}function I(ke,Ie,Te,V,q){let Y=0;if(Te===ke.length)return[];if(V===Ie.length)return null;if(!f(ke.charCodeAt(Te),Ie.charCodeAt(V))){const we=n(ke.charCodeAt(Te));if(!we)return null;for(let Ne=0;Ne<we.length;Ne++)if(!f(we[Ne],Ie.charCodeAt(V+Ne)))return null;Y+=we.length-1}let x=null,fe=V+Y+1;if(x=I(ke,Ie,Te+1,fe,q),!q)for(;!x&&(fe=k(Ie,fe))<Ie.length;)x=I(ke,Ie,Te+1,fe,q),fe++;if(!x)return null;if(ke.charCodeAt(Te)!==Ie.charCodeAt(V)){const we=n(ke.charCodeAt(Te));if(!we)return x;for(let Ne=0;Ne<we.length;Ne++)if(we[Ne]!==Ie.charCodeAt(V+Ne))return x}return i({start:V,end:V+Y+1},x)}function k(ke,Ie){for(let Te=Ie;Te<ke.length;Te++)if(g(ke.charCodeAt(Te))||Te>0&&g(ke.charCodeAt(Te-1)))return Te;return ke.length}const b=L(e.$Ek,D,$),v=L(e.$Ek,D,l),N=new h.$Ec(1e4);function O(ke,Ie,Te=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let V=N.get(ke);V||(V=new RegExp(R.$mf(ke),"i"),N.set(ke,V));const q=V.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Te?v(ke,Ie):b(ke,Ie)}function F(ke,Ie){const Te=he(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?B(Te):null}function j(ke,Ie,Te,V,q,Y){const x=Math.min(13,ke.length);for(;Te<x;Te++){const fe=he(ke,Ie,Te,V,q,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Y]}function B(ke){if(typeof ke>"u")return[];const Ie=[],Te=ke[1];for(let V=ke.length-1;V>1;V--){const q=ke[V]+Te,Y=Ie[Ie.length-1];Y&&Y.end===q?Y.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const M=128;function W(){const ke=[],Ie=[];for(let Te=0;Te<=M;Te++)Ie[Te]=0;for(let Te=0;Te<=M;Te++)ke.push(Ie.slice(0));return ke}function _(ke){const Ie=[];for(let Te=0;Te<=ke;Te++)Ie[Te]=0;return Ie}const re=_(2*M),z=_(2*M),G=W(),J=W(),ee=W(),ue=!1;function ne(ke,Ie,Te,V,q){function Y(fe,we,Ne=" "){for(;fe.length<we;)fe=Ne+fe;return fe}let x=` |   |${V.split("").map(fe=>Y(fe,3)).join("|")}
`;for(let fe=0;fe<=Te;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,q+1).map(we=>Y(we.toString(),3)).join("|")+`
`;return x}function De(ke,Ie,Te,V){ke=ke.substr(Ie),Te=Te.substr(V),console.log(ne(J,ke,ke.length,Te,Te.length)),console.log(ne(ee,ke,ke.length,Te,Te.length)),console.log(ne(G,ke,ke.length,Te,Te.length))}function $e(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Te=ke.codePointAt(Ie);switch(Te){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Wf(Te)}}function Q(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function U(ke,Ie,Te){return Ie[ke]!==Te[ke]}function se(ke,Ie,Te,V,q,Y,x=!1){for(;Ie<Te&&q<Y;)ke[Ie]===V[q]&&(x&&(re[Ie]=q),Ie+=1),q+=1;return Ie===Te}var oe;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var te;(function(ke){ke.Default=[-100,0];function Ie(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Ie})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Te){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Te}}e.$Pk=le;function he(ke,Ie,Te,V,q,Y,x=le.default){const fe=ke.length>M?M:ke.length,we=V.length>M?M:V.length;if(Te>=fe||Y>=we||fe-Te>we-Y||!se(Ie,Te,fe,q,Y,we,!0))return;X(fe,we,Te,Y,Ie,q);let Ne=1,Ge=1,Je=Te,tt=Y;const rt=[!1];for(Ne=1,Je=Te;Je<fe;Ne++,Je++){const ht=re[Je],at=z[Je],Pe=Je+1<fe?z[Je+1]:we;for(Ge=ht-Y+1,tt=ht;tt<Pe;Ge++,tt++){let Be=Number.MIN_SAFE_INTEGER,Ke=!1;tt<=at&&(Be=ae(ke,Ie,Je,Te,V,q,tt,we,Y,G[Ne-1][Ge-1]===0,rt));let Oe=0;Be!==Number.MAX_SAFE_INTEGER&&(Ke=!0,Oe=Be+J[Ne-1][Ge-1]);const Fe=tt>ht,Z=Fe?J[Ne][Ge-1]+(G[Ne][Ge-1]>0?-5:0):0,de=tt>ht+1&&G[Ne][Ge-1]>0,Ce=de?J[Ne][Ge-2]+(G[Ne][Ge-2]>0?-5:0):0;if(de&&(!Fe||Ce>=Z)&&(!Ke||Ce>=Oe))J[Ne][Ge]=Ce,ee[Ne][Ge]=oe.LeftLeft,G[Ne][Ge]=0;else if(Fe&&(!Ke||Z>=Oe))J[Ne][Ge]=Z,ee[Ne][Ge]=oe.Left,G[Ne][Ge]=0;else if(Ke)J[Ne][Ge]=Oe,ee[Ne][Ge]=oe.Diag,G[Ne][Ge]=G[Ne-1][Ge-1]+1;else throw new Error("not possible")}}if(ue&&De(ke,Te,V,Y),!rt[0]&&!x.firstMatchCanBeWeak)return;Ne--,Ge--;const ot=[J[Ne][Ge],Y];let nt=0,ct=0;for(;Ne>=1;){let ht=Ge;do{const at=ee[Ne][ht];if(at===oe.LeftLeft)ht=ht-2;else if(at===oe.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Ie[Te+Ne-1]===q[Y+Ge-1]&&!U(ht+Y-1,V,q)&&nt+1>G[Ne][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,ct||(ct=ht),Ne--,Ge=ht-1,ot.push(Ge)}we-Y===fe&&x.boostFullMatch&&(ot[0]+=2);const $t=ct-fe;return ot[0]-=$t,ot}function X(ke,Ie,Te,V,q,Y){let x=ke-1,fe=Ie-1;for(;x>=Te&&fe>=V;)q[x]===Y[fe]&&(z[x]=fe,x--),fe--}function ae(ke,Ie,Te,V,q,Y,x,fe,we,Ne,Ge){if(Ie[Te]!==Y[x])return Number.MIN_SAFE_INTEGER;let Je=1,tt=!1;return x===Te-V?Je=ke[Te]===q[x]?7:5:U(x,q,Y)&&(x===0||!U(x-1,q,Y))?(Je=ke[Te]===q[x]?7:5,tt=!0):$e(Y,x)&&(x===0||!$e(Y,x-1))?Je=5:($e(Y,x-1)||Q(Y,x-1))&&(Je=5,tt=!0),Je>1&&Te===V&&(Ge[0]=!0),tt||(tt=U(x,q,Y)||$e(Y,x-1)||Q(Y,x-1)),Te===V?x>we&&(Je-=tt?3:5):Ne?Je+=tt?2:0:Je+=tt?0:1,x+1===fe&&(Je-=tt?3:5),Je}function pe(ke,Ie,Te,V,q,Y,x){return Me(ke,Ie,Te,V,q,Y,!0,x)}function be(ke,Ie,Te,V,q,Y,x){return Me(ke,Ie,Te,V,q,Y,!1,x)}function Me(ke,Ie,Te,V,q,Y,x,fe){let we=he(ke,Ie,Te,V,q,Y,fe);if(we&&!x)return we;if(ke.length>=3){const Ne=Math.min(7,ke.length-1);for(let Ge=Te+1;Ge<Ne;Ge++){const Je=We(ke,Ge);if(Je){const tt=he(Je,Je.toLowerCase(),Te,V,q,Y,fe);tt&&(tt[0]-=3,(!we||tt[0]>we[0])&&(we=tt))}}}return we}function We(ke,Ie){if(Ie+1>=ke.length)return;const Te=ke[Ie],V=ke[Ie+1];if(Te!==V)return ke.slice(0,Ie)+V+Te+ke.slice(Ie+2)}}),define(Ee[60],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=h,e.$rj=A,e.$sj=R,e.$tj=T,e.$vj=c,r=Ue(r);function h(f){return A(f,0)}function A(f,m){switch(typeof f){case"object":return f===null?R(349,m):Array.isArray(f)?$(f,m):l(f,m);case"string":return T(f,m);case"boolean":return L(f,m);case"number":return R(f,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(f,m){return(m<<5)-m+f|0}function L(f,m){return R(f?433:863,m)}function T(f,m){m=R(149417,m);for(let n=0,o=f.length;n<o;n++)m=R(f.charCodeAt(n),m);return m}function $(f,m){return m=R(104579,m),f.reduce((n,o)=>A(o,n),m)}function l(f,m){return m=R(181387,m),Object.keys(f).sort().reduce((n,o)=>(n=T(o,n),A(f[o],n)),m)}class C{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=A(m,this.g),this.g}}e.$uj=C;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function u(f,m,n=32){const o=n-m,i=~((1<<o)-1);return(f<<m|(i&f)>>>o)>>>0}function P(f,m=0,n=f.byteLength,o=0){for(let i=0;i<n;i++)f[m+i]=o}function p(f,m,n="0"){for(;f.length<m;)f=n+f;return f}function c(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(n=>n.toString(16).padStart(2,"0")).join(""):p((f>>>0).toString(16),m/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const n=m.length;if(n===0)return;const o=this.p;let i=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=m.charCodeAt(0),d=0);;){let a=s;if(r.$Hf(s))if(d+1<n){const w=m.charCodeAt(d+1);r.$If(w)?(d++,a=r.$Jf(s,w)):a=E.UNICODE_REPLACEMENT}else{t=s;break}else r.$If(s)&&(a=E.UNICODE_REPLACEMENT);if(i=this.w(o,i,a),d++,d<n)s=m.charCodeAt(d);else break}this.r=i,this.u=t}w(m,n,o){return o<128?m[n++]=o:o<2048?(m[n++]=192|(o&1984)>>>6,m[n++]=128|(o&63)>>>0):o<65536?(m[n++]=224|(o&61440)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0):(m[n++]=240|(o&1835008)>>>18,m[n++]=128|(o&258048)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,m[0]=m[E.BLOCK_SIZE+0],m[1]=m[E.BLOCK_SIZE+1],m[2]=m[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,n=this.q;for(let D=0;D<64;D+=4)m.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)m.setUint32(D,u(m.getUint32(D-12,!1)^m.getUint32(D-32,!1)^m.getUint32(D-56,!1)^m.getUint32(D-64,!1),1),!1);let o=this.h,i=this.l,t=this.m,s=this.n,d=this.o,a,w,y;for(let D=0;D<80;D++)D<20?(a=i&t|~i&s,w=1518500249):D<40?(a=i^t^s,w=1859775393):D<60?(a=i&t|i&s|t&s,w=2400959708):(a=i^t^s,w=3395469782),y=u(o,5)+a+d+w+m.getUint32(D*4,!1)&4294967295,d=s,s=t,t=u(i,30),i=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$wj=g}),define(Ee[136],Se([1,0,135,13,50]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=$,e.$Uk=C,e.$Vk=u,e.$Wk=P,e.$Xk=c,e.$Yk=g;const R="$(",L=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${L.source}`,"g");function $(f){return f.replace(T,(m,n)=>n?m:`\\${m}`)}const l=new RegExp(`\\\\${L.source}`,"g");function C(f){return f.replace(l,m=>`\\${m}`)}const E=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u(f){return f.indexOf(R)===-1?f:f.replace(E,(m,n,o,i)=>o?m:n||i||"")}function P(f){return f?f.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const p=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(f){p.lastIndex=0;let m="";const n=[];let o=0;for(;;){const i=p.lastIndex,t=p.exec(f),s=f.substring(i,t?.index);if(s.length>0){m+=s;for(let d=0;d<s.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:m,iconOffsets:n}}function g(f,m,n=!1){const{text:o,iconOffsets:i}=m;if(!i||i.length===0)return(0,r.$Kk)(f,o,n);const t=(0,h.$kf)(o," "),s=o.length-t.length,d=(0,r.$Kk)(f,t,n);if(d)for(const a of d){const w=i[a.start+s]+s;a.start+=w,a.end+=w}return d}}),define(Ee[44],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ue(r);var h;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(h||(h={})),function(A){const R="error",L="warning",T="warn",$="info",l="ignore";function C(u){return u?r.$Df(R,u)?A.Error:r.$Df(L,u)||r.$Df(T,u)?A.Warning:r.$Df($,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function E(u){switch(u){case A.Error:return R;case A.Warning:return L;case A.Info:return $;default:return l}}A.toString=E}(h||(h={})),e.default=h}),define(Ee[85],Se([1,0,19,27,13]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class R{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const c=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return c-g}value(){return this.b[this.c]}}e.$Ei=R;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,A.$xf)(p,this.b,0,p.length,this.c,this.d):(0,A.$zf)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=L;class T{constructor(p=!0,c=!0){this.f=p,this.g=c}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let c=p.length-1;c>=0;c--,this.c--){const g=this.b.charCodeAt(c);if(!(g===h.CharCode.Slash||this.f&&g===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===h.CharCode.Slash||this.f&&c===h.CharCode.Backslash)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,A.$xf)(p,this.b,0,p.length,this.d,this.e):(0,A.$zf)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=T;var $;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})($||($={}));class l{constructor(p,c){this.f=p,this.g=c,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new T(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push($.Path)),this.g(p)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===$.Scheme)return(0,A.$yf)(p,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,A.$yf)(p,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(p);if(this.d[this.e]===$.Query)return(0,A.$wf)(p,this.c.query);if(this.d[this.e]===$.Fragment)return(0,A.$wf)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Hi=l;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(E||(E={}));class u{static forUris(p=()=>!1,c=()=>!1){return new u(new l(p,c))}static forPaths(p=!1){return new u(new T(void 0,!p))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,c){if(c){const g=c.slice(0);(0,r.$Xb)(g);for(const f of g)this.set(f,p)}else{const g=p.slice(0);(0,r.$Xb)(g);for(const f of g)this.set(f[0],f[1])}}set(p,c){const g=this.b.reset(p);let f;this.c||(this.c=new C,this.c.segment=g.value());const m=[];for(f=this.c;;){const o=g.cmp(f.segment);if(o>0)f.left||(f.left=new C,f.left.segment=g.value()),m.push([E.Left,f]),f=f.left;else if(o<0)f.right||(f.right=new C,f.right.segment=g.value()),m.push([E.Right,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new C,f.mid.segment=g.value()),m.push([E.Mid,f]),f=f.mid;else break}const n=f.value;f.value=c,f.key=p;for(let o=m.length-1;o>=0;o--){const i=m[o][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const s=m[o][0],d=m[o+1][0];if(s===E.Right&&d===E.Right)m[o][1]=i.rotateLeft();else if(s===E.Left&&d===E.Left)m[o][1]=i.rotateRight();else if(s===E.Right&&d===E.Left)i.right=m[o+1][1]=m[o+1][1].rotateRight(),m[o][1]=i.rotateLeft();else if(s===E.Left&&d===E.Right)i.left=m[o+1][1]=m[o+1][1].rotateLeft(),m[o][1]=i.rotateRight();else throw new Error;if(o>0)switch(m[o-1][0]){case E.Left:m[o-1][1].left=m[o][1];break;case E.Right:m[o-1][1].right=m[o][1];break;case E.Mid:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const c=this.b.reset(p);let g=this.c;for(;g;){const f=c.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(p){const c=this.d(p);return!(c?.value===void 0&&c?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,c){const g=this.b.reset(p),f=[];let m=this.c;for(;m;){const n=g.cmp(m.segment);if(n>0)f.push([E.Left,m]),m=m.left;else if(n<0)f.push([E.Right,m]),m=m.right;else if(g.hasNext())g.next(),f.push([E.Mid,m]),m=m.mid;else break}if(m){if(c?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:o,value:i,segment:t}=n;this.e(n.key,!1),m.key=o,m.value=i,m.segment=t}}else{const n=m.left??m.right;if(f.length>0){const[o,i]=f[f.length-1];switch(o){case E.Left:i.left=n;break;case E.Mid:i.mid=n;break;case E.Right:i.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const o=f[n][1];o.updateHeight();const i=o.balanceFactor();if(i>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),f[n][1]=o.rotateLeft()):i<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),f[n][1]=o.rotateRight()),n>0)switch(f[n-1][0]){case E.Left:f[n-1][1].left=f[n][1];break;case E.Right:f[n-1][1].right=f[n][1];break;case E.Mid:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const c=this.b.reset(p);let g=this.c,f;for(;g;){const m=c.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(c.hasNext())c.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(p){return this.g(p,!1)}g(p,c){const g=this.b.reset(p);let f=this.c;for(;f;){const m=g.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this.h(f.mid):c?f.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[c,g]of this)p(g,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const c=[];return this.j(p,c),c[Symbol.iterator]()}j(p,c){p&&(p.left&&this.j(p.left,c),p.value&&c.push([p.key,p.value]),p.mid&&this.j(p.mid,c),p.right&&this.j(p.right,c))}_isBalanced(){const p=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:p(c.left)&&p(c.right)};return p(this.c)}}e.$Ii=u}),define(Ee[32],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(A){return r.test(A)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(T){for(let $=0;$<T.length;$++)T[$]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),L=[];for(let T=0;T<256;T++)L.push(T.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,l="";return l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l}}()}),define(Ee[186],Se([1,0,19,40,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$hu=void 0,e.$fu=R,e.$gu=L,e.$iu=l;function R(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function L(E,u,P){const p={id:(0,A.$Yg)(),name:E,uri:u,data:P};return{asString:async()=>"",asFile:()=>p,value:void 0}}class T{constructor(){this.a=new Map}get size(){let u=0;for(const P of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const P=[...this.a.keys()];return h.Iterable.some(this,([p,c])=>c.asFile())&&P.push("files"),C($(u),P)}get(u){return this.a.get(this.b(u))?.[0]}append(u,P){const p=this.a.get(u);p?p.push(P):this.a.set(this.b(u),[P])}replace(u,P){this.a.set(this.b(u),[P])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,P]of this.a)for(const p of P)yield[u,p]}b(u){return $(u)}}e.$hu=T;function $(E){return E.toLowerCase()}function l(E,u){return C($(E),u.map($))}function C(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const P=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[p,c,g]=P;return g==="*"?u.some(f=>f.startsWith(c+"/")):!1}e.$ju=Object.freeze({create:E=>(0,r.$Nb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$ju.split(E).filter(u=>!u.startsWith("#"))})}),define(Ee[187],Se([1,0,67]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h,e.$3g=R,r=Ue(r);function h(T,$,l,C=1){let E=!1;return new Promise(u=>{const P=setTimeout(()=>{if(!E)return E=!0,u(0)},l);A(T,$,C,p=>{if(!E)return E=!0,clearTimeout(P),u(p)})})}function A(T,$,l,C){if($===0)return C(0);const E=new r.Socket;E.once("connect",()=>(L(E),A(T+l,$-1,l,C))),E.once("data",()=>{}),E.once("error",u=>(L(E),u.code!=="ECONNREFUSED"?A(T+l,$-1,l,C):C(T))),E.connect(T,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,$,l,C="127.0.0.1"){let E=!1,u,P=1;const p=r.createServer({pauseOnConnect:!0});function c(g,f){E||(E=!0,p.removeAllListeners(),p.close(),u&&clearTimeout(u),f(g))}return new Promise(g=>{u=setTimeout(()=>{c(0,g)},l),p.on("listening",()=>{c(T,g)}),p.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&P<$?(T++,P++,p.listen(T,C)):c(0,g)}),p.on("close",()=>{c(0,g)}),p.listen(T,C)})}function L(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch($){console.error($)}}}),define(Ee[137],Se([1,0,84]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=e.$0t=void 0;class h{constructor(T){const $=(0,r.$$e)(T);this.c=$,this.a=h.d($),this.b=new Map}static d(T){const $=new Uint8Array(256);return $.fill(T),$}set(T,$){const l=(0,r.$$e)($);T>=0&&T<256?this.a[T]=l:this.b.set(T,l)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$0t=h;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new h(A.False)}add(T){this.a.set(T,A.True)}has(T){return this.a.get(T)===A.True}clear(){return this.a.clear()}}e.$$t=R}),define(Ee[188],Se([1,0,27]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$pu=A;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function A(R){let L=0,T=0,$=0,l=h.Unknown;for(let C=0,E=R.length;C<E;C++){const u=R.charCodeAt(C);u===r.CharCode.CarriageReturn?(L===0&&(T=C),L++,C+1<E&&R.charCodeAt(C+1)===r.CharCode.LineFeed?(l|=h.CRLF,C++):l|=h.Invalid,$=C+1):u===r.CharCode.LineFeed&&(l|=h.LF,L===0&&(T=C),L++,$=C+1)}return L===0&&(T=R.length),[L,T,R.length-$,l]}}),define(Ee[53],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const L=A.lineNumber|0,T=R.lineNumber|0;if(L===T){const $=A.column|0,l=R.column|0;return $-l}return L-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Et=r}),define(Ee[31],Se([1,0,53]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0;class h{constructor(R,L,T,$){R>T||R===T&&L>$?(this.startLineNumber=T,this.startColumn=$,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=T,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,L){let T,$,l,C;return L.startLineNumber<R.startLineNumber?(T=L.startLineNumber,$=L.startColumn):L.startLineNumber===R.startLineNumber?(T=L.startLineNumber,$=Math.min(L.startColumn,R.startColumn)):(T=R.startLineNumber,$=R.startColumn),L.endLineNumber>R.endLineNumber?(l=L.endLineNumber,C=L.endColumn):L.endLineNumber===R.endLineNumber?(l=L.endLineNumber,C=Math.max(L.endColumn,R.endColumn)):(l=R.endLineNumber,C=R.endColumn),new h(T,$,l,C)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,L){let T=R.startLineNumber,$=R.startColumn,l=R.endLineNumber,C=R.endColumn;const E=L.startLineNumber,u=L.startColumn,P=L.endLineNumber,p=L.endColumn;return T<E?(T=E,$=u):T===E&&($=Math.max($,u)),l>P?(l=P,C=p):l===P&&(C=Math.min(C,p)),T>l||T===l&&$>C?null:new h(T,$,l,C)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Et(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Et(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new h(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new h(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new h(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const l=R.startLineNumber|0,C=L.startLineNumber|0;if(l===C){const E=R.startColumn|0,u=L.startColumn|0;if(E===u){const P=R.endLineNumber|0,p=L.endLineNumber|0;if(P===p){const c=R.endColumn|0,g=L.endColumn|0;return c-g}return P-p}return E-u}return l-C}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$Ft=h}),define(Ee[189],Se([1,0,31]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;class h{static insert(R,L){return{range:new r.$Ft(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$Gt=h}),define(Ee[190],Se([1,0,53,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.SelectionDirection=void 0;var A;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends h.$Ft{constructor(T,$,l,C){super(T,$,l,C),this.selectionStartLineNumber=T,this.selectionStartColumn=$,this.positionLineNumber=l,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,$){return T.selectionStartLineNumber===$.selectionStartLineNumber&&T.selectionStartColumn===$.selectionStartColumn&&T.positionLineNumber===$.positionLineNumber&&T.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(T,$){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,T,$):new R(T,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Et(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Et(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,$){return this.getDirection()===A.LTR?new R(T,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,$)}static fromPositions(T,$=T){return new R(T.lineNumber,T.column,$.lineNumber,$.column)}static fromRange(T,$){return $===A.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,$){if(T&&!$||!T&&$)return!1;if(!T&&!$)return!0;if(T.length!==$.length)return!1;for(let l=0,C=T.length;l<C;l++)if(!this.selectionsEqual(T[l],$[l]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,$,l,C,E){return E===A.LTR?new R(T,$,l,C):new R(l,C,T,$)}}e.$Ht=R}),define(Ee[191],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0,e.$ct={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[192],Se([1,0,27,29,137]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_t=e.WordCharacterClass=void 0,e.$au=$;var R;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends A.$0t{constructor(C,E){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,P=C.length;u<P;u++)this.set(C.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(C,E){let u=null;for(const P of this.h(C)){if(P.index>E)break;u=P}return u}findNextIntlWordAtOrAfterOffset(C,E){for(const u of this.h(C))if(!(u.index<E))return u;return null}h(C){return this.e?this.f===C?this.g:(this.f=C,this.g=this.j(this.e.segment(C)),this.g):[]}j(C){const E=[];for(const u of C)this.k(u)&&E.push(u);return E}k(C){return!!C.isWordLike}}e.$_t=L;const T=new h.$Ec(10);function $(l,C){const E=`${l}/${C.join(",")}`;let u=T.get(E);return u||(u=new L(l,C),T.set(E,u)),u}}),define(Ee[138],Se([1,0,40,3,81]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0,e.$ft=L,e.$gt=$,e.$ht=l,e.$dt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(E=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$dt)E.indexOf(P)>=0||(u+="\\"+P);return u+="\\s]+)",new RegExp(u,"g")}e.$et=R();function L(E){let u=e.$et;if(E&&E instanceof RegExp)if(E.global)u=E;else{let P="g";E.ignoreCase&&(P+="i"),E.multiline&&(P+="m"),E.unicode&&(P+="u"),u=new RegExp(E.source,P)}return u.lastIndex=0,u}const T=new A.$6c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const u=T.unshift(E);return(0,h.$Tc)(u)}function l(E,u,P,p,c){if(u=L(u),c||(c=r.Iterable.first(T)),P.length>c.maxLen){let o=E-c.maxLen/2;return o<0?o=0:p+=o,P=P.substring(o,E+c.maxLen/2),l(E,u,P,p,c)}const g=Date.now(),f=E-1-p;let m=-1,n=null;for(let o=1;!(Date.now()-g>=c.timeBudget);o++){const i=f-c.windowSize*o;u.lastIndex=Math.max(0,i);const t=C(u,P,f,m);if(!t&&n||(n=t,i<=0))break;m=i}if(n){const o={word:n[0],startColumn:p+1+n.index,endColumn:p+1+n.index+n[0].length};return u.lastIndex=0,o}return null}function C(E,u,P,p){let c;for(;c=E.exec(u);){const g=c.index||0;if(g<=P&&E.lastIndex>=P)return c;if(p>0&&g>p)return null}return null}}),define(Ee[106],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var A;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class T{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let E="mtk"+this.getForeground(l);const u=this.getFontStyle(l);return u&h.Italic&&(E+=" mtki"),u&h.Bold&&(E+=" mtkb"),u&h.Underline&&(E+=" mtku"),u&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(l,C){const E=this.getForeground(l),u=this.getFontStyle(l);let P=`color: ${C[E]};`;u&h.Italic&&(P+="font-style: italic;"),u&h.Bold&&(P+="font-weight: bold;");let p="";return u&h.Underline&&(p+=" underline"),u&h.Strikethrough&&(p+=" line-through"),p&&(P+=`text-decoration:${p};`),P}static getPresentationFromMetadata(l){const C=this.getForeground(l),E=this.getFontStyle(l);return{foreground:C,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$lu=T}),define(Ee[193],Se([1,0,27,106]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=e.$Mu=e.IndentAction=void 0;var A;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let C=0,E=l.notIn.length;C<E;C++)switch(l.notIn[C]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(l,C){if(l.getTokenCount()===0)return!0;const E=l.findTokenIndexAtOffset(C-2),u=l.getStandardTokenType(E);return this.isOK(u)}g(l,C){for(let E=l;E<=C;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Mu=R;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of l)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.$Nu=L;function T($,l,C){$.has(l)?$.get(l).push(C):$.set(l,[C])}}),define(Ee[194],Se([1,0,27,137]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3=e.$D3=e.State=void 0,e.$F3=P;var A;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(c,g,f){const m=new Uint8Array(c*g);for(let n=0,o=c*g;n<o;n++)m[n]=f;this.a=m,this.rows=c,this.cols=g}get(c,g){return this.a[c*this.cols+g]}set(c,g,f){this.a[c*this.cols+g]=f}}class L{constructor(c){let g=0,f=A.Invalid;for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];t>g&&(g=t),i>f&&(f=i),s>f&&(f=s)}g++,f++;const m=new R(f,g,A.Invalid);for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];m.set(i,t,s)}this.a=m,this.b=g}nextState(c,g){return g<0||g>=this.b?A.Invalid:this.a.get(c,g)}}e.$D3=L;let T=null;function $(){return T===null&&(T=new L([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),T}var l;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let C=null;function E(){if(C===null){C=new h.$0t(l.None);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<p.length;g++)C.set(p.charCodeAt(g),l.ForceTermination);const c=".,;:";for(let g=0;g<c.length;g++)C.set(c.charCodeAt(g),l.CannotEndIn)}return C}class u{static a(c,g,f,m,n){let o=n-1;do{const i=g.charCodeAt(o);if(c.get(i)!==l.CannotEndIn)break;o--}while(o>m);if(m>0){const i=g.charCodeAt(m-1),t=g.charCodeAt(o);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:f,startColumn:m+1,endLineNumber:f,endColumn:o+2},url:g.substring(m,o+1)}}static computeLinks(c,g=$()){const f=E(),m=[];for(let n=1,o=c.getLineCount();n<=o;n++){const i=c.getLineContent(n),t=i.length;let s=0,d=0,a=0,w=A.Start,y=!1,D=!1,S=!1,I=!1;for(;s<t;){let k=!1;const b=i.charCodeAt(s);if(w===A.Accept){let v;switch(b){case r.CharCode.OpenParen:y=!0,v=l.None;break;case r.CharCode.CloseParen:v=y?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:S=!0,D=!0,v=l.None;break;case r.CharCode.CloseSquareBracket:S=!1,v=D?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:I=!0,v=l.None;break;case r.CharCode.CloseCurlyBrace:v=I?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:a===b?v=l.ForceTermination:a===r.CharCode.SingleQuote||a===r.CharCode.DoubleQuote||a===r.CharCode.BackTick?v=l.None:v=l.ForceTermination;break;case r.CharCode.Asterisk:v=a===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:v=a===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:v=S?l.None:l.ForceTermination;break;default:v=f.get(b)}v===l.ForceTermination&&(m.push(u.a(f,i,n,d,s)),k=!0)}else if(w===A.End){let v;b===r.CharCode.OpenSquareBracket?(D=!0,v=l.None):v=f.get(b),v===l.ForceTermination?k=!0:w=A.Accept}else w=g.nextState(w,b),w===A.Invalid&&(k=!0);k&&(w=A.Start,y=!1,D=!1,I=!1,d=s+1,a=b),s++}w===A.Accept&&m.push(u.a(f,i,n,d,t))}return m}}e.$E3=u;function P(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:u.computeLinks(p)}}),define(Ee[54],Se([1,0,25]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$v=e.$0v=e.$9v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$7v=e.$6v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$8v=p,e.$_v=o;var h;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var T;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var $;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var l;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var C;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(C||(e.EndOfLineSequence=C={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$do)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$6v=E;class u{constructor(t,s){this._findMatchBrand=void 0,this.range=t,this.matches=s}}e.$7v=u;var P;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function p(i){return i&&typeof i.read=="function"}var c;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var g;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class f{constructor(t,s,d,a,w,y){this.identifier=t,this.range=s,this.text=d,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=w,this._isTracked=y}}e.$9v=f;class m{constructor(t,s,d){this.regex=t,this.wordSeparators=s,this.simpleSearch=d}}e.$0v=m;class n{constructor(t,s,d){this.reverseEdits=t,this.changes=s,this.trimAutoWhitespaceLineNumbers=d}}e.$$v=n;function o(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(Ee[195],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.NodeColor=e.$WC=void 0,e.$YC=A,e.$ZC=R,e.$1C=l,e.$2C=C,e.$3C=E,e.$4C=u,e.$5C=P,e.$6C=p;class r{constructor(g,f){this.piece=g,this.color=f,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$XC)return A(this.right);let g=this;for(;g.parent!==e.$XC&&g.parent.left!==g;)g=g.parent;return g.parent===e.$XC?e.$XC:g.parent}prev(){if(this.left!==e.$XC)return R(this.left);let g=this;for(;g.parent!==e.$XC&&g.parent.right!==g;)g=g.parent;return g.parent===e.$XC?e.$XC:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$WC=r;var h;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$XC=new r(null,h.Black),e.$XC.parent=e.$XC,e.$XC.left=e.$XC,e.$XC.right=e.$XC,e.$XC.color=h.Black;function A(c){for(;c.left!==e.$XC;)c=c.left;return c}function R(c){for(;c.right!==e.$XC;)c=c.right;return c}function L(c){return c===e.$XC?0:c.size_left+c.piece.length+L(c.right)}function T(c){return c===e.$XC?0:c.lf_left+c.piece.lineFeedCnt+T(c.right)}function $(){e.$XC.parent=e.$XC}function l(c,g){const f=g.right;f.size_left+=g.size_left+(g.piece?g.piece.length:0),f.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=f.left,f.left!==e.$XC&&(f.left.parent=g),f.parent=g.parent,g.parent===e.$XC?c.root=f:g.parent.left===g?g.parent.left=f:g.parent.right=f,f.left=g,g.parent=f}function C(c,g){const f=g.left;g.left=f.right,f.right!==e.$XC&&(f.right.parent=g),f.parent=g.parent,g.size_left-=f.size_left+(f.piece?f.piece.length:0),g.lf_left-=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),g.parent===e.$XC?c.root=f:g===g.parent.right?g.parent.right=f:g.parent.left=f,f.right=g,g.parent=f}function E(c,g){let f,m;if(g.left===e.$XC?(m=g,f=m.right):g.right===e.$XC?(m=g,f=m.left):(m=A(g.right),f=m.right),m===c.root){c.root=f,f.color=h.Black,g.detach(),$(),c.root.parent=e.$XC;return}const n=m.color===h.Red;if(m===m.parent.left?m.parent.left=f:m.parent.right=f,m===g?(f.parent=m.parent,p(c,f)):(m.parent===g?f.parent=m:f.parent=m.parent,p(c,f),m.left=g.left,m.right=g.right,m.parent=g.parent,m.color=g.color,g===c.root?c.root=m:g===g.parent.left?g.parent.left=m:g.parent.right=m,m.left!==e.$XC&&(m.left.parent=m),m.right!==e.$XC&&(m.right.parent=m),m.size_left=g.size_left,m.lf_left=g.lf_left,p(c,m)),g.detach(),f.parent.left===f){const i=L(f),t=T(f);if(i!==f.parent.size_left||t!==f.parent.lf_left){const s=i-f.parent.size_left,d=t-f.parent.lf_left;f.parent.size_left=i,f.parent.lf_left=t,P(c,f.parent,s,d)}}if(p(c,f.parent),n){$();return}let o;for(;f!==c.root&&f.color===h.Black;)f===f.parent.left?(o=f.parent.right,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,l(c,f.parent),o=f.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,C(c,o),o=f.parent.right),o.color=f.parent.color,f.parent.color=h.Black,o.right.color=h.Black,l(c,f.parent),f=c.root)):(o=f.parent.left,o.color===h.Red&&(o.color=h.Black,f.parent.color=h.Red,C(c,f.parent),o=f.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,f=f.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,l(c,o),o=f.parent.left),o.color=f.parent.color,f.parent.color=h.Black,o.left.color=h.Black,C(c,f.parent),f=c.root));f.color=h.Black,$()}function u(c,g){for(p(c,g);g!==c.root&&g.parent.color===h.Red;)if(g.parent===g.parent.parent.left){const f=g.parent.parent.right;f.color===h.Red?(g.parent.color=h.Black,f.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,l(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,C(c,g.parent.parent))}else{const f=g.parent.parent.left;f.color===h.Red?(g.parent.color=h.Black,f.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,C(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,l(c,g.parent.parent))}c.root.color=h.Black}function P(c,g,f,m){for(;g!==c.root&&g!==e.$XC;)g.parent.left===g&&(g.parent.size_left+=f,g.parent.lf_left+=m),g=g.parent}function p(c,g){let f=0,m=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,f=L(g.left)-g.size_left,m=T(g.left)-g.lf_left,g.size_left+=f,g.lf_left+=m;g!==c.root&&(f!==0||m!==0);)g.parent.left===g&&(g.parent.size_left+=f,g.parent.lf_left+=m),g=g.parent}}}),define(Ee[196],Se([1,0,19,84]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.$cw=void 0;class A{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,l){$=(0,h.$_e)($);const C=this.a,E=this.b,u=l.length;return u===0?!1:(this.a=new Uint32Array(C.length+u),this.a.set(C.subarray(0,$),0),this.a.set(C.subarray($),$+u),this.a.set(l,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,l){return $=(0,h.$_e)($),l=(0,h.$_e)(l),this.a[$]===l?!1:(this.a[$]=l,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,l){$=(0,h.$_e)($),l=(0,h.$_e)(l);const C=this.a,E=this.b;if($>=C.length)return!1;const u=C.length-$;return l>=u&&(l=u),l===0?!1:(this.a=new Uint32Array(C.length-l),this.a.set(C.subarray(0,$),0),this.a.set(C.subarray($+l),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$_e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),$>=this.a.length&&($=this.a.length-1);for(let C=l;C<=$;C++)this.b[C]=this.b[C-1]+this.a[C];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let l=0,C=this.a.length-1,E=0,u=0,P=0;for(;l<=C;)if(E=l+(C-l)/2|0,u=this.b[E],P=u-this.a[E],$<P)C=E-1;else if($>=u)l=E+1;else break;return new L(E,$-P)}}e.$cw=A;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const l=this.e[$],C=l>0?this.d[l-1]:0;return new L(l,$-C)}removeValues($,l){this.a.splice($,l),this.f($)}insertValues($,l){this.a=(0,r.$Wb)(this.a,$,l),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,l=this.a.length;$<l;$++){const C=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+C;for(let u=0;u<C;u++)this.e[E+u]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,l){this.a[$]!==l&&(this.a[$]=l,this.f($))}}e.$dw=R;class L{constructor($,l){this.index=$,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=l}}e.$ew=L}),define(Ee[197],Se([1,0,13,53,196]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=void 0;class R{constructor(T,$,l,C){this.d=T,this.f=$,this.g=l,this.h=C,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const $=T.changes;for(const l of $)this.o(l.range),this.p(new h.$Et(l.range.startLineNumber,l.range.startColumn),l.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,$=this.f.length,l=new Uint32Array($);for(let C=0;C<$;C++)l[C]=this.f[C].length+T;this.j=new A.$cw(l)}}n(T,$){this.f[T]=$,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,$){if($.length===0)return;const l=(0,r.$qf)($);if(l.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+l[0]+this.f[T.lineNumber-1].substring(T.column-1));return}l[l.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+l[0]);const C=new Uint32Array(l.length-1);for(let E=1;E<l.length;E++)this.f.splice(T.lineNumber+E-1,0,l[E]),C[E-1]=l[E].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,C)}}e.$fw=R}),define(Ee[107],Se([1,0,27,13,192,53,31,54]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$0C=e.$7C=void 0,e.$8C=C,e.$9C=E,e.$$C=g,h=Ue(h);const $=999;class l{constructor(n,o,i,t){this.searchString=n,this.isRegex=o,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=C(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$of(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new T.$0v(o,this.wordSeparators?(0,A.$au)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.$7C=l;function C(m){if(!m||m.length===0)return!1;for(let n=0,o=m.length;n<o;n++){const i=m.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=o)break;const t=m.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function E(m,n,o){if(!o)return new T.$7v(m,null);const i=[];for(let t=0,s=n.length;t<s;t++)i[t]=n[t];return new T.$7v(m,i)}class u{constructor(n){const o=[];let i=0;for(let t=0,s=n.length;t<s;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(o[i++]=t);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let i=0,t=o.length-1;if(t===-1||n<=o[0])return 0;for(;i<t;){const s=i+((t-i)/2>>0);o[s]>=n?t=s-1:o[s+1]>=n?(i=s,t=s):i=s+1}return i+1}}class P{static findMatches(n,o,i,t,s){const d=o.parseSearchRequest();return d?d.regex.multiline?this.b(n,i,new f(d.wordSeparators,d.regex),t,s):this.c(n,i,d,t,s):[]}static a(n,o,i,t,s,d){let a,w=0;t?(w=t.findLineFeedCountBeforeOffset(s),a=o+s+w):a=o+s;let y;if(t){const k=t.findLineFeedCountBeforeOffset(s+d.length)-w;y=a+d.length+k}else y=a+d.length;const D=n.getPositionAt(a),S=n.getPositionAt(y);return new L.$Ft(D.lineNumber,D.column,S.lineNumber,S.column)}static b(n,o,i,t,s){const d=n.getOffsetAt(o.getStartPosition()),a=n.getValueInRange(o,T.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new u(a):null,y=[];let D=0,S;for(i.reset(0);S=i.next(a);)if(y[D++]=E(this.a(n,d,a,w,S.index,S[0]),S,t),D>=s)return y;return y}static c(n,o,i,t,s){const d=[];let a=0;if(o.startLineNumber===o.endLineNumber){const y=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return a=this.d(i,y,o.startLineNumber,o.startColumn-1,a,d,t,s),d}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);a=this.d(i,w,o.startLineNumber,o.startColumn-1,a,d,t,s);for(let y=o.startLineNumber+1;y<o.endLineNumber&&a<s;y++)a=this.d(i,n.getLineContent(y),y,0,a,d,t,s);if(a<s){const y=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);a=this.d(i,y,o.endLineNumber,0,a,d,t,s)}return d}static d(n,o,i,t,s,d,a,w){const y=n.wordSeparators;if(!a&&n.simpleSearch){const I=n.simpleSearch,k=I.length,b=o.length;let v=-k;for(;(v=o.indexOf(I,v+k))!==-1;)if((!y||g(y,o,b,v,k))&&(d[s++]=new T.$7v(new L.$Ft(i,v+1+t,i,v+1+k+t),null),s>=w))return s;return s}const D=new f(n.wordSeparators,n.regex);let S;D.reset(0);do if(S=D.next(o),S&&(d[s++]=E(new L.$Ft(i,S.index+1+t,i,S.index+1+S[0].length+t),S,a),s>=w))return s;while(S);return s}static findNextMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const d=new f(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,i,d,t):this.f(n,i,d,t)}static e(n,o,i,t){const s=new R.$Et(o.lineNumber,1),d=n.getOffsetAt(s),a=n.getLineCount(),w=n.getValueInRange(new L.$Ft(s.lineNumber,s.column,a,n.getLineMaxColumn(a)),T.EndOfLinePreference.LF),y=n.getEOL()===`\r
`?new u(w):null;i.reset(o.column-1);const D=i.next(w);return D?E(this.a(n,d,w,y,D.index,D[0]),D,t):o.lineNumber!==1||o.column!==1?this.e(n,new R.$Et(1,1),i,t):null}static f(n,o,i,t){const s=n.getLineCount(),d=o.lineNumber,a=n.getLineContent(d),w=this.g(i,a,d,o.column,t);if(w)return w;for(let y=1;y<=s;y++){const D=(d+y-1)%s,S=n.getLineContent(D+1),I=this.g(i,S,D+1,1,t);if(I)return I}return null}static g(n,o,i,t,s){n.reset(t-1);const d=n.next(o);return d?E(new L.$Ft(i,d.index+1,i,d.index+1+d[0].length),d,s):null}static findPreviousMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const d=new f(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,i,d,t):this.j(n,i,d,t)}static h(n,o,i,t){const s=this.b(n,new L.$Ft(1,1,o.lineNumber,o.column),i,t,10*$);if(s.length>0)return s[s.length-1];const d=n.getLineCount();return o.lineNumber!==d||o.column!==n.getLineMaxColumn(d)?this.h(n,new R.$Et(d,n.getLineMaxColumn(d)),i,t):null}static j(n,o,i,t){const s=n.getLineCount(),d=o.lineNumber,a=n.getLineContent(d).substring(0,o.column-1),w=this.k(i,a,d,t);if(w)return w;for(let y=1;y<=s;y++){const D=(s+d-y-1)%s,S=n.getLineContent(D+1),I=this.k(i,S,D+1,t);if(I)return I}return null}static k(n,o,i,t){let s=null,d;for(n.reset(0);d=n.next(o);)s=E(new L.$Ft(i,d.index+1,i,d.index+1+d[0].length),d,t);return s}}e.$0C=P;function p(m,n,o,i,t){if(i===0)return!0;const s=n.charCodeAt(i-1);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const d=n.charCodeAt(i);if(m.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function c(m,n,o,i,t){if(i+t===o)return!0;const s=n.charCodeAt(i+t);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const d=n.charCodeAt(i+t-1);if(m.get(d)!==A.WordCharacterClass.Regular)return!0}return!1}function g(m,n,o,i,t){return p(m,n,o,i,t)&&c(m,n,o,i,t)}class f{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let i;do{if(this.b+this.c===o||(i=this.a.exec(n),!i))return null;const t=i.index,s=i[0].length;if(t===this.b&&s===this.c){if(s===0){h.$Kf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=s,!this._wordSeparators||g(this._wordSeparators,n,o,t,s))return i}while(i);return null}}e.$_C=f}),define(Ee[139],Se([1,0,27,53,31,54,195,107]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=void 0,e.$aD=E,e.$bD=u;const $=65535;function l(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class C{constructor(n,o,i,t,s){this.lineStarts=n,this.cr=o,this.lf=i,this.crlf=t,this.isBasicASCII=s}}function E(m,n=!0){const o=[0];let i=1;for(let t=0,s=m.length;t<s;t++){const d=m.charCodeAt(t);d===r.CharCode.CarriageReturn?t+1<s&&m.charCodeAt(t+1)===r.CharCode.LineFeed?(o[i++]=t+2,t++):o[i++]=t+1:d===r.CharCode.LineFeed&&(o[i++]=t+1)}return n?l(o):o}function u(m,n){m.length=0,m[0]=0;let o=1,i=0,t=0,s=0,d=!0;for(let w=0,y=n.length;w<y;w++){const D=n.charCodeAt(w);D===r.CharCode.CarriageReturn?w+1<y&&n.charCodeAt(w+1)===r.CharCode.LineFeed?(s++,m[o++]=w+2,w++):(i++,m[o++]=w+1):D===r.CharCode.LineFeed?(t++,m[o++]=w+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const a=new C(l(m),i,t,s,d);return m.length=0,a}class P{constructor(n,o,i,t,s){this.bufferIndex=n,this.start=o,this.end=i,this.lineFeedCnt=t,this.length=s}}e.$cD=P;class p{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$dD=p;class c{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==L.$XC&&n.iterate(n.root,i=>(i!==L.$XC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const i=this.b;for(let t=0;t<i.length;t++){const s=i[t];if(s.node.parent===null||s.nodeStartOffset>=n){i[t]=null,o=!0;continue}}if(o){const t=[];for(const s of i)s!==null&&t.push(s);this.b=t}}}class f{constructor(n,o,i){this.create(n,o,i)}create(n,o,i){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=L.$XC,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=i;let t=null;for(let s=0,d=n.length;s<d;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=E(n[s].buffer));const a=new P(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),t=this.S(t,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,i=o-Math.floor(o/3),t=i*2;let s="",d=0;const a=[];if(this.iterate(this.root,w=>{const y=this.R(w),D=y.length;if(d<=i||d+D<t)return s+=y,d+=D,!0;const S=s.replace(/\r\n|\r|\n/g,n);return a.push(new p(S,E(S))),s=y,d=D,!0}),d>0){const w=s.replace(/\r\n|\r|\n/g,n);a.push(new p(w,E(w)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new c(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,t=>{if(t===L.$XC)return!0;const s=this.R(t),d=s.length,a=n.G(o),w=n.G(o+d),y=n.getValueInRange2(a,w);return o+=d,s===y})}getOffsetAt(n,o){let i=0,t=this.root;for(;t!==L.$XC;)if(t.left!==L.$XC&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const s=this.B(t,n-t.lf_left-2);return i+=s+o-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,i=0;const t=n;for(;o!==L.$XC;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(i+=o.lf_left+s.index,s.index===0){const d=this.getOffsetAt(i+1,1),a=t-d;return new h.$Et(i+1,a+1)}return new h.$Et(i+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,i+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$XC){const s=this.getOffsetAt(i+1,1),d=t-n-s;return new h.$Et(i+1,d+1)}else o=o.right;return new h.$Et(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(i,t);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const a=n.node,w=this.a[a.piece.bufferIndex].buffer,y=this.u(a.piece.bufferIndex,a.piece.start);return w.substring(y+n.remainder,y+o.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,s=this.u(i.piece.bufferIndex,i.piece.start);let d=t.substring(s+n.remainder,s+i.piece.length);for(i=i.next();i!==L.$XC;){const a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(i===o.node){d+=a.substring(w,w+o.remainder);break}else d+=a.substr(w,i.piece.length);i=i.next()}return d}getLinesContent(){const n=[];let o=0,i="",t=!1;return this.iterate(this.root,s=>{if(s===L.$XC)return!0;const d=s.piece;let a=d.length;if(a===0)return!0;const w=this.a[d.bufferIndex].buffer,y=this.a[d.bufferIndex].lineStarts,D=d.start.line,S=d.end.line;let I=y[D]+d.start.column;if(t&&(w.charCodeAt(I)===r.CharCode.LineFeed&&(I++,a--),n[o++]=i,i="",t=!1,a===0))return!0;if(D===S)return!this.f&&w.charCodeAt(I+a-1)===r.CharCode.CarriageReturn?(t=!0,i+=w.substr(I,a-1)):i+=w.substr(I,a),!0;i+=this.f?w.substring(I,Math.max(I,y[D+1]-this.e)):w.substring(I,y[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;for(let k=D+1;k<S;k++)i=this.f?w.substring(y[k],y[k+1]-this.e):w.substring(y[k],y[k+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;return!this.f&&w.charCodeAt(y[S]+d.end.column-1)===r.CharCode.CarriageReturn?(t=!0,d.end.column===0?o--:i=w.substr(y[S],d.end.column-1)):i=w.substr(y[S],d.end.column),!0}),t&&(n[o++]=i,i=""),n[o++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const i=this.a[o.piece.bufferIndex],t=this.u(o.piece.bufferIndex,o.piece.start);return i.buffer.charCodeAt(t)}else{const o=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(t)}}getLineCharCode(n,o){const i=this.H(n,o+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,i,t,s,d,a,w,y,D,S){const I=this.a[n.piece.bufferIndex],k=this.u(n.piece.bufferIndex,n.piece.start),b=this.u(n.piece.bufferIndex,s),v=this.u(n.piece.bufferIndex,d);let N;const O={line:0,column:0};let F,j;o._wordSeparators?(F=I.buffer.substring(b,v),j=B=>B+b,o.reset(0)):(F=I.buffer,j=B=>B,o.reset(b));do if(N=o.next(F),N){if(j(N.index)>=v)return D;this.s(n,j(N.index)-k,O);const B=this.t(n.piece.bufferIndex,s,O),M=O.line===s.line?O.column-s.column+t:O.column+1,W=M+N[0].length;if(S[D++]=(0,T.$9C)(new A.$Ft(i+B,M,i+B,W),N,w),j(N.index)+N[0].length>=v||D>=y)return D}while(N);return D}findMatchesLineByLine(n,o,i,t){const s=[];let d=0;const a=new T.$_C(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const y=this.H(n.endLineNumber,n.endColumn);if(y===null)return[];let D=this.s(w.node,w.remainder);const S=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,a,n.startLineNumber,n.startColumn,D,S,o,i,t,d,s),s;let I=n.startLineNumber,k=w.node;for(;k!==y.node;){const v=this.t(k.piece.bufferIndex,D,k.piece.end);if(v>=1){const O=this.a[k.piece.bufferIndex].lineStarts,F=this.u(k.piece.bufferIndex,k.piece.start),j=O[D.line+v],B=I===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(k,a,I,B,D,this.s(k,j-F),o,i,t,d,s),d>=t)return s;I+=v}const N=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const O=this.getLineContent(I).substring(N,n.endColumn-1);return d=this.n(o,a,O,n.endLineNumber,N,d,s,i,t),s}if(d=this.n(o,a,this.getLineContent(I).substr(N),I,N,d,s,i,t),d>=t)return s;I++,w=this.H(I,1),k=w.node,D=this.s(w.node,w.remainder)}if(I===n.endLineNumber){const v=I===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(I).substring(v,n.endColumn-1);return d=this.n(o,a,N,n.endLineNumber,v,d,s,i,t),s}const b=I===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(y.node,a,I,b,D,S,o,i,t,d,s),s}n(n,o,i,t,s,d,a,w,y){const D=n.wordSeparators;if(!w&&n.simpleSearch){const I=n.simpleSearch,k=I.length,b=i.length;let v=-k;for(;(v=i.indexOf(I,v+k))!==-1;)if((!D||(0,T.$$C)(D,i,b,v,k))&&(a[d++]=new R.$7v(new A.$Ft(t,v+1+s,t,v+1+k+s),null),d>=y))return d;return d}let S;o.reset(0);do if(S=o.next(i),S&&(a[d++]=(0,T.$9C)(new A.$Ft(t,S.index+1+s,t,S.index+1+S[0].length+s),S,w),d>=y))return d;while(S);return d}insert(n,o,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==L.$XC){const{node:t,remainder:s,nodeStartOffset:d}=this.G(n),a=t.piece,w=a.bufferIndex,y=this.s(t,s);if(t.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&d+a.length===n&&o.length<$){this.F(t,o),this.y();return}if(d===n)this.o(o,t),this.h.validate(n);else if(d+t.piece.length>n){const D=[];let S=new P(a.bufferIndex,y,a.end,this.t(a.bufferIndex,y,a.end),this.u(w,a.end)-this.u(w,y));if(this.K()&&this.M(o)&&this.I(t,s)===10){const v={line:S.start.line+1,column:0};S=new P(S.bufferIndex,v,S.end,this.t(S.bufferIndex,v,S.end),S.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(t,s-1)===13){const v=this.s(t,s-1);this.C(t,v),o="\r"+o,t.piece.length===0&&D.push(t)}else this.C(t,y);else this.C(t,y);const I=this.w(o);S.length>0&&this.S(t,S);let k=t;for(let b=0;b<I.length;b++)k=this.S(k,I[b]);this.v(D)}else this.q(o,t)}else{const t=this.w(o);let s=this.T(null,t[0]);for(let d=1;d<t.length;d++)s=this.S(s,t[d])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$XC)return;const i=this.G(n),t=this.G(n+o),s=i.node,d=t.node;if(s===d){const I=this.s(s,i.remainder),k=this.s(s,t.remainder);if(i.nodeStartOffset===n){if(o===s.piece.length){const b=s.next();(0,L.$3C)(this,s),this.N(b),this.y();return}this.D(s,k),this.h.validate(n),this.N(s),this.y();return}if(i.nodeStartOffset+s.piece.length===n+o){this.C(s,I),this.O(s),this.y();return}this.E(s,I,k),this.y();return}const a=[],w=this.s(s,i.remainder);this.C(s,w),this.h.validate(n),s.piece.length===0&&a.push(s);const y=this.s(d,t.remainder);this.D(d,y),d.piece.length===0&&a.push(d);const D=s.next();for(let I=D;I!==L.$XC&&I!==d;I=I.next())a.push(I);const S=s.piece.length===0?s.prev():s;this.v(a),this.O(S),this.y()}o(n,o){const i=[];if(this.K()&&this.M(n)&&this.L(o)){const d=o.piece,a={line:d.start.line+1,column:0},w=new P(d.bufferIndex,a,d.end,this.t(d.bufferIndex,a,d.end),d.length-1);o.piece=w,n+=`
`,(0,L.$5C)(this,o,-1,-1),o.piece.length===0&&i.push(o)}const t=this.w(n);let s=this.T(o,t[t.length-1]);for(let d=t.length-2;d>=0;d--)s=this.T(s,t[d]);this.N(s),this.v(i)}q(n,o){this.Q(n,o)&&(n+=`
`);const i=this.w(n),t=this.S(o,i[0]);let s=t;for(let d=1;d<i.length;d++)s=this.S(s,i[d]);this.N(t)}s(n,o,i){const t=n.piece,s=n.piece.bufferIndex,d=this.a[s].lineStarts,w=d[t.start.line]+t.start.column+o;let y=t.start.line,D=t.end.line,S=0,I=0,k=0;for(;y<=D&&(S=y+(D-y)/2|0,k=d[S],S!==D);)if(I=d[S+1],w<k)D=S-1;else if(w>=I)y=S+1;else break;return i?(i.line=S,i.column=w-k,null):{line:S,column:w-k}}t(n,o,i){if(i.column===0)return i.line-o.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-o.line;const s=t[i.line+1],d=t[i.line]+i.column;if(s>d+1)return i.line-o.line;const a=d-1;return this.a[n].buffer.charCodeAt(a)===13?i.line-o.line+1:i.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,L.$3C)(this,n[o])}w(n){if(n.length>$){const D=[];for(;n.length>$;){const I=n.charCodeAt($-1);let k;I===r.CharCode.CarriageReturn||I>=55296&&I<=56319?(k=n.substring(0,$-1),n=n.substring($-1)):(k=n.substring(0,$),n=n.substring($));const b=E(k);D.push(new P(this.a.length,{line:0,column:0},{line:b.length-1,column:k.length-b[b.length-1]},b.length-1,k.length)),this.a.push(new p(k,b))}const S=E(n);return D.push(new P(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),D}let o=this.a[0].buffer.length;const i=E(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let D=0;D<i.length;D++)i[D]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<i.length;D++)i[D]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,a=s-this.a[0].lineStarts[d],w={line:d,column:a},y=new P(0,t,w,this.t(0,t,w),s-o);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let i=this.root,t="";const s=this.h.get2(n);if(s){i=s.node;const d=this.B(i,n-s.nodeStartLineNumber-1),a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(s.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=a.substring(w+d,w+i.piece.length);else{const y=this.B(i,n-s.nodeStartLineNumber);return a.substring(w+d,w+y-o)}}else{let d=0;const a=n;for(;i!==L.$XC;)if(i.left!==L.$XC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const w=this.B(i,n-i.lf_left-2),y=this.B(i,n-i.lf_left-1),D=this.a[i.piece.bufferIndex].buffer,S=this.u(i.piece.bufferIndex,i.piece.start);return d+=i.size_left,this.h.set({node:i,nodeStartOffset:d,nodeStartLineNumber:a-(n-1-i.lf_left)}),D.substring(S+w,S+y-o)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const w=this.B(i,n-i.lf_left-2),y=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);t=y.substring(D+w,D+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,d+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==L.$XC;){const d=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const a=this.B(i,0),w=this.u(i.piece.bufferIndex,i.piece.start);return t+=d.substring(w,w+a-o),t}else{const a=this.u(i.piece.bufferIndex,i.piece.start);t+=d.substr(a,i.piece.length)}i=i.next()}return t}y(){let n=this.root,o=1,i=0;for(;n!==L.$XC;)o+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=i,this.h.validate(this.c)}A(n,o){const i=n.piece,t=this.s(n,o),s=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===o){const d=this.t(n.piece.bufferIndex,i.start,t);if(d!==s)return{index:d,remainder:0}}return{index:s,remainder:t.column}}B(n,o){if(o<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,s=i.start.line+o+1;return s>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[s]-t[i.start.line]-i.start.column}C(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.end),d=o,a=this.u(i.bufferIndex,d),w=this.t(i.bufferIndex,i.start,d),y=w-t,D=a-s,S=i.length+D;n.piece=new P(i.bufferIndex,i.start,d,w,S),(0,L.$5C)(this,n,D,y)}D(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.start),d=o,a=this.t(i.bufferIndex,d,i.end),w=this.u(i.bufferIndex,d),y=a-t,D=s-w,S=i.length+D;n.piece=new P(i.bufferIndex,d,i.end,a,S),(0,L.$5C)(this,n,D,y)}E(n,o,i){const t=n.piece,s=t.start,d=t.end,a=t.length,w=t.lineFeedCnt,y=o,D=this.t(t.bufferIndex,t.start,y),S=this.u(t.bufferIndex,o)-this.u(t.bufferIndex,s);n.piece=new P(t.bufferIndex,t.start,y,D,S),(0,L.$5C)(this,n,S-a,D-w);const I=new P(t.bufferIndex,i,d,this.t(t.bufferIndex,i,d),this.u(t.bufferIndex,d)-this.u(t.bufferIndex,i)),k=this.S(n,I);this.N(k)}F(n,o){this.Q(o,n)&&(o+=`
`);const i=this.K()&&this.L(o)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=o;const s=E(o,!1);for(let k=0;k<s.length;k++)s[k]+=t;if(i){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const d=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[d],w={line:d,column:a},y=n.piece.length+o.length,D=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,w),I=S-D;n.piece=new P(n.piece.bufferIndex,n.piece.start,w,S,y),this.g=w,(0,L.$5C)(this,n,o.length,I)}G(n){let o=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;o!==L.$XC;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){t+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:t};return this.h.set(s),s}else n-=o.size_left+o.piece.length,t+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let i=this.root,t=0;for(;i!==L.$XC;)if(i.left!==L.$XC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const s=this.B(i,n-i.lf_left-2),d=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(s+o-1,d),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const s=this.B(i,n-i.lf_left-2);if(s+o-1<=i.piece.length)return{node:i,remainder:s+o-1,nodeStartOffset:t};o-=i.piece.length-s;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==L.$XC;){if(i.piece.lineFeedCnt>0){const s=this.B(i,0),d=this.J(i);return{node:i,remainder:Math.min(o-1,s),nodeStartOffset:d}}else if(i.piece.length>=o-1){const s=this.J(i);return{node:i,remainder:o-1,nodeStartOffset:s}}else o-=i.piece.length;i=i.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+o;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$XC||n.piece.lineFeedCnt===0)return!1;const o=n.piece,i=this.a[o.bufferIndex].lineStarts,t=o.start.line,s=i[t]+o.start.column;return t===i.length-1||i[t+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$XC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new P(n.piece.bufferIndex,n.piece.start,s,a,d),(0,L.$5C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const w={line:o.piece.start.line+1,column:0},y=o.piece.length-1,D=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new P(o.piece.bufferIndex,w,o.piece.end,D,y),(0,L.$5C)(this,o,-1,-1),o.piece.length===0&&i.push(o);const S=this.w(`\r
`);this.S(n,S[0]);for(let I=0;I<i.length;I++)(0,L.$3C)(this,i[I])}Q(n,o){if(this.K()&&this.M(n)){const i=o.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,L.$3C)(this,i);else{const t=i.piece,s={line:t.start.line+1,column:0},d=t.length-1,a=this.t(t.bufferIndex,s,t.end);i.piece=new P(t.bufferIndex,s,t.end,a,d),(0,L.$5C)(this,i,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.$XC)return o(L.$XC);const i=this.iterate(n.left,o);return i&&o(n)&&this.iterate(n.right,o)}R(n){if(n===L.$XC)return"";const o=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,s)}getPieceContent(n){const o=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return o.buffer.substring(i,t)}S(n,o){const i=new L.$WC(o,L.NodeColor.Red);if(i.left=L.$XC,i.right=L.$XC,i.parent=L.$XC,i.size_left=0,i.lf_left=0,this.root===L.$XC)this.root=i,i.color=L.NodeColor.Black;else if(n.right===L.$XC)n.right=i,i.parent=n;else{const s=(0,L.$YC)(n.right);s.left=i,i.parent=s}return(0,L.$4C)(this,i),i}T(n,o){const i=new L.$WC(o,L.NodeColor.Red);if(i.left=L.$XC,i.right=L.$XC,i.parent=L.$XC,i.size_left=0,i.lf_left=0,this.root===L.$XC)this.root=i,i.color=L.NodeColor.Black;else if(n.left===L.$XC)n.left=i,i.parent=n;else{const t=(0,L.$ZC)(n.left);t.right=i,i.parent=t}return(0,L.$4C)(this,i),i}U(n){let o="";return this.iterate(n,i=>(o+=this.R(i),!0)),o}}e.$eD=f}),define(Ee[198],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$=e.$I$=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$I$=r;class h{constructor(R){this.identifier=R}}e.$J$=h}),define(Ee[199],Se([1,0,4,3,106]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$je,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,l){return this.a.set($,l),this.handleChange([$]),(0,h.$Tc)(()=>{this.a.get($)===l&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,l){this.b.get($)?.dispose();const C=new L(this,$,l);return this.b.set($,C),(0,h.$Tc)(()=>{const E=this.b.get($);!E||E!==C||(this.b.delete($),E.dispose())})}async getOrCreate($){const l=this.get($);if(l)return l;const C=this.b.get($);return!C||C.isResolved?null:(await C.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const C=this.b.get($);return!!(!C||C.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$ou=R;class L extends h.$Vc{get isResolved(){return this.c}constructor($,l,C){super(),this.f=$,this.g=l,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Ee[200],Se([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[201],Se([1,0,4,3,200]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=C,A=Ue(A);class R extends h.$Vc{constructor(u,P="",p="",c=!0,g){super(),this.j=this.B(new r.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=P,this.w=p,this.z=c,this.D=g}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,P){this.D&&await this.D(u)}}e.$hj=R;class L extends h.$Vc{constructor(){super(...arguments),this.f=this.B(new r.$je),this.onWillRun=this.f.event,this.m=this.B(new r.$je),this.onDidRun=this.m.event}async run(u,P){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,P)}catch(c){p=c}this.m.fire({action:u,error:p})}async u(u,P){await u.run(P)}}e.$ij=L;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let P=[];for(const p of u)p.length&&(P.length?P=[...P,new T,...p]:P=p);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=T;class ${get actions(){return this.a}constructor(u,P,p,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=P,this.class=c,this.a=p}async run(){}}e.$kj=$;class l extends R{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,A.localize(0,null),void 0,!1)}}e.$lj=l;function C(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(Ee[202],Se([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[203],Se([1,0,202]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=l,e.$Ym=C,e.$Zm=E;const h=60,A=h*60,R=A*24,L=R*7,T=R*30,$=R*365;function l(u,P,p,c){typeof u!="number"&&(u=u.getTime());const g=Math.round((new Date().getTime()-u)/1e3);if(g<-30)return(0,r.localize)(0,null,l(new Date().getTime()+g*1e3,!1));if(!c&&g<30)return(0,r.localize)(1,null);let f;return g<h?(f=g,P?f===1?p?(0,r.localize)(2,null,f):(0,r.localize)(3,null,f):p?(0,r.localize)(4,null,f):(0,r.localize)(5,null,f):f===1?p?(0,r.localize)(6,null,f):(0,r.localize)(7,null,f):p?(0,r.localize)(8,null,f):(0,r.localize)(9,null,f)):g<A?(f=Math.floor(g/h),P?f===1?p?(0,r.localize)(10,null,f):(0,r.localize)(11,null,f):p?(0,r.localize)(12,null,f):(0,r.localize)(13,null,f):f===1?p?(0,r.localize)(14,null,f):(0,r.localize)(15,null,f):p?(0,r.localize)(16,null,f):(0,r.localize)(17,null,f)):g<R?(f=Math.floor(g/A),P?f===1?p?(0,r.localize)(18,null,f):(0,r.localize)(19,null,f):p?(0,r.localize)(20,null,f):(0,r.localize)(21,null,f):f===1?p?(0,r.localize)(22,null,f):(0,r.localize)(23,null,f):p?(0,r.localize)(24,null,f):(0,r.localize)(25,null,f)):g<L?(f=Math.floor(g/R),P?f===1?(0,r.localize)(26,null,f):(0,r.localize)(27,null,f):f===1?(0,r.localize)(28,null,f):(0,r.localize)(29,null,f)):g<T?(f=Math.floor(g/L),P?f===1?p?(0,r.localize)(30,null,f):(0,r.localize)(31,null,f):p?(0,r.localize)(32,null,f):(0,r.localize)(33,null,f):f===1?p?(0,r.localize)(34,null,f):(0,r.localize)(35,null,f):p?(0,r.localize)(36,null,f):(0,r.localize)(37,null,f)):g<$?(f=Math.floor(g/T),P?f===1?p?(0,r.localize)(38,null,f):(0,r.localize)(39,null,f):p?(0,r.localize)(40,null,f):(0,r.localize)(41,null,f):f===1?p?(0,r.localize)(42,null,f):(0,r.localize)(43,null,f):p?(0,r.localize)(44,null,f):(0,r.localize)(45,null,f)):(f=Math.floor(g/$),P?f===1?p?(0,r.localize)(46,null,f):(0,r.localize)(47,null,f):p?(0,r.localize)(48,null,f):(0,r.localize)(49,null,f):f===1?p?(0,r.localize)(50,null,f):(0,r.localize)(51,null,f):p?(0,r.localize)(52,null,f):(0,r.localize)(53,null,f))}function C(u,P){const p=Math.abs(u/1e3);return p<1?P?(0,r.localize)(54,null,u):(0,r.localize)(55,null,u):p<h?P?(0,r.localize)(56,null,Math.round(u)/1e3):(0,r.localize)(57,null,Math.round(u)/1e3):p<A?P?(0,r.localize)(58,null,Math.round(u/(1e3*h))):(0,r.localize)(59,null,Math.round(u/(1e3*h))):p<R?P?(0,r.localize)(60,null,Math.round(u/(1e3*A))):(0,r.localize)(61,null,Math.round(u/(1e3*A))):(0,r.localize)(62,null,Math.round(u/(1e3*R)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[204],Se([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[55],Se([1,0,19,18,204]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=$,e.$oj=l,e.$pj=C,r=Ue(r),h=Ue(h),A=Ue(A);function R(E,u){return u&&(E.stack||E.stacktrace)?A.localize(0,null,T(E),L(E.stack)||L(E.stacktrace)):T(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function T(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function $(E=null,u=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const P=r.$Ib(E),p=$(P[0],u);return P.length>1?A.localize(4,null,p,P.length):p}if(h.$cg(E))return E;if(E.detail){const P=E.detail;if(P.error)return R(P.error,u);if(P.exception)return R(P.exception,u)}return E.stack?R(E,u):E.message?E.message:A.localize(5,null)}function l(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function C(E,u){let P;return typeof E=="string"?P=new Error(E):P=E,P.actions=u,P}}),define(Ee[205],Se([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,205]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=S,e.$J=I,r=Ue(r),e.$g="en";let h=!1,A=!1,R=!1,L=!1,T=!1,$=!1,l=!1,C=!1,E=!1,u=!1,P,p=e.$g,c=e.$g,g,f;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",i=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",A=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.$g,p=e.$g;const k=n.env.VSCODE_NLS_CONFIG;if(k)try{const b=JSON.parse(k),v=b.availableLanguages["*"];P=b.locale,c=b.osLocale,p=v||e.$g,g=b._translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!i?(f=navigator.userAgent,h=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=f.indexOf("Linux")>=0,u=f?.indexOf("Mobi")>=0,$=!0,P=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,p=P,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let d=t.Web;A?d=t.Mac:h?d=t.Windows:R&&(d=t.Linux),e.$i=h,e.$j=A,e.$k=R,e.$l=L,e.$m=T,e.$n=l,e.$o=$,e.$p=$&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=C,e.$s=u,e.$t=E,e.$u=d,e.$v=f,e.$w=p;var a;(function(k){function b(){return e.$w}k.value=b;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=v;function N(){return e.$w==="en"}k.isDefault=N})(a||(e.Language=a={})),e.$x=P,e.$y=c,e.$z=g,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const k=[];m.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let N=0,O=k.length;N<O;N++){const F=k[N];if(F.id===v.data.vscodeScheduleAsyncWork){k.splice(N,1),F.callback();return}}});let b=0;return v=>{const N=++b;k.push({id:N,callback:v}),m.postMessage({vscodeScheduleAsyncWork:N},"*")}}return k=>setTimeout(k)})();var w;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=A||C?w.Macintosh:h?w.Windows:w.Linux;let y=!0,D=!1;function S(){if(!D){D=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,y=new Uint16Array(k.buffer)[0]===513}return y}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(k){return parseFloat(k)>=20}}),define(Ee[56],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$ec=h.platform,e.$fc=h.arch}),define(Ee[16],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0,r=Ue(r);const h=65,A=97,R=90,L=122,T=46,$=47,l=92,C=58,E=63;class u extends Error{constructor(s,d,a){let w;typeof d=="string"&&d.indexOf("not ")===0?(w="must not be",d=d.replace(/^not /,"")):w="must be";const y=s.indexOf(".")!==-1?"property":"argument";let D=`The "${s}" ${y} ${w} of type ${d}`;D+=`. Received type ${typeof a}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function P(t,s){if(t===null||typeof t!="object")throw new u(s,"Object",t)}function p(t,s){if(typeof t!="string")throw new u(s,"string",t)}const c=r.$ec==="win32";function g(t){return t===$||t===l}function f(t){return t===$}function m(t){return t>=h&&t<=R||t>=A&&t<=L}function n(t,s,d,a){let w="",y=0,D=-1,S=0,I=0;for(let k=0;k<=t.length;++k){if(k<t.length)I=t.charCodeAt(k);else{if(a(I))break;I=$}if(a(I)){if(!(D===k-1||S===1))if(S===2){if(w.length<2||y!==2||w.charCodeAt(w.length-1)!==T||w.charCodeAt(w.length-2)!==T){if(w.length>2){const b=w.lastIndexOf(d);b===-1?(w="",y=0):(w=w.slice(0,b),y=w.length-1-w.lastIndexOf(d)),D=k,S=0;continue}else if(w.length!==0){w="",y=0,D=k,S=0;continue}}s&&(w+=w.length>0?`${d}..`:"..",y=2)}else w.length>0?w+=`${d}${t.slice(D+1,k)}`:w=t.slice(D+1,k),y=k-D-1;D=k,S=0}else I===T&&S!==-1?++S:S=-1}return w}function o(t,s){P(s,"pathObject");const d=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${a}`:`${d}${t}${a}`:a}e.$gc={resolve(...t){let s="",d="",a=!1;for(let w=t.length-1;w>=-1;w--){let y;if(w>=0){if(y=t[w],p(y,"path"),y.length===0)continue}else s.length===0?y=r.cwd():(y=r.env[`=${s}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==s.toLowerCase()&&y.charCodeAt(2)===l)&&(y=`${s}\\`));const D=y.length;let S=0,I="",k=!1;const b=y.charCodeAt(0);if(D===1)g(b)&&(S=1,k=!0);else if(g(b))if(k=!0,g(y.charCodeAt(1))){let v=2,N=v;for(;v<D&&!g(y.charCodeAt(v));)v++;if(v<D&&v!==N){const O=y.slice(N,v);for(N=v;v<D&&g(y.charCodeAt(v));)v++;if(v<D&&v!==N){for(N=v;v<D&&!g(y.charCodeAt(v));)v++;(v===D||v!==N)&&(I=`\\\\${O}\\${y.slice(N,v)}`,S=v)}}}else S=1;else m(b)&&y.charCodeAt(1)===C&&(I=y.slice(0,2),S=2,D>2&&g(y.charCodeAt(2))&&(k=!0,S=3));if(I.length>0)if(s.length>0){if(I.toLowerCase()!==s.toLowerCase())continue}else s=I;if(a){if(s.length>0)break}else if(d=`${y.slice(S)}\\${d}`,a=k,k&&s.length>0)break}return d=n(d,!a,"\\",g),a?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){p(t,"path");const s=t.length;if(s===0)return".";let d=0,a,w=!1;const y=t.charCodeAt(0);if(s===1)return f(y)?"\\":t;if(g(y))if(w=!0,g(t.charCodeAt(1))){let S=2,I=S;for(;S<s&&!g(t.charCodeAt(S));)S++;if(S<s&&S!==I){const k=t.slice(I,S);for(I=S;S<s&&g(t.charCodeAt(S));)S++;if(S<s&&S!==I){for(I=S;S<s&&!g(t.charCodeAt(S));)S++;if(S===s)return`\\\\${k}\\${t.slice(I)}\\`;S!==I&&(a=`\\\\${k}\\${t.slice(I,S)}`,d=S)}}}else d=1;else m(y)&&t.charCodeAt(1)===C&&(a=t.slice(0,2),d=2,s>2&&g(t.charCodeAt(2))&&(w=!0,d=3));let D=d<s?n(t.slice(d),!w,"\\",g):"";return D.length===0&&!w&&(D="."),D.length>0&&g(t.charCodeAt(s-1))&&(D+="\\"),a===void 0?w?`\\${D}`:D:w?`${a}\\${D}`:`${a}${D}`},isAbsolute(t){p(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return g(d)||s>2&&m(d)&&t.charCodeAt(1)===C&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let y=0;y<t.length;++y){const D=t[y];p(D,"path"),D.length>0&&(s===void 0?s=d=D:s+=`\\${D}`)}if(s===void 0)return".";let a=!0,w=0;if(typeof d=="string"&&g(d.charCodeAt(0))){++w;const y=d.length;y>1&&g(d.charCodeAt(1))&&(++w,y>2&&(g(d.charCodeAt(2))?++w:a=!1))}if(a){for(;w<s.length&&g(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return e.$gc.normalize(s)},relative(t,s){if(p(t,"from"),p(s,"to"),t===s)return"";const d=e.$gc.resolve(t),a=e.$gc.resolve(s);if(d===a||(t=d.toLowerCase(),s=a.toLowerCase(),t===s))return"";let w=0;for(;w<t.length&&t.charCodeAt(w)===l;)w++;let y=t.length;for(;y-1>w&&t.charCodeAt(y-1)===l;)y--;const D=y-w;let S=0;for(;S<s.length&&s.charCodeAt(S)===l;)S++;let I=s.length;for(;I-1>S&&s.charCodeAt(I-1)===l;)I--;const k=I-S,b=D<k?D:k;let v=-1,N=0;for(;N<b;N++){const F=t.charCodeAt(w+N);if(F!==s.charCodeAt(S+N))break;F===l&&(v=N)}if(N!==b){if(v===-1)return a}else{if(k>b){if(s.charCodeAt(S+N)===l)return a.slice(S+N+1);if(N===2)return a.slice(S+N)}D>b&&(t.charCodeAt(w+N)===l?v=N:N===2&&(v=3)),v===-1&&(v=0)}let O="";for(N=w+v+1;N<=y;++N)(N===y||t.charCodeAt(N)===l)&&(O+=O.length===0?"..":"\\..");return S+=v,O.length>0?`${O}${a.slice(S,I)}`:(a.charCodeAt(S)===l&&++S,a.slice(S,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const d=s.charCodeAt(2);if(d!==E&&d!==T)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return t},dirname(t){p(t,"path");const s=t.length;if(s===0)return".";let d=-1,a=0;const w=t.charCodeAt(0);if(s===1)return g(w)?t:".";if(g(w)){if(d=a=1,g(t.charCodeAt(1))){let S=2,I=S;for(;S<s&&!g(t.charCodeAt(S));)S++;if(S<s&&S!==I){for(I=S;S<s&&g(t.charCodeAt(S));)S++;if(S<s&&S!==I){for(I=S;S<s&&!g(t.charCodeAt(S));)S++;if(S===s)return t;S!==I&&(d=a=S+1)}}}}else m(w)&&t.charCodeAt(1)===C&&(d=s>2&&g(t.charCodeAt(2))?3:2,a=d);let y=-1,D=!0;for(let S=s-1;S>=a;--S)if(g(t.charCodeAt(S))){if(!D){y=S;break}}else D=!1;if(y===-1){if(d===-1)return".";y=d}return t.slice(0,y)},basename(t,s){s!==void 0&&p(s,"ext"),p(t,"path");let d=0,a=-1,w=!0,y;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let D=s.length-1,S=-1;for(y=t.length-1;y>=d;--y){const I=t.charCodeAt(y);if(g(I)){if(!w){d=y+1;break}}else S===-1&&(w=!1,S=y+1),D>=0&&(I===s.charCodeAt(D)?--D===-1&&(a=y):(D=-1,a=S))}return d===a?a=S:a===-1&&(a=t.length),t.slice(d,a)}for(y=t.length-1;y>=d;--y)if(g(t.charCodeAt(y))){if(!w){d=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(d,a)},extname(t){p(t,"path");let s=0,d=-1,a=0,w=-1,y=!0,D=0;t.length>=2&&t.charCodeAt(1)===C&&m(t.charCodeAt(0))&&(s=a=2);for(let S=t.length-1;S>=s;--S){const I=t.charCodeAt(S);if(g(I)){if(!y){a=S+1;break}continue}w===-1&&(y=!1,w=S+1),I===T?d===-1?d=S:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||w===-1||D===0||D===1&&d===w-1&&d===a+1?"":t.slice(d,w)},format:o.bind(null,"\\"),parse(t){p(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let a=0,w=t.charCodeAt(0);if(d===1)return g(w)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(g(w)){if(a=1,g(t.charCodeAt(1))){let v=2,N=v;for(;v<d&&!g(t.charCodeAt(v));)v++;if(v<d&&v!==N){for(N=v;v<d&&g(t.charCodeAt(v));)v++;if(v<d&&v!==N){for(N=v;v<d&&!g(t.charCodeAt(v));)v++;v===d?a=v:v!==N&&(a=v+1)}}}}else if(m(w)&&t.charCodeAt(1)===C){if(d<=2)return s.root=s.dir=t,s;if(a=2,g(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;a=3}}a>0&&(s.root=t.slice(0,a));let y=-1,D=a,S=-1,I=!0,k=t.length-1,b=0;for(;k>=a;--k){if(w=t.charCodeAt(k),g(w)){if(!I){D=k+1;break}continue}S===-1&&(I=!1,S=k+1),w===T?y===-1?y=k:b!==1&&(b=1):y!==-1&&(b=-1)}return S!==-1&&(y===-1||b===0||b===1&&y===S-1&&y===D+1?s.base=s.name=t.slice(D,S):(s.name=t.slice(D,y),s.base=t.slice(D,S),s.ext=t.slice(y,S))),D>0&&D!==a?s.dir=t.slice(0,D-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(c){const t=/\\/g;return()=>{const s=r.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$hc={resolve(...t){let s="",d=!1;for(let a=t.length-1;a>=-1&&!d;a--){const w=a>=0?t[a]:i();p(w,"path"),w.length!==0&&(s=`${w}/${s}`,d=w.charCodeAt(0)===$)}return s=n(s,!d,"/",f),d?`/${s}`:s.length>0?s:"."},normalize(t){if(p(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!s,"/",f),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return p(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const a=t[d];p(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(p(t,"from"),p(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const d=1,a=t.length,w=a-d,y=1,D=s.length-y,S=w<D?w:D;let I=-1,k=0;for(;k<S;k++){const v=t.charCodeAt(d+k);if(v!==s.charCodeAt(y+k))break;v===$&&(I=k)}if(k===S)if(D>S){if(s.charCodeAt(y+k)===$)return s.slice(y+k+1);if(k===0)return s.slice(y+k)}else w>S&&(t.charCodeAt(d+k)===$?I=k:k===0&&(I=0));let b="";for(k=d+I+1;k<=a;++k)(k===a||t.charCodeAt(k)===$)&&(b+=b.length===0?"..":"/..");return`${b}${s.slice(y+I)}`},toNamespacedPath(t){return t},dirname(t){if(p(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$;let d=-1,a=!0;for(let w=t.length-1;w>=1;--w)if(t.charCodeAt(w)===$){if(!a){d=w;break}}else a=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&p(s,"ext"),p(t,"path");let d=0,a=-1,w=!0,y;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let D=s.length-1,S=-1;for(y=t.length-1;y>=0;--y){const I=t.charCodeAt(y);if(I===$){if(!w){d=y+1;break}}else S===-1&&(w=!1,S=y+1),D>=0&&(I===s.charCodeAt(D)?--D===-1&&(a=y):(D=-1,a=S))}return d===a?a=S:a===-1&&(a=t.length),t.slice(d,a)}for(y=t.length-1;y>=0;--y)if(t.charCodeAt(y)===$){if(!w){d=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(d,a)},extname(t){p(t,"path");let s=-1,d=0,a=-1,w=!0,y=0;for(let D=t.length-1;D>=0;--D){const S=t.charCodeAt(D);if(S===$){if(!w){d=D+1;break}continue}a===-1&&(w=!1,a=D+1),S===T?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||a===-1||y===0||y===1&&s===a-1&&s===d+1?"":t.slice(s,a)},format:o.bind(null,"/"),parse(t){p(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===$;let a;d?(s.root="/",a=1):a=0;let w=-1,y=0,D=-1,S=!0,I=t.length-1,k=0;for(;I>=a;--I){const b=t.charCodeAt(I);if(b===$){if(!S){y=I+1;break}continue}D===-1&&(S=!1,D=I+1),b===T?w===-1?w=I:k!==1&&(k=1):w!==-1&&(k=-1)}if(D!==-1){const b=y===0&&d?1:y;w===-1||k===0||k===1&&w===D-1&&w===y+1?s.base=s.name=t.slice(b,D):(s.name=t.slice(b,w),s.base=t.slice(b,D),s.ext=t.slice(w,D))}return y>0?s.dir=t.slice(0,y-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(Ee[140],Se([1,0,49,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=T,e.$sr=$,e.$tr=l,e.$ur=C,e.$vr=E,e.$wr=u,e.$xr=P,e.$yr=p,e.$zr=c,e.$Ar=g,e.$Br=w,e.$Cr=y,e.$Dr=D;const A=new r.$W(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(S,I,k=!1){const b=S||"",v=I||"",N=A.value.collator.compare(b,v);return A.value.collatorIsNumeric&&N===0&&b!==v?b<v?-1:1:N}function $(S,I){const k=R.value.collator;return S=S||"",I=I||"",o(k,S,I)}function l(S,I){const k=R.value.collator;return S=S||"",I=I||"",d(S,I)||o(k,S,I)}function C(S,I){const k=R.value.collator;return S=S||"",I=I||"",s(S,I)||o(k,S,I)}function E(S,I){return S=S||"",I=I||"",S===I?0:S<I?-1:1}function u(S,I){const[k,b]=m(S),[v,N]=m(I);let O=A.value.collator.compare(b,N);if(O===0){if(A.value.collatorIsNumeric&&b!==N)return b<N?-1:1;if(O=A.value.collator.compare(k,v),A.value.collatorIsNumeric&&O===0&&k!==v)return k<v?-1:1}return O}function P(S,I){S=S||"",I=I||"";const k=n(S),b=n(I),v=R.value.collator,N=L.value.collator;return o(N,k,b)||o(v,S,I)}function p(S,I){S=S||"",I=I||"";const k=n(S),b=n(I),v=R.value.collator,N=L.value.collator;return o(N,k,b)||d(S,I)||o(v,S,I)}function c(S,I){S=S||"",I=I||"";const k=n(S),b=n(I),v=R.value.collator,N=L.value.collator;return o(N,k,b)||s(S,I)||o(v,S,I)}function g(S,I){S=S||"",I=I||"";const k=n(S).toLowerCase(),b=n(I).toLowerCase();return k!==b?k<b?-1:1:S!==I?S<I?-1:1:0}const f=/^(.*?)(\.([^.]*))?$/;function m(S,I=!1){const k=S?f.exec(S):[];let b=[k&&k[1]||"",k&&k[3]||""];return I&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(S){const I=S?f.exec(S):[];return I&&I[1]&&I[1].charAt(0)!=="."&&I[3]||""}function o(S,I,k){const b=S.compare(I,k);return b!==0?b:I.length!==k.length?I.length<k.length?-1:1:0}function i(S){const I=S.charAt(0);return I.toLocaleUpperCase()!==I}function t(S){const I=S.charAt(0);return I.toLocaleLowerCase()!==I}function s(S,I){return i(S)&&t(I)?-1:t(S)&&i(I)?1:0}function d(S,I){return t(S)&&i(I)?-1:i(S)&&t(I)?1:0}function a(S,I,k=!1){return k||(S=S&&S.toLowerCase(),I=I&&I.toLowerCase()),S===I?0:S<I?-1:1}function w(S,I,k=!1){const b=S.split(h.sep),v=I.split(h.sep),N=b.length-1,O=v.length-1;let F,j;for(let B=0;;B++){if(F=N===B,j=O===B,F&&j)return T(b[B],v[B],k);if(F)return-1;if(j)return 1;const M=a(b[B],v[B],k);if(M!==0)return M}}function y(S,I,k){const b=S.toLowerCase(),v=I.toLowerCase(),N=D(S,I,k);if(N)return N;const O=b.endsWith(k),F=v.endsWith(k);if(O!==F)return O?-1:1;const j=T(b,v);return j!==0?j:b.localeCompare(v)}function D(S,I,k){const b=S.toLowerCase(),v=I.toLowerCase(),N=b.startsWith(k),O=v.startsWith(k);if(N!==O)return N?-1:1;if(N&&O){if(b.length<v.length)return-1;if(b.length>v.length)return 1}return 0}}),define(Ee[33],Se([1,0,27,16,11,13,18]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=T,e.$vg=$,e.$wg=l,e.$xg=C,e.$yg=E,e.$zg=c,e.$Ag=g,e.$Bg=f,e.$Cg=m,e.$Dg=n,e.$Eg=o,e.$Fg=i,e.$Gg=t,e.$Hg=s,e.$Ig=d,e.$Jg=a,e.$Kg=D;function T(S){return S===r.CharCode.Slash||S===r.CharCode.Backslash}function $(S){return S.replace(/[\\/]/g,h.$hc.sep)}function l(S){return S.indexOf("/")===-1&&(S=$(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}function C(S,I=h.$hc.sep){if(!S)return"";const k=S.length,b=S.charCodeAt(0);if(T(b)){if(T(S.charCodeAt(1))&&!T(S.charCodeAt(2))){let N=3;const O=N;for(;N<k&&!T(S.charCodeAt(N));N++);if(O!==N&&!T(S.charCodeAt(N+1))){for(N+=1;N<k;N++)if(T(S.charCodeAt(N)))return S.slice(0,N+1).replace(/[\\/]/g,I)}}return I}else if(m(b)&&S.charCodeAt(1)===r.CharCode.Colon)return T(S.charCodeAt(2))?S.slice(0,2)+I:S.slice(0,2);let v=S.indexOf("://");if(v!==-1){for(v+=3;v<k;v++)if(T(S.charCodeAt(v)))return S.slice(0,v+1)}return""}function E(S){if(!A.$i||!S||S.length<5)return!1;let I=S.charCodeAt(0);if(I!==r.CharCode.Backslash||(I=S.charCodeAt(1),I!==r.CharCode.Backslash))return!1;let k=2;const b=k;for(;k<S.length&&(I=S.charCodeAt(k),I!==r.CharCode.Backslash);k++);return!(b===k||(I=S.charCodeAt(k+1),isNaN(I)||I===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,P=/[/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(S,I=A.$i){const k=I?u:P;return!(!S||S.length===0||/^\s+$/.test(S)||(k.lastIndex=0,k.test(S))||I&&p.test(S)||S==="."||S===".."||I&&S[S.length-1]==="."||I&&S.length!==S.trim().length||S.length>255)}function g(S,I,k){const b=S===I;return!k||b?b:!S||!I?!1:(0,R.$Df)(S,I)}function f(S,I,k,b=h.sep){if(S===I)return!0;if(!S||!I||I.length>S.length)return!1;if(k){if(!(0,R.$Ef)(S,I))return!1;if(I.length===S.length)return!0;let N=I.length;return I.charAt(I.length-1)===b&&N--,S.charAt(N)===b}return I.charAt(I.length-1)!==b&&(I+=b),S.indexOf(I)===0}function m(S){return S>=r.CharCode.A&&S<=r.CharCode.Z||S>=r.CharCode.a&&S<=r.CharCode.z}function n(S,I){return A.$i&&S.endsWith(":")&&(S+=h.sep),(0,h.$jc)(S)||(S=(0,h.$kc)(I,S)),S=(0,h.$ic)(S),o(S)}function o(S){return A.$i?(S=(0,R.$lf)(S,h.sep),S.endsWith(":")&&(S+=h.sep)):(S=(0,R.$lf)(S,h.sep),S||(S=h.sep)),S}function i(S){const I=(0,h.$ic)(S);return A.$i?S.length>3?!1:t(I)&&(S.length===2||I.charCodeAt(2)===r.CharCode.Backslash):I===h.$hc.sep}function t(S,I=A.$i){return I?m(S.charCodeAt(0))&&S.charCodeAt(1)===r.CharCode.Colon:!1}function s(S,I=A.$i){return t(S,I)?S[0]:void 0}function d(S,I,k){return I.length>S.length?-1:S===I?0:(k&&(S=S.toLowerCase(),I=I.toLowerCase()),S.indexOf(I))}function a(S){const I=S.split(":");let k,b,v;for(const N of I){const O=Number(N);(0,L.$gg)(O)?b===void 0?b=O:v===void 0&&(v=O):k=k?[k,N].join(":"):N}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:b!==void 0?b:void 0,column:v!==void 0?v:b!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(S,I,k=8){let b="";for(let N=0;N<k;N++){let O;N===0&&A.$i&&!I&&(k===3||k===4)?O=y:O=w,b+=O.charAt(Math.floor(Math.random()*O.length))}let v;return I?v=`${I}-${b}`:v=b,S?(0,h.$kc)(S,v):v}}),define(Ee[141],Se([1,0,27,140,135,60,16,11,13]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=E,e.$Fr=f,e.$Gr=a,e.$Hr=b,e.$Ir=B,e.$Jr=W;const l=0,C=[l,[]];function E(_,re,z,G){if(!_||!re)return C;const J=_.length,ee=re.length;if(J<ee)return C;const ue=_.toLowerCase();return u(re,z,ee,_,ue,J,G)}function u(_,re,z,G,J,ee,ue){const ne=[],De=[];for(let se=0;se<z;se++){const oe=se*ee,te=oe-ee,le=se>0,he=_[se],X=re[se];for(let ae=0;ae<ee;ae++){const pe=ae>0,be=oe+ae,Me=be-1,We=te+ae-1,ke=pe?ne[Me]:0,Ie=le&&pe?ne[We]:0,Te=le&&pe?De[We]:0;let V;!Ie&&le?V=0:V=P(he,X,G,J,ae,Te),V&&Ie+V>=ke&&(ue||le||J.startsWith(re,ae))?(De[be]=Te+1,ne[be]=Ie+V):(De[be]=l,ne[be]=ke)}}const $e=[];let Q=z-1,U=ee-1;for(;Q>=0&&U>=0;){const se=Q*ee+U;De[se]===l||($e.push(U),Q--),U--}return[ne[z*ee-1],$e.reverse()]}function P(_,re,z,G,J,ee){let ue=0;if(!p(re,G[J]))return ue;if(ue+=1,ee>0&&(ue+=ee*5),_===z[J]&&(ue+=1),J===0)ue+=8;else{const ne=c(z.charCodeAt(J-1));ne?ue+=ne:(0,A.$Hk)(z.charCodeAt(J))&&ee===0&&(ue+=2)}return ue}function p(_,re){return _===re?!0:_==="/"||_==="\\"?re==="/"||re==="\\":!1}function c(_){switch(_){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const g=[void 0,[]];function f(_,re,z=0,G=0){const J=re;return J.values&&J.values.length>1?m(_,J.values,z,G):n(_,re,z,G)}function m(_,re,z,G){let J=0;const ee=[];for(const ue of re){const[ne,De]=n(_,ue,z,G);if(typeof ne!="number")return g;J+=ne,ee.push(...De)}return[J,I(ee)]}function n(_,re,z,G){const J=(0,A.$Qk)(re.original,re.originalLowercase,z,_,_.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return J?[J[0],(0,A.$Nk)(J)]:g}const o=Object.freeze({score:0}),i=1<<18,t=1<<17,s=65536;function d(_,re,z,G){const J=G.values?G.values:[G];return(0,R.$qj)({[G.normalized]:{values:J.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:_,description:re,allowNonContiguousMatches:z}})}function a(_,re,z,G,J){if(!_||!re.normalized)return o;const ee=G.getItemLabel(_);if(!ee)return o;const ue=G.getItemDescription(_),ne=d(ee,ue,z,re),De=J[ne];if(De)return De;const $e=w(ee,ue,G.getItemPath(_),re,z);return J[ne]=$e,$e}function w(_,re,z,G,J){const ee=!z||!G.containsPathSeparator;return z&&(T.$k?G.pathNormalized===z:(0,$.$Df)(G.pathNormalized,z))?{score:i,labelMatch:[{start:0,end:_.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?y(_,re,z,G.values,ee,J):D(_,re,z,G,ee,J)}function y(_,re,z,G,J,ee){let ue=0;const ne=[],De=[];for(const $e of G){const{score:Q,labelMatch:U,descriptionMatch:se}=D(_,re,z,$e,J,ee);if(Q===l)return o;ue+=Q,U&&ne.push(...U),se&&De.push(...se)}return{score:ue,labelMatch:I(ne),descriptionMatch:I(De)}}function D(_,re,z,G,J,ee){if(J||!re){const[ue,ne]=E(_,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(ue){const De=(0,A.$Ek)(G.normalized,_);let $e;if(De){$e=t;const Q=Math.round(G.normalized.length/_.length*100);$e+=Q}else $e=s;return{score:$e+ue,labelMatch:De||S(ne)}}}if(re){let ue=re;z&&(ue=`${re}${L.sep}`);const ne=ue.length,De=`${ue}${_}`,[$e,Q]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const U=S(Q),se=[],oe=[];return U.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),oe.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):oe.push(te)}),{score:$e,labelMatch:se,descriptionMatch:oe}}}return o}function S(_){const re=[];if(!_)return re;let z;for(const G of _)z&&z.end===G?z.end+=1:(z={start:G,end:G+1},re.push(z));return re}function I(_){const re=_.sort((J,ee)=>J.start-ee.start),z=[];let G;for(const J of re)!G||!k(G,J)?(G=J,z.push(J)):(G.start=Math.min(G.start,J.start),G.end=Math.max(G.end,J.end));return z}function k(_,re){return!(_.end<re.start||re.end<_.start)}function b(_,re,z,G,J,ee){const ue=a(_,z,G,J,ee),ne=a(re,z,G,J,ee),De=ue.score,$e=ne.score;if((De===i||$e===i)&&De!==$e)return De===i?-1:1;if(De>s||$e>s){if(De!==$e)return De>$e?-1:1;if(De<t&&$e<t){const he=N(ue.labelMatch,ne.labelMatch);if(he!==0)return he}const te=J.getItemLabel(_)||"",le=J.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const Q=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(Q&&!U)return-1;if(U&&!Q)return 1;const se=v(_,ue,J),oe=v(re,ne,J);return se&&oe&&se!==oe?oe>se?-1:1:O(_,re,z,J)}function v(_,re,z){let G=-1,J=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(J=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=z.getItemDescription(_);ee&&(J+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(J=re.descriptionMatch[re.descriptionMatch.length-1].end);return J-G}function N(_,re){if(!_&&!re||(!_||!_.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!_||!_.length)return 1;const z=_[0].start,J=_[_.length-1].end-z,ee=re[0].start,ne=re[re.length-1].end-ee;return J===ne?0:ne<J?1:-1}function O(_,re,z,G){const J=G.getItemLabel(_)||"",ee=G.getItemLabel(re)||"",ue=G.getItemDescription(_),ne=G.getItemDescription(re),De=J.length+(ue?ue.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const Q=G.getItemPath(_),U=G.getItemPath(re);return Q&&U&&Q.length!==U.length?Q.length-U.length:J!==ee?(0,h.$Cr)(J,ee,z.normalized):ue&&ne&&ue!==ne?(0,h.$Cr)(ue,ne,z.normalized):Q&&U&&Q!==U?(0,h.$Cr)(Q,U,z.normalized):0}function F(_){return _.startsWith('"')&&_.endsWith('"')}const j=" ";function B(_){typeof _!="string"&&(_="");const re=_.toLowerCase(),{pathNormalized:z,normalized:G,normalizedLowercase:J}=M(_),ee=z.indexOf(L.sep)>=0,ue=F(_);let ne;const De=_.split(j);if(De.length>1)for(const $e of De){const Q=F($e),{pathNormalized:U,normalized:se,normalizedLowercase:oe}=M($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:U,normalized:se,normalizedLowercase:oe,expectContiguousMatch:Q}))}return{original:_,originalLowercase:re,pathNormalized:z,normalized:G,normalizedLowercase:J,values:ne,containsPathSeparator:ee,expectContiguousMatch:ue}}function M(_){let re;T.$i?re=_.replace(/\//g,L.sep):re=_.replace(/\\/g,L.sep);const z=(0,$.$nf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:z,normalizedLowercase:z.toLowerCase()}}function W(_){return Array.isArray(_)?B(_.map(re=>re.original).join(j)):B(_.original)}}),define(Ee[108],Se([1,0,16]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$3s=R,e.$4s=L,e.$5s=T,e.$6s=l,e.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(C){const E=(0,r.$pc)(C),u=h[E.toLowerCase()];return u!==void 0?u:L(C)}function L(C){const E=(0,r.$pc)(C);return A[E.toLowerCase()]}function T(C){for(const E in A)if(A[E]===C)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function l(C,E){const u=$.exec(C);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:C}}),define(Ee[109],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$hm=R,e.$im=L;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h||(e.Source=h={}));var A;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(T,...$){const l=$.reduce((u,P)=>(u[P]=!0,u),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(u=>!l[u]).forEach(u=>{for(let P=0;P<C.length;P++)if(u.search(C[P])!==-1){delete T[u];break}})}function L(T){T&&(delete T.DEBUG,r.$j&&delete T.DYLD_LIBRARY_PATH,r.$k&&delete T.LD_PRELOAD)}}),define(Ee[2],Se([1,0,27,41,16,11]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=g,e.$xc=t,A=Ue(A);const L=/^\w[\w\d+.-]*$/,T=/^\//,$=/^\/\//;function l(y,D){if(!y.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!L.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!T.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(y,D){return!y&&!D?"file":y}function E(y,D){switch(y){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const u="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(D){return D instanceof c?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,S,I,k,b,v=!1){typeof D=="object"?(this.scheme=D.scheme||u,this.authority=D.authority||u,this.path=D.path||u,this.query=D.query||u,this.fragment=D.fragment||u):(this.scheme=C(D,v),this.authority=S||u,this.path=E(this.scheme,I||u),this.query=k||u,this.fragment=b||u,l(this,v))}get fsPath(){return t(this,!1)}with(D){if(!D)return this;let{scheme:S,authority:I,path:k,query:b,fragment:v}=D;return S===void 0?S=this.scheme:S===null&&(S=u),I===void 0?I=this.authority:I===null&&(I=u),k===void 0?k=this.path:k===null&&(k=u),b===void 0?b=this.query:b===null&&(b=u),v===void 0?v=this.fragment:v===null&&(v=u),S===this.scheme&&I===this.authority&&k===this.path&&b===this.query&&v===this.fragment?this:new m(S,I,k,b,v)}static parse(D,S=!1){const I=p.exec(D);return I?new m(I[2]||u,w(I[4]||u),w(I[5]||u),w(I[7]||u),w(I[9]||u),S):new m(u,u,u,u,u)}static file(D){let S=u;if(R.$i&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const I=D.indexOf(P,2);I===-1?(S=D.substring(2),D=P):(S=D.substring(2,I),D=D.substring(I)||P)}return new m("file",S,D,u,u)}static from(D,S){return new m(D.scheme,D.authority,D.path,D.query,D.fragment,S)}static joinPath(D,...S){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return R.$i&&D.scheme==="file"?I=c.file(A.$gc.join(t(D,!0),...S)).path:I=A.$hc.join(D.path,...S),D.with({path:I})}toString(D=!1){return s(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof c)return D;{const S=new m(D);return S._formatted=D.external??null,S._fsPath=D._sep===f?D.fsPath??null:null,S}}else return D}}e.URI=c;function g(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const f=R.$i?1:void 0;class m extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(D=!1){return D?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const D={$mid:h.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=f),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(y,D,S){let I,k=-1;for(let b=0;b<y.length;b++){const v=y.charCodeAt(b);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||D&&v===r.CharCode.Slash||S&&v===r.CharCode.OpenSquareBracket||S&&v===r.CharCode.CloseSquareBracket||S&&v===r.CharCode.Colon)k!==-1&&(I+=encodeURIComponent(y.substring(k,b)),k=-1),I!==void 0&&(I+=y.charAt(b));else{I===void 0&&(I=y.substr(0,b));const N=n[v];N!==void 0?(k!==-1&&(I+=encodeURIComponent(y.substring(k,b)),k=-1),I+=N):k===-1&&(k=b)}}return k!==-1&&(I+=encodeURIComponent(y.substring(k))),I!==void 0?I:y}function i(y){let D;for(let S=0;S<y.length;S++){const I=y.charCodeAt(S);I===r.CharCode.Hash||I===r.CharCode.QuestionMark?(D===void 0&&(D=y.substr(0,S)),D+=n[I]):D!==void 0&&(D+=y[S])}return D!==void 0?D:y}function t(y,D){let S;return y.authority&&y.path.length>1&&y.scheme==="file"?S=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===r.CharCode.Slash&&(y.path.charCodeAt(1)>=r.CharCode.A&&y.path.charCodeAt(1)<=r.CharCode.Z||y.path.charCodeAt(1)>=r.CharCode.a&&y.path.charCodeAt(1)<=r.CharCode.z)&&y.path.charCodeAt(2)===r.CharCode.Colon?D?S=y.path.substr(1):S=y.path[1].toLowerCase()+y.path.substr(2):S=y.path,R.$i&&(S=S.replace(/\//g,"\\")),S}function s(y,D){const S=D?i:o;let I="",{scheme:k,authority:b,path:v,query:N,fragment:O}=y;if(k&&(I+=k,I+=":"),(b||k==="file")&&(I+=P,I+=P),b){let F=b.indexOf("@");if(F!==-1){const j=b.substr(0,F);b=b.substr(F+1),F=j.lastIndexOf(":"),F===-1?I+=S(j,!1,!1):(I+=S(j.substr(0,F),!1,!1),I+=":",I+=S(j.substr(F+1),!1,!0)),I+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?I+=S(b,!1,!0):(I+=S(b.substr(0,F),!1,!0),I+=b.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const F=v.charCodeAt(1);F>=r.CharCode.A&&F<=r.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const F=v.charCodeAt(0);F>=r.CharCode.A&&F<=r.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}I+=S(v,!0,!1)}return N&&(I+="?",I+=S(N,!1,!1)),O&&(I+="#",I+=D?O:o(O,!1,!1)),I}function d(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+d(y.substr(3)):y}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(y){return y.match(a)?y.replace(a,D=>d(D)):y}}),define(Ee[206],Se([1,0,2]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=h,e.$8q=A,e.$9q=R,e.log=T;function h(l){const C=l;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function A(l){const C=[];let E;try{const u=JSON.parse(l.arguments),P=u[u.length-1];P&&P.__$stack&&(u.pop(),E=P.__$stack),C.push(...u)}catch{C.push("Unable to log remote console arguments",l.arguments)}return{args:C,stack:E}}function R(l){if(typeof l!="string")return R(A(l).stack);const C=l;if(C){const E=L(C),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(l){if(!l)return l;const C=l.indexOf(`
`);return C===-1?l:l.substring(0,C)}function T(l,C){const{args:E,stack:u}=A(l),P=typeof E[0]=="string"&&E.length===1;let p=L(u);p&&(p=`(${p.trim()})`);let c=[];if(typeof E[0]=="string"?p&&P?c=[`%c[${C}] %c${E[0]} %c${p}`,$("blue"),$(""),$("grey")]:c=[`%c[${C}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:c=[`%c[${C}]%`,$("blue"),...E],p&&!P&&c.push(p),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,c)}function $(l){return`color: ${l}`}}),define(Ee[57],Se([1,0,22,2,41]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=L,e.$_h=$;function R(l){return JSON.stringify(l,T)}function L(l){let C=JSON.parse(l);return C=$(C),C}function T(l,C){return C instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function $(l,C=0){if(!l||C>200)return l;if(typeof l=="object"){switch(l.$mid){case A.MarshalledId.Uri:return h.URI.revive(l);case A.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case A.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.$Le||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let E=0;E<l.length;++E)l[E]=$(l[E],C+1);else for(const E in l)Object.hasOwnProperty.call(l,E)&&(l[E]=$(l[E],C+1))}return l}}),define(Ee[15],Se([1,0,14,11,13,2,16]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=$,e.$Mg=l,e.$Qg=E,r=Ue(r),h=Ue(h),L=Ue(L);var T;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",p.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.commentsInput="comment",p.codeSetting="code-setting"})(T||(e.Schemas=T={}));function $(p,c){return R.URI.isUri(p)?(0,A.$Df)(p.scheme,c):(0,A.$Ef)(p,c+":")}function l(p,...c){return c.some(g=>$(p,g))}e.$Ng="vscode-tkn",e.$Og="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=E(c,g)}getServerRootPath(){return this.f}get g(){return L.$hc.join(this.f,T.vscodeRemoteResource)}set(c,g,f){this.a[c]=g,this.b[c]=f}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(i){return r.$2(i),c}const g=c.authority;let f=this.a[g];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const m=this.b[g],n=this.c[g];let o=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(o+=`&${e.$Og}=${encodeURIComponent(n)}`),R.URI.from({scheme:h.$o?this.d:T.vscodeRemoteResource,authority:`${f}:${m}`,path:this.g,query:o})}}e.$Pg=new C;function E(p,c){return L.$hc.join(c??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(c){const g=this.b(c,ce);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===T.vscodeRemote?e.$Pg.rewrite(c):c.scheme===T.file&&(h.$m||h.$q===`${T.vscodeFileResource}://${u.a}`)?c.with({scheme:T.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ce);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===T.vscodeFileResource?c.with({scheme:T.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return R.URI.isUri(c)?c:R.URI.parse(g.toUrl(c))}}e.$Wg=new u;var P;(function(p){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function f(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const i=o?.get(g);if(i)return c.get(i)}p.getHeadersFromQuery=f;function m(n,o,i){if(!globalThis.crossOriginIsolated)return;const t=o&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(g,t):n[g]=t}p.addSearchParam=m})(P||(e.COI=P={}))}),define(Ee[207],Se([1,0,173,15,11,2]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=C,A=Ue(A);class L{constructor(u,P,p){this.id=u,this.dependencies=P,this.callback=p}}class T{static{this.INSTANCE=new T}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,P,p)=>{typeof u!="string"&&(p=P,P=u,u=null),(typeof P!="object"||!Array.isArray(P))&&(p=P,P=null),this.c.push(new L(u,P,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const P=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!P)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(u){return new Promise((P,p)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",f),c.removeEventListener("error",m)},f=n=>{g(),P(this.c.pop())},m=n=>{g(),p(n)};c.addEventListener("load",f),c.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),c.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(u){return new Promise((P,p)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),P(this.c.pop())}catch(c){p(c)}})}async j(u){try{const P=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(u).fsPath,f=P.readFileSync(g).toString(),m=c.wrap(f.replace(/^#!.*/,""));return new p.Script(m).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}const $=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function C(E,u,P){if(r.$U){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[E]&&(E=l[E]);const p=`${E}/${u}`;if($.has(p))return $.get(p);let c;if(/^\w[\w\d+.-]*:\/\//.test(p))c=p;else{const n=`${P&&!A.$o?h.$Tg:h.$Sg}/${p}`;c=h.$Wg.asBrowserUri(n).toString(!0)}const g=T.INSTANCE.load(c);return $.set(p,g),g}else return await new Promise((p,c)=>{ce([E],p,c)}).then(Ue)}}),define(Ee[23],Se([1,0,27,33,15,16,11,13,2]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=l,e.$mh=E,e.$nh=P,h=Ue(h),R=Ue(R);function l(p){return(0,$.$xc)(p,!0)}class C{constructor(c){this.a=c}compare(c,g,f=!1){return c===g?0:(0,T.$wf)(this.getComparisonKey(c,f),this.getComparisonKey(g,f))}isEqual(c,g,f=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,f)===this.getComparisonKey(g,f)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,f=!1){if(c.scheme===g.scheme){if(c.scheme===A.Schemas.file)return h.$Bg(l(c),l(g),this.a(c))&&c.query===g.query&&(f||c.fragment===g.fragment);if((0,e.$ih)(c.authority,g.authority))return h.$Bg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(f||c.fragment===g.fragment)}return!1}joinPath(c,...g){return $.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$ah)(c)||c.authority}basename(c){return R.$hc.basename(c.path)}extname(c){return R.$hc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$nc(l(c))).path:(g=R.$hc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$ic(l(c))).path:g=R.$hc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$ih)(c.authority,g.authority))return;if(c.scheme===A.Schemas.file){const n=R.$mc(l(c),l(g));return L.$i?h.$vg(n):n}let f=c.path||"/";const m=g.path||"/";if(this.a(c)){let n=0;for(const o=Math.min(f.length,m.length);n<o&&!(f.charCodeAt(n)!==m.charCodeAt(n)&&f.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);f=m.substr(0,n)+f.substr(n)}return R.$hc.relative(f,m)}resolvePath(c,g){if(c.scheme===A.Schemas.file){const f=$.URI.file(R.$lc(l(c),g));return c.with({authority:f.authority,path:f.path})}return g=h.$wg(g),c.with({path:R.$hc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,T.$Df)(c,g)}hasTrailingPathSeparator(c,g=R.sep){if(c.scheme===A.Schemas.file){const f=l(c);return f.length>h.$xg(f).length&&f[f.length-1]===g}else{const f=c.path;return f.length>1&&f.charCodeAt(f.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=R.sep){return(0,e.$jh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=R.sep){let f=!1;if(c.scheme===A.Schemas.file){const m=l(c);f=m!==void 0&&m.length===h.$xg(m).length&&m[m.length-1]===g}else{g="/";const m=c.path;f=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!f&&!(0,e.$jh)(c,g)?c.with({path:c.path+"/"}):c}}e.$5g=C,e.$6g=new C(()=>!1),e.$7g=new C(p=>p.scheme===A.Schemas.file?!L.$k:!0),e.$8g=new C(p=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function E(p,c){const g=[];for(let f=0;f<p.length;f++){const m=c(p[f]);p.some((n,o)=>o===f?!1:(0,e.$0g)(m,c(n)))||g.push(p[f])}return g}var u;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function c(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[i,t]=o.split(":");i&&t&&f.set(i,t)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&f.set(p.META_DATA_MIME,n),f}p.parseMetaData=c})(u||(e.DataUri=u={}));function P(p,c,g){if(c){let f=p.path;return f&&f[0]!==R.$hc.sep&&(f=R.$hc.sep+f),p.with({scheme:g,authority:c,path:f})}return p.with({scheme:g})}}),define(Ee[9],Se([1,0,21,14,4,3,23,11,184,49]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=C,e.$ph=E,e.$qh=u,e.$rh=P,e.$sh=p,e.$th=c,e.$uh=g,e.$vh=f,e.$Dh=y,e.$Eh=D,e.$Fh=S,e.$Gh=I,e.$Hh=k,e.$Wh=G,e.$5h=te;function C(he){return!!he&&typeof he.then=="function"}function E(he){const X=new r.$ue,ae=he(X.token),pe=new Promise((be,Me)=>{const We=X.token.onCancellationRequested(()=>{We.dispose(),Me(new h.$6)});Promise.resolve(ae).then(ke=>{We.dispose(),X.dispose(),be(ke)},ke=>{We.dispose(),X.dispose(),Me(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(be,Me){return pe.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return pe.finally(be)}}}function u(he,X,ae){return new Promise((pe,be)=>{const Me=X.onCancellationRequested(()=>{Me.dispose(),pe(ae)});he.then(pe,be).finally(()=>Me.dispose())})}function P(he,X){return new Promise((ae,pe)=>{const be=X.onCancellationRequested(()=>{be.dispose(),pe(new h.$6)});he.then(ae,pe).finally(()=>be.dispose())})}async function p(he){let X=-1;const ae=he.map((pe,be)=>pe.then(Me=>(X=be,Me)));try{return await Promise.race(ae)}finally{he.forEach((pe,be)=>{be!==X&&pe.cancel()})}}function c(he,X,ae){let pe;const be=setTimeout(()=>{pe?.(void 0),ae?.()},X);return Promise.race([he.finally(()=>clearTimeout(be)),new Promise(Me=>pe=Me)])}function g(he){return new Promise((X,ae)=>{const pe=he();C(pe)?pe.then(X,ae):X(pe)})}function f(){let he,X;return{promise:new Promise((pe,be)=>{he=pe,X=be}),resolve:he,reject:X}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ae=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(ae,ae).then(pe)})}return new Promise((ae,pe)=>{this.b.then(ae,pe)})}return this.a=X(),new Promise((ae,pe)=>{this.a.then(be=>{this.a=null,ae(be)},be=>{this.a=null,pe(be)})})}dispose(){this.f=!0}}e.$wh=m;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$xh=n;class o{constructor(){this.a=new Map}queue(X,ae){const be=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(X)===be&&this.a.delete(X)});return this.a.set(X,be),be}}e.$yh=o;const i=(he,X)=>{let ae=!0;const pe=setTimeout(()=>{ae=!1,X()},he);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(pe),ae=!1}}},t=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class s{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ae=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((be,Me)=>{this.d=be,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=ae===$.$ee?t(pe):i(ae,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=s;class d{constructor(X){this.a=new s(X),this.b=new m}trigger(X,ae){return this.a.trigger(()=>this.b.queue(X),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=d;class a{constructor(){this.a=!1,this.b=new Promise((X,ae)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=a;class w extends a{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ch=w;function y(he,X){return X?new Promise((ae,pe)=>{const be=setTimeout(()=>{Me.dispose(),ae()},he),Me=X.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),pe(new h.$6)})}):E(ae=>y(he,ae))}function D(he,X=0,ae){const pe=setTimeout(()=>{he(),ae&&be.dispose()},X),be=(0,R.$Tc)(()=>{clearTimeout(pe),ae?.deleteAndLeak(be)});return ae?.add(be),be}function S(he){const X=[];let ae=0;const pe=he.length;function be(){return ae<pe?he[ae++]():null}function Me(We){We!=null&&X.push(We);const ke=be();return ke?ke.then(Me):Promise.resolve(X)}return Promise.resolve(null).then(Me)}function I(he,X=pe=>!!pe,ae=null){let pe=0;const be=he.length,Me=()=>{if(pe>=be)return Promise.resolve(ae);const We=he[pe++];return Promise.resolve(We()).then(Ie=>X(Ie)?Promise.resolve(Ie):Me())};return Me()}function k(he,X=pe=>!!pe,ae=null){if(he.length===0)return Promise.resolve(ae);let pe=he.length;const be=()=>{pe=-1;for(const Me of he)Me.cancel?.()};return new Promise((Me,We)=>{for(const ke of he)ke.then(Ie=>{--pe>=0&&X(Ie)?(be(),Me(Ie)):pe===0&&Me(ae)}).catch(Ie=>{--pe>=0&&(be(),We(Ie))})})}class b{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new A.$je}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,pe)=>{this.g.push({factory:X,c:ae,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ae=X.factory();ae.then(X.c,X.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=b;class v extends b{constructor(){super(1)}}e.$Jh=v;class N{constructor(){this.a=new J,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Kh=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ae=L.$6g){const pe=ae.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,ae,pe=L.$6g){const be=pe.getComparisonKey(X);let Me=this.a.get(be);if(!Me){Me=new v;const We=this.f++,ke=A.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(We),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(We,ke),this.a.set(be,Me)}return Me.queue(ae)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=O;class F{constructor(X,ae){this.b=!1,this.a=-1,typeof X=="function"&&typeof ae=="number"&&this.setIfNotSet(X,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ae){if(this.b)throw new h.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ae)}setIfNotSet(X,ae){if(this.b)throw new h.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ae))}}e.$Mh=F;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ae,pe=globalThis){if(this.f)throw new h.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=pe.setInterval(()=>{X()},ae);this.d=(0,R.$Tc)(()=>{pe.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class B{constructor(X,ae){this.b=-1,this.a=X,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=B;class M{constructor(X,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=X,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=M;class W extends B{constructor(X,ae){super(X,ae),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Qh=W;class _ extends R.$Vc{constructor(X,ae){super(),this.g=X,this.h=ae,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of X)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(he,X)=>{(0,T.$B)(()=>{if(ae)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Th=(he,X,ae)=>{const pe=he.requestIdleCallback(X,typeof ae=="number"?{timeout:ae}:void 0);let be=!1;return{dispose(){be||(be=!0,he.cancelIdleCallback(pe))}}},e.$Sh=he=>(0,e.$Th)(globalThis,he)}();class re{constructor(X,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Th)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=re;class z extends re{constructor(X){super(globalThis,X)}}e.$Vh=z;async function G(he,X,ae){let pe;for(let be=0;be<ae;be++)try{return await he()}catch(Me){pe=Me,await y(X)}throw pe}class J{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ae,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:ae},ae.then(()=>this.d(X),()=>this.d(X)),ae}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ae,resolve:pe,reject:be}=f();this.b={run:X,promise:ae,promiseResolve:pe,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=J;class ee{constructor(X,ae=()=>Date.now()){this.d=X,this.f=ae,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Yh=ee;var ue;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,ae)=>{this.a=X,this.b=ae})}complete(X){return new Promise(ae=>{this.a(X),this.d={outcome:ue.Resolved,value:X},ae()})}error(X){return new Promise(ae=>{this.b(X),this.d={outcome:ue.Rejected,value:X},ae()})}cancel(){return this.error(new h.$6)}}e.$Zh=ne;var De;(function(he){async function X(pe){let be;const Me=await Promise.all(pe.map(We=>We.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Me}he.settled=X;function ae(pe){return new Promise(async(be,Me)=>{try{await pe(be,Me)}catch(We){Me(We)}})}he.withAsyncBody=ae})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new h.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=$e;class Q{constructor(X){this.b=X,this.a=new l.$W(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=Q;var U;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(U||(U={}));class se{static fromArray(X){return new se(ae=>{ae.emitMany(X)})}static fromPromise(X){return new se(async ae=>{ae.emitMany(await X)})}static fromPromises(X){return new se(async ae=>{await Promise.all(X.map(async pe=>ae.emitOne(await pe)))})}static merge(X){return new se(async ae=>{await Promise.all(X.map(async pe=>{for await(const be of pe)ae.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(X,ae){this.a=U.Initial,this.b=[],this.d=null,this.f=ae,this.g=new A.$je,queueMicrotask(async()=>{const pe={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(X(pe)),this.k()}catch(be){this.l(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===U.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===U.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,ae){return new se(async pe=>{for await(const be of X)pe.emitOne(ae(be))})}map(X){return se.map(this,X)}static filter(X,ae){return new se(async pe=>{for await(const be of X)ae(be)&&pe.emitOne(be)})}filter(X){return se.filter(this,X)}static coalesce(X){return se.filter(X,ae=>!!ae)}coalesce(){return se.coalesce(this)}static async toPromise(X){const ae=[];for await(const pe of X)ae.push(pe);return ae}toPromise(){return se.toPromise(this)}h(X){this.a===U.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===U.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===U.Initial&&(this.a=U.DoneOK,this.g.fire())}l(X){this.a===U.Initial&&(this.a=U.DoneError,this.d=X,this.g.fire())}}e.$3h=se;class oe extends se{constructor(X,ae){super(ae),this.m=X}cancel(){this.m.cancel()}}e.$4h=oe;function te(he){const X=new r.$ue,ae=he(X.token);return new oe(X,async pe=>{const be=X.token.onCancellationRequested(()=>{be.dispose(),X.dispose(),pe.reject(new h.$6)});try{for await(const Me of ae){if(X.token.isCancellationRequested)return;pe.emitOne(Me)}be.dispose(),X.dispose()}catch(Me){be.dispose(),X.dispose(),pe.reject(Me)}})}class le{constructor(X){this.a=new ne,this.b=new se(be=>{if(ae){be.reject(ae);return}return pe&&be.emitMany(pe),this.d=Me=>be.reject(Me),this.f=Me=>be.emitOne(Me),this.a.p},X);let ae,pe;this.f=be=>{pe||(pe=[]),pe.push(be)},this.d=be=>{ae||(ae=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$6h=le}),define(Ee[39],Se([1,0,19,9,27,33,29,16,11,13]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=C,e.$uk=c,e.$vk=N,e.$wk=O,e.$xk=F,e.$yk=j,e.$zk=B,e.$Ak=re;function C(){return Object.create(null)}e.$sk="**",e.$tk="/";const E="[/\\\\]",u="[^/\\\\]",P=/\//g;function p(z,G){switch(z){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${G?`|${E}${u}+`:""})*?`}}function c(z,G){if(!z)return[];const J=[];let ee=!1,ue=!1,ne="";for(const De of z){switch(De){case G:if(!ee&&!ue){J.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=De}return ne&&J.push(ne),J}function g(z){if(!z)return"";let G="";const J=c(z,e.$tk);if(J.every(ee=>ee===e.$sk))G=".*";else{let ee=!1;J.forEach((ue,ne)=>{if(ue===e.$sk){if(ee)return;G+=p(2,ne===J.length-1)}else{let De=!1,$e="",Q=!1,U="";for(const se of ue){if(se!=="}"&&De){$e+=se;continue}if(Q&&(se!=="]"||!U)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!U?oe="^":se===e.$tk?oe="":oe=(0,l.$ff)(se),U+=oe;continue}switch(se){case"{":De=!0;continue;case"[":Q=!0;continue;case"}":{const te=`(?:${c($e,",").map(le=>g(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+U+"]",Q=!1,U="";break}case"?":G+=u;continue;case"*":G+=p(1);continue;default:G+=(0,l.$ff)(se)}}ne<J.length-1&&(J[ne+1]!==e.$sk||ne+2<J.length)&&(G+=E)}ee=ue===e.$sk})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.$Ec(1e4),d=function(){return!1},a=function(){return null};function w(z,G){if(!z)return a;let J;typeof z!="string"?J=z.pattern:J=z,J=J.trim();const ee=`${J}_${!!G.trimForExclusions}`;let ue=s.get(ee);if(ue)return y(ue,z);let ne;return f.test(J)?ue=S(J.substr(4),J):(ne=m.exec(D(J,G)))?ue=I(ne[1],J):(G.trimForExclusions?o:n).test(J)?ue=k(J,G):(ne=i.exec(D(J,G)))?ue=b(ne[1].substr(1),J,!0):(ne=t.exec(D(J,G)))?ue=b(ne[1],J,!1):ue=v(J),s.set(ee,ue),y(ue,z)}function y(z,G){if(typeof G=="string")return z;const J=function(ee,ue){return(0,R.$Bg)(ee,G.base,!$.$k)?z((0,l.$kf)(ee.substr(G.base.length),T.sep),ue):null};return J.allBasenames=z.allBasenames,J.allPaths=z.allPaths,J.basenames=z.basenames,J.patterns=z.patterns,J}function D(z,G){return G.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function S(z,G){return function(J,ee){return typeof J=="string"&&J.endsWith(z)?G:null}}function I(z,G){const J=`/${z}`,ee=`\\${z}`,ue=function(De,$e){return typeof De!="string"?null:$e?$e===z?G:null:De===z||De.endsWith(J)||De.endsWith(ee)?G:null},ne=[z];return ue.basenames=ne,ue.patterns=[G],ue.allBasenames=ne,ue}function k(z,G){const J=_(z.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==a),z),ee=J.length;if(!ee)return a;if(ee===1)return J[0];const ue=function($e,Q){for(let U=0,se=J.length;U<se;U++)if(J[U]($e,Q))return z;return null},ne=J.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=J.reduce(($e,Q)=>Q.allPaths?$e.concat(Q.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function b(z,G,J){const ee=T.sep===T.$hc.sep,ue=ee?z:z.replace(P,T.sep),ne=T.sep+ue,De=T.$hc.sep+z;let $e;return J?$e=function(Q,U){return typeof Q=="string"&&(Q===ue||Q.endsWith(ne)||!ee&&(Q===z||Q.endsWith(De)))?G:null}:$e=function(Q,U){return typeof Q=="string"&&(Q===ue||!ee&&Q===z)?G:null},$e.allPaths=[(J?"*/":"./")+z],$e}function v(z){try{const G=new RegExp(`^${g(z)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?z:null}}catch{return a}}function N(z,G,J){return!z||typeof G!="string"?!1:O(z)(G,void 0,J)}function O(z,G={}){if(!z)return d;if(typeof z=="string"||F(z)){const J=w(z,G);if(J===a)return d;const ee=function(ue,ne){return!!J(ue,ne)};return J.allBasenames&&(ee.allBasenames=J.allBasenames),J.allPaths&&(ee.allPaths=J.allPaths),ee}return M(z,G)}function F(z){const G=z;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(z){return z.allBasenames||[]}function B(z){return z.allPaths||[]}function M(z,G){const J=_(Object.getOwnPropertyNames(z).map($e=>W($e,z[$e],G)).filter($e=>$e!==a)),ee=J.length;if(!ee)return a;if(!J.some($e=>!!$e.requiresSiblings)){if(ee===1)return J[0];const $e=function(se,oe){let te;for(let le=0,he=J.length;le<he;le++){const X=J[le](se,oe);if(typeof X=="string")return X;(0,h.$oh)(X)&&(te||(te=[]),te.push(X))}return te?(async()=>{for(const le of te){const he=await le;if(typeof he=="string")return he}return null})():null},Q=J.find(se=>!!se.allBasenames);Q&&($e.allBasenames=Q.allBasenames);const U=J.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return U.length&&($e.allPaths=U),$e}const ue=function($e,Q,U){let se,oe;for(let te=0,le=J.length;te<le;te++){const he=J[te];he.requiresSiblings&&U&&(Q||(Q=(0,T.$oc)($e)),se||(se=Q.substr(0,Q.length-(0,T.$pc)($e).length)));const X=he($e,Q,se,U);if(typeof X=="string")return X;(0,h.$oh)(X)&&(oe||(oe=[]),oe.push(X))}return oe?(async()=>{for(const te of oe){const le=await te;if(typeof le=="string")return le}return null})():null},ne=J.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=J.reduce(($e,Q)=>Q.allPaths?$e.concat(Q.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function W(z,G,J){if(G===!1)return a;const ee=w(z,J);if(ee===a)return a;if(typeof G=="boolean")return ee;if(G){const ue=G.when;if(typeof ue=="string"){const ne=(De,$e,Q,U)=>{if(!U||!ee(De,$e))return null;const se=ue.replace("$(basename)",()=>Q),oe=U(se);return(0,h.$oh)(oe)?oe.then(te=>te?z:null):oe?z:null};return ne.requiresSiblings=!0,ne}}return ee}function _(z,G){const J=z.filter($e=>!!$e.basenames);if(J.length<2)return z;const ee=J.reduce(($e,Q)=>{const U=Q.basenames;return U?$e.concat(U):$e},[]);let ue;if(G){ue=[];for(let $e=0,Q=ee.length;$e<Q;$e++)ue.push(G)}else ue=J.reduce(($e,Q)=>{const U=Q.patterns;return U?$e.concat(U):$e},[]);const ne=function($e,Q){if(typeof $e!="string")return null;if(!Q){let se;for(se=$e.length;se>0;se--){const oe=$e.charCodeAt(se-1);if(oe===A.CharCode.Slash||oe===A.CharCode.Backslash)break}Q=$e.substr(se)}const U=ee.indexOf(Q);return U!==-1?ue[U]:null};ne.basenames=ee,ne.patterns=ue,ne.allBasenames=ee;const De=z.filter($e=>!$e.basenames);return De.push(ne),De}function re(z,G){return(0,r.$vb)(z,G,(J,ee)=>typeof J=="string"&&typeof ee=="string"?J===ee:typeof J!="string"&&typeof ee!="string"?J.base===ee.base&&J.pattern===ee.pattern:!1)}}),define(Ee[86],Se([1,0,14,136,23,13,2]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=l,e.$2k=C,e.$3k=E,e.$4k=u,e.$5k=P,e.$6k=p,e.$7k=c,e.$8k=g;var T;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class ${constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.$8)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=T.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Tk)(m):m).replace(/([ \t]+)/g,(o,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===T.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${P(n,m)}
`,this}appendLink(m,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,n){const o=new RegExp((0,R.$ff)(n),"g");return m.replace(o,(i,t)=>m.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$Zk=$;function l(f){return C(f)?!f.value:Array.isArray(f)?f.every(l):!0}function C(f){return f instanceof $?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function E(f,m){return f===m?!0:!f||!m?!1:f.value===m.value&&f.isTrusted===m.isTrusted&&f.supportThemeIcons===m.supportThemeIcons&&f.supportHtml===m.supportHtml&&(f.baseUri===m.baseUri||!!f.baseUri&&!!m.baseUri&&(0,A.$9g)(L.URI.from(f.baseUri),L.URI.from(m.baseUri)))}function u(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(f,m){const n=f.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${m}`,f,`${"`".repeat(o)}`].join(`
`)}function p(f){return f.replace(/"/g,"&quot;")}function c(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(f){const m=[],n=f.split("|").map(i=>i.trim());f=n[0];const o=n[1];if(o){const i=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),s=i?i[1]:"",d=t?t[1]:"",a=isFinite(parseInt(d)),w=isFinite(parseInt(s));a&&m.push(`width="${d}"`),w&&m.push(`height="${s}"`)}return{href:f,dimensions:m}}}),define(Ee[110],Se([1,0,19,33,16,11,23,13]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=$,e.$Qw=C,e.$Rw=u,e.$Sw=P,e.$Tw=f,e.$Uw=n,e.$Vw=o,e.$Ww=i,e.$Xw=t,e.$Yw=s;function $(a,w){const{os:y,tildify:D,relative:S}=w;if(S){const b=l(a,S,y);if(typeof b=="string")return b}let I=a.fsPath;if(y===R.OperatingSystem.Windows&&!R.$i?I=I.replace(/\//g,"\\"):y!==R.OperatingSystem.Windows&&R.$i&&(I=I.replace(/\\/g,"/")),y!==R.OperatingSystem.Windows&&D?.userHome){const b=D.userHome.fsPath;let v;a.scheme!==D.userHome.scheme&&a.path[0]===A.$hc.sep&&a.path[1]!==A.$hc.sep?v=D.userHome.with({path:a.path}).fsPath:v=I,I=u(v,b,y)}return(y===R.OperatingSystem.Windows?A.$gc:A.$hc).normalize(C(I,y===R.OperatingSystem.Windows))}function l(a,w,y){const D=y===R.OperatingSystem.Windows?A.$gc:A.$hc,S=y===R.OperatingSystem.Linux?L.$6g:L.$8g,I=w.getWorkspace(),k=(0,r.$Pb)(I.folders);if(!k)return;a.scheme!==k.uri.scheme&&a.path[0]===A.$hc.sep&&a.path[1]!==A.$hc.sep&&(a=k.uri.with({path:a.path}));const b=w.getWorkspaceFolder(a);if(!b)return;let v;if(S.isEqual(b.uri,a)?v="":v=S.relativePath(b.uri,a)??"",v&&(v=D.normalize(v)),I.folders.length>1&&!w.noPrefix){const N=b.name?b.name:S.basenameOrAuthority(b.uri);v=v?`${N} \u2022 ${v}`:N}return v}function C(a,w=R.$i){return(0,h.$Gg)(a,w)?a.charAt(0).toUpperCase()+a.slice(1):a}let E=Object.create(null);function u(a,w,y=R.OS){if(y===R.OperatingSystem.Windows||!a||!w)return a;let D=E.original===w?E.normalized:void 0;D||(D=w,R.$i&&(D=(0,h.$vg)(D)),D=`${(0,T.$lf)(D,A.$hc.sep)}${A.$hc.sep}`,E={original:w,normalized:D});let S=a;return R.$i&&(S=(0,h.$vg)(S)),(y===R.OperatingSystem.Linux?S.startsWith(D):(0,T.$Ef)(S,D))?`~/${S.substr(D.length)}`:a}function P(a,w){return a.replace(/^~($|\/|\\)/,`${w}$1`)}const p="\u2026",c="\\\\",g="~";function f(a,w=A.sep){const y=new Array(a.length);let D=!1;for(let S=0;S<a.length;S++){const I=a[S];if(I===""){y[S]=`.${w}`;continue}if(!I){y[S]=I;continue}D=!0;let k="",b=I;b.indexOf(c)===0?(k=b.substr(0,b.indexOf(c)+c.length),b=b.substr(b.indexOf(c)+c.length)):b.indexOf(w)===0?(k=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length)):b.indexOf(g)===0&&(k=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length));const v=b.split(w);for(let N=1;D&&N<=v.length;N++)for(let O=v.length-N;D&&O>=0;O--){D=!1;let F=v.slice(O,O+N).join(w);for(let j=0;!D&&j<a.length;j++)if(j!==S&&a[j]&&a[j].indexOf(F)>-1){const B=O+N===v.length,M=O>0&&a[j].indexOf(w)>-1?w+F:F,W=a[j].endsWith(M);D=!B||W}if(!D){let j="";(v[0].endsWith(":")||k!=="")&&(O===1&&(O=0,N++,F=v[0]+w+F),O>0&&(j=v[0]+w),j=k+j),O>0&&(j=j+p+w),j=j+F,O+N<v.length&&(j=j+w+p),y[S]=j}}D&&(y[S]=I)}return y}var m;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(a,w=Object.create(null)){const y=[];let D=!1,S="";for(const I of a)if(I==="$"||D&&I==="{")S&&y.push({value:S,type:m.TEXT}),S="",D=!0;else if(I==="}"&&D){const k=w[S];if(typeof k=="string")k.length&&y.push({value:k,type:m.VARIABLE});else if(k){const b=y[y.length-1];(!b||b.type!==m.SEPARATOR)&&y.push({value:k.label,type:m.SEPARATOR})}S="",D=!1}else S+=I;return S&&!D&&y.push({value:S,type:m.TEXT}),y.filter((I,k)=>{if(I.type===m.SEPARATOR){const b=y[k-1],v=y[k+1];return[b,v].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(I=>I.value).join("")}function o(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):a.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function i(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,""):R.$i?a.replace(/&&|&/g,y=>y==="&"?"&&":"&"):a.replace(/&&/g,"_")}function t(a){return a.replace(/&/g,"&&")}function s(a){if(a.endsWith("]")){const w=a.lastIndexOf(" [",a.length-2);if(w!==-1){const y=d(a.substring(0,w)),D=a.substring(w);return{name:y.name+D,parentPath:y.parentPath}}}return d(a)}function d(a){const w=a.indexOf("/")!==-1?A.$hc:A.$gc,y=w.basename(a),D=w.dirname(a);return y.length?{name:y,parentPath:D}:{name:D,parentPath:""}}}),define(Ee[142],Se([1,0,22,41,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0,e.$In=$,e.$Jn=C,e.$Kn=E;function R(u){return u.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const p=this.a.transformIncoming(P);return p===P?P:R(A.URI.from(p))}transformOutgoing(P){const p=this.a.transformOutgoing(P);return p===P?P:R(A.URI.from(p))}transformOutgoingURI(P){const p=this.a.transformOutgoing(P);return p===P?P:A.URI.from(p)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Gn=L,e.$Hn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function T(u,P,p){if(!u||p>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return P.transformOutgoing(u);for(const c in u)if(Object.hasOwnProperty.call(u,c)){const g=T(u[c],P,p+1);g!==null&&(u[c]=g)}}return null}function $(u,P){const p=T(u,P,0);return p===null?u:p}function l(u,P,p,c){if(!u||c>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return p?A.URI.revive(P.transformIncoming(u)):P.transformIncoming(u);if(u instanceof r.$Le)return null;for(const g in u)if(Object.hasOwnProperty.call(u,g)){const f=l(u[g],P,p,c+1);f!==null&&(u[g]=f)}}return null}function C(u,P){const p=l(u,P,!1,0);return p===null?u:p}function E(u,P){const p=l(u,P,!0,0);return p===null?u:p}}),define(Ee[34],Se([1,0,61,68,410,9,33,82,16,11,23,2]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=y,e.writeFileSync=S,r=Ue(r);var u;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function P(M,W=u.UNLINK,_){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===u.UNLINK?c(M):p(M,_)}async function p(M,W=(0,L.$Kg)((0,h.tmpdir)())){try{try{await r.promises.rename(M,W)}catch(_){return _.code==="ENOENT"?void 0:c(M)}c(W).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function c(M){return r.promises.rm(M,{recursive:!0,force:!0,maxRetries:3})}function g(M){if((0,L.$Fg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function f(M,W){return o(await(W?m(M):r.promises.readdir(M)))}async function m(M){try{return await r.promises.readdir(M,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const W=[],_=await f(M);for(const re of _){let z=!1,G=!1,J=!1;try{const ee=await e.Promises.lstat((0,$.$kc)(M,re));z=ee.isFile(),G=ee.isDirectory(),J=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}W.push({name:re,isFile:()=>z,isDirectory:()=>G,isSymbolicLink:()=>J})}return W}function n(M){return o(r.readdirSync(M))}function o(M){return M.map(W=>typeof W=="string"?l.$j?(0,T.$jm)(W):W:(W.name=l.$j?(0,T.$jm)(W.name):W.name,W))}async function i(M){const W=await f(M),_=[];for(const re of W)await s.existsDirectory((0,$.$kc)(M,re))&&_.push(re);return _}function t(M,W=1e3){return new Promise(_=>{let re=!1;const z=setInterval(()=>{re||(re=!0,r.access(M,G=>{re=!1,G&&(clearInterval(z),_(void 0))}))},W)})}var s;(function(M){async function W(z){let G;try{if(G=await e.Promises.lstat(z),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(l.$i&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw J}}M.stat=W;async function _(z){try{const{stat:G,symbolicLink:J}=await M.stat(z);return G.isFile()&&J?.dangling!==!0}catch{}return!1}M.existsFile=_;async function re(z){try{const{stat:G,symbolicLink:J}=await M.stat(z);return G.isDirectory()&&J?.dangling!==!0}catch{}return!1}M.existsDirectory=re})(s||(e.SymlinkSupport=s={}));const d=new R.$Lh;function a(M,W,_){return d.queueFor(E.URI.file(M),()=>{const re=I(_);return new Promise((z,G)=>D(M,W,re,J=>J?G(J):z()))},C.$7g)}let w=!0;function y(M){w=M}function D(M,W,_,re){if(!w)return r.writeFile(M,W,{mode:_.mode,flag:_.flag},re);r.open(M,_.flag,_.mode,(z,G)=>{if(z)return re(z);r.writeFile(G,W,J=>{if(J)return r.close(G,()=>re(J));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),y(!1)),r.close(G,ue=>re(ue))))})})}function S(M,W,_){const re=I(_);if(!w)return r.writeFileSync(M,W,{mode:re.mode,flag:re.flag});const z=r.openSync(M,re.flag,re.mode);try{r.writeFileSync(z,W);try{r.fdatasyncSync(z)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),y(!1)}}finally{r.closeSync(z)}}function I(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function k(M,W,_=6e4){if(M!==W)try{l.$i&&typeof _=="number"?await b(M,W,Date.now(),_):await r.promises.rename(M,W)}catch(re){if(M.toLowerCase()!==W.toLowerCase()&&re.code==="EXDEV"||M.endsWith("."))await v(M,W,{preserveSymlinks:!1}),await P(M,u.MOVE);else throw re}}async function b(M,W,_,re,z=0){try{return await r.promises.rename(M,W)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-_>=re)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${G}`),G;if(z===0){let J=!1;try{const{stat:ee}=await s.stat(W);ee.isFile()||(J=!0)}catch{}if(J)throw G}return await(0,R.$Dh)(Math.min(100,z*10)),b(M,W,_,re,z+1)}}async function v(M,W,_){return O(M,W,{root:{source:M,target:W},options:_,handledSourcePaths:new Set})}const N=511;async function O(M,W,_){if(_.handledSourcePaths.has(M))return;_.handledSourcePaths.add(M);const{stat:re,symbolicLink:z}=await s.stat(M);if(z){if(_.options.preserveSymlinks)try{return await B(M,W,_)}catch{}if(z.dangling)return}return re.isDirectory()?F(M,W,re.mode&N,_):j(M,W,re.mode&N)}async function F(M,W,_,re){await e.Promises.mkdir(W,{recursive:!0,mode:_});const z=await f(M);for(const G of z)await O((0,$.$kc)(M,G),(0,$.$kc)(W,G),re)}async function j(M,W,_){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,_)}async function B(M,W,_){let re=await e.Promises.readlink(M);(0,L.$Bg)(re,_.root.source,!l.$k)&&(re=(0,$.$kc)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,W)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(M,W,_,re,z)=>new Promise((G,J)=>{r.read(M,W,_,re,z,(ee,ue,ne)=>ee?J(ee):G({bytesRead:ue,buffer:ne}))})}get readFile(){return r.promises.readFile}get write(){return(M,W,_,re,z)=>new Promise((G,J)=>{r.write(M,W,_,re,z,(ee,ue,ne)=>ee?J(ee):G({bytesWritten:ue,buffer:ne}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,A.promisify)(r.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return i}get writeFile(){return a}get rm(){return P}get rename(){return k}get copy(){return v}}}),define(Ee[111],Se([1,0,61,16,11,13,34]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=T,e.$dr=$,e.$er=l,e.$fr=C,r=Ue(r);function T(u){if(A.$k)return u;const P=(0,h.$nc)(u);if(u===P)return u;const p=((0,h.$oc)(u)||u).toLowerCase();try{const g=(0,L.readdirSync)(P).filter(f=>f.toLowerCase()===p);if(g.length===1){const f=T(P);if(f)return(0,h.$kc)(f,g[0])}else if(g.length>1){const f=g.indexOf(p);if(f>=0){const m=T(P);if(m)return(0,h.$kc)(m,g[f])}}}catch{}return null}async function $(u,P){if(A.$k)return u;const p=(0,h.$nc)(u);if(u===p)return u;const c=((0,h.$oc)(u)||u).toLowerCase();try{if(P?.isCancellationRequested)return null;const f=(await L.Promises.readdir(p)).filter(m=>m.toLowerCase()===c);if(f.length===1){const m=await $(p,P);if(m)return(0,h.$kc)(m,f[0])}else if(f.length>1){const m=f.indexOf(c);if(m>=0){const n=await $(p,P);if(n)return(0,h.$kc)(n,f[m])}}}catch{}return null}async function l(u){try{return await L.Promises.realpath(u)}catch{const p=E(u);return await L.Promises.access(p,r.constants.R_OK),p}}function C(u){try{return r.realpathSync(u)}catch{const p=E(u);return r.accessSync(p,r.constants.R_OK),p}}function E(u){return(0,R.$lf)((0,h.$ic)(u),h.sep)}}),define(Ee[112],Se([1,0,16,11,56,109,18,34]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=$,e.$vm=l,r=Ue(r),h=Ue(h),A=Ue(A),L=Ue(L),T=Ue(T),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(E=A.env){return E.comspec||"cmd.exe"}function l(E){let u=[],P=!1;const p=function(c){if(P){u.push(c);return}(!E.send(c,f=>{if(f&&console.error(f),P=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(n=>p(n))}})||h.$i)&&(P=!0)};return{send:p}}var C;(function(E){async function u(P,p,c){if(r.$jc(P))return P;if(p===void 0&&(p=A.cwd()),r.$nc(P)!=="."||(c===void 0&&L.$cg(A.env.PATH)&&(c=A.env.PATH.split(r.$uc)),c===void 0||c.length===0))return r.$kc(p,P);async function f(m){if(await T.Promises.exists(m)){let n;try{n=await T.Promises.stat(m)}catch(o){o.message.startsWith("EACCES")&&(n=await T.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of c){let n;if(r.$jc(m)?n=r.$kc(m,P):n=r.$kc(p,m,P),await f(n))return n;let o=n+".com";if(await f(o)||(o=n+".exe",await f(o)))return o}return r.$kc(p,P)}E.findExecutable=u})(C||(e.win32=C={}))});var Ye=this&&this.__decorate||function(ce,e,r,h){var A=arguments.length,R=A<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ce,e,r,h);else for(var T=ce.length-1;T>=0;T--)(L=ce[T])&&(R=(A<3?L(R):A>3?L(e,r,R):L(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(Ee[87],Se([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=y,e.$di=D,e.$ii=N,e.$ji=O,E=Ue(E);var P;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(P||(P={}));function p(z){switch(z){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var c;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(c||(c={}));function g(z){switch(z){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));function m(z){let G=0;for(let J=0;;J+=7){const ee=z.read(1);if(G|=(ee.buffer[0]&127)<<J,!(ee.buffer[0]&128))return G}}const n=d(0);function o(z,G){if(G===0){z.write(n);return}let J=0;for(let ue=G;ue!==0;ue=ue>>>7)J++;const ee=A.$Le.alloc(J);for(let ue=0;G!==0;ue++)ee.buffer[ue]=G&127,G=G>>>7,G>0&&(ee.buffer[ue]|=128);z.write(ee)}class i{constructor(G){this.b=G,this.a=0}read(G){const J=this.b.slice(this.a,this.a+G);return this.a+=J.byteLength,J}}e.$ai=i;class t{constructor(){this.a=[]}get buffer(){return A.$Le.concat(this.a)}write(G){this.a.push(G)}}e.$bi=t;var s;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(s||(s={}));function d(z){const G=A.$Le.alloc(1);return G.writeUInt8(z,0),G}const a={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},w=typeof Buffer<"u";function y(z,G){if(typeof G>"u")z.write(a.Undefined);else if(typeof G=="string"){const J=A.$Le.fromString(G);z.write(a.String),o(z,J.byteLength),z.write(J)}else if(w&&Buffer.isBuffer(G)){const J=A.$Le.wrap(G);z.write(a.Buffer),o(z,J.byteLength),z.write(J)}else if(G instanceof A.$Le)z.write(a.VSBuffer),o(z,G.byteLength),z.write(G);else if(Array.isArray(G)){z.write(a.Array),o(z,G.length);for(const J of G)y(z,J)}else if(typeof G=="number"&&(G|0)===G)z.write(a.Uint),o(z,G);else{const J=A.$Le.fromString(JSON.stringify(G));z.write(a.Object),o(z,J.byteLength),z.write(J)}}function D(z){switch(z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return z.read(m(z)).toString();case s.Buffer:return z.read(m(z)).buffer;case s.VSBuffer:return z.read(m(z));case s.Array:{const J=m(z),ee=[];for(let ue=0;ue<J;ue++)ee.push(D(z));return ee}case s.Object:return JSON.parse(z.read(m(z)).toString());case s.Int:return m(z)}}class S{constructor(G,J,ee=null,ue=1e3){this.h=G,this.j=J,this.k=ee,this.l=ue,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:c.Initialize})}registerChannel(G,J){this.b.set(G,J),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case c.Initialize:{const J=this.o([G.type]);this.k?.logOutgoing(J,0,I.OtherSide,g(G.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const J=this.o([G.type,G.id],G.data);this.k?.logOutgoing(J,G.id,I.OtherSide,g(G.type),G.data);return}}}o(G,J=void 0){const ee=new t;return y(ee,G),y(ee,J),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const J=new i(G),ee=D(J),ue=D(J),ne=ee[0];switch(ne){case P.Promise:return this.k?.logIncoming(G.byteLength,ee[1],I.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,ue),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],I.OtherSide,`${p(ne)}: ${ee[2]}.${ee[3]}`,ue),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case P.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],I.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]});case P.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],I.OtherSide,`${p(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const ee=new R.$ue;let ue;try{ue=J.call(this.j,G.name,G.arg,ee.token)}catch($e){ue=Promise.reject($e)}const ne=G.id;ue.then($e=>{this.m({id:ne,data:$e,type:c.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:ne,data:$e,type:c.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,l.$Tc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const J=this.b.get(G.channelName);if(!J){this.v(G);return}const ee=G.id,ne=J.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:c.EventFire}));this.d.set(G.id,ne)}u(G){const J=this.d.get(G.id);J&&(J.dispose(),this.d.delete(G.id))}v(G){let J=this.g.get(G.channelName);J||(J=[],this.g.set(G.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===P.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);J.push({request:G,timeoutTimer:ee})}w(G){const J=this.g.get(G);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case P.Promise:this.s(ee.request);break;case P.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$ei=S;var I;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class k{constructor(G,J=null){this.l=G,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=J}getChannel(G){const J=this;return{call(ee,ue,ne){return J.a?Promise.reject(new T.$6):J.m(G,ee,ue,ne)},listen(ee,ue){return J.a?$.Event.None:J.o(G,ee,ue)}}}m(G,J,ee,ue=R.CancellationToken.None){const ne=this.g++,De=P.Promise,$e={id:ne,type:De,channelName:G,name:J,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new T.$6);let Q;return new Promise((se,oe)=>{if(ue.isCancellationRequested)return oe(new T.$6);const te=()=>{const ae=pe=>{switch(pe.type){case c.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case c.PromiseError:{this.f.delete(ne);const be=new Error(pe.data.message);be.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,be.name=pe.data.name,oe(be);break}case c.PromiseErrorObj:this.f.delete(ne),oe(pe.data);break}};this.f.set(ne,ae),this.p($e)};let le=null;this.b===f.Idle?te():(le=(0,h.$ph)(ae=>this.u()),le.then(()=>{le=null,te()}));const he=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:P.PromiseCancel}),oe(new T.$6)},X=ue.onCancellationRequested(he);Q=(0,l.$Sc)((0,l.$Tc)(he),X),this.d.add(Q)}).finally(()=>{Q.dispose(),this.d.delete(Q)})}o(G,J,ee){const ue=this.g++,ne=P.EventListen,De={id:ue,type:ne,channelName:G,name:J,arg:ee};let $e=null;const Q=new $.$je({onWillAddFirstListener:()=>{$e=(0,h.$ph)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(Q),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(Q),this.p({id:ue,type:P.EventDispose}))}}),U=se=>Q.fire(se.data);return this.f.set(ue,U),Q.event}p(G){switch(G.type){case P.Promise:case P.EventListen:{const J=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(J,G.id,I.LocalSide,`${p(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case P.PromiseCancel:case P.EventDispose:{const J=this.q([G.type,G.id]);this.j?.logOutgoing(J,G.id,I.LocalSide,p(G.type));return}}}q(G,J=void 0){const ee=new t;return y(ee,G),y(ee,J),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const J=new i(G),ee=D(J),ue=D(J),ne=ee[0];switch(ne){case c.Initialize:return this.j?.logIncoming(G.byteLength,0,I.LocalSide,g(ne)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],I.LocalSide,g(ne),ue),this.t({type:ee[0],id:ee[1],data:ue})}}t(G){if(G.type===c.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$fi=k,Ye([L.$7h],k.prototype,"onDidInitializePromise",null);class b{get connections(){const G=[];return this.f.forEach(J=>G.push(J)),G}constructor(G,J,ee){this.a=new Map,this.f=new Set,this.g=new $.$je,this.onDidAddConnection=this.g.event,this.h=new $.$je,this.onDidRemoveConnection=this.h.event,this.j=new l.$Uc,this.j.add(G(({protocol:ue,onDidClientDisconnect:ne})=>{const De=$.Event.once(ue.onMessage);this.j.add(De($e=>{const Q=new i($e),U=D(Q),se=new S(ue,U,J,ee),oe=new k(ue,J);this.a.forEach((le,he)=>se.registerChannel(he,le));const te={channelServer:se,channelClient:oe,ctx:U};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),oe.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,J){const ee=this;return{call(ue,ne,De){let $e;if((0,u.$qg)(J)){const U=(0,r.$4b)(ee.connections.filter(J));$e=U?Promise.resolve(U):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,J))}else $e=J.routeCall(ee,ue,ne);const Q=$e.then(U=>U.channelClient.getChannel(G));return N(Q).call(ue,ne,De)},listen(ue,ne){if((0,u.$qg)(J))return ee.k(G,J,ue,ne);const De=J.routeEvent(ee,ue,ne).then($e=>$e.channelClient.getChannel(G));return N(De).listen(ue,ne)}}}k(G,J,ee,ue){const ne=this;let De;const $e=new $.$je({onWillAddFirstListener:()=>{De=new l.$Uc;const Q=new $.$pe,U=new Map,se=te=>{const he=te.channelClient.getChannel(G).listen(ee,ue),X=Q.add(he);U.set(te,X)},oe=te=>{const le=U.get(te);le&&(le.dispose(),U.delete(te))};ne.connections.filter(J).forEach(se),$.Event.filter(ne.onDidAddConnection,J)(se,void 0,De),ne.onDidRemoveConnection(oe,void 0,De),Q.event($e.fire,$e,De),De.add(Q)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,J){this.a.set(G,J);for(const ee of this.f)ee.channelServer.registerChannel(G,J)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=b;class v{constructor(G,J,ee=null){const ue=new t;y(ue,J),G.send(ue.buffer),this.a=new k(G,ee),this.d=new S(G,J,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,J){this.d.registerChannel(G,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=v;function N(z){return{call(G,J,ee){return z.then(ue=>ue.call(G,J,ee))},listen(G,J){const ee=new $.$se;return z.then(ue=>ee.input=ue.listen(G,J)),ee.event}}}function O(z){let G=!1;return{call(J,ee,ue){return G?z.call(J,ee,ue):(0,h.$Dh)(0).then(()=>G=!0).then(()=>z.call(J,ee,ue))},listen(J,ee){if(G)return z.listen(J,ee);const ue=new $.$se;return(0,h.$Dh)(0).then(()=>G=!0).then(()=>ue.input=z.listen(J,ee)),ue.event}}}class F{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const J of G.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ki=F;var j;(function(z){function G(ne,De,$e){const Q=ne,U=$e&&$e.disableMarshalling,se=new Map;for(const oe in Q)ee(oe)&&se.set(oe,$.Event.buffer(Q[oe],!0,void 0,De));return new class{listen(oe,te,le){const he=se.get(te);if(he)return he;const X=Q[te];if(typeof X=="function"){if(ue(te))return X.call(Q,le);if(ee(te))return se.set(te,$.Event.buffer(Q[te],!0,void 0,De)),se.get(te)}throw new T.$cb(`Event not found: ${te}`)}call(oe,te,le){const he=Q[te];if(typeof he=="function"){if(!U&&Array.isArray(le))for(let ae=0;ae<le.length;ae++)le[ae]=(0,C.$_h)(le[ae]);let X=he.apply(Q,le);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new T.$cb(`Method not found: ${te}`)}}}z.fromService=G;function J(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(Q,U){if(typeof U=="string")return De?.properties?.has(U)?De.properties.get(U):ue(U)?function(se){return ne.listen(U,se)}:ee(U)?ne.listen(U):async function(...se){let oe;De&&!(0,u.$lg)(De.context)?oe=[De.context,...se]:oe=se;const te=await ne.call(U,oe);return $e?te:(0,C.$_h)(te)};throw new T.$cb(`Property not found: ${String(U)}`)}})}z.toService=J;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Cf(ne.charCodeAt(2))}function ue(ne){return/^onDynamic/.test(ne)&&E.$Cf(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const G=z.toString();if(G!=="[object Object]")return G}return z}function W(z){return Array.isArray(z)?z.map(M):M(z)}function _(z,G,J,ee,ue,ne,De){De=W(De);const $e=B[ue],Q=$e[ee%$e.length];let U=[`%c[${z}]%c[${String(G).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(ne)?(U=U.concat(De),U.push(")")):U.push(De),console.log.apply(console,U)}class re{constructor(G,J){this.d=G,this.f=J,this.a=0,this.b=0}logOutgoing(G,J,ee,ue,ne){this.b+=G,_(this.d,this.b,G,J,ee,ue,ne)}logIncoming(G,J,ee,ue,ne){this.a+=G,_(this.f,this.a,G,J,ee,ue,ne)}}e.$li=re}),define(Ee[69],Se([1,0,22,4,3,87]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var T;(function(a){a.enableDiagnostics=!1,a.records=[];const w=new WeakMap;let y=0;function D(I,k){if(!w.has(I)){const b=String(++y);w.set(I,b)}return w.get(I)}function S(I,k,b,v){if(!a.enableDiagnostics)return;const N=D(I,k);if(v instanceof r.$Le||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const O=r.$Le.alloc(v.byteLength);O.set(v),a.records.push({timestamp:Date.now(),id:N,label:k,type:b,buff:O})}else a.records.push({timestamp:Date.now(),id:N,label:k,type:b,data:v})}a.traceSocketEvent=S})(T||(e.SocketDiagnostics=T={}));var $;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let l=null;function C(){return l||(l=r.$Le.alloc(0)),l}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,y){if(w===0)return C();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const k=this.a[0];return y&&(this.a.shift(),this.b-=w),k}if(this.a[0].byteLength>w){const k=this.a[0].slice(0,w);return y&&(this.a[0]=this.a[0].slice(w),this.b-=w),k}const D=r.$Le.alloc(w);let S=0,I=0;for(;w>0;){const k=this.a[I];if(k.byteLength>w){const b=k.slice(0,w);D.set(b,S),S+=w,y&&(this.a[I]=k.slice(w),this.b-=w),w-=w}else D.set(k,S),S+=k.byteLength,y?(this.a.shift(),this.b-=k.byteLength):I++,w-=k.byteLength}return D}}e.$mi=E;var u;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(u||(u={}));function P(a){switch(a){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var p;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",a[a.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class c{constructor(w,y,D,S){this.type=w,this.id=y,this.ack=D,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.$Vc{constructor(w){super(),this.f=this.B(new h.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:p.HeaderLength,messageType:u.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,S=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=p.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,y),this.f.fire(new c(D,S,I,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=r.$Le.alloc(p.HeaderLength);y.writeUInt8(w.type,0),y.writeUInt32BE(w.id,1),y.writeUInt32BE(w.ack,5),y.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,w.data),this.j(y,w.data)}g(w,y){const D=this.f===0;return this.d.push(w,y),this.f+=w.byteLength+y.byteLength,D}h(){const w=r.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,y){this.g(w,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class m extends A.$Vc{constructor(w){super(),this.f=new h.$je,this.onMessage=this.f.event,this.g=new h.$je,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new f(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(y=>{y.type===u.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new c(u.Regular,0,0,w))}}e.$ni=m;class n extends R.$hi{static fromSocket(w,y){return new n(new m(w),y)}get onDidDispose(){return this.b.onDidDispose}constructor(w,y,D=null){super(w,y,D),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$oi=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$pi=o;class i{constructor(w){this.data=w,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let w=0,y=this.a;for(;y;)y=y.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let y=0,D=this.a;for(;D;)w[y++]=D.data,D=D.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const y=new i(w);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let y=0;y<s.a;y++)this.c[y]=w-1e3*y;setInterval(()=>{for(let y=s.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),y=(1+s.a)*1e3;let D=0;for(let S=0;S<s.a;S++)w-this.c[S]<=y&&D++;return 1-D/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??s.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Uc,this.o=w.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},p.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new c(u.Disconnect,0,0,C());this.p.write(w),this.p.flush()}sendPause(){const w=new c(u.Pause,0,0,C());this.p.write(w)}sendResume(){const w=new c(u.Resume,0,0,C());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,y){this.a=!0,this.r.dispose(),this.r=new A.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new c(u.Ack,0,this.h,C());this.p.write(w);const y=this.b.toArray();for(let D=0,S=y.length;D<S;D++)this.p.write(y[D]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const y=this.b.peek();if(y&&y.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case u.None:break;case u.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new c(u.ReplayRequest,0,0,C())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case u.Control:{this.u.fire(w.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const y=this.b.toArray();for(let D=0,S=y.length;D<S;D++)this.p.write(y[D]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const y=++this.c;this.h=this.g;const D=new c(u.Regular,y,this.h,w);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(w){const y=new c(u.Control,0,0,w);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=p.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},p.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),y=Date.now()-w.writtenTime,D=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(y>=p.TimeoutTime&&D>=p.TimeoutTime&&S>=p.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:D});return}const I=Math.max(p.TimeoutTime-y,p.TimeoutTime-D,p.TimeoutTime-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new c(u.Ack,0,this.h,C());this.p.write(w)}D(){this.h=this.g;const w=new c(u.KeepAlive,0,this.h,C());this.p.write(w)}}e.$qi=d}),define(Ee[208],Se([1,0,58,9,22,21,206,14,4,3,25,112,109,87]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=void 0,T=Ue(T);class p extends P.$ei{constructor(f){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",m=>A.$Le.wrap(Buffer.from(m,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$$q=p;class c{constructor(f,m){this.i=f,this.j=m,this.c=new Set,this.g=new Map,this.h=new $.$je,this.onDidProcessExit=this.h.event;const n=m&&m.timeout?m.timeout:6e4;this.b=new h.$zh(n),this.d=null,this.f=null}getChannel(f){const m=this;return{call(n,o,i){return m.k(f,n,o,i)},listen(n,o){return m.l(f,n,o)}}}k(f,m,n,o=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.$7());this.b.cancel();const i=this.n(f),t=(0,h.$ph)(a=>i.call(m,n,a)),s=o.onCancellationRequested(()=>t.cancel()),d=(0,l.$Tc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,m,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const i=new $.$je({onWillAddFirstListener:()=>{o=this.n(f).listen(m,n)(i.fire,i),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,C.$_n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,u.$im)(m.env),this.d=(0,r.fork)(this.i,f,m);const n=new $.$je,i=$.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,L.$7q)(y)){(0,L.log)(y,`IPC Library: ${this.j.serverName}`);return}n.fire(A.$Le.wrap(Buffer.from(y,"base64")))}),t=this.j.useQueue?(0,E.$vm)(this.d):this.d,s=y=>this.d&&this.d.connected&&t.send(y.buffer.toString("base64")),d=n.event,a={send:s,onMessage:d};this.f=new P.$fi(a);const w=()=>this.o();process.once("exit",w),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,D)=>{process.removeListener("exit",w),i.dispose(),this.c.forEach(S=>(0,l.$Qc)(S)),this.c.clear(),y!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:D})})}return this.f}n(f){let m=this.g.get(f);return m||(m=this.m.getChannel(f),this.g.set(f,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$_q=c}),define(Ee[209],Se([1,0,9,4,3,57,18]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=$;var T;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function $(u){const P=u;return P?.changed instanceof Map||P?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(e.StorageState=l={}));class C extends A.$Vc{static{this.a=100}constructor(P,p=Object.create(null)){super(),this.r=P,this.s=p,this.b=this.B(new h.$me),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new r.$Ah(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((p,c)=>this.w(c,p)),P.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(P,p){if(this.c===l.Closed)return;let c=!1;(0,L.$lg)(p)?c=this.f.delete(P):this.f.get(P)!==p&&(this.f.set(P,p),c=!0),c&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,p){const c=this.f.get(P);return(0,L.$lg)(c)?p:c}getBoolean(P,p){const c=this.get(P);return(0,L.$lg)(c)?p:c==="true"}getNumber(P,p){const c=this.get(P);return(0,L.$lg)(c)?p:parseInt(c,10)}getObject(P,p){const c=this.get(P);return(0,L.$lg)(c)?p:(0,R.$$h)(c)}async set(P,p,c=!1){if(this.c===l.Closed)return;if((0,L.$lg)(p))return this.delete(P,c);const g=(0,L.$eg)(p)||Array.isArray(p)?(0,R.$0h)(p):String(p);if(this.f.get(P)!==g)return this.f.set(P,g),this.j.set(P,g),this.h.delete(P),this.b.fire({key:P,external:c}),this.D()}async delete(P,p=!1){if(!(this.c===l.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:p}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===l.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$8p=C;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((p,c)=>this.a.set(c,p)),P.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$9p=E}),define(Ee[210],Se([1,0,13,11,22]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=void 0,e.$5t=C,e.$6t=E,r=Ue(r),h=Ue(h),A=Ue(A);let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function $(){return T||(T=new TextDecoder("UTF-16BE")),T}let l;function C(){return l||(l=h.$D()?L():$()),l}function E(p,c,g){const f=new Uint16Array(p.buffer,c,g);return g>0&&(f[0]===65279||f[0]===65534)?u(p,c,g):L().decode(f)}function u(p,c,g){const f=[];let m=0;for(let n=0;n<g;n++){const o=A.$Ne(p,c);c+=2,f[m++]=String.fromCharCode(o)}return f.join("")}class P{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return C().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||r.$Hf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let f=0;f<g;f++)this.b[this.d++]=c.charCodeAt(f)}}e.$7t=P}),define(Ee[211],Se([1,0,22,210]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=void 0,e.$9t=L,r=Ue(r);function A($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,C,E,u){this.oldPosition=l,this.oldText=C,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(l){return 4+2*l.length}static c(l,C,E){const u=C.length;r.$Qe(l,u,E),E+=4;for(let P=0;P<u;P++)r.$Oe(l,C.charCodeAt(P),E),E+=2;return E}static d(l,C){const E=r.$Pe(l,C);return C+=4,(0,h.$6t)(l,C,E)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(l,C){return r.$Qe(l,this.oldPosition,C),C+=4,r.$Qe(l,this.newPosition,C),C+=4,C=R.c(l,this.oldText,C),C=R.c(l,this.newText,C),C}static read(l,C,E){const u=r.$Pe(l,C);C+=4;const P=r.$Pe(l,C);C+=4;const p=R.d(l,C);C+=R.a(p);const c=R.d(l,C);return C+=R.a(c),E.push(new R(u,p,P,c)),C}}e.$8t=R;function L($,l){return $===null||$.length===0?l:new T($,l).compress()}class T{constructor(l,C){this.a=l,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let l=0,C=0,E=this.n(l),u=this.l(C);for(;l<this.f||C<this.h;){if(E===null){this.k(u),u=this.l(++C);continue}if(u===null){this.m(E),E=this.n(++l);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++C);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++l);continue}if(u.oldPosition<E.newPosition){const[f,m]=T.r(u,E.newPosition-u.oldPosition);this.k(f),u=m;continue}if(E.newPosition<u.oldPosition){const[f,m]=T.q(E,u.oldPosition-E.newPosition);this.m(f),E=m;continue}let c,g;if(u.oldEnd===E.newEnd)c=E,g=u,E=this.n(++l),u=this.l(++C);else if(u.oldEnd<E.newEnd){const[f,m]=T.q(E,u.oldLength);c=f,g=u,E=m,u=this.l(++C)}else{const[f,m]=T.r(u,E.newLength);c=E,g=f,E=this.n(++l),u=m}this.d[this.e++]=new R(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const P=T.s(this.d);return T.t(P)}k(l){this.d[this.e++]=T.o(this.g,l),this.j+=l.newLength-l.oldLength}l(l){return l<this.h?this.c[l]:null}m(l){this.d[this.e++]=T.p(this.j,l),this.g+=l.newLength-l.oldLength}n(l){return l<this.f?this.a[l]:null}static o(l,C){return new R(C.oldPosition-l,C.oldText,C.newPosition,C.newText)}static p(l,C){return new R(C.oldPosition,C.oldText,C.newPosition+l,C.newText)}static q(l,C){const E=l.newText.substr(0,C),u=l.newText.substr(C);return[new R(l.oldPosition,l.oldText,l.newPosition,E),new R(l.oldEnd,"",l.newPosition+C,u)]}static r(l,C){const E=l.oldText.substr(0,C),u=l.oldText.substr(C);return[new R(l.oldPosition,E,l.newPosition,l.newText),new R(l.oldPosition+C,u,l.newEnd,"")]}static s(l){if(l.length===0)return l;const C=[];let E=0,u=l[0];for(let P=1;P<l.length;P++){const p=l[P];u.oldEnd===p.oldPosition?u=new R(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(C[E++]=u,u=p)}return C[E++]=u,C}static t(l){if(l.length===0)return l;const C=[];let E=0;for(let u=0;u<l.length;u++){const P=l[u];P.oldText!==P.newText&&(C[E++]=P)}return C}}}),define(Ee[212],Se([1,0,39,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=A,e.$nu=R;function A(L,T,$,l,C,E){if(Array.isArray(L)){let u=0;for(const P of L){const p=A(P,T,$,l,C,E);if(p===10)return p;p>u&&(u=p)}return u}else{if(typeof L=="string")return l?L==="*"?5:L===$?10:0:0;if(L){const{language:u,pattern:P,scheme:p,hasAccessToAllModels:c,notebookType:g}=L;if(!l&&!c)return 0;g&&C&&(T=C);let f=0;if(p)if(p===T.scheme)f=10;else if(p==="*")f=5;else return 0;if(u)if(u===$)f=10;else if(u==="*")f=Math.max(f,5);else return 0;if(g)if(g===E)f=10;else if(g==="*"&&E!==void 0)f=Math.max(f,5);else return 0;if(P){let m;if(typeof P=="string"?m=P:m={...P,base:(0,h.$ic)(P.base)},m===T.fsPath||(0,r.$vk)(m,T.fsPath))f=10;else return 0}return f}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(Ee[213],Se([1,0,4,13,31,54,139,188,211,3]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0,h=Ue(h);class C extends l.$Vc{constructor(u,P,p,c,g,f,m){super(),this.m=this.B(new r.$je),this.onDidChangeContent=this.m.event,this.f=P,this.j=!f,this.g=c,this.h=g,this.c=new L.$eD(u,p,m)}equals(u){return!(u instanceof C)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,P){return this.c.getOffsetAt(u,P)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,P){const p=u+P,c=this.getPositionAt(u),g=this.getPositionAt(p);return new A.$Ft(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const p=this.n(P);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,P=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),c=this.getOffsetAt(u.endLineNumber,u.endColumn);let g=0;const f=this.n(P),m=this.getEOL();if(f.length!==m.length){const n=f.length-m.length,o=u.endLineNumber-u.startLineNumber;g=n*o}return c-p+g}getCharacterCountInRange(u,P=R.EndOfLinePreference.TextDefined){if(this.j){let p=0;const c=u.startLineNumber,g=u.endLineNumber;for(let f=c;f<=g;f++){const m=this.getLineContent(f),n=f===c?u.startColumn-1:0,o=f===g?u.endColumn-1:m.length;for(let i=n;i<o;i++)h.$Hf(m.charCodeAt(i))?(p=p+1,i=i+1):p=p+1}return p+=this.n(P).length*(g-c),p}return this.getValueLengthInRange(u,P)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,P){return this.c.getLineCharCode(u,P)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const P=h.$sf(this.getLineContent(u));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(u){const P=h.$uf(this.getLineContent(u));return P===-1?0:P+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,P,p){let c=this.g,g=this.h,f=this.j,m=!0,n=[];for(let w=0;w<u.length;w++){const y=u[w];m&&y._isTracked&&(m=!1);const D=y.range;if(y.text){let v=!0;f||(v=!h.$Sf(y.text),f=v),!c&&v&&(c=h.$Rf(y.text)),!g&&v&&(g=h.$Uf(y.text))}let S="",I=0,k=0,b=0;if(y.text){let v;[I,k,b,v]=(0,T.$pu)(y.text);const N=this.getEOL(),O=N===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;v===T.StringEOL.Unknown||v===O?S=y.text:S=y.text.replace(/\r\n|\r|\n/g,N)}n[w]={sortIndex:w,identifier:y.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:S,eolCount:I,firstLineLength:k,lastLineLength:b,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(C.u);let o=!1;for(let w=0,y=n.length-1;w<y;w++){const D=n[w].range.getEndPosition(),S=n[w+1].range.getStartPosition();if(S.isBeforeOrEqual(D)){if(S.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}m&&(n=this.s(n));const i=p||P?C._getInverseEditRanges(n):[],t=[];if(P)for(let w=0;w<n.length;w++){const y=n[w],D=i[w];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let S=D.startLineNumber;S<=D.endLineNumber;S++){let I="";S===D.startLineNumber&&(I=this.getLineContent(y.range.startLineNumber),h.$sf(I)!==-1)||t.push({lineNumber:S,oldContent:I})}}let s=null;if(p){let w=0;s=[];for(let y=0;y<n.length;y++){const D=n[y],S=i[y],I=this.getValueInRange(D.range),k=D.rangeOffset+w;w+=D.text.length-I.length,s[y]={sortIndex:D.sortIndex,identifier:D.identifier,range:S,text:I,textChange:new $.$8t(D.rangeOffset,I,k,D.text)}}o||s.sort((y,D)=>y.sortIndex-D.sortIndex)}this.g=c,this.h=g,this.j=f;const d=this.t(n);let a=null;if(P&&t.length>0){t.sort((w,y)=>y.lineNumber-w.lineNumber),a=[];for(let w=0,y=t.length;w<y;w++){const D=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===D)continue;const S=t[w].oldContent,I=this.getLineContent(D);I.length===0||I===S||h.$sf(I)!==-1||a.push(D)}}return this.m.fire(),new R.$$v(s,d,a)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let P=!1;const p=u[0].range,c=u[u.length-1].range,g=new A.$Ft(p.startLineNumber,p.startColumn,c.endLineNumber,c.endColumn);let f=p.startLineNumber,m=p.startColumn;const n=[];for(let d=0,a=u.length;d<a;d++){const w=u[d],y=w.range;P=P||w.forceMoveMarkers,n.push(this.getValueInRange(new A.$Ft(f,m,y.startLineNumber,y.startColumn))),w.text.length>0&&n.push(w.text),f=y.endLineNumber,m=y.endColumn}const o=n.join(""),[i,t,s]=(0,T.$pu)(o);return{sortIndex:0,identifier:u[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,R.EndOfLinePreference.TextDefined),text:o,eolCount:i,firstLineLength:t,lastLineLength:s,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(u){u.sort(C.w);const P=[];for(let p=0;p<u.length;p++){const c=u[p],g=c.range.startLineNumber,f=c.range.startColumn,m=c.range.endLineNumber,n=c.range.endColumn;if(g===m&&f===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const o=new A.$Ft(g,f,m,n);P.push({range:o,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return P}findMatchesLineByLine(u,P,p,c){return this.c.findMatchesLineByLine(u,P,p,c)}getPieceTree(){return this.c}static _getInverseEditRange(u,P){const p=u.startLineNumber,c=u.startColumn,[g,f,m]=(0,T.$pu)(P);let n;if(P.length>0){const o=g+1;o===1?n=new A.$Ft(p,c,p,c+f):n=new A.$Ft(p,c,p+o-1,m+1)}else n=new A.$Ft(p,c,p,c);return n}static _getInverseEditRanges(u){const P=[];let p=0,c=0,g=null;for(let f=0,m=u.length;f<m;f++){const n=u[f];let o,i;g?g.range.endLineNumber===n.range.startLineNumber?(o=p,i=c+(n.range.startColumn-g.range.endColumn)):(o=p+(n.range.startLineNumber-g.range.endLineNumber),i=n.range.startColumn):(o=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new A.$Ft(o,i,o,i+n.firstLineLength):t=new A.$Ft(o,i,o+s-1,n.lastLineLength+1)}else t=new A.$Ft(o,i,o,i);p=t.endLineNumber,c=t.endColumn,P.push(t),g=n}return P}static u(u,P){const p=A.$Ft.compareRangesUsingEnds(u.range,P.range);return p===0?u.sortIndex-P.sortIndex:p}static w(u,P){const p=A.$Ft.compareRangesUsingEnds(u.range,P.range);return p===0?P.sortIndex-u.sortIndex:-p}}e.$fD=C}),define(Ee[214],Se([1,0,27,13,54,139,213]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=void 0,h=Ue(h);class T{constructor(C,E,u,P,p,c,g,f,m){this.a=C,this.b=E,this.c=u,this.d=P,this.e=p,this.f=c,this.g=g,this.h=f,this.j=m}k(C){const E=this.c+this.d+this.e,u=this.c+this.e;return E===0?C===A.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(C){const E=this.k(C),u=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,c=u.length;p<c;p++){const g=u[p].buffer.replace(/\r\n|\r|\n/g,E),f=(0,R.$aD)(g);u[p]=new R.$dD(g,f)}const P=new L.$fD(u,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(C){return this.a[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(C){if(C.length===0)return;this.a.length===0&&h.$3f(C)&&(this.b=h.$2f,C=C.substr(1));const E=C.charCodeAt(C.length-1);E===r.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(C.substr(0,C.length-1),!1),this.c=!0,this.d=E):(this.m(C,!1),this.c=!1,this.d=E)}m(C,E){!E&&C.length===0||(this.c?this.n(String.fromCharCode(this.d)+C):this.n(C))}n(C){const E=(0,R.$bD)(this.e,C);this.a.push(new R.$dD(C,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Rf(C)),this.k||(this.k=h.$Uf(C)))}finish(C=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,C)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const C=this.a[this.a.length-1];C.buffer+=String.fromCharCode(this.d);const E=(0,R.$aD)(C.buffer);C.lineStarts=E,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$gD=$}),define(Ee[143],Se([1,0,22,11]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=$,e.$Fcb=C,h=Ue(h);var A;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(A||(A={}));function R(E){for(let u=0,P=E.length;u<P;u+=4){const p=E[u+0],c=E[u+1],g=E[u+2],f=E[u+3];E[u+0]=f,E[u+1]=g,E[u+2]=c,E[u+3]=p}}function L(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||R(u),r.$Le.wrap(u)}function T(E){const u=E.buffer;if(h.$D()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const P=new Uint8Array(u.byteLength);return P.set(u),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function $(E){const u=new Uint32Array(l(E));let P=0;if(u[P++]=E.id,E.type==="full")u[P++]=A.Full,u[P++]=E.data.length,u.set(E.data,P),P+=E.data.length;else{u[P++]=A.Delta,u[P++]=E.deltas.length;for(const p of E.deltas)u[P++]=p.start,u[P++]=p.deleteCount,p.data?(u[P++]=p.data.length,u.set(p.data,P),P+=p.data.length):u[P++]=0}return L(u)}function l(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const P of E.deltas)P.data&&(u+=P.data.length)}return u}function C(E){const u=T(E);let P=0;const p=u[P++];if(u[P++]===A.Full){const m=u[P++],n=u.subarray(P,P+m);return P+=m,{id:p,type:"full",data:n}}const g=u[P++],f=[];for(let m=0;m<g;m++){const n=u[P++],o=u[P++],i=u[P++];let t;i>0&&(t=u.subarray(P,P+i),P+=i),f[m]={start:n,deleteCount:o,data:t}}return{id:p,type:"delta",deltas:f}}}),define(Ee[215],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(Ee[216],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[88],Se([1,0,83,2,189,31,199,216]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Hu=e.$Gu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Fu=e.$Eu=e.SymbolKinds=e.SymbolTag=e.$Cu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Au=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$zu=e.$yu=e.$xu=void 0,e.$Bu=d,e.$Du=w;class ${constructor(G,J,ee){this.offset=G,this.type=J,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$xu=$;class l{constructor(G,J){this.tokens=G,this.endState=J,this._tokenizationResultBrand=void 0}}e.$yu=l;class C{constructor(G,J){this.tokens=G,this.endState=J,this._encodedTokenizationResultBrand=void 0}}e.$zu=C;var E;(function(z){z[z.Increase=0]="Increase",z[z.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var u;(function(z){z[z.Method=0]="Method",z[z.Function=1]="Function",z[z.Constructor=2]="Constructor",z[z.Field=3]="Field",z[z.Variable=4]="Variable",z[z.Class=5]="Class",z[z.Struct=6]="Struct",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Event=10]="Event",z[z.Operator=11]="Operator",z[z.Unit=12]="Unit",z[z.Value=13]="Value",z[z.Constant=14]="Constant",z[z.Enum=15]="Enum",z[z.EnumMember=16]="EnumMember",z[z.Keyword=17]="Keyword",z[z.Text=18]="Text",z[z.Color=19]="Color",z[z.File=20]="File",z[z.Reference=21]="Reference",z[z.Customcolor=22]="Customcolor",z[z.Folder=23]="Folder",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue",z[z.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var P;(function(z){const G=new Map;G.set(u.Method,r.$2j.symbolMethod),G.set(u.Function,r.$2j.symbolFunction),G.set(u.Constructor,r.$2j.symbolConstructor),G.set(u.Field,r.$2j.symbolField),G.set(u.Variable,r.$2j.symbolVariable),G.set(u.Class,r.$2j.symbolClass),G.set(u.Struct,r.$2j.symbolStruct),G.set(u.Interface,r.$2j.symbolInterface),G.set(u.Module,r.$2j.symbolModule),G.set(u.Property,r.$2j.symbolProperty),G.set(u.Event,r.$2j.symbolEvent),G.set(u.Operator,r.$2j.symbolOperator),G.set(u.Unit,r.$2j.symbolUnit),G.set(u.Value,r.$2j.symbolValue),G.set(u.Enum,r.$2j.symbolEnum),G.set(u.Constant,r.$2j.symbolConstant),G.set(u.Enum,r.$2j.symbolEnum),G.set(u.EnumMember,r.$2j.symbolEnumMember),G.set(u.Keyword,r.$2j.symbolKeyword),G.set(u.Snippet,r.$2j.symbolSnippet),G.set(u.Text,r.$2j.symbolText),G.set(u.Color,r.$2j.symbolColor),G.set(u.File,r.$2j.symbolFile),G.set(u.Reference,r.$2j.symbolReference),G.set(u.Customcolor,r.$2j.symbolCustomColor),G.set(u.Folder,r.$2j.symbolFolder),G.set(u.TypeParameter,r.$2j.symbolTypeParameter),G.set(u.User,r.$2j.account),G.set(u.Issue,r.$2j.issues);function J(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=r.$2j.symbolProperty),De}z.toIcon=J;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function ue(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=u.Property),$e}z.fromString=ue})(P||(e.CompletionItemKinds=P={}));var p;(function(z){z[z.Deprecated=1]="Deprecated"})(p||(e.CompletionItemTag=p={}));var c;(function(z){z[z.None=0]="None",z[z.KeepWhitespace=1]="KeepWhitespace",z[z.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var g;(function(z){z[z.Word=0]="Word",z[z.Line=1]="Line",z[z.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var f;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var m;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(G,J,ee,ue){this.range=G,this.text=J,this.completionKind=ee,this.isSnippetText=ue}equals(G){return R.$Ft.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Au=n;var o;(function(z){z[z.Invoke=1]="Invoke",z[z.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var i;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var s;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function d(z){return z&&h.URI.isUri(z.uri)&&R.$Ft.isIRange(z.range)&&(R.$Ft.isIRange(z.originSelectionRange)||R.$Ft.isIRange(z.targetSelectionRange))}var a;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$Cu={[a.Array]:(0,T.localize)(0,null),[a.Boolean]:(0,T.localize)(1,null),[a.Class]:(0,T.localize)(2,null),[a.Constant]:(0,T.localize)(3,null),[a.Constructor]:(0,T.localize)(4,null),[a.Enum]:(0,T.localize)(5,null),[a.EnumMember]:(0,T.localize)(6,null),[a.Event]:(0,T.localize)(7,null),[a.Field]:(0,T.localize)(8,null),[a.File]:(0,T.localize)(9,null),[a.Function]:(0,T.localize)(10,null),[a.Interface]:(0,T.localize)(11,null),[a.Key]:(0,T.localize)(12,null),[a.Method]:(0,T.localize)(13,null),[a.Module]:(0,T.localize)(14,null),[a.Namespace]:(0,T.localize)(15,null),[a.Null]:(0,T.localize)(16,null),[a.Number]:(0,T.localize)(17,null),[a.Object]:(0,T.localize)(18,null),[a.Operator]:(0,T.localize)(19,null),[a.Package]:(0,T.localize)(20,null),[a.Property]:(0,T.localize)(21,null),[a.String]:(0,T.localize)(22,null),[a.Struct]:(0,T.localize)(23,null),[a.TypeParameter]:(0,T.localize)(24,null),[a.Variable]:(0,T.localize)(25,null)};function w(z,G){return(0,T.localize)(26,null,z,e.$Cu[G])}var y;(function(z){z[z.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var D;(function(z){const G=new Map;G.set(a.File,r.$2j.symbolFile),G.set(a.Module,r.$2j.symbolModule),G.set(a.Namespace,r.$2j.symbolNamespace),G.set(a.Package,r.$2j.symbolPackage),G.set(a.Class,r.$2j.symbolClass),G.set(a.Method,r.$2j.symbolMethod),G.set(a.Property,r.$2j.symbolProperty),G.set(a.Field,r.$2j.symbolField),G.set(a.Constructor,r.$2j.symbolConstructor),G.set(a.Enum,r.$2j.symbolEnum),G.set(a.Interface,r.$2j.symbolInterface),G.set(a.Function,r.$2j.symbolFunction),G.set(a.Variable,r.$2j.symbolVariable),G.set(a.Constant,r.$2j.symbolConstant),G.set(a.String,r.$2j.symbolString),G.set(a.Number,r.$2j.symbolNumber),G.set(a.Boolean,r.$2j.symbolBoolean),G.set(a.Array,r.$2j.symbolArray),G.set(a.Object,r.$2j.symbolObject),G.set(a.Key,r.$2j.symbolKey),G.set(a.Null,r.$2j.symbolNull),G.set(a.EnumMember,r.$2j.symbolEnumMember),G.set(a.Struct,r.$2j.symbolStruct),G.set(a.Event,r.$2j.symbolEvent),G.set(a.Operator,r.$2j.symbolOperator),G.set(a.TypeParameter,r.$2j.symbolTypeParameter);function J(ee){let ue=G.get(ee);return ue||(console.info("No codicon found for SymbolKind "+ee),ue=r.$2j.symbolProperty),ue}z.toIcon=J})(D||(e.SymbolKinds=D={}));class S{static asEditOperation(G){return A.$Gt.replace(R.$Ft.lift(G.range),G.text)}}e.$Eu=S;class I{static{this.Comment=new I("comment")}static{this.Imports=new I("imports")}static{this.Region=new I("region")}static fromValue(G){switch(G){case"comment":return I.Comment;case"imports":return I.Imports;case"region":return I.Region}return new I(G)}constructor(G){this.value=G}}e.$Fu=I;var k;(function(z){z[z.AIGenerated=1]="AIGenerated"})(k||(e.NewSymbolNameTag=k={}));var b;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(b||(e.NewSymbolNameTriggerKind=b={}));var v;(function(z){function G(J){return!J||typeof J!="object"?!1:typeof J.id=="string"&&typeof J.title=="string"}z.is=G})(v||(e.Command=v={}));var N;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var O;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(O||(e.CommentThreadState=O={}));var F;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(F||(e.CommentThreadApplicability=F={}));var j;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var B;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(B||(e.CommentState=B={}));var M;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class W{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Gu=W,e.$Hu=new L.$ou;var _;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var re;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(Ee[217],Se([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[218],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[219],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[220],Se([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[221],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[222],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[223],Se([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[224],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[225],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[226],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[227],Se([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[228],Se([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[229],Se([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[230],Se([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[231],Se([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[232],Se([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[233],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[234],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[235],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[236],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[237],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[238],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[239],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[240],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[241],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[242],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[243],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[244],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[245],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[246],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(Ee[247],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[248],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(Ee[249],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[250],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[251],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[252],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[253],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[254],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[255],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[256],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[257],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[258],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[259],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[260],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[261],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[262],Se([1,0,27,14,219]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var R;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...C){switch(C.length){case 1:return(0,A.localize)(0,null,C[0]);case 2:return(0,A.localize)(1,null,C[0],C[1]);case 3:return(0,A.localize)(2,null,C[0],C[1],C[2]);default:return}}const T=(0,A.localize)(3,null),$=(0,A.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return E.isTripleEq?"===":"==";case R.NotEq:return E.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return E.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return E.lexeme;case R.QuotedStr:return E.lexeme;case R.Error:return E.lexeme;case R.EOF:return"EOF";default:throw(0,h.$9)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const u=this.d,P=this.c.substring(this.d,this.e),p={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:u,lexeme:P,additionalInfo:E}),this.f.push(p)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const u=this.c.substring(this.d,this.e),P=l.b.get(u);P?this.k(P):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,u=!1,P=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const c=this.c.charCodeAt(E);if(u)u=!1;else if(c===r.CharCode.Slash&&!P){E++;break}else c===r.CharCode.OpenSquareBracket?P=!0:c===r.CharCode.Backslash?u=!0:c===r.CharCode.CloseSquareBracket&&(P=!1);E++}for(;E<this.c.length&&l.a.has(this.c.charCodeAt(E));)E++;this.e=E;const p=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=l});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[263],Se([1,0,23,44,222,411]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=$,e.$Sp=l,e.$Tp=C,e.$Up=E,e.$Vp=u,e.$Wp=P,e.$Xp=p,h=Wt(h),A=Ue(A),R=Ue(R);const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function $(f){return f=f.trim(),f==="*"||L.test(f)}function l(f){if(!$(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=f.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function C(f){if(!f)return null;const m=f.majorBase,n=f.majorMustEqual,o=f.minorBase;let i=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(m===0||(i=!1),s=!1);let d=0;if(f.preRelease){const a=T.exec(f.preRelease);if(a){const[,w,y,D]=a;d=Date.UTC(Number(w),Number(y)-1,Number(D))}}return{majorBase:m,majorMustEqual:n,minorBase:o,minorMustEqual:i,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:d}}function E(f,m,n){let o;typeof f=="string"?o=C(l(f)):o=f;let i;m instanceof Date?i=m.getTime():typeof m=="string"&&(i=new Date(m).getTime());let t;if(typeof n=="string"?t=C(l(n)):t=n,!o||!t)return!1;const s=o.majorBase,d=o.minorBase,a=o.patchBase;let w=t.majorBase,y=t.minorBase,D=t.patchBase;const S=t.notBefore;let I=t.majorMustEqual,k=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?s>w?!0:s<w?!1:d>y?!0:d<y||i&&i<S?!1:a>=D:(s===1&&w===0&&(!I||!k||!b)&&(w=1,y=0,D=0,I=!0,k=!1,b=!1),s<w?!1:s>w?!I:d<y?!1:d>y?!k:a<D?!1:a>D?!b:!(i&&i<S))}function u(f,m,n,o,i){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([h.default.Error,A.localize(0,null)]),t;if(typeof o.name!="string")return t.push([h.default.Error,A.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([h.default.Error,A.localize(2,null,"version")]),t;if(!o.engines)return t.push([h.default.Error,A.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([h.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!g(o.extensionDependencies))return t.push([h.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!g(o.activationEvents))return t.push([h.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([h.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([h.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([h.default.Error,A.localize(9,null,"main")]),t;{const a=(0,r.$dh)(n,o.main);(0,r.$0g)(a,n)||t.push([h.default.Warning,A.localize(10,null,a.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([h.default.Error,A.localize(11,null,"browser")]),t;{const a=(0,r.$dh)(n,o.browser);(0,r.$0g)(a,n)||t.push([h.default.Warning,A.localize(12,null,a.path,n.path)])}}if(!R.valid(o.version))return t.push([h.default.Error,A.localize(13,null)]),t;const s=[];if(!P(f,m,o,i,s))for(const a of s)t.push([h.default.Error,a]);return t}function P(f,m,n,o,i){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:c(f,m,n.engines.vscode,i)}function p(f,m,n){return f==="*"||c(m,n,f)}function c(f,m,n,o=[]){const i=C(l(n));if(!i)return o.push(A.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return o.push(A.localize(15,null,n)),!1}else if(!i.majorMustEqual)return o.push(A.localize(16,null,n)),!1;return E(f,m,i)?!0:(o.push(A.localize(17,null,f,n)),!1)}function g(f){if(!Array.isArray(f))return!1;for(let m=0,n=f.length;m<n;m++)if(typeof f[m]!="string")return!1;return!0}}),define(Ee[113],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class r{constructor(A,R=[],L=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$zi=r}),define(Ee[89],Se([1,0,113]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=R,e.$Js=L;const h=[];var A;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(T,$,l){$ instanceof r.$zi||($=new r.$zi($,[],!!l)),h.push([T,$])}function L(){return h}}),define(Ee[264],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class r{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$lr=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const T=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(L);T.outgoing.set($.key,$),$.incoming.set(T.key,T)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const T of this.a.values())T.outgoing.delete(L),T.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let T=this.a.get(L);return T||(T=new r(L,R),this.a.set(L,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,T]of this.a)R.push(`${L}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const T=new Set([R]),$=this.c(L,T);if($)return $}}c(R,L){for(const[T,$]of R.outgoing){if(L.has(T))return[...L,T].join(" -> ");L.add(T);const l=this.c($,L);if(l)return l;L.delete(T)}}}e.$mr=h}),define(Ee[5],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=A,e.$Di=R;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function T($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=T})(r||(e._util=r={})),e.$Bi=A("instantiationService");function h(L,T,$){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:L,index:$}):(T[r.DI_DEPENDENCIES]=[{id:L,index:$}],T[r.DI_TARGET]=T)}function A(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const T=function($,l,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(T,$,C)};return T.toString=()=>L,r.serviceIds.set(L,T),T}function R(L){return L}}),define(Ee[45],Se([1,0,18,2,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=R,e.$$i=L,e.$_i=$,e.$aj=l,e.$bj=C,e.$cj=E,e.$dj=u,e.$ej=p,e.$fj=c,e.$gj=g,r=Ue(r),e.$9i=(0,A.$Ci)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof h.URI)}function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof h.URI)}var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function $(f){switch(f){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function l(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function C(f,m){const n=Object.create(null);for(const o in f)E(n,o,f[o],m);return n}function E(f,m,n,o){const i=m.split("."),t=i.pop();let s=f;for(let d=0;d<i.length;d++){const a=i[d];let w=s[a];switch(typeof w){case"undefined":w=s[a]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${m} as ${i.slice(0,d+1).join(".")} is null`);return}break;default:o(`Ignoring ${m} as ${i.slice(0,d+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}function u(f,m){const n=m.split(".");P(f,n)}function P(f,m){const n=m.shift();if(m.length===0){delete f[n];return}if(Object.keys(f).indexOf(n)!==-1){const o=f[n];typeof o=="object"&&!Array.isArray(o)&&(P(o,m),Object.keys(o).length===0&&delete f[n])}}function p(f,m,n){function o(s,d){let a=s;for(const w of d){if(typeof a!="object"||a===null)return;a=a[w]}return a}const i=m.split("."),t=o(f,i);return typeof t>"u"?n:t}function c(f,m,n){Object.keys(m).forEach(o=>{o!=="__proto__"&&(o in f?r.$eg(f[o])&&r.$eg(m[o])?c(f[o],m[o],n):n&&(f[o]=m[o]):f[o]=m[o])})}function g(f){return f.replace(/[\[\]]/g,"")}}),define(Ee[36],Se([1,0,27,11,13,262,5,218,14]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=C,e.$Bj=d,e.$Cj=a,e.$Vj=ne;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",h.$j),l.set("isLinux",h.$k),l.set("isWindows",h.$i),l.set("isWeb",h.$o),l.set("isMacNative",h.$j&&!h.$o),l.set("isEdge",h.$H),l.set("isFirefox",h.$F),l.set("isChrome",h.$E),l.set("isSafari",h.$G);function C(Q,U){if(l.get(Q)!==void 0)throw(0,$.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(Q,U)}const E=Object.prototype.hasOwnProperty;var u;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const P={regexParsingWithErrorRecovery:!0},p=(0,T.localize)(0,null),c=(0,T.localize)(1,null),g=(0,T.localize)(2,null),f=(0,T.localize)(3,null),m=(0,T.localize)(4,null),n=(0,T.localize)(5,null),o=(0,T.localize)(6,null),i=(0,T.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=P){this.k=U,this.d=new R.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const oe=this.D(),te=oe.type===R.TokenType.Str?n:void 0;throw this.h.push({message:m,offset:oe.offset,lexeme:R.$xj.getLexeme(oe),additionalInfo:te}),t.c}return se}catch(se){if(se!==t.c)throw se;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();U.push(se)}return U.length===1?U[0]:s.or(...U)}o(){const U=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();U.push(se)}return U.length===1?U[0]:s.and(...U)}s(){if(this.y(R.TokenType.Neg)){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),y.INSTANCE;case R.TokenType.False:return this.z(),D.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se?.negate()}case R.TokenType.Str:return this.z(),N.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case R.TokenType.True:return this.z(),s.true();case R.TokenType.False:return this.z(),s.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se}case R.TokenType.Str:{const se=U.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,he=le.lastIndexOf("/"),X=he===le.length-1?void 0:this.w(le.substring(he+1));let ae;try{ae=new RegExp(le.substring(1,he),X)}catch{throw this.B("REGEX",te)}return W.create(se,ae)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const le=[te.lexeme];this.z();let he=this.D(),X=0;for(let We=0;We<te.lexeme.length;We++)te.lexeme.charCodeAt(We)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==R.TokenType.And&&he.type!==R.TokenType.Or;){switch(he.type){case R.TokenType.LParen:X++;break;case R.TokenType.RParen:X--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let We=0;We<he.lexeme.length;We++)he.lexeme.charCodeAt(We)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(We)===r.CharCode.CloseParen&&X--}if(X<0)break;le.push(R.$xj.getLexeme(he)),this.z(),he=this.D()}const ae=le.join(""),pe=ae.lastIndexOf("/"),be=pe===ae.length-1?void 0:this.w(ae.substring(pe+1));let Me;try{Me=new RegExp(ae.substring(1,pe),be)}catch{throw this.B("REGEX",te)}return s.regex(se,Me)}case R.TokenType.QuotedStr:{const le=te.lexeme;this.z();let he=null;if(!(0,A.$af)(le)){const X=le.indexOf("/"),ae=le.lastIndexOf("/");if(X!==ae&&X>=0){const pe=le.slice(X+1,ae),be=le[ae+1]==="i"?"i":"";try{he=new RegExp(pe,be)}catch{throw this.B("REGEX",te)}}}if(he===null)throw this.B("REGEX",te);return W.create(se,he)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,g);const te=this.u();return s.notIn(se,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.equals(se,te);switch(te){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.notEquals(se,te);switch(te){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,te)}}case R.TokenType.Lt:return this.z(),B.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),F.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case R.TokenType.EOF:throw this.h.push({message:o,offset:U.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),U.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,se){if(this.C(U))return this.z();throw this.B(se,this.D())}B(U,se,oe){const te=(0,T.localize)(8,null,U,R.$xj.getLexeme(se)),le=se.offset,he=R.$xj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:he,additionalInfo:oe}),t.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$zj=t;class s{static false(){return y.INSTANCE}static true(){return D.INSTANCE}static has(U){return S.create(U)}static equals(U,se){return I.create(U,se)}static notEquals(U,se){return v.create(U,se)}static regex(U,se){return W.create(U,se)}static in(U,se){return k.create(U,se)}static notIn(U,se){return b.create(U,se)}static not(U){return N.create(U)}static and(...U){return z.create(U,null,!0)}static or(...U){return G.create(U,null,!0)}static greater(U,se){return F.create(U,se)}static greaterEquals(U,se){return j.create(U,se)}static smaller(U,se){return B.create(U,se)}static smallerEquals(U,se){return M.create(U,se)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Aj=s;function d(Q){const U=new t({regexParsingWithErrorRecovery:!1});return Q.map(se=>(U.parse(se),U.lexingErrors.length>0?U.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,T.localize)(9,null,oe.additionalInfo):(0,T.localize)(10,null),offset:oe.offset,length:oe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function a(Q,U){const se=Q?Q.substituteConstants():void 0,oe=U?U.substituteConstants():void 0;return!se&&!oe?!0:!se||!oe?!1:se.equals(oe)}function w(Q,U){return Q.cmp(U)}class y{static{this.INSTANCE=new y}constructor(){this.type=u.False}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return D.INSTANCE}}e.$Dj=y;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return y.INSTANCE}}e.$Ej=D;class S{static create(U,se=null){const oe=l.get(U);return typeof oe=="boolean"?oe?D.INSTANCE:y.INSTANCE:new S(U,se)}constructor(U,se){this.key=U,this.c=se,this.type=u.Defined}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=l.get(this.key);return typeof U=="boolean"?U?D.INSTANCE:y.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Fj=S;class I{static create(U,se,oe=null){if(typeof se=="boolean")return se?S.create(U,oe):N.create(U,oe);const te=l.get(U);return typeof te=="boolean"?se===(te?"true":"false")?D.INSTANCE:y.INSTANCE:new I(U,se,oe)}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.Equals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=l.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?D.INSTANCE:y.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Gj=I;class k{static create(U,se){return new k(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.In,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.f),oe=U.getValue(this.d);return Array.isArray(se)?se.includes(oe):typeof oe=="string"&&typeof se=="object"&&se!==null?E.call(se,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Hj=k;class b{static create(U,se){return new b(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.NotIn,this.c=k.create(U,se)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=b;class v{static create(U,se,oe=null){if(typeof se=="boolean")return se?N.create(U,oe):S.create(U,oe);const te=l.get(U);return typeof te=="boolean"?se===(te?"true":"false")?y.INSTANCE:D.INSTANCE:new v(U,se,oe)}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.NotEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=l.get(this.c);if(typeof U=="boolean"){const se=U?"true":"false";return this.d===se?y.INSTANCE:D.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Jj=v;class N{static create(U,se=null){const oe=l.get(U);return typeof oe=="boolean"?oe?y.INSTANCE:D.INSTANCE:new N(U,se)}constructor(U,se){this.c=U,this.d=se,this.type=u.Not}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=l.get(this.c);return typeof U=="boolean"?U?y.INSTANCE:D.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$Kj=N;function O(Q,U){if(typeof Q=="string"){const se=parseFloat(Q);isNaN(se)||(Q=se)}return typeof Q=="string"||typeof Q=="number"?U(Q):y.INSTANCE}class F{static create(U,se,oe=null){return O(se,te=>new F(U,te,oe))}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.Greater}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=F;class j{static create(U,se,oe=null){return O(se,te=>new j(U,te,oe))}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.GreaterEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Mj=j;class B{static create(U,se,oe=null){return O(se,te=>new B(U,te,oe))}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.Smaller}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=B;class M{static create(U,se,oe=null){return O(se,te=>new M(U,te,oe))}constructor(U,se,oe){this.c=U,this.d=se,this.f=oe,this.type=u.SmallerEquals}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=M;class W{static create(U,se){return new W(U,se)}constructor(U,se){this.d=U,this.f=se,this.type=u.Regex,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const se=this.f?this.f.source:"",oe=U.f?U.f.source:"";return se<oe?-1:se>oe?1:0}equals(U){if(U.type===this.type){const se=this.f?this.f.source:"",oe=U.f?U.f.source:"";return this.d===U.d&&se===oe}return!1}substituteConstants(){return this}evaluate(U){const se=U.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Pj=W;class _{static create(U){return new _(U)}constructor(U){this.c=U,this.type=u.NotRegex}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new _(this.c.map(U))}negate(){return this.c}}e.$Qj=_;function re(Q){let U=null;for(let se=0,oe=Q.length;se<oe;se++){const te=Q[se].substituteConstants();if(Q[se]!==te&&U===null){U=[];for(let le=0;le<se;le++)U[le]=Q[le]}U!==null&&(U[se]=te)}return U===null?Q:U}class z{static create(U,se,oe){return z.d(U,se,oe)}constructor(U,se){this.expr=U,this.c=se,this.type=u.And}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=re(this.expr);return U===this.expr?this:z.create(U,this.c,!1)}evaluate(U){for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].evaluate(U))return!1;return!0}static d(U,se,oe){const te=[];let le=!1;for(const he of U)if(he){if(he.type===u.True){le=!0;continue}if(he.type===u.False)return y.INSTANCE;if(he.type===u.And){te.push(...he.expr);continue}te.push(he)}if(te.length===0&&le)return D.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];for(;te.length>1;){const he=te[te.length-1];if(he.type!==u.Or)break;te.pop();const X=te.pop(),ae=te.length===0,pe=G.create(he.expr.map(be=>z.create([be,X],null,oe)),null,ae);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let X=he+1;X<te.length;X++)if(te[he].negate().equals(te[X]))return y.INSTANCE;if(te.length===1)return te[0]}return new z(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new z(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());this.c=G.create(U,this,!0)}return this.c}}e.$Rj=z;class G{static create(U,se,oe){return G.d(U,se,oe)}constructor(U,se){this.expr=U,this.c=se,this.type=u.Or}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],U.expr[se]);if(te!==0)return te}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(U.expr[se]))return!1;return!0}return!1}substituteConstants(){const U=re(this.expr);return U===this.expr?this:G.create(U,this.c,!1)}evaluate(U){for(let se=0,oe=this.expr.length;se<oe;se++)if(this.expr[se].evaluate(U))return!0;return!1}static d(U,se,oe){let te=[],le=!1;if(U){for(let he=0,X=U.length;he<X;he++){const ae=U[he];if(ae){if(ae.type===u.False){le=!0;continue}if(ae.type===u.True)return D.INSTANCE;if(ae.type===u.Or){te=te.concat(ae.expr);continue}te.push(ae)}}if(te.length===0&&le)return y.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let X=he+1;X<te.length;X++)if(te[he].negate().equals(te[X]))return D.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const se of this.expr)U.push(...se.keys());return U}map(U){return new G(this.expr.map(se=>se.map(U)),null)}negate(){if(!this.c){const U=[];for(const se of this.expr)U.push(se.negate());for(;U.length>1;){const se=U.shift(),oe=U.shift(),te=[];for(const le of $e(se))for(const he of $e(oe))te.push(z.create([le,he],null,!1));U.unshift(G.create(te,null,!1))}this.c=G.create(U,this,!0)}return this.c}}e.$Sj=G;class J extends S{static{this.d=[]}static all(){return J.d.values()}constructor(U,se,oe){super(U,null),this.f=se,typeof oe=="object"?J.d.push({...oe,key:U}):oe!==!0&&J.d.push({key:U,description:oe,type:se!=null?typeof se:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return I.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$Tj=J,e.$Uj=(0,L.$Ci)("contextKeyService");function ee(Q,U){return Q<U?-1:Q>U?1:0}function ue(Q,U,se,oe){return Q<se?-1:Q>se?1:U<oe?-1:U>oe?1:0}function ne(Q,U){if(Q.type===u.False||U.type===u.True)return!0;if(Q.type===u.Or)return U.type===u.Or?De(Q.expr,U.expr):!1;if(U.type===u.Or){for(const se of U.expr)if(ne(Q,se))return!0;return!1}if(Q.type===u.And){if(U.type===u.And)return De(U.expr,Q.expr);for(const se of Q.expr)if(ne(se,U))return!0;return!1}return Q.equals(U)}function De(Q,U){let se=0,oe=0;for(;se<Q.length&&oe<U.length;){const te=Q[se].cmp(U[oe]);if(te<0)return!1;te===0&&se++,oe++}return se===Q.length}function $e(Q){return Q.type===u.Or?Q.expr:[Q]}}),define(Ee[265],Se([1,0,36,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$jt=e.AccessibilitySupport=e.$it=void 0,e.$kt=R,e.$it=(0,h.$Ci)("accessibilityService");var A;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$jt=new r.$Tj("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$lt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[114],Se([1,0,19,25,11,183,84,191,138,215,265]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=s,e.stringSet=w,e.cursorStyleToString=O,e.filterValidationDecorations=Ie,r=Ue(r),h=Ue(h),A=Ue(A),l=Ue(l);var E;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(de){this.c=de}hasChanged(de){return this.c[de]}}e.ConfigurationChangedEvent=u;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class p{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}compute(de,Ce,Xe){return Xe}}class c{constructor(de,Ce){this.newValue=de,this.didChange=Ce}}e.ApplyUpdateResult=c;function g(Z,de){if(typeof Z!="object"||typeof de!="object"||!Z||!de)return new c(de,Z!==de);if(Array.isArray(Z)||Array.isArray(de)){const Xe=Array.isArray(Z)&&Array.isArray(de)&&r.$vb(Z,de);return new c(de,!Xe)}let Ce=!1;for(const Xe in de)if(de.hasOwnProperty(Xe)){const _e=g(Z[Xe],de[Xe]);_e.didChange&&(Z[Xe]=_e.newValue,Ce=!0)}return new c(Z,Ce)}class f{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return this.defaultValue}}class m{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,Ce,Xe){return Xe}}function n(Z,de){return typeof Z>"u"?de:Z==="false"?!1:!!Z}class o extends m{constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return n(de,this.defaultValue)}}function i(Z,de,Ce,Xe){if(typeof Z>"u")return de;let _e=parseInt(Z,10);return isNaN(_e)?de:(_e=Math.max(Ce,_e),_e=Math.min(Xe,_e),_e|0)}class t extends m{static clampedInt(de,Ce,Xe,_e){return i(de,Ce,Xe,_e)}constructor(de,Ce,Xe,_e,lt,ft=void 0){typeof ft<"u"&&(ft.type="integer",ft.default=Xe,ft.minimum=_e,ft.maximum=lt),super(de,Ce,Xe,ft),this.minimum=_e,this.maximum=lt}validate(de){return t.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function s(Z,de,Ce,Xe){if(typeof Z>"u")return de;const _e=d.float(Z,de);return d.clamp(_e,Ce,Xe)}class d extends m{static clamp(de,Ce,Xe){return de<Ce?Ce:de>Xe?Xe:de}static float(de,Ce){if(typeof de=="number")return de;if(typeof de>"u")return Ce;const Xe=parseFloat(de);return isNaN(Xe)?Ce:Xe}constructor(de,Ce,Xe,_e,lt){typeof lt<"u"&&(lt.type="number",lt.default=Xe),super(de,Ce,Xe,lt),this.validationFn=_e}validate(de){return this.validationFn(d.float(de,this.defaultValue))}}class a extends m{static string(de,Ce){return typeof de!="string"?Ce:de}constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return a.string(de,this.defaultValue)}}function w(Z,de,Ce,Xe){return typeof Z!="string"?de:Xe&&Z in Xe?Xe[Z]:Ce.indexOf(Z)===-1?de:Z}class y extends m{constructor(de,Ce,Xe,_e,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Xe),super(de,Ce,Xe,lt),this.c=_e}validate(de){return w(de,this.defaultValue,this.c)}}class D extends p{constructor(de,Ce,Xe,_e,lt,ft,kt=void 0){typeof kt<"u"&&(kt.type="string",kt.enum=lt,kt.default=_e),super(de,Ce,Xe,kt),this.c=lt,this.d=ft}validate(de){return typeof de!="string"?this.defaultValue:this.c.indexOf(de)===-1?this.defaultValue:this.d(de)}}function S(Z){switch(Z){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class I extends p{constructor(){super(Fe.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(de){switch(de){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,Ce,Xe){return Xe===C.AccessibilitySupport.Unknown?de.accessibilitySupport:Xe}}class k extends p{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(Fe.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:l.localize(5,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var b;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(b||(e.TextEditorCursorBlinkingStyle=b={}));function v(Z){switch(Z){case"blink":return b.Blink;case"smooth":return b.Smooth;case"phase":return b.Phase;case"expand":return b.Expand;case"solid":return b.Solid}}var N;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function O(Z){switch(Z){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function F(Z){switch(Z){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class j extends f{constructor(){super(Fe.editorClassName)}compute(de,Ce,Xe){const _e=["monaco-editor"];return Ce.get(Fe.extraEditorClassName)&&_e.push(Ce.get(Fe.extraEditorClassName)),de.extraEditorClassName&&_e.push(de.extraEditorClassName),Ce.get(Fe.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(Fe.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(Fe.showUnused)&&_e.push("showUnused"),Ce.get(Fe.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class B extends o{constructor(){super(Fe.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(de,Ce,Xe){return Xe&&de.emptySelectionClipboard}}class M extends p{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Fe.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:l.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:l.localize(18,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":w(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":w(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class W extends p{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Fe.fontLigatures,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?W.OFF:de==="true"?W.ON:de:de?W.ON:W.OFF}}e.EditorFontLigatures=W;class _ extends p{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Fe.fontVariations,"fontVariations",_.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?_.OFF:de==="true"?_.TRANSLATE:de:de?_.TRANSLATE:_.OFF}compute(de,Ce,Xe){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=_;class re extends f{constructor(){super(Fe.fontInfo)}compute(de,Ce,Xe){return de.fontInfo}}class z extends m{constructor(){super(Fe.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(de){const Ce=d.float(de,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ce,6,100)}compute(de,Ce,Xe){return de.fontInfo.fontSize}}class G extends p{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Fe.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(de){return de==="normal"||de==="bold"?de:String(t.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class J extends p{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Fe.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Xe,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Xe,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Xe,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Xe,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Xe,description:l.localize(41,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:a.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:a.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:a.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:a.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:a.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends p{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Fe.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:de.above,description:l.localize(46,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var ue;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class ne extends f{constructor(){super(Fe.layoutInfo)}compute(de,Ce,Xe){return ne.computeLayout(Ce,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const Ce=de.height/de.lineHeight,Xe=Math.floor(de.paddingTop/de.lineHeight);let _e=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const lt=(Xe+de.viewLineCount+_e)/(de.pixelRatio*de.height),ft=Math.floor(de.viewLineCount/lt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:_e,desiredRatio:lt,minimapLineCount:ft}}static c(de,Ce){const Xe=de.outerWidth,_e=de.outerHeight,lt=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const ft=Ce.stableMinimapLayoutInput,kt=ft&&de.outerHeight===ft.outerHeight&&de.lineHeight===ft.lineHeight&&de.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&de.pixelRatio===ft.pixelRatio&&de.scrollBeyondLastLine===ft.scrollBeyondLastLine&&de.paddingTop===ft.paddingTop&&de.paddingBottom===ft.paddingBottom&&de.minimap.enabled===ft.minimap.enabled&&de.minimap.side===ft.minimap.side&&de.minimap.size===ft.minimap.size&&de.minimap.showSlider===ft.minimap.showSlider&&de.minimap.renderCharacters===ft.minimap.renderCharacters&&de.minimap.maxColumn===ft.minimap.maxColumn&&de.minimap.scale===ft.minimap.scale&&de.verticalScrollbarWidth===ft.verticalScrollbarWidth&&de.isViewportWrapping===ft.isViewportWrapping,Tt=de.lineHeight,zt=de.typicalHalfwidthCharacterWidth,ui=de.scrollBeyondLastLine,it=de.minimap.renderCharacters;let Ct=lt>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const Kt=de.minimap.maxColumn,mt=de.minimap.size,bt=de.minimap.side,hi=de.verticalScrollbarWidth,ei=de.viewLineCount,Ut=de.remainingWidth,wt=de.isViewportWrapping,Vt=it?2:3;let Yt=Math.floor(lt*_e);const Xt=Yt/lt;let xe=!1,$i=!1,ti=Vt*Ct,si=Ct/lt,Dt=1;if(mt==="fill"||mt==="fit"){const{typicalViewportLineCount:qt,extraLinesBeforeFirstLine:Qt,extraLinesBeyondLastLine:di,desiredRatio:jt,minimapLineCount:vt}=ne.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:ui,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:_e,lineHeight:Tt,pixelRatio:lt});if(ei/vt>1)xe=!0,$i=!0,Ct=1,ti=1,si=Ct/lt;else{let Ot=!1,It=Ct+1;if(mt==="fit"){const Zt=Math.ceil((Qt+ei+di)*ti);wt&&kt&&Ut<=Ce.stableFitRemainingWidth?(Ot=!0,It=Ce.stableFitMaxMinimapScale):Ot=Zt>Yt}if(mt==="fill"||Ot){xe=!0;const Zt=Ct;ti=Math.min(Tt*lt,Math.max(1,Math.floor(1/jt))),wt&&kt&&Ut<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),Ct=Math.min(It,Math.max(1,Math.floor(ti/Vt))),Ct>Zt&&(Dt=Math.min(2,Ct/Zt)),si=Ct/lt/Dt,Yt=Math.ceil(Math.max(qt,Qt+ei+di)*ti),wt?(Ce.stableMinimapLayoutInput=de,Ce.stableFitRemainingWidth=Ut,Ce.stableFitMaxMinimapScale=Ct):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Jt=Math.floor(Kt*si),Lt=Math.min(Jt,Math.max(0,Math.floor((Ut-hi-2)*si/(zt+si)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(lt*Lt);const ii=Ft/lt;Ft=Math.floor(Ft*Dt);const ni=it?ue.Text:ue.Blocks,oi=bt==="left"?0:Xe-Lt-hi;return{renderMinimap:ni,minimapLeft:oi,minimapWidth:Lt,minimapHeightIsEditorHeight:xe,minimapIsSampling:$i,minimapScale:Ct,minimapLineHeight:ti,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:Yt,minimapCanvasOuterWidth:ii,minimapCanvasOuterHeight:Xt}}static computeLayout(de,Ce){const Xe=Ce.outerWidth|0,_e=Ce.outerHeight|0,lt=Ce.lineHeight|0,ft=Ce.lineNumbersDigitCount|0,kt=Ce.typicalHalfwidthCharacterWidth,Tt=Ce.maxDigitWidth,zt=Ce.pixelRatio,ui=Ce.viewLineCount,it=de.get(Fe.wordWrapOverride2),Ct=it==="inherit"?de.get(Fe.wordWrapOverride1):it,Kt=Ct==="inherit"?de.get(Fe.wordWrap):Ct,mt=de.get(Fe.wordWrapColumn),bt=Ce.isDominatedByLongLines,hi=de.get(Fe.glyphMargin),ei=de.get(Fe.lineNumbers).renderType!==We.Off,Ut=de.get(Fe.lineNumbersMinChars),wt=de.get(Fe.scrollBeyondLastLine),Vt=de.get(Fe.padding),Yt=de.get(Fe.minimap),Xt=de.get(Fe.scrollbar),xe=Xt.verticalScrollbarSize,$i=Xt.verticalHasArrows,ti=Xt.arrowSize,si=Xt.horizontalScrollbarSize,Dt=de.get(Fe.folding),Jt=de.get(Fe.showFoldingControls)!=="never";let Lt=de.get(Fe.lineDecorationsWidth);Dt&&Jt&&(Lt+=16);let Ft=0;if(ei){const pi=Math.max(ft,Ut);Ft=Math.round(pi*Tt)}let ii=0;hi&&(ii=lt*Ce.glyphMarginDecorationLaneCount);let ni=0,oi=ni+ii,qt=oi+Ft,Qt=qt+Lt;const di=Xe-ii-Ft-Lt;let jt=!1,vt=!1,Pt=-1;Ct==="inherit"&&bt?(jt=!0,vt=!0):Kt==="on"||Kt==="bounded"?vt=!0:Kt==="wordWrapColumn"&&(Pt=mt);const Ot=ne.c({outerWidth:Xe,outerHeight:_e,lineHeight:lt,typicalHalfwidthCharacterWidth:kt,pixelRatio:zt,scrollBeyondLastLine:wt,paddingTop:Vt.top,paddingBottom:Vt.bottom,minimap:Yt,verticalScrollbarWidth:xe,viewLineCount:ui,remainingWidth:di,isViewportWrapping:vt},Ce.memory||new P);Ot.renderMinimap!==ue.None&&Ot.minimapLeft===0&&(ni+=Ot.minimapWidth,oi+=Ot.minimapWidth,qt+=Ot.minimapWidth,Qt+=Ot.minimapWidth);const It=di-Ot.minimapWidth,Zt=Math.max(1,Math.floor((It-xe-2)/kt)),Ht=$i?ti:0;return vt&&(Pt=Math.max(1,Zt),Kt==="bounded"&&(Pt=Math.min(Pt,mt))),{width:Xe,height:_e,glyphMarginLeft:ni,glyphMarginWidth:ii,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Ft,decorationsLeft:qt,decorationsWidth:Lt,contentLeft:Qt,contentWidth:It,minimap:Ot,viewportColumn:Zt,isWordWrapMinified:jt,isViewportWrapping:vt,wrappingColumn:Pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:si,overviewRuler:{top:Ht,width:xe,height:_e-2*Ht,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends p{constructor(){super(Fe.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(de){return w(de,"simple",["simple","advanced"])}compute(de,Ce,Xe){return Ce.get(Fe.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":Xe}}var $e;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class Q extends p{constructor(){const de={enabled:$e.On};super(Fe.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:de.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:w(de.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class U extends p{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Fe.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:l.localize(57,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends p{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Fe.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:l.localize(65,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:w(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class oe extends p{constructor(){super(Fe.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):t.clampedInt(de,this.defaultValue,0,1e3)}compute(de,Ce,Xe){return Xe<0?t.clampedInt(-Xe*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends d{constructor(){super(Fe.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>d.clamp(de,0,150),{markdownDescription:l.localize(66,null)})}compute(de,Ce,Xe){return de.fontInfo.lineHeight}}class le extends p{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Fe.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:de.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:w(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ce.side,this.defaultValue.side,["right","left"]),showSlider:w(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(Z){return Z==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class X extends p{constructor(){super(Fe.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class ae extends p{constructor(){const de={enabled:!0,cycle:!0};super(Fe.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:l.localize(85,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class pe extends f{constructor(){super(Fe.pixelRatio)}compute(de,Ce,Xe){return de.pixelRatio}}class be extends p{constructor(){super(Fe.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Me extends p{constructor(){const de={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Fe.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:de.strings,description:l.localize(89,null)},comments:{anyOf:Ce,default:de.comments,description:l.localize(90,null)},other:{anyOf:Ce,default:de.other,description:l.localize(91,null)}},default:de,markdownDescription:l.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const zt=de?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!de||typeof de!="object")return this.defaultValue;const{other:Ce,comments:Xe,strings:_e}=de,lt=["on","inline","off"];let ft,kt,Tt;return typeof Ce=="boolean"?ft=Ce?"on":"off":ft=w(Ce,this.defaultValue.other,lt),typeof Xe=="boolean"?kt=Xe?"on":"off":kt=w(Xe,this.defaultValue.comments,lt),typeof _e=="boolean"?Tt=_e?"on":"off":Tt=w(_e,this.defaultValue.strings,lt),{other:ft,comments:kt,strings:Tt}}}var We;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(We||(e.RenderLineNumbersType=We={}));class ke extends p{constructor(){super(Fe.lineNumbers,"lineNumbers",{renderType:We.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(de){let Ce=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(Ce=We.Custom,Xe=de):de==="interval"?Ce=We.Interval:de==="relative"?Ce=We.Relative:de==="on"?Ce=We.On:Ce=We.Off),{renderType:Ce,renderFn:Xe}}}function Ie(Z){const de=Z.get(Fe.renderValidationDecorations);return de==="editable"?Z.get(Fe.readOnly):de!=="on"}class Te extends p{constructor(){const de=[],Ce={type:"number",description:l.localize(98,null)};super(Fe.rulers,"rulers",de,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:de,description:l.localize(100,null)})}validate(de){if(Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="number")Ce.push({column:t.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const _e=Xe;Ce.push({column:t.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Xe,_e)=>Xe.column-_e.column),Ce}return this.defaultValue}}class V extends p{constructor(){super(Fe.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function q(Z,de){if(typeof Z!="string")return de;switch(Z){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class Y extends p{constructor(){const de={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Fe.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de,Xe=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:q(Ce.vertical,this.defaultValue.vertical),horizontal:q(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends p{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Fe.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:l.localize(119,null)}})}applyUpdate(de,Ce){let Xe=!1;Ce.allowedCharacters&&de&&(h.$do(de.allowedCharacters,Ce.allowedCharacters)||(de={...de,allowedCharacters:Ce.allowedCharacters},Xe=!0)),Ce.allowedLocales&&de&&(h.$do(de.allowedLocales,Ce.allowedLocales)||(de={...de,allowedLocales:Ce.allowedLocales},Xe=!0));const _e=super.applyUpdate(de,Ce);return Xe?new c(_e.newValue,!0):_e}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{nonBasicASCII:Je(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Je(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Je(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(de.allowedLocales,this.defaultValue.allowedLocales)}}c(de,Ce){if(typeof de!="object"||!de)return Ce;const Xe={};for(const[_e,lt]of Object.entries(de))lt===!0&&(Xe[_e]=!0);return Xe}}class fe extends p{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Fe.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(126,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:w(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class we extends p{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Fe.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:de.backgroundColoring,description:l.localize(133,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends p{constructor(){const de={enabled:T.$ct.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$ct.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Fe.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends p{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Fe.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:de.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:de.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:de.highlightActiveIndentation,description:l.localize(149,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{bracketPairs:Je(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Je(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Je(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Je(Z,de,Ce){const Xe=Ce.indexOf(Z);return Xe===-1?de:Ce[Xe]}class tt extends p{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Fe.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:de.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:de.selectionMode,markdownDescription:l.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertMode:w(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:w(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends p{constructor(){super(Fe.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(de.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends p{constructor(){const de=[];super(Fe.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Ce.push(Xe)}catch{}return Ce}return this.defaultValue}}var nt;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends p{constructor(){super(Fe.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(de){switch(de){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(de,Ce,Xe){return Ce.get(Fe.accessibilitySupport)===C.AccessibilitySupport.Enabled?nt.None:Xe}}class $t extends f{constructor(){super(Fe.wrappingInfo)}compute(de,Ce,Xe){const _e=Ce.get(Fe.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class ht extends p{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(Fe.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:w(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends p{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(Fe.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:w(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?Be:A.$k?Ke:Pe,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var Fe;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.placeholder=88]="placeholder",Z[Z.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=90]="quickSuggestions",Z[Z.quickSuggestionsDelay=91]="quickSuggestionsDelay",Z[Z.readOnly=92]="readOnly",Z[Z.readOnlyMessage=93]="readOnlyMessage",Z[Z.renameOnType=94]="renameOnType",Z[Z.renderControlCharacters=95]="renderControlCharacters",Z[Z.renderFinalNewline=96]="renderFinalNewline",Z[Z.renderLineHighlight=97]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=99]="renderValidationDecorations",Z[Z.renderWhitespace=100]="renderWhitespace",Z[Z.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Z[Z.roundedSelection=102]="roundedSelection",Z[Z.rulers=103]="rulers",Z[Z.scrollbar=104]="scrollbar",Z[Z.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=106]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=107]="scrollPredominantAxis",Z[Z.selectionClipboard=108]="selectionClipboard",Z[Z.selectionHighlight=109]="selectionHighlight",Z[Z.selectOnLineNumbers=110]="selectOnLineNumbers",Z[Z.showFoldingControls=111]="showFoldingControls",Z[Z.showUnused=112]="showUnused",Z[Z.snippetSuggestions=113]="snippetSuggestions",Z[Z.smartSelect=114]="smartSelect",Z[Z.smoothScrolling=115]="smoothScrolling",Z[Z.stickyScroll=116]="stickyScroll",Z[Z.stickyTabStops=117]="stickyTabStops",Z[Z.stopRenderingLineAfter=118]="stopRenderingLineAfter",Z[Z.suggest=119]="suggest",Z[Z.suggestFontSize=120]="suggestFontSize",Z[Z.suggestLineHeight=121]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Z[Z.suggestSelection=123]="suggestSelection",Z[Z.tabCompletion=124]="tabCompletion",Z[Z.tabIndex=125]="tabIndex",Z[Z.unicodeHighlighting=126]="unicodeHighlighting",Z[Z.unusualLineTerminators=127]="unusualLineTerminators",Z[Z.useShadowDOM=128]="useShadowDOM",Z[Z.useTabStops=129]="useTabStops",Z[Z.wordBreak=130]="wordBreak",Z[Z.wordSegmenterLocales=131]="wordSegmenterLocales",Z[Z.wordSeparators=132]="wordSeparators",Z[Z.wordWrap=133]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=136]="wordWrapColumn",Z[Z.wordWrapOverride1=137]="wordWrapOverride1",Z[Z.wordWrapOverride2=138]="wordWrapOverride2",Z[Z.wrappingIndent=139]="wrappingIndent",Z[Z.wrappingStrategy=140]="wrappingStrategy",Z[Z.showDeprecated=141]="showDeprecated",Z[Z.inlayHints=142]="inlayHints",Z[Z.editorClassName=143]="editorClassName",Z[Z.pixelRatio=144]="pixelRatio",Z[Z.tabFocusMode=145]="tabFocusMode",Z[Z.layoutInfo=146]="layoutInfo",Z[Z.wrappingInfo=147]="wrappingInfo",Z[Z.defaultColorDecorators=148]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Fe||(e.EditorOption=Fe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new o(Fe.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:Oe(new y(Fe.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:Oe(new I),accessibilityPageSize:Oe(new t(Fe.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:Oe(new a(Fe.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:Oe(new o(Fe.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new o(Fe.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new y(Fe.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:Oe(new y(Fe.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:Oe(new y(Fe.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:Oe(new y(Fe.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:Oe(new y(Fe.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:Oe(new D(Fe.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:Oe(new o(Fe.automaticLayout,"automaticLayout",!1)),autoSurround:Oe(new y(Fe.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:Oe(new Ne),bracketPairGuides:Oe(new Ge),stickyTabStops:Oe(new o(Fe.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:Oe(new o(Fe.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:Oe(new a(Fe.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:Oe(new t(Fe.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:Oe(new o(Fe.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:Oe(new y(Fe.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:Oe(new t(Fe.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:Oe(new o(Fe.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:Oe(new k),contextmenu:Oe(new o(Fe.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new o(Fe.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:Oe(new D(Fe.cursorBlinking,"cursorBlinking",b.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:Oe(new y(Fe.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:Oe(new D(Fe.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:l.localize(261,null)})),cursorSurroundingLines:Oe(new t(Fe.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:Oe(new y(Fe.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:Oe(new t(Fe.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:Oe(new o(Fe.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new o(Fe.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new o(Fe.domReadOnly,"domReadOnly",!1)),dragAndDrop:Oe(new o(Fe.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:Oe(new B),dropIntoEditor:Oe(new ht),stickyScroll:Oe(new U),experimentalWhitespaceRendering:Oe(new y(Fe.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:Oe(new a(Fe.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Oe(new d(Fe.fastScrollSensitivity,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:l.localize(272,null)})),find:Oe(new M),fixedOverflowWidgets:Oe(new o(Fe.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Oe(new o(Fe.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:Oe(new y(Fe.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:Oe(new o(Fe.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:Oe(new o(Fe.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:Oe(new t(Fe.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:Oe(new o(Fe.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:Oe(new a(Fe.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:Oe(new re),fontLigatures2:Oe(new W),fontSize:Oe(new z),fontWeight:Oe(new G),fontVariations:Oe(new _),formatOnPaste:Oe(new o(Fe.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:Oe(new o(Fe.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:Oe(new o(Fe.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:Oe(new J),hideCursorInOverviewRuler:Oe(new o(Fe.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:Oe(new ee),inDiffEditor:Oe(new o(Fe.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Oe(new d(Fe.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>d.clamp(Z,-5,20),{description:l.localize(286,null)})),lightbulb:Oe(new Q),lineDecorationsWidth:Oe(new oe),lineHeight:Oe(new te),lineNumbers:Oe(new ke),lineNumbersMinChars:Oe(new t(Fe.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new o(Fe.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:Oe(new o(Fe.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:Oe(new y(Fe.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:Oe(new le),mouseStyle:Oe(new y(Fe.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new d(Fe.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:Oe(new o(Fe.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$j?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:Oe(new o(Fe.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:Oe(new D(Fe.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:Oe(new y(Fe.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:Oe(new t(Fe.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:Oe(new y(Fe.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:Oe(new o(Fe.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:Oe(new t(Fe.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Oe(new X),pasteAs:Oe(new at),parameterHints:Oe(new ae),peekWidgetDefaultFocus:Oe(new y(Fe.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),placeholder:Oe(new be),definitionLinkOpensInPeek:Oe(new o(Fe.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:Oe(new Me),quickSuggestionsDelay:Oe(new t(Fe.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:Oe(new o(Fe.readOnly,"readOnly",!1)),readOnlyMessage:Oe(new V),renameOnType:Oe(new o(Fe.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:Oe(new o(Fe.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:Oe(new y(Fe.renderFinalNewline,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:Oe(new y(Fe.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Oe(new o(Fe.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:Oe(new y(Fe.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new y(Fe.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:Oe(new t(Fe.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new o(Fe.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:Oe(new Te),scrollbar:Oe(new Y),scrollBeyondLastColumn:Oe(new t(Fe.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:Oe(new o(Fe.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:Oe(new o(Fe.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:Oe(new o(Fe.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:A.$k})),selectionHighlight:Oe(new o(Fe.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:Oe(new o(Fe.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new y(Fe.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:Oe(new o(Fe.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:Oe(new o(Fe.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:Oe(new se),snippetSuggestions:Oe(new y(Fe.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:Oe(new rt),smoothScrolling:Oe(new o(Fe.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:Oe(new t(Fe.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Oe(new tt),inlineSuggest:Oe(new fe),inlineEdit:Oe(new we),inlineCompletionsAccessibilityVerbose:Oe(new o(Fe.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:Oe(new t(Fe.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new t(Fe.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new o(Fe.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:Oe(new y(Fe.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:Oe(new y(Fe.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:Oe(new t(Fe.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Oe(new x),unusualLineTerminators:Oe(new y(Fe.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:Oe(new o(Fe.useShadowDOM,"useShadowDOM",!0)),useTabStops:Oe(new o(Fe.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:Oe(new y(Fe.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:Oe(new ot),wordSeparators:Oe(new a(Fe.wordSeparators,"wordSeparators",$.$dt,{description:l.localize(360,null)})),wordWrap:Oe(new y(Fe.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:Oe(new a(Fe.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new a(Fe.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new t(Fe.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:Oe(new y(Fe.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new y(Fe.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new j),defaultColorDecorators:Oe(new o(Fe.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:Oe(new pe),tabFocusMode:Oe(new o(Fe.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:Oe(new ne),wrappingInfo:Oe(new $t),wrappingIndent:Oe(new ct),wrappingStrategy:Oe(new De)}});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[266],Se([1,0,23,44,220,5,110,11,25]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$2w=e.$1w=e.$Zw=void 0,e.$3w=P,e.$4w=p,h=Wt(h),e.$Zw=(0,R.$Ci)("dialogService");var l;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(l||(l={}));class C{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,f){const m=[];switch(f){case l.Confirmation:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(1,null));break}case l.Prompt:{const n=g;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,A.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,A.localize)(3,null))),m.length===0&&m.push((0,A.localize)(4,null));break}case l.Input:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(6,null));break}}return m}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===h.default.Info?"info":g===h.default.Error?"error":g===h.default.Warning?"warning":"none"}f(g,f,m){const n=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&n.push(g.cancelButton);let o=n[f]?.run({checkboxChecked:m});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:m}}}e.$1w=C,e.$2w=(0,R.$Ci)("fileDialogService");var E;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const u=10;function P(c){const g=[];return g.push(...c.slice(0,u).map(f=>typeof f=="string"?f:(0,r.$ah)(f))),c.length>u&&(c.length-u===1?g.push((0,A.localize)(7,null)):g.push((0,A.localize)(8,null,c.length-u))),g.push(""),g.join(`
`)}function p(c,g){const f=(0,$.$_n)(c);let m=(f.buttons??[]).map(t=>(0,L.$Ww)(t)),n=(c.buttons||[]).map((t,s)=>s),o=0,i=f.cancelId??m.length-1;if(m.length>1){const t=typeof i=="number"?m[i]:void 0;if(T.$k||T.$j){if(typeof t=="string"&&m.length>1&&i!==1){m.splice(i,1),m.splice(1,0,t);const s=n[i];n.splice(i,1),n.splice(1,0,s),i=1}T.$k&&m.length>1&&(m=m.reverse(),n=n.reverse(),o=m.length-1,typeof t=="string"&&(i=o-1))}else if(T.$i&&typeof t=="string"&&m.length>1&&i!==m.length-1){m.splice(i,1),m.push(t);const s=n[i];n.splice(i,1),n.push(s),i=m.length-1}}return f.buttons=m,f.defaultId=o,f.cancelId=i,f.noLink=!0,f.title=f.title||g.nameLong,{options:f,buttonIndeces:n}}}),define(Ee[144],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,r.$Ci)("environmentService"),e.$Ki=(0,r.$Di)(e.$Ji)}),define(Ee[267],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=e.$G8b=void 0,e.$G8b=(0,r.$Ci)("externalTerminal"),e.$H8b="Terminal.app"}),define(Ee[268],Se([1,0,58,59,15,16,11,109,34,112,223,267]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=void 0,r=Ue(r),R=Ue(R),L=Ue(L),$=Ue($),l=Ue(l),C=Ue(C);const u=C.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends P{static{this.b="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,l.$um(),t)}spawnTerminal(i,t,s,d){const a=t.windowsExec||p.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const w=R.$oc(a,".exe").toLowerCase();if(w==="cmder")return i.spawn(a,d?[d]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return a.indexOf(" ")>=0&&y.push('""'),y.push(a),w==="wt"&&y.push("-d ."),new Promise((D,S)=>{const I=f(process),k=i.spawn(s,y,{cwd:d,env:I,detached:!0});k.on("error",S),k.on("exit",()=>D())})}async runInTerminal(i,t,s,d,a){const w="windowsExec"in a&&a.windowsExec?a.windowsExec:p.getDefaultTerminalWindows(),y=await p.f();return new Promise((D,S)=>{const I=`"${t} - ${u}"`,k=`"${s.join('" "')}" & pause`,b=Object.assign({},f(process),d);Object.keys(b).filter(j=>b[j]===null).forEach(j=>delete b[j]);const v={cwd:t,env:b,windowsVerbatimArguments:!0};let N,O;R.$oc(w,".exe")==="wt"?(N=w,O=["-d",".",p.b,"/c",k]):y?(N=y,O=["-d",".",w,"/c",k]):(N=p.b,O=["/c","start",I,"/wait",w,"/c",`"${k}"`]),r.spawn(N,O,v).on("error",j=>{S(m(j))}),D(void 0)})}static getDefaultTerminalWindows(){if(!p.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return p.d}static async f(){try{const i=await l.win32.findExecutable("wt");return await $.Promises.exists(i)?i:void 0}catch{return}}}e.$qec=p,Ye([h.$7h],p,"f",null);class c extends P{static{this.b="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,d,a){const w=a.osxExec||E.$H8b;return new Promise((y,D)=>{if(w===E.$H8b||w==="iTerm.app"){const S=w===E.$H8b?"TerminalHelper":"iTermHelper",k=[A.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",i||u,"-w",t];for(const N of s)k.push("-a"),k.push(N);if(d){const N=Object.assign({},f(process),d);for(const O in N){const F=N[O];F===null?(k.push("-u"),k.push(O)):(k.push("-e"),k.push(`${O}=${F}`))}}let b="";const v=r.spawn(c.b,k);v.on("error",N=>{D(m(N))}),v.stderr.on("data",N=>{b+=N.toString()}),v.on("exit",N=>{if(N===0)y(void 0);else if(b){const O=b.split(`
`,1);D(new Error(O[0]))}else D(new Error(C.localize(1,null,S,N)))})}else D(new Error(C.localize(2,null,w)))})}spawnTerminal(i,t,s){const d=t.osxExec||E.$H8b;return new Promise((a,w)=>{const y=["-a",d];s&&y.push(s);const D=f(process),S=i.spawn("/usr/bin/open",y,{cwd:s,env:D});S.on("error",w),S.on("exit",()=>a())})}}e.$rec=c;class g extends P{static{this.b=C.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,d,a){const w=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((y,D)=>{const S=[];w.then(I=>{I.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const k=`${n(s)}; echo; read -p "${g.b}" -n1;`;S.push(`''${k}''`);const b=Object.assign({},f(process),d);Object.keys(b).filter(F=>b[F]===null).forEach(F=>delete b[F]);const v={cwd:t,env:b};let N="";const O=r.spawn(I,S,v);O.on("error",F=>{D(m(F))}),O.stderr.on("data",F=>{N+=F.toString()}),O.on("exit",F=>{if(F===0)y(void 0);else if(N){const j=N.split(`
`,1);D(new Error(j[0]))}else D(new Error(C.localize(4,null,I,F)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!L.$k)g.d=Promise.resolve("xterm");else{const i=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(i,t,s){const d=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,w)=>{d.then(y=>{const D=f(process),S=i.spawn(y,[],{cwd:s,env:D});S.on("error",w),S.on("exit",()=>a())})})}}e.$sec=g;function f(o){const i={...o.env};return(0,T.$hm)(i),i}function m(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(C.localize(5,null,o.path)):o}function n(o){let i="";for(const t of o)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(Ee[28],Se([1,0,85,16,13,18,2,224,5,11,15,49]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=g,e.$_k=m,e.$al=n,e.$bl=o,e.$cl=i,e.$dl=t,e.$el=s,e.$fl=d,e.$gl=a,e.$hl=w,e.$jl=S,e.$kl=I,e.$ll=k,e.$ml=b,e.$nl=v,e.$ql=B,e.$Cl=G,e.$Dl=J,e.$Fl=ue,e.$9k=(0,$.$Ci)("fileService");function u(ne){return ne.create===!0}var P;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var p;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(p||(e.FilePermission=p={}));var c;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function g(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var f;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function m(ne){return!!(ne.capabilities&f.FileReadWrite)}function n(ne){return!!(ne.capabilities&f.FileFolderCopy)}function o(ne){return!!(ne.capabilities&f.FileClone)}function i(ne){return!!(ne.capabilities&f.FileOpenReadWriteClose)}function t(ne){return!!(ne.capabilities&f.FileReadStream)}function s(ne){return m(ne)?!!(ne.capabilities&f.FileAtomicRead):!1}function d(ne){return m(ne)?!!(ne.capabilities&f.FileAtomicWrite):!1}function a(ne){return!!(ne.capabilities&f.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&f.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class D extends Error{static create(De,$e){const Q=new D(De.toString(),$e);return k(Q,$e),Q}constructor(De,$e){super(De),this.code=$e}}e.$il=D;function S(ne,De){return D.create(ne,De)}function I(ne){return ne||S((0,T.localize)(0,null),y.Unknown)}function k(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function b(ne){if(!ne)return y.Unknown;if(ne instanceof D)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return y.Unknown;switch(De[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function v(ne){if(ne instanceof M)return ne.fileOperationResult;switch(b(ne)){case y.FileNotFound:return re.FILE_NOT_FOUND;case y.FileIsADirectory:return re.FILE_IS_DIRECTORY;case y.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return re.FILE_WRITE_LOCKED;case y.NoPermissions:return re.FILE_PERMISSION_DENIED;case y.FileExists:return re.FILE_MOVE_CONFLICT;case y.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var N;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(De,$e,Q){this.resource=De,this.operation=$e,this.target=Q}isOperation(De){return this.operation===De}}e.$ol=O;var F;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$W(()=>{const Q=r.$Ii.forUris(()=>this.c);return Q.fill(this.rawAdded.map(U=>[U,!0])),Q}),this.f=new E.$W(()=>{const Q=r.$Ii.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(U=>[U,!0])),Q}),this.g=new E.$W(()=>{const Q=r.$Ii.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(U=>[U,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of De){switch(Q.type){case F.ADDED:this.rawAdded.push(Q.resource);break;case F.UPDATED:this.rawUpdated.push(Q.resource);break;case F.DELETED:this.rawDeleted.push(Q.resource);break}this.b!==j.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...Q){if(!De)return!1;const U=Q.length>0;return!!((!U||Q.includes(F.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!U||Q.includes(F.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!U||Q.includes(F.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$pl=j;function B(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,A.$Ef)(ne,De):ne.indexOf(De)===0)}class M extends Error{constructor(De,$e,Q){super(De),this.fileOperationResult=$e,this.options=Q}}e.$rl=M;class W extends M{constructor(De,$e,Q,U){super(De,$e,U),this.fileOperationResult=$e,this.size=Q}}e.$sl=W;class _ extends M{constructor(De,$e,Q){super(De,re.FILE_NOT_MODIFIED_SINCE,Q),this.stat=$e}}e.$tl=_;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var z;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(z||(e.FileKind=z={})),e.$Bl="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function J(ne,De){if(!De.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise($e=>{const Q=De.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(Q.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,R.$gg)(De)||(De=0),De<ee.KB?(0,T.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,T.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,T.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,T.localize)(4,null,(De/ee.GB).toFixed(2)):(0,T.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$El=ee;function ue(ne){const De=typeof ne=="string"||ne?.scheme===C.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===C.Schemas.file?1024*ee.MB:De?10*ee.MB:l.$o?50*ee.MB:1024*ee.MB}}),define(Ee[269],Se([1,0,22,14,225,28]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=L;async function L(C,E,u,P,p,c){let g;try{await T(C,E,u,P,p,c)}catch(f){g=f}finally{g&&p.errorTransformer&&(g=p.errorTransformer(g)),typeof g<"u"&&u.error(g),u.end()}}async function T(C,E,u,P,p,c){$(c);const g=await C.open(E,{create:!1});try{$(c);let f=0,m=0,n=p&&typeof p.length=="number"?p.length:void 0,o=r.$Le.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),i=p&&typeof p.position=="number"?p.position:0,t=0;do m=await C.read(g,i,o.buffer,t,o.byteLength-t),i+=m,t+=m,f+=m,typeof n=="number"&&(n-=m),t===o.byteLength&&(await u.write(P(o)),o=r.$Le.alloc(Math.min(p.bufferSize,typeof n=="number"?n:p.bufferSize)),t=0);while(m>0&&(typeof n!="number"||n>0)&&$(c)&&l(f,p));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),u.write(P(o.slice(0,s)))}}catch(f){throw(0,R.$kl)(f)}finally{await C.close(g)}}function $(C){if(C.isCancellationRequested)throw(0,h.$7)();return!0}function l(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,R.$jl)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[70],Se([1,0,39,3,16,11,2,28]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0,e.$Uq=$,e.$Vq=l,e.$Zq=P,e.$1q=p,e.$2q=c,e.$3q=g,e.$4q=m,e.$5q=n;function $(o){return typeof o.correlationId=="number"}function l(o){return o.recursive===!0}class C extends h.$Vc{static{this.a=3}static{this.b=10}constructor(i,t,s,d){super(),this.m=i,this.n=t,this.r=s,this.s=d,this.f=this.B(new h.$Wc),this.g=void 0,this.h=new Map,this.j=0}u(){const i=new h.$Uc;this.f.value=i,this.c=this.t(i),this.c.setVerboseLogging(this.r),i.add(this.c.onDidChangeFile(t=>this.m(t))),i.add(this.c.onDidLogMessage(t=>this.n(t))),i.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(i,t){if(this.s.restartOnError&&this.g?.length)if(t){const s=this.h.get(t.path)??0;s<C.a?(this.z(`restarting watcher from error in watch request (retrying request): ${i} (${JSON.stringify(t)})`),this.h.set(t.path,s+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${i} (${JSON.stringify(t)})`),this.y(this.g.filter(d=>d.path!==t.path)))}else this.j<C.b?(this.z(`restarting watcher after unknown global error: ${i}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${i}`);else this.z(i)}y(i){this.u(),this.watch(i)}async watch(i){this.g=i,await this.c?.watch(i)}async setVerboseLogging(i){this.r=i,await this.c?.setVerboseLogging(i)}z(i){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${i}`})}C(i){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${i}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Wq=C;class E extends C{constructor(i,t,s){super(i,t,s,{type:"node.js",restartOnError:!1})}}e.$Xq=E;class u extends C{constructor(i,t,s){super(i,t,s,{type:"universal",restartOnError:!0})}}e.$Yq=u;function P(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}function p(o){const i=new f;for(const t of o)i.processEvent(t);return i.coalesce()}function c(o,i){return typeof i=="string"&&!i.startsWith(r.$sk)&&!(0,A.$jc)(i)?{base:o,pattern:i}:i}function g(o,i){const t=[];for(const s of i)t.push((0,r.$wk)(c(o,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.b.get(this.c(i));let s=!1;if(t){const d=t.type,a=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===T.FileChangeType.DELETED||i.type===T.FileChangeType.ADDED)?s=!0:d===T.FileChangeType.ADDED&&a===T.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(t)):d===T.FileChangeType.DELETED&&a===T.FileChangeType.ADDED?t.type=T.FileChangeType.UPDATED:d===T.FileChangeType.ADDED&&a===T.FileChangeType.UPDATED||(t.type=a)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],t=[];return Array.from(this.a).filter(s=>s.type!==T.FileChangeType.DELETED?(i.push(s),!1):!0).sort((s,d)=>s.resource.fsPath.length-d.resource.fsPath.length).filter(s=>t.some(d=>(0,T.$ql)(s.resource.fsPath,d,!R.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(i)}}function m(o,i){if(typeof i=="number")switch(o.type){case T.FileChangeType.ADDED:return(i&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(i&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(i&T.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const i=[];return o&T.FileChangeFilter.ADDED&&i.push("Added"),o&T.FileChangeFilter.DELETED&&i.push("Deleted"),o&T.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(Ee[270],Se([1,0,61,3,70,4,28,2,9]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class l extends h.$Vc{constructor(){super(),this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$5c),this.m=new Set,this.n=5007,this.r=new $.$Zh,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,A.$Uq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new $.$Zh;try{this.h.clear(),this.g.clear();for(const u of E)this.t(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const u=new h.$Uc;this.j.set(E.correlationId,u),await this.r.p,!u.isDisposed&&(this.z(E,u),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,u){this.C(E,u)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,u),this.m.add(E.correlationId))}C(E,u){const P=this.M?.subscribe(E.path,(p,c)=>{u.isDisposed||(p?this.z(E,u):c?.type===L.FileChangeType.ADDED&&this.F(E))});return P?(u.add(P),!0):!1}D(E,u){let P=!1;const p=(c,g)=>{if(u.isDisposed)return;const f=this.G(c),m=this.G(g),n=P;P=f,!f&&(m||n)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.watchFile)(E.path,{persistent:!1,interval:this.n},p)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}u.add((0,h.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.unwatchFile)(E.path,p)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const u={resource:T.URI.file(E.path),type:L.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([u]),this.H(u,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,u){if(this.P){const P=` >> normalized ${E.type===L.FileChangeType.ADDED?"[ADDED]":E.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(P,u)}}I(E,u){this.P&&this.N(`${E}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,A.$5q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$br=l}),define(Ee[271],Se([1,0,61,9,21,33,3,82,16,11,23,2,111,34,28,70]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0,e.$hr=f;class g extends L.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,i,t,s,d){super(),this.s=n,this.t=o,this.u=i,this.w=t,this.y=s,this.z=d,this.c=this.B(new h.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.u(a))),this.f=this.B(new h.$Qh(a=>this.M(a),g.b)),this.g=(0,c.$3q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$3q)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Uq)(this.s)?this.s.filter:void 0,this.m=new A.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await P.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await P.Promises.realpath(n.path),n.path===o&&(o=await(0,u.$dr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const i=new L.$Uc;return this.H(n,o,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,i)),i}H(n,o,i){if(o)return!1;const t=E.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(d,a)=>{if(!i.isDisposed)if(d){const w=await this.G(n,o);i.isDisposed?w.dispose():i.add(w)}else a&&(typeof a.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:a.type,cId:this.s.correlationId},!0)});return s?(i.add(s),!0):!1}async I(n,o,i){if(l.$j&&(0,R.$Bg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.$ue(this.m.token);i.add((0,L.$Tc)(()=>t.dispose(!0)));const s=new L.$Uc;i.add(s);try{const d=E.URI.file(this.s.path),a=(0,$.$oc)(n),w=(0,r.watch)(n);s.add((0,L.$Tc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const y=new Set;if(o)try{for(const S of await P.Promises.readdir(n))y.add(S)}catch(S){this.O(S)}if(t.token.isCancellationRequested)return;const D=new Map;s.add((0,L.$Tc)(()=>{for(const[,S]of D)S.dispose();D.clear()})),w.on("error",(S,I)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${S}, ${I})`),this.D())}),w.on("change",(S,I)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${S}"] ${I}`);let k="";if(I&&(k=I.toString(),l.$j&&(k=(0,T.$jm)(k))),!(!k||S!=="change"&&S!=="rename"))if(o)if(S==="rename"){D.get(k)?.dispose();const b=setTimeout(async()=>{if(D.delete(k),k===a&&!await P.Promises.exists(n)){this.J(d);return}if(t.token.isCancellationRequested)return;const v=await this.N((0,$.$kc)(n,k));if(t.token.isCancellationRequested)return;let N;v?y.has(k)?N=p.FileChangeType.UPDATED:(N=p.FileChangeType.ADDED,y.add(k)):(y.delete(k),N=p.FileChangeType.DELETED),this.L({resource:(0,C.$dh)(d,k),type:N,cId:this.s.correlationId})},g.a);D.set(k,(0,L.$Tc)(()=>clearTimeout(b)))}else{let b;y.has(k)?b=p.FileChangeType.UPDATED:(b=p.FileChangeType.ADDED,y.add(k)),this.L({resource:(0,C.$dh)(d,k),type:b,cId:this.s.correlationId})}else if(S==="rename"||k!==a){const b=setTimeout(async()=>{const v=await P.Promises.exists(n);t.token.isCancellationRequested||(v?(this.L({resource:d,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(d))},g.a);s.clear(),s.add((0,L.$Tc)(()=>clearTimeout(b)))}else this.L({resource:d,type:p.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){t.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${d.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:p.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===p.FileChangeType.ADDED?"[ADDED]":n.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,c.$1q)(n),i=[];for(const s of o){if((0,c.$4q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}i.push(s)}if(i.length===0)return;if(this.z)for(const s of i)this.R(` >> normalized ${s.type===p.FileChangeType.ADDED?"[ADDED]":s.type===p.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(l.$k)return P.Promises.exists(n);try{const o=(0,$.$oc)(n);return(await P.Promises.readdir((0,$.$nc)(n))).some(t=>t===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$gr=g;async function f(m,n,o,i,t=512){const s=await P.Promises.open(m,"r"),d=Buffer.allocUnsafe(t),a=new A.$ue(i);let w,y=!1;const D={path:m,excludes:[],recursive:!1},S=new g(D,void 0,I=>{(async()=>{for(const{type:k}of I)if(k===p.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:b}=await P.Promises.read(s,d,0,t,null);if(!b||a.token.isCancellationRequested)break;n(d.slice(0,b))}}catch(b){w=new Error(b),a.dispose(!0)}finally{y=!1}}})()});return await S.ready,o(),new Promise((I,k)=>{a.token.onCancellationRequested(async()=>{S.dispose();try{await P.Promises.close(s)}catch(b){w=new Error(b)}w?k(w):I()})})}}),define(Ee[272],Se([1,0,4,39,270,11,271,33]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class $ extends A.$br{constructor(C){super(),this.M=C,this.onDidError=r.Event.None,this.watchers=new Set}async L(C){C=this.X(C);const E=[],u=new Set(Array.from(this.watchers));for(const P of C){const p=this.S(P);p&&(0,h.$Ak)(p.request.excludes,P.excludes)&&(0,h.$Ak)(p.request.includes,P.includes)?u.delete(p):E.push(P)}E.length&&this.N(`Request to start watching: ${E.map(P=>this.J(P)).join(",")}`),u.size&&this.N(`Request to stop watching: ${Array.from(u).map(P=>this.J(P.request)).join(",")}`);for(const P of u)this.W(P);for(const P of E)this.U(P)}S(C){for(const E of this.watchers)if(typeof C.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===C.correlationId)return E}else if((0,T.$Ag)(E.request.path,C.path,!R.$k))return E}U(C){const E=new L.$gr(C,this.M,P=>this.a.fire(P),()=>this.c.fire(C),P=>this.b.fire(P),this.P),u={request:C,instance:E};this.watchers.add(u)}async stop(){await super.stop();for(const C of this.watchers)this.W(C)}W(C){this.N("stopping file watcher",C),this.watchers.delete(C),C.instance.dispose()}X(C){const E=new Map;for(const u of C){const P=R.$k?u.path:u.path.toLowerCase();let p=E.get(u.correlationId);p||(p=new Map,E.set(u.correlationId,p)),p.has(P)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(u)}`),p.set(P,u)}return Array.from(E.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(C){super.setVerboseLogging(C);for(const E of this.watchers)E.instance.setVerboseLogging(C)}N(C,E){this.P&&this.b.fire({type:"trace",message:this.$(C,E)})}O(C){this.b.fire({type:"warn",message:this.$(C)})}$(C,E){return E?`[File Watcher (node.js)] ${C} (${this.J(E.request)})`:`[File Watcher (node.js)] ${C}`}}e.$ir=$}),define(Ee[273],Se([1,0,70,272]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class A extends r.$Xq{constructor(L,T,$){super(L,T,$),this.u()}t(L){return L.add(new h.$ir(void 0))}}e.$jr=A}),define(Ee[274],Se([1,0,15,87,208,70]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class L extends R.$Yq{constructor($,l,C){super($,l,C),this.u()}t($){const l=$.add(new A.$_q(r.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(l.onDidProcessExit(({code:C,signal:E})=>this.w(`terminated by itself with code ${C}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$ji)(l.getChannel("watcher")))}}e.$ar=L}),define(Ee[115],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class r{constructor(...A){this.a=new Map;for(const[R,L]of A)this.set(R,L)}set(A,R){const L=this.a.get(A);return this.a.set(A,R),L}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Ai=r}),define(Ee[275],Se([1,0,9,14,3,113,264,5,115,81]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const C=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class u{constructor(g=new $.$Ai,f=!1,m,n=C){this.i=g,this.j=f,this.k=m,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Bi,this),this._globalGraph=n?m?._globalGraph??new L.$mr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Qc)(this.h),this.h.clear();for(const g of this.g)(0,A.$Pc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g,f){this.m();const m=this,n=new class extends u{dispose(){m.h.delete(n),super.dispose()}}(g,this.j,this,this.l);return this.h.add(n),f?.add(n),n}invokeFunction(g,...f){this.m();const m=p.traceInvocation(this.l,g);let n=!1;try{return g({get:i=>{if(n)throw(0,h.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(i,m);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...f)}finally{n=!0,m.stop()}}createInstance(g,...f){this.m();let m,n;return g instanceof R.$zi?(m=p.traceCreation(this.l,g.ctor),n=this.o(g.ctor,g.staticArguments.concat(f),m)):(m=p.traceCreation(this.l,g),n=this.o(g,f,m)),m.stop(),n}o(g,f=[],m){const n=T._util.getServiceDependencies(g).sort((t,s)=>t.index-s.index),o=[];for(const t of n){const s=this.s(t.id,m);s||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(s)}const i=n.length>0?n[0].index:f.length;if(f.length!==i){console.trace(`[createInstance] First service dependency of ${g.name} at position ${i+1} conflicts with ${f.length} static arguments`);const t=i-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,i)}return Reflect.construct(g,f.concat(o))}q(g,f){if(this.i.get(g)instanceof R.$zi)this.i.set(g,f);else if(this.k)this.k.q(g,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const f=this.i.get(g);return!f&&this.k?this.k.r(g):f}s(g,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.r(g);return m instanceof R.$zi?this.u(g,m,f.branch(g,!0)):(f.branch(g,!1),m)}u(g,f,m){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,f,m)}finally{this.t.delete(g)}}v(g,f,m){const n=new L.$mr(t=>t.id.toString());let o=0;const i=[{id:g,desc:f,_trace:m}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new E(n);for(const s of T._util.getServiceDependencies(t.desc.ctor)){const d=this.r(s.id);if(d||this.y(`[createInstance] ${g} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof R.$zi){const a={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,a),i.push(a)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:s}of t){if(this.r(s.id)instanceof R.$zi){const a=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,a)}n.removeNode(s)}}return this.r(g)}w(g,f,m=[],n,o){if(this.i.get(g)instanceof R.$zi)return this.x(g,f,m,n,o,this.g);if(this.k)return this.k.w(g,f,m,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(g,f,m=[],n,o,i){if(n){const t=new u(void 0,this.j,this,this.l);t.c=String(g);const s=new Map,d=new r.$Vh(()=>{const a=t.o(f,m,o);for(const[w,y]of s){const D=a[w];if(typeof D=="function")for(const S of y)S.disposable=D.apply(a,S.listener)}return s.clear(),i.add(a),a});return new Proxy(Object.create(null),{get(a,w){if(!d.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let S=s.get(w);return S||(S=new l.$6c,s.set(w,S)),(k,b,v)=>{if(d.isInitialized)return d.value[w](k,b,v);{const N={listener:[k,b,v],disposable:void 0},O=S.push(N);return(0,A.$Tc)(()=>{O(),N.disposable?.dispose()})}}}if(w in a)return a[w];const y=d.value;let D=y[w];return typeof D!="function"||(D=D.bind(y),a[w]=D),D},set(a,w,y){return d.value[w]=y,!0},getPrototypeOf(a){return f.prototype}})}else{const t=this.o(f,m,o);return i.add(t),t}}y(g,f){if(f&&console.warn(g),this.j)throw new Error(g)}}e.$nr=u;var P;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(P||(P={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,f){return g?new p(P.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(g,f){return g?new p(P.Creation,f.name):p.c}static{this.f=0}constructor(g,f){this.type=g,this.name=f,this.g=Date.now(),this.h=[]}branch(g,f){const m=new p(P.Branch,g.toString());return this.h.push([g,f,m]),m}stop(){const g=Date.now()-this.g;p.f+=g;let f=!1;function m(o,i){const t=[],s=new Array(o+1).join("	");for(const[d,a,w]of i.h)if(a&&w){f=!0,t.push(`${s}CREATES -> ${d}`);const y=m(o+1,w);y&&t.push(y)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(g>2||f)&&p.all.add(n.join(`
`))}}e.$or=p}),define(Ee[12],Se([1,0,227,55,4,60,3,29,11,23,18,2,36,5]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=c,e.log=f,e.$kk=D,e.$lk=S,e.$mk=I,e.$nk=k,r=Ue(r),e.$9j=(0,P.$Ci)("logService"),e.$0j=(0,P.$Ci)("loggerService");function p(){return new Date().toISOString()}function c(b){return(0,C.$gg)(b)}var g;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$_j=g.Info;function f(b,v,N){switch(v){case g.Trace:b.trace(N);break;case g.Debug:b.debug(N);break;case g.Info:b.info(N);break;case g.Warning:b.warn(N);break;case g.Error:b.error(N);break;case g.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function m(b,v=!1){let N="";for(let O=0;O<b.length;O++){let F=b[O];if(F instanceof Error&&(F=(0,h.$nj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}N+=(O>0?" ":"")+F}return N}class n extends L.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new A.$je),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==g.Off&&this.b<=v}}e.$bk=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...N){this.f(g.Trace)&&this.g(g.Trace,m([v,...N],!0))}debug(v,...N){this.f(g.Debug)&&this.g(g.Debug,m([v,...N]))}info(v,...N){this.f(g.Info)&&this.g(g.Info,m([v,...N]))}warn(v,...N){this.f(g.Warning)&&this.g(g.Warning,m([v,...N]))}error(v,...N){if(this.f(g.Error))if(v instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=v.stack,this.g(g.Error,m(O))}else this.g(g.Error,m([v,...N]))}flush(){}}e.$ck=o;class i extends n{constructor(v=e.$_j){super(),this.setLevel(v),this.g=!$.$i}trace(v,...N){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...N):console.log(`[main ${p()}]`,v,...N))}debug(v,...N){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...N):console.log(`[main ${p()}]`,v,...N))}info(v,...N){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,v,...N):console.log(`[main ${p()}]`,v,...N))}warn(v,...N){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,v,...N):console.warn(`[main ${p()}]`,v,...N))}error(v,...N){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,v,...N):console.error(`[main ${p()}]`,v,...N))}flush(){}}e.$dk=i;class t extends n{constructor(v=e.$_j,N=!0){super(),this.g=N,this.setLevel(v)}trace(v,...N){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...N):console.log(v,...N))}debug(v,...N){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...N):console.log(v,...N))}info(v,...N){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...N):console.log(v,...N))}warn(v,...N){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...N):console.log(v,...N))}error(v,...N){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...N):console.error(v,...N))}flush(){}}e.$ek=t;class s extends n{constructor(v,N=e.$_j){super(),this.g=v,this.setLevel(N)}trace(v,...N){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(v),...N])}debug(v,...N){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(v),...N])}info(v,...N){this.f(g.Info)&&this.g.log(g.Info,[this.h(v),...N])}warn(v,...N){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(v),...N])}error(v,...N){this.f(g.Error)&&this.g.log(g.Error,[this.h(v),...N])}h(v){return typeof v=="string"?v:(0,h.$nj)(v,this.f(g.Trace))}flush(){}}e.$fk=s;class d extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const N of this.g)N.setLevel(v);super.setLevel(v)}trace(v,...N){for(const O of this.g)O.trace(v,...N)}debug(v,...N){for(const O of this.g)O.debug(v,...N)}info(v,...N){for(const O of this.g)O.info(v,...N)}warn(v,...N){for(const O of this.g)O.warn(v,...N)}error(v,...N){for(const O of this.g)O.error(v,...N)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$gk=d;class a extends L.$Vc{constructor(v,N,O){if(super(),this.h=v,this.j=N,this.b=new T.$Bc,this.c=this.B(new A.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$je),this.onDidChangeVisibility=this.g.event,O)for(const F of O)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,C.$cg)(v)?[...this.b.values()].find(N=>N.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,N){const O=this.n(v),F=(0,C.$cg)(v)?v:N?.id??(0,R.$qj)(O.toString()).toString(16);let j=this.b.get(O)?.logger;const B=N?.logLevel==="always"?g.Trace:N?.logLevel;j||(j=this.s(O,B??this.getLogLevel(O)??this.h,{...N,id:F}));const M={logger:j,info:{resource:O,id:F,logLevel:B,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(M.info),this.b.set(O,M),j}n(v){return(0,C.$cg)(v)?(0,l.$dh)(this.j,`${v}.log`):v}setLogLevel(v,N){if(E.URI.isUri(v)){const O=v,F=N,j=this.b.get(O);j&&F!==j.info.logLevel&&(j.info.logLevel=F===this.h?void 0:F,j.logger?.setLevel(F),this.b.set(j.info.resource,j),this.f.fire([O,F]))}else{this.h=v;for(const[O,F]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,N){const O=this.m(v);O&&N!==!O.info.hidden&&(O.info.hidden=!N,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,N]))}getLogLevel(v){let N;return v&&(N=this.b.get(v)?.info.logLevel),N??this.h}registerLogger(v){const N=this.b.get(v.resource);N?N.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const N=this.b.get(v);N&&(N.logger&&N.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=a;class w{constructor(){this.onDidChangeLogLevel=new A.$je().event}setLevel(v){}getLevel(){return g.Info}trace(v,...N){}debug(v,...N){}info(v,...N){}warn(v,...N){}error(v,...N){}critical(v,...N){}dispose(){}flush(){}}e.$ik=w;class y extends w{}e.$jk=y;function D(b){if(b.verbose)return g.Trace;if(typeof b.logLevel=="string"){const v=k(b.logLevel.toLowerCase());if(v!==void 0)return v}return e.$_j}function S(b){switch(b){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function I(b){switch(b){case g.Trace:return{original:"Trace",value:r.localize(0,null)};case g.Debug:return{original:"Debug",value:r.localize(1,null)};case g.Info:return{original:"Info",value:r.localize(2,null)};case g.Warning:return{original:"Warning",value:r.localize(3,null)};case g.Error:return{original:"Error",value:r.localize(4,null)};case g.Off:return{original:"Off",value:r.localize(5,null)}}}function k(b){switch(b){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$ok=new u.$Tj("logLevel",S(g.Info))}),define(Ee[276],Se([1,0,19,9,14,4,33,3,16,70,12]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class E extends T.$Vc{constructor(P,p){super(),this.a=P,this.b=p,this.c=this.B(new R.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Ah(0)),this.w=[],this.y=this.B(new h.$Ah(0))}watch(P,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(P,p):this.z(P,p)}n(P,p){const c={path:this.J(P),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},g=(0,r.$Ub)(this.j,c);return this.r(),(0,T.$Tc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,A.$2)(P))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$Zq)(p)),p=>this.G(p),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const p of this.j)(0,l.$Vq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const p of this.j)(0,l.$Vq)(p)&&P.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,p){const c={path:this.J(P),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},g=(0,r.$Ub)(this.w,c);return this.C(),(0,T.$Tc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,A.$2)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,l.$Zq)(P)),P=>this.G(P),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,$.$ic)(P.fsPath)}J(P){const p=this.I(P);return(0,L.$Eg)(p)}}e.$6q=E}),define(Ee[277],Se([1,0,9,29,22,4,33,3,16,11,23,104,34,226,28,269,276,274,273]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;class n extends g.$6q{static{this.L=!1}constructor(i,t){super(i,t),this.onDidChangeCapabilities=R.Event.None,this.P=new h.$Bc(s=>C.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(i){try{const{stat:t,symbolicLink:s}=await u.SymlinkSupport.stat(this.I(i));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:p.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await u.Promises.readdir(this.I(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async d=>{try{let a;d.isSymbolicLink()?a=(await this.stat((0,C.$dh)(i,d.name))).type:a=this.O(d),s.push([d.name,a])}catch(a){this.a.trace(a)}})),s}catch(t){throw this.hb(t)}}O(i,t){let s;return t?.dangling?s=p.FileType.Unknown:i.isFile()?s=p.FileType.File:i.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,t&&(s|=p.FileType.SymbolicLink),s}async Q(i){const t=this.I(i);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(i);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const d=new r.$Bh;return this.P.set(i,d),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,T.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(i)===d&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(i)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),d.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(i)})`),s=await this.Q(i));const d=this.I(i);return await u.Promises.readFile(d)}catch(d){throw this.hb(d)}finally{s?.dispose()}}R(i){n.L&&this.a.trace(i)}readFileStream(i,t,s){const d=(0,E.$ze)(a=>A.$Le.concat(a.map(w=>A.$Le.wrap(w))).buffer);return(0,c.$Sq)(this,i,d,a=>a.buffer,{...t,bufferSize:256*1024},s),d}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(i)?this.U(i,(0,C.$dh)((0,C.$ch)(i),`${(0,C.$ah)(i)}${s.atomic.postfix}`),t,s):this.W(i,t,s)}async S(i){try{const t=this.I(i),{symbolicLink:s}=await u.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(i,t,s,d){const a=new T.$Uc;try{a.add(await this.Q(i)),a.add(await this.Q(t)),await this.W(t,s,d,!0);try{await this.rename(t,i,{overwrite:!0})}catch(w){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async W(i,t,s,d){let a;try{const w=this.I(i);if(!s.create||!s.overwrite){if(await u.Promises.exists(w)){if(!s.overwrite)throw(0,p.$jl)((0,P.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$jl)((0,P.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock},d),await this.write(a,0,t,0,t.byteLength)}catch(w){throw await this.ib(i,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(i){n.$=i}async open(i,t,s){const d=this.I(i);let a;(0,p.$0k)(t)&&!s&&(a=await this.Q(i));let w;try{if((0,p.$0k)(t)&&t.unlock)try{const{stat:D}=await u.SymlinkSupport.stat(d);D.mode&128||await u.Promises.chmod(d,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let y;if((0,p.$0k)(t)){if(l.$i)try{await u.Promises.truncate(d,0),y="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}y||(y="w")}else y="r";w=await u.Promises.open(d,y)}catch(y){throw a?.dispose(),(0,p.$0k)(t)?await this.ib(i,y):this.hb(y)}if(this.X.set(w,0),(0,p.$0k)(t)&&this.Z.set(w,i),a){const y=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${d})`),this.Y.set(w,a),y&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${d})`),y.dispose())}return w}async close(i){const t=this.Y.get(i);try{if(this.X.delete(i),this.Z.delete(i)&&n.$)try{await u.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(i)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(i)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.Y.delete(i)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,d,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.read(i,s,d,a,w)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(i,w,y)}return y}ab(i,t){return t===this.X.get(i)?null:t}bb(i,t,s){const d=this.X.get(i);typeof d=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(i,d+s):this.X.delete(i)))}async write(i,t,s,d,a){return(0,r.$Wh)(()=>this.cb(i,t,s,d,a),100,3)}async cb(i,t,s,d,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.write(i,s,d,a,w)).bytesWritten}catch(D){throw await this.ib(this.Z.get(i),D)}finally{this.bb(i,w,y)}return y}async mkdir(i){try{await u.Promises.mkdir(this.I(i))}catch(t){throw this.hb(t)}}async delete(i,t){try{const s=this.I(i);if(t.recursive){let d;t?.atomic!==!1&&t.atomic.postfix&&(d=(0,$.$kc)((0,$.$nc)(s),`${(0,$.$oc)(s)}${t.atomic.postfix}`)),await u.Promises.rm(s,u.RimRafMode.MOVE,d)}else try{await u.Promises.unlink(s)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:y}=await u.SymlinkSupport.stat(s);a=w.isDirectory()&&!y}catch{}if(a)await u.Promises.rmdir(s);else throw d}else throw d}}catch(s){throw this.hb(s)}}async rename(i,t,s){const d=this.I(i),a=this.I(t);if(d!==a)try{await this.db(i,t,"move",s.overwrite),await u.Promises.rename(d,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,P.localize)(2,null,(0,$.$oc)(d),(0,$.$oc)((0,$.$nc)(a)),w.toString()))),this.hb(w)}}async copy(i,t,s){const d=this.I(i),a=this.I(t);if(d!==a)try{await this.db(i,t,"copy",s.overwrite),await u.Promises.copy(d,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,P.localize)(3,null,(0,$.$oc)(d),(0,$.$oc)((0,$.$nc)(a)),w.toString()))),this.hb(w)}}async db(i,t,s,d){const a=this.I(i),w=this.I(t);let y=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,L.$Ag)(a,w,!0)),y){if(s==="copy")throw(0,p.$jl)((0,P.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const S=await this.N(i);if(!S)throw(0,p.$jl)((0,P.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const I=await this.N(t);if(I){if(!d)throw(0,p.$jl)((0,P.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);S.type&p.FileType.File&&I.type&p.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.eb(i,t,!1)}async eb(i,t,s){const d=this.I(i),a=this.I(t),w=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.$Ag)(d,a,!w))return;const y=new T.$Uc;try{y.add(await this.Q(i)),y.add(await this.Q(t)),s&&await u.Promises.mkdir((0,$.$nc)(a),{recursive:!0}),await u.Promises.copyFile(d,a)}catch(D){if(D.code==="ENOENT"&&!s)return this.eb(i,t,!0);throw this.hb(D)}finally{y.dispose()}}t(i,t,s){return new f.$ar(d=>i(d),d=>t(d),s)}F(i,t,s){return new m.$jr(d=>i(d),d=>t(d),s)}hb(i){if(i instanceof p.$il)return i;let t=i,s;switch(i.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$jl)(t,s)}async ib(i,t){let s=this.hb(t);if(i&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await u.SymlinkSupport.stat(this.I(i));d.mode&128||(s=(0,p.$jl)(t,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return s}}e.$kr=n}),define(Ee[278],Se([1,0,3,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=void 0;class A extends r.$Vc{constructor(L,T=[]){super(),this.a=new h.$gk([L,...T]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...T){this.a.trace(L,...T)}debug(L,...T){this.a.debug(L,...T)}info(L,...T){this.a.info(L,...T)}warn(L,...T){this.a.warn(L,...T)}error(L,...T){this.a.error(L,...T)}flush(){this.a.flush()}}e.$SQ=A}),define(Ee[279],Se([1,0,28,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=void 0;var A;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(A||(A={}));async function R(l,C,E,u,P){try{const p=await new Promise((g,f)=>{ce(["@vscode/spdlog"],g,f)}).then(Ue);p.setFlushOn(A.Trace);const c=await p.createAsyncRotatingLogger(l,C,E,u);return P?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(p){console.error(p)}return null}function L(l,C,E){switch(C){case h.LogLevel.Trace:l.trace(E);break;case h.LogLevel.Debug:l.debug(E);break;case h.LogLevel.Info:l.info(E);break;case h.LogLevel.Warning:l.warn(E);break;case h.LogLevel.Error:l.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function T(l,C){switch(C){case h.LogLevel.Trace:l.setLevel(A.Trace);break;case h.LogLevel.Debug:l.setLevel(A.Debug);break;case h.LogLevel.Info:l.setLevel(A.Info);break;case h.LogLevel.Warning:l.setLevel(A.Warning);break;case h.LogLevel.Error:l.setLevel(A.Error);break;case h.LogLevel.Off:l.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class $ extends h.$ck{constructor(C,E,u,P,p){super(),this.m=[],this.setLevel(p),this.n=this.s(C,E,u,P),this.B(this.onDidChangeLogLevel(c=>{this.r&&T(this.r,c)}))}async s(C,E,u,P){const p=u?6:1,c=30/p*r.$El.MB,g=await R(C,E,c,p,P);if(g){this.r=g,T(this.r,this.getLevel());for(const{level:f,message:m}of this.m)L(this.r,f,m);this.m=[]}}g(C,E){this.r?L(this.r,C,E):this.getLevel()<=C&&this.m.push({level:C,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$HQ=$});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[145],Se([1,0,44,228,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Wt(r);var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function l(p,c){return c-p}$.compare=l;const C=Object.create(null);C[$.Error]=(0,h.localize)(0,null),C[$.Warning]=(0,h.localize)(1,null),C[$.Info]=(0,h.localize)(2,null);function E(p){return C[p]||""}$.toString=E;function u(p){switch(p){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=u;function P(p){switch(p){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=P}(L||(e.MarkerSeverity=L={}));var T;(function($){const l="";function C(u){return E(u,!0)}$.makeKey=C;function E(u,P){const p=[l];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(l),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(l),u.severity!==void 0&&u.severity!==null?p.push(L.toString(u.severity)):p.push(l),u.message&&P?p.push(u.message.replace("\xA6","\\\xA6")):p.push(l),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(l),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(l),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(l),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(l),p.push(l),p.join("\xA6")}$.makeKeyOptionalMessage=E})(T||(e.IMarkerData=T={})),e.$wu=(0,A.$Ci)("markerService")});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[280],Se([1,0,4,44,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$jw=e.Severity=void 0,e.$kw=T,h=Wt(h),e.Severity=h.default,e.$jw=(0,A.$Ci)("notificationService");var R;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function T(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class l{constructor(){this.progress=new C,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$lw=l;class C{infinite(){}done(){}total(u){}worked(u){}}e.$mw=C}),define(Ee[281],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Ee[116],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,r.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(ce,e){return function(r,h){e(r,h,ce)}};define(Ee[90],Se([1,0,9,21,3,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.$qw=e.$pw=e.$ow=e.ProgressLocation=e.$nw=void 0,e.$nw=(0,R.$Ci)("progressService");var L;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$ow=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$pw=T;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const P=this.d;this.d=()=>{P?.(),u()}}):Promise.resolve()}}e.$qw=$;let l=class extends A.$Vc{constructor(u,P){super(),this.a=new r.$Zh,P.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,A.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$rw=l,e.$rw=l=Ye([qe(1,e.$nw)],l);class C extends A.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Uc)}start(u){this.stop();const P=++this.a,p=new h.$ue;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Tc)(()=>p.cancel())),this.b.add((0,A.$Tc)(()=>this.c?this.c.done():void 0)),{id:P,token:p.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$sw=C,e.$tw=(0,R.$Ci)("editorProgressService")}),define(Ee[37],Se([1,0,66,18]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,r=Ue(r),h=Ue(h);class A{constructor(){this.a=new Map}add(L,T){r.ok(h.$cg(L)),r.ok(h.$eg(T)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,T)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$mo=new A}),define(Ee[117],Se([1,0,4,37]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,h=Ue(h),e.$no={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new r.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,l){this.a[A($)]=l,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;h.$mo.add(e.$no.JSONContribution,L)}),define(Ee[71],Se([1,0,19,4,18,217,45,117,37]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=c,e.$Do=g,e.$Eo=f,e.$Fo=n,e.$Go=o,A=Ue(A),R=Ue(R);var l;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$ro={Configuration:"base.contributions.configuration"};var C;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const E=$.$mo.as(T.$no.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$je,this.onDidSchemaChange=this.i.event,this.j=new h.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),E.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),E.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),E.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:a,source:w}of t)for(const y in a)if(s.add(y),e.$Bo.test(y)){const D=this.a.get(y),S=D?.valuesSources??new Map;if(w)for(const v of Object.keys(a[y]))S.set(v,w);const I={...D?.value||{},...a[y]};this.a.set(y,{source:w,value:I,valuesSources:S});const k=(0,L.$gj)(y),b={type:"object",default:I,description:R.localize(1,null,k),$ref:e.$yo,defaultDefaultValue:I,source:A.$cg(w)?void 0:w,defaultValueSource:w};d.push(...c(y)),this.d[y]=b,this.b.properties[y]=b}else{this.a.set(y,{value:a[y],source:w});const D=this.d[y];D&&(this.w(y,D),this.r(y,D))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:a}of t)for(const w in d){const y=this.a.get(w),D=A.$cg(a)?a:a?.id,S=A.$cg(y?.source)?y?.source:y?.source?.id;if(D===S)if(s.add(w),this.a.delete(w),e.$Bo.test(w))delete this.d[w],delete this.b.properties[w];else{const I=this.d[w];I&&(this.w(w,I),this.r(w,I))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(a=>{this.p(a,s,a.extensionInfo,a.restrictedProperties,void 0,d),this.c.push(a),this.q(a)})}o(t,s){const d=a=>{if(a.properties)for(const w in a.properties){s.add(w);const y=this.d[w];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[w],this.s(w,a.properties[w])}a.allOf?.forEach(w=>d(w))};for(const a of t){d(a);const w=this.c.indexOf(a);w!==-1&&this.c.splice(w,1)}}p(t,s=!0,d,a,w=C.WINDOW,y){w=A.$lg(t.scope)?w:t.scope;const D=t.properties;if(D)for(const I in D){const k=D[I];if(s&&n(I,k)){delete D[I];continue}if(k.source=d,k.defaultDefaultValue=D[I].default,this.w(I,k),e.$Bo.test(I)?k.scope=void 0:(k.scope=A.$lg(k.scope)?w:k.scope,k.restricted=A.$lg(k.restricted)?!!a?.includes(I):k.restricted),D[I].hasOwnProperty("included")&&!D[I].included){this.f[I]=D[I],delete D[I];continue}else this.d[I]=D[I],D[I].policy?.name&&this.e.set(D[I].policy.name,I);!D[I].deprecationMessage&&D[I].markdownDeprecationMessage&&(D[I].deprecationMessage=D[I].markdownDeprecationMessage),y.add(I)}const S=t.allOf;if(S)for(const I of S)this.p(I,s,d,a,w,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const a=d.properties;if(a)for(const y in a)this.r(y,a[y]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$so.properties[t]=s,s.scope){case C.APPLICATION:e.$to.properties[t]=s;break;case C.MACHINE:e.$uo.properties[t]=s;break;case C.MACHINE_OVERRIDABLE:e.$vo.properties[t]=s;break;case C.WINDOW:e.$wo.properties[t]=s;break;case C.RESOURCE:e.$xo.properties[t]=s;break;case C.LANGUAGE_OVERRIDABLE:e.$xo.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$so.properties[t],s.scope){case C.APPLICATION:delete e.$to.properties[t];break;case C.MACHINE:delete e.$uo.properties[t];break;case C.MACHINE_OVERRIDABLE:delete e.$vo.properties[t];break;case C.WINDOW:delete e.$wo.properties[t];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$yo};this.w(s,d),e.$so.properties[s]=d,e.$to.properties[s]=d,e.$uo.properties[s]=d,e.$vo.properties[s]=d,e.$wo.properties[s]=d,e.$xo.properties[s]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=t,e.$to.patternProperties[e.$Ao]=t,e.$uo.patternProperties[e.$Ao]=t,e.$vo.patternProperties[e.$Ao]=t,e.$wo.patternProperties[e.$Ao]=t,e.$xo.patternProperties[e.$Ao]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let a=d?.value,w=d?.source;A.$jg(a)&&(a=s.defaultDefaultValue,w=void 0),A.$jg(a)&&(a=f(s.type)),s.default=a,s.defaultValueSource=w}}const P="\\[([^\\]]+)\\]",p=new RegExp(P,"g");e.$Ao=`^(${P})+$`,e.$Bo=new RegExp(e.$Ao);function c(i){const t=[];if(e.$Bo.test(i)){let s=p.exec(i);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=p.exec(i)}}return(0,r.$Nb)(t)}function g(i){return i.reduce((t,s)=>`${t}[${s}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;$.$mo.add(e.$ro.Configuration,m);function n(i,t){return i.trim()?e.$Bo.test(i)?R.localize(7,null,i):m.getConfigurationProperties()[i]!==void 0?R.localize(8,null,i):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,i,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function o(){const i=[],t=m.getConfigurationProperties();for(const s of Object.keys(t))i.push([s,t[s].scope]);return i.push(["launch",C.RESOURCE]),i.push(["task",C.RESOURCE]),i}}),define(Ee[282],Se([1,0,19,4,175,3,29,25,18,2,45,71,28,37]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=o,r=Ue(r),A=Ue(A),T=Ue(T),$=Ue($);function p(d){return Object.isFrozen(d)?d:T.$ao(d)}class c{static createEmptyModel(a){return new c({},[],[],void 0,a)}constructor(a,w,y,D,S){this.b=a,this.c=w,this.d=y,this.raw=D,this.f=S,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(w=>{if(w instanceof c)return w;const y=new g("",this.f);return y.parseRaw(w),y.configurationModel});this.g=a.reduce((w,y)=>y===w?y:w.merge(y),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,C.$ej)(this.contents,a):this.contents}inspect(a,w){const y=this;return{get value(){return p(y.rawConfiguration.getValue(a))},get override(){return w?p(y.rawConfiguration.getOverrideValue(a,w)):void 0},get merged(){return p(w?y.rawConfiguration.override(w).getValue(a):y.rawConfiguration.getValue(a))},get overrides(){const D=[];for(const{contents:S,identifiers:I,keys:k}of y.rawConfiguration.overrides){const b=new c(S,k,[],void 0,y.f).getValue(a);b!==void 0&&D.push({identifiers:I,value:b})}return D.length?p(D):void 0}}}getOverrideValue(a,w){const y=this.j(w);return y?a?(0,C.$ej)(y,a):y:void 0}getKeysForOverrideIdentifier(a){const w=[];for(const y of this.overrides)y.identifiers.includes(a)&&w.push(...y.keys);return r.$Nb(w)}getAllOverrideIdentifiers(){const a=[];for(const w of this.overrides)a.push(...w.identifiers);return r.$Nb(a)}override(a){let w=this.a.get(a);return w||(w=this.h(a),this.a.set(a,w)),w}merge(...a){const w=T.$_n(this.contents),y=T.$_n(this.overrides),D=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const I of a)if(S.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.i(w,I.contents);for(const k of I.overrides){const[b]=y.filter(v=>r.$vb(v.identifiers,k.identifiers));b?(this.i(b.contents,k.contents),b.keys.push(...k.keys),b.keys=r.$Nb(b.keys)):y.push(T.$_n(k))}for(const k of I.keys)D.indexOf(k)===-1&&D.push(k)}return new c(w,D,y,S.every(I=>I instanceof c)?void 0:S,this.f)}h(a){const w=this.j(a);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const D of r.$Nb([...Object.keys(this.contents),...Object.keys(w)])){let S=this.contents[D];const I=w[D];I&&(typeof S=="object"&&typeof I=="object"?(S=T.$_n(S),this.i(S,I)):S=I),y[D]=S}return new c(y,this.keys,this.overrides,void 0,this.f)}i(a,w){for(const y of Object.keys(w)){if(y in a&&$.$eg(a[y])&&$.$eg(w[y])){this.i(a[y],w[y]);continue}a[y]=T.$_n(w[y])}}j(a){let w=null,y=null;const D=S=>{S&&(y?this.i(y,S):y=T.$_n(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===a?w=S.contents:S.identifiers.includes(a)&&D(S.contents);return D(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,w){this.k(a,w,!0)}setValue(a,w){this.k(a,w,!1)}removeValue(a){const w=this.keys.indexOf(a);w!==-1&&(this.keys.splice(w,1),(0,C.$dj)(this.contents,a),E.$Bo.test(a)&&this.overrides.splice(this.overrides.findIndex(y=>r.$vb(y.identifiers,(0,E.$Co)(a))),1))}k(a,w,y){(0,C.$cj)(this.contents,a,w,D=>this.f.error(D)),y=y||this.keys.indexOf(a)===-1,y&&this.keys.push(a),E.$Bo.test(a)&&this.overrides.push({identifiers:(0,E.$Co)(a),keys:Object.keys(this.contents[a]),contents:(0,C.$bj)(this.contents[a],D=>this.f.error(D))})}}e.$Ho=c;class g{constructor(a,w){this.f=a,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,w){if(!$.$lg(a)){const y=this.h(a);this.parseRaw(y,w)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,w){this.a=a;const{contents:y,keys:D,overrides:S,restricted:I,hasExcludedProperties:k}=this.i(a,w);this.b=new c(y,D,S,k?[a]:void 0,this.g),this.c=I||[]}h(a){let w={},y=null,D=[];const S=[],I=[];function k(v){Array.isArray(D)?D.push(v):y!==null&&(D[y]=v)}const b={onObjectBegin:()=>{const v={};k(v),S.push(D),D=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{D=S.pop()},onArrayBegin:()=>{const v=[];k(v),S.push(D),D=v,y=null},onArrayEnd:()=>{D=S.pop()},onLiteralValue:k,onError:(v,N,O)=>{I.push({error:v,offset:N,length:O})}};if(a)try{A.$Zn(a,b),w=D[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(a,w){const y=P.$mo.as(E.$ro.Configuration).getConfigurationProperties(),D=this.j(a,y,!0,w);a=D.raw;const S=(0,C.$bj)(a,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),I=Object.keys(a),k=this.l(a,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:S,keys:I,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(a,w,y,D){let S=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:S};const I={},k=[];for(const b in a)if(E.$Bo.test(b)&&y){const v=this.j(a[b],w,!1,D);I[b]=v.raw,S=S||v.hasExcludedProperties,k.push(...v.restricted)}else{const v=w[b],N=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&k.push(b),!D.exclude?.includes(b)&&(D.include?.includes(b)||(N===void 0||D.scopes===void 0||D.scopes.includes(N))&&!(D.skipRestricted&&v?.restricted))?I[b]=a[b]:S=!0}return{raw:I,restricted:k,hasExcludedProperties:S}}l(a,w){const y=[];for(const D of Object.keys(a))if(E.$Bo.test(D)){const S={};for(const I in a[D])S[I]=a[D][I];y.push({identifiers:(0,E.$Co)(D),keys:Object.keys(S),contents:(0,C.$bj)(S,w)})}return y}}e.$Io=g;class f extends R.$Vc{constructor(a,w,y,D,S){super(),this.c=a,this.f=w,this.g=D,this.h=S,this.b=this.B(new h.$je),this.onDidChange=this.b.event,this.a=new g(this.c.toString(),S),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(u.FileOperation.CREATE)||I.isOperation(u.FileOperation.COPY)||I.isOperation(u.FileOperation.DELETE)||I.isOperation(u.FileOperation.WRITE))&&y.isEqual(I.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=f;class m{constructor(a,w,y,D,S,I,k,b,v,N,O,F,j){this.a=a,this.b=w,this.c=y,this.overrideIdentifiers=D,this.d=S,this.f=I,this.g=k,this.h=b,this.i=v,this.j=N,this.k=O,this.l=F,this.m=j}get value(){return p(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,w,y,D,S,I,k,b,v,N){this.j=a,this.l=w,this.m=y,this.n=D,this.p=S,this.q=I,this.r=k,this.s=b,this.t=v,this.u=N,this.h=null,this.i=new L.$Bc,this.v=null}getValue(a,w,y){return this.w(a,w,y).getValue(a)}updateValue(a,w,y={}){let D;y.resource?(D=this.t.get(y.resource),D||(D=c.createEmptyModel(this.u),this.t.set(y.resource,D))):D=this.s,w===void 0?D.removeValue(a):D.setValue(a,w),y.resource||(this.h=null)}inspect(a,w,y){const D=this.w(a,w,y),S=this.A(w.resource,y),I=w.resource?this.t.get(w.resource)||this.s:this.s,k=new Set;for(const b of D.overrides)for(const v of b.identifiers)D.getOverrideValue(a,v)!==void 0&&k.add(v);return new m(a,w,D.getValue(a),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,S||void 0,I)}keys(a){const w=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,w){this.r.set(a,w),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,w){const y=[];if(!w){const{added:D,updated:S,removed:I}=t(this.j,a);w=[...D,...S,...I]}for(const D of w)for(const S of(0,E.$Co)(D)){const I=this.j.getKeysForOverrideIdentifier(S),k=a.getKeysForOverrideIdentifier(S),b=[...k.filter(v=>I.indexOf(v)===-1),...I.filter(v=>k.indexOf(v)===-1),...I.filter(v=>!T.$do(this.j.override(S).getValue(v),a.override(S).getValue(v)))];y.push([S,b])}return this.updateDefaultConfiguration(a),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(a){const{added:w,updated:y,removed:D}=t(this.l,a),S=[...w,...y,...D];return S.length&&this.updatePolicyConfiguration(a),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:w,updated:y,removed:D,overrides:S}=t(this.applicationConfiguration,a),I=[...w,...y,...D];return I.length&&this.updateApplicationConfiguration(a),{keys:I,overrides:S}}compareAndUpdateLocalUserConfiguration(a){const{added:w,updated:y,removed:D,overrides:S}=t(this.localUserConfiguration,a),I=[...w,...y,...D];return I.length&&this.updateLocalUserConfiguration(a),{keys:I,overrides:S}}compareAndUpdateRemoteUserConfiguration(a){const{added:w,updated:y,removed:D,overrides:S}=t(this.remoteUserConfiguration,a),I=[...w,...y,...D];return I.length&&this.updateRemoteUserConfiguration(a),{keys:I,overrides:S}}compareAndUpdateWorkspaceConfiguration(a){const{added:w,updated:y,removed:D,overrides:S}=t(this.workspaceConfiguration,a),I=[...w,...y,...D];return I.length&&this.updateWorkspaceConfiguration(a),{keys:I,overrides:S}}compareAndUpdateFolderConfiguration(a,w){const y=this.folderConfigurations.get(a),{added:D,updated:S,removed:I,overrides:k}=t(y,w),b=[...D,...S,...I];return(b.length||!y)&&this.updateFolderConfiguration(a,w),{keys:b,overrides:k}}compareAndDeleteFolderConfiguration(a){const w=this.folderConfigurations.get(a);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:y,updated:D,removed:S,overrides:I}=t(w,void 0);return{keys:[...y,...D,...S],overrides:I}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,w,y){let D=this.x(w,y);return w.overrideIdentifier&&(D=D.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(D=D.merge(this.l)),D}x({resource:a},w){let y=this.y();if(w&&a){const D=w.getFolder(a);D&&(y=this.z(D.uri)||y);const S=this.t.get(a);S&&(y=y.merge(S))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let w=this.i.get(a);if(!w){const y=this.y(),D=this.r.get(a);D?(w=y.merge(D),this.i.set(a,w)):w=y}return w}A(a,w){if(w&&a){const y=w.getFolder(a);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,w)=>{const{contents:y,overrides:D,keys:S}=this.r.get(w);return a.push([w,{contents:y,overrides:D,keys:S}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(w=>a.add(w)),this.userConfiguration.keys.forEach(w=>a.add(w)),this.q.keys.forEach(w=>a.add(w)),this.r.forEach(w=>w.keys.forEach(y=>a.add(y))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>a.add(y))),[...a.values()]}D(a){const w=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.q.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(a).forEach(D=>w.add(D))),[...w.values()]}static parse(a,w){const y=this.E(a.defaults,w),D=this.E(a.policy,w),S=this.E(a.application,w),I=this.E(a.user,w),k=this.E(a.workspace,w),b=a.folders.reduce((v,N)=>(v.set(l.URI.revive(N[0]),this.E(N[1],w)),v),new L.$Bc);return new n(y,D,S,I,c.createEmptyModel(w),k,b,c.createEmptyModel(w),new L.$Bc,w)}static E(a,w){return new c(a.contents,a.keys,a.overrides,void 0,w)}}e.$Ko=n;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const a=new Set,w=new Map;for(const D of d)D.keys.forEach(S=>a.add(S)),D.overrides.forEach(([S,I])=>{const k=(0,L.$yc)(w,S,new Set);I.forEach(b=>k.add(b))});const y=[];return w.forEach((D,S)=>y.push([S,[...D.values()]])),{keys:[...a.values()],overrides:y}}class i{constructor(a,w,y,D,S){this.change=a,this.f=w,this.g=y,this.h=D,this.i=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const I of a.keys)this.affectedKeys.add(I);for(const[,I]of a.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,w){const y=this.a+a,D=this.d.indexOf(y);if(D<0)return!1;const S=D+y.length;if(S>=this.d.length)return!1;const I=this.d.charCodeAt(S);if(I!==this.b&&I!==this.c)return!1;if(w){const k=this.previousConfiguration?this.previousConfiguration.getValue(a,w,this.f?.workspace):void 0,b=this.g.getValue(a,w,this.h);return!T.$do(k,b)}return!0}}e.$Mo=i;function t(d,a){const{added:w,removed:y,updated:D}=s(a?.rawConfiguration,d?.rawConfiguration),S=[],I=d?.getAllOverrideIdentifiers()||[],k=a?.getAllOverrideIdentifiers()||[];if(a){const b=k.filter(v=>!I.includes(v));for(const v of b)S.push([v,a.getKeysForOverrideIdentifier(v)])}if(d){const b=I.filter(v=>!k.includes(v));for(const v of b)S.push([v,d.getKeysForOverrideIdentifier(v)])}if(a&&d){for(const b of I)if(k.includes(b)){const v=s({contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)},{contents:a.getOverrideValue(void 0,b)||{},keys:a.getKeysForOverrideIdentifier(b)});S.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:y,updated:D,overrides:S}}function s(d,a){const w=d?a?d.keys.filter(S=>a.keys.indexOf(S)===-1):[...d.keys]:[],y=a?d?a.keys.filter(S=>d.keys.indexOf(S)===-1):[...a.keys]:[],D=[];if(d&&a){for(const S of a.keys)if(d.keys.indexOf(S)!==-1){const I=(0,C.$ej)(a.contents,S),k=(0,C.$ej)(d.contents,S);T.$do(I,k)||D.push(S)}}return{added:w,removed:y,updated:D}}}),define(Ee[283],Se([1,0,22,4,3,69]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$owb=e.$mwb=e.$lwb=void 0,e.$nwb=T;const L=(l,C,E)=>{const u=new Uint8Array(16);for(let c=0;c<16;c++)u[c]=Math.round(Math.random()*256);const P=(0,r.$6e)(r.$Le.wrap(u));return[`GET ws://localhost${l}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$lwb=L,e.$mwb=r.$Le.fromString(`\r
\r
`);async function T(l,C,E,u,P){l.write(r.$Le.fromString((0,e.$lwb)(C,E,u)));const p=new A.$Uc;try{return await new Promise((c,g)=>{let f;p.add(l.onData(m=>{f?f=r.$Le.concat([f,m],f.byteLength+m.byteLength):f=m;const n=f.indexOf(e.$mwb);if(n===-1)return;c(l),l.pauseData();const o=f.slice(n+e.$mwb.byteLength);o.byteLength&&P.onData.fire(o)})),p.add(l.onClose(m=>g(m??new Error("socket closed")))),p.add(l.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw l.dispose(),c}finally{p.dispose()}}class $ extends A.$Vc{constructor(C,E){super(),this.g=C,this.a=this.B(new h.$me),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(u=>this.a.fire(u))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,E){R.SocketDiagnostics.traceSocketEvent(this,this.g,C,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$owb=$}),define(Ee[72],Se([1,0,14,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=l,e.$Nl=(0,h.$Ci)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(E){this.id=E,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=R;class L{constructor(E,u){this.host=E,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=L;var T;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class $ extends r.$cb{static isNotAvailable(E){return E instanceof $&&E._code===T.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===T.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===T.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===T.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,u=T.Unknown,P){super(E),this._message=E,this._code=u,this._detail=P,this.isHandled=u===T.NotAvailable&&P===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ql=$;function l(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}}),define(Ee[284],Se([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Wl=S,e.$Xl=I,e.$Yl=b,l=Ue(l);const p=30*1e3;var c;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g($e){switch($e){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function f($e){const Q=new A.$ue;return setTimeout(()=>Q.cancel(),$e),Q.token}function m($e,Q){if($e.isCancellationRequested||Q.isCancellationRequested)return A.CancellationToken.Cancelled;const U=new A.$ue;return $e.onCancellationRequested(()=>U.cancel()),Q.onCancellationRequested(()=>U.cancel()),U.token}class n{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new T.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$vh)(),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function o($e,Q){const U=new n(Q);return U.registerDisposable($e.onControlMessage(se=>{const oe=JSON.parse(se.toString()),te=G(oe);te?U.reject(te):U.resolve(oe)})),U.promise}function i($e,Q,U,se,oe,te,le,he){const X=new n(he),ae=C.$de.create(!1);return $e.info(`Creating a socket (${le})...`),l.mark(`code/willCreateSocket/${te}`),Q.connect(U,se,oe,le).then(pe=>{X.didTimeout?(l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(l.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${ae.elapsed()} ms.`),X.resolve(pe))},pe=>{l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${ae.elapsed()} ms.`),$e.error(pe),X.reject(pe)}),X.promise}function t($e,Q){const U=new n(Q);return $e.then(se=>{U.didTimeout||U.resolve(se)},se=>{U.didTimeout||U.reject(se)}),U.promise}async function s($e,Q,U,se){const oe=ne($e,Q);$e.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let te;try{te=await i($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Pg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,g(Q),`renderer-${g(Q)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let le,he;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,he=!1):(le=new u.$qi({socket:te}),he=!0),$e.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const X=await t($e.signService.createNewMessage((0,E.$Yg)()),se),ae={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:X.data};le.sendControl(h.$Le.fromString(JSON.stringify(ae)));try{const pe=await o(le,m(se,f(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await t($e.signService.validate(X,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Me=await t($e.signService.sign(pe.data),se),We={type:"connectionType",commit:$e.commit,signedData:Me,desiredConnectionType:Q};return U&&(We.args=U),$e.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Le.fromString(JSON.stringify(We))),{protocol:le,ownsProtocol:he}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${oe} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${oe} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),he&&z(le),pe}}async function d($e,Q,U,se){const oe=Date.now(),te=ne($e,Q),{protocol:le,ownsProtocol:he}=await s($e,Q,U,se),X=new n(se);return X.registerDisposable(le.onControlMessage(ae=>{const pe=JSON.parse(ae.toString()),be=G(pe);be?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(be),he&&z(le),X.reject(be)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(oe)}!`),X.resolve({protocol:le,firstMessage:pe}))})),X.promise}async function a($e,Q){const{protocol:U}=await d($e,c.Management,void 0,Q);return{protocol:U}}async function w($e,Q,U){const{protocol:se,firstMessage:oe}=await d($e,c.ExtensionHost,Q,U),te=oe&&oe.debugPort;return{protocol:se,debugPort:te}}async function y($e,Q,U){const se=Date.now(),oe=ne($e,c.Tunnel),{protocol:te}=await s($e,c.Tunnel,Q,U);return $e.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function D($e,Q,U){const{connectTo:se,connectionToken:oe}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:oe,reconnectionToken:Q,reconnectionProtocol:U,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function S($e,Q,U){return k($e,async se=>{const{protocol:oe}=await a(se,A.CancellationToken.None);return new _($e,Q,U,se.reconnectionToken,oe)})}async function I($e,Q){return k($e,async U=>{const{protocol:se,debugPort:oe}=await w(U,Q,A.CancellationToken.None);return new re($e,Q,U.reconnectionToken,se,oe)})}async function k($e,Q){for(let se=1;;se++)try{const oe=(0,E.$Yg)(),te=await D($e,oe,null);return await Q(te)}catch(oe){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(oe);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(oe),W.triggerPermanentFailure(0,0,P.$Ql.isHandled(oe)),oe}}async function b($e,Q,U){const se=await D($e,(0,E.$Yg)(),null);return await y(se,{host:Q,port:U},A.CancellationToken.None)}function v($e){return(0,r.$ph)(Q=>new Promise((U,se)=>{const oe=setTimeout(U,$e*1e3);Q.onCancellationRequested(()=>{clearTimeout(oe),U()})}))}var N;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(Q,U){this.reconnectionToken=Q,this.millisSinceLastIncomingData=U,this.type=N.ConnectionLost}}e.$Zl=O;class F{constructor(Q,U,se,oe){this.reconnectionToken=Q,this.millisSinceLastIncomingData=U,this.durationSeconds=se,this.c=oe,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$1l=F;class j{constructor(Q,U,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=N.ReconnectionRunning}}e.$2l=j;class B{constructor(Q,U,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=U,this.attempt=se,this.type=N.ConnectionGain}}e.$3l=B;class M{constructor(Q,U,se,oe){this.reconnectionToken=Q,this.millisSinceLastIncomingData=U,this.attempt=se,this.handled=oe,this.type=N.ReconnectionPermanentFailure}}e.$4l=M;class W extends T.$Vc{static triggerPermanentFailure(Q,U,se){this._permanentFailure=!0,this.f=Q,this.g=U,this.h=se,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Q=>Q.y())}static debugPauseSocketWriting(){this.j.forEach(Q=>Q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(Q,U,se,oe,te){super(),this.t=Q,this.u=U,this.reconnectionToken=se,this.protocol=oe,this.w=te,this.m=this.B(new L.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new B(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(le=>{const he=ue(this.t,this.reconnectionToken,!0);le?le.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${he} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${he} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${he} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(le=>{const he=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${he} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,T.$Tc)(()=>{const le=W.j.indexOf(this);le>=0&&W.j.splice(le,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Q=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const oe=se<U.length?U[se]:U[U.length-1];try{if(oe>0){const le=v(oe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,le)),this.u.logService.info(`${Q} waiting for ${oe} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${Q} resolving connection...`);const te=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Q} connecting to ${te.connectTo}...`),await this.G(te,f(p)),this.u.logService.info(`${Q} reconnected!`),this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Ql.isTemporarilyNotAvailable(te)){this.u.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$5)(te)){this.u.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof P.$Ql){this.u.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Ql.isHandled(te));break}this.u.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(Q,U,se){this.w?W.triggerPermanentFailure(Q,U,se):this.D(Q,U,se)}D(Q,U,se){this.m.fire(new M(this.reconnectionToken,Q,U,se)),z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5l=W;class _ extends W{constructor(Q,U,se,oe,te){super(c.Management,Q,oe,te,!0),this.client=this.B(new u.$oi(te,{remoteAuthority:U,clientId:se},Q.ipcLogger))}async G(Q,U){await a(Q,U)}}e.$6l=_;class re extends W{constructor(Q,U,se,oe,te){super(c.ExtensionHost,Q,se,oe,!1),this.H=U,this.debugPort=te}async G(Q,U){await w(Q,this.H,U)}}e.$7l=re;function z($e){try{$e.acceptDisconnect();const Q=$e.getSocket();$e.dispose(),Q.dispose()}catch(Q){(0,R.$2)(Q)}}function G($e){if($e&&$e.type==="error"){const Q=new Error(`Connection error: ${$e.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function J($e,Q){for(;$e.length<Q;)$e+=" ";return $e}function ee($e,Q){return`[remote-connection][${J(g($e),13)}][${Q.substr(0,5)}\u2026]`}function ue($e,Q,U){return`${ee($e,Q)}[${U?"reconnect":"initial"}]`}function ne($e,Q){return`${ue(Q,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(Ee[91],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=h,e.$en=A,e.$fn=R,e.$gn=L;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function A($){if(!$)return;const l=$.indexOf("+");return l<0?$:$.substr(0,l)}function R($){const{host:l,port:C}=T($);if(typeof C>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:C}}function L($,l){let{host:C,port:E}=T($);return typeof E>"u"&&(E=l),{host:C,port:E}}function T($){const l=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const C=$.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(Ee[24],Se([1,0,13,5,91]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=R,e.$qn=E,e.$rn=u,e.$sn=P,e.$tn=p,r=Ue(r),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function R(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(L||(e.ExtensionType=L={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,f){if(typeof g>"u"||g===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof g=="string"||typeof f=="string"){const m=typeof g=="string"?g:g.value,n=typeof f=="string"?f:f.value;return r.$Df(m,n)}return g._lower===f._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$nn=$;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const f of g)this.add(f)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$on=l;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,f){this.c.set($.toKey(g),f)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=C;function E(c){return u(c)}function u(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function P(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function p(c,g){if(g){const f=`onResolveRemoteAuthority:${(0,A.$en)(g)}`;return!!c.activationEvents?.includes(f)}return!1}e.$un=(0,h.$Ci)("IBuiltinExtensionsScannerService")}),define(Ee[146],Se([1,0,11,221,24,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=T,e.$_o=$,e.$ap=l,e.$bp=C,e.$cp=E,e.$dp=u,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function T(i){switch(i){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function $(i){switch(i){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function l(i,t){switch(i){case r.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function C(i,t){return t===A.TargetPlatform.WEB&&!i.includes(A.TargetPlatform.WEB)}function E(i,t,s){return C(t,s)?!1:i===A.TargetPlatform.UNDEFINED||i===A.TargetPlatform.UNIVERSAL?!0:i===A.TargetPlatform.UNKNOWN?!1:i===s}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var P;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var p;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var c;(function(i){i.Install="install",i.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$ep=(0,R.$Ci)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class m extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$fp=m;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$gp=o,e.$hp=(0,R.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,R.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,R.$Ci)("IExtensionTipsService"),e.$mp=(0,h.localize2)(0,"Extensions"),e.$np=(0,h.localize2)(1,"Preferences")}),define(Ee[147],Se([1,0,14,24]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(L,T){this.a.set(L,T)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const T=Object.create(null);for(const $ of L){const l=this.readActivationEvents($);l.length>0&&(T[h.$nn.toKey($.identifier)]=l)}return T}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const T=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<T.length;$++)T[$]==="onUri"&&(T[$]=`onUri:${h.$nn.toKey(L.identifier)}`);if(!L.contributes)return T;for(const $ in L.contributes){const l=this.a.get($);if(!l)continue;const C=L.contributes[$],E=Array.isArray(C)?C:[C];try{l(E,T)}catch(u){(0,r.$2)(u)}}return T}}e.$FG=A,e.$GG=new A}),define(Ee[285],Se([1,0,3,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl=(0,h.$Ci)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(L,T){return this.a[L]??=[],this.a[L].push(T),(0,r.$Tc)(()=>{const $=this.a[L]?.indexOf(T);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,T,$,l){const C=this.b(L);if(!C)throw new Error(`No socket factory found for ${L}`);return C.connect(L,T,$,l)}}e.$Tl=A}),define(Ee[286],Se([1,0,22,14,3,229,71,5,12,37]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=u,e.$2p=P,e.$3p=p,e.$4p=c,e.$5p=g,e.$6p=f,e.$Yp=(0,T.$Ci)("requestService");class C{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class E extends A.$Vc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(0,null),when:$.$ok.isEqualTo((0,$.$lk)($.LogLevel.Trace)).serialize()})}async c(i,t,s){const d=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${d} - begin`,t.type,new C(t.headers??{}));try{const a=await s();return this.a.trace(`${d} - end`,t.type,a.res.statusCode,a.res.headers),a}catch(a){throw this.a.error(`${d} - error`,t.type,(0,h.$$)(a)),a}}}e.$Zp=E;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function p(o){return P(o)?null:(await(0,r.$Xe)(o.stream)).toString()}async function c(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return p(o)}async function g(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const t=(await(0,r.$Xe)(o.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(o){n(o)}let m;function n(o){const i=l.$mo.as(L.$ro.Configuration),t=m;m={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(Ee[287],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const L=String(r.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const L=this.b.get(A.id);if(!L)return!1;this.b.delete(A.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$Cac=r}),define(Ee[118],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=void 0,e.$Ul="signService",e.$Vl=(0,r.$Ci)(e.$Ul)}),define(Ee[148],Se([1,0,287]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;class h extends r.$Cac{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>ce(["vsda"],R,L))}}e.$Hfc=h}),define(Ee[288],Se([1,0,11,56,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=L,e.$pp=T;function R($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,l,C,E,u,P,p,c,g,f){const m=Object.create(null);m["common.machineId"]=P,m["common.sqmId"]=p,m["common.devDeviceId"]=c,m.sessionID=(0,A.$Yg)()+Date.now(),m.commitHash=E,m.version=u,m["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.$h)(r.$u),m["common.nodePlatform"]=h.$ec,m["common.nodeArch"]=C,m["common.product"]=f||"desktop",g&&(m["common.msftInternal"]=g);let n=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(m["common.snap"]="true");const i=R(l);return i&&(m["common.platformDetail"]=i),m}function T($){const l=h.env.USERDNSDOMAIN;if(!l)return!1;const C=l.toLowerCase();return $.some(E=>C===E)}}),define(Ee[149],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,r.$Ci)("telemetryService"),e.$9l=(0,r.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ee[92],Se([1,0,25,18,91,288,149]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=C,e.$yp=E,e.$zp=u,e.$Ap=P,e.$Bp=c,e.$Cp=f,e.$Dp=m,e.$Ep=i;class T{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$qp=T;class ${constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=$,e.$sp=new $;class l{async publicLog(s,d,a){}async publicLogError(s,d,a){}}e.$tp=l,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function C(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function E(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const s=t.getValue(L.$em),d=t.getValue(L.$fm);if(t.getValue(L.$gm)===!1||d===!1)return L.TelemetryLevel.NONE;switch(s??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(t){const s={},d={},a={};g(t,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const y=a[w];typeof y=="number"?d[w]=y:typeof y=="boolean"?d[w]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${y.length}`),s[w]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[w]=y)}return{properties:s,measurements:d}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const s=(0,A.$en)(t);return p.has(s)?s:"other"}function g(t,s,d=0,a){if(t)for(const w of Object.getOwnPropertyNames(t)){const y=t[w],D=a?a+w:w;Array.isArray(y)?s[D]=(0,r.$eo)(y):y instanceof Date?s[D]=y.toISOString():(0,h.$eg)(y)?d<2?g(y,s,d+1,D+"."):s[D]=(0,r.$eo)(y):s[D]=y}}function f(t,s){const d=t.msftInternalDomains||[],a=s.getValue("telemetry.internalTesting");return(0,R.$pp)(d)||a}function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const a=[];for(const S of s)for(;;){const I=S.exec(t);if(!I)break;a.push([I.index,S.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const S=y.exec(t);if(!S)break;const I=a.some(([k,b])=>S.index<b&&k<y.lastIndex);!w.test(S[0])&&!I&&(d+=t.substring(D,S.index)+"<REDACTED: user-file-path>",D=y.lastIndex)}return D<t.length&&(d+=t.substr(D)),d}function o(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of s)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function i(t,s){return(0,r.$bo)(t,d=>{if(d instanceof T||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let a=d.replaceAll("%20"," ");a=n(a,s);for(const w of s)a=a.replace(w,"");return a=o(a),a}})}}),define(Ee[289],Se([1,0,13,146,24,11,2,14,56,92]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=C,e.$Hp=p,e.$Ip=c,e.$Jp=g,e.$Kp=f,e.$Lp=m,e.$Mp=n,e.$Np=o,e.$Pp=i,e.$Qp=s;function C(d,a){return d.uuid&&a.uuid?d.uuid===a.uuid:d.id===a.id?!0:(0,r.$yf)(d.id,a.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(a){const w=a.manifest?a.manifest.version:a.version,y=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new u(a.identifier,w,y)}static parse(a){const w=E.exec(a);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(a,w,y=A.TargetPlatform.UNDEFINED){this.identifier=a,this.version=w,this.targetPlatform=y,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof u?C(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$Gp=u;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(d){const a=P.exec(d);return a&&a[1]?[g(a[1]),a[2]]:[g(d),void 0]}function c(d,a){return`${d}.${a}`}function g(d){return d.toLowerCase()}function f(d,a){return g(c(d??A.$jn,a))}function m(d,a){const w=[],y=D=>{for(const S of w)if(S.some(I=>C(a(I),a(D))))return S;return null};for(const D of d){const S=y(D);S?S.push(D):w.push([D])}return w}function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function o(d){return{id:new l.$qp(d.identifier.id),name:new l.$qp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Op=new A.$nn("pprice.better-merge");function i(d,a){const w=[],y=a.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const D=y.shift();if(D&&w.every(S=>!C(S.identifier,{id:D}))){const S=d.filter(I=>C(I.identifier,{id:D}));S.length===1&&(w.push(S[0]),y.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(d,a){if(!R.$k)return!1;let w;try{w=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){a.debug("Error while getting the os-release file.",(0,T.$$)(D))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,a){const w=await t(d,a),y=(0,h.$ap)(w?"alpine":R.$u,$.$fc);return a.debug("ComputeTargetPlatform:",y),y}}),define(Ee[290],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=r,e.$xs=h,e.$ys=A,e.$zs=R,e.$As=L,e.$Bs=T;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function A($){return new Map($)}function R($){return new Map($??[])}function L($){return Array.from($.entries()).map(l=>[l[0],r(l[1].map),h(l[1].descriptionMap)])}function T($){return new Map($.map(l=>[l[0],{map:A(l[1]),descriptionMap:R(l[2])}]))}}),define(Ee[291],Se([1,0,5,36,37]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fs=void 0,e.$fs=new h.$Tj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var T;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(T||(e.PosixShellType=T={}));var $;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})($||(e.WindowsShellType=$={}));var l;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var C;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var E;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$gs=(0,r.$Ci)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var P;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var p;(function(i){i.TerminalView="view",i.Editor="editor"})(p||(e.TerminalLocationString=p={}));var c;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var f;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var m;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$hs={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}A.$mo.add(e.$hs.Backend,new o),e.$is=(0,r.$Ci)("localPtyService"),e.$js=(0,r.$Ci)("terminalLogService")}),define(Ee[292],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gwb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,L=5){const T=R($=>{const l=typeof $=="string"?$:$.data;let C=this.a.get(A);if(C){C.data.push(l);return}const E=setTimeout(()=>this.flushBuffer(A),L);C={data:[l],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(A),T.dispose()}},this.a.set(A,C)});return T}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$Gwb=r}),define(Ee[293],Se([1,0,9,83,105,50,4,18,2,230,117,37]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yx=e.$xx=e.$wx=e.$vx=e.$ux=e.$tx=e.IconFontDefinition=e.IconContribution=e.$qx=void 0,e.$rx=g,e.$sx=f,E=Ue(E),e.$qx={IconContribution:"base.contributions.icons"};var u;(function(i){function t(s,d){let a=s.defaults;for(;R.ThemeIcon.isThemeIcon(a);){const w=c.getIcon(a.id);if(!w)return;a=w.defaults}return a}i.getDefinition=t})(u||(e.IconContribution=u={}));var P;(function(i){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(a=>({format:a.format,location:a.location.toString()}))}}i.toJSONObject=t;function s(d){const a=w=>(0,T.$cg)(w)?w:void 0;if(d&&Array.isArray(d.src)&&d.src.every(w=>(0,T.$cg)(w.format)&&(0,T.$cg)(w.location)))return{weight:a(d.weight),style:a(d.style),src:d.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}i.fromJSONObject=s})(P||(e.IconFontDefinition=P={}));class p{constructor(){this.a=new L.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,s,d,a){const w=this.b[t];if(w){if(d&&!w.description){w.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=d),this.a.fire()}return w}const y={id:t,description:d,defaults:s,deprecationMessage:a};this.b[t]=y;const D={$ref:"#/definitions/icons"};return a&&(D.deprecationMessage=a),d&&(D.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=D,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const s=this.e.enum.indexOf(t);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,s){const d=this.f[t];return d||(this.f[t]=s,this.a.fire(),s)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,y)=>w.id.localeCompare(y.id),s=w=>{for(;R.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(w=>this.b[w]);for(const w of a.filter(y=>!!y.description).sort(t))d.push(`|<i class="${s(w)}"></i>|${w.id}|${R.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const w of a.filter(y=>!R.ThemeIcon.isThemeIcon(y.defaults)).sort(t))d.push(`|<i class="${s(w)}"></i>|${w.id}|`);return d.join(`
`)}}const c=new p;E.$mo.add(e.$qx.IconContribution,c);function g(i,t,s,d){return c.registerIcon(i,t,s,d)}function f(){return c}function m(){const i=(0,A.$Xj)();for(const t in i){const s="\\"+i[t].toString(16);c.registerIcon(t,{fontCharacter:s})}}m(),e.$tx="vscode://schemas/icons";const n=E.$mo.as(C.$no.JSONContribution);n.registerSchema(e.$tx,c.getIconSchema());const o=new r.$Oh(()=>n.notifySchemaChanged(e.$tx),200);c.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$ux=g("widget-close",h.$2j.close,(0,l.localize)(2,null)),e.$vx=g("goto-previous-location",h.$2j.arrowUp,(0,l.localize)(3,null)),e.$wx=g("goto-next-location",h.$2j.arrowDown,(0,l.localize)(4,null)),e.$xx=R.ThemeIcon.modify(h.$2j.sync,"spin"),e.$yx=R.ThemeIcon.modify(h.$2j.loading,"spin")}),define(Ee[93],Se([1,0,4,3,11,2,45,5,12]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Bw=e.$zw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vw=e.$uw=void 0,e.$ww=E,e.$xw=P,e.$yw=p,e.$Aw=c,e.$Cw=g,e.$Dw=f,e.$uw=(0,T.$Ci)("tunnelService"),e.$vw=(0,T.$Ci)("sharedTunnelsService");var l;(function(o){o.Http="http",o.Https="https"})(l||(e.TunnelProtocol=l={}));var C;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(C||(e.TunnelPrivacyId=C={}));function E(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(i)return{address:i[1],port:+i[2]}}function p(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const i=o.query.split("&");for(const t of i){const s=t.split("=")[1];if(/^https?:/.exec(s)){const d=P(R.URI.parse(s));if(d)return d}}}e.$zw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(o){return e.$zw.indexOf(o)>=0}e.$Bw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(o){return e.$Bw.indexOf(o)>=0}function f(o,i,t,s){if(t===A.OperatingSystem.Windows)return!1;if(t===A.OperatingSystem.Macintosh&&g(i)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(d?.length===4&&parseInt(d[1])>=18)return!1}return o<1024}class m{constructor(i,t,s){this.remoteAddress=i,this.localAddress=t,this.b=s,this.a=new r.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ew=m;let n=class extends h.$Vc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new r.$je,this.onTunnelOpened=this.a.event,this.b=new r.$je,this.onTunnelClosed=this.b.event,this.c=new r.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const s of t){const d=Array.from(s.values());for(const a of d){const w=await a.value;w&&typeof w!="string"&&i.push(w)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,s,d,a){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:s,privacy:d,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(g(i)||c(i))&&(i=e.$zw[0]);const s=this.D(i,t);if(s)return++s.refcount,s.value}openTunnel(i,t,s,d,a,w=!1,y,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${a}.`);const S=this.g??i;if(!S)return;if(t||(t="localhost"),d||(d=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const I=this.F(S,t,s,d,a,w,y,D);return I?I.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&k.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),I)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const s=t.get(i.tunnelRemotePort);s&&(s.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async y(i,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const d=s.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),d}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const s=this.f.get(i);if(s&&s.has(t)){const d=s.get(t);d.refcount=0,await this.y(i,t,d)}}z(i,t,s){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:s})}async C(i,t){const s=this.f.get(i);if(s){const d=s.get(t),a=d?await d.value:void 0;(!a||typeof a=="string")&&s.delete(t),s.size===0&&this.f.delete(i)}}D(i,t){const s=[i];c(i)?(s.push(...e.$zw),s.push(...e.$Bw)):g(i)&&s.push(...e.$Bw);const d=s.map(a=>this.f.get(a));for(const a of d){const w=a?.get(t);if(w)return w}}canTunnel(i){return!!P(i)}G(i,t,s,d,a,w,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${d}.`);const D=s;this.n.add(D);const S=d===void 0?s:d,I={elevationRequired:a?this.isPortPrivileged(S):!1},k={remoteAddress:{host:t,port:s},localAddressPort:d,privacy:w,public:w?w!==C.Private:void 0,protocol:y},b=i.forwardPort(k,I);return b?(this.z(t,s,b),b.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),b}};e.$Fw=n,e.$Fw=n=Ye([qe(0,$.$9j),qe(1,L.$9i)],n)}),define(Ee[294],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,r.$Ci)("IUriIdentityService")}),define(Ee[295],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Gw=void 0,e.$Gw=(0,r.$Ci)("editSessionIdentityService");var h;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Ee[296],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=h,e.$wM=A,e.$xM=R,e.$yM=L,e.$zM=T;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function A($){if($.folders.length)return $.folders.every(l=>h(l.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function R($){return A($)?.scheme}function L($){return A($)?.authority}function T($){return A($)!==void 0}}),define(Ee[46],Se([1,0,232,16,85,23,2,5,15]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=l,e.$Ni=C,e.$Qi=E,e.$Ri=u,e.$Si=P,e.$Ti=c,e.$Ui=g,e.$Xi=n,e.$3i=o,e.$4i=i,e.$6i=t,e.$7i=s,e.$8i=d,e.$Li=(0,T.$Ci)("contextService");function l(a){const w=a;return typeof w?.id=="string"&&L.URI.isUri(w.uri)}function C(a){return typeof a?.id=="string"&&!l(a)&&!u(a)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function E(a,w){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,h.$oc)(a)}:w?e.$Oi:e.$Pi;const y=a;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function u(a){const w=a;return typeof w?.id=="string"&&L.URI.isUri(w.configPath)}function P(a){const w=a;if(w?.uri)return{id:w.id,uri:L.URI.revive(w.uri)};const y=a;if(y?.configPath)return{id:y.id,configPath:L.URI.revive(y.configPath)};if(a?.id)return{id:a.id}}var p;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function c(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function g(a){const w=a;return!!(w&&typeof w=="object"&&L.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class f{constructor(w,y,D,S,I){this.h=w,this.j=D,this.k=S,this.l=I,this.c=A.$Ii.forUris(this.l,()=>!0),this.folders=y}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=A.$Ii.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=f;class m{constructor(w,y){this.raw=y,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,R.$dh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=m;function n(a){return new m({uri:a,index:0,name:(0,R.$_g)(a)},{uri:a.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,r.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function o(a,w){return R.$7g.isEqualOrParent(a,w.untitledWorkspacesHome)}function i(a){let w;return L.URI.isUri(a)?w=a:w=a.configuration,w?.scheme===$.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.$5i}function s(a,w){return!o(a,w)&&!i(a)}function d(a){return(typeof a=="string"?(0,h.$pc)(a):(0,R.$bh)(a))===e.$Zi}}),define(Ee[150],Se([1,0,60,4,3,23,2,231,144,28,5,12,46,29,294,9,32,13,18]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=o,e.$Jl=i,e.$Kl=t;var n;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&L.URI.isUri(w.location)&&L.URI.isUri(w.globalStorageHome)&&L.URI.isUri(w.settingsResource)&&L.URI.isUri(w.keybindingsResource)&&L.URI.isUri(w.tasksResource)&&L.URI.isUri(w.snippetsHome)&&L.URI.isUri(w.extensionsResource))}e.$Il=(0,C.$Ci)("IUserDataProfilesService");function i(a,w){return{id:a.id,isDefault:a.isDefault,name:a.name,shortName:a.shortName,icon:a.icon,location:L.URI.revive(a.location).with({scheme:w}),globalStorageHome:L.URI.revive(a.globalStorageHome).with({scheme:w}),settingsResource:L.URI.revive(a.settingsResource).with({scheme:w}),keybindingsResource:L.URI.revive(a.keybindingsResource).with({scheme:w}),tasksResource:L.URI.revive(a.tasksResource).with({scheme:w}),snippetsHome:L.URI.revive(a.snippetsHome).with({scheme:w}),extensionsResource:L.URI.revive(a.extensionsResource).with({scheme:w}),cacheHome:L.URI.revive(a.cacheHome).with({scheme:w}),useDefaultFlags:a.useDefaultFlags,isTransient:a.isTransient}}function t(a,w,y,D,S,I){return{id:a,name:w,location:y,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:I&&S?.useDefaultFlags?.globalState?I.globalStorageHome:(0,R.$dh)(y,"globalStorage"),settingsResource:I&&S?.useDefaultFlags?.settings?I.settingsResource:(0,R.$dh)(y,"settings.json"),keybindingsResource:I&&S?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,R.$dh)(y,"keybindings.json"),tasksResource:I&&S?.useDefaultFlags?.tasks?I.tasksResource:(0,R.$dh)(y,"tasks.json"),snippetsHome:I&&S?.useDefaultFlags?.snippets?I.snippetsHome:(0,R.$dh)(y,"snippets"),extensionsResource:I&&S?.useDefaultFlags?.extensions?I.extensionsResource:(0,R.$dh)(y,"extensions.json"),cacheHome:(0,R.$dh)(D,a),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let s=class extends A.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,y,D,S){super(),this.t=w,this.u=y,this.w=D,this.y=S,this.f=!0,this.h=this.B(new h.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Bc,workspaces:new P.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),y=[w];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,m.$cg)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}y.push(t((0,R.$ah)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},w))}}catch(I){this.y.error(I)}const D=new P.$Bc,S=new Map;if(y.length)try{const I=this.Q();if(I.workspaces)for(const[k,b]of Object.entries(I.workspaces)){const v=L.URI.parse(k),N=y.find(O=>O.id===b);N&&D.set(v,N)}if(I.emptyWindows)for(const[k,b]of Object.entries(I.emptyWindows)){const v=y.find(N=>N.id===b);v&&S.set(k,v)}}catch(I){this.y.error(I)}this.z={profiles:y,workspaces:D,emptyWindows:S}}return this.z}D(){const w=t("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const y="Temp",D=new RegExp(`${(0,f.$ff)(y)}\\s(\\d+)`);let S=0;for(const k of this.profiles){const b=D.exec(k.name),v=b?parseInt(b[1]):0;S=v>S?v:S}const I=`${y} ${S+1}`;return this.createProfile((0,r.$qj)((0,g.$Yg)()).toString(16),I,{transient:!0},w)}async createNamedProfile(w,y,D){return this.createProfile((0,r.$qj)((0,g.$Yg)()).toString(16),w,y,D)}async createProfile(w,y,D,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(w,y,D);return S&&await this.setProfileForWorkspace(S,I),I}async F(w,y,D){if(!(0,m.$cg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(y);return S||(S=(async()=>{try{if(this.profiles.find(v=>v.name===y||v.id===w))throw new Error(`Profile with ${y} name already exists`);const k=t(w,y,(0,R.$dh)(this.profilesHome,w),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const b=[];return this.j.fire({profile:k,join(v){b.push(v)}}),await c.Promises.settled(b),this.I([k],[],[]),k}finally{this.r.delete(y)}})(),this.r.set(y,S)),S}async updateProfile(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(S=>S.id===w.id);if(!D)throw new Error(`Profile '${w.name}' does not exist`);return D=t(D.id,y.name??D.name,D.location,this.g,{shortName:y.shortName??D.shortName,icon:y.icon===null?void 0:y.icon??D.icon,transient:y.transient??D.isTransient,useDefaultFlags:y.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(S=>S.id===w.id);if(!y)throw new Error(`Profile '${w.name}' does not exist`);const D=[];this.m.fire({profile:y,join(S){D.push(S)}});try{await Promise.allSettled(D)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(S){(0,l.$nl)(S)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(S)}}async setProfileForWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(S=>S.id===y.id);if(!D)throw new Error(`Profile '${y.name}' does not exist`);this.L(w,D)}unsetWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(y=>y.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(w.map(y=>this.removeProfile(y)))}getProfileForWorkspace(w){const y=this.G(w),D=L.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return D||((0,u.$Mi)(w)?this.s.folders.get(w.uri):(0,u.$Ri)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,u.$Mi)(w)?w.uri:(0,u.$Ri)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,w.location)))}I(w,y,D){const S=[...this.profiles,...w],I=[],k=this.s.profiles;this.s.profiles=[];for(let b of S){if(b.isDefault||y.some(N=>b.id===N.id))continue;b=D.find(N=>b.id===N.id)??b;const v=k.find(N=>b.id===N.id);if(b.isTransient)this.s.profiles.push(b);else{if(v){for(const[N,O]of this.s.emptyWindows.entries())if(b.id===O.id){this.L({id:N},b);break}for(const[N,O]of this.s.workspaces.entries())if(b.id===O.id){this.L({id:"",configPath:N},b);break}for(const[N,O]of this.s.folders.entries())if(b.id===O.id){this.L({id:"",uri:N},b);break}}I.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags})}}this.P(I),this.z=void 0,this.J(w,y,D)}J(w,y,D){this.h.fire({added:w,removed:y,updated:D,all:this.profiles})}L(w,y,D){if(D=y?.isTransient?!0:D,D)(0,u.$Mi)(w)?(this.s.folders.delete(w.uri),y&&this.s.folders.set(w.uri,y)):(0,u.$Ri)(w)?(this.s.workspaces.delete(w.configPath),y&&this.s.workspaces.set(w.configPath,y)):(this.s.emptyWindows.delete(w.id),y&&this.s.emptyWindows.set(w.id,y));else{this.L(w,void 0,!0);const S=this.G(w);L.URI.isUri(S)?(this.C.workspaces.delete(S),y&&this.C.workspaces.set(S,y)):(this.C.emptyWindows.delete(S),y&&this.C.emptyWindows.set(S,y)),this.M()}}M(){const w={};for(const[D,S]of this.C.workspaces.entries())w[D.toString()]=S.id;const y={};for(const[D,S]of this.C.emptyWindows.entries())y[D.toString()]=S.id;this.R({workspaces:w,emptyWindows:y}),this.z=void 0}N(w){const y={},D=this.D();if(w.workspaces)for(const[I,k]of Object.entries(w.workspaces)){const b=L.URI.parse(k);y[I]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}const S={};if(w.emptyWindows)for(const[I,k]of Object.entries(w.emptyWindows)){const b=L.URI.parse(k);S[I]=this.w.extUri.isEqual(b,D.location)?D.id:this.w.extUri.basename(b)}return{workspaces:y,emptyWindows:S}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Ll=s,e.$Ll=s=Ye([qe(0,$.$Ji),qe(1,l.$9k),qe(2,p.$Gl),qe(3,E.$9j)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Ml=d}),define(Ee[151],Se([1,0,9,4,3,62,18,209,5,150]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=P,e.$cq=c,e.$eq=f,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,$.$Ci)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function P(m){const n=m.get(e.$$p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class p extends A.$Vc{static{this.a=60*1e3}constructor(n={flushInterval:p.a}){super(),this.m=n,this.b=this.B(new h.$me),this.c=this.B(new h.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$je),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,i){return h.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),i)}n(){this.j.value=(0,r.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:i,external:t}=o;if(i===e.$$p){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,o,i){return this.P(o)?.get(n,i)}getBoolean(n,o,i){return this.P(o)?.getBoolean(n,i)}getNumber(n,o,i){return this.P(o)?.getNumber(n,i)}getObject(n,o,i){return this.P(o)?.getObject(n,i)}storeAll(n,o){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,o)})}store(n,o,i,t,s=!1){if((0,L.$lg)(o)){this.remove(n,i,s);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,o,s)})}remove(n,o,i=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const i=[],t=this.J(n);for(const s of Object.keys(t))t[s]===o&&i.push(s);return i}z(n,o,i,t=!1){const s=this.J(o);typeof i=="number"?s[n]!==i&&(s[n]=i,this.P(o)?.set(e.$$p,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$$p,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?P(o):Object.create(null)}isNew(n){return this.getBoolean(e.$0p,n)===!0}async flush(n=C.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),i=this.P(E.PROFILE),t=this.P(E.WORKSPACE);switch(n){case C.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,i=this.P(E.WORKSPACE)?.items??new Map;return f(n,o,i,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(C.NONE),(0,l.$Hl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||c(o)&&c(n))}N(n,o,i){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),o.get(s)!==d&&this.u(i,{key:s,external:!0});for(const[s]of o.items)t.has(s)||this.u(i,{key:s,external:!0})})}}e.$bq=p;function c(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class g extends p{constructor(){super(),this.U=this.B(new T.$8p(new T.$9p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$8p(new T.$9p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$8p(new T.$9p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dq=g;async function f(m,n,o,i,t,s){const d=v=>{try{return JSON.parse(v)}catch{return v}},a=new Map,w=new Map;m.forEach((v,N)=>{a.set(N,v),w.set(N,d(v))});const y=new Map,D=new Map;n.forEach((v,N)=>{y.set(N,v),D.set(N,d(v))});const S=new Map,I=new Map;o.forEach((v,N)=>{S.set(N,v),I.set(N,d(v))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const k=[];if(a.forEach((v,N)=>{k.push({key:N,value:v})}),console.table(k),console.groupEnd(),console.log(w),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const v=[];y.forEach((N,O)=>{v.push({key:O,value:N})}),console.table(v),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${s})`);const b=[];S.forEach((v,N)=>{b.push({key:N,value:v})}),console.table(b),console.groupEnd(),console.log(I)}}),define(Ee[119],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$9mc=r}),define(Ee[63],Se([1,0,15,23,28,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$5g($=>{const l=this.b.get($.scheme);return!(l===void 0||l&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,l){l===null?this.b.delete($.scheme):this.b.set($.scheme,l)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$bnc=L,e.$cnc=(0,R.$Ci)("IExtHostFileSystemInfo")}),define(Ee[30],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0,e.$IP=(0,r.$Ci)("IExtHostInitDataService")}),define(Ee[297],Se([1,0,237,12,278,30]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;let L=class extends A.$SQ{constructor($,l,C){const E=C.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=C.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(E,{name:u}))}};e.$jpc=L,e.$jpc=L=Ye([qe(1,h.$0j),qe(2,R.$IP)],L)}),define(Ee[298],Se([1,0,9]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;class h{constructor(L,T,$){this.h=new Map,this.a=L,this.b=T,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(l=>(this.f=l,this)),this.g=this.c.onDidChangeStorage(l=>{l.shared===this.b&&l.key===this.a&&(this.f=l.value)}),this.i=new r.$Oh(()=>{const l=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of l.values())C.complete()}catch(C){for(const E of l.values())E.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,T){let $=this.f[L];return typeof $>"u"&&($=T),$}update(L,T){this.f[L]=T;const $=this.h.get(L);if($!==void 0)return $.p;const l=new r.$Zh;return this.h.set(L,l),this.i.isScheduled()||this.i.schedule(),l.p}dispose(){this.g.dispose()}}e.$Tnc=h;class A extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,T){super(L.identifier.value,!0,T),this.j=L}}e.$Unc=A}),define(Ee[299],Se([1,0,4,2]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class A{constructor(L){this.c=L,this.a=new r.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,T,$,l){const E=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(T.value,$,l);this.b.fire(E)}$acceptDirtyStateChanged(L,T){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(T)}$acceptModelSaved(L){const T=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(T.apiNotebook)}}e.$Noc=A}),define(Ee[20],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=void 0,e.$sP=(0,r.$Ci)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$tP=h}),define(Ee[300],Se([1,0,24,4]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class A{#e;constructor(L,T){this.b=new h.$je,this.onDidChange=this.b.event,this.a=r.$nn.toKey(L.identifier),this.#e=T,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(L){return this.#e.get(this.a,L)}store(L,T){return this.#e.store(this.a,L,T)}delete(L){return this.#e.delete(this.a,L)}}e.$4nc=A}),define(Ee[73],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$rnc=(0,r.$Ci)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$snc=h}),define(Ee[301],Se([1,0,302,412,413,67,2,12,414]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=C,r=Ue(r),h=Ue(h),A=Ue(A),R=Ue(R);const l=!1;function C(n,o,i,t,s,d){const a=d.environment.useHostProxy,w=typeof a=="boolean"?a:!d.remote.isRemote,y={resolveProxy:I=>n.resolveProxy(I),lookupProxyAuthorization:g.bind(void 0,t,s,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>u(o),addCertificatesV2:()=>P(o),log:t,getLogLevel:()=>{const I=t.getLevel();switch(I){case T.LogLevel.Trace:return $.LogLevel.Trace;case T.LogLevel.Debug:return $.LogLevel.Debug;case T.LogLevel.Info:return $.LogLevel.Info;case T.LogLevel.Warning:return $.LogLevel.Warning;case T.LogLevel.Error:return $.LogLevel.Error;case T.LogLevel.Off:return $.LogLevel.Off;default:return k(I)}function k(b){return t.error("Unknown log level",b),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const I=[];if(d.remote.isRemote&&I.push((0,$.loadSystemCertificates)({log:t})),w){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=n.loadCertificates();k.then(b=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",b.length)),I.push(k)}return(await Promise.all(I)).flat()},env:process.env},D=(0,$.createProxyResolver)(y),S=E(y,D);return c(i,S)}function E(n,o){function i(t,s){return new Proxy(t,{get(d,a){return a in s?s[a]:d[a]}})}return{http:i(r,(0,$.createHttpPatch)(n,r,o)),https:i(h,(0,$.createHttpPatch)(n,h,o)),net:i(R,(0,$.createNetPatch)(n,R)),tls:i(A,(0,$.createTlsPatch)(n,A))}}function u(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}function P(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}const p=new Map;function c(n,o){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(a,w,y){if(a==="net")return o.net;if(a==="tls")return o.tls;if(a!=="http"&&a!=="https")return s.apply(this,arguments);const D=i.findSubstr(L.URI.file(w.filename));let S=p.get(D);if(S||p.set(D,S={}),!S[a]){const I=o[a];S[a]={...I}}return S[a]}})}async function g(n,o,i,t,s,d,a,w){const y=t[d];a&&(t[d]=a),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${y}`);const D=a||y,S=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(m(o,S,s),S.some(I=>/^(Negotiate|Kerberos)( |$)/i.test(I))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const I=await new Promise((O,F)=>{ce(["kerberos"],O,F)}).then(Ue),k=new URL(d),b=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${b}`),"Negotiate "+await(await I.initializeClient(b)).step("")}catch(I){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",I)}}let f=!1;function m(n,o,i){f||!o.length||(f=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(Ee[303],Se([1,0,142]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=A;function h(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function A(R){return new r.$Gn(h(R))}});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[152],Se([1,0,247,18,2,3,5,37,28,15,55,201,44]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$$F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$1F=e.EditorInputCapabilities=e.$ZF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=void 0,e.$QF=c,e.$RF=g,e.$SF=f,e.$TF=m,e.$UF=n,e.$VF=o,e.$WF=i,e.$XF=t,e.$YF=s,e.$2F=S,e.$3F=k,e.$4F=b,e.$5F=v,e.$6F=N,e.$7F=O,e.$8F=F,e.$9F=j,e.$0F=z,e.$_F=ee,e.$aG=ne,e.$bG=De,e.$cG=$e,u=Wt(u),e.$LF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$MF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$NF="workbench.editor.sidebysideEditor",e.$OF="workbench.editors.textDiffEditor",e.$PF="workbench.editors.binaryResourceDiffEditor";var P;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var p;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function c(Q){const U=Q;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function g(Q){const U=Q;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function f(Q,U,se){for(const oe of se.visibleEditorPanes)if(oe.group.id===U&&Q.matches(oe.input))return oe.getViewState()}function m(Q){if(S(Q))return!1;const U=Q;return A.URI.isUri(U?.resource)}function n(Q){if(S(Q))return!1;const U=Q;return U?.original!==void 0&&U.modified!==void 0}function o(Q){if(S(Q))return!1;const U=Q;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function i(Q){if(S(Q)||n(Q))return!1;const U=Q;return U?.primary!==void 0&&U.secondary!==void 0}function t(Q){if(S(Q))return!1;const U=Q;return U?U.resource===void 0||U.resource.scheme===l.Schemas.untitled||U.forceUntitled===!0:!1}function s(Q){if(S(Q))return!1;const U=Q;return A.URI.isUri(U?.base?.resource)&&A.URI.isUri(U?.input1?.resource)&&A.URI.isUri(U?.input2?.resource)&&A.URI.isUri(U?.result?.resource)}var d;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var a;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class w{constructor(){this.a=new Map}registerSource(U,se){let oe=this.a.get(U);return oe||(oe={source:U,label:se},this.a.set(U,oe)),oe.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$ZF=new w;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class D extends R.$Vc{}e.$1F=D;function S(Q){return Q instanceof D}function I(Q){const U=Q;return A.URI.isUri(U?.preferredResource)}function k(Q){const U=Q;return S(U?.primary)&&S(U?.secondary)}function b(Q){const U=Q;return S(U?.modified)&&S(U?.original)}function v(Q,U,se,oe,te){return $e(oe,[(0,E.$mj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};Q.openEditor(U,le)}}),(0,E.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function N(Q){return S(Q?.editor)}function O(Q){const U=Q;return N(Q)&&U?.group!==void 0}function F(Q){const U=Q;return typeof U?.groupId=="number"&&S(U.editor)}function j(Q){return typeof Q?.groupId=="number"}var B;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var M;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var W;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class _{getOriginalUri(U,se){if(!U)return;if(s(U))return e.$$F.getOriginalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(U);if(te&&le){if(se?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===W.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===W.PRIMARY?te:le}}if(n(U)||o(U)||i(U)||s(U))return;const oe=I(U)?U.preferredResource:U.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}a(U){return k(U)||i(U)?{primary:U.primary,secondary:U.secondary}:b(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,se){if(!U)return;if(s(U))return e.$$F.getCanonicalUri(U.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(U);if(te&&le){if(se?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===W.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});U=se.supportSideBySide===W.PRIMARY?te:le}}if(n(U)||o(U)||i(U)||s(U))return;const oe=U.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}b(U,se){if(Array.isArray(se)){if(se.some(oe=>U.scheme===oe))return U}else if(se===U.scheme)return U}}var re;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function z(Q,U,se,oe){if(!Q.isSticky(U))return!1;switch(oe.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$$F=new _;var G;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class J{constructor(){this.c=new Map,this.d=new Map}start(U){const se=this.a=U.get(L.$Bi);for(const[oe,te]of this.c)this.e(oe,te,se);this.c.clear()}e(U,se,oe){const te=oe.createInstance(se);this.d.set(U,te)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,h.$ng)(this.b)}registerEditorSerializer(U,se){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,se,this.a):this.c.set(U,se),(0,R.$Tc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}T.$mo.add(e.$LF.EditorFactory,new J);async function ee(Q,U,se){return!Q||!Q.length?[]:await Promise.all(Q.map(async oe=>{const te=A.URI.revive(oe.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",oe);return}if(!await U.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",oe);return}let he=oe.exists,X=oe.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await U.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(pe){se.error(pe),he=!1}if(!he&&oe.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",oe);return}if(X===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",oe);return}const ae={...oe.options,pinned:!0};return he?{resource:te,options:ae}:{resource:te,options:ae,forceUntitled:!0}}))}var ue;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ne(Q){const U=Q;if(!U)return!1;const se=U;if(se.modified)return ne(se.modified);const oe=U;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}function De(Q){return(0,C.$oj)(Q)}function $e(Q,U,se){const oe=(0,C.$pj)(Q,U);return oe.forceMessage=se?.forceMessage,oe.forceSeverity=se?.forceSeverity,oe.allowDialog=se?.allowDialog,oe}}),define(Ee[304],Se([1,0,4,248,5,3,29,37,25,83,293]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$iG=e.ViewContentGroups=e.$gG=e.ViewContainerLocation=e.Extensions=e.$fG=e.$eG=e.$dG=void 0,e.$hG=P,e.$dG="views",e.$eG=(0,h.localize)(0,null),e.$fG=(0,C.$rx)("default-view-icon",l.$2j.window,(0,h.localize)(1,null));var E;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$gG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function P(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class p extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onDidRegister=this.c.event,this.f=this.B(new r.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,d,a){const w=this.get(s.id);if(w)return w;const y=s;return y.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,L.$yc)(this.g,d,[]).push(y),a?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:d}),y}deregisterViewContainer(s){for(const d of this.g.keys()){const a=this.g.get(d),w=a?.indexOf(s);if(w!==-1){a?.splice(w,1),a.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}T.$mo.add(E.ViewContainersRegistry,new p);var c;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(c||(e.ViewContentGroups=c={}));function g(t,s){const d=t.group??c.More,a=s.group??c.More;return d!==a?d.localeCompare(a):(t.order??5)-(s.order??5)}class f extends R.$Vc{constructor(){super(...arguments),this.c=this.B(new r.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Ic}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:a})=>this.r(d,a)),this.c.fire(s)}deregisterViews(s,d){const a=this.s(s,d);a.length&&this.f.fire({views:a,viewContainer:d})}moveViews(s,d){for(const a of this.m.keys())if(a!==d){const w=this.s(s,a);w.length&&(this.r(w,d),this.g.fire({views:w,from:a,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const a=(this.m.get(d)||[]).filter(w=>w.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(w=>w.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,R.$Tc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const a=new Map;for(const[w,y]of d)this.n.add(s,y),a.set(w,(0,R.$Tc)(()=>{this.n.delete(s,y),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,a=>d.push(a)),d.sort(g)}r(s,d){let a=this.m.get(d);a||(a=[],this.m.set(d,a),this.j.push(d));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));a.push(w)}}s(s,d){const a=this.m.get(d);if(!a)return[];const w=[],y=[];for(const D of a)s.includes(D)?w.push(D):y.push(D);return w.length&&(y.length?this.m.set(d,y):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),w}}T.$mo.add(E.ViewsRegistry,new f),e.$iG=(0,A.$Ci)("viewDescriptorService");var m;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,d){this.c=!1,this.d=!1,(0,$.$co)(this,s),this.d=!!d,this.resolve=async a=>{if(d&&!this.c){const w=await d(a);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$jG=o;class i extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$kG=i}),define(Ee[305],Se([1,0,249,36]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0,e.$oG=new h.$Tj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$pG=new h.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$qG=new h.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$rG=new h.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$sG=new h.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$tG=new h.$Tj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$uG=new h.$Tj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$vG=new h.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$wG=new h.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$xG=new h.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$yG=new h.$Tj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$zG=new h.$Tj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$AG=new h.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$BG=new h.$Tj("chatCursorAtTop",!1),e.$CG=new h.$Tj("chatInputHasAgent",!1),e.$DG=new h.$Tj("chatLocation",void 0),e.$EG=new h.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Ee[306],Se([1,0,132,9,21,4,40,3,57,180,13,36,24,5,12,116,286,151,305]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.ChatAgentLocation=void 0,e.$JH=d,e.$KH=a;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function y(D){switch(D){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$EH=(0,P.$Ci)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(y){this.f=y,this.b=new Map,this.d=new R.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=m.$AG.bindTo(this.f)}registerAgent(y,D){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const I=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(v=>!v.when||I.f.contextMatchesRules(E.$Aj.deserialize(v.when)))}};const b={data:D};return this.b.set(y,b),(0,T.$Tc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,D){const S=this.b.get(y);if(!S)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(S.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return S.data.isDefault&&this.e.set(!0),S.impl=D,this.d.fire(new t(S.data,D)),(0,T.$Tc)(()=>{S.impl=void 0,this.d.fire(void 0),S.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,D){y.isDynamic=!0;const S={data:y,impl:D};return this.b.set(y.id,S),this.d.fire(new t(y,D)),(0,T.$Tc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,D){return this.g.set(y,D),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,D,S){return await this.g.get(y)?.(D,S)??[]}updateAgent(y,D){const S=this.b.get(y);if(!S?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);S.data.metadata={...S.data.metadata,...D},this.d.fire(new t(S.data,S.impl))}getDefaultAgent(y){return(0,r.$gb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(y))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const D=this.b.get(y);return!D?.data.when||this.f.contextMatchesRules(E.$Aj.deserialize(D.data.when))}getAgentByFullyQualifiedId(y){const D=L.Iterable.find(this.b.values(),S=>d(S.data)===y)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new t(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(D=>D.name===y)}agentHasDupeName(y){const D=this.getAgent(y);return D?this.getAgentsByName(D.name).filter(S=>S.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(y,D,S,I,k){const b=this.b.get(y);if(!b?.impl)throw new Error(`No activated agent with id "${y}"`);return await b.impl.invoke(D,S,I,k)}async getFollowups(y,D,S,I,k){const b=this.b.get(y);if(!b?.impl)throw new Error(`No activated agent with id "${y}"`);return b.impl?.provideFollowups?b.impl.provideFollowups(D,S,I,k):[]}};e.$FH=i,e.$FH=i=Ye([qe(0,E.$Uj)],i);class t{constructor(y,D){this.b=y,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,D,S,I){return this.d.invoke(y,D,S,I)}async provideFollowups(y,D,S,I){return this.d.provideFollowups?this.d.provideFollowups(y,D,S,I):[]}provideWelcomeMessage(y,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,D)}provideSampleQuestions(y,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,D)}}e.$GH=t,e.$HH=(0,P.$Ci)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(y,D,S,I){if(this.g=D,this.h=S,this.i=I,this.e=(0,l.$4d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const k=I.get(n.b,f.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{I.remove(n.b,f.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,g.$5p)(y);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const S=D.restrictedChatParticipants;this.e.set(S,void 0),this.i.store(n.b,JSON.stringify(S),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(y){const D=this.l(y.name,y).get(),S=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return D&&S}l(y,D){return this.e.map(I=>I[y.toLowerCase()]).map(I=>I?I.some(k=>(0,C.$Df)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$IH=s,e.$IH=s=n=Ye([qe(0,c.$pk),qe(1,g.$Yp),qe(2,p.$9j),qe(3,f.$_p)],s);function d(w){return`${w.extensionId.value}.${w.id}`}function a(w){const y="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new u.$nn("")),(0,$.$_h)(y)}}),define(Ee[307],Se([1,0,2,31,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$aH=R,e.$bH=L;function R(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(h.$Ft.isIRange)}function L(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(R)}var T;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var $;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$cH=(0,A.$Ci)("IChatService"),e.$dH="accessibility.voice.keywordActivation"}),define(Ee[153],Se([1,0,4,9,251]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$je,this.o=new r.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,$,l,C){const E={command:T};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof C=="number"){const u=setTimeout(()=>{clearTimeout(u);const P=this.f.get(E.seq);if(P){this.f.delete(E.seq);const p={type:"response",seq:0,request_seq:E.seq,success:!1,command:T,message:(0,A.localize)(0,null,C,T)};P(p)}},C)}return l&&this.f.set(E.seq,l),E.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,$){return T.type!=="event"||$.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,h.$Dh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const $=T,l=this.f.get($.request_seq);l&&(this.f.delete($.request_seq),l($));break}}}}u(T,$){$.type=T,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach(($,l)=>T.set(l,$)),await(0,h.$Dh)(500),T.forEach(($,l)=>{$({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.f.delete(l)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Ssb=R}),define(Ee[120],Se([1,0,2,252,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$uK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$sK=e.MemoryRangeType=e.State=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=void 0,e.$rK=$,e.$tK=C,h=Ue(h),e.$fJ="workbench.view.debug",e.$gJ="workbench.debug.variablesView",e.$hJ="workbench.debug.watchExpressionsView",e.$iJ="workbench.debug.callStackView",e.$jJ="workbench.debug.loadedScriptsView",e.$kJ="workbench.debug.breakPointsView",e.$lJ="workbench.debug.disassemblyView",e.$mJ="workbench.panel.repl",e.$nJ="workbench.panel.repl.view",e.$oJ=new A.$Tj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$pJ=new A.$Tj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$qJ=new A.$Tj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$rJ="debugUx",e.$sJ=new A.$Tj(e.$rJ,"default",{type:"string",description:h.localize(3,null)}),e.$tJ=new A.$Tj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$uJ=new A.$Tj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$vJ=new A.$Tj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$wJ=new A.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$xJ=new A.$Tj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$yJ=new A.$Tj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$zJ=new A.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$AJ=new A.$Tj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$BJ=new A.$Tj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$CJ=new A.$Tj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$DJ=new A.$Tj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$EJ=new A.$Tj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$FJ=new A.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$GJ=new A.$Tj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$HJ=new A.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$IJ=new A.$Tj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$JJ=new A.$Tj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$KJ=new A.$Tj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$LJ=new A.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$MJ=new A.$Tj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$NJ=new A.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$OJ=new A.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$PJ=new A.$Tj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$QJ=new A.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$RJ=new A.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$SJ=new A.$Tj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$TJ=new A.$Tj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$UJ=new A.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$VJ=new A.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$WJ=new A.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$XJ=new A.$Tj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$YJ=new A.$Tj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$ZJ=new A.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$1J=new A.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$2J=new A.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$3J=new A.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$4J=new A.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$5J=new A.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$6J=new A.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$7J=new A.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$8J=new A.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$9J=new A.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$0J=new A.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$$J=new A.$Tj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$_J=new A.$Tj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$aK=new A.$Tj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$bK=new A.$Tj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$cK=new A.$Tj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$dK=new A.$Tj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$eK=new A.$Tj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$fK=new A.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$gK=new A.$Tj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$hK=new A.$Tj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$iK=new A.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$jK=new A.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$kK=new A.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$lK=new A.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const L=n=>h.localize(61,null,n);e.$mK=L,e.$nK="editor.contrib.debug",e.$oK="editor.contrib.breakpoint",e.$pK="debug",e.$qK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var T;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(T||(e.State=T={}));function $(n){switch(n){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var l;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.$sK="vscode-debug-memory";function C(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var P;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$uK=(0,R.$Ci)("debugService");var p;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(p||(e.BreakpointWidgetContext=p={}));var c;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var f;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(f||(e.IDebugVisualizationTreeItem=f={}));var m;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(m||(e.IDebugVisualization=m={}))}),define(Ee[308],Se([1,0,13,2,16,25,15,31,21,19]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZH=void 0,e.$NH=E,e.$OH=u,e.$PH=P,e.$QH=p,e.$RH=c,e.$SH=g,e.$TH=f,e.$UH=n,e.$VH=t,e.$WH=s,e.$XH=a,e.$YH=y;const C=/{([^}]+)}/g;function E(S,I,k){return S.replace(C,function(b,v){return I&&v.length>0&&v[0]!=="_"?b:k&&k.hasOwnProperty(v)?k[v]:b})}function u(S){const I={};for(const k of Object.keys(S))k.startsWith("!")||(I[k]=S[k]);return I}function P(S){return S.configuration.request==="attach"&&!p(S)&&(!S.parentSession||P(S.parentSession))}function p(S){let I=S.configuration.type;if(I)return I==="vslsShare"&&(I=S.configuration.adapterProxy.configuration.type),(0,r.$Df)(I,"extensionhost")||(0,r.$Df)(I,"pwa-extensionhost")?S:S.parentSession?p(S.parentSession):void 0}function c(S){return S.type&&(S.label||S.program||S.runtime)}function g(S,I,k){let b,v=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(S);){const F=O.index+1,j=F+O[0].length;if(F<=I&&j>=k){b=O[0],v=F;break}}if(b){const F=/\w+/g;let j=null;for(;(j=F.exec(b))&&!(j.index+1+v+j[0].length>=k););j&&(b=b.substring(0,F.lastIndex))}return b?{start:v,end:v+b.length-1}:{start:0,end:0}}async function f(S,I,k,b){if(S.evaluatableExpressionProvider.has(I)){const v=S.evaluatableExpressionProvider.ordered(I),N=(0,l.$Ib)(await Promise.all(v.map(async O=>{try{return await O.provideEvaluatableExpression(I,k,b??$.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const F=N[0].range;return O||(O=I.getLineContent(k.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:O}}}else{const v=I.getLineContent(k.lineNumber),{start:N,end:O}=g(v,k.column,k.column),F=v.substring(N-1,O);return{matchingExpression:F,range:new T.$Ft(k.lineNumber,N,k.lineNumber,N+F.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(S){return!!(S&&S.match(m))}function o(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(n(S.path))return h.URI.parse(S.path);if((0,A.$jc)(S.path))return h.URI.file(S.path)}return S.path}function i(S){if(typeof S.path=="object"){const I=h.URI.revive(S.path);if(I)return I.scheme===L.Schemas.file?I.fsPath:I.toString()}return S.path}function t(S,I){const k=I?o:i,b=(0,R.$_n)(S);return d(b,(v,N)=>{v&&N&&(N.path=k(N))}),b}function s(S,I){const k=I?o:i,b=(0,R.$_n)(S);return d(b,(v,N)=>{!v&&N&&(N.path=k(N))}),b}function d(S,I){switch(S.type){case"event":{const k=S;switch(k.event){case"output":I(!1,k.body.source);break;case"loadedSource":I(!1,k.body.source);break;case"breakpoint":I(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=S;switch(k.command){case"setBreakpoints":I(!0,k.arguments.source);break;case"breakpointLocations":I(!0,k.arguments.source);break;case"source":I(!0,k.arguments.source);break;case"gotoTargets":I(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(b=>I(!1,b));break;default:break}break}case"response":{const k=S;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(b=>I(!1,b.source));break;case"loadedSources":k.body.sources.forEach(b=>I(!1,b));break;case"scopes":k.body.scopes.forEach(b=>I(!1,b.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(b=>I(!1,b.source));break;case"setBreakpoints":k.body.breakpoints.forEach(b=>I(!1,b.source));break;case"disassemble":k.body?.instructions.forEach(v=>I(!1,v.location));break;default:break}break}}}function a(S){return S.filter(I=>!I.presentation?.hidden).sort((I,k)=>I.presentation?k.presentation?I.presentation.group?k.presentation.group?I.presentation.group!==k.presentation.group?I.presentation.group.localeCompare(k.presentation.group):w(I.presentation.order,k.presentation.order):-1:k.presentation.group?1:w(I.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function w(S,I){return typeof S!="number"?typeof I!="number"?0:1:typeof I!="number"?-1:S-I}async function y(S,I){const k=S.getValue("debug.saveBeforeStart",{overrideIdentifier:I.activeTextEditorLanguageId});if(k!=="none"&&(await I.saveAll(),k==="allEditorsInActiveGroup")){const b=I.activeEditorPane;b&&b.input.resource?.scheme===L.Schemas.untitled&&await I.save({editor:b.input,groupId:b.group.id})}await S.reloadConfiguration()}const D=(S,I)=>!S||!I?S===I:S.name===I.name&&S.path===I.path&&S.sourceReference===I.sourceReference;e.$ZH=D}),define(Ee[309],Se([1,0,58,67,25,16,11,13,34,253,153]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=e.$rpc=e.$qpc=e.$ppc=void 0,r=Ue(r),h=Ue(h),A=Ue(A),R=Ue(R),L=Ue(L),T=Ue(T),l=Ue(l);class E extends C.$Ssb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(f,m){this.l=m,this.p=Buffer.allocUnsafe(0),this.r=-1,f.on("data",n=>this.v(n))}sendMessage(f){if(this.l){const m=JSON.stringify(f);this.l.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${E.a}${m}`,"utf8")}}v(f){for(this.p=Buffer.concat([this.p,f]);;){if(this.r>=0){if(this.p.length>=this.r){const m=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this.n.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.p.indexOf(E.a);if(m!==-1){const o=this.p.toString("utf8",0,m).split(E.b);for(const i of o){const t=i.split(E.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(m+E.a.length);continue}}break}}}e.$ppc=E;class u extends E{startSession(){return new Promise((f,m)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),f(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):m(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$qpc=u;class P extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.$rpc=P;class p extends u{constructor(f){super(),this.z=f}y(f){return h.createConnection(this.z.path,f)}}e.$spc=p;class c extends E{constructor(f,m){super(),this.y=f,this.z=m}async startSession(){const f=this.y.command,m=this.y.args,n=this.y.options||{};try{if(f)if(R.$jc(f)){if(!await $.Promises.exists(f))throw new Error(l.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=A.$co(A.$_n(process.env),n.env)),f==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=r.fork(m[0],m.slice(1),t);if(!s.pid)throw new Error(l.localize(2,null,m[0]));this.x=s}else throw new Error(l.localize(3,null));else{const i={env:o};n.cwd&&(i.cwd=n.cwd),this.x=r.spawn(f,m,i)}this.x.on("error",i=>{this.n.fire(i)}),this.x.on("exit",(i,t)=>{this.o.fire(i)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",i=>{this.n.fire(i)}),this.x.stdin.on("error",i=>{this.n.fire(i)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),L.$i?new Promise((f,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,i,t){if(o)return m(o)});n.on("exit",f),n.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,m){if(!f)return;const n=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?n.runtime=R.$kc(m,f.runtime):n.runtime=f.runtime),f.runtimeArgs&&(n.runtimeArgs=f.runtimeArgs),f.program&&(R.$jc(f.program)?n.program=f.program:n.program=R.$kc(m,f.program)),f.args&&(n.args=f.args);const o=f;return o.win&&(n.win=c.A(o.win,m)),o.winx86&&(n.winx86=c.A(o.winx86,m)),o.windows&&(n.windows=c.A(o.windows,m)),o.osx&&(n.osx=c.A(o.osx,m)),o.linux&&(n.linux=c.A(o.linux,m)),n}static platformAdapterExecutable(f,m){let n=Object.create(null);m=m.toLowerCase();for(const a of f)if(a.contributes){const w=a.contributes.debuggers;w&&w.length>0&&w.filter(y=>typeof y.type=="string"&&T.$Df(y.type,m)).forEach(y=>{const D=c.A(y,a.extensionLocation.fsPath);n=A.$co(n,D,a.isBuiltin)})}let o;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.$i?o=n.win||n.windows:L.$j?o=n.osx:L.$k&&(o=n.linux),o=o||n;const i=o.program||n.program,t=o.args||n.args,s=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.$tpc=c}),define(Ee[310],Se([1,0,58,33,11]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=L,e.$vpc=$,r=Ue(r),A=Ue(A);function R(l,C){return new Promise((E,u)=>{let P="";const p=r.spawn(l,C);p.pid&&p.stdout.on("data",c=>{P+=c.toString()}),p.on("error",c=>{u(c)}),p.on("close",c=>{E(P)})})}async function L(l){if(l)if(A.$i){const C=await new Promise((E,u)=>{ce(["@vscode/windows-process-tree"],E,u)}).then(Ue);return new Promise(E=>{C.getProcessTree(l,u=>{E(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(C=>{const E=C.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},C=>!0);return Promise.resolve(!0)}var T;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(T||(T={}));function $(l,C,E,u,P){l=l.trim().toLowerCase();let p;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?p=T.powershell:l.indexOf("cmd.exe")>=0?p=T.cmd:l.indexOf("bash")>=0?p=T.bash:A.$i?p=T.cmd:p=T.bash;let c,g=" ";switch(p){case T.powershell:if(c=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),u){const f=(0,h.$Hg)(u);f&&(g+=`${f}:; `),g+=`cd ${c(u)}; `}if(P)for(const f in P){const m=P[f];m===null?g+=`Remove-Item env:${f}; `:g+=`\${env:${f}}='${m}'; `}if(C.length>0){const f=C.shift(),m=E?f:c(f);g+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of C)g+=n==="<"||n===">"||E?n:c(n),g+=" "}break;case T.cmd:if(c=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>f.includes(m))||f.length===0?`"${f}"`:f),u){const f=(0,h.$Hg)(u);f&&(g+=`${f}: && `),g+=`cd ${c(u)} && `}if(P){g+='cmd /C "';for(const f in P){let m=P[f];m===null?g+=`set "${f}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),g+=`set "${f}=${m}" && `)}}for(const f of C)g+=f==="<"||f===">"||E?f:c(f),g+=" ";P&&(g+='"');break;case T.bash:{c=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const f=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(u&&(g+=`cd ${c(u)} ; `),P){g+="/usr/bin/env";for(const m in P){const n=P[m];n===null?g+=` -u ${f(m)}`:g+=` ${f(`${m}=${n}`)}`}g+=" "}for(const m of C)g+=m==="<"||m===">"||E?m:c(m),g+=" ";break}}return g}}),define(Ee[311],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.CellExecutionUpdateType=void 0;var h;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$MK=(0,r.$Ci)("INotebookExecutionService")}),define(Ee[312],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jb=e.$7jb=e.ProxyKernelState=e.$6jb=void 0,e.$6jb=100;var h;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$7jb=(0,r.$Ci)("INotebookKernelService"),e.$8jb=(0,r.$Ci)("INotebookKernelHistoryService")}),define(Ee[313],Se([1,0,3,31,54,214,107]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uYb=void 0;class T extends r.$Vc{constructor(l,C,E){super(),this._source=l,this.b=C,this.c=E,this.a=void 0}f(l){const C=l.getLineCount();return new h.$Ft(1,1,C,this.g(l,C))}g(l,C){if(C<1||C>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(C)+1}get inputTextBuffer(){if(!this.b){const l=new R.$gD;l.acceptChunk(this._source);const C=l.finish(!0),{textBuffer:E,disposable:u}=C.create(A.DefaultEndOfLine.LF);this.b=E,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(l=>{const C=new R.$gD;C.acceptChunk(l);const E=C.finish(!0),{textBuffer:u,disposable:P}=E.create(A.DefaultEndOfLine.LF);return this.B(P),u})),this.a}findInInputs(l){const E=new L.$7C(l,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(l){const E=new L.$7C(l,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const P=u.findMatchesLineByLine(this.f(u),E,!0,5e3);if(P.length!==0)return{textBuffer:u,matches:P}}).filter(u=>!!u):[]}}e.$uYb=T}),define(Ee[74],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class A{static fromExtHostTestItem(L,T,$=L.parent){if(L._isRoot)return new A([T]);const l=[L.id];for(let C=$;C&&C.id!==T;C=C.parent)l.push(C.id);return l.push(T),new A(l.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const T=L.indexOf(r.Delimiter);return T===-1?L:L.slice(0,T)}static fromString(L){return new A(L.split(r.Delimiter))}static join(L,T){return new A([...L.path,T])}static joinToString(L,T){return L.toString()+r.Delimiter+T}static parentId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?void 0:L.slice(0,T)}static localId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?L:L.slice(T+r.Delimiter.length)}static isChild(L,T){return T.startsWith(L)&&T[L.length]===r.Delimiter}static compare(L,T){return L===T?h.IsSame:A.isChild(L,T)?h.IsChild:A.isChild(T,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,T){if(L===0)return 0;let $=0;for(;$<L-1;){for(let l=1;l<L;l++){const C=T(l-1),E=T(l);if(C.path[$]!==E.path[$])return $}$++}return $}constructor(L,T=L.length){if(this.path=L,this.d=T,L.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new A(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new A(this.path,L)}compare(L){if(typeof L=="string")return A.compare(this.toString(),L);for(let T=0;T<L.d&&T<this.d;T++)if(L.path[T]!==this.path[T])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$MI=A}),define(Ee[75],Se([1,0,2,53,31,74]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$UI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$TI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$SI=e.$RI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$QI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$PI=e.$OI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$NI=e.TestResultState=void 0;var L;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$NI={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var T;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var $;(function(B){B[B.Run=2]="Run",B[B.Debug=4]="Debug",B[B.Coverage=8]="Coverage",B[B.HasNonDefaultProfile=16]="HasNonDefaultProfile",B[B.HasConfigurable=32]="HasConfigurable",B[B.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$OI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const l=B=>"runId"in B;e.$PI=l;var C;(function(B){B.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),B.deserialize=(M,W)=>({range:A.$Ft.lift(W.range),uri:M.asCanonicalUri(r.URI.revive(W.uri))})})(C||(e.IRichLocation=C={}));var E;(function(B){B[B.Error=0]="Error",B[B.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(B){B.serialize=M=>({message:M.message,type:E.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&C.serialize(M.location)}),B.deserialize=(M,W)=>({message:W.message,type:E.Error,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&C.deserialize(M,W.location)})})(u||(e.ITestErrorMessage=u={}));const P=(B,M)=>`${M?"s":"e"}${B}`;e.$QI=P;var p;(function(B){B.serialize=M=>({message:M.message,type:E.Output,offset:M.offset,length:M.length,location:M.location&&C.serialize(M.location)}),B.deserialize=(M,W)=>({message:W.message,type:E.Output,offset:W.offset,length:W.length,location:W.location&&C.deserialize(M,W.location)})})(p||(e.ITestOutputMessage=p={}));var c;(function(B){B.serialize=M=>M.type===E.Error?u.serialize(M):p.serialize(M),B.deserialize=(M,W)=>W.type===E.Error?u.deserialize(M,W):p.deserialize(M,W)})(c||(e.ITestMessage=c={}));var g;(function(B){B.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),B.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(c.serialize)}),B.deserialize=(M,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(_=>c.deserialize(M,_))})})(g||(e.ITestTaskState=g={}));const f="\0",m=(B,M)=>B+f+M;e.$RI=m;const n=B=>{const M=B.indexOf(f);return{ctrlId:B.slice(0,M),tagId:B.slice(M+1)}};e.$SI=n;var o;(function(B){B.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),B.deserialize=(M,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?M.asCanonicalUri(r.URI.revive(W.uri)):void 0,range:W.range?A.$Ft.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(o||(e.ITestItem=o={}));var i;(function(B){B[B.NotExpandable=0]="NotExpandable",B[B.Expandable=1]="Expandable",B[B.BusyExpanding=2]="BusyExpanding",B[B.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(B){B.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),B.deserialize=(M,W)=>({controllerId:R.$MI.root(W.item.extId),expand:W.expand,item:o.deserialize(M,W.item)})})(t||(e.InternalTestItem=t={}));var s;(function(B){B.serialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.uri!==void 0&&(W.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(W.range=M.item.range?.toJSON()),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}},B.deserialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.range!==void 0&&(W.range=M.item.range?A.$Ft.lift(M.item.range):null),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}}})(s||(e.ITestItemUpdate=s={}));const d=(B,M)=>{M.expand!==void 0&&(B.expand=M.expand),M.item!==void 0&&(B.item=B.item?Object.assign(B.item,M.item):M.item)};e.$TI=d;var a;(function(B){B.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serializeWithoutMessages)}),B.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(g.serialize)}),B.deserialize=(M,W)=>({...t.deserialize(M,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(_=>g.deserialize(M,_)),retired:!0})})(a||(e.TestResultItem=a={}));var w;(function(B){B.empty=()=>({covered:0,total:0}),B.sum=(M,W)=>{M.covered+=W.covered,M.total+=W.total}})(w||(e.ICoverageCount=w={}));var y;(function(B){B.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testId:M.testId?.toString(),uri:M.uri.toJSON()}),B.deserialize=(M,W)=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,testId:W.testId?R.$MI.fromString(W.testId):void 0,uri:M.asCanonicalUri(r.URI.revive(W.uri))}),B.empty=(M,W)=>({id:M,uri:W,testId:void 0,statement:w.empty()})})(y||(e.IFileCoverage=y={}));function D(B){return{...B,location:B.location?.toJSON()}}function S(B){return B.location=B.location?h.$Et.isIPosition(B.location)?h.$Et.lift(B.location):A.$Ft.lift(B.location):void 0,B}e.$UI=3;var I;(function(B){B[B.Declaration=0]="Declaration",B[B.Statement=1]="Statement",B[B.Branch=2]="Branch"})(I||(e.DetailType=I={}));var k;(function(B){B.serialize=M=>M.type===I.Declaration?v.serialize(M):N.serialize(M),B.deserialize=M=>M.type===I.Declaration?v.deserialize(M):N.deserialize(M)})(k||(e.CoverageDetails=k={}));var b;(function(B){B.serialize=D,B.deserialize=S})(b||(e.IBranchCoverage=b={}));var v;(function(B){B.serialize=D,B.deserialize=S})(v||(e.IDeclarationCoverage=v={}));var N;(function(B){B.serialize=M=>({...D(M),branches:M.branches?.map(b.serialize)}),B.deserialize=M=>({...S(M),branches:M.branches?.map(b.deserialize)})})(N||(e.IStatementCoverage=N={}));var O;(function(B){B[B.Add=0]="Add",B[B.Update=1]="Update",B[B.DocumentSynced=2]="DocumentSynced",B[B.Remove=3]="Remove",B[B.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",B[B.Retire=5]="Retire",B[B.AddTag=6]="AddTag",B[B.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var F;(function(B){B.deserialize=(M,W)=>W.op===O.Add?{op:W.op,item:t.deserialize(M,W.item)}:W.op===O.Update?{op:W.op,item:s.deserialize(W.item)}:W.op===O.DocumentSynced?{op:W.op,uri:M.asCanonicalUri(r.URI.revive(W.uri)),docv:W.docv}:W,B.serialize=M=>M.op===O.Add?{op:M.op,item:t.serialize(M.item)}:M.op===O.Update?{op:M.op,item:s.serialize(M.item)}:M})(F||(e.TestsDiffOp=F={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const W=this.w();for(const _ of M)switch(_.op){case O.Add:this.l(t.deserialize(this.k,_.item),W);break;case O.Update:this.p(s.deserialize(_.item),W);break;case O.Remove:this.q(_.itemId,W);break;case O.Retire:this.v(_.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(_.amount);break;case O.AddTag:this.c.set(_.tag.id,_.tag);break;case O.RemoveTag:this.c.delete(_.id);break}W.complete?.()}l(M,W){const _=R.$MI.parentId(M.item.extId)?.toString();let re;if(!_)re=this.x(M),this.g.add(re),this.f.set(M.item.extId,re);else if(this.f.has(_)){const z=this.f.get(_);z.children.add(M.item.extId),re=this.x(M,z),this.f.set(M.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return W.add?.(re),M.expand===i.BusyExpanding&&this.h++,re}p(M,W){const _=this.f.get(M.extId);if(_)return M.expand!==void 0&&(_.expand===i.BusyExpanding&&this.h--,M.expand===i.BusyExpanding&&this.h++),(0,e.$TI)(_,M),W.update?.(_),_}q(M,W){const _=this.f.get(M);if(!_)return;const re=R.$MI.parentId(_.item.extId)?.toString();re?this.f.get(re).children.delete(_.item.extId):this.g.delete(_);const z=[[M]];for(;z.length;)for(const G of z.pop()){const J=this.f.get(G);J&&(z.push(J.children),this.f.delete(G),W.remove?.(J,J!==_),J.expand===i.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$VI=j}),define(Ee[314],Se([1,0,136,256,75]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$sFb=e.$rFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(E){E.List="list",E.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var T;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const $={[A.TestResultState.Errored]:(0,h.localize)(0,null),[A.TestResultState.Failed]:(0,h.localize)(1,null),[A.TestResultState.Passed]:(0,h.localize)(2,null),[A.TestResultState.Queued]:(0,h.localize)(3,null),[A.TestResultState.Running]:(0,h.localize)(4,null),[A.TestResultState.Skipped]:(0,h.localize)(5,null),[A.TestResultState.Unset]:(0,h.localize)(6,null)},l=(E,u)=>(0,h.localize)(7,null,(0,r.$Vk)(E),$[u]);e.$rFb=l,e.$sFb={[A.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[A.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[A.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var C;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(Ee[121],Se([1,0,9,4,3,66,75,74]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.TestItemEventOp=void 0;var $;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const l=(m,n)=>m===n,E=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:l,label:l,description:l,error:l,sortText:l,tags:(m,n)=>!(m.length!==n.length||m.some(o=>!n.includes(o)))}),u=(m,n)=>{let o;for(const[i,t]of E)t(m[i],n[i])||(o?o[i]=n[i]:o={[i]:n[i]});return o};class P extends A.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new h.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,L.$TI)(o.item,n.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,L.$TI)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||o>i.expandLevels)&&(i.expandLevels=o),i.expand===L.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,o-1):t.wait().then(()=>this.L(i,o-1))}else if(i.expand===L.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,o-1)):this.L(i,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(T.$MI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const i of o.ops)this.w(n,i);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$fd)(o)}}y(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const i=T.$MI.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(i.toString());if(!s){s={fullId:i,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,o);const d=this.s.getChildren(s.actual),a=s.actual,w=u(this.s.toITestItem(a),this.s.toITestItem(n));this.s.getApiFor(a).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=L.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,a.tags,i.toString()),delete w.tags),this.w(s,{op:$.SetProp,update:w})),this.I(n,s,o);for(const[D,S]of d)this.s.getChildren(n).get(S.id)||this.O(T.$MI.joinToString(i,S.id));const y=s.expandLevels;y!==void 0&&queueMicrotask(()=>{s.expand===L.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(i.toString(),y))}),this.y(s.actual.uri)}C(n,o,i){const t=new Set(o.map(s=>s.id));for(const s of n)t.delete(s.id)||this.D(s);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(s=>(0,L.$RI)(this.s.controllerId,s.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$RI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$RI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=s=>this.w(o,s),this.J(o)}I(n,o,i){this.H(n,o,i);for(const[t,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const i=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(T.$MI.joinToString(n.fullId,s.id),o);(0,r.$oh)(d)&&i.push(d)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Bh;return s.open(),s}n.expand=L.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Bh,i=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){i(s)}return(0,r.$oh)(t)?t.catch(i).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const i=[o];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.F(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))i.push(this.tree.get(T.$MI.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$iP=P;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$jP=p;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$kP=c;class g extends Error{constructor(n,o,i){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${i}".`)}}e.$lP=g;const f=(m,n,o)=>{let i=new Map;return{get size(){return i.size},forEach(t,s){for(const d of i.values())t.call(s,d,this)},[Symbol.iterator](){return i.entries()},replace(t){const s=new Map,d=new Set(i.keys()),a={op:$.Bulk,ops:[]};for(const w of t){if(!(w instanceof o))throw new c(w.id);const y=n(w).controllerId;if(y!==m.controllerId)throw new g(w.id,y,m.controllerId);if(s.has(w.id))throw new p(w.id);s.set(w.id,w),d.delete(w.id),a.ops.push({op:$.Upsert,item:w})}for(const w of d.keys())a.ops.push({op:$.RemoveChild,id:w});m.listener?.(a),i=s},add(t){if(!(t instanceof o))throw new c(t.id);i.set(t.id,t),m.listener?.({op:$.Upsert,item:t})},delete(t){i.delete(t)&&m.listener?.({op:$.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$mP=f}),define(Ee[154],Se([1,0,121]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=void 0;const h=new WeakMap,A=(L,T)=>{const $={controllerId:T};return h.set(L,$),$};e.$nP=A;const R=L=>{const T=h.get(L);if(!T)throw new r.$kP(L?.id||"<unknown>");return T};e.$oP=R}),define(Ee[122],Se([1,0,27,15,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hCb=e.$gCb=e.$fCb=void 0,e.$iCb=R,e.$jCb=T,e.$fCb="vscode-cdn.net",e.$gCb=`vscode-resource.${e.$fCb}`,e.$hCb=`'self' https://*.${e.$fCb}`;function R($,l){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(l&&l.authority&&l.isRemote&&$.scheme===h.Schemas.file&&($=A.URI.from({scheme:h.Schemas.vscodeRemote,authority:l.authority,path:$.path})),A.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$gCb}`,path:$.path,fragment:$.fragment,query:$.query}))}function L($){return $.replace(/./g,l=>{const C=l.charCodeAt(0);return C>=r.CharCode.a&&C<=r.CharCode.z||C>=r.CharCode.A&&C<=r.CharCode.Z||C>=r.CharCode.Digit0&&C<=r.CharCode.Digit9?l:"-"+C.toString(16).padStart(4,"0")})}function T($){return $.replace(/-([0-9a-f]{4})/g,(l,C)=>String.fromCharCode(parseInt(C,16)))}}),define(Ee[315],Se([1,0,4,3,122]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class R{constructor(T,$,l){this.d=T,this.e=$,this.f=l,this.a=0,this.b=new h.$Uc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const C=$.getVisibleTextEditors();for(const E of this.c.values())C.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,$,l,C,E){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===T){u=n;break}if(!u)throw new Error("not a visible editor");const P=this,p=this.a++,c=new r.$je,g=new r.$je,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$iCb)(n,P.f)}get cspSource(){return A.$hCb}set options(n){this.b=n,P.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,P.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return P.d.$postMessage(p,n)}},m=new class{constructor(){this.editor=T,this.line=$,this.height=l,this.webview=f,this.onDidDispose=g.event}dispose(){P.c.has(p)&&(P.c.delete(p),P.d.$disposeEditorInset(p),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,$+1,l,C||{},E.identifier,E.extensionLocation),this.c.set(p,{editor:T,inset:m,onDidReceiveMessage:c}),m}$onDidDispose(T){const $=this.c.get(T);$&&$.inset.dispose()}$onDidReceiveMessage(T,$){this.c.get(T)?.onDidReceiveMessage.fire($)}}e.$pnc=R}),define(Ee[155],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.$1L=void 0,e.$1L="__",e.$2L=(0,r.$Ci)("IAuthenticationService"),e.$3L=(0,r.$Ci)("IAuthenticationExtensionsService")}),define(Ee[316],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=e.VariableKind=e.$gQ=void 0,e.$gQ=(0,r.$Ci)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class A extends Error{constructor(L,T){super(T),this.variable=L}}e.$hQ=A}),define(Ee[317],Se([1,0,16,56,18,25,11,110,257,316,13]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=void 0,r=Ue(r),h=Ue(h),A=Ue(A),R=Ue(R);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,p,c,g){this.h=new Map,this.a=P,this.b=p,this.g=c,g&&(this.c=g.then(f=>this.i(f)))}i(P){if(L.$i){const p=Object.create(null);return Object.keys(P).forEach(c=>{p[c.toLowerCase()]=P[c]}),p}return P}resolveWithEnvironment(P,p,c){return this.l({env:this.i(P),userHome:void 0},p?p.uri:void 0,c)}async resolveAsync(P,p){const c={env:await this.c,userHome:await this.g};return this.l(c,P?P.uri:void 0,p)}async j(P,p,c,g){const f=R.$_n(p);L.$i&&f.windows?Object.keys(f.windows).forEach(n=>f[n]=f.windows[n]):L.$j&&f.osx?Object.keys(f.osx).forEach(n=>f[n]=f.osx[n]):L.$k&&f.linux&&Object.keys(f.linux).forEach(n=>f[n]=f.linux[n]),delete f.windows,delete f.osx,delete f.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,P?P.uri:void 0,f,c,g)}async resolveAnyAsync(P,p,c){return this.j(P,p,c)}async resolveAnyMap(P,p,c){const g=new Map;return{newConfig:await this.j(P,p,c,g),resolvedVariables:g}}resolveWithInteractionReplace(P,p,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,p,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,p){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,p)}async l(P,p,c,g,f){if(A.$cg(c))return this.m(P,p,c,g,f);if(Array.isArray(c))return Promise.all(c.map(m=>this.l(P,p,m,g,f)));if(A.$eg(c)){const m=Object.create(null),n=await Promise.all(Object.keys(c).map(async o=>[await this.m(P,p,o,g,f),await this.l(P,p,c[o],g,f)]));for(const[o,i]of n)m[o]=i;return m}return c}m(P,p,c,g,f){return(0,C.$vf)(c,E.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(E.VARIABLE_LHS))return m;let o=await this.o(P,m,n,p,g);return f?.set(n,o),o!==m&&A.$cg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(P,p,o,g,f)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,p,c,g,f){let m;const n=c.split(":");n.length>1&&(c=n[0],m=n[1]);const o=s=>{const d=this.a.getFilePath();if(d)return(0,T.$Qw)(d);throw new l.$hQ(s,(0,$.localize)(0,null,p))},i=s=>{const d=o(s);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,T.$Qw)(a)}throw new l.$hQ(s,(0,$.localize)(1,null,p,r.$oc(d)))},t=s=>{if(m){const d=this.a.getFolderUri(m);if(d)return d;throw new l.$hQ(s,(0,$.localize)(2,null,p,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new l.$hQ(s,(0,$.localize)(3,null,p)):new l.$hQ(s,(0,$.localize)(4,null,p))};switch(c){case"env":if(m){if(P.env){const s=P.env[L.$i?m.toLowerCase():m];if(A.$cg(s))return s}return""}throw new l.$hQ(l.VariableKind.Env,(0,$.localize)(5,null,p));case"config":if(m){const s=this.a.getConfigurationValue(g,m);if(A.$lg(s))throw new l.$hQ(l.VariableKind.Config,(0,$.localize)(6,null,p,m));if(A.$eg(s))throw new l.$hQ(l.VariableKind.Config,(0,$.localize)(7,null,p,m));return s}throw new l.$hQ(l.VariableKind.Config,(0,$.localize)(8,null,p));case"command":return this.p(l.VariableKind.Command,p,m,f,"command");case"input":return this.p(l.VariableKind.Input,p,m,f,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new l.$hQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,p,m));return this.n(s.extensionLocation)}throw new l.$hQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,p));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,T.$Qw)(this.n(t(l.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,T.$Qw)(this.n(t(l.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Qw)(r.$oc(this.n(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new l.$hQ(l.VariableKind.UserHome,(0,$.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new l.$hQ(l.VariableKind.LineNumber,(0,$.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new l.$hQ(l.VariableKind.SelectedText,(0,$.localize)(13,null,p))}case"file":return o(l.VariableKind.File);case"fileWorkspaceFolder":return i(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$oc(i(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?r.$mc(this.n(t(l.VariableKind.RelativeFile)),o(l.VariableKind.RelativeFile)):o(l.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$nc(o(l.VariableKind.RelativeFileDirname));if(g||m){const d=r.$mc(this.n(t(l.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return r.$nc(o(l.VariableKind.FileDirname));case"fileExtname":return r.$pc(o(l.VariableKind.FileExtname));case"fileBasename":return r.$oc(o(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$oc(o(l.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$pc(s).length)}case"fileDirnameBasename":return r.$oc(r.$nc(o(l.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":case"/":return r.sep;default:try{const s=m?`${c}:${m}`:c;return this.p(l.VariableKind.Unknown,p,s,f,void 0)}catch{return p}}}}p(P,p,c,g,f){if(c&&g){const m=f===void 0?g[c]:g[f+":"+c];if(typeof m=="string")return m;throw new l.$hQ(P,(0,$.localize)(14,null,p))}return p}}e.$wQ=E}),define(Ee[156],Se([1,0,5,152]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$dE=void 0,e.$eE=l,e.$fE=u,e.$gE=P,e.$dE=(0,r.$Ci)("editorGroupsService");var A;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var T;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var $;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function l(p){const c=p;return(0,h.$2F)(c?.editor)&&(0,h.$2F)(c?.replacement)}var C;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var E;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(p){const c=p;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function P(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(Ee[318],Se([1,0,5,156]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=e.$jE=e.$iE=e.$hE=void 0,e.$lE=A,e.$hE=(0,r.$Ci)("editorService"),e.$iE=-1,e.$jE=-2,e.$kE=-3;function A(R){const L=R;return typeof R=="number"||(0,h.$fE)(L)}}),define(Ee[157],Se([1,0,5,144]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0,e.$jM=(0,r.$Di)(h.$Ji)}),define(Ee[158],Se([1,0,24,4,16,3,9]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=e.$Dbc=e.$Cbc=e.$Bbc=void 0,A=Ue(A);class T{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.$Bbc=T;class ${static isHostExtension(m,n,o){if(n.getExtensionDescription(m))return!1;const i=o.getExtensionDescription(m);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(m,n){this.j=m,this.c=new h.$je,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new r.$pn,this.g=[],this.h=new Map;for(const m of this.e){if(this.f.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this.f.set(m.identifier,m),this.g.push(m);const n=this.j.readActivationEvents(m);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(m)}}set(m){return this.e=m,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(m,n){this.e=g(this.e,n),this.e=this.e.concat(m);const o=$.l(this.e);return this.e=g(this.e,o.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,o)}static l(m){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,a){this.addNode(d),this.addNode(a),this.c.has(d)?this.c.get(d).push(a):this.c.set(d,[a])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,a){const w=n.getArcs(d);for(let y=0;y<w.length;y++)if(!a.has(w[y]))return!1;return!0}getNodes(){return this.e}},o=new r.$pn;for(const d of m)if(o.set(d.identifier,d),d.extensionDependencies)for(const a of d.extensionDependencies)n.addArc(r.$nn.toKey(d.identifier),r.$nn.toKey(a));const i=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>i.add(d));const t=n.getNodes().filter(d=>!i.has(d));let s;do{s=!1;for(let d=0;d<t.length;d++){const a=t[d];n.hasOnlyGoodArcs(a,i)&&(t.splice(d,1),d--,i.add(a),s=!0)}}while(s);return t.map(d=>o.get(d))}containsActivationEvent(m){return this.h.has(m)}containsExtension(m){return this.f.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this.h.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new l(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this.f.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this.g)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Cbc=$;class l{constructor(m,n){this.versionId=m,this.extensions=n}}e.$Dbc=l;class C{constructor(m){this.d=new P,this.c=new $(m,[])}async acquireLock(m){const n=await this.d.acquire(m);return new E(this,n)}deltaExtensions(m,n,o){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(m){return this.c.containsActivationEvent(m)}containsExtension(m){return this.c.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this.c.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(m){return this.c.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this.c.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this.c.getExtensionDescriptionByIdOrUUID(m,n)}}e.$Ebc=C;class E extends R.$Vc{constructor(m,n){super(),this.f=m,this.c=!1,this.B(n)}isAcquiredFor(m){return!this.c&&this.f===m}}e.$Fbc=E;class u{constructor(m){this.name=m;const n=(0,L.$vh)();this.promise=n.promise,this.c=n.resolve}resolve(m){this.c(m)}}class P{constructor(){this.c=[],this.d=!1}async acquire(m){const n=new u(m);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const m=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};m.resolve((0,R.$Tc)(i))}}var p;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(p||(p={}));function c(f,m){const n=f.isBuiltin?p.Builtin:f.isUnderDevelopment?p.Dev:p.User,o=m.isBuiltin?p.Builtin:m.isUnderDevelopment?p.Dev:p.User;if(n!==o)return n-o;const i=A.$hc.basename(f.extensionLocation.path),t=A.$hc.basename(m.extensionLocation.path);return i<t?-1:i>t?1:0}function g(f,m){const n=new r.$on(m);return f.filter(o=>!n.has(o.identifier))}}),define(Ee[319],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=e.ExtHostConnectionType=void 0,e.$bn=T,e.$cn=$;var r;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=r.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$$m=h;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[A.ENV_KEY]="1"}}e.$_m=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[R.ENV_KEY]="1"}}e.$an=R;function L(C){delete C[h.ENV_KEY],delete C[A.ENV_KEY],delete C[R.ENV_KEY]}function T(C,E){L(E),C.serialize(E)}function $(C){if(C[h.ENV_KEY])return l(C,new h(C[h.ENV_KEY]));if(C[A.ENV_KEY])return l(C,new A);if(C[R.ENV_KEY])return l(C,new R);throw new Error("No connection information defined in environment!")}function l(C,E){return L(C),E}}),define(Ee[94],Se([1,0,22]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$vn=L,e.$wn=T;var h;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(h||(e.UIKind=h={}));var A;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(l){const C=r.$Le.alloc(1);switch(l){case R.Initialized:C.writeUInt8(1,0);break;case R.Ready:C.writeUInt8(2,0);break;case R.Terminate:C.writeUInt8(3,0);break}return C}function T(l,C){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return C===R.Initialized;case 2:return C===R.Ready;case 3:return C===R.Terminate;default:return!1}}var $;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[95],Se([1,0,5,4,149,12,30,94,91,92,25,2,3,240]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$KP=e.$JP=void 0,e.$LP=g;let p=class extends u.$Vc{constructor(m,n){super(),this.s=m,this.t=n,this.a=this.B(new h.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:l.$vp,name:(0,P.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,R.$$j)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,o){const i=this.getTelemetryDetails(),t=new c(n,o,m,this.n,this.j,this.getBuiltInCommonProperties(m),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),s=this.r.get(m.identifier.value)??[];return this.r.set(m.identifier.value,[...s,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(m,n,o){this.f=m,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:n["common.uikind"]="web";break;case T.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$en)((0,l.$Bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(m){this.h=this.getTelemetryConfiguration(),this.f=m;const n=this.getTelemetryDetails();this.r.forEach((o,i)=>{const t=o.filter(s=>!s.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(o=>{for(const i of o)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(m,n){const i=this.r.get(m.value)?.filter(s=>!s.isDisposed);if(!i)return this.r.delete(m.value),!1;let t=!1;for(const s of i)s.ignoreUnhandledExtHostErrors||(s.logError(n),t=!0);return t}};e.$JP=p,e.$JP=p=Ye([qe(0,L.$IP),qe(1,R.$0j)],p);class c{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,o,i,t,s,d){this.g=o,this.h=i,this.i=t,this.j=s,this.a=new h.$je,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=m,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(m,n){this.e&&(this.d={isUsageEnabled:m,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,l.$Ep)(n,[]),this.c&&(n=(0,C.$co)(n,this.c)),this.b||(n=(0,C.$co)(n,this.j)),"properties"in m?m.properties=n:m=n,m}k(m,n){this.f&&(this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(m,n),this.h.trace(m,n))}logUsage(m,n){this.d.isUsageEnabled&&this.k(m,n)}logError(m,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof m=="string")this.k(m,n);else{const o={name:m.name,message:m.message,stack:m.stack,cause:m.cause},i=(0,l.$Ep)(o,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.d.isUsageEnabled},get isErrorsEnabled(){return m.d.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.a.event.bind(m)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let m=this.f;this.f=void 0,Promise.resolve(m.flush()).then(m=void 0),this.e=void 0}else this.f=void 0}}e.$KP=c;function g(f){const m=Date.now()-new Date(f).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.$MP=(0,r.$Ci)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,289,147,24,5]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7G=e.ActivationKind=e.$4G=e.$3G=e.$ZG=e.ExtensionHostStartup=e.$YG=e.$XG=e.$WG=e.$VG=void 0,e.$1G=u,e.$2G=P,e.$5G=f,e.$6G=m,e.$VG=Object.freeze({identifier:new L.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$WG="extensions.webWorker",e.$XG=(0,T.$Ci)("extensionService");class ${constructor(i){this.dependency=i}}e.$YG=$;var l;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,s){this.c=i,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$GG.createActivationEventsMap(this.d)}}set(i,t,s){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const d=[],a=[],w=[],y=[],D=E(this.d),S=E(t),I=(O,F)=>O.extensionLocation.toString()===F.extensionLocation.toString()||O.isBuiltin===F.isBuiltin||O.isUserBuiltin===F.isUserBuiltin||O.isUnderDevelopment===F.isUnderDevelopment;for(const O of this.d){const F=S.get(O.identifier);if(!F){d.push(O.identifier),D.delete(O.identifier);continue}if(!I(O,F)){d.push(O.identifier),D.delete(O.identifier);continue}}for(const O of t){const F=D.get(O.identifier);if(!F){a.push(O);continue}if(!I(F,O)){d.push(F.identifier),D.delete(F.identifier);continue}}const k=new L.$on(this.e),b=new L.$on(s);for(const O of this.e)b.has(O)||w.push(O);for(const O of s)k.has(O)||y.push(O);const v=R.$GG.createActivationEventsMap(a),N={versionId:i,toRemove:d,toAdd:a,addActivationEvents:v,myToRemove:w,myToAdd:y};return this.delta(N),N}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:a}=i,w=new L.$on(t),y=new L.$on(d);for(let D=0;D<this.d.length;D++)w.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)y.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of s)this.d.push(D);for(const D of a)this.e.push(D);return this.f=null,i}containsExtension(i){for(const t of this.e)if(L.$nn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$GG.readActivationEvents(t);for(const d of s)i.add(d)}return i}}e.$ZG=C;function E(o){const i=new L.$pn;for(const t of o)i.set(t.identifier,t);return i}function u(o,i){return o.enabledApiProposals?o.enabledApiProposals.includes(i):!1}function P(o,i){if(!u(o,i))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class p{constructor(i,t,s,d){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$3G=p;class c{constructor(i,t){this.description=i,this.value=t}}e.$4G=c;var g;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function f(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Kp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function m(o,i){const t=(0,A.$Ip)(o.manifest.publisher,o.manifest.name);return{id:t,identifier:new L.$nn(t),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!i,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$7G=n}),define(Ee[320],Se([1,0,14,158,24,26,12,9]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=e.$Onc=e.$Nnc=e.$Mnc=e.$Lnc=void 0,r=Ue(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(f,m,n,o){this.startup=f,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Lnc=$;class l{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,m){return f===-1||m===-1?-1:m-f}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Mnc=l;class C{constructor(f,m,n,o,i,t){this.activationFailed=f,this.activationFailedError=m,this.activationTimes=n,this.module=o,this.exports=i,this.subscriptions=t}}e.$Nnc=C;class E extends C{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Onc=E;class u extends C{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Pnc=u;class P extends C{constructor(f){super(!0,f,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(f,m,n,o){this.g=o,this.a=f,this.b=m,this.c=n,this.d=new A.$pn,this.f=Object.create(null)}dispose(){for(const[f,m]of this.d)m.dispose()}async waitForActivatingExtensions(){const f=[];for(const[m,n]of this.d)f.push(n.wait());await Promise.all(f)}isActivated(f){const m=this.d.get(f);return!!(m&&m.value)}getActivatedExtension(f){const m=this.d.get(f);if(!m||!m.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return m.value}async activateByEvent(f,m){if(this.f[f])return;const n=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(n.map(o=>({id:o.identifier,reason:{startup:m,extensionId:o.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,m){const n=this.a.getExtensionDescription(f);if(!n)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:n.identifier,reason:m}])}async h(f){const m=f.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(m.map(n=>n.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const m=this.a.getExtensionDescription(f.id);if(!m){const i=new Error(`Cannot activate unknown extension '${f.id.value}'`),t=this.k(f,null,[],new P(i));return this.c.onExtensionActivationError(f.id,i,new R.$YG(f.id.value)),t}const n=[],o=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const i of o){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:f.reason}));continue}const s=this.a.getExtensionDescription(i);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:f.reason}));continue}const d=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${i}'`),w=this.k(f,m.displayName,[],new P(a));return this.c.onExtensionActivationError(m.identifier,a,new R.$YG(i)),w}return this.k(f,m.displayName,n,null)}k(f,m,n,o){const i=new c(f.id,m,f.reason,n,o,this.c,this.g);return this.d.set(f.id,i),i}l(f){return h.$Cbc.isHostExtension(f,this.a,this.b)}m(f){const m=this.b.getExtensionDescription(f);return m?!m.main&&!m.browser:!1}};e.$Qnc=p,e.$Qnc=p=Ye([qe(3,L.$9j)],p);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,m,n,o,i,t,s){this.c=f,this.d=m,this.f=n,this.g=o,this.h=i,this.j=t,this.k=s,this.a=new T.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const m=this.g[f];if(m.value&&!m.value.activationFailed){this.g.splice(f,1),f--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this.h=new P(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const m=new Error;if(f&&f.name&&(m.name=f.name),f&&f.message?m.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(m.stack=f.stack),this.h=new P(m),this.b&&r.$5(f))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};c=Ye([qe(6,L.$9j)],c)}),define(Ee[321],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[159],Se([1,0,259,14,44,146,117,37,24,321,116,147]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=void 0,r=Ue(r),A=Wt(A);const u=T.$mo.as(L.$no.JSONContribution);class P{constructor(i,t,s){this.a=i,this.b=t,this.c=s}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(A.default.Error,i)}warn(i){this.d(A.default.Warning,i)}info(i){this.d(A.default.Info,i)}}e.$PG=P;class p{static a(i){const t=new $.$on;for(let s=0,d=i.length;s<d;s++)t.add(i[s].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new p(t,[]);if(!t||!t.length)return new p([],i);const s=this.a(i),d=this.a(t),a=t.filter(y=>!s.has(y.description.identifier)),w=i.filter(y=>!d.has(y.description.identifier));return new p(a,w)}constructor(i,t){this.added=i,this.removed=t}}e.$QG=p;class c{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=p.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,h.$2)(i)}}}e.$RG=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.$SG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$mn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4o}},extensionKind:{description:r.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new c(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&E.$GG.register(i.extensionPoint,i.activationEventsGenerator),e.$SG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(f,e.$SG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$TG=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};T.$mo.add(n.ExtensionsRegistry,new m),e.$UG=T.$mo.as(n.ExtensionsRegistry),u.registerSchema(f,e.$SG),u.registerSchema(C.$qk,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(Ee[322],Se([1,0,4,40,3,13,250,24,5,12,26,159]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.$8G=e.ChatMessageRole=void 0;var u;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$8G=(0,$.$Ci)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.$9G=E.$UG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(c,g)=>{for(const f of c)g.push(`onLanguageModelChat:${f.vendor}`)}});let p=class{constructor(g,f){this.e=g,this.f=f,this.a=new A.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$9G.setHandler(m=>{this.c.clear();for(const o of m){if(!(0,C.$1G)(o.description,"chatProvider")){o.collector.error((0,L.localize)(2,null));continue}for(const i of h.Iterable.wrap(o.value)){if(this.c.has(i.vendor)){o.collector.error((0,L.localize)(3,null,i.vendor));continue}if((0,R.$af)(i.vendor)){o.collector.error((0,L.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){o.collector.error((0,L.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[o,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(g){return this.b.get(g)?.metadata}async selectLanguageModels(g){if(g.vendor)await this.e.activateByEvent(`onLanguageModelChat:${g.vendor}}`);else{const m=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const f=[];for(const[m,n]of this.b)(g.vendor===void 0||n.metadata.vendor===g.vendor)&&(g.family===void 0||n.metadata.family===g.family)&&(g.version===void 0||n.metadata.version===g.version)&&(g.identifier===void 0||n.metadata.id===g.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>T.$nn.equals(o,g.extension)))&&f.push(m);return this.f.trace("[LM] selected language models",g,f),f}registerLanguageModelChat(g,f){if(this.f.trace("[LM] registering language model chat",g,f.metadata),!this.c.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this.b.has(g))throw new Error(`Chat response provider with identifier ${g} is already registered.`);return this.b.set(g,f),this.d.fire({added:[{identifier:g,metadata:f.metadata}]}),(0,A.$Tc)(()=>{this.b.delete(g)&&(this.d.fire({removed:[g]}),this.f.trace("[LM] UNregistered language model chat",g,f.metadata))})}makeLanguageModelChatRequest(g,f,m,n,o,i){const t=this.b.get(g);if(!t)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return t.provideChatResponse(m,f,n,o,i)}computeTokenLength(g,f,m){const n=this.b.get(g);if(!n)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return n.provideTokenCount(f,m)}};e.$0G=p,e.$0G=p=Ye([qe(0,C.$XG),qe(1,l.$9j)],p)}),define(Ee[323],Se([1,0,254,18,25,159,36,4]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=void 0,r=Ue(r),h=Ue(h),A=Ue(A);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(u){function P(p,c,g){if(!p)return;const f=h.$cg(p.type)?p.type:void 0;if(!f||f.length===0){g.error(r.localize(3,null));return}const m=[];if(Array.isArray(p.required))for(const n of p.required)h.$cg(n)&&m.push(n);return{extensionId:c.value,taskType:f,required:m,properties:p.properties?A.$_n(p.properties):{},when:p.when?L.$Aj.deserialize(p.when):void 0}}u.from=P})(l||(l={}));const C=R.$UG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,P)=>{for(const p of u)p.type&&P.push(`onTaskType:${p.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new T.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,p)=>{C.setHandler((c,g)=>{this.c=void 0;try{for(const f of g.removed){const m=f.value;for(const n of m)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const f of g.added){const m=f.value;for(const n of m){const o=l.from(n,f.description.identifier,f.collector);o&&(this.a[o.taskType]=o)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const p of this.all()){const c={type:"object",additionalProperties:!1};p.required.length>0&&(c.required=p.required.slice(0)),p.properties!==void 0?c.properties=A.$_n(p.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[p.taskType]},P.push(c)}this.c={oneOf:P}}return this.c}}e.$AI=new E}),define(Ee[324],Se([1,0,255,18,23,25,36,323,45]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$KI=e.JsonSchemaVersion=e.ExecutionEngine=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$EI=e.ShellQuoting=e.$DI=e.$CI=e.$BI=void 0,r=Ue(r),h=Ue(h),A=Ue(A),R=Ue(R),e.$BI="settings",e.$CI=new L.$Tj("taskRunning",!1,r.localize(0,null)),e.$DI=r.localize2(2,"Tasks");var l;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.$EI="$customized",function(M){function W(_){if(!_)return M.Strong;switch(_.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=W}(l||(e.ShellQuoting=l={}));var C;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var E;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(E||(e.RevealKind=E={})),function(M){function W(_){switch(_.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=W}(E||(e.RevealKind=E={}));var u;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(M){function W(_){switch(_.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=W}(u||(e.RevealProblemKind=u={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function W(_){switch(_.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=W}(P||(e.PanelKind=P={}));var p;(function(M){M.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var c;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(c||(e.RuntimeType=c={})),function(M){function W(re){switch(re.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=W;function _(re){switch(re){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=_}(c||(e.RuntimeType=c={}));var g;(function(M){function W(_){return h.$cg(_)?_:_.value}M.value=W})(g||(e.CommandString=g={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function W(re){return re===M.Clean._id||re===M.Build._id||re===M.Rebuild._id||re===M.Test._id}M.is=W;function _(re){if(re!==void 0)return h.$cg(re)?W(re)?{_id:re,isDefault:!1}:void 0:re}M.from=_})(f||(e.TaskGroup=f={}));var m;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function W(_){switch(_){case M.User:return $.ConfigurationTarget.USER;case M.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=W})(n||(e.TaskSourceKind=n={}));var o;(function(M){M.parallel="parallel",M.sequence="sequence"})(o||(e.DependsOrder=o={}));var i;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class s{constructor(W,_,re,z,G,J){this._label="",this._id=W,_&&(this._label=_),re&&(this.type=re),this.runOptions=z,this.configurationProperties=G,this._source=J}getDefinition(W){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const W={folder:this.d(),id:this._id};return JSON.stringify(W)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(W,_=!1){if(W===void 0)return!1;if(h.$cg(W))return W===this._label||W===this.configurationProperties.identifier||_&&W===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===W._key}getQualifiedLabel(){const W=this.getWorkspaceFolder();return W?`${this._label} (${W.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(W){this.c===void 0&&(this.c=[]),W&&(this.c=this.c.concat(W))}get taskLoadMessages(){return this.c}}e.$FI=s;class d extends s{constructor(W,_,re,z,G,J,ee,ue){super(W,re,void 0,ee,ue,_),this.command={},this._source=_,this.hasDefinedMatchers=J,G&&(this.command=G)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(W=!1){if(W&&this._source.customizes!==void 0)return this._source.customizes;{let _;switch(this.command?this.command.runtime:void 0){case c.Shell:_="shell";break;case c.Process:_="process";break;case c.CustomExecution:_="customExecution";break;case void 0:_="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:_,_key:this._id,id:this._id}}}static is(W){return W instanceof d}getMapKey(){const W=this._source.config.workspaceFolder;return W?`${W.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$BI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const W=this.d();if(!W)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$EI,folder:W,id:_};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(W){return new d(W._id,W._source,W._label,W.type,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$GI=d;class a extends s{constructor(W,_,re,z,G,J,ee){super(W,re,z,J,ee,_),this._source=_,this.configures=G}static is(W){return W instanceof a}f(W){return W}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$BI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const W=this.d();if(!W)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$EI,folder:W,id:_};return JSON.stringify(re)}}e.$HI=a;class w extends s{constructor(W,_,re,z,G,J,ee,ue,ne){super(W,re,z,ue,ne,_),this.defines=G,this.hasDefinedMatchers=ee,this.command=J,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(W){return W instanceof w}getMapKey(){const W=this._source.workspaceFolder;return W?`${this._source.scope.toString()}|${W.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const W={type:"contributed",scope:this._source.scope,id:this._id};return W.folder=this.d(),JSON.stringify(W)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(W){return new w(W._id,W._source,W._label,W.type,W.defines,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$II=w;class y extends s{constructor(W,_,re,z,G,J){super(W,re,z,G,J,_),this._source=_}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(W){return W instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(W){return new y(W._id,W._source,W._label,W.type,W.runOptions,W.configurationProperties)}}e.$JI=y;var D;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(M){M._default=M.Terminal}(D||(e.ExecutionEngine=D={}));var S;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class I{constructor(W){this.c=new Map;for(let _=0;_<W.length;_++)this.c.set(W[_].uri.toString(),_)}compare(W,_){const re=W.getWorkspaceFolder(),z=_.getWorkspaceFolder();if(re&&z){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let J=this.c.get(z.uri.toString());return J=J===void 0?0:J+1,G===J?W._label.localeCompare(_._label):G-J}else return!re&&z?-1:re&&!z?1:0}}e.$KI=I;var k;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(k||(e.TaskEventKind=k={}));var b;(function(M){M.SingleRun="singleRun",M.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var N;(function(M){function W(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?b.Background:b.SingleRun,group:ue.configurationProperties.group,__task:ue}}function _(ue,ne,De){return{...W(ue),kind:k.Start,terminalId:ne,resolvedVariables:De}}M.start=_;function re(ue,ne,De){return{...W(ue),kind:k.ProcessStarted,terminalId:ne,processId:De}}M.processStarted=re;function z(ue,ne,De){return{...W(ue),kind:k.ProcessEnded,terminalId:ne,exitCode:De}}M.processEnded=z;function G(ue,ne,De){return{...W(ue),kind:k.Terminated,exitReason:De,terminalId:ne}}M.terminated=G;function J(ue,ne,De){return{...W(ne),kind:ue,terminalId:De}}M.general=J;function ee(){return{kind:k.Changed}}M.changed=ee})(N||(e.TaskEvent=N={}));var O;(function(M){function W(re){const z=Object.keys(re).sort();let G="";for(const J of z){let ee=re[J];ee instanceof Object?ee=W(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=J+","+ee+","}return G}function _(re){const G={_key:W(re),type:re.taskType};return Object.assign(G,re),G}M.create=_})(O||(e.KeyedTaskIdentifier=O={}));var F;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var B;(function(M){function W(_,re){const z=T.$AI.get(_.type);if(z===void 0){const ue=R.$_n(_);return delete ue._key,O.create(ue)}const G=Object.create(null);G.type=z.taskType;const J=new Set;z.required.forEach(ue=>J.add(ue));const ee=z.properties;for(const ue of Object.keys(ee)){const ne=_[ue];if(ne!=null)G[ue]=ne;else if(J.has(ue)){const De=ee[ue];if(De.default!==void 0)G[ue]=R.$_n(De.default);else switch(De.type){case"boolean":G[ue]=!1;break;case"number":case"integer":G[ue]=0;break;case"string":G[ue]="";break;default:re.error(r.localize(1,null,JSON.stringify(_,void 0,0),ue));return}}}return O.create(G)}M.createTaskIdentifier=W})(B||(e.TaskDefinition=B={}))}),define(Ee[325],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,T)=>{this.b=L,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$2)(L))}then(L,T){return this.j().then(L,T)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$Gbc=h;class A extends h{constructor(){super(),this.h=!0,this.i=new r.$6}}e.$Hbc=A}),define(Ee[51],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Kw=void 0,e.$Lw=A,e.$Mw=R;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Kw=r;const h=[];function A(T){const $=new r(T);return h[$.nid]=$,$}function R(T){return h[T].sid}class L{constructor($){this.value=$}}e.$Nw=L}),define(Ee[6],Se([1,0,51]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$XM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var A;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var T;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var l;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var C;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class E{static{this.a=0}static mixin(g){return g._id=E.a++,g}}e.$XM=E;var u;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var P;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$YM={MainThreadAuthentication:(0,r.$Lw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Lw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Lw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Lw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Lw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Lw)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Lw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Lw)("MainThreadCommands"),MainThreadComments:(0,r.$Lw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Lw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Lw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Lw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Lw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Lw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Lw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Lw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Lw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Lw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Lw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Lw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Lw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Lw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Lw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Lw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Lw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Lw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Lw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Lw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Lw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Lw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Lw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Lw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Lw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Lw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Lw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Lw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Lw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Lw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Lw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Lw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Lw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Lw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Lw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Lw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Lw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Lw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Lw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Lw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Lw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Lw)("MainThreadSCM"),MainThreadSearch:(0,r.$Lw)("MainThreadSearch"),MainThreadShare:(0,r.$Lw)("MainThreadShare"),MainThreadTask:(0,r.$Lw)("MainThreadTask"),MainThreadWindow:(0,r.$Lw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Lw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Lw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Lw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Lw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Lw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Lw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Lw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Lw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Lw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Lw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Lw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Lw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Lw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Lw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Lw)("MainThreadAiEmbeddingVector")},e.$ZM={ExtHostCommands:(0,r.$Lw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Lw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Lw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Lw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Lw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Lw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Lw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Lw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Lw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Lw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Lw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Lw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Lw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Lw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Lw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Lw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Lw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Lw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Lw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Lw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Lw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Lw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Lw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Lw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Lw)("ExtHostSCM"),ExtHostSearch:(0,r.$Lw)("ExtHostSearch"),ExtHostTask:(0,r.$Lw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Lw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Lw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Lw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Lw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Lw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Lw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Lw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Lw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Lw)("ExtHostProgress"),ExtHostComments:(0,r.$Lw)("ExtHostComments"),ExtHostSecretState:(0,r.$Lw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Lw)("ExtHostStorage"),ExtHostUrls:(0,r.$Lw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Lw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Lw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Lw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Lw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Lw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Lw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Lw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Lw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Lw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Lw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Lw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Lw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Lw)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Lw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Lw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Lw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Lw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Lw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Lw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Lw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Lw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Lw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Lw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Lw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Lw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Lw)("ExtHostLocalization")}}),define(Ee[96],Se([1,0,5,12,6,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=e.$$mc=void 0,A=Ue(A),e.$$mc=(0,r.$Ci)("IExtHostApiDeprecationService");let L=class{constructor($,l){this.c=l,this.a=new Set,this.b=$.getProxy(A.$YM.MainThreadTelemetry)}report($,l,C){const E=this.d($,l);this.a.has(E)||(this.a.add(E),l.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:$}))}d($,l){return`${$}-${l.identifier.value}`}};e.$_mc=L,e.$_mc=L=Ye([qe(0,R.$sP),qe(1,h.$9j)],L),e.$anc=Object.freeze(new class{report(T,$,l){}})}),define(Ee[326],Se([1,0,6]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class h{constructor(R){const L=R.getProxy(r.$YM.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(T){return L.$writeText(T)}})}}e.$nnc=h}),define(Ee[327],Se([1,0,25,6,30,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0;let L=class{constructor(C,E){this.a=C.getProxy(h.$YM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(C,E){const u=this,P=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){u.e(C,E,P,arguments)}})}e(C,E,u,P){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(P,this.b)}),this.c&&this.f(C,u,P)}};e.$ipc=L,e.$ipc=L=Ye([qe(0,R.$sP),qe(1,A.$IP)],L);const T=1e5;function $(l,C){const E=[];if(l.length)for(let u=0;u<l.length;u++){let P=l[u];if(typeof P>"u")P="undefined";else if(P instanceof Error){const p=P;p.stack?P=p.stack:P=p.toString()}E.push(P)}if(C){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$eo)(E);return u.length>T?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ee[328],Se([1,0,2,6,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class R{constructor(T){this.a=T.getProxy(h.$YM.MainThreadDialogs)}showOpenDialog(T,$){return $?.allowUIResources&&(0,A.$2G)(T,"showLocal"),this.a.$showOpenDialog($).then(l=>l?l.map(C=>r.URI.revive(C)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then($=>$?r.URI.revive($):void 0)}}e.$poc=R}),define(Ee[329],Se([1,0,21,4,3,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0;class L{constructor($){this.b=new Map,this.c=new h.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(R.$YM.MainThreadEmbeddings)}registerEmbeddingsProvider($,l,C){if(this.d.has(l))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,l),this.b.set(E,{id:l,provider:C}),(0,A.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,l,C){C??=r.CancellationToken.None;let E=!1;typeof l=="string"&&(l=[l],E=!0);const u=await this.a.$computeEmbeddings($,l,C);if(u.length!==l.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,l,C){const E=this.b.get($);if(!E)return[];const u=await E.provider.provideEmbeddings(l,C);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$soc=L}),define(Ee[330],Se([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class A{constructor(L){this.b=0,this.a=L.getProxy(h.$YM.MainThreadLabelService)}$registerResourceLabelFormatter(L){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,L),(0,r.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Joc=A}),define(Ee[123],Se([1,0,11,13,2,5,12,6,30,20]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=e.$5nc=void 0;let C=class{constructor(u,P,p){this.f=p,this.d=new Map,this.a=P.getProxy(T.$YM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$g}getMessage(u,P){const{message:p,args:c,comment:g}=P;if(this.c)return(0,h.$cf)(p,c??{});let f=p;g&&g.length>0&&(f+=`/${Array.isArray(g)?g.join(""):g}`);const m=this.d.get(u)?.contents[f];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,h.$cf)(m??p,c??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let P;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(p),g=JSON.parse(c);P=u.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${c.message}`);return}P&&this.d.set(u.identifier.value,{contents:P,uri:p})}async g(u){if(u.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(P)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$5nc=C,e.$5nc=C=Ye([qe(0,$.$IP),qe(1,l.$sP),qe(2,L.$9j)],C),e.$6nc=(0,R.$Ci)("IExtHostLocalizationService")}),define(Ee[160],Se([1,0,12,6,30,20,2,57]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;let $=class extends r.$hk{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(P=>(0,T.$_h)(P))),this.r=E.getProxy(h.$YM.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(L.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,P){return new l(this.r,E,u,P)}};e.$hpc=$,e.$hpc=$=Ye([qe(0,R.$sP),qe(1,A.$IP)],$);class l extends r.$ck{constructor(E,u,P,p){super(p?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const P=[[E,u]];this.m?this.u(P):this.n.push(...P)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],Se([1,0,6,5,3,20,22]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=e.$7nc=void 0,e.$7nc=(0,h.$Ci)("IExtHostManagedSockets");let T=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(r.$YM.MainThreadManagedSockets)}setFactory(E,u){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,P=await this.c.makeConnection(),p=new A.$Uc;return this.d.set(u,new l(u,P,p)),p.add((0,A.$Tc)(()=>this.d.delete(u))),p.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(P.onDidClose(c=>{this.a.$onDidManagedSocketClose(u,c?.stack??c?.message),p.dispose()})),p.add(P.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(u,L.$Le.wrap(c)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$8nc=T,e.$8nc=T=Ye([qe(0,R.$sP)],T);class ${constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class l extends A.$Vc{constructor(E,u,P){super(),this.socketId=E,this.actual=u,this.B(P)}}}),define(Ee[331],Se([1,0,6,12,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;function R(T){return T&&T.title}let L=class{constructor($,l){this.b=l,this.a=$.getProxy(r.$YM.MainThreadMessageService)}showMessage($,l,C,E,u){const P={source:{identifier:$.identifier,label:$.displayName||$.name}};let p;typeof E=="string"||R(E)?p=[E,...u]:(P.modal=E?.modal,P.useCustom=E?.useCustom,P.detail=E?.detail,p=u),P.useCustom&&(0,A.$2G)($,"resolvers");const c=[];let g=!1;for(let f=0;f<p.length;f++){const m=p[f];if(typeof m=="string")c.push({title:m,handle:f,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:o}=m;c.push({title:n,isCloseAffordance:!!o,handle:f}),o&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,m):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,m)}return this.a.$showMessage(l,C,P,c).then(f=>{if(typeof f=="number")return p[f]})}};e.$Loc=L,e.$Loc=L=Ye([qe(1,h.$9j)],L)}),define(Ee[332],Se([1,0,3,18,2,26,6]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class T{constructor(l){this.b=new Map,this.a=l.getProxy(L.$YM.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,C,E){if((0,R.$2G)(l,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,E),this.a.$registerProfileContentHandler(C,E.name,E.description,l.identifier.value),(0,r.$Tc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(l,C,E,u){const P=this.b.get(l);if(!P)throw new Error(`Unknown handler with id: ${l}`);return P.saveProfile(C,E,u)}async $readProfile(l,C,E){const u=this.b.get(l);if(!u)throw new Error(`Unknown handler with id: ${l}`);return u.readProfile((0,h.$cg)(C)?C:A.URI.revive(C),E)}}e.$Uoc=T}),define(Ee[125],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0;class R{constructor(T){this.b=new h.$je,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$YM.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,$){return this.a.$getPassword(T,$)}store(T,$,l){return this.a.$setPassword(T,$,l)}delete(T,$){return this.a.$deletePassword(T,$)}}e.$2nc=R,e.$3nc=(0,A.$Ci)("IExtHostSecretState")}),define(Ee[333],Se([1,0,21,3,6]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(A.$YM.MainThreadSpeech)}async $createSpeechToTextSession(T,$,l){const C=this.c.get(T);if(!C)return;const E=new h.$Uc,u=new r.$ue;this.d.set($,u);const P=await C.provideSpeechToTextSession(u.token,l?{language:l}:void 0);P&&(E.add(P.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,p)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,$,l){const C=this.c.get(T);if(!C)return;const E=new h.$Uc,u=new r.$ue;this.d.set($,u);const P=await C.provideTextToSpeechSession(u.token,l?{language:l}:void 0);P&&(this.f.set($,P),E.add(P.onDidChange(p=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,p)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(T,$){this.f.get(T)?.synthesize($)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,$){const l=this.c.get(T);if(!l)return;const C=new h.$Uc,E=new r.$ue;this.d.set($,E);const u=await l.provideKeywordRecognitionSession(E.token);u&&(C.add(u.onDidChange(P=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,P)})),C.add(E.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,$,l){const C=R.a++;return this.c.set(C,l),this.b.$registerProvider(C,$,{extension:T,displayName:T.value}),(0,h.$Tc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$2oc=R}),define(Ee[126],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=e.$Rnc=void 0;class R{constructor(T,$){this.c=$,this.b=new h.$je,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$YM.MainThreadStorage)}registerExtensionStorageKeysToSync(T,$){this.a.$registerExtensionStorageKeysToSync(T,$)}async initializeExtensionStorage(T,$,l){const C=await this.a.$initializeExtensionStorage(T,$);let E;return C&&(E=this.d(T,$,C)),E||l}setValue(T,$,l){return this.a.$setValue(T,$,l)}$acceptValue(T,$,l){const C=this.d(T,$,l);C&&this.b.fire({shared:T,key:$,value:C})}d(T,$,l){try{return JSON.parse(l)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${T}): ${C}`)}}}e.$Rnc=R,e.$Snc=(0,A.$Ci)("IExtHostStorage")}),define(Ee[334],Se([1,0,3,15,2,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$YM.MainThreadUriOpeners)}registerExternalUriOpener($,l,C,E){if(this.c.has(l))throw new Error(`Opener with id '${l}' already registered`);const u=E.schemes.find(P=>!L.a.has(P));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(l,C),this.b.$registerUriOpener(l,E.schemes,$,E.label),(0,r.$Tc)(()=>{this.c.delete(l),this.b.$unregisterUriOpener(l)})}async $canOpenUri($,l,C){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const u=A.URI.revive(l);return E.canOpenExternalUri(u,C)}async $openUri($,l,C){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(A.URI.revive(l.resolvedUri),{sourceUri:A.URI.revive(l.sourceUri)},C)}}e.$bpc=L}),define(Ee[335],Se([1,0,6,2,3,14,24]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class T{static{this.a=0}constructor(l){this.c=new L.$on,this.d=new Map,this.b=l.getProxy(r.$YM.MainThreadUrls)}registerUriHandler(l,C){const E=l.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=T.a++;return this.c.add(E),this.d.set(u,C),this.b.$registerUriHandler(u,E,l.displayName||l.name),(0,A.$Tc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(l,C){const E=this.d.get(l);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(C))}catch(u){(0,R.$2)(u)}return Promise.resolve(void 0)}async createAppUri(l){return h.URI.revive(await this.b.$createAppUri(l))}}e.$cpc=T}),define(Ee[336],Se([1,0,22,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=R,e.$Gsb=T,h=Ue(h);class A{constructor(){this.buffers=[]}add(l){let C=this.buffers.indexOf(l);return C<0&&(C=this.buffers.length,this.buffers.push(l)),C}}function R($,l){if(l.serializeBuffersForPostMessage){const C=new A,u=JSON.stringify($,(p,c)=>{if(c instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(c)};if(ArrayBuffer.isView(c)){const g=L(c);if(g)return{$$vscode_array_buffer_reference$$:!0,index:C.add(c.buffer),view:{type:g,byteLength:c.byteLength,byteOffset:c.byteOffset}}}return c}),P=C.buffers.map(p=>{const c=new Uint8Array(p);return r.$Le.wrap(c)});return{message:u,buffers:P}}else return{message:JSON.stringify($),buffers:[]}}function L($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function T($,l){const C=l.map(P=>{const p=new ArrayBuffer(P.byteLength);return new Uint8Array(p).set(P.buffer),p}),E=l.length?(P,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const c=p,{index:g}=c,f=C[g];if(c.view)switch(c.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(f,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(f,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(f,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(f,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(f,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(f,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(f,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(f,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(f,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(f,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(f,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return p}:void 0;return{message:JSON.parse($,E),arrayBuffers:C}}}),define(Ee[97],Se([1,0,4,3,15,25,2,263,336,122,6]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Cnc=void 0,e.$Dnc=u,e.$Fnc=c,e.$Gnc=g,R=Ue(R),C=Ue(C);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,i,t,s,d,a,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$je,this._onDidDispose=this.#h.event,this.#e=o,this.#t=i,this.#o=t,this.#n=s,this.#s=d,this.#r=a,this.#u=u(a),this.#d=P(a),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,l.$iCb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let i=o.toString();return i.endsWith("/")||(i+="/"),i+" "+l.$hCb}return l.$hCb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),R.$do(this.#o,o)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const i=(0,$.$Fsb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const i=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,a,w,y,D)=>{const S=L.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),I=(0,l.$iCb)(S,{isRemote:i,authority:t}).toString();return`${d}${I}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,a,w,y,D)=>{const S=L.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),I=(0,l.$iCb)(S,{isRemote:i,authority:t}).toString();return`${d}${I}${D}`})}}e.$Cnc=E;function u(n){try{const o=(0,T.$Tp)((0,T.$Sp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function P(n){try{const o=(0,T.$Tp)((0,T.$Sp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends h.$Vc{constructor(o,i,t,s,d){super(),this.c=i,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=o.getProxy(C.$YM.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,i,t){const s=this.j(o);if(s){const{message:d}=(0,$.$Gsb)(i,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(o,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,i,t){const s=new E(o,this.a,f(i),this.c,this.f,t,this.h);this.b.set(o,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Enc=p;function c(n){return{id:n.identifier,location:n.extensionLocation}}function g(n,o,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||m(n,o)}}function f(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function m(n,o){return[...(o?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(Ee[161],Se([1,0,4,15,13,2,5,20,6]),function(ce,e,r,h,A,R,L,T,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;let C=class{static{l=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$je,this.onDidChangeWindowState=this.c.event,this.d=l.a,this.b=u.getProxy($.$YM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:p})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,P){P!==this.d[u]&&(this.d={...this.d,[u]:P},this.c.fire(this.d))}openUri(u,P){let p;if(typeof u=="string"){p=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,p,P)}async asExternalUri(u,P){if((0,A.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(u,P);return R.URI.from(p)}};e.$epc=C,e.$epc=C=l=Ye([qe(0,T.$sP)],C),e.$fpc=(0,L.$Ci)("IExtHostWindow")}),define(Ee[337],Se([1,0,327,30,20,94]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0;const L=1024*1024;let T=class extends r.$ipc{constructor(l,C){super(l,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(l,C,E){const u=l==="error"||l==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),C.apply(console,E),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(l,C){const E=process[l],u=E.write;let P="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(p,c,g)=>{if(!this.g){P+=p.toString(c);const f=P.length>L?P.length:P.lastIndexOf(`
`);f!==-1&&(console[C](P.slice(0,f)),P=P.slice(f+1))}u.call(E,p,c,g)}})}};e.$Tpc=T,e.$Tpc=T=Ye([qe(0,A.$sP),qe(1,h.$IP)],T)}),define(Ee[338],Se([1,0,160,15,279,32]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=void 0;class L extends r.$hpc{s($,l,C){return $.scheme===h.Schemas.file?new A.$HQ(C?.name||(0,R.$Yg)(),$.fsPath,!C?.donotRotate,!!C?.donotUseFormatters,l):super.s($,l,C)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$6pc=L}),define(Ee[339],Se([1,0,9,22,21,27,14,4,3,41,142,325,51]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ibc=m,e.$Jbc=n,L=Ue(L);function p(N,O){try{return JSON.stringify(N,O)}catch{return"null"}}const c="$$ref$$",g={[c]:-1};class f{constructor(O,F){this.jsonString=O,this.referencedBuffers=F}}function m(N,O=null,F=!1){const j=[];return{jsonString:(F?p:JSON.stringify)(N,(M,W)=>{if(typeof W>"u")return g;if(typeof W=="object"){if(W instanceof h.$Le){const _=j.push(W)-1;return{[c]:_}}if(O)return O(M,W)}return W}),referencedBuffers:j}}function n(N,O,F){return JSON.parse(N,(j,B)=>{if(B){const M=B[c];if(typeof M=="number")return O[M];if(F&&B.$mid===l.MarshalledId.Uri)return F.transformIncoming(B)}return B})}function o(N,O){return JSON.stringify(N,O)}function i(N){return N?(O,F)=>F&&F.$mid===l.MarshalledId.Uri?N.transformOutgoing(F):F:null}var t;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var s;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const d=()=>{},a=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class y extends $.$Vc{static{P=a}static{this.a=3*1e3}constructor(O,F=null,j=null){super(),this[P]=!0,this.b=this.B(new T.$je),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=F,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let B=0,M=u.$Kw.count;B<M;B++)this.m[B]=null,this.s[B]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(B=>this.L(B)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const F=this.w[O];delete this.w[O],F.resolveErr(L.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,C.$Jn)(O,this.g):O}getProxy(O){const{nid:F,sid:j}=O;return this.s[F]||(this.s[F]=this.J(F,j)),this.s[F]}J(O,F){const j={get:(B,M)=>(typeof M=="string"&&!B[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(B[M]=(...W)=>this.U(O,M,W)),M===w?F:B[M])};return new Proxy(Object.create(null),j)}set(O,F){return this.m[O.nid]=F,F}assertRegistered(O){for(let F=0,j=O.length;F<j;F++){const B=O[F];if(!this.m[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}L(O){if(this.j)return;const F=O.byteLength,j=S.read(O,0),B=j.readUInt8(),M=j.readUInt32();switch(B){case b.RequestJSONArgs:case b.RequestJSONArgsWithCancellation:{let{rpcId:W,method:_,args:re}=k.deserializeRequestJSONArgs(j);this.g&&(re=(0,C.$Jn)(re,this.g)),this.M(F,M,W,_,re,B===b.RequestJSONArgsWithCancellation);break}case b.RequestMixedArgs:case b.RequestMixedArgsWithCancellation:{let{rpcId:W,method:_,args:re}=k.deserializeRequestMixedArgs(j);this.g&&(re=(0,C.$Jn)(re,this.g)),this.M(F,M,W,_,re,B===b.RequestMixedArgsWithCancellation);break}case b.Acknowledged:{this.f?.logIncoming(F,M,t.LocalSide,"ack"),this.G(M);break}case b.Cancel:{this.N(F,M);break}case b.ReplyOKEmpty:{this.O(F,M,void 0);break}case b.ReplyOKJSON:{let W=k.deserializeReplyOKJSON(j);this.g&&(W=(0,C.$Jn)(W,this.g)),this.O(F,M,W);break}case b.ReplyOKJSONWithBuffers:{const W=k.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(F,M,W);break}case b.ReplyOKVSBuffer:{const W=k.deserializeReplyOKVSBuffer(j);this.O(F,M,W);break}case b.ReplyErrError:{let W=k.deserializeReplyErrError(j);this.g&&(W=(0,C.$Jn)(W,this.g)),this.P(F,M,W);break}case b.ReplyErrEmpty:{this.P(F,M,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,F,j,B,M,W){this.f?.logIncoming(O,F,t.OtherSide,`receiveRequest ${(0,u.$Mw)(j)}.${B}(`,M);const _=String(F);let re,z;if(W){const J=new A.$ue;M.push(J.token),re=this.Q(j,B,M),z=()=>J.cancel()}else re=this.Q(j,B,M),z=d;this.u[_]=z;const G=k.serializeAcknowledged(F);this.f?.logOutgoing(G.byteLength,F,t.OtherSide,"ack"),this.c.send(G),re.then(J=>{delete this.u[_];const ee=k.serializeReplyOK(F,J,this.h);this.f?.logOutgoing(ee.byteLength,F,t.OtherSide,"reply:",J),this.c.send(ee)},J=>{delete this.u[_];const ee=k.serializeReplyErr(F,J);this.f?.logOutgoing(ee.byteLength,F,t.OtherSide,"replyErr:",J),this.c.send(ee)})}N(O,F){this.f?.logIncoming(O,F,t.OtherSide,"receiveCancel");const j=String(F);this.u[j]?.()}O(O,F,j){this.f?.logIncoming(O,F,t.LocalSide,"receiveReply:",j);const B=String(F);if(!this.w.hasOwnProperty(B))return;const M=this.w[B];delete this.w[B],M.resolveOk(j)}P(O,F,j){this.f?.logIncoming(O,F,t.LocalSide,"receiveReplyErr:",j);const B=String(F);if(!this.w.hasOwnProperty(B))return;const M=this.w[B];delete this.w[B];let W;j&&(j.$isError?(W=new Error,W.name=j.name,W.message=j.message,W.stack=j.stack):W=j),M.resolveErr(W)}Q(O,F,j){try{return Promise.resolve(this.S(O,F,j))}catch(B){return Promise.reject(B)}}S(O,F,j){const B=this.m[O];if(!B)throw new Error("Unknown actor "+(0,u.$Mw)(O));const M=B[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,u.$Mw)(O));return M.apply(B,j)}U(O,F,j){if(this.j)return new E.$Hbc;let B=null;if(j.length>0&&A.CancellationToken.isCancellationToken(j[j.length-1])&&(B=j.pop()),B&&B.isCancellationRequested)return Promise.reject(L.$7());const M=k.serializeRequestArguments(j,this.h),W=++this.t,_=String(W),re=new E.$Gbc,z=new $.$Uc;B&&z.add(B.onCancellationRequested(()=>{const J=k.serializeCancel(W);this.f?.logOutgoing(J.byteLength,W,t.LocalSide,"cancel"),this.c.send(k.serializeCancel(W))})),this.w[_]=new D(re,z),this.F(W);const G=k.serializeRequest(W,O,F,M,!!B);return this.f?.logOutgoing(G.byteLength,W,t.LocalSide,`request: ${(0,u.$Mw)(O)}.${F}(`,j),this.c.send(G),re}}e.$Kbc=y;class D{constructor(O,F){this.a=O,this.b=F}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class S{static alloc(O,F,j){const B=new S(h.$Le.alloc(j+1+4),0);return B.writeUInt8(O),B.writeUInt32(F),B}static read(O,F){return new S(O,F)}get buffer(){return this.a}constructor(O,F){this.a=O,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+O);return this.b+=O,F}static sizeMixedArray(O){let F=0;F+=1;for(let j=0,B=O.length;j<B;j++){const M=O[j];switch(F+=1,M.type){case v.String:F+=this.sizeLongString(M.value);break;case v.VSBuffer:F+=this.sizeVSBuffer(M.value);break;case v.SerializedObjectWithBuffers:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let W=0;W<M.buffers.length;++W)F+=this.sizeVSBuffer(M.buffers[W]);break;case v.Undefined:break}}return F}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let F=0,j=O.length;F<j;F++){const B=O[F];switch(B.type){case v.String:this.writeUInt8(v.String),this.writeLongString(B.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(B.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let M=0;M<B.buffers.length;++M)this.writeBuffer(B.buffers[M]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const F=new Array(O);for(let j=0;j<O;j++)switch(this.readUInt8()){case v.String:F[j]=this.readLongString();break;case v.VSBuffer:F[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const M=this.readUInt32(),W=this.readLongString(),_=[];for(let re=0;re<M;++re)_.push(this.readVSBuffer());F[j]=new u.$Nw(n(W,_,null));break}case v.Undefined:F[j]=void 0;break}return F}}var I;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(I||(I={}));class k{static a(O){for(let F=0,j=O.length;F<j;F++)if(O[F]instanceof h.$Le||O[F]instanceof u.$Nw||typeof O[F]>"u")return!0;return!1}static serializeRequestArguments(O,F){if(this.a(O)){const j=[];for(let B=0,M=O.length;B<M;B++){const W=O[B];if(W instanceof h.$Le)j[B]={type:v.VSBuffer,value:W};else if(typeof W>"u")j[B]={type:v.Undefined};else if(W instanceof u.$Nw){const{jsonString:_,referencedBuffers:re}=m(W.value,F);j[B]={type:v.SerializedObjectWithBuffers,value:h.$Le.fromString(_),buffers:re}}else j[B]={type:v.String,value:h.$Le.fromString(o(W,F))}}return{type:I.Mixed,args:j}}return{type:I.Simple,args:o(O,F)}}static serializeRequest(O,F,j,B,M){switch(B.type){case I.Simple:return this.b(O,F,j,B.args,M);case I.Mixed:return this.c(O,F,j,B.args,M)}}static b(O,F,j,B,M){const W=h.$Le.fromString(j),_=h.$Le.fromString(B);let re=0;re+=S.sizeUInt8(),re+=S.sizeShortString(W),re+=S.sizeLongString(_);const z=S.alloc(M?b.RequestJSONArgsWithCancellation:b.RequestJSONArgs,O,re);return z.writeUInt8(F),z.writeShortString(W),z.writeLongString(_),z.buffer}static deserializeRequestJSONArgs(O){const F=O.readUInt8(),j=O.readShortString(),B=O.readLongString();return{rpcId:F,method:j,args:JSON.parse(B)}}static c(O,F,j,B,M){const W=h.$Le.fromString(j);let _=0;_+=S.sizeUInt8(),_+=S.sizeShortString(W),_+=S.sizeMixedArray(B);const re=S.alloc(M?b.RequestMixedArgsWithCancellation:b.RequestMixedArgs,O,_);return re.writeUInt8(F),re.writeShortString(W),re.writeMixedArray(B),re.buffer}static deserializeRequestMixedArgs(O){const F=O.readUInt8(),j=O.readShortString(),B=O.readMixedArray(),M=new Array(B.length);for(let W=0,_=B.length;W<_;W++){const re=B[W];typeof re=="string"?M[W]=JSON.parse(re):M[W]=re}return{rpcId:F,method:j,args:M}}static serializeAcknowledged(O){return S.alloc(b.Acknowledged,O,0).buffer}static serializeCancel(O){return S.alloc(b.Cancel,O,0).buffer}static serializeReplyOK(O,F,j){if(typeof F>"u")return this.d(O);if(F instanceof h.$Le)return this.e(O,F);if(F instanceof u.$Nw){const{jsonString:B,referencedBuffers:M}=m(F.value,j,!0);return this.g(O,B,M)}else return this.f(O,p(F,j))}static d(O){return S.alloc(b.ReplyOKEmpty,O,0).buffer}static e(O,F){let j=0;j+=S.sizeVSBuffer(F);const B=S.alloc(b.ReplyOKVSBuffer,O,j);return B.writeVSBuffer(F),B.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,F){const j=h.$Le.fromString(F);let B=0;B+=S.sizeLongString(j);const M=S.alloc(b.ReplyOKJSON,O,B);return M.writeLongString(j),M.buffer}static g(O,F,j){const B=h.$Le.fromString(F);let M=0;M+=S.sizeUInt32,M+=S.sizeLongString(B);for(const _ of j)M+=S.sizeVSBuffer(_);const W=S.alloc(b.ReplyOKJSONWithBuffers,O,M);W.writeUInt32(j.length),W.writeLongString(B);for(const _ of j)W.writeBuffer(_);return W.buffer}static deserializeReplyOKJSON(O){const F=O.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(O,F){const j=O.readUInt32(),B=O.readLongString(),M=[];for(let W=0;W<j;++W)M.push(O.readVSBuffer());return new u.$Nw(n(B,M,F))}static serializeReplyErr(O,F){const j=F?p(L.$4(F),null):void 0;if(typeof j!="string")return this.h(O);const B=h.$Le.fromString(j);let M=0;M+=S.sizeLongString(B);const W=S.alloc(b.ReplyErrError,O,M);return W.writeLongString(B),W.buffer}static deserializeReplyErrError(O){const F=O.readLongString();return JSON.parse(F)}static h(O){return S.alloc(b.ReplyErrEmpty,O,0).buffer}}var b;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var v;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[340],Se([1,0,22,29,15,89,5]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$IK=void 0,e.$JK=C,e.$KK=E,e.$IK=(0,L.$Ci)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${T.join("")}]+`),l=7;function C(P){if(P.scheme!==A.Schemas.vscodeNotebookCell)return;const p=P.fragment.indexOf("s");if(p<0)return;const c=parseInt(P.fragment.substring(0,p).replace($,""),l),g=(0,r.$5e)(P.fragment.substring(p+1)).toString();if(!isNaN(c))return{handle:c,notebook:P.with({scheme:g,fragment:null})}}function E(P,p){const c=p.toString(l),f=`${c.length<T.length?T[c.length-1]:"z"}${c}s${(0,r.$6e)(r.$Le.fromString(P.scheme),!0,!0)}`;return P.with({scheme:A.Schemas.vscodeNotebookCell,fragment:f})}class u{constructor(){this.a=new h.$Bc}getNotebook(p){if(p.scheme===A.Schemas.vscodeNotebookCell){const c=C(p);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$LK=u,(0,R.$Is)(e.$IK,u,R.InstantiationType.Delayed)}),define(Ee[127],Se([1,0,22,39,40,108,15,16,11,36,340]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$3K=e.CellStatusbarAlignment=e.$2K=e.NotebookEditorPriority=e.$YK=e.$XK=e.$VK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UK=e.$TK=e.$SK=e.$RK=e.CellKind=e.$QK=e.$PK=e.$OK=void 0,e.$WK=s,e.$ZK=a,e.$1K=w,e.$4K=S,e.$5K=k,h=Ue(h),e.$OK="workbench.editor.notebook",e.$PK="workbench.editor.notebookTextDiffEditor",e.$QK="workbench.editor.interactive";var E;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(E||(e.CellKind=E={})),e.$RK=["application/json","application/javascript","text/html","image/svg+xml",R.$2s.latex,R.$2s.markdown,"image/png","image/jpeg",R.$2s.text],e.$SK=[R.$2s.latex,R.$2s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$2s.text],e.$TK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UK="_notAvailable";var u;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var P;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var c;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var f;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var m;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(W){W.scheme=L.Schemas.vscodeNotebookCell;function _(ue,ne){return(0,C.$KK)(ue,ne)}W.generate=_;function re(ue){return(0,C.$JK)(ue)}W.parse=re;function z(ue,ne){return ue.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${ue.scheme!==L.Schemas.file?ue.scheme:""}`})}W.generateCellOutputUri=z;function G(ue){if(ue.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!ne)return;const De=ne[1]&&ne[1]!==""?ne[1]:void 0,$e=ne[2];return{outputId:De,notebook:ue.with({scheme:$e||L.Schemas.file,fragment:null})}}W.parseCellOutputUri=G;function J(ue,ne,De){return W.generate(ue,ne).with({scheme:De})}W.generateCellPropertyUri=J;function ee(ue,ne){if(ue.scheme===ne)return W.parse(ue.with({scheme:W.scheme}))}W.parseCellPropertyUri=ee})(o||(e.CellUri=o={}));const i=W=>$.$i?W.replace(/\//g,"\\"):W;class t{constructor(_=[],re=e.$RK){this.e=re,this.d=[...new Set(_)].map(z=>({pattern:z,matches:h.$wk(i(z))}))}sort(_){const re=new Map(A.Iterable.map(_,G=>[G,i(G)]));let z=[];for(const{matches:G}of this.d)for(const[J,ee]of re)if(G(ee)){z.push(J),re.delete(J);break}return re.size&&(z=z.concat([...re.keys()].sort((G,J)=>this.e.indexOf(G)-this.e.indexOf(J)))),z}prioritize(_,re){const z=this.f(_);if(z===-1){this.d.unshift({pattern:_,matches:h.$wk(i(_))});return}const G=new Set(re.map(ee=>this.f(ee,z)));G.delete(-1);const J=Array.from(G).sort();this.d.splice(z+1,0,...J.map(ee=>this.d[ee]));for(let ee=J.length-1;ee>=0;ee--)this.d.splice(J[ee],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,re=this.d.length){const z=i(_);for(let G=0;G<re;G++)if(this.d[G].matches(z))return G;return-1}}e.$VK=t;function s(W,_,re,z=(G,J)=>G===J){const G=[];function J(ne,De,$e){if(De===0&&$e.length===0)return;const Q=G[G.length-1];Q&&Q.start+Q.deleteCount===ne?(Q.deleteCount+=De,Q.toInsert.push(...$e)):G.push({start:ne,deleteCount:De,toInsert:$e})}let ee=0,ue=0;for(;;){if(ee===W.length){J(ee,0,_.slice(ue));break}if(ue===_.length){J(ee,W.length-ee,[]);break}const ne=W[ee],De=_[ue];if(z(ne,De)){ee+=1,ue+=1;continue}re(De)?(J(ee,1,[]),ee+=1):(J(ee,0,[De]),ue+=1)}return G}e.$XK=new l.$Tj("notebookEditorCursorAtBoundary","none"),e.$YK=new l.$Tj("notebookEditorCursorAtLineBoundary","none");var d;(function(W){W.default="default",W.option="option"})(d||(e.NotebookEditorPriority=d={}));function a(W){const _=W;return!!((typeof _.include=="string"||h.$xk(_.include))&&(typeof _.exclude=="string"||h.$xk(_.exclude)))}function w(W,_,re){if(Array.isArray(W.viewType)&&W.viewType.indexOf(_)>=0||W.viewType===_)return!0;if(W.filenamePattern){const z=a(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,G=a(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(h.$vk(z,(0,T.$oc)(re.fsPath).toLowerCase()))return!(G&&h.$vk(G,(0,T.$oc)(re.fsPath).toLowerCase()))}return!1}e.$2K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class D{static{this.d="notebook/"}static create(_){return`${D.d}${_}`}static parse(_){if(_.startsWith(D.d))return _.substring(D.d.length)}}e.$3K=D;function S(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}const I=new TextDecoder;function k(W){const _=[];let re=!1;for(const ee of W)(_.length===0||re)&&(_.push(ee),re=!0);let z=N(_);const G=r.$Le.concat(_.map(ee=>r.$Le.wrap(ee))),J=M(G);return z=z||J.byteLength!==G.byteLength,{data:J,didCompression:z}}e.$6K="\x1B[A";const b=e.$6K.split("").map(W=>W.charCodeAt(0)),v=10;function N(W){let _=!1;return W.forEach((re,z)=>{if(z===0||re.length<e.$6K.length)return;const G=W[z-1],J=re.subarray(0,e.$6K.length);if(J[0]===b[0]&&J[1]===b[1]&&J[2]===b[2]){const ee=G.lastIndexOf(v);if(ee===-1)return;_=!0,W[z-1]=G.subarray(0,ee),W[z]=re.subarray(e.$6K.length)}}),_}function O(W){let _=W;do W=_,_=W.replace(/[^\n]\x08/gm,"");while(_.length<W.length);return W}function F(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const _=W.match(/^(.*)\r+/m)[1];let re=W.match(/\r+(.*)$/m)[1];re=re+_.slice(re.length,_.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return W}const j=8,B=13;function M(W){return!W.buffer.includes(j)&&!W.buffer.includes(B)?W:r.$Le.fromString(F(O(I.decode(W.buffer))))}}),define(Ee[10],Se([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p){"use strict";var c,g,f,m,n,o,i,t,s,d,a,w,y,D,S,I,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$hP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.LanguageModelChatMessageRole=e.ChatLocation=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$WO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$JO=e.$IO=e.$HO=e.$GO=e.$EO=e.$DO=e.$CO=e.$BO=e.TestRunProfileKind=e.TestResultState=e.$AO=e.$zO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$yO=e.NotebookVariablesRequestKind=e.$xO=e.$wO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$vO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ColorThemeKind=e.$pO=e.$oO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$nO=e.$mO=e.DebugConsoleMode=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$gO=e.$fO=e.FileChangeType=e.$eO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$dO=e.$cO=e.$bO=e.$aO=e.InlineCompletionTriggerKind=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$ZN=e.ConfigurationTarget=e.$YN=e.$XN=e.$WN=e.$VN=e.DocumentPasteTriggerKind=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ON=e.ViewBadge=e.ProgressLocation=e.$NN=e.$MN=e.TaskScope=e.ShellQuoting=e.$LN=e.$KN=e.$JN=e.TaskPanelKind=e.TaskRevealKind=e.$IN=e.TerminalLocation=e.$HN=e.$GN=e.$FN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EN=e.$DN=e.$CN=e.$BN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$zN=e.$yN=e.$xN=e.$wN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vN=e.$uN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.LanguageStatusSeverity=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.CodeActionTriggerKind=e.$iN=e.$hN=e.SymbolTag=e.SymbolKind=e.$gN=e.$fN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.DiagnosticSeverity=e.DiagnosticTag=e.$_M=e.$$M=e.FileEditType=e.$0M=e.$9M=e.$8M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$AN=_e,e.$1N=Oi,e.$FO=Dn;function b(K){return Object.assign(K,{apply:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(K,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(K,[]);{const[Le,...Ze]=me;return Reflect.construct(K,Ze,Le.constructor)}}})}var v;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var N;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let O=c=class{static from(...H){let me=H;return new c(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$1M=O,e.$1M=O=c=Ye([b],O);let F=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isBefore(me)&&(me=Ze)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ze=H[Le];Ze.isAfter(me)&&(me=Ze)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Le}=H;return typeof me=="number"&&typeof Le=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$8)("line must be non-negative");if(me<0)throw(0,h.$8)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$8)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&me===0?this:new g(this.line+Le,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$8)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Le===this.line&&me===this.character?this:new g(Le,me)}toJSON(){return{line:this.line,character:this.character}}};e.$2M=F,e.$2M=F=g=Ye([b],F);let j=f=class{static isRange(H){return H instanceof f?!0:H?F.isPosition(H.start)&&F.isPosition(H.end):!1}static of(H){if(H instanceof f)return H;if(this.isRange(H))return new f(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Le,Ze){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new F(H,me),pt=new F(Le,Ze)):F.isPosition(H)&&F.isPosition(me)&&(st=F.of(H),pt=F.of(me)),!st||!pt)throw new Error("Invalid arguments");st.isBefore(pt)?(this.c=st,this.e=pt):(this.c=pt,this.e=st)}contains(H){return f.isRange(H)?this.contains(H.start)&&this.contains(H.end):F.isPosition(H)?!(F.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=F.Max(H.start,this.c),Le=F.Min(H.end,this.e);if(!me.isAfter(Le))return new f(me,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=F.Min(H.start,this.c),Le=F.Max(H.end,this.end);return new f(me,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$8)();let Le;return H?F.isPosition(H)?Le=H:(Le=H.start||this.start,me=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&me.isEqual(this.end)?this:new f(Le,me)}toJSON(){return[this.start,this.end]}};e.$3M=j,e.$3M=j=f=Ye([b],j);let B=m=class extends j{static isSelection(H){return H instanceof m?!0:H?j.isRange(H)&&F.isPosition(H.anchor)&&F.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Le,Ze){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"?(st=new F(H,me),pt=new F(Le,Ze)):F.isPosition(H)&&F.isPosition(me)&&(st=F.of(H),pt=F.of(me)),!st||!pt)throw new Error("Invalid arguments");super(st,pt),this.f=st,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$4M=B,e.$4M=B=m=Ye([b],B);const M=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,h.$8)("connectionToken")};class W{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Le){if(typeof H!="string"||H.length===0)throw(0,h.$8)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$8)("port");typeof Le<"u"&&M(Le),this.host=H,this.port=Math.round(me),this.connectionToken=Le}}e.$5M=W;class _{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&M(me)}}e.$6M=_;class re extends Error{static NotAvailable(H,me){return new re(H,P.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=me,this._detail=Le,Object.setPrototypeOf(this,re.prototype)}}e.$7M=re;var z;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(z||(e.EndOfLine=z={}));var G;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let J=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new F(0,0),new F(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$8)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$8)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$8)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$8M=J,e.$8M=J=n=Ye([b],J);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?Ei.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new Ei(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Le=new o(new Ei(H,H),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(H){const me=new o(new Ei(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$9M=ee,e.$9M=ee=o=Ye([b],ee);class ue{static isSnippetTextEdit(H){return H instanceof ue?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new ue(H,me)}static insert(H,me){return ue.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$0M=ue;var ne;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Le,Ze){this.c.push({_type:ne.File,from:H,to:me,options:Le,metadata:Ze})}createFile(H,me,Le){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Le})}deleteFile(H,me,Le){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Le})}e(H,me,Le){this.c.push({_type:ne.Cell,metadata:Le,uri:H,edit:{editType:p.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Le,Ze){const st=me.start,pt=me.end;(st!==pt||Le.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:pt-st,cells:Le,metadata:Ze})}g(H,me,Le,Ze){this.c.push({_type:ne.Cell,metadata:Ze,uri:H,edit:{editType:p.CellEditType.Metadata,index:me,metadata:Le}})}replace(H,me,Le,Ze){this.c.push({_type:ne.Text,uri:H,edit:new J(me,Le),metadata:Ze})}insert(H,me,Le,Ze){this.replace(H,new j(me,me),Le,Ze)}delete(H,me,Le){this.replace(H,me,"",Le)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Le of me){if(!Le)continue;let Ze,st;Array.isArray(Le)?(Ze=Le[0],st=Le[1]):Ze=Le,ee.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(H,Ze.range.start,Ze.newCellMetadata,st):Ze.newNotebookMetadata?this.e(H,Ze.newNotebookMetadata,st):this.f(H,Ze.range,Ze.newCells,st):ue.isSnippetTextEdit(Ze)?this.c.push({_type:ne.Snippet,uri:H,range:Ze.range,edit:Ze.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Ze,metadata:st})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ze.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,r.$Jb)(this.c)}}get(H){const me=[];for(const Le of this.c)Le._type===ne.Text&&Le.uri.toString()===H.toString()&&me.push(Le.edit);return me}entries(){const H=new R.$Bc;for(const me of this.c)if(me._type===ne.Text){let Le=H.get(me.uri);Le||(Le=[me.uri,[]],H.set(me.uri,Le)),Le[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$$M=De,e.$$M=De=Ye([b],De);let $e=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Le=new i;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=i.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Le=H.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Le=new i;Le.e=this.e,me(Le),this.e=Le.e,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$_M=$e,e.$_M=$e=i=Ye([b],$e);var Q;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(Q||(e.DiagnosticTag=Q={}));var U;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(U||(e.DiagnosticSeverity=U={}));let se=t=class{static isLocation(H){return H instanceof t?!0:H?j.isRange(H.range)&&l.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(F.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$aN=se,e.$aN=se=t=Ye([b],se);let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&l.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$bN=oe,e.$bN=oe=Ye([b],oe);let te=class{constructor(H,me,Le=U.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Le}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,r.$vb)(H.tags,me.tags)&&(0,r.$vb)(H.relatedInformation,me.relatedInformation,oe.isEqual)}};e.$cN=te,e.$cN=te=Ye([b],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$dN=le,e.$dN=le=Ye([b],le);let he=class extends le{constructor(H,me,Le,Ze){super(H,me),this.canIncreaseHover=Le,this.canDecreaseHover=Ze}};e.$eN=he,e.$eN=he=Ye([b],he);var X;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var ae;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let pe=class{constructor(H,me=ae.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$fN=pe,e.$fN=pe=Ye([b],pe);let be=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$gN=be,e.$gN=be=Ye([b],be);var Me;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var We;(function(K){K[K.Deprecated=1]="Deprecated"})(We||(e.SymbolTag=We={}));let ke=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Le,Ze,st){this.name=H,this.kind=me,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),Ze instanceof se?this.location=Ze:Le instanceof j&&(this.location=new se(Ze,Le)),s.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$hN=ke,e.$hN=ke=s=Ye([b],ke);let Ie=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,me,Le,Ze,st){this.name=H,this.detail=me,this.kind=Le,this.range=Ze,this.selectionRange=st,this.children=[],d.validate(this)}};e.$iN=Ie,e.$iN=Ie=d=Ye([b],Ie);var Te;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let V=class{constructor(H,me){this.title=H,this.kind=me}};e.$jN=V,e.$jN=V=Ye([b],V);let q=class{static{a=this}static{this.c="."}constructor(H){this.value=H}append(H){return new a(this.value?this.value+a.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+a.c)}};e.$kN=q,e.$kN=q=a=Ye([b],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let Y=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lN=Y,e.$lN=Y=Ye([b],Y);class x{constructor(H,me,Le,Ze,st,pt){this.kind=H,this.name=me,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=pt}}e.$mN=x;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$nN=fe;class we{constructor(H,me){this.fromRanges=me,this.to=H}}e.$oN=we;var Ne;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ge=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$pN=Ge,e.$pN=Ge=Ye([b],Ge);let Je=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new A.$Zk(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$qN=Je,e.$qN=Je=w=Ye([b],Je);let tt=class{constructor(H,me){this.label=H,this.documentation=me}};e.$rN=tt,e.$rN=tt=Ye([b],tt);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$sN=rt,e.$sN=rt=Ye([b],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tN=ot,e.$tN=ot=Ye([b],ot);var nt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var ct;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let $t=class{constructor(H){this.value=H}};e.$uN=$t,e.$uN=$t=Ye([b],$t);let ht=class{constructor(H,me,Le){this.position=H,this.label=me,this.kind=Le}};e.$vN=ht,e.$vN=ht=Ye([b],ht);var at;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Pe;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var Be;(function(K){K[K.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let Ke=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wN=Ke,e.$wN=Ke=Ye([b],Ke);let Oe=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$xN=Oe,e.$xN=Oe=Ye([b],Oe);let Fe=class{constructor(H,me,Le){this.insertText=H,this.range=me,this.command=Le}};e.$yN=Fe,e.$yN=Fe=Ye([b],Fe);let Z=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$zN=Z,e.$zN=Z=Ye([b],Z);var de;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(de||(e.PartialAcceptTriggerKind=de={}));var Ce;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Xe;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function _e(K,H){return`${E.$nn.toKey(K)}.${H}`}var lt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var ft;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(ft||(e.TextDocumentSaveReason=ft={}));var kt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Tt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var zt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var ui;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(K){function H(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=H}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var it;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(K){function H(me){switch(me){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=H}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(H,me){if(me&&!l.URI.isUri(me))throw(0,h.$8)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$8)("range");this.range=H,this.target=me}};e.$BN=Ct,e.$BN=Ct=Ye([b],Ct);let Kt=class{constructor(H,me,Le,Ze){this.red=H,this.green=me,this.blue=Le,this.alpha=Ze}};e.$CN=Kt,e.$CN=Kt=Ye([b],Kt);let mt=class{constructor(H,me){if(me&&!(me instanceof Kt))throw(0,h.$8)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$8)("range");this.range=H,this.color=me}};e.$DN=mt,e.$DN=mt=Ye([b],mt);let bt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$8)("label");this.label=H}};e.$EN=bt,e.$EN=bt=Ye([b],bt);var hi;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var ei;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var Ut;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Ut||(e.TerminalExitReason=Ut={}));var wt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Vt{constructor(H,me,Le){if(this.startIndex=H,this.length=me,this.tooltip=Le,typeof H!="number"||H<0)throw(0,h.$8)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$8)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$8)("tooltip")}}e.$FN=Vt;class Yt{constructor(H){this.uri=H}}e.$GN=Yt;class Xt{constructor(H){this.terminalCommand=H}}e.$HN=Xt;var xe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class $i{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$8)("options")}}e.$IN=$i;var ti;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var si;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(si||(e.TaskPanelKind=si={}));let Dt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(H){switch(H){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$8)("name");this.c=H}get id(){return this.c}};e.$JN=Dt,e.$JN=Dt=y=Ye([b],Dt);function Jt(K){let H="";for(let me=0;me<K.length;me++)H+=K[me].replace(/,/g,",,")+",";return H}let Lt=class{constructor(H,me,Le){if(typeof H!="string")throw(0,h.$8)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Le):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$8)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Jt(H)}};e.$KN=Lt,e.$KN=Lt=Ye([b],Lt);let Ft=class{constructor(H,me,Le){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$8)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$8)("command");this.e=H,this.f=me,this.g=Le}else{if(typeof H!="string")throw(0,h.$8)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$8)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$8)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Jt(H)}};e.$LN=Ft,e.$LN=Ft=Ye([b],Ft);var ii;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var ni;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(ni||(e.TaskScope=ni={}));class oi{constructor(H){this.c=H}computeId(){return"customExecution"+(0,C.$Yg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$MN=oi;let qt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Le,Ze,st,pt){this.k=!1,this.l=this.definition=H;let Et;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Le,this.execution=Ze,Et=st,this.k=!0):me===ni.Global||me===ni.Workspace?(this.target=me,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,Et=pt):(this.target=me,this.o=this.name=Le,this.w=this.source=Ze,this.execution=st,Et=pt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,C.$Yg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$8)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$8)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(D.g===me||D.e===me||D.f===me||D.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$8)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$NN=qt,e.$NN=qt=D=Ye([b],qt);var Qt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var di;(function(K){function H(me){const Le=me;return(0,$.$gg)(Le.value)?Le.tooltip&&!(0,$.$cg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=H})(di||(e.ViewBadge=di={}));let jt=S=class{static isTreeItem(H,me){const Le=H;if(Le.checkboxState!==void 0){const Ze=(0,$.$gg)(Le.checkboxState)?Le.checkboxState:(0,$.$eg)(Le.checkboxState)&&(0,$.$gg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,$.$gg)(Le.checkboxState)&&(0,$.$eg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Pt.Checked&&Ze!==Pt.Unchecked||st!==void 0&&!(0,$.$cg)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof S)return!0;if(Le.label!==void 0&&!(0,$.$cg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$cg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$cg)(Le.iconPath)&&!l.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$cg)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$cg)(Ze.light)&&!l.URI.isUri(Ze.light)&&!(0,$.$cg)(Ze.dark)&&!l.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$cg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!l.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$cg)(Le.tooltip)&&!(Le.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<vt.None&&Le.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$cg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,me=vt.None){this.collapsibleState=me,l.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$ON=jt,e.$ON=jt=S=Ye([b],jt);var vt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Pt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let Ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$PN=Ot,e.$PN=Ot=Ye([b],Ot);class It extends Ot{}e.$QN=It;class Zt extends It{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$RN=Zt;class Ht{constructor(H,me,Le,Ze){this.name=H,this.uri=me,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$SN=Ht;let pi=class{#e=new Map;constructor(H){for(const[me,Le]of H??[]){const Ze=this.#e.get(this.#t(me));Ze?Ze.push(Le):this.#e.set(this.#t(me),[Le])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Le,Ze]of this.#e)for(const st of Ze)H.call(me,st,Le,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Le of me)yield[H,Le]}#t(H){return H.toLowerCase()}};e.$TN=pi,e.$TN=pi=Ye([b],pi);let fi=class{constructor(H,me,Le){this.insertText=H,this.title=me,this.kind=Le}};e.$UN=fi,e.$UN=fi=Ye([b],fi);var Ai;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Nt{static{this.c="."}constructor(H){this.value=H}append(...H){return new Nt((this.value?[this.value,...H]:H).join(Nt.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+Nt.c)}}e.$VN=Nt,Nt.Empty=new Nt("");class Ti{constructor(H,me,Le){this.title=me,this.insertText=H,this.kind=Le}}e.$WN=Ti;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$XN=ai,e.$XN=ai=Ye([b],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(H){this.id=H}};e.$YN=Rt,e.$YN=Rt=Ye([b],Rt);var Si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Di=class{get base(){return this.c}set base(H){this.c=H,this.e=l.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!l.URI.isUri(H)&&!l.URI.isUri(H.uri)))throw(0,h.$8)("base");if(typeof me!="string")throw(0,h.$8)("pattern");typeof H=="string"?this.baseUri=l.URI.file(H):l.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ZN=Di,e.$ZN=Di=Ye([b],Di);const vi=new WeakMap;function Oi(K,H){vi.set(K,H)}let gi=class{constructor(H,me,Le,Ze,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=vi.get(this)??(0,C.$Yg)()),this.c}};e.$2N=gi,e.$2N=gi=Ye([b],gi);let Gt=class extends gi{constructor(H,me,Le,Ze,st,pt){if(super(me,Le,Ze,st,pt),H===null)throw(0,h.$8)("location");this.location=H}};e.$3N=Gt,e.$3N=Gt=Ye([b],Gt);let Ae=class extends gi{constructor(H,me,Le,Ze,st,pt){super(me,Le,Ze,st,pt),this.functionName=H}};e.$4N=Ae,e.$4N=Ae=Ye([b],Ae);let je=class extends gi{constructor(H,me,Le,Ze,st,pt,Et,_t){if(super(Ze,st,pt,Et,_t),!me)throw(0,h.$8)("dataId");this.label=H,this.dataId=me,this.canPersist=Le}};e.$5N=je,e.$5N=je=Ye([b],je);let ve=class{constructor(H,me,Le){this.command=H,this.args=me||[],this.options=Le}};e.$6N=ve,e.$6N=ve=Ye([b],ve);let ie=class{constructor(H,me){this.port=H,this.host=me}};e.$7N=ie,e.$7N=ie=Ye([b],ie);let Re=class{constructor(H){this.path=H}};e.$8N=Re,e.$8N=Re=Ye([b],Re);let He=class{constructor(H){this.implementation=H}};e.$9N=He,e.$9N=He=Ye([b],He);class et{constructor(H,me,Le){this.session=H,this.threadId=me,this.frameId=Le}}e.$0N=et;class Qe{constructor(H,me){this.session=H,this.threadId=me}}e.$$N=Qe;let gt=class{constructor(H,me){this.range=H,this.expression=me}};e.$_N=gt,e.$_N=gt=Ye([b],gt);var At;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(At||(e.InlineCompletionTriggerKind=At={}));let xt=class{constructor(H,me){this.range=H,this.text=me}};e.$aO=xt,e.$aO=xt=Ye([b],xt);let ci=class{constructor(H,me,Le=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Le}};e.$bO=ci,e.$bO=ci=Ye([b],ci);let Bt=class{constructor(H,me){this.range=H,this.expression=me}};e.$cO=Bt,e.$cO=Bt=Ye([b],Bt);let ri=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$dO=ri,e.$dO=ri=Ye([b],ri);var Wi;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));var Zi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Zi||(e.NewSymbolNameTriggerKind=Zi={}));class zi{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$eO=zi;var Ni;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Ni||(e.FileChangeType=Ni={}));let Ui=I=class extends Error{static FileExists(H){return new I(H,u.FileSystemProviderErrorCode.FileExists,I.FileExists)}static FileNotFound(H){return new I(H,u.FileSystemProviderErrorCode.FileNotFound,I.FileNotFound)}static FileNotADirectory(H){return new I(H,u.FileSystemProviderErrorCode.FileNotADirectory,I.FileNotADirectory)}static FileIsADirectory(H){return new I(H,u.FileSystemProviderErrorCode.FileIsADirectory,I.FileIsADirectory)}static NoPermissions(H){return new I(H,u.FileSystemProviderErrorCode.NoPermissions,I.NoPermissions)}static Unavailable(H){return new I(H,u.FileSystemProviderErrorCode.Unavailable,I.Unavailable)}constructor(H,me=u.FileSystemProviderErrorCode.Unknown,Le){super(l.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,u.$ll)(this,me),Object.setPrototypeOf(this,I.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$fO=Ui,e.$fO=Ui=I=Ye([b],Ui);let Vi=class{constructor(H,me,Le){this.start=H,this.end=me,this.kind=Le}};e.$gO=Vi,e.$gO=Vi=Ye([b],Vi);var ki;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Mi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var en;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class $n{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$hO=$n;function tn(K){return typeof K>"u"||(0,$.$dg)(K)}class Gi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Le=H.tokenTypes.length;me<Le;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Le=H.tokenModifiers.length;me<Le;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Le,Ze,st){if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Le,Ze,st);if(j.isRange(H)&&typeof me=="string"&&tn(Le))return this.o(H,me,Le);throw(0,h.$8)()}o(H,me,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,st=H.start.character,pt=H.end.character-H.start.character,Et=this.k.get(me);let _t=0;if(Le)for(const mi of Le){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);_t|=1<<wi>>>0}this.q(Ze,st,pt,Et,_t)}q(H,me,Le,Ze,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const _t=this.g.length/5|0;let mi=0,wi=0;for(let yi=0;yi<_t;yi++){let Ci=this.g[5*yi],Yi=this.g[5*yi+1];Ci===0?(Ci=mi,Yi+=wi):Ci+=mi,this.g[5*yi]=Ci,this.g[5*yi+1]=Yi,mi=Ci,wi=Yi}}let pt=H,Et=me;this.f&&this.j>0&&(pt-=this.c,pt===0&&(Et-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=Et,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Le=H.length/5|0;for(let Et=0;Et<Le;Et++)me[Et]=Et;me.sort((Et,_t)=>{const mi=H[5*Et],wi=H[5*_t];if(mi===wi){const yi=H[5*Et+1],Ci=H[5*_t+1];return yi-Ci}return mi-wi});const Ze=new Uint32Array(H.length);let st=0,pt=0;for(let Et=0;Et<Le;Et++){const _t=5*me[Et],mi=H[_t+0],wi=H[_t+1],yi=H[_t+2],Ci=H[_t+3],Yi=H[_t+4],Wn=mi-st,kr=Wn===0?wi-pt:wi,Xi=5*Et;Ze[Xi+0]=Wn,Ze[Xi+1]=kr,Ze[Xi+2]=yi,Ze[Xi+3]=Ci,Ze[Xi+4]=Yi,st=mi,pt=wi}return Ze}build(H){return this.f?new Ii(new Uint32Array(this.g),H):new Ii(Gi.r(this.g),H)}}e.$iO=Gi;class Ii{constructor(H,me){this.resultId=me,this.data=H}}e.$jO=Ii;class pn{constructor(H,me,Le){this.start=H,this.deleteCount=me,this.data=Le}}e.$kO=pn;class bn{constructor(H,me){this.resultId=me,this.edits=H}}e.$lO=bn;var nn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Hi{constructor(H){this.name=H}}e.$mO=Hi;let Fi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$nO=Fi,e.$nO=Fi=Ye([b],Fi);var Ve;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ve||(e.QuickPickItemKind=Ve={}));var bi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Ki;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Ki||(e.ExtensionKind=Ki={}));class ut{static validate(H){if(typeof H.badge=="string"){let me=(0,T.$Nf)(H.badge,0);if(me<H.badge.length&&(me+=(0,T.$Nf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Le){this.badge=H,this.tooltip=me,this.color=Le}}e.$oO=ut;let yt=class{constructor(H){this.kind=H}};e.$pO=yt,e.$pO=yt=Ye([b],yt);var rn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class Ei{static isNotebookRange(H){return H instanceof Ei?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$8)("start must be positive");if(me<0)throw(0,h.$8)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Le=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Le=H.end),me===this.c&&Le===this.e?this:new Ei(me,Le)}}e.$qO=Ei;class Li{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Li.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Le,Ze,st,pt,Et){this.kind=H,this.value=me,this.languageId=Le,this.mime=Ze,this.outputs=st??[],this.metadata=pt,this.executionSummary=Et,Li.validate(this)}}e.$rO=Li;class wn{constructor(H){this.cells=H}}e.$sO=wn;class li{static isNotebookCellOutputItem(H){return H instanceof li?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return li.json(me,"application/vnd.code.notebook.error")}static stdout(H){return li.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return li.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new li(H,me)}static#e=new TextEncoder;static text(H,me=L.$2s.text){const Le=li.#e.encode(String(H));return new li(Le,me)}static json(H,me="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return li.text(Le,me)}constructor(H,me){this.data=H,this.mime=me;const Le=(0,L.$6s)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$tO=li;class ji{static isNotebookCellOutput(H){return H instanceof ji?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Le=new Set,Ze=new Set;for(let st=0;st<H.length;st++){const pt=H[st],Et=(0,L.$6s)(pt.mime);if(!Le.has(Et)||(0,p.$4K)(Et)){Le.add(Et);continue}Ze.add(st),me&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ze.size===0?H:H.filter((st,pt)=>!Ze.has(pt))}constructor(H,me,Le){this.items=ji.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,C.$Yg)(),this.metadata=me??Le)}}e.$uO=ji;var sn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(H,me){this.text=H,this.alignment=me}}e.$vO=vn;var cn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var ln;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class En{constructor(H,me=[]){this.uri=H,this.provides=(0,r.$3b)(me)}}e.$wO=En;class yn{constructor(H){this.label=H}}e.$xO=yn;var un;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Qi=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$yO=Qi,e.$yO=Qi=Ye([b],Qi);var hn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ge{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$zO=ge;class ye{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$AO=ye;var ze;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ze||(e.TestResultState=ze={}));var dt;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(dt||(e.TestRunProfileKind=dt={}));let St=class{constructor(H=void 0,me=void 0,Le=void 0,Ze=!1,st=!0){this.include=H,this.exclude=me,this.profile=Le,this.continuous=Ze,this.preserveFocus=st}};e.$BO=St,e.$BO=St=Ye([b],St);let Mt=k=class{static diff(H,me,Le){const Ze=new k(H);return Ze.expectedOutput=me,Ze.actualOutput=Le,Ze}constructor(H){this.message=H}};e.$CO=Mt,e.$CO=Mt=k=Ye([b],Mt);let Pi=class{constructor(H){this.id=H}};e.$DO=Pi,e.$DO=Pi=Ye([b],Pi);class Bi{constructor(H,me){this.covered=H,this.total=me,Dn(this)}}e.$EO=Bi;function Dn(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class Sn{static fromDetails(H,me){const Le=new Bi(0,0),Ze=new Bi(0,0),st=new Bi(0,0);for(const Et of me)if("branches"in Et){Le.total+=1,Le.covered+=Et.executed?1:0;for(const _t of Et.branches)Ze.total+=1,Ze.covered+=_t.executed?1:0}else st.total+=1,st.covered+=Et.executed?1:0;const pt=new Sn(H,Le,Ze.total>0?Ze:void 0,st.total>0?st:void 0);return pt.detailedCoverage=me,pt}constructor(H,me,Le,Ze,st){this.uri=H,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Ze,this.testItem=st}}e.$GO=Sn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le=[]){this.executed=H,this.location=me,this.branches=Le}}e.$HO=Vn;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.executed=H,this.location=me,this.label=Le}}e.$IO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.name=H,this.executed=me,this.location=Le}}e.$JO=Gn;var kn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,me,Le,Ze,st,pt){this.kind=H,this.name=me,this.detail=Le,this.uri=Ze,this.range=st,this.selectionRange=pt}}e.$KO=Hn;class Kn{constructor(H){this.uri=H}}e.$LO=Kn;class Jn{constructor(H,me){this.original=H,this.modified=me}}e.$MO=Jn;class Qn{constructor(H,me,Le,Ze){this.base=H,this.input1=me,this.input2=Le,this.result=Ze}}e.$NO=Qn;class Yn{constructor(H,me){this.uri=H,this.viewType=me}}e.$OO=Yn;class Xn{constructor(H){this.viewType=H}}e.$PO=Xn;class Zn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$QO=Zn;class xn{constructor(H,me,Le){this.original=H,this.modified=me,this.notebookType=Le}}e.$RO=xn;class _n{constructor(){}}e.$SO=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$TO=er;class tr{constructor(){}}e.$UO=tr;class ir{constructor(H){this.textDiffs=H}}e.$VO=ir;var Cn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Le){this.id=H,this.label=me,this.values=Le}}e.$WO=nr;var Tn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Ln;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Je(H):H}}e.$XO=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Je(H):H,this.vulnerabilities=me}}e.$YO=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$ZO=or;class ar{constructor(H,me,Le){this.title=H,this.message=me,this.data=Le}}e.$1O=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$2O=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$3O=lr;class ur{constructor(H){this.value=H}}e.$4O=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$5O=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Je(H):H}}e.$6O=dr;class fr{constructor(H){this.value=H}}e.$7O=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$8O=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$9O=mr;class $r{constructor(H,me,Le,Ze){this.prompt=H,this.command=me,this.references=Le,this.participant=Ze}}e.$0O=$r;class pr{constructor(H,me,Le,Ze){this.response=H,this.result=me,this.participant=Le,this.command=Ze}}e.$$O=pr;var On;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var gn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(H,me,Le){this.name=H,this.content=me,this.isError=Le??!1}}e.$_O=br;class mn{static User(H,me){const Le=new mn(gn.User,typeof H=="string"?H:"",me);return Le.content2=H,Le}static Assistant(H,me){return new mn(gn.Assistant,H,me)}constructor(H,me,Le){this.role=H,this.content=me,this.content2=me,this.name=Le}}e.$aP=mn;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$bP=wr;class vr{constructor(H){this.value=H}}e.$cP=vr;class Er{constructor(H){this.content=H}}e.$dP=Er;class yr{constructor(H,me){this.content=H,this.name=me}}e.$eP=yr;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$fP=Sr;class Ri extends Error{static NotFound(H){return new Ri(H,Ri.NotFound.name)}static NoPermissions(H){return new Ri(H,Ri.NoPermissions.name)}static Blocked(H){return new Ri(H,Ri.Blocked.name)}constructor(H,me,Le){super(H,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.$gP=Ri;var Nn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Mn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(Mn||(e.SpeechToTextStatus=Mn={}));var Fn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var jn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$hP=Dr;var Bn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Bn||(e.InlineEditTriggerKind=Bn={}))}),define(Ee[341],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$YM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,T,$){if(this.a.size===0)throw new Error("No related information providers registered");const l=this.a.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(T,$)??[]}getRelatedInformation(L,T,$){return this.c.$getAiRelatedInformation(T,$)}registerRelatedInformationProvider(L,T,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiRelatedInformationProvider(l,T),new h.$1M(()=>{this.c.$unregisterAiRelatedInformationProvider(l),this.a.delete(l)})}}e.$0mc=A}),define(Ee[128],Se([1,0,4,6,10,24,155,5,20]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,T.$Ci)("IExtHostAuthentication");let l=class{constructor(u){this.b=new Map,this.c=new r.$je,this.onDidChangeSessions=this.c.event,this.d=new C,this.f=new C,this.a=u.getProxy(h.$YM.MainThreadAuthentication)}async getSession(u,P,p,c={}){const g=R.$nn.toKey(u.identifier),f=[...p].sort().join(" ");return await this.d.getOrCreate(`${g} ${P} ${f}`,async()=>{await this.a.$ensureProvider(P);const m=u.displayName||u.name;return this.a.$getSession(P,p,g,m,c)})}async getSessions(u,P,p){const c=R.$nn.toKey(u.identifier),g=[...p].sort().join(" ");return await this.f.getOrCreate(`${c} ${g}`,async()=>{await this.a.$ensureProvider(P);const f=u.displayName||u.name;return this.a.$getSessions(P,p,c,f)})}async removeSession(u,P){const p=this.b.get(u);return p?p.provider.removeSession(P):this.a.$removeSession(u,P)}registerAuthenticationProvider(u,P,p,c){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:P,provider:p,options:c??{supportsMultipleAccounts:!1}});const g=p.onDidChangeSessions(f=>this.a.$sendDidChangeSessions(u,f));return this.a.$registerAuthenticationProvider(u,P,c?.supportsMultipleAccounts??!1),new A.$1M(()=>{g.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,P,p){const c=this.b.get(u);if(c)return await c.provider.createSession(P,p);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,P){const p=this.b.get(u);if(p)return await p.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,P){const p=this.b.get(u);if(p)return await p.provider.getSessions(P);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,P){return u.startsWith(L.$1L)||this.c.fire({provider:{id:u,label:P}}),Promise.resolve()}};e.$jnc=l,e.$jnc=l=Ye([qe(0,$.$sP)],l);class C{constructor(){this.a=new Map}getOrCreate(u,P){const p=this.a.get(u);if(p)return p;const c=P().finally(()=>this.a.delete(u));return this.a.set(u,c),c}}}),define(Ee[162],Se([1,0,2,6,10,5,20,12,19,13,16,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=void 0;let P=class{static{u=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(h.$YM.MainThreadDecorations)}registerFileDecorationProvider(c,g){const f=u.c++;this.f.set(f,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(f,g.identifier.value);const m=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(f,null);return}const o=(0,$.$3b)(n);if(o.length<=u.d){this.g.$onDidChange(f,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,o.length);const i=o.map(d=>({uri:d,rank:(0,l.$gf)(d.path,"/")})),t=(0,$.$Ab)(i,(d,a)=>d.rank-a.rank||(0,l.$wf)(d.uri.path,a.uri.path)),s=[];e:for(const d of t){let a;for(const w of d){const y=(0,C.$nc)(w.uri.path);if(a!==y&&(a=y,s.push(w.uri)>=u.d))break e}}this.g.$onDidChange(f,s)});return new A.$1M(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(f),this.f.delete(f)})}async $provideDecorations(c,g,f){if(!this.f.has(c))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(c);return await Promise.all(g.map(async i=>{try{const{uri:t,id:s}=i,d=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),f));if(!d)return;try{A.$oO.validate(d),d.badge&&typeof d.badge!="string"&&(0,E.$2G)(o,"codiconDecoration"),m[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(a){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${a}`)}}catch(t){this.h.error(t)}})),m}};e.$noc=P,e.$noc=P=u=Ye([qe(0,L.$sP),qe(1,T.$9j)],P),e.$ooc=(0,R.$Ci)("IExtHostDecorations")}),define(Ee[342],Se([1,0,14,2,10,6,15,21,13]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class l{static{this.a=0}constructor(E,u,P){this.d=u,this.e=P,this.b=new Map,this.c=E.getProxy(R.$YM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(L.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const P=l.a++;this.b.set(P,u),this.c.$registerTextContentProvider(P,E);let p;if(typeof u.onDidChange=="function"){let c;p=u.onDidChange(async g=>{if(g.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const f=this.$provideTextDocumentContent(P,g).then(async m=>{if(!m&&typeof m!="string")return;const n=this.d.getDocument(g);if(!n)return;const o=(0,$.$qf)(m);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(g,m)}).catch(r.$2).finally(()=>{c===f&&(c=void 0)});c=f})}return new A.$1M(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(E,u){const P=this.b.get(E);return P?Promise.resolve(P.provideTextDocumentContent(h.URI.revive(u),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$qoc=l}),define(Ee[163],Se([1,0,66,15,13,197,138,10,19]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=void 0,e.$uP=C;const l=new Map;function C(p,c){c?l.set(p,c):l.delete(p)}function E(p){return l.get(p)}class u extends R.$fw{constructor(c,g,f,m,n,o,i){super(g,f,m,n),this.c=c,this.m=o,this.q=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$vb)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===h.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,f){return c.y(g,f)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,r.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,r.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const f=this.g,m=g.start.line,n=g.end.line,o=[];o.push(this.f[m].substring(g.start.character));for(let i=m+1;i<n;i++)o.push(this.f[i]);return o.push(this.f[n].substring(0,g.end.character)),o.join(f)}t(c){let g;if(c instanceof T.$2M?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new P(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),f=this.f[g.index].length;return new T.$2M(g.index,Math.min(g.remainder,f))}w(c){if(!(c instanceof T.$3M))throw new Error("Invalid argument");const g=this.x(c.start),f=this.x(c.end);return g===c.start&&f===c.end?c:new T.$3M(g.line,g.character,f.line,f.character)}x(c){if(!(c instanceof T.$2M))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:f}=c,m=!1;if(g<0)g=0,f=0,m=!0;else if(g>=this.f.length)g=this.f.length-1,f=this.f[g].length,m=!0;else{const n=this.f[g].length;f<0?(f=0,m=!0):f>n&&(f=n,m=!0)}return m?new T.$2M(g,f):c}y(c,g){const f=this.x(c);if(!g)g=E(this.m);else if((0,A.$pf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const m=(0,L.$ht)(f.character+1,(0,L.$ft)(g),this.f[f.line],0);if(m)return new T.$3M(f.line,m.startColumn-1,f.line,m.endColumn-1)}}e.$vP=u;class P{constructor(c,g,f){this.a=c,this.b=g,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$3M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$3M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$wP=P}),define(Ee[343],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$YM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,T,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const l=this.a.get(L);if(!l)throw new Error("Embedding vector provider not found");const C=await l.provideEmbeddingVector(T,$);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(L,T,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiEmbeddingVectorProvider(T,l),new h.$1M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(l),this.a.delete(l)})}}e.$toc=A}),define(Ee[76],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=void 0,h=Ue(h);let p=P=class{constructor(g,f){this.b=new Map,this.c=new C.$Lh,this.a=g.getProxy(r.$YM.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let o;const i=m.b.get(n.scheme);return i?(await m.a.$ensureActivation(n.scheme),o=await i.impl.stat(n)):o=await m.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await m.a.$readdir(n)}catch(o){return P.e(o)}},async createDirectory(n){try{const o=m.b.get(n.scheme);return o&&!o.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(o.impl,o.extUri,n)):await m.a.$mkdir(n)}catch(o){return P.e(o)}},async readFile(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await m.a.$readFile(n)).buffer}catch(o){return P.e(o)}},async writeFile(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(i.impl,i.extUri,i.extUri.dirname(n)),await m.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await m.a.$writeFile(n,R.$Le.wrap(o))}catch(i){return P.e(i)}},async delete(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly&&!o?.useTrash?(await m.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...o})):await m.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(i){return P.e(i)}},async rename(n,o,i){try{return await m.a.$rename(n,o,{overwrite:!1,...i})}catch(t){return P.e(t)}},async copy(n,o,i){try{return await m.a.$copy(n,o,{overwrite:!1,...i})}catch(t){return P.e(t)}},isWritableFileSystem(n){const o=f.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(g,f,m){const n=[];for(;!f.isEqual(m,f.dirname(m));)try{if(!((await g.stat(m)).type&h.FileType.Directory))throw A.$fO.FileExists(`Unable to create folder '${m.scheme===u.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$ml(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(f.basename(m)),m=f.dirname(m)}for(let o=n.length-1;o>=0;o--){m=f.joinPath(m,n[o]);try{await g.createDirectory(m)}catch(i){if(h.$ml(i)!==h.FileSystemProviderErrorCode.FileExists)throw i}}}static e(g){if(g instanceof A.$fO)throw g;if(g instanceof h.$il)switch(g.code){case h.FileSystemProviderErrorCode.FileExists:throw A.$fO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$fO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$fO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$fO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$fO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$fO.Unavailable(g.message);default:throw new A.$fO(g.message,g.name)}if(!(g instanceof Error))throw new A.$fO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw A.$fO.Unavailable(g.message);switch(g.name){case h.FileSystemProviderErrorCode.FileExists:throw A.$fO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$fO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$fO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$fO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$fO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$fO.Unavailable(g.message);default:throw new A.$fO(g.message,g.name)}}addFileSystemProvider(g,f,m){return this.b.set(g,{impl:f,extUri:m?.isCaseSensitive?E.$6g:E.$8g,isReadonly:!!m?.isReadonly}),(0,l.$Tc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??E.$6g}};e.$ync=p,e.$ync=p=P=Ye([qe(0,T.$sP),qe(1,$.$cnc)],p),e.$znc=(0,L.$Ci)("IExtHostConsumerFileSystem")}),define(Ee[98],Se([1,0,5,30,12,76,2]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$Anc=void 0,e.$Anc=(0,r.$Ci)("IExtensionStoragePaths");let T=class{constructor(l,C,E){this.d=C,this.f=E,this.a=l.workspace??void 0,this.b=l.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(l){return L.URI.joinPath(this.b.workspaceStorageHome,l)}async h(){if(!this.a)return Promise.resolve(void 0);const l=this.a.id,C=await this.g(l);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(L.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(l){if(this.c)return L.URI.joinPath(this.c,l.identifier.value)}globalValue(l){return L.URI.joinPath(this.b.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Bnc=T,e.$Bnc=T=Ye([qe(0,h.$IP),qe(1,A.$9j),qe(2,R.$znc)],T)}),define(Ee[344],Se([1,0,10,20,4]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;let R=class{constructor(T){this.a=new r.$pO(r.ColorThemeKind.Dark),this.b=new A.$je}get activeColorTheme(){return this.a}$onColorThemeChange(T){let $;switch(T){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$pO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0oc=R,e.$0oc=R=Ye([qe(0,h.$sP)],R)}),define(Ee[77],Se([1,0,21,4,3,243,5,12,93,6,30,20,10]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Eb=e.$2Eb=e.TunnelDtoConverter=void 0,R=Ue(R),u=Ue(u);class P extends $.$Ew{}var p;(function(g){function f(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}g.fromApiTunnel=f;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}g.fromServiceTunnel=m})(p||(e.TunnelDtoConverter=p={})),e.$2Eb=(0,L.$Ci)("IExtHostTunnelService");let c=class extends A.$Vc{constructor(f,m,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=f.getProxy(l.$YM.MainThreadTunnelService)}async openTunnel(f,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this.a.$openTunnel(m,f.displayName);if(n){const o=new P(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(f,m){f.portRange===void 0&&f.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:f,provider:m}),this.a.$registerPortsAttributesProvider(f,n),new u.$1M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(f,m,n,o,i){const t=[];for(const d of f){const a=this.r.get(d);if(!a)return[];t.push(...await Promise.all(m.map(async w=>{let y;try{y=await a.provider.providePortAttributes({port:w,pid:n,commandLine:o},i)}catch{y=await a.provider.providePortAttributes(w,n,o,i)}return{providedAttributes:y,port:w}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(f){}registerTunnelProvider(f,m){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,i)=>await f.provideTunnel(o,i,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(f,m){if(f){f.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this.f=f.showCandidatePort,this.a.$setCandidateFilter());const n=f.tunnelFactory??(m?this.w(m):void 0);if(n){this.b=n;let o=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,A.$Tc)(()=>{this.b=void 0})}w(f){}async $closeTunnel(f,m){if(this.g.has(f.host)){const n=this.g.get(f.host);n.has(f.port)&&(m&&n.get(f.port).disposeListener.dispose(),await n.get(f.port).tunnel.dispose(),n.delete(f.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(f,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(f,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(f.remoteAddress.host)||this.g.set(f.remoteAddress.host,new Map);const i=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:o,disposeListener:i}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(f){const m=await Promise.all(f.map(o=>this.f(o.host,o.port,o.detail??""))),n=f.filter((o,i)=>m[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$3Eb=c,e.$3Eb=c=Ye([qe(0,E.$sP),qe(1,C.$IP),qe(2,T.$9j)],c)}),define(Ee[17],Se([1,0,19,22,186,80,86,29,176,57,108,25,181,23,50,18,2,114,31,106,88,54,145,90,154,152,306,322,120,127,74,75,318,10]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a,w,y,D,S,I,k,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$pP=ee,e.$qP=ne,e.$rP=De,L=Ue(L),m=Ue(m),n=Ue(n),o=Ue(o),y=Ue(y),S=Ue(S),v=Ue(v);var N;(function(Ae){function je(ie){const{selectionStartLineNumber:Re,selectionStartColumn:He,positionLineNumber:et,positionColumn:Qe}=ie,gt=new v.$2M(Re-1,He-1),At=new v.$2M(et-1,Qe-1);return new v.$4M(gt,At)}Ae.to=je;function ve(ie){const{anchor:Re,active:He}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Ae.from=ve})(N||(e.Selection=N={}));var O;(function(Ae){function je(ie){if(!ie)return;const{start:Re,end:He}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Ae.from=je;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:He,endLineNumber:et,endColumn:Qe}=ie;return new v.$3M(Re-1,He-1,et-1,Qe-1)}Ae.to=ve})(O||(e.Range=O={}));var F;(function(Ae){function je(ie){return{uri:ie.uri,range:O.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$aN(g.URI.revive(ie.uri),O.to(ie.range))}Ae.to=ve})(F||(e.Location=F={}));var j;(function(Ae){function je(ve){switch(ve){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=je})(j||(e.TokenType=j={}));var B;(function(Ae){function je(ie){return new v.$2M(ie.lineNumber-1,ie.column-1)}Ae.to=je;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(B||(e.Position=B={}));var M;(function(Ae){function je(Re,He,et){return(0,r.$Ib)((0,r.$3b)(Re).map(Qe=>ve(Qe,He,et)))}Ae.from=je;function ve(Re,He,et){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:et?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,He),pattern:_e.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:et?.isBuiltin}}function ie(Re,He){return He&&typeof Re=="string"?He.transformOutgoingScheme(Re):Re}})(M||(e.DocumentSelector=M={}));var W;(function(Ae){function je(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case t.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(W||(e.DiagnosticTag=W={}));var _;(function(Ae){function je(ie){let Re;return ie.code&&((0,c.$cg)(ie.code)||(0,c.$gg)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...O.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:z.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,r.$Ib)(ie.tags.map(W.from)):void 0}}Ae.from=je;function ve(ie){const Re=new v.$cN(O.to(ie),ie.message,z.to(ie.severity));return Re.source=ie.source,Re.code=(0,c.$cg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Re.tags=ie.tags&&(0,r.$Ib)(ie.tags.map(W.to)),Re}Ae.to=ve})(_||(e.Diagnostic=_={}));var re;(function(Ae){function je(ie){return{...O.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=je;function ve(ie){return new v.$bN(new v.$aN(ie.resource,O.to(ie)),ie.message)}Ae.to=ve})(re||(e.DiagnosticRelatedInformation=re={}));var z;(function(Ae){function je(ie){switch(ie){case v.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=je;function ve(ie){switch(ie){case t.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(z||(e.DiagnosticSeverity=z={}));var G;(function(Ae){function je(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?b.$jE:b.$iE}Ae.from=je;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function J(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!J(Ae[0])}var ue;(function(Ae){function je(Qe){return Qe.map(Ae.from)}Ae.fromMany=je;function ve(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let gt;if(ve(Qe)){const{language:Bt,value:ri}=Qe;gt={value:"```"+Bt+`
`+ri+"\n```\n"}}else v.$qN.isMarkdownString(Qe)?gt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?gt={value:Qe}:gt={value:""};const At=Object.create(null);gt.uris=At;const xt=Bt=>{try{let ri=g.URI.parse(Bt,!0);ri=ri.with({query:Re(ri.query,At)}),At[Bt]=ri}catch{}return""},ci=new $.marked.Renderer;return ci.link=xt,ci.image=Bt=>typeof Bt=="string"?xt(L.$8k(Bt).href):"",(0,$.marked)(gt.value,{renderer:ci}),gt}Ae.from=ie;function Re(Qe,gt){if(!Qe)return Qe;let At;try{At=(0,l.$$h)(Qe)}catch{}if(!At)return Qe;let xt=!1;return At=(0,E.$bo)(At,ci=>{if(g.URI.isUri(ci)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[Bt]=ci,xt=!0,Bt}else return}),xt?JSON.stringify(At):Qe}function He(Qe){const gt=new v.$qN(Qe.value,Qe.supportThemeIcons);return gt.isTrusted=Qe.isTrusted,gt.supportHtml=Qe.supportHtml,gt.baseUri=Qe.baseUri?g.URI.from(Qe.baseUri):void 0,gt}Ae.to=He;function et(Qe){if(Qe)return typeof Qe=="string"?Qe:Ae.from(Qe)}Ae.fromStrict=et})(ue||(e.MarkdownString=ue={}));function ne(Ae){return ee(Ae)?Ae.map(je=>({range:O.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?ue.fromMany(je.hoverMessage):je.hoverMessage?ue.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ae.map(je=>({range:O.from(je)}))}function De(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?g.URI.file(Ae):Ae}var $e;(function(Ae){function je(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?De(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=je})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var Q;(function(Ae){function je(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(Q||(e.ThemableDecorationRenderOptions=Q={}));var U;(function(Ae){function je(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=je})(U||(e.DecorationRangeBehavior=U={}));var se;(function(Ae){function je(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?U.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?Q.from(ve.light):void 0,dark:ve.dark?Q.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(se||(e.DecorationRenderOptions=se={}));var oe;(function(Ae){function je(ie){return{text:ie.newText,eol:ie.newEol&&Fe.from(ie.newEol),range:O.from(ie.range)}}Ae.from=je;function ve(ie){const Re=new v.$8M(O.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:Fe.to(ie.eol),Re}Ae.to=ve})(oe||(e.TextEdit=oe={}));var te;(function(Ae){function je(ie,Re){const He={edits:[]};if(ie instanceof v.$$M){const et=new T.$Cc;for(const Qe of ie._allEntries())Qe._type===v.FileEditType.File&&g.URI.isUri(Qe.to)&&Qe.from===void 0&&et.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===v.FileEditType.File){let gt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?gt={type:"base64",value:(0,h.$6e)(h.$Le.wrap(Qe.options.contents))}:gt={type:"dataTransferItem",id:Qe.options.contents._itemId}),He.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:gt},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?He.edits.push({resource:Qe.uri,textEdit:oe.from(Qe.edit),versionId:et.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?He.edits.push({resource:Qe.uri,textEdit:{range:O.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:et.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?He.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&He.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:S.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Ct.from)}})}return He}Ae.from=je;function ve(ie){const Re=new v.$$M,He=new T.$Bc;for(const et of ie.edits)if(et.textEdit){const Qe=et,gt=g.URI.revive(Qe.resource),At=O.to(Qe.textEdit.range),xt=Qe.textEdit.text,ci=Qe.textEdit.insertAsSnippet;let Bt;ci?Bt=v.$0M.replace(At,new v.$_M(xt)):Bt=v.$8M.replace(At,xt);const ri=He.get(gt);ri?ri.push(Bt):He.set(gt,[Bt])}else Re.renameFile(g.URI.revive(et.oldResource),g.URI.revive(et.newResource),et.options);for(const[et,Qe]of He)Re.set(et,Qe);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var le;(function(Ae){const je=Object.create(null);je[v.SymbolKind.File]=o.SymbolKind.File,je[v.SymbolKind.Module]=o.SymbolKind.Module,je[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[v.SymbolKind.Package]=o.SymbolKind.Package,je[v.SymbolKind.Class]=o.SymbolKind.Class,je[v.SymbolKind.Method]=o.SymbolKind.Method,je[v.SymbolKind.Property]=o.SymbolKind.Property,je[v.SymbolKind.Field]=o.SymbolKind.Field,je[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[v.SymbolKind.Enum]=o.SymbolKind.Enum,je[v.SymbolKind.Interface]=o.SymbolKind.Interface,je[v.SymbolKind.Function]=o.SymbolKind.Function,je[v.SymbolKind.Variable]=o.SymbolKind.Variable,je[v.SymbolKind.Constant]=o.SymbolKind.Constant,je[v.SymbolKind.String]=o.SymbolKind.String,je[v.SymbolKind.Number]=o.SymbolKind.Number,je[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[v.SymbolKind.Array]=o.SymbolKind.Array,je[v.SymbolKind.Object]=o.SymbolKind.Object,je[v.SymbolKind.Key]=o.SymbolKind.Key,je[v.SymbolKind.Null]=o.SymbolKind.Null,je[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[v.SymbolKind.Struct]=o.SymbolKind.Struct,je[v.SymbolKind.Event]=o.SymbolKind.Event,je[v.SymbolKind.Operator]=o.SymbolKind.Operator,je[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof je[Re]=="number"?je[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const He in je)if(je[He]===Re)return Number(He);return v.SymbolKind.Property}Ae.to=ie})(le||(e.SymbolKind=le={}));var he;(function(Ae){function je(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(he||(e.SymbolTag=he={}));var X;(function(Ae){function je(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(he.from),containerName:ie.containerName,location:We.from(ie.location)}}Ae.from=je;function ve(ie){const Re=new v.$hN(ie.name,le.to(ie.kind),ie.containerName,We.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(he.to),Re}Ae.to=ve})(X||(e.WorkspaceSymbol=X={}));var ae;(function(Ae){function je(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(he.from)??[]};return ie.children&&(Re.children=ie.children.map(je)),Re}Ae.from=je;function ve(ie){const Re=new v.$iN(ie.name,ie.detail,le.to(ie.kind),O.to(ie.range),O.to(ie.selectionRange));return(0,r.$Mb)(ie.tags)&&(Re.tags=ie.tags.map(he.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(ae||(e.DocumentSymbol=ae={}));var pe;(function(Ae){function je(ie){const Re=new v.$mN(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Ae){function je(ve){return new v.$nN(pe.to(ve.from),ve.fromRanges.map(ie=>O.to(ie)))}Ae.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Me;(function(Ae){function je(ve){return new v.$oN(pe.to(ve.to),ve.fromRanges.map(ie=>O.to(ie)))}Ae.to=je})(Me||(e.CallHierarchyOutgoingCall=Me={}));var We;(function(Ae){function je(ie){return{range:ie.range&&O.from(ie.range),uri:ie.uri}}Ae.from=je;function ve(ie){return new v.$aN(g.URI.revive(ie.uri),O.to(ie.range))}Ae.to=ve})(We||(e.location=We={}));var ke;(function(Ae){function je(ie){const Re=ie,He=ie;return{originSelectionRange:Re.originSelectionRange?O.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:He.uri,range:O.from(Re.targetRange?Re.targetRange:He.range),targetSelectionRange:Re.targetSelectionRange?O.from(Re.targetSelectionRange):void 0}}Ae.from=je;function ve(ie){return{targetUri:g.URI.revive(ie.uri),targetRange:O.to(ie.range),targetSelectionRange:ie.targetSelectionRange?O.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?O.to(ie.originSelectionRange):void 0}}Ae.to=ve})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Ae){function je(ie){return{range:O.from(ie.range),contents:ue.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=je;function ve(ie){const Re=ie.contents.map(ue.to),He=O.to(ie.range),et=ie.canIncreaseVerbosity,Qe=ie.canDecreaseVerbosity;return new v.$eN(Re,He,et,Qe)}Ae.to=ve})(Ie||(e.Hover=Ie={}));var Te;(function(Ae){function je(ie){return{range:O.from(ie.range),expression:ie.expression}}Ae.from=je;function ve(ie){return new v.$_N(O.to(ie.range),ie.expression)}Ae.to=ve})(Te||(e.EvaluatableExpression=Te={}));var V;(function(Ae){function je(ie){if(ie instanceof v.$aO)return{type:"text",range:O.from(ie.range),text:ie.text};if(ie instanceof v.$bO)return{type:"variable",range:O.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$cO)return{type:"expression",range:O.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=je;function ve(ie){switch(ie.type){case"text":return{range:O.to(ie.range),text:ie.text};case"variable":return{range:O.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:O.to(ie.range),expression:ie.expression}}}Ae.to=ve})(V||(e.InlineValue=V={}));var q;(function(Ae){function je(ie){return{frameId:ie.frameId,stoppedLocation:O.from(ie.stoppedLocation)}}Ae.from=je;function ve(ie){return new v.$dO(ie.frameId,O.to(ie.stoppedLocation))}Ae.to=ve})(q||(e.InlineValueContext=q={}));var Y;(function(Ae){function je(ie){return{range:O.from(ie.range),kind:ie.kind}}Ae.from=je;function ve(ie){return new v.$fN(O.to(ie.range),ie.kind)}Ae.to=ve})(Y||(e.DocumentHighlight=Y={}));var x;(function(Ae){function je(ie){return{uri:ie.uri,highlights:ie.highlights.map(Y.from)}}Ae.from=je;function ve(ie){return new v.$gN(g.URI.revive(ie.uri),ie.highlights.map(Y.to))}Ae.to=ve})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Ae){function je(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Ae){function je(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=je})(we||(e.CompletionContext=we={}));var Ne;(function(Ae){function je(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Ne||(e.CompletionItemTag=Ne={}));var Ge;(function(Ae){const je=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(He){return je.get(He)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(He){return ie.get(He)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Je;(function(Ae){function je(ve,ie){const Re=new v.$wN(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Ne.to),Re.detail=ve.detail,Re.documentation=L.$2k(ve.documentation)?ue.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,m.$Ft.isIRange(ve.range)?Re.range=O.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:O.to(ve.range.insert),replacing:O.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$_M(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$3M?new v.$8M(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(He=>oe.to(He))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=je})(Je||(e.CompletionItem=Je={}));var tt;(function(Ae){function je(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ue.fromStrict(ie.documentation)}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:L.$2k(ie.documentation)?ue.to(ie.documentation):ie.documentation}}Ae.to=ve})(tt||(e.ParameterInformation=tt={}));var rt;(function(Ae){function je(ie){return{label:ie.label,documentation:ue.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:L.$2k(ie.documentation)?ue.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function je(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=je;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function je(ve,ie){const Re=new v.$vN(B.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,ve)),ie.kind&&$t.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(oe.to),Re.tooltip=L.$2k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=je})(nt||(e.InlayHint=nt={}));var ct;(function(Ae){function je(ve,ie){const Re=new v.$uN(ie.label);return Re.tooltip=L.$2k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=We.to(ie.location)),Re}Ae.to=je})(ct||(e.InlayHintLabelPart=ct={}));var $t;(function(Ae){function je(ie){return ie}Ae.from=je;function ve(ie){return ie}Ae.to=ve})($t||(e.InlayHintKind=$t={}));var ht;(function(Ae){function je(ie){return{range:O.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=je;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?g.URI.parse(ie.url,!0):g.URI.revive(ie.url)}catch{}const He=new v.$BN(O.to(ie.range),Re);return He.tooltip=ie.tooltip,He}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var at;(function(Ae){function je(ie){const Re=new v.$EN(ie.label);return ie.textEdit&&(Re.textEdit=oe.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(He=>oe.to(He))),Re}Ae.to=je;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?oe.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>oe.from(Re)):void 0}}Ae.from=ve})(at||(e.ColorPresentation=at={}));var Pe;(function(Ae){function je(ie){return new v.$CN(ie[0],ie[1],ie[2],ie[3])}Ae.to=je;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Pe||(e.Color=Pe={}));var Be;(function(Ae){function je(ie){return{range:O.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$lN(O.to(ie.range))}Ae.to=ve})(Be||(e.SelectionRange=Be={}));var Ke;(function(Ae){function je(ve){switch(ve){case a.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case a.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case a.SaveReason.FOCUS_CHANGE:case a.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=je})(Ke||(e.TextDocumentSaveReason=Ke={}));var Oe;(function(Ae){function je(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}Ae.from=je;function ve(ie){switch(ie){case f.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var Fe;(function(Ae){function je(ie){if(ie===v.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return i.EndOfLineSequence.LF}Ae.from=je;function ve(ie){if(ie===i.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===i.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(Fe||(e.EndOfLine=Fe={}));var Z;(function(Ae){function je(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case v.ProgressLocation.Window:return s.ProgressLocation.Window;case v.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=je})(Z||(e.ProgressLocation=Z={}));var de;(function(Ae){function je(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=je;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(de||(e.FoldingRange=de={}));var Ce;(function(Ae){function je(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Fu.Comment;case v.FoldingRangeKind.Imports:return o.$Fu.Imports;case v.FoldingRangeKind.Region:return o.$Fu.Region}}Ae.from=je;function ve(ie){if(ie)switch(ie.value){case o.$Fu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Fu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Fu.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Xe;(function(Ae){function je(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?O.from(ve.selection):void 0,override:typeof ve.override=="boolean"?a.$MF.id:void 0}}Ae.from=je})(Xe||(e.TextEditorOpenOptions=Xe={}));var _e;(function(Ae){function je(He){return He instanceof v.$ZN?He.toJSON():typeof He=="string"?He:ve(He)||ie(He)?new v.$ZN(He.baseUri??He.base,He.pattern).toJSON():He}Ae.from=je;function ve(He){const et=He;return et?g.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ie(He){const et=He;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Re(He){return typeof He=="string"?He:new v.$ZN(g.URI.revive(He.baseUri),He.pattern)}Ae.to=Re})(_e||(e.GlobPattern=_e={}));var lt;(function(Ae){function je(ve){if(ve){if(Array.isArray(ve))return ve.map(je);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:_e.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=je})(lt||(e.LanguageSelector=lt={}));var ft;(function(Ae){function je(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(He=>He&&typeof He=="object"&&"uri"in He&&g.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(et=>et instanceof v.$3M)))}Ae.is=je;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(He=>({uri:g.URI.from(He.uri),version:He.version,ranges:He.ranges.map(et=>O.from(et))})))}}Ae.from=ve})(ft||(e.MappedEditsContext=ft={}));var kt;(function(Ae){function je(ie){return{start:ie.start,end:ie.end}}Ae.from=je;function ve(ie){return new v.$qO(ie.start,ie.end)}Ae.to=ve})(kt||(e.NotebookRange=kt={}));var Tt;(function(Ae){function je(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=je;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Tt||(e.NotebookCellExecutionSummary=Tt={}));var zt;(function(Ae){function je(ve){if(ve===S.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===S.NotebookCellExecutionState.Pending)return;if(ve===S.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=je})(zt||(e.NotebookCellExecutionState=zt={}));var ui;(function(Ae){function je(ie){switch(ie){case v.NotebookCellKind.Markup:return S.CellKind.Markup;case v.NotebookCellKind.Code:default:return S.CellKind.Code}}Ae.from=je;function ve(ie){switch(ie){case S.CellKind.Markup:return v.NotebookCellKind.Markup;case S.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(ui||(e.NotebookCellKind=ui={}));var it;(function(Ae){function je(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const He of ie.cells)v.$rO.validate(He),Re.cells.push(Ct.from(He));return Re}Ae.from=je;function ve(ie){const Re=new v.$sO(ie.cells.map(Ct.to));return(0,c.$pg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(it||(e.NotebookData=it={}));var Ct;(function(Ae){function je(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Tt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(mt.from):[]}}Ae.from=je;function ve(ie){return new v.$rO(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(mt.to):void 0,ie.metadata,ie.internalMetadata?Tt.to(ie.internalMetadata):void 0)}Ae.to=ve})(Ct||(e.NotebookCellData=Ct={}));var Kt;(function(Ae){function je(ie){return{mime:ie.mime,valueBytes:h.$Le.wrap(ie.data)}}Ae.from=je;function ve(ie){return new v.$tO(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Kt||(e.NotebookCellOutputItem=Kt={}));var mt;(function(Ae){function je(ie){return{outputId:ie.id,items:ie.items.map(Kt.from),metadata:ie.metadata}}Ae.from=je;function ve(ie){const Re=ie.items.map(Kt.to);return new v.$uO(Re,ie.outputId,ie.metadata)}Ae.to=ve})(mt||(e.NotebookCellOutput=mt={}));var bt;(function(Ae){function je(Re){return ie(Re)?{include:_e.from(Re.include)??void 0,exclude:_e.from(Re.exclude)??void 0}:_e.from(Re)??void 0}Ae.from=je;function ve(Re){return ie(Re)?{include:_e.to(Re.include),exclude:_e.to(Re.exclude)}:_e.to(Re)}Ae.to=ve;function ie(Re){const He=Re;return He?!(0,c.$lg)(He.include)&&!(0,c.$lg)(He.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?S.CellStatusbarAlignment.Left:S.CellStatusbarAlignment.Right,command:ie.toInternal(He,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=je})(hi||(e.NotebookStatusBarItem=hi={}));var ei;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(He,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=je})(ei||(e.NotebookKernelSourceAction=ei={}));var Ut;(function(Ae){function je(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=je})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var wt;(function(Ae){function je(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=je;function ve(ie){return new v.$wO(g.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(wt||(e.NotebookRendererScript=wt={}));var Vt;(function(Ae){function je(ie){return{message:ue.fromStrict(ie.message)||"",type:k.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:O.from(ie.location.range),uri:ie.location.uri}}}Ae.from=je;function ve(ie){const Re=new v.$CO(typeof ie.message=="string"?ie.message:ue.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?We.to(ie.location):void 0,Re}Ae.to=ve})(Vt||(e.TestMessage=Vt={}));var Yt;(function(Ae){Ae.namespace=k.$RI,Ae.denamespace=k.$SI})(Yt||(e.TestTag=Yt={}));var Xt;(function(Ae){function je(ie){const Re=(0,d.$oP)(ie).controllerId;return{extId:I.$MI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:g.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(He=>Yt.namespace(Re,He.id)),range:m.$Ft.lift(O.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ue.fromStrict(ie.error)||null}}Ae.from=je;function ve(ie){return{parent:void 0,error:void 0,id:I.$MI.fromString(ie.extId).localId,label:ie.label,uri:g.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:He}=Yt.denamespace(Re);return new v.$DO(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(Xt||(e.TestItem=Xt={})),function(Ae){function je(ie){return{id:ie.id}}Ae.from=je;function ve(ie){return new v.$DO(ie.id)}Ae.to=ve}(Yt||(e.TestTag=Yt={}));var xe;(function(Ae){const je=(ie,Re)=>{const He=ie.value;if(!He)return;const et={...Xt.toPlain(He.item),parent:Re,taskStates:He.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(gt=>gt.type===k.TestMessageType.Error).map(Vt.to)})),children:[]};if(ie.children)for(const Qe of ie.children.values()){const gt=je(Qe,et);gt&&et.children.push(gt)}return et};function ve(ie){const Re=new u.$LI;for(const Qe of ie.items)Re.insert(I.$MI.fromString(Qe.item.extId).path,Qe);const He=[Re.nodes],et=[];for(;He.length;)for(const Qe of He.pop())Qe.value?et.push(Qe):Qe.children&&He.push(Qe.children.values());return{completedAt:ie.completedAt,results:et.map(Qe=>je(Qe)).filter(c.$kg)}}Ae.to=ve})(xe||(e.TestResults=xe={}));var $i;(function(Ae){function je(He){return{covered:He.covered,total:He.total}}function ve(He){return"line"in He?B.from(He):O.from(He)}function ie(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:ve(He.location),type:k.DetailType.Statement,branches:He.branches.length?He.branches.map(et=>({count:et.executed,location:et.location&&ve(et.location),label:et.label})):void 0}:{type:k.DetailType.Declaration,name:He.name,count:He.executed,location:ve(He.location)}}Ae.fromDetails=ie;function Re(He,et,Qe){return v.$FO(Qe.statementCoverage),v.$FO(Qe.branchCoverage),v.$FO(Qe.declarationCoverage),{id:et,uri:Qe.uri,statement:je(Qe.statementCoverage),branch:Qe.branchCoverage&&je(Qe.branchCoverage),declaration:Qe.declarationCoverage&&je(Qe.declarationCoverage),testId:Qe instanceof v.$GO&&Qe.testItem?I.$MI.fromExtHostTestItem(Qe.testItem,He).toString():void 0}}Ae.fromFile=Re})($i||(e.TestCoverage=$i={}));var ti;(function(Ae){function je(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=je})(ti||(e.CodeActionTriggerKind=ti={}));var si;(function(Ae){function je(ie){const Re=new v.$KO(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),O.to(ie.range),O.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:O.from(ie.range),selectionRange:O.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(si||(e.TypeHierarchyItem=si={}));var Dt;(function(Ae){function je(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=je})(Dt||(e.ViewBadge=Dt={}));var Jt;(function(Ae){function je(He,et,Qe){const gt=et.fileData;return gt?new v.$RN(new v.$SN(gt.name,g.URI.revive(gt.uri),gt.id,(0,R.$eb)(()=>Qe(gt.id)))):He===C.$2s.uriList&&et.uriListData?new v.$QN(Re(et.uriListData)):new v.$QN(et.asString)}Ae.to=je;async function ve(He,et){const Qe=await et.asString();if(He===C.$2s.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const gt=et.asFile();return{asString:Qe,fileData:gt?{name:gt.name,uri:gt.uri,id:gt._itemId??gt.id}:void 0}}Ae.from=ve;function ie(He){return A.$ju.split(He).map(et=>{if(et.startsWith("#"))return et;try{return g.URI.parse(et)}catch{}return et})}function Re(He){return A.$ju.create(He.map(et=>typeof et=="string"?et:g.URI.revive(et)))}})(Jt||(e.DataTransferItem=Jt={}));var Lt;(function(Ae){function je(ie,Re){const He=ie.items.map(([et,Qe])=>[et,Jt.to(et,Qe,Re)]);return new v.$TN(He)}Ae.toDataTransfer=je;async function ve(ie){const Re={items:[]},He=[];for(const[et,Qe]of ie)He.push((async()=>{Re.items.push([et,await Jt.from(et,Qe)])})());return await Promise.all(He),Re}Ae.from=ve})(Lt||(e.DataTransfer=Lt={}));var Ft;(function(Ae){function je(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=je;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Ft||(e.ChatFollowup=Ft={}));var ii;(function(Ae){function je(ie){switch(ie){case y.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=je;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}Ae.from=ve})(ii||(e.LanguageModelChatMessageRole=ii={}));var ni;(function(Ae){function je(ie){let Re="",He;ie.content.type==="text"?Re=ie.content.value:He=new v.$_O(ie.content.name,ie.content.value,ie.content.isError);const et=ii.to(ie.role),Qe=new v.$aP(et,Re,ie.name);return He!==void 0&&(Qe.content2=He),Qe}Ae.to=je;function ve(ie){const Re=ii.from(ie.role),He=ie.name;let et;return ie.content2 instanceof v.$_O?et={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:et={type:"text",value:ie.content},{role:Re,name:He,content:et}}Ae.from=ve})(ni||(e.LanguageModelChatMessage=ni={}));var oi;(function(Ae){function je(ie){return{kind:"markdownContent",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$XO(ue.to(ie.content))}Ae.to=ve})(oi||(e.ChatResponseMarkdownPart=oi={}));var qt;(function(Ae){function je(ie){return{kind:"markdownVuln",content:ue.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=je;function ve(ie){return new v.$YO(ue.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=qt={}));var Qt;(function(Ae){function je(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=je;function ve(ie){return new v.$ZO(ie.agentId,ie.command)}Ae.to=ve})(Qt||(e.ChatResponseDetectedParticipantPart=Qt={}));var di;(function(Ae){function je(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=je})(di||(e.ChatResponseConfirmationPart=di={}));var jt;(function(Ae){function je(ie){const{value:Re,baseUri:He}=ie;function et(Qe,gt){return Qe.map(At=>{const xt=g.URI.joinPath(gt,At.name);return{label:At.name,uri:xt,children:At.children&&et(At.children,xt)}})}return{kind:"treeData",treeData:{label:(0,P.$ah)(He),uri:He,children:et(Re,He)}}}Ae.from=je;function ve(ie){const Re=(0,l.$_h)(ie.treeData);function He(gt){return gt.map(At=>({name:At.label,children:At.children&&He(At.children)}))}const et=Re.uri,Qe=Re.children?He(Re.children):[];return new v.$2O(Qe,et)}Ae.to=ve})(jt||(e.ChatResponseFilesPart=jt={}));var vt;(function(Ae){function je(ie){const Re=He=>g.URI.isUri(He);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:F.from(ie.value)}}Ae.from=je;function ve(ie){const Re=(0,l.$_h)(ie);return new v.$3O(g.URI.isUri(Re.inlineReference)?Re.inlineReference:F.to(Re.inlineReference),ie.name)}Ae.to=ve})(vt||(e.ChatResponseAnchorPart=vt={}));var Pt;(function(Ae){function je(ie){return{kind:"progressMessage",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$4O(ie.content.value)}Ae.to=ve})(Pt||(e.ChatResponseProgressPart=Pt={}));var Ot;(function(Ae){function je(ie){return{kind:"warning",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$6O(ie.content.value)}Ae.to=ve})(Ot||(e.ChatResponseWarningPart=Ot={}));var It;(function(Ae){function je(ve){return{kind:"progressTask",content:ue.from(ve.value)}}Ae.from=je})(It||(e.ChatTask=It={}));var Zt;(function(Ae){function je(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?ue.from(ve):void 0}}Ae.from=je})(Zt||(e.ChatTaskResult=Zt={}));var Ht;(function(Ae){function je(ie,Re,He){return{kind:"command",command:Re.toInternal(ie.value,He)??{command:ie.value.command,title:ie.value.title}}}Ae.from=je;function ve(ie,Re){return new v.$7O(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var pi;(function(Ae){function je(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>oe.from(Re))}}Ae.from=je;function ve(ie){return new v.$9O(g.URI.revive(ie.uri),ie.edits.map(Re=>oe.to(Re)))}Ae.to=ve})(pi||(e.ChatResponseTextEditPart=pi={}));var fi;(function(Ae){function je(ie){const Re=p.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:g.URI.isUri(ie.iconPath)?{light:g.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&g.URI.isUri(ie.iconPath.light)&&g.URI.isUri(ie.iconPath.dark)?{light:g.URI.revive(ie.iconPath.light),dark:g.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:g.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:F.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:g.URI.isUri(ie.value)?ie.value:F.from(ie.value),iconPath:Re}}Ae.from=je;function ve(ie){const Re=(0,l.$_h)(ie),He=et=>g.URI.isUri(et)?et:F.to(et);return new v.$8O("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&He(Re.reference.value)}:He(Re.reference))}Ae.to=ve})(fi||(e.ChatResponseReferencePart=fi={}));var Ai;(function(Ae){function je(Re,He,et){return Re instanceof v.$XO?oi.from(Re):Re instanceof v.$3O?vt.from(Re):Re instanceof v.$8O?fi.from(Re):Re instanceof v.$4O?Pt.from(Re):Re instanceof v.$2O?jt.from(Re):Re instanceof v.$7O?Ht.from(Re,He,et):Re instanceof v.$9O?pi.from(Re):Re instanceof v.$YO?qt.from(Re):Re instanceof v.$ZO?Qt.from(Re):Re instanceof v.$6O?Ot.from(Re):{kind:"markdownContent",content:ue.from("")}}Ae.from=je;function ve(Re,He){switch(Re.kind){case"reference":return fi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,He)}}Ae.to=ve;function ie(Re,He){switch(Re.kind){case"markdownContent":return oi.to(Re);case"inlineReference":return vt.to(Re);case"progressMessage":return;case"treeData":return jt.to(Re);case"command":return Ht.to(Re,He)}}Ae.toContent=ie})(Ai||(e.ChatResponsePart=Ai={}));var Nt;(function(Ae){function je(ve){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:Ti.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData}}Ae.to=je})(Nt||(e.ChatAgentRequest=Nt={}));var Ti;(function(Ae){function je(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=je;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ae.from=ve})(Ti||(e.ChatLocation=Ti={}));var ai;(function(Ae){function je(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,g.$wc)(ie)?g.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,g.$wc)(ie.uri)?F.to((0,l.$_h)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=je})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(Ae){function je(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=je})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Si;(function(Ae){function je(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=je})(Si||(e.ChatAgentResult=Si={}));var Di;(function(Ae){function je(ve,ie,Re){if(ie.action.kind==="vote")return;const He=Si.to(ve);if(ie.action.kind==="command"){const et=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(et)??{command:et.id,title:et.title}}},result:He}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(ie.action.followup)},result:He}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:He}:{action:ie.action,result:He}}Ae.to=je})(Di||(e.ChatAgentUserActionEvent=Di={}));var vi;(function(Ae){function je(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=je})(vi||(e.TerminalQuickFix=vi={}));var Oi;(function(Ae){function je(ve){return{kind:gi.to(ve.kind)}}Ae.to=je})(Oi||(e.PartialAcceptInfo=Oi={}));var gi;(function(Ae){function je(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=je})(gi||(e.PartialAcceptTriggerKind=gi={}));var Gt;(function(Ae){function je(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=je})(Gt||(e.DebugTreeItem=Gt={}))}),define(Ee[345],Se([1,0,6,20,17,51]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;let L=class{constructor($,l){this.a=$.getProxy(r.$YM.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,l,C){const E=new R.$Nw(A.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,C?.isRefactoring??!1)}};e.$knc=L,e.$knc=L=Ye([qe(0,h.$sP)],L)}),define(Ee[346],Se([1,0,19,9,55,4,40,3,43,18,2,24,6,17,10,307,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0,P=Ue(P),p=Ue(p);class f{constructor(i,t,s,d,a){this.j=i,this.k=t,this.l=s,this.m=d,this.n=a,this.b=$.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(d){if(i.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,d),a}};const i=this;this.b.reset();const s=(d,a)=>{if(typeof this.d>"u"&&"content"in d&&(this.d=this.b.elapsed()),a){const w=this.l.$handleProgressChunk(this.k.requestId,d),y={report:D=>{w?.then(S=>{S&&(p.$qN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseWarningPart.from(D),S):this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseReferencePart.from(D),S))})}};Promise.all([w,a?.(y)]).then(([D,S])=>{D!==void 0&&S!==void 0&&this.l.$handleProgressChunk(this.k.requestId,P.ChatTaskResult.from(S),D)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){t(this.markdown);const a=new p.$XO(d),w=P.ChatResponseMarkdownPart.from(a);return s(w),this},markdownWithVulnerabilities(d,a){t(this.markdown),a&&(0,g.$2G)(i.j,"chatParticipantAdditions");const w=new p.$YO(d,a),y=P.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return s(y),this},filetree(d,a){t(this.filetree);const w=new p.$2O(d,a),y=P.ChatResponseFilesPart.from(w);return s(y),this},anchor(d,a){t(this.anchor);const w=new p.$3O(d,a),y=P.ChatResponseAnchorPart.from(w);return s(y),this},button(d){t(this.anchor);const a=new p.$7O(d),w=P.ChatResponseCommandButtonPart.from(a,i.m,i.n);return s(w),this},progress(d,a){t(this.progress);const w=new p.$5O(d,a),y=a?P.ChatTask.from(w):P.ChatResponseProgressPart.from(w);return s(y,a),this},warning(d){t(this.progress),(0,g.$2G)(i.j,"chatParticipantAdditions");const a=new p.$6O(d),w=P.ChatResponseWarningPart.from(a);return s(w),this},reference(d,a){if(t(this.reference),"variableName"in d&&(0,g.$2G)(i.j,"chatParticipantAdditions"),"variableName"in d&&!d.value){const w=i.k.variables.variables.find(y=>y.name===d.variableName);if(w){let y;if(w.references?.length)y=w.references.map(D=>({kind:"reference",reference:{variableName:d.variableName,value:D.reference}}));else{const D=new p.$8O(d,a);y=[P.ChatResponseReferencePart.from(D)]}return y.forEach(D=>s(D)),this}}else{const w=new p.$8O(d,a),y=P.ChatResponseReferencePart.from(w);s(y)}return this},textEdit(d,a){t(this.textEdit),(0,g.$2G)(i.j,"chatParticipantAdditions");const w=new p.$9O(d,a),y=P.ChatResponseTextEditPart.from(w);return s(y),this},detectedParticipant(d,a){t(this.detectedParticipant),(0,g.$2G)(i.j,"chatParticipantAdditions");const w=new p.$ZO(d,a),y=P.ChatResponseDetectedParticipantPart.from(w);return s(y),this},confirmation(d,a,w){t(this.confirmation),(0,g.$2G)(i.j,"chatParticipantAdditions");const y=new p.$1O(d,a,w),D=P.ChatResponseConfirmationPart.from(y);return s(D),this},push(d){if(t(this.push),(d instanceof p.$9O||d instanceof p.$YO||d instanceof p.$ZO||d instanceof p.$6O||d instanceof p.$1O)&&(0,g.$2G)(i.j,"chatParticipantAdditions"),d instanceof p.$8O)this.reference(d.value,d.iconPath);else{const a=P.ChatResponsePart.from(d,i.m,i.n);s(a)}return this}}}return this.g}}class m extends T.$Vc{static{this.b=0}constructor(i,t,s,d){super(),this.n=t,this.s=s,this.t=d,this.c=new Map,this.j=this.B(new T.$5c),this.m=this.B(new T.$5c),this.g=i.getProxy(u.$YM.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,s){const d=m.b++,a=new n(i,this.t,t,this.g,d,s);return this.c.set(d,a),a.isAgentEnabled()&&this.g.$registerAgent(d,i.identifier,t,{},void 0),a.apiAgent}createDynamicChatAgent(i,t,s,d){const a=m.b++,w=new n(i,this.t,t,this.g,a,d);return this.c.set(a,w),this.g.$registerAgent(a,i.identifier,t,{isSticky:!0},s),w.apiAgent}async $invokeAgent(i,t,s,d){const a=this.c.get(i);if(!a)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new T.$Uc,this.j.set(t.sessionId,w));const y=new f(a.extension,t,this.g,this.s.converter,w);try{const D=await this.u(t.agentId,s),S=a.invoke(P.ChatAgentRequest.to(t),{history:D},y.apiObject,d);return await(0,h.$qh)(Promise.resolve(S).then(I=>{if(I?.metadata)try{JSON.stringify(I.metadata)}catch(b){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${b.message}`;return this.n.error(`[${a.extension.identifier.value}] [@${a.id}] ${v}`,a.extension),{errorDetails:{message:v},timings:y.timings}}let k;return I?.errorDetails&&(k={...I.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,g.$2G)(a.extension,"chatParticipantPrivate"),{errorDetails:k,timings:y.timings,metadata:I?.metadata}}),d)}catch(D){return this.n.error(D,a.extension),D instanceof p.$gP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,A.$nj)(D),responseIsIncomplete:!0}}}finally{y.close()}}async u(i,t){const s=[];for(const d of t.history){const a=P.ChatAgentResult.to(d.result),w=i===d.request.agentId?a:{...a,metadata:void 0};s.push(new p.$0O(d.request.message,d.request.command,d.request.variables.variables.map(P.ChatAgentValueReference.to),d.request.agentId));const y=(0,r.$Ib)(d.response.map(D=>P.ChatResponsePart.toContent(D,this.s.converter)));s.push(new p.$$O(y,w,d.request.agentId,d.request.command))}return s}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,s,d,a){const w=this.c.get(t);if(!w)return Promise.resolve([]);const y=await this.u(w.id,d),D=P.ChatAgentResult.to(s);return(await w.provideFollowups(D,{history:y},a)).filter(S=>{const I=!S.participant||L.Iterable.some(this.c.values(),k=>k.id===S.participant&&E.$nn.equals(k.extension.identifier,w.extension.identifier));return I||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),I}).map(S=>P.ChatFollowup.from(S,i))}$acceptFeedback(i,t,s,d){const a=this.c.get(i);if(!a)return;const w=P.ChatAgentResult.to(t);let y;switch(s){case c.ChatAgentVoteDirection.Down:y=p.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:y=p.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(d?{result:w,kind:y,reportIssue:d}:{result:w,kind:y}))}$acceptAction(i,t,s){const d=this.c.get(i);if(!d||s.action.kind==="vote")return;const a=P.ChatAgentUserActionEvent.to(t,s,this.s.converter);a&&d.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(i,t,s){const d=this.c.get(i);if(!d)return[];let a=this.m.get(i);return a?a.clear():(a=new T.$Uc,this.m.set(i,a)),(await d.invokeCompletionProvider(t,s)).map(y=>P.ChatAgentCompletionItem.from(y,this.s.converter,a))}async $provideWelcomeMessage(i,t,s){const d=this.c.get(i);if(d)return await d.provideWelcomeMessage(P.ChatLocation.to(t),s)}async $provideSampleQuestions(i,t,s){const d=this.c.get(i);if(d)return(await d.provideSampleQuestions(P.ChatLocation.to(t),s)).map(a=>P.ChatFollowup.from(a,void 0))}}e.$lnc=m;class n{constructor(i,t,s,d,a,w){this.extension=i,this.w=t,this.id=s,this.x=d,this.y=a,this.z=w,this.m=new R.$je,this.n=new R.$je}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,g.$1G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,s){if(!this.b)return[];const d=await this.b.provideFollowups(i,t,s);return d?d.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(i,t);return s?s.map(d=>typeof d=="string"?d:P.MarkdownString.from(d)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(i,t);return s||[]}get apiAgent(){let i=!1,t=!1;const s=()=>{i||t||(t=!0,queueMicrotask(()=>{d.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof C.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof p.$XN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:P.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:P.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:P.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(a){d.c=a,s()},get requestHandler(){return d.z},set requestHandler(a){(0,l.$mg)(typeof a=="function","Invalid request handler"),d.z=a},get followupProvider(){return d.b},set followupProvider(a){d.b=a,s()},get isDefault(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.d},set isDefault(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.d=a,s()},get helpTextPrefix(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.g},set helpTextPrefix(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.g=a,s()},get helpTextVariablesPrefix(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.j},set helpTextVariablesPrefix(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.j=a,s()},get helpTextPostfix(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.k},set helpTextPostfix(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.k=a,s()},get isSecondary(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.l},set isSecondary(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.l=a,s()},get supportIssueReporting(){return(0,g.$2G)(d.extension,"chatParticipantPrivate"),d.o},set supportIssueReporting(a){(0,g.$2G)(d.extension,"chatParticipantPrivate"),d.o=a,s()},get onDidReceiveFeedback(){return d.m.event},set participantVariableProvider(a){if((0,g.$2G)(d.extension,"chatParticipantAdditions"),d.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");d.x.$registerAgentCompletionsProvider(d.y,d.id,a.triggerCharacters)}else d.x.$unregisterAgentCompletionsProvider(d.y,d.id)},get participantVariableProvider(){return(0,g.$2G)(d.extension,"chatParticipantAdditions"),d.q},set welcomeMessageProvider(a){(0,g.$2G)(d.extension,"defaultChatParticipant"),d.s=a,s()},get welcomeMessageProvider(){return(0,g.$2G)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,g.$1G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(a){d.t=a,s()},get requester(){return d.t},set supportsSlowReferences(a){(0,g.$2G)(d.extension,"chatParticipantPrivate"),d.u=a,s()},get supportsSlowReferences(){return(0,g.$2G)(d.extension,"chatParticipantPrivate"),d.u},dispose(){i=!0,d.b=void 0,d.m.dispose(),d.x.$unregisterAgent(d.y)}}}invoke(i,t,s,d){return this.z(i,t,s,d)}}}),define(Ee[347],Se([1,0,14,3,50,6,17,10,26]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0,L=Ue(L),T=Ue(T);class l{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$YM.MainThreadChatVariables)}async $resolveVariable(u,P,p,c){const g=this.b.get(u);if(g)try{if(g.resolver.resolve2){(0,$.$2G)(g.extension,"chatParticipantAdditions");const f=new C(P,this.c),m=await g.resolver.resolve2(g.data.name,{prompt:p},f.apiObject,c);if(m&&m[0])return m[0].value}else{const f=await g.resolver.resolve(g.data.name,{prompt:p},c);if(f&&f[0])return f[0].value}}catch(f){(0,r.$3)(f)}}registerVariableResolver(u,P,p,c,g,f,m,n,o){const i=l.a++,t=o?A.ThemeIcon.fromId(o):void 0;return this.b.set(i,{extension:u,data:{id:P,name:p,description:c,modelDescription:g,icon:t},resolver:m}),this.c.$registerVariable(i,{id:P,name:p,description:c,modelDescription:g,isSlow:f,fullName:n,icon:t}),(0,h.$Tc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$mnc=l;class C{constructor(u,P){this.c=u,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(c){if(u.a){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,c),g}};const u=this,p=c=>{this.d.$handleProgressChunk(this.c,c)};this.b={progress(c){P(this.progress);const g=new T.$4O(c),f=L.ChatResponseProgressPart.from(g);return p(f),this},reference(c){P(this.reference);const g=new T.$8O(c),f=L.ChatResponseReferencePart.from(g);return p(f),this},push(c){return P(this.push),c instanceof T.$8O?p(L.ChatResponseReferencePart.from(c)):c instanceof T.$4O&&p(L.ChatResponseProgressPart.from(c)),this}}}return this.b}}}),define(Ee[348],Se([1,0,9,59,4,3,41,2,88,24,17,10,6,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=p,$=Ue($),C=Ue(C),E=Ue(E);function p(c,g,f){const m=c.getProxy(u.$YM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new l.$pn,g.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===L.MarshalledId.CommentController){const I=this.b.get(S.handle);return I?I.value:S}else if(S&&S.$mid===L.MarshalledId.CommentThread){const I=S,k=this.b.get(I.commentControlHandle);if(!k)return I;const b=k.getCommentThread(I.commentThreadHandle);return b?b.value:I}else if(S&&(S.$mid===L.MarshalledId.CommentThreadReply||S.$mid===L.MarshalledId.CommentThreadInstance)){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const k=I.getCommentThread(S.thread.commentThreadHandle);return k?S.$mid===L.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:S.text}:S}else if(S&&S.$mid===L.MarshalledId.CommentNode){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const k=I.getCommentThread(S.thread.commentThreadHandle);if(!k)return S;const b=S.commentUniqueId,v=k.getCommentByUniqueId(b);return v||S}else if(S&&S.$mid===L.MarshalledId.CommentThreadNode){const I=this.b.get(S.thread.commentControlHandle);if(!I)return S;const k=I.getCommentThread(S.thread.commentThreadHandle);if(!k)return S;const b=S.text,v=S.commentUniqueId,N=k.getCommentByUniqueId(v);return N?(typeof N.body=="string"?N.body=b:N.body=new E.$qN(b),N):S}return S}})}createCommentController(S,I,k){const b=n.a++,v=new i(S,b,I,k);this.b.set(v.handle,v);const N=this.c.get(S.identifier)||[];return N.push(v),this.c.set(S.identifier,N),v.value}async $createCommentThreadTemplate(S,I,k,b){const v=this.b.get(S);v&&v.$createCommentThreadTemplate(I,k,b)}async $setActiveComment(S,I){const k=this.b.get(S);k&&k.$setActiveComment(I??void 0)}async $updateCommentThreadTemplate(S,I,k){const b=this.b.get(S);b&&b.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(S,I){this.b.get(S)?.$deleteCommentThread(I)}async $provideCommentingRanges(S,I,k){const b=this.b.get(S);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const v=await f.ensureDocumentData(T.URI.revive(I));return(0,r.$uh)(async()=>{const N=await b.commentingRangeProvider.provideCommentingRanges(v.document,k);let O;return Array.isArray(N)?O={ranges:N,fileComments:!1}:N?O={ranges:N.ranges||[],fileComments:N.fileComments||!1}:O=N??void 0,O}).then(N=>{let O;return N&&(O={ranges:N.ranges.map(F=>C.Range.from(F)),fileComments:N.fileComments}),O})}$toggleReaction(S,I,k,b,v){const N=this.b.get(S);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.$uh)(()=>{const O=N.getCommentThread(I);if(O){const F=O.getCommentByUniqueId(b.uniqueIdInThread);if(N!==void 0&&F&&N.reactionHandler)return N.reactionHandler(F,d(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(S){this.n=S}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(S){(S===void 0!=(this.p===void 0)||!S||!this.p||!S.isEqual(this.p))&&(this.p=S,this.b.range=S,this.c.fire())}get range(){return this.p}set canReply(S){this.d!==S&&(this.d=S,this.b.canReply=S,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(S){this.e=S,this.b.label=S,this.c.fire()}get contextValue(){return this.f}set contextValue(S){this.f=S,this.b.contextValue=S,this.c.fire()}get comments(){return this.q}set comments(S){this.q=S,this.b.comments=S,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(S){this.g=S,this.b.collapsibleState=S,this.c.fire()}get state(){return this.h}set state(S){this.h=S,typeof S=="object"?((0,P.$2G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=S.resolved,this.b.applicability=S.applicability):this.b.state=S,this.c.fire()}get isDisposed(){return this.j}constructor(S,I,k,b,v,N,O,F,j){this.m=I,this.n=k,this.o=b,this.p=v,this.q=N,this.extensionDescription=O,this.r=F,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Wc,this.l.value=new R.$Uc,this.n===void 0&&(this.n=`${S}.${this.handle}`),m.$createCommentThread(I,this.handle,this.n,this.o,C.Range.from(this.p),O.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{m.$deleteCommentThread(I,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(M){B.range=M},get comments(){return B.comments},set comments(M){B.comments=M},get collapsibleState(){return B.collapsibleState},set collapsibleState(M){B.collapsibleState=M},get canReply(){return B.canReply},set canReply(M){B.canReply=M},get contextValue(){return B.contextValue},set contextValue(M){B.contextValue=M},get label(){return B.label},set label(M){B.label=M},get state(){return B.state},set state(M){B.state=M},reveal:M=>B.reveal(M),dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Uc);const S=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};S("range")&&(I.range=C.Range.from(this.p)),S("label")&&(I.label=this.label),S("contextValue")&&(I.contextValue=this.contextValue??null),S("comments")&&(I.comments=this.q.map(k=>t(this,k,this.k,this.extensionDescription))),S("collapsibleState")&&(I.collapseState=a(this.g)),S("canReply")&&(I.canReply=this.canReply),S("state")&&(I.state=w(this.h)),S("applicability")&&(I.applicability=y(this.h)),S("isTemplate")&&(I.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(S){for(const I of this.k){const k=I[0],b=I[1];if(S===b)return k}}async reveal(S){return(0,P.$2G)(this.extensionDescription,"commentReveal"),m.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...S})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(S=>S.dispose())}}Ye([(0,h.$8h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(S){this.b=S,S?.resourceHints&&(0,P.$2G)(this.h,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,S?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(S){this.c=S,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!S})}get options(){return this.d}set options(S){this.d=S,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$2G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$2G)(this.h,"activeComment"),this.f}constructor(S,I,k,b){this.h=S,this.i=I,this.j=k,this.k=b,this.a=new Map,m.$registerCommentController(this.handle,k,b,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(N){v.options=N},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(N){v.commentingRangeProvider=N},get reactionHandler(){return v.reactionHandler},set reactionHandler(N){v.reactionHandler=N},get activeCommentThread(){return v.activeCommentThread},createCommentThread(N,O,F){return v.createCommentThread(N,O,F).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(S,I,k){I===void 0&&(0,P.$2G)(this.h,"fileComments");const b=new o(this.id,this.handle,void 0,S,I,k,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(S){if(!S){this.e=void 0,this.f=void 0;return}const I=this.a.get(S.commentThreadHandle);I&&(this.e=S.uniqueIdInThread?I.getCommentByUniqueId(S.uniqueIdInThread):void 0,this.f=I)}$createCommentThreadTemplate(S,I,k){const b=new o(this.id,this.handle,void 0,T.URI.revive(S),C.Range.to(I),[],this.h,!0,k);return b.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(b.handle,b),b}$updateCommentThreadTemplate(S,I){const k=this.a.get(S);k&&(k.range=C.Range.to(I))}$deleteCommentThread(S){this.a.get(S)?.dispose(),this.a.delete(S)}getCommentThread(S){return this.a.get(S)}dispose(){this.a.forEach(S=>{S.dispose()}),this.g.forEach(S=>S.dispose())}}function t(D,S,I,k){let b=I.get(S);return b||(b=++D.commentHandle,I.set(S,b)),S.state!==void 0&&(0,P.$2G)(k,"commentsDraftState"),S.reactions?.some(v=>v.reactors!==void 0)&&(0,P.$2G)(k,"commentReactor"),{mode:S.mode,contextValue:S.contextValue,uniqueIdInThread:b,body:typeof S.body=="string"?S.body:C.MarkdownString.from(S.body),userName:S.author.name,userIconPath:S.author.iconPath,label:S.label,commentReactions:S.reactions?S.reactions.map(v=>s(v)):void 0,state:S.state,timestamp:S.timestamp?.toJSON()}}function s(D){return{label:D.label,iconPath:D.iconPath?C.$rP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(S=>S.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(S=>({name:S}))}}function a(D){if(D!==void 0)switch(D){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(D){let S;if(typeof D=="object"?S=D.resolved:S=D,S!==void 0)switch(S){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function y(D){let S;if(typeof D=="object"&&(S=D.applicability),S!==void 0)switch(S){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Ee[349],Se([1,0,21,60,3,15,23,2,17,97,119,6,10]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0,$=Ue($),E=Ue(E),u=Ue(u);class P{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new C.$9mc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=i(this.document.uri)+this.a++;return(0,L.$dh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class p{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,a){const w=this.b(s,d.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const y=new P(d,a);return this.a.set(w,y),y}delete(s,d){const a=this.b(s,d.uri);this.a.delete(a)}b(s,d){return`${s}@@@${d}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(s,d,a){return this.b(s,{type:c.Text,extension:d,provider:a})}addCustomProvider(s,d,a){return this.b(s,{type:c.Custom,extension:d,provider:a})}get(s){return this.a.get(s)}b(s,d){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,d),new u.$1M(()=>this.a.delete(s))}}class f{constructor(s,d,a,w,y){this.d=d,this.f=a,this.g=w,this.h=y,this.b=new g,this.c=new p,this.a=s.getProxy(E.$YM.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,a,w){const y=new A.$Uc;return n(a)?(y.add(this.b.addTextProvider(d,s,a)),this.a.$registerTextEditorProvider((0,l.$Fnc)(s),d,w.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,l.$Dnc)(s))):(y.add(this.b.addCustomProvider(d,s,a)),m(a)&&y.add(a.onDidChangeCustomDocument(D=>{const S=this.i(d,D.document.uri);if(o(D)){const I=S.addEdit(D);this.a.$onDidEdit(D.document.uri,d,I,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,l.$Fnc)(s),d,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,l.$Dnc)(s))),u.$1M.from(y,new u.$1M(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,a,w,y){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==c.Custom)throw new Error(`Invalid provide type for '${d}'`);const S=T.URI.revive(s),I=await D.provider.openCustomDocument(S,{backupId:a,untitledDocumentData:w?.buffer},y);let k;return m(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,I,k),{editable:m(D.provider)}}async $disposeCustomDocument(s,d){const a=this.b.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(a.type!==c.Custom)throw new Error(`Invalid provider type for '${d}'`);const w=T.URI.revive(s),{document:y}=this.i(d,w);this.c.delete(d,y),y.dispose()}async $resolveCustomEditor(s,d,a,w,y,D){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);const I=$.ViewColumn.to(y),k=this.g.createNewWebview(d,w.contentOptions,S.extension),b=this.h.createNewWebviewPanel(d,a,w.title,I,w.options,k,w.active),v=T.URI.revive(s);switch(S.type){case c.Custom:{const{document:N}=this.i(a,v);return S.provider.resolveCustomEditor(N,b,D)}case c.Text:{const N=this.d.getDocument(v);return S.provider.resolveCustomTextEditor(N,b,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,a){this.i(d,s).disposeEdits(a)}async $onMoveCustomEditor(s,d,a){const w=this.b.get(a);if(!w)throw new Error(`No provider found for '${a}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const y=this.h.getWebviewPanel(s);if(!y)throw new Error("No webview found");const D=T.URI.revive(d),S=this.d.getDocument(D);await w.provider.moveCustomTextEditor(S,y,r.CancellationToken.None)}async $undo(s,d,a,w){return this.i(d,s).undo(a,w)}async $redo(s,d,a,w){return this.i(d,s).redo(a,w)}async $revert(s,d,a){const w=this.i(d,s);await this.j(d).revertCustomDocument(w.document,a),w.disposeBackup()}async $onSave(s,d,a){const w=this.i(d,s);await this.j(d).saveCustomDocument(w.document,a),w.disposeBackup()}async $onSaveAs(s,d,a,w){const y=this.i(d,s);return this.j(d).saveCustomDocumentAs(y.document,T.URI.revive(a),w)}async $backup(s,d,a){const w=this.i(d,s),D=await this.j(d).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},a);return w.updateBackup(D),D.id}i(s,d){const a=this.c.get(s,T.URI.revive(d));if(!a)throw new Error("No custom document found");return a}j(s){const a=this.b.get(s)?.provider;if(!a||!m(a))throw new Error("Custom document is not editable");return a}}e.$Inc=f;function m(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,h.$qj)(s)+""}}),define(Ee[350],Se([1,0,233,145,2,6,10,17,4,12,29,63]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0,T=Ue(T);class P{#e;#t;#i;constructor(g,f,m,n,o,i,t,s){this.d=g,this.e=f,this.f=m,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,m),this.#i=new C.$Bc(d=>i.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,f){if(!g){this.clear();return}this.j();let m=[];if(A.URI.isUri(g)){if(!f){this.delete(g);return}this.#i.set(g,f.slice()),m=[g]}else if(Array.isArray(g)){m=[];let i;g=[...g].sort(P.k);for(const t of g){const[s,d]=t;if((!i||s.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=s,m.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const a=this.#i.get(s);a&&(a.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let o=0;for(const i of m){let t=[];const s=this.#i.get(i);if(s)if(s.length>this.g){t=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const w of s)if(w.severity===d[a]&&t.push({...T.Diagnostic.from(w),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...T.Diagnostic.from(d),modelVersionId:this.h(i)}));if(n.push([i,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,f){this.j();for(const[m,n]of this)g.call(f,m,n,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const f=this.#i.get(g);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,f){return g[0].toString()<f[0].toString()?-1:g[0].toString()>f[0].toString()?1:0}}e.$dnc=P;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(g){const f=new C.$Bc;for(const m of g)f.set(m,m);return{uris:Object.freeze(Array.from(f.values()))}}constructor(g,f,m,n){this.j=f,this.k=m,this.l=n,this.g=new Map,this.h=new $.$ne({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=g.getProxy(R.$YM.MainThreadDiagnostics)}createDiagnosticCollection(g,f){const{g:m,f:n,h:o,j:i,k:t,l:s}=this,d=new class{$changeMany(y,D){n.$changeMany(y,D),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,y,D.length===0?"CLEARING":D)}$clear(y){n.$clear(y),i.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,y)}dispose(){n.dispose()}};let a;if(!f)f="_generated_diagnostic_collection_name_#"+u.c++,a=f;else if(!m.has(f))a=f;else{this.j.warn(`DiagnosticCollection with name '${f}' does already exist.`);do a=f+u.c++;while(m.has(a))}return new class extends P{constructor(){super(f,a,u.e,u.d,y=>s.getDocument(y)?.version,t.extUri,d,o),m.set(a,this)}dispose(){super.dispose(),m.delete(a)}}}getDiagnostics(g){if(g)return this.m(g);{const f=new Map,m=[];for(const n of this.g.values())n.forEach((o,i)=>{let t=f.get(o.toString());typeof t>"u"&&(t=m.length,f.set(o.toString(),t),m.push([o,[]])),m[t][1]=m[t][1].concat(...i)});return m}}m(g){let f=[];for(const m of this.g.values())m.has(g)&&(f=f.concat(m.get(g)));return f}$acceptMarkersChange(g){if(!this.n){const f="_generated_mirror",m=new P(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(f,m),this.n=m}for(const[f,m]of g)this.n.set(A.URI.revive(f),m.map(T.Diagnostic.to))}};e.$enc=p,e.$enc=p=u=Ye([qe(1,l.$9j),qe(2,E.$cnc)],p)}),define(Ee[351],Se([1,0,2,14,10,17,81,51]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class ${constructor(C,E,u,P={timeout:1500,errors:3}){this.c=C,this.d=E,this.f=u,this.g=P,this.a=new L.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(E,u,P)=>{const c={dispose:this.a.push([E,u,C])};return Array.isArray(P)&&P.push(c),c}}async $participateInSave(C,E){const u=r.URI.revive(C);let P=!1;const p=setTimeout(()=>P=!0,this.g.timeout),c=[];try{for(const g of[...this.a]){if(P)break;const f=this.d.getDocument(u),m=await this.h(g,{document:f,reason:R.TextDocumentSaveReason.to(E)});c.push(m)}}finally{clearTimeout(p)}return c}h([C,E,u],P){const p=this.b.get(C);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(u,C,E,P).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this.b.get(C);this.b.set(C,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,E,u,P){const p=[],c=Date.now(),{document:g,reason:f}=P,{version:m}=g,n=Object.freeze({document:g,reason:f,waitUntil(o){if(Object.isFrozen(p))throw(0,h.$9)("waitUntil can not be called async");p.push(Promise.resolve(o))}});try{E.apply(u,[n])}catch(o){return Promise.reject(o)}return Object.freeze(p),new Promise((o,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(p).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(t),o(s)}).catch(s=>{clearTimeout(t),i(s)})}).then(o=>{const i={edits:[]};for(const t of o)if(Array.isArray(t)&&t.every(s=>s instanceof A.$8M))for(const{newText:s,newEol:d,range:a}of t)i.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:s,eol:d&&R.EndOfLine.from(d)}});if(i.edits.length!==0)return m===g.version?this.f.$tryApplyWorkspaceEdit(new T.$Nw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$roc=$}),define(Ee[352],Se([1,0,4,3,2,6,163,17,18,25,10]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0,T=Ue(T);class E{constructor(P,p){this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Uc,this.h=new Map,this.f=P.getProxy(R.$YM.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const p=this.g.getDocument(P);if(p)return p}getDocument(P){const p=this.getDocumentData(P);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return p.document}ensureDocumentData(P){const p=this.g.getDocument(P);if(p)return Promise.resolve(p);let c=this.h.get(P.toString());return c||(c=this.f.$tryOpenDocument(P).then(g=>{this.h.delete(P.toString());const f=A.URI.revive(g);return(0,$.$ng)(this.g.getDocument(f))},g=>(this.h.delete(P.toString()),Promise.reject(g))),this.h.set(P.toString(),c)),c}createDocumentData(P){return this.f.$tryCreateDocument(P).then(p=>A.URI.revive(p))}$acceptModelLanguageChanged(P,p){const c=A.URI.revive(P),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(p),this.a.fire(g.document)}$acceptModelSaved(P){const p=A.URI.revive(P),c=this.g.getDocument(p);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(P,p){const c=A.URI.revive(P),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(p),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,p,c){const g=A.URI.revive(P),f=this.g.getDocument(g);if(!f)throw new Error("unknown document");f._acceptIsDirty(c),f.onEvents(p);let m;p.isUndoing?m=C.TextDocumentChangeReason.Undo:p.isRedoing&&(m=C.TextDocumentChangeReason.Redo),this.c.fire((0,l.$ao)({document:f.document,contentChanges:p.changes.map(n=>({range:T.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(P,p){(0,L.$uP)(P,p)}}e.$fnc=E}),define(Ee[78],Se([1,0,79,4,18,2,5,6,20,17,10]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=e.$Jnc=void 0,l=Ue(l),e.$Jnc=(0,L.$Ci)("IExtHostEditorTabs");class E{constructor(g,f,m){this.e=m,this.d=f,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new C.$LO(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new C.$MO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new C.$NO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new C.$OO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new C.$PO(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new C.$QO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new C.$RO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new C.$SO;case T.TabInputKind.InteractiveEditorInput:return new C.$TO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new C.$UO;case T.TabInputKind.MultiDiffEditorInput:return new C.$VO(this.b.input.diffEditors.map(g=>new C.$MO(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class u{constructor(g,f){this.c=[],this.d="",this.b=g,this.e=f;for(const m of g.tabs)m.isActive&&(this.d=m.id),this.c.push(new E(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,f={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return l.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(m=>m.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(m=>m.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===T.TabModelOperationKind.TAB_OPEN){const m=new E(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,m),g.tabDto.isActive&&(this.d=m.tabId),m}else if(g.kind===T.TabModelOperationKind.TAB_CLOSE){const m=this.c.splice(g.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(g.kind===T.TabModelOperationKind.TAB_MOVE){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(g.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,m),m}const f=this.c.find(m=>m.tabId===g.tabDto.id);if(!f)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(g.tabDto),f}activeTabId(){return this.d}}let P=class{constructor(g){this.b=new h.$je,this.c=new h.$je,this.e=[],this.a=g.getProxy(T.$YM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,f={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(m=>m.apiObject))},get activeTabGroup(){const m=g.d;return(0,A.$ng)(g.e.find(o=>o.groupId===m)?.apiObject)},close:async(m,n)=>{const o=Array.isArray(m)?m:[m];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(g){const f=new Set(this.e.map(d=>d.groupId)),m=new Set(g.map(d=>d.groupId)),n=(0,r.$L)(f,m),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),i=[],t=[];this.e=g.map(d=>{const a=new u(d,()=>this.d);return n.added.includes(a.groupId)?i.push(a.apiObject):t.push(a.apiObject),a});const s=(0,A.$ng)(g.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:i,closed:o,changed:t}))}$acceptTabGroupUpdate(g){const f=this.e.find(m=>m.groupId===g.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const f=this.e.find(n=>n.groupId===g.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const m=f.acceptTabOperation(g);switch(g.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(g){for(const f of this.e)for(const m of f.tabs)if(m.apiObject===g)return m}h(g){return this.e.find(f=>f.apiObject===g)}async i(g,f){const m=[];for(const n of g){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");m.push(o.tabId)}return this.a.$closeTab(m,f)}async j(g,f){const m=[];for(const n of g){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");m.push(o.groupId)}return this.a.$closeGroup(m,f)}};e.$Knc=P,e.$Knc=P=Ye([qe(0,$.$sP)],P);function p(c){return c.tabs!==void 0}}),define(Ee[353],Se([1,0,2,6,28,3,10,17,194,13,27,22,26,86]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0,A=Ue(A),T=Ue(T);class p{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const m=this.a.indexOf(f);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),m=[];let n,o,i=$.State.LastKnownState,t=$.State.LastKnownState;for(const s of f){let d=n?(0,l.$Ff)(n,s):0;for(d===0?o=$.State.Start:o=t;d<s.length;d++)d+1===s.length?(i=t,t=$.State.BeforeColon):t+=1,m.push([o,s.toUpperCase().charCodeAt(d),t]),m.push([o,s.toLowerCase().charCodeAt(d),t]),o=t;n=s,t=i}m.push([$.State.BeforeColon,C.CharCode.Colon,$.State.AfterColon]),m.push([$.State.AfterColon,C.CharCode.Slash,$.State.End]),this.b=new $.$D3(m)}}provideDocumentLinks(f){this.c();const m=[],n=$.$E3.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this.b);for(const o of n){const i=T.DocumentLink.to(o);i.target&&m.push(i)}return m}}class c{constructor(f,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(h.$YM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,m,n,o={}){if(c.j(n),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,n);let t=A.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(t+=A.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(t+=A.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$2G)(f,"fsChunks"),t+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,P.$2k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,t,s).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${m}`),console.error(a)});const d=n.onDidChangeFile(a=>{const w=[];for(const y of a){const{uri:D,type:S}=y;if(D.scheme!==m)continue;let I;switch(S){case L.FileChangeType.Changed:I=A.FileChangeType.UPDATED;break;case L.FileChangeType.Created:I=A.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:I=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:D,type:I})}this.a.$onFileSystemChange(i,w)});return(0,R.$Tc)(()=>{d.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:m,ctime:n,mtime:o,size:i,permissions:t}=f;return{type:m,ctime:n,mtime:o,size:i,permissions:t}}$stat(f,m){return Promise.resolve(this.l(f).stat(r.URI.revive(m))).then(n=>c.k(n))}$readdir(f,m){return Promise.resolve(this.l(f).readDirectory(r.URI.revive(m)))}$readFile(f,m){return Promise.resolve(this.l(f).readFile(r.URI.revive(m))).then(n=>E.$Le.wrap(n))}$writeFile(f,m,n,o){return Promise.resolve(this.l(f).writeFile(r.URI.revive(m),n.buffer,o))}$delete(f,m,n){return Promise.resolve(this.l(f).delete(r.URI.revive(m),n))}$rename(f,m,n,o){return Promise.resolve(this.l(f).rename(r.URI.revive(m),r.URI.revive(n),o))}$copy(f,m,n,o){const i=this.l(f);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(m),r.URI.revive(n),o))}$mkdir(f,m){return Promise.resolve(this.l(f).createDirectory(r.URI.revive(m)))}$watch(f,m,n,o){const i=this.l(f).watch(r.URI.revive(n),o);this.f.set(m,i)}$unwatch(f,m){const n=this.f.get(m);n&&(n.dispose(),this.f.delete(m))}$open(f,m,n){const o=this.l(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(m),n))}$close(f,m){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(f,m,n,o){const i=this.l(f);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=E.$Le.alloc(o);return Promise.resolve(i.read(m,n,t.buffer,0,o)).then(s=>t.slice(0,s))}$write(f,m,n,o){const i=this.l(f);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,n,o.buffer,0,o.byteLength))}l(f){const m=this.c.get(f);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.$uoc=c}),define(Ee[354],Se([1,0,4,39,2,6,17,10,28,49]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0,L=Ue(L);class C{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,c,g,f,m,n){this.a=Math.random(),this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$wk)(m),i=typeof m=="string",t=n?.correlate,s=f(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(t&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const a of d.created){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const a of d.changed){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const a of d.deleted){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=T.$1M.from(this.i(p,g,m,n,n?.correlate),this.b,this.c,this.d,s)}i(p,c,g,f,m){const n=T.$1M.from();if(typeof g=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const o=p.getProxy(R.$YM.MainThreadFileSystemEventService);let i=!1;(g.pattern.includes(h.$sk)||g.pattern.includes(h.$tk))&&(i=!0);let t;return m&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(t=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,f?.ignoreChangeEvents&&(t&=~$.FileChangeFilter.UPDATED),f?.ignoreCreateEvents&&(t&=~$.FileChangeFilter.ADDED),f?.ignoreDeleteEvents&&(t&=~$.FileChangeFilter.DELETED)),o.$watch(c.identifier.value,this.a,g.baseUri,{recursive:i,excludes:f?.excludes??[],filter:t},!!m),T.$1M.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(p){this.a=p,this.session=this.a.session,this.b=new l.$W(()=>this.a.created.map(A.URI.revive)),this.c=new l.$W(()=>this.a.changed.map(A.URI.revive)),this.d=new l.$W(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(p,c,g){this.j=p,this.k=c,this.l=g,this.a=new r.$je,this.b=new r.$je,this.c=new r.$je,this.d=new r.$je,this.g=new r.$le,this.h=new r.$le,this.i=new r.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,c,g,f){return new C(this.j,p,c,this.a.event,L.GlobPattern.from(g),f)}$onFileEvent(p){this.a.fire(new E(p))}$onDidRunFileOperation(p,c){switch(p){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:c.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,c){return(g,f,m)=>{const n=function(i){g.call(f,i)};return n.extension=p,c.event(n,void 0,m)}}async $onWillRunFileOperation(p,c,g,f){switch(p){case $.FileOperation.MOVE:return await this.n(this.g,{files:c.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))},g,f);case $.FileOperation.DELETE:return await this.n(this.i,{files:c.map(m=>A.URI.revive(m.target))},g,f);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:c.map(m=>A.URI.revive(m.target))},g,f)}}async n(p,c,g,f){const m=new Set,n=[];if(await p.fireAsync(c,f,async(i,t)=>{const s=Date.now(),d=await Promise.resolve(i);d instanceof T.$$M&&(n.push([t.extension,d]),m.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-s>g&&this.k.warn("SLOW file-participant",t.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,i]of n){const{edits:t}=L.WorkspaceEdit.from(i,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(t)}return{edit:o,extensionNames:Array.from(m)}}}e.$voc=u}),define(Ee[355],Se([1,0,19,9,21,14,133,3,25,43,13,18,2,31,190,88,143,235,24,17,10,26,119,6]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0,c=Ue(c),n=Ue(n),s=Ue(s);class d{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const Y=this.d.getDocument(V),x=await this.e.provideDocumentSymbols(Y,q);if(!(0,r.$Lb)(x))return x[0]instanceof o.$iN?x.map(n.DocumentSymbol.from):d.f(x)}static f(V){V=V.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const q=[],Y=[];for(const x of V){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(Y.length===0){Y.push(fe),q.push(fe);break}const we=Y[Y.length-1];if(P.$Ft.containsRange(we.range,fe.range)&&!P.$Ft.equalsRange(we.range,fe.range)){we.children?.push(fe),Y.push(fe);break}Y.pop()}}return q}}class a{constructor(V,q,Y,x,fe,we){this.f=V,this.g=q,this.h=Y,this.j=x,this.k=fe,this.l=we,this.d=new t.$9mc("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const Y=this.f.getDocument(V),x=await this.h.provideCodeLenses(Y,q);if(!x||q.isCancellationRequested)return;const fe=this.d.add(x),we=new T.$Uc;this.e.set(fe,we);const Ne={cacheId:fe,lenses:[]};for(let Ge=0;Ge<x.length;Ge++)Ne.lenses.push({cacheId:[fe,Ge],range:n.Range.from(x[Ge].range),command:this.g.toInternal(x[Ge].command,we)});return Ne}async resolveCodeLens(V,q){const Y=V.cacheId&&this.d.get(...V.cacheId);if(!Y)return;let x;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?x=Y:x=await this.h.resolveCodeLens(Y,q),x||(x=Y),q.isCancellationRequested)return;const fe=V.cacheId&&this.e.get(V.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(x.command,fe),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function w(Te){return Array.isArray(Te)?Te.map(n.DefinitionLink.from):Te?[n.DefinitionLink.from(Te)]:[]}class y{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDefinition(x,fe,Y);return w(we)}}class D{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDeclaration(x,fe,Y);return w(we)}}class S{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideImplementation(x,fe,Y);return w(we)}}class I{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideTypeDefinition(x,fe,Y);return w(we)}}class k{static{this.f=10}constructor(V,q){this.g=V,this.h=q,this.d=0,this.e=new Map}async provideHover(V,q,Y,x){const fe=this.g.getDocument(V),we=n.Position.to(q);let Ne;if(Y&&Y.verbosityRequest){const rt=Y.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:Y.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this.h.provideHover(fe,we,x,nt)}else Ne=await this.h.provideHover(fe,we,x);if(!Ne||(0,r.$Lb)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(we)),Ne.range||(Ne.range=new o.$3M(we,we));const Ge=n.Hover.from(Ne),Je=this.d;if(this.e.size===k.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Je,Ne),this.d+=1,{...Ge,id:Je}}releaseHover(V){this.e.delete(V)}}class b{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideEvaluatableExpression(x,fe,Y);if(we)return n.EvaluatableExpression.from(we)}}class v{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,Y,x){const fe=this.d.getDocument(V),we=await this.e.provideInlineValues(fe,n.Range.to(q),n.InlineValueContext.to(Y),x);if(Array.isArray(we))return we.map(Ne=>n.InlineValue.from(Ne))}}class N{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideDocumentHighlights(x,fe,Y);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class O{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,Y,x){const fe=this.d.getDocument(V),we=Y.map(Je=>this.d.getDocument(Je)),Ne=n.Position.to(q),Ge=await this.e.provideMultiDocumentHighlights(fe,Ne,we,x);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class F{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,Y){const x=this.d.getDocument(V),fe=n.Position.to(q),we=await this.e.provideLinkedEditingRanges(x,fe,Y);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Ib)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,Y,x){const fe=this.d.getDocument(V),we=n.Position.to(q),Ne=await this.e.provideReferences(fe,we,Y,x);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class B{static{this.d=1e3}constructor(V,q,Y,x,fe,we,Ne){this.g=V,this.h=q,this.j=Y,this.k=x,this.l=fe,this.m=we,this.n=Ne,this.e=new t.$9mc("CodeAction"),this.f=new Map}async provideCodeActions(V,q,Y,x){const fe=this.g.getDocument(V),we=p.$Ht.isISelection(q)?n.Selection.to(q):n.Range.to(q),Ne=[];for(const nt of this.j.getDiagnostics(V))if(we.intersection(nt.range)&&Ne.push(nt)>B.d)break;const Ge={diagnostics:Ne,only:Y.only?new o.$kN(Y.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Y.trigger)},Je=await this.k.provideCodeActions(fe,we,Ge,x);if(!(0,r.$Mb)(Je)||x.isCancellationRequested)return;const tt=this.e.add(Je),rt=new T.$Uc;this.f.set(tt,rt);const ot=[];for(let nt=0;nt<Je.length;nt++){const ct=Je[nt];if(ct)if(B.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{Ge.only&&(ct.kind?Ge.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value} 'requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=ct.ranges??[];ot.push({cacheId:[tt,nt],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(n.Diagnostic.from),edit:ct.edit&&n.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,i.$1G)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,i.$1G)(this.m,"codeActionRanges")?(0,r.$Ib)($t.map(n.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(V,q){const[Y,x]=V,fe=this.e.get(Y,x);if(!fe||B.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,q)??fe;let Ne;we.edit&&(Ne=n.WorkspaceEdit.from(we.edit,void 0));let Ge;if(we.command){const Je=this.f.get(Y);Je&&(Ge=this.h.toInternal(we.command,Je))}return{edit:Ne,command:Ge}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class M{constructor(V,q,Y,x,fe){this.e=V,this.f=q,this.g=Y,this.h=x,this.j=fe,this.d=new t.$9mc("DocumentPasteEdit")}async prepareDocumentPaste(V,q,Y,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(V),we=q.map(Je=>n.Range.to(Je)),Ne=n.DataTransfer.toDataTransfer(Y,()=>{throw new R.$_});if(await this.g.prepareDocumentPaste(fe,we,Ne,x),x.isCancellationRequested)return;const Ge=Array.from(Ne).filter(([,Je])=>!(Je instanceof o.$QN));return n.DataTransfer.from(Ge)}async providePasteEdits(V,q,Y,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(q),Ge=Y.map(ot=>n.Range.to(ot)),Je=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolvePasteFileData(this.h,V,ot)).buffer),tt=await this.g.provideDocumentPasteEdits(Ne,Ge,Je,{only:fe.only?new o.$VN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[Y,x]=V,fe=this.d.get(Y,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class W{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,Y){const x=this.d.getDocument(V),fe=await this.e.provideDocumentFormattingEdits(x,q,Y);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class _{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,Y,x){const fe=this.d.getDocument(V),we=n.Range.to(q),Ne=await this.e.provideDocumentRangeFormattingEdits(fe,we,Y,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,Y,x){(0,E.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(V),we=q.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(fe,we,Y,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class re{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,Y,x,fe){const we=this.d.getDocument(V),Ne=n.Position.to(q),Ge=await this.e.provideOnTypeFormattingEdits(we,Ne,Y,x,fe);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class z{constructor(V,q){this.e=V,this.f=q,this.d=new t.$9mc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const Y=await this.e.provideWorkspaceSymbols(V,q);if(!(0,r.$Mb)(Y))return{symbols:[]};const x=this.d.add(Y),fe={cacheId:x,symbols:[]};for(let we=0;we<Y.length;we++){const Ne=Y[we];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Y=this.d.get(...V.cacheId);if(Y){const x=await this.e.resolveWorkspaceSymbol(Y,q);return x&&(0,$.$co)(V,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class G{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,Y){this.d=V,this.e=q,this.f=Y}async provideRenameEdits(V,q,Y,x){const fe=this.d.getDocument(V),we=n.Position.to(q);try{const Ne=await this.e.provideRenameEdits(fe,we,Y,x);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ge=G.g(Ne);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(V,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(V),fe=n.Position.to(q);try{const we=await this.e.prepareRename(x,fe,Y);let Ne,Ge;if(o.$3M.isRange(we)?(Ne=we,Ge=x.getText(we)):(0,E.$eg)(we)&&(Ne=we.range,Ge=we.placeholder),!Ne||!Ge)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ge}}catch(we){const Ne=G.g(we);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class J{static{this.d={[c.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[c.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(V,q,Y){this.e=V,this.f=q,this.g=Y}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,q,Y,x){const fe=this.e.getDocument(V),we=n.Range.to(q);try{const Ne=J.d[Y],Ge=await this.f.provideNewSymbolNames(fe,we,Ne,x);return Ge?Ge.map(Je=>typeof Je=="string"?{newSymbolName:Je}:{newSymbolName:Je.newSymbolName,tags:Je.tags}):void 0}catch(Ne){this.g.error(J.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ee{constructor(V,q){this.resultId=V,this.tokens=q}}class ue{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,Y){const x=this.f.getDocument(V),fe=q!==0?this.d.get(q):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,Y):await this.g.provideDocumentSemanticTokens(x,Y);return fe&&this.d.delete(q),we?(we=ue.h(we),this.o(ue.n(fe,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ue.j(V)?ue.k(V)?V:new o.$jO(new Uint32Array(V.data),V.resultId):ue.l(V)?ue.m(V)?V:new o.$lO(V.edits.map(q=>new o.$kO(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!ue.j(q)||!V||!V.tokens)return q;const Y=V.tokens,x=Y.length,fe=q.data,we=fe.length;let Ne=0;const Ge=Math.min(x,we);for(;Ne<Ge&&Y[Ne]===fe[Ne];)Ne++;if(Ne===x&&Ne===we)return new o.$lO([],q.resultId);let Je=0;const tt=Ge-Ne;for(;Je<tt&&Y[x-Je-1]===fe[we-Je-1];)Je++;return new o.$lO([{start:Ne,deleteCount:x-Ne-Je,data:fe.subarray(Ne,we-Je)}],q.resultId)}o(V,q){if(ue.j(V)){const Y=this.e++;return this.d.set(Y,new ee(V.resultId,V.data)),(0,g.$Ecb)({id:Y,type:"full",data:V.data})}if(ue.l(V)){const Y=this.e++;return ue.j(q)?this.d.set(Y,new ee(q.resultId,q.data)):this.d.set(Y,new ee(V.resultId)),(0,g.$Ecb)({id:Y,type:"delta",deltas:(V.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,Y){const x=this.d.getDocument(V),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(q),Y);return fe?this.f(fe):null}f(V){return(0,g.$Ecb)({id:0,type:"full",data:V.data})}}class De{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,Y,x,fe){this.f=V,this.g=q,this.h=Y,this.j=x,this.k=fe,this.d=new t.$9mc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,Y,x){const fe=this.f.getDocument(V),we=n.Position.to(q),Ne=fe.getWordRangeAtPosition(we)||new o.$3M(we,we),Ge=Ne.with({end:we}),Je=new l.$de,tt=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(Y));if(!tt||x.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.$xN(tt):tt,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new T.$Uc;this.e.set(ot,nt);const ct=[],$t={x:ot,[s.ISuggestResultDtoField.completions]:ct,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ne),insert:n.Range.from(Ge)},[s.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Je.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const at=rt.items[ht],Pe=this.l(at,[ot,ht],Ge,Ne);ct.push(Pe)}return $t}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...V);if(!Y)return;const x=this.l(Y,V),fe=await this.h.resolveCompletionItem(Y,q);if(!fe)return;const we=this.l(fe,V);return(x[s.ISuggestDataDtoField.insertText]!==we[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==we[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==we[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==we[s.ISuggestDataDtoField.commandId]||!(0,$.$do)(x[s.ISuggestDataDtoField.commandArguments],we[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:we[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:we[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:we[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:we[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:we[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:we[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:we[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:we[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,Y,x){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,fe),Ne={x:q,[s.ISuggestDataDtoField.label]:V.label,[s.ISuggestDataDtoField.kind]:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:V.tags&&V.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:V.detail,[s.ISuggestDataDtoField.documentation]:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),[s.ISuggestDataDtoField.sortText]:V.sortText!==V.label?V.sortText:void 0,[s.ISuggestDataDtoField.filterText]:V.filterText!==V.label?V.filterText:void 0,[s.ISuggestDataDtoField.preselect]:V.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:V.keepWhitespace?c.CompletionItemInsertTextRule.KeepWhitespace:c.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:V.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:we?.$ident,[s.ISuggestDataDtoField.commandId]:we?.id,[s.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[s.ISuggestDataDtoField.insertText]=V.textEdit.newText):typeof V.insertText=="string"?Ne[s.ISuggestDataDtoField.insertText]=V.insertText:V.insertText instanceof o.$_M&&(Ne[s.ISuggestDataDtoField.insertText]=V.insertText.value,Ne[s.ISuggestDataDtoField.insertTextRules]|=c.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return V.textEdit?Ge=V.textEdit.range:V.range&&(Ge=V.range),o.$3M.isRange(Ge)?Ne[s.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!Y?.isEqual(Ge.inserting)||!x?.isEqual(Ge.replacing))&&(Ne[s.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Ne}}class $e{async provideInlineCompletions(V,q,Y,x){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,Y){}handlePartialAccept(V,q,Y,x){}}class Q extends $e{constructor(V,q,Y,x){super(),this.f=V,this.g=q,this.h=Y,this.j=x,this.d=new se,this.e=(0,i.$1G)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$1G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,Y,x){const fe=this.g.getDocument(V),we=n.Position.to(q),Ne=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},x);if(!Ne||x.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Je=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,ct)=>{let $t;nt.command&&(rt||(rt=new T.$Uc),$t=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:$t,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Je.map(nt=>(rt||(rt=new T.$Uc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,Y){const x=this.d.get(V)?.items[q];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,Y)}handlePartialAccept(V,q,Y,x){const fe=this.d.get(V)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Y),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class U{async provideInlineEdits(V,q,Y){const x=this.f.getDocument(V),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[q.triggerKind]},Y);if(!fe||Y.isCancellationRequested)return;let we;const Ne=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ge;fe.accepted&&(we||(we=new T.$Uc),Ge=this.h.toInternal(fe.accepted,we));let Je;return fe.rejected&&(we||(we=new T.$Uc),Je=this.h.toInternal(fe.rejected,we)),{pid:Ne,text:fe.text,range:n.Range.from(fe.range),accepted:Ge,rejected:Je}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,Y,x){this.f=q,this.g=Y,this.h=x,this.d=new se,this.e={[c.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class oe{constructor(V,q){this.e=V,this.f=q,this.d=new t.$9mc("SignatureHelp")}async provideSignatureHelp(V,q,Y,x){const fe=this.e.getDocument(V),we=n.Position.to(q),Ne=this.g(Y),Ge=await this.f.provideSignatureHelp(fe,we,x,Ne);if(Ge){const Je=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Je}}}g(V){let q;if(V.activeSignatureHelp){const Y=n.SignatureHelp.to(V.activeSignatureHelp),x=this.d.get(V.activeSignatureHelp.id,0);x?(q=x,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class te{constructor(V,q,Y,x,fe){this.f=V,this.g=q,this.h=Y,this.j=x,this.k=fe,this.d=new t.$9mc("InlayHints"),this.e=new Map}async provideInlayHints(V,q,Y){const x=this.f.getDocument(V),fe=n.Range.to(q),we=await this.h.provideInlayHints(x,fe,Y);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Y.isCancellationRequested)return;const Ne=this.d.add(we);this.e.set(Ne,new T.$Uc);const Ge={hints:[],cacheId:Ne};for(let Je=0;Je<we.length;Je++)this.l(we[Je],fe)&&Ge.hints.push(this.m(we[Je],[Ne,Je]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Ge}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...V);if(!Y)return;const x=await this.h.resolveInlayHint(Y,q);if(x&&this.l(x))return this.m(x,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const x={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")x.label=V.label;else{const fe=[];x.label=fe;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};o.$aN.isLocation(we.location)&&(Ne.location=n.location.from(we.location)),we.command&&(Ne.command=this.g.toInternal(we.command,Y)),fe.push(Ne)}}return x}}class le{constructor(V,q){this.e=V,this.f=q,this.d=new t.$9mc("DocumentLink")}async provideLinks(V,q){const Y=this.e.getDocument(V),x=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(x)||x.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Ne=0;Ne<x.length;Ne++){if(!le.g(x[Ne]))continue;const Ge=n.DocumentLink.from(x[Ne]);Ge.cacheId=[fe,Ne],we.links.push(Ge)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...V);if(!Y)return;const x=await this.f.resolveDocumentLink(Y,q);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(V){this.d.delete(V)}}class he{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const Y=this.d.getDocument(V),x=await this.e.provideDocumentColors(Y,q);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(V,q,Y){const x=this.d.getDocument(V),fe=n.Range.to(q.range),we=n.Color.to(q.color),Ne=await this.e.provideColorPresentations(we,{document:x,range:fe},Y);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class X{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,Y){const x=this.d.getDocument(V),fe=await this.e.provideFoldingRanges(x,q,Y);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ae{constructor(V,q,Y){this.d=V,this.e=q,this.f=Y}async provideSelectionRanges(V,q,Y){const x=this.d.getDocument(V),fe=q.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,Y);if(!(0,r.$Mb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ge=0;Ge<fe.length;Ge++){const Je=[];Ne.push(Je);let tt=fe[Ge],rt=we[Ge];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Je.push(n.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Ne}}class pe{constructor(V,q){this.f=V,this.g=q,this.d=new L.$xP(""),this.e=new Map}async prepareSession(V,q,Y){const x=this.f.getDocument(V),fe=n.Position.to(q),we=await this.g.prepareCallHierarchy(x,fe,Y);if(!we)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(we)?we.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,we)]}async provideCallsTo(V,q,Y){const x=this.j(V,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,Y);if(fe)return fe.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(V,q,Y){const x=this.j(V,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,Y);if(fe)return fe.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(V){this.e.delete(V)}h(V,q){const Y=this.e.get(V),x=n.CallHierarchyItem.from(q,V,Y.size.toString(36));return Y.set(x._itemId,q),x}j(V,q){return this.e.get(V)?.get(q)}}class be{constructor(V,q){this.f=V,this.g=q,this.d=new L.$xP(""),this.e=new Map}async prepareSession(V,q,Y){const x=this.f.getDocument(V),fe=n.Position.to(q),we=await this.g.prepareTypeHierarchy(x,fe,Y);if(!we)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(we)?we.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,we)]}async provideSupertypes(V,q,Y){const x=this.j(V,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,Y);if(fe)return fe.map(we=>this.h(V,we))}async provideSubtypes(V,q,Y){const x=this.j(V,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,Y);if(fe)return fe.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,q){const Y=this.e.get(V),x=n.TypeHierarchyItem.from(q,V,Y.size.toString(36));return Y.set(x._itemId,q),x}j(V,q){return this.e.get(V)?.get(q)}}class Me{constructor(V,q,Y,x,fe){this.e=V,this.f=q,this.g=Y,this.h=x,this.j=fe,this.d=new t.$9mc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,q,Y,x,fe){const we=this.f.getDocument(q),Ne=n.Position.to(Y),Ge=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,ot)).buffer),Je=await this.g.provideDocumentDropEdits(we,Ne,Ge,fe);if(!Je)return;const tt=(0,r.$3b)(Je),rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,f.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,q){const[Y,x]=V,fe=this.d.get(Y,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class We{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,Y,x){const fe=u.URI.revive(V),we=this.d.getDocument(fe),Ne=Y.documents.map(tt=>tt.map(rt=>({uri:u.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ge={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Je=await this.e.provideMappedEdits(we,q,Ge,x);return Je?n.WorkspaceEdit.from(Je):null}}class ke{constructor(V,q){this.adapter=V,this.extension=q}}class Ie{static{this.d=0}constructor(V,q,Y,x,fe,we,Ne,Ge){this.g=q,this.h=Y,this.j=x,this.k=fe,this.l=we,this.m=Ne,this.n=Ge,this.f=new Map,this.e=V.getProxy(s.$YM.MainThreadLanguageFeatures)}o(V,q){return n.DocumentSelector.from(V,this.g,q)}p(V){return new o.$1M(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ie.d++}async s(V,q,Y,x,fe,we=!1){const Ne=this.f.get(V);if(!Ne||!(Ne.adapter instanceof q))return x;const Ge=Date.now();we||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Je=Y(Ne.adapter,Ne.extension);return Promise.resolve(Je).catch(tt=>{(0,R.$5)(tt)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Ne.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),A.CancellationToken.isCancellationToken(fe)?(0,h.$rh)(Je,fe):Je}t(V,q){const Y=this.q();return this.f.set(Y,new ke(V,q)),Y}static u(V){return V.displayName||V.name}static w(V){return V.identifier.value}registerDocumentSymbolProvider(V,q,Y,x){const fe=this.t(new d(this.h,Y),V),we=x&&x.label||Ie.u(V);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,V),we),this.p(fe)}$provideDocumentSymbols(V,q,Y){return this.s(V,d,x=>x.provideDocumentSymbols(u.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(V,q,Y){const x=this.q(),fe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new a(this.h,this.j.converter,Y,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(x,this.o(q,V),fe);let we=this.p(x);if(fe!==void 0){const Ne=Y.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(fe));we=o.$1M.from(we,Ne)}return we}$provideCodeLenses(V,q,Y){return this.s(V,a,x=>x.provideCodeLenses(u.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(V,q,Y){return this.s(V,a,x=>x.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,a,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,Y){const x=this.t(new y(this.h,Y),V);return this.e.$registerDefinitionSupport(x,this.o(q,V)),this.p(x)}$provideDefinition(V,q,Y,x){return this.s(V,y,fe=>fe.provideDefinition(u.URI.revive(q),Y,x),[],x)}registerDeclarationProvider(V,q,Y){const x=this.t(new D(this.h,Y),V);return this.e.$registerDeclarationSupport(x,this.o(q,V)),this.p(x)}$provideDeclaration(V,q,Y,x){return this.s(V,D,fe=>fe.provideDeclaration(u.URI.revive(q),Y,x),[],x)}registerImplementationProvider(V,q,Y){const x=this.t(new S(this.h,Y),V);return this.e.$registerImplementationSupport(x,this.o(q,V)),this.p(x)}$provideImplementation(V,q,Y,x){return this.s(V,S,fe=>fe.provideImplementation(u.URI.revive(q),Y,x),[],x)}registerTypeDefinitionProvider(V,q,Y){const x=this.t(new I(this.h,Y),V);return this.e.$registerTypeDefinitionSupport(x,this.o(q,V)),this.p(x)}$provideTypeDefinition(V,q,Y,x){return this.s(V,I,fe=>fe.provideTypeDefinition(u.URI.revive(q),Y,x),[],x)}registerHoverProvider(V,q,Y,x){const fe=this.t(new k(this.h,Y),V);return this.e.$registerHoverProvider(fe,this.o(q,V)),this.p(fe)}$provideHover(V,q,Y,x,fe){return this.s(V,k,we=>we.provideHover(u.URI.revive(q),Y,x,fe),void 0,fe)}$releaseHover(V,q){this.s(V,k,Y=>Promise.resolve(Y.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(V,q,Y,x){const fe=this.t(new b(this.h,Y),V);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,V)),this.p(fe)}$provideEvaluatableExpression(V,q,Y,x){return this.s(V,b,fe=>fe.provideEvaluatableExpression(u.URI.revive(q),Y,x),void 0,x)}registerInlineValuesProvider(V,q,Y,x){const fe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new v(this.h,Y),V);this.e.$registerInlineValuesProvider(we,this.o(q,V),fe);let Ne=this.p(we);if(fe!==void 0){const Ge=Y.onDidChangeInlineValues(Je=>this.e.$emitInlineValuesEvent(fe));Ne=o.$1M.from(Ne,Ge)}return Ne}$provideInlineValues(V,q,Y,x,fe){return this.s(V,v,we=>we.provideInlineValues(u.URI.revive(q),Y,x,fe),void 0,fe)}registerDocumentHighlightProvider(V,q,Y){const x=this.t(new N(this.h,Y),V);return this.e.$registerDocumentHighlightProvider(x,this.o(q,V)),this.p(x)}registerMultiDocumentHighlightProvider(V,q,Y){const x=this.t(new O(this.h,Y),V);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(q,V)),this.p(x)}$provideDocumentHighlights(V,q,Y,x){return this.s(V,N,fe=>fe.provideDocumentHighlights(u.URI.revive(q),Y,x),void 0,x)}$provideMultiDocumentHighlights(V,q,Y,x,fe){return this.s(V,O,we=>we.provideMultiDocumentHighlights(u.URI.revive(q),Y,x.map(Ne=>u.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(V,q,Y){const x=this.t(new F(this.h,Y),V);return this.e.$registerLinkedEditingRangeProvider(x,this.o(q,V)),this.p(x)}$provideLinkedEditingRanges(V,q,Y,x){return this.s(V,F,async fe=>{const we=await fe.provideLinkedEditingRanges(u.URI.revive(q),Y,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(V,q,Y){const x=this.t(new j(this.h,Y),V);return this.e.$registerReferenceSupport(x,this.o(q,V)),this.p(x)}$provideReferences(V,q,Y,x,fe){return this.s(V,j,we=>we.provideReferences(u.URI.revive(q),Y,x,fe),void 0,fe)}registerCodeActionProvider(V,q,Y,x){const fe=new T.$Uc,we=this.t(new B(this.h,this.j.converter,this.k,Y,this.l,V,this.m),V);return this.e.$registerCodeActionSupport(we,this.o(q,V),{providedKinds:x?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:x?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,fe)}))},Ie.u(V),Ie.w(V),!!Y.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(V,q,Y,x,fe){return this.s(V,B,we=>we.provideCodeActions(u.URI.revive(q),Y,x,fe),void 0,fe)}$resolveCodeAction(V,q,Y){return this.s(V,B,x=>x.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(V,q){this.s(V,B,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,Y){const x=this.t(new W(this.h,Y),V);return this.e.$registerDocumentFormattingSupport(x,this.o(q,V),V.identifier,V.displayName||V.name),this.p(x)}$provideDocumentFormattingEdits(V,q,Y,x){return this.s(V,W,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(q),Y,x),void 0,x)}registerDocumentRangeFormattingEditProvider(V,q,Y){const x=typeof Y.provideDocumentRangesFormattingEdits=="function",fe=this.t(new _(this.h,Y),V);return this.e.$registerRangeFormattingSupport(fe,this.o(q,V),V.identifier,V.displayName||V.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(V,q,Y,x,fe){return this.s(V,_,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(q),Y,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(V,q,Y,x,fe){return this.s(V,_,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(q),Y,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(V,q,Y,x){const fe=this.t(new re(this.h,Y),V);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,V),x,V.identifier),this.p(fe)}$provideOnTypeFormattingEdits(V,q,Y,x,fe,we){return this.s(V,re,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(q),Y,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(V,q){const Y=this.t(new z(q,this.l),V);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(V,q,Y){return this.s(V,z,x=>x.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(V,q,Y){return this.s(V,z,x=>x.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,z,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,Y){const x=this.t(new G(this.h,Y,this.l),V);return this.e.$registerRenameSupport(x,this.o(q,V),G.supportsResolving(Y)),this.p(x)}$provideRenameEdits(V,q,Y,x,fe){return this.s(V,G,we=>we.provideRenameEdits(u.URI.revive(q),Y,x,fe),void 0,fe)}$resolveRenameLocation(V,q,Y,x){return this.s(V,G,fe=>fe.resolveRenameLocation(u.URI.revive(q),Y,x),void 0,x)}registerNewSymbolNamesProvider(V,q,Y){const x=this.t(new J(this.h,Y,this.l),V);return this.e.$registerNewSymbolNamesProvider(x,this.o(q,V)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,J,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,q,Y,x,fe){return this.s(V,J,we=>we.provideNewSymbolNames(u.URI.revive(q),Y,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(V,q,Y,x){const fe=this.t(new ue(this.h,Y),V),we=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,V),x,we);let Ne=this.p(fe);if(we){const Ge=Y.onDidChangeSemanticTokens(Je=>this.e.$emitDocumentSemanticTokensEvent(we));Ne=o.$1M.from(Ne,Ge)}return Ne}$provideDocumentSemanticTokens(V,q,Y,x){return this.s(V,ue,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(q),Y,x),null,x)}$releaseDocumentSemanticTokens(V,q){this.s(V,ue,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,Y,x){const fe=this.t(new ne(this.h,Y),V);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,V),x),this.p(fe)}$provideDocumentRangeSemanticTokens(V,q,Y,x){return this.s(V,ne,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(q),Y,x),null,x)}registerCompletionItemProvider(V,q,Y,x){const fe=this.t(new De(this.h,this.j.converter,Y,this.m,V),V);return this.e.$registerCompletionsProvider(fe,this.o(q,V),x,De.supportsResolving(Y),V.identifier),this.p(fe)}$provideCompletionItems(V,q,Y,x,fe){return this.s(V,De,we=>we.provideCompletionItems(u.URI.revive(q),Y,x,fe),void 0,fe)}$resolveCompletionItem(V,q,Y){return this.s(V,De,x=>x.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(V,q){this.s(V,De,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,Y,x){const fe=new Q(V,this.h,Y,this.j.converter),we=this.t(fe,V);return this.e.$registerInlineCompletionsSupport(we,this.o(q,V),fe.supportsHandleEvents,m.$nn.toKey(V.identifier.value),x?.yieldTo?.map(Ne=>m.$nn.toKey(Ne))||[]),this.p(we)}$provideInlineCompletions(V,q,Y,x,fe){return this.s(V,$e,we=>we.provideInlineCompletions(u.URI.revive(q),Y,x,fe),void 0,fe)}$handleInlineCompletionDidShow(V,q,Y,x){this.s(V,$e,async fe=>{fe.handleDidShowCompletionItem(q,Y,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,Y,x,fe){this.s(V,$e,async we=>{we.handlePartialAccept(q,Y,x,fe)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,$e,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,Y){const x=new U(V,this.h,Y,this.j.converter),fe=this.t(x,V);return this.e.$registerInlineEditProvider(fe,this.o(q,V),V.identifier),this.p(fe)}$provideInlineEdit(V,q,Y,x){return this.s(V,U,fe=>fe.provideInlineEdits(u.URI.revive(q),Y,x),void 0,x)}$freeInlineEdit(V,q){this.s(V,U,async Y=>{Y.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,Y,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new oe(this.h,Y),V);return this.e.$registerSignatureHelpProvider(we,this.o(q,V),fe),this.p(we)}$provideSignatureHelp(V,q,Y,x,fe){return this.s(V,oe,we=>we.provideSignatureHelp(u.URI.revive(q),Y,x,fe),void 0,fe)}$releaseSignatureHelp(V,q){this.s(V,oe,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,Y){const x=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,Y,this.l,V),V);this.e.$registerInlayHintsProvider(fe,this.o(q,V),typeof Y.resolveInlayHint=="function",x,Ie.u(V));let we=this.p(fe);if(x!==void 0){const Ne=Y.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(x));we=o.$1M.from(we,Ne)}return we}$provideInlayHints(V,q,Y,x){return this.s(V,te,fe=>fe.provideInlayHints(u.URI.revive(q),Y,x),void 0,x)}$resolveInlayHint(V,q,Y){return this.s(V,te,x=>x.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(V,q){this.s(V,te,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,Y){const x=this.t(new le(this.h,Y),V);return this.e.$registerDocumentLinkProvider(x,this.o(q,V),typeof Y.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(V,q,Y){return this.s(V,le,x=>x.provideLinks(u.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(V,q,Y){return this.s(V,le,x=>x.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,le,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,Y){const x=this.t(new he(this.h,Y),V);return this.e.$registerDocumentColorProvider(x,this.o(q,V)),this.p(x)}$provideDocumentColors(V,q,Y){return this.s(V,he,x=>x.provideColors(u.URI.revive(q),Y),[],Y)}$provideColorPresentations(V,q,Y,x){return this.s(V,he,fe=>fe.provideColorPresentations(u.URI.revive(q),Y,x),void 0,x)}registerFoldingRangeProvider(V,q,Y){const x=this.q(),fe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new X(this.h,Y),V)),this.e.$registerFoldingRangeProvider(x,this.o(q,V),V.identifier,fe);let we=this.p(x);if(fe!==void 0){const Ne=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=o.$1M.from(we,Ne)}return we}$provideFoldingRanges(V,q,Y,x){return this.s(V,X,fe=>fe.provideFoldingRanges(u.URI.revive(q),Y,x),void 0,x)}registerSelectionRangeProvider(V,q,Y){const x=this.t(new ae(this.h,Y,this.l),V);return this.e.$registerSelectionRangeProvider(x,this.o(q,V)),this.p(x)}$provideSelectionRanges(V,q,Y,x){return this.s(V,ae,fe=>fe.provideSelectionRanges(u.URI.revive(q),Y,x),[],x)}registerCallHierarchyProvider(V,q,Y){const x=this.t(new pe(this.h,Y),V);return this.e.$registerCallHierarchyProvider(x,this.o(q,V)),this.p(x)}$prepareCallHierarchy(V,q,Y,x){return this.s(V,pe,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),Y,x)),void 0,x)}$provideCallHierarchyIncomingCalls(V,q,Y,x){return this.s(V,pe,fe=>fe.provideCallsTo(q,Y,x),void 0,x)}$provideCallHierarchyOutgoingCalls(V,q,Y,x){return this.s(V,pe,fe=>fe.provideCallsFrom(q,Y,x),void 0,x)}$releaseCallHierarchy(V,q){this.s(V,pe,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,Y){const x=this.t(new be(this.h,Y),V);return this.e.$registerTypeHierarchyProvider(x,this.o(q,V)),this.p(x)}$prepareTypeHierarchy(V,q,Y,x){return this.s(V,be,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(q),Y,x)),void 0,x)}$provideTypeHierarchySupertypes(V,q,Y,x){return this.s(V,be,fe=>fe.provideSupertypes(q,Y,x),void 0,x)}$provideTypeHierarchySubtypes(V,q,Y,x){return this.s(V,be,fe=>fe.provideSubtypes(q,Y,x),void 0,x)}$releaseTypeHierarchy(V,q){this.s(V,be,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,Y,x){const fe=this.q();return this.f.set(fe,new ke(new Me(this.e,this.h,Y,fe,V),V)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,V),(0,i.$1G)(V,"documentPaste")&&x?{supportsResolve:!!Y.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(V,q,Y,x,fe,we){return this.s(V,Me,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(q,u.URI.revive(Y),x,fe,we)),void 0,void 0)}$resolveDropEdit(V,q,Y){return this.s(V,Me,x=>x.resolveDropEdit(q,Y),{},void 0)}$releaseDropEdits(V,q){this.s(V,Me,Y=>Promise.resolve(Y.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(V,q,Y){const x=this.t(new We(this.h,Y),V);return this.e.$registerMappedEditsProvider(x,this.o(q,V)),this.p(x)}$provideMappedEdits(V,q,Y,x,fe){return this.s(V,We,we=>Promise.resolve(we.provideMappedEdits(q,Y,x,fe)),null,fe)}registerDocumentPasteEditProvider(V,q,Y,x){const fe=this.q();return this.f.set(fe,new ke(new M(this.e,this.h,Y,fe,V),V)),this.e.$registerPasteEditProvider(fe,this.o(q,V),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(V,q,Y,x,fe){return this.s(V,M,we=>we.prepareDocumentPaste(u.URI.revive(q),Y,x,fe),void 0,fe)}$providePasteEdits(V,q,Y,x,fe,we,Ne){return this.s(V,M,Ge=>Ge.providePasteEdits(q,u.URI.revive(Y),x,fe,we,Ne),void 0,Ne)}$resolvePasteEdit(V,q,Y){return this.s(V,M,x=>x.resolvePasteEdit(q,Y),{},void 0)}$releasePasteEdits(V,q){this.s(V,M,Y=>Promise.resolve(Y.releasePasteEdits(q)),void 0,void 0)}static y(V){return{pattern:V.source,flags:V.flags}}static z(V){return{decreaseIndentPattern:Ie.y(V.decreaseIndentPattern),increaseIndentPattern:Ie.y(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ie.y(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ie.y(V.unIndentedLinePattern):void 0}}static B(V){return{beforeText:Ie.y(V.beforeText),afterText:V.afterText?Ie.y(V.afterText):void 0,previousLineText:V.previousLineText?Ie.y(V.previousLineText):void 0,action:V.action}}static C(V){return V.map(Ie.B)}static D(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(V){return V.map(Ie.D)}setLanguageConfiguration(V,q,Y){const{wordPattern:x}=Y;if(x&&(0,C.$pf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(q,x):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this.q(),we={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Ie.y(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Ie.z(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Ie.C(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Ie.E(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,we),this.p(fe)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$gnc=Ie}),define(Ee[129],Se([1,0,9,21,14,4,40,3,236,24,5,12,90,6,128,20,17,10,155,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Znc=void 0,g=Ue(g),f=Ue(f),e.$Znc=(0,C.$Ci)("IExtHostLanguageModels");class i{constructor(a,w){this.option=a,this.stream=new r.$6h,this.stream=w??new r.$6h}}class t{constructor(){this.a=new Map,this.b=new r.$6h,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable,text:r.$3h.map(a.b.asyncIterable,w=>{if(w instanceof f.$cP)return w.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let w=this.a.get(a.index);w||(this.a.size===0?w=new i(a.index,this.b):w=new i(a.index),this.a.set(a.index,w));let y;a.part.type==="text"?y=new f.$cP(a.part.value):y=new f.$bP(a.part.name,a.part.parameters),w.stream.emitOne(y)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const w of this.f())w.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(a,w,y){this.j=w,this.k=y,this.c=new R.$je,this.d=new R.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new l.$pn,this.i=new Map,this.r=new Set,this.b=a.getProxy(P.$YM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,w,y,D){const S=o.a++;this.f.set(S,{extension:a.identifier,provider:y,languageModelId:w});let I;D.auth&&(I={providerLabel:a.displayName||a.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(S,`${l.$nn.toKey(a.identifier)}/${S}/${w}`,{extension:a.identifier,id:w,vendor:D.vendor??l.$nn.toKey(a.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:I,targetExtensions:D.extensions});const k=y.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:v,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(w,new l.$nn(b),v,N)});return(0,T.$Tc)(()=>{this.f.delete(S),this.b.$unregisterProvider(S),k?.dispose()})}async $provideLanguageModelResponse(a,w,y,D,S,I){const k=this.f.get(a);if(!k)return;const b=new u.$pw(async v=>{if(I.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let N;if(v.part instanceof f.$bP?N={type:"function_use",name:v.part.name,parameters:v.part.parameters}:v.part instanceof f.$cP&&(N={type:"text",value:v.part.value}),!N){this.j.warn(`[CHAT](${k.extension.value}) UNKNOWN part ${JSON.stringify(v)}`);return}this.b.$handleProgressChunk(w,{index:v.index,part:N})});if(k.provider.provideLanguageModelResponse2)return k.provider.provideLanguageModelResponse2(D.map(g.LanguageModelChatMessage.to),S,l.$nn.toKey(y),b,I);{const v=new u.$pw(async N=>{b.report({index:N.index,part:new f.$cP(N.part)})});return k.provider.provideLanguageModelResponse(D.map(g.LanguageModelChatMessage.to),S?.modelOptions??{},l.$nn.toKey(y),v,I)}}$provideTokenLength(a,w,y){const D=this.f.get(a);return D?Promise.resolve(D.provider.provideTokenCount(w,y)):Promise.resolve(0)}$acceptChatModelMetadata(a){if(a.added)for(const{identifier:w,metadata:y}of a.added)this.g.set(w,{metadata:y,apiObjects:new l.$pn});if(a.removed)for(const w of a.removed){this.g.delete(w);for(const[y,D]of this.i)D.languageModelId===w&&(D.res.reject(new A.$6),this.i.delete(y))}a.added?.forEach(w=>this.p(w.metadata)),this.d.fire(void 0)}async selectLanguageModels(a,w){const y=await this.b.$selectChatModels({...w,extension:a.identifier}),D=[],S=this;for(const I of y){const k=this.g.get(I);if(!k)continue;this.o(a.identifier,k.metadata)&&await this.p(k.metadata);let b=k.apiObjects.get(a.identifier);b||(b={id:I,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(v,N){if(!S.g.has(I))throw f.$gP.NotFound(I);return S.q(I,v,N??h.CancellationToken.None)},sendRequest(v,N,O){if(!S.g.has(I))throw f.$gP.NotFound(I);return S.l(a,I,v,N??{},O??h.CancellationToken.None)}},Object.freeze(b),k.apiObjects.set(a.identifier,b)),D.push(b)}return D}async l(a,w,y,D,S){const I=this.m(a,y),k=a.identifier,b=this.g.get(w)?.metadata;if(!b||!this.g.has(w))throw f.$gP.NotFound(`Language model '${w}' is unknown.`);if(this.o(k,b)&&(!await this.n(a,{identifier:b.extension,displayName:b.auth.providerLabel},D.justification,!1)||!this.h.get(k)?.has(b.extension)))throw f.$gP.NoPermissions(`Language model '${w}' cannot be used by '${k.value}'.`);const v=Math.random()*1e6|0,N=this.b.$fetchResponse(k,w,v,I,D,S),O=new r.$Bh,F=new t;this.i.set(v,{languageModelId:w,res:F});let j;if(N.catch(B=>{O.isOpen()?F.reject(B):j=B}).finally(()=>{this.i.delete(v),F.resolve(),O.open()}),await O.wait(),j)throw j.name===f.$gP.name?j:new f.$gP(`Language model '${w}' errored, check cause for more details`,"Unknown",j);return F.apiObject}m(a,w){const y=[];for(const D of w)D.role===f.LanguageModelChatMessageRole.System&&(0,n.$2G)(a,"languageModelSystem"),D.content2 instanceof f.$_O&&(0,n.$2G)(a,"lmTools"),y.push(g.LanguageModelChatMessage.from(D));return y}async $handleResponseFragment(a,w){const y=this.i.get(a);y&&y.res.handleFragment(w)}async n(a,w,y,D){const S=m.$1L+w.identifier.value;if(await this.k.getSession(a,S,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0;if(D)return!1;try{const k=y?(0,$.localize)(0,null,w.displayName,y):void 0;return await this.k.getSession(a,S,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}o(a,w){return!!w.auth&&!l.$nn.equals(w.extension,a)}async p(a){if(a.auth)for(const w of this.r)try{await this.n(w,{identifier:a.extension,displayName:""},void 0,!0)}catch(y){this.j.error("Fake Auth request failed"),this.j.error(y)}}async q(a,w,y){if(!this.g.get(a))throw f.$gP.NotFound(`Language model '${a}' is unknown.`);const S=L.Iterable.find(this.f.values(),I=>I.languageModelId===a);return S?S.provider.provideTokenCount(w,y):this.b.$countTokens(a,typeof w=="string"?w:g.LanguageModelChatMessage.from(w),y)}$updateModelAccesslist(a){const w=new Array;for(const{from:y,to:D,enabled:S}of a){const I=this.h.get(y)??new l.$on;if(I.has(D)!==S){S?I.add(D):I.delete(D),this.h.set(y,I);const b={from:y,to:D};w.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(a){this.r.add(a);const w=this,y=R.Event.signal(R.Event.filter(this.c.event,S=>l.$nn.equals(S.from,a.identifier))),D=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(y,D)},canSendRequest(S){let I;e:for(const[b,v]of w.g)for(const N of v.apiObjects.values())if(N===S){I=v.metadata;break e}if(!I)return;if(!w.o(a.identifier,I))return!0;const k=w.h.get(a.identifier);if(k)return k.has(I.extension)}}}};e.$1nc=s,e.$1nc=s=o=Ye([qe(0,c.$sP),qe(1,E.$9j),qe(2,p.$inc)],s)});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[356],Se([1,0,6,17,10,44,9,3,26]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0,h=Ue(h),R=Wt(R);class l{constructor(E,u,P,p){this.c=u,this.d=P,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(r.$YM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const P=this.c.getDocumentData(E);if(!P)throw new Error(`document '${E.toString()}' NOT found`);return P.document}async tokenAtPosition(E,u){const P=E.version,p=h.Position.from(u),c=await this.a.$tokensAtPosition(E.uri,p),g={type:A.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new A.$3M(u.line,u.character,u.line,u.character)};if(!c)return g;const f={range:h.Range.to(c.range),type:h.TokenType.to(c.type)};return!f.range.contains(u)||P!==E.version?g:f}createLanguageStatusItem(E,u,P){const p=this.f++,c=this.a,g=this.g,f=`${E.identifier.value}/${u}`;if(g.has(f))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);g.add(f);const m={selector:P,id:u,name:E.displayName??E.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new T.$Uc,i=()=>{if(n?.dispose(),!g.has(f)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Eh)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:f,name:m.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===A.LanguageStatusSeverity.Error?R.default.Error:m.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,o),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),c.$removeLanguageStatus(p),g.delete(f)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,i()},get selector(){return m.selector},set selector(s){m.selector=s,i()},get text(){return m.text},set text(s){m.text=s,i()},set text2(s){(0,$.$2G)(E,"languageStatusText"),m.text=s,i()},get text2(){return(0,$.$2G)(E,"languageStatusText"),m.text},get detail(){return m.detail},set detail(s){m.detail=s,i()},get severity(){return m.severity},set severity(s){m.severity=s,i()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,i()},get command(){return m.command},set command(s){m.command=s,i()},get busy(){return m.busy},set busy(s){m.busy=s,i()}};return i(),t}}e.$Koc=l}),define(Ee[357],Se([1,0,15,2,17,10,127]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,A=Ue(A),L=Ue(L);class T{constructor(E,u,P,p){this.start=E,this.deletedCount=u,this.deletedItems=P,this.items=p}asApiEvent(){return{range:new R.$qO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,P){this.notebook=E,this.h=u,this.j=P,this.handle=P.handle,this.uri=h.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(A.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(p){E.g=p},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(P)}return this.f}setOutputs(E){this.a=E.map(A.NotebookCellOutput.to)}setOutputItems(E,u,P){const p=P.map(A.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===E);if(c&&(u||(c.items.length=0),c.items.push(...p),c.items.length>1&&c.items.every(g=>L.$4K(g.mime)))){const g=new Map,f=[];c.items.forEach(m=>{let n;g.has(m.mime)?n=g.get(m.mime):(n=[],g.set(m.mime,n),f.push(m.mime)),n.push(m.data)}),c.items.length=0,f.forEach(m=>{const n=L.$5K(g.get(m));c.items.push({mime:m,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$woc=$;class l{static{this.a=0}constructor(E,u,P,p,c){this.k=E,this.l=u,this.m=P,this.uri=p,this.handle=l.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(P){return P=E.n(P),E.b[P].apiCell},getCells(P){return(P?E.p(P):E.b).map(c=>c.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,P){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:P});const p={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},c=[];for(const f of E.rawEvents)f.kind===L.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,p.contentChanges):f.kind===L.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,p.contentChanges):f.kind===L.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),c.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),c.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),c.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===L.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),c.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),c.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const g=new Map;for(let f=0;f<c.length;f++){const m=c[f],n=g.get(m.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});g.set(m.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...m}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,P=E.end|0;return u<0&&(u=0),P>this.b.length&&(P=this.b.length),E.with({start:u,end:P})}p(E){E=this.o(E);const u=[];for(let P=E.start;P<E.end;P++)u.push(this.b[P]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,P){if(this.j)return;const p=[],c=[],g=[];if(E.reverse().forEach(f=>{const n=f[2].map(t=>{const s=new $(this,this.l,t);return u||c.push($.asModelAddData(t)),s}),o=new T(f[0],f[1],[],n),i=this.b.splice(f[0],f[1],...n);for(const t of i)g.push(t.uri),o.deletedItems.push(t.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),P)for(const f of p)P.push(f.asApiEvent())}s(E,u,P,p){const c=this.b.splice(E,u);this.b.splice(P,0,...c);const g=[new T(E,u,c.map(f=>f.apiCell),[]),new T(P,0,[],c)];for(const f of g)p.push(f.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,P,p){this.b[E].setOutputItems(u,P,p)}v(E,u){const P=this.b[E];P.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(P.uri,u)}w(E,u){const P=this.b[E];P.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$xoc=l}),define(Ee[358],Se([1,0,4,2,17,10,51]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class T{constructor(l,C,E,u={timeout:1500,errors:3}){this.b=l,this.c=C,this.d=E,this.f=u,this.a=new r.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(C,E,u)=>{const P=function(c){C.call(E,c)};return P.extension=l,this.a.event(P,void 0,u)}}async $participateInSave(l,C,E){const u=h.URI.revive(l),P=this.c.getNotebookDocument(u);if(!P)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:A.TextDocumentSaveReason.to(C)},E,async(g,f)=>{const m=Date.now(),n=await await Promise.resolve(g);Date.now()-m>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof R.$$M?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(p.length===0)return!0;const c={edits:[]};for(const g of p){const{edits:f}=A.WorkspaceEdit.from(g);c.edits=c.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(new L.$Nw(c))}}e.$Moc=T}),define(Ee[164],Se([1,0,14,17,10]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0,h=Ue(h),A=Ue(A);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,$,l,C,E,u){this.id=T,this.f=$,this.notebookData=l,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=C,this.c=u}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection($){this.selections=[$]},get selections(){return T.a},set selections($){if(!Array.isArray($)||!$.every(A.$qO.isNotebookRange))throw(0,r.$8)("selections");T.a=$,T.g($)},get visibleRanges(){return T.b},revealRange($,l){T.f.$tryRevealRange(T.id,h.NotebookRange.from($),l??A.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(h.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$yoc=R}),define(Ee[359],Se([1,0,4,12,17]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0,A=Ue(A);let R=class{constructor(T,$){this.c=T,this.d=$,this.a=new r.$je,this.b=new r.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,$);const l=this.d.getEditorById(T);$.visibleRanges&&l._acceptVisibleRanges($.visibleRanges.ranges.map(A.NotebookRange.to)),$.selections&&l._acceptSelections($.selections.selections.map(A.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const $ in T)this.d.getEditorById($)._acceptViewColumn(A.ViewColumn.to(T[$]))}};e.$Ooc=R,e.$Ooc=R=Ye([qe(0,h.$9j)],R)}),define(Ee[360],Se([1,0,4,6,164]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0;class R{constructor(T,$){this.c=$,this.a=new Map,this.b=T.getProxy(h.$YM.MainThreadNotebookRenderers)}$postRendererMessage(T,$,l){const C=this.c.getEditorById(T);this.a.get($)?.fire({editor:C.apiEditor,message:l})}createRendererMessaging(T,$){if(!T.contributes?.notebookRenderer?.some(C=>C.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(C,E,u)=>this.d($).event(C,E,u),postMessage:(C,E)=>{A.$yoc.apiEditorsToExtHost.has(C)&&([C,E]=[E,C]);const u=E&&A.$yoc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,$,C)}}}d(T){let $=this.a.get(T);return $||($=new r.$je({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(T)}}),this.a.set(T,$),$)}}e.$Roc=R}),define(Ee[361],Se([1,0,17,90,21,59,14]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class T{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,P){const p=this.b++,{title:c,location:g,cancellable:f}=u,m={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(p,{location:r.ProgressLocation.from(g),title:c,source:m,cancellable:f},E.isUnderDevelopment?void 0:E.identifier.value).catch(L.$3),this.d(p,P,!!f)}d(E,u,P){let p;P&&(p=new A.$ue,this.c.set(E,p));const c=f=>{this.a.$progressEnd(f),this.c.delete(f),p?.dispose()};let g;try{g=u(new l(this.a,E),P&&p?p.token:A.CancellationToken.None)}catch(f){throw c(E),f}return g.then(f=>c(E),f=>c(E)),g}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$Voc=T;function $(C,E){return C.message=E.message,typeof E.increment=="number"&&(typeof C.increment=="number"?C.increment+=E.increment:C.increment=E.increment),C}class l extends h.$pw{constructor(E,u){super(P=>this.throttledReport(P)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Ye([(0,R.$9h)(100,(C,E)=>$(C,E),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Ee[362],Se([1,0,2,6,9,17]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class L{static{this.a=0}constructor($,l){this.d=l,this.c=new Map,this.b=$.getProxy(h.$YM.MainThreadQuickDiff)}$provideOriginalResource($,l,C){const E=r.URI.revive(l),u=this.c.get($);return u?(0,A.$uh)(()=>u.provideOriginalResource(E,C)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider($,l,C,E){const u=L.a++;return this.c.set(u,l),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from($,this.d),C,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Woc=L});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[363],Se([1,0,21,4,3,6,2,10,14,19,44,50,26,17]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=p,C=Wt(C);function p(c,g,f){const m=c.getProxy(R.$YM.MainThreadQuickOpen);class n{constructor(D,S){this.e=new Map,this.f=0,this.a=D,this.b=S}showQuickPick(D,S,I,k=r.CancellationToken.None){this.c=void 0;const b=Promise.resolve(S),v=++this.f,N=m.$show(v,{title:I?.title,placeHolder:I?.placeHolder,matchOnDescription:I?.matchOnDescription,matchOnDetail:I?.matchOnDetail,ignoreFocusLost:I?.ignoreFocusOut,canPickMany:I?.canPickMany},k),O={},F=N.then(()=>O);return Promise.race([F,b]).then(j=>{if(j===O)return;const B=(0,u.$1G)(D,"quickPickItemTooltip");return b.then(M=>{const W=[];for(let _=0;_<M.length;_++){const re=M[_];if(typeof re=="string")W.push({label:re,handle:_});else if(re.kind===T.QuickPickItemKind.Separator)W.push({type:"separator",label:re.label});else{re.tooltip&&!B&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const z=re.iconPath?d(re.iconPath):void 0;W.push({label:re.label,iconPath:z?.iconPath,iconClass:z?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:B?P.MarkdownString.fromStrict(re.tooltip):void 0,handle:_})}}return I&&typeof I.onDidSelectItem=="function"&&(this.c=_=>{I.onDidSelectItem(M[_])}),m.$setItems(v,W),N.then(_=>{if(typeof _=="number")return M[_];if(Array.isArray(_))return _.map(re=>M[re])})})}).then(void 0,j=>{if(!(0,$.$5)(j))return m.$setError(v,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,S=r.CancellationToken.None){return this.d=D?.validateInput,m.$input(D,typeof this.d=="function",S).then(void 0,I=>{if(!(0,$.$5)(I))return Promise.reject(I)})}async $validateInput(D){if(!this.d)return;const S=await this.d(D);if(!S||typeof S=="string")return S;let I;switch(S.severity){case T.InputBoxValidationSeverity.Info:I=C.default.Info;break;case T.InputBoxValidationSeverity.Warning:I=C.default.Warning;break;case T.InputBoxValidationSeverity.Error:I=C.default.Error;break;default:I=S.message?C.default.Error:C.default.Ignore;break}return{content:S.message,severity:I}}async showWorkspaceFolderPick(D,S=r.CancellationToken.None){const I=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!I)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(b=>b.uri.toString()===I.uri.toString())}createQuickPick(D){const S=new a(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(D){const S=new w(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(D,S){this.e.get(D)?._fireDidChangeValue(S)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,S){const I=this.e.get(D);I instanceof a&&I._fireDidChangeActive(S)}$onDidChangeSelection(D,S){const I=this.e.get(D);I instanceof a&&I._fireDidChangeSelection(S)}$onDidTriggerButton(D,S){this.e.get(D)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(D,S,I){const k=this.e.get(D);k instanceof a&&k._fireDidTriggerItemButton(S,I)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class o{static{this.a=1}constructor(D,S){this.x=D,this.y=S,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$je,this.q=new h.$je,this.r=new h.$je,this.s=new h.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((S,I)=>{const k=S===T.$nO.Back?-1:I;this.o.set(k,S)}),this.z({buttons:D.map((S,I)=>({...d(S.iconPath),tooltip:S.tooltip,handle:S===T.$nO.Back?-1:I}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const S=this.o.get(D);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(D){if(!this.v){for(const S of Object.keys(D)){const I=D[S];this.u[S]=I===void 0?null:I}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}function i(y){if(y instanceof T.$XN)return{id:y.id};const D=s(y),S=t(y);return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof S=="string"?L.URI.file(S):S}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function s(y){return typeof y=="object"&&"dark"in y?y.dark:y}function d(y){const D=i(y);let S,I;return"id"in D?I=E.ThemeIcon.asClassName(D):S=D,{iconPath:S,iconClass:I}}class a extends o{constructor(D,S){super(D.identifier,S),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$je,this.L=[],this.M=new h.$je,this.N=new h.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,b)=>{this.C.set(b,k),this.D.set(k,b)});const S=(0,u.$1G)(this.O,"quickPickItemTooltip"),I=[];for(let k=0;k<D.length;k++){const b=D[k];if(b.kind===T.QuickPickItemKind.Separator)I.push({type:"separator",label:b.label});else{b.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=b.iconPath?d(b.iconPath):void 0;I.push({handle:k,label:b.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:S?P.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((N,O)=>({...d(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:I})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(D){const S=(0,l.$Ib)(D.map(I=>this.C.get(I)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(D){const S=(0,l.$Ib)(D.map(I=>this.C.get(I)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(D,S){const I=this.C.get(D);if(!I||!I.buttons||!I.buttons.length)return;const k=I.buttons[S];k&&this.N.fire({button:k,item:I})}}class w extends o{constructor(D,S){super(D.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:C.default.Error}):this.z({validationMessage:D.message,severity:D.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new n(g,f)}}),define(Ee[364],Se([1,0,2,4,59,3,9,6,19,140,12,24,41,50,17,26,15,11]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0;function n(N){return N instanceof r.URI}function o(N,O){return N.scheme===g.Schemas.file&&O.scheme===g.Schemas.file&&f.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function i(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function t(N){if(N.icon){if(r.URI.isUri(N.icon))return N.icon;if(P.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function s(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const F=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,j=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,l.$Br)(F,j)}function d(N,O){let F=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(F=s(N,O),F!==0)return F;if(N.light&&O.light)F=s(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(F!==0)return F;if(N.dark&&O.dark)F=s(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return F}function a(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let F=0;F<N.arguments.length;F++){const j=N.arguments[F],B=O.arguments[F];if(j!==B&&!(n(j)&&n(B)&&o(j,B)))return j<B?-1:1}return 0}function w(N,O){let F=(0,l.$Br)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(F!==0)return F;if(N.command&&O.command)F=a(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(F!==0)return F;if(N.decorations&&O.decorations)F=d(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)F=(0,l.$Br)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)F=(0,l.$Br)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return F}function y(N,O){for(let F=0;F<N.length;F++)if(N[F]!==O[F])return!1;return!0}function D(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?y(N.arguments,O.arguments):N.arguments===O.arguments)}function S(N,O){return(0,$.$vb)(N,O,D)}class I{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,c.$2G)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,c.$2G)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,c.$2G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,F,j,B,M){this.k=O,this.l=B,this.m=M,this.d="",this.e=new h.$je,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(O,F){(0,c.$2G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,F)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Yoc=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,F,j,B,M,W,_){this.q=O,this.s=F,this.t=j,this.u=B,this.v=M,this.multiDiffEditorEnableViewChanges=W,this.w=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$je,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new h.$je,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,F){const j=this.h.get(O);return j?(0,L.$uh)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(w),j=(0,$.$Eb)(this.o,O,w).map(W=>{const _=W.toInsert.map(re=>{const z=this.e++;this.g.set(z,re);const G=re.resourceUri;let J;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const X=new R.$Uc;J=this.s.converter.toInternal(re.command,X),this.j.set(z,X)}else this.h.set(z,re.command);const ee=(0,c.$1G)(this.w,"scmMultiDiffEditor"),ue=ee?re.multiDiffEditorOriginalUri:void 0,ne=ee?re.multiFileDiffEditorModifiedUri:void 0,De=i(re.decorations),$e=re.decorations&&i(re.decorations.light)||De,Q=re.decorations&&i(re.decorations.dark)||De,U=[$e,Q],se=re.decorations&&re.decorations.tooltip||"",oe=re.decorations&&!!re.decorations.strikeThrough,te=re.decorations&&!!re.decorations.faded,le=re.contextValue||"";return{rawResource:[z,G,U,se,oe,te,le,J,ue,ne],handle:z}});return{start:W.start,deleteCount:W.deleteCount,toInsert:_}}),B=j.map(({start:W,deleteCount:_,toInsert:re})=>[W,_,re.map(z=>z.rawResource)]),M=j.reverse();for(const{start:W,deleteCount:_,toInsert:re}of M){const z=re.map(J=>J.handle),G=this.n.splice(W,_,...z);for(const J of G)this.g.delete(J),this.h.delete(J),this.j.get(J)?.dispose(),this.j.delete(J)}return this.o=O,B}dispose(){this.l=!0,this.m.fire()}}class b{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let F;(0,c.$1G)(this.x,"quickDiffProvider")&&(F=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:F})}get historyProvider(){return(0,c.$2G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,c.$2G)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new R.$Uc,this.o=O;const F=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,c.$2G)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,c.$2G)(this.x,"scmActionButton"),this.p.value=new R.$Uc,this.q=O;const F=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(j=>j.map(B=>this.y.converter.toInternal(B,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new R.$Uc,this.t=O;const F=(O||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(O,F,j,B,M,W,_){this.x=O,this.y=B,this.z=M,this.A=W,this.B=_,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Wc,this.m=void 0,this.n=new R.$Wc,this.o=void 0,this.p=new R.$Wc,this.s=new R.$Wc,this.t=void 0,this.u=!1,this.v=new h.$je,this.onDidChangeSelection=this.v.event,this.w=b.d++,this.C=new Map,this.D=new Set,this.#e=j;const re=r.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:_?`rootUri=${encodeURIComponent(_.toString())}`:void 0});this.f=new I(O,F,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,M,W,_,re)}createResourceGroup(O,F,j){const B=(0,c.$1G)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new k(this.#e,this.y,this.w,O,F,B,this.x),W=h.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,W),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const O=[],F=[];for(const[j,B]of this.C){B.dispose();const M=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});h.Event.once(j.onDidDispose)(()=>{this.D.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),O.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const W=j._takeResourceStateSnapshot();W.length>0&&F.push([j.handle,W]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,O,F),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&O.push([F.handle,j])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ye([(0,A.$8h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ye([(0,A.$8h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{m=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,F,j,B){this.l=F,this.m=j,this.n=B,this.g=new Map,this.h=new E.$pn,this.j=new h.$je,this.e=O.getProxy(T.$YM.MainThreadSCM),this.f=O.getProxy(T.$YM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===u.MarshalledId.ScmResource){const W=this.g.get(M.sourceControlHandle);if(!W)return M;const _=W.getResourceGroup(M.groupHandle);return _?_.getResourceState(M.handle):M}else if(M&&M.$mid===u.MarshalledId.ScmResourceGroup){const W=this.g.get(M.sourceControlHandle);return W?W.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===u.MarshalledId.ScmProvider){const W=this.g.get(M.handle);return W||M}return M}})}createSourceControl(O,F,j,B){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,F,j,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const M=m.d++,W=new b(O,this.m,this.e,this.l,F,j,B);this.g.set(M,W);const _=this.h.get(O.identifier)||[];return _.push(W),this.h.set(O.identifier,_),W}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const F=this.h.get(O.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(O,F,j){const B=r.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",O,B.toString());const M=this.g.get(O);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$uh)(()=>M.quickDiffProvider.provideOriginalResource(B,j)).then(W=>W||null)}$onInputBoxValueChange(O,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const j=this.g.get(O);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(O,F,j,B){this.n.trace("ExtHostSCM#$executeResourceCommand",O,F,j);const M=this.g.get(O);if(!M)return Promise.resolve(void 0);const W=M.getResourceGroup(F);return W?W.$executeResourceCommand(j,B):Promise.resolve(void 0)}$validateInput(O,F,j){this.n.trace("ExtHostSCM#$validateInput",O);const B=this.g.get(O);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,L.$uh)(()=>B.inputBox.validateInput(F,j)).then(M=>{if(!M)return Promise.resolve(void 0);const W=p.MarkdownString.fromStrict(M.message);return W?Promise.resolve([W,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,F,j,B){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,B)??void 0}async $provideHistoryItems(O,F,j,B){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(F,j,B))?.map(_=>({..._,icon:t(_)}))??void 0}async $provideHistoryItemSummary(O,F,j,B){const M=this.g.get(O)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const W=await M.provideHistoryItemSummary(F,j,B);return W?{...W,icon:t(W)}:void 0}async $provideHistoryItemChanges(O,F,j,B){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(F,j,B)??void 0}};e.$Zoc=v,e.$Zoc=v=m=Ye([qe(3,C.$9j)],v)}),define(Ee[365],Se([1,0,6,17,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0;class R{static{this.a=0}constructor(T,$){this.d=$,this.c=new Map,this.b=T.getProxy(r.$YM.MainThreadShare)}async $provideShare(T,$,l){return await this.c.get(T)?.provideShare({selection:h.Range.to($.selection),resourceUri:A.URI.revive($.resourceUri)},l)??void 0}registerShareProvider(T,$){const l=R.a++;return this.c.set(l,$),this.b.$registerShareProvider(l,h.DocumentSelector.from(T,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(l),this.c.delete(l)}}}}e.$1oc=R}),define(Ee[366],Se([1,0,10,6,239,3,17,18]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$YN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$YN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,P,p,c,g,f=r.StatusBarAlignment.Left,m){if(this.i=!1,this.k="",this.q=new R.$Uc,this.#e=u,this.#t=P,g&&c){this.c=(0,r.$AN)(c.identifier,g);const n=p.get(this.c);n&&(f=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=g,this.g=f,this.h=this.u(m)}u(u){if((0,T.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let P;this.m?P=this.m:P=(0,A.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=$.b.get(this.o.id));const c=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,P,this.k,c,this.r?.internal,p,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$3oc=$;class l{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const P={message:u};return this.b.unshift(P),this.c(),new r.$1M(()=>{const p=this.b.indexOf(P);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(u,P){this.e=new Map,this.a=u.getProxy(h.$YM.MainThreadStatusBar),this.b=P,this.c=new l(this)}$acceptStaticEntries(u){for(const P of u)this.e.set(P.entryId,P)}createStatusBarEntry(u,P,p,c){return new $(this.a,this.b,this.e,u,P,p,c)}setStatusBarMessage(u,P){const p=this.c.setMessage(u);let c;return typeof P=="number"?c=setTimeout(()=>p.dispose(),P):typeof P<"u"&&P.then(()=>p.dispose(),()=>p.dispose()),new r.$1M(()=>{p.dispose(),clearTimeout(c)})}}e.$4oc=C}),define(Ee[165],Se([1,0,31,154,74,121,75,17,2]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=e.$FP=e.$EP=void 0,r=Ue(r),T=Ue(T);const l=(n,o,i,t)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!i(s,d)){const a=s;s=d,n.listener?.(t(d,a))}}}},C=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(n,o)=>!(n.length!==o.length||n.some(i=>!o.find(t=>i.id===t.id)))},u=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),P=(n,o)=>({range:(()=>{let i;const t=u(s=>({range:r.$Ft.lift(T.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return i},set(s){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),E.range(i,s)||(i=s,n.listener?.(t(s)))}}})(),label:l(n,o,E.label,u(i=>({label:i}))),description:l(n,void 0,E.description,u(i=>({description:i}))),sortText:l(n,void 0,E.sortText,u(i=>({sortText:i}))),canResolveChildren:l(n,!1,E.canResolveChildren,i=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:l(n,!1,E.busy,u(i=>({busy:i}))),error:l(n,void 0,E.error,u(i=>({error:T.MarkdownString.fromStrict(i)||null}))),tags:l(n,[],E.tags,(i,t)=>({op:R.TestItemEventOp.SetTags,new:i.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),p=n=>{const o=A.$MI.fromString(n.extId),i=new g(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return i.range=T.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>T.TestTag.to({id:(0,L.$SI)(t).tagId})),i},c=n=>{let o;for(const i of n.tests){const t=p(i.item);(0,h.$oP)(t).parent=o,o=t}return o};e.$EP=c;class g{constructor(o,i,t,s){if(i.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const d=(0,h.$nP)(this,o);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof f?void 0:d.parent}},children:{value:(0,R.$mP)(d,h.$oP,g),enumerable:!0,writable:!1},...P(d,t)})}}e.$FP=g;class f extends g{constructor(o,i){super(o,o,i,void 0),this._isRoot=!0}}e.$GP=f;class m extends R.$iP{constructor(o,i,t){super({controllerId:o,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:h.$oP,getChildren:s=>s.children,root:new f(o,i),toITestItem:T.TestItem.from})}}e.$HP=m}),define(Ee[35],Se([1,0,18,10,17,25,6,19,12,57,31,53,2,3,5,20,165,22,51,55,43,92,95,32]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=void 0,h=Ue(h),A=Ue(A);let d=class{#e;#t;#i;constructor(I,k,b){this.b=new Map,this.c=new Map,this.#e=I.getProxy(L.$YM.MainThreadCommands),this.d=k,this.#i=b,this.#t=I.getProxy(L.$YM.MainThreadTelemetry),this.converter=new a(this,v=>{const N=this.c.get(v);return N?.result===y.Void?N:void 0},k),this.f=[{processArgument(v){return(0,l.$_h)(v)}},{processArgument(v){return(0,R.$bo)(v,function(N){if(C.$Ft.isIRange(N))return A.Range.to(N);if(E.$Et.isIPosition(N))return A.Position.to(N);if(C.$Ft.isIRange(N.range)&&u.URI.isUri(N.uri))return A.location.to(N);if(N instanceof f.$Le)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const k=this.registerCommand(!1,I.id,async(...b)=>{const v=I.args.map((O,F)=>{if(!O.validate(b[F]))throw new Error(`Invalid argument '${O.name}' when running '${I.id}', received: ${typeof b[F]=="object"?JSON.stringify(b[F],null,"	"):b[F]} `);return O.convert(b[F])}),N=await this.executeCommand(I.internalId,...v);return I.result.convert(N,b,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new h.$1M(()=>{k.dispose(),this.c.delete(I.id)})}registerCommand(I,k,b,v,N,O){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:b,thisArg:v,metadata:N,extension:O}),I&&this.#e.$registerCommand(k),new h.$1M(()=>{this.b.delete(k)&&I&&this.#e.$unregisterCommand(k)})}executeCommand(I,...k){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,k,!0)}async g(I,k,b){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,k,!1);{let v=!1;const N=(0,R.$bo)(k,function(O){if(O instanceof h.$2M)return A.Position.from(O);if(O instanceof h.$3M)return A.Range.from(O);if(O instanceof h.$aN)return A.location.from(O);if(h.$qO.isNotebookRange(O))return A.NotebookRange.from(O);if(O instanceof ArrayBuffer)return v=!0,f.$Le.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return v=!0,f.$Le.wrap(O);if(O instanceof f.$Le)return v=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(I,v?new m.$Nw(N):N,b);return(0,l.$_h)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(I,k,!1);throw O}}}async h(I,k,b){const v=this.b.get(I);if(!v)throw new Error("Unknown command");const{callback:N,thisArg:O,metadata:F}=v;if(F?.args)for(let B=0;B<F.args.length;B++)try{(0,r.$tg)(k[B],F.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${F.args[B].name}' - ${F.args[B].description}`)}const j=o.$de.create();try{return await N.apply(O,k)}catch(B){if(I===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...k);M&&(I=M.command)}if(this.d.error(B,I,v.extension?.identifier),!b)throw B;if(v.extension?.identifier){const M=this.#i.onExtensionError(v.extension.identifier,B);this.d.trace("forwarded error to extension?",M,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$nj)(B)),this.id=I,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,I,j.elapsed())}}j(I,k,b){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new i.$qp(k),duration:b})}$executeContributedCommand(I,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const b=this.b.get(I);return b?(k=k.map(v=>this.f.reduce((N,O)=>O.processArgument(N,b.extension?.identifier),v)),this.h(I,k,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(k=>(I&&(k=k.filter(b=>b[0]!=="_")),k))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[k,b]of this.b){const{metadata:v}=b;v&&(I[k]=v)}return Promise.resolve(I)}};e.$NP=d,e.$NP=d=Ye([qe(0,c.$sP),qe(1,$.$9j),qe(2,t.$MP)],d),e.$OP=(0,p.$Ci)("IExtHostCommands");class a{constructor(I,k,b){this.d=I,this.f=k,this.g=b,this.delegatingCommandId=`__vsc${(0,s.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,k){if(!I)return;const b={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return b;const v=this.f(I.command);if(v)b.id=v.internalId,b.arguments=v.args.map((N,O)=>N.convert(I.arguments&&I.arguments[O]));else if((0,T.$Mb)(I.arguments)){const N=`${I.command} /${++this.c}`;this.b.set(N,I),k.add((0,P.$Tc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),b.$ident=N,b.id=this.delegatingCommandId,b.arguments=[N],this.g.trace("CommandsConverter#CREATE",I.command,N)}return b}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const k=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$PP=a;class w{static{this.Uri=new w("uri","Uri of a text document",I=>u.URI.isUri(I),I=>I)}static{this.Position=new w("position","A position in a text document",I=>h.$2M.isPosition(I),A.Position.from)}static{this.Range=new w("range","A range in a text document",I=>h.$3M.isRange(I),A.Range.from)}static{this.Selection=new w("selection","A selection in a text document",I=>h.$4M.isSelection(I),A.Selection.from)}static{this.Number=new w("number","",I=>typeof I=="number",I=>I)}static{this.String=new w("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=w.Arr(w.String)}static Arr(I){return new w(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,k=>Array.isArray(k)&&k.every(b=>I.validate(b)),k=>k.map(b=>I.convert(b)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",I=>I instanceof h.$mN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",I=>I instanceof h.$KO,A.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",I=>I instanceof g.$FP,A.TestItem.from)}constructor(I,k,b,v){this.name=I,this.description=k,this.validate=b,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,k){return new w(I??this.name,k??this.description,this.validate,this.convert)}}e.$QP=w;class y{static{this.Void=new y("no result",I=>I)}constructor(I,k){this.description=I,this.convert=k}}e.$RP=y;class D{constructor(I,k,b,v,N){this.id=I,this.internalId=k,this.description=b,this.args=v,this.result=N}}e.$SP=D}),define(Ee[367],Se([1,0,19,15,2,88,143,36,35,17,10]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0,R=Ue(R),l=Ue(l),C=Ue(C);const E=[new $.$SP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of DocumentHighlight-instances.",P(l.DocumentHighlight.to))),new $.$SP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$QP.Uri],new $.$RP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,r.$Lb)(c))return;class f extends C.$hN{static to(n){const o=new f(n.name,l.SymbolKind.to(n.kind),n.containerName||"",new C.$aN(g[0],l.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=l.Range.to(n.selectionRange),o.children=n.children?n.children.map(f.to):[],o}}return c.map(f.to)})),new $.$SP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$QP.Uri,new $.$QP("options","Formatting options",c=>!0,c=>c)],new $.$RP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$SP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$QP.Uri,$.$QP.Range,new $.$QP("options","Formatting options",c=>!0,c=>c)],new $.$RP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$SP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$QP.Uri,$.$QP.Position,new $.$QP("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$QP("options","Formatting options",c=>!0,c=>c)],new $.$RP("A promise that resolves to an array of TextEdits.",P(l.TextEdit.to))),new $.$SP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$SP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$SP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$SP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Location or LocationLink instances.",p)),new $.$SP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Location-instances.",P(l.location.to))),new $.$SP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of Hover-instances.",P(l.Hover.to))),new $.$SP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$QP.Uri,new $.$QP("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>C.$2M.isPosition(g)),c=>c.map(l.Position.from))],new $.$RP("A promise that resolves to an array of ranges.",c=>c.map(g=>{let f;for(const m of g.reverse())f=new C.$lN(l.Range.to(m),f);return f}))),new $.$SP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$QP.String.with("query","Search string")],new $.$RP("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(l.WorkspaceSymbol.to))),new $.$SP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(l.CallHierarchyItem.to))),new $.$SP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$QP.CallHierarchyItem],new $.$RP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(l.CallHierarchyIncomingCall.to))),new $.$SP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$QP.CallHierarchyItem],new $.$RP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(l.CallHierarchyOutgoingCall.to))),new $.$SP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:l.Range.to(c.range),placeholder:c.text}})),new $.$SP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$QP.Uri,$.$QP.Position,$.$QP.String.with("newName","The new symbol name")],new $.$RP("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return l.WorkspaceEdit.to(c)}})),new $.$SP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$QP.Uri,$.$QP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$RP("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(l.DocumentLink.to))),new $.$SP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$QP.Uri],new $.$RP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new C.$hO(c.tokenTypes,c.tokenModifiers)})),new $.$SP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$QP.Uri],new $.$RP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,L.$Fcb)(c);if(g.type==="full")return new C.$jO(g.data,void 0)})),new $.$SP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$QP.Uri,$.$QP.Range.optional()],new $.$RP("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new C.$hO(c.tokenTypes,c.tokenModifiers)})),new $.$SP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$QP.Uri,$.$QP.Range],new $.$RP("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,L.$Fcb)(c);if(g.type==="full")return new C.$jO(g.data,void 0)})),new $.$SP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$QP.Uri,$.$QP.Position,$.$QP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$QP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$RP("A promise that resolves to a CompletionList-instance.",(c,g,f)=>{if(!c)return new C.$xN([]);const m=c.suggestions.map(n=>l.CompletionItem.to(n,f));return new C.$xN(m,c.incomplete)})),new $.$SP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$QP.Uri,$.$QP.Position,$.$QP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$RP("A promise that resolves to SignatureHelp.",c=>{if(c)return l.SignatureHelp.to(c)})),new $.$SP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$QP.Uri,$.$QP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$RP("A promise that resolves to an array of CodeLens-instances.",(c,g,f)=>P(m=>new C.$pN(l.Range.to(m.range),m.command&&f.fromInternal(m.command)))(c))),new $.$SP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$QP.Uri,new $.$QP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>C.$3M.isRange(c),c=>C.$4M.isSelection(c)?l.Selection.from(c):l.Range.from(c)),$.$QP.String.with("kind","Code action kind to return code actions for").optional(),$.$QP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$RP("A promise that resolves to an array of Command-instances.",(c,g,f)=>P(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(m.command)}else{const n=new C.$jN(m.title,m.kind?new C.$kN(m.kind):void 0);return m.edit&&(n.edit=l.WorkspaceEdit.to(m.edit)),m.command&&(n.command=f.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(c))),new $.$SP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$QP.Uri],new $.$RP("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new C.$DN(l.Range.to(g.range),l.Color.to(g.color))):[])),new $.$SP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$QP("color","The color to show and insert",c=>c instanceof C.$CN,l.Color.from),new $.$QP("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:l.Range.from(c.range)}))],new $.$RP("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(l.ColorPresentation.to):[])),new $.$SP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$QP.Uri,$.$QP.Range],new $.$RP("A promise that resolves to an array of Inlay objects",(c,g,f)=>c.map(l.InlayHint.to.bind(void 0,f)))),new $.$SP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$QP.Uri],new $.$RP("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(l.FoldingRange.to)})),new $.$SP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$RP("A promise that resolves to an array of NotebookContentProvider static info objects.",P(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.to(g))})))),new $.$SP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$QP.Uri,$.$QP.Range,new $.$QP("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof C.$3M,c=>l.InlineValueContext.from(c))],new $.$RP("A promise that resolves to an array of InlineValue objects",c=>c.map(l.InlineValue.to))),new $.$SP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$QP("uriOrString","Uri-instance or string (only http/https)",c=>A.URI.isUri(c)||typeof c=="string"&&(0,h.$Mg)(c,h.Schemas.http,h.Schemas.https),c=>c),new $.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional(),$.$QP.String.with("label","").optional()],$.$RP.Void),new $.$SP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$QP.Uri.with("resource","Resource to open"),$.$QP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional()],$.$RP.Void),new $.$SP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$QP.Uri.with("left","Left-hand side resource of the diff editor"),$.$QP.Uri.with("right","Right-hand side resource of the diff editor"),$.$QP.String.with("title","Human readable title for the diff editor").optional(),new $.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)]).optional()],$.$RP.Void),new $.$SP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$QP.String.with("title","Human readable title for the changes editor"),new $.$QP("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[f,m,n]=g;if(!A.URI.isUri(f)||!A.URI.isUri(m)&&m!==void 0&&m!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],$.$RP.Void),new $.$SP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$QP.Uri,$.$QP.Position],new $.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$SP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$QP.TypeHierarchyItem],new $.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$SP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$QP.TypeHierarchyItem],new $.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$SP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$QP.TestItem],$.$RP.Void),new $.$SP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$QP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$RP.Void),new $.$SP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$QP.String.with("name","The context key name"),new $.$QP("value","The context key value",()=>!0,c=>c)],$.$RP.Void),new $.$SP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$QP.Uri,$.$QP.StringArray,new $.$QP("MappedEditsContext","Mapped Edits Context",c=>l.MappedEditsContext.is(c),c=>l.MappedEditsContext.from(c))],new $.$RP("A promise that resolves to a workspace edit or null",c=>c?l.WorkspaceEdit.to(c):null)),new $.$SP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$QP("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?l.Range.from(c.initialRange):void 0,initialSelection:C.$4M.isSelection(c.initialSelection)?l.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?l.Position.from(c.position):void 0}})],$.$RP.Void)];class u{static register(g){E.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",T.$Bj)}}e.$hnc=u;function P(c){return g=>{if(Array.isArray(g))return g.map(c)}}function p(c){if(!Array.isArray(c))return;const g=[];for(const f of c)R.$Bu(f)?g.push(l.DefinitionLink.to(f)):g.push(l.location.to(f));return g}}),define(Ee[368],Se([1,0,2,35]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;class A{constructor(L,T,$,l,C){this.a=T,this.b=$,this.c=l;const E=new h.$SP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$QP("showOptions","Show Options",u=>!0,u=>u),new h.$QP("resource","Interactive resource Uri",u=>!0,u=>u),new h.$QP("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$QP("title","Interactive editor title",u=>!0,u=>u)],new h.$RP("Notebook and input URI",u=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const P=this.a.getEditorById(u.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:P.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(L,T,$,l){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Ioc=A}),define(Ee[369],Se([1,0,19,9,21,4,3,29,2,24,12,6,35,17,10,122,311,26,51,312]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=void 0,e.$Qoc=w,P=Ue(P);let o=class{constructor(D,S,I,k,b){this.m=S,this.n=I,this.o=k,this.q=b,this.b=new T.$Bc,this.c=new T.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(E.$YM.MainThreadNotebookKernels);const v=new u.$SP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$QP("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const F=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:F}}else if(O&&"notebookEditor"in O){const F=this.n.getIdByEditor(O.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return O})],u.$RP.Void),N=new u.$SP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$QP.Uri],new u.$RP("A promise that resolves to an array of variables",(O,F)=>O.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(N)}createNotebookController(D,S,I,k,b,v){for(const ne of this.j.values())if(ne.controller.id===S&&l.$nn.equals(D.identifier,ne.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${D.identifier.value}, ${S}`);const F=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${D.identifier}'`);let j=!1;const B=new R.$je,M=new R.$je,W={id:w(D.identifier,S),notebookType:I,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let _=b??F,re,z;this.a.$addKernel(N,W).catch(ne=>{console.log(ne),j=!0});let G=0;const J=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(N,W)})},ee=new T.$Bc,ue={get id(){return S},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return W.label},set label(ne){W.label=ne??D.displayName??D.name,J()},get detail(){return W.detail??""},set detail(ne){W.detail=ne,J()},get description(){return W.description??""},set description(ne){W.description=ne,J()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(ne){W.supportedLanguages=ne,J()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){W.supportsExecutionOrder=ne,J()},get rendererScripts(){return W.preloads?W.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return _},set executeHandler(ne){_=ne??F},get interruptHandler(){return re},set interruptHandler(ne){re=ne,W.supportsInterrupt=!!ne,J()},set variableProvider(ne){(0,f.$2G)(D,"notebookVariableProvider"),z=ne,W.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>O.a.$variablesUpdated(De.uri)),J()},get variableProvider(){return z},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return O._createNotebookCellExecution(ne,w(D.identifier,this.id))},createNotebookExecution(ne){if((0,f.$2G)(D,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return O._createNotebookExecution(ne,w(D.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),B.dispose(),M.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ne,De){De===p.NotebookControllerAffinity2.Hidden&&(0,f.$2G)(D,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,ne.uri,De)},onDidReceiveMessage:M.event,postMessage(ne,De){return(0,f.$2G)(D,"notebookMessaging"),O.a.$postMessage(N,De&&O.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,f.$2G)(D,"notebookMessaging"),(0,c.$iCb)(ne,O.m.remote)}};return this.j.set(N,{extensionId:D.identifier,controller:ue,onDidReceiveMessage:M,onDidChangeSelection:B,associatedNotebooks:ee}),ue}getIdByController(D){for(const[S,I]of this.j)if(I.controller===D)return w(I.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,S){const I=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(I,S);const b={dispose:()=>{this.f.delete(I),k.a.$removeKernelDetectionTask(I)}};return this.f.set(I,b),b}registerKernelSourceActionProvider(D,S,I){const k=this.i++,b=typeof I.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,v=this;this.h.set(k,I),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,S);let N;return b!==void 0&&(N=I.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(k),v.a.$removeKernelSourceActionProvider(k,k),N?.dispose()}}}async $provideKernelSourceActions(D,S){const I=this.h.get(D);if(I){const k=new L.$Uc;return(await I.provideNotebookKernelSourceActions(S)??[]).map(v=>P.NotebookKernelSourceAction.from(v,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,S,I){const k=this.j.get(D);if(k){const b=this.n.getNotebookDocument($.URI.revive(S));I?k.associatedNotebooks.set(b.uri,!0):k.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,b.uri.toString(),I),k.onDidChangeSelection.fire({selected:I,notebook:b.apiNotebook})}}async $executeCells(D,S,I){const k=this.j.get(D);if(!k)return;const b=this.n.getNotebookDocument($.URI.revive(S)),v=[];for(const N of I){const O=b.getCell(N);O&&v.push(O.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,b.uri.toString(),v.length),await k.controller.executeHandler.call(k.controller,v,b.apiNotebook,k.controller)}catch(N){this.q.error(`NotebookController[${D}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(D,S,I){const k=this.j.get(D);if(!k)return;const b=this.n.getNotebookDocument($.URI.revive(S));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,b.apiNotebook);else for(const v of I){const N=b.getCell(v);N&&this.b.get(N.uri)?.cancel()}if(k.controller.interruptHandler){const v=this.c.get(b.uri);this.c.delete(b.uri),I.length&&Array.isArray(v)&&v.length&&v.forEach(N=>N.dispose())}}async $provideVariables(D,S,I,k,b,v,N){const O=this.j.get(D);if(!O)return;const F=this.n.getNotebookDocument($.URI.revive(I)),j=O.controller.variableProvider;if(!j)return;let B;if(k!==void 0){if(B=this.s[k],!B)return}else this.s={};const M=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,W=j.provideVariables(F.apiNotebook,B,M,v,N);let _=0;for await(const re of W){if(N.isCancellationRequested)return;const z={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[z.id]=re.variable,this.a.$receiveVariable(S,z),_++>=n.$6jb)return}}$acceptKernelMessageFromRenderer(D,S,I){const k=this.j.get(D);if(!k)return;const b=this.n.getEditorById(S);k.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:I}))}$cellExecutionChanged(D,S,I){const b=this.n.getNotebookDocument($.URI.revive(D)).getCell(S);if(b){const v=I?P.NotebookCellExecutionState.to(I):p.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(D,S){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const b=new t(S,k,this.a);this.b.set(k.uri,b);const v=b.onDidChangeState(()=>{b.state===i.Resolved&&(b.dispose(),v.dispose(),this.b.delete(k.uri))});return b.asApiObject()}_createNotebookExecution(D,S){const I=this.n.getNotebookDocument(D.uri),k=D.getCells().find(N=>{const O=I.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const b=new d(S,I,this.a),v=b.onDidChangeState(()=>{b.state===s.Resolved&&(b.dispose(),v.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[b,v]),b.asApiObject()}};e.$Poc=o,e.$Poc=o=Ye([qe(4,C.$9j)],o);var i;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(i||(i={}));class t extends L.$Vc{static{this.a=0}get state(){return this.f}constructor(D,S,I){super(),this.m=S,this.n=I,this.b=t.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new A.$ue),this.h=new a(10,k=>this.s(k)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const S=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new m.$Nw(S))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let S=this.m;if(D&&(S=this.m.notebook.getCellFromApiCell(D)),!S)throw new Error("INVALID cell");return S.handle}y(D){return D.map(S=>{const I=p.$uO.ensureUniqueMimeTypes(S.items,!0);return I===S.items?P.NotebookCellOutput.from(S):P.NotebookCellOutput.from({items:I,id:S.id,metadata:S.metadata})})}async z(D,S,I){const k=this.w(S),b=this.y((0,r.$3b)(D));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:k,append:I,outputs:b})}async C(D,S,I){return D=p.$uO.ensureUniqueMimeTypes((0,r.$3b)(D),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:S.id,append:I})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(I){D.j=I,D.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(I){if(D.f===i.Resolved||D.f===i.Started)throw new Error("Cannot call start again");D.f=i.Started,D.c.fire(),D.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,k,b){if(D.f===i.Resolved)throw new Error("Cannot call resolve twice");D.f=i.Resolved,D.c.fire(),D.h.flush();const v=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;D.n.$completeExecution(D.b,new m.$Nw({runEndTime:k,lastRunSuccess:I,error:v}))},clearOutput(I){return D.t(),D.z([],I,!1)},appendOutput(I,k){return D.t(),D.z(I,k,!0)},replaceOutput(I,k){return D.t(),D.z(I,k,!1)},appendOutputItems(I,k){return D.t(),D.C(I,k,!0)},replaceOutputItems(I,k){return D.t(),D.C(I,k,!1)}})}}var s;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(s||(s={}));class d extends L.$Vc{static{this.a=0}get state(){return this.f}constructor(D,S,I){super(),this.h=S,this.j=I,this.b=d.a++,this.c=new R.$je,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new A.$ue),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(D,S){this.f=D,this.g=S,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new h.$Zh,this.b=Date.now(),(0,h.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>D.complete())}}function w(y,D){return`${y.value}/${D}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,10,241,14,290,21,32,291,292,50,9,17,35,41]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=e.$Xnc=e.$Wnc=e.$Vnc=void 0,e.$Vnc=(0,A.$Ci)("IExtHostTerminalService");class i extends T.$Vc{constructor(b,v,N,O){super(),this.u=b,this._id=v,this.w=N,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const F=this;this.value={get name(){return F.y||""},get processId(){return F.b},get creationOptions(){return F.w},get exitStatus(){return F.j},get state(){return F.m},get selection(){return F.n},get shellIntegration(){return F.shellIntegration},sendText(j,B=!0){F.C(),F.u.$sendText(F._id,j,B)},show(j){F.C(),F.u.$show(F._id,j)},hide(){F.C(),F.u.$hide(F._id)},dispose(){F.a||(F.a=!0,F.u.$dispose(F._id))},get dimensions(){if(!(F.f===void 0||F.h===void 0))return{columns:F.f,rows:F.h}}}}dispose(){this.s.fire(),super.dispose()}async create(b,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??v?.cwd??void 0,env:b.env??void 0,icon:D(b.iconPath)??void 0,color:g.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(b.location,v?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,v,N,O,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:g.ThemeColor.isThemeColor(F)?F.id:void 0,location:v?.location||this.z(b,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(b,v){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in b?{viewColumn:m.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.y=b}setExitStatus(b,v){this.j=Object.freeze({code:b,reason:v})}setDimensions(b,v){return b===this.f&&v===this.h||b===0||v===0?!1:(this.f=b,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(b){this.n=b}_setProcessId(b){this.g?(this.g(b),this.g=void 0):this.b.then(v=>{v!==b&&(this.b=Promise.resolve(b))})}}e.$Wnc=i;class t{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new r.$je,this.onProcessData=this.a.event,this.b=new r.$je,this.d=new r.$je,this.onDidChangeProperty=this.d.event,this.f=new r.$je,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,v){this.g.setDimensions?.({columns:b,rows:v})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:p.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:p.ProcessPropertyType.Title,value:v})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,d=class extends T.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,v,N){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$je,this.onDidCloseTerminal=this.H.event,this.I=new r.$je,this.onDidOpenTerminal=this.I.event,this.J=new r.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$je,this.onDidChangeTerminalState=this.M.event,this.N=new r.$je,this.onDidChangeShell=this.N.event,this.O=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(h.$YM.MainThreadTerminalService),this.y=new c.$Gwb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:O=>{const F=j=>{const B=j;return this.getTerminalById(B.instanceId)?.value};switch(O?.$mid){case o.MarshalledId.TerminalContext:return F(O);default:{if(Array.isArray(O))for(let j=0;j<O.length&&O[j].$mid===o.MarshalledId.TerminalContext;j++)O[j]=F(O[j]);return O}}}}),this.B({dispose:()=>{for(const[O,F]of this.g)F.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,v){const N=new i(this.a,(0,P.$Yg)(),b,b.name),O=new t(b.pty);return N.createExtensionTerminal(b.location,v,this.R(b,v).resolvedExtHostIdentifier,D(b.iconPath),S(b.color)).then(F=>{const j=this.S(F,O);this.h[F]=j}),this.f.push(N),N.value}R(b,v){if(v=v||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const N=b.location.parentTerminal;if(N){const O=this.f.find(F=>F.value===N);O&&(v.resolvedExtHostIdentifier=O._id)}}else b.location&&typeof b.location!="object"?v.location=b.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(b,v){if(!this.getTerminalById(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const O=new t(v),F=this.S(b,O);this.h[b]=F}async $acceptActiveTerminalChanged(b){const v=this.b;if(b===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(b);N&&(this.b=N,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,v){const N=this.getTerminalById(b);N&&this.O.fire({terminal:N.value,data:v})}async $acceptTerminalDimensions(b,v,N){const O=this.getTerminalById(b);O&&O.setDimensions(v,N)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(b,v){const N=this.getTerminalById(b);N&&this.P.fire({terminal:N.value,...v})}async $acceptTerminalMaximumDimensions(b,v,N){this.g.get(b)?.resize(v,N)}async $acceptTerminalTitleChange(b,v){const N=this.getTerminalById(b);N&&(N.name=v)}async $acceptTerminalClosed(b,v,N){const O=this.X(this.f,b);if(O!==null){const F=this.f.splice(O,1)[0];F.setExitStatus(v,N),this.H.fire(F.value)}}$acceptTerminalOpened(b,v,N,O){if(v){const B=this.X(this.f,v);if(B!==null){this.f[B]._id=b,this.I.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const F={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:R.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},j=new i(this.a,b,F,N);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(b,v){this.getTerminalById(b)?._setProcessId(v)}async $startExtensionTerminal(b,v){const N=this.getTerminalById(b);if(!N)return{message:(0,l.localize)(0,null,b)};N.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async B=>{B===N.value&&(j.dispose(),F())})});const O=this.g.get(b);O?O.startSendingEvents(v):this.j[b]={initialDimensions:v}}S(b,v){const N=new T.$Uc;N.add(v.onProcessReady(F=>this.a.$sendProcessReady(b,F.pid,F.cwd,F.windowsPty))),N.add(v.onDidChangeProperty(F=>this.a.$sendProcessProperty(b,F))),this.y.startBuffering(b,v.onProcessData),N.add(v.onProcessExit(F=>this.U(b,F))),this.g.set(b,v);const O=this.j[b];return O&&v instanceof t&&(v.startSendingEvents(O.initialDimensions),delete this.j[b]),N}$acceptProcessAckDataEvent(b,v){this.g.get(b)?.acknowledgeDataEvent(v)}$acceptProcessInput(b,v){this.g.get(b)?.input(v)}$acceptTerminalInteraction(b){const v=this.getTerminalById(b);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(b,v){this.getTerminalById(b)?.setSelection(v)}$acceptProcessResize(b,v,N){try{this.g.get(b)?.resize(v,N)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(b,v){this.g.get(b)?.shutdown(v)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(v=>this.a.$sendProcessProperty(b,{type:p.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$1M(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,v,N){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,N),this.a.$registerProfileProvider(v,b.identifier.value),new $.$1M(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(b,v,N){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,N),this.a.$registerQuickFixProvider(b,v),new $.$1M(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,v){const N=new u.$ue().token;if(N.isCancellationRequested)return;const O=this.D.get(b);if(!O)return;const F=await O.provideTerminalQuickFixes(v,N);if(F===null||Array.isArray(F)&&F.length===0)return;const j=new T.$Uc;if(this.w.value=j,!Array.isArray(F))return F?m.TerminalQuickFix.from(F,this.Q.converter,j):void 0;const B=[];for(const M of F){const W=m.TerminalQuickFix.from(M,this.Q.converter,j);W&&B.push(W)}return B}async $createContributedProfileTerminal(b,v){const N=new u.$ue().token;let O=await this.C.get(b)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,v);return}this.createTerminalFromOptions(O.options,v)}}async $provideLinks(b,v){const N=this.getTerminalById(b);if(!N)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const F=new u.$ue;this.G.set(b,F);const j=[],B={terminal:N.value,line:v},M=[];for(const re of this.z)M.push(f.Promises.withAsyncBody(async z=>{F.token.onCancellationRequested(()=>z({provider:re,links:[]}));const G=await re.provideTerminalLinks(B,F.token)||[];F.token.isCancellationRequested||z({provider:re,links:G})}));const W=await Promise.all(M);if(F.token.isCancellationRequested)return[];const _=new Map;for(const re of W)re&&re.links.length>0&&j.push(...re.links.map(z=>{const G={id:s++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return _.set(G.id,{provider:re.provider,link:z}),G}));return this.F.set(b,_),j}$activateLink(b,v){const N=this.F.get(b)?.get(v);N&&N.provider.handleTerminalLink(N.link)}U(b,v){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const N=this.h[b];N&&(N.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,v)}getTerminalById(b){return this.W(this.f,b)}getTerminalIdByApiObject(b){const v=this.f.findIndex(N=>N.value===b);return v>=0?v:null}W(b,v){const N=this.X(b,v);return N!==null?b[N]:null}X(b,v){const N=b.findIndex(O=>O._id===v);return N>=0?N:null}getEnvironmentVariableCollection(b){let v=this.n.get(b.identifier.value);return v||(v=this.B(new a),this.Z(b.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(b,v){const N=(0,E.$ws)(v.map),O=(0,E.$xs)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(b,v.persistent,N.length===0?void 0:N,O)}$initEnvironmentVariableCollections(b){b.forEach(v=>{const N=v[0],O=this.B(new a(v[1]));this.Z(N,O)})}$acceptDefaultProfile(b,v){const N=this.s;this.s=b,this.u=v,N?.path!==b.path&&this.N.fire(b.path)}Z(b,v){this.n.set(b,v),this.B(v.onDidChangeCollection(()=>{this.Y(b,v)}))}};e.$Xnc=d,e.$Xnc=d=Ye([qe(1,n.$OP),qe(2,L.$sP)],d);class a extends T.$Vc{get persistent(){return this.b}set persistent(b){this.b=b,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(b){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$je,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const v=this.j(b);let N=this.a.get(v);return N||(N=new w(this,b),this.a.set(v,N),this.B(N.onDidChangeCollection(()=>this.f.fire()))),N}replace(b,v,N,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:O})}append(b,v,N,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:O})}prepend(b,v,N,O){this.g(b,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:O})}g(b,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.h(b,v.scope),O=this.map.get(N),F=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==v.value||O.type!==v.type||O.options?.applyAtProcessCreation!==F.applyAtProcessCreation||O.options?.applyAtShellIntegration!==F.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(b,v.scope),B={variable:b,...v,options:F};this.map.set(j,B),this.f.fire()}}get(b,v){const N=this.h(b,v),O=this.map.get(N);return O?I(O):void 0}h(b,v){const N=this.j(v);return N.length?`${b}:::${N}`:b}j(b){return this.m(b?.workspaceFolder)??""}m(b){return b?b.uri.toString():void 0}getVariableMap(b){const v=new Map;for(const[N,O]of this.map)this.j(O.scope)===this.j(b)&&v.set(O.variable,I(O));return v}delete(b,v){const N=this.h(b,v);this.map.delete(N),this.f.fire()}clear(b){if(b?.workspaceFolder){for(const[v,N]of this.map)N.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(v);this.n(b)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(b,v){const N=this.j(v),O=this.descriptionMap.get(N);if(!O||O.description!==b){let F;typeof b=="string"?F=b:F=b?.value.split(`

`)[0];const j={description:F,scope:v};this.descriptionMap.set(N,j),this.f.fire()}}getDescription(b){const v=this.j(b);return this.descriptionMap.get(v)?.description}n(b){const v=this.j(b);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,v){this.b=b,this.d=v,this.a=new r.$je}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,v,N){this.b.replace(b,v,N,this.d)}append(b,v,N){this.b.append(b,v,N,this.d)}prepend(b,v,N){this.b.prepend(b,v,N,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,v){this.b.getVariableMap(this.d).forEach((N,O)=>b.call(v,O,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends d{constructor(b,v){super(!1,b,v)}createTerminal(b,v,N){throw new C.$ab}createTerminalFromOptions(b,v){throw new C.$ab}};e.$Ync=y,e.$Ync=y=Ye([qe(0,n.$OP),qe(1,L.$sP)],y);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function S(k){return g.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const b={...k};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Ee[166],Se([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=void 0,e.$8oc=(0,A.$Ci)("IExtHostTerminalShellIntegration");let E=class extends h.$Vc{constructor(g,f){super(),this.h=f,this.b=new Map,this.c=new $.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$YM.MainThreadTerminalShellIntegration),this.B((0,h.$Tc)(()=>{for(const[m,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(g){const f=this.h.getTerminalById(g);if(!f)return;const m=f.value;let n=this.b.get(g);n||(n=new u(f.value,this.f),this.b.set(g,n),n.store.add(f.onWillDispose(()=>this.b.get(g)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(g,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),f.shellIntegration=n.value),this.c.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(g,f,m,n,o){this.b.has(g)||this.$shellIntegrationChange(g);const i={value:f,confidence:m,isTrusted:n};this.b.get(g)?.startShellExecution(i,o)}$shellExecutionEnd(g,f,m,n,o){const i={value:f,confidence:m,isTrusted:n};this.b.get(g)?.endShellExecution(i,o)}$shellExecutionData(g,f){this.b.get(g)?.emitData(f)}$cwdChange(g,f){this.b.get(g)?.setCwd((0,l.$wc)(f)?l.URI.revive(f):f)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$9oc=E,e.$9oc=E=Ye([qe(0,L.$sP),qe(1,T.$Vnc)],E);class u extends h.$Vc{get currentExecution(){return this.a}constructor(g,f){super(),this.j=g,this.m=f,this.b=!1,this.store=this.B(new h.$Uc),this.f=this.B(new $.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$je),this.onDidRequestEndExecution=this.h.event;const m=this;this.value={get cwd(){return m.c},executeCommand(n,o){let i=n;o&&(i+=` "${o.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),m.g.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=m.startShellExecution(t,m.c,!0).value;return m.b=!0,s}}}startShellExecution(g,f,m){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new P(g,f);m?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,f){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:f}),this.a=void 0)}setCwd(g){let f=!1;l.URI.isUri(this.c)?f=!l.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(f=!0),f&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(g,f){this.c=g,this.cwd=f,this.b=!1;const m=this;this.value={get commandLine(){return m.c},get cwd(){return m.cwd},read(){return m.d()}}}d(){if(!this.a){if(this.b)return C.$3h.EMPTY;this.a=new p}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class p extends h.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new C.$Bh);const g=this.a;return new C.$3h(async m=>{this.b.push(m),await g.wait()})}emitData(g){for(const f of this.b)f.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ee[167],Se([1,0,66,14,133,17,10]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=e.$zP=void 0,R=Ue(R);class T{static{this.c=new A.$xP("TextEditorDecorationType")}constructor(u,P,p){const c=T.c.nextId();u.$registerTextEditorDecorationType(P.identifier,c,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:c,dispose(){u.$removeTextEditorDecorationType(c)}})}}e.$zP=T;class ${constructor(u,P){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,P){this.k();let p=null;if(u instanceof L.$2M)p=new L.$3M(u,u);else if(u instanceof L.$3M)p=u;else throw new Error("Unrecognized location");this.l(p,P,!1)}insert(u,P){this.k(),this.l(new L.$3M(u,u),P,!0)}delete(u){this.k();let P=null;if(u instanceof L.$3M)P=u;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(u,P,p){const c=this.c.validateRange(u);this.g.push({range:c,text:P,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,h.$8)("endOfLine");this.h=u}}class l{constructor(u,P,p,c){this.c=u,this.d=P,this._accept(p),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(f){g.n(f)},get indentSize(){return g.g},set indentSize(f){g.p(f)},get insertSpaces(){return g.j},set insertSpaces(f){g.s(f)},get cursorStyle(){return g.k},set cursorStyle(f){g.t(f)},get lineNumbers(){return g.l},set lineNumbers(f){g.u(f)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}n(u){const P=this.m(u);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const P=Math.floor(u);return P>0?P:null}if(typeof u=="string"){const P=parseInt(u,10);return isNaN(P)?null:P>0?P:null}return null}p(u){const P=this.o(u);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const P=this.q(u);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const P={};let p=!1;if(typeof u.tabSize<"u"){const c=this.m(u.tabSize);c==="auto"?(p=!0,P.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,p=!0,P.tabSize=c)}if(typeof u.indentSize<"u"){const c=this.o(u.indentSize);c==="tabSize"?(p=!0,P.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,p=!0,P.indentSize=c)}if(typeof u.insertSpaces<"u"){const c=this.q(u.insertSpaces);c==="auto"?(p=!0,P.insertSpaces=c):this.j!==c&&(this.j=c,p=!0,P.insertSpaces=c)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,p=!0,P.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,p=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(u,P){P.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$AP=l;class C{constructor(u,P,p,c,g,f,m,n){this.id=u,this.j=P,this.k=p,this.g=!1,this.h=new Set,this.c=g,this.d=new l(this.j,this.id,f,p),this.e=m,this.f=n;const o=this;this.value=Object.freeze({get document(){return c.value},set document(i){throw new h.$0("document")},get selection(){return o.c&&o.c[0]},set selection(i){if(!(i instanceof L.$4M))throw(0,h.$8)("selection");o.c=[i],o.l()},get selections(){return o.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof L.$4M)))throw(0,h.$8)("selections");o.c=i,o.l()},get visibleRanges(){return o.e},set visibleRanges(i){throw new h.$0("visibleRanges")},get options(){return o.d.value},set options(i){o.g||o.d.assign(i)},get viewColumn(){return o.f},set viewColumn(i){throw new h.$0("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(c.value,t);return i(s),o.m(s)},insertSnippet(i,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(a=>R.Range.from(a));else if(t instanceof L.$2M){const{lineNumber:a,column:w}=R.Position.from(t);d=[{startLineNumber:a,startColumn:w,endLineNumber:a,endColumn:w}]}else if(t instanceof L.$3M)d=[R.Range.from(t)];else{d=[];for(const a of t)if(a instanceof L.$3M)d.push(R.Range.from(a));else{const{lineNumber:w,column:y}=R.Position.from(a);d.push({startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y})}}return P.$tryInsertSnippet(u,c.value.version,i.value,d,s)},setDecorations(i,t){const s=t.length===0;s&&!o.h.has(i.key)||(s?o.h.delete(i.key):o.h.add(i.key),o.n(()=>{if(R.$pP(t))return P.$trySetDecorations(u,i.key,R.$qP(t));{const d=new Array(4*t.length);for(let a=0,w=t.length;a<w;a++){const y=t[a];d[4*a]=y.start.line+1,d[4*a+1]=y.start.character+1,d[4*a+2]=y.end.line+1,d[4*a+3]=y.end.character+1}return P.$trySetDecorationsFast(u,i.key,d)}}))},revealRange(i,t){o.n(()=>P.$tryRevealRange(u,R.Range.from(i),t||L.TextEditorRevealType.Default))},show(i){P.$tryShowEditor(u,R.ViewColumn.from(i))},hide(){P.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const P=u.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const p=P.edits.map(g=>g.range);p.sort((g,f)=>g.end.line===f.end.line?g.end.character===f.end.character?g.start.line===f.start.line?g.start.character-f.start.character:g.start.line-f.start.line:g.end.character-f.end.character:g.end.line-f.end.line);for(let g=0,f=p.length-1;g<f;g++){const m=p[g].end;if(p[g+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=P.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,c,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$BP=C}),define(Ee[64],Se([1,0,66,4,3,2,5,6,163,20,167,17,12,29,15,40,49]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,r=Ue(r),E=Ue(E);class f{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(o,i){this.h=o,this.i=i,this.a=null,this.b=new Map,this.c=new P.$Bc,this.d=new h.$je,this.e=new h.$je,this.f=new h.$je,this.g=new h.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const i=[],t=[],s=[];if(o.removedDocuments)for(const d of o.removedDocuments){const a=R.URI.revive(d),w=this.c.get(a);w?.unref()&&(this.c.delete(a),i.push(w.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const a=R.URI.revive(d.uri);let w=this.c.get(a);if(w&&a.scheme!==p.Schemas.vscodeNotebookCell&&a.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);w||(w=new f(new $.$vP(this.h.getProxy(T.$YM.MainThreadDocuments),a,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(a,w),t.push(w.value)),w.ref()}if(o.removedEditors)for(const d of o.removedEditors){const a=this.b.get(d);this.b.delete(d),a&&s.push(a)}if(o.addedEditors)for(const d of o.addedEditors){const a=R.URI.revive(d.documentUri);r.ok(this.c.has(a),`document '${a}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const w=this.c.get(a).value,y=new C.$BP(d.id,this.h.getProxy(T.$YM.MainThreadTextEditors),this.i,new g.$W(()=>w.document),d.selections.map(E.Selection.to),d.options,d.visibleRanges.map(D=>E.Range.to(D)),typeof d.editorPosition=="number"?E.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,y)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Qc)(i),(0,A.$Qc)(s),o.removedDocuments&&this.e.fire(i),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return c.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const i=this.b.get(this.a);return o?i:i?.value}allEditors(){return[...this.b.values()]}};e.$CP=m,e.$CP=m=Ye([qe(0,l.$sP),qe(1,u.$9j)],m),e.$DP=(0,L.$Ci)("IExtHostDocumentsAndEditors")}),define(Ee[99],Se([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,165,17,10,314,74,121,75,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=e.$goc=e.$foc=e.$eoc=e.$doc=void 0,n=Ue(n);let w=0;const y=new WeakMap;e.$doc=(0,u.$Ci)("IExtHostTesting");let D=class extends $.$Vc{constructor(z,G,J,ee){super(),this.C=G,this.D=J,this.F=ee,this.f=this.B(new R.$je),this.g=new Map,this.w=this.B(new R.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=z.getProxy(p.$YM.MainThreadTesting),this.m=new j(this.h),this.j=new b(this.h,G),J.registerArgumentProcessor({processArgument:ue=>{switch(ue?.$mid){case l.MarshalledId.TestItemContext:{const ne=ue,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(t.$MI.root(De))?.collection.tree.get(De)?.actual??(0,m.$EP)(ue)}case l.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=ue,$e=ne.item.extId;return{test:this.g.get(t.$MI.root($e))?.collection.tree.get($e)?.actual??(0,m.$EP)({$mid:l.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return ue}}}),J.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ue=await J.executeCommand(i.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(t.$MI.root(De));if($e)return t.$MI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:ue?.include.map(ne).filter(C.$kg)||[],exclude:ue?.exclude.map(ne).filter(C.$kg)||[]}})}createTestController(z,G,J,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const ue=new $.$Uc,ne=ue.add(new m.$HP(G,J,this.F));ne.root.label=J;const De=new Map,$e=new Set,Q=this.h,U={items:ne.root.children,get label(){return J},set label(oe){J=oe,ne.root.label=oe,Q.$updateController(G,{label:J})},get refreshHandler(){return ee},set refreshHandler(oe){ee=oe,Q.$updateController(G,{canRefresh:!!oe})},get id(){return G},createRunProfile:(oe,te,le,he,X,ae)=>{let pe=(0,T.$qj)(oe);for(;De.has(pe);)pe++;return new M(this.h,De,$e,this.w.event,G,pe,oe,te,le,he,X,ae)},createTestItem(oe,te,le){return new m.$FP(G,oe,te,le)},createTestRun:(oe,te,le=!0)=>this.j.createTestRun(z,G,ne,oe,te,le),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const te=oe instanceof Array?oe:[oe];this.h.$markTestRetired(te.map(le=>t.$MI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(oe){ne.resolveHandler=oe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{ue.dispose()}};Q.$registerTestController(G,J,!!ee),ue.add((0,$.$Tc)(()=>Q.$unregisterTestController(G)));const se={controller:U,collection:ne,profiles:De,extension:z,activeProfiles:$e};return this.g.set(G,se),ue.add((0,$.$Tc)(()=>this.g.delete(G))),ue.add(ne.onDidGenerateDiff(oe=>Q.$publishDiff(G,oe.map(d.TestsDiffOp.serialize)))),U}createTestObserver(){return this.m.checkout()}async runTests(z,G=A.CancellationToken.None){const J=v(z);if(!J)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(J.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:z.preserveFocus??!0,group:W[J.kind],targets:[{testIds:z.include?.map(ue=>t.$MI.fromExtHostTestItem(ue,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:J.profileId,controllerId:J.controllerId}],exclude:z.exclude?.map(ue=>ue.id)},G)}registerTestFollowupProvider(z){return this.y.add(z),{dispose:()=>{this.y.delete(z)}}}$syncTests(){for(const{collection:z}of this.g.values())z.flushDiff();return Promise.resolve()}async $getCoverageDetails(z,G){return(await this.j.getCoverageDetails(z,G))?.map(n.TestCoverage.fromDetails)}async $disposeRun(z){this.j.disposeTestRun(z)}$configureRunProfile(z,G){this.g.get(z)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(z){const G=new Map;for(const[J,ee]of Object.entries(z)){const ue=this.g.get(J);if(!ue)continue;const ne=new Map,De=ee.filter(Q=>!ue.activeProfiles.has(Q)),$e=[...ue.activeProfiles].filter(Q=>!ee.includes(Q));for(const Q of De)ne.set(Q,!0),ue.activeProfiles.add(Q);for(const Q of $e)ne.set(Q,!1),ue.activeProfiles.delete(Q);ne.size&&G.set(J,ne)}this.w.fire(G)}async $refreshTests(z,G){await this.g.get(z)?.controller.refreshHandler?.(G)}$publishTestResults(z){this.results=Object.freeze(z.map(G=>{const J=n.TestResults.to(G);return y.set(J,G.id),J}).concat(this.results).sort((G,J)=>J.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(z,G){const J=this.g.get(t.$MI.fromString(z).controllerId)?.collection;J&&(await J.expand(z,G<0?1/0:G),J.flushDiff())}$acceptDiff(z){this.m.applyDiff(z.map(G=>d.TestsDiffOp.deserialize({asCanonicalUri:J=>J},G)))}async $runControllerTests(z,G){return Promise.all(z.map(J=>this.G(J,!1,G)))}async $startContinuousRun(z,G){const J=new A.$ue(G),ee=await Promise.all(z.map(ue=>this.G(ue,!0,J.token)));return!G.isCancellationRequested&&!ee.some(ue=>ue.error)&&await new Promise(ue=>G.onCancellationRequested(ue)),J.dispose(!0),ee}async $provideTestFollowups(z,G){const J=this.results.find(ne=>y.get(ne)===z.resultId),ee=J&&_(t.$MI.fromString(z.extId),J?.results);if(!ee)return[];let ue=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(J,ee,z.taskIndex,z.messageIndex,G);De&&(ue=ue.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:ue.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(z){for(const G of z)this.z.delete(G)}$executeTestFollowup(z){const G=this.z.get(z);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(z){z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(z)}getMetadataForRun(z){for(const G of this.j.trackers){const J=G.getTaskIdForRun(z);return J?{taskId:J,runId:G.id}:void 0}}async G(z,G,J){const ee=this.g.get(z.controllerId);if(!ee)return{};const{collection:ue,profiles:ne,extension:De}=ee,$e=ne.get(z.profileId);if(!$e)return{};const Q=z.testIds.map(te=>ue.tree.get(te)).filter(C.$kg),U=z.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(C.$kg).filter(te=>Q.some(le=>le.fullId.compare(te.fullId)===t.TestPosition.IsChild));if(!Q.length)return{};const se=new o.$BO(Q.some(te=>te.actual instanceof m.$GP)?void 0:Q.map(te=>te.actual),U.map(te=>te.actual),$e,G),oe=(0,d.$PI)(z)&&this.j.prepareForMainThreadTestRun(De,se,N.fromInternal(z,ee.collection),$e,J);try{return await $e.runHandler(se,J),{}}catch(te){return{error:String(te)}}finally{oe&&oe.hasRunningTasks&&!J.isCancellationRequested&&await R.Event.toPromise(oe.onEnd)}}};e.$eoc=D,e.$eoc=D=Ye([qe(0,f.$sP),qe(1,P.$9j),qe(2,c.$OP),qe(3,g.$DP)],D);const S=1e4;var I;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(I||(I={}));class k extends $.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(z,G,J,ee,ue,ne){super(),this.z=z,this.C=G,this.D=J,this.F=ee,this.G=ue,this.c=I.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$ue(ne));const De=this.B(new r.$Oh(()=>this.H(),S));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new R.$je;this.w=$e.event,this.B((0,$.$Tc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(z){for(const[G,{run:J}]of this.g)if(J===z)return G}cancel(){this.c===I.Running?(this.j.cancel(),this.c=I.Cancelling):this.c===I.Cancelling&&this.H()}getCoverageDetails(z,G){const[,J]=t.$MI.fromString(z).path,ee=this.y.get(z);if(!ee)return[];const ue=this.g.get(J);if(!ue)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(ue.run,ee,G)??[]}createRun(z){const G=this.z.id,J=this.z.controllerId,ee=(0,E.$Yg)(),ue=U=>(se,...oe)=>{if(De){this.D.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.J(se),U(se,...oe)},ne=(U,se)=>{const oe=se instanceof Array?se.map(n.TestMessage.from):[n.TestMessage.from(se)];if(U.uri&&U.range){const te={range:n.Range.from(U.range),uri:U.uri};for(const le of oe)le.location=le.location||te}this.C.$appendTestMessagesInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),oe)};let De=!1;const $e=new Map,Q={isPersisted:this.z.isPersisted,token:this.j.token,name:z,onDidDispose:this.w,addCoverage:U=>{if(De)return;const se=U instanceof o.$GO?U.testItem:void 0;let oe;se&&((0,a.$2G)(this.G,"attributableCoverage"),this.J(se),oe=$e.get(se),oe===void 0&&(oe=$e.size,$e.set(se,oe)));const te=U.uri.toString(),le=new t.$MI(oe!==void 0?[G,ee,te,String(oe)]:[G,ee,te]).toString();this.y.set(le,U),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(J,le,U))},enqueued:ue(U=>{this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),d.TestResultState.Queued)}),skipped:ue(U=>{this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),d.TestResultState.Skipped)}),started:ue(U=>{this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),d.TestResultState.Running)}),errored:ue((U,se,oe)=>{ne(U,se),this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),d.TestResultState.Errored,oe)}),failed:ue((U,se,oe)=>{ne(U,se),this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,J).toString(),d.TestResultState.Failed,oe)}),passed:ue((U,se)=>{this.C.$updateTestStateInRun(G,ee,t.$MI.fromExtHostTestItem(U,this.z.controllerId).toString(),d.TestResultState.Passed,se)}),appendOutput:(U,se,oe)=>{De||(oe&&this.J(oe),this.C.$appendOutputToRun(G,ee,h.$Le.fromString(U),se&&n.location.from(se),oe&&t.$MI.fromExtHostTestItem(oe,J).toString()))},end:()=>{De||(De=!0,$e.clear(),this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:Q}),this.C.$startedTestRunTask(G,{id:ee,name:z,running:!0}),Q}H(){for(const{run:z}of this.g.values())z.end()}I(){this.c!==I.Ended&&(this.c=I.Ended,this.m.fire())}J(z){if(!(z instanceof m.$FP))throw new s.$kP(z.id);if(this.h.has(t.$MI.fromExtHostTestItem(z,this.z.controllerId).toString()))return;const G=[],J=this.z.colllection.root;for(;;){const ee=n.TestItem.from(z);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),z===J))break;z=z.parent||J}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class b{get trackers(){return this.c.values()}constructor(z,G){this.g=z,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(z,G){const J=t.$MI.root(z);return this.f.get(J)?.getCoverageDetails(z,G)||[]}disposeTestRun(z){this.f.get(z)?.dispose(),this.f.delete(z);for(const[G,{id:J}]of this.c)J===z&&this.c.delete(G)}prepareForMainThreadTestRun(z,G,J,ee,ue){return this.j(G,J,ee,z,ue)}cancelRunById(z){this.f.get(z)?.cancel()}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,G,J,ee,ue,ne){const De=this.c.get(ee);if(De)return De.createRun(ue);const $e=N.fromPublic(G,J,ee,ne),Q=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:Q&&{group:W[Q.kind],id:Q.profileId},exclude:ee.exclude?.map(se=>t.$MI.fromExtHostTestItem(se,J.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>t.$MI.fromExtHostTestItem(se,J.root.id).toString())??[J.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const U=this.j(ee,$e,ee.profile,z);return R.Event.once(U.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),U.createRun(ue)}j(z,G,J,ee,ue){const ne=new k(G,this.g,this.h,J,ee,ue);return this.c.set(z,ne),this.f.set(ne.id,ne),ne}}e.$foc=b;const v=re=>{if(re.profile){if(!(re.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class N{static fromPublic(z,G,J,ee){return new N(z,(0,E.$Yg)(),ee,G)}static fromInternal(z,G){return new N(z.controllerId,z.runId,!0,G)}constructor(z,G,J,ee){this.controllerId=z,this.id=G,this.isPersisted=J,this.colllection=ee}}e.$goc=N;class O{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,n.TestItem.toPlain(z.item)),this.c.has(z)||this.f.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.f.delete(z);const G=t.$MI.parentId(z.item.extId);if(G&&this.h.has(G.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{c:z,f:G,g:J}=this;return{get added(){return[...z].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...J].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class F extends d.$VI{constructor(){super(...arguments),this.y=new R.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}x(z,G){return{...z,revived:n.TestItem.toPlain(z.item),depth:G?G.depth+1:0,children:new Set}}w(){return new O(this.y)}}class j{constructor(z){this.f=z}checkout(){this.c||(this.c=this.g());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(G=>G.revived)},dispose:(0,L.$eb)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}g(){const z=new F({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}const B=(re,z,G,J)=>{G?Object.assign(G,J):z.$updateTestRunConfig(re.controllerId,re.profileId,J)};class M{#e;#t;#i;#n;#s;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,B(this,this.#e,this.#n,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,B(this,this.#e,this.#n,{supportsContinuousRun:z}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(z){z!==this.isDefault&&(z?this.#t.add(this.profileId):this.#t.delete(this.profileId),B(this,this.#e,this.#n,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,B(this,this.#e,this.#n,{tag:z?n.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,B(this,this.#e,this.#n,{hasConfigurationHandler:!!z}))}get onDidChangeDefault(){return R.Event.chain(this.#i,z=>z.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(C.$kg))}constructor(z,G,J,ee,ue,ne,De,$e,Q,U=!1,se=void 0,oe=!1){this.controllerId=ue,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=Q,this._tag=se,this.g=oe,this.#e=z,this.#s=G,this.#t=J,this.#i=ee,G.set(ne,this);const te=W[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);U&&J.add(ne),this.#n={profileId:ne,controllerId:ue,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:U,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$hoc=M;const W={[o.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function _(re,z){for(let G=0;G<re.path.length;G++){const J=z.find(ee=>ee.id===re.path[G]);if(!J)return;if(G===re.path.length-1)return J;z=J.children}}}),define(Ee[370],Se([1,0,19,4,3,6,167,17,10]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,r=Ue(r),T=Ue(T);class l extends A.$Vc{constructor(E,u){super(),this.m=u,this.a=new h.$je,this.b=new h.$je,this.c=new h.$je,this.f=new h.$je,this.g=new h.$je,this.h=new h.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(R.$YM.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const u=this.m.allEditors();return E?u:u.map(P=>P.value)}async showTextDocument(E,u,P){let p;typeof u=="number"?p={position:T.ViewColumn.from(u),preserveFocus:P}:typeof u=="object"?p={position:T.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?T.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const c=await this.j.$tryShowTextDocument(E.uri,p),g=c&&this.m.getEditor(c);if(g)return g.value;throw c?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new L.$zP(this.j,E,u).value}$acceptEditorPropertiesChanged(E,u){const P=this.m.getEditor(E);if(!P)throw new Error("unknown text editor");if(u.options&&P._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(T.Selection.to);P._acceptSelections(p)}if(u.visibleRanges){const p=r.$Ib(u.visibleRanges.map(T.Range.to));P._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:P.value,options:{...u.options,lineNumbers:T.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=$.TextEditorSelectionChangeKind.fromValue(u.selections.source),c=u.selections.selections.map(T.Selection.to);this.a.fire({textEditor:P.value,selections:c,kind:p})}if(u.visibleRanges){const p=r.$Ib(u.visibleRanges.map(T.Range.to));this.c.fire({textEditor:P.value,visibleRanges:p})}}$acceptEditorPositionData(E){for(const u in E){const P=this.m.getEditor(u);if(!P)throw new Error("Unknown text editor");const p=T.ViewColumn.to(E[u]);P.value.viewColumn!==p&&(P._acceptViewColumn(p),this.f.fire({textEditor:P.value,viewColumn:p}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$onc=l}),define(Ee[371],Se([1,0,2,5,6,3,10,17,24,41,18]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0,e.$$oc=(0,h.$Ci)("IExtHostTimeline");class E{constructor(p,c){this.b=new Map,this.c=new Map,this.a=p.getProxy(A.$YM.MainThreadTimeline),c.registerArgumentProcessor({processArgument:(g,f)=>{if(g&&g.$mid===l.MarshalledId.TimelineActionContext)if(this.b.get(g.source)&&$.$nn.equals(f,this.b.get(g.source)?.extension)){const m=g.uri===void 0?void 0:r.URI.revive(g.uri);return this.c.get(g.source)?.get(u(m))?.get(g.handle)}else return;return g}})}async $getTimeline(p,c,g,f){return this.b.get(p)?.provider.provideTimeline(r.URI.revive(c),g,f)}registerTimelineProvider(p,c,g,f){const m=new R.$Uc,n=this.d(c.id,f,m).bind(this);let o;c.onDidChange&&(o=c.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:c.id}),this));const i=this.c;return this.f({...c,scheme:p,onDidChange:void 0,async provideTimeline(t,s,d){s?.resetCache&&(m.clear(),i.get(c.id)?.clear());const a=await c.provideTimeline(t,s,d);if(a==null)return;const w=n(t,s);return{...a,source:c.id,items:a.items.map(w)}},dispose(){for(const t of i.values())t.get(c.id)?.clear();o?.dispose(),m.dispose()}},g)}d(p,c,g){return(f,m)=>{let n;if(m?.cacheResults){let o=this.c.get(p);o===void 0&&(o=new Map,this.c.set(p,o));const i=u(f);n=o.get(i),n===void 0&&(n=new Map,o.set(i,n))}return o=>{const{iconPath:i,...t}=o,s=`${p}|${o.id??o.timestamp}`;n?.set(s,o);let d,a,w;o.iconPath&&(i instanceof L.$XN?w={id:i.id,color:i.color}:r.URI.isUri(i)?(d=i,a=i):{light:d,dark:a}=i);let y;return L.$qN.isMarkdownString(t.tooltip)?y=T.MarkdownString.from(t.tooltip):(0,C.$cg)(t.tooltip)?y=t.tooltip:L.$qN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=T.MarkdownString.from(t.detail)):(0,C.$cg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=t.detail),{...t,id:t.id??void 0,handle:s,source:p,command:o.command?c.toInternal(o.command,g):void 0,icon:d,iconDark:a,themeIcon:w,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(p,c){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:c}),(0,R.$Tc)(()=>{for(const f of this.c.values())f.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$_oc=E;function u(P){return P?.toString()}}),define(Ee[372],Se([1,0,242,23,2,4,3,304,9,10,18,19,17,86,21,198,26]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0,l=Ue(l);function f(o,i){if((0,C.$cg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class m extends L.$Vc{constructor(i,t,s){super(),this.f=i,this.g=t,this.h=s,this.a=new Map,this.b=new c.$I$;function d(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>d(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(w=>d(w)?this.r(w):w):a})}registerTreeDataProvider(i,t,s){const d=this.createTreeView(i,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(i,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,D=this.m(i,t,s),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:a,hasHandleDrag:w,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},I=this.f.$registerTreeViewDataProvider(i,S),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,g.$2G)(s,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,g.$2G)(s,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(b){(0,P.$2k)(b)&&(0,g.$2G)(s,"treeViewMarkdownMessage"),D.message=b},get title(){return D.title},set title(b){D.title=b},get description(){return D.description},set description(b){D.description=b},get badge(){return D.badge},set badge(b){b!==void 0&&l.ViewBadge.isViewBadge(b)?D.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(D.badge=void 0)},reveal:(b,v)=>D.reveal(b,v),dispose:async()=>{await I,this.a.delete(i),D.dispose()}};return this.B(k),k}$getChildren(i,t){const s=this.a.get(i);return s?s.getChildren(t):Promise.reject(new T.$kG(i))}async $handleDrop(i,t,s,d,a,w,y,D){const S=this.a.get(i);if(!S)return Promise.reject(new T.$kG(i));const I=u.DataTransfer.toDataTransfer(s,async k=>(await this.f.$resolveDropFileData(i,t,k)).buffer);return y===i&&D&&await this.j(I,S,D,a,w),S.onDrop(I,d,a)}async j(i,t,s,d,a){const w=this.b.removeDragOperationTransfer(a);if(w)(await w)?.forEach((y,D)=>{y&&i.set(D,y)});else if(a&&t.handleDrag){const y=t.handleDrag(s,i,d);this.b.addDragOperationTransfer(a,y),await y}return i}async $handleDrag(i,t,s,d){const a=this.a.get(i);if(!a)return Promise.reject(new T.$kG(i));const w=await this.j(new l.$TN,a,t,d,s);if(!(!w||d.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new T.$kG(i);return t.hasResolve}$resolve(i,t,s){const d=this.a.get(i);if(!d)throw new T.$kG(i);return d.resolveTreeItem(t,s)}$setExpanded(i,t,s){const d=this.a.get(i);if(!d)throw new T.$kG(i);d.setExpanded(t,s)}$setSelectionAndFocus(i,t,s){const d=this.a.get(i);if(!d)throw new T.$kG(i);d.setSelectionAndFocus(t,s)}$setVisible(i,t){const s=this.a.get(i);if(!s){if(!t)return;throw new T.$kG(i)}s.setVisible(t)}$changeCheckboxState(i,t){const s=this.a.get(i);if(!s)throw new T.$kG(i);s.setCheckboxState(t)}m(i,t,s){const d=this.B(new n(i,t,this.f,this.g.converter,this.h,s));return this.a.set(i,d),d}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$apc=m;class n extends L.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,C.$lg)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,s,d,a,w){if(super(),this.I=i,this.J=s,this.L=d,this.M=a,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$ue,w.contributes&&w.contributes.views)for(const I in w.contributes.views)for(const k of w.contributes.views[I])k.id===i&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(I=>{Array.isArray(I)&&I.length===0||this.F.fire({message:!1,element:I})}));let y,D;const S=R.Event.debounce(this.F.event,(I,k)=>(I||(I={message:!1,elements:[]}),k.element!==!1&&(y||(y=new Promise(b=>D=b),this.G=this.G.then(()=>y)),Array.isArray(k.element)?I.elements.push(...k.element):I.elements.push(k.element)),k.message&&(I.message=!0),I),200,!0);this.B(S(({message:I,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const b=D;return y=null,this.$(k).then(()=>b())})),I&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let s=this.X(i);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const s=(0,C.$lg)(t.select)?!0:t.select,d=(0,C.$lg)(t.focus)?!1:t.focus,a=(0,C.$lg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then(w=>this.W(i,w[w.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:w.map(D=>D.item)},{select:s,focus:d,expand:a})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:a})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const s=this.getExtensionElement(i);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(i,t){const s=!(0,E.$vb)(this.s,i);this.s=i;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(i,t,s){const d=[];for(const a of i){const w=this.getExtensionElement(a);w&&d.push(w)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(d,i,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(i);if(s){const d=this.m.get(s);if(d){const a=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(a),d.item.tooltip=this.eb(a.tooltip),d.item.command=this.fb(d.disposableStore,a.command),d.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$uh)(()=>this.f.getParent(i))}W(i,t){const s=this.m.get(i);return s?Promise.resolve(s):(0,$.$uh)(()=>this.f.getTreeItem(i)).then(d=>this.kb(i,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(d);if(a){const w=this.m.get(a);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const s=this.getExtensionElement(i);t=s?this.m.get(s):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new p.$ue(this.Z.token);try{const s=i?this.m.get(i):void 0,d=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const a=(0,E.$Ib)(d||[]),w=await Promise.all((0,E.$Ib)(a).map(D=>this.f.getTreeItem(D)));if(t.token.isCancellationRequested)return;const y=w.map((D,S)=>D?this.db(a[S],D,s):null);return(0,E.$Ib)(y)}finally{t.dispose()}}$(i){if(i.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$ue,this.tb(),this.J.$refresh(this.I);{const s=this.ab(i);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(i){const t=new Set,s=i.map(a=>this.m.get(a));for(const a of s)if(a&&!t.has(a.item.handle)){let w=a;for(;w&&w.parent&&s.findIndex(y=>w&&w.parent&&y&&y.item.handle===w.parent.item.handle)===-1;){const y=this.j.get(w.parent.item.handle);w=y?this.m.get(y):void 0}w&&!w.parent&&t.add(a.item.handle)}const d=[];return t.forEach(a=>{const w=this.j.get(a);if(w){const y=this.m.get(w);y&&(!y.parent||!t.has(y.parent.item.handle))&&d.push(a)}}),d}bb(i){const t={};return Promise.all(i.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,$.$uh)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const a=this.ib(t,d,s.parent);return this.pb(t,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}db(i,t,s){const d=this.ib(i,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(i,d),this.qb(d,s),d}eb(i){return l.$qN.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,s,d;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,s=i.checkboxState.tooltip,d=i.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(i){if(!l.$ON.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,s){this.hb(t);const d=this.B(new L.$Uc),a=this.kb(i,t,s),w=this.lb(t);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:f(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,C.$lg)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(i){return i.iconPath instanceof l.$XN?i.iconPath:void 0}kb(i,{id:t,label:s,resourceUri:d},a,w){if(t)return`${n.b}/${t}`;const y=f(s,this.N),D=a?a.item.handle:n.a;let S=y?y.label:d?(0,h.$ah)(d):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const I=this.m.has(i)?this.m.get(i).item.handle:void 0,k=this.X(a)||[];let b,v=0;do{if(b=`${D}/${v}:${S}`,w||!this.j.has(b)||I===b)break;v++}while(v<=k.length);return b}lb(i){if(i.iconPath&&!(i.iconPath instanceof l.$XN))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof l.$XN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return A.URI.isUri(i)?i:A.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,s,d){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(i,t);const a=this.X(d)||[],w=a.filter(y=>y.item.handle===s.item.handle)[0];w&&a.splice(a.indexOf(w),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[373],Se([1,0,4,3,2,32,17,97,6,10]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,L=Ue(L),$=Ue($),l=Ue(l);class C extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(p,c,g,f){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$je),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=c,this.#n=g,this.#i=f.viewType,this.#s=f.panelOptions,this.#o=f.viewColumn,this.#r=f.title,this.#l=f.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,A.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(p){this.#u||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#l=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:L.ViewColumn.from(p),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Vc{static c(){return(0,R.$Yg)()}constructor(p,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=p.getProxy($.$YM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,c,g,f,m={}){const n=typeof f=="object"?f.viewColumn:f,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof f=="object"&&!!f.preserveFocus},i=(0,T.$Dnc)(p),t=E.c();this.f.$createWebviewPanel((0,T.$Fnc)(p),t,c,{title:g,panelOptions:u(m),webviewOptions:(0,T.$Gnc)(p,this.m,m),serializeBuffersForPostMessage:i},o);const s=this.j.createNewWebview(t,m,p);return this.createNewWebviewPanel(t,c,g,n,m,s,!0)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((g,f)=>{const m=p[g],n=p[f];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const g of c){const f=this.getWebviewPanel(g);if(!f)continue;const m=p[g];f._updateViewState({active:m.active,visible:m.visible,viewColumn:L.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:p}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,T.$Dnc)(p)}),new l.$1M(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,g,f){const m=this.h.get(c);if(!m)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:o}=m,i=this.j.createNewWebview(p,g.webviewOptions,o),t=this.createNewWebviewPanel(p,c,g.title,f,g.panelOptions,i,g.active);await n.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(p,c,g,f,m,n,o){const i=new C(p,this.f,n,{viewType:c,title:g,viewColumn:f,panelOptions:m,active:o});return this.g.set(p,i),i}getWebviewPanel(p){return this.g.get(p)}}e.$Hnc=E;function u(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(Ee[374],Se([1,0,4,3,97,17,6,10]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0,L=Ue(L),T=Ue(T);class $ extends h.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,P,p,c,g){super(),this.#s=!1,this.#l=this.B(new r.$je),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$je),this.onDidDispose=this.#u.event,this.#i=P,this.#a=p,this.#e=E,this.#t=u,this.#n=c,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$YM.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,P,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:P,extension:E}),this.a.$registerWebviewViewProvider((0,A.$Fnc)(E),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$Dnc)(E)}),new T.$1M(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,P,p,c){const g=this.b.get(u);if(!g)throw new Error(`No view provider found for '${u}'`);const{provider:f,extension:m}=g,n=this.d.createNewWebview(E,{},m),o=new $(E,this.a,u,P,n,!0);this.c.set(E,o),await f.resolveWebviewView(o,{state:p},c)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$dpc=l}),define(Ee[375],Se([1,0,76,15,12,277,28,11]),function(ce,e,r,h,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0;let $=class{constructor(E,u){E.addFileSystemProvider(h.Schemas.file,new l(u),{isCaseSensitive:T.$k})}};e.$Upc=$,e.$Upc=$=Ye([qe(0,r.$znc),qe(1,A.$9j)],$);class l{constructor(E){this.b=E,this.a=new R.$kr(this.b)}async stat(E){const u=await this.a.stat(E);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,u,P){return this.a.writeFile(E,u,{...P,unlock:!1,atomic:!1})}delete(E,u){return this.a.delete(E,{...u,useTrash:!1,atomic:!1})}rename(E,u,P){return this.a.rename(E,u,P)}copy(E,u,P){return this.a.copy(E,u,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,u){throw new Error("Method not implemented.")}}}),define(Ee[376],Se([1,0,16,68,32,35,3,6,2,20]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0;let C=class extends L.$Vc{constructor(u,P){super();const p=u.getProxy(T.$YM.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=$.URI.file((0,r.$kc)((0,h.tmpdir)(),(0,A.$Yg)()));return await p.$download(c,g),g})}};e.$Spc=C,e.$Spc=C=Ye([qe(0,l.$sP),qe(1,R.$OP)],C)}),define(Ee[377],Se([1,0,61,16,2,98,3,15,9,34]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=void 0,r=Ue(r),h=Ue(h);class C extends R.$Bnc{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==T.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let a=0;do{let w;a===0?w=d:w=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${a}`:`${d}-${a}`,await E(w);const y=h.$kc(w,"vscode.lock"),D=await c(this.d,y,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),A.URI.file(w);a++}while(a<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$5pc=C;async function E(i){try{await l.Promises.stat(i);return}catch{}try{await l.Promises.mkdir(i,{recursive:!0})}catch{}}const u=1e3,P=10*60*1e3;class p extends L.$Vc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new $.$Nh),this.a.cancelAndSet(async()=>{const d=await g(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await l.Promises.utimes(s,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${s}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function c(i,t,s){try{const a={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){i.error(a)}const d=await g(i,t);return!d||d.pid!==process.pid?s?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new p(i,t))}async function g(i,t){let s;try{s=await l.Promises.readFile(t)}catch(d){return i.error(d),null}try{return JSON.parse(String(s))}catch(d){return i.error(d),null}}async function f(i,t){let s;try{s=await l.Promises.stat(t)}catch(d){return i.error(d),0}return s.mtime.getTime()}function m(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const s=await g(i,t);if(!s)return i.info(`Lock '${t}': Could not read pid of lock holder.`),o(i,t);if(s.willReleaseAt){let D=s.willReleaseAt-Date.now();if(D<5e3){for(D>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${D} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,$.$Dh)(Math.min(100,D)),await f(i,t)===0)return o(i,t);D=s.willReleaseAt-Date.now()}return o(i,t)}}if(!m(s.pid))return i.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),o(i,t);const d=await f(i,t),a=Date.now()-d;if(a<=P)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$Dh)(2e3);const w=await f(i,t),y=Date.now()-w;return y<=P?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(i,t))}async function o(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return c(i,t,!0)}}),define(Ee[378],Se([1,0,32,20,47,35]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=void 0;let L=class extends A.$Xnc{constructor($,l){super(!0,$,l)}createTerminal($,l,C){return this.createTerminalFromOptions({name:$,shellPath:l,shellArgs:C})}createTerminalFromOptions($,l){const C=new A.$Wnc(this.a,(0,r.$Yg)(),$,$.name);return this.f.push(C),C.create($,this.R($,l)),C.value}};e.$npc=L,e.$npc=L=Ye([qe(0,R.$OP),qe(1,h.$sP)],L)}),define(Ee[379],Se([1,0,4,37,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.OutputChannelUpdateMode=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0,e.$7L="text/x-code-output",e.$8L="output",e.$9L="Log",e.$0L="text/x-code-log-output",e.$$L="log",e.$_L="workbench.panel.output",e.$aM=new A.$Tj("inOutput",!1),e.$bM=new A.$Tj("activeLogOutput",!1),e.$cM=new A.$Tj("activeLogOutput.levelSettable",!1),e.$dM=new A.$Tj("activeLogOutput.level",""),e.$eM=new A.$Tj("activeLogOutput.levelIsDefault",!1),e.$fM=new A.$Tj("outputView.scrollLock",!1),e.$gM=(0,R.$Ci)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$hM={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$je,this.onDidRegisterChannel=this.b.event,this.c=new r.$je,this.onDidRemoveChannel=this.c.event}registerChannel(l){this.a.has(l.id)||(this.a.set(l.id,l),this.b.fire(l.id))}getChannels(){const l=[];return this.a.forEach(C=>l.push(C)),l}getChannel(l){return this.a.get(l)}removeChannel(l){this.a.delete(l),this.c.fire(l)}}h.$mo.add(e.$hM.OutputChannels,new T),e.$iM=new A.$Tj("activeOutputChannel","")}),define(Ee[168],Se([1,0,6,5,20,24,12,379,76,30,63,203,22,18,28,4,3]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Soc=void 0;class f extends L.$ck{get disposed(){return this.n}constructor(i,t,s,d,a){super(),this.id=i,this.name=t,this.r=s,this.s=d,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=u.$Le.fromString(t).byteLength,(0,L.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class m extends f{appendLine(i){this.append(i)}}let n=class{constructor(i,t,s,d,a,w){this.i=t,this.j=s,this.k=d,this.l=a,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(r.$YM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(i,t,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,a=(0,P.$cg)(t)?t:void 0;if((0,P.$cg)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const y=this.i.environment.extensionLogLevel?.find(([S])=>R.$nn.equals(s.identifier,S))?.[1];y&&(w=(0,L.$nk)(y));const D=d?this.o(i,w,s):this.n(i,a,s);return D.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),d?this.r(i,w??this.m.getLevel(),D):this.q(i,D)}async n(i,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,a=this.k.extUri.joinPath(d,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(i,a,t,s.identifier.value);return new f(y,i,w,this.a,s)}async o(i,t,s){const d=await this.p(s),a=i.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(d,`${a}.log`),y=`${s.identifier.value}.${a}`,D=this.l.createLogger(w,{id:y,name:i,logLevel:t,extensionId:s.identifier.value});return new m(y,i,D,this.a,s)}p(i){let t=this.d.get(i.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,p.$ml)(d)!==p.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(i,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return i},append(a){d(),t.then(w=>w.append(a))},appendLine(a){d(),t.then(w=>w.appendLine(a))},clear(){d(),t.then(a=>a.clear())},replace(a){d(),t.then(w=>w.replace(a))},show(a,w){d(),t.then(y=>y.show(a,w))},hide(){d(),t.then(a=>a.hide())},dispose(){s=!0,t.then(a=>a.dispose())}}}r(i,t,s){const d=new g.$Uc,a=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},w=d.add(new c.$je);function y(D){t=D,w.fire(D)}return s.then(D=>{d.add(D),D.logLevel!==t&&y(D.logLevel),d.add(D.onDidChangeLogLevel(S=>y(S)))}),{...this.q(i,s),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(D,...S){a(),s.then(I=>I.trace(D,...S))},debug(D,...S){a(),s.then(I=>I.debug(D,...S))},info(D,...S){a(),s.then(I=>I.info(D,...S))},warn(D,...S){a(),s.then(I=>I.warn(D,...S))},error(D,...S){a(),s.then(I=>I.error(D,...S))},dispose(){d.dispose()}}}};e.$Soc=n,e.$Soc=n=Ye([qe(0,A.$sP),qe(1,l.$IP),qe(2,$.$znc),qe(3,C.$cnc),qe(4,L.$0j),qe(5,L.$9j)],n),e.$Toc=(0,h.$Ci)("IExtHostOutputService")}),define(Ee[169],Se([1,0,5,9]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,r.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const $=await A.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,h.$Dh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((T,$)=>T+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((T,$)=>T+$,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[380],Se([1,0,246,71,37,46,45,3,4,169,11,25,9,150]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hb=e.$1hb=e.$Zhb=e.$Yhb=e.$Xhb=e.$Whb=e.$Vhb=e.$Uhb=e.$Thb=e.$Shb=void 0,e.$Shb=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$Thb=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$Uhb=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$Vhb=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$Whb=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$Xhb={ConfigurationMigration:"base.contributions.configuration.migration"};class p{constructor(){this.migrations=[],this.a=new $.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const c=new p;A.$mo.add(e.$Xhb.ConfigurationMigration,c);let g=class extends T.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const s of t.added)await this.f(s,c.migrations)})),this.c(c.migrations),this.B(c.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(t=>this.g(t,o?.uri))])}async g(o,i){const t=this.a.inspect(o.key,{resource:i}),s=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[d,a]of s){const w=t[d];if(!w)continue;const y=[];if(w.value!==void 0){const D=await this.h(o,d,w.value,i,void 0);for(const S of D??[])y.push([S,[]])}for(const{identifiers:D,value:S}of w.overrides??[])if(S!==void 0){const I=await this.h(o,d,S,i,D);for(const k of I??[])y.push([k,D])}y.length&&await Promise.allSettled(y.map(async([[D,S],I])=>this.a.updateValue(D,S.value,{resource:i,overrideIdentifiers:I},a)))}}async h(o,i,t,s,d){const a=y=>{const S=this.a.inspect(y,{resource:s})[i];if(S)return d?S.overrides?.find(({identifiers:I})=>(0,E.$do)(I,d))?.value:S.value},w=await o.migrateFn(t,a);return Array.isArray(w)?w:[[o.key,w]]}};e.$Yhb=g,e.$Yhb=g=Ye([qe(0,L.$9i),qe(1,R.$Li)],g);let f=class extends T.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!C.$i&&(await this.b.getEnvironment())?.os!==C.OperatingSystem.Windows)return;A.$mo.as(h.$ro.Configuration).registerConfiguration({...e.$Uhb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$Zhb=f,e.$Zhb=f=Ye([qe(0,l.$Sm)],f),e.$1hb="window.newWindowProfile";let m=class extends T.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,i){super(),this.c=o,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==L.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$1hb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=A.$mo.as(h.$ro.Configuration),i={...e.$Whb,properties:{[e.$1hb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[i],remove:[this.a]}):o.registerConfiguration(i),this.a=i}h(){const o=this.f.getValue(e.$1hb);this.b=o?this.c.profiles.find(i=>i.name===o):void 0}j(){const o=this.f.getValue(e.$1hb);if(!o)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;o!==i?.name&&this.f.updateValue(e.$1hb,i?.name)}};e.$2hb=m,e.$2hb=m=Ye([qe(0,P.$Il),qe(1,L.$9i)],m)}),define(Ee[381],Se([1,0,39,15,16,23,258,380,71,5,37]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$4hb=e.$3hb=void 0,e.$5hb=c,e.$6hb=g,r=Ue(r),e.$3hb=(0,l.$Ci)("editorResolverService"),e.$4hb="workbench.editorAssociations";const E=C.$mo.as($.$ro.Configuration),u={...T.$Thb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var P;(function(f){f.builtin="builtin",f.option="option",f.exclusive="exclusive",f.default="default"})(P||(e.RegisteredEditorPriority=P={}));var p;(function(f){f[f.ABORT=1]="ABORT",f[f.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function c(f){switch(f){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function g(f,m){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(m.scheme))return!1;const i=typeof f=="string"&&f.indexOf(A.$hc.sep)>=0?`${m.scheme}:${m.path}`:(0,R.$ah)(m);return r.$vk(typeof f=="string"?f.toLowerCase():f,i.toLowerCase())}}),define(Ee[382],Se([1,0,33,15,16,11,23,2,5,296,46,157,169]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,$.$Ci)("pathService");let p=P=class{constructor(g,f,m,n){this.d=g,this.e=f,this.f=m,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??g})()}hasValidBasename(g,f,m){return typeof f=="string"||typeof f>"u"?this.a.then(n=>this.h(g,n,f)):this.h(g,f,m)}h(g,f,m){return g.scheme===h.Schemas.file||g.scheme===h.Schemas.vscodeRemote?(0,r.$zg)(m??(0,L.$ah)(g),f===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,f){if(g.remoteAuthority)return h.Schemas.vscodeRemote;const m=(0,l.$xM)(f.getWorkspace());if(m)return m;const n=f.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=f.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===R.OperatingSystem.Windows?A.$gc:A.$hc)}async fileURI(g){let f="";if(await this.a===R.OperatingSystem.Windows&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const n=g.indexOf("/",2);n===-1?(f=g.substring(2),g="/"):(f=g.substring(2,n),g=g.substring(n)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:f,path:g,query:"",fragment:""})}};e.$BM=p,e.$BM=p=P=Ye([qe(1,u.$Sm),qe(2,E.$jM),qe(3,C.$Li)],p)}),define(Ee[383],Se([1,0,260,59,4,60,3,2,45,266,12,72,151,93,46,157,26,21,18,25,36]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.OnPortForward=e.$oM=e.$nM=e.TunnelSource=e.TunnelCloseReason=e.$lM=e.$kM=void 0,e.$mM=a,e.$pM=D,e.$qM=S,e.$rM=I,e.$sM=b,r=Ue(r);const i=10*1e3,t="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$kM="onTunnel",e.$lM=new o.$Tj("forwardedPortsViewEnabled",!1,r.localize(0,null));function a(O){const F=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}var w;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var y;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$nM={source:y.User,description:r.localize(1,null)},e.$oM={source:y.Auto,description:r.localize(2,null)};function D(O,F,j){const B=O.get(I(F,j));if(B)return B;if((0,P.$Aw)(F))for(const M of P.$zw){const W=I(M,j);if(O.has(W))return O.get(W)}else if((0,P.$Cw)(F))for(const M of P.$Bw){const W=I(M,j);if(O.has(W))return O.get(W)}}function S(O,F,j){const B=D(O,F,j);if(B)return B;const M=(0,P.$Cw)(F)?"localhost":(0,P.$Aw)(F)?"0.0.0.0":void 0;if(M)return D(O,M,j)}function I(O,F){return O+":"+F}var k;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(k||(e.OnPortForward=k={}));function b(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}class v extends L.$Vc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new A.$je,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,j,B){let M=this.w(F,j,B,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const _=this.j[M];_.key===F?(W.onAutoForward=_.onAutoForward??W.onAutoForward,W.elevateIfNeeded=_.elevateIfNeeded!==void 0?_.elevateIfNeeded:W.elevateIfNeeded,W.label=_.label??W.label,W.requireLocalPort=_.requireLocalPort,W.protocol=_.protocol):(W.onAutoForward=W.onAutoForward??_.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:_.elevateIfNeeded,W.label=W.label??_.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??_.protocol),M=this.w(F,j,B,this.j,M+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,m.$cg)(F.host)&&(0,m.$gg)(F.port)}w(F,j,B,M,W){if(W>=M.length)return-1;const _=!(0,P.$Aw)(j)&&!(0,P.$Cw)(j),z=M.slice(W).findIndex(G=>(0,m.$gg)(G.key)?_?!1:G.key===F:this.t(G.key)?_?!1:F>=G.key.start&&F<=G.key.end:this.u(G.key)?F===G.key.port&&j===G.key.host:B?G.key.test(B):!1);return z>=0?z+W:-1}y(){const F=this.r.getValue(v.c);if(!F||!(0,m.$eg)(F))return[];const j=[];for(const M in F){if(M===void 0)continue;const W=F[M];let _;if(Number(M))_=Number(M);else if((0,m.$cg)(M))if(v.g.test(M)){const re=M.match(v.g);_={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(M)){const re=M.match(v.h);_={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(M)}catch{}re&&(_=re)}_&&j.push({key:_,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const B=this.r.getValue(v.f);return B&&(this.m={elevateIfNeeded:B.elevateIfNeeded,label:B.label,onAutoForward:B.onAutoForward,requireLocalPort:B.requireLocalPort,protocol:B.protocol}),this.z(j)}z(F){function j(B,M){return(0,m.$gg)(B.key)?B.key:M.t(B.key)?B.key.start:M.u(B.key)?B.key.port:Number.MAX_VALUE}return F.sort((B,M)=>j(B,this)-j(M,this))}C(){return this.m}static providedActionToAction(F){switch(F){case P.ProvidedOnAutoForward.Notify:return k.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case P.ProvidedOnAutoForward.Silent:return k.Silent;case P.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(F,j,B){const W=this.r.inspect(v.c).userRemoteValue;let _;!W||!(0,m.$eg)(W)?_={}:_=(0,n.$_n)(W),_[`${F}`]||(_[`${F}`]={});for(const re in j)_[`${F}`][re]=j[re];return this.r.updateValue(v.c,_,B)}}e.$tM=v;let N=class extends L.$Vc{constructor(F,j,B,M,W,_,re,z,G,J){super(),this.H=F,this.I=j,this.J=B,this.L=M,this.M=W,this.N=_,this.O=re,this.P=z,this.Q=G,this.R=J,this.c=new Map,this.g=new A.$je,this.onForwardPort=this.g.event,this.h=new A.$je,this.onClosePort=this.h.event,this.j=new A.$je,this.onPortName=this.j.event,this.n=new A.$je,this.onCandidatesChanged=this.n.event,this.t=new A.$je,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$je,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(B),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const ue=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=I(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=S(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ue?.get(ne.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ue?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$nM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const ue=I(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!S(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!S(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!S(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=S(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$nM})}await this.cb(),this.f.set(ue,ee),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$kM))?(this.R.createKey(e.$lM.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,j){const B=I(F.host,F.port);this.forwarded.has(B)&&(this.forwarded.delete(B),await this.cb(),this.h.fire(F))}X(F,j){if(F.startsWith("http"))return T.URI.parse(F);const B=j?.protocol??"http";return T.URI.parse(`${B}://${F}`)}async Y(F){const j=this.N.getWorkspace(),B=j.configuration?(0,R.$qj)(j.configuration.path):j.folders.length>0?(0,R.$qj)(j.folders[0].uri.path):void 0;if(B===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${B}`}async Z(){return this.Y(t)}async $(){return this.Y(s)}async ab(){const F=this.I.get(t,u.StorageScope.WORKSPACE);if(F)return this.I.remove(t,u.StorageScope.WORKSPACE),await this.cb(),F;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const j=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(B=>B.remotePort).join(", ")}`);for(const B of j){const M=S(this.detected,B.remoteHost,B.remotePort);B.source.source!==y.Extension&&!M||B.source.source===y.Extension&&M?await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,elevateIfNeeded:!0,source:B.source}):B.source.source===y.Extension&&!M&&this.D.set(I(B.remoteHost,B.remotePort),B)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new L.$Uc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===F&&(this.s=Promise.resolve(this.I.get(F,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of F){const B=this.I.getNumber(j,u.StorageScope.PROFILE);if(B&&B<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(s,t);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(M,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),j=F.map(_=>({remoteHost:_.remoteHost,remotePort:_.remotePort,localPort:_.localPort,name:_.name,localAddress:_.localAddress,localUri:_.localUri,protocol:_.protocol,source:_.source}));let B;F.length>0&&(B=JSON.stringify(j));const M=await this.Z(),W=await this.$();!B&&M&&W?(this.I.remove(M,u.StorageScope.PROFILE),this.I.remove(W,u.StorageScope.PROFILE)):B!==this.y&&M&&W&&(this.I.store(M,B,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(W,Date.now()+d,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=B}}async eb(F,j,B){if(!F.tunnelLocalPort||!B?.requireLocalPort||F.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+i>M.getTime())return;this.db=M;const W=r.localize(3,null,j,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(W)}async forward(F,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(F,j)}async fb(F,j){await this.Q.activateByEvent(e.$kM);const B=S(this.forwarded,F.remote.host,F.remote.port);j=j??(j!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const M=F.local!==void 0?F.local:F.remote.port;let W;if(B)return this.hb(B,F,j);{const _=this.L.remoteAuthority,re=_?{getAddress:async()=>(await this.M.resolveAuthority(_)).authority}:void 0,z=I(F.remote.host,F.remote.port);this.c.set(z,!0),F=this.gb(z,F);const G=await this.H.openTunnel(re,F.remote.host,F.remote.port,void 0,M,F.elevateIfNeeded?F.elevateIfNeeded:j?.elevateIfNeeded,F.privacy,j?.protocol);if(typeof G=="string")W=G;else if(G&&G.localAddress){const J=S(this.m??new Map,F.remote.host,F.remote.port),ee=G.protocol?G.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,ue={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??F.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:J?.detail,hasRunningProcess:!!J,pid:J?.pid,source:F.source??e.$nM,privacy:G.privacy};return this.forwarded.set(z,ue),this.f.set(z,G),this.c.delete(z),await this.cb(),await this.eb(G,M,j),this.g.fire(ue),G}this.c.delete(z)}return W}gb(F,j){const B=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(B){const M=B.get(F);B.delete(F),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(F,j,B){const M=B?.label??j.name;let W;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(W||(W={}));let _=W.None;switch(M!==F.name&&(F.name=M,_=W.Fire),(B?.protocol||F.protocol!==P.TunnelProtocol.Http)&&B?.protocol!==F.protocol&&(j.source=F.source,_=W.Reopen),j.privacy&&F.privacy!==j.privacy&&(_=W.Reopen),_){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(F.remoteHost,F.remotePort,w.User),await this.fb(j,B)}return S(this.f,j.remote.host,j.remote.port)}async name(F,j,B){const M=S(this.forwarded,F,j),W=I(F,j);if(M){M.name=B,await this.cb(),this.j.fire({host:F,port:j});return}else this.detected.has(W)&&(this.detected.get(W).name=B,this.j.fire({host:F,port:j}))}async close(F,j,B){const M=I(F,j),W=this.forwarded.get(M);return B===w.AutoForwardEnd&&W&&W.source.source===y.Auto&&this.F.set(M,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(F,j),this.W({host:F,port:j},B)}address(F,j){const B=I(F,j);return(this.forwarded.get(B)||this.detected.get(B))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const j of F){const B=S(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:I(j.localAddress.host,j.localAddress.port);this.detected.set(I(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let j=F;this.r&&(j=await this.r(F));const B=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(B.values()).map(M=>M.port).join(", ")}`),this.n.fire(B)}ib(F){const j=this.m??new Map,B=new Map;return this.m=B,F.forEach(M=>{const W=I(M.host,M.port);B.set(W,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(W)&&j.delete(W);const _=S(this.forwarded,M.host,M.port);_&&(_.runningProcess=M.detail,_.hasRunningProcess=!0,_.pid=M.pid)}),j.forEach((M,W)=>{const _=a(W);if(!_)return;const re=S(this.forwarded,_.host,_.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const z=S(this.detected,_.host,_.port);z&&(z.runningProcess=void 0,z.hasRunningProcess=!1,z.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),j=await this.getAttributes(F.map(B=>({port:B.remotePort,host:B.remoteHost})),!1);if(j)for(const B of F){const M=j.get(B.remotePort);(M?.protocol||B.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==B.protocol&&await this.fb({remote:{host:B.remoteHost,port:B.remotePort},local:B.localPort,name:B.name,source:B.source},M),M&&M.label&&M.label!==B.name&&await this.name(B.remoteHost,B.remotePort,M.label)}}async getAttributes(F,j=!0){const B=new Map,M=new Map;F.forEach(G=>{const J=S(this.m??new Map,P.$zw[0],G.port)??G;if(J){B.set(G.port,J);const ee=b(J)?J.pid:void 0;M.has(ee)||M.set(ee,[]),M.get(ee)?.push(G.port)}});const W=new Map;if(F.forEach(G=>{const J=this.configPortsAttributes.getAttributes(G.port,G.host,B.get(G.port)?.detail);J&&W.set(G.port,J)}),this.G.length===0||!j)return W.size>0?W:void 0;const _=await Promise.all(this.G.flatMap(G=>Array.from(M.entries()).map(J=>{const ee=J[1],ue=B.get(ee[0]);return G.providePortAttributes(ee,ue?.pid,ue?.detail,f.CancellationToken.None)}))),re=new Map;if(_.forEach(G=>G.forEach(J=>{J&&re.set(J.port,J)})),!W&&!re)return;const z=new Map;return F.forEach(G=>{const J=W.get(G.port),ee=re.get(G.port);z.set(G.port,{elevateIfNeeded:J?.elevateIfNeeded,label:J?.label,onAutoForward:J?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:J?.requireLocalPort,protocol:J?.protocol})}),z}addAttributesProvider(F){this.G.push(F)}};e.$uM=N,Ye([(0,h.$8h)(1e3)],N.prototype,"cb",null),e.$uM=N=Ye([qe(0,P.$uw),qe(1,u.$_p),qe(2,$.$9i),qe(3,c.$jM),qe(4,E.$Nl),qe(5,p.$Li),qe(6,C.$9j),qe(7,l.$Zw),qe(8,g.$XG),qe(9,o.$Uj)],N)}),define(Ee[100],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$cL=e.$bL=void 0;class r{constructor(L,T){this.line=L,this.character=T}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,T){return new r(0,0)}with(L){return new r(0,0)}}e.$bL=r;class h{constructor(L,T,$,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,T),this.end=new r($,l)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new h(0,0,0,0)}with(L){return new h(0,0,0,0)}}e.$cL=h;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ee[38],Se([1,0,19,39,25,33,13,5,16,14,100,9]),function(ce,e,r,h,A,R,L,T,$,l,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$AL=e.$tL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$qL=e.$pL=e.$oL=e.$nL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.TextSearchCompleteMessageType=void 0,e.$kL=f,e.$lL=m,e.$mL=n,e.$rL=D,e.$sL=S,e.$uL=b,e.$vL=v,e.$wL=N,e.$xL=O,e.$yL=F,e.$zL=j,e.$BL=M,e.$DL=re,e.$EL=z,h=Ue(h),A=Ue(A),R=Ue(R),$=Ue($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$dL="workbench.view.search",e.$eL="workbench.panel.search",e.$fL="workbench.view.search",e.$gL="search-result",e.$hL="search.exclude",e.$iL=2e4;const u="\u27EA ",P=" characters skipped \u27EB",p=(u.length+P.length+5)*2;e.$jL=(0,T.$Ci)("searchService");var c;(function(J){J[J.file=0]="file",J[J.text=1]="text",J[J.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var g;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.aiText=3]="aiText"})(g||(e.QueryType=g={}));function f(J){return!!J.preview}function m(J){return!!J.resource}function n(J){return!!J.message}var o;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class i{constructor(ee){this.resource=ee,this.results=[]}}e.$nL=i;class t{constructor(ee,ue,ne,De){this.ranges=ue,this.webviewIndex=De;const $e=Array.isArray(ue)?ue:[ue];if(ne&&ne.matchLines===1&&s($e)){ee=(0,L.$8f)(ee,ne.matchLines);let Q="",U=0,se=0;const oe=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const he=Math.max(le.startColumn-oe,0),X=le.startColumn+ne.charsPerLine;if(he>se+oe+p){const ae=u+(he-se)+P;Q+=ae+ee.slice(he,X),U+=he-(se+ae.length)}else Q+=ee.slice(se,X);te.push(new a(0,le.startColumn-U,le.endColumn-U)),se=X}this.preview={text:Q,matches:Array.isArray(this.ranges)?te:te[0]}}else{const Q=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ee,matches:(0,r.$2b)(ue,U=>new d(U.startLineNumber-Q,U.startColumn,U.endLineNumber-Q,U.endColumn))}}}}e.$oL=t;function s(J){const ee=J[0].startLineNumber;for(const ue of J)if(ue.startLineNumber!==ee||ue.endLineNumber!==ee)return!1;return!0}class d{constructor(ee,ue,ne,De){this.startLineNumber=ee,this.startColumn=ue,this.endLineNumber=ne,this.endColumn=De}}e.$pL=d;class a extends d{constructor(ee,ue,ne){super(ee,ue,ee,ne)}}e.$qL=a;var w;(function(J){J.List="list",J.Tree="tree"})(w||(e.ViewMode=w={}));var y;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function D(J,ee=!0){const ue=J&&J.files&&J.files.exclude,ne=ee&&J&&J.search&&J.search.exclude;if(!ue&&!ne)return;if(!ue||!ne)return ue||ne;let De=Object.create(null);return De=A.$co(De,A.$_n(ue)),De=A.$co(De,A.$_n(ne),!0),De}function S(J,ee){return J.excludePattern&&h.$vk(J.excludePattern,ee)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&h.$vk(J.includePattern,ee)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ue=>{const ne=ue.folder.fsPath;if(R.$Bg(ee,ne)){const De=$.$mc(ne,ee);return!ue.includePattern||!!h.$vk(ue.includePattern,De)}else return!1}):!1:!0}var I;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(I||(e.SearchErrorCode=I={}));class k extends Error{constructor(ee,ue){super(ee),this.code=ue}}e.$tL=k;function b(J){const ee=J.message;if((0,l.$5)(J))return new k(ee,I.canceled);try{const ue=JSON.parse(ee);return new k(ue.message,ue.code)}catch{return new k(ee,I.other)}}function v(J){const ee={message:J.message,code:J.code};return new Error(JSON.stringify(ee))}function N(J){return J.type==="error"?!0:J.type==="success"}function O(J){return J.type==="success"}function F(J){return!!J.path}function j(J,ee,ue=!0){const ne=J.searchPath?J.searchPath:J.relativePath;return ue?(0,L.$5f)(ne,ee):h.$vk(ee,ne)}class B{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$AL=B;function M(J,ee){const ue={...J||{},...ee||{}};return Object.keys(ue).filter(ne=>{const De=ue[ne];return typeof De=="boolean"&&De})}class W{constructor(ee,ue){this.c=null,this.a={...ee.excludePattern||{},...ue.excludePattern||{}},this.b=h.$wk(this.a);let ne=ee.includePattern;ue.includePattern&&(ne?ne={...ne,...ue.includePattern}:ne=ue.includePattern),ne&&(this.c=h.$wk(ne))}matchesExcludesSync(ee,ue,ne){return!!(this.b&&this.b(ee,ue,ne))}includedInQuerySync(ee,ue,ne){return!(this.b&&this.b(ee,ue,ne)||this.c&&!this.c(ee,ue,ne))}includedInQuery(ee,ue,ne){const De=this.b(ee,ue,ne),$e=()=>this.c?!!this.c(ee,ue,ne):!0;return(0,E.$oh)(De)?De.then(Q=>Q?!1:$e()):$e()}hasSiblingExcludeClauses(){return _(this.a)}}e.$CL=W;function _(J){for(const ee in J)if(typeof J[ee]!="boolean")return!0;return!1}function re(J){if(!J)return;let ee;return ue=>(ee||(ee=(J()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[ue]))}function z(J){if(!J)return;let ee;return ue=>{if(!ee){const ne=J();ee=ne?G(ne):{}}return!!ee[ue]}}function G(J){const ee={};for(const ue of J)ee[ue]=!0;return ee}}),define(Ee[48],Se([1,0,19,9,21,4,3,85,15,134,23,13,2,244,28,5,12,280,46,63,30,20,17,10,73,38,6,57]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;function D(F,j,B){return new C.$5g(M=>b(M,B)).isEqual(F,j)}function S(F,j,B){return D(F.uri,j.uri,B)?0:(0,E.$wf)(F.uri.toString(),j.uri.toString())}function I(F,j,B){return F.index!==j.index?F.index<j.index?-1:1:D(F.uri,j.uri,B)?(0,E.$wf)(F.name,j.name):(0,E.$wf)(F.uri.toString(),j.uri.toString())}function k(F,j,B,M){const W=F.slice(0).sort((re,z)=>B(re,z,M)),_=j.slice(0).sort((re,z)=>B(re,z,M));return(0,r.$Fb)(W,_,(re,z)=>B(re,z,M))}function b(F,j){const B=j.getCapabilities(F.scheme);return!(B&&B&p.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends m.$Vi{static toExtHostWorkspace(j,B,M,W){if(!j)return{workspace:null,added:[],removed:[]};const{id:_,name:re,folders:z,configuration:G,transient:J,isUntitled:ee}=j,ue=[],ne=B;B?z.forEach((U,se)=>{const oe=u.URI.revive(U.uri),te=v.o(M||B,oe,W);te?(te.name=U.name,te.index=U.index,ue.push(te)):ue.push({uri:oe,name:U.name,index:se})}):ue.push(...z.map(({uri:U,name:se,index:oe})=>({uri:u.URI.revive(U),name:se,index:oe}))),ue.sort((U,se)=>U.index<se.index?-1:1);const De=new v(_,re,ue,!!J,G?u.URI.revive(G):null,!!ee,U=>b(U,W)),{added:$e,removed:Q}=k(ne?ne.workspaceFolders:[],De.workspaceFolders,S,W);return{workspace:De,added:$e,removed:Q}}static o(j,B,M){for(let W=0;W<j.folders.length;W++){const _=j.workspaceFolders[W];if(D(_.uri,B,M))return _}}constructor(j,B,M,W,_,re,z){super(j,M.map(G=>new m.$Wi(G)),W,_,z),this.t=B,this.u=re,this.q=[],this.s=T.$Ii.forUris(z),M.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,B){return B&&this.s.get(j)&&(j=(0,C.$ch)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let N=class{constructor(j,B,M,W,_){this.c=new R.$je,this.onDidChangeWorkspace=this.c.event,this.g=new R.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$le,this.C=new Map,this.h=W,this.s=M,this.t=_,this.j=new l.$Jm,this.k=new h.$Bh,this.o=j.getProxy(w.$YM.MainThreadWorkspace),this.q=j.getProxy(w.$YM.MainThreadMessageService);const re=B.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,z=>b(z,M)):void 0}$initializeWorkspace(j,B){this.v=B,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,C.$ah)((0,C.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,B,M,...W){const _=[];if(Array.isArray(W)&&W.forEach(ee=>{u.URI.isUri(ee.uri)&&!_.some(ue=>D(ue.uri,ee.uri,this.s))&&_.push({uri:ee.uri,name:ee.name||(0,C.$_g)(ee.uri)})}),this.n||[B,M].some(ee=>typeof ee!="number"||ee<0)||M===0&&_.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(B+M>re.length)return!1;const z=re.slice(0);z.splice(B,M,..._.map(ee=>({uri:ee.uri,name:ee.name||(0,C.$_g)(ee.uri),index:void 0})));for(let ee=0;ee<z.length;ee++){const ue=z[ee];if(z.some((ne,De)=>De!==ee&&D(ue.uri,ne.uri,this.s)))return!1}z.forEach((ee,ue)=>ee.index=ue);const{added:G,removed:J}=k(re,z,I,this.s);if(G.length===0&&J.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,B,M,_).then(void 0,ue=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,P.localize)(0,null,ee,ue.toString()),ne,[])})}return this.y(z),!0}getWorkspaceFolder(j,B){if(this.x)return this.x.getWorkspaceFolder(j,B)}async getWorkspaceFolder2(j,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,B)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,B){let M,W="";if(typeof j=="string"?(M=u.URI.file(j),W=j):typeof j<"u"&&(M=j,W=j.fsPath),!M)return W;const _=this.getWorkspaceFolder(M,!0);if(!_)return W;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let re=(0,C.$fh)(_.uri,M);return B&&_.name&&(re=`${_.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:B,added:M,removed:W}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:W}))}findFiles(j,B,M,W,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let re="",z=!0;return B===null?z=!1:B!==void 0&&(typeof B=="string"?re=B:re=B.pattern),this.z(j,void 0,{exclude:re,maxResults:M,useDefaultExcludes:z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},_)}findFiles2(j,B={},M,W=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,B,W)}async z(j,B,M,W=A.CancellationToken.None){if(W&&W.isCancellationRequested)return Promise.resolve([]);const _=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,re={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:_,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let z;if(j){const{includePattern:G,folder:J}=O(t.GlobPattern.from(j));z=J,re.includePattern=G}else{const{includePattern:G,folder:J}=O(t.GlobPattern.from(B));z=J,re.filePattern=G}return this.o.$startFileSearch(z??null,re,W).then(G=>Array.isArray(G)?G.map(J=>u.URI.revive(J)):[])}async findTextInFiles(j,B,M,W,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),z=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:G,folder:J}=O(t.GlobPattern.from(B.include)),ee=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=u.URI.revive(De.resource);De.results.forEach(Q=>{const U=(0,y.$_h)(Q);(0,a.$kL)(U)?M({uri:$e,preview:{text:U.preview.text,matches:(0,r.$2b)(U.preview.matches,se=>new s.$3M(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$2b)(U.ranges,se=>new s.$3M(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:$e,text:U.text,lineNumber:U.lineNumber})})},_.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,J??null,ue,re,_);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,B){this.u[B]?.(j)}async save(j){const B=await this.o.$save(j,{saveAs:!1});return u.URI.revive(B)}async saveAs(j){const B=await this.o.$save(j,{saveAs:!0});return u.URI.revive(B)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,B){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,B);const M=this.t.transformOutgoingScheme(j),W=this.A++;return this.o.$registerEditSessionIdentityProvider(W,M),(0,L.$Tc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(W)})}async $getEditSessionIdentifier(j,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const W=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!W),!W)return;const _=await W.provideEditSessionIdentity(M,B);if(this.h.info("Provider returned edit session identifier: ",_),!!_)return _}async $provideEditSessionIdentityMatch(j,B,M,W){this.h.info("Getting edit session identifier for workspaceFolder",j);const _=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!_){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",_);const re=this.w.get(_.uri.scheme);if(this.h.info(`Provider for scheme ${_.uri.scheme} is defined: `,!!re),!re)return;const z=await re.provideEditSessionIdentityMatch?.(B,M,W);if(this.h.info("Provider returned edit session identifier match result: ",z),!!z)return z}getOnWillCreateEditSessionIdentityEvent(j){return(B,M,W)=>{const _=function(z){B.call(M,z)};return _.extension=j,this.B.event(_,void 0,W)}}async $onWillCreateEditSessionIdentity(j,B,M){const W=await this.resolveWorkspaceFolder(u.URI.revive(j));if(W===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:W},B,async(_,re)=>{const z=Date.now();await Promise.resolve(_),Date.now()-z>M&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(j,B){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,B);const M=this.t.transformOutgoingScheme(j),W=this.A++;return this.o.$registerCanonicalUriProvider(W,M),(0,L.$Tc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(W)})}async provideCanonicalUri(j,B,M){const W=this.C.get(j.scheme);if(!W)return;const _=await W.provideCanonicalUri?.(u.URI.revive(j),B,M);if(_)return _}async $provideCanonicalUri(j,B,M){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:B},M)}};e.$tnc=N,e.$tnc=N=Ye([qe(0,i.$sP),qe(1,o.$IP),qe(2,n.$cnc),qe(3,g.$9j),qe(4,d.$rnc)],N),e.$unc=(0,c.$Ci)("IExtHostWorkspace");function O(F){let j,B;return F&&(typeof F=="string"?j=F:(j=F.pattern,B=u.URI.revive(F.baseUri))),{includePattern:j,folder:B}}}),define(Ee[42],Se([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=e.$vnc=void 0;function g(d,a){if(a){const w=a.split(".");let y=d;for(let D=0;y&&D<w.length;D++)y=y[w[D]];return y}}function f(d){return d instanceof c.URI}function m(d){return d&&d.uri instanceof c.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof c.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function i(d){if(f(d))return{resource:d};if(m(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let t=class{constructor(a,w,y){this.a=a.getProxy(R.$YM.MainThreadConfiguration),this.c=w,this.b=y,this.d=new E.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(a,w))}};e.$vnc=t,e.$vnc=t=Ye([qe(0,P.$sP),qe(1,A.$unc),qe(2,p.$9j)],t);class s{constructor(a,w,y,D){this.a=new h.$je,this.b=a,this.f=D,this.c=w,this.e=$.$Ko.parse(y,D),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Ko.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(a,w,y){const D=i(w)||{},S=this.g(a?g(this.e.getValue(void 0,D,this.c.workspace),a):this.e.getValue(void 0,D,this.c.workspace));a&&this.h(a,D,y?.identifier);function I(b){if(b==null)return null;if(typeof b=="boolean")return b?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(b){case L.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(b){return typeof g(S,b)<"u"},get:(b,v)=>{this.h(a?`${a}.${b}`:b,D,y?.identifier);let N=g(S,b);if(typeof N>"u")N=v;else{let O;const F=(j,B)=>{if((0,C.$eg)(j)){let M;const W=()=>{O=O||(0,r.$_n)(S),M=M||g(O,B)};return new Proxy(j,{get:(_,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return W(),()=>M;if(O)return M=M||g(O,B),M[re];const z=_[re];return typeof re=="string"?F(z,`${B}.${re}`):z},set:(_,re,z)=>(W(),M&&(M[re]=z),!0),deleteProperty:(_,re)=>(W(),M&&delete M[re],!0),defineProperty:(_,re,z)=>(W(),M&&Object.defineProperty(M,re,z),!0)})}return Array.isArray(j)?(0,r.$_n)(j):j};N=F(N,b)}return N},update:(b,v,N,O)=>{b=a?`${a}.${b}`:b;const F=I(N);return v!==void 0?this.b.$updateConfigurationOption(F,b,v,D,O):this.b.$removeConfigurationOption(F,b,D,O)},inspect:b=>{b=a?`${a}.${b}`:b;const v=this.e.inspect(b,D,this.c.workspace);if(v)return{key:b,defaultValue:(0,r.$_n)(v.policy?.value??v.default?.value),globalValue:(0,r.$_n)(v.user?.value??v.application?.value),workspaceValue:(0,r.$_n)(v.workspace?.value),workspaceFolderValue:(0,r.$_n)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$_n)(v.default?.override),globalLanguageValue:(0,r.$_n)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$_n)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$_n)(v.workspaceFolder?.override),languageIds:(0,r.$_n)(v.overrideIdentifiers)}}};return typeof S=="object"&&(0,r.$co)(k,S,!1),Object.freeze(k)}g(a){const w=y=>(0,C.$eg)(y)?new Proxy(y,{get:(D,S)=>w(D[S]),set:(D,S,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(D,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(D,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(a)}h(a,w,y){const D=l.$Bo.test(a)?l.ConfigurationScope.RESOURCE:this.d.get(a),S=y?`[${y.value}] `:"";if(l.ConfigurationScope.RESOURCE===D){typeof w?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===D){w?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,w){const y=new $.$Mo(a,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,S)=>y.affectsConfiguration(D,i(S))})}k(a){return a.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$wnc=s,e.$xnc=(0,u.$Ci)("IExtHostConfiguration")}),define(Ee[101],Se([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=e.$6oc=e.$5oc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=Ue(L),g=Ue(g);var i;(function(O){function F(B){if(B!=null)return B}O.from=F;function j(B){if(B!=null)return B}O.to=j})(i||(i={}));var t;(function(O){function F(B){if(B!=null)return B}O.from=F;function j(B){if(B!=null)return B}O.to=j})(t||(t={}));var s;(function(O){function F(B){if(B!=null)return B}O.from=F;function j(B){if(B!=null)return B}O.to=j})(s||(s={}));var d;(function(O){function F(M){if(M){const W=M;return W&&!!W.process}else return!1}O.is=F;function j(M){if(M==null)return;const W={process:M.process,args:M.args};return M.options&&(W.options=s.from(M.options)),W}O.from=j;function B(M){if(M!=null)return new L.$KN(M.process,M.args,M.options)}O.to=B})(d||(d={}));var a;(function(O){function F(B){if(B!=null)return B}O.from=F;function j(B){if(B!=null)return B}O.to=j})(a||(a={}));var w;(function(O){function F(M){if(M){const W=M;return W&&(!!W.commandLine||!!W.command)}else return!1}O.is=F;function j(M){if(M==null)return;const W={};return M.commandLine!==void 0?W.commandLine=M.commandLine:(W.command=M.command,W.args=M.args),M.options&&(W.options=a.from(M.options)),W}O.from=j;function B(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$LN(M.commandLine,M.options):new L.$LN(M.command,M.args?M.args:[],M.options)}O.to=B})(w||(w={}));var y;(function(O){function F(M){if(M){const W=M;return W&&W.customExecution==="customExecution"}else return!1}O.is=F;function j(M){return{customExecution:"customExecution"}}O.from=j;function B(M,W){return W.get(M)}O.to=B})(y||(e.CustomExecutionDTO=y={}));var D;(function(O){function F(j,B){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&B&&B.workspaceFile?M=B.workspaceFile:M=n.$BI),{id:j._id,workspaceFolder:M}}O.from=F})(D||(e.TaskHandleDTO=D={}));var S;(function(O){function F(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=F})(S||(S={}));var I;(function(O){function F(M,W){if(M==null)return[];const _=[];for(const re of M){const z=j(re,W);z&&_.push(z)}return _}O.fromMany=F;function j(M,W){if(M==null)return;let _;M.execution instanceof L.$KN?_=d.from(M.execution):M.execution instanceof L.$LN?_=w.from(M.execution):M.execution&&M.execution instanceof L.$MN&&(_=y.from(M.execution));const re=i.from(M.definition);let z;return M.scope?typeof M.scope=="number"?z=M.scope:z=M.scope.uri:z=L.TaskScope.Workspace,!re||!z?void 0:{_id:M._id,definition:re,name:M.name,source:{extensionId:W.identifier.value,label:M.source,scope:z},execution:_,isBackground:M.isBackground,group:S.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=j;async function B(M,W,_){if(M==null)return;let re;d.is(M.execution)?re=d.to(M.execution):w.is(M.execution)?re=w.to(M.execution):y.is(M.execution)&&(re=y.to(M._id,_));const z=i.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await W.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):G=L.TaskScope.Workspace),!z||!G)return;const J=new L.$NN(z,G,M.name,M.source.label,re,M.problemMatchers);return M.isBackground!==void 0&&(J.isBackground=M.isBackground),M.group!==void 0&&(J.group=L.$JN.from(M.group._id),J.group&&M.group.isDefault&&(J.group=new L.$JN(J.group.id,J.group.label),M.group.isDefault===!0&&(J.group.isDefault=M.group.isDefault))),M.presentationOptions&&(J.presentationOptions=t.to(M.presentationOptions)),M._id&&(J._id=M._id),M.detail&&(J.detail=M.detail),J}O.to=B})(I||(e.TaskDTO=I={}));var k;(function(O){function F(B){return B}O.from=F;function j(B){if(B)return Object.assign(Object.create(null),B)}O.to=j})(k||(k={}));class b{#e;constructor(F,j,B){this._id=j,this.a=B,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let v=class{constructor(F,j,B,M,W,_,re,z){this.q=new A.$je,this.r=new A.$je,this.s=new A.$je,this.u=new A.$je,this.a=F.getProxy(R.$YM.MainThreadTask),this.b=B,this.c=M,this.d=W,this.e=_,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,j,B){if(!B)return new L.$1M(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:B,extension:F}),this.a.$registerTaskProvider(M,j),new L.$1M(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(F,j){this.a.$registerTaskSystem(F,j)}fetchTasks(F){return this.a.$fetchTasks(k.from(F)).then(async j=>{const B=[];for(const M of j){const W=await I.to(M,this.b,this.m);W&&B.push(W)}return B})}get taskExecutions(){const F=[];return this.k.forEach(j=>F.push(j)),F}terminateTask(F){if(!(F instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,j,B){const M=this.m.get(F.id);M&&(this.o.set(F.id,M),this.e.attachPtyToTerminal(j,await M.callback(B))),this.p=F.id,this.q.fire({execution:await this.z(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){if(!this.l.has(F.id))return;const j=await this.z(F);this.l.delete(F.id),this.k.delete(F.id),this.B(F),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const j=await this.z(F.id);this.s.fire({execution:j,processId:F.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(F){const j=await this.z(F.id);this.u.fire({execution:j,exitCode:F.exitCode})}$provideTasks(F,j){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));const M=[],W=(0,h.$uh)(()=>B.provider.provideTasks(C.CancellationToken.None)).then(_=>this.v(j,M,B,_));return new Promise(_=>{W.then(re=>{Promise.all(M).then(()=>{_(re)})})})}async $resolveTask(F,j){const B=this.j.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(j.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${B.type}].`);const M=await I.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const W=await B.provider.resolveTask(M,C.CancellationToken.None);if(!W)return;this.A(W,B);const _=I.from(W,B.extension);if(!_)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(_.execution)&&await this.y(_,W,!0),await this.w(_)}x(){return this.h++}async y(F,j,B){const M=await this.a.$createTaskId(F);!B&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(F,j){if(typeof F=="string"){const W=this.l.get(F);if(!W)throw new o.$cb("Unexpected: The specified task is missing an execution");return W}const B=this.l.get(F.id);if(B)return B;let M;return j?M=Promise.resolve(new b(this,F.id,j)):M=I.to(F.task,this.b,this.m).then(W=>{if(!W)throw new o.$cb("Unexpected: Task does not exist.");return new b(this,F.id,W)}),this.l.set(F.id,M),M.then(W=>(this.k.set(F.id,W),W))}A(F,j){F._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const B=this.n.values();let M=B.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=B.next()}};e.$5oc=v,e.$5oc=v=Ye([qe(0,u.$sP),qe(1,P.$IP),qe(2,T.$unc),qe(3,$.$DP),qe(4,l.$xnc),qe(5,E.$Vnc),qe(6,f.$9j),qe(7,m.$$mc)],v);let N=class extends v{constructor(F,j,B,M,W,_,re,z){super(F,j,B,M,W,_,re,z),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(g.Platform.Web)})}async executeTask(F,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const B=I.from(j,F);if(B===void 0)throw new Error("Task is not valid");if(y.is(B.execution))await this.y(B,j,!1);else throw new o.$ab;const M=await this.z(await this.a.$getTaskExecution(B),j);return this.a.$executeTask(B).catch(W=>{throw new Error(W)}),M}v(F,j,B,M){const W=[];if(M)for(const _ of M){if(this.A(_,B),!_.definition||!F[_.definition.type]){const z=_.source?_.source:"No task source";this.f.warn(`The task [${z}, ${_.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=I.from(_,B.extension);re&&y.is(re.execution)?(W.push(re),j.push(this.y(re,_,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:B.extension}}async w(F){if(y.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,j,B){}};e.$6oc=N,e.$6oc=N=Ye([qe(0,u.$sP),qe(1,P.$IP),qe(2,T.$unc),qe(3,$.$DP),qe(4,l.$xnc),qe(5,E.$Vnc),qe(6,f.$9j),qe(7,m.$$mc)],N),e.$7oc=(0,p.$Ci)("IExtHostTask")}),define(Ee[384],Se([1,0,38,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=void 0,e.$KL=A,e.$ML=R;function A(L){return"cellResults"in L}e.$LL="rawCell#";function R(L,T){let $=-1;const l=[];let C=[];return L.forEach(u=>{u.range.startLineNumber!==$&&C.length>0&&(l.push([...C]),C=[]),C.push(u),$=u.range.endLineNumber}),C.length>0&&l.push([...C]),l.map(u=>{const P=[],p=u[0].range.startLineNumber,c=u[u.length-1].range.endLineNumber;for(let g=p;g<=c;g++)P.push(T.getLineContent(g));return new r.$oL(P.join(`
`)+`
`,u.map(g=>new h.$Ft(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(Ee[385],Se([1,0,238,22,4,3,29,41,13,18,2,28,119,6,35,17,10,51,357,164,25,15,38,313,384,381]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0,E=Ue(E),c=Ue(c),g=Ue(g);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,S,I,k,b,v,N){this.q=I,this.r=k,this.s=b,this.t=v,this.u=N,this.f=new Map,this.g=new L.$Bc,this.h=new Map,this.j=new A.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$9mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$YM.MainThreadNotebook),this.c=D.getProxy(P.$YM.MainThreadNotebookDocuments),this.d=D.getProxy(P.$YM.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===T.MarshalledId.NotebookCellActionContext){const F=O.notebookEditor?.notebookUri,j=O.cell.handle,M=this.g.get(F)?.getCell(j);if(M)return M.apiCell}if(O&&O.$mid===T.MarshalledId.NotebookActionContext){const F=O.uri,j=this.g.get(F);if(j)return j.apiNotebook}return O}}),w.C(S)}getEditorById(D){const S=this.h.get(D);if(!S)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(D){for(const[S,I]of this.h)if(I.apiEditor===D)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,S){const I=this.g.get(D);if(!I&&!S)throw new Error(`NO notebook document for '${D}'`);return I}static w(D,S){if(!S)return;const I=S.filenamePattern.map(k=>c.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(S.filenamePattern&&!I){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:S.displayName,filenamePattern:I,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,S,I){const k=w.a++,b=typeof I.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(k,I),this.b.$registerNotebookCellStatusBarItemProvider(k,b,S);let v;return b!==void 0&&(v=I.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(b))),new g.$1M(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,b),v?.dispose()})}async createNotebookDocument(D){const S=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&c.NotebookData.from(D.content)});return C.URI.revive(S)}async openNotebookDocument(D){const S=this.g.get(D);if(S)return S.apiNotebook;const I=await this.c.$tryOpenNotebook(D),k=this.g.get(C.URI.revive(I));return(0,l.$ng)(k?.apiNotebook)}async showNotebookDocument(D,S){C.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let I;typeof S=="object"?I={position:c.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(c.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:I={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,I),b=k&&this.h.get(k)?.apiEditor;if(b)return b;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,S,I,k){const b=this.f.get(D),v=C.URI.revive(S),N=this.g.get(v);if(!N||!b)return;const O=N.getCellFromIndex(I);if(!O)return;const F=await b.provideCellStatusBarItems(O.apiCell,k);if(!F)return;const j=new R.$Uc,B=this.p.add([j]),W=(Array.isArray(F)?F:[F]).map(_=>c.NotebookStatusBarItem.from(_,this.i,j));return{cacheId:B,items:W}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,S,I,k,b){if((0,$.$af)(S))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:S,serializer:I,options:k}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},S,c.NotebookDocumentContentOptions.from(k),w.w(D,b)),(0,R.$Tc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,S,I){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const b=await k.serializer.deserializeNotebook(S.buffer,I);return new f.$Nw(c.NotebookData.from(b))}async $notebookToData(D,S,I){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const b=await k.serializer.serializeNotebook(c.NotebookData.to(S.value),I);return h.$Le.wrap(b)}async $saveNotebook(D,S,I,k,b){const v=C.URI.revive(S),N=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${I}, ${v.toString()})`),!N)throw new Error("NO serializer found");const O=this.g.get(v);if(!O)throw new Error("Document NOT found");if(O.versionId!==I)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$rl((0,r.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const F={metadata:(0,o.$ho)(O.apiNotebook.metadata,_=>!(N.options?.transientDocumentMetadata??{})[_]),cells:[]};for(const _ of O.apiNotebook.getCells()){const re=new g.$rO(_.kind,_.document.getText(),_.document.languageId,_.mime,N.options?.transientOutputs?[]:[..._.outputs],_.metadata,_.executionSummary);re.metadata=(0,o.$ho)(_.metadata,z=>!(N.options?.transientCellMetadata??{})[z]),F.cells.push(re)}if(await this.z(v,k),b.isCancellationRequested)throw new Error("canceled");const j=await N.serializer.serializeNotebook(F,b);if(b.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${I} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${I} ${v.toString()}`);const B=this.s.getFileSystemProviderExtUri(v.scheme),M=await this.s.value.stat(v),W={name:B.basename(v),isFile:(M.type&E.FileType.File)!==0,isDirectory:(M.type&E.FileType.Directory)!==0,isSymbolicLink:(M.type&E.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((M.permissions??0)&E.FilePermission.Locked),etag:E.$Cl({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${I}, ${v.toString()})`),W}async $searchInNotebooks(D,S,I,k,b){const v=this.y.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const N=new L.$Cc;await(async(M,W,_)=>{await Promise.all(M.map(async re=>await Promise.all(re.filenamePatterns.map(z=>{const G={_reason:_._reason,folderQueries:_.folderQueries,includePattern:_.includePattern,excludePattern:_.excludePattern,maxResults:_.maxResults,type:t.QueryType.File,filePattern:z};return this.t.doInternalFileSearchWithCustomCallback(G,W,J=>{J.forEach(ee=>{N.has(ee)||k.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,a.$6hb)(De,ee)))||N.add(ee)})}).catch(J=>{if(J.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw J})}))))})(I,b,S);const F=new L.$Bc;let j=!1;const B=Array.from(N).map(async M=>{const W=[];try{if(b.isCancellationRequested)return;if(S.maxResults&&[...F.values()].reduce((G,J)=>G+J.cellResults.length,0)>S.maxResults){j=!0;return}const _=[],re=this.g.get(M);if(re)re.apiNotebook.getCells().forEach(J=>_.push({input:J.document.getText(),outputs:J.outputs.flatMap(ee=>ee.items.map(ue=>ue.data.toString()))}));else{const G=await this.s.value.readFile(M),J=h.$Le.fromString(G.toString()),ee=await v.deserializeNotebook(J.buffer,b);if(b.isCancellationRequested)return;c.NotebookData.from(ee).cells.forEach(ne=>_.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(b.isCancellationRequested)return;_.forEach((G,J)=>{const ee=S.contentPattern.pattern,ue=new s.$uYb(G.input,void 0,G.outputs),ne=ue.findInInputs(ee),De=ue.findInOutputs(ee),$e=De.flatMap(Q=>(0,d.$ML)(Q.matches,Q.textBuffer)).map((Q,U)=>(Q.webviewIndex=U,Q));if(ne.length>0||De.length>0){const Q={index:J,contentResults:(0,d.$ML)(ne,ue.inputTextBuffer),webviewResults:$e};W.push(Q)}});const z={resource:M,cellResults:W};F.set(M,z);return}catch{return}});return await Promise.all(B),{limitHit:j,results:[...F.values()]}}async z(D,S){const I=await this.s.value.stat(D);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==E.$Bl&&typeof I.mtime=="number"&&typeof I.size=="number"&&S.mtime<I.mtime&&S.etag!==E.$Cl({mtime:S.mtime,size:I.size}))throw new E.$rl((0,r.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,S)}A(D){return D.scheme===i.Schemas.file?D.fsPath:D.toString()}B(D,S,I){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const k=new n.$yoc(S,this.d,D,I.visibleRanges.map(c.NotebookRange.to),I.selections.map(c.NotebookRange.to),typeof I.viewColumn=="number"?c.ViewColumn.to(I.viewColumn):void 0);this.h.set(S,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const I of D.value.removedDocuments){const k=C.URI.revive(I),b=this.g.get(k);b&&(b.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===k.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const I=[];for(const k of D.value.addedDocuments){const b=C.URI.revive(k.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new m.$xoc(this.c,this.q,this.r,b,k);I.push(...k.cells.map(N=>m.$woc.asModelAddData(N))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:I}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const I of D.value.addedEditors){if(this.h.has(I.id))return;const k=C.URI.revive(I.documentUri),b=this.g.get(k);b&&this.B(b,I.id,I)}const S=[];if(D.value.removedEditors)for(const I of D.value.removedEditors){const k=this.h.get(I);k&&(this.h.delete(I),this.k?.id===k.id&&(this.k=void 0),S.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const I=new Set;this.l.forEach(k=>I.add(k.id));for(const k of this.h.values()){const b=I.has(k.id);k._acceptVisibility(b)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const S=p.$QP.String.with("notebookType","A notebook type"),I=new p.$SP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new p.$QP("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>h.$Le.wrap(b))],new p.$RP("Notebook Data",b=>c.NotebookData.to(b.value))),k=new p.$SP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new p.$QP("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new f.$Nw(c.NotebookData.from(b)))],new p.$RP("Bytes",b=>b.buffer));D.registerApiCommand(I),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Hoc=w}),define(Ee[386],Se([1,0,16,21,55,39,23,43,38]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,r=Ue(r),R=Ue(R),L=Ue(L);class l{constructor(u,P,p){this.k=u,this.l=P,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$wk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$wk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const P=this.k.folderQueries||[];return new Promise((p,c)=>{const g=f=>{this.f++,u(f)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const m=f.toString(),n=r.$oc(m);this.j&&this.j(m,n)||this.v(g,{base:f,basename:n})}),Promise.all(P.map(f=>this.p(f,g))).then(f=>{p({limitHit:this.e,stats:f[0]||void 0})},f=>{c(new Error((0,A.$nj)(f)))})})}async p(u,P){const p=new h.$ue,c=this.q(u),g=this.r(),f=new $.$CL(this.k,u),m=!f.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=T.$de.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,p.token),i=n.elapsed(),t=T.$de.create();return this.g&&!this.e||(o&&o.forEach(s=>{const d=r.$hc.relative(u.folder.path,s.path);if(m){const a=r.$oc(s.path);this.v(P,{base:u.folder,relativePath:d,basename:a});return}this.s(g,u.folder,d,P)}),this.g&&!this.e)?null:(this.u(g,f,P),{providerTime:i,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const P=(0,$.$BL)(this.k.includePattern,u.includePattern),p=(0,$.$BL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:P,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},P,p,c){if(p===this.a){const f=r.$oc(this.a);this.v(c,{base:P,relativePath:this.a,basename:f})}function g(f){const m=r.$oc(f),n=r.$nc(f);let o=u[n];o||(o=u[n]=[],g(n)),o.push({base:P,relativePath:f,basename:m})}g(p)}u({rootEntries:u,pathToEntries:P},p,c){const g=this,f=this.a;function m(n){const o=(0,$.$EL)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const s=n[i],{relativePath:d,basename:a}=s;if(p.matchesExcludesSync(d,a,f!==a?o:void 0))continue;const w=P[d];if(w)m(w);else{if(d===f)continue;g.v(c,s)}if(g.e)break}}m(u)}v(u,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(P))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,P,p,c){const g=this.c(u.cacheKey),f=new l(u,P,g&&g.token);let m=0;const n=o=>{m+=o.length,p(o.map(i=>this.d(i)))};return this.e(f,C.a,n,c).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:L.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,P,p,c){const g=c.onCancellationRequested(()=>{u.cancel()}),f=n=>{n&&(m.push(n),P>0&&m.length>=P&&(p(m),m=[]))};let m=[];return u.search(f).then(n=>(m.length&&p(m),g.dispose(),n),n=>(m.length&&p(m),g.dispose(),Promise.reject(n)))}}e.$zoc=C}),define(Ee[387],Se([1,0,19,79,39,110,29,15,16,23,13,18,2,107,261,45,12,46,156,382,38]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=void 0,e.$DM=S,r=Ue(r),h=Ue(h),A=Ue(A),$=Ue($),C=Ue(C),p=Ue(p);let i=class{constructor(k,b,v,N,O){this.a=k,this.b=b,this.c=v,this.d=N,this.e=O}text(k,b,v={}){k=this.f(k,v);const N=this.a.getValue(),O=b&&b.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(b?.map(f.$Xi),v),type:o.QueryType.Text,contentPattern:k,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(k,b){const v=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const N={...k,wordSeparators:v.editor.wordSeparators};return this.j(k,b)&&(N.isCaseSensitive=!0),this.k(k)&&(N.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),N}file(k,b={}){return{...this.h(k,b),type:o.QueryType.File,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(k,b){return k?(k=Array.isArray(k)?k.map(w):w(k),b?this.parseSearchPaths(k):{pattern:s(...Array.isArray(k)?k:[k])}):{}}h(k=[],b={}){const v=this.g(b.includePattern,b.expandPatterns),N=this.g(b.excludePattern,b.expandPatterns),O=k.length>1,F=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.q(M,b,N)):k.map(M=>this.r(M,b,N,O))).filter(M=>!!M),j={_reason:b._reason,folderQueries:F,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:N.pattern,includePattern:v.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const M=r.$Ib(this.c.groups.flatMap(re=>re.editors.map(z=>z.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const W=M.filter(re=>(0,o.$sL)(j,re.fsPath)),_=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...j,..._}}const B=b.extraFileResources&&b.extraFileResources.filter(M=>(0,o.$sL)(j,M.fsPath));return j.extraFileResources=B&&B.length?B:void 0,j}i(k){const b=[],v=new L.$Bc,N={};let O=!1;return k.forEach(F=>{if(F.scheme===T.Schemas.walkThrough)return;if((0,l.$hh)(F)){const B=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$nc(F.fsPath)});let M=v.get(B);M||(O=!0,M={folder:B,includePattern:{}},b.push(M),v.set(B,M));const W=$.$mc(B.fsPath,F.fsPath);(0,E.$ng)(M.includePattern)[W.replace(/\\/g,"/")]=!0}else F.fsPath&&(O=!0,N[F.fsPath]=!0)}),{folderQueries:b,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(k,b){if(b.isSmartCase){if(k.isRegExp){if(C.$6f(k.pattern,!0))return!0}else if(C.$6f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,P.$8C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const b=_=>$.$jc(_)||/^\.\.?([\/\\]|$)/.test(_),N=(Array.isArray(k)?k:d(k)).map(_=>{const re=this.e.resolvedUserHome;return re?(0,R.$Sw)(_,re.scheme===T.Schemas.file?re.fsPath:re.path):_}),O=h.$K(N,_=>b(_)?"searchPaths":"exprSegments"),F=(O.exprSegments||[]).map(_=>C.$lf(_,"/")).map(_=>C.$lf(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),a(_))),j={},B=this.m(O.searchPaths||[]);B&&B.length&&(j.searchPaths=B);const M=F.flat(),W=s(...M);return W&&(j.pattern=W),j}l(k,b){return b.disregardExcludeSettings?void 0:(0,o.$rL)(k,!b.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const b=k.flatMap(N=>{let{pathPortion:O,globPortion:F}=t(N);return F&&(F=y(F)),this.n(O).flatMap(B=>this.o(B,F))}),v=new Map;return b.forEach(N=>{const O=N.searchPath.toString(),F=v.get(O);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):v.set(O,{searchPath:N.searchPath,pattern:N.pattern?s(N.pattern):void 0})}),Array.from(v.values())}n(k){if($.$jc(k)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==T.Schemas.file?[{searchPath:b[0].uri.with({path:k})}]:[{searchPath:u.URI.file($.$ic(k))}]}if(this.b.getWorkbenchState()===f.WorkbenchState.FOLDER){const b=this.b.getWorkspace().folders[0].uri;if(k=w(k),k.startsWith("../")||k===".."){const N=$.$hc.resolve(b.path,k);return[{searchPath:b.with({path:N})}]}const v=y(k);return[{searchPath:b,pattern:v}]}else{if(k==="./"||k===".\\")return[];{const b=k.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const F=b.match(new RegExp(`^${C.$ff(O.name)}(?:/(.*)|$)`));return F?{match:F,folder:O}:null}).filter(E.$kg);if(N.length)return N.map(O=>{const F=O.match[1];return{searchPath:O.folder.uri,pattern:F&&y(F)}});{const O=k.match(/\.[\/\\](.+)[\/\\]?/),F=O?O[1]:k,j=p.localize(0,null,F);throw new Error(j)}}}}o(k,b){const v=k.pattern&&b?`${k.pattern}/${b}`:k.pattern||b,N=[{searchPath:k.searchPath,pattern:v}];return v&&!v.endsWith("**")&&N.push({searchPath:k.searchPath,pattern:v+"/**"}),N}q(k,b,v){const N=this.r((0,f.$Xi)(k.searchPath),b,v,!1);return N?{...N,includePattern:k.pattern}:null}r(k,b,v,N){let O;const F=u.URI.isUri(k)?k:k.uri;if(v.searchPaths){const _=v.searchPaths.filter(re=>(0,l.$9g)(re.searchPath,F))[0];if(_&&!_.pattern)return null;_&&(O=_.pattern)}const j=this.a.getValue({resource:F}),M={...this.l(j,b)||{},...O||{}},W=u.URI.isUri(k)?(0,l.$ah)(k):k.name;return{folder:F,folderName:N?W:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!j.search.followSymlinks}}};e.$CM=i,e.$CM=i=Ye([qe(0,c.$9i),qe(1,f.$Li),qe(2,m.$dE),qe(3,g.$9j),qe(4,n.$AM)],i);function t(I){const k=I.match(/[\*\{\}\(\)\[\]\?]/);if(k){const b=k.index,v=I.substr(0,b).match(/[/|\\][^/\\]*$/);if(v){let N=I.substr(0,v.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:I.substr((v.index||0)+1)}}}return{pathPortion:I}}function s(...I){return I.length?I.reduce((k,b)=>(k[b]=!0,k),Object.create(null)):void 0}function d(I){return A.$uk(I,",").map(k=>k.trim()).filter(k=>!!k.length)}function a(I){return[`**/${I}/**`,`**/${I}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function w(I){return I.replace(/\\/g,"/")}function y(I){return w(I).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(I){return I.replace(/([?*[\]])/g,"[$1]")}function S(I,k){I=r.$Nb(I,N=>N.toString());const b=[],v=k.getWorkspace();return I&&I.forEach(N=>{let O;if(k.getWorkbenchState()===f.WorkbenchState.FOLDER)O=(0,l.$fh)(v.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const F=k.getWorkspaceFolder(N);if(F){const j=F.name;if(v.folders.filter(M=>M.name===j).length===1){const M=(0,l.$fh)(F.uri,N);M===""?O=`./${F.name}`:O=`./${F.name}/${M}`}else O=N.fsPath}}O&&b.push(D(O))}),b}}),define(Ee[388],Se([1,0,23,2,21,14,5,387,38,46,9]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mxb=u,e.$nxb=c,r=Ue(r),R=Ue(R);const E=7e3;function u(g,f){const m=f.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],o=[];for(const w of m)if(/^workspaceContains:/.test(w)){const y=w.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||g.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,C.$vh)(),s=w=>t({activationEvent:w}),d=Promise.all(n.map(w=>P(g,w,s))).then(()=>{}),a=p(g,f.identifier,o,s);return Promise.all([d,a]).then(()=>{t(void 0)}),i}async function P(g,f,m){for(const n of g.folders)if(await g.exists(r.$dh(h.URI.revive(n),f))){m(`workspaceContains:${f}`);return}}async function p(g,f,m,n){if(m.length===0)return Promise.resolve(void 0);const o=new A.$ue,i=g.checkExists(g.folders,m,o.token),t=setTimeout(async()=>{o.cancel(),g.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},E);let s=!1;try{s=await i}catch(d){R.$5(d)||R.$2(d)}o.dispose(),clearTimeout(t),s&&n(`workspaceContains:${m.join(",")}`)}function c(g,f,m,n){const o=g.get(L.$Bi),i=g.get($.$jL),s=o.createInstance(T.$CM).file(f.map(d=>(0,l.$Xi)(h.URI.revive(d))),{_reason:"checkExists",includePattern:m,exists:!0});return i.fileSearch(s,n).then(d=>!!d.limitHit,d=>R.$5(d)?!1:Promise.reject(d))}}),define(Ee[52],Se([1,0,234,16,62,23,9,3,85,2,12,6,42,320,126,48,26,158,14,24,22,298,10,72,5,30,98,20,115,77,47,129,4,388,125,300,15,123,43,11,124]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a,w,y,D,S,I,k,b,v,N,O,F,j,B,M,W){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=e.$$nc=e.$0nc=e.$9nc=void 0,r=Ue(r),h=Ue(h),A=Ue(A),m=Ue(m),e.$9nc=(0,d.$Ci)("IHostUtils");let re=_=class extends T.$Vc{constructor(Q,U,se,oe,te,le,he,X,ae,pe,be,Me,We){super(),this.Y=Me,this.Z=We,this.a=this.B(new b.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=U,this.g=se,this.f=he,this.j=oe,this.m=te,this.s=le,this.t=ae,this.u=pe,this.w=be,this.y=this.g.getProxy(E.$YM.MainThreadWorkspace),this.z=this.g.getProxy(E.$YM.MainThreadTelemetry),this.C=this.g.getProxy(E.$YM.MainThreadExtensionService),this.D=new L.$Bh,this.F=new L.$Bh,this.G=new L.$Bh,this.H=new L.$Bh,this.I=new De(this.f.extensions.activationEvents),this.L=new f.$Cbc(this.I,this.f.extensions.allExtensions);const ke=new n.$on(this.f.extensions.myExtensions);this.J=new f.$Cbc(this.I,ue(this.L,ke)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${J(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${J(this.J)}`)),this.M=new p.$Rnc(this.g,this.s),this.N=new N.$2nc(this.g),this.O=X,this.h=Q.createChild(new D.$Ai([p.$Snc,this.M],[N.$3nc,this.N])),this.P=this.B(new P.$Qnc(this.J,this.L,{onExtensionActivationError:(Ie,Te,V)=>{this.C.$onExtensionActivationError(Ie,m.$4(Te),V)},actualActivateExtension:async(Ie,Te)=>{if(f.$Cbc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Te),new P.$Pnc;const V=this.J.getExtensionDescription(Ie);return this.fb(V,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Q){m.$2(Q)}}async $(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(Q)}terminate(Q,U=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),m.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Dh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const U=await this.C.$getExtension(Q);return U&&{...U,identifier:new n.$nn(U.identifier.value),extensionLocation:l.URI.revive(U.extensionLocation)}}ab(Q,U){return this.P.activateByEvent(Q,U)}bb(Q,U){return this.P.activateById(Q,U)}activateByIdWithErrors(Q,U){return this.bb(Q,U).then(()=>{const se=this.P.getActivatedExtension(Q);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async cb(Q){if(Q.scheme===F.Schemas.file&&this.c.fsRealpath){const U=Q.fsPath;this.R.has(U)||this.R.set(U,this.c.fsRealpath(U));const se=await this.R.get(U);return l.URI.file(se)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Q=>new ne(Q))),this.Q}async db(Q){const U=$.$Ii.forUris(se=>R.$7g.ignorePathCasing(se));return await Promise.all(Q.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);U.set(oe,se)}})),U}eb(Q){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return U;const se=this.P.getActivatedExtension(Q);if(!se)return U;try{typeof se.module.deactivate=="function"&&(U=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(oe)}try{(0,T.$Qc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.s.error(oe)}return U}async fb(Q,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.hb(Q,U).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,U),this.gb(Q,U,"success",oe),se},se=>{throw this.gb(Q,U,"failure"),se})}gb(Q,U,se,oe){const te=G(Q,U);this.z.$publicLog2("extensionActivationTimes",{...te,...oe||{},outcome:se})}hb(Q,U){const se=G(Q,U);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(Q);if(!oe)return Promise.resolve(new P.$Onc(P.$Lnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${Q.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const te=new P.$Mnc(U.startup);return Promise.all([this.xb(Q,(0,R.$dh)(Q.extensionLocation,oe),te),this.ib(Q)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),_.jb(this.s,Q.identifier,le[0],le[1],te))).then(le=>(A.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),le))}ib(Q){const U=this.Z.createLanguageModelAccessInformation(Q),se=new i.$Unc(Q,this.M),oe=new i.$Tnc(Q.identifier.value,!1,this.M),te=new O.$4nc(Q,this.N),le=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const X=this;let ae,pe;const be=(0,g.$1G)(Q,"ipc")?this.f.messagePorts?.get(n.$nn.toKey(Q.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:te,subscriptions:[],get languageModelAccessInformation(){return U},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Me){return h.$kc(Q.extensionLocation.fsPath,Me)},get storagePath(){return X.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return X.O.globalValue(Q).fsPath},get logPath(){return h.$kc(X.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return l.URI.joinPath(X.f.logsLocation,Q.identifier.value)},get storageUri(){return X.O.workspaceValue(Q)},get globalStorageUri(){return X.O.globalValue(Q)},get extensionMode(){return le},get extension(){return ae===void 0&&(ae=new ee(X,Q.identifier,Q,he,!1)),ae},get extensionRuntime(){return(0,g.$2G)(Q,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!pe){if(!be)return;const Me=b.Event.buffer(b.Event.fromDOMEventEmitter(be,"message",We=>We.data));be.start(),pe={onDidReceiveMessage:Me,postMessage:be.postMessage.bind(be)}}return pe}})})}static jb(Q,U,se,oe,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(Q,U,se,oe,te).then(le=>new P.$Nnc(!1,null,te.build(),se,le,oe.subscriptions))}static kb(Q,U,se,oe,te){if(typeof se.activate=="function")try{te.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${U.value}`);const le=typeof global=="object"?global:self,he=se.activate.apply(le,[oe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(he).then(X=>(te.activateResolveStop(),X))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(Q,U){this.bb(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:U}).then(void 0,se=>{this.s.error(se)})}mb(Q,U=0){const oe=Date.now();(0,M.$B)(()=>{for(let te=U;te<Q.length;te+=1){const le=Q[te];for(const he of le.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-oe>50){this.mb(Q,te);break}else this.lb(le,he)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Q=>{const U=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(U)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const te of oe.activationEvents)te==="onStartupFinished"&&this.lb(oe,te)})}ob(){const Q=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const U=this.j.workspace?this.j.workspace.folders:[],se=this.pb(U),oe=this.rb(),te=Promise.all([oe,Q,se]).then(()=>{});return Promise.race([te,(0,L.$Dh)(1e4)]).then(()=>{this.nb()}),te}pb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.qb(Q,U))).then(()=>{})}async qb(Q,U){if(this.isActivated(U.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:Q.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,he,X)=>this.y.$checkExists(le,he,X)},te=await(0,v.$mxb)(oe,U);if(te)return this.bb(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Q){throw console.error(Q),Q}}async sb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:U}=this.f.environment;if(!Q||!U)throw new Error(r.localize(0,null));const se=await this.xb(null,U,new P.$Mnc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,U.toString()));return new Promise((oe,te)=>{const le=(ae,pe)=>{ae?(M.$t&&this.s.error("Test runner called back with error",ae),te(ae)):(M.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof pe=="number"&&pe>0?1:0))},he=(0,R.$4g)(U),X=se.run(he,le);X&&X.then&&X.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),oe(0)}).catch(ae=>{M.$t&&this.s.error("Test runner finished with error",ae),te(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,U){return this.S[Q]=U,(0,T.$Tc)(()=>{delete this.S[Q]})}async getRemoteExecServer(Q){const{resolver:U}=await this.ub(Q);return U?.resolveExecServer?.(Q,{resolveAttempt:0})}async ub(Q){const U=Q.indexOf("+");if(U===-1)throw new t.$7M("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Q.substr(0,U);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(Q,U){const se=B.$de.create(!1),oe=()=>`[resolveAuthority(${(0,s.$Rl)(Q)},${U})][${se.elapsed()}ms] `,te=q=>this.s.info(`${oe()}${q}`),le=q=>this.s.warn(`${oe()}${q}`),he=(q,Y=void 0)=>this.s.error(`${oe()}${q}`,Y),X=q=>{if(q instanceof t.$7M)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},ae=async q=>{te(`activating resolver for ${q}...`);const{resolver:Y,authorityPrefix:x}=await this.ub(q);if(!Y)throw he(`no resolver for ${x}`),new t.$7M(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:x,remoteAuthority:q}},pe=Q.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let be;try{be=await Promise.all(pe.map(ae)).catch(async q=>{if(!(q instanceof t.$7M)||q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return le(`resolving nested authorities failed: ${q.message}`),[await ae(Q)]})}catch(q){return X(q)}const Me=new L.$Nh;Me.cancelAndSet(()=>te("waiting..."),1e3);let We,ke;for(const[q,{authorityPrefix:Y,resolver:x,remoteAuthority:fe}]of be.entries())try{if(q===be.length-1)te("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${Y}`),We=await x.resolve(fe,{resolveAttempt:U,execServer:ke}),A.mark(`code/extHost/didResolveAuthorityOK/${Y}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,t.$6M.isManagedResolvedAuthority(We)?We:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),A.mark(`code/extHost/willResolveExecServer/${Y}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:U,execServer:ke}),!ke)throw new t.$7M(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(we){return A.mark(`code/extHost/didResolveAuthorityError/${Y}`),he("returned an error",we),Me.dispose(),X(we)}Me.dispose();const Ie={environmentTunnels:We.environmentTunnels,features:We.tunnelFeatures?{elevation:We.tunnelFeatures.elevation,privacyOptions:We.tunnelFeatures.privacyOptions,protocol:We.tunnelFeatures.protocol===void 0?!0:We.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:We.extensionHostEnv,isTrusted:We.isTrusted,authenticationSession:We.authenticationSessionForInitializingExtensions?{id:We.authenticationSessionForInitializingExtensions.id,providerId:We.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${t.$6M.isManagedResolvedAuthority(We)?"managed authority":`${We.host}:${We.port}`}`);let V;if(t.$6M.isManagedResolvedAuthority(We)){const q=U;this.Y.setFactory(q,We.makeConnection),V={authority:Q,connectTo:new s.$Ol(q),connectionToken:We.connectionToken}}else V={authority:Q,connectTo:new s.$Pl(We.host,We.port),connectionToken:We.connectionToken};return{type:"ok",value:{authority:V,options:Te,tunnelInformation:Ie}}}async $getCanonicalURI(Q,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Rl)(Q)})`);const{resolver:se}=await this.ub(Q);if(!se)return null;const oe=l.URI.revive(U);if(typeof se.getCanonicalURI>"u")return oe;const te=await(0,L.$uh)(()=>se.getCanonicalURI(oe));return te||oe}async $startExtensionHost(Q){Q.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:U,myExtensions:se}=z(this.I,this.L,this.J,Q),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${J(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${J(this.J)}`)),this.tb()}$activateByEvent(Q,U){return U===g.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(Q,!1)):this.G.wait().then(se=>this.ab(Q,!1))}async $activate(Q,U){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.bb(Q,U),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:U,myExtensions:se}=z(this.I,this.L,this.J,Q),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(U.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${J(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${J(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const U=o.$Le.alloc(Q),se=Math.random()%256;for(let oe=0;oe<Q;oe++)U.writeUInt8(se,oe);return U}async $updateRemoteConnectionData(Q){this.X=Q,this.a.fire()}};e.$0nc=re,e.$0nc=re=_=Ye([qe(0,d.$Bi),qe(1,e.$9nc),qe(2,y.$sP),qe(3,c.$unc),qe(4,u.$xnc),qe(5,C.$9j),qe(6,a.$IP),qe(7,w.$Anc),qe(8,S.$2Eb),qe(9,I.$Vnc),qe(10,j.$6nc),qe(11,W.$7nc),qe(12,k.$Znc)],re);function z($e,Q,U,se){$e.addActivationEvents(se.addActivationEvents);const oe=new f.$Cbc($e,Q.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$on(U.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of se.myToRemove)te.delete(he);for(const he of se.myToAdd)te.add(he);const le=ue(oe,te);return{globalRegistry:oe,myExtensions:le}}function G($e,Q){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function J($e){return $e.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$$nc=(0,d.$Ci)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(Q,U,se,oe,te){this.#e=Q,this.#t=U,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$ic((0,R.$4g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$_nc=ee;function ue($e,Q){return $e.getAllExtensionDescriptions().filter(U=>Q.has(U.identifier))}class ne{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$aoc=ne;class De{constructor(Q){this.a=new n.$pn,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const U of Object.keys(Q))this.a.set(U,Q[U])}}}),define(Ee[389],Se([1,0,62,2,6,42,26,24,20,30,5,52,12,13]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0,r=Ue(r);let c=class{constructor(o,i,t,s,d,a,w){this.c=o,this.d=i,this.e=t,this.f=s,this.g=d,this.h=a,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new f(this.c,i,this.d,o,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,i,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const i of o.nodeModuleName)this.a.set(i,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(i=>o.alternativeModuleName(i))}};e.$kpc=c,e.$kpc=c=Ye([qe(2,C.$Bi),qe(3,R.$xnc),qe(4,E.$$nc),qe(5,l.$IP),qe(6,u.$9j)],c);let g=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const i=(0,P.$ff)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const i=this.b.exec(this.c(o));if(!i)return;const[,t,s,d]=i,a=p.a.get(s);if(a!==void 0)return console.warn(`${s} as been renamed to ${a}, please update your imports`),t+a+d}c(o){return o.replace(/\\/g,"/")}};g=p=Ye([qe(0,l.$IP)],g);class f{constructor(o,i,t,s,d){this.c=o,this.d=i,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new T.$pn}load(o,i){const t=this.d.findSubstr(i);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,a)=>s+=`	${a} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(L.$VG,this.e,this.f)}return this.b}}let m=class{constructor(o,i,t){this.e=o,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$YM.MainThreadTelemetry);const s=t.getProxy(A.$YM.MainThreadWindow);this.c=(d,a)=>{const w=h.URI.parse(d);return a?this.g(d,a):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,d,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,d,{}):this.g(d,a)}}load(o,i,t){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=t(o),this.c}g(o,i){return this.i(),this.b(o,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Ye([qe(2,$.$sP)],m)}),define(Ee[65],Se([1,0,49,3,16,56,5,64,78,52,10,48,317,42]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=void 0,A=Ue(A),R=Ue(R),e.$boc=(0,L.$Ci)("IExtHostVariableResolverProvider");class p extends u.$wQ{constructor(f,m,n,o,i,t,s){function d(){if(n){const a=n.activeEditor();if(a)return a.document.uri;const w=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof C.$MO||w.input instanceof C.$RO)return w.input.modified;if(w.input instanceof C.$LO||w.input instanceof C.$QO||w.input instanceof C.$OO)return w.input.uri}}}super({getFolderUri:a=>{const w=t.folders.filter(y=>y.name===a);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,w)=>i.getConfiguration(void 0,a).get(w),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=d();if(a)return A.$ic(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const a=d();if(a){const w=m.getWorkspaceFolder(a);if(w)return A.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const a=n.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(n){const a=n.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>f.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let c=class extends h.$Vc{constructor(f,m,n,o,i){super(),this.b=f,this.c=m,this.g=n,this.h=o,this.j=i,this.a=new r.$W(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$coc=c,e.$coc=c=Ye([qe(0,l.$$nc),qe(1,E.$unc),qe(2,T.$DP),qe(3,P.$xnc),qe(4,$.$Jnc)],c)}),define(Ee[102],Se([1,0,9,4,2,3,24,5,6,78,52,20,10,48,153,120,308,42,65,50,35,17,19,99]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=e.$loc=e.$koc=e.$joc=e.$ioc=void 0,i=Ue(i),e.$ioc=(0,T.$Ci)("IExtHostDebugService");let d=class extends R.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,b,v,N,O,F,j,B){super(),this.Y=b,this.Z=v,this.$=N,this.ab=O,this.bb=F,this.cb=j,this.db=B,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$je),this.z=this.B(new h.$je),this.C=this.B(new h.$je),this.F=this.B(new h.$je),this.u=k.getProxy($.$YM.MainThreadDebugService),this.I=this.B(new h.$je),this.L=this.B(new h.$je),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(M=>{this.B(M.onDidChange(W=>{this.fb(M)})),this.fb(M)})}async $getVisualizerTreeItem(k,b){const v=this.gb(b);if(!v)return;const N=await this.Q.get(k)?.getTreeItem?.(v);return N?this.eb(k,N):void 0}registerDebugVisualizationTree(k,b,v){const N=L.$nn.toKey(k.identifier),O=this.ub(N,b);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.Q.set(O,v),this.u.$registerDebugVisualizerTree(O,!!v.editItem),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(b)})}async $getVisualizerTreeItemChildren(k,b){const v=this.S.get(b)?.item;return v?(await this.Q.get(k)?.getChildren?.(v))?.map(O=>this.eb(k,O))||[]:[]}async $editVisualizerTreeItem(k,b){const v=this.S.get(k);if(!v)return;const N=await this.Q.get(v.provider)?.editItem?.(v.item,b);return this.eb(v.provider,N||v.item)}$disposeVisualizedTree(k){const b=this.S.get(k);if(!b)return;const v=[b.children];for(const N of v)if(N)for(const O of N)v.push(this.S.get(O)?.children),this.S.delete(O)}eb(k,b){let v=this.R.get(b);return v||(v=this.O++,this.R.set(b,v),this.S.set(v,{provider:k,item:b})),i.DebugTreeItem.from(b,v)}asDebugSourceUri(k,b){const v=k;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let N=`debug:${encodeURIComponent(v.path||"")}`,O="?";return b&&(N+=`${O}session=${encodeURIComponent(b.id)}`,O="&"),N+=`${O}ref=${v.sourceReference}`,A.URI.parse(N)}else{if(v.path)return A.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const b=[];for(const v of k.getAllExtensionDescriptions())if(v.contributes){const N=v.contributes.debuggers;if(N&&N.length>0)for(const O of N)(0,g.$RH)(O)&&b.push(O.type)}this.u.$registerDebugTypes(b)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(b=>k.push(b)),k}async $resolveDebugVisualizer(k,b){const v=this.W.get(k);if(!v)throw new Error(`No debug visualizer found with id '${k}'`);let{v:N,provider:O,extensionId:F}=v;if(N.visualization||(N=await O.resolveDebugVisualization?.(N,b)||N,v.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.vb(F,N.visualization)}async $executeDebugVisualizerCommand(k){const b=this.W.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);const v=b.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(k){const b=this.w.get(k.sessionId);return b&&{session:b.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,b,v,N){const O=this.gb(v),F=this.ub(k,b),j=this.P.get(F);if(!O||!j)return[];const B=await j.provideDebugVisualization(O,N);return B?B.map(M=>{const W=++this.X;this.W.set(W,{v:M,provider:j,extensionId:k});const _=M.iconPath?this.wb(M.iconPath):void 0;return{id:W,name:M.name,iconClass:_?.iconClass,iconPath:_?.iconPath,visualization:this.vb(k,M.visualization)}}):[]}$disposeDebugVisualizers(k){for(const b of k)this.W.delete(b)}registerDebugVisualizationProvider(k,b,v){if(!k.contributes?.debugVisualizers?.some(F=>F.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const N=L.$nn.toKey(k.identifier),O=this.ub(N,b);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.P.set(O,v),this.u.$registerDebugVisualizer(N,b),(0,R.$Tc)(()=>{this.u.$unregisterDebugVisualizer(N,b),this.P.delete(b)})}addBreakpoints(k){const b=k.filter(O=>{const F=O.id;return this.H.has(F)?!1:(this.H.set(F,O),!0)});this.rb(b,[],[]);const v=[],N=new Map;for(const O of b)if(O instanceof u.$3N){let F=N.get(O.location.uri.toString());F||(F={type:"sourceMulti",uri:O.location.uri,lines:[]},N.set(O.location.uri.toString(),F),v.push(F)),F.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof u.$4N&&v.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(k){const b=k.filter(F=>this.H.delete(F.id));this.rb([],b,[]);const v=b.filter(F=>F instanceof u.$3N).map(F=>F.id),N=b.filter(F=>F instanceof u.$4N).map(F=>F.id),O=b.filter(F=>F instanceof u.$5N).map(F=>F.id);return this.u.$unregisterBreakpoints(v,N,O)}startDebugging(k,b,v){const N=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(k?k.uri:void 0,b,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,b,v){if(!b)return new u.$1M(()=>{});const N=this.f++;return this.g.push({type:k,handle:N,provider:b}),this.u.$registerDebugConfigurationProvider(k,v,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,N),new u.$1M(()=>{this.g=this.g.filter(O=>O.provider!==b),this.u.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(k,b,v){if(!v)return new u.$1M(()=>{});if(!this.nb(k,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.kb(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this.h++;return this.j.push({type:b,handle:N,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(b,N),new u.$1M(()=>{this.j=this.j.filter(O=>O.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(k,b){if(!b)return new u.$1M(()=>{});const v=this.m++;return this.n.push({type:k,handle:v,factory:b}),new u.$1M(()=>{this.n=this.n.filter(N=>N.factory!==b)})}async $runInTerminal(k,b){return Promise.resolve(void 0)}async $substituteVariables(k,b){let v;const N=await this.tb(k);return N&&(v={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,b)}hb(k,b){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,b){const v=this,N=await this.sb(b);return this.pb(this.kb(N.type),N).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const F=this.jb(O),j=this.hb(F,N);if(!j)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const B=j;return this.M.set(k,B),this.ob(N).then(M=>(M&&this.N.set(k,M),B.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const _=W,re={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const z=await this.U.sign(_.arguments.value);re.body={signature:z},B.sendResponse(re)}else throw new Error("no signer")}catch(z){re.success=!1,re.message=z.message,B.sendResponse(re)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(W),W=(0,g.$WH)(W,!0),v.u.$acceptDAMessage(k,W)}),B.onError(W=>{M&&M.onError&&M.onError(W),this.u.$acceptDAError(k,W.name,W.message,W.stack)}),B.onExit(W=>{M&&M.onExit&&M.onExit(W??void 0,void 0),this.u.$acceptDAExit(k,W??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),B.startSession()))})}$sendDAMessage(k,b){b=(0,g.$VH)(b,!1);const v=this.N.get(k);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(b),this.M.get(k)?.sendMessage(b)}$stopDASession(k){const b=this.N.get(k);this.N.delete(k),b&&b.onWillStopSession&&b.onWillStopSession();const v=this.M.get(k);return this.M.delete(k),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const b=[],v=[],N=[];if(k.added)for(const O of k.added){const F=O.id;if(F&&!this.H.has(F)){let j;if(O.type==="function")j=new u.$4N(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")j=new u.$5N(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const B=A.URI.revive(O.uri);j=new u.$3N(new u.$aN(B,new u.$2M(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,u.$1N)(j,F),this.H.set(F,j),b.push(j)}}if(k.removed)for(const O of k.removed){const F=this.H.get(O);F&&(this.H.delete(O),v.push(F))}if(k.changed){for(const O of k.changed)if(O.id){const F=this.H.get(O.id);if(F){if(F instanceof u.$4N&&O.type==="function"){const j=F;j.enabled=O.enabled,j.condition=O.condition,j.hitCondition=O.hitCondition,j.logMessage=O.logMessage,j.functionName=O.functionName}else if(F instanceof u.$3N&&O.type==="source"){const j=F;j.enabled=O.enabled,j.condition=O.condition,j.hitCondition=O.hitCondition,j.logMessage=O.logMessage,j.location=new u.$aN(A.URI.revive(O.uri),new u.$2M(O.line,O.character))}N.push(F)}}}this.rb(b,v,N)}async $acceptStackFrameFocus(k){let b;if(k){const v=await this.sb(k.sessionId);k.kind==="thread"?b=new u.$$N(v.api,k.threadId):b=new u.$0N(v.api,k.threadId,k.frameId)}this.J=b,this.L.fire(this.J)}$provideDebugConfigurations(k,b,v){return(0,r.$uh)(async()=>{const N=this.mb(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.tb(b);return N.provideDebugConfigurations(O,v)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(k,b,v,N){return(0,r.$uh)(async()=>{const O=this.mb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.tb(b);return O.resolveDebugConfiguration(F,v,N)})}$resolveDebugConfigurationWithSubstitutedVariables(k,b,v,N){return(0,r.$uh)(async()=>{const O=this.mb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.tb(b);return O.resolveDebugConfigurationWithSubstitutedVariables(F,v,N)})}async $provideDebugAdapter(k,b){const v=this.lb(k);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.sb(b);return this.pb(v,N).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.jb(O)})}async $acceptDebugSessionStarted(k){const b=await this.sb(k);this.y.fire(b.api)}async $acceptDebugSessionTerminated(k){const b=await this.sb(k);b&&(this.z.fire(b.api),this.w.delete(b.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,b){(await this.sb(k))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(k,b){const N={session:(await this.sb(k)).api,event:b.event,body:b.body};this.F.fire(N)}jb(k){if(k instanceof u.$6N)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof u.$7N)return{type:"server",port:k.port,host:k.host};if(k instanceof u.$8N)return{type:"pipeServer",path:k.path};if(k instanceof u.$9N)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const b=this.j.filter(v=>v.type===k);if(b.length>0)return b[0].factory}lb(k){const b=this.j.filter(v=>v.handle===k);if(b.length>0)return b[0].factory}mb(k){const b=this.g.filter(v=>v.handle===k);if(b.length>0)return b[0].provider}nb(k,b){if(k.contributes){const v=k.contributes.debuggers;if(v&&v.length>0){for(const N of v)if(N.label&&N.type&&N.type===b)return!0}}return!1}ob(k){const v=k.configuration.type,N=this.n.filter(O=>O.type===v||O.type==="*").map(O=>(0,r.$uh)(()=>O.factory.createDebugAdapterTracker(k.api)).then(F=>F,F=>null));return Promise.race([Promise.all(N).then(O=>{const F=(0,t.$Ib)(O);if(F.length>0)return new y(F)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async pb(k,b){const v=b.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$7N(v));if(k){const O=await this.Z.getExtensionRegistry();return(0,r.$uh)(()=>k.createDebugAdapterDescriptor(b.api,this.qb(b,O))).then(F=>{if(F)return F})}const N=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(b,N))}qb(k,b){}rb(k,b,v){(k.length>0||b.length>0||v.length>0)&&this.I.fire(Object.freeze({added:k,removed:b,changed:v}))}async sb(k){if(k)if(typeof k=="string"){const b=this.w.get(k);if(b)return b}else{let b=this.w.get(k.id);if(!b){const v=await this.tb(k.folderUri),N=k.parent?this.w.get(k.parent):void 0;b=new a(this.u,k.id,k.type,k.name,v,k.configuration,N?.api),this.w.set(b.id,b),this.u.$sessionCached(b.id)}return b}throw new Error("cannot find session")}tb(k){if(k){const b=A.URI.revive(k);return this.Y.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}ub(k,b){return`${k}\0${b}`}vb(k,b){if(b){if("title"in b&&"command"in b)return{type:c.DebugVisualizationType.Command};if("treeId"in b)return{type:c.DebugVisualizationType.Tree,id:`${k}\0${b.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const b=this.xb(k);let v,N;return"id"in b?N=n.ThemeIcon.asClassName(b):v=b,{iconPath:v,iconClass:N}}xb(k){if(k instanceof u.$XN)return{id:k.id};const b=typeof k=="object"&&"dark"in k?k.dark:k,v=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof b=="string"?A.URI.file(b):b,light:typeof v=="string"?A.URI.file(v):v}}};e.$joc=d,e.$joc=d=Ye([qe(0,E.$sP),qe(1,P.$unc),qe(2,C.$$nc),qe(3,f.$xnc),qe(4,l.$Jnc),qe(5,m.$boc),qe(6,o.$OP),qe(7,s.$doc)],d);class a{constructor(k,b,v,N,O,F,j){this.f=k,this.g=b,this.h=v,this.j=N,this.k=O,this.l=F,this.m=j}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(b){k.j=b,k.f.$setDebugSessionName(k.g,b)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(b,v){return k.f.$customDebugAdapterRequest(k.g,b,v)},getDebugProtocolBreakpoint(b){return k.f.$getDebugProtocolBreakpoint(k.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$koc=a;class w{constructor(k){this.value=Object.freeze({append(b){k.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$loc=w;class y{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(b=>b.onError?b.onError(k):void 0)}onExit(k,b){this.d.forEach(v=>v.onExit?v.onExit(k,b):void 0)}}class D extends p.$Ssb{constructor(k){super(),this.h=k,k.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends d{constructor(k,b,v,N,O,F,j,B){super(k,b,v,N,O,F,j,B)}};e.$moc=S,e.$moc=S=Ye([qe(0,E.$sP),qe(1,P.$unc),qe(2,C.$$nc),qe(3,f.$xnc),qe(4,l.$Jnc),qe(5,m.$boc),qe(6,o.$OP),qe(7,s.$doc)],S)}),define(Ee[390],Se([1,0,14,62,2,6,339,12,89,115,30,275,20,73,52,95]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,r=Ue(r),h=Ue(h);class g{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(T.$9j),t=n.get(u.$sP).getProxy(R.$YM.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const d=r.$4(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(T.$9j),i=n.get(u.$sP),t=n.get(p.$$nc),s=n.get(c.$MP),d=i.getProxy(R.$YM.MainThreadExtensionService),a=i.getProxy(R.$YM.MainThreadErrors),w=await t.getExtensionPathIndex(),y=new WeakMap;function D(k,b){if(y.has(k))return y.get(k).stack;let v="",N,O;for(const j of b)v+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=w.findSubstr(A.URI.file(O)));const F=`${k.name||"Error"}: ${k.message||""}${v}`;return y.set(k,{extensionIdentifier:N?.identifier,stack:F}),F}const S=Symbol("prepareStackTrace wrapped");let I=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return I},set(k){if(k===D||!k||k[S]){I=k||D;return}I=function(b,v){return D(b,v),k.call(Error,b,v)},Object.assign(I,{[S]:!0})}}),r.setUnexpectedErrorHandler(k=>{o.error(k);const b=r.$4(k),v=y.get(k);if(!v?.extensionIdentifier){a.$onUnexpectedError(b);return}d.$onExtensionRuntimeError(v.extensionIdentifier,b);const N=s.onExtensionError(v.extensionIdentifier,k);o.trace("forwarded error to extension?",N,v)})}}e.$lpc=g;class f{constructor(n,o,i,t,s){this.a=i,this.b=new L.$Kbc(n,null,t),o=f.e(o,this.b);const d=new l.$Ai(...(0,$.$Js)());d.set(C.$IP,{_serviceBrand:void 0,...o,messagePorts:s}),d.set(u.$sP,new u.$tP(this.b)),d.set(P.$rnc,new P.$snc(t)),d.set(p.$9nc,i);const a=new E.$nr(d,!0);a.invokeFunction(g.installEarlyHandler),this.d=a.invokeFunction(w=>w.get(T.$9j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=a.invokeFunction(w=>w.get(p.$$nc)),this.c.initialize(),a.invokeFunction(g.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(R.$YM.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>A.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$mpc=f}),define(Ee[391],Se([1,0,9,11,245,268,148,102,78,52,20,47,10,65,48,309,310,42,35,99]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0,h=Ue(h),A=Ue(A);let o=class extends T.$joc{constructor(a,w,y,D,S,I,k,b,v){super(a,w,y,D,I,k,b,v),this.Ab=S,this.yb=new s}hb(a,w){switch(a.type){case"server":return new c.$rpc(a);case"pipeServer":return new c.$spc(a);case"executable":return new c.$tpc(a,w.type)}return super.hb(a,w)}qb(a,w){const y=c.$tpc.platformAdapterExecutable(w.getAllExtensionDescriptions(),a.type);if(y)return new u.$6N(y.command,y.args,y.options)}ib(){return new L.$Hfc}async $runInTerminal(a,w){if(a.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(B=>{this.yb.onTerminalClosed(B)})));const y=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),S=this.Ab.getDefaultShellArgs(!0),I=a.title||A.localize(0,null),k=JSON.stringify({shell:D,shellArgs:S});let b=await this.yb.checkout(k,I),v,N=!1;if(b)v=a.cwd;else{const B={shellPath:D,shellArgs:S,cwd:a.cwd,name:I,iconPath:new u.$XN("debug")};N=!0,b=this.Ab.createTerminalFromOptions(B,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(b,k)}b.show(!0);const O=await b.processId;N?await new Promise(B=>setTimeout(B,1e3)):(b.state.isInteractedWith&&(b.sendText(""),await(0,r.$Dh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?b.sendText("cls"):D.indexOf("bash")>=0?b.sendText("clear"):h.$i?b.sendText("cls"):b.sendText("clear")));const F=(0,g.$vpc)(D,a.args,!!a.argsCanBeInterpretedByShell,v,a.env);b.sendText(F);const j=this.onDidTerminateDebugSession(B=>{B.id===w&&(this.yb.free(b),j.dispose())});return O}else if(a.kind==="external")return t(a,await this.$.getConfigProvider());return super.$runInTerminal(a,w)}};e.$wpc=o,e.$wpc=o=Ye([qe(0,C.$sP),qe(1,p.$unc),qe(2,l.$$nc),qe(3,f.$xnc),qe(4,E.$Vnc),qe(5,$.$Jnc),qe(6,P.$boc),qe(7,m.$OP),qe(8,n.$doc)],o);let i;function t(d,a){if(!i)if(h.$i)i=new R.$qec;else if(h.$j)i=new R.$rec;else if(h.$k)i=new R.$sec;else throw new Error("external terminals not supported on this platform");const w=a.getConfiguration("terminal");return i.runInTerminal(d.title,d.cwd,d.args,d.env||{},w.external||{})}class s{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,w,y=!1){const S=[...this.b.entries()].map(([I,k])=>(0,r.$ph)(async b=>{if(I.name!==w||k.lastUsedAt!==-1&&await(0,g.$upc)(await I.processId))return null;const v=Date.now();return k.lastUsedAt+s.a>v||b.isCancellationRequested?null:k.config!==a?(y&&I.dispose(),null):(k.lastUsedAt=v,I)}));return await(0,r.$Hh)(S,I=>!!I)}insert(a,w){this.b.set(a,{lastUsedAt:Date.now(),config:w})}free(a){const w=this.b.get(a);w&&(w.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(Ee[392],Se([1,0,16,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=void 0,r=Ue(r),g=Ue(g);let n=class extends u.$5oc{constructor(i,t,s,d,a,w,y,D,S){super(i,t,s,d,a,w,y,D),this.C=s,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=u.TaskHandleDTO.from(s,this.C),a=await this.a.$getTaskExecution(d);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(a,t);return this.a.$executeTask(d).catch(()=>{}),w}else{const d=u.TaskDTO.from(t,i);if(d===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const a=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),a}}v(i,t,s,d){const a=[];if(d)for(const w of d){this.A(w,s),(!w.definition||!i[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const y=u.TaskDTO.from(w,s.extension);y&&(a.push(y),u.CustomExecutionDTO.is(y.execution)&&t.push(this.y(y,w,!0)))}return{tasks:a,extension:s.extension}}async w(i){return i}async G(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const s=h.URI.file((0,f.homedir)());t=new $.$Wi({uri:s,name:g.$ah(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const s=h.URI.revive(i),d={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(s),w=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),D=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const S of t.variables)d.variables[S]=await y.resolveAsync(D,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(r.$uc);for(let I=0;I<S.length;I++)S[I]=await y.resolveAsync(D,S[I])}d.process=await A.win32.findExecutable(await y.resolveAsync(D,t.process.name),t.process.cwd!==void 0?await y.resolveAsync(D,t.process.cwd):void 0,S)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,s){return A.win32.findExecutable(i,t,s)}};e.$opc=n,e.$opc=n=Ye([qe(0,C.$sP),qe(1,E.$IP),qe(2,R.$unc),qe(3,L.$DP),qe(4,T.$xnc),qe(5,l.$Vnc),qe(6,p.$9j),qe(7,c.$$mc),qe(8,m.$boc)],n)}),define(Ee[393],Se([1,0,68,65]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0;class A extends h.$coc{m(){return(0,r.homedir)()}}e.$7pc=A}),define(Ee[170],Se([1,0,19,9,21,55,15,16,23,2,38]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Boc=e.$Aoc=void 0,e.$Coc=c,T=Ue(T),$=Ue($);class E{constructor(m,n,o){this.d=m,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(m,n){const o=this.g.folderQueries||[],i=new A.$ue(n);return new Promise((t,s)=>{this.a=new P(m);let d=!1;const a=(w,y)=>{if(!d&&!this.b){const D=this.h(w);c(w)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,i.cancel(),w=this.j(w,this.g.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!c(w))&&this.a.add(w,y)}};Promise.all(o.map((w,y)=>this.k(w,D=>a(D,y),i.token))).then(w=>{i.dispose(),this.a.flush();const y=w.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||y,messages:w.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},w=>{i.dispose();const y=(0,R.$nj)(w);s(new Error(y))})})}h(m){return c(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,n){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],i=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,n),preview:{matches:i.slice(0,n),text:m.preview.text},uri:m.uri}}async k(m,n,o){const i=new C.$CL(this.g,m),t=[],s={report:w=>{if(!this.l(w))return;const y=m.folder.scheme===L.Schemas.file?(0,C.$DL)(()=>this.e.readdir($.$ch(w.uri))):void 0,D=$.$fh(m.folder,w.uri);if(D){const S=i.includedInQuery(D,T.$oc(D),y);(0,h.$oh)(S)?t.push(S.then(I=>{I&&n(w)})):S&&n(w)}}},d=this.n(m);let a;return this.d.query.type===C.QueryType.aiText?a=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,s,o):a=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,s,o),t.length&&await Promise.all(t),a}l(m){if(c(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const n=(0,C.$BL)(this.g.includePattern,m.includePattern),o=(0,C.$BL)(this.g.excludePattern,m.excludePattern),i={folder:l.URI.from(m.folder),excludes:o,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.e.toCanonicalName(m.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??C.$iL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$Aoc=E;function u(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class P{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new g(512,n=>this.g(n))}add(m,n){this.d&&(this.b!==n||!$.$9g(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:m.uri,results:[]}),this.d.results.push(p(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.$Boc=P;function p(f){return c(f)?{preview:{matches:(0,r.$2b)(f.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:f.preview.text},ranges:(0,r.$2b)(f.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function c(f){return!!f.preview}class g{static{this.a=4e3}static{this.b=50}constructor(m,n){this.g=m,this.h=n,this.c=0,this.d=[],this.e=0}addItem(m,n){m&&this.j(m,n)}addItems(m,n){m&&this.k(m,n)}j(m,n){this.d.push(m),this.e+=n,this.l()}k(m,n){this.d=this.d.concat(m),this.e+=n,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Doc=g}),define(Ee[103],Se([1,0,3,6,5,386,20,73,12,2,170]),function(ce,e,r,h,A,R,L,T,$,l,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Eoc=void 0,e.$Goc=u,e.$Eoc=(0,A.$Ci)("IExtHostSearch");let E=class{constructor(c,g,f){this.n=c,this.o=g,this.q=f,this.c=this.n.getProxy(h.$YM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$zoc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const f=this.d++;return this.e.set(f,g),this.c.$registerTextSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.g.delete(c),this.e.delete(f),this.c.$unregisterProvider(f)})}registerAITextSearchProvider(c,g){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const f=this.d++;return this.h.set(f,g),this.c.$registerAITextSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.i.delete(c),this.h.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(c,g){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const f=this.d++;return this.j.set(f,g),this.c.$registerFileSearchProvider(f,this.s(c)),(0,r.$Tc)(()=>{this.k.delete(c),this.j.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(c,g,f,m){const n=u(f),o=this.j.get(c);if(o)return this.l.fileSearch(n,o,i=>{this.c.$handleFileMatch(c,g,i.map(t=>t.resource))},m);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,f){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,f,m){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=u(f);return this.t(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$provideAITextSearchResults(c,g,f,m){const n=this.h.get(c);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=u(f);return this.v(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$enableExtensionHostSearch(){}t(c,g){return new C.$Aoc({query:c,provider:g},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}v(c,g){return new C.$Aoc({query:c,provider:g},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"aiTextSearchProvider")}};e.$Foc=E,e.$Foc=E=Ye([qe(0,L.$sP),qe(1,T.$rnc),qe(2,$.$9j)],E);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(P),extraFileResources:p.extraFileResources&&p.extraFileResources.map(c=>l.URI.revive(c))}}function P(p){return{...p,folder:l.URI.revive(p.folder)}}});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[394],Se([1,0,21,14,4,3,15,44,2,114,212,193,54,24,28,12,91,92,295,6,341,367,96,128,345,346,347,326,315,35,348,42,349,102,162,350,328,342,351,352,64,78,329,343,52,353,76,354,63,30,368,330,355,129,356,123,124,331,385,358,299,359,369,360,168,332,361,362,363,20,364,103,125,365,333,366,126,98,101,95,47,166,99,370,344,371,372,77,17,10,334,73,335,97,373,374,161,48,120,94,26,100]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a,w,y,D,S,I,k,b,v,N,O,F,j,B,M,W,_,re,z,G,J,ee,ue,ne,De,$e,Q,U,se,oe,te,le,he,X,ae,pe,be,Me,We,ke,Ie,Te,V,q,Y,x,fe,we,Ne,Ge,Je,tt,rt,ot,nt,ct,$t,ht,at,Pe,Be,Ke,Oe,Fe,Z,de,Ce,Xe,_e,lt,ft,kt,Tt,zt,ui,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=Kt,h=Ue(h),T=Wt(T),E=Ue(E),p=Ue(p),Fe=Ue(Fe),Z=Ue(Z);function Kt(mt){const bt=mt.get(De.$IP),hi=mt.get(ne.$cnc),ei=mt.get(ee.$znc),Ut=mt.get(G.$$nc),wt=mt.get(Tt.$unc),Vt=mt.get(nt.$MP),Yt=mt.get(k.$xnc),Xt=mt.get(Ce.$rnc),xe=mt.get(Y.$sP),$i=mt.get(tt.$Snc),ti=mt.get(rt.$Anc),si=mt.get(c.$0j),Dt=mt.get(c.$9j),Jt=mt.get(Oe.$2Eb),Lt=mt.get(t.$$mc),Ft=mt.get(kt.$fpc),ii=mt.get(we.$3nc),ni=mt.get(_.$Jnc),oi=mt.get(le.$7nc),qt=mt.get(s.$inc),Qt=mt.get(se.$Znc);xe.set(n.$ZM.ExtHostFileSystemInfo,hi),xe.set(n.$ZM.ExtHostLogLevelServiceShape,si),xe.set(n.$ZM.ExtHostWorkspace,wt),xe.set(n.$ZM.ExtHostConfiguration,Yt),xe.set(n.$ZM.ExtHostExtensionService,Ut),xe.set(n.$ZM.ExtHostStorage,$i),xe.set(n.$ZM.ExtHostTunnelService,Jt),xe.set(n.$ZM.ExtHostWindow,Ft),xe.set(n.$ZM.ExtHostSecretState,ii),xe.set(n.$ZM.ExtHostTelemetry,Vt),xe.set(n.$ZM.ExtHostEditorTabs,ni),xe.set(n.$ZM.ExtHostManagedSockets,oi),xe.set(n.$ZM.ExtHostAuthentication,qt),xe.set(n.$ZM.ExtHostChatProvider,Qt);const di=xe.set(n.$ZM.ExtHostDecorations,mt.get(N.$ooc)),jt=xe.set(n.$ZM.ExtHostDocumentsAndEditors,mt.get(W.$DP)),vt=xe.set(n.$ZM.ExtHostCommands,mt.get(S.$OP)),Pt=xe.set(n.$ZM.ExtHostTerminalService,mt.get(ct.$Vnc)),Ot=xe.set(n.$ZM.ExtHostTerminalShellIntegration,mt.get($t.$8oc)),It=xe.set(n.$ZM.ExtHostDebugService,mt.get(v.$ioc)),Zt=xe.set(n.$ZM.ExtHostSearch,mt.get(fe.$Eoc)),Ht=xe.set(n.$ZM.ExtHostTask,mt.get(ot.$7oc)),pi=xe.set(n.$ZM.ExtHostOutputService,mt.get(ke.$Toc)),fi=xe.set(n.$ZM.ExtHostLocalization,mt.get(te.$6nc)),Ai=xe.set(n.$ZM.ExtHostUrls,new Xe.$cpc(xe)),Nt=xe.set(n.$ZM.ExtHostDocuments,new M.$fnc(xe,jt)),Ti=xe.set(n.$ZM.ExtHostDocumentContentProviders,new j.$qoc(xe,jt,Dt)),ai=xe.set(n.$ZM.ExtHostDocumentSaveParticipant,new B.$roc(Dt,Nt,xe.getProxy(n.$YM.MainThreadBulkEdits))),Rt=xe.set(n.$ZM.ExtHostNotebook,new X.$Hoc(xe,vt,jt,Nt,ei,Zt,Dt)),Si=xe.set(n.$ZM.ExtHostNotebookDocuments,new pe.$Noc(Rt)),Di=xe.set(n.$ZM.ExtHostNotebookEditors,new be.$Ooc(Dt,Rt)),vi=xe.set(n.$ZM.ExtHostNotebookKernels,new Me.$Poc(xe,bt,Rt,vt,Dt)),Oi=xe.set(n.$ZM.ExtHostNotebookRenderers,new We.$Roc(xe,Rt)),gi=xe.set(n.$ZM.ExtHostNotebookDocumentSaveParticipant,new ae.$Moc(Dt,Rt,xe.getProxy(n.$YM.MainThreadBulkEdits))),Gt=xe.set(n.$ZM.ExtHostEditors,new at.$onc(xe,jt)),Ae=xe.set(n.$ZM.ExtHostTreeViews,new Ke.$apc(xe.getProxy(n.$YM.MainThreadTreeViews),vt,Dt)),je=xe.set(n.$ZM.ExtHostEditorInsets,new D.$pnc(xe.getProxy(n.$YM.MainThreadEditorInsets),Gt,bt.remote)),ve=xe.set(n.$ZM.ExtHostDiagnostics,new O.$enc(xe,Dt,hi,jt)),ie=xe.set(n.$ZM.ExtHostLanguages,new oe.$Koc(xe,Nt,vt.converter,Xt)),Re=xe.set(n.$ZM.ExtHostLanguageFeatures,new U.$gnc(xe,Xt,Nt,vt,ve,Dt,Lt,Vt)),He=xe.set(n.$ZM.ExtHostFileSystem,new J.$uoc(xe,Re)),et=xe.set(n.$ZM.ExtHostFileSystemEventService,new ue.$voc(xe,Dt,jt)),Qe=xe.set(n.$ZM.ExtHostQuickOpen,(0,q.$Xoc)(xe,wt,vt)),gt=xe.set(n.$ZM.ExtHostSCM,new x.$Zoc(xe,vt,Nt,Dt)),At=xe.set(n.$ZM.ExtHostQuickDiff,new V.$Woc(xe,Xt)),xt=xe.set(n.$ZM.ExtHostShare,new Ne.$1oc(xe,Xt)),ci=xe.set(n.$ZM.ExtHostComments,(0,I.$qnc)(xe,vt,Nt)),Bt=xe.set(n.$ZM.ExtHostProgress,new Te.$Voc(xe.getProxy(n.$YM.MainThreadProgress))),ri=xe.set(n.$ZM.ExtHostLabelService,new Q.$Joc(xe)),Wi=xe.set(n.$ZM.ExtHostTheming,new Pe.$0oc(xe)),Zi=xe.set(n.$ZM.ExtHostTimeline,new Be.$_oc(xe,vt)),zi=xe.set(n.$ZM.ExtHostWebviews,new _e.$Enc(xe,bt.remote,wt,Dt,Lt)),Ni=xe.set(n.$ZM.ExtHostWebviewPanels,new lt.$Hnc(xe,zi,wt)),Ui=xe.set(n.$ZM.ExtHostCustomEditors,new b.$Inc(xe,Nt,ti,zi,Ni)),Vi=xe.set(n.$ZM.ExtHostWebviewViews,new ft.$dpc(xe,zi)),ki=xe.set(n.$ZM.ExtHostTesting,mt.get(ht.$doc)),xi=xe.set(n.$ZM.ExtHostUriOpeners,new de.$bpc(xe)),_i=xe.set(n.$ZM.ExtHostProfileContentHandlers,new Ie.$Uoc(xe));xe.set(n.$ZM.ExtHostInteractive,new $e.$Ioc(xe,Rt,jt,vt,Dt));const Mi=xe.set(n.$ZM.ExtHostChatAgents2,new a.$lnc(xe,Dt,vt,bt.quality)),en=xe.set(n.$ZM.ExtHostChatVariables,new w.$mnc(xe)),qi=xe.set(n.$ZM.ExtHostAiRelatedInformation,new o.$0mc(xe)),$n=xe.set(n.$ZM.ExtHostAiEmbeddingVector,new z.$toc(xe)),tn=xe.set(n.$ZM.ExtHostStatusBar,new Je.$4oc(xe,vt.converter)),Gi=xe.set(n.$ZM.ExtHostSpeech,new Ge.$2oc(xe)),Ii=xe.set(n.$ZM.ExtHostEmbeddings,new re.$soc(xe)),pn=Object.values(n.$ZM);xe.assertRegistered(pn);const bn=new d.$knc(xe,jt),nn=new y.$nnc(xe),Hi=new he.$Loc(xe,Dt),Fi=new F.$poc(xe);return i.$hnc.register(vt),function(Ve,bi,Ki){function ut(ge){return(ye,ze,dt)=>{const St=ge(Mt=>{try{ye.call(ze,Mt)}catch(Pi){h.$3(new Error(`[ExtensionListenerError] Extension '${Ve.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Vt.onExtensionError(Ve.identifier,Pi)}});return dt?.push(St),St}}const yt=function(){let ge=!Ve.isUnderDevelopment;function ye(){ge||(Dt.info(`Extension '${Ve.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function ze(dt){if(Array.isArray(dt))dt.forEach(ze);else if(typeof dt=="string")ye();else{const St=dt;typeof St.scheme>"u"&&ye(),typeof St.exclusive=="boolean"&&(0,it.$2G)(Ve,"documentFiltersExclusive")}return dt}}(),rn={getSession(ge,ye,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,it.$2G)(Ve,"authLearnMore"),qt.getSession(Ve,ge,ye,ze)},getSessions(ge,ye){return(0,it.$2G)(Ve,"authGetSessions"),qt.getSessions(Ve,ge,ye)},async hasSession(ge,ye){return(0,it.$2G)(Ve,"authSession"),!!await qt.getSession(Ve,ge,ye,{silent:!0})},get onDidChangeSessions(){return ut(qt.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,ze,dt){return qt.registerAuthenticationProvider(ge,ye,ze,dt)}},Ei={registerCommand(ge,ye,ze){return vt.registerCommand(!0,ge,ye,ze,void 0,Ve)},registerTextEditorCommand(ge,ye,ze){return vt.registerCommand(!0,ge,(...dt)=>{const St=Gt.getActiveTextEditor();if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Mt=>{ye.apply(ze,[St,Mt,...dt])}).then(Mt=>{Mt||Dt.warn("Edits from command "+ge+" were not applied.")},Mt=>{Dt.warn("An error occurred while running command "+ge,Mt)})},void 0,void 0,Ve)},registerDiffInformationCommand:(ge,ye,ze)=>((0,it.$2G)(Ve,"diffCommand"),vt.registerCommand(!0,ge,async(...dt)=>{const St=jt.activeEditor(!0);if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Mt=await Gt.getDiffInformation(St.id);ye.apply(ze,[Mt,...dt])},void 0,void 0,Ve)),executeCommand(ge,...ye){return vt.executeCommand(ge,...ye)},getCommands(ge=!1){return vt.getCommands(ge)}},Li={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return ut(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ut(Vt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$2G)(Ve,"telemetry"),Vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$2G)(Ve,"telemetry"),ut(Vt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$LP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return nt.$KP.validateSender(ge),Vt.instantiateLogger(Ve,ge,ye)},openExternal(ge,ye){return Ft.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return Ai.createAppUri(ge);try{return await Ft.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,L.$Lg)(ge,L.Schemas.http)||(0,L.$Lg)(ge,L.Schemas.https))return ge;throw ye}},get remoteName(){return(0,g.$en)(bt.remote.authority)},get remoteAuthority(){return(0,it.$2G)(Ve,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return ut(Dt.onDidChangeLogLevel)},get appQuality(){return(0,it.$2G)(Ve,"resolvers"),bt.quality},get appCommit(){return(0,it.$2G)(Ve,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Li);const wn={createTestController(ge,ye,ze){return ki.createTestController(Ve,ge,ye,ze)},createTestObserver(){return(0,it.$2G)(Ve,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,it.$2G)(Ve,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,it.$2G)(Ve,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,it.$2G)(Ve,"testObserver"),ut(ki.onResultsChanged)},get testResults(){return(0,it.$2G)(Ve,"testObserver"),ki.results}},li=bt.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,ji={getExtension(ge,ye){(0,it.$1G)(Ve,"extensionsAny")||(ye=!1);const ze=bi.mine.getExtensionDescription(ge);if(ze)return new G.$_nc(Ut,Ve.identifier,ze,li,!1);if(ye){const dt=bi.all.getExtensionDescription(ge);if(dt)return new G.$_nc(Ut,Ve.identifier,dt,li,!0)}},get all(){const ge=[];for(const ye of bi.mine.getAllExtensionDescriptions())ge.push(new G.$_nc(Ut,Ve.identifier,ye,li,!1));return ge},get allAcrossExtensionHosts(){(0,it.$2G)(Ve,"extensionsAny");const ge=new P.$on(bi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ye=[];for(const ze of bi.all.getAllExtensionDescriptions()){const dt=!ge.has(ze.identifier);ye.push(new G.$_nc(Ut,Ve.identifier,ze,li,dt))}return ye},get onDidChange(){return(0,it.$1G)(Ve,"extensionsAny")?ut(A.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ut(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ge){return ve.createDiagnosticCollection(Ve.identifier,ge)},get onDidChangeDiagnostics(){return ut(ve.onDidChangeDiagnostics)},getDiagnostics:ge=>ve.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,ye){return ie.changeLanguage(ge.uri,ye)},match(ge,ye){const ze=Fe.LanguageSelector.from(ge);let dt;return(0,C.$nu)(ze)&&(dt=Rt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Mt=>Mt.document===ye))?.apiNotebook),(0,C.$mu)(ze,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,ye,ze){return Re.registerCodeActionProvider(Ve,yt(ge),ye,ze)},registerDocumentPasteEditProvider(ge,ye,ze){return(0,it.$2G)(Ve,"documentPaste"),Re.registerDocumentPasteEditProvider(Ve,yt(ge),ye,ze)},registerCodeLensProvider(ge,ye){return Re.registerCodeLensProvider(Ve,yt(ge),ye)},registerDefinitionProvider(ge,ye){return Re.registerDefinitionProvider(Ve,yt(ge),ye)},registerDeclarationProvider(ge,ye){return Re.registerDeclarationProvider(Ve,yt(ge),ye)},registerImplementationProvider(ge,ye){return Re.registerImplementationProvider(Ve,yt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return Re.registerTypeDefinitionProvider(Ve,yt(ge),ye)},registerHoverProvider(ge,ye){return Re.registerHoverProvider(Ve,yt(ge),ye,Ve.identifier)},registerEvaluatableExpressionProvider(ge,ye){return Re.registerEvaluatableExpressionProvider(Ve,yt(ge),ye,Ve.identifier)},registerInlineValuesProvider(ge,ye){return Re.registerInlineValuesProvider(Ve,yt(ge),ye,Ve.identifier)},registerDocumentHighlightProvider(ge,ye){return Re.registerDocumentHighlightProvider(Ve,yt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return Re.registerMultiDocumentHighlightProvider(Ve,yt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return Re.registerLinkedEditingRangeProvider(Ve,yt(ge),ye)},registerReferenceProvider(ge,ye){return Re.registerReferenceProvider(Ve,yt(ge),ye)},registerRenameProvider(ge,ye){return Re.registerRenameProvider(Ve,yt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,it.$2G)(Ve,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(Ve,yt(ge),ye)},registerDocumentSymbolProvider(ge,ye,ze){return Re.registerDocumentSymbolProvider(Ve,yt(ge),ye,ze)},registerWorkspaceSymbolProvider(ge){return Re.registerWorkspaceSymbolProvider(Ve,ge)},registerDocumentFormattingEditProvider(ge,ye){return Re.registerDocumentFormattingEditProvider(Ve,yt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return Re.registerDocumentRangeFormattingEditProvider(Ve,yt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,ze,...dt){return Re.registerOnTypeFormattingEditProvider(Ve,yt(ge),ye,[ze].concat(dt))},registerDocumentSemanticTokensProvider(ge,ye,ze){return Re.registerDocumentSemanticTokensProvider(Ve,yt(ge),ye,ze)},registerDocumentRangeSemanticTokensProvider(ge,ye,ze){return Re.registerDocumentRangeSemanticTokensProvider(Ve,yt(ge),ye,ze)},registerSignatureHelpProvider(ge,ye,ze,...dt){return typeof ze=="object"?Re.registerSignatureHelpProvider(Ve,yt(ge),ye,ze):Re.registerSignatureHelpProvider(Ve,yt(ge),ye,typeof ze>"u"?[]:[ze,...dt])},registerCompletionItemProvider(ge,ye,...ze){return Re.registerCompletionItemProvider(Ve,yt(ge),ye,ze)},registerInlineCompletionItemProvider(ge,ye,ze){return ye.handleDidShowCompletionItem&&(0,it.$2G)(Ve,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,it.$2G)(Ve,"inlineCompletionsAdditions"),ze&&(0,it.$2G)(Ve,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(Ve,yt(ge),ye,ze)},registerInlineEditProvider(ge,ye){return(0,it.$2G)(Ve,"inlineEdit"),Re.registerInlineEditProvider(Ve,yt(ge),ye)},registerDocumentLinkProvider(ge,ye){return Re.registerDocumentLinkProvider(Ve,yt(ge),ye)},registerColorProvider(ge,ye){return Re.registerColorProvider(Ve,yt(ge),ye)},registerFoldingRangeProvider(ge,ye){return Re.registerFoldingRangeProvider(Ve,yt(ge),ye)},registerSelectionRangeProvider(ge,ye){return Re.registerSelectionRangeProvider(Ve,ge,ye)},registerCallHierarchyProvider(ge,ye){return Re.registerCallHierarchyProvider(Ve,ge,ye)},registerTypeHierarchyProvider(ge,ye){return Re.registerTypeHierarchyProvider(Ve,ge,ye)},setLanguageConfiguration:(ge,ye)=>Re.setLanguageConfiguration(Ve,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,it.$2G)(Ve,"tokenInformation"),ie.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return Re.registerInlayHintsProvider(Ve,ge,ye)},createLanguageStatusItem(ge,ye){return ie.createLanguageStatusItem(Ve,ge,ye)},registerDocumentDropEditProvider(ge,ye,ze){return Re.registerDocumentOnDropEditProvider(Ve,ge,ye,(0,it.$1G)(Ve,"documentPaste")?ze:void 0)}},on={get activeTextEditor(){return Gt.getActiveTextEditor()},get visibleTextEditors(){return Gt.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(ge,ye,ze){$.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&Lt.report("workspace.showTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(Ji.openTextDocument(ge)):Promise.resolve(ge));return Gt.showTextDocument(dt,ye,ze)},createTextEditorDecorationType(ge){return Gt.createTextEditorDecorationType(Ve,ge)},onDidChangeActiveTextEditor(ge,ye,ze){return ut(Gt.onDidChangeActiveTextEditor)(ge,ye,ze)},onDidChangeVisibleTextEditors(ge,ye,ze){return ut(Gt.onDidChangeVisibleTextEditors)(ge,ye,ze)},onDidChangeTextEditorSelection(ge,ye,ze){return ut(Gt.onDidChangeTextEditorSelection)(ge,ye,ze)},onDidChangeTextEditorOptions(ge,ye,ze){return ut(Gt.onDidChangeTextEditorOptions)(ge,ye,ze)},onDidChangeTextEditorVisibleRanges(ge,ye,ze){return ut(Gt.onDidChangeTextEditorVisibleRanges)(ge,ye,ze)},onDidChangeTextEditorViewColumn(ge,ye,ze){return ut(Gt.onDidChangeTextEditorViewColumn)(ge,ye,ze)},onDidCloseTerminal(ge,ye,ze){return ut(Pt.onDidCloseTerminal)(ge,ye,ze)},onDidOpenTerminal(ge,ye,ze){return ut(Pt.onDidOpenTerminal)(ge,ye,ze)},onDidChangeActiveTerminal(ge,ye,ze){return ut(Pt.onDidChangeActiveTerminal)(ge,ye,ze)},onDidChangeTerminalDimensions(ge,ye,ze){return(0,it.$2G)(Ve,"terminalDimensions"),ut(Pt.onDidChangeTerminalDimensions)(ge,ye,ze)},onDidChangeTerminalState(ge,ye,ze){return ut(Pt.onDidChangeTerminalState)(ge,ye,ze)},onDidWriteTerminalData(ge,ye,ze){return(0,it.$2G)(Ve,"terminalDataWriteEvent"),ut(Pt.onDidWriteTerminalData)(ge,ye,ze)},onDidExecuteTerminalCommand(ge,ye,ze){return(0,it.$2G)(Ve,"terminalExecuteCommandEvent"),ut(Pt.onDidExecuteTerminalCommand)(ge,ye,ze)},onDidChangeTerminalShellIntegration(ge,ye,ze){return(0,it.$2G)(Ve,"terminalShellIntegration"),ut(Ot.onDidChangeTerminalShellIntegration)(ge,ye,ze)},onDidStartTerminalShellExecution(ge,ye,ze){return(0,it.$2G)(Ve,"terminalShellIntegration"),ut(Ot.onDidStartTerminalShellExecution)(ge,ye,ze)},onDidEndTerminalShellExecution(ge,ye,ze){return(0,it.$2G)(Ve,"terminalShellIntegration"),ut(Ot.onDidEndTerminalShellExecution)(ge,ye,ze)},get state(){return Ft.getState()},onDidChangeWindowState(ge,ye,ze){return ut(Ft.onDidChangeWindowState)(ge,ye,ze)},showInformationMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return Hi.showMessage(Ve,T.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,ze){return Qe.showQuickPick(Ve,ge,ye,ze)},showWorkspaceFolderPick(ge){return Qe.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return Qe.showInput(ge,ye)},showOpenDialog(ge){return Fi.showOpenDialog(Ve,ge)},showSaveDialog(ge){return Fi.showSaveDialog(ge)},createStatusBarItem(ge,ye,ze){let dt,St,Mt;return typeof ge=="string"?(dt=ge,St=ye,Mt=ze):(St=ge,Mt=ye),tn.createStatusBarEntry(Ve,dt,St,Mt)},setStatusBarMessage(ge,ye){return tn.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Lt.report("window.withScmProgress",Ve,"Use 'withProgress' instead."),Bt.withProgress(Ve,{location:Z.ProgressLocation.SourceControl},(ye,ze)=>ge({report(dt){}}))},withProgress(ge,ye){return Bt.withProgress(Ve,ge,ye)},createOutputChannel(ge,ye){return pi.createOutputChannel(ge,ye,Ve)},createWebviewPanel(ge,ye,ze,dt){return Ni.createWebviewPanel(Ve,ge,ye,ze,dt)},createWebviewTextEditorInset(ge,ye,ze,dt){return(0,it.$2G)(Ve,"editorInsets"),je.createWebviewEditorInset(ge,ye,ze,dt,Ve)},createTerminal(ge,ye,ze){return typeof ge=="object"?"pty"in ge?Pt.createExtensionTerminal(ge):Pt.createTerminalFromOptions(ge):Pt.createTerminal(ge,ye,ze)},registerTerminalLinkProvider(ge){return Pt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Pt.registerProfileProvider(Ve,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,it.$2G)(Ve,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(ge,Ve.identifier.value,ye)},registerTreeDataProvider(ge,ye){return Ae.registerTreeDataProvider(ge,ye,Ve)},createTreeView(ge,ye){return Ae.createTreeView(ge,ye,Ve)},registerWebviewPanelSerializer:(ge,ye)=>Ni.registerWebviewPanelSerializer(Ve,ge,ye),registerCustomEditorProvider:(ge,ye,ze={})=>Ui.registerCustomEditorProvider(Ve,ge,ye,ze),registerFileDecorationProvider(ge){return di.registerFileDecorationProvider(ge,Ve)},registerUriHandler(ge){return Ai.registerUriHandler(Ve,ge)},createQuickPick(){return Qe.createQuickPick(Ve)},createInputBox(){return Qe.createInputBox(Ve)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,ze){return ut(Wi.onDidChangeActiveColorTheme)(ge,ye,ze)},registerWebviewViewProvider(ge,ye,ze){return Vi.registerWebviewViewProvider(Ve,ge,ye,ze?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,ze){return ut(Rt.onDidChangeActiveNotebookEditor)(ge,ye,ze)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ut(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,ze){return ut(Di.onDidChangeNotebookEditorSelection)(ge,ye,ze)},onDidChangeNotebookEditorVisibleRanges(ge,ye,ze){return ut(Di.onDidChangeNotebookEditorVisibleRanges)(ge,ye,ze)},showNotebookDocument(ge,ye){return Rt.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,ze){return(0,it.$2G)(Ve,"externalUriOpener"),xi.registerExternalUriOpener(Ve.identifier,ge,ye,ze)},registerProfileContentHandler(ge,ye){return(0,it.$2G)(Ve,"profileContentHandlers"),_i.registerProfileContentHandler(Ve,ge,ye)},registerQuickDiffProvider(ge,ye,ze,dt){return(0,it.$2G)(Ve,"quickDiffProvider"),At.registerQuickDiffProvider(yt(ge),ye,ze,dt)},get tabGroups(){return ni.tabGroups},registerShareProvider(ge,ye){return(0,it.$2G)(Ve,"shareProvider"),xt.registerShareProvider(yt(ge),ye)}},Ji={get rootPath(){return Lt.report("workspace.rootPath",Ve,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ge){throw new h.$0("rootPath")},getWorkspaceFolder(ge){return wt.getWorkspaceFolder(ge)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ge){throw new h.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ge){throw new h.$0("workspaceFile")},updateWorkspaceFolders:(ge,ye,...ze)=>wt.updateWorkspaceFolders(Ve,ge,ye||0,...ze),onDidChangeWorkspaceFolders:function(ge,ye,ze){return ut(wt.onDidChangeWorkspace)(ge,ye,ze)},asRelativePath:(ge,ye)=>wt.getRelativePath(ge,ye),findFiles:(ge,ye,ze,dt)=>wt.findFiles(ge,ye,ze,Ve.identifier,dt),findFiles2:(ge,ye,ze)=>((0,it.$2G)(Ve,"findFiles2"),wt.findFiles2(ge,ye,Ve.identifier,ze)),findTextInFiles:(ge,ye,ze,dt)=>{(0,it.$2G)(Ve,"findTextInFiles");let St,Mt;return typeof ye=="object"?(St=ye,Mt=ze):(St={},Mt=ye,dt=ze),wt.findTextInFiles(ge,St||{},Mt,Ve.identifier,dt)},save:ge=>wt.save(ge),saveAs:ge=>wt.saveAs(ge),saveAll:ge=>wt.saveAll(ge),applyEdit(ge,ye){return bn.applyWorkspaceEdit(ge,Ve,ye)},createFileSystemWatcher:(ge,ye,ze,dt)=>{let St;return typeof ye=="boolean"?St={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,it.$2G)(Ve,"createFileSystemWatcher"),St={...ye,correlate:!0}),et.createFileSystemWatcher(wt,Ve,ge,St)},get textDocuments(){return Nt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$0("textDocuments")},openTextDocument(ge){let ye;const ze=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!ze||typeof ze=="object")ye=Nt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",Ve,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(ge,ye,ze)=>ut(Nt.onDidAddDocument)(ge,ye,ze),onDidCloseTextDocument:(ge,ye,ze)=>ut(Nt.onDidRemoveDocument)(ge,ye,ze),onDidChangeTextDocument:(ge,ye,ze)=>ut(Nt.onDidChangeDocument)(ge,ye,ze),onDidSaveTextDocument:(ge,ye,ze)=>ut(Nt.onDidSaveDocument)(ge,ye,ze),onWillSaveTextDocument:(ge,ye,ze)=>ut(ai.getOnWillSaveTextDocumentEvent(Ve))(ge,ye,ze),get notebookDocuments(){return Rt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let ze;if($.URI.isUri(ge))ze=ge,await Rt.openNotebookDocument(ge);else if(typeof ge=="string")ze=$.URI.revive(await Rt.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ge,ye,ze){return ut(Si.onDidSaveNotebookDocument)(ge,ye,ze)},onDidChangeNotebookDocument(ge,ye,ze){return ut(Si.onDidChangeNotebookDocument)(ge,ye,ze)},onWillSaveNotebookDocument(ge,ye,ze){return ut(gi.getOnWillSaveNotebookDocumentEvent(Ve))(ge,ye,ze)},get onDidOpenNotebookDocument(){return ut(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ut(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,ze,dt){return Rt.registerNotebookSerializer(Ve,ge,ye,ze,(0,it.$1G)(Ve,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,ye,ze)=>ut(Ki.onDidChangeConfiguration)(ge,ye,ze),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,Ki.getConfiguration(ge,ye,Ve)},registerTextDocumentContentProvider(ge,ye){return Ti.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Lt.report("window.registerTaskProvider",Ve,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ve,ge,ye)),registerFileSystemProvider(ge,ye,ze){return(0,R.$Sc)(He.registerFileSystemProvider(Ve,ge,ye,ze),ei.addFileSystemProvider(ge,ye,ze))},get fs(){return ei.value},registerFileSearchProvider:(ge,ye)=>((0,it.$2G)(Ve,"fileSearchProvider"),Zt.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,it.$2G)(Ve,"textSearchProvider"),Zt.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,it.$2G)(Ve,"aiTextSearchProvider"),(0,it.$2G)(Ve,"textSearchProvider"),Zt.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,it.$2G)(Ve,"resolvers"),Ut.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,it.$2G)(Ve,"resolvers"),ri.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,it.$2G)(Ve,"resolvers"),Ut.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,ze)=>ut(et.onDidCreateFile)(ge,ye,ze),onDidDeleteFiles:(ge,ye,ze)=>ut(et.onDidDeleteFile)(ge,ye,ze),onDidRenameFiles:(ge,ye,ze)=>ut(et.onDidRenameFile)(ge,ye,ze),onWillCreateFiles:(ge,ye,ze)=>ut(et.getOnWillCreateFileEvent(Ve))(ge,ye,ze),onWillDeleteFiles:(ge,ye,ze)=>ut(et.getOnWillDeleteFileEvent(Ve))(ge,ye,ze),onWillRenameFiles:(ge,ye,ze)=>ut(et.getOnWillRenameFileEvent(Ve))(ge,ye,ze),openTunnel:ge=>((0,it.$2G)(Ve,"tunnels"),Jt.openTunnel(Ve,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,it.$2G)(Ve,"tunnels"),Jt.getTunnels()},onDidChangeTunnels:(ge,ye,ze)=>((0,it.$2G)(Ve,"tunnels"),ut(Jt.onDidChangeTunnels)(ge,ye,ze)),registerPortAttributesProvider:(ge,ye)=>((0,it.$2G)(Ve,"portsAttributes"),Jt.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,it.$2G)(Ve,"tunnelFactory"),Jt.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,it.$2G)(Ve,"timeline"),Zi.registerTimelineProvider(ge,ye,Ve.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ge=>((0,it.$2G)(Ve,"workspaceTrust"),wt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,ze)=>ut(wt.onDidGrantWorkspaceTrust)(ge,ye,ze),registerEditSessionIdentityProvider:(ge,ye)=>((0,it.$2G)(Ve,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,ze)=>((0,it.$2G)(Ve,"editSessionIdentityProvider"),ut(wt.getOnWillCreateEditSessionIdentityEvent(Ve))(ge,ye,ze)),registerCanonicalUriProvider:(ge,ye)=>((0,it.$2G)(Ve,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,ze)=>((0,it.$2G)(Ve,"canonicalUriProvider"),wt.provideCanonicalUri(ge,ye,ze))},an={get inputBox(){return Lt.report("scm.inputBox",Ve,"Use 'SourceControl.inputBox' instead"),gt.getLastInputBox(Ve)},createSourceControl(ge,ye,ze){return gt.createSourceControl(Ve,ge,ye,ze)}},vn={createCommentController(ge,ye){return ci.createCommentController(Ve,ge,ye)}},cn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,it.$2G)(Ve,"debugVisualization"),It.registerDebugVisualizationProvider(Ve,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,it.$2G)(Ve,"debugVisualization"),It.registerDebugVisualizationTree(Ve,ge,ye)},onDidStartDebugSession(ge,ye,ze){return ut(It.onDidStartDebugSession)(ge,ye,ze)},onDidTerminateDebugSession(ge,ye,ze){return ut(It.onDidTerminateDebugSession)(ge,ye,ze)},onDidChangeActiveDebugSession(ge,ye,ze){return ut(It.onDidChangeActiveDebugSession)(ge,ye,ze)},onDidReceiveDebugSessionCustomEvent(ge,ye,ze){return ut(It.onDidReceiveDebugSessionCustomEvent)(ge,ye,ze)},onDidChangeBreakpoints(ge,ye,ze){return ut(It.onDidChangeBreakpoints)(ge,ye,ze)},onDidChangeActiveStackItem(ge,ye,ze){return ut(It.onDidChangeActiveStackItem)(ge,ye,ze)},registerDebugConfigurationProvider(ge,ye,ze){return It.registerDebugConfigurationProvider(ge,ye,ze||zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return It.registerDebugAdapterDescriptorFactory(Ve,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return It.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,ze){return!ze||typeof ze=="object"&&"configuration"in ze?It.startDebugging(ge,ye,{parentSession:ze}):It.startDebugging(ge,ye,ze||{})},stopDebugging(ge){return It.stopDebugging(ge)},addBreakpoints(ge){return It.addBreakpoints(ge)},removeBreakpoints(ge){return It.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return It.asDebugSourceUri(ge,ye)}},ln={registerTaskProvider:(ge,ye)=>Ht.registerTaskProvider(Ve,ge,ye),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(Ve,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,ye,ze)=>ut(Ht.onDidStartTask)(ge,ye,ze),onDidEndTask:(ge,ye,ze)=>ut(Ht.onDidEndTask)(ge,ye,ze),onDidStartTaskProcess:(ge,ye,ze)=>ut(Ht.onDidStartTaskProcess)(ge,ye,ze),onDidEndTaskProcess:(ge,ye,ze)=>ut(Ht.onDidEndTaskProcess)(ge,ye,ze)},En={createNotebookController(ge,ye,ze,dt,St){return vi.createNotebookController(Ve,ge,ye,ze,dt,(0,it.$1G)(Ve,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>Rt.registerNotebookCellStatusBarItemProvider(Ve,ge,ye),createRendererMessaging(ge){return Oi.createRendererMessaging(Ve,ge)},createNotebookControllerDetectionTask(ge){return(0,it.$2G)(Ve,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Ve,ge)},registerKernelSourceActionProvider(ge,ye){return(0,it.$2G)(Ve,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Ve,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,ze){return(0,it.$2G)(Ve,"notebookCellExecutionState"),ut(vi.onDidChangeNotebookCellExecutionState)(ge,ye,ze)}},yn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),ze=!ge||typeof ge[0]!="object"?ge:ge[0];return fi.getMessage(Ve.identifier.value,{message:ye,args:ze})}return fi.getMessage(Ve.identifier.value,ge[0])},get bundle(){return fi.getBundle(Ve.identifier.value)},get uri(){return fi.getBundleUri(Ve.identifier.value)}},un={_version:1,transferActiveChat(ge){return(0,it.$2G)(Ve,"interactive"),Mi.transferActiveChat(ge)}},Qi={getRelatedInformation(ge,ye){return(0,it.$2G)(Ve,"aiRelatedInformation"),qi.getRelatedInformation(Ve,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,it.$2G)(Ve,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Ve,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,it.$2G)(Ve,"aiRelatedInformation"),$n.registerEmbeddingVectorProvider(Ve,ge,ye)}},hn={_version:1,registerChatResponseProvider(ge,ye,ze){return(0,it.$2G)(Ve,"chatProvider"),Qt.registerLanguageModel(Ve,ge,ye,ze)},registerChatVariableResolver(ge,ye,ze,dt,St,Mt,Pi,Bi){return(0,it.$2G)(Ve,"chatVariableResolver"),en.registerVariableResolver(Ve,ge,ye,ze,dt,St,Mt,Pi,Bi?.id)},registerMappedEditsProvider(ge,ye){return(0,it.$2G)(Ve,"mappedEditsProvider"),Re.registerMappedEditsProvider(Ve,ge,ye)},createChatParticipant(ge,ye){return Mi.createChatAgent(Ve,ge,ye)},createDynamicChatParticipant(ge,ye,ze){return(0,it.$2G)(Ve,"chatParticipantPrivate"),Mi.createDynamicChatAgent(Ve,ge,ye,ze)}},dn={selectChatModels:ge=>bt.quality==="stable"?(console.warn(`[${P.$nn.toKey(Ve.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Qt.selectLanguageModels(Ve,ge??{}),onDidChangeChatModels:(ge,ye,ze)=>bt.quality==="stable"?(console.warn(`[${P.$nn.toKey(Ve.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),A.Event.None(ge,ye,ze)):Qt.onDidChangeProviders(ge,ye,ze),registerChatModelProvider:(ge,ye,ze)=>((0,it.$2G)(Ve,"chatProvider"),Qt.registerLanguageModel(Ve,ge,ye,ze)),get embeddingModels(){return(0,it.$2G)(Ve,"embeddings"),Ii.embeddingsModels},onDidChangeEmbeddingModels:(ge,ye,ze)=>((0,it.$2G)(Ve,"embeddings"),Ii.onDidChange(ge,ye,ze)),registerEmbeddingsProvider(ge,ye){return(0,it.$2G)(Ve,"embeddings"),Ii.registerEmbeddingsProvider(Ve,ge,ye)},async computeEmbeddings(ge,ye,ze){return(0,it.$2G)(Ve,"embeddings"),Ii.computeEmbeddings(ge,ye,ze)}},fn={registerSpeechProvider(ge,ye){return(0,it.$2G)(Ve,"speech"),Gi.registerProvider(Ve.identifier,ge,ye)}};return{version:bt.version,ai:Qi,authentication:rn,commands:Ei,comments:vn,chat:hn,debug:cn,env:Li,extensions:ji,interactive:un,l10n:yn,languages:sn,lm:dn,notebooks:En,scm:an,speech:fn,tasks:ln,tests:wn,window:on,workspace:Ji,Breakpoint:Z.$2N,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatResultFeedbackKind:Z.ChatResultFeedbackKind,ChatVariableLevel:Z.ChatVariableLevel,ChatCompletionItem:Z.$WO,CallHierarchyIncomingCall:Z.$nN,CallHierarchyItem:Z.$mN,CallHierarchyOutgoingCall:Z.$oN,CancellationError:h.$6,CancellationTokenSource:r.$ue,CandidatePortSource:n.CandidatePortSource,CodeAction:Z.$jN,CodeActionKind:Z.$kN,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$pN,Color:Z.$CN,ColorInformation:Z.$DN,ColorPresentation:Z.$EN,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CommentThreadApplicability:Z.CommentThreadApplicability,CompletionItem:Z.$wN,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$xN,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$MN,DebugAdapterExecutable:Z.$6N,DebugAdapterInlineImplementation:Z.$9N,DebugAdapterNamedPipeServer:Z.$8N,DebugAdapterServer:Z.$7N,DebugConfigurationProviderTriggerKind:zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DebugVisualization:Z.$mO,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$cN,DiagnosticRelatedInformation:Z.$bN,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$1M,DocumentHighlight:Z.$fN,DocumentHighlightKind:Z.DocumentHighlightKind,MultiDocumentHighlight:Z.$gN,DocumentLink:Z.$BN,DocumentSymbol:Z.$iN,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$_N,InlineValueText:Z.$aO,InlineValueVariableLookup:Z.$bO,InlineValueEvaluatableExpression:Z.$cO,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:A.$je,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$oO,FileDecoration2:Z.$oO,FileSystemError:Z.$fO,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Z.$gO,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$4N,InlineCompletionItem:Z.$yN,InlineCompletionList:Z.$zN,Hover:Z.$dN,VerboseHover:Z.$eN,HoverVerbosityAction:Z.HoverVerbosityAction,IndentAction:E.IndentAction,Location:Z.$aN,MarkdownString:Z.$qN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Z.$rN,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$2M,ProcessExecution:Z.$KN,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$nO,Range:Z.$3M,RelativePattern:Z.$ZN,Selection:Z.$4M,SelectionRange:Z.$lN,SemanticTokens:Z.$jO,SemanticTokensBuilder:Z.$iO,SemanticTokensEdit:Z.$kO,SemanticTokensEdits:Z.$lO,SemanticTokensLegend:Z.$hO,ShellExecution:Z.$LN,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$tN,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$sN,SnippetString:Z.$_M,SourceBreakpoint:Z.$3N,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$hN,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$NN,TaskGroup:Z.$JN,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$FN,TerminalQuickFixTerminalCommand:Z.$HN,TerminalQuickFixOpener:Z.$GN,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$IN,TerminalExitReason:Z.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Z.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$8M,SnippetTextEdit:Z.$0M,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$YN,ThemeIcon:Z.$XN,TreeItem:Z.$ON,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$KO,UIKind:ui.UIKind,Uri:$.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$$M,DocumentPasteTriggerKind:Z.DocumentPasteTriggerKind,DocumentDropEdit:Z.$UN,DocumentDropOrPasteEditKind:Z.$VN,DocumentPasteEdit:Z.$WN,InlayHint:Z.$vN,InlayHintLabelPart:Z.$uN,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$7M,ResolvedAuthority:Z.$5M,ManagedResolvedAuthority:Z.$6M,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$yO,NotebookRange:Z.$qO,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$rO,NotebookData:Z.$sO,NotebookRendererScript:Z.$wO,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$uO,NotebookCellOutputItem:Z.$tO,NotebookCellStatusBarItem:Z.$vO,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$9M,NotebookKernelSourceAction:Z.$xO,NotebookVariablesRequestKind:Z.NotebookVariablesRequestKind,PortAttributes:Z.$AO,LinkedEditingRanges:Z.$zO,TestResultState:Z.TestResultState,TestRunRequest:Z.$BO,TestMessage:Z.$CO,TestTag:Z.$DO,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:Z.$TN,DataTransferItem:Z.$PN,TestCoverageCount:Z.$EO,FileCoverage:Z.$GO,FileCoverage2:Z.$GO,StatementCoverage:Z.$HO,BranchCoverage:Z.$IO,DeclarationCoverage:Z.$JO,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$LO,TabInputTextDiff:Z.$MO,TabInputTextMerge:Z.$NO,TabInputCustom:Z.$OO,TabInputNotebook:Z.$QO,TabInputNotebookDiff:Z.$RO,TabInputWebview:Z.$PO,TabInputTerminal:Z.$SO,TabInputInteractiveWindow:Z.$TO,TabInputChat:Z.$UO,TabInputTextMultiDiff:Z.$VO,TelemetryTrustedValue:f.$qp,LogLevel:c.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,ChatCopyKind:Z.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Z.$0N,DebugThread:Z.$$N,RelatedInformationType:Z.RelatedInformationType,SpeechToTextStatus:Z.SpeechToTextStatus,TextToSpeechStatus:Z.TextToSpeechStatus,PartialAcceptTriggerKind:Z.PartialAcceptTriggerKind,KeywordRecognitionStatus:Z.KeywordRecognitionStatus,ChatResponseMarkdownPart:Z.$XO,ChatResponseFileTreePart:Z.$2O,ChatResponseAnchorPart:Z.$3O,ChatResponseProgressPart:Z.$4O,ChatResponseProgressPart2:Z.$5O,ChatResponseReferencePart:Z.$8O,ChatResponseWarningPart:Z.$6O,ChatResponseTextEditPart:Z.$9O,ChatResponseMarkdownWithVulnerabilitiesPart:Z.$YO,ChatResponseCommandButtonPart:Z.$7O,ChatResponseDetectedParticipantPart:Z.$ZO,ChatResponseConfirmationPart:Z.$1O,ChatRequestTurn:Z.$0O,ChatResponseTurn:Z.$$O,ChatLocation:Z.ChatLocation,LanguageModelChatMessageRole:Z.LanguageModelChatMessageRole,LanguageModelChatMessage:Z.$aP,LanguageModelChatMessageFunctionResultPart:Z.$_O,LanguageModelChatResponseTextPart:Z.$cP,LanguageModelChatResponseFunctionUsePart:Z.$bP,LanguageModelChatMessage2:Z.$aP,LanguageModelChatSystemMessage:Z.$dP,LanguageModelChatUserMessage:Z.$eP,LanguageModelChatAssistantMessage:Z.$fP,LanguageModelError:Z.$gP,NewSymbolName:Z.$eO,NewSymbolNameTag:Z.NewSymbolNameTag,NewSymbolNameTriggerKind:Z.NewSymbolNameTriggerKind,InlineEdit:Z.$hP,InlineEditTriggerKind:Z.InlineEditTriggerKind}}}}),define(Ee[395],Se([1,0,89,168,48,162,42,35,64,47,101,102,103,126,77,96,161,76,63,125,95,78,160,12,65,123,124,128,129,166,99]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d,a,w,y,D,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Is)(a.$6nc,a.$5nc,r.InstantiationType.Delayed),(0,r.$Is)(s.$0j,t.$hpc,r.InstantiationType.Delayed),(0,r.$Is)(c.$$mc,c.$_mc,r.InstantiationType.Delayed),(0,r.$Is)(T.$OP,T.$NP,r.InstantiationType.Eager),(0,r.$Is)(y.$inc,y.$jnc,r.InstantiationType.Eager),(0,r.$Is)(D.$Znc,D.$1nc,r.InstantiationType.Eager),(0,r.$Is)(L.$xnc,L.$vnc,r.InstantiationType.Eager),(0,r.$Is)(f.$znc,f.$ync,r.InstantiationType.Eager),(0,r.$Is)(I.$doc,I.$eoc,r.InstantiationType.Eager),(0,r.$Is)(E.$ioc,E.$moc,r.InstantiationType.Eager),(0,r.$Is)(R.$ooc,R.$noc,r.InstantiationType.Eager),(0,r.$Is)($.$DP,$.$CP,r.InstantiationType.Eager),(0,r.$Is)(w.$7nc,w.$8nc,r.InstantiationType.Eager),(0,r.$Is)(m.$cnc,m.$bnc,r.InstantiationType.Eager),(0,r.$Is)(h.$Toc,h.$Soc,r.InstantiationType.Delayed),(0,r.$Is)(u.$Eoc,u.$Foc,r.InstantiationType.Eager),(0,r.$Is)(P.$Snc,P.$Rnc,r.InstantiationType.Eager),(0,r.$Is)(C.$7oc,C.$6oc,r.InstantiationType.Eager),(0,r.$Is)(l.$Vnc,l.$Ync,r.InstantiationType.Eager),(0,r.$Is)(S.$8oc,S.$9oc,r.InstantiationType.Eager),(0,r.$Is)(p.$2Eb,p.$3Eb,r.InstantiationType.Eager),(0,r.$Is)(g.$fpc,g.$epc,r.InstantiationType.Eager),(0,r.$Is)(A.$unc,A.$tnc,r.InstantiationType.Eager),(0,r.$Is)(n.$3nc,n.$2nc,r.InstantiationType.Eager),(0,r.$Is)(o.$MP,o.$JP,r.InstantiationType.Eager),(0,r.$Is)(i.$Jnc,i.$Knc,r.InstantiationType.Eager),(0,r.$Is)(d.$boc,d.$coc,r.InstantiationType.Eager)}),define(Ee[130],Se([1,0,19,12,38,100]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0,e.$xpc=L,e.$ypc=T,R=Ue(R);function L(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function T(E,u,P,p){const c=(0,r.$2b)(P,$),g=new A.$oL(u,c,p),f=g.preview.matches;return{ranges:(0,r.$2b)(c,l),uri:E,preview:{text:g.preview.text,matches:(0,r.$2b)(f,l)}}}function $(E){return new A.$pL(E.start.line,E.start.character,E.end.line,E.end.character)}function l(E){return new R.$cL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let C=class{constructor(u,P){this.a=u,this.b=P}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$zpc=C,e.$zpc=C=Ye([qe(1,h.$9j)],C)}),define(Ee[396],Se([1,0,58,16,82,33,11,13,130,397]),function(ce,e,r,h,A,R,L,T,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=E,e.$Bpc=g,e.$Cpc=m,r=Ue(r),h=Ue(h),R=Ue(R),T=Ue(T);const C=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,i,t,s){const d=u(n,o,i,t,s),a=o.folder.fsPath;return{cmd:r.spawn(C,d.args,{cwd:a}),rgDiskPath:C,siblingClauses:d.siblingClauses,rgArgs:d,cwd:a}}function u(n,o,i,t,s){const d=["--files","--hidden","--case-sensitive","--no-require-git"];p([o],i,!1).forEach(w=>{const y=(0,$.$xpc)(w);if(d.push("-g",y),L.$j){const D=(0,A.$km)(y);D!==y&&d.push("-g",D)}});const a=P([o],t,void 0,!1);return a.globArgs.forEach(w=>{const y=`!${(0,$.$xpc)(w)}`;if(d.push("-g",y),L.$j){const D=(0,A.$km)(y);D!==y&&d.push("-g",D)}}),o.disregardIgnoreFiles!==!1?d.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),o.ignoreSymlinks||d.push("--follow"),n.exists&&d.push("--quiet"),s&&d.push("--threads",`${s}`),d.push("--no-config"),o.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:a.siblingClauses}}function P(n,o,i,t=!0){const s=[];let d={};return n.forEach(a=>{const w=Object.assign({},a.excludePattern||{},o||{}),y=c(w,t?a.folder.fsPath:void 0,i);s.push(...y.globArgs),y.siblingClauses&&(d=Object.assign(d,y.siblingClauses))}),{globArgs:s,siblingClauses:d}}function p(n,o,i=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},o||{},s.includePattern||{}),a=c(d,i?s.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function c(n,o,i){const t=[],s={};return Object.keys(n).forEach(d=>{if(i&&i.has(d)||!d)return;const a=n[d];d=f(o?g(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof a=="boolean"&&a?(d.startsWith("\\\\")&&(d+="**"),t.push(m(d))):a&&a.when&&(s[d]=a)}),{globArgs:t,siblingClauses:s}}function g(n,o){return h.$jc(o)?o:h.$kc(n,o)}function f(n){return n=T.$lf(n,"\\"),T.$lf(n,"/")}function m(n){return R.$xg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[398],Se([1,0,58,61,16,399,19,55,39,82,33,11,43,13,18,34,38,396,141]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=e.$Dpc=void 0,r=Ue(r),h=Ue(h),A=Ue(A),L=Ue(L),$=Ue($),l=Ue(l),E=Ue(E),P=Ue(P),p=Ue(p);const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&$.$wk(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=a.shouldGlobMatchFilePattern?null:(0,m.$Ir)(this.b).normalizedLowercase),this.u=a.excludePattern&&$.$wk(a.excludePattern),this.t=new Map,a.folderQueries.forEach(w=>{const y=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),D=w.folder.fsPath;a.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==D).forEach(S=>{(0,C.$Bg)(S,D)&&(y[A.$mc(D,S)]=!0)}),this.t.set(D,new t(y,D))})}cancel(){this.l=!0,n.forEach(a=>a())}walk(a,w,y,D,S,I){if(this.m=u.$de.create(!1),this.l)return I(null,this.j);w.forEach(k=>{const b=A.$oc(k.fsPath);this.u&&this.u(k.fsPath,b)||this.J(D,{relativePath:k.fsPath,searchPath:void 0})}),this.r=u.$de.create(!1),this.w(a,(k,b)=>{this.x(this.y,this,k,y,D,S,v=>{if(v){const N=(0,T.$nj)(v);console.error(N),this.q.push(N),b(v,void 0)}else b(null,void 0)})},(k,b)=>{this.m.stop();const v=k?L.$Ib(k)[0]:null;I(v,this.j)})}w(a,w,y){const D=new Array(a.length),S=new Array(a.length);let I=!1,k=0;if(a.length===0)return y(null,[]);a.forEach((b,v)=>{w(b,(N,O)=>{if(N?(I=!0,D[v]=null,S[v]=N):(D[v]=O,S[v]=null),++k===a.length)return y(I?S:null,D)})})}x(a,w,...y){try{a.apply(w,y)}catch(D){y[y.length-1](D)}}y(a,w,y,D,S){const I=a.folder.fsPath,k=E.$j,b=()=>j&&j.kill();n.add(b);let v=_=>{n.delete(b),v=()=>{},S(_)},N="";const O=this.D(),F=(0,f.$Apc)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression,w),j=F.cmd,B=!Object.keys(F.siblingClauses).length,M=F.rgArgs.args.map(_=>_.match(/^-/)?_:`'${_}'`).join(" ");let W=`${F.rgDiskPath} ${M}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(W+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),D({message:W}),this.s=0,this.z(j,"utf8",D,(_,re,z)=>{if(_){v(_);return}if(this.j){v();return}const J=(N+(k?l.$jm(re||""):re)).split(`
`);if(z){const ee=J.length;J[ee-1]=J[ee-1].trim(),J[ee-1]||J.pop()}else N=J.pop()||"";if(J.length&&J[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=J.length,B){for(const ee of J)if(this.J(y,{base:I,relativePath:ee,searchPath:this.N(a,ee)}),this.j){b();break}(z||this.j)&&v();return}this.G(a,O,I,J,y),z&&(this.H(O,I,y),v())})}spawnFindCmd(a){const w=this.t.get(a.folder.fsPath),y=w.getBasenameTerms(),D=w.getPathTerms(),S=["-L","."];if(y.length||D.length){S.push("-not","(","(");for(const I of y)S.push("-name",I),S.push("-o");for(const I of D)S.push("-path",I),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),r.spawn("find",S,{cwd:a.folder.fsPath})}readStdout(a,w,y){let D="";this.z(a,w,()=>{},(S,I,k)=>{if(S){y(S);return}D+=I,k&&y(null,D)})}z(a,w,y,D){let S=(b,v,N)=>{(b||N)&&(S=()=>{},this.r?.stop()),D(b,v,N)},I=!1;a.stdout?(this.A(a.stdout,w,S),a.stdout.once("data",()=>I=!0)):y({message:"stdout is null"});let k;a.stderr?k=this.B(a.stderr):y({message:"stderr is null"}),a.on("error",b=>{S(b)}),a.on("close",b=>{let v;!I&&(v=this.C(k,w))&&s(v)?S(new Error(`command failed with error code ${b}: ${this.C(k,w)}`)):(this.g&&b===0&&(this.j=!0),S(null,"",!0))})}A(a,w,y){const D=new R.StringDecoder(w);return a.on("data",S=>{y(null,D.write(S))}),D}B(a){const w=[];return a.on("data",y=>{w.push(y)}),w}C(a,w){const y=new R.StringDecoder(w);return a.map(D=>y.write(D)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:w},y,D,S){D.indexOf(this.b)!==-1&&this.J(S,{base:y,relativePath:this.b,searchPath:this.N(a,this.b)});const I=k=>{const b=A.$oc(k),v=A.$nc(k);let N=w[v];N||(N=w[v]=[],I(v)),N.push({base:y,relativePath:k,basename:b,searchPath:this.N(a,k)})};D.forEach(I)}H({rootEntries:a,pathToEntries:w},y,D){const S=this,I=this.t.get(y),k=this.b;function b(v){S.o++;const N=(0,g.$EL)(()=>v.map(O=>O.basename));for(let O=0,F=v.length;O<F;O++){const j=v[O],{relativePath:B,basename:M}=j;if(I.test(B,M,k!==M?N:void 0))continue;const W=w[B];if(W)b(W);else{if(S.p++,B===k)continue;S.J(D,j)}if(S.j)break}}b(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,w,y,D,S){const I=a.folder,k=(0,g.$EL)(()=>y);this.w(y,(b,v)=>{if(this.l||this.j)return v(null);const N=w?[w,b].join(A.sep):b;if(this.t.get(a.folder.fsPath).test(N,b,this.a.filePattern!==b?k:void 0))return v(null);const O=[I.fsPath,N].join(A.sep);h.lstat(O,(F,j)=>{if(F||this.l||this.j)return v(null);this.L(O,j,(B,M)=>B||this.l||this.j?v(null):M.isDirectory()?(this.o++,this.M(O,j,(W,_)=>W||this.l||this.j||(_=_||"",this.v[_])?v(null):(this.v[_]=!0,c.Promises.readdir(O).then(re=>{if(this.l||this.j)return v(null);this.I(a,N,re,D,z=>v(z||null))},re=>{v(null)})))):(this.p++,N===this.b||this.h&&p.$gg(M.size)&&M.size>this.h||this.J(D,{base:I.fsPath,relativePath:N,searchPath:this.N(a,N)}),v(null,void 0)))})},b=>{const v=b&&L.$Ib(b);return S(v&&v.length>0?v[0]:void 0)})}J(a,w){this.K(w)&&(!this.d||this.d(w.relativePath,A.$oc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(w))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$zL)(a,this.c);if(this.b)return(0,g.$zL)(a,this.b,!1)}return!0}L(a,w,y){return w.isSymbolicLink()?h.stat(a,y):y(null,w)}M(a,w,y){return w.isSymbolicLink()?h.realpath(a,(D,S)=>D?y(D):y(null,S)):y(null,a)}N(a,w){return a.folderName?A.$kc(a.folderName,w):w}}e.$Dpc=o;class i{constructor(a,w){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.d=w,this.c=new o(a)}search(a,w,y){this.c.walk(this.a,this.b,this.d,a,w,(D,S)=>{y(D,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Epc=i;class t{constructor(a,w){this.expression=a,this.c=w,this.d(a)}d(a){let w,y;Object.keys(a).filter(D=>a[D]).forEach(D=>{A.$jc(D)?(w=w||$.$rk(),w[D]=a[D]):(y=y||$.$rk(),y[D]=a[D])}),this.a=w&&$.$wk(w,{trimForExclusions:!0}),this.b=y&&$.$wk(y,{trimForExclusions:!0})}test(a,w,y){return this.b&&this.b(a,w,y)||this.a&&this.a(A.$kc(this.c,a),w,y)}getBasenameTerms(){const a=[];return this.a&&a.push(...$.$yk(this.a)),this.b&&a.push(...$.$yk(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...$.$zk(this.a)),this.b&&a.push(...$.$zk(this.b)),a}}function s(d){const a=d.trim().split(`
`),w=a[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return P.$7f(a[a.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(Ee[400],Se([1,0,104,22,207,21,19]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=e.$DE=e.$vE=e.DecodeStreamErrorKind=e.$uE=e.$tE=e.$sE=e.$qE=e.$pE=e.$oE=e.$nE=void 0,e.$rE=T,e.$wE=c,e.$xE=g,e.$yE=f,e.$zE=m,e.$AE=n,e.$BE=y,e.$CE=D,e.$nE="utf8",e.$oE="utf8bom",e.$pE="utf16be",e.$qE="utf16le";function T(S){return[e.$nE,e.$oE,e.$pE,e.$qE].some(I=>I===S)}e.$sE=[254,255],e.$tE=[255,254],e.$uE=[239,187,191];const $=512,l=512,C=512*8,E=512*128;var u;(function(S){S[S.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class P extends Error{constructor(I,k){super(I),this.decodeStreamErrorKind=k}}e.$vE=P;class p{static async create(I){let k;if(I!==e.$nE)k=(await(0,A.$mE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(m(I));else{const b=new TextDecoder;k={write(v){return b.decode(v,{stream:!0})},end(){return b.decode()}}}return new p(k)}constructor(I){this.a=I}write(I){return this.a.write(I)}end(){return this.a.end()}}function c(S,I){const k=I.minBytesRequiredForDetection??I.guessEncoding?C:l;return new Promise((b,v)=>{const N=(0,r.$ze)(W=>W.join("")),O=[];let F=0,j;const B=new R.$ue,M=async()=>{try{const W=await D({buffer:h.$Le.concat(O),bytesRead:F},I.guessEncoding,I.candidateGuessEncodings);if(W.seemsBinary&&I.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);W.encoding=await I.overwriteEncoding(W.encoding),j=await p.create(W.encoding);const _=j.write(h.$Le.concat(O).buffer);N.write(_),O.length=0,F=0,b({stream:N,detected:W})}catch(W){B.cancel(),N.destroy(),v(W)}};(0,r.$De)(S,{onData:async W=>{j?N.write(j.write(W.buffer)):(O.push(W),F+=W.byteLength,F>=k&&(S.pause(),await M(),setTimeout(()=>S.resume())))},onError:W=>N.error(W),onEnd:async()=>{j||await M(),N.end(j?.end())}},B.token)})}async function g(S,I,k){const v=(await(0,A.$mE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(m(I),k);let N=!1,O=!1;return{read(){if(O)return null;const F=S.read();if(typeof F!="string"){if(O=!0,!N&&k?.addBOM)switch(I){case e.$nE:case e.$oE:return h.$Le.wrap(Uint8Array.from(e.$uE));case e.$pE:return h.$Le.wrap(Uint8Array.from(e.$sE));case e.$qE:return h.$Le.wrap(Uint8Array.from(e.$tE))}const j=v.end();return j&&j.length>0?(N=!0,h.$Le.wrap(j)):null}return N=!0,h.$Le.wrap(v.write(F))}}}async function f(S){return(await(0,A.$mE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(m(S))}function m(S){return S===e.$oE||S===null?e.$nE:S}function n(S,I){if(!S||I<e.$sE.length)return null;const k=S.readUInt8(0),b=S.readUInt8(1);if(k===e.$sE[0]&&b===e.$sE[1])return e.$pE;if(k===e.$tE[0]&&b===e.$tE[1])return e.$qE;if(I<e.$uE.length)return null;const v=S.readUInt8(2);return k===e.$uE[0]&&b===e.$uE[1]&&v===e.$uE[2]?e.$oE:null}const o=["ascii","utf-16","utf-32"];async function i(S,I){const k=await(0,A.$mE)("jschardet","dist/jschardet.min.js"),b=S.slice(0,E),v=w(b.buffer);I&&(I=(0,L.$Ib)(I.map(F=>a(F))),I.length===0&&(I=void 0));const N=k.detect(v,I?{detectEncodings:I}:void 0);if(!N||!N.encoding)return null;const O=N.encoding.toLowerCase();return 0<=o.indexOf(O)?null:d(N.encoding)}const t={ibm866:"cp866",big5:"cp950"};function s(S){return S.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(S){const I=s(S);return t[I]||I}function a(S){const I=s(S);return e.$EE[I].guessableName}function w(S){let I="";for(let k=0;k<S.length;k++)I+=String.fromCharCode(S[k]);return I}function y(S){switch(S){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const I=S.match(/windows(\d+)/);return I?"windows-"+I[1]:S}}}function D({buffer:S,bytesRead:I},k,b){let v=n(S,I),N=!1;if(v!==e.$pE&&v!==e.$qE&&S){let O=!0,F=!0,j=!1;for(let B=0;B<I&&B<$;B++){const M=B%2===1,W=S.readUInt8(B)===0;if(W&&(j=!0),O&&(M&&!W||!M&&W)&&(O=!1),F&&(M&&W||!M&&!W)&&(F=!1),W&&!O&&!F)break}j&&(O?v=e.$qE:F?v=e.$pE:N=!0)}return k&&!N&&!v&&S?i(S.slice(0,I),b).then(O=>({seemsBinary:!1,encoding:O})):{seemsBinary:N,encoding:v}}e.$DE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$EE=(()=>{const S={};for(const I in e.$DE)e.$DE[I].guessableName&&(S[I]=e.$DE[I]);return S})()}),define(Ee[171],Se([1,0,400,34,170]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,h=Ue(h);class R extends A.$Aoc{constructor(T,$,l=h,C="searchProcess"){super({query:T,provider:$},{readdir:E=>l.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,r.$BE)(E)},C)}}e.$Mpc=R}),define(Ee[172],Se([1,0,58,415,399,19,79,39,13,2,38,100,416,397,130]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=void 0,e.$Hpc=t,e.$Ipc=d,e.$Jpc=w,e.$Kpc=y,e.$Lpc=S,r=Ue(r);const c=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(k,b){this.a=k,this.b=b}provideTextSearchResults(k,b,v,N){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((O,F)=>{N.onCancellationRequested(()=>J());const j={...b,numThreads:this.b},B=t(k,j),M=b.folder.fsPath,W=B.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${c} ${W}
 - cwd: ${M}`);let _=r.spawn(c,B,{cwd:M});_.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),F((0,C.$vL)(new C.$tL($e&&$e.message,C.SearchErrorCode.rgProcessError)))});let re=!1;const z=new n(b.maxResults,b.folder,b.previewOptions);z.on("result",$e=>{re=!0,ue="",v.report($e)});let G=!1;const J=()=>{G=!0,_?.kill(),z?.cancel()};let ee=!1;z.on("hitLimit",()=>{ee=!0,J()});let ue="";_.stdout.on("data",$e=>{z.handleData($e),re||(ue+=$e)});let ne=!1;_.stdout.once("data",()=>ne=!0);let De="";_.stderr.on("data",$e=>{const Q=$e.toString();this.a.appendLine(Q),De.length+Q.length<1e6&&(De+=Q)}),_.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),G)O({limitHit:ee});else{z.flush(),_=null;let $e;De&&!ne&&($e=f(De))?F((0,C.$vL)(new C.$tL($e.message,$e.code))):O({limitHit:ee})}})})}}e.$Fpc=g;function f(I){const k=I.split(`
`),b=k[0].trim();if(k.some(N=>N.startsWith("regex parse error")))return new C.$tL(m(k),C.SearchErrorCode.regexParseError);const v=b.match(/grep config error: unknown encoding: (.*)/);if(v)return new C.$tL(`Unknown encoding: ${v[1]}`,C.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new C.$tL(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new C.$tL(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new C.$tL(b,C.SearchErrorCode.regexParseError)}function m(I){const k=["Regex parse error"],b=I.filter(v=>v.startsWith("PCRE2:"));if(b.length>=1){const v=b[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const N=v.split(":")[1];k.push(":"+N)}}return k.join("")}class n extends h.EventEmitter{constructor(k,b,v){super(),this.g=k,this.h=b,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,b){return super.on(k,b),this}handleData(k){if(this.b)return;const b=typeof k=="string"?k:this.d.write(k);this.k(b)}k(k){let b=k.indexOf(`
`);const v=this.a+k;if(b>=0)b+=this.a.length;else{this.a=v;return}let N=0;for(;b>=0;)this.m(v.substring(N,b).trim()),N=b+1,b=v.indexOf(`
`,N);this.a=v.substring(N)}m(k){if(this.b||!k)return;let b;try{b=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(b.type==="match"){const v=o(b.data.path),N=l.URI.joinPath(this.h,v),O=this.n(b.data,N);this.p(O),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const v=o(b.data.path),N=l.URI.joinPath(this.h,v);this.o(b.data,N).forEach(F=>this.p(F))}}n(k,b){const v=k.line_number-1,N=o(k.lines),O=Buffer.from(N);let F=0,j=0,B=v;k.submatches.length===0&&k.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Ib)(k.submatches.map((W,_)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(W.match),z=O.slice(F,W.start).toString(),G=i(z),J=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=i(re),ue=G.numLines+B,ne=ee.numLines+ue,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+J;return F=W.end,j=De,B=ne,new E.$cL(ue,J,ne,De)}));return(0,p.$ypc)(b,N,M,this.j)}o(k,b){const v=o(k.lines),N=k.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((O,F)=>({text:O,uri:b,lineNumber:N+F}))}p(k){this.emit("result",k)}}e.$Gpc=n;function o(I){return I.bytes?Buffer.from(I.bytes,"base64").toString():I.text}function i(I){const k=/\n/g;let b=0,v=-1,N;for(;N=k.exec(I);)b++,v=N.index;const O=v>=0?I.length-v-1:I.length;return{numLines:b,lastLineLength:O}}function t(I,k){const b=["--hidden","--no-require-git"];b.push(I.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:N}=(0,L.$K)(k.includes,F=>F.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const F=new Set;N.forEach(j=>{F.add(j)}),b.push("-g","!*"),F.forEach(j=>{s(j).map(p.$xpc).forEach(B=>{b.push("-g",B)})})}v&&v.length&&v.forEach(F=>{b.push("-g",F)}),k.excludes.map(p.$xpc).forEach(F=>b.push("-g",`!${F}`)),k.maxFileSize&&b.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),k.followSymlinks&&b.push("--follow"),k.encoding&&k.encoding!=="utf8"&&b.push("--encoding",k.encoding),k.numThreads&&b.push("--threads",`${k.numThreads}`),I.pattern==="--"&&(I.isRegExp=!0,I.pattern="\\-\\-"),I.isMultiline&&!I.isRegExp&&(I.pattern=(0,$.$ff)(I.pattern),I.isRegExp=!0),k.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),I.isRegExp&&(I.pattern=d(I.pattern),b.push("--engine","auto"));let O;if(I.isWordMatch){const j=(0,$.$of)(I.pattern,!!I.isRegExp,{wholeWord:I.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",j)}else if(I.isRegExp){let F=w(I.pattern);F=y(F),b.push("--regexp",F)}else O=I.pattern,b.push("--fixed-strings");return b.push("--no-config"),k.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),I.isMultiline&&b.push("--multiline"),k.beforeContext&&b.push("--before-context",k.beforeContext+""),k.afterContext&&b.push("--after-context",k.afterContext+""),b.push("--"),O&&b.push(O),b.push("."),b}function s(I){return S(I).flatMap(b=>{const v=(0,T.$uk)(b,"/");return v.map((N,O)=>v.slice(0,O+1).join("/"))})}function d(I){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;I.match(k);)I=I.replace(k,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;I.match(b);)I=I.replace(b,"$1\\x{$2}");return I}const a=I=>I.type==="Assertion"&&I.kind==="lookbehind";function w(I){let k;try{k=new u.RegExpParser().parsePattern(I)}catch{return I}let b="",v=0;const N=(j,B,M)=>{b+=I.slice(v,j)+M,v=B},O=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const B=O[0];if(!B)N(j.start,j.end,"\\r?\\n");else if(!O.some(a))if(B.type==="CharacterClass")if(B.negate){const M=I.slice(B.start+2,j.start)+I.slice(j.end,B.end-1);B.parent?.type==="Quantifier"?N(B.start,B.end,M?`[^${M}]`:"."):N(B.start,B.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=I.slice(B.start+1,j.start)+I.slice(j.end,B.end-1);N(B.start,B.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else B.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){O.unshift(j)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(j){O.unshift(j)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(j){O.unshift(j)},onCharacterClassLeave(){O.shift()},onAssertionEnter(j){a(j)&&O.push(j)},onAssertionLeave(j){O[0]===j&&O.shift()}}).visit(k),b+=I.slice(v),b}function y(I){return I.replace(/\n/g,"\\r?\\n")}function D(I){let k=!1,b=!1,v="",N="";for(let O=0;O<I.length;O++){const F=I[O];switch(F){case"\\":b?(k?N+="\\"+F:v+="\\"+F,b=!1):b=!0;break;case"{":if(b)k?N+=F:v+=F,b=!1;else{if(k)return{strInBraces:v+"{"+N+"{"+I.substring(O+1)};k=!0}break;case"}":if(b)k?N+=F:v+=F,b=!1;else{if(k)return{fixedStart:v,strInBraces:N,fixedEnd:I.substring(O+1)};v+=F}break;default:k?N+=(b?"\\":"")+F:v+=(b?"\\":"")+F,b=!1;break}}return{strInBraces:v+(k?"{"+N:"")}}function S(I){const{fixedStart:k,strInBraces:b,fixedEnd:v}=D(I);if(k===void 0||v===void 0)return[b];let N=(0,T.$uk)(b,",");N.length||(N=[""]);const O=S(v);return N.flatMap(F=>{const j=k+F;return O.map(B=>j+B)})}}),define(Ee[401],Se([1,0,21,172,90,15]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0;class L{constructor(l,C){this.b=l,this.c=C,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(l,C,E,u){const P=await this.c(),p=new h.$Fpc(this.b,P),c={...C,numThreads:P};if(C.folder.scheme===R.Schemas.vscodeUserData){const g={...c,folder:C.folder.with({scheme:R.Schemas.file})},f=new A.$pw(m=>E.report({...m,uri:m.uri.with({scheme:C.folder.scheme})}));return this.d(u,m=>p.provideTextSearchResults(l,g,f,m))}else return this.d(u,g=>p.provideTextSearchResults(l,c,E,g))}async d(l,C){const E=T(l);this.a.add(E);const u=await C(E.token);return this.a.delete(E),u}e(){this.a.forEach(l=>l.cancel())}}e.$Ppc=L;function T($){const l=new r.$ue;return $.onCancellationRequested(()=>l.cancel()),l}}),define(Ee[402],Se([1,0,34,172,171]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0,r=Ue(r);class R{constructor($,l){this.a=$,this.b=l}search($,l,C){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(P){C({message:P})}},u=new A.$Mpc(this.a,new h.$Fpc(E,this.b),r);return new Promise((P,p)=>u.search(c=>{l(c.map(L))},$).then(c=>P({limitHit:c.limitHit??!1,type:"success",stats:c.stats,messages:[]}),p))}}e.$Npc=R;function L(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce(($,l)=>{if(l.ranges){const C=l;return $+(Array.isArray(C.ranges)?C.ranges.length:1)}else return $+1},0)}}}),define(Ee[403],Se([1,0,19,9,14,4,141,16,43,2,28,38,398,402]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0,r=Ue(r);class p{static{this.a=512}constructor(o="searchProcess",i){this.d=o,this.f=i,this.b=Object.create(null)}fileSearch(o){let i;const t=f(o),s=new R.$je({onDidAddFirstListener:()=>{i=(0,h.$ph)(async d=>{const a=await this.f?.();return this.doFileSearchWithEngine(u.$Epc,t,w=>s.fire(w),d,p.a,a)}),i.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}textSearch(o){let i;const t=f(o),s=new R.$je({onDidAddFirstListener:()=>{i=(0,h.$ph)(d=>this.g(t,a=>s.fire(a),d)),i.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}async g(o,i,t){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new P.$Npc(o,s).search(t,i,i)}h(){return{maxFileSize:16*C.$El.GB}}doFileSearch(o,i,t,s){return this.doFileSearchWithEngine(u.$Epc,o,t,s,p.a,i)}doFileSearchWithEngine(o,i,t,s,d=p.a,a){let w=0;const y=S=>{Array.isArray(S)?(w+=S.length,t(S.map(I=>this.j(I)))):S.relativePath?(w++,t(this.j(S))):t(S)};if(i.sortByScore){let S=this.n(i,y,s);if(!S){const I=i.maxResults?Object.assign({},i,{maxResults:null}):i,k=new o(I,a);S=this.k(k,i,t,y,s)}return new Promise((I,k)=>{S.then(([b,v])=>{const N=v.map(O=>this.j(O));this.q(N,t,d),I(b)},k)})}const D=new o(i,a);return this.s(D,y,d,s).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,T.$kc)(o.base,o.relativePath):o.relativePath}}k(o,i,t,s,d){const a=new R.$je;let w=(0,h.$ph)(D=>{let S=[];const I=k=>{Array.isArray(k)?S=k:(s(k),a.fire(k))};return this.s(o,I,-1,D).then(k=>[k,S])}),y;if(i.cacheKey){y=this.l(i.cacheKey);const D={promise:w,event:a.event,resolved:!1};y.resultsToSearchCache[i.filePattern||""]=D,w.then(()=>{D.resolved=!0},S=>{delete y.resultsToSearchCache[i.filePattern||""]}),w=this.t(w)}return w.then(([D,S])=>{const I=y?y.scorerCache:Object.create(null),k=(typeof i.maxResults!="number"||i.maxResults>0)&&$.$de.create(!1);return this.o(i,S,I,d).then(b=>{const v=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:b.length},messages:D.messages,limitHit:D.limitHit||typeof i.maxResults=="number"&&S.length>i.maxResults},b]})})}l(o){const i=this.b[o];return i||(this.b[o]=new c)}n(o,i,t){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const d=this.r(s,o.filePattern||"",i,t);if(d)return d.then(([a,w,y])=>{const D=$.$de.create(!1);return this.o(o,w,s.scorerCache,t).then(S=>{const I=D.elapsed(),k={fromCache:!0,detailStats:y,type:this.d,resultCount:w.length,sortingTime:I};return[{type:"success",limitHit:a.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:k,messages:[]},S]})})}o(o,i,t,s){const d=(0,L.$Ir)(o.filePattern||""),a=(y,D)=>(0,L.$Hr)(y,D,d,!0,g,t),w=typeof o.maxResults=="number"?o.maxResults:E.$iL;return r.$Hb(i,a,w,1e4,s)}q(o,i,t){if(t&&t>0)for(let s=0;s<o.length;s+=t)i(o.slice(s,s+t));else i(o)}r(o,i,t,s){const d=$.$de.create(!1),a=i.indexOf(T.sep)>=0;let w;for(const I in o.resultsToSearchCache)if(i.startsWith(I)){if(a&&I.indexOf(T.sep)<0&&I!=="")continue;const k=o.resultsToSearchCache[I];w={promise:this.t(k.promise),event:k.event,resolved:k.resolved};break}if(!w)return null;const y=d.elapsed(),D=$.$de.create(!1),S=w.event(t);return s&&s.onCancellationRequested(()=>{S.dispose()}),w.promise.then(([I,k])=>{if(s&&s.isCancellationRequested)throw(0,A.$7)();const b=[],v=(0,L.$Ir)(i).normalizedLowercase;for(const N of k)(0,E.$zL)(N,v)&&b.push(N);return[I,b,{cacheWasResolved:w.resolved,cacheLookupTime:y,cacheFilterTime:D.elapsed(),cacheEntryCount:k.length}]})}s(o,i,t,s){return new Promise((d,a)=>{let w=[];s?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(t?(w.push(y),t>0&&w.length>=t&&(i(w),w=[])):i(y))},y=>{i(y)},(y,D)=>{w.length&&i(w),y?(i({message:"Search finished. Error: "+y.message}),a(y)):(i({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return o.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return o.finally(i)}}}}e.$Opc=p;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(n){return(0,T.$oc)(n.relativePath)}getItemDescription(n){return(0,T.$nc)(n.relativePath)}getItemPath(n){return n.relativePath}};function f(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>l.URI.revive(o))}}function m(n){return{...n,folder:l.URI.revive(n.folder)}}}),define(Ee[404],Se([1,0,3,15,2,34,12,42,30,20,103,73,38,403,401,130,171]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,R=Ue(R);let f=class extends C.$Foc{constructor(n,o,i,t,s){super(n,i,s),this.D=t,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Uc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new c.$zpc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new p.$Ppc(d,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),t.getConfigProvider().then(a=>{this.C||this.B.add(a.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new c.$zpc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new p.$Ppc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new P.$Opc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const i=this.d++;return this.y=o,this.x=i,this.c.$registerFileSearchProvider(i,this.s(n)),(0,r.$Tc)(()=>{this.y=null,this.c.$unregisterProvider(i)})}$provideFileSearchResults(n,o,i,t){const s=(0,C.$Goc)(i);if(n===this.x){const d=Date.now();return this.H(n,o,s,t).then(a=>{const w=Date.now()-d;return this.q.debug(`Ext host file search time: ${w}ms`),a})}return super.$provideFileSearchResults(n,o,i,t)}async doInternalFileSearchWithCustomCallback(n,o,i){const t=d=>{if((0,u.$yL)(d)&&(d=[d]),Array.isArray(d)){i(d.map(a=>A.URI.file(a.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,t,o)}async H(n,o,i,t){return this.doInternalFileSearchWithCustomCallback(i,t,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new g.$Mpc(n,o,void 0,"textSearchProvider")}};e.$Qpc=f,e.$Qpc=f=Ye([qe(0,l.$sP),qe(1,$.$IP),qe(2,E.$rnc),qe(3,T.$xnc),qe(4,L.$9j)],f)}),define(Ee[131],Se([1,0,417,67,68,418,22,14,4,3,16,11,32,87,69]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=d,e.$vi=a,e.$xi=D,e.$yi=S;class c{traceSocketEvent(k,b){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,b)}constructor(k,b=""){this.f=!0,this.debugLabel=b,this.socket=k,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=v=>{if(this.traceSocketEvent(p.SocketDiagnosticsEventType.Error,{code:v?.code,message:v?.message}),v){if(v.code==="EPIPE")return;(0,T.$2)(v)}},this.socket.on("error",this.a),this.b=v=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Close,{hadError:v}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const b=v=>{this.traceSocketEvent(p.SocketDiagnosticsEventType.Read,v),k(L.$Le.wrap(v))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(k){const b=v=>{k({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:v,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(k){const b=()=>{k()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(p.SocketDiagnosticsEventType.Write,k),this.socket.write(k.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,T.$2)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,T.$2)(b)}}end(){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((k,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),k();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),this.traceSocketEvent(p.SocketDiagnosticsEventType.NodeDrainEnd),k()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.$ri=c;var g;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var f;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(f||(f={}));class m extends l.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,b){this.socket.traceSocketEvent(k,b)}constructor(k,b,v,N){super(),this.f=this.B(new $.$je),this.g=this.B(new $.$je),this.h=!1,this.j={state:f.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent(p.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:v?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,b,v,N,this.f,(O,F)=>this.m(O,F))),this.B(this.a.onError(O=>{console.error(O),(0,T.$2)(O),this.g.fire({type:p.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new p.$mi,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let b=0;for(;b<k.byteLength;)this.a.writeMessage(k.slice(b,Math.min(b+g.MaxWebSocketMessageLength,k.byteLength)),{compressed:!0,opcode:2}),b+=g.MaxWebSocketMessageLength}m(k,{compressed:b,opcode:v}){if(this.h)return;this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,k);let N=g.MinHeaderByteSize;k.byteLength<126?N+=0:k.byteLength<2**16?N+=2:N+=8;const O=L.$Le.alloc(N),F=b?64:0,j=v&15;if(O.writeUInt8(128|F|j,0),k.byteLength<126)O.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){O.writeUInt8(126,1);let B=1;O.writeUInt8(k.byteLength>>>8&255,++B),O.writeUInt8(k.byteLength>>>0&255,++B)}else{O.writeUInt8(127,1);let B=1;O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(k.byteLength>>>24&255,++B),O.writeUInt8(k.byteLength>>>16&255,++B),O.writeUInt8(k.byteLength>>>8&255,++B),O.writeUInt8(k.byteLength>>>0&255,++B)}this.socket.write(L.$Le.concat([O,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const b=this.b.peek(this.j.readLen),v=b.readUInt8(0),N=(v&128)>>>7,O=(v&64)>>>6,F=v&15,j=b.readUInt8(1),B=(j&128)>>>7,M=j&127;this.j.state=f.ReadHeader,this.j.readLen=g.MinHeaderByteSize+(B?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const b=this.b.read(this.j.readLen),v=b.readUInt8(1),N=(v&128)>>>7;let O=v&127,F=1;O===126?O=b.readUInt8(++F)*2**8+b.readUInt8(++F):O===127&&(O=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let j=0;N&&(j=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this.j.state=f.ReadBody,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const b=this.b.read(this.j.readLen);this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,b),t(b,this.j.mask),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,b),this.j.state=f.PeekHeader,this.j.readLen=g.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(b,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(p.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=m;class n extends l.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Le.alloc(0)}constructor(k,b,v,N,O,F){super(),this.n=k,this.r=O,this.s=F,this.a=this.B(new $.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new o(this.n,N,v,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(k,b){this.g.push({data:k,options:b}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:b}=this.g.shift();if(this.f&&b.compressed){const v=await this.w(this.f,k);this.s(v,b)}else this.s(k,{...b,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,b){return new Promise((v,N)=>{k.write(b),k.flush(O=>v(O))})}acceptFrame(k,b,v){this.h.push({data:k,isCompressed:b,isLastFrameOfMessage:v}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const b=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,b,v){return new Promise((N,O)=>{k.write(b),v&&k.write(L.$Le.fromByteArray([0,0,255,255])),k.flush(F=>N(F))})}}class o extends l.$Vc{get recordedInflateBytes(){return this.j?L.$Le.concat(this.f):L.$Le.alloc(0)}constructor(k,b,v,N){super(),this.h=k,this.j=b,this.a=this.B(new $.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Le.wrap(O))}),v&&(this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialWrite,v.buffer),this.b.write(v.buffer),this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateWrite,k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent(p.SocketDiagnosticsEventType.zlibInflateFlushFired);const b=L.$Le.concat(this.g);this.g.length=0,k(b)})}}class i extends l.$Vc{constructor(k,b){super(),this.g=k,this.a=this.B(new $.$je),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",v=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateError,{message:v?.message,code:v?.code}),this.a.fire(v)}),this.b.on("data",v=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateData,v),this.f.push(L.$Le.wrap(v))})}write(k){this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateWrite,k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent(p.SocketDiagnosticsEventType.zlibDeflateFlushFired);let b=L.$Le.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),k(b)})}}function t(I,k){if(k===0)return;const b=I.byteLength>>>2;for(let B=0;B<b;B++){const M=I.readUInt32BE(B*4);I.writeUInt32BE(M^k,B*4)}const v=b*4,N=I.byteLength-v,O=k>>>24&255,F=k>>>16&255,j=k>>>8&255;N>=1&&I.writeUInt8(I.readUInt8(v)^O,v),N>=2&&I.writeUInt8(I.readUInt8(v+1)^F,v+1),N>=3&&I.writeUInt8(I.readUInt8(v+2)^j,v+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const s={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function d(){const I=(0,u.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const k=process.platform!=="darwin"&&e.$ti?e.$ti:(0,A.tmpdir)(),b=(0,C.$kc)(k,`vscode-ipc-${I}.sock`);return w(b),b}function a(I,k,b){const N=(0,r.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${b}-${k}-sock`;const O=b.substr(0,4),F=k.substr(0,6);let j;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?j=(0,C.$kc)(e.$ti,`vscode-${N}-${O}-${F}.sock`):j=(0,C.$kc)(I,`${O}-${F}.sock`),w(j),j}function w(I){const k=s[E.$u];typeof k=="number"&&I.length>=k&&console.warn(`WARNING: IPC handle "${I}" is longer than ${k} chars, try a shorter --user-data-dir`)}class y extends P.$gi{static b(k){const b=$.Event.fromNodeEventEmitter(k,"connection");return $.Event.map(b,v=>({protocol:new p.$ni(new c(v,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(v,"close"))}))}constructor(k){super(y.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=y;function D(I){return new Promise((k,b)=>{const v=(0,h.createServer)();v.on("error",b),v.listen(I,()=>{v.removeListener("error",b),k(new y(v))})})}function S(I,k){return new Promise((b,v)=>{const N=(0,h.createConnection)(I,()=>{N.removeListener("error",v),b(p.$oi.fromSocket(new c(N,`ipc-client${k}`),k))});N.once("error",v)})}}),define(Ee[405],Se([1,0,67,68,187,131,9,3,11,45,12,116,284,285,118,93,22]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=e.$Cfc=void 0,r=Ue(r),h=Ue(h);async function f(t,s,d,a,w){let y;for(let D=3;D&&(y?.dispose(),y=await new m(t,s,d,a,w).waitForReady(),!(w&&A.$2g[w]||!A.$2g[y.tunnelLocalPort]));D--);return y}class m extends T.$Vc{constructor(s,d,a,w,y){super(),this.m=d,this.n=y,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new L.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,c.$Cw)(this.m)?"0.0.0.0":"127.0.0.1";let a=await(0,A.$3g)(s,2,1e3,d),w=null;return this.b.listen(a,this.m),await this.c.wait(),w=this.b.address(),w||(a=0,this.b.listen(a,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(s){s.pause();const d=(0,c.$Aw)(this.tunnelRemoteHost)||(0,c.$Cw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,u.$Yl)(this.a,d,this.tunnelRemotePort),w=a.getSocket(),y=a.readEntireBuffer();a.dispose(),y.byteLength>0&&s.write(y.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),w.end()}),s.on("close",()=>w.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),w instanceof R.$ri?w.socket.destroy():w.end()}),w instanceof R.$ri?this.t(s,w):this.s(s,w),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),w.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(a=>s.write(a.buffer)),s.on("data",a=>d.write(g.$Le.wrap(a))),s.resume()}t(s,d){const a=d.socket;a.on("end",()=>s.end()),a.on("close",()=>s.end()),a.on("error",()=>{s.destroy()}),a.pipe(s),s.pipe(a)}}e.$Cfc=m;let n=class extends c.$Fw{constructor(s,d,a,w,y){super(d,y),this.H=s,this.I=a,this.J=w}isPortPrivileged(s){return(0,c.$Dw)(s,this.t,$.OS,h.release())}F(s,d,a,w,y,D,S,I){const k=this.D(d,a);if(k)return++k.refcount,k.value;if((0,c.$ww)(s))return this.G(s,d,a,y,D,S,I);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${a} on local port ${y}.`);const b={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(b,w,d,a,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,a,v),v}}};e.$Dfc=n,e.$Dfc=n=Ye([qe(0,P.$Sl),qe(1,C.$9j),qe(2,p.$Vl),qe(3,E.$pk),qe(4,l.$9i)],n);let o=class extends n{constructor(s,d,a,w,y){super(s,d,a,w,y)}};e.$Efc=o,e.$Efc=o=Ye([qe(0,P.$Sl),qe(1,C.$9j),qe(2,p.$Vl),qe(3,E.$pk),qe(4,l.$9i)],o);let i=class extends T.$Vc{constructor(s,d,a,w,y){super(),this.b=s,this.c=d,this.f=a,this.g=w,this.h=y,this.a=new Map}async openTunnel(s,d,a,w,y,D,S,I,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${w} on local port ${D}.`),!this.a.has(s)){const b=new o(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(s,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,a,w,y,D,S,I,k)}};e.$Ffc=i,e.$Ffc=i=Ye([qe(0,P.$Sl),qe(1,C.$9j),qe(2,E.$pk),qe(3,p.$Vl),qe(4,l.$9i)],i)}),define(Ee[406],Se([1,0,131,302,61,35,2,12,46]),function(ce,e,r,h,A,R,L,T,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=e.$TP=void 0,h=Ue(h),A=Ue(A);class l{constructor(u,P,p){this.b=u,this.c=P,this.f=p,this.a=h.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(P.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,P){const p=(g,f)=>{P.writeHead(g,{"content-type":"application/json"}),P.end(JSON.stringify(f||null),m=>m&&this.c.error(m))},c=[];u.setEncoding("utf8"),u.on("data",g=>c.push(g)),u.on("end",async()=>{try{const g=JSON.parse(c.join(""));let f;switch(g.type){case"open":f=await this.i(g);break;case"openExternal":f=await this.j(g);break;case"status":f=await this.l(g);break;case"extensionManagement":f=await this.k(g);break;default:p(404,`Unknown message type: ${g.type}`);break}p(200,f)}catch(g){const f=g instanceof Error?g.message:JSON.stringify(g);p(500,f),this.c.error("Error while processing pipe request",g)}})}async i(u){const{fileURIs:P,folderURIs:p,forceNewWindow:c,diffMode:g,mergeMode:f,addMode:m,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:i,remoteAuthority:t}=u,s=[];if(Array.isArray(p))for(const y of p)try{s.push({folderUri:L.URI.parse(y)})}catch{}if(Array.isArray(P))for(const y of P)try{(0,$.$8i)(y)?s.push({workspaceUri:L.URI.parse(y)}):s.push({fileUri:L.URI.parse(y)})}catch{}const d=i?L.URI.file(i):void 0,w={forceNewWindow:c,diffMode:g,mergeMode:f,addMode:m,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!m,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,w)}async j(u){for(const P of u.uris){const p=L.URI.parse(P),c=p.scheme==="file"?p:P;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(u){const P=c=>c?.map(g=>/\.vsix$/i.test(g)?L.URI.parse(g):g),p={list:u.list,install:P(u.install),uninstall:P(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$TP=l;let C=class extends l{constructor(u,P){super(u,P,(0,r.$ui)())}};e.$UP=C,e.$UP=C=Ye([qe(0,R.$OP),qe(1,T.$9j)],C)}),define(Ee[407],Se([1,0,62,394,389,301,52,376,2,15,10,406,111,337,375]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=void 0,r=Ue(r);class c extends A.$kpc{j(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,a,w){return d=t(d),m.a.has(d)?m.a.get(d).load(d,$.URI.file((0,u.$fr)(a.filename)),y=>o.apply(this,[y,a,w])):o.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>i.call(this,t(s),d);const t=s=>{for(const d of m.b){const a=d(s);if(a){s=a;break}}return s}}}class g extends L.$0nc{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$Tpc);const m=this.h.invokeFunction(h.$gpc);if(this.h.createInstance(T.$Spc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(E.$UP);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(p.$Upc),await this.h.createInstance(c,m,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,R.$Rpc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(m){return m.main}async xb(m,n,o){if(n.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=m?.identifier.value;m&&await this.w.initializeLocalizedMessages(m);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=ce.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return i}async $setRemoteEnvironment(m){if(this.f.remote.isRemote)for(const n in m){const o=m[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Vpc=g}),define(Ee[408],Se([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,405,30,20,77,383]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4pc=void 0,e.$Wpc=t,e.$Xpc=s,e.$Ypc=d,e.$Zpc=a,e.$1pc=y,e.$2pc=D,e.$3pc=S,$=Ue($),C=Ue(C);function t(b){const v=b.trim().split(`
`),N=[];return v.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&N.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),N.reduce((F,j)=>(F[j.socket]=j,F),{})}function s(...b){const v=[].concat(...b.map(a));return[...new Map(v.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:d(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function d(b){let v="";if(b.length===8)for(let N=b.length-2;N>=0;N-=2)v+=parseInt(b.substr(N,2),16),N!==0&&(v+=".");else for(let N=0;N<b.length;N+=8){const O=b.substring(N,N+8);let F="";for(let j=8;j>=2;j-=2)F+=O.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),v+=`${F}`,F="",N+j!==b.length-6&&(v+=":"))}return v}function a(b){const v=b.trim().split(`
`),N=v.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return v.map(F=>F.trim().split(/\s+/).reduce((j,B,M)=>(j[N[M]||M]=B,j),{}))}function w(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function y(b){const v=b.trim().split(`
`),N=[];return v.forEach(O=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);F&&F.length>=4&&N.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),N}async function D(b,v,N){const O=N.reduce((j,B)=>(j[B.pid]=B,j),{}),F=[];return b.forEach(({socket:j,ip:B,port:M})=>{const W=v[j]?v[j].pid:void 0,_=W?O[W]?.cmd:void 0;W&&_&&!w(_)&&F.push({host:B,port:M,detail:_,pid:W})}),F}function S(b,v,N){const O=new Map,F=y(v);for(const j of b){const B=N.get(j.port);if(B){O.set(j.port,B);continue}const M=F.find(W=>W.cmd.includes(`${j.port}`));if(M){let W=M,_;do _=F.find(re=>re.ppid===W.pid),_&&(W=_);while(_);O.set(j.port,{host:j.ip,port:j.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else O.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return O}let I=class extends o.$3Eb{constructor(v,N,O,F){super(v,N,O),this.D=N,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,T.$k&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new L.$Km;let F=0;for(;this.C;){const j=new Date().getTime(),B=(await this.I()).filter(_=>(0,g.$Aw)(_.host)||(0,g.$Cw)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(_=>_.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),F++>3&&O.update(M),(!N||JSON.stringify(N)!==JSON.stringify(B))&&(N=B,await this.a.$onFoundNewCandidates(N));const W=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${W} ms.`),await new Promise(_=>setTimeout(()=>_(),W))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",N="";try{v=await C.Promises.readFile("/proc/net/tcp","utf8"),N=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=s(v,N),F=await new Promise(G=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(J,ee,ue)=>{G(ee)})}),j=t(F),B=await C.Promises.readdir("/proc"),M=[];for(const G of B)try{const J=Number(G),ee=$.$dh(l.URI.file("/proc"),G);if((await C.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(J)){const ne=await C.Promises.readlink($.$dh(ee,"cwd").fsPath),De=await C.Promises.readFile($.$dh(ee,"cmdline").fsPath,"utf8");M.push({pid:J,cwd:ne,cmd:De})}}catch{}const W=[],_=O.filter(G=>{const J=j[G.socket];return J||W.push(G),J}),re=D(_,j,M);let z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const G=await new Promise(J=>{(0,r.exec)("ps -F -A -l | grep root",(ee,ue,ne)=>{J(ue)})});this.z=S(W,G,this.z),z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.map(J=>J.port).join(", ")}`)}return re.then(G=>z?G.concat(z):G)}w(v){return async N=>{const O=new f.$Cfc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,B,M,W){const _=await v.makeConnection();return k.connect(_,B,M,W)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new p.$Ol(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const F=new A.$je;return{localAddress:(0,i.$mM)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{O.dispose(),F.fire(),F.dispose()}}}}};e.$4pc=I,e.$4pc=I=Ye([qe(0,n.$sP),qe(1,m.$IP),qe(2,u.$9j),qe(3,c.$Vl)],I);class k extends P.$owb{static connect(v,N,O,F){const j=new R.$Uc,B={onClose:j.add(new A.$je),onData:j.add(new A.$je),onEnd:j.add(new A.$je)};j.add(v.onDidReceiveMessage(W=>B.onData.fire(h.$Le.wrap(W)))),j.add(v.onDidEnd(()=>B.onEnd.fire())),j.add(v.onDidClose(W=>B.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:W,hadError:!!W})));const M=new k(v,F,B);return M.B(j),(0,P.$nwb)(M,N,O,F,B)}constructor(v,N,O){super(N,O),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[409],Se([1,0,89,378,392,391,404,407,408,102,52,103,101,47,77,98,377,338,12,393,65,297,113,118,148]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f,m,n,o,i,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Is)(C.$$nc,T.$Vpc,r.InstantiationType.Eager),(0,r.$Is)(m.$0j,f.$6pc,r.InstantiationType.Delayed),(0,r.$Is)(m.$9j,new t.$zi(i.$jpc,[!1],!0)),(0,r.$Is)(s.$Vl,d.$Hfc,r.InstantiationType.Delayed),(0,r.$Is)(c.$Anc,g.$5pc,r.InstantiationType.Eager),(0,r.$Is)(l.$ioc,R.$wpc,r.InstantiationType.Eager),(0,r.$Is)(E.$Eoc,L.$Qpc,r.InstantiationType.Eager),(0,r.$Is)(u.$7oc,A.$opc,r.InstantiationType.Eager),(0,r.$Is)(P.$Vnc,h.$npc,r.InstantiationType.Eager),(0,r.$Is)(p.$2Eb,$.$4pc,r.InstantiationType.Eager),(0,r.$Is)(o.$boc,n.$7pc,r.InstantiationType.Eager)});var Wt=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[419],Se([1,0,420,67,9,22,14,62,111,34,69,131,114,281,390,303,319,94,395,409]),function(ce,e,r,h,A,R,L,T,$,l,C,E,u,P,p,c,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Wt(r),h=Ue(h),T=Ue(T),P=Wt(P),function(){for(let D=0;D<process.execArgv.length;D++)process.execArgv[D]==="--inspect-port=0"&&(process.execArgv.splice(D,1),D--)}();const m=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,D=y._load;y._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return D.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function i(y){process.exit=function(D){if(y)n(D);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const D=new Error("An extension called process.crash() and this was prevented.");console.warn(D.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(D,S){D==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),o(D,S)}}let t=function(y){n()};function s(){const y=(0,g.$cn)(process.env);if(y.type===g.ExtHostConnectionType.MessagePort)return new Promise((D,S)=>{const I=k=>{const b=k[0],v=new C.$pi;b.on("message",N=>v.fire(R.$Le.wrap(N.data))),b.on("close",()=>{t("renderer closed the MessagePort")}),b.start(),D({onMessage:v.event,send:N=>b.postMessage(N.buffer)})};process.parentPort.on("message",k=>I(k.ports))});if(y.type===g.ExtHostConnectionType.Socket)return new Promise((D,S)=>{let I=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=C.ProtocolConstants.ReconnectionGraceTime,v=C.ProtocolConstants.ReconnectionShortGraceTime,N=new A.$Ph(()=>t("renderer disconnected for too long (1)"),b),O=new A.$Ph(()=>t("renderer disconnected for too long (2)"),v);process.on("message",(j,B)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const M=R.$Le.wrap(Buffer.from(j.initialDataChunk,"base64"));let W;if(j.skipWebSocketFrames)W=new E.$ri(B,"extHost-socket");else{const _=R.$Le.wrap(Buffer.from(j.inflateBytes,"base64"));W=new E.$si(new E.$ri(B,"extHost-socket"),j.permessageDeflate,_,!1)}I?(N.cancel(),O.cancel(),I.beginAcceptReconnection(W,M),I.endAcceptReconnection(),I.sendResume()):(clearTimeout(k),I=new C.$qi({socket:W,initialChunk:M}),I.sendResume(),I.onDidDispose(()=>t("renderer disconnected")),D(I),I.onSocketClose(()=>{N.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;N.isScheduled()&&O.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const D=y.pipeName;return new Promise((S,I)=>{const k=h.createConnection(D,()=>{k.removeListener("error",I);const b=new C.$qi({socket:new E.$ri(k,"extHost-renderer")});b.sendResume(),S(b)});k.once("error",I),k.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const y=await s();return new class{constructor(){this.a=new C.$pi,this.onMessage=this.a.event,this.b=!1,this.d=y.onMessage(D=>{(0,f.$wn)(D,f.MessageType.Terminate)?(this.b=!0,this.d.dispose(),t("received terminate message from renderer")):this.a.fire(D)})}send(D){this.b||y.send(D)}async drain(){if(y.drain)return y.drain()}}}function a(y){return new Promise(D=>{const S=y.onMessage(I=>{S.dispose();const k=JSON.parse(I.toString()),b=k.commit,v=P.default.commit;if(b&&v&&b!==v&&n(f.ExtensionHostExitCode.VersionMismatch),k.parentPid){let N=0;setInterval(function(){try{process.kill(k.parentPid,0),N=0}catch(F){F&&F.code==="EPERM"?(N++,N>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(k.parentPid)}catch(F){(0,L.$2)(F)}}y.send((0,f.$vn)(f.MessageType.Initialized)),D({protocol:y,initData:k})});y.send((0,f.$vn)(f.MessageType.Ready))})}async function w(){const y=[];process.on("unhandledRejection",(N,O)=>{y.push(O),setTimeout(()=>{const F=y.indexOf(O);F>=0&&O.catch(j=>{y.splice(F,1),(0,L.$5)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),N&&(0,L.$2)(N))})},1e3)}),process.on("rejectionHandled",N=>{const O=y.indexOf(N);O>=0&&y.splice(O,1)}),process.on("uncaughtException",function(N){(0,L.$1)(N)||(0,L.$2)(N)}),T.mark("code/extHost/willConnectToRenderer");const D=await d();T.mark("code/extHost/didConnectToRenderer");const S=await a(D);T.mark("code/extHost/didWaitForInitData");const{initData:I}=S;i(!!I.environment.extensionTestsLocationURI),I.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,I.environment.skipWorkspaceStorageLock=(0,u.boolean)(m.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(O){n(O)}fsExists(O){return l.Promises.exists(O)}fsRealpath(O){return(0,$.$er)(O)}};let b=null;I.remote.authority&&m.transformURIs&&(b=(0,c.$Ms)(I.remote.authority));const v=new p.$mpc(S.protocol,I,k,b);t=N=>v.terminate(N)}w().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/6facfe23b300eb448c35d07291cad7ad98625302/core/vs/workbench/api/node/extensionHostProcess.js.map
