/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],w=0,C=oe.length;w<C;w++)e[w]=Ce[oe[w]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=C,e.$8h=P,e.$9h=O;function w(A){return(M,p,c)=>{let R=null,v=null;if(typeof c.value=="function"?(R="value",v=c.value):typeof c.get=="function"&&(R="get",v=c.get),!v)throw new Error("not supported");c[R]=A(v,p)}}function C(A,M,p){let c=null,R=null;if(typeof p.value=="function"?(c="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",R=p.get),!R)throw new Error("not supported");const v=`$memoize$${M}`;p[c]=function(...u){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[v]}}function P(A,M,p){return w((c,R)=>{const v=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[v]),M&&(this[u]=M(this[u],...E),E=[this[u]]),this[v]=setTimeout(()=>{c.apply(this,E),this[u]=p?p():void 0},A)}})}function O(A,M,p){return w((c,R)=>{const v=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...r){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),M&&(this[u]=M(this[u],...r)),this[d])return;const o=this[E]+A;o<=Date.now()?(this[E]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[v]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0},o-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,w,C){C===void 0&&(C=w);var P=Object.getOwnPropertyDescriptor(e,w);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(oe,C,P)}:function(oe,e,w,C){C===void 0&&(C=w),oe[C]=e[w]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var w in oe)w!=="default"&&Object.prototype.hasOwnProperty.call(oe,w)&&Bn(e,oe,w);return Wn(e,oe),e};define(Ce[134],Ie([1,0,18]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=P,e.$9c=O,e.$0c=A,e.$$c=M,e.$_c=p,e.$ad=c,w=qe(w);const C=(E,d)=>E===d;e.$7c=C;function P(E=e.$7c){return(d,r)=>w.$vb(d,r,E)}function O(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function M(E,d,r){if(r!==void 0){const o=E;return o==null||d===void 0||d===null?d===o:r(o,d)}else{const o=E;return(a,h)=>a==null||h===void 0||h===null?h===a:o(a,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],d[r]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=E,o=d,a=Object.keys(r),h=Object.keys(o),i=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!i.has(s)||!p(r[s],o[s]))return!1;return!0}return!1}function c(E){return JSON.stringify(u(E))}let R=0;const v=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=u(d[o]);return r}else{let d=v.get(E);return d===void 0&&(d=R++,v.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(Ce[97],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=e.$xP=void 0;class w{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$xP=w,e.$yP=new w("id#")}),define(Ce[135],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Qn=A,e.$Rn=v,e.$Sn=u,e.$Tn=E,e.$Un=d,e.$Vn=r,e.$Wn=o,e.$Xn=a,e.$Yn=h,e.$Zn=i,e.$1n=s,e.$2n=n;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,m=!1){let f=0;const l=t.length;let $="",I=0,D=C.Unknown,y=w.None;function S(G){let W=0,N=0;for(;W<G;){const V=t.charCodeAt(f);if(V>=R._0&&V<=R._9)N=N*16+V-R._0;else if(V>=R.A&&V<=R.F)N=N*16+V-R.A+10;else if(V>=R.a&&V<=R.f)N=N*16+V-R.a+10;else break;f++,W++}return W<G&&(N=-1),N}function k(G){f=G,$="",I=0,D=C.Unknown,y=w.None}function g(){const G=f;if(t.charCodeAt(f)===R._0)f++;else for(f++;f<t.length&&c(t.charCodeAt(f));)f++;if(f<t.length&&t.charCodeAt(f)===R.dot)if(f++,f<t.length&&c(t.charCodeAt(f)))for(f++;f<t.length&&c(t.charCodeAt(f));)f++;else return y=w.UnexpectedEndOfNumber,t.substring(G,f);let W=f;if(f<t.length&&(t.charCodeAt(f)===R.E||t.charCodeAt(f)===R.e))if(f++,(f<t.length&&t.charCodeAt(f)===R.plus||t.charCodeAt(f)===R.minus)&&f++,f<t.length&&c(t.charCodeAt(f))){for(f++;f<t.length&&c(t.charCodeAt(f));)f++;W=f}else y=w.UnexpectedEndOfNumber;return t.substring(G,W)}function b(){let G="",W=f;for(;;){if(f>=l){G+=t.substring(W,f),y=w.UnexpectedEndOfString;break}const N=t.charCodeAt(f);if(N===R.doubleQuote){G+=t.substring(W,f),f++;break}if(N===R.backslash){if(G+=t.substring(W,f),f++,f>=l){y=w.UnexpectedEndOfString;break}switch(t.charCodeAt(f++)){case R.doubleQuote:G+='"';break;case R.backslash:G+="\\";break;case R.slash:G+="/";break;case R.b:G+="\b";break;case R.f:G+="\f";break;case R.n:G+=`
`;break;case R.r:G+="\r";break;case R.t:G+="	";break;case R.u:{const ce=S(4);ce>=0?G+=String.fromCharCode(ce):y=w.InvalidUnicode;break}default:y=w.InvalidEscapeCharacter}W=f;continue}if(N>=0&&N<=31)if(p(N)){G+=t.substring(W,f),y=w.UnexpectedEndOfString;break}else y=w.InvalidCharacter;f++}return G}function L(){if($="",y=w.None,I=f,f>=l)return I=l,D=C.EOF;let G=t.charCodeAt(f);if(M(G)){do f++,$+=String.fromCharCode(G),G=t.charCodeAt(f);while(M(G));return D=C.Trivia}if(p(G))return f++,$+=String.fromCharCode(G),G===R.carriageReturn&&t.charCodeAt(f)===R.lineFeed&&(f++,$+=`
`),D=C.LineBreakTrivia;switch(G){case R.openBrace:return f++,D=C.OpenBraceToken;case R.closeBrace:return f++,D=C.CloseBraceToken;case R.openBracket:return f++,D=C.OpenBracketToken;case R.closeBracket:return f++,D=C.CloseBracketToken;case R.colon:return f++,D=C.ColonToken;case R.comma:return f++,D=C.CommaToken;case R.doubleQuote:return f++,$=b(),D=C.StringLiteral;case R.slash:{const W=f-1;if(t.charCodeAt(f+1)===R.slash){for(f+=2;f<l&&!p(t.charCodeAt(f));)f++;return $=t.substring(W,f),D=C.LineCommentTrivia}if(t.charCodeAt(f+1)===R.asterisk){f+=2;const N=l-1;let V=!1;for(;f<N;){if(t.charCodeAt(f)===R.asterisk&&t.charCodeAt(f+1)===R.slash){f+=2,V=!0;break}f++}return V||(f++,y=w.UnexpectedEndOfComment),$=t.substring(W,f),D=C.BlockCommentTrivia}return $+=String.fromCharCode(G),f++,D=C.Unknown}case R.minus:if($+=String.fromCharCode(G),f++,f===l||!c(t.charCodeAt(f)))return D=C.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return $+=g(),D=C.NumericLiteral;default:for(;f<l&&T(G);)f++,G=t.charCodeAt(f);if(I!==f){switch($=t.substring(I,f),$){case"true":return D=C.TrueKeyword;case"false":return D=C.FalseKeyword;case"null":return D=C.NullKeyword}return D=C.Unknown}return $+=String.fromCharCode(G),f++,D=C.Unknown}}function T(G){if(M(G)||p(G))return!1;switch(G){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function q(){let G;do G=L();while(G>=C.LineCommentTrivia&&G<=C.Trivia);return G}return{setPosition:k,getPosition:()=>f,scan:m?q:L,getToken:()=>D,getTokenValue:()=>$,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>y}}function M(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function c(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function v(t,m){const f=[],l=new Object;let $;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function y(S,k,g,b){I.value=S,I.offset=k,I.length=g,I.type=b,I.colonOffset=void 0,$=I}try{i(t,{onObjectBegin:(S,k)=>{if(m<=S)throw l;$=void 0,D=m>S,f.push("")},onObjectProperty:(S,k,g)=>{if(m<k||(y(S,k,g,"property"),f[f.length-1]=S,m<=k+g))throw l},onObjectEnd:(S,k)=>{if(m<=S)throw l;$=void 0,f.pop()},onArrayBegin:(S,k)=>{if(m<=S)throw l;$=void 0,f.push(0)},onArrayEnd:(S,k)=>{if(m<=S)throw l;$=void 0,f.pop()},onLiteralValue:(S,k,g)=>{if(m<k||(y(S,k,g,n(S)),m<=k+g))throw l},onSeparator:(S,k,g)=>{if(m<=k)throw l;if(S===":"&&$&&$.type==="property")$.colonOffset=k,D=!1,$=void 0;else if(S===","){const b=f[f.length-1];typeof b=="number"?f[f.length-1]=b+1:(D=!0,f[f.length-1]=""),$=void 0}}})}catch(S){if(S!==l)throw S}return{path:f,previousNode:$,isAtPropertyKey:D,matches:S=>{let k=0;for(let g=0;k<S.length&&g<f.length;g++)if(S[k]===f[g]||S[k]==="*")k++;else if(S[k]!=="**")return!1;return k===S.length}}}function u(t,m=[],f=O.DEFAULT){let l=null,$=[];const I=[];function D(S){Array.isArray($)?$.push(S):l!==null&&($[l]=S)}return i(t,{onObjectBegin:()=>{const S={};D(S),I.push($),$=S,l=null},onObjectProperty:S=>{l=S},onObjectEnd:()=>{$=I.pop()},onArrayBegin:()=>{const S=[];D(S),I.push($),$=S,l=null},onArrayEnd:()=>{$=I.pop()},onLiteralValue:D,onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f),$[0]}function E(t,m=[],f=O.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(S){l.type==="property"&&(l.length=S-l.offset,l=l.parent)}function I(S){return l.children.push(S),S}i(t,{onObjectBegin:S=>{l=I({type:"object",offset:S,length:-1,parent:l,children:[]})},onObjectProperty:(S,k,g)=>{l=I({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:S,offset:k,length:g,parent:l})},onObjectEnd:(S,k)=>{l.length=S+k-l.offset,l=l.parent,$(S+k)},onArrayBegin:(S,k)=>{l=I({type:"array",offset:S,length:-1,parent:l,children:[]})},onArrayEnd:(S,k)=>{l.length=S+k-l.offset,l=l.parent,$(S+k)},onLiteralValue:(S,k,g)=>{I({type:n(S),offset:k,length:g,parent:l,value:S}),$(k+g)},onSeparator:(S,k,g)=>{l.type==="property"&&(S===":"?l.colonOffset=k:S===","&&$(k))},onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f);const y=l.children[0];return y&&delete y.parent,y}function d(t,m){if(!t)return;let f=t;for(const l of m)if(typeof l=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let $=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===l){f=I.children[1],$=!0;break}if(!$)return}else{const $=l;if(f.type!=="array"||$<0||!Array.isArray(f.children)||$>=f.children.length)return;f=f.children[$]}return f}function r(t){if(!t.parent||!t.parent.children)return[];const m=r(t.parent);if(t.parent.type==="property"){const f=t.parent.children[0].value;m.push(f)}else if(t.parent.type==="array"){const f=t.parent.children.indexOf(t);f!==-1&&m.push(f)}return m}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const m=Object.create(null);for(const f of t.children){const l=f.children[1];l&&(m[f.children[0].value]=o(l))}return m}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,m,f=!1){return m>=t.offset&&m<t.offset+t.length||f&&m===t.offset+t.length}function h(t,m,f=!1){if(a(t,m,f)){const l=t.children;if(Array.isArray(l))for(let $=0;$<l.length&&l[$].offset<=m;$++){const I=h(l[$],m,f);if(I)return I}return t}}function i(t,m,f=O.DEFAULT){const l=A(t,!1);function $(be){return be?()=>be(l.getTokenOffset(),l.getTokenLength()):()=>!0}function I(be){return be?re=>be(re,l.getTokenOffset(),l.getTokenLength()):()=>!0}const D=$(m.onObjectBegin),y=I(m.onObjectProperty),S=$(m.onObjectEnd),k=$(m.onArrayBegin),g=$(m.onArrayEnd),b=I(m.onLiteralValue),L=I(m.onSeparator),T=$(m.onComment),q=I(m.onError),G=f&&f.disallowComments,W=f&&f.allowTrailingComma;function N(){for(;;){const be=l.scan();switch(l.getTokenError()){case w.InvalidUnicode:V(P.InvalidUnicode);break;case w.InvalidEscapeCharacter:V(P.InvalidEscapeCharacter);break;case w.UnexpectedEndOfNumber:V(P.UnexpectedEndOfNumber);break;case w.UnexpectedEndOfComment:G||V(P.UnexpectedEndOfComment);break;case w.UnexpectedEndOfString:V(P.UnexpectedEndOfString);break;case w.InvalidCharacter:V(P.InvalidCharacter);break}switch(be){case C.LineCommentTrivia:case C.BlockCommentTrivia:G?V(P.InvalidCommentToken):T();break;case C.Unknown:V(P.InvalidSymbol);break;case C.Trivia:case C.LineBreakTrivia:break;default:return be}}}function V(be,re=[],Pe=[]){if(q(be),re.length+Pe.length>0){let Le=l.getToken();for(;Le!==C.EOF;){if(re.indexOf(Le)!==-1){N();break}else if(Pe.indexOf(Le)!==-1)break;Le=N()}}}function ce(be){const re=l.getTokenValue();return be?b(re):y(re),N(),!0}function ge(){switch(l.getToken()){case C.NumericLiteral:{let be=0;try{be=JSON.parse(l.getTokenValue()),typeof be!="number"&&(V(P.InvalidNumberFormat),be=0)}catch{V(P.InvalidNumberFormat)}b(be);break}case C.NullKeyword:b(null);break;case C.TrueKeyword:b(!0);break;case C.FalseKeyword:b(!1);break;default:return!1}return N(),!0}function ie(){return l.getToken()!==C.StringLiteral?(V(P.PropertyNameExpected,[],[C.CloseBraceToken,C.CommaToken]),!1):(ce(!1),l.getToken()===C.ColonToken?(L(":"),N(),de()||V(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken])):V(P.ColonExpected,[],[C.CloseBraceToken,C.CommaToken]),!0)}function me(){D(),N();let be=!1;for(;l.getToken()!==C.CloseBraceToken&&l.getToken()!==C.EOF;){if(l.getToken()===C.CommaToken){if(be||V(P.ValueExpected,[],[]),L(","),N(),l.getToken()===C.CloseBraceToken&&W)break}else be&&V(P.CommaExpected,[],[]);ie()||V(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken]),be=!0}return S(),l.getToken()!==C.CloseBraceToken?V(P.CloseBraceExpected,[C.CloseBraceToken],[]):N(),!0}function se(){k(),N();let be=!1;for(;l.getToken()!==C.CloseBracketToken&&l.getToken()!==C.EOF;){if(l.getToken()===C.CommaToken){if(be||V(P.ValueExpected,[],[]),L(","),N(),l.getToken()===C.CloseBracketToken&&W)break}else be&&V(P.CommaExpected,[],[]);de()||V(P.ValueExpected,[],[C.CloseBracketToken,C.CommaToken]),be=!0}return g(),l.getToken()!==C.CloseBracketToken?V(P.CloseBracketExpected,[C.CloseBracketToken],[]):N(),!0}function de(){switch(l.getToken()){case C.OpenBracketToken:return se();case C.OpenBraceToken:return me();case C.StringLiteral:return ce(!0);default:return ge()}}return N(),l.getToken()===C.EOF?f.allowEmptyContent?!0:(V(P.ValueExpected,[],[]),!1):de()?(l.getToken()!==C.EOF&&V(P.EndOfFileExpected,[],[]),!0):(V(P.ValueExpected,[],[]),!1)}function s(t,m){const f=A(t),l=[];let $,I=0,D;do switch(D=f.getPosition(),$=f.scan(),$){case C.LineCommentTrivia:case C.BlockCommentTrivia:case C.EOF:I!==D&&l.push(t.substring(I,D)),m!==void 0&&l.push(f.getTokenValue().replace(/[^\r\n]/g,m)),I=f.getPosition();break}while($!==C.EOF);return l.join("")}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[136],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ae,ve){for(var le=0;le<ve.length;le++){var X=ve[le];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ae,X.key,X)}}function w(ae,ve,le){return ve&&e(ae.prototype,ve),le&&e(ae,le),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function C(ae,ve){if(ae){if(typeof ae=="string")return P(ae,ve);var le=Object.prototype.toString.call(ae).slice(8,-1);if(le==="Object"&&ae.constructor&&(le=ae.constructor.name),le==="Map"||le==="Set")return Array.from(ae);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return P(ae,ve)}}function P(ae,ve){(ve==null||ve>ae.length)&&(ve=ae.length);for(var le=0,X=new Array(ve);le<ve;le++)X[le]=ae[le];return X}function O(ae,ve){var le=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(le)return(le=le.call(ae)).next.bind(le);if(Array.isArray(ae)||(le=C(ae))||ve&&ae&&typeof ae.length=="number"){le&&(ae=le);var X=0;return function(){return X>=ae.length?{done:!0}:{done:!1,value:ae[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function M(ae){oe.defaults=ae}var p=/[&<>"']/,c=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ve){return u[ve]};function d(ae,ve){if(ve){if(p.test(ae))return ae.replace(c,E)}else if(R.test(ae))return ae.replace(v,E);return ae}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ae){return ae.replace(r,function(ve,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(ae,ve){ae=typeof ae=="string"?ae:ae.source,ve=ve||"";var le={replace:function(Z,pe){return pe=pe.source||pe,pe=pe.replace(a,"$1"),ae=ae.replace(Z,pe),le},getRegex:function(){return new RegExp(ae,ve)}};return le}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(ae,ve,le){if(ae){var X;try{X=decodeURIComponent(o(le)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ve&&!s.test(le)&&(le=$(ve,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},m=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ae,ve){t[" "+ae]||(m.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=S(ae,"/",!0)),ae=t[" "+ae];var le=ae.indexOf(":")===-1;return ve.substring(0,2)==="//"?le?ve:ae.replace(f,"$1")+ve:ve.charAt(0)==="/"?le?ve:ae.replace(l,"$1")+ve:ae+ve}var I={exec:function(){}};function D(ae){for(var ve=1,le,X;ve<arguments.length;ve++){le=arguments[ve];for(X in le)Object.prototype.hasOwnProperty.call(le,X)&&(ae[X]=le[X])}return ae}function y(ae,ve){var le=ae.replace(/\|/g,function(pe,$e,Me){for(var je=!1,ke=$e;--ke>=0&&Me[ke]==="\\";)je=!je;return je?"|":" |"}),X=le.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>ve)X.splice(ve);else for(;X.length<ve;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function S(ae,ve,le){var X=ae.length;if(X===0)return"";for(var Z=0;Z<X;){var pe=ae.charAt(X-Z-1);if(pe===ve&&!le)Z++;else if(pe!==ve&&le)Z++;else break}return ae.slice(0,X-Z)}function k(ae,ve){if(ae.indexOf(ve[1])===-1)return-1;for(var le=ae.length,X=0,Z=0;Z<le;Z++)if(ae[Z]==="\\")Z++;else if(ae[Z]===ve[0])X++;else if(ae[Z]===ve[1]&&(X--,X<0))return Z;return-1}function g(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ae,ve){if(ve<1)return"";for(var le="";ve>1;)ve&1&&(le+=ae),ve>>=1,ae+=ae;return le+ae}function L(ae,ve,le,X){var Z=ve.href,pe=ve.title?d(ve.title):null,$e=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){X.state.inLink=!0;var Me={type:"link",raw:le,href:Z,title:pe,text:$e,tokens:X.inlineTokens($e)};return X.state.inLink=!1,Me}return{type:"image",raw:le,href:Z,title:pe,text:d($e)}}function T(ae,ve){var le=ae.match(/^(\s+)(?:```)/);if(le===null)return ve;var X=le[1];return ve.split(`
`).map(function(Z){var pe=Z.match(/^\s+/);if(pe===null)return Z;var $e=pe[0];return $e.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var q=function(){function ae(le){this.options=le||oe.defaults}var ve=ae.prototype;return ve.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ve.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var pe=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:S(pe,`
`)}}},ve.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var pe=Z[0],$e=T(pe,Z[3]||"");return{type:"code",raw:pe,lang:Z[2]?Z[2].trim():Z[2],text:$e}}},ve.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var pe=Z[2].trim();if(/#$/.test(pe)){var $e=S(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ve.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},ve.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var pe=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ve.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var pe,$e,Me,je,ke,Re,Oe,z,j,K,J,ne,fe=Z[1].trim(),Ae=fe.length>1,ze={type:"list",raw:"",ordered:Ae,start:Ae?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ae?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ae?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ne=!1,!(!(Z=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=Z[0],X=X.substring(pe.length),z=Z[2].split(`
`,1)[0],j=X.split(`
`,1)[0],this.options.pedantic?(je=2,J=z.trimLeft()):(je=Z[2].search(/[^ ]/),je=je>4?1:je,J=z.slice(je),je+=Z[1].length),Re=!1,!z&&/^ *$/.test(j)&&(pe+=j+`
`,X=X.substring(j.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,je-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,je-1)+"}#");X&&(K=X.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(z)||tt.test(z)||_e.test(z)||it.test(X)));){if(z.search(/[^ ]/)>=je||!z.trim())J+=`
`+z.slice(je);else if(!Re)J+=`
`+z;else break;!Re&&!z.trim()&&(Re=!0),pe+=K+`
`,X=X.substring(K.length+1)}ze.loose||(Oe?ze.loose=!0:/\n *\n *$/.test(pe)&&(Oe=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(J),$e&&(Me=$e[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:pe,task:!!$e,checked:Me,loose:!1,text:J}),ze.raw+=pe}ze.items[ze.items.length-1].raw=pe.trimRight(),ze.items[ze.items.length-1].text=J.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,ze.items[ke].tokens=this.lexer.blockTokens(ze.items[ke].text,[]);var $t=ze.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=$t.every(function(st){for(var ct=st.raw.split(""),gt=0,mt=O(ct),Be;!(Be=mt()).done;){var Ue=Be.value;if(Ue===`
`&&(gt+=1),gt>1)return!0}return!1});!ze.loose&&$t.length&&lt&&(ze.loose=!0,ze.items[ke].loose=!0)}return ze}},ve.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var pe={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},ve.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var pe=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:Z[0],href:Z[2],title:Z[3]}}},ve.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var pe={type:"table",header:y(Z[1]).map(function(Oe){return{text:Oe}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=Z[0];var $e=pe.align.length,Me,je,ke,Re;for(Me=0;Me<$e;Me++)/^ *-+: *$/.test(pe.align[Me])?pe.align[Me]="right":/^ *:-+: *$/.test(pe.align[Me])?pe.align[Me]="center":/^ *:-+ *$/.test(pe.align[Me])?pe.align[Me]="left":pe.align[Me]=null;for($e=pe.rows.length,Me=0;Me<$e;Me++)pe.rows[Me]=y(pe.rows[Me],pe.header.length).map(function(Oe){return{text:Oe}});for($e=pe.header.length,je=0;je<$e;je++)pe.header[je].tokens=this.lexer.inline(pe.header[je].text);for($e=pe.rows.length,je=0;je<$e;je++)for(Re=pe.rows[je],ke=0;ke<Re.length;ke++)Re[ke].tokens=this.lexer.inline(Re[ke].text);return pe}}},ve.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ve.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var pe=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:pe,tokens:this.lexer.inline(pe)}}},ve.text=function(X){var Z=this.rules.block.text.exec(X);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ve.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:d(Z[1])}},ve.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]):Z[0]}},ve.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var pe=Z[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=S(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Me=k(Z[2],"()");if(Me>-1){var je=Z[0].indexOf("!")===0?5:4,ke=je+Z[1].length+Me;Z[2]=Z[2].substring(0,Me),Z[0]=Z[0].substring(0,ke).trim(),Z[3]=""}}var Re=Z[2],Oe="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);z&&(Re=z[1],Oe=z[3])}else Oe=Z[3]?Z[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(pe)?Re=Re.slice(1):Re=Re.slice(1,-1)),L(Z,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ve.reflink=function(X,Z){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=Z[$e.toLowerCase()],!$e||!$e.href){var Me=pe[0].charAt(0);return{type:"text",raw:Me,text:Me}}return L(pe,$e,pe[0],this.lexer)}},ve.emStrong=function(X,Z,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(X);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=$e[1]||$e[2]||"";if(!Me||Me&&(pe===""||this.rules.inline.punctuation.exec(pe))){var je=$e[0].length-1,ke,Re,Oe=je,z=0,j=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Z=Z.slice(-1*X.length+je);($e=j.exec(Z))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Re=ke.length,$e[3]||$e[4]){Oe+=Re;continue}else if(($e[5]||$e[6])&&je%3&&!((je+Re)%3)){z+=Re;continue}if(Oe-=Re,!(Oe>0)){if(Re=Math.min(Re,Re+Oe+z),Math.min(je,Re)%2){var K=X.slice(1,je+$e.index+Re);return{type:"em",raw:X.slice(0,je+$e.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var J=X.slice(2,je+$e.index+Re-1);return{type:"strong",raw:X.slice(0,je+$e.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ve.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var pe=Z[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Me=/^ /.test(pe)&&/ $/.test(pe);return $e&&Me&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:Z[0],text:pe}}},ve.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},ve.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ve.autolink=function(X,Z){var pe=this.rules.inline.autolink.exec(X);if(pe){var $e,Me;return pe[2]==="@"?($e=d(this.options.mangle?Z(pe[1]):pe[1]),Me="mailto:"+$e):($e=d(pe[1]),Me=$e),{type:"link",raw:pe[0],text:$e,href:Me,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.url=function(X,Z){var pe;if(pe=this.rules.inline.url.exec(X)){var $e,Me;if(pe[2]==="@")$e=d(this.options.mangle?Z(pe[0]):pe[0]),Me="mailto:"+$e;else{var je;do je=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(je!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Me="http://"+$e:Me=$e}return{type:"link",raw:pe[0],text:$e,href:Me,tokens:[{type:"text",raw:$e,text:$e}]}}},ve.inlineText=function(X,Z){var pe=this.rules.inline.text.exec(X);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?Z(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},ae}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=h(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=h(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=h(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=h(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=h(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=h(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=h(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=h(W.reflink).replace("label",W._label).replace("ref",G._label).getRegex(),W.nolink=h(W.nolink).replace("ref",G._label).getRegex(),W.reflinkSearch=h(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=D({},W),W.pedantic=D({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=D({},W.normal,{escape:h(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=h(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=D({},W.gfm,{br:h(W.br).replace("{2,}","*").getRegex(),text:h(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ae){var ve="",le,X,Z=ae.length;for(le=0;le<Z;le++)X=ae.charCodeAt(le),Math.random()>.5&&(X="x"+X.toString(16)),ve+="&#"+X+";";return ve}var ce=function(){function ae(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||oe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:G.normal,inline:W.normal};this.options.pedantic?(X.block=G.pedantic,X.inline=W.pedantic):this.options.gfm&&(X.block=G.gfm,this.options.breaks?X.inline=W.breaks:X.inline=W.gfm),this.tokenizer.rules=X}ae.lex=function(X,Z){var pe=new ae(Z);return pe.lex(X)},ae.lexInline=function(X,Z){var pe=new ae(Z);return pe.inlineTokens(X)};var ve=ae.prototype;return ve.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ve.blockTokens=function(X,Z){var pe=this;Z===void 0&&(Z=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,z,j){return z+"    ".repeat(j.length)});for(var $e,Me,je,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return($e=Oe.call({lexer:pe},X,Z))?(X=X.substring($e.raw.length),Z.push($e),!0):!1}))){if($e=this.tokenizer.space(X)){X=X.substring($e.raw.length),$e.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push($e);continue}if($e=this.tokenizer.code(X)){X=X.substring($e.raw.length),Me=Z[Z.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+$e.raw,Me.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push($e);continue}if($e=this.tokenizer.fences(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.heading(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.hr(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.blockquote(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.list(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.html(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.def(X)){X=X.substring($e.raw.length),Me=Z[Z.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+$e.raw,Me.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.lheading(X)){X=X.substring($e.raw.length),Z.push($e);continue}if(je=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,z=X.slice(1),j=void 0;pe.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},z),typeof j=="number"&&j>=0&&(Oe=Math.min(Oe,j))}),Oe<1/0&&Oe>=0&&(je=X.substring(0,Oe+1))}(),this.state.top&&($e=this.tokenizer.paragraph(je))){Me=Z[Z.length-1],ke&&Me.type==="paragraph"?(Me.raw+=`
`+$e.raw,Me.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push($e),ke=je.length!==X.length,X=X.substring($e.raw.length);continue}if($e=this.tokenizer.text(X)){X=X.substring($e.raw.length),Me=Z[Z.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+$e.raw,Me.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Z.push($e);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Z},ve.inline=function(X,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:X,tokens:Z}),Z},ve.inlineTokens=function(X,Z){var pe=this;Z===void 0&&(Z=[]);var $e,Me,je,ke=X,Re,Oe,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)j.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(z=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return($e=J.call({lexer:pe},X,Z))?(X=X.substring($e.raw.length),Z.push($e),!0):!1}))){if($e=this.tokenizer.escape(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.tag(X)){X=X.substring($e.raw.length),Me=Z[Z.length-1],Me&&$e.type==="text"&&Me.type==="text"?(Me.raw+=$e.raw,Me.text+=$e.text):Z.push($e);continue}if($e=this.tokenizer.link(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring($e.raw.length),Me=Z[Z.length-1],Me&&$e.type==="text"&&Me.type==="text"?(Me.raw+=$e.raw,Me.text+=$e.text):Z.push($e);continue}if($e=this.tokenizer.emStrong(X,ke,z)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.codespan(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.br(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.del(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.autolink(X,V)){X=X.substring($e.raw.length),Z.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(X,V))){X=X.substring($e.raw.length),Z.push($e);continue}if(je=X,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,ne=X.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(Ae){fe=Ae.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(J=Math.min(J,fe))}),J<1/0&&J>=0&&(je=X.substring(0,J+1))}(),$e=this.tokenizer.inlineText(je,N)){X=X.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(z=$e.raw.slice(-1)),Oe=!0,Me=Z[Z.length-1],Me&&Me.type==="text"?(Me.raw+=$e.raw,Me.text+=$e.text):Z.push($e);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},w(ae,null,[{key:"rules",get:function(){return{block:G,inline:W}}}]),ae}(),ge=function(){function ae(le){this.options=le||oe.defaults}var ve=ae.prototype;return ve.code=function(X,Z,pe){var $e=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(X,$e);Me!=null&&Me!==X&&(pe=!0,X=Me)}return X=X.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:d(X,!0))+`</code></pre>
`},ve.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ve.html=function(X){return X},ve.heading=function(X,Z,pe,$e){if(this.options.headerIds){var Me=this.options.headerPrefix+$e.slug(pe);return"<h"+Z+' id="'+Me+'">'+X+"</h"+Z+`>
`}return"<h"+Z+">"+X+"</h"+Z+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(X,Z,pe){var $e=Z?"ol":"ul",Me=Z&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Me+`>
`+X+"</"+$e+`>
`},ve.listitem=function(X){return"<li>"+X+`</li>
`},ve.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(X){return"<p>"+X+`</p>
`},ve.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},ve.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ve.tablecell=function(X,Z){var pe=Z.header?"th":"td",$e=Z.align?"<"+pe+' align="'+Z.align+'">':"<"+pe+">";return $e+X+("</"+pe+`>
`)},ve.strong=function(X){return"<strong>"+X+"</strong>"},ve.em=function(X){return"<em>"+X+"</em>"},ve.codespan=function(X){return"<code>"+X+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(X){return"<del>"+X+"</del>"},ve.link=function(X,Z,pe){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<a href="'+d(X)+'"';return Z&&($e+=' title="'+Z+'"'),$e+=">"+pe+"</a>",$e},ve.image=function(X,Z,pe){if(X=n(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<img src="'+X+'" alt="'+pe+'"';return Z&&($e+=' title="'+Z+'"'),$e+=this.options.xhtml?"/>":">",$e},ve.text=function(X){return X},ae}(),ie=function(){function ae(){}var ve=ae.prototype;return ve.strong=function(X){return X},ve.em=function(X){return X},ve.codespan=function(X){return X},ve.del=function(X){return X},ve.html=function(X){return X},ve.text=function(X){return X},ve.link=function(X,Z,pe){return""+pe},ve.image=function(X,Z,pe){return""+pe},ve.br=function(){return""},ae}(),me=function(){function ae(){this.seen={}}var ve=ae.prototype;return ve.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(X,Z){var pe=X,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[X];do $e++,pe=X+"-"+$e;while(this.seen.hasOwnProperty(pe))}return Z||(this.seen[X]=$e,this.seen[pe]=0),pe},ve.slug=function(X,Z){Z===void 0&&(Z={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,Z.dryrun)},ae}(),se=function(){function ae(le){this.options=le||oe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new me}ae.parse=function(X,Z){var pe=new ae(Z);return pe.parse(X)},ae.parseInline=function(X,Z){var pe=new ae(Z);return pe.parseInline(X)};var ve=ae.prototype;return ve.parse=function(X,Z){Z===void 0&&(Z=!0);var pe="",$e,Me,je,ke,Re,Oe,z,j,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt=X.length;for($e=0;$e<rt;$e++){if(J=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(tt=this.options.extensions.renderers[J.type].call({parser:this},J),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){pe+=tt||"";continue}switch(J.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(J.tokens),J.depth,o(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(j="",z="",ke=J.header.length,Me=0;Me<ke;Me++)z+=this.renderer.tablecell(this.parseInline(J.header[Me].tokens),{header:!0,align:J.align[Me]});for(j+=this.renderer.tablerow(z),K="",ke=J.rows.length,Me=0;Me<ke;Me++){for(Oe=J.rows[Me],z="",Re=Oe.length,je=0;je<Re;je++)z+=this.renderer.tablecell(this.parseInline(Oe[je].tokens),{header:!1,align:J.align[je]});K+=this.renderer.tablerow(z)}pe+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(J.tokens),pe+=this.renderer.blockquote(K);continue}case"list":{for(ne=J.ordered,fe=J.start,Ae=J.loose,ke=J.items.length,K="",Me=0;Me<ke;Me++)Ke=J.items[Me],_e=Ke.checked,it=Ke.task,ze="",Ke.task&&(nt=this.renderer.checkbox(_e),Ae?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Ke.tokens,Ae),K+=this.renderer.listitem(ze,it,_e);pe+=this.renderer.list(K,ne,fe);continue}case"html":{pe+=this.renderer.html(J.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(K=J.tokens?this.parseInline(J.tokens):J.text;$e+1<rt&&X[$e+1].type==="text";)J=X[++$e],K+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);pe+=Z?this.renderer.paragraph(K):K;continue}default:{var $t='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},ve.parseInline=function(X,Z){Z=Z||this.renderer;var pe="",$e,Me,je,ke=X.length;for($e=0;$e<ke;$e++){if(Me=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(je=this.options.extensions.renderers[Me.type].call({parser:this},Me),je!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){pe+=je||"";continue}switch(Me.type){case"escape":{pe+=Z.text(Me.text);break}case"html":{pe+=Z.html(Me.text);break}case"link":{pe+=Z.link(Me.href,Me.title,this.parseInline(Me.tokens,Z));break}case"image":{pe+=Z.image(Me.href,Me.title,Me.text);break}case"strong":{pe+=Z.strong(this.parseInline(Me.tokens,Z));break}case"em":{pe+=Z.em(this.parseInline(Me.tokens,Z));break}case"codespan":{pe+=Z.codespan(Me.text);break}case"br":{pe+=Z.br();break}case"del":{pe+=Z.del(this.parseInline(Me.tokens,Z));break}case"text":{pe+=Z.text(Me.text);break}default:{var Re='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return pe},ae}();function de(ae,ve,le){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ve=="function"&&(le=ve,ve=null),ve=D({},de.defaults,ve||{}),g(ve),le){var X=ve.highlight,Z;try{Z=ce.lex(ae,ve)}catch(ke){return le(ke)}var pe=function(Re){var Oe;if(!Re)try{ve.walkTokens&&de.walkTokens(Z,ve.walkTokens),Oe=se.parse(Z,ve)}catch(z){Re=z}return ve.highlight=X,Re?le(Re):le(null,Oe)};if(!X||X.length<3||(delete ve.highlight,!Z.length))return pe();var $e=0;de.walkTokens(Z,function(ke){ke.type==="code"&&($e++,setTimeout(function(){X(ke.text,ke.lang,function(Re,Oe){if(Re)return pe(Re);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Me(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var je=ce.lex(ae,ve);if(ve.walkTokens){if(ve.async)return Promise.all(de.walkTokens(je,ve.walkTokens)).then(function(){return se.parse(je,ve)}).catch(Me);de.walkTokens(je,ve.walkTokens)}return se.parse(je,ve)}catch(ke){Me(ke)}}de.options=de.setOptions=function(ae){return D(de.defaults,ae),M(de.defaults),de},de.getDefaults=A,de.defaults=oe.defaults,de.use=function(){for(var ae=arguments.length,ve=new Array(ae),le=0;le<ae;le++)ve[le]=arguments[le];var X=D.apply(void 0,[{}].concat(ve)),Z=de.defaults.extensions||{renderers:{},childTokens:{}},pe;ve.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(je){if(!je.name)throw new Error("extension name required");if(je.renderer){var ke=Z.renderers?Z.renderers[je.name]:null;ke?Z.renderers[je.name]=function(){for(var Re=arguments.length,Oe=new Array(Re),z=0;z<Re;z++)Oe[z]=arguments[z];var j=je.renderer.apply(this,Oe);return j===!1&&(j=ke.apply(this,Oe)),j}:Z.renderers[je.name]=je.renderer}if(je.tokenizer){if(!je.level||je.level!=="block"&&je.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[je.level]?Z[je.level].unshift(je.tokenizer):Z[je.level]=[je.tokenizer],je.start&&(je.level==="block"?Z.startBlock?Z.startBlock.push(je.start):Z.startBlock=[je.start]:je.level==="inline"&&(Z.startInline?Z.startInline.push(je.start):Z.startInline=[je.start]))}je.childTokens&&(Z.childTokens[je.name]=je.childTokens)})),$e.renderer&&function(){var je=de.defaults.renderer||new ge,ke=function(z){var j=je[z];je[z]=function(){for(var K=arguments.length,J=new Array(K),ne=0;ne<K;ne++)J[ne]=arguments[ne];var fe=$e.renderer[z].apply(je,J);return fe===!1&&(fe=j.apply(je,J)),fe}};for(var Re in $e.renderer)ke(Re);X.renderer=je}(),$e.tokenizer&&function(){var je=de.defaults.tokenizer||new q,ke=function(z){var j=je[z];je[z]=function(){for(var K=arguments.length,J=new Array(K),ne=0;ne<K;ne++)J[ne]=arguments[ne];var fe=$e.tokenizer[z].apply(je,J);return fe===!1&&(fe=j.apply(je,J)),fe}};for(var Re in $e.tokenizer)ke(Re);X.tokenizer=je}(),$e.walkTokens){var Me=de.defaults.walkTokens;X.walkTokens=function(je){var ke=[];return ke.push($e.walkTokens.call(this,je)),Me&&(ke=ke.concat(Me.call(this,je))),ke}}pe&&(X.extensions=Z),de.setOptions(X)})},de.walkTokens=function(ae,ve){for(var le=[],X=function(){var Me=pe.value;switch(le=le.concat(ve.call(de,Me)),Me.type){case"table":{for(var je=O(Me.header),ke;!(ke=je()).done;){var Re=ke.value;le=le.concat(de.walkTokens(Re.tokens,ve))}for(var Oe=O(Me.rows),z;!(z=Oe()).done;)for(var j=z.value,K=O(j),J;!(J=K()).done;){var ne=J.value;le=le.concat(de.walkTokens(ne.tokens,ve))}break}case"list":{le=le.concat(de.walkTokens(Me.items,ve));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[Me.type]?de.defaults.extensions.childTokens[Me.type].forEach(function(fe){le=le.concat(de.walkTokens(Me[fe],ve))}):Me.tokens&&(le=le.concat(de.walkTokens(Me.tokens,ve)))}},Z=O(ae),pe;!(pe=Z()).done;)X();return le},de.parseInline=function(ae,ve){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ve=D({},de.defaults,ve||{}),g(ve);try{var le=ce.lexInline(ae,ve);return ve.walkTokens&&de.walkTokens(le,ve.walkTokens),se.parseInline(le,ve)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},de.Parser=se,de.parser=se.parse,de.Renderer=ge,de.TextRenderer=ie,de.Lexer=ce,de.lexer=ce.lex,de.Tokenizer=q,de.Slugger=me,de.parse=de;var be=de.options,re=de.setOptions,Pe=de.use,Le=de.walkTokens,Y=de.parseInline,B=de,_=se.parse,we=ce.lex;oe.Lexer=ce,oe.Parser=se,oe.Renderer=ge,oe.Slugger=me,oe.TextRenderer=ie,oe.Tokenizer=q,oe.getDefaults=A,oe.lexer=we,oe.marked=de,oe.options=be,oe.parse=B,oe.parseInline=Y,oe.parser=_,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Le,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[137],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=w;function w(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const P=new Uint32Array(10);function O(r){if(C=0,A(r,v,p.InitialConsonant),C>0||(A(r,u,p.Vowel),C>0)||(A(r,E,p.FinalConsonant),C>0)||(A(r,d,p.CompatibilityJamo),C))return P.subarray(0,C);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),i=Math.floor(a/28),s=a%28-1;if(h<v.length?A(h,v,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),i<u.length?A(i,u,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),s>=0&&(s<E.length?A(s,E,0):p.FinalConsonant+s-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+s-p.CompatibilityJamo,d,p.CompatibilityJamo)),C>0)return P.subarray(0,C)}}function A(r,o,a){r>=a&&r<a+o.length&&M(o[r-a])}function M(r){r!==c.NUL&&(P[C++]=r&255,r>>8&&(P[C++]=r>>8&255),r>>16&&(P[C++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var R;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(R||(R={}));const v=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l]),E=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,R.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.E,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,c.Q,R.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l])}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=w,e.rot=C,e.$Mm=M;function w(p,c,R){return Math.min(Math.max(p,c),R)}function C(p,c){return(c+p%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=P;class O{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=O;class A{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const R=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=A;function M(p,c,R,v,u,E,d,r){const o=d-R,a=r-v,h=u-R,i=E-v,s=p-R,n=c-v,t=o*o+a*a,m=o*h+a*i,f=o*s+a*n,l=h*h+i*i,$=h*s+i*n,I=1/(t*l-m*m),D=(l*f-m*$)*I,y=(t*$-m*f)*I;return D>=0&&y>=0&&D+y<1}}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=O,e.$dd=u;class w{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$bd=w;const C=new Map,P=new WeakMap;function O(E,d){const r=P.get(E);if(r)return r;const o=A(E,d);if(o){let a=C.get(o)??0;a++,C.set(o,a);const h=a===1?o:`${o}#${a}`;return P.set(E,h),h}}function A(E,d){const r=P.get(E);if(r)return r;const o=d.owner?R(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const i=d.referenceFn;if(i!==void 0&&(a=u(i),a!==void 0))return o+a;if(d.owner!==void 0){const s=M(d.owner,E);if(s!==void 0)return o+s}}function M(E,d){for(const r in E)if(E[r]===d)return r}const p=new Map,c=new WeakMap;function R(E){const d=c.get(E);if(d)return d;const r=v(E);let o=p.get(r)??0;o++,p.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(E,a),a}function v(E){const d=E.constructor;return d?d.name:"Object"}function u(E){const d=E.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Ce[140],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=C,e.$Jd=P;let w;function C(r){w=r}function P(){return w}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([M(E("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[M(" "),c(R(o.oldValue,70),{color:"red",strikeThrough:!0}),M(" "),c(R(o.newValue,60),{color:"green"})]:[M(" (unchanged)")]:[M(" "),c(R(o.newValue,60),{color:"green"}),M(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([p("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,i)=>(this.d.get(o).add(h),a.apply(o,[h,i]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([p("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([p("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,i)=>(this.d.get(o).add(h),a.apply(o,[h,i]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([p("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([p("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=O;function A(r){const o=new Array,a=[];let h="";function i(n){if("length"in n)for(const t of n)t&&i(t);else"text"in n?(h+=`%c${n.text}`,o.push(n.style),n.data&&a.push(...n.data)):"data"in n&&a.push(...n.data)}i(r);const s=[h,...o];return s.push(...a),s}function M(r){return c(r,{color:"black"})}function p(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(i){return Object.entries(i).reduce((s,[n,t])=>`${s}${n}:${t};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function R(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?v(r,o):u(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function v(r,o){let a="[ ",h=!0;for(const i of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${R(i,o-a.length)}`}return a+=" ]",a}function u(r,o){let a="{ ",h=!0;for(const[i,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${i}: ${R(s,o-a.length)}`}return a+=" }",a}function E(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ce[141],Ie([1,0,134,139,140]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$3d=e.$Xd=e.$Wd=void 0,e.$Td=A,e.$Ud=p,e.$Vd=R,e.$Yd=E,e.$Zd=r,e.$1d=o,e.$2d=a,e.$4d=i,e.$6d=n;let O;function A(m){O=m}let M;function p(m){M=m}let c;function R(m){c=m}class v{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,l){const $=l===void 0?void 0:f,I=l===void 0?f:l;return c({owner:$,debugName:()=>{const D=(0,C.$dd)(I);if(D!==void 0)return D;const S=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(S)return`${this.debugName}.${S[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:I},D=>I(this.read(D),D))}recomputeInitiallyAndOnChange(f,l){return f.add(O(this,l)),this}keepObserved(f){return f.add(M(this)),this}get a(){return this.get()}}e.$Wd=v;class u extends v{constructor(){super(...arguments),this.b=new Set}addObserver(f){const l=this.b.size;this.b.add(f),l===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Xd=u;function E(m,f){const l=new h(m,f);try{m(l)}finally{l.finish()}}let d;function r(m){if(d)m(d);else{const f=new h(m,void 0);d=f;try{m(f)}finally{f.finish(),d=void 0}}}async function o(m,f){const l=new h(m,f);try{await m(l)}finally{l.finish()}}function a(m,f,l){m?f(m):E(f,l)}class h{constructor(f,l){this._fn=f,this.b=l,this.a=[],(0,P.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(f,l){this.a.push({observer:f,observable:l}),f.beginUpdate(l)}finish(){const f=this.a;for(let l=0;l<f.length;l++){const{observer:$,observable:I}=f[l];$.endUpdate(I)}this.a=null,(0,P.$Jd)()?.handleEndTransaction()}}e.$3d=h;function i(m,f){let l;return typeof m=="string"?l=new C.$bd(void 0,m,void 0):l=new C.$bd(m,void 0,void 0),new s(l,f,w.$7c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,l,$){super(),this.e=f,this.g=$,this.d=l}get(){return this.d}set(f,l,$){if($===void 0&&this.g(this.d,f))return;let I;l||(l=I=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(f),(0,P.$Jd)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:$,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,$)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$5d=s;function n(m,f){let l;return typeof m=="string"?l=new C.$bd(void 0,m,void 0):l=new C.$bd(m,void 0,void 0),new t(l,f,w.$7c)}class t extends s{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$7d=t}),function(){function oe(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(p){O.push(p,Date.now())}function M(){const p=[];for(let c=0;c<O.length;c+=2)p.push({name:O[c],startTime:O[c+1]});return p}return{mark:A,getMarks:M}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=w(C))}(),define(Ce[142],Ie([1,0,40]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LI=void 0;const C=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||w.Iterable.empty()}insert(p,c,R){this.d(p,v=>v._value=c,R)}mutate(p,c){this.d(p,R=>R._value=c(R._value===C?void 0:R._value))}mutatePath(p,c){this.d(p,()=>{},R=>c(R))}delete(p){const c=this.c(p);if(!c)return;let R=c.length-1;const v=c[R].node._value;if(v!==C){for(this.b--,c[R].node._value=C;R>0;R--){const{node:u,part:E}=c[R];if(u.children?.size||u._value!==C)break;c[R-1].node.children.delete(E)}return v}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const R=c[c.length-1].node;for(let v=c.length-1;v>0;v--){const u=c[v-1];if(u.node.children.delete(c[v].part),u.node.children.size>0||u.node._value!==C)break}for(const v of O(R))v._value!==C&&(this.b--,yield v._value)}find(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return;c=v}return c._value===C?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;if(v._value!==C)return!0;c=v}return!1}hasKeyOrChildren(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return!0}hasKey(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return c._value!==C}c(p){const c=[{part:"",node:this.a}];let R=0;for(const v of p){const u=c[R].node.children?.get(v);if(!u)return;c.push({part:v,node:u}),R++}return c}d(p,c,R){let v=this.a;for(const d of p){if(v.children)if(v.children.has(d))v=v.children.get(d);else{const r=new A;v.children.set(d,r),v=r}else{const r=new A;v.children=new Map([[d,r]]),v=r}R?.(v)}const u=v._value===C?0:1;c(v);const E=v._value===C?0:1;this.b+=E-u}*values(){for(const{_value:p}of O(this.a))p!==C&&(yield p)}}e.$LI=P;function*O(M){const p=[M];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const R of c.children.values())p.push(R)}}class A{constructor(){this._value=C}get value(){return this._value===C?void 0:this._value}set value(p){this._value=p===void 0?C:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var C in w)(typeof exports=="object"?exports:oe)[C]=w[C]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(C){if(e[C])return e[C].exports;var P=e[C]={i:C,l:!1,exports:{}};return oe[C].call(P.exports,P,P.exports,w),P.l=!0,P.exports}return w.m=oe,w.c=e,w.d=function(C,P,O){w.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:O})},w.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},w.t=function(C,P){if(1&P&&(C=w(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(w.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var A in C)w.d(O,A,function(M){return C[M]}.bind(null,A));return O},w.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return w.d(P,"a",P),P},w.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},w.p="",w(w.s=0)}([function(oe,e,w){(function(C){var P;e=oe.exports=Pe,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,M=e.re=[],p=e.src=[],c=0,R=c++;p[R]="0|[1-9]\\d*";var v=c++;p[v]="[0-9]+";var u=c++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=c++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var d=c++;p[d]="("+p[v]+")\\.("+p[v]+")\\.("+p[v]+")";var r=c++;p[r]="(?:"+p[R]+"|"+p[u]+")";var o=c++;p[o]="(?:"+p[v]+"|"+p[u]+")";var a=c++;p[a]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var h=c++;p[h]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var i=c++;p[i]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var n=c++,t="v?"+p[E]+p[a]+"?"+p[s]+"?";p[n]="^"+t+"$";var m="[v=\\s]*"+p[d]+p[h]+"?"+p[s]+"?",f=c++;p[f]="^"+m+"$";var l=c++;p[l]="((?:<|>)?=?)";var $=c++;p[$]=p[v]+"|x|X|\\*";var I=c++;p[I]=p[R]+"|x|X|\\*";var D=c++;p[D]="[v=\\s]*("+p[I]+")(?:\\.("+p[I]+")(?:\\.("+p[I]+")(?:"+p[a]+")?"+p[s]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[s]+"?)?)?";var S=c++;p[S]="^"+p[l]+"\\s*"+p[D]+"$";var k=c++;p[k]="^"+p[l]+"\\s*"+p[y]+"$";var g=c++;p[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=c++;p[b]="(?:~>?)";var L=c++;p[L]="(\\s*)"+p[b]+"\\s+",M[L]=new RegExp(p[L],"g");var T=c++;p[T]="^"+p[b]+p[D]+"$";var q=c++;p[q]="^"+p[b]+p[y]+"$";var G=c++;p[G]="(?:\\^)";var W=c++;p[W]="(\\s*)"+p[G]+"\\s+",M[W]=new RegExp(p[W],"g");var N=c++;p[N]="^"+p[G]+p[D]+"$";var V=c++;p[V]="^"+p[G]+p[y]+"$";var ce=c++;p[ce]="^"+p[l]+"\\s*("+m+")$|^$";var ge=c++;p[ge]="^"+p[l]+"\\s*("+t+")$|^$";var ie=c++;p[ie]="(\\s*)"+p[l]+"\\s*("+m+"|"+p[D]+")",M[ie]=new RegExp(p[ie],"g");var me=c++;p[me]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var se=c++;p[se]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var de=c++;p[de]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)P(be,p[be]),M[be]||(M[be]=new RegExp(p[be]));function re(j,K){if(j instanceof Pe)return j;if(typeof j!="string"||j.length>O||!(K?M[f]:M[n]).test(j))return null;try{return new Pe(j,K)}catch{return null}}function Pe(j,K){if(j instanceof Pe){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Pe))return new Pe(j,K);P("SemVer",j,K),this.loose=K;var J=j.trim().match(K?M[f]:M[n]);if(!J)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=re,e.valid=function(j,K){var J=re(j,K);return J?J.version:null},e.clean=function(j,K){var J=re(j.trim().replace(/^[=v]+/,""),K);return J?J.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof Pe||(j=new Pe(j,this.loose)),this.compareMain(j)||this.comparePre(j)},Pe.prototype.compareMain=function(j){return j instanceof Pe||(j=new Pe(j,this.loose)),Y(this.major,j.major)||Y(this.minor,j.minor)||Y(this.patch,j.patch)},Pe.prototype.comparePre=function(j){if(j instanceof Pe||(j=new Pe(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ne=j.prerelease[K];if(P("prerelease compare",K,J,ne),J===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(J===void 0)return-1;if(J!==ne)return Y(J,ne)}while(++K)},Pe.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,J,ne){typeof J=="string"&&(ne=J,J=void 0);try{return new Pe(j,J).inc(K,ne).version}catch{return null}},e.diff=function(j,K){if(ae(j,K))return null;var J=re(j),ne=re(K);if(J.prerelease.length||ne.prerelease.length){for(var fe in J)if((fe==="major"||fe==="minor"||fe==="patch")&&J[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in J)if((fe==="major"||fe==="minor"||fe==="patch")&&J[fe]!==ne[fe])return fe},e.compareIdentifiers=Y;var Le=/^[0-9]+$/;function Y(j,K){var J=Le.test(j),ne=Le.test(K);return J&&ne&&(j=+j,K=+K),J&&!ne?-1:ne&&!J?1:j<K?-1:j>K?1:0}function B(j,K,J){return new Pe(j,J).compare(new Pe(K,J))}function _(j,K,J){return B(j,K,J)>0}function we(j,K,J){return B(j,K,J)<0}function ae(j,K,J){return B(j,K,J)===0}function ve(j,K,J){return B(j,K,J)!==0}function le(j,K,J){return B(j,K,J)>=0}function X(j,K,J){return B(j,K,J)<=0}function Z(j,K,J,ne){var fe;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),fe=j===J;break;case"!==":typeof j=="object"&&(j=j.version),typeof J=="object"&&(J=J.version),fe=j!==J;break;case"":case"=":case"==":fe=ae(j,J,ne);break;case"!=":fe=ve(j,J,ne);break;case">":fe=_(j,J,ne);break;case">=":fe=le(j,J,ne);break;case"<":fe=we(j,J,ne);break;case"<=":fe=X(j,J,ne);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function pe(j,K){if(j instanceof pe){if(j.loose===K)return j;j=j.value}if(!(this instanceof pe))return new pe(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return Y(K,j)},e.major=function(j,K){return new Pe(j,K).major},e.minor=function(j,K){return new Pe(j,K).minor},e.patch=function(j,K){return new Pe(j,K).patch},e.compare=B,e.compareLoose=function(j,K){return B(j,K,!0)},e.rcompare=function(j,K,J){return B(K,j,J)},e.sort=function(j,K){return j.sort(function(J,ne){return e.compare(J,ne,K)})},e.rsort=function(j,K){return j.sort(function(J,ne){return e.rcompare(J,ne,K)})},e.gt=_,e.lt=we,e.eq=ae,e.neq=ve,e.gte=le,e.lte=X,e.cmp=Z,e.Comparator=pe;var $e={};function Me(j,K){if(j instanceof Me)return j.loose===K?j:new Me(j.raw,K);if(j instanceof pe)return new Me(j.value,K);if(!(this instanceof Me))return new Me(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function je(j){return!j||j.toLowerCase()==="x"||j==="*"}function ke(j,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt){return((K=je(J)?"":je(ne)?">="+J+".0.0":je(fe)?">="+J+"."+ne+".0":">="+K)+" "+(Ke=je(_e)?"":je(it)?"<"+(+_e+1)+".0.0":je(nt)?"<"+_e+"."+(+it+1)+".0":tt?"<="+_e+"."+it+"."+nt+"-"+tt:"<="+Ke)).trim()}function Re(j,K){for(var J=0;J<j.length;J++)if(!j[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<j.length;J++)if(P(j[J].semver),j[J].semver!==$e&&j[J].semver.prerelease.length>0){var ne=j[J].semver;if(ne.major===K.major&&ne.minor===K.minor&&ne.patch===K.patch)return!0}return!1}return!0}function Oe(j,K,J){try{K=new Me(K,J)}catch{return!1}return K.test(j)}function z(j,K,J,ne){var fe,Ae,ze,Ke,_e;switch(j=new Pe(j,ne),K=new Me(K,ne),J){case">":fe=_,Ae=X,ze=we,Ke=">",_e=">=";break;case"<":fe=we,Ae=le,ze=_,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(j,K,ne))return!1;for(var it=0;it<K.set.length;++it){var nt=K.set[it],tt=null,rt=null;if(nt.forEach(function($t){$t.semver===$e&&($t=new pe(">=0.0.0")),tt=tt||$t,rt=rt||$t,fe($t.semver,tt.semver,ne)?tt=$t:ze($t.semver,rt.semver,ne)&&(rt=$t)}),tt.operator===Ke||tt.operator===_e||(!rt.operator||rt.operator===Ke)&&Ae(j,rt.semver)||rt.operator===_e&&ze(j,rt.semver))return!1}return!0}pe.prototype.parse=function(j){var K=this.loose?M[ce]:M[ge],J=j.match(K);if(!J)throw new TypeError("Invalid comparator: "+j);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Pe(J[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===$e||(typeof j=="string"&&(j=new Pe(j,this.loose)),Z(j,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(j,K){if(!(j instanceof pe))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Me(j.value,K),Oe(this.value,J,K);if(j.operator==="")return J=new Me(this.value,K),Oe(j.semver,J,K);var ne=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ae=this.semver.version===j.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ke=Z(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=Z(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ne||fe||Ae&&ze||Ke||_e},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var J=K?M[se]:M[me];j=j.replace(J,ke),P("hyphen replace",j),j=j.replace(M[ie],"$1$2$3"),P("comparator trim",j,M[ie]),j=(j=(j=j.replace(M[L],"$1~")).replace(M[W],"$1^")).split(/\s+/).join(" ");var ne=K?M[ce]:M[ge],fe=j.split(" ").map(function(Ae){return function(ze,Ke){return P("comp",ze),ze=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){P("caret",tt,rt);var $t=rt?M[V]:M[N];return tt.replace($t,function(lt,st,ct,gt,mt){var Be;return P("caret",tt,lt,st,ct,gt,mt),je(st)?Be="":je(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":je(gt)?Be=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":mt?(P("replaceCaret pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+mt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+mt+" <"+(+st+1)+".0.0"):(P("no pr"),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+" <"+(+st+1)+".0.0"),P("caret return",Be),Be})}(nt,it)}).join(" ")}(ze,Ke),P("caret",ze),ze=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){var $t=rt?M[q]:M[T];return tt.replace($t,function(lt,st,ct,gt,mt){var Be;return P("tilde",tt,lt,st,ct,gt,mt),je(st)?Be="":je(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":je(gt)?Be=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":mt?(P("replaceTilde pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0"):Be=">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0",P("tilde return",Be),Be})}(nt,it)}).join(" ")}(ze,Ke),P("tildes",ze),ze=function(_e,it){return P("replaceXRanges",_e,it),_e.split(/\s+/).map(function(nt){return function(tt,rt){tt=tt.trim();var $t=rt?M[k]:M[S];return tt.replace($t,function(lt,st,ct,gt,mt,Be){P("xRange",tt,lt,st,ct,gt,mt,Be);var Ue=je(ct),H=Ue||je(gt),x=H||je(mt);return st==="="&&x&&(st=""),Ue?lt=st===">"||st==="<"?"<0.0.0":"*":st&&x?(H&&(gt=0),x&&(mt=0),st===">"?(st=">=",H?(ct=+ct+1,gt=0,mt=0):x&&(gt=+gt+1,mt=0)):st==="<="&&(st="<",H?ct=+ct+1:gt=+gt+1),lt=st+ct+"."+gt+"."+mt):H?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":x&&(lt=">="+ct+"."+gt+".0 <"+ct+"."+(+gt+1)+".0"),P("xRange return",lt),lt})}(nt,it)}).join(" ")}(ze,Ke),P("xrange",ze),ze=function(_e,it){return P("replaceStars",_e,it),_e.trim().replace(M[de],"")}(ze,Ke),P("stars",ze),ze}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ae){return!!Ae.match(ne)})),fe=fe.map(function(Ae){return new pe(Ae,K)})},Me.prototype.intersects=function(j,K){if(!(j instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ne){return j.set.some(function(fe){return fe.every(function(Ae){return ne.intersects(Ae,K)})})})})},e.toComparators=function(j,K){return new Me(j,K).set.map(function(J){return J.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new Pe(j,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],j))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(j,K,J){var ne=null,fe=null;try{var Ae=new Me(K,J)}catch{return null}return j.forEach(function(ze){Ae.test(ze)&&(ne&&fe.compare(ze)!==-1||(fe=new Pe(ne=ze,J)))}),ne},e.minSatisfying=function(j,K,J){var ne=null,fe=null;try{var Ae=new Me(K,J)}catch{return null}return j.forEach(function(ze){Ae.test(ze)&&(ne&&fe.compare(ze)!==1||(fe=new Pe(ne=ze,J)))}),ne},e.validRange=function(j,K){try{return new Me(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,J){return z(j,K,"<",J)},e.gtr=function(j,K,J){return z(j,K,">",J)},e.outside=z,e.prerelease=function(j,K){var J=re(j,K);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(j,K,J){return j=new Me(j,J),K=new Me(K,J),j.intersects(K)},e.coerce=function(j){if(j instanceof Pe)return j;if(typeof j!="string")return null;var K=j.match(M[g]);return K==null?null:re((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,C,P=oe.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function M(o){if(w===setTimeout)return setTimeout(o,0);if((w===O||!w)&&setTimeout)return w=setTimeout,setTimeout(o,0);try{return w(o,0)}catch{try{return w.call(null,o,0)}catch{return w.call(this,o,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:O}catch{w=O}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var p,c=[],R=!1,v=-1;function u(){R&&p&&(R=!1,p.length?c=p.concat(c):v=-1,c.length&&E())}function E(){if(!R){var o=M(u);R=!0;for(var a=c.length;a;){for(p=c,c=[];++v<a;)p&&p[v].run();v=-1,a=c.length}p=null,R=!1,function(h){if(C===clearTimeout)return clearTimeout(h);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(h);try{C(h)}catch{try{return C.call(null,h)}catch{return C.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||R||M(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ce[143],Ie([1,0,4,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,o,a,h,i,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,i=i|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>i&&(s=i-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=i,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,n=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:s,scrollTopChanged:n}}}e.$7s=O;class A extends C.$Vc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$je),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new R(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$8s=A;class M{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$9s=M;function p(E,d){const r=d-E;return function(o){return E+r*u(o)}}function c(E,d,r){return function(o){return o<r?E(o/r):d((o-r)/(1-r))}}class R{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,i;return d<r?(h=d+.75*o,i=r-.75*o):(h=d-.75*o,i=r+.75*o),c(p(d,h),p(i,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new M(o,a,!1)}return new M(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return R.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new R(d,r,a,o)}}e.$0s=R;function v(E){return Math.pow(E,3)}function u(E){return 1-v(1-E)}}),define(Ce[144],Ie([1,0,14,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=P,e.$xe=O,e.$ye=A,e.$ze=M,e.$Ae=c,e.$Be=R,e.$Ce=v,e.$De=u,e.$Ee=E,e.$Fe=d,e.$Ge=r,e.$He=o,e.$Ie=a,e.$Je=h,e.$Ke=i;function P(s){const n=s;return n?typeof n.read=="function":!1}function O(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(t=>typeof t=="function"):!1}function A(s){const n=s;return n?O(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function M(s,n){return new p(s,n)}class p{constructor(n,t){this.e=n,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(t=>t(n))}h(n){this.c.error.length===0?(0,w.$2)(n):this.c.error.slice(0).forEach(t=>t(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,t){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(n,t){if(this.a.destroyed)return;let m;switch(n){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const f=m.indexOf(t);f>=0&&m.splice(f,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,n){const t=[];let m;for(;(m=s.read())!==null;)t.push(m);return n(t)}function R(s,n,t){const m=[];let f;for(;(f=s.read())!==null&&m.length<t;)m.push(f);return f===null&&m.length>0?n(m):{read:()=>{if(m.length>0)return m.shift();if(typeof f<"u"){const l=f;return f=void 0,l}return s.read()}}}function v(s,n){return new Promise((t,m)=>{const f=[];u(s,{onData:l=>{n&&f.push(l)},onError:l=>{n?m(l):t(void 0)},onEnd:()=>{t(n?n(f):void 0)}})})}function u(s,n,t){s.on("error",m=>{t?.isCancellationRequested||n.onError(m)}),s.on("end",()=>{t?.isCancellationRequested||n.onEnd()}),s.on("data",m=>{t?.isCancellationRequested||n.onData(m)})}function E(s,n){return new Promise((t,m)=>{const f=new C.$Uc,l=[],$=y=>{if(l.push(y),l.length>n)return f.dispose(),s.pause(),t({stream:s,buffer:l,ended:!1})},I=y=>(f.dispose(),m(y)),D=()=>(f.dispose(),t({stream:s,buffer:l,ended:!0}));f.add((0,C.$Tc)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,C.$Tc)(()=>s.removeListener("end",D))),s.on("end",D),f.add((0,C.$Tc)(()=>s.removeListener("data",$))),s.on("data",$)})}function d(s,n){const t=M(n);return t.end(s),t}function r(){const s=M(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}function a(s,n,t){const m=M(t);return u(s,{onData:f=>m.write(n.data(f)),onError:f=>m.error(n.error?n.error(f):f),onEnd:()=>m.end()}),m}function h(s,n,t){let m=!1;return{read:()=>{const f=n.read();return m?f:(m=!0,f!==null?t([s,f]):s)}}}function i(s,n,t){let m=!1;const f=M(t);return u(n,{onData:l=>m?f.write(l):(m=!0,f.write(t([s,l]))),onError:l=>f.error(l),onEnd:()=>{m||(m=!0,f.write(s)),f.end()}}),f}}),define(Ce[23],Ie([1,0,47,144]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=R,e.$Oe=v,e.$Pe=u,e.$Qe=E,e.$Re=d,e.$Se=r,e.$Te=o,e.$Ue=a,e.$Ve=h,e.$We=i,e.$Xe=s,e.$Ye=n,e.$Ze=t,e.$1e=m,e.$2e=f,e.$3e=l,e.$4e=$,e.$5e=I,e.$6e=S,C=qe(C);const P=typeof Buffer<"u",O=new w.$W(()=>new Uint8Array(256));let A,M;class p{static alloc(g){return P?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return P&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(g)):(A||(A=new TextEncoder),new p(A.encode(g)))}static fromByteArray(g){const b=p.alloc(g.length);for(let L=0,T=g.length;L<T;L++)b.buffer[L]=g[L];return b}static concat(g,b){if(typeof b>"u"){b=0;for(let q=0,G=g.length;q<G;q++)b+=g[q].byteLength}const L=p.alloc(b);let T=0;for(let q=0,G=g.length;q<G;q++){const W=g[q];L.set(W,T),T+=W.byteLength}return L}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=p.alloc(this.byteLength);return g.set(this),g}toString(){return P?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(g,b){return new p(this.buffer.subarray(g,b))}set(g,b){if(g instanceof p)this.buffer.set(g.buffer,b);else if(g instanceof Uint8Array)this.buffer.set(g,b);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),b);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return u(this.buffer,g)}writeUInt32BE(g,b){E(this.buffer,g,b)}readUInt32LE(g){return d(this.buffer,g)}writeUInt32LE(g,b){r(this.buffer,g,b)}readUInt8(g){return o(this.buffer,g)}writeUInt8(g,b){a(this.buffer,g,b)}indexOf(g,b=0){return c(this.buffer,g instanceof p?g.buffer:g,b)}}e.$Le=p;function c(k,g,b=0){const L=g.byteLength,T=k.byteLength;if(L===0)return 0;if(L===1)return k.indexOf(g[0]);if(L>T-b)return-1;const q=O.value;q.fill(g.length);for(let V=0;V<g.length;V++)q[g[V]]=g.length-V-1;let G=b+g.length-1,W=G,N=-1;for(;G<T;)if(k[G]===g[W]){if(W===0){N=G;break}G--,W--}else G+=Math.max(g.length-W,q[k[G]]),W=g.length-1;return N}function R(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0}function v(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255}function u(k,g){return k[g]*2**24+k[g+1]*2**16+k[g+2]*2**8+k[g+3]}function E(k,g,b){k[b+3]=g,g=g>>>8,k[b+2]=g,g=g>>>8,k[b+1]=g,g=g>>>8,k[b]=g}function d(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0|k[g+2]<<16>>>0|k[g+3]<<24>>>0}function r(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255,g=g>>>8,k[b+2]=g&255,g=g>>>8,k[b+3]=g&255}function o(k,g){return k[g]}function a(k,g,b){k[b]=g}function h(k){return C.$Ae(k,g=>p.concat(g))}function i(k){return C.$He(k)}function s(k){return C.$Ce(k,g=>p.concat(g))}async function n(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await s(k.stream)])}function t(k){return C.$Fe(k,g=>p.concat(g))}function m(k){return C.$Ie(k,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}function f(k){return C.$ze(g=>p.concat(g),k)}function l(k,g){return C.$Je(k,g,b=>p.concat(b))}function $(k,g){return C.$Ke(k,g,b=>p.concat(b))}function I(k){let g=0,b=0,L=0;const T=new Uint8Array(Math.floor(k.length/4*3)),q=W=>{switch(b){case 3:T[L++]=g|W,b=0;break;case 2:T[L++]=g|W>>>2,g=W<<6,b=3;break;case 1:T[L++]=g|W>>>4,g=W<<4,b=2;break;default:g=W<<2,b=1}};for(let W=0;W<k.length;W++){const N=k.charCodeAt(W);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${k[W]}`)}}const G=L;for(;b>0;)q(0);return p.wrap(T).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:k},g=!0,b=!1){const L=b?y:D;let T="";const q=k.byteLength%3;let G=0;for(;G<k.byteLength-q;G+=3){const W=k[G+0],N=k[G+1],V=k[G+2];T+=L[W>>>2],T+=L[(W<<4|N>>>4)&63],T+=L[(N<<2|V>>>6)&63],T+=L[V&63]}if(q===1){const W=k[G+0];T+=L[W>>>2],T+=L[W<<4&63],g&&(T+="==")}else if(q===2){const W=k[G+0],N=k[G+1];T+=L[W>>>2],T+=L[(W<<4|N>>>4)&63],T+=L[N<<2&63],g&&(T+="=")}return T}}),define(Ce[145],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(Ce[35],Ie([1,0,98]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=P;var C;(function(A){function M(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=M})(C||(e.ThemeColor=C={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const i=M.exec(h.id);if(!i)return p(w.$2j.error);const[,s,n]=i,t=["codicon","codicon-"+s];return n&&t.push("codicon-modifier-"+n.substring(1)),t}A.asClassNameArray=p;function c(h){return p(h).join(" ")}A.asClassName=c;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||C.isThemeColor(h.color))}A.isThemeIcon=v;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const i=u.exec(h);if(!i)return;const[,s]=i;return{id:s}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function r(h,i){let s=h.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),i&&(s=`${s}~${i}`),{id:s}}A.modify=r;function o(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}A.getModifier=o;function a(h,i){return h.id===i.id&&h.color?.id===i.color?.id}A.isEqual=a})(O||(e.ThemeIcon=O={}))}),define(Ce[146],Ie([1,0,28,29,137,13]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.FuzzyScore=e.$Ek=e.$Dk=void 0,e.or=A,e.$Fk=p,e.$Gk=c,e.$Hk=u,e.$Ik=D,e.$Jk=y,e.$Kk=T,e.$Lk=q,e.$Mk=G,e.$Nk=W,e.$Ok=_,e.$Qk=le,e.$Rk=pe,e.$Sk=$e,O=qe(O);function A(...ke){return function(Re,Oe){for(let z=0,j=ke.length;z<j;z++){const K=ke[z](Re,Oe);if(K)return K}return null}}e.$Dk=M.bind(void 0,!1),e.$Ek=M.bind(void 0,!0);function M(ke,Re,Oe){if(!Oe||Oe.length<Re.length)return null;let z;return ke?z=O.$Ef(Oe,Re):z=Oe.indexOf(Re)===0,z?Re.length>0?[{start:0,end:Re.length}]:[]:null}function p(ke,Re){const Oe=Re.toLowerCase().indexOf(ke.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ke.length}]}function c(ke,Re){return R(ke.toLowerCase(),Re.toLowerCase(),0,0)}function R(ke,Re,Oe,z){if(Oe===ke.length)return[];if(z===Re.length)return null;if(ke[Oe]===Re[z]){let j=null;return(j=R(ke,Re,Oe+1,z+1))?n({start:z,end:z+1},j):null}return R(ke,Re,Oe,z+1)}function v(ke){return w.CharCode.a<=ke&&ke<=w.CharCode.z}function u(ke){return w.CharCode.A<=ke&&ke<=w.CharCode.Z}function E(ke){return w.CharCode.Digit0<=ke&&ke<=w.CharCode.Digit9}function d(ke){return ke===w.CharCode.Space||ke===w.CharCode.Tab||ke===w.CharCode.LineFeed||ke===w.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>r.add(ke.charCodeAt(0)));function o(ke){return d(ke)||r.has(ke)}function a(ke,Re){return ke===Re||o(ke)&&o(Re)}const h=new Map;function i(ke){if(h.has(ke))return h.get(ke);let Re;const Oe=(0,P.$Bk)(ke);return Oe&&(Re=Oe),h.set(ke,Re),Re}function s(ke){return v(ke)||u(ke)||E(ke)}function n(ke,Re){return Re.length===0?Re=[ke]:ke.end===Re[0].start?Re[0].start=ke.start:Re.unshift(ke),Re}function t(ke,Re){for(let Oe=Re;Oe<ke.length;Oe++){const z=ke.charCodeAt(Oe);if(u(z)||E(z)||Oe>0&&!s(ke.charCodeAt(Oe-1)))return Oe}return ke.length}function m(ke,Re,Oe,z){if(Oe===ke.length)return[];if(z===Re.length)return null;if(ke[Oe]!==Re[z].toLowerCase())return null;{let j=null,K=z+1;for(j=m(ke,Re,Oe+1,z+1);!j&&(K=t(Re,K))<Re.length;)j=m(ke,Re,Oe+1,K),K++;return j===null?null:n({start:z,end:z+1},j)}}function f(ke){let Re=0,Oe=0,z=0,j=0,K=0;for(let ze=0;ze<ke.length;ze++)K=ke.charCodeAt(ze),u(K)&&Re++,v(K)&&Oe++,s(K)&&z++,E(K)&&j++;const J=Re/ke.length,ne=Oe/ke.length,fe=z/ke.length,Ae=j/ke.length;return{upperPercent:J,lowerPercent:ne,alphaPercent:fe,numericPercent:Ae}}function l(ke){const{upperPercent:Re,lowerPercent:Oe}=ke;return Oe===0&&Re>.6}function $(ke){const{upperPercent:Re,lowerPercent:Oe,alphaPercent:z,numericPercent:j}=ke;return Oe>.2&&Re<.8&&z>.6&&j<.2}function I(ke){let Re=0,Oe=0,z=0,j=0;for(let K=0;K<ke.length;K++)z=ke.charCodeAt(K),u(z)&&Re++,v(z)&&Oe++,d(z)&&j++;return(Re===0||Oe===0)&&j===0?ke.length<=30:Re<=5}function D(ke,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(ke))return null;Re.length>60&&(Re=Re.substring(0,60));const Oe=f(Re);if(!$(Oe)){if(!l(Oe))return null;Re=Re.toLowerCase()}let z=null,j=0;for(ke=ke.toLowerCase();j<Re.length&&(z=m(ke,Re,0,j))===null;)j=t(Re,j+1);return z}function y(ke,Re,Oe=!1){if(!Re||Re.length===0)return null;let z=null,j=0;for(ke=ke.toLowerCase(),Re=Re.toLowerCase();j<Re.length&&(z=S(ke,Re,0,j,Oe),z===null);)j=k(Re,j+1);return z}function S(ke,Re,Oe,z,j){let K=0;if(Oe===ke.length)return[];if(z===Re.length)return null;if(!a(ke.charCodeAt(Oe),Re.charCodeAt(z))){const fe=i(ke.charCodeAt(Oe));if(!fe)return null;for(let Ae=0;Ae<fe.length;Ae++)if(!a(fe[Ae],Re.charCodeAt(z+Ae)))return null;K+=fe.length-1}let J=null,ne=z+K+1;if(J=S(ke,Re,Oe+1,ne,j),!j)for(;!J&&(ne=k(Re,ne))<Re.length;)J=S(ke,Re,Oe+1,ne,j),ne++;if(!J)return null;if(ke.charCodeAt(Oe)!==Re.charCodeAt(z)){const fe=i(ke.charCodeAt(Oe));if(!fe)return J;for(let Ae=0;Ae<fe.length;Ae++)if(fe[Ae]!==Re.charCodeAt(z+Ae))return J}return n({start:z,end:z+K+1},J)}function k(ke,Re){for(let Oe=Re;Oe<ke.length;Oe++)if(o(ke.charCodeAt(Oe))||Oe>0&&o(ke.charCodeAt(Oe-1)))return Oe;return ke.length}const g=A(e.$Ek,D,p),b=A(e.$Ek,D,c),L=new C.$Ec(1e4);function T(ke,Re,Oe=!1){if(typeof ke!="string"||typeof Re!="string")return null;let z=L.get(ke);z||(z=new RegExp(O.$mf(ke),"i"),L.set(ke,z));const j=z.exec(Re);return j?[{start:j.index,end:j.index+j[0].length}]:Oe?b(ke,Re):g(ke,Re)}function q(ke,Re){const Oe=le(ke,ke.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?W(Oe):null}function G(ke,Re,Oe,z,j,K){const J=Math.min(13,ke.length);for(;Oe<J;Oe++){const ne=le(ke,Re,Oe,z,j,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,K]}function W(ke){if(typeof ke>"u")return[];const Re=[],Oe=ke[1];for(let z=ke.length-1;z>1;z--){const j=ke[z]+Oe,K=Re[Re.length-1];K&&K.end===j?K.end=j+1:Re.push({start:j,end:j+1})}return Re}const N=128;function V(){const ke=[],Re=[];for(let Oe=0;Oe<=N;Oe++)Re[Oe]=0;for(let Oe=0;Oe<=N;Oe++)ke.push(Re.slice(0));return ke}function ce(ke){const Re=[];for(let Oe=0;Oe<=ke;Oe++)Re[Oe]=0;return Re}const ge=ce(2*N),ie=ce(2*N),me=V(),se=V(),de=V(),be=!1;function re(ke,Re,Oe,z,j){function K(ne,fe,Ae=" "){for(;ne.length<fe;)ne=Ae+ne;return ne}let J=` |   |${z.split("").map(ne=>K(ne,3)).join("|")}
`;for(let ne=0;ne<=Oe;ne++)ne===0?J+=" |":J+=`${Re[ne-1]}|`,J+=ke[ne].slice(0,j+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return J}function Pe(ke,Re,Oe,z){ke=ke.substr(Re),Oe=Oe.substr(z),console.log(re(se,ke,ke.length,Oe,Oe.length)),console.log(re(de,ke,ke.length,Oe,Oe.length)),console.log(re(me,ke,ke.length,Oe,Oe.length))}function Le(ke,Re){if(Re<0||Re>=ke.length)return!1;const Oe=ke.codePointAt(Re);switch(Oe){case w.CharCode.Underline:case w.CharCode.Dash:case w.CharCode.Period:case w.CharCode.Space:case w.CharCode.Slash:case w.CharCode.Backslash:case w.CharCode.SingleQuote:case w.CharCode.DoubleQuote:case w.CharCode.Colon:case w.CharCode.DollarSign:case w.CharCode.LessThan:case w.CharCode.GreaterThan:case w.CharCode.OpenParen:case w.CharCode.CloseParen:case w.CharCode.OpenSquareBracket:case w.CharCode.CloseSquareBracket:case w.CharCode.OpenCurlyBrace:case w.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Wf(Oe)}}function Y(ke,Re){if(Re<0||Re>=ke.length)return!1;switch(ke.charCodeAt(Re)){case w.CharCode.Space:case w.CharCode.Tab:return!0;default:return!1}}function B(ke,Re,Oe){return Re[ke]!==Oe[ke]}function _(ke,Re,Oe,z,j,K,J=!1){for(;Re<Oe&&j<K;)ke[Re]===z[j]&&(J&&(ge[Re]=j),Re+=1),j+=1;return Re===Oe}var we;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(we||(we={}));var ae;(function(ke){ke.Default=[-100,0];function Re(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ke.isDefault=Re})(ae||(e.FuzzyScore=ae={}));class ve{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Oe){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Oe}}e.$Pk=ve;function le(ke,Re,Oe,z,j,K,J=ve.default){const ne=ke.length>N?N:ke.length,fe=z.length>N?N:z.length;if(Oe>=ne||K>=fe||ne-Oe>fe-K||!_(Re,Oe,ne,j,K,fe,!0))return;X(ne,fe,Oe,K,Re,j);let Ae=1,ze=1,Ke=Oe,_e=K;const it=[!1];for(Ae=1,Ke=Oe;Ke<ne;Ae++,Ke++){const lt=ge[Ke],st=ie[Ke],ct=Ke+1<ne?ie[Ke+1]:fe;for(ze=lt-K+1,_e=lt;_e<ct;ze++,_e++){let gt=Number.MIN_SAFE_INTEGER,mt=!1;_e<=st&&(gt=Z(ke,Re,Ke,Oe,z,j,_e,fe,K,me[Ae-1][ze-1]===0,it));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(mt=!0,Be=gt+se[Ae-1][ze-1]);const Ue=_e>lt,H=Ue?se[Ae][ze-1]+(me[Ae][ze-1]>0?-5:0):0,x=_e>lt+1&&me[Ae][ze-1]>0,De=x?se[Ae][ze-2]+(me[Ae][ze-2]>0?-5:0):0;if(x&&(!Ue||De>=H)&&(!mt||De>=Be))se[Ae][ze]=De,de[Ae][ze]=we.LeftLeft,me[Ae][ze]=0;else if(Ue&&(!mt||H>=Be))se[Ae][ze]=H,de[Ae][ze]=we.Left,me[Ae][ze]=0;else if(mt)se[Ae][ze]=Be,de[Ae][ze]=we.Diag,me[Ae][ze]=me[Ae-1][ze-1]+1;else throw new Error("not possible")}}if(be&&Pe(ke,Oe,z,K),!it[0]&&!J.firstMatchCanBeWeak)return;Ae--,ze--;const nt=[se[Ae][ze],K];let tt=0,rt=0;for(;Ae>=1;){let lt=ze;do{const st=de[Ae][lt];if(st===we.LeftLeft)lt=lt-2;else if(st===we.Left)lt=lt-1;else break}while(lt>=1);tt>1&&Re[Oe+Ae-1]===j[K+ze-1]&&!B(lt+K-1,z,j)&&tt+1>me[Ae][lt]&&(lt=ze),lt===ze?tt++:tt=1,rt||(rt=lt),Ae--,ze=lt-1,nt.push(ze)}fe-K===ne&&J.boostFullMatch&&(nt[0]+=2);const $t=rt-ne;return nt[0]-=$t,nt}function X(ke,Re,Oe,z,j,K){let J=ke-1,ne=Re-1;for(;J>=Oe&&ne>=z;)j[J]===K[ne]&&(ie[J]=ne,J--),ne--}function Z(ke,Re,Oe,z,j,K,J,ne,fe,Ae,ze){if(Re[Oe]!==K[J])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return J===Oe-z?Ke=ke[Oe]===j[J]?7:5:B(J,j,K)&&(J===0||!B(J-1,j,K))?(Ke=ke[Oe]===j[J]?7:5,_e=!0):Le(K,J)&&(J===0||!Le(K,J-1))?Ke=5:(Le(K,J-1)||Y(K,J-1))&&(Ke=5,_e=!0),Ke>1&&Oe===z&&(ze[0]=!0),_e||(_e=B(J,j,K)||Le(K,J-1)||Y(K,J-1)),Oe===z?J>fe&&(Ke-=_e?3:5):Ae?Ke+=_e?2:0:Ke+=_e?0:1,J+1===ne&&(Ke-=_e?3:5),Ke}function pe(ke,Re,Oe,z,j,K,J){return Me(ke,Re,Oe,z,j,K,!0,J)}function $e(ke,Re,Oe,z,j,K,J){return Me(ke,Re,Oe,z,j,K,!1,J)}function Me(ke,Re,Oe,z,j,K,J,ne){let fe=le(ke,Re,Oe,z,j,K,ne);if(fe&&!J)return fe;if(ke.length>=3){const Ae=Math.min(7,ke.length-1);for(let ze=Oe+1;ze<Ae;ze++){const Ke=je(ke,ze);if(Ke){const _e=le(Ke,Ke.toLowerCase(),Oe,z,j,K,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function je(ke,Re){if(Re+1>=ke.length)return;const Oe=ke[Re],z=ke[Re+1];if(Oe!==z)return ke.slice(0,Re)+z+Oe+ke.slice(Re+2)}}),define(Ce[99],Ie([1,0,146,13,35]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=p,e.$Uk=R,e.$Vk=u,e.$Wk=E,e.$Xk=r,e.$Yk=o;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),M=new RegExp(`(\\\\)?${A.source}`,"g");function p(a){return a.replace(M,(h,i)=>i?h:`\\${h}`)}const c=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(c,h=>`\\${h}`)}const v=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(a){return a.indexOf(O)===-1?a:a.replace(v,(h,i,s,n)=>s?h:i||n||"")}function E(a){return a?a.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const i=[];let s=0;for(;;){const n=d.lastIndex,t=d.exec(a),m=a.substring(n,t?.index);if(m.length>0){h+=m;for(let f=0;f<m.length;f++)i.push(s)}if(!t)break;s+=t[0].length}return{text:h,iconOffsets:i}}function o(a,h,i=!1){const{text:s,iconOffsets:n}=h;if(!n||n.length===0)return(0,w.$Kk)(a,s,i);const t=(0,C.$kf)(s," "),m=s.length-t.length,f=(0,w.$Kk)(a,t,i);if(f)for(const l of f){const $=n[l.start+m]+m;l.start+=$,l.end+=$}return f}}),define(Ce[36],Ie([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w=qe(w);var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const O="error",A="warning",M="warn",p="info",c="ignore";function R(u){return u?w.$Df(O,u)?P.Error:w.$Df(A,u)||w.$Df(M,u)?P.Warning:w.$Df(p,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function v(u){switch(u){case P.Error:return O;case P.Warning:return A;case P.Info:return p;default:return c}}P.toString=v}(C||(C={})),e.default=C}),define(Ce[59],Ie([1,0,18,28,13]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Ei=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===C.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$xf)(d,this.b,0,d.length,this.c,this.d):(0,P.$zf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=A;class M{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===C.CharCode.Slash||this.f&&o===C.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===C.CharCode.Slash||this.f&&r===C.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$xf)(d,this.b,0,d.length,this.d,this.e):(0,P.$zf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=M;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new M(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,P.$yf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$yf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,P.$wf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$wf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(v||(v={}));class u{static forUris(d=()=>!1,r=()=>!1){return new u(new c(d,r))}static forPaths(d=!1){return new u(new M(void 0,!d))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,w.$Xb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,w.$Xb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new R,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new R,a.left.segment=o.value()),h.push([v.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new R,a.right.segment=o.value()),h.push([v.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new R,a.mid.segment=o.value()),h.push([v.Mid,a]),a=a.mid;else break}const i=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const n=h[s][1];n.updateHeight();const t=n.balanceFactor();if(t<-1||t>1){const m=h[s][0],f=h[s+1][0];if(m===v.Right&&f===v.Right)h[s][1]=n.rotateLeft();else if(m===v.Left&&f===v.Left)h[s][1]=n.rotateRight();else if(m===v.Right&&f===v.Left)n.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=n.rotateLeft();else if(m===v.Left&&f===v.Right)n.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case v.Left:h[s-1][1].left=h[s][1];break;case v.Right:h[s-1][1].right=h[s][1];break;case v.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const i=o.cmp(h.segment);if(i>0)a.push([v.Left,h]),h=h.left;else if(i<0)a.push([v.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([v.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:s,value:n,segment:t}=i;this.e(i.key,!1),h.key=s,h.value=n,h.segment=t}}else{const i=h.left??h.right;if(a.length>0){const[s,n]=a[a.length-1];switch(s){case v.Left:n.left=i;break;case v.Mid:n.mid=i;break;case v.Right:n.right=i;break}}else this.c=i}for(let i=a.length-1;i>=0;i--){const s=a[i][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[i][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[i][1]=s.rotateRight()),i>0)switch(a[i-1][0]){case v.Left:a[i-1][1].left=a[i][1];break;case v.Right:a[i-1][1].right=a[i][1];break;case v.Mid:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Ii=u}),define(Ce[37],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=C;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return w.test(P)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(M){for(let p=0;p<M.length;p++)M[p]=Math.floor(Math.random()*256);return M};const O=new Uint8Array(16),A=[];for(let M=0;M<256;M++)A.push(M.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,c="";return c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c+="-",c+=A[O[p++]],c+=A[O[p++]],c+="-",c+=A[O[p++]],c+=A[O[p++]],c+="-",c+=A[O[p++]],c+=A[O[p++]],c+="-",c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c+=A[O[p++]],c}}()}),define(Ce[147],Ie([1,0,18,40,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$hu=void 0,e.$fu=O,e.$gu=A,e.$iu=c;function O(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function A(v,u,E){const d={id:(0,P.$Yg)(),name:v,uri:u,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class M{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return C.Iterable.some(this,([d,r])=>r.asFile())&&E.push("files"),R(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const d=this.a.get(u);d?d.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const d of E)yield[u,d]}b(u){return p(u)}}e.$hu=M;function p(v){return v.toLowerCase()}function c(v,u){return R(p(v),u.map(p))}function R(v,u){if(v==="*/*")return u.length>0;if(u.includes(v))return!0;const E=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,r,o]=E;return o==="*"?u.some(a=>a.startsWith(r+"/")):!1}e.$ju=Object.freeze({create:v=>(0,w.$Nb)(v.map(u=>u.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$ju.split(v).filter(u=>!u.startsWith("#"))})}),define(Ce[148],Ie([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$pu=P;var C;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function P(O){let A=0,M=0,p=0,c=C.Unknown;for(let R=0,v=O.length;R<v;R++){const u=O.charCodeAt(R);u===w.CharCode.CarriageReturn?(A===0&&(M=R),A++,R+1<v&&O.charCodeAt(R+1)===w.CharCode.LineFeed?(c|=C.CRLF,R++):c|=C.Invalid,p=R+1):u===w.CharCode.LineFeed&&(c|=C.LF,A===0&&(M=R),A++,p=R+1)}return A===0&&(M=O.length),[A,M,O.length-p,c]}}),define(Ce[149],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0,e.$ct={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[150],Ie([1,0,28,151]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nu=e.$Mu=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let R=0,v=c.notIn.length;R<v;R++)switch(c.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case C.StandardTokenType.Other:return!0;case C.StandardTokenType.Comment:return this.c;case C.StandardTokenType.String:return this.b;case C.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,R){if(c.getTokenCount()===0)return!0;const v=c.findTokenIndexAtOffset(R-2),u=c.getStandardTokenType(v);return this.isOK(u)}g(c,R){for(let v=c;v<=R;v++){const u=String.fromCharCode(v);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(w.CharCode.Digit0,w.CharCode.Digit9)),this.e||(this.e=this.g(w.CharCode.a,w.CharCode.z)),this.e||(this.e=this.g(w.CharCode.A,w.CharCode.Z))),this.e}}e.$Mu=O;class A{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of c)M(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),M(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),M(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),M(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&M(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Nu=A;function M(p,c,R){p.has(c)?p.get(c).push(R):p.set(c,[R])}}),define(Ce[152],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.NodeColor=e.$WC=void 0,e.$YC=P,e.$ZC=O,e.$1C=c,e.$2C=R,e.$3C=v,e.$4C=u,e.$5C=E,e.$6C=d;class w{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$XC)return P(this.right);let o=this;for(;o.parent!==e.$XC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$XC?e.$XC:o.parent}prev(){if(this.left!==e.$XC)return O(this.left);let o=this;for(;o.parent!==e.$XC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$XC?e.$XC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$WC=w;var C;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(C||(e.NodeColor=C={})),e.$XC=new w(null,C.Black),e.$XC.parent=e.$XC,e.$XC.left=e.$XC,e.$XC.right=e.$XC,e.$XC.color=C.Black;function P(r){for(;r.left!==e.$XC;)r=r.left;return r}function O(r){for(;r.right!==e.$XC;)r=r.right;return r}function A(r){return r===e.$XC?0:r.size_left+r.piece.length+A(r.right)}function M(r){return r===e.$XC?0:r.lf_left+r.piece.lineFeedCnt+M(r.right)}function p(){e.$XC.parent=e.$XC}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$XC&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$XC?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function R(r,o){const a=o.left;o.left=a.right,a.right!==e.$XC&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$XC?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function v(r,o){let a,h;if(o.left===e.$XC?(h=o,a=h.right):o.right===e.$XC?(h=o,a=h.left):(h=P(o.right),a=h.right),h===r.root){r.root=a,a.color=C.Black,o.detach(),p(),r.root.parent=e.$XC;return}const i=h.color===C.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$XC&&(h.left.parent=h),h.right!==e.$XC&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const n=A(a),t=M(a);if(n!==a.parent.size_left||t!==a.parent.lf_left){const m=n-a.parent.size_left,f=t-a.parent.lf_left;a.parent.size_left=n,a.parent.lf_left=t,E(r,a.parent,m,f)}}if(d(r,a.parent),i){p();return}let s;for(;a!==r.root&&a.color===C.Black;)a===a.parent.left?(s=a.parent.right,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,c(r,a.parent),s=a.parent.right),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.right.color===C.Black&&(s.left.color=C.Black,s.color=C.Red,R(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=C.Black,s.right.color=C.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,R(r,a.parent),s=a.parent.left),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.left.color===C.Black&&(s.right.color=C.Black,s.color=C.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=C.Black,s.left.color=C.Black,R(r,a.parent),a=r.root));a.color=C.Black,p()}function u(r,o){for(d(r,o);o!==r.root&&o.parent.color===C.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,R(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,c(r,o.parent.parent))}r.root.color=C.Black}function E(r,o,a,h){for(;o!==r.root&&o!==e.$XC;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,h=M(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(Ce[100],Ie([1,0,28,101,33,52,152,102]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=void 0,e.$aD=v,e.$bD=u;const p=65535;function c(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class R{constructor(i,s,n,t,m){this.lineStarts=i,this.cr=s,this.lf=n,this.crlf=t,this.isBasicASCII=m}}function v(h,i=!0){const s=[0];let n=1;for(let t=0,m=h.length;t<m;t++){const f=h.charCodeAt(t);f===w.CharCode.CarriageReturn?t+1<m&&h.charCodeAt(t+1)===w.CharCode.LineFeed?(s[n++]=t+2,t++):s[n++]=t+1:f===w.CharCode.LineFeed&&(s[n++]=t+1)}return i?c(s):s}function u(h,i){h.length=0,h[0]=0;let s=1,n=0,t=0,m=0,f=!0;for(let $=0,I=i.length;$<I;$++){const D=i.charCodeAt($);D===w.CharCode.CarriageReturn?$+1<I&&i.charCodeAt($+1)===w.CharCode.LineFeed?(m++,h[s++]=$+2,$++):(n++,h[s++]=$+1):D===w.CharCode.LineFeed?(t++,h[s++]=$+1):f&&D!==w.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const l=new R(c(h),n,t,m,f);return h.length=0,l}class E{constructor(i,s,n,t,m){this.bufferIndex=i,this.start=s,this.end=n,this.lineFeedCnt=t,this.length=m}}e.$cD=E;class d{constructor(i,s){this.buffer=i,this.lineStarts=s}}e.$dD=d;class r{constructor(i,s){this.a=[],this.c=i,this.d=s,this.b=0,i.root!==A.$XC&&i.iterate(i.root,n=>(n!==A.$XC&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let s=!1;const n=this.b;for(let t=0;t<n.length;t++){const m=n[t];if(m.node.parent===null||m.nodeStartOffset>=i){n[t]=null,s=!0;continue}}if(s){const t=[];for(const m of n)m!==null&&t.push(m);this.b=t}}}class a{constructor(i,s,n){this.create(i,s,n)}create(i,s,n){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$XC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=n;let t=null;for(let m=0,f=i.length;m<f;m++)if(i[m].buffer.length>0){i[m].lineStarts||(i[m].lineStarts=v(i[m].buffer));const l=new E(m+1,{line:0,column:0},{line:i[m].lineStarts.length-1,column:i[m].buffer.length-i[m].lineStarts[i[m].lineStarts.length-1]},i[m].lineStarts.length-1,i[m].buffer.length);this.a.push(i[m]),t=this.S(t,l)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const s=p,n=s-Math.floor(s/3),t=n*2;let m="",f=0;const l=[];if(this.iterate(this.root,$=>{const I=this.R($),D=I.length;if(f<=n||f+D<t)return m+=I,f+=D,!0;const y=m.replace(/\r\n|\r|\n/g,i);return l.push(new d(y,v(y))),m=I,f=D,!0}),f>0){const $=m.replace(/\r\n|\r|\n/g,i);l.push(new d($,v($)))}this.create(l,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let s=0;return this.iterate(this.root,t=>{if(t===A.$XC)return!0;const m=this.R(t),f=m.length,l=i.G(s),$=i.G(s+f),I=i.getValueInRange2(l,$);return s+=f,m===I})}getOffsetAt(i,s){let n=0,t=this.root;for(;t!==A.$XC;)if(t.left!==A.$XC&&t.lf_left+1>=i)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=i){n+=t.size_left;const m=this.B(t,i-t.lf_left-2);return n+=m+s-1}else i-=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let s=this.root,n=0;const t=i;for(;s!==A.$XC;)if(s.size_left!==0&&s.size_left>=i)s=s.left;else if(s.size_left+s.piece.length>=i){const m=this.A(s,i-s.size_left);if(n+=s.lf_left+m.index,m.index===0){const f=this.getOffsetAt(n+1,1),l=t-f;return new C.$Et(n+1,l+1)}return new C.$Et(n+1,m.remainder+1)}else if(i-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$XC){const m=this.getOffsetAt(n+1,1),f=t-i-m;return new C.$Et(n+1,f+1)}else s=s.right;return new C.$Et(1,1)}getValueInRange(i,s){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),t=this.H(i.endLineNumber,i.endColumn),m=this.getValueInRange2(n,t);return s?s!==this.d||!this.f?m.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?m:m.replace(/\r\n|\r|\n/g,s):m}getValueInRange2(i,s){if(i.node===s.node){const l=i.node,$=this.a[l.piece.bufferIndex].buffer,I=this.u(l.piece.bufferIndex,l.piece.start);return $.substring(I+i.remainder,I+s.remainder)}let n=i.node;const t=this.a[n.piece.bufferIndex].buffer,m=this.u(n.piece.bufferIndex,n.piece.start);let f=t.substring(m+i.remainder,m+n.piece.length);for(n=n.next();n!==A.$XC;){const l=this.a[n.piece.bufferIndex].buffer,$=this.u(n.piece.bufferIndex,n.piece.start);if(n===s.node){f+=l.substring($,$+s.remainder);break}else f+=l.substr($,n.piece.length);n=n.next()}return f}getLinesContent(){const i=[];let s=0,n="",t=!1;return this.iterate(this.root,m=>{if(m===A.$XC)return!0;const f=m.piece;let l=f.length;if(l===0)return!0;const $=this.a[f.bufferIndex].buffer,I=this.a[f.bufferIndex].lineStarts,D=f.start.line,y=f.end.line;let S=I[D]+f.start.column;if(t&&($.charCodeAt(S)===w.CharCode.LineFeed&&(S++,l--),i[s++]=n,n="",t=!1,l===0))return!0;if(D===y)return!this.f&&$.charCodeAt(S+l-1)===w.CharCode.CarriageReturn?(t=!0,n+=$.substr(S,l-1)):n+=$.substr(S,l),!0;n+=this.f?$.substring(S,Math.max(S,I[D+1]-this.e)):$.substring(S,I[D+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=n;for(let k=D+1;k<y;k++)n=this.f?$.substring(I[k],I[k+1]-this.e):$.substring(I[k],I[k+1]).replace(/(\r\n|\r|\n)$/,""),i[s++]=n;return!this.f&&$.charCodeAt(I[y]+f.end.column-1)===w.CharCode.CarriageReturn?(t=!0,f.end.column===0?s--:n=$.substr(I[y],f.end.column-1)):n=$.substr(I[y],f.end.column),!0}),t&&(i[s++]=n,n=""),i[s++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const s=i.node.next();if(!s)return 0;const n=this.a[s.piece.bufferIndex],t=this.u(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(t)}else{const s=this.a[i.node.piece.bufferIndex],t=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return s.buffer.charCodeAt(t)}}getLineCharCode(i,s){const n=this.H(i,s+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const s=this.getOffsetAt(i,1);return this.getLength()-s}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const s=this.G(i);return this.l(s)}findMatchesInNode(i,s,n,t,m,f,l,$,I,D,y){const S=this.a[i.piece.bufferIndex],k=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,m),b=this.u(i.piece.bufferIndex,f);let L;const T={line:0,column:0};let q,G;s._wordSeparators?(q=S.buffer.substring(g,b),G=W=>W+g,s.reset(0)):(q=S.buffer,G=W=>W,s.reset(g));do if(L=s.next(q),L){if(G(L.index)>=b)return D;this.s(i,G(L.index)-k,T);const W=this.t(i.piece.bufferIndex,m,T),N=T.line===m.line?T.column-m.column+t:T.column+1,V=N+L[0].length;if(y[D++]=(0,M.$9C)(new P.$Ft(n+W,N,n+W,V),L,$),G(L.index)+L[0].length>=b||D>=I)return D}while(L);return D}findMatchesLineByLine(i,s,n,t){const m=[];let f=0;const l=new M.$_C(s.wordSeparators,s.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const I=this.H(i.endLineNumber,i.endColumn);if(I===null)return[];let D=this.s($.node,$.remainder);const y=this.s(I.node,I.remainder);if($.node===I.node)return this.findMatchesInNode($.node,l,i.startLineNumber,i.startColumn,D,y,s,n,t,f,m),m;let S=i.startLineNumber,k=$.node;for(;k!==I.node;){const b=this.t(k.piece.bufferIndex,D,k.piece.end);if(b>=1){const T=this.a[k.piece.bufferIndex].lineStarts,q=this.u(k.piece.bufferIndex,k.piece.start),G=T[D.line+b],W=S===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(k,l,S,W,D,this.s(k,G-q),s,n,t,f,m),f>=t)return m;S+=b}const L=S===i.startLineNumber?i.startColumn-1:0;if(S===i.endLineNumber){const T=this.getLineContent(S).substring(L,i.endColumn-1);return f=this.n(s,l,T,i.endLineNumber,L,f,m,n,t),m}if(f=this.n(s,l,this.getLineContent(S).substr(L),S,L,f,m,n,t),f>=t)return m;S++,$=this.H(S,1),k=$.node,D=this.s($.node,$.remainder)}if(S===i.endLineNumber){const b=S===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(S).substring(b,i.endColumn-1);return f=this.n(s,l,L,i.endLineNumber,b,f,m,n,t),m}const g=S===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(I.node,l,S,g,D,y,s,n,t,f,m),m}n(i,s,n,t,m,f,l,$,I){const D=i.wordSeparators;if(!$&&i.simpleSearch){const S=i.simpleSearch,k=S.length,g=n.length;let b=-k;for(;(b=n.indexOf(S,b+k))!==-1;)if((!D||(0,M.$$C)(D,n,g,b,k))&&(l[f++]=new O.$7v(new P.$Ft(t,b+1+m,t,b+1+k+m),null),f>=I))return f;return f}let y;s.reset(0);do if(y=s.next(n),y&&(l[f++]=(0,M.$9C)(new P.$Ft(t,y.index+1+m,t,y.index+1+y[0].length+m),y,$),f>=I))return f;while(y);return f}insert(i,s,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==A.$XC){const{node:t,remainder:m,nodeStartOffset:f}=this.G(i),l=t.piece,$=l.bufferIndex,I=this.s(t,m);if(t.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&f+l.length===i&&s.length<p){this.F(t,s),this.y();return}if(f===i)this.o(s,t),this.h.validate(i);else if(f+t.piece.length>i){const D=[];let y=new E(l.bufferIndex,I,l.end,this.t(l.bufferIndex,I,l.end),this.u($,l.end)-this.u($,I));if(this.K()&&this.M(s)&&this.I(t,m)===10){const b={line:y.start.line+1,column:0};y=new E(y.bufferIndex,b,y.end,this.t(y.bufferIndex,b,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(t,m-1)===13){const b=this.s(t,m-1);this.C(t,b),s="\r"+s,t.piece.length===0&&D.push(t)}else this.C(t,I);else this.C(t,I);const S=this.w(s);y.length>0&&this.S(t,y);let k=t;for(let g=0;g<S.length;g++)k=this.S(k,S[g]);this.v(D)}else this.q(s,t)}else{const t=this.w(s);let m=this.T(null,t[0]);for(let f=1;f<t.length;f++)m=this.S(m,t[f])}this.y()}delete(i,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$XC)return;const n=this.G(i),t=this.G(i+s),m=n.node,f=t.node;if(m===f){const S=this.s(m,n.remainder),k=this.s(m,t.remainder);if(n.nodeStartOffset===i){if(s===m.piece.length){const g=m.next();(0,A.$3C)(this,m),this.N(g),this.y();return}this.D(m,k),this.h.validate(i),this.N(m),this.y();return}if(n.nodeStartOffset+m.piece.length===i+s){this.C(m,S),this.O(m),this.y();return}this.E(m,S,k),this.y();return}const l=[],$=this.s(m,n.remainder);this.C(m,$),this.h.validate(i),m.piece.length===0&&l.push(m);const I=this.s(f,t.remainder);this.D(f,I),f.piece.length===0&&l.push(f);const D=m.next();for(let S=D;S!==A.$XC&&S!==f;S=S.next())l.push(S);const y=m.piece.length===0?m.prev():m;this.v(l),this.O(y),this.y()}o(i,s){const n=[];if(this.K()&&this.M(i)&&this.L(s)){const f=s.piece,l={line:f.start.line+1,column:0},$=new E(f.bufferIndex,l,f.end,this.t(f.bufferIndex,l,f.end),f.length-1);s.piece=$,i+=`
`,(0,A.$5C)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const t=this.w(i);let m=this.T(s,t[t.length-1]);for(let f=t.length-2;f>=0;f--)m=this.T(m,t[f]);this.N(m),this.v(n)}q(i,s){this.Q(i,s)&&(i+=`
`);const n=this.w(i),t=this.S(s,n[0]);let m=t;for(let f=1;f<n.length;f++)m=this.S(m,n[f]);this.N(t)}s(i,s,n){const t=i.piece,m=i.piece.bufferIndex,f=this.a[m].lineStarts,$=f[t.start.line]+t.start.column+s;let I=t.start.line,D=t.end.line,y=0,S=0,k=0;for(;I<=D&&(y=I+(D-I)/2|0,k=f[y],y!==D);)if(S=f[y+1],$<k)D=y-1;else if($>=S)I=y+1;else break;return n?(n.line=y,n.column=$-k,null):{line:y,column:$-k}}t(i,s,n){if(n.column===0)return n.line-s.line;const t=this.a[i].lineStarts;if(n.line===t.length-1)return n.line-s.line;const m=t[n.line+1],f=t[n.line]+n.column;if(m>f+1)return n.line-s.line;const l=f-1;return this.a[i].buffer.charCodeAt(l)===13?n.line-s.line+1:n.line-s.line}u(i,s){return this.a[i].lineStarts[s.line]+s.column}v(i){for(let s=0;s<i.length;s++)(0,A.$3C)(this,i[s])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const S=i.charCodeAt(p-1);let k;S===w.CharCode.CarriageReturn||S>=55296&&S<=56319?(k=i.substring(0,p-1),i=i.substring(p-1)):(k=i.substring(0,p),i=i.substring(p));const g=v(k);D.push(new E(this.a.length,{line:0,column:0},{line:g.length-1,column:k.length-g[g.length-1]},g.length-1,k.length)),this.a.push(new d(k,g))}const y=v(i);return D.push(new E(this.a.length,{line:0,column:0},{line:y.length-1,column:i.length-y[y.length-1]},y.length-1,i.length)),this.a.push(new d(i,y)),D}let s=this.a[0].buffer.length;const n=v(i,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let D=0;D<n.length;D++)n[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,s+=1}else{if(s!==0)for(let D=0;D<n.length;D++)n[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const m=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,l=m-this.a[0].lineStarts[f],$={line:f,column:l},I=new E(0,t,$,this.t(0,t,$),m-s);return this.g=$,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,s=0){let n=this.root,t="";const m=this.h.get2(i);if(m){n=m.node;const f=this.B(n,i-m.nodeStartLineNumber-1),l=this.a[n.piece.bufferIndex].buffer,$=this.u(n.piece.bufferIndex,n.piece.start);if(m.nodeStartLineNumber+n.piece.lineFeedCnt===i)t=l.substring($+f,$+n.piece.length);else{const I=this.B(n,i-m.nodeStartLineNumber);return l.substring($+f,$+I-s)}}else{let f=0;const l=i;for(;n!==A.$XC;)if(n.left!==A.$XC&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const $=this.B(n,i-n.lf_left-2),I=this.B(n,i-n.lf_left-1),D=this.a[n.piece.bufferIndex].buffer,y=this.u(n.piece.bufferIndex,n.piece.start);return f+=n.size_left,this.h.set({node:n,nodeStartOffset:f,nodeStartLineNumber:l-(i-1-n.lf_left)}),D.substring(y+$,y+I-s)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const $=this.B(n,i-n.lf_left-2),I=this.a[n.piece.bufferIndex].buffer,D=this.u(n.piece.bufferIndex,n.piece.start);t=I.substring(D+$,D+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,f+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==A.$XC;){const f=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const l=this.B(n,0),$=this.u(n.piece.bufferIndex,n.piece.start);return t+=f.substring($,$+l-s),t}else{const l=this.u(n.piece.bufferIndex,n.piece.start);t+=f.substr(l,n.piece.length)}n=n.next()}return t}y(){let i=this.root,s=1,n=0;for(;i!==A.$XC;)s+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=s,this.c=n,this.h.validate(this.c)}A(i,s){const n=i.piece,t=this.s(i,s),m=t.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===s){const f=this.t(i.piece.bufferIndex,n.start,t);if(f!==m)return{index:f,remainder:0}}return{index:m,remainder:t.column}}B(i,s){if(s<0)return 0;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,m=n.start.line+s+1;return m>n.end.line?t[n.end.line]+n.end.column-t[n.start.line]-n.start.column:t[m]-t[n.start.line]-n.start.column}C(i,s){const n=i.piece,t=n.lineFeedCnt,m=this.u(n.bufferIndex,n.end),f=s,l=this.u(n.bufferIndex,f),$=this.t(n.bufferIndex,n.start,f),I=$-t,D=l-m,y=n.length+D;i.piece=new E(n.bufferIndex,n.start,f,$,y),(0,A.$5C)(this,i,D,I)}D(i,s){const n=i.piece,t=n.lineFeedCnt,m=this.u(n.bufferIndex,n.start),f=s,l=this.t(n.bufferIndex,f,n.end),$=this.u(n.bufferIndex,f),I=l-t,D=m-$,y=n.length+D;i.piece=new E(n.bufferIndex,f,n.end,l,y),(0,A.$5C)(this,i,D,I)}E(i,s,n){const t=i.piece,m=t.start,f=t.end,l=t.length,$=t.lineFeedCnt,I=s,D=this.t(t.bufferIndex,t.start,I),y=this.u(t.bufferIndex,s)-this.u(t.bufferIndex,m);i.piece=new E(t.bufferIndex,t.start,I,D,y),(0,A.$5C)(this,i,y-l,D-$);const S=new E(t.bufferIndex,n,f,this.t(t.bufferIndex,n,f),this.u(t.bufferIndex,f)-this.u(t.bufferIndex,n)),k=this.S(i,S);this.N(k)}F(i,s){this.Q(s,i)&&(s+=`
`);const n=this.K()&&this.L(s)&&this.M(i),t=this.a[0].buffer.length;this.a[0].buffer+=s;const m=v(s,!1);for(let k=0;k<m.length;k++)m[k]+=t;if(n){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(m.slice(1));const f=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[f],$={line:f,column:l},I=i.piece.length+s.length,D=i.piece.lineFeedCnt,y=this.t(0,i.piece.start,$),S=y-D;i.piece=new E(i.piece.bufferIndex,i.piece.start,$,y,I),this.g=$,(0,A.$5C)(this,i,s.length,S)}G(i){let s=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let t=0;for(;s!==A.$XC;)if(s.size_left>i)s=s.left;else if(s.size_left+s.piece.length>=i){t+=s.size_left;const m={node:s,remainder:i-s.size_left,nodeStartOffset:t};return this.h.set(m),m}else i-=s.size_left+s.piece.length,t+=s.size_left+s.piece.length,s=s.right;return null}H(i,s){let n=this.root,t=0;for(;n!==A.$XC;)if(n.left!==A.$XC&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const m=this.B(n,i-n.lf_left-2),f=this.B(n,i-n.lf_left-1);return t+=n.size_left,{node:n,remainder:Math.min(m+s-1,f),nodeStartOffset:t}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const m=this.B(n,i-n.lf_left-2);if(m+s-1<=n.piece.length)return{node:n,remainder:m+s-1,nodeStartOffset:t};s-=n.piece.length-m;break}else i-=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==A.$XC;){if(n.piece.lineFeedCnt>0){const m=this.B(n,0),f=this.J(n);return{node:n,remainder:Math.min(s-1,m),nodeStartOffset:f}}else if(n.piece.length>=s-1){const m=this.J(n);return{node:n,remainder:s-1,nodeStartOffset:m}}else s-=n.piece.length;n=n.next()}return null}I(i,s){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],t=this.u(i.piece.bufferIndex,i.piece.start)+s;return n.buffer.charCodeAt(t)}J(i){if(!i)return 0;let s=i.size_left;for(;i!==this.root;)i.parent.right===i&&(s+=i.parent.size_left+i.parent.piece.length),i=i.parent;return s}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$XC||i.piece.lineFeedCnt===0)return!1;const s=i.piece,n=this.a[s.bufferIndex].lineStarts,t=s.start.line,m=n[t]+s.start.column;return t===n.length-1||n[t+1]>m+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(m)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$XC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const s=i.prev();this.M(s)&&this.P(s,i)}}O(i){if(this.K()&&this.M(i)){const s=i.next();this.L(s)&&this.P(i,s)}}P(i,s){const n=[],t=this.a[i.piece.bufferIndex].lineStarts;let m;i.piece.end.column===0?m={line:i.piece.end.line-1,column:t[i.piece.end.line]-t[i.piece.end.line-1]-1}:m={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,l=i.piece.lineFeedCnt-1;i.piece=new E(i.piece.bufferIndex,i.piece.start,m,l,f),(0,A.$5C)(this,i,-1,-1),i.piece.length===0&&n.push(i);const $={line:s.piece.start.line+1,column:0},I=s.piece.length-1,D=this.t(s.piece.bufferIndex,$,s.piece.end);s.piece=new E(s.piece.bufferIndex,$,s.piece.end,D,I),(0,A.$5C)(this,s,-1,-1),s.piece.length===0&&n.push(s);const y=this.w(`\r
`);this.S(i,y[0]);for(let S=0;S<n.length;S++)(0,A.$3C)(this,n[S])}Q(i,s){if(this.K()&&this.M(i)){const n=s.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,A.$3C)(this,n);else{const t=n.piece,m={line:t.start.line+1,column:0},f=t.length-1,l=this.t(t.bufferIndex,m,t.end);n.piece=new E(t.bufferIndex,m,t.end,l,f),(0,A.$5C)(this,n,-1,-1)}return!0}}return!1}iterate(i,s){if(i===A.$XC)return s(A.$XC);const n=this.iterate(i.left,s);return n&&s(i)&&this.iterate(i.right,s)}R(i){if(i===A.$XC)return"";const s=this.a[i.piece.bufferIndex],n=i.piece,t=this.u(n.bufferIndex,n.start),m=this.u(n.bufferIndex,n.end);return s.buffer.substring(t,m)}getPieceContent(i){const s=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),t=this.u(i.bufferIndex,i.end);return s.buffer.substring(n,t)}S(i,s){const n=new A.$WC(s,A.NodeColor.Red);if(n.left=A.$XC,n.right=A.$XC,n.parent=A.$XC,n.size_left=0,n.lf_left=0,this.root===A.$XC)this.root=n,n.color=A.NodeColor.Black;else if(i.right===A.$XC)i.right=n,n.parent=i;else{const m=(0,A.$YC)(i.right);m.left=n,n.parent=m}return(0,A.$4C)(this,n),n}T(i,s){const n=new A.$WC(s,A.NodeColor.Red);if(n.left=A.$XC,n.right=A.$XC,n.parent=A.$XC,n.size_left=0,n.lf_left=0,this.root===A.$XC)this.root=n,n.color=A.NodeColor.Black;else if(i.left===A.$XC)i.left=n,n.parent=i;else{const t=(0,A.$ZC)(i.left);t.right=n,n.parent=t}return(0,A.$4C)(this,n),n}U(i){let s="";return this.iterate(i,n=>(s+=this.R(n),!0)),s}}e.$eD=a}),define(Ce[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$=e.$I$=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$I$=w;class C{constructor(O){this.identifier=O}}e.$J$=C}),define(Ce[154],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[155],Ie([1,0,4,5,154]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=void 0,e.$mj=R,P=qe(P);class O extends C.$Vc{constructor(u,E="",d="",r=!0,o){super(),this.j=this.B(new w.$je),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$hj=O;class A extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new w.$je),this.onWillRun=this.f.event,this.m=this.B(new w.$je),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,E)}catch(r){d=r}this.m.fire({action:u,error:d})}async u(u,E){await u.run(E)}}e.$ij=A;class M{constructor(){this.id=M.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const d of u)d.length&&(E.length?E=[...E,new M,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$jj=M;class p{get actions(){return this.a}constructor(u,E,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=r,this.a=d}async run(){}}e.$kj=p;class c extends O{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$lj=c;function R(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...u)=>v.run(...u)}}}),define(Ce[156],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[157],Ie([1,0,156]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=c,e.$Ym=R,e.$Zm=v;const C=60,P=C*60,O=P*24,A=O*7,M=O*30,p=O*365;function c(u,E,d,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,w.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,w.localize)(1,null);let a;return o<C?(a=o,E?a===1?d?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):d?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a):a===1?d?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):d?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):o<P?(a=Math.floor(o/C),E?a===1?d?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):d?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a):a===1?d?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):d?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):o<O?(a=Math.floor(o/P),E?a===1?d?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):d?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a):a===1?d?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):d?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):o<A?(a=Math.floor(o/O),E?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a)):o<M?(a=Math.floor(o/A),E?a===1?d?(0,w.localize)(30,null,a):(0,w.localize)(31,null,a):d?(0,w.localize)(32,null,a):(0,w.localize)(33,null,a):a===1?d?(0,w.localize)(34,null,a):(0,w.localize)(35,null,a):d?(0,w.localize)(36,null,a):(0,w.localize)(37,null,a)):o<p?(a=Math.floor(o/M),E?a===1?d?(0,w.localize)(38,null,a):(0,w.localize)(39,null,a):d?(0,w.localize)(40,null,a):(0,w.localize)(41,null,a):a===1?d?(0,w.localize)(42,null,a):(0,w.localize)(43,null,a):d?(0,w.localize)(44,null,a):(0,w.localize)(45,null,a)):(a=Math.floor(o/p),E?a===1?d?(0,w.localize)(46,null,a):(0,w.localize)(47,null,a):d?(0,w.localize)(48,null,a):(0,w.localize)(49,null,a):a===1?d?(0,w.localize)(50,null,a):(0,w.localize)(51,null,a):d?(0,w.localize)(52,null,a):(0,w.localize)(53,null,a))}function R(u,E){const d=Math.abs(u/1e3);return d<1?E?(0,w.localize)(54,null,u):(0,w.localize)(55,null,u):d<C?E?(0,w.localize)(56,null,Math.round(u)/1e3):(0,w.localize)(57,null,Math.round(u)/1e3):d<P?E?(0,w.localize)(58,null,Math.round(u/(1e3*C))):(0,w.localize)(59,null,Math.round(u/(1e3*C))):d<O?E?(0,w.localize)(60,null,Math.round(u/(1e3*P))):(0,w.localize)(61,null,Math.round(u/(1e3*P))):(0,w.localize)(62,null,Math.round(u/(1e3*O)))}function v(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[158],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[48],Ie([1,0,18,15,158]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=p,e.$oj=c,e.$pj=R,w=qe(w),C=qe(C),P=qe(P);function O(v,u){return u&&(v.stack||v.stacktrace)?P.localize(0,null,M(v),A(v.stack)||A(v.stacktrace)):M(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function M(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function p(v=null,u=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const E=w.$Ib(v),d=p(E[0],u);return E.length>1?P.localize(4,null,d,E.length):d}if(C.$cg(v))return v;if(v.detail){const E=v.detail;if(E.error)return O(E.error,u);if(E.exception)return O(E.exception,u)}return v.stack?O(v,u):v.message?v.message:P.localize(5,null)}function c(v){const u=v;return u instanceof Error&&Array.isArray(u.actions)}function R(v,u){let E;return typeof v=="string"?E=new Error(v):E=v,E.actions=u,E}}),define(Ce[159],Ie([1,0,47,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=M,e.$sr=p,e.$tr=c,e.$ur=R,e.$vr=v,e.$wr=u,e.$xr=E,e.$yr=d,e.$zr=r,e.$Ar=o,e.$Br=$,e.$Cr=I,e.$Dr=D;const P=new w.$W(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),O=new w.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$W(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function M(y,S,k=!1){const g=y||"",b=S||"",L=P.value.collator.compare(g,b);return P.value.collatorIsNumeric&&L===0&&g!==b?g<b?-1:1:L}function p(y,S){const k=O.value.collator;return y=y||"",S=S||"",s(k,y,S)}function c(y,S){const k=O.value.collator;return y=y||"",S=S||"",f(y,S)||s(k,y,S)}function R(y,S){const k=O.value.collator;return y=y||"",S=S||"",m(y,S)||s(k,y,S)}function v(y,S){return y=y||"",S=S||"",y===S?0:y<S?-1:1}function u(y,S){const[k,g]=h(y),[b,L]=h(S);let T=P.value.collator.compare(g,L);if(T===0){if(P.value.collatorIsNumeric&&g!==L)return g<L?-1:1;if(T=P.value.collator.compare(k,b),P.value.collatorIsNumeric&&T===0&&k!==b)return k<b?-1:1}return T}function E(y,S){y=y||"",S=S||"";const k=i(y),g=i(S),b=O.value.collator,L=A.value.collator;return s(L,k,g)||s(b,y,S)}function d(y,S){y=y||"",S=S||"";const k=i(y),g=i(S),b=O.value.collator,L=A.value.collator;return s(L,k,g)||f(y,S)||s(b,y,S)}function r(y,S){y=y||"",S=S||"";const k=i(y),g=i(S),b=O.value.collator,L=A.value.collator;return s(L,k,g)||m(y,S)||s(b,y,S)}function o(y,S){y=y||"",S=S||"";const k=i(y).toLowerCase(),g=i(S).toLowerCase();return k!==g?k<g?-1:1:y!==S?y<S?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(y,S=!1){const k=y?a.exec(y):[];let g=[k&&k[1]||"",k&&k[3]||""];return S&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function i(y){const S=y?a.exec(y):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function s(y,S,k){const g=y.compare(S,k);return g!==0?g:S.length!==k.length?S.length<k.length?-1:1:0}function n(y){const S=y.charAt(0);return S.toLocaleUpperCase()!==S}function t(y){const S=y.charAt(0);return S.toLocaleLowerCase()!==S}function m(y,S){return n(y)&&t(S)?-1:t(y)&&n(S)?1:0}function f(y,S){return t(y)&&n(S)?-1:n(y)&&t(S)?1:0}function l(y,S,k=!1){return k||(y=y&&y.toLowerCase(),S=S&&S.toLowerCase()),y===S?0:y<S?-1:1}function $(y,S,k=!1){const g=y.split(C.sep),b=S.split(C.sep),L=g.length-1,T=b.length-1;let q,G;for(let W=0;;W++){if(q=L===W,G=T===W,q&&G)return M(g[W],b[W],k);if(q)return-1;if(G)return 1;const N=l(g[W],b[W],k);if(N!==0)return N}}function I(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),L=D(y,S,k);if(L)return L;const T=g.endsWith(k),q=b.endsWith(k);if(T!==q)return T?-1:1;const G=M(g,b);return G!==0?G:g.localeCompare(b)}function D(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),L=g.startsWith(k),T=b.startsWith(k);if(L!==T)return L?-1:1;if(L&&T){if(g.length<b.length)return-1;if(g.length>b.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=M,e.$vg=p,e.$wg=c,e.$xg=R,e.$yg=v,e.$zg=r,e.$Ag=o,e.$Bg=a,e.$Cg=h,e.$Dg=i,e.$Eg=s,e.$Fg=n,e.$Gg=t,e.$Hg=m,e.$Ig=f,e.$Jg=l,e.$Kg=D;function M(y){return y===w.CharCode.Slash||y===w.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,C.$hc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function R(y,S=C.$hc.sep){if(!y)return"";const k=y.length,g=y.charCodeAt(0);if(M(g)){if(M(y.charCodeAt(1))&&!M(y.charCodeAt(2))){let L=3;const T=L;for(;L<k&&!M(y.charCodeAt(L));L++);if(T!==L&&!M(y.charCodeAt(L+1))){for(L+=1;L<k;L++)if(M(y.charCodeAt(L)))return y.slice(0,L+1).replace(/[\\/]/g,S)}}return S}else if(h(g)&&y.charCodeAt(1)===w.CharCode.Colon)return M(y.charCodeAt(2))?y.slice(0,2)+S:y.slice(0,2);let b=y.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(M(y.charCodeAt(b)))return y.slice(0,b+1)}return""}function v(y){if(!P.$i||!y||y.length<5)return!1;let S=y.charCodeAt(0);if(S!==w.CharCode.Backslash||(S=y.charCodeAt(1),S!==w.CharCode.Backslash))return!1;let k=2;const g=k;for(;k<y.length&&(S=y.charCodeAt(k),S!==w.CharCode.Backslash);k++);return!(g===k||(S=y.charCodeAt(k+1),isNaN(S)||S===w.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(y,S=P.$i){const k=S?u:E;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||S&&d.test(y)||y==="."||y===".."||S&&y[y.length-1]==="."||S&&y.length!==y.trim().length||y.length>255)}function o(y,S,k){const g=y===S;return!k||g?g:!y||!S?!1:(0,O.$Df)(y,S)}function a(y,S,k,g=C.sep){if(y===S)return!0;if(!y||!S||S.length>y.length)return!1;if(k){if(!(0,O.$Ef)(y,S))return!1;if(S.length===y.length)return!0;let L=S.length;return S.charAt(S.length-1)===g&&L--,y.charAt(L)===g}return S.charAt(S.length-1)!==g&&(S+=g),y.indexOf(S)===0}function h(y){return y>=w.CharCode.A&&y<=w.CharCode.Z||y>=w.CharCode.a&&y<=w.CharCode.z}function i(y,S){return P.$i&&y.endsWith(":")&&(y+=C.sep),(0,C.$jc)(y)||(y=(0,C.$kc)(S,y)),y=(0,C.$ic)(y),s(y)}function s(y){return P.$i?(y=(0,O.$lf)(y,C.sep),y.endsWith(":")&&(y+=C.sep)):(y=(0,O.$lf)(y,C.sep),y||(y=C.sep)),y}function n(y){const S=(0,C.$ic)(y);return P.$i?y.length>3?!1:t(S)&&(y.length===2||S.charCodeAt(2)===w.CharCode.Backslash):S===C.$hc.sep}function t(y,S=P.$i){return S?h(y.charCodeAt(0))&&y.charCodeAt(1)===w.CharCode.Colon:!1}function m(y,S=P.$i){return t(y,S)?y[0]:void 0}function f(y,S,k){return S.length>y.length?-1:y===S?0:(k&&(y=y.toLowerCase(),S=S.toLowerCase()),y.indexOf(S))}function l(y){const S=y.split(":");let k,g,b;for(const L of S){const T=Number(L);(0,A.$gg)(T)?g===void 0?g=T:b===void 0&&(b=T):k=k?[k,L].join(":"):L}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:g!==void 0?g:void 0,column:b!==void 0?b:g!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,S,k=8){let g="";for(let L=0;L<k;L++){let T;L===0&&P.$i&&!S&&(k===3||k===4)?T=I:T=$,g+=T.charAt(Math.floor(Math.random()*T.length))}let b;return S?b=`${S}-${g}`:b=g,y?(0,C.$kc)(y,b):b}}),define(Ce[73],Ie([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,e.$3s=O,e.$4s=A,e.$5s=M,e.$6s=c,e.$2s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const v=(0,w.$pc)(R),u=C[v.toLowerCase()];return u!==void 0?u:A(R)}function A(R){const v=(0,w.$pc)(R);return P[v.toLowerCase()]}function M(R){for(const v in P)if(P[v]===R)return v}const p=/^(.+)\/(.+?)(;.+)?$/;function c(R,v){const u=p.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:v?void 0:R}}),define(Ce[49],Ie([1,0,23,2,38]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=O,e.$$h=A,e.$_h=p;function O(c){return JSON.stringify(c,M)}function A(c){let R=JSON.parse(c);return R=p(R),R}function M(c,R){return R instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(c,R=0){if(!c||R>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return C.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof w.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=p(c[v],R+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=p(c[v],R+1))}return c}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=p,e.$Mg=c,e.$Qg=v,w=qe(w),C=qe(C),A=qe(A);var M;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(M||(e.Schemas=M={}));function p(d,r){return O.URI.isUri(d)?(0,P.$Df)(d.scheme,r):(0,P.$Ef)(d,r+":")}function c(d,...r){return r.some(o=>p(d,o))}e.$Ng="vscode-tkn",e.$Og="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=v(r,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,M.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(n){return w.$2(n),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],i=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(s+=`&${e.$Og}=${encodeURIComponent(i)}`),O.URI.from({scheme:C.$o?this.d:M.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Pg=new R;function v(d,r){return A.$hc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class u{static{this.a=e.$Vg}asBrowserUri(r){const o=this.b(r,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===M.vscodeRemote?e.$Pg.rewrite(r):r.scheme===M.file&&(C.$m||C.$q===`${M.vscodeFileResource}://${u.a}`)?r.with({scheme:M.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,oe);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===M.vscodeFileResource?r.with({scheme:M.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.$Wg=new u;var E;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:O.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const n=s?.get(o);if(n)return r.get(n)}d.getHeadersFromQuery=a;function h(i,s,n){if(!globalThis.crossOriginIsolated)return;const t=s&&n?"3":n?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}d.addSearchParam=h})(E||(e.COI=E={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=v,e.$nh=E,C=qe(C),O=qe(O);function c(d){return(0,p.$xc)(d,!0)}class R{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,M.$wf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return C.$Bg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$ih)(r.authority,o.authority))return C.$Bg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return p.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$ah)(r)||r.authority}basename(r){return O.$hc.basename(r.path)}extname(r){return O.$hc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(O.$nc(c(r))).path:(o=O.$hc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==w.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(O.$ic(c(r))).path:o=O.$hc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$ih)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const i=O.$mc(c(r),c(o));return A.$i?C.$vg(i):i}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let i=0;for(const s=Math.min(a.length,h.length);i<s&&!(a.charCodeAt(i)!==h.charCodeAt(i)&&a.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);a=h.substr(0,i)+a.substr(i)}return O.$hc.relative(a,h)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=p.URI.file(O.$lc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=C.$wg(o),r.with({path:O.$hc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,M.$Df)(r,o)}hasTrailingPathSeparator(r,o=O.sep){if(r.scheme===P.Schemas.file){const a=c(r);return a.length>C.$xg(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===w.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=O.sep){return(0,e.$jh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=O.sep){let a=!1;if(r.scheme===P.Schemas.file){const h=c(r);a=h!==void 0&&h.length===C.$xg(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===w.CharCode.Slash}return!a&&!(0,e.$jh)(r,o)?r.with({path:r.path+"/"}):r}}e.$5g=R,e.$6g=new R(()=>!1),e.$7g=new R(d=>d.scheme===P.Schemas.file?!A.$k:!0),e.$8g=new R(d=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function v(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((i,s)=>s===a?!1:(0,e.$0g)(h,r(i)))||o.push(d[a])}return o}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,t]=s.split(":");n&&t&&a.set(n,t)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&a.set(d.META_DATA_MIME,i),a}d.parseMetaData=r})(u||(e.DataUri=u={}));function E(d,r,o){if(r){let a=d.path;return a&&a[0]!==O.$hc.sep&&(a=O.$hc.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(Ce[11],Ie([1,0,22,14,4,5,24,21,145,47]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=R,e.$ph=v,e.$qh=u,e.$rh=E,e.$sh=d,e.$th=r,e.$uh=o,e.$vh=a,e.$Dh=I,e.$Eh=D,e.$Fh=y,e.$Gh=S,e.$Hh=k,e.$Wh=me,e.$5h=ae;function R(le){return!!le&&typeof le.then=="function"}function v(le){const X=new w.$ue,Z=le(X.token),pe=new Promise(($e,Me)=>{const je=X.token.onCancellationRequested(()=>{je.dispose(),Me(new C.$6)});Promise.resolve(Z).then(ke=>{je.dispose(),X.dispose(),$e(ke)},ke=>{je.dispose(),X.dispose(),Me(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then($e,Me){return pe.then($e,Me)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function u(le,X,Z){return new Promise((pe,$e)=>{const Me=X.onCancellationRequested(()=>{Me.dispose(),pe(Z)});le.then(pe,$e).finally(()=>Me.dispose())})}function E(le,X){return new Promise((Z,pe)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),pe(new C.$6)});le.then(Z,pe).finally(()=>$e.dispose())})}async function d(le){let X=-1;const Z=le.map((pe,$e)=>pe.then(Me=>(X=$e,Me)));try{return await Promise.race(Z)}finally{le.forEach((pe,$e)=>{$e!==X&&pe.cancel()})}}function r(le,X,Z){let pe;const $e=setTimeout(()=>{pe?.(void 0),Z?.()},X);return Promise.race([le.finally(()=>clearTimeout($e)),new Promise(Me=>pe=Me)])}function o(le){return new Promise((X,Z)=>{const pe=le();R(pe)?pe.then(X,Z):X(pe)})}function a(){let le,X;return{promise:new Promise((pe,$e)=>{le=pe,X=$e}),resolve:le,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Z=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(Z,Z).then(pe)})}return new Promise((Z,pe)=>{this.b.then(Z,pe)})}return this.a=X(),new Promise((Z,pe)=>{this.a.then($e=>{this.a=null,Z($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$wh=h;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$xh=i;class s{constructor(){this.a=new Map}queue(X,Z){const $e=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(X)===$e&&this.a.delete(X)});return this.a.set(X,$e),$e}}e.$yh=s;const n=(le,X)=>{let Z=!0;const pe=setTimeout(()=>{Z=!1,X()},le);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(pe),Z=!1}}},t=le=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,le())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class m{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Z=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise(($e,Me)=>{this.d=$e,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=Z===p.$ee?t(pe):n(Z,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$6),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=m;class f{constructor(X){this.a=new m(X),this.b=new h}trigger(X,Z){return this.a.trigger(()=>this.b.queue(X),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=f;class l{constructor(){this.a=!1,this.b=new Promise((X,Z)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=l;class $ extends l{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ch=$;function I(le,X){return X?new Promise((Z,pe)=>{const $e=setTimeout(()=>{Me.dispose(),Z()},le),Me=X.onCancellationRequested(()=>{clearTimeout($e),Me.dispose(),pe(new C.$6)})}):v(Z=>I(le,Z))}function D(le,X=0,Z){const pe=setTimeout(()=>{le(),Z&&$e.dispose()},X),$e=(0,O.$Tc)(()=>{clearTimeout(pe),Z?.deleteAndLeak($e)});return Z?.add($e),$e}function y(le){const X=[];let Z=0;const pe=le.length;function $e(){return Z<pe?le[Z++]():null}function Me(je){je!=null&&X.push(je);const ke=$e();return ke?ke.then(Me):Promise.resolve(X)}return Promise.resolve(null).then(Me)}function S(le,X=pe=>!!pe,Z=null){let pe=0;const $e=le.length,Me=()=>{if(pe>=$e)return Promise.resolve(Z);const je=le[pe++];return Promise.resolve(je()).then(Re=>X(Re)?Promise.resolve(Re):Me())};return Me()}function k(le,X=pe=>!!pe,Z=null){if(le.length===0)return Promise.resolve(Z);let pe=le.length;const $e=()=>{pe=-1;for(const Me of le)Me.cancel?.()};return new Promise((Me,je)=>{for(const ke of le)ke.then(Re=>{--pe>=0&&X(Re)?($e(),Me(Re)):pe===0&&Me(Z)}).catch(Re=>{--pe>=0&&($e(),je(Re))})})}class g{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$je}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,pe)=>{this.g.push({factory:X,c:Z,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Z=X.factory();Z.then(X.c,X.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=g;class b extends g{constructor(){super(1)}}e.$Jh=b;class L{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Kh=L;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new re;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Z=A.$6g){const pe=Z.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,Z,pe=A.$6g){const $e=pe.getComparisonKey(X);let Me=this.a.get($e);if(!Me){Me=new b;const je=this.f++,ke=P.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(je),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(je,ke),this.a.set($e,Me)}return Me.queue(Z)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=T;class q{constructor(X,Z){this.b=!1,this.a=-1,typeof X=="function"&&typeof Z=="number"&&this.setIfNotSet(X,Z)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Z){if(this.b)throw new C.$db("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Z)}setIfNotSet(X,Z){if(this.b)throw new C.$db("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Z))}}e.$Mh=q;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Z,pe=globalThis){if(this.f)throw new C.$db("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{X()},Z);this.d=(0,O.$Tc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=G;class W{constructor(X,Z){this.b=-1,this.a=X,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=W;class N{constructor(X,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=X,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=N;class V extends W{constructor(X,Z){super(X,Z),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Qh=V;class ce extends O.$Vc{constructor(X,Z){super(),this.g=X,this.h=Z,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of X)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(le,X)=>{(0,M.$B)(()=>{if(Z)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Th=(le,X,Z)=>{const pe=le.requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let $e=!1;return{dispose(){$e||($e=!0,le.cancelIdleCallback(pe))}}},e.$Sh=le=>(0,e.$Th)(globalThis,le)}();class ge{constructor(X,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Th)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ge;class ie extends ge{constructor(X){super(globalThis,X)}}e.$Vh=ie;async function me(le,X,Z){let pe;for(let $e=0;$e<Z;$e++)try{return await le()}catch(Me){pe=Me,await I(X)}throw pe}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Z,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:Z},Z.then(()=>this.d(X),()=>this.d(X)),Z}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Z,resolve:pe,reject:$e}=a();this.b={run:X,promise:Z,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=se;class de{constructor(X,Z=()=>Date.now()){this.d=X,this.f=Z,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Yh=de;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class re{get isRejected(){return this.d?.outcome===be.Rejected}get isResolved(){return this.d?.outcome===be.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===be.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,Z)=>{this.a=X,this.b=Z})}complete(X){return new Promise(Z=>{this.a(X),this.d={outcome:be.Resolved,value:X},Z()})}error(X){return new Promise(Z=>{this.b(X),this.d={outcome:be.Rejected,value:X},Z()})}cancel(){return this.error(new C.$6)}}e.$Zh=re;var Pe;(function(le){async function X(pe){let $e;const Me=await Promise.all(pe.map(je=>je.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Me}le.settled=X;function Z(pe){return new Promise(async($e,Me)=>{try{await pe($e,Me)}catch(je){Me(je)}})}le.withAsyncBody=Z})(Pe||(e.Promises=Pe={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new C.$db("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=Le;class Y{constructor(X){this.b=X,this.a=new c.$W(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=Y;var B;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(B||(B={}));class _{static fromArray(X){return new _(Z=>{Z.emitMany(X)})}static fromPromise(X){return new _(async Z=>{Z.emitMany(await X)})}static fromPromises(X){return new _(async Z=>{await Promise.all(X.map(async pe=>Z.emitOne(await pe)))})}static merge(X){return new _(async Z=>{await Promise.all(X.map(async pe=>{for await(const $e of pe)Z.emitOne($e)}))})}static{this.EMPTY=_.fromArray([])}constructor(X,Z){this.a=B.Initial,this.b=[],this.d=null,this.f=Z,this.g=new P.$je,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(X(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Z){return new _(async pe=>{for await(const $e of X)pe.emitOne(Z($e))})}map(X){return _.map(this,X)}static filter(X,Z){return new _(async pe=>{for await(const $e of X)Z($e)&&pe.emitOne($e)})}filter(X){return _.filter(this,X)}static coalesce(X){return _.filter(X,Z=>!!Z)}coalesce(){return _.coalesce(this)}static async toPromise(X){const Z=[];for await(const pe of X)Z.push(pe);return Z}toPromise(){return _.toPromise(this)}h(X){this.a===B.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===B.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(X){this.a===B.Initial&&(this.a=B.DoneError,this.d=X,this.g.fire())}}e.$3h=_;class we extends _{constructor(X,Z){super(Z),this.m=X}cancel(){this.m.cancel()}}e.$4h=we;function ae(le){const X=new w.$ue,Z=le(X.token);return new we(X,async pe=>{const $e=X.token.onCancellationRequested(()=>{$e.dispose(),X.dispose(),pe.reject(new C.$6)});try{for await(const Me of Z){if(X.token.isCancellationRequested)return;pe.emitOne(Me)}$e.dispose(),X.dispose()}catch(Me){$e.dispose(),X.dispose(),pe.reject(Me)}})}class ve{constructor(X){this.a=new re,this.b=new _($e=>{if(Z){$e.reject(Z);return}return pe&&$e.emitMany(pe),this.d=Me=>$e.reject(Me),this.f=Me=>$e.emitOne(Me),this.a.p},X);let Z,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{Z||(Z=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$6h=ve}),define(Ce[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$rk=R,e.$uk=r,e.$vk=L,e.$wk=T,e.$xk=q,e.$yk=G,e.$zk=W,e.$Ak=ge;function R(){return Object.create(null)}e.$sk="**",e.$tk="/";const v="[/\\\\]",u="[^/\\\\]",E=/\//g;function d(ie,me){switch(ie){case 0:return"";case 1:return`${u}*?`;default:return`(?:${v}|${u}+${v}${me?`|${v}${u}+`:""})*?`}}function r(ie,me){if(!ie)return[];const se=[];let de=!1,be=!1,re="";for(const Pe of ie){switch(Pe){case me:if(!de&&!be){se.push(re),re="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":be=!0;break;case"]":be=!1;break}re+=Pe}return re&&se.push(re),se}function o(ie){if(!ie)return"";let me="";const se=r(ie,e.$tk);if(se.every(de=>de===e.$sk))me=".*";else{let de=!1;se.forEach((be,re)=>{if(be===e.$sk){if(de)return;me+=d(2,re===se.length-1)}else{let Pe=!1,Le="",Y=!1,B="";for(const _ of be){if(_!=="}"&&Pe){Le+=_;continue}if(Y&&(_!=="]"||!B)){let we;_==="-"?we=_:(_==="^"||_==="!")&&!B?we="^":_===e.$tk?we="":we=(0,c.$ff)(_),B+=we;continue}switch(_){case"{":Pe=!0;continue;case"[":Y=!0;continue;case"}":{const ae=`(?:${r(Le,",").map(ve=>o(ve)).join("|")})`;me+=ae,Pe=!1,Le="";break}case"]":{me+="["+B+"]",Y=!1,B="";break}case"?":me+=u;continue;case"*":me+=d(1);continue;default:me+=(0,c.$ff)(_)}}re<se.length-1&&(se[re+1]!==e.$sk||re+2<se.length)&&(me+=v)}de=be===e.$sk})}return me}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new A.$Ec(1e4),f=function(){return!1},l=function(){return null};function $(ie,me){if(!ie)return l;let se;typeof ie!="string"?se=ie.pattern:se=ie,se=se.trim();const de=`${se}_${!!me.trimForExclusions}`;let be=m.get(de);if(be)return I(be,ie);let re;return a.test(se)?be=y(se.substr(4),se):(re=h.exec(D(se,me)))?be=S(re[1],se):(me.trimForExclusions?s:i).test(se)?be=k(se,me):(re=n.exec(D(se,me)))?be=g(re[1].substr(1),se,!0):(re=t.exec(D(se,me)))?be=g(re[1],se,!1):be=b(se),m.set(de,be),I(be,ie)}function I(ie,me){if(typeof me=="string")return ie;const se=function(de,be){return(0,O.$Bg)(de,me.base,!p.$k)?ie((0,c.$kf)(de.substr(me.base.length),M.sep),be):null};return se.allBasenames=ie.allBasenames,se.allPaths=ie.allPaths,se.basenames=ie.basenames,se.patterns=ie.patterns,se}function D(ie,me){return me.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function y(ie,me){return function(se,de){return typeof se=="string"&&se.endsWith(ie)?me:null}}function S(ie,me){const se=`/${ie}`,de=`\\${ie}`,be=function(Pe,Le){return typeof Pe!="string"?null:Le?Le===ie?me:null:Pe===ie||Pe.endsWith(se)||Pe.endsWith(de)?me:null},re=[ie];return be.basenames=re,be.patterns=[me],be.allBasenames=re,be}function k(ie,me){const se=ce(ie.slice(1,-1).split(",").map(Le=>$(Le,me)).filter(Le=>Le!==l),ie),de=se.length;if(!de)return l;if(de===1)return se[0];const be=function(Le,Y){for(let B=0,_=se.length;B<_;B++)if(se[B](Le,Y))return ie;return null},re=se.find(Le=>!!Le.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return Pe.length&&(be.allPaths=Pe),be}function g(ie,me,se){const de=M.sep===M.$hc.sep,be=de?ie:ie.replace(E,M.sep),re=M.sep+be,Pe=M.$hc.sep+ie;let Le;return se?Le=function(Y,B){return typeof Y=="string"&&(Y===be||Y.endsWith(re)||!de&&(Y===ie||Y.endsWith(Pe)))?me:null}:Le=function(Y,B){return typeof Y=="string"&&(Y===be||!de&&Y===ie)?me:null},Le.allPaths=[(se?"*/":"./")+ie],Le}function b(ie){try{const me=new RegExp(`^${o(ie)}$`);return function(se){return me.lastIndex=0,typeof se=="string"&&me.test(se)?ie:null}}catch{return l}}function L(ie,me,se){return!ie||typeof me!="string"?!1:T(ie)(me,void 0,se)}function T(ie,me={}){if(!ie)return f;if(typeof ie=="string"||q(ie)){const se=$(ie,me);if(se===l)return f;const de=function(be,re){return!!se(be,re)};return se.allBasenames&&(de.allBasenames=se.allBasenames),se.allPaths&&(de.allPaths=se.allPaths),de}return N(ie,me)}function q(ie){const me=ie;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function G(ie){return ie.allBasenames||[]}function W(ie){return ie.allPaths||[]}function N(ie,me){const se=ce(Object.getOwnPropertyNames(ie).map(Le=>V(Le,ie[Le],me)).filter(Le=>Le!==l)),de=se.length;if(!de)return l;if(!se.some(Le=>!!Le.requiresSiblings)){if(de===1)return se[0];const Le=function(_,we){let ae;for(let ve=0,le=se.length;ve<le;ve++){const X=se[ve](_,we);if(typeof X=="string")return X;(0,C.$oh)(X)&&(ae||(ae=[]),ae.push(X))}return ae?(async()=>{for(const ve of ae){const le=await ve;if(typeof le=="string")return le}return null})():null},Y=se.find(_=>!!_.allBasenames);Y&&(Le.allBasenames=Y.allBasenames);const B=se.reduce((_,we)=>we.allPaths?_.concat(we.allPaths):_,[]);return B.length&&(Le.allPaths=B),Le}const be=function(Le,Y,B){let _,we;for(let ae=0,ve=se.length;ae<ve;ae++){const le=se[ae];le.requiresSiblings&&B&&(Y||(Y=(0,M.$oc)(Le)),_||(_=Y.substr(0,Y.length-(0,M.$pc)(Le).length)));const X=le(Le,Y,_,B);if(typeof X=="string")return X;(0,C.$oh)(X)&&(we||(we=[]),we.push(X))}return we?(async()=>{for(const ae of we){const ve=await ae;if(typeof ve=="string")return ve}return null})():null},re=se.find(Le=>!!Le.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return Pe.length&&(be.allPaths=Pe),be}function V(ie,me,se){if(me===!1)return l;const de=$(ie,se);if(de===l)return l;if(typeof me=="boolean")return de;if(me){const be=me.when;if(typeof be=="string"){const re=(Pe,Le,Y,B)=>{if(!B||!de(Pe,Le))return null;const _=be.replace("$(basename)",()=>Y),we=B(_);return(0,C.$oh)(we)?we.then(ae=>ae?ie:null):we?ie:null};return re.requiresSiblings=!0,re}}return de}function ce(ie,me){const se=ie.filter(Le=>!!Le.basenames);if(se.length<2)return ie;const de=se.reduce((Le,Y)=>{const B=Y.basenames;return B?Le.concat(B):Le},[]);let be;if(me){be=[];for(let Le=0,Y=de.length;Le<Y;Le++)be.push(me)}else be=se.reduce((Le,Y)=>{const B=Y.patterns;return B?Le.concat(B):Le},[]);const re=function(Le,Y){if(typeof Le!="string")return null;if(!Y){let _;for(_=Le.length;_>0;_--){const we=Le.charCodeAt(_-1);if(we===P.CharCode.Slash||we===P.CharCode.Backslash)break}Y=Le.substr(_)}const B=de.indexOf(Y);return B!==-1?be[B]:null};re.basenames=de,re.patterns=be,re.allBasenames=de;const Pe=ie.filter(Le=>!Le.basenames);return Pe.push(re),Pe}function ge(ie,me){return(0,w.$vb)(ie,me,(se,de)=>typeof se=="string"&&typeof de=="string"?se===de:typeof se!="string"&&typeof de!="string"?se.base===de.base&&se.pattern===de.pattern:!1)}}),define(Ce[60],Ie([1,0,14,99,24,13,2]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.MarkdownStringTextNewlineStyle=void 0,e.$1k=c,e.$2k=R,e.$3k=v,e.$4k=u,e.$5k=E,e.$6k=d,e.$7k=r,e.$8k=o;var M;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(M||(e.MarkdownStringTextNewlineStyle=M={}));class p{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,w.$8)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=M.Paragraph){return this.value+=u(this.supportThemeIcons?(0,C.$Tk)(h):h).replace(/([ \t]+)/g,(s,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===M.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${E(i,h)}
`,this}appendLink(h,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,i){const s=new RegExp((0,O.$ff)(i),"g");return h.replace(s,(n,t)=>h.charAt(t-1)!=="\\"?`\\${n}`:n)}}e.$Zk=p;function c(a){return R(a)?!a.value:Array.isArray(a)?a.every(c):!0}function R(a){return a instanceof p?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function v(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,P.$9g)(A.URI.from(a.baseUri),A.URI.from(h.baseUri)))}function u(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(a,h){const i=a.match(/^`+/gm)?.reduce((n,t)=>n.length>t.length?n:t).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],i=a.split("|").map(n=>n.trim());a=i[0];const s=i[1];if(s){const n=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),m=n?n[1]:"",f=t?t[1]:"",l=isFinite(parseInt(f)),$=isFinite(parseInt(m));l&&h.push(`width="${f}"`),$&&h.push(`height="${m}"`)}return{href:a,dimensions:h}}}),define(Ce[103],Ie([1,0,18,53,20,21,24,13]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pw=p,e.$Qw=R,e.$Rw=u,e.$Sw=E,e.$Tw=a,e.$Uw=i,e.$Vw=s,e.$Ww=n,e.$Xw=t,e.$Yw=m;function p(l,$){const{os:I,tildify:D,relative:y}=$;if(y){const g=c(l,y,I);if(typeof g=="string")return g}let S=l.fsPath;if(I===O.OperatingSystem.Windows&&!O.$i?S=S.replace(/\//g,"\\"):I!==O.OperatingSystem.Windows&&O.$i&&(S=S.replace(/\\/g,"/")),I!==O.OperatingSystem.Windows&&D?.userHome){const g=D.userHome.fsPath;let b;l.scheme!==D.userHome.scheme&&l.path[0]===P.$hc.sep&&l.path[1]!==P.$hc.sep?b=D.userHome.with({path:l.path}).fsPath:b=S,S=u(b,g,I)}return(I===O.OperatingSystem.Windows?P.$gc:P.$hc).normalize(R(S,I===O.OperatingSystem.Windows))}function c(l,$,I){const D=I===O.OperatingSystem.Windows?P.$gc:P.$hc,y=I===O.OperatingSystem.Linux?A.$6g:A.$8g,S=$.getWorkspace(),k=(0,w.$Pb)(S.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===P.$hc.sep&&l.path[1]!==P.$hc.sep&&(l=k.uri.with({path:l.path}));const g=$.getWorkspaceFolder(l);if(!g)return;let b;if(y.isEqual(g.uri,l)?b="":b=y.relativePath(g.uri,l)??"",b&&(b=D.normalize(b)),S.folders.length>1&&!$.noPrefix){const L=g.name?g.name:y.basenameOrAuthority(g.uri);b=b?`${L} \u2022 ${b}`:L}return b}function R(l,$=O.$i){return(0,C.$Gg)(l,$)?l.charAt(0).toUpperCase()+l.slice(1):l}let v=Object.create(null);function u(l,$,I=O.OS){if(I===O.OperatingSystem.Windows||!l||!$)return l;let D=v.original===$?v.normalized:void 0;D||(D=$,O.$i&&(D=(0,C.$vg)(D)),D=`${(0,M.$lf)(D,P.$hc.sep)}${P.$hc.sep}`,v={original:$,normalized:D});let y=l;return O.$i&&(y=(0,C.$vg)(y)),(I===O.OperatingSystem.Linux?y.startsWith(D):(0,M.$Ef)(y,D))?`~/${y.substr(D.length)}`:l}function E(l,$){return l.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",r="\\\\",o="~";function a(l,$=P.sep){const I=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const S=l[y];if(S===""){I[y]=`.${$}`;continue}if(!S){I[y]=S;continue}D=!0;let k="",g=S;g.indexOf(r)===0?(k=g.substr(0,g.indexOf(r)+r.length),g=g.substr(g.indexOf(r)+r.length)):g.indexOf($)===0?(k=g.substr(0,g.indexOf($)+$.length),g=g.substr(g.indexOf($)+$.length)):g.indexOf(o)===0&&(k=g.substr(0,g.indexOf(o)+o.length),g=g.substr(g.indexOf(o)+o.length));const b=g.split($);for(let L=1;D&&L<=b.length;L++)for(let T=b.length-L;D&&T>=0;T--){D=!1;let q=b.slice(T,T+L).join($);for(let G=0;!D&&G<l.length;G++)if(G!==y&&l[G]&&l[G].indexOf(q)>-1){const W=T+L===b.length,N=T>0&&l[G].indexOf($)>-1?$+q:q,V=l[G].endsWith(N);D=!W||V}if(!D){let G="";(b[0].endsWith(":")||k!=="")&&(T===1&&(T=0,L++,q=b[0]+$+q),T>0&&(G=b[0]+$),G=k+G),T>0&&(G=G+d+$),G=G+q,T+L<b.length&&(G=G+$+d),I[y]=G}}D&&(I[y]=S)}return I}var h;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(l,$=Object.create(null)){const I=[];let D=!1,y="";for(const S of l)if(S==="$"||D&&S==="{")y&&I.push({value:y,type:h.TEXT}),y="",D=!0;else if(S==="}"&&D){const k=$[y];if(typeof k=="string")k.length&&I.push({value:k,type:h.VARIABLE});else if(k){const g=I[I.length-1];(!g||g.type!==h.SEPARATOR)&&I.push({value:k.label,type:h.SEPARATOR})}y="",D=!1}else y+=S;return y&&!D&&I.push({value:y,type:h.TEXT}),I.filter((S,k)=>{if(S.type===h.SEPARATOR){const g=I[k-1],b=I[k+1];return[g,b].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(S=>S.value).join("")}function s(l,$){return O.$j||$?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):l.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function n(l,$){return O.$j||$?l.replace(/\(&&\w\)|&&/g,""):O.$i?l.replace(/&&|&/g,I=>I==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function m(l){if(l.endsWith("]")){const $=l.lastIndexOf(" [",l.length-2);if($!==-1){const I=f(l.substring(0,$)),D=l.substring($);return{name:I.name+D,parentPath:I.parentPath}}}return f(l)}function f(l){const $=l.indexOf("/")!==-1?P.$hc:P.$gc,I=$.basename(l),D=$.dirname(l);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[160],Ie([1,0,23,38,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=void 0,e.$In=p,e.$Jn=R,e.$Kn=v;function O(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:O(P.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:O(P.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:P.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Gn=A,e.$Hn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function M(u,E,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return E.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const o=M(u[r],E,d+1);o!==null&&(u[r]=o)}}return null}function p(u,E){const d=M(u,E,0);return d===null?u:d}function c(u,E,d,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===C.MarshalledId.Uri)return d?P.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof w.$Le)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const a=c(u[o],E,d,r+1);a!==null&&(u[o]=a)}}return null}function R(u,E){const d=c(u,E,!1,0);return d===null?u:d}function v(u,E){const d=c(u,E,!0,0);return d===null?u:d}}),define(Ce[161],Ie([1,0,11,4,5,49,15]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.StorageState=e.StorageHint=void 0,e.$7p=p;var M;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M||(e.StorageHint=M={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class R extends P.$Vc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new C.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new w.$Ah(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,r)=>this.w(r,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===c.Closed)return;let r=!1;(0,A.$lg)(d)?r=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const r=this.f.get(E);return(0,A.$lg)(r)?d:r}getBoolean(E,d){const r=this.get(E);return(0,A.$lg)(r)?d:r==="true"}getNumber(E,d){const r=this.get(E);return(0,A.$lg)(r)?d:parseInt(r,10)}getObject(E,d){const r=this.get(E);return(0,A.$lg)(r)?d:(0,O.$$h)(r)}async set(E,d,r=!1){if(this.c===c.Closed)return;if((0,A.$lg)(d))return this.delete(E,r);const o=(0,A.$eg)(d)||Array.isArray(d)?(0,O.$0h)(d):String(d);if(this.f.get(E)!==o)return this.f.set(E,o),this.j.set(E,o),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,d=!1){if(!(this.c===c.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===c.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===M.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===M.STORAGE_IN_MEMORY}}e.$8p=R;class v{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,r)=>this.a.set(r,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$9p=v}),define(Ce[162],Ie([1,0,13,21,23]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=void 0,e.$5t=R,e.$6t=v,w=qe(w),C=qe(C),P=qe(P);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let M;function p(){return M||(M=new TextDecoder("UTF-16BE")),M}let c;function R(){return c||(c=C.$D()?A():p()),c}function v(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?u(d,r,o):A().decode(a)}function u(d,r,o){const a=[];let h=0;for(let i=0;i<o;i++){const s=P.$Ne(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return R().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||w.$Hf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$7t=E}),define(Ce[163],Ie([1,0,23,162]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=void 0,e.$9t=A,w=qe(w);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,R,v,u){this.oldPosition=c,this.oldText=R,this.newPosition=v,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,R,v){const u=R.length;w.$Qe(c,u,v),v+=4;for(let E=0;E<u;E++)w.$Oe(c,R.charCodeAt(E),v),v+=2;return v}static d(c,R){const v=w.$Pe(c,R);return R+=4,(0,C.$6t)(c,R,v)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(c,R){return w.$Qe(c,this.oldPosition,R),R+=4,w.$Qe(c,this.newPosition,R),R+=4,R=O.c(c,this.oldText,R),R=O.c(c,this.newText,R),R}static read(c,R,v){const u=w.$Pe(c,R);R+=4;const E=w.$Pe(c,R);R+=4;const d=O.d(c,R);R+=O.a(d);const r=O.d(c,R);return R+=O.a(r),v.push(new O(u,d,E,r)),R}}e.$8t=O;function A(p,c){return p===null||p.length===0?c:new M(p,c).compress()}class M{constructor(c,R){this.a=c,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,R=0,v=this.n(c),u=this.l(R);for(;c<this.f||R<this.h;){if(v===null){this.k(u),u=this.l(++R);continue}if(u===null){this.m(v),v=this.n(++c);continue}if(u.oldEnd<=v.newPosition){this.k(u),u=this.l(++R);continue}if(v.newEnd<=u.oldPosition){this.m(v),v=this.n(++c);continue}if(u.oldPosition<v.newPosition){const[a,h]=M.r(u,v.newPosition-u.oldPosition);this.k(a),u=h;continue}if(v.newPosition<u.oldPosition){const[a,h]=M.q(v,u.oldPosition-v.newPosition);this.m(a),v=h;continue}let r,o;if(u.oldEnd===v.newEnd)r=v,o=u,v=this.n(++c),u=this.l(++R);else if(u.oldEnd<v.newEnd){const[a,h]=M.q(v,u.oldLength);r=a,o=u,v=h,u=this.l(++R)}else{const[a,h]=M.r(u,v.newLength);r=v,o=a,v=this.n(++c),u=h}this.d[this.e++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const E=M.s(this.d);return M.t(E)}k(c){this.d[this.e++]=M.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=M.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,R){return new O(R.oldPosition-c,R.oldText,R.newPosition,R.newText)}static p(c,R){return new O(R.oldPosition,R.oldText,R.newPosition+c,R.newText)}static q(c,R){const v=c.newText.substr(0,R),u=c.newText.substr(R);return[new O(c.oldPosition,c.oldText,c.newPosition,v),new O(c.oldEnd,"",c.newPosition+R,u)]}static r(c,R){const v=c.oldText.substr(0,R),u=c.oldText.substr(R);return[new O(c.oldPosition,v,c.newPosition,c.newText),new O(c.oldPosition+R,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const R=[];let v=0,u=c[0];for(let E=1;E<c.length;E++){const d=c[E];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(R[v++]=u,u=d)}return R[v++]=u,R}static t(c){if(c.length===0)return c;const R=[];let v=0;for(let u=0;u<c.length;u++){const E=c[u];E.oldText!==E.newText&&(R[v++]=E)}return R}}}),define(Ce[164],Ie([1,0,41,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=P,e.$nu=O;function P(A,M,p,c,R,v){if(Array.isArray(A)){let u=0;for(const E of A){const d=P(E,M,p,c,R,v);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return c?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:d,hasAccessToAllModels:r,notebookType:o}=A;if(!c&&!r)return 0;o&&R&&(M=R);let a=0;if(d)if(d===M.scheme)a=10;else if(d==="*")a=5;else return 0;if(u)if(u===p)a=10;else if(u==="*")a=Math.max(a,5);else return 0;if(o)if(o===v)a=10;else if(o==="*"&&v!==void 0)a=Math.max(a,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,C.$ic)(E.base)},h===M.fsPath||(0,w.$vk)(h,M.fsPath))a=10;else return 0}return a}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ce[165],Ie([1,0,4,13,33,52,100,148,163,5]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0,C=qe(C);class R extends c.$Vc{constructor(u,E,d,r,o,a,h){super(),this.m=this.B(new w.$je),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=r,this.h=o,this.c=new A.$eD(u,d,h)}equals(u){return!(u instanceof R)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const d=u+E,r=this.getPositionAt(u),o=this.getPositionAt(d);return new P.$Ft(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,E=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const a=this.n(E),h=this.getEOL();if(a.length!==h.length){const i=a.length-h.length,s=u.endLineNumber-u.startLineNumber;o=i*s}return r-d+o}getCharacterCountInRange(u,E=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=u.startLineNumber,o=u.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),i=a===r?u.startColumn-1:0,s=a===o?u.endColumn-1:h.length;for(let n=i;n<s;n++)C.$Hf(h.charCodeAt(n))?(d=d+1,n=n+1):d=d+1}return d+=this.n(E).length*(o-r),d}return this.getValueLengthInRange(u,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=C.$sf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=C.$uf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,d){let r=this.g,o=this.h,a=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const I=u[$];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let b=!0;a||(b=!C.$Sf(I.text),a=b),!r&&b&&(r=C.$Rf(I.text)),!o&&b&&(o=C.$Uf(I.text))}let y="",S=0,k=0,g=0;if(I.text){let b;[S,k,g,b]=(0,M.$pu)(I.text);const L=this.getEOL(),T=L===`\r
`?M.StringEOL.CRLF:M.StringEOL.LF;b===M.StringEOL.Unknown||b===T?y=I.text:y=I.text.replace(/\r\n|\r|\n/g,L)}i[$]={sortIndex:$,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:S,firstLineLength:k,lastLineLength:g,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}i.sort(R.u);let s=!1;for(let $=0,I=i.length-1;$<I;$++){const D=i[$].range.getEndPosition(),y=i[$+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(i=this.s(i));const n=d||E?R._getInverseEditRanges(i):[],t=[];if(E)for(let $=0;$<i.length;$++){const I=i[$],D=n[$];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let S="";y===D.startLineNumber&&(S=this.getLineContent(I.range.startLineNumber),C.$sf(S)!==-1)||t.push({lineNumber:y,oldContent:S})}}let m=null;if(d){let $=0;m=[];for(let I=0;I<i.length;I++){const D=i[I],y=n[I],S=this.getValueInRange(D.range),k=D.rangeOffset+$;$+=D.text.length-S.length,m[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:S,textChange:new p.$8t(D.rangeOffset,S,k,D.text)}}s||m.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(i);let l=null;if(E&&t.length>0){t.sort(($,I)=>I.lineNumber-$.lineNumber),l=[];for(let $=0,I=t.length;$<I;$++){const D=t[$].lineNumber;if($>0&&t[$-1].lineNumber===D)continue;const y=t[$].oldContent,S=this.getLineContent(D);S.length===0||S===y||C.$sf(S)!==-1||l.push(D)}}return this.m.fire(),new O.$$v(m,f,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const d=u[0].range,r=u[u.length-1].range,o=new P.$Ft(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const i=[];for(let f=0,l=u.length;f<l;f++){const $=u[f],I=$.range;E=E||$.forceMoveMarkers,i.push(this.getValueInRange(new P.$Ft(a,h,I.startLineNumber,I.startColumn))),$.text.length>0&&i.push($.text),a=I.endLineNumber,h=I.endColumn}const s=i.join(""),[n,t,m]=(0,M.$pu)(s);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:s,eolCount:n,firstLineLength:t,lastLineLength:m,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(R.w);const E=[];for(let d=0;d<u.length;d++){const r=u[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,i=r.range.endColumn;if(o===h&&a===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new P.$Ft(o,a,h,i);E.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,d,r){return this.c.findMatchesLineByLine(u,E,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const d=u.startLineNumber,r=u.startColumn,[o,a,h]=(0,M.$pu)(E);let i;if(E.length>0){const s=o+1;s===1?i=new P.$Ft(d,r,d,r+a):i=new P.$Ft(d,r,d+s-1,h+1)}else i=new P.$Ft(d,r,d,r);return i}static _getInverseEditRanges(u){const E=[];let d=0,r=0,o=null;for(let a=0,h=u.length;a<h;a++){const i=u[a];let s,n;o?o.range.endLineNumber===i.range.startLineNumber?(s=d,n=r+(i.range.startColumn-o.range.endColumn)):(s=d+(i.range.startLineNumber-o.range.endLineNumber),n=i.range.startColumn):(s=i.range.startLineNumber,n=i.range.startColumn);let t;if(i.text.length>0){const m=i.eolCount+1;m===1?t=new P.$Ft(s,n,s,n+i.firstLineLength):t=new P.$Ft(s,n,s+m-1,i.lastLineLength+1)}else t=new P.$Ft(s,n,s,n);d=t.endLineNumber,r=t.endColumn,E.push(t),o=i}return E}static u(u,E){const d=P.$Ft.compareRangesUsingEnds(u.range,E.range);return d===0?u.sortIndex-E.sortIndex:d}static w(u,E){const d=P.$Ft.compareRangesUsingEnds(u.range,E.range);return d===0?E.sortIndex-u.sortIndex:-d}}e.$fD=R}),define(Ce[166],Ie([1,0,28,13,52,100,165]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=void 0,C=qe(C);class M{constructor(R,v,u,E,d,r,o,a,h){this.a=R,this.b=v,this.c=u,this.d=E,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(R){const v=this.c+this.d+this.e,u=this.c+this.e;return v===0?R===P.DefaultEndOfLine.LF?`
`:`\r
`:u>v/2?`\r
`:`
`}create(R){const v=this.k(R),u=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let d=0,r=u.length;d<r;d++){const o=u[d].buffer.replace(/\r\n|\r|\n/g,v),a=(0,O.$aD)(o);u[d]=new O.$dD(o,a)}const E=new A.$fD(u,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&C.$3f(R)&&(this.b=C.$2f,R=R.substr(1));const v=R.charCodeAt(R.length-1);v===w.CharCode.CarriageReturn||v>=55296&&v<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=v):(this.m(R,!1),this.c=!1,this.d=v)}m(R,v){!v&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const v=(0,O.$bD)(this.e,R);this.a.push(new O.$dD(R,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Rf(R)),this.k||(this.k=C.$Uf(R)))}finish(R=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const v=(0,O.$aD)(R.buffer);R.lineStarts=v,this.d===w.CharCode.CarriageReturn&&this.f++}}}e.$gD=p}),define(Ce[104],Ie([1,0,23,21]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecb=p,e.$Fcb=R,C=qe(C);var P;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(P||(P={}));function O(v){for(let u=0,E=v.length;u<E;u+=4){const d=v[u+0],r=v[u+1],o=v[u+2],a=v[u+3];v[u+0]=a,v[u+1]=o,v[u+2]=r,v[u+3]=d}}function A(v){const u=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return C.$D()||O(u),w.$Le.wrap(u)}function M(v){const u=v.buffer;if(C.$D()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(v){const u=new Uint32Array(c(v));let E=0;if(u[E++]=v.id,v.type==="full")u[E++]=P.Full,u[E++]=v.data.length,u.set(v.data,E),E+=v.data.length;else{u[E++]=P.Delta,u[E++]=v.deltas.length;for(const d of v.deltas)u[E++]=d.start,u[E++]=d.deleteCount,d.data?(u[E++]=d.data.length,u.set(d.data,E),E+=d.data.length):u[E++]=0}return A(u)}function c(v){let u=0;if(u+=2,v.type==="full")u+=1+v.data.length;else{u+=1,u+=3*v.deltas.length;for(const E of v.deltas)E.data&&(u+=E.data.length)}return u}function R(v){const u=M(v);let E=0;const d=u[E++];if(u[E++]===P.Full){const h=u[E++],i=u.subarray(E,E+h);return E+=h,{id:d,type:"full",data:i}}const o=u[E++],a=[];for(let h=0;h<o;h++){const i=u[E++],s=u[E++],n=u[E++];let t;n>0&&(t=u.subarray(E,E+n),E+=n),a[h]={start:i,deleteCount:s,data:t}}return{id:d,type:"delta",deltas:a}}}),define(Ce[167],Ie([8,9]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[168],Ie([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[169],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[170],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[171],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[172],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[173],Ie([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[174],Ie([8,9]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[175],Ie([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[176],Ie([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[177],Ie([8,9]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[178],Ie([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[179],Ie([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[180],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[181],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[182],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[183],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[184],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[185],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[186],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[187],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[188],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[189],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[190],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[191],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[192],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[193],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[194],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[195],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[196],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[197],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[198],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[199],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[200],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[201],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[202],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[203],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[204],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[205],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[206],Ie([1,0,28,14,170]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var O;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...R){switch(R.length){case 1:return(0,P.localize)(0,null,R[0]);case 2:return(0,P.localize)(1,null,R[0],R[1]);case 3:return(0,P.localize)(2,null,R[0],R[1],R[2]);default:return}}const M=(0,P.localize)(3,null),p=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return v.isTripleEq?"===":"==";case O.NotEq:return v.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return v.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return v.lexeme;case O.QuotedStr:return v.lexeme;case O.Error:return v.lexeme;case O.EOF:return"EOF";default:throw(0,C.$9)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case w.CharCode.OpenParen:this.k(O.LParen);break;case w.CharCode.CloseParen:this.k(O.RParen);break;case w.CharCode.ExclamationMark:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case w.CharCode.SingleQuote:this.o();break;case w.CharCode.Slash:this.q();break;case w.CharCode.Equals:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(w.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case w.CharCode.LessThan:this.k(this.h(w.CharCode.Equals)?O.LtEq:O.Lt);break;case w.CharCode.GreaterThan:this.k(this.h(w.CharCode.Equals)?O.GtEq:O.Gt);break;case w.CharCode.Ampersand:this.h(w.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case w.CharCode.Pipe:this.h(w.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case w.CharCode.Space:case w.CharCode.CarriageReturn:case w.CharCode.Tab:case w.CharCode.LineFeed:case w.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?w.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const u=this.d,E=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:v}),this.f.push(d)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const u=this.c.substring(this.d,this.e),E=c.b.get(u);E?this.k(E):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==w.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,u=!1,E=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(p);return}const r=this.c.charCodeAt(v);if(u)u=!1;else if(r===w.CharCode.Slash&&!E){v++;break}else r===w.CharCode.OpenSquareBracket?E=!0:r===w.CharCode.Backslash?u=!0:r===w.CharCode.CloseSquareBracket&&(E=!1);v++}for(;v<this.c.length&&c.a.has(this.c.charCodeAt(v));)v++;this.e=v;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[207],Ie([1,0,24,36,172,321]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=p,e.$Sp=c,e.$Tp=R,e.$Up=v,e.$Vp=u,e.$Wp=E,e.$Xp=d,C=ri(C),P=qe(P),O=qe(O);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function p(a){return a=a.trim(),a==="*"||A.test(a)}function c(a){if(!p(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function R(a){if(!a)return null;const h=a.majorBase,i=a.majorMustEqual,s=a.minorBase;let n=a.minorMustEqual;const t=a.patchBase;let m=a.patchMustEqual;a.hasCaret&&(h===0||(n=!1),m=!1);let f=0;if(a.preRelease){const l=M.exec(a.preRelease);if(l){const[,$,I,D]=l;f=Date.UTC(Number($),Number(I)-1,Number(D))}}return{majorBase:h,majorMustEqual:i,minorBase:s,minorMustEqual:n,patchBase:t,patchMustEqual:m,isMinimum:a.hasGreaterEquals,notBefore:f}}function v(a,h,i){let s;typeof a=="string"?s=R(c(a)):s=a;let n;h instanceof Date?n=h.getTime():typeof h=="string"&&(n=new Date(h).getTime());let t;if(typeof i=="string"?t=R(c(i)):t=i,!s||!t)return!1;const m=s.majorBase,f=s.minorBase,l=s.patchBase;let $=t.majorBase,I=t.minorBase,D=t.patchBase;const y=t.notBefore;let S=t.majorMustEqual,k=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?m>$?!0:m<$?!1:f>I?!0:f<I||n&&n<y?!1:l>=D:(m===1&&$===0&&(!S||!k||!g)&&($=1,I=0,D=0,S=!0,k=!1,g=!1),m<$?!1:m>$?!S:f<I?!1:f>I?!k:l<D?!1:l>D?!g:!(n&&n<y))}function u(a,h,i,s,n){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([C.default.Error,P.localize(0,null)]),t;if(typeof s.name!="string")return t.push([C.default.Error,P.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([C.default.Error,P.localize(2,null,"version")]),t;if(!s.engines)return t.push([C.default.Error,P.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([C.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return t.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return t.push([C.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([C.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([C.default.Error,P.localize(9,null,"main")]),t;{const l=(0,w.$dh)(i,s.main);(0,w.$0g)(l,i)||t.push([C.default.Warning,P.localize(10,null,l.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([C.default.Error,P.localize(11,null,"browser")]),t;{const l=(0,w.$dh)(i,s.browser);(0,w.$0g)(l,i)||t.push([C.default.Warning,P.localize(12,null,l.path,i.path)])}}if(!O.valid(s.version))return t.push([C.default.Error,P.localize(13,null)]),t;const m=[];if(!E(a,h,s,n,m))for(const l of m)t.push([C.default.Error,l]);return t}function E(a,h,i,s,n){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(a,h,i.engines.vscode,n)}function d(a,h,i){return a==="*"||r(h,i,a)}function r(a,h,i,s=[]){const n=R(c(i));if(!n)return s.push(P.localize(14,null,i)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return s.push(P.localize(15,null,i)),!1}else if(!n.majorMustEqual)return s.push(P.localize(16,null,i)),!1;return v(a,h,n)?!0:(s.push(P.localize(17,null,a,i)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,i=a.length;h<i;h++)if(typeof a[h]!="string")return!1;return!0}}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class w{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$zi=w}),define(Ce[61],Ie([1,0,74]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Is=O,e.$Js=A;const C=[];var P;(function(M){M[M.Eager=0]="Eager",M[M.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(M,p,c){p instanceof w.$zi||(p=new w.$zi(p,[],!!c)),C.push([M,p])}function A(){return C}}),define(Ce[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;class w{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$lr=w;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const M=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);M.outgoing.set(p.key,p),p.incoming.set(M.key,M)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const M of this.a.values())M.outgoing.delete(A),M.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let M=this.a.get(A);return M||(M=new w(A,O),this.a.set(A,M)),M}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,M]of this.a)O.push(`${A}
	(-> incoming)[${[...M.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...M.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const M=new Set([O]),p=this.c(A,M);if(p)return p}}c(O,A){for(const[M,p]of O.outgoing){if(A.has(M))return[...A,M].join(" -> ");A.add(M);const c=this.c(p,A);if(c)return c;A.delete(M)}}}e.$mr=C}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=P,e.$Di=O;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function M(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=M})(w||(e._util=w={})),e.$Bi=P("instantiationService");function C(A,M,p){M[w.DI_TARGET]===M?M[w.DI_DEPENDENCIES].push({id:A,index:p}):(M[w.DI_DEPENDENCIES]=[{id:A,index:p}],M[w.DI_TARGET]=M)}function P(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const M=function(p,c,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(M,p,R)};return M.toString=()=>A,w.serviceIds.set(A,M),M}function O(A){return A}}),define(Ce[42],Ie([1,0,15,2,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=O,e.$$i=A,e.$_i=p,e.$aj=c,e.$bj=R,e.$cj=v,e.$dj=u,e.$ej=d,e.$fj=r,e.$gj=o,w=qe(w),e.$9i=(0,P.$Ci)("configurationService");function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof C.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof C.URI)}var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(M||(e.ConfigurationTarget=M={}));function p(a){switch(a){case M.APPLICATION:return"APPLICATION";case M.USER:return"USER";case M.USER_LOCAL:return"USER_LOCAL";case M.USER_REMOTE:return"USER_REMOTE";case M.WORKSPACE:return"WORKSPACE";case M.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case M.DEFAULT:return"DEFAULT";case M.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function R(a,h){const i=Object.create(null);for(const s in a)v(i,s,a[s],h);return i}function v(a,h,i,s){const n=h.split("."),t=n.pop();let m=a;for(let f=0;f<n.length;f++){const l=n[f];let $=m[l];switch(typeof $){case"undefined":$=m[l]=Object.create(null);break;case"object":if($===null){s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${n.slice(0,f+1).join(".")} is ${JSON.stringify($)}`);return}m=$}if(typeof m=="object"&&m!==null)try{m[t]=i}catch{s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(m)}`)}else s(`Ignoring ${h} as ${n.join(".")} is ${JSON.stringify(m)}`)}function u(a,h){const i=h.split(".");E(a,i)}function E(a,h){const i=h.shift();if(h.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const s=a[i];typeof s=="object"&&!Array.isArray(s)&&(E(s,h),Object.keys(s).length===0&&delete a[i])}}function d(a,h,i){function s(m,f){let l=m;for(const $ of f){if(typeof l!="object"||l===null)return;l=l[$]}return l}const n=h.split("."),t=s(a,n);return typeof t>"u"?i:t}function r(a,h,i){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?w.$eg(a[s])&&w.$eg(h[s])?r(a[s],h[s],i):i&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,206,3,169,14]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=R,e.$Bj=f,e.$Cj=l,e.$Vj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",C.$j),c.set("isLinux",C.$k),c.set("isWindows",C.$i),c.set("isWeb",C.$o),c.set("isMacNative",C.$j&&!C.$o),c.set("isEdge",C.$H),c.set("isFirefox",C.$F),c.set("isChrome",C.$E),c.set("isSafari",C.$G);function R(Y,B){if(c.get(Y)!==void 0)throw(0,p.$8)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,B)}const v=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},d=(0,M.localize)(0,null),r=(0,M.localize)(1,null),o=(0,M.localize)(2,null),a=(0,M.localize)(3,null),h=(0,M.localize)(4,null),i=(0,M.localize)(5,null),s=(0,M.localize)(6,null),n=(0,M.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=E){this.k=B,this.d=new O.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const we=this.D(),ae=we.type===O.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:we.offset,lexeme:O.$xj.getLexeme(we),additionalInfo:ae}),t.c}return _}catch(_){if(_!==t.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(O.TokenType.Or);){const _=this.o();B.push(_)}return B.length===1?B[0]:m.or(...B)}o(){const B=[this.s()];for(;this.y(O.TokenType.And);){const _=this.s();B.push(_)}return B.length===1?B[0]:m.and(...B)}s(){if(this.y(O.TokenType.Neg)){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),I.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const _=this.l();return this.A(O.TokenType.RParen,a),_?.negate()}case O.TokenType.Str:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),m.true();case O.TokenType.False:return this.z(),m.false();case O.TokenType.LParen:{this.z();const _=this.l();return this.A(O.TokenType.RParen,a),_}case O.TokenType.Str:{const _=B.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==O.TokenType.RegexStr)throw this.B("REGEX",ae);const ve=ae.lexeme,le=ve.lastIndexOf("/"),X=le===ve.length-1?void 0:this.w(ve.substring(le+1));let Z;try{Z=new RegExp(ve.substring(1,le),X)}catch{throw this.B("REGEX",ae)}return V.create(_,Z)}switch(ae.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const ve=[ae.lexeme];this.z();let le=this.D(),X=0;for(let je=0;je<ae.lexeme.length;je++)ae.lexeme.charCodeAt(je)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(je)===w.CharCode.CloseParen&&X--;for(;!this.E()&&le.type!==O.TokenType.And&&le.type!==O.TokenType.Or;){switch(le.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let je=0;je<le.lexeme.length;je++)le.lexeme.charCodeAt(je)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(je)===w.CharCode.CloseParen&&X--}if(X<0)break;ve.push(O.$xj.getLexeme(le)),this.z(),le=this.D()}const Z=ve.join(""),pe=Z.lastIndexOf("/"),$e=pe===Z.length-1?void 0:this.w(Z.substring(pe+1));let Me;try{Me=new RegExp(Z.substring(1,pe),$e)}catch{throw this.B("REGEX",ae)}return m.regex(_,Me)}case O.TokenType.QuotedStr:{const ve=ae.lexeme;this.z();let le=null;if(!(0,P.$af)(ve)){const X=ve.indexOf("/"),Z=ve.lastIndexOf("/");if(X!==Z&&X>=0){const pe=ve.slice(X+1,Z),$e=ve[Z+1]==="i"?"i":"";try{le=new RegExp(pe,$e)}catch{throw this.B("REGEX",ae)}}}if(le===null)throw this.B("REGEX",ae);return V.create(_,le)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const ae=this.u();return m.notIn(_,ae)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return m.equals(_,ae);switch(ae){case"true":return m.has(_);case"false":return m.not(_);default:return m.equals(_,ae)}}case O.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===O.TokenType.QuotedStr)return m.notEquals(_,ae);switch(ae){case"true":return m.not(_);case"false":return m.has(_);default:return m.notEquals(_,ae)}}case O.TokenType.Lt:return this.z(),W.create(_,this.u());case O.TokenType.LtEq:return this.z(),N.create(_,this.u());case O.TokenType.Gt:return this.z(),q.create(_,this.u());case O.TokenType.GtEq:return this.z(),G.create(_,this.u());case O.TokenType.In:return this.z(),m.in(_,this.u());default:return m.has(_)}}case O.TokenType.EOF:throw this.h.push({message:s,offset:B.offset,lexeme:"",additionalInfo:n}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),B.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,we){const ae=(0,M.localize)(8,null,B,O.$xj.getLexeme(_)),ve=_.offset,le=O.$xj.getLexeme(_);return this.h.push({message:ae,offset:ve,lexeme:le,additionalInfo:we}),t.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$zj=t;class m{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(B){return y.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return b.create(B,_)}static regex(B,_){return V.create(B,_)}static in(B,_){return k.create(B,_)}static notIn(B,_){return g.create(B,_)}static not(B){return L.create(B)}static and(...B){return ie.create(B,null,!0)}static or(...B){return me.create(B,null,!0)}static greater(B,_){return q.create(B,_)}static greaterEquals(B,_){return G.create(B,_)}static smaller(B,_){return W.create(B,_)}static smallerEquals(B,_){return N.create(B,_)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Aj=m;function f(Y){const B=new t({regexParsingWithErrorRecovery:!1});return Y.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,M.localize)(9,null,we.additionalInfo):(0,M.localize)(10,null),offset:we.offset,length:we.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}function l(Y,B){const _=Y?Y.substituteConstants():void 0,we=B?B.substituteConstants():void 0;return!_&&!we?!0:!_||!we?!1:_.equals(we)}function $(Y,B){return Y.cmp(B)}class I{static{this.INSTANCE=new I}constructor(){this.type=u.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Dj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return I.INSTANCE}}e.$Ej=D;class y{static create(B,_=null){const we=c.get(B);return typeof we=="boolean"?we?D.INSTANCE:I.INSTANCE:new y(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=u.Defined}cmp(B){return B.type!==this.type?this.type-B.type:de(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=c.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:I.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Fj=y;class S{static create(B,_,we=null){if(typeof _=="boolean")return _?y.create(B,we):L.create(B,we);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?D.INSTANCE:I.INSTANCE:new S(B,_,we)}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.Equals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?D.INSTANCE:I.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Gj=S;class k{static create(B,_){return new k(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:be(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),we=B.getValue(this.d);return Array.isArray(_)?_.includes(we):typeof we=="string"&&typeof _=="object"&&_!==null?v.call(_,we):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Hj=k;class g{static create(B,_){return new g(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.NotIn,this.c=k.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=g;class b{static create(B,_,we=null){if(typeof _=="boolean")return _?L.create(B,we):y.create(B,we);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?I.INSTANCE:D.INSTANCE:new b(B,_,we)}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?I.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Jj=b;class L{static create(B,_=null){const we=c.get(B);return typeof we=="boolean"?we?I.INSTANCE:D.INSTANCE:new L(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=u.Not}cmp(B){return B.type!==this.type?this.type-B.type:de(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=c.get(this.c);return typeof B=="boolean"?B?I.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=L;function T(Y,B){if(typeof Y=="string"){const _=parseFloat(Y);isNaN(_)||(Y=_)}return typeof Y=="string"||typeof Y=="number"?B(Y):I.INSTANCE}class q{static create(B,_,we=null){return T(_,ae=>new q(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.Greater}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Lj=q;class G{static create(B,_,we=null){return T(_,ae=>new G(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Mj=G;class W{static create(B,_,we=null){return T(_,ae=>new W(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Nj=W;class N{static create(B,_,we=null){return T(_,ae=>new N(B,ae,we))}constructor(B,_,we){this.c=B,this.d=_,this.f=we,this.type=u.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Oj=N;class V{static create(B,_){return new V(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",we=B.f?B.f.source:"";return _<we?-1:_>we?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",we=B.f?B.f.source:"";return this.d===B.d&&_===we}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Pj=V;class ce{static create(B){return new ce(B)}constructor(B){this.c=B,this.type=u.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new ce(this.c.map(B))}negate(){return this.c}}e.$Qj=ce;function ge(Y){let B=null;for(let _=0,we=Y.length;_<we;_++){const ae=Y[_].substituteConstants();if(Y[_]!==ae&&B===null){B=[];for(let ve=0;ve<_;ve++)B[ve]=Y[ve]}B!==null&&(B[_]=ae)}return B===null?Y:B}class ie{static create(B,_,we){return ie.d(B,_,we)}constructor(B,_){this.expr=B,this.c=_,this.type=u.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,we=this.expr.length;_<we;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,we){const ae=[];let ve=!1;for(const le of B)if(le){if(le.type===u.True){ve=!0;continue}if(le.type===u.False)return I.INSTANCE;if(le.type===u.And){ae.push(...le.expr);continue}ae.push(le)}if(ae.length===0&&ve)return D.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort($);for(let le=1;le<ae.length;le++)ae[le-1].equals(ae[le])&&(ae.splice(le,1),le--);if(ae.length===1)return ae[0];for(;ae.length>1;){const le=ae[ae.length-1];if(le.type!==u.Or)break;ae.pop();const X=ae.pop(),Z=ae.length===0,pe=me.create(le.expr.map($e=>ie.create([$e,X],null,we)),null,Z);pe&&(ae.push(pe),ae.sort($))}if(ae.length===1)return ae[0];if(we){for(let le=0;le<ae.length;le++)for(let X=le+1;X<ae.length;X++)if(ae[le].negate().equals(ae[X]))return I.INSTANCE;if(ae.length===1)return ae[0]}return new ie(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=me.create(B,this,!0)}return this.c}}e.$Rj=ie;class me{static create(B,_,we){return me.d(B,_,we)}constructor(B,_){this.expr=B,this.c=_,this.type=u.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,we=this.expr.length;_<we;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,we=this.expr.length;_<we;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let _=0,we=this.expr.length;_<we;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,we){let ae=[],ve=!1;if(B){for(let le=0,X=B.length;le<X;le++){const Z=B[le];if(Z){if(Z.type===u.False){ve=!0;continue}if(Z.type===u.True)return D.INSTANCE;if(Z.type===u.Or){ae=ae.concat(Z.expr);continue}ae.push(Z)}}if(ae.length===0&&ve)return I.INSTANCE;ae.sort($)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let le=1;le<ae.length;le++)ae[le-1].equals(ae[le])&&(ae.splice(le,1),le--);if(ae.length===1)return ae[0];if(we){for(let le=0;le<ae.length;le++)for(let X=le+1;X<ae.length;X++)if(ae[le].negate().equals(ae[X]))return D.INSTANCE;if(ae.length===1)return ae[0]}return new me(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new me(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),we=B.shift(),ae=[];for(const ve of Le(_))for(const le of Le(we))ae.push(ie.create([ve,le],null,!1));B.unshift(me.create(ae,null,!1))}this.c=me.create(B,this,!0)}return this.c}}e.$Sj=me;class se extends y{static{this.d=[]}static all(){return se.d.values()}constructor(B,_,we){super(B,null),this.f=_,typeof we=="object"?se.d.push({...we,key:B}):we!==!0&&se.d.push({key:B,description:we,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return b.create(this.key,B)}}e.$Tj=se,e.$Uj=(0,A.$Ci)("contextKeyService");function de(Y,B){return Y<B?-1:Y>B?1:0}function be(Y,B,_,we){return Y<_?-1:Y>_?1:B<we?-1:B>we?1:0}function re(Y,B){if(Y.type===u.False||B.type===u.True)return!0;if(Y.type===u.Or)return B.type===u.Or?Pe(Y.expr,B.expr):!1;if(B.type===u.Or){for(const _ of B.expr)if(re(Y,_))return!0;return!1}if(Y.type===u.And){if(B.type===u.And)return Pe(B.expr,Y.expr);for(const _ of Y.expr)if(re(_,B))return!0;return!1}return Y.equals(B)}function Pe(Y,B){let _=0,we=0;for(;_<Y.length&&we<B.length;){const ae=Y[_].cmp(B[we]);if(ae<0)return!1;ae===0&&_++,we++}return _===Y.length}function Le(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Ce[209],Ie([1,0,32,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$jt=e.AccessibilitySupport=e.$it=void 0,e.$kt=O,e.$it=(0,C.$Ci)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$jt=new w.$Tj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$lt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[105],Ie([1,0,18,26,21,143,322,149,210,167,209]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=n,e.clampedFloat=m,e.stringSet=$,e.cursorStyleToString=T,e.filterValidationDecorations=Re,w=qe(w),C=qe(C),P=qe(P),c=qe(c);var v;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(x,De,Xe,Ze){this.id=x,this.name=De,this.defaultValue=Xe,this.schema=Ze}applyUpdate(x,De){return o(x,De)}compute(x,De,Xe){return Xe}}class r{constructor(x,De){this.newValue=x,this.didChange=De}}e.ApplyUpdateResult=r;function o(H,x){if(typeof H!="object"||typeof x!="object"||!H||!x)return new r(x,H!==x);if(Array.isArray(H)||Array.isArray(x)){const Xe=Array.isArray(H)&&Array.isArray(x)&&w.$vb(H,x);return new r(x,!Xe)}let De=!1;for(const Xe in x)if(x.hasOwnProperty(Xe)){const Ze=o(H[Xe],x[Xe]);Ze.didChange&&(H[Xe]=Ze.newValue,De=!0)}return new r(H,De)}class a{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,De){return o(x,De)}validate(x){return this.defaultValue}}class h{constructor(x,De,Xe,Ze){this.id=x,this.name=De,this.defaultValue=Xe,this.schema=Ze}applyUpdate(x,De){return o(x,De)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,De,Xe){return Xe}}function i(H,x){return typeof H>"u"?x:H==="false"?!1:!!H}class s extends h{constructor(x,De,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Xe),super(x,De,Xe,Ze)}validate(x){return i(x,this.defaultValue)}}function n(H,x,De,Xe){if(typeof H>"u")return x;let Ze=parseInt(H,10);return isNaN(Ze)?x:(Ze=Math.max(De,Ze),Ze=Math.min(Xe,Ze),Ze|0)}class t extends h{static clampedInt(x,De,Xe,Ze){return n(x,De,Xe,Ze)}constructor(x,De,Xe,Ze,dt,pt=void 0){typeof pt<"u"&&(pt.type="integer",pt.default=Xe,pt.minimum=Ze,pt.maximum=dt),super(x,De,Xe,pt),this.minimum=Ze,this.maximum=dt}validate(x){return t.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function m(H,x,De,Xe){if(typeof H>"u")return x;const Ze=f.float(H,x);return f.clamp(Ze,De,Xe)}class f extends h{static clamp(x,De,Xe){return x<De?De:x>Xe?Xe:x}static float(x,De){if(typeof x=="number")return x;if(typeof x>"u")return De;const Xe=parseFloat(x);return isNaN(Xe)?De:Xe}constructor(x,De,Xe,Ze,dt){typeof dt<"u"&&(dt.type="number",dt.default=Xe),super(x,De,Xe,dt),this.validationFn=Ze}validate(x){return this.validationFn(f.float(x,this.defaultValue))}}class l extends h{static string(x,De){return typeof x!="string"?De:x}constructor(x,De,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Xe),super(x,De,Xe,Ze)}validate(x){return l.string(x,this.defaultValue)}}function $(H,x,De,Xe){return typeof H!="string"?x:Xe&&H in Xe?Xe[H]:De.indexOf(H)===-1?x:H}class I extends h{constructor(x,De,Xe,Ze,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Ze,dt.default=Xe),super(x,De,Xe,dt),this.c=Ze}validate(x){return $(x,this.defaultValue,this.c)}}class D extends d{constructor(x,De,Xe,Ze,dt,pt,Lt=void 0){typeof Lt<"u"&&(Lt.type="string",Lt.enum=dt,Lt.default=Ze),super(x,De,Xe,Lt),this.c=dt,this.d=pt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function y(H){switch(H){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class S extends d{constructor(){super(Ue.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(x){switch(x){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,De,Xe){return Xe===R.AccessibilitySupport.Unknown?x.accessibilitySupport:Xe}}class k extends d{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(Ue.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:c.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertSpace:i(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function b(H){switch(H){case"blink":return g.Blink;case"smooth":return g.Smooth;case"phase":return g.Phase;case"expand":return g.Expand;case"solid":return g.Solid}}var L;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function T(H){switch(H){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function q(H){switch(H){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class G extends a{constructor(){super(Ue.editorClassName)}compute(x,De,Xe){const Ze=["monaco-editor"];return De.get(Ue.extraEditorClassName)&&Ze.push(De.get(Ue.extraEditorClassName)),x.extraEditorClassName&&Ze.push(x.extraEditorClassName),De.get(Ue.mouseStyle)==="default"?Ze.push("mouse-default"):De.get(Ue.mouseStyle)==="copy"&&Ze.push("mouse-copy"),De.get(Ue.showUnused)&&Ze.push("showUnused"),De.get(Ue.showDeprecated)&&Ze.push("showDeprecated"),Ze.join(" ")}}class W extends s{constructor(){super(Ue.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(x,De,Xe){return Xe&&x.emptySelectionClipboard}}class N extends d{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ue.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:c.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{cursorMoveOnType:i(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(De.loop,this.defaultValue.loop)}}}class V extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ue.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class ce extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ue.fontVariations,"fontVariations",ce.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ce.OFF:x==="true"?ce.TRANSLATE:x:x?ce.TRANSLATE:ce.OFF}compute(x,De,Xe){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ce;class ge extends a{constructor(){super(Ue.fontInfo)}compute(x,De,Xe){return x.fontInfo}}class ie extends h{constructor(){super(Ue.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(x){const De=f.float(x,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(De,6,100)}compute(x,De,Xe){return x.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Ue.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(t.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class se extends d{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ue.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Xe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Xe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Xe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Xe,description:c.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{multiple:$(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??$(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??$(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??$(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??$(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??$(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends d{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ue.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:c.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),delay:t.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:i(De.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(De.above,this.defaultValue.above)}}}var be;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(be||(e.RenderMinimap=be={}));class re extends a{constructor(){super(Ue.layoutInfo)}compute(x,De,Xe){return re.computeLayout(De,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const De=x.height/x.lineHeight,Xe=Math.floor(x.paddingTop/x.lineHeight);let Ze=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ze=Math.max(Ze,De-1));const dt=(Xe+x.viewLineCount+Ze)/(x.pixelRatio*x.height),pt=Math.floor(x.viewLineCount/dt);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:Ze,desiredRatio:dt,minimapLineCount:pt}}static c(x,De){const Xe=x.outerWidth,Ze=x.outerHeight,dt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:be.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(dt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const pt=De.stableMinimapLayoutInput,Lt=pt&&x.outerHeight===pt.outerHeight&&x.lineHeight===pt.lineHeight&&x.typicalHalfwidthCharacterWidth===pt.typicalHalfwidthCharacterWidth&&x.pixelRatio===pt.pixelRatio&&x.scrollBeyondLastLine===pt.scrollBeyondLastLine&&x.paddingTop===pt.paddingTop&&x.paddingBottom===pt.paddingBottom&&x.minimap.enabled===pt.minimap.enabled&&x.minimap.side===pt.minimap.side&&x.minimap.size===pt.minimap.size&&x.minimap.showSlider===pt.minimap.showSlider&&x.minimap.renderCharacters===pt.minimap.renderCharacters&&x.minimap.maxColumn===pt.minimap.maxColumn&&x.minimap.scale===pt.minimap.scale&&x.verticalScrollbarWidth===pt.verticalScrollbarWidth&&x.isViewportWrapping===pt.isViewportWrapping,zt=x.lineHeight,xt=x.typicalHalfwidthCharacterWidth,li=x.scrollBeyondLastLine,xe=x.minimap.renderCharacters;let It=dt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,ht=x.minimap.size,bt=x.minimap.side,hi=x.verticalScrollbarWidth,_t=x.viewLineCount,Ut=x.remainingWidth,wt=x.isViewportWrapping,Bt=xe?2:3;let Jt=Math.floor(dt*Ze);const Qt=Jt/dt;let Qe=!1,pi=!1,ei=Bt*It,si=It/dt,St=1;if(ht==="fill"||ht==="fit"){const{typicalViewportLineCount:Wt,extraLinesBeforeFirstLine:Ht,extraLinesBeyondLastLine:di,desiredRatio:Ft,minimapLineCount:vt}=re.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:li,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ze,lineHeight:zt,pixelRatio:dt});if(_t/vt>1)Qe=!0,pi=!0,It=1,ei=1,si=It/dt;else{let Tt=!1,kt=It+1;if(ht==="fit"){const Xt=Math.ceil((Ht+_t+di)*ei);wt&&Lt&&Ut<=De.stableFitRemainingWidth?(Tt=!0,kt=De.stableFitMaxMinimapScale):Tt=Xt>Jt}if(ht==="fill"||Tt){Qe=!0;const Xt=It;ei=Math.min(zt*dt,Math.max(1,Math.floor(1/Ft))),wt&&Lt&&Ut<=De.stableFitRemainingWidth&&(kt=De.stableFitMaxMinimapScale),It=Math.min(kt,Math.max(1,Math.floor(ei/Bt))),It>Xt&&(St=Math.min(2,It/Xt)),si=It/dt/St,Jt=Math.ceil(Math.max(Wt,Ht+_t+di)*ei),wt?(De.stableMinimapLayoutInput=x,De.stableFitRemainingWidth=Ut,De.stableFitMaxMinimapScale=It):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Gt*si),At=Math.min(Kt,Math.max(0,Math.floor((Ut-hi-2)*si/(xt+si)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(dt*At);const ti=Nt/dt;Nt=Math.floor(Nt*St);const ii=xe?be.Text:be.Blocks,oi=bt==="left"?0:Xe-At-hi;return{renderMinimap:ii,minimapLeft:oi,minimapWidth:At,minimapHeightIsEditorHeight:Qe,minimapIsSampling:pi,minimapScale:It,minimapLineHeight:ei,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Jt,minimapCanvasOuterWidth:ti,minimapCanvasOuterHeight:Qt}}static computeLayout(x,De){const Xe=De.outerWidth|0,Ze=De.outerHeight|0,dt=De.lineHeight|0,pt=De.lineNumbersDigitCount|0,Lt=De.typicalHalfwidthCharacterWidth,zt=De.maxDigitWidth,xt=De.pixelRatio,li=De.viewLineCount,xe=x.get(Ue.wordWrapOverride2),It=xe==="inherit"?x.get(Ue.wordWrapOverride1):xe,Gt=It==="inherit"?x.get(Ue.wordWrap):It,ht=x.get(Ue.wordWrapColumn),bt=De.isDominatedByLongLines,hi=x.get(Ue.glyphMargin),_t=x.get(Ue.lineNumbers).renderType!==je.Off,Ut=x.get(Ue.lineNumbersMinChars),wt=x.get(Ue.scrollBeyondLastLine),Bt=x.get(Ue.padding),Jt=x.get(Ue.minimap),Qt=x.get(Ue.scrollbar),Qe=Qt.verticalScrollbarSize,pi=Qt.verticalHasArrows,ei=Qt.arrowSize,si=Qt.horizontalScrollbarSize,St=x.get(Ue.folding),Kt=x.get(Ue.showFoldingControls)!=="never";let At=x.get(Ue.lineDecorationsWidth);St&&Kt&&(At+=16);let Nt=0;if(_t){const $i=Math.max(pt,Ut);Nt=Math.round($i*zt)}let ti=0;hi&&(ti=dt*De.glyphMarginDecorationLaneCount);let ii=0,oi=ii+ti,Wt=oi+Nt,Ht=Wt+At;const di=Xe-ti-Nt-At;let Ft=!1,vt=!1,Ct=-1;It==="inherit"&&bt?(Ft=!0,vt=!0):Gt==="on"||Gt==="bounded"?vt=!0:Gt==="wordWrapColumn"&&(Ct=ht);const Tt=re.c({outerWidth:Xe,outerHeight:Ze,lineHeight:dt,typicalHalfwidthCharacterWidth:Lt,pixelRatio:xt,scrollBeyondLastLine:wt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:Jt,verticalScrollbarWidth:Qe,viewLineCount:li,remainingWidth:di,isViewportWrapping:vt},De.memory||new E);Tt.renderMinimap!==be.None&&Tt.minimapLeft===0&&(ii+=Tt.minimapWidth,oi+=Tt.minimapWidth,Wt+=Tt.minimapWidth,Ht+=Tt.minimapWidth);const kt=di-Tt.minimapWidth,Xt=Math.max(1,Math.floor((kt-Qe-2)/Lt)),qt=pi?ei:0;return vt&&(Ct=Math.max(1,Xt),Gt==="bounded"&&(Ct=Math.min(Ct,ht))),{width:Xe,height:Ze,glyphMarginLeft:ii,glyphMarginWidth:ti,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Nt,decorationsLeft:Wt,decorationsWidth:At,contentLeft:Ht,contentWidth:kt,minimap:Tt,viewportColumn:Xt,isWordWrapMinified:Ft,isViewportWrapping:vt,wrappingColumn:Ct,verticalScrollbarWidth:Qe,horizontalScrollbarHeight:si,overviewRuler:{top:qt,width:Qe,height:Ze-2*qt,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends d{constructor(){super(Ue.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,De,Xe){return De.get(Ue.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Xe}}var Le;(function(H){H.Off="off",H.OnCode="onCode",H.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class Y extends d{constructor(){const x={enabled:Le.On};super(Ue.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:x.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class B extends d{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ue.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:c.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends d{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ue.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:c.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:$(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily),padding:i(De.padding,this.defaultValue.padding)}}}class we extends d{constructor(){super(Ue.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):t.clampedInt(x,this.defaultValue,0,1e3)}compute(x,De,Xe){return Xe<0?t.clampedInt(-Xe*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class ae extends f{constructor(){super(Ue.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>f.clamp(x,0,150),{markdownDescription:c.localize(66,null)})}compute(x,De,Xe){return x.fontInfo.lineHeight}}class ve extends d{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ue.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:x.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),autohide:i(De.autohide,this.defaultValue.autohide),size:$(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(De.side,this.defaultValue.side,["right","left"]),showSlider:$(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(De.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(De.scale,1,1,3),maxColumn:t.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(H){return H==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(Ue.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{top:t.clampedInt(De.top,0,0,1e3),bottom:t.clampedInt(De.bottom,0,0,1e3)}}}class Z extends d{constructor(){const x={enabled:!0,cycle:!0};super(Ue.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:c.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),cycle:i(De.cycle,this.defaultValue.cycle)}}}class pe extends a{constructor(){super(Ue.pixelRatio)}compute(x,De,Xe){return x.pixelRatio}}class $e extends d{constructor(){super(Ue.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Me extends d{constructor(){const x={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(Ue.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:x.strings,description:c.localize(89,null)},comments:{anyOf:De,default:x.comments,description:c.localize(90,null)},other:{anyOf:De,default:x.other,description:c.localize(91,null)}},default:x,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const xt=x?"on":"off";return{comments:xt,strings:xt,other:xt}}if(!x||typeof x!="object")return this.defaultValue;const{other:De,comments:Xe,strings:Ze}=x,dt=["on","inline","off"];let pt,Lt,zt;return typeof De=="boolean"?pt=De?"on":"off":pt=$(De,this.defaultValue.other,dt),typeof Xe=="boolean"?Lt=Xe?"on":"off":Lt=$(Xe,this.defaultValue.comments,dt),typeof Ze=="boolean"?zt=Ze?"on":"off":zt=$(Ze,this.defaultValue.strings,dt),{other:pt,comments:Lt,strings:zt}}}var je;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(je||(e.RenderLineNumbersType=je={}));class ke extends d{constructor(){super(Ue.lineNumbers,"lineNumbers",{renderType:je.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(x){let De=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(De=je.Custom,Xe=x):x==="interval"?De=je.Interval:x==="relative"?De=je.Relative:x==="on"?De=je.On:De=je.Off),{renderType:De,renderFn:Xe}}}function Re(H){const x=H.get(Ue.renderValidationDecorations);return x==="editable"?H.get(Ue.readOnly):x!=="on"}class Oe extends d{constructor(){const x=[],De={type:"number",description:c.localize(98,null)};super(Ue.rulers,"rulers",x,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:x,description:c.localize(100,null)})}validate(x){if(Array.isArray(x)){const De=[];for(const Xe of x)if(typeof Xe=="number")De.push({column:t.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const Ze=Xe;De.push({column:t.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return De.sort((Xe,Ze)=>Xe.column-Ze.column),De}return this.defaultValue}}class z extends d{constructor(){super(Ue.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function j(H,x){if(typeof H!="string")return x;switch(H){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class K extends d{constructor(){const x={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ue.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x,Xe=t.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=t.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(De.vertical,this.defaultValue.vertical),horizontal:j(De.horizontal,this.defaultValue.horizontal),useShadows:i(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:t.clampedInt(De.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:t.clampedInt(De.verticalSliderSize,Ze,0,1e3),scrollByPage:i(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends d{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ue.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:c.localize(119,null)}})}applyUpdate(x,De){let Xe=!1;De.allowedCharacters&&x&&(C.$do(x.allowedCharacters,De.allowedCharacters)||(x={...x,allowedCharacters:De.allowedCharacters},Xe=!0)),De.allowedLocales&&x&&(C.$do(x.allowedLocales,De.allowedLocales)||(x={...x,allowedLocales:De.allowedLocales},Xe=!0));const Ze=super.applyUpdate(x,De);return Xe?new r(Ze.newValue,!0):Ze}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,De){if(typeof x!="object"||!x)return De;const Xe={};for(const[Ze,dt]of Object.entries(x))dt===!0&&(Xe[Ze]=!0);return Xe}}class ne extends d{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ue.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),mode:$(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ue.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:c.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ae extends d{constructor(){const x={enabled:M.$ct.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$ct.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ue.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ue.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:x.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:x.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:x.highlightActiveIndentation,description:c.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(H,x,De){const Xe=De.indexOf(H);return Xe===-1?x:De[Xe]}class _e extends d{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ue.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:x.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:x.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertMode:$(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(De.showIcons,this.defaultValue.showIcons),showStatusBar:i(De.showStatusBar,this.defaultValue.showStatusBar),preview:i(De.preview,this.defaultValue.preview),previewMode:$(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(De.showMethods,this.defaultValue.showMethods),showFunctions:i(De.showFunctions,this.defaultValue.showFunctions),showConstructors:i(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(De.showFields,this.defaultValue.showFields),showVariables:i(De.showVariables,this.defaultValue.showVariables),showClasses:i(De.showClasses,this.defaultValue.showClasses),showStructs:i(De.showStructs,this.defaultValue.showStructs),showInterfaces:i(De.showInterfaces,this.defaultValue.showInterfaces),showModules:i(De.showModules,this.defaultValue.showModules),showProperties:i(De.showProperties,this.defaultValue.showProperties),showEvents:i(De.showEvents,this.defaultValue.showEvents),showOperators:i(De.showOperators,this.defaultValue.showOperators),showUnits:i(De.showUnits,this.defaultValue.showUnits),showValues:i(De.showValues,this.defaultValue.showValues),showConstants:i(De.showConstants,this.defaultValue.showConstants),showEnums:i(De.showEnums,this.defaultValue.showEnums),showEnumMembers:i(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(De.showKeywords,this.defaultValue.showKeywords),showWords:i(De.showWords,this.defaultValue.showWords),showColors:i(De.showColors,this.defaultValue.showColors),showFiles:i(De.showFiles,this.defaultValue.showFiles),showReferences:i(De.showReferences,this.defaultValue.showReferences),showFolders:i(De.showFolders,this.defaultValue.showFolders),showTypeParameters:i(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(De.showSnippets,this.defaultValue.showSnippets),showUsers:i(De.showUsers,this.defaultValue.showUsers),showIssues:i(De.showIssues,this.defaultValue.showIssues)}}}class it extends d{constructor(){super(Ue.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const x=[];super(Ue.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const De=[];for(const Xe of x)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&De.push(Xe)}catch{}return De}return this.defaultValue}}var tt;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends d{constructor(){super(Ue.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(x,De,Xe){return De.get(Ue.accessibilitySupport)===R.AccessibilitySupport.Enabled?tt.None:Xe}}class $t extends a{constructor(){super(Ue.wrappingInfo)}compute(x,De,Xe){const Ze=De.get(Ue.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class lt extends d{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(Ue.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showDropSelector:$(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(Ue.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:i(De.enabled,this.defaultValue.enabled),showPasteSelector:$(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?gt:P.$k?mt:ct,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(H){return e.editorOptionsRegistry[H.id]=H,H}var Ue;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.ariaRequired=5]="ariaRequired",H[H.autoClosingBrackets=6]="autoClosingBrackets",H[H.autoClosingComments=7]="autoClosingComments",H[H.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",H[H.autoClosingDelete=9]="autoClosingDelete",H[H.autoClosingOvertype=10]="autoClosingOvertype",H[H.autoClosingQuotes=11]="autoClosingQuotes",H[H.autoIndent=12]="autoIndent",H[H.automaticLayout=13]="automaticLayout",H[H.autoSurround=14]="autoSurround",H[H.bracketPairColorization=15]="bracketPairColorization",H[H.guides=16]="guides",H[H.codeLens=17]="codeLens",H[H.codeLensFontFamily=18]="codeLensFontFamily",H[H.codeLensFontSize=19]="codeLensFontSize",H[H.colorDecorators=20]="colorDecorators",H[H.colorDecoratorsLimit=21]="colorDecoratorsLimit",H[H.columnSelection=22]="columnSelection",H[H.comments=23]="comments",H[H.contextmenu=24]="contextmenu",H[H.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",H[H.cursorBlinking=26]="cursorBlinking",H[H.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",H[H.cursorStyle=28]="cursorStyle",H[H.cursorSurroundingLines=29]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",H[H.cursorWidth=31]="cursorWidth",H[H.disableLayerHinting=32]="disableLayerHinting",H[H.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",H[H.domReadOnly=34]="domReadOnly",H[H.dragAndDrop=35]="dragAndDrop",H[H.dropIntoEditor=36]="dropIntoEditor",H[H.emptySelectionClipboard=37]="emptySelectionClipboard",H[H.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",H[H.extraEditorClassName=39]="extraEditorClassName",H[H.fastScrollSensitivity=40]="fastScrollSensitivity",H[H.find=41]="find",H[H.fixedOverflowWidgets=42]="fixedOverflowWidgets",H[H.folding=43]="folding",H[H.foldingStrategy=44]="foldingStrategy",H[H.foldingHighlight=45]="foldingHighlight",H[H.foldingImportsByDefault=46]="foldingImportsByDefault",H[H.foldingMaximumRegions=47]="foldingMaximumRegions",H[H.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=49]="fontFamily",H[H.fontInfo=50]="fontInfo",H[H.fontLigatures=51]="fontLigatures",H[H.fontSize=52]="fontSize",H[H.fontWeight=53]="fontWeight",H[H.fontVariations=54]="fontVariations",H[H.formatOnPaste=55]="formatOnPaste",H[H.formatOnType=56]="formatOnType",H[H.glyphMargin=57]="glyphMargin",H[H.gotoLocation=58]="gotoLocation",H[H.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",H[H.hover=60]="hover",H[H.inDiffEditor=61]="inDiffEditor",H[H.inlineSuggest=62]="inlineSuggest",H[H.inlineEdit=63]="inlineEdit",H[H.letterSpacing=64]="letterSpacing",H[H.lightbulb=65]="lightbulb",H[H.lineDecorationsWidth=66]="lineDecorationsWidth",H[H.lineHeight=67]="lineHeight",H[H.lineNumbers=68]="lineNumbers",H[H.lineNumbersMinChars=69]="lineNumbersMinChars",H[H.linkedEditing=70]="linkedEditing",H[H.links=71]="links",H[H.matchBrackets=72]="matchBrackets",H[H.minimap=73]="minimap",H[H.mouseStyle=74]="mouseStyle",H[H.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=76]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",H[H.multiCursorModifier=78]="multiCursorModifier",H[H.multiCursorPaste=79]="multiCursorPaste",H[H.multiCursorLimit=80]="multiCursorLimit",H[H.occurrencesHighlight=81]="occurrencesHighlight",H[H.overviewRulerBorder=82]="overviewRulerBorder",H[H.overviewRulerLanes=83]="overviewRulerLanes",H[H.padding=84]="padding",H[H.pasteAs=85]="pasteAs",H[H.parameterHints=86]="parameterHints",H[H.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",H[H.placeholder=88]="placeholder",H[H.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",H[H.quickSuggestions=90]="quickSuggestions",H[H.quickSuggestionsDelay=91]="quickSuggestionsDelay",H[H.readOnly=92]="readOnly",H[H.readOnlyMessage=93]="readOnlyMessage",H[H.renameOnType=94]="renameOnType",H[H.renderControlCharacters=95]="renderControlCharacters",H[H.renderFinalNewline=96]="renderFinalNewline",H[H.renderLineHighlight=97]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=99]="renderValidationDecorations",H[H.renderWhitespace=100]="renderWhitespace",H[H.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",H[H.roundedSelection=102]="roundedSelection",H[H.rulers=103]="rulers",H[H.scrollbar=104]="scrollbar",H[H.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=106]="scrollBeyondLastLine",H[H.scrollPredominantAxis=107]="scrollPredominantAxis",H[H.selectionClipboard=108]="selectionClipboard",H[H.selectionHighlight=109]="selectionHighlight",H[H.selectOnLineNumbers=110]="selectOnLineNumbers",H[H.showFoldingControls=111]="showFoldingControls",H[H.showUnused=112]="showUnused",H[H.snippetSuggestions=113]="snippetSuggestions",H[H.smartSelect=114]="smartSelect",H[H.smoothScrolling=115]="smoothScrolling",H[H.stickyScroll=116]="stickyScroll",H[H.stickyTabStops=117]="stickyTabStops",H[H.stopRenderingLineAfter=118]="stopRenderingLineAfter",H[H.suggest=119]="suggest",H[H.suggestFontSize=120]="suggestFontSize",H[H.suggestLineHeight=121]="suggestLineHeight",H[H.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",H[H.suggestSelection=123]="suggestSelection",H[H.tabCompletion=124]="tabCompletion",H[H.tabIndex=125]="tabIndex",H[H.unicodeHighlighting=126]="unicodeHighlighting",H[H.unusualLineTerminators=127]="unusualLineTerminators",H[H.useShadowDOM=128]="useShadowDOM",H[H.useTabStops=129]="useTabStops",H[H.wordBreak=130]="wordBreak",H[H.wordSegmenterLocales=131]="wordSegmenterLocales",H[H.wordSeparators=132]="wordSeparators",H[H.wordWrap=133]="wordWrap",H[H.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=136]="wordWrapColumn",H[H.wordWrapOverride1=137]="wordWrapOverride1",H[H.wordWrapOverride2=138]="wordWrapOverride2",H[H.wrappingIndent=139]="wrappingIndent",H[H.wrappingStrategy=140]="wrappingStrategy",H[H.showDeprecated=141]="showDeprecated",H[H.inlayHints=142]="inlayHints",H[H.editorClassName=143]="editorClassName",H[H.pixelRatio=144]="pixelRatio",H[H.tabFocusMode=145]="tabFocusMode",H[H.layoutInfo=146]="layoutInfo",H[H.wrappingInfo=147]="wrappingInfo",H[H.defaultColorDecorators=148]="defaultColorDecorators",H[H.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",H[H.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ue||(e.EditorOption=Ue={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(Ue.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Be(new I(Ue.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Be(new S),accessibilityPageSize:Be(new t(Ue.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new l(Ue.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Be(new s(Ue.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(Ue.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new I(Ue.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Be(new I(Ue.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Be(new I(Ue.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Be(new I(Ue.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Be(new I(Ue.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Be(new D(Ue.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Be(new s(Ue.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new I(Ue.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Be(new Ae),bracketPairGuides:Be(new ze),stickyTabStops:Be(new s(Ue.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Be(new s(Ue.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Be(new l(Ue.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Be(new t(Ue.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Be(new s(Ue.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Be(new I(Ue.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Be(new t(Ue.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Be(new s(Ue.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Be(new k),contextmenu:Be(new s(Ue.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(Ue.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Be(new D(Ue.cursorBlinking,"cursorBlinking",g.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Be(new I(Ue.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Be(new D(Ue.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],q,{description:c.localize(261,null)})),cursorSurroundingLines:Be(new t(Ue.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Be(new I(Ue.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Be(new t(Ue.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Be(new s(Ue.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(Ue.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(Ue.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new s(Ue.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Be(new W),dropIntoEditor:Be(new lt),stickyScroll:Be(new B),experimentalWhitespaceRendering:Be(new I(Ue.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Be(new l(Ue.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new f(Ue.fastScrollSensitivity,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:c.localize(272,null)})),find:Be(new N),fixedOverflowWidgets:Be(new s(Ue.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new s(Ue.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Be(new I(Ue.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Be(new s(Ue.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Be(new s(Ue.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Be(new t(Ue.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new s(Ue.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Be(new l(Ue.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Be(new ge),fontLigatures2:Be(new V),fontSize:Be(new ie),fontWeight:Be(new me),fontVariations:Be(new ce),formatOnPaste:Be(new s(Ue.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Be(new s(Ue.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Be(new s(Ue.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new s(Ue.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Be(new de),inDiffEditor:Be(new s(Ue.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new f(Ue.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>f.clamp(H,-5,20),{description:c.localize(286,null)})),lightbulb:Be(new Y),lineDecorationsWidth:Be(new we),lineHeight:Be(new ae),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new t(Ue.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(Ue.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Be(new s(Ue.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Be(new I(Ue.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Be(new ve),mouseStyle:Be(new I(Ue.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new f(Ue.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Be(new s(Ue.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Be(new s(Ue.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Be(new D(Ue.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Be(new I(Ue.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Be(new t(Ue.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Be(new I(Ue.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Be(new s(Ue.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Be(new t(Ue.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new X),pasteAs:Be(new st),parameterHints:Be(new Z),peekWidgetDefaultFocus:Be(new I(Ue.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),placeholder:Be(new $e),definitionLinkOpensInPeek:Be(new s(Ue.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Be(new Me),quickSuggestionsDelay:Be(new t(Ue.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Be(new s(Ue.readOnly,"readOnly",!1)),readOnlyMessage:Be(new z),renameOnType:Be(new s(Ue.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Be(new s(Ue.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Be(new I(Ue.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Be(new I(Ue.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(Ue.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Be(new I(Ue.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new I(Ue.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Be(new t(Ue.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(Ue.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Be(new Oe),scrollbar:Be(new K),scrollBeyondLastColumn:Be(new t(Ue.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Be(new s(Ue.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Be(new s(Ue.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Be(new s(Ue.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:Be(new s(Ue.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Be(new s(Ue.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new I(Ue.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Be(new s(Ue.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Be(new s(Ue.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Be(new _),snippetSuggestions:Be(new I(Ue.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Be(new it),smoothScrolling:Be(new s(Ue.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Be(new t(Ue.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ne),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new s(Ue.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Be(new t(Ue.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new t(Ue.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(Ue.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Be(new I(Ue.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Be(new I(Ue.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Be(new t(Ue.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new J),unusualLineTerminators:Be(new I(Ue.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Be(new s(Ue.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new s(Ue.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Be(new I(Ue.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new l(Ue.wordSeparators,"wordSeparators",p.$dt,{description:c.localize(360,null)})),wordWrap:Be(new I(Ue.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new l(Ue.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new l(Ue.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new t(Ue.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Be(new I(Ue.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new I(Ue.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new G),defaultColorDecorators:Be(new s(Ue.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Be(new pe),tabFocusMode:Be(new s(Ue.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new $t),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Pe)}}),define(Ce[106],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,w.$Ci)("environmentService"),e.$Ki=(0,w.$Di)(e.$Ji)}),define(Ce[30],Ie([1,0,59,20,13,15,2,173,3,21,16,47]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Bl=e.FileKind=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.FileOperationResult=e.$tl=e.$sl=e.$rl=e.$pl=e.FileChangeType=e.$ol=e.FileOperation=e.$il=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$9k=void 0,e.$0k=u,e.$$k=o,e.$_k=h,e.$al=i,e.$bl=s,e.$cl=n,e.$dl=t,e.$el=m,e.$fl=f,e.$gl=l,e.$hl=$,e.$jl=y,e.$kl=S,e.$ll=k,e.$ml=g,e.$nl=b,e.$ql=W,e.$Cl=me,e.$Dl=se,e.$Fl=be,e.$9k=(0,p.$Ci)("fileService");function u(re){return re.create===!0}var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(re){return!!(re.capabilities&a.FileReadWrite)}function i(re){return!!(re.capabilities&a.FileFolderCopy)}function s(re){return!!(re.capabilities&a.FileClone)}function n(re){return!!(re.capabilities&a.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&a.FileReadStream)}function m(re){return h(re)?!!(re.capabilities&a.FileAtomicRead):!1}function f(re){return h(re)?!!(re.capabilities&a.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&a.FileAtomicDelete)}function $(re){return!!(re.capabilities&a.Readonly)}var I;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Pe,Le){const Y=new D(Pe.toString(),Le);return k(Y,Le),Y}constructor(Pe,Le){super(Pe),this.code=Le}}e.$il=D;function y(re,Pe){return D.create(re,Pe)}function S(re){return re||y((0,M.localize)(0,null),I.Unknown)}function k(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function g(re){if(!re)return I.Unknown;if(re instanceof D)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return I.Unknown;switch(Pe[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function b(re){if(re instanceof N)return re.fileOperationResult;switch(g(re)){case I.FileNotFound:return ge.FILE_NOT_FOUND;case I.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case I.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case I.NoPermissions:return ge.FILE_PERMISSION_DENIED;case I.FileExists:return ge.FILE_MOVE_CONFLICT;case I.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor(Pe,Le,Y){this.resource=Pe,this.operation=Le,this.target=Y}isOperation(Pe){return this.operation===Pe}}e.$ol=T;var q;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class G{static{this.a=null}constructor(Pe,Le){this.c=Le,this.b=void 0,this.d=new v.$W(()=>{const Y=w.$Ii.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new v.$W(()=>{const Y=w.$Ii.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new v.$W(()=>{const Y=w.$Ii.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Pe){switch(Y.type){case q.ADDED:this.rawAdded.push(Y.resource);break;case q.UPDATED:this.rawUpdated.push(Y.resource);break;case q.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==G.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Pe,...Le){return this.h(Pe,{includeChildren:!1},...Le)}affects(Pe,...Le){return this.h(Pe,{includeChildren:!0},...Le)}h(Pe,Le,...Y){if(!Pe)return!1;const B=Y.length>0;return!!((!B||Y.includes(q.ADDED))&&(this.d.value.get(Pe)||Le.includeChildren&&this.d.value.findSuperstr(Pe))||(!B||Y.includes(q.UPDATED))&&(this.f.value.get(Pe)||Le.includeChildren&&this.f.value.findSuperstr(Pe))||(!B||Y.includes(q.DELETED))&&(this.g.value.findSubstr(Pe)||Le.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$pl=G;function W(re,Pe,Le){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==C.sep&&(Pe+=C.sep),Le?(0,P.$Ef)(re,Pe):re.indexOf(Pe)===0)}class N extends Error{constructor(Pe,Le,Y){super(Pe),this.fileOperationResult=Le,this.options=Y}}e.$rl=N;class V extends N{constructor(Pe,Le,Y,B){super(Pe,Le,B),this.fileOperationResult=Le,this.size=Y}}e.$sl=V;class ce extends N{constructor(Pe,Le,Y){super(Pe,ge.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Le}}e.$tl=ce;var ge;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$ul={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wl="files.associations",e.$xl="files.exclude",e.$yl="files.readonlyInclude",e.$zl="files.readonlyExclude",e.$Al="files.readonlyFromPermissions";var ie;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie||(e.FileKind=ie={})),e.$Bl="";function me(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function se(re,Pe){if(!Pe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(Le=>{const Y=Pe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(Y.dispose(),Le())})})}class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Pe){return(0,O.$gg)(Pe)||(Pe=0),Pe<de.KB?(0,M.localize)(1,null,Pe.toFixed(0)):Pe<de.MB?(0,M.localize)(2,null,(Pe/de.KB).toFixed(2)):Pe<de.GB?(0,M.localize)(3,null,(Pe/de.MB).toFixed(2)):Pe<de.TB?(0,M.localize)(4,null,(Pe/de.GB).toFixed(2)):(0,M.localize)(5,null,(Pe/de.TB).toFixed(2))}}e.$El=de;function be(re){const Pe=typeof re=="string"||re?.scheme===R.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===R.Schemas.file?1024*de.MB:Pe?10*de.MB:c.$o?50*de.MB:1024*de.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class w{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ai=w}),define(Ce[211],Ie([1,0,11,14,5,74,208,3,75,212]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;const R=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new p.$Ai,a=!1,h,i=R){this.i=o,this.j=a,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(M.$Bi,this),this._globalGraph=i?h?._globalGraph??new A.$mr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),a?.add(i),i}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let i=!1;try{return o({get:n=>{if(i)throw(0,C.$9)("service accessor is only valid during the invocation of its target method");const t=this.s(n,h);if(!t)throw new Error(`[invokeFunction] unknown service '${n}'`);return t}},...a)}finally{i=!0,h.stop()}}createInstance(o,...a){this.m();let h,i;return o instanceof O.$zi?(h=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),i=this.o(o,a,h)),h.stop(),i}o(o,a=[],h){const i=M._util.getServiceDependencies(o).sort((t,m)=>t.index-m.index),s=[];for(const t of i){const m=this.s(t.id,h);m||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(m)}const n=i.length>0?i[0].index:a.length;if(a.length!==n){console.trace(`[createInstance] First service dependency of ${o.name} at position ${n+1} conflicts with ${a.length} static arguments`);const t=n-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,n)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof O.$zi)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof O.$zi?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const i=new A.$mr(t=>t.id.toString());let s=0;const n=[{id:o,desc:a,_trace:h}];for(;n.length;){const t=n.pop();if(i.lookupOrInsertNode(t),s++>1e3)throw new v(i);for(const m of M._util.getServiceDependencies(t.desc.ctor)){const f=this.r(m.id);if(f||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(m.id)),f instanceof O.$zi){const l={id:m.id,desc:f,_trace:t._trace.branch(m.id,!0)};i.insertEdge(t,l),n.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new v(i);break}for(const{data:m}of t){if(this.r(m.id)instanceof O.$zi){const l=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,l)}i.removeNode(m)}}return this.r(o)}w(o,a,h=[],i,s){if(this.i.get(o)instanceof O.$zi)return this.x(o,a,h,i,s,this.g);if(this.k)return this.k.w(o,a,h,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],i,s,n){if(i){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const m=new Map,f=new w.$Vh(()=>{const l=t.o(a,h,s);for(const[$,I]of m){const D=l[$];if(typeof D=="function")for(const y of I)y.disposable=D.apply(l,y.listener)}return m.clear(),n.add(l),l});return new Proxy(Object.create(null),{get(l,$){if(!f.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let y=m.get($);return y||(y=new c.$6c,m.set($,y)),(k,g,b)=>{if(f.isInitialized)return f.value[$](k,g,b);{const L={listener:[k,g,b],disposable:void 0},T=y.push(L);return(0,P.$Tc)(()=>{T(),L.disposable?.dispose()})}}}if($ in l)return l[$];const I=f.value;let D=I[$];return typeof D!="function"||(D=D.bind(I),l[$]=D),D},set(l,$,I){return f.value[$]=I,!0},getPrototypeOf(l){return a.prototype}})}else{const t=this.o(a,h,s);return n.add(t),t}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$nr=u;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(E.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(E.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(E.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,n){const t=[],m=new Array(s+1).join("	");for(const[f,l,$]of n.h)if(l&&$){a=!0,t.push(`${m}CREATES -> ${f}`);const I=h(s+1,$);I&&t.push(I)}else t.push(`${m}uses -> ${f}`);return t.join(`
`)}const i=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(i.join(`
`))}}e.$or=d}),define(Ce[12],Ie([1,0,174,48,4,76,5,29,21,24,15,2,32,3]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$_j=e.LogLevel=e.$0j=e.$9j=void 0,e.$$j=r,e.log=a,e.$kk=D,e.$lk=y,e.$mk=S,e.$nk=k,w=qe(w),e.$9j=(0,E.$Ci)("logService"),e.$0j=(0,E.$Ci)("loggerService");function d(){return new Date().toISOString()}function r(g){return(0,R.$gg)(g)}var o;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$_j=o.Info;function a(g,b,L){switch(b){case o.Trace:g.trace(L);break;case o.Debug:g.debug(L);break;case o.Info:g.info(L);break;case o.Warning:g.warn(L);break;case o.Error:g.error(L);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function h(g,b=!1){let L="";for(let T=0;T<g.length;T++){let q=g[T];if(q instanceof Error&&(q=(0,C.$nj)(q,b)),typeof q=="object")try{q=JSON.stringify(q)}catch{}L+=(T>0?" ":"")+q}return L}class i extends A.$Vc{constructor(){super(...arguments),this.b=e.$_j,this.c=this.B(new P.$je),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$bk=i;class s extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...L){this.f(o.Trace)&&this.g(o.Trace,h([b,...L],!0))}debug(b,...L){this.f(o.Debug)&&this.g(o.Debug,h([b,...L]))}info(b,...L){this.f(o.Info)&&this.g(o.Info,h([b,...L]))}warn(b,...L){this.f(o.Warning)&&this.g(o.Warning,h([b,...L]))}error(b,...L){if(this.f(o.Error))if(b instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=b.stack,this.g(o.Error,h(T))}else this.g(o.Error,h([b,...L]))}flush(){}}e.$ck=s;class n extends i{constructor(b=e.$_j){super(),this.setLevel(b),this.g=!p.$i}trace(b,...L){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}debug(b,...L){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}info(b,...L){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}warn(b,...L){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...L):console.warn(`[main ${d()}]`,b,...L))}error(b,...L){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...L):console.error(`[main ${d()}]`,b,...L))}flush(){}}e.$dk=n;class t extends i{constructor(b=e.$_j,L=!0){super(),this.g=L,this.setLevel(b)}trace(b,...L){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...L):console.log(b,...L))}debug(b,...L){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...L):console.log(b,...L))}info(b,...L){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...L):console.log(b,...L))}warn(b,...L){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...L):console.log(b,...L))}error(b,...L){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...L):console.error(b,...L))}flush(){}}e.$ek=t;class m extends i{constructor(b,L=e.$_j){super(),this.g=b,this.setLevel(L)}trace(b,...L){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...L])}debug(b,...L){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...L])}info(b,...L){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...L])}warn(b,...L){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...L])}error(b,...L){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...L])}h(b){return typeof b=="string"?b:(0,C.$nj)(b,this.f(o.Trace))}flush(){}}e.$fk=m;class f extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const L of this.g)L.setLevel(b);super.setLevel(b)}trace(b,...L){for(const T of this.g)T.trace(b,...L)}debug(b,...L){for(const T of this.g)T.debug(b,...L)}info(b,...L){for(const T of this.g)T.info(b,...L)}warn(b,...L){for(const T of this.g)T.warn(b,...L)}error(b,...L){for(const T of this.g)T.error(b,...L)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$gk=f;class l extends A.$Vc{constructor(b,L,T){if(super(),this.h=b,this.j=L,this.b=new M.$Bc,this.c=this.B(new P.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$je),this.onDidChangeVisibility=this.g.event,T)for(const q of T)this.b.set(q.resource,{logger:void 0,info:q})}m(b){return(0,R.$cg)(b)?[...this.b.values()].find(L=>L.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,L){const T=this.n(b),q=(0,R.$cg)(b)?b:L?.id??(0,O.$qj)(T.toString()).toString(16);let G=this.b.get(T)?.logger;const W=L?.logLevel==="always"?o.Trace:L?.logLevel;G||(G=this.s(T,W??this.getLogLevel(T)??this.h,{...L,id:q}));const N={logger:G,info:{resource:T,id:q,logLevel:W,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(N.info),this.b.set(T,N),G}n(b){return(0,R.$cg)(b)?(0,c.$dh)(this.j,`${b}.log`):b}setLogLevel(b,L){if(v.URI.isUri(b)){const T=b,q=L,G=this.b.get(T);G&&q!==G.info.logLevel&&(G.info.logLevel=q===this.h?void 0:q,G.logger?.setLevel(q),this.b.set(G.info.resource,G),this.f.fire([T,q]))}else{this.h=b;for(const[T,q]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,L){const T=this.m(b);T&&L!==!T.info.hidden&&(T.info.hidden=!L,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,L]))}getLogLevel(b){let L;return b&&(L=this.b.get(b)?.info.logLevel),L??this.h}registerLogger(b){const L=this.b.get(b.resource);L?L.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const L=this.b.get(b);L&&(L.logger&&L.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hk=l;class ${constructor(){this.onDidChangeLogLevel=new P.$je().event}setLevel(b){}getLevel(){return o.Info}trace(b,...L){}debug(b,...L){}info(b,...L){}warn(b,...L){}error(b,...L){}critical(b,...L){}dispose(){}flush(){}}e.$ik=$;class I extends ${}e.$jk=I;function D(g){if(g.verbose)return o.Trace;if(typeof g.logLevel=="string"){const b=k(g.logLevel.toLowerCase());if(b!==void 0)return b}return e.$_j}function y(g){switch(g){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function S(g){switch(g){case o.Trace:return{original:"Trace",value:w.localize(0,null)};case o.Debug:return{original:"Debug",value:w.localize(1,null)};case o.Info:return{original:"Info",value:w.localize(2,null)};case o.Warning:return{original:"Warning",value:w.localize(3,null)};case o.Error:return{original:"Error",value:w.localize(4,null)};case o.Off:return{original:"Off",value:w.localize(5,null)}}}function k(g){switch(g){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ok=new u.$Tj("logLevel",y(o.Info))}),define(Ce[213],Ie([1,0,5,12]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=void 0;class P extends w.$Vc{constructor(A,M=[]){super(),this.a=new C.$gk([A,...M]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...M){this.a.trace(A,...M)}debug(A,...M){this.a.debug(A,...M)}info(A,...M){this.a.info(A,...M)}warn(A,...M){this.a.warn(A,...M)}error(A,...M){this.a.error(A,...M)}flush(){this.a.flush()}}e.$SQ=P});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[107],Ie([1,0,36,175,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,w=ri(w);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function c(d,r){return r-d}p.compare=c;const R=Object.create(null);R[p.Error]=(0,C.localize)(0,null),R[p.Warning]=(0,C.localize)(1,null),R[p.Info]=(0,C.localize)(2,null);function v(d){return R[d]||""}p.toString=v;function u(d){switch(d){case w.default.Error:return p.Error;case w.default.Warning:return p.Warning;case w.default.Info:return p.Info;case w.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(d){switch(d){case p.Error:return w.default.Error;case p.Warning:return w.default.Warning;case p.Info:return w.default.Info;case p.Hint:return w.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var M;(function(p){const c="";function R(u){return v(u,!0)}p.makeKey=R;function v(u,E){const d=[c];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(c),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(c),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(c),u.message&&E?d.push(u.message.replace("\xA6","\\\xA6")):d.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(c),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(c),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}p.makeKeyOptionalMessage=v})(M||(e.IMarkerData=M={})),e.$wu=(0,P.$Ci)("markerService")});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[214],Ie([1,0,4,36,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$jw=e.Severity=void 0,e.$kw=M,C=ri(C),e.Severity=C.default,e.$jw=(0,P.$Ci)("notificationService");var O;(function(v){v[v.DEFAULT=0]="DEFAULT",v[v.SILENT=1]="SILENT",v[v.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.PROFILE=1]="PROFILE",v[v.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function M(v){if(v){const u=v;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(v){v[v.OFF=0]="OFF",v[v.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new R,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$lw=c;class R{infinite(){}done(){}total(u){}worked(u){}}e.$mw=R}),define(Ce[108],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qk=e.$pk=void 0,e.$pk=(0,w.$Ci)("productService"),e.$qk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(oe,e,w,C){var P=arguments.length,O=P<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,w):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(oe,e,w,C);else for(var M=oe.length-1;M>=0;M--)(A=oe[M])&&(O=(P<3?A(O):P>3?A(e,w,O):A(e,w))||O);return P>3&&O&&Object.defineProperty(e,w,O),O},Ve=this&&this.__param||function(oe,e){return function(w,C){e(w,C,oe)}};define(Ce[77],Ie([1,0,11,22,5,3]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tw=e.$sw=e.$rw=e.$qw=e.$pw=e.$ow=e.ProgressLocation=e.$nw=void 0,e.$nw=(0,O.$Ci)("progressService");var A;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$ow=Object.freeze({total(){},worked(){},done(){}});class M{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$pw=M;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$qw=p;let c=class extends P.$Vc{constructor(u,E){super(),this.a=new w.$Zh,E.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Tc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$rw=c,e.$rw=c=He([Ve(1,e.$nw)],c);class R extends P.$Vc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Uc)}start(u){this.stop();const E=++this.a,d=new C.$ue;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Tc)(()=>d.cancel())),this.b.add((0,P.$Tc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$sw=R,e.$tw=(0,O.$Ci)("editorProgressService")}),define(Ce[31],Ie([1,0,62,15]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=void 0,w=qe(w),C=qe(C);class P{constructor(){this.a=new Map}add(A,M){w.ok(C.$cg(A)),w.ok(C.$eg(M)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,M)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$mo=new P}),define(Ce[78],Ie([1,0,4,31]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,C=qe(C),e.$no={JSONContribution:"base.contributions.json"};function P(M){return M.length>0&&M.charAt(M.length-1)==="#"?M.substring(0,M.length-1):M}class O{constructor(){this.b=new w.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[P(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;C.$mo.add(e.$no.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,4,15,168,42,78,31]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.ConfigurationScope=e.$ro=e.EditPresentationTypes=void 0,e.$Co=r,e.$Do=o,e.$Eo=a,e.$Fo=i,e.$Go=s,P=qe(P),O=qe(O);var c;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ro={Configuration:"base.contributions.configuration"};var R;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo="vscode://schemas/settings/resourceLanguage",e.$zo="vscode://schemas/settings/configurationDefaults";const v=p.$mo.as(M.$no.JSONContribution);class u{constructor(){this.h=new Set,this.i=new C.$je,this.onDidSchemaChange=this.i.event,this.j=new C.$je,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$yo,this.g),this.v()}registerConfiguration(t,m=!0){this.registerConfigurations([t],m)}registerConfigurations(t,m=!0){const f=new Set;this.n(t,m,f),v.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(t){const m=new Set;this.o(t,m),v.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:m})}updateConfigurations({add:t,remove:m}){const f=new Set;this.o(m,f),this.n(t,!1,f),v.registerSchema(e.$yo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(t){const m=new Set;this.k(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}k(t,m){const f=[];for(const{overrides:l,source:$}of t)for(const I in l)if(m.add(I),e.$Bo.test(I)){const D=this.a.get(I),y=D?.valuesSources??new Map;if($)for(const b of Object.keys(l[I]))y.set(b,$);const S={...D?.value||{},...l[I]};this.a.set(I,{source:$,value:S,valuesSources:y});const k=(0,A.$gj)(I),g={type:"object",default:S,description:O.localize(1,null,k),$ref:e.$yo,defaultDefaultValue:S,source:P.$cg($)?void 0:$,defaultValueSource:$};f.push(...r(I)),this.d[I]=g,this.b.properties[I]=g}else{this.a.set(I,{value:l[I],source:$});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(f)}deregisterDefaultConfigurations(t){const m=new Set;this.l(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}l(t,m){for(const{overrides:f,source:l}of t)for(const $ in f){const I=this.a.get($),D=P.$cg(l)?l:l?.id,y=P.$cg(I?.source)?I?.source:I?.source?.id;if(D===y)if(m.add($),this.a.delete($),e.$Bo.test($))delete this.d[$],delete this.b.properties[$];else{const S=this.d[$];S&&(this.w($,S),this.r($,S))}}this.u()}deltaConfiguration(t){let m=!1;const f=new Set;t.removedDefaults&&(this.l(t.removedDefaults,f),m=!0),t.addedDefaults&&(this.k(t.addedDefaults,f),m=!0),t.removedConfigurations&&this.o(t.removedConfigurations,f),t.addedConfigurations&&this.n(t.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const m of t)this.h.add(m);this.u()}n(t,m,f){t.forEach(l=>{this.p(l,m,l.extensionInfo,l.restrictedProperties,void 0,f),this.c.push(l),this.q(l)})}o(t,m){const f=l=>{if(l.properties)for(const $ in l.properties){m.add($);const I=this.d[$];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[$],this.s($,l.properties[$])}l.allOf?.forEach($=>f($))};for(const l of t){f(l);const $=this.c.indexOf(l);$!==-1&&this.c.splice($,1)}}p(t,m=!0,f,l,$=R.WINDOW,I){$=P.$lg(t.scope)?$:t.scope;const D=t.properties;if(D)for(const S in D){const k=D[S];if(m&&i(S,k)){delete D[S];continue}if(k.source=f,k.defaultDefaultValue=D[S].default,this.w(S,k),e.$Bo.test(S)?k.scope=void 0:(k.scope=P.$lg(k.scope)?$:k.scope,k.restricted=P.$lg(k.restricted)?!!l?.includes(S):k.restricted),D[S].hasOwnProperty("included")&&!D[S].included){this.f[S]=D[S],delete D[S];continue}else this.d[S]=D[S],D[S].policy?.name&&this.e.set(D[S].policy.name,S);!D[S].deprecationMessage&&D[S].markdownDeprecationMessage&&(D[S].deprecationMessage=D[S].markdownDeprecationMessage),I.add(S)}const y=t.allOf;if(y)for(const S of y)this.p(S,m,f,l,$,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const m=f=>{const l=f.properties;if(l)for(const I in l)this.r(I,l[I]);f.allOf?.forEach(m)};m(t)}r(t,m){switch(e.$so.properties[t]=m,m.scope){case R.APPLICATION:e.$to.properties[t]=m;break;case R.MACHINE:e.$uo.properties[t]=m;break;case R.MACHINE_OVERRIDABLE:e.$vo.properties[t]=m;break;case R.WINDOW:e.$wo.properties[t]=m;break;case R.RESOURCE:e.$xo.properties[t]=m;break;case R.LANGUAGE_OVERRIDABLE:e.$xo.properties[t]=m,this.g.properties[t]=m;break}}s(t,m){switch(delete e.$so.properties[t],m.scope){case R.APPLICATION:delete e.$to.properties[t];break;case R.MACHINE:delete e.$uo.properties[t];break;case R.MACHINE_OVERRIDABLE:delete e.$vo.properties[t];break;case R.WINDOW:delete e.$wo.properties[t];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$xo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const m=`[${t}]`,f={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$yo};this.w(m,f),e.$so.properties[m]=f,e.$to.properties[m]=f,e.$uo.properties[m]=f,e.$vo.properties[m]=f,e.$wo.properties[m]=f,e.$xo.properties[m]=f}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$yo};e.$so.patternProperties[e.$Ao]=t,e.$to.patternProperties[e.$Ao]=t,e.$uo.patternProperties[e.$Ao]=t,e.$vo.patternProperties[e.$Ao]=t,e.$wo.patternProperties[e.$Ao]=t,e.$xo.patternProperties[e.$Ao]=t,this.i.fire()}w(t,m){const f=this.a.get(t);let l=f?.value,$=f?.source;P.$jg(l)&&(l=m.defaultDefaultValue,$=void 0),P.$jg(l)&&(l=a(m.type)),m.default=l,m.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Ao=`^(${E})+$`,e.$Bo=new RegExp(e.$Ao);function r(n){const t=[];if(e.$Bo.test(n)){let m=d.exec(n);for(;m?.length;){const f=m[1].trim();f&&t.push(f),m=d.exec(n)}}return(0,w.$Nb)(t)}function o(n){return n.reduce((t,m)=>`${t}[${m}]`,"")}function a(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$mo.add(e.$ro.Configuration,h);function i(n,t){return n.trim()?e.$Bo.test(n)?O.localize(7,null,n):h.getConfigurationProperties()[n]!==void 0?O.localize(8,null,n):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,n,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function s(){const n=[],t=h.getConfigurationProperties();for(const m of Object.keys(t))n.push([m,t[m].scope]);return n.push(["launch",R.RESOURCE]),n.push(["task",R.RESOURCE]),n}}),define(Ce[215],Ie([1,0,18,4,135,5,29,26,15,2,42,54,30,31]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Lo=s,w=qe(w),P=qe(P),M=qe(M),p=qe(p);function d(f){return Object.isFrozen(f)?f:M.$ao(f)}class r{static createEmptyModel(l){return new r({},[],[],void 0,l)}constructor(l,$,I,D,y){this.b=l,this.c=$,this.d=I,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map($=>{if($ instanceof r)return $;const I=new o("",this.f);return I.parseRaw($),I.configurationModel});this.g=l.reduce(($,I)=>I===$?I:$.merge(I),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,R.$ej)(this.contents,l):this.contents}inspect(l,$){const I=this;return{get value(){return d(I.rawConfiguration.getValue(l))},get override(){return $?d(I.rawConfiguration.getOverrideValue(l,$)):void 0},get merged(){return d($?I.rawConfiguration.override($).getValue(l):I.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:S,keys:k}of I.rawConfiguration.overrides){const g=new r(y,k,[],void 0,I.f).getValue(l);g!==void 0&&D.push({identifiers:S,value:g})}return D.length?d(D):void 0}}}getOverrideValue(l,$){const I=this.j($);return I?l?(0,R.$ej)(I,l):I:void 0}getKeysForOverrideIdentifier(l){const $=[];for(const I of this.overrides)I.identifiers.includes(l)&&$.push(...I.keys);return w.$Nb($)}getAllOverrideIdentifiers(){const l=[];for(const $ of this.overrides)l.push(...$.identifiers);return w.$Nb(l)}override(l){let $=this.a.get(l);return $||($=this.h(l),this.a.set(l,$)),$}merge(...l){const $=M.$_n(this.contents),I=M.$_n(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const S of l)if(y.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i($,S.contents);for(const k of S.overrides){const[g]=I.filter(b=>w.$vb(b.identifiers,k.identifiers));g?(this.i(g.contents,k.contents),g.keys.push(...k.keys),g.keys=w.$Nb(g.keys)):I.push(M.$_n(k))}for(const k of S.keys)D.indexOf(k)===-1&&D.push(k)}return new r($,D,I,y.every(S=>S instanceof r)?void 0:y,this.f)}h(l){const $=this.j(l);if(!$||typeof $!="object"||!Object.keys($).length)return this;const I={};for(const D of w.$Nb([...Object.keys(this.contents),...Object.keys($)])){let y=this.contents[D];const S=$[D];S&&(typeof y=="object"&&typeof S=="object"?(y=M.$_n(y),this.i(y,S)):y=S),I[D]=y}return new r(I,this.keys,this.overrides,void 0,this.f)}i(l,$){for(const I of Object.keys($)){if(I in l&&p.$eg(l[I])&&p.$eg($[I])){this.i(l[I],$[I]);continue}l[I]=M.$_n($[I])}}j(l){let $=null,I=null;const D=y=>{y&&(I?this.i(I,y):I=M.$_n(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?$=y.contents:y.identifiers.includes(l)&&D(y.contents);return D($),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,$){this.k(l,$,!0)}setValue(l,$){this.k(l,$,!1)}removeValue(l){const $=this.keys.indexOf(l);$!==-1&&(this.keys.splice($,1),(0,R.$dj)(this.contents,l),v.$Bo.test(l)&&this.overrides.splice(this.overrides.findIndex(I=>w.$vb(I.identifiers,(0,v.$Co)(l))),1))}k(l,$,I){(0,R.$cj)(this.contents,l,$,D=>this.f.error(D)),I=I||this.keys.indexOf(l)===-1,I&&this.keys.push(l),v.$Bo.test(l)&&this.overrides.push({identifiers:(0,v.$Co)(l),keys:Object.keys(this.contents[l]),contents:(0,R.$bj)(this.contents[l],D=>this.f.error(D))})}}e.$Ho=r;class o{constructor(l,$){this.f=l,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,$){if(!p.$lg(l)){const I=this.h(l);this.parseRaw(I,$)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,$){this.a=l;const{contents:I,keys:D,overrides:y,restricted:S,hasExcludedProperties:k}=this.i(l,$);this.b=new r(I,D,y,k?[l]:void 0,this.g),this.c=S||[]}h(l){let $={},I=null,D=[];const y=[],S=[];function k(b){Array.isArray(D)?D.push(b):I!==null&&(D[I]=b)}const g={onObjectBegin:()=>{const b={};k(b),y.push(D),D=b,I=null},onObjectProperty:b=>{I=b},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const b=[];k(b),y.push(D),D=b,I=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:k,onError:(b,L,T)=>{S.push({error:b,offset:L,length:T})}};if(l)try{P.$Zn(l,g),$=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return $}i(l,$){const I=E.$mo.as(v.$ro.Configuration).getConfigurationProperties(),D=this.j(l,I,!0,$);l=D.raw;const y=(0,R.$bj)(l,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(l),k=this.l(l,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:y,keys:S,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,$,I,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const S={},k=[];for(const g in l)if(v.$Bo.test(g)&&I){const b=this.j(l[g],$,!1,D);S[g]=b.raw,y=y||b.hasExcludedProperties,k.push(...b.restricted)}else{const b=$[g],L=b?typeof b.scope<"u"?b.scope:v.ConfigurationScope.WINDOW:void 0;b?.restricted&&k.push(g),!D.exclude?.includes(g)&&(D.include?.includes(g)||(L===void 0||D.scopes===void 0||D.scopes.includes(L))&&!(D.skipRestricted&&b?.restricted))?S[g]=l[g]:y=!0}return{raw:S,restricted:k,hasExcludedProperties:y}}l(l,$){const I=[];for(const D of Object.keys(l))if(v.$Bo.test(D)){const y={};for(const S in l[D])y[S]=l[D][S];I.push({identifiers:(0,v.$Co)(D),keys:Object.keys(y),contents:(0,R.$bj)(y,$)})}return I}}e.$Io=o;class a extends O.$Vc{constructor(l,$,I,D,y){super(),this.c=l,this.f=$,this.g=D,this.h=y,this.b=this.B(new C.$je),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),y),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(u.FileOperation.CREATE)||S.isOperation(u.FileOperation.COPY)||S.isOperation(u.FileOperation.DELETE)||S.isOperation(u.FileOperation.WRITE))&&I.isEqual(S.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jo=a;class h{constructor(l,$,I,D,y,S,k,g,b,L,T,q,G){this.a=l,this.b=$,this.c=I,this.overrideIdentifiers=D,this.d=y,this.f=S,this.g=k,this.h=g,this.i=b,this.j=L,this.k=T,this.l=q,this.m=G}get value(){return d(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(l,$,I,D,y,S,k,g,b,L){this.j=l,this.l=$,this.m=I,this.n=D,this.p=y,this.q=S,this.r=k,this.s=g,this.t=b,this.u=L,this.h=null,this.i=new A.$Bc,this.v=null}getValue(l,$,I){return this.w(l,$,I).getValue(l)}updateValue(l,$,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=r.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,$===void 0?D.removeValue(l):D.setValue(l,$),I.resource||(this.h=null)}inspect(l,$,I){const D=this.w(l,$,I),y=this.A($.resource,I),S=$.resource?this.t.get($.resource)||this.s:this.s,k=new Set;for(const g of D.overrides)for(const b of g.identifiers)D.getOverrideValue(l,b)!==void 0&&k.add(b);return new h(l,$,D.getValue(l),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,y||void 0,S)}keys(l){const $=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,$){this.r.set(l,$),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,$){const I=[];if(!$){const{added:D,updated:y,removed:S}=t(this.j,l);$=[...D,...y,...S]}for(const D of $)for(const y of(0,v.$Co)(D)){const S=this.j.getKeysForOverrideIdentifier(y),k=l.getKeysForOverrideIdentifier(y),g=[...k.filter(b=>S.indexOf(b)===-1),...S.filter(b=>k.indexOf(b)===-1),...S.filter(b=>!M.$do(this.j.override(y).getValue(b),l.override(y).getValue(b)))];I.push([y,g])}return this.updateDefaultConfiguration(l),{keys:$,overrides:I}}compareAndUpdatePolicyConfiguration(l){const{added:$,updated:I,removed:D}=t(this.l,l),y=[...$,...I,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.applicationConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateApplicationConfiguration(l),{keys:S,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.localUserConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateLocalUserConfiguration(l),{keys:S,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.remoteUserConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateRemoteUserConfiguration(l),{keys:S,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.workspaceConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateWorkspaceConfiguration(l),{keys:S,overrides:y}}compareAndUpdateFolderConfiguration(l,$){const I=this.folderConfigurations.get(l),{added:D,updated:y,removed:S,overrides:k}=t(I,$),g=[...D,...y,...S];return(g.length||!I)&&this.updateFolderConfiguration(l,$),{keys:g,overrides:k}}compareAndDeleteFolderConfiguration(l){const $=this.folderConfigurations.get(l);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:I,updated:D,removed:y,overrides:S}=t($,void 0);return{keys:[...I,...D,...y],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,$,I){let D=this.x($,I);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},$){let I=this.y();if($&&l){const D=$.getFolder(l);D&&(I=this.z(D.uri)||I);const y=this.t.get(l);y&&(I=I.merge(y))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let $=this.i.get(l);if(!$){const I=this.y(),D=this.r.get(l);D?($=I.merge(D),this.i.set(l,$)):$=I}return $}A(l,$){if($&&l){const I=$.getFolder(l);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,$)=>{const{contents:I,overrides:D,keys:y}=this.r.get($);return l.push([$,{contents:I,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach($=>l.add($)),this.userConfiguration.keys.forEach($=>l.add($)),this.q.keys.forEach($=>l.add($)),this.r.forEach($=>$.keys.forEach(I=>l.add(I))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>l.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>l.add($)),this.q.getAllOverrideIdentifiers().forEach($=>l.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(I=>l.add(I))),[...l.values()]}D(l){const $=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.q.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(l).forEach(D=>$.add(D))),[...$.values()]}static parse(l,$){const I=this.E(l.defaults,$),D=this.E(l.policy,$),y=this.E(l.application,$),S=this.E(l.user,$),k=this.E(l.workspace,$),g=l.folders.reduce((b,L)=>(b.set(c.URI.revive(L[0]),this.E(L[1],$)),b),new A.$Bc);return new i(I,D,y,S,r.createEmptyModel($),k,g,r.createEmptyModel($),new A.$Bc,$)}static E(l,$){return new r(l.contents,l.keys,l.overrides,void 0,$)}}e.$Ko=i;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const l=new Set,$=new Map;for(const D of f)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,S])=>{const k=(0,A.$yc)($,y,new Set);S.forEach(g=>k.add(g))});const I=[];return $.forEach((D,y)=>I.push([y,[...D.values()]])),{keys:[...l.values()],overrides:I}}class n{constructor(l,$,I,D,y){this.change=l,this.f=$,this.g=I,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of l.keys)this.affectedKeys.add(S);for(const[,S]of l.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,$){const I=this.a+l,D=this.d.indexOf(I);if(D<0)return!1;const y=D+I.length;if(y>=this.d.length)return!1;const S=this.d.charCodeAt(y);if(S!==this.b&&S!==this.c)return!1;if($){const k=this.previousConfiguration?this.previousConfiguration.getValue(l,$,this.f?.workspace):void 0,g=this.g.getValue(l,$,this.h);return!M.$do(k,g)}return!0}}e.$Mo=n;function t(f,l){const{added:$,removed:I,updated:D}=m(l?.rawConfiguration,f?.rawConfiguration),y=[],S=f?.getAllOverrideIdentifiers()||[],k=l?.getAllOverrideIdentifiers()||[];if(l){const g=k.filter(b=>!S.includes(b));for(const b of g)y.push([b,l.getKeysForOverrideIdentifier(b)])}if(f){const g=S.filter(b=>!k.includes(b));for(const b of g)y.push([b,f.getKeysForOverrideIdentifier(b)])}if(l&&f){for(const g of S)if(k.includes(g)){const b=m({contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)},{contents:l.getOverrideValue(void 0,g)||{},keys:l.getKeysForOverrideIdentifier(g)});y.push([g,[...b.added,...b.removed,...b.updated]])}}return{added:$,removed:I,updated:D,overrides:y}}function m(f,l){const $=f?l?f.keys.filter(y=>l.keys.indexOf(y)===-1):[...f.keys]:[],I=l?f?l.keys.filter(y=>f.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(f&&l){for(const y of l.keys)if(f.keys.indexOf(y)!==-1){const S=(0,R.$ej)(l.contents,y),k=(0,R.$ej)(f.contents,y);M.$do(S,k)||D.push(y)}}return{added:$,removed:I,updated:D}}}),define(Ce[109],Ie([1,0,14,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.RemoteAuthorityResolverErrorCode=e.$Pl=e.$Ol=e.RemoteConnectionType=e.$Nl=void 0,e.$Rl=c,e.$Nl=(0,C.$Ci)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(v){this.id=v,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ol=O;class A{constructor(v,u){this.host=v,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pl=A;var M;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(M||(e.RemoteAuthorityResolverErrorCode=M={}));class p extends w.$cb{static isNotAvailable(v){return v instanceof p&&v._code===M.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof p&&v._code===M.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof p&&v._code===M.NoResolverFound}static isInvalidAuthority(v){return v instanceof p&&v._code===M.InvalidAuthority}static isHandled(v){return v instanceof p&&v.isHandled}constructor(v,u=M.Unknown,E){super(v),this._message=v,this._code=u,this._detail=E,this.isHandled=u===M.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ql=p;function c(R){const v=R.indexOf("+");return v===-1?R:R.substring(0,v)}}),define(Ce[63],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=C,e.$en=P,e.$fn=O,e.$gn=A;function C(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function O(p){const{host:c,port:R}=M(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:R}}function A(p,c){let{host:R,port:v}=M(p);return typeof v>"u"&&(v=c),{host:R,port:v}}function M(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const v=p.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,63]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$pn=e.$on=e.$nn=e.TargetPlatform=e.ExtensionType=e.$mn=e.$kn=e.$jn=e.$in=e.$hn=void 0,e.$ln=O,e.$qn=v,e.$rn=u,e.$sn=E,e.$tn=d,w=qe(w),e.$hn="extensions.user.cache",e.$in="extensions.builtin.cache",e.$jn="undefined_publisher",e.$kn=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$mn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var M;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(M||(e.TargetPlatform=M={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,i=typeof a=="string"?a:a.value;return w.$Df(h,i)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$nn=p;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$on=c;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,a){this.c.set(p.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pn=R;function v(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function E(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.$en)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$un=(0,C.$Ci)("IBuiltinExtensionsScannerService")}),define(Ce[110],Ie([1,0,21,171,19,3]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.ExtensionManagementErrorCode=e.$fp=e.ExtensionGalleryErrorCode=e.$ep=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=M,e.$_o=p,e.$ap=c,e.$bp=R,e.$cp=v,e.$dp=u,e.$4o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5o=new RegExp(e.$4o),e.$6o="__web_extension",e.$7o="skipWalkthrough",e.$8o="extensionInstallSource",e.$9o="dependecyOrPackExtensionInstall",e.$0o="clientTargetPlatform";var A;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function M(n){switch(n){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(n){switch(n){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(n,t){switch(n){case w.Platform.Windows:return t==="x64"?P.TargetPlatform.WIN32_X64:t==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Linux:return t==="x64"?P.TargetPlatform.LINUX_X64:t==="arm64"?P.TargetPlatform.LINUX_ARM64:t==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?P.TargetPlatform.ALPINE_X64:t==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Mac:return t==="x64"?P.TargetPlatform.DARWIN_X64:t==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Web:return P.TargetPlatform.WEB}}function R(n,t){return t===P.TargetPlatform.WEB&&!n.includes(P.TargetPlatform.WEB)}function v(n,t,m){return R(t,m)?!1:n===P.TargetPlatform.UNDEFINED||n===P.TargetPlatform.UNIVERSAL?!0:n===P.TargetPlatform.UNKNOWN?!1:n===m}function u(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var E;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(n){n.Install="install",n.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$ep=(0,O.$Ci)("extensionGalleryService");var a;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$fp=h;var i;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class s extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$gp=s,e.$hp=(0,O.$Ci)("extensionManagementService"),e.$ip="extensionsIdentifiers/disabled",e.$jp="extensionsIdentifiers/enabled",e.$kp=(0,O.$Ci)("IGlobalExtensionEnablementService"),e.$lp=(0,O.$Ci)("IExtensionTipsService"),e.$mp=(0,C.localize2)(0,"Extensions"),e.$np=(0,C.localize2)(1,"Preferences")}),define(Ce[111],Ie([1,0,14,19]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=e.$FG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,M){this.a.set(A,M)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const M=Object.create(null);for(const p of A){const c=this.readActivationEvents(p);c.length>0&&(M[C.$nn.toKey(p.identifier)]=c)}return M}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const M=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<M.length;p++)M[p]==="onUri"&&(M[p]=`onUri:${C.$nn.toKey(A.identifier)}`);if(!A.contributes)return M;for(const p in A.contributes){const c=this.a.get(p);if(!c)continue;const R=A.contributes[p],v=Array.isArray(R)?R:[R];try{c(v,M)}catch(u){(0,w.$2)(u)}}return M}}e.$FG=P,e.$GG=new P}),define(Ce[216],Ie([1,0,23,14,5,176,54,3,12,31]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0,e.$1p=u,e.$2p=E,e.$3p=d,e.$4p=r,e.$5p=o,e.$6p=a,e.$Yp=(0,M.$Ci)("requestService");class R{constructor(n){this.b=n}toJSON(){if(!this.a){const n=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?n[t]="*****":n[t]=this.b[t];this.a=n}return this.a}}class v extends P.$Vc{constructor(n){super(),this.b=0,this.a=n.createLogger("network",{name:(0,O.localize)(0,null),when:p.$ok.isEqualTo((0,p.$lk)(p.LogLevel.Trace)).serialize()})}async c(n,t,m){const f=`${n} #${++this.b}: ${t.url}`;this.a.trace(`${f} - begin`,t.type,new R(t.headers??{}));try{const l=await m();return this.a.trace(`${f} - end`,t.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${f} - error`,t.type,(0,C.$$)(l)),l}}}e.$Zp=v;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function E(s){return s.res.statusCode===204}async function d(s){return E(s)?null:(await(0,w.$Xe)(s.stream)).toString()}async function r(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(E(s))return null;const t=(await(0,w.$Xe)(s.stream)).toString();try{return JSON.parse(t)}catch(m){throw m.message+=`:
`+t,m}}function a(s){i(s)}let h;function i(s){const n=c.$mo.as(A.$ro.Configuration),t=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[h],remove:t?[t]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ce[217],Ie([1,0,21,79,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=A,e.$pp=M;function O(p){if(w.$u===w.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,c,R,v,u,E,d,r,o,a){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,P.$Yg)()+Date.now(),h.commitHash=v,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.$h)(w.$u),h["common.nodePlatform"]=C.$ec,h["common.nodeArch"]=R,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let i=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(h["common.snap"]="true");const n=O(c);return n&&(h["common.platformDetail"]=n),h}function M(p){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const R=c.toLowerCase();return p.some(v=>R===v)}}),define(Ce[112],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=(0,w.$Ci)("telemetryService"),e.$9l=(0,w.$Ci)("customEndpointTelemetryService"),e.$0l="telemetry.currentSessionDate",e.$$l="telemetry.firstSessionDate",e.$_l="telemetry.lastSessionDate",e.$am="telemetry.machineId",e.$bm="telemetry.sqmId",e.$cm="telemetry.devDeviceId",e.$dm="telemetry",e.$em="telemetry.telemetryLevel",e.$fm="telemetry.enableCrashReporter",e.$gm="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ce[64],Ie([1,0,26,15,63,217,112]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$xp=R,e.$yp=v,e.$zp=u,e.$Ap=E,e.$Bp=r,e.$Cp=a,e.$Dp=h,e.$Ep=n;class M{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$qp=M;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$rp=p,e.$sp=new p;class c{async publicLog(m,f,l){}async publicLogError(m,f,l){}}e.$tp=c,e.$up="telemetry",e.$vp="extensionTelemetryLog",e.$wp={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!t.enableTelemetry)}function v(t,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const m=t.getValue(A.$em),f=t.getValue(A.$fm);if(t.getValue(A.$gm)===!1||f===!1)return A.TelemetryLevel.NONE;switch(m??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(t){const m={},f={},l={};o(t,l);for(let $ in l){$=$.length>150?$.substr($.length-149):$;const I=l[$];typeof I=="number"?f[$]=I:typeof I=="boolean"?f[$]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${I.length}`),m[$]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(m[$]=I)}return{properties:m,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const m=(0,P.$en)(t);return d.has(m)?m:"other"}function o(t,m,f=0,l){if(t)for(const $ of Object.getOwnPropertyNames(t)){const I=t[$],D=l?l+$:$;Array.isArray(I)?m[D]=(0,w.$eo)(I):I instanceof Date?m[D]=I.toISOString():(0,C.$eg)(I)?f<2?o(I,m,f+1,D+"."):m[D]=(0,w.$eo)(I):m[D]=I}}function a(t,m){const f=t.msftInternalDomains||[],l=m.getValue("telemetry.internalTesting");return(0,O.$pp)(f)||l}function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,m){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let f=t;const l=[];for(const y of m)for(;;){const S=y.exec(t);if(!S)break;l.push([S.index,y.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const y=I.exec(t);if(!y)break;const S=l.some(([k,g])=>y.index<g&&k<I.lastIndex);!$.test(y[0])&&!S&&(f+=t.substring(D,y.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<t.length&&(f+=t.substr(D)),f}function s(t){if(!t)return t;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(t))return`<REDACTED: ${f.label}>`;return t}function n(t,m){return(0,w.$bo)(t,f=>{if(f instanceof M||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let l=f.replaceAll("%20"," ");l=i(l,m);for(const $ of m)l=l.replace($,"");return l=s(l),l}})}}),define(Ce[218],Ie([1,0,13,110,19,21,2,14,79,64]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Gp=void 0,e.$Fp=R,e.$Hp=d,e.$Ip=r,e.$Jp=o,e.$Kp=a,e.$Lp=h,e.$Mp=i,e.$Np=s,e.$Pp=n,e.$Qp=m;function R(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,w.$yf)(f.id,l.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const $=l.manifest?l.manifest.version:l.version,I=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,$,I)}static parse(l){const $=v.exec(l);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(l,$,I=P.TargetPlatform.UNDEFINED){this.identifier=l,this.version=$,this.targetPlatform=I,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Gp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const l=E.exec(f);return l&&l[1]?[o(l[1]),l[2]]:[o(f),void 0]}function r(f,l){return`${f}.${l}`}function o(f){return f.toLowerCase()}function a(f,l){return o(r(f??P.$jn,l))}function h(f,l){const $=[],I=D=>{for(const y of $)if(y.some(S=>R(l(S),l(D))))return y;return null};for(const D of f){const y=I(D);y?y.push(D):$.push([D])}return $}function i(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$qp(f.identifier.id),name:new c.$qp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Op=new P.$nn("pprice.better-merge");function n(f,l){const $=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&$.every(y=>!R(y.identifier,{id:D}))){const y=f.filter(S=>R(S.identifier,{id:D}));y.length===1&&($.push(y[0]),I.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(f,l){if(!O.$k)return!1;let $;try{$=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,M.$$)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function m(f,l){const $=await t(f,l),I=(0,C.$ap)($?"alpine":O.$u,p.$fc);return l.debug("ComputeTargetPlatform:",I),I}}),define(Ce[219],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=w,e.$xs=C,e.$ys=P,e.$zs=O,e.$As=A,e.$Bs=M;function w(p){return[...p.entries()]}function C(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(c=>[c[0],w(c[1].map),C(c[1].descriptionMap)])}function M(p){return new Map(p.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}}),define(Ce[220],Ie([1,0,3,32,31]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$gs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$fs=void 0,e.$fs=new C.$Tj("terminalTabFocusMode",!1,!0);var O;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var M;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(M||(e.PosixShellType=M={}));var p;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var R;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var v;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$gs=(0,w.$Ci)("ptyService");var u;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(n){n.TerminalView="view",n.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$hs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const m=this.b(t.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$mo.add(e.$hs.Backend,new s),e.$is=(0,w.$Ci)("localPtyService"),e.$js=(0,w.$Ci)("terminalLogService")}),define(Ce[221],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gwb=void 0;class w{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const M=O(p=>{const c=typeof p=="string"?p:p.data;let R=this.a.get(P);if(R){R.data.push(c);return}const v=setTimeout(()=>this.flushBuffer(P),A);R={data:[c],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(P),M.dispose()}},this.a.set(P,R)});return M}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Gwb=w}),define(Ce[222],Ie([1,0,11,98,323,35,4,15,2,177,78,31]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yx=e.$xx=e.$wx=e.$vx=e.$ux=e.$tx=e.IconFontDefinition=e.IconContribution=e.$qx=void 0,e.$rx=o,e.$sx=a,v=qe(v),e.$qx={IconContribution:"base.contributions.icons"};var u;(function(n){function t(m,f){let l=m.defaults;for(;O.ThemeIcon.isThemeIcon(l);){const $=r.getIcon(l.id);if(!$)return;l=$.defaults}return l}n.getDefinition=t})(u||(e.IconContribution=u={}));var E;(function(n){function t(f){return{weight:f.weight,style:f.style,src:f.src.map(l=>({format:l.format,location:l.location.toString()}))}}n.toJSONObject=t;function m(f){const l=$=>(0,M.$cg)($)?$:void 0;if(f&&Array.isArray(f.src)&&f.src.every($=>(0,M.$cg)($.format)&&(0,M.$cg)($.location)))return{weight:l(f.weight),style:l(f.style),src:f.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}n.fromJSONObject=m})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$je,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,m,f,l){const $=this.b[t];if($){if(f&&!$.description){$.description=f,this.d.properties[t].markdownDescription=`${f} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return $}const I={id:t,description:f,defaults:m,deprecationMessage:l};this.b[t]=I;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),f&&(D.markdownDescription=`${f}: $(${t})`),this.d.properties[t]=D,this.e.enum.push(t),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const m=this.e.enum.indexOf(t);m!==-1&&(this.e.enum.splice(m,1),this.e.enumDescriptions.splice(m,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,m){const f=this.f[t];return f||(this.f[t]=m,this.a.fire(),m)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,I)=>$.id.localeCompare(I.id),m=$=>{for(;O.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map($=>this.b[$]);for(const $ of l.filter(I=>!!I.description).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|${O.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const $ of l.filter(I=>!O.ThemeIcon.isThemeIcon(I.defaults)).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|`);return f.join(`
`)}}const r=new d;v.$mo.add(e.$qx.IconContribution,r);function o(n,t,m,f){return r.registerIcon(n,t,m,f)}function a(){return r}function h(){const n=(0,P.$Xj)();for(const t in n){const m="\\"+n[t].toString(16);r.registerIcon(t,{fontCharacter:m})}}h(),e.$tx="vscode://schemas/icons";const i=v.$mo.as(R.$no.JSONContribution);i.registerSchema(e.$tx,r.getIconSchema());const s=new w.$Oh(()=>i.notifySchemaChanged(e.$tx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$ux=o("widget-close",C.$2j.close,(0,c.localize)(2,null)),e.$vx=o("goto-previous-location",C.$2j.arrowUp,(0,c.localize)(3,null)),e.$wx=o("goto-next-location",C.$2j.arrowDown,(0,c.localize)(4,null)),e.$xx=O.ThemeIcon.modify(C.$2j.sync,"spin"),e.$yx=O.ThemeIcon.modify(C.$2j.loading,"spin")}),define(Ce[223],Ie([1,0,4,5,21,2,42,3,12]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Ew=e.$Bw=e.$zw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$vw=e.$uw=void 0,e.$ww=v,e.$xw=E,e.$yw=d,e.$Aw=r,e.$Cw=o,e.$Dw=a,e.$uw=(0,M.$Ci)("tunnelService"),e.$vw=(0,M.$Ci)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var R;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(R||(e.TunnelPrivacyId=R={}));function v(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(n)return{address:n[1],port:+n[2]}}function d(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const n=s.query.split("&");for(const t of n){const m=t.split("=")[1];if(/^https?:/.exec(m)){const f=E(O.URI.parse(m));if(f)return f}}}e.$zw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(s){return e.$zw.indexOf(s)>=0}e.$Bw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(s){return e.$Bw.indexOf(s)>=0}function a(s,n,t,m){if(t===P.OperatingSystem.Windows)return!1;if(t===P.OperatingSystem.Macintosh&&o(n)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(f?.length===4&&parseInt(f[1])>=18)return!1}return s<1024}class h{constructor(n,t,m){this.remoteAddress=n,this.localAddress=t,this.b=m,this.a=new w.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ew=h;let i=class extends C.$Vc{constructor(n,t){super(),this.r=n,this.s=t,this.a=new w.$je,this.onTunnelOpened=this.a.event,this.b=new w.$je,this.onTunnelClosed=this.b.event,this.c=new w.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const n=this.s.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.g=n,n?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.h=n.elevation,this.m=n.privacyOptions,this.j=n.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const n=[],t=Array.from(this.f.values());for(const m of t){const f=Array.from(m.values());for(const l of f){const $=await l.value;$&&typeof $!="string"&&n.push($)}}return n}async dispose(){super.dispose();for(const n of this.f.values()){for(const{value:t}of n.values())await t.then(m=>typeof m!="string"?m?.dispose():void 0);n.clear()}this.f.clear()}setEnvironmentTunnel(n,t,m,f,l){this.z(n,t,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:t,localAddress:m,privacy:f,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,t){(o(n)||r(n))&&(n=e.$zw[0]);const m=this.D(n,t);if(m)return++m.refcount,m.value}openTunnel(n,t,m,f,l,$=!1,I,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${m} on local port ${l}.`);const y=this.g??n;if(!y)return;if(t||(t="localhost"),f||(f=this.t),this.g&&this.n.has(m)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.F(y,t,m,f,l,$,I,D);return S?S.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,m),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,m);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==m)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),I&&k.privacy!==I&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}w(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const t=this.f.get(n.tunnelRemoteHost);if(t){const m=t.get(n.tunnelRemotePort);m&&(m.refcount--,await this.y(n.tunnelRemoteHost,n.tunnelRemotePort,m))}}}}async y(n,t,m){if(m.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${t}.`);const f=m.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(n)&&this.f.get(n).delete(t),f}}async closeTunnel(n,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${t} `);const m=this.f.get(n);if(m&&m.has(t)){const f=m.get(t);f.refcount=0,await this.y(n,t,f)}}z(n,t,m){this.f.has(n)||this.f.set(n,new Map),this.f.get(n).set(t,{refcount:1,value:m})}async C(n,t){const m=this.f.get(n);if(m){const f=m.get(t),l=f?await f.value:void 0;(!l||typeof l=="string")&&m.delete(t),m.size===0&&this.f.delete(n)}}D(n,t){const m=[n];r(n)?(m.push(...e.$zw),m.push(...e.$Bw)):o(n)&&m.push(...e.$Bw);const f=m.map(l=>this.f.get(l));for(const l of f){const $=l?.get(t);if($)return $}}canTunnel(n){return!!E(n)}G(n,t,m,f,l,$,I){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${m} on local port ${f}.`);const D=m;this.n.add(D);const y=f===void 0?m:f,S={elevationRequired:l?this.isPortPrivileged(y):!1},k={remoteAddress:{host:t,port:m},localAddressPort:f,privacy:$,public:$?$!==R.Private:void 0,protocol:I},g=n.forwardPort(k,S);return g?(this.z(t,m,g),g.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),g}};e.$Fw=i,e.$Fw=i=He([Ve(0,p.$9j),Ve(1,A.$9i)],i)}),define(Ce[224],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=void 0,e.$Gl=(0,w.$Ci)("IUriIdentityService")}),define(Ce[225],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Gw=void 0,e.$Gw=(0,w.$Ci)("editSessionIdentityService");var C;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ce[226],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=C,e.$wM=P,e.$xM=O,e.$yM=A,e.$zM=M;function C(p){return p.scheme!==w.Schemas.file&&p.scheme!==w.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(c=>C(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&C(p.configuration))return p.configuration}function O(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function M(p){return P(p)!==void 0}}),define(Ce[50],Ie([1,0,179,20,59,24,2,3,16]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=R,e.$Qi=v,e.$Ri=u,e.$Si=E,e.$Ti=r,e.$Ui=o,e.$Xi=i,e.$3i=s,e.$4i=n,e.$6i=t,e.$7i=m,e.$8i=f,e.$Li=(0,M.$Ci)("contextService");function c(l){const $=l;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function v(l,$){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,C.$oc)(l)}:$?e.$Oi:e.$Pi;const I=l;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function u(l){const $=l;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(l){const $=l;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const I=l;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(l?.id)return{id:l.id}}var d;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function o(l){const $=l;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class a{constructor($,I,D,y,S){this.h=$,this.j=D,this.k=y,this.l=S,this.c=P.$Ii.forUris(this.l,()=>!0),this.folders=I}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=P.$Ii.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=a;class h{constructor($,I){this.raw=I,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$dh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=h;function i(l){return new h({uri:l,index:0,name:(0,O.$_g)(l)},{uri:l.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,w.localize)(0,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function s(l,$){return O.$7g.isEqualOrParent(l,$.untitledWorkspacesHome)}function n(l){let $;return A.URI.isUri(l)?$=l:$=l.configuration,$?.scheme===p.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$5i}function m(l,$){return!s(l,$)&&!n(l)}function f(l){return(typeof l=="string"?(0,C.$pc)(l):(0,O.$bh)(l))===e.$Zi}}),define(Ce[113],Ie([1,0,76,4,5,24,2,178,106,30,3,12,50,29,224,11,37,13,15]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Il=e.ProfileResourceType=void 0,e.$Hl=s,e.$Jl=n,e.$Kl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Il=(0,R.$Ci)("IUserDataProfilesService");function n(l,$){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:$}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:$}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,$,I,D,y,S){return{id:l,name:$,location:I,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:S&&y?.useDefaultFlags?.globalState?S.globalStorageHome:(0,O.$dh)(I,"globalStorage"),settingsResource:S&&y?.useDefaultFlags?.settings?S.settingsResource:(0,O.$dh)(I,"settings.json"),keybindingsResource:S&&y?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,O.$dh)(I,"keybindings.json"),tasksResource:S&&y?.useDefaultFlags?.tasks?S.tasksResource:(0,O.$dh)(I,"tasks.json"),snippetsHome:S&&y?.useDefaultFlags?.snippets?S.snippetsHome:(0,O.$dh)(I,"snippets"),extensionsResource:S&&y?.useDefaultFlags?.extensions?S.extensionsResource:(0,O.$dh)(I,"extensions.json"),cacheHome:(0,O.$dh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let m=class extends P.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,I,D,y){super(),this.t=$,this.u=I,this.w=D,this.y=y,this.f=!0,this.h=this.B(new C.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Bc,workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,O.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),I=[$];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,h.$cg)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}I.push(t((0,O.$ah)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},$))}}catch(S){this.y.error(S)}const D=new E.$Bc,y=new Map;if(I.length)try{const S=this.Q();if(S.workspaces)for(const[k,g]of Object.entries(S.workspaces)){const b=A.URI.parse(k),L=I.find(T=>T.id===g);L&&D.set(b,L)}if(S.emptyWindows)for(const[k,g]of Object.entries(S.emptyWindows)){const b=I.find(L=>L.id===g);b&&y.set(k,b)}}catch(S){this.y.error(S)}this.z={profiles:I,workspaces:D,emptyWindows:y}}return this.z}D(){const $=t("__default__profile__",(0,M.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const I="Temp",D=new RegExp(`${(0,a.$ff)(I)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const g=D.exec(k.name),b=g?parseInt(g[1]):0;y=b>y?b:y}const S=`${I} ${y+1}`;return this.createProfile((0,w.$qj)((0,o.$Yg)()).toString(16),S,{transient:!0},$)}async createNamedProfile($,I,D){return this.createProfile((0,w.$qj)((0,o.$Yg)()).toString(16),$,I,D)}async createProfile($,I,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F($,I,D);return y&&await this.setProfileForWorkspace(y,S),S}async F($,I,D){if(!(0,h.$cg)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(I);return y||(y=(async()=>{try{if(this.profiles.find(b=>b.name===I||b.id===$))throw new Error(`Profile with ${I} name already exists`);const k=t($,I,(0,O.$dh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const g=[];return this.j.fire({profile:k,join(b){g.push(b)}}),await r.Promises.settled(g),this.I([k],[],[]),k}finally{this.r.delete(I)}})(),this.r.set(I,y)),y}async updateProfile($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=t(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(y=>y.id===$.id);if(!I)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:I,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(y){(0,c.$nl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L($,D)}unsetWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,I)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled($.map(I=>this.removeProfile(I)))}getProfileForWorkspace($){const I=this.G($),D=A.URI.isUri(I)?this.C.workspaces.get(I):this.C.emptyWindows.get(I);return D||((0,u.$Mi)($)?this.s.folders.get($.uri):(0,u.$Ri)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Mi)($)?$.uri:(0,u.$Ri)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.folders.values()].some(I=>this.w.extUri.isEqual(I.location,$.location)))}I($,I,D){const y=[...this.profiles,...$],S=[],k=this.s.profiles;this.s.profiles=[];for(let g of y){if(g.isDefault||I.some(L=>g.id===L.id))continue;g=D.find(L=>g.id===L.id)??g;const b=k.find(L=>g.id===L.id);if(g.isTransient)this.s.profiles.push(g);else{if(b){for(const[L,T]of this.s.emptyWindows.entries())if(g.id===T.id){this.L({id:L},g);break}for(const[L,T]of this.s.workspaces.entries())if(g.id===T.id){this.L({id:"",configPath:L},g);break}for(const[L,T]of this.s.folders.entries())if(g.id===T.id){this.L({id:"",uri:L},g);break}}S.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags})}}this.P(S),this.z=void 0,this.J($,I,D)}J($,I,D){this.h.fire({added:$,removed:I,updated:D,all:this.profiles})}L($,I,D){if(D=I?.isTransient?!0:D,D)(0,u.$Mi)($)?(this.s.folders.delete($.uri),I&&this.s.folders.set($.uri,I)):(0,u.$Ri)($)?(this.s.workspaces.delete($.configPath),I&&this.s.workspaces.set($.configPath,I)):(this.s.emptyWindows.delete($.id),I&&this.s.emptyWindows.set($.id,I));else{this.L($,void 0,!0);const y=this.G($);A.URI.isUri(y)?(this.C.workspaces.delete(y),I&&this.C.workspaces.set(y,I)):(this.C.emptyWindows.delete(y),I&&this.C.emptyWindows.set(y,I)),this.M()}}M(){const $={};for(const[D,y]of this.C.workspaces.entries())$[D.toString()]=y.id;const I={};for(const[D,y]of this.C.emptyWindows.entries())I[D.toString()]=y.id;this.R({workspaces:$,emptyWindows:I}),this.z=void 0}N($){const I={},D=this.D();if($.workspaces)for(const[S,k]of Object.entries($.workspaces)){const g=A.URI.parse(k);I[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const y={};if($.emptyWindows)for(const[S,k]of Object.entries($.emptyWindows)){const g=A.URI.parse(k);y[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:I,emptyWindows:y}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ll=m,e.$Ll=m=He([Ve(0,p.$Ji),Ve(1,c.$9k),Ve(2,d.$Gl),Ve(3,v.$9j)],m);class f extends m{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Ml=f}),define(Ce[227],Ie([1,0,11,4,5,65,15,161,3,113]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$bq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_p=e.$$p=e.$0p=void 0,e.$aq=E,e.$cq=r,e.$eq=a,e.$0p="__$__isNewStorageMarker",e.$$p="__$__targetStorageMarker",e.$_p=(0,p.$Ci)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const i=h.get(e.$$p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Vc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new C.$me),this.c=this.B(new C.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$je),this.onWillSaveState=this.f.event,this.h=this.B(new w.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,n){return C.Event.filter(this.b.event,t=>t.scope===i&&(s===void 0||t.key===s),n)}n(){this.j.value=(0,w.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:n,external:t}=s;if(n===e.$$p){switch(i){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:n,target:this.J(i)[n],external:t})}w(i){this.f.fire({reason:i})}get(i,s,n){return this.P(s)?.get(i,n)}getBoolean(i,s,n){return this.P(s)?.getBoolean(i,n)}getNumber(i,s,n){return this.P(s)?.getNumber(i,n)}getObject(i,s,n){return this.P(s)?.getObject(i,n)}storeAll(i,s){this.y(()=>{for(const n of i)this.store(n.key,n.value,n.scope,n.target,s)})}store(i,s,n,t,m=!1){if((0,A.$lg)(s)){this.remove(i,n,m);return}this.y(()=>{this.z(i,n,t),this.P(n)?.set(i,s,m)})}remove(i,s,n=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,n)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const n=[],t=this.J(i);for(const m of Object.keys(t))t[m]===s&&n.push(m);return n}z(i,s,n,t=!1){const m=this.J(s);typeof n=="number"?m[i]!==n&&(m[i]=n,this.P(s)?.set(e.$$p,JSON.stringify(m),t)):typeof m[i]=="number"&&(delete m[i],this.P(s)?.set(e.$$p,JSON.stringify(m),t))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(i){switch(i){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?E(s):Object.create(null)}isNew(i){return this.getBoolean(e.$0p,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const s=this.P(v.APPLICATION),n=this.P(v.PROFILE),t=this.P(v.WORKSPACE);switch(i){case R.NONE:await w.Promises.settled([s?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await w.Promises.settled([s?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(v.APPLICATION)?.items??new Map,s=this.P(v.PROFILE)?.items??new Map,n=this.P(v.WORKSPACE)?.items??new Map;return a(i,s,n,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(R.NONE),(0,c.$Hl)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||r(s)&&r(i))}N(i,s,n){this.y(()=>{const t=new Set;for(const[m,f]of i)t.add(m),s.get(m)!==f&&this.u(n,{key:m,external:!0});for(const[m]of s.items)t.has(m)||this.u(n,{key:m,external:!0})})}}e.$bq=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new M.$8p(new M.$9p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(v.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(v.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(v.APPLICATION,i)))}P(i){switch(i){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$dq=o;async function a(h,i,s,n,t,m){const f=b=>{try{return JSON.parse(b)}catch{return b}},l=new Map,$=new Map;h.forEach((b,L)=>{l.set(L,b),$.set(L,f(b))});const I=new Map,D=new Map;i.forEach((b,L)=>{I.set(L,b),D.set(L,f(b))});const y=new Map,S=new Map;s.forEach((b,L)=>{y.set(L,b),S.set(L,f(b))}),console.group(n!==t?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const k=[];if(l.forEach((b,L)=>{k.push({key:L,value:b})}),console.table(k),console.groupEnd(),console.log($),n!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const b=[];I.forEach((L,T)=>{b.push({key:T,value:L})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${m})`);const g=[];y.forEach((b,L)=>{g.push({key:L,value:b})}),console.table(g),console.groupEnd(),console.log(S)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class w{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$9mc=w}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0;class A{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new C.$5g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$bnc=A,e.$cnc=(0,O.$Ci)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0,e.$IP=(0,w.$Ci)("IExtHostInitDataService")}),define(Ce[228],Ie([1,0,184,12,213,27]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=void 0;let A=class extends P.$SQ{constructor(p,c,R){const v=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=R.remote.isRemote?(0,w.localize)(0,null):p?(0,w.localize)(1,null):(0,w.localize)(2,null);super(c.createLogger(v,{name:u}))}};e.$jpc=A,e.$jpc=A=He([Ve(1,C.$0j),Ve(2,O.$IP)],A)}),define(Ce[229],Ie([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0;class C{constructor(A,M,p){this.h=new Map,this.a=A,this.b=M,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new w.$Oh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of c.values())R.complete()}catch(R){for(const v of c.values())v.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,M){let p=this.f[A];return typeof p>"u"&&(p=M),p}update(A,M){this.f[A]=M;const p=this.h.get(A);if(p!==void 0)return p.p;const c=new w.$Zh;return this.h.set(A,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$Tnc=C;class P extends C{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,M){super(A.identifier.value,!0,M),this.j=A}}e.$Unc=P}),define(Ce[230],Ie([1,0,4,2]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class P{constructor(A){this.c=A,this.a=new w.$je,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$je,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,M,p,c){const v=this.c.getNotebookDocument(C.URI.revive(A)).acceptModelChanged(M.value,p,c);this.b.fire(v)}$acceptDirtyStateChanged(A,M){this.c.getNotebookDocument(C.URI.revive(A)).acceptDirty(M)}$acceptModelSaved(A){const M=this.c.getNotebookDocument(C.URI.revive(A));this.a.fire(M.apiNotebook)}}e.$Noc=P}),define(Ce[17],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.$sP=void 0,e.$sP=(0,w.$Ci)("IExtHostRpcService");class C{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$tP=C}),define(Ce[231],Ie([1,0,19,4]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class P{#e;constructor(A,M){this.b=new C.$je,this.onDidChange=this.b.event,this.a=w.$nn.toKey(A.identifier),this.#e=M,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(A){return this.#e.get(this.a,A)}store(A,M){return this.#e.store(this.a,A,M)}delete(A){return this.#e.delete(this.a,A)}}e.$4nc=P}),define(Ce[66],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$rnc=(0,w.$Ci)("IURITransformerService");class C{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$snc=C});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[114],Ie([1,0,193,15,2,5,3,31,30,16,48,155,36]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$$F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$1F=e.EditorInputCapabilities=e.$ZF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=void 0,e.$QF=r,e.$RF=o,e.$SF=a,e.$TF=h,e.$UF=i,e.$VF=s,e.$WF=n,e.$XF=t,e.$YF=m,e.$2F=y,e.$3F=k,e.$4F=g,e.$5F=b,e.$6F=L,e.$7F=T,e.$8F=q,e.$9F=G,e.$0F=ie,e.$_F=de,e.$aG=re,e.$bG=Pe,e.$cG=Le,u=ri(u),e.$LF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$MF={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$NF="workbench.editor.sidebysideEditor",e.$OF="workbench.editors.textDiffEditor",e.$PF="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Y){const B=Y;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function o(Y){const B=Y;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(Y,B,_){for(const we of _.visibleEditorPanes)if(we.group.id===B&&Y.matches(we.input))return we.getViewState()}function h(Y){if(y(Y))return!1;const B=Y;return P.URI.isUri(B?.resource)}function i(Y){if(y(Y))return!1;const B=Y;return B?.original!==void 0&&B.modified!==void 0}function s(Y){if(y(Y))return!1;const B=Y;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function n(Y){if(y(Y)||i(Y))return!1;const B=Y;return B?.primary!==void 0&&B.secondary!==void 0}function t(Y){if(y(Y))return!1;const B=Y;return B?B.resource===void 0||B.resource.scheme===c.Schemas.untitled||B.forceUntitled===!0:!1}function m(Y){if(y(Y))return!1;const B=Y;return P.URI.isUri(B?.base?.resource)&&P.URI.isUri(B?.input1?.resource)&&P.URI.isUri(B?.input2?.resource)&&P.URI.isUri(B?.result?.resource)}var f;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class ${constructor(){this.a=new Map}registerSource(B,_){let we=this.a.get(B);return we||(we={source:B,label:_},this.a.set(B,we)),we.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$ZF=new $;var I;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends O.$Vc{}e.$1F=D;function y(Y){return Y instanceof D}function S(Y){const B=Y;return P.URI.isUri(B?.preferredResource)}function k(Y){const B=Y;return y(B?.primary)&&y(B?.secondary)}function g(Y){const B=Y;return y(B?.modified)&&y(B?.original)}function b(Y,B,_,we,ae){return Le(we,[(0,v.$mj)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ve={..._,limits:{size:Number.MAX_VALUE}};Y.openEditor(B,ve)}}),(0,v.$mj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function L(Y){return y(Y?.editor)}function T(Y){const B=Y;return L(Y)&&B?.group!==void 0}function q(Y){const B=Y;return typeof B?.groupId=="number"&&y(B.editor)}function G(Y){return typeof Y?.groupId=="number"}var W;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var N;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class ce{getOriginalUri(B,_){if(!B)return;if(m(B))return e.$$F.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:ve}=this.a(B);if(ae&&ve){if(_?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ve,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getOriginalUri(ae,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ve,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===V.PRIMARY?ae:ve}}if(i(B)||s(B)||n(B)||m(B))return;const we=S(B)?B.preferredResource:B.resource;return!we||!_||!_.filterByScheme?we:this.b(we,_.filterByScheme)}a(B){return k(B)||n(B)?{primary:B.primary,secondary:B.secondary}:g(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(m(B))return e.$$F.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:ve}=this.a(B);if(ae&&ve){if(_?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ve,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ve,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===V.PRIMARY?ae:ve}}if(i(B)||s(B)||n(B)||m(B))return;const we=B.resource;return!we||!_||!_.filterByScheme?we:this.b(we,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(we=>B.scheme===we))return B}else if(_===B.scheme)return B}}var ge;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function ie(Y,B,_,we){if(!Y.isSticky(B))return!1;switch(we.preventPinnedEditorClose){case"keyboardAndMouse":return _===ge.MOUSE||_===ge.KEYBOARD;case"mouse":return _===ge.MOUSE;case"keyboard":return _===ge.KEYBOARD}return!1}e.$$F=new ce;var me;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class se{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(A.$Bi);for(const[we,ae]of this.c)this.e(we,ae,_);this.c.clear()}e(B,_,we){const ae=we.createInstance(_);this.d.set(B,ae)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,C.$ng)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,O.$Tc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}M.$mo.add(e.$LF.EditorFactory,new se);async function de(Y,B,_){return!Y||!Y.length?[]:await Promise.all(Y.map(async we=>{const ae=P.URI.revive(we.fileUri);if(!ae){_.info("Cannot resolve the path because it is not valid.",we);return}if(!await B.canHandleResource(ae)){_.info("Cannot resolve the path because it cannot be handled",we);return}let le=we.exists,X=we.type;if(typeof le!="boolean"||typeof X!="number")try{X=(await B.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,le=!0}catch(pe){_.error(pe),le=!1}if(!le&&we.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",we);return}if(X===p.FileType.Directory){_.info("Cannot resolve the path because it is a directory",we);return}const Z={...we.options,pinned:!0};return le?{resource:ae,options:Z}:{resource:ae,options:Z,forceUntitled:!0}}))}var be;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function re(Y){const B=Y;if(!B)return!1;const _=B;if(_.modified)return re(_.modified);const we=B;return!!(we.contributionsState&&we.viewState&&Array.isArray(we.cursorState))}function Pe(Y){return(0,R.$oj)(Y)}function Le(Y,B,_){const we=(0,R.$pj)(Y,B);return we.forceMessage=_?.forceMessage,we.forceSeverity=_?.forceSeverity,we.allowDialog=_?.allowDialog,we}}),define(Ce[232],Ie([1,0,4,194,3,5,29,31,26,98,222]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kG=e.$jG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$iG=e.ViewContentGroups=e.$gG=e.ViewContainerLocation=e.Extensions=e.$fG=e.$eG=e.$dG=void 0,e.$hG=E,e.$dG="views",e.$eG=(0,C.localize)(0,null),e.$fG=(0,R.$rx)("default-view-icon",c.$2j.window,(0,C.localize)(1,null));var v;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$gG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new w.$je),this.onDidRegister=this.c.event,this.f=this.B(new w.$je),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(m,f,l){const $=this.get(m.id);if($)return $;const I=m;return I.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$yc)(this.g,f,[]).push(I),l?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(m){for(const f of this.g.keys()){const l=this.g.get(f),$=l?.indexOf(m);if($!==-1){l?.splice($,1),l.length===0&&this.g.delete(f),this.f.fire({viewContainer:m,viewContainerLocation:f});return}}}get(m){return this.all.filter(f=>f.id===m)[0]}getViewContainers(m){return[...this.g.get(m)||[]]}getViewContainerLocation(m){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(l=>l?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.h.find(f=>this.getViewContainerLocation(f)===m)}}M.$mo.add(v.ViewContainersRegistry,new d);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(t,m){const f=t.group??r.More,l=m.group??r.More;return f!==l?f.localeCompare(l):(t.order??5)-(m.order??5)}class a extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new w.$je),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$je),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$je),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$je),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Ic}registerViews(m,f){this.registerViews2([{views:m,viewContainer:f}])}registerViews2(m){m.forEach(({views:f,viewContainer:l})=>this.r(f,l)),this.c.fire(m)}deregisterViews(m,f){const l=this.s(m,f);l.length&&this.f.fire({views:l,viewContainer:f})}moveViews(m,f){for(const l of this.m.keys())if(l!==f){const $=this.s(m,l);$.length&&(this.r($,f),this.g.fire({views:$,from:l,to:f}))}}getViews(m){return this.m.get(m)||[]}getView(m){for(const f of this.j){const l=(this.m.get(f)||[]).filter($=>$.id===m)[0];if(l)return l}return null}getViewContainer(m){for(const f of this.j)if((this.m.get(f)||[]).filter($=>$.id===m)[0])return f;return null}registerViewWelcomeContent(m,f){return this.n.add(m,f),this.h.fire(m),(0,O.$Tc)(()=>{this.n.delete(m,f),this.h.fire(m)})}registerViewWelcomeContent2(m,f){const l=new Map;for(const[$,I]of f)this.n.add(m,I),l.set($,(0,O.$Tc)(()=>{this.n.delete(m,I),this.h.fire(m)}));return this.h.fire(m),l}getViewWelcomeContent(m){const f=[];return this.n.forEach(m,l=>f.push(l)),f.sort(o)}r(m,f){let l=this.m.get(f);l||(l=[],this.m.set(f,l),this.j.push(f));for(const $ of m){if(this.getView($.id)!==null)throw new Error((0,C.localize)(2,null,$.id));l.push($)}}s(m,f){const l=this.m.get(f);if(!l)return[];const $=[],I=[];for(const D of l)m.includes(D)?$.push(D):I.push(D);return $.length&&(I.length?this.m.set(f,I):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),$}}M.$mo.add(v.ViewsRegistry,new a),e.$iG=(0,P.$Ci)("viewDescriptorService");var h;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class s{constructor(m,f){this.c=!1,this.d=!1,(0,p.$co)(this,m),this.d=!!f,this.resolve=async l=>{if(f&&!this.c){const $=await f(l);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$jG=s;class n extends Error{constructor(m){super((0,C.localize)(3,null,m)),this.name="NoTreeViewError"}static is(m){return m.name==="NoTreeViewError"}}e.$kG=n}),define(Ce[233],Ie([1,0,195,32]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=void 0,e.$oG=new C.$Tj("chatSessionResponseVote","",{type:"string",description:(0,w.localize)(0,null)}),e.$pG=new C.$Tj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,w.localize)(1,null)}),e.$qG=new C.$Tj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,w.localize)(2,null)}),e.$rG=new C.$Tj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,w.localize)(3,null)}),e.$sG=new C.$Tj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,w.localize)(4,null)}),e.$tG=new C.$Tj("chatResponse",!1,{type:"boolean",description:(0,w.localize)(5,null)}),e.$uG=new C.$Tj("chatRequest",!1,{type:"boolean",description:(0,w.localize)(6,null)}),e.$vG=new C.$Tj("chatEditApplied",!1,{type:"boolean",description:(0,w.localize)(7,null)}),e.$wG=new C.$Tj("chatInputHasText",!1,{type:"boolean",description:(0,w.localize)(8,null)}),e.$xG=new C.$Tj("chatInputHasFocus",!1,{type:"boolean",description:(0,w.localize)(9,null)}),e.$yG=new C.$Tj("inChatInput",!1,{type:"boolean",description:(0,w.localize)(10,null)}),e.$zG=new C.$Tj("inChat",!1,{type:"boolean",description:(0,w.localize)(11,null)}),e.$AG=new C.$Tj("chatIsEnabled",!1,{type:"boolean",description:(0,w.localize)(12,null)}),e.$BG=new C.$Tj("chatCursorAtTop",!1),e.$CG=new C.$Tj("chatInputHasAgent",!1),e.$DG=new C.$Tj("chatLocation",void 0),e.$EG=new C.$Tj("quickChatHasFocus",!1,{type:"boolean",description:(0,w.localize)(13,null)})}),define(Ce[234],Ie([1,0,324,11,22,4,40,5,49,141,13,32,19,3,12,108,216,227,233]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.ChatAgentLocation=void 0,e.$JH=f,e.$KH=l;var s;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function($){function I(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.$EH=(0,E.$Ci)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new O.$je,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$AG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const S=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(b=>!b.when||S.f.contextMatchesRules(v.$Aj.deserialize(b.when)))}};const g={data:D};return this.b.set(I,g),(0,M.$Tc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const y=this.b.get(I);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new t(y.data,D)),(0,M.$Tc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const y={data:I,impl:D};return this.b.set(I.id,y),this.d.fire(new t(I,D)),(0,M.$Tc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,y){return await this.g.get(I)?.(D,y)??[]}updateAgent(I,D){const y=this.b.get(I);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new t(y.data,y.impl))}getDefaultAgent(I){return(0,w.$gb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(v.$Aj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),y=>f(y.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new t(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}agentHasDupeName(I){const D=this.getAgent(I);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return await g.impl.invoke(D,y,S,k)}async getFollowups(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return g.impl?.provideFollowups?g.impl.provideFollowups(D,y,S,k):[]}};e.$FH=n,e.$FH=n=He([Ve(0,v.$Uj)],n);class t{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,y,S){return this.d.invoke(I,D,y,S)}async provideFollowups(I,D,y,S){return this.d.provideFollowups?this.d.provideFollowups(I,D,y,S):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$GH=t,e.$HH=(0,E.$Ci)("chatAgentNameService");let m=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,y,S){if(this.g=D,this.h=y,this.i=S,this.e=(0,c.$4d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const k=S.get(i.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{S.remove(i.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,C.$Dh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$5p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(i.b,JSON.stringify(y),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),y=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&y}l(I,D){return this.e.map(S=>S[I.toLowerCase()]).map(S=>S?S.some(k=>(0,R.$Df)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$IH=m,e.$IH=m=i=He([Ve(0,r.$pk),Ve(1,o.$Yp),Ve(2,d.$9j),Ve(3,a.$_p)],m);function f($){return`${$.extensionId.value}.${$.id}`}function l($){const I="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new u.$nn("")),(0,p.$_h)(I)}}),define(Ce[235],Ie([1,0,2,33,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$aH=O,e.$bH=A;function O(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof w.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(C.$Ft.isIRange)}function A(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(O)}var M;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(M||(e.ChatAgentVoteDirection=M={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$cH=(0,P.$Ci)("IChatService"),e.$dH="accessibility.voice.keywordActivation"}),define(Ce[236],Ie([1,0,4,11,197]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new w.$je,this.o=new w.$je,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(M){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=M}onEvent(M){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=M}onRequest(M){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=M}sendResponse(M){M.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${M.command}`)):this.u("response",M)}sendRequest(M,p,c,R){const v={command:M};if(p&&Object.keys(p).length>0&&(v.arguments=p),this.u("request",v),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(v.seq);if(E){this.f.delete(v.seq);const d={type:"response",seq:0,request_seq:v.seq,success:!1,command:M,message:(0,P.localize)(0,null,R,M)};E(d)}},R)}return c&&this.f.set(v.seq,c),v.seq}acceptMessage(M){this.k?this.k(M):(this.m.push(M),this.m.length===1&&this.s())}q(M,p){return M.type!=="event"||p.type!=="event"}async s(){let M;for(;this.m.length;){if((!M||this.q(this.m[0],M))&&await(0,C.$Dh)(0),M=this.m.shift(),!M)return;switch(M.type){case"event":this.j?.(M);break;case"request":this.g?.(M);break;case"response":{const p=M,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(M,p){p.type=M,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const M=new Map;this.f.forEach((p,c)=>M.set(c,p)),await(0,C.$Dh)(500),M.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Ssb=O}),define(Ce[81],Ie([1,0,2,198,32,3]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$uK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$sK=e.MemoryRangeType=e.State=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=void 0,e.$rK=p,e.$tK=R,C=qe(C),e.$fJ="workbench.view.debug",e.$gJ="workbench.debug.variablesView",e.$hJ="workbench.debug.watchExpressionsView",e.$iJ="workbench.debug.callStackView",e.$jJ="workbench.debug.loadedScriptsView",e.$kJ="workbench.debug.breakPointsView",e.$lJ="workbench.debug.disassemblyView",e.$mJ="workbench.panel.repl",e.$nJ="workbench.panel.repl.view",e.$oJ=new P.$Tj("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$pJ=new P.$Tj("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$qJ=new P.$Tj("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$rJ="debugUx",e.$sJ=new P.$Tj(e.$rJ,"default",{type:"string",description:C.localize(3,null)}),e.$tJ=new P.$Tj("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$uJ=new P.$Tj("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$vJ=new P.$Tj("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$wJ=new P.$Tj("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$xJ=new P.$Tj("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$yJ=new P.$Tj("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$zJ=new P.$Tj("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$AJ=new P.$Tj("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$BJ=new P.$Tj("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$CJ=new P.$Tj("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$DJ=new P.$Tj("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$EJ=new P.$Tj("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$FJ=new P.$Tj("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$GJ=new P.$Tj("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$HJ=new P.$Tj("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$IJ=new P.$Tj("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$JJ=new P.$Tj("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$KJ=new P.$Tj("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$LJ=new P.$Tj("breakpointItemBytes",void 0,{type:"boolean",description:C.localize(22,null)}),e.$MJ=new P.$Tj("breakpointHasModes",!1,{type:"boolean",description:C.localize(23,null)}),e.$NJ=new P.$Tj("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(24,null)}),e.$OJ=new P.$Tj("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(25,null)}),e.$PJ=new P.$Tj("loadedScriptsItemType",void 0,{type:"string",description:C.localize(26,null)}),e.$QJ=new P.$Tj("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(27,null)}),e.$RJ=new P.$Tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:C.localize(28,null)}),e.$SJ=new P.$Tj("stepBackSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$TJ=new P.$Tj("restartFrameSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$UJ=new P.$Tj("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(31,null)}),e.$VJ=new P.$Tj("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(32,null)}),e.$WJ=new P.$Tj("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(33,null)}),e.$XJ=new P.$Tj("breakpointsExist",!1,{type:"boolean",description:C.localize(34,null)}),e.$YJ=new P.$Tj("debuggersAvailable",!1,{type:"boolean",description:C.localize(35,null)}),e.$ZJ=new P.$Tj("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(36,null)}),e.$1J=new P.$Tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(37,null)}),e.$2J=new P.$Tj("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$3J=new P.$Tj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$4J=new P.$Tj("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$5J=new P.$Tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$6J=new P.$Tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(42,null)}),e.$7J=new P.$Tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(43,null)}),e.$8J=new P.$Tj("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(44,null)}),e.$9J=new P.$Tj("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(45,null)}),e.$0J=new P.$Tj("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(46,null)}),e.$$J=new P.$Tj("variableIsReadonly",!1,{type:"boolean",description:C.localize(47,null)}),e.$_J=new P.$Tj("variableValue",!1,{type:"string",description:C.localize(48,null)}),e.$aK=new P.$Tj("variableType",!1,{type:"string",description:C.localize(49,null)}),e.$bK=new P.$Tj("variableInterfaces",!1,{type:"array",description:C.localize(50,null)}),e.$cK=new P.$Tj("variableName",!1,{type:"string",description:C.localize(51,null)}),e.$dK=new P.$Tj("variableLanguage",!1,{type:"string",description:C.localize(52,null)}),e.$eK=new P.$Tj("variableExtensionId",!1,{type:"string",description:C.localize(53,null)}),e.$fK=new P.$Tj("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(54,null)}),e.$gK=new P.$Tj("multiSessionRepl",!1,{type:"boolean",description:C.localize(55,null)}),e.$hK=new P.$Tj("multiSessionDebug",!1,{type:"boolean",description:C.localize(56,null)}),e.$iK=new P.$Tj("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(57,null)}),e.$jK=new P.$Tj("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(58,null)}),e.$kK=new P.$Tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(59,null)}),e.$lK=new P.$Tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(60,null)});const A=i=>C.localize(61,null,i);e.$mK=A,e.$nK="editor.contrib.debug",e.$oK="editor.contrib.breakpoint",e.$pK="debug",e.$qK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(62,null)};var M;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(M||(e.State=M={}));function p(i){switch(i){case M.Initializing:return"initializing";case M.Stopped:return"stopped";case M.Running:return"running";default:return"inactive"}}var c;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$sK="vscode-debug-memory";function R(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var v;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$uK=(0,O.$Ci)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(i){i.deserialize=s=>s,i.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(i){i.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:w.URI.revive(s.iconPath.light),dark:w.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),i.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(Ce[237],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZH=void 0,e.$NH=v,e.$OH=u,e.$PH=E,e.$QH=d,e.$RH=r,e.$SH=o,e.$TH=a,e.$UH=i,e.$VH=t,e.$WH=m,e.$XH=l,e.$YH=I;const R=/{([^}]+)}/g;function v(y,S,k){return y.replace(R,function(g,b){return S&&b.length>0&&b[0]!=="_"?g:k&&k.hasOwnProperty(b)?k[b]:g})}function u(y){const S={};for(const k of Object.keys(y))k.startsWith("!")||(S[k]=y[k]);return S}function E(y){return y.configuration.request==="attach"&&!d(y)&&(!y.parentSession||E(y.parentSession))}function d(y){let S=y.configuration.type;if(S)return S==="vslsShare"&&(S=y.configuration.adapterProxy.configuration.type),(0,w.$Df)(S,"extensionhost")||(0,w.$Df)(S,"pwa-extensionhost")?y:y.parentSession?d(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function o(y,S,k){let g,b=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=L.exec(y);){const q=T.index+1,G=q+T[0].length;if(q<=S&&G>=k){g=T[0],b=q;break}}if(g){const q=/\w+/g;let G=null;for(;(G=q.exec(g))&&!(G.index+1+b+G[0].length>=k););G&&(g=g.substring(0,q.lastIndex))}return g?{start:b,end:b+g.length-1}:{start:0,end:0}}async function a(y,S,k,g){if(y.evaluatableExpressionProvider.has(S)){const b=y.evaluatableExpressionProvider.ordered(S),L=(0,c.$Ib)(await Promise.all(b.map(async T=>{try{return await T.provideEvaluatableExpression(S,k,g??p.CancellationToken.None)}catch{return}})));if(L.length>0){let T=L[0].expression;const q=L[0].range;return T||(T=S.getLineContent(k.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:T}}}else{const b=S.getLineContent(k.lineNumber),{start:L,end:T}=o(b,k.column,k.column),q=b.substring(L-1,T);return{matchingExpression:q,range:new M.$Ft(k.lineNumber,L,k.lineNumber,L+q.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(y){return!!(y&&y.match(h))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(i(y.path))return C.URI.parse(y.path);if((0,P.$jc)(y.path))return C.URI.file(y.path)}return y.path}function n(y){if(typeof y.path=="object"){const S=C.URI.revive(y.path);if(S)return S.scheme===A.Schemas.file?S.fsPath:S.toString()}return y.path}function t(y,S){const k=S?s:n,g=(0,O.$_n)(y);return f(g,(b,L)=>{b&&L&&(L.path=k(L))}),g}function m(y,S){const k=S?s:n,g=(0,O.$_n)(y);return f(g,(b,L)=>{!b&&L&&(L.path=k(L))}),g}function f(y,S){switch(y.type){case"event":{const k=y;switch(k.event){case"output":S(!1,k.body.source);break;case"loadedSource":S(!1,k.body.source);break;case"breakpoint":S(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=y;switch(k.command){case"setBreakpoints":S(!0,k.arguments.source);break;case"breakpointLocations":S(!0,k.arguments.source);break;case"source":S(!0,k.arguments.source);break;case"gotoTargets":S(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(g=>S(!1,g));break;default:break}break}case"response":{const k=y;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(g=>S(!1,g.source));break;case"loadedSources":k.body.sources.forEach(g=>S(!1,g));break;case"scopes":k.body.scopes.forEach(g=>S(!1,g.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"setBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"disassemble":k.body?.instructions.forEach(b=>S(!1,b.location));break;default:break}break}}}function l(y){return y.filter(S=>!S.presentation?.hidden).sort((S,k)=>S.presentation?k.presentation?S.presentation.group?k.presentation.group?S.presentation.group!==k.presentation.group?S.presentation.group.localeCompare(k.presentation.group):$(S.presentation.order,k.presentation.order):-1:k.presentation.group?1:$(S.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function $(y,S){return typeof y!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:y-S}async function I(y,S){const k=y.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(k!=="none"&&(await S.saveAll(),k==="allEditorsInActiveGroup")){const g=S.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await S.save({editor:g.input,groupId:g.group.id})}await y.reloadConfiguration()}const D=(y,S)=>!y||!S?y===S:y.name===S.name&&y.path===S.path&&y.sourceReference===S.sourceReference;e.$ZH=D}),define(Ce[238],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.CellExecutionUpdateType=void 0;var C;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$MK=(0,w.$Ci)("INotebookExecutionService")}),define(Ce[239],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jb=e.$7jb=e.ProxyKernelState=e.$6jb=void 0,e.$6jb=100;var C;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(C||(e.ProxyKernelState=C={})),e.$7jb=(0,w.$Ci)("INotebookKernelService"),e.$8jb=(0,w.$Ci)("INotebookKernelHistoryService")}),define(Ce[240],Ie([1,0,5,33,52,166,102]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uYb=void 0;class M extends w.$Vc{constructor(c,R,v){super(),this._source=c,this.b=R,this.c=v,this.a=void 0}f(c){const R=c.getLineCount();return new C.$Ft(1,1,R,this.g(c,R))}g(c,R){if(R<1||R>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const c=new O.$gD;c.acceptChunk(this._source);const R=c.finish(!0),{textBuffer:v,disposable:u}=R.create(P.DefaultEndOfLine.LF);this.b=v,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const R=new O.$gD;R.acceptChunk(c);const v=R.finish(!0),{textBuffer:u,disposable:E}=v.create(P.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(c){const v=new A.$7C(c,!1,!1,null).parseSearchRequest();if(!v)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,v,!0,5e3)}findInOutputs(c){const v=new A.$7C(c,!1,!1,null).parseSearchRequest();return v?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),v,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$uYb=M}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(O){O.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var C;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class P{static fromExtHostTestItem(A,M,p=A.parent){if(A._isRoot)return new P([M]);const c=[A.id];for(let R=p;R&&R.id!==M;R=R.parent)c.push(R.id);return c.push(M),new P(c.reverse())}static isRoot(A){return!A.includes(w.Delimiter)}static root(A){const M=A.indexOf(w.Delimiter);return M===-1?A:A.slice(0,M)}static fromString(A){return new P(A.split(w.Delimiter))}static join(A,M){return new P([...A.path,M])}static joinToString(A,M){return A.toString()+w.Delimiter+M}static parentId(A){const M=A.lastIndexOf(w.Delimiter);return M===-1?void 0:A.slice(0,M)}static localId(A){const M=A.lastIndexOf(w.Delimiter);return M===-1?A:A.slice(M+w.Delimiter.length)}static isChild(A,M){return M.startsWith(A)&&M[A.length]===w.Delimiter}static compare(A,M){return A===M?C.IsSame:P.isChild(A,M)?C.IsChild:P.isChild(M,A)?C.IsParent:C.Disconnected}static getLengthOfCommonPrefix(A,M){if(A===0)return 0;let p=0;for(;p<A-1;){for(let c=1;c<A;c++){const R=M(c-1),v=M(c);if(R.path[p]!==v.path[p])return p}p++}return p}constructor(A,M=A.length){if(this.path=A,this.d=M,A.length===0||M<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let M=0;M<A.d&&M<this.d;M++)if(A.path[M]!==this.path[M])return C.Disconnected;return A.d>this.d?C.IsChild:A.d<this.d?C.IsParent:C.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=w.Delimiter,this.c+=this.path[A]}return this.c}}e.$MI=P}),define(Ce[56],Ie([1,0,2,101,33,55]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$UI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$TI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$SI=e.$RI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$QI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$PI=e.$OI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$NI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$NI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var M;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(M||(e.ExtTestRunProfileKind=M={}));var p;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$OI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=W=>"runId"in W;e.$PI=c;var R;(function(W){W.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),W.deserialize=(N,V)=>({range:P.$Ft.lift(V.range),uri:N.asCanonicalUri(w.URI.revive(V.uri))})})(R||(e.IRichLocation=R={}));var v;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(v||(e.TestMessageType=v={}));var u;(function(W){W.serialize=N=>({message:N.message,type:v.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&R.serialize(N.location)}),W.deserialize=(N,V)=>({message:V.message,type:v.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&R.deserialize(N,V.location)})})(u||(e.ITestErrorMessage=u={}));const E=(W,N)=>`${N?"s":"e"}${W}`;e.$QI=E;var d;(function(W){W.serialize=N=>({message:N.message,type:v.Output,offset:N.offset,length:N.length,location:N.location&&R.serialize(N.location)}),W.deserialize=(N,V)=>({message:V.message,type:v.Output,offset:V.offset,length:V.length,location:V.location&&R.deserialize(N,V.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(W){W.serialize=N=>N.type===v.Error?u.serialize(N):d.serialize(N),W.deserialize=(N,V)=>V.type===v.Error?u.deserialize(N,V):d.deserialize(N,V)})(r||(e.ITestMessage=r={}));var o;(function(W){W.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),W.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),W.deserialize=(N,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ce=>r.deserialize(N,ce))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(W,N)=>W+a+N;e.$RI=h;const i=W=>{const N=W.indexOf(a);return{ctrlId:W.slice(0,N),tagId:W.slice(N+1)}};e.$SI=i;var s;(function(W){W.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),W.deserialize=(N,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?N.asCanonicalUri(w.URI.revive(V.uri)):void 0,range:V.range?P.$Ft.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(s||(e.ITestItem=s={}));var n;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var t;(function(W){W.serialize=N=>({expand:N.expand,item:s.serialize(N.item)}),W.deserialize=(N,V)=>({controllerId:O.$MI.root(V.item.extId),expand:V.expand,item:s.deserialize(N,V.item)})})(t||(e.InternalTestItem=t={}));var m;(function(W){W.serialize=N=>{let V;return N.item&&(V={},N.item.label!==void 0&&(V.label=N.item.label),N.item.tags!==void 0&&(V.tags=N.item.tags),N.item.busy!==void 0&&(V.busy=N.item.busy),N.item.uri!==void 0&&(V.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(V.range=N.item.range?.toJSON()),N.item.description!==void 0&&(V.description=N.item.description),N.item.error!==void 0&&(V.error=N.item.error),N.item.sortText!==void 0&&(V.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:V}},W.deserialize=N=>{let V;return N.item&&(V={},N.item.label!==void 0&&(V.label=N.item.label),N.item.tags!==void 0&&(V.tags=N.item.tags),N.item.busy!==void 0&&(V.busy=N.item.busy),N.item.range!==void 0&&(V.range=N.item.range?P.$Ft.lift(N.item.range):null),N.item.description!==void 0&&(V.description=N.item.description),N.item.error!==void 0&&(V.error=N.item.error),N.item.sortText!==void 0&&(V.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:V}}})(m||(e.ITestItemUpdate=m={}));const f=(W,N)=>{N.expand!==void 0&&(W.expand=N.expand),N.item!==void 0&&(W.item=W.item?Object.assign(W.item,N.item):N.item)};e.$TI=f;var l;(function(W){W.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serializeWithoutMessages)}),W.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(o.serialize)}),W.deserialize=(N,V)=>({...t.deserialize(N,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ce=>o.deserialize(N,ce)),retired:!0})})(l||(e.TestResultItem=l={}));var $;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(N,V)=>{N.covered+=V.covered,N.total+=V.total}})($||(e.ICoverageCount=$={}));var I;(function(W){W.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),W.deserialize=(N,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testId:V.testId?O.$MI.fromString(V.testId):void 0,uri:N.asCanonicalUri(w.URI.revive(V.uri))}),W.empty=(N,V)=>({id:N,uri:V,testId:void 0,statement:$.empty()})})(I||(e.IFileCoverage=I={}));function D(W){return{...W,location:W.location?.toJSON()}}function y(W){return W.location=W.location?C.$Et.isIPosition(W.location)?C.$Et.lift(W.location):P.$Ft.lift(W.location):void 0,W}e.$UI=3;var S;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(S||(e.DetailType=S={}));var k;(function(W){W.serialize=N=>N.type===S.Declaration?b.serialize(N):L.serialize(N),W.deserialize=N=>N.type===S.Declaration?b.deserialize(N):L.deserialize(N)})(k||(e.CoverageDetails=k={}));var g;(function(W){W.serialize=D,W.deserialize=y})(g||(e.IBranchCoverage=g={}));var b;(function(W){W.serialize=D,W.deserialize=y})(b||(e.IDeclarationCoverage=b={}));var L;(function(W){W.serialize=N=>({...D(N),branches:N.branches?.map(g.serialize)}),W.deserialize=N=>({...y(N),branches:N.branches?.map(g.deserialize)})})(L||(e.IStatementCoverage=L={}));var T;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var q;(function(W){W.deserialize=(N,V)=>V.op===T.Add?{op:V.op,item:t.deserialize(N,V.item)}:V.op===T.Update?{op:V.op,item:m.deserialize(V.item)}:V.op===T.DocumentSynced?{op:V.op,uri:N.asCanonicalUri(w.URI.revive(V.uri)),docv:V.docv}:V,W.serialize=N=>N.op===T.Add?{op:N.op,item:t.serialize(N.item)}:N.op===T.Update?{op:N.op,item:m.serialize(N.item)}:N})(q||(e.TestsDiffOp=q={}));class G{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const V=this.w();for(const ce of N)switch(ce.op){case T.Add:this.l(t.deserialize(this.k,ce.item),V);break;case T.Update:this.p(m.deserialize(ce.item),V);break;case T.Remove:this.q(ce.itemId,V);break;case T.Retire:this.v(ce.itemId);break;case T.IncrementPendingExtHosts:this.updatePendingRoots(ce.amount);break;case T.AddTag:this.c.set(ce.tag.id,ce.tag);break;case T.RemoveTag:this.c.delete(ce.id);break}V.complete?.()}l(N,V){const ce=O.$MI.parentId(N.item.extId)?.toString();let ge;if(!ce)ge=this.x(N),this.g.add(ge),this.f.set(N.item.extId,ge);else if(this.f.has(ce)){const ie=this.f.get(ce);ie.children.add(N.item.extId),ge=this.x(N,ie),this.f.set(N.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return V.add?.(ge),N.expand===n.BusyExpanding&&this.h++,ge}p(N,V){const ce=this.f.get(N.extId);if(ce)return N.expand!==void 0&&(ce.expand===n.BusyExpanding&&this.h--,N.expand===n.BusyExpanding&&this.h++),(0,e.$TI)(ce,N),V.update?.(ce),ce}q(N,V){const ce=this.f.get(N);if(!ce)return;const ge=O.$MI.parentId(ce.item.extId)?.toString();ge?this.f.get(ge).children.delete(ce.item.extId):this.g.delete(ce);const ie=[[N]];for(;ie.length;)for(const me of ie.pop()){const se=this.f.get(me);se&&(ie.push(se.children),this.f.delete(me),V.remove?.(se,se!==ce),se.expand===n.BusyExpanding&&this.h--)}}v(N){}updatePendingRoots(N){this.j+=N}w(){return{}}}e.$VI=G}),define(Ce[241],Ie([1,0,99,201,56]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$sFb=e.$rFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(v){v.ViewletId="workbench.view.extension.test",v.ExplorerViewId="workbench.view.testing",v.OutputPeekContributionId="editor.contrib.testingOutputPeek",v.DecorationsContributionId="editor.contrib.testingDecorations",v.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",v.CoverageViewId="workbench.view.testCoverage",v.ResultsPanelId="workbench.panel.testResults",v.ResultsViewId="workbench.panel.testResults.view",v.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(v){v.List="list",v.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var M;(function(v){v.ByLocation="location",v.ByStatus="status",v.ByDuration="duration"})(M||(e.TestExplorerViewSorting=M={}));const p={[P.TestResultState.Errored]:(0,C.localize)(0,null),[P.TestResultState.Failed]:(0,C.localize)(1,null),[P.TestResultState.Passed]:(0,C.localize)(2,null),[P.TestResultState.Queued]:(0,C.localize)(3,null),[P.TestResultState.Running]:(0,C.localize)(4,null),[P.TestResultState.Skipped]:(0,C.localize)(5,null),[P.TestResultState.Unset]:(0,C.localize)(6,null)},c=(v,u)=>(0,C.localize)(7,null,(0,w.$Vk)(v),p[u]);e.$rFb=c,e.$sFb={[P.TestRunProfileBitset.Debug]:(0,C.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,C.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,C.localize)(10,null)};var R;(function(v){v.CancelTestRefreshAction="testing.cancelTestRefresh",v.CancelTestRunAction="testing.cancelRun",v.ClearTestResultsAction="testing.clearTestResults",v.CollapseAllAction="testing.collapseAll",v.ConfigureTestProfilesAction="testing.configureProfile",v.ContinousRunUsingForTest="testing.continuousRunUsingForTest",v.CoverageAtCursor="testing.coverageAtCursor",v.CoverageByUri="testing.coverage.uri",v.CoverageClear="testing.coverage.close",v.CoverageCurrentFile="testing.coverageCurrentFile",v.CoverageFilterToTest="testing.coverageFilterToTest",v.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",v.CoverageLastRun="testing.coverageLastRun",v.CoverageSelectedAction="testing.coverageSelected",v.CoverageToggleToolbar="testing.coverageToggleToolbar",v.CoverageViewChangeSorting="testing.coverageViewChangeSorting",v.DebugAction="testing.debug",v.DebugAllAction="testing.debugAll",v.DebugAtCursor="testing.debugAtCursor",v.DebugByUri="testing.debug.uri",v.DebugCurrentFile="testing.debugCurrentFile",v.DebugFailedTests="testing.debugFailTests",v.DebugLastRun="testing.debugLastRun",v.DebugSelectedAction="testing.debugSelected",v.FilterAction="workbench.actions.treeView.testExplorer.filter",v.GetExplorerSelection="_testing.getExplorerSelection",v.GetSelectedProfiles="testing.getSelectedProfiles",v.GoToTest="testing.editFocusedTest",v.HideTestAction="testing.hideTest",v.OpenCoverage="testing.openCoverage",v.OpenOutputPeek="testing.openOutputPeek",v.RefreshTestsAction="testing.refreshTests",v.ReRunFailedTests="testing.reRunFailTests",v.ReRunLastRun="testing.reRunLastRun",v.RunAction="testing.run",v.RunAllAction="testing.runAll",v.RunAllWithCoverageAction="testing.coverageAll",v.RunAtCursor="testing.runAtCursor",v.RunByUri="testing.run.uri",v.RunCurrentFile="testing.runCurrentFile",v.RunSelectedAction="testing.runSelected",v.RunUsingProfileAction="testing.runUsing",v.RunWithCoverageAction="testing.coverage",v.SearchForTestExtension="testing.searchForTestExtension",v.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",v.ShowMostRecentOutputAction="testing.showMostRecentOutput",v.StartContinousRun="testing.startContinuousRun",v.StopContinousRun="testing.stopContinuousRun",v.TestingSortByDurationAction="testing.sortByDuration",v.TestingSortByLocationAction="testing.sortByLocation",v.TestingSortByStatusAction="testing.sortByStatus",v.TestingViewAsListAction="testing.viewAsList",v.TestingViewAsTreeAction="testing.viewAsTree",v.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",v.ToggleInlineTestOutput="testing.toggleInlineTestOutput",v.UnhideAllTestsAction="testing.unhideAllTests",v.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ce[82],Ie([1,0,11,4,5,62,56,55]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(h,i)=>h===i,v=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,i)=>!(h.length!==i.length||h.some(s=>!i.includes(s)))}),u=(h,i)=>{let s;for(const[n,t]of v)t(h[n],i[n])||(s?s[n]=i[n]:s={[n]:i[n]});return s};class E extends P.$Vc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new w.$Oh(()=>this.flushDiff(),200)),this.g=this.B(new C.$je),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===i.uri){s.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===i.item.extId){(0,A.$TI)(s.item,i.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===i.item.extId){(0,A.$TI)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const n=this.tree.get(i);if(n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===A.TestItemExpandState.Expandable){const t=this.M(n);return t.isOpen()?this.L(n,s-1):t.wait().then(()=>this.L(n,s-1))}else if(n.expand===A.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.L(n,s-1)):this.L(n,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case p.RemoveChild:this.O(M.$MI.joinToString(i.fullId,s.id));break;case p.Upsert:this.z(s.item,i);break;case p.Bulk:for(const n of s.ops)this.w(i,n);break;case p.SetTags:this.C(s.new,s.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$fd)(s)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const n=M.$MI.fromExtHostTestItem(i,this.root.id,s?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(i.id);let m=this.tree.get(n.toString());if(!m){m={fullId:n,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(m.fullId.toString(),m),this.G(i,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:m.expand,item:this.s.toITestItem(i)}}),this.I(i,m,s);return}if(m.actual===i){this.H(i,m,s);return}if(m.actual.uri?.toString()!==i.uri?.toString())return this.O(n.toString()),this.z(i,s);const f=this.s.getChildren(m.actual),l=m.actual,$=u(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,m.actual=i,m.resolveBarrier=void 0,m.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,n.toString()),delete $.tags),this.w(m,{op:p.SetProp,update:$})),this.I(i,m,s);for(const[D,y]of f)this.s.getChildren(i).get(y.id)||this.O(M.$MI.joinToString(n,y.id));const I=m.expandLevels;I!==void 0&&queueMicrotask(()=>{m.expand===A.TestItemExpandState.Expandable&&(m.expandLevels=void 0,this.expand(n.toString(),I))}),this.y(m.actual.uri)}C(i,s,n){const t=new Set(s.map(m=>m.id));for(const m of i)t.delete(m.id)||this.D(m);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n,item:{tags:i.map(m=>(0,A.$RI)(this.s.controllerId,m.id))}}}),t.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$RI)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$RI)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,n){this.G(i,n);const t=this.s.getApiFor(i);t.parent=n?.actual,t.listener=m=>this.w(s,m),this.J(s)}I(i,s,n){this.H(i,s,n);for(const[t,m]of this.s.getChildren(i))this.z(m,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==i.expand&&(i.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const n=[];for(const[t,m]of this.s.getChildren(i.actual)){const f=this.expand(M.$MI.joinToString(i.fullId,m.id),s);(0,w.$oh)(f)&&n.push(f)}if(n.length)return Promise.all(n).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const m=new w.$Bh;return m.open(),m}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const s=i.resolveBarrier=new w.$Bh,n=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,m)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(m){n(m)}return(0,w.$oh)(t)?t.catch(n).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const n=[s];for(;n.length;){const t=n.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const m of t.actual.tags)this.F(m.id);this.tree.delete(t.fullId.toString());for(const[m,f]of this.s.getChildren(t.actual))n.push(this.tree.get(M.$MI.joinToString(t.fullId,f.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$iP=E;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$jP=d;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$kP=r;class o extends Error{constructor(i,s,n){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${n}".`)}}e.$lP=o;const a=(h,i,s)=>{let n=new Map;return{get size(){return n.size},forEach(t,m){for(const f of n.values())t.call(m,f,this)},[Symbol.iterator](){return n.entries()},replace(t){const m=new Map,f=new Set(n.keys()),l={op:p.Bulk,ops:[]};for(const $ of t){if(!($ instanceof s))throw new r($.id);const I=i($).controllerId;if(I!==h.controllerId)throw new o($.id,I,h.controllerId);if(m.has($.id))throw new d($.id);m.set($.id,$),f.delete($.id),l.ops.push({op:p.Upsert,item:$})}for(const $ of f.keys())l.ops.push({op:p.RemoveChild,id:$});h.listener?.(l),n=m},add(t){if(!(t instanceof s))throw new r(t.id);n.set(t.id,t),h.listener?.({op:p.Upsert,item:t})},delete(t){n.delete(t)&&h.listener?.({op:p.RemoveChild,id:t})},get(t){return n.get(t)},toJSON(){return Array.from(n.values())}}};e.$mP=a}),define(Ce[115],Ie([1,0,82]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=void 0;const C=new WeakMap,P=(A,M)=>{const p={controllerId:M};return C.set(A,p),p};e.$nP=P;const O=A=>{const M=C.get(A);if(!M)throw new w.$kP(A?.id||"<unknown>");return M};e.$oP=O}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hCb=e.$gCb=e.$fCb=void 0,e.$iCb=O,e.$jCb=M,e.$fCb="vscode-cdn.net",e.$gCb=`vscode-resource.${e.$fCb}`,e.$hCb=`'self' https://*.${e.$fCb}`;function O(p,c){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===C.Schemas.file&&(p=P.URI.from({scheme:C.Schemas.vscodeRemote,authority:c.authority,path:p.path})),P.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$gCb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,c=>{const R=c.charCodeAt(0);return R>=w.CharCode.a&&R<=w.CharCode.z||R>=w.CharCode.A&&R<=w.CharCode.Z||R>=w.CharCode.Digit0&&R<=w.CharCode.Digit9?c:"-"+R.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(c,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ce[242],Ie([1,0,4,5,83]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class O{constructor(M,p,c){this.d=M,this.e=p,this.f=c,this.a=0,this.b=new C.$Uc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const v of this.c.values())R.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this.c.forEach(M=>M.inset.dispose()),this.b.dispose()}createWebviewEditorInset(M,p,c,R,v){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===M){u=i;break}if(!u)throw new Error("not a visible editor");const E=this,d=this.a++,r=new w.$je,o=new w.$je,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$iCb)(i,E.f)}get cspSource(){return P.$hCb}set options(i){this.b=i,E.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return E.d.$postMessage(d,i)}},h=new class{constructor(){this.editor=M,this.line=p,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,c,R||{},v.identifier,v.extensionLocation),this.c.set(d,{editor:M,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(M){const p=this.c.get(M);p&&p.inset.dispose()}$onDidReceiveMessage(M,p){this.c.get(M)?.onDidReceiveMessage.fire(p)}}e.$pnc=O}),define(Ce[116],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.$1L=void 0,e.$1L="__",e.$2L=(0,w.$Ci)("IAuthenticationService"),e.$3L=(0,w.$Ci)("IAuthenticationExtensionsService")}),define(Ce[243],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=e.VariableKind=e.$gQ=void 0,e.$gQ=(0,w.$Ci)("configurationResolverService");var C;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class P extends Error{constructor(A,M){super(M),this.variable=A}}e.$hQ=P}),define(Ce[244],Ie([1,0,20,79,15,26,21,103,202,243,13]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=void 0,w=qe(w),C=qe(C),P=qe(P),O=qe(O);class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,r,o){this.h=new Map,this.a=E,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(r=>{d[r.toLowerCase()]=E[r]}),d}return E}resolveWithEnvironment(E,d,r){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(E,d){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,d)}async j(E,d,r,o){const a=O.$_n(d);A.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):A.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):A.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,a,r,o)}async resolveAnyAsync(E,d,r){return this.j(E,d,r)}async resolveAnyMap(E,d,r){const o=new Map;return{newConfig:await this.j(E,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(E,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,r,o,a){if(P.$cg(r))return this.m(E,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(E,d,h,o,a)));if(P.$eg(r)){const h=Object.create(null),i=await Promise.all(Object.keys(r).map(async s=>[await this.m(E,d,s,o,a),await this.l(E,d,r[s],o,a)]));for(const[s,n]of i)h[s]=n;return h}return r}m(E,d,r,o,a){return(0,R.$vf)(r,v.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(v.VARIABLE_LHS))return h;let s=await this.o(E,h,i,d,o);return a?.set(i,s),s!==h&&P.$cg(s)&&s.match(v.VARIABLE_REGEXP)&&(s=await this.m(E,d,s,o,a)),s})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,r,o,a){let h;const i=r.split(":");i.length>1&&(r=i[0],h=i[1]);const s=m=>{const f=this.a.getFilePath();if(f)return(0,M.$Qw)(f);throw new c.$hQ(m,(0,p.localize)(0,null,d))},n=m=>{const f=s(m);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,M.$Qw)(l)}throw new c.$hQ(m,(0,p.localize)(1,null,d,w.$oc(f)))},t=m=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$hQ(m,(0,p.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$hQ(m,(0,p.localize)(3,null,d)):new c.$hQ(m,(0,p.localize)(4,null,d))};switch(r){case"env":if(h){if(E.env){const m=E.env[A.$i?h.toLowerCase():h];if(P.$cg(m))return m}return""}throw new c.$hQ(c.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const m=this.a.getConfigurationValue(o,h);if(P.$lg(m))throw new c.$hQ(c.VariableKind.Config,(0,p.localize)(6,null,d,h));if(P.$eg(m))throw new c.$hQ(c.VariableKind.Config,(0,p.localize)(7,null,d,h));return m}throw new c.$hQ(c.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const m=await this.a.getExtension(h);if(!m)throw new c.$hQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(m.extensionLocation)}throw new c.$hQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,M.$Qw)(this.n(t(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,M.$Qw)(this.n(t(c.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,M.$Qw)(w.$oc(this.n(t(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new c.$hQ(c.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const m=this.a.getLineNumber();if(m)return m;throw new c.$hQ(c.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const m=this.a.getSelectedText();if(m)return m;throw new c.$hQ(c.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return n(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return w.$oc(n(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?w.$mc(this.n(t(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const m=w.$nc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=w.$mc(this.n(t(c.VariableKind.RelativeFileDirname)),m);return f.length===0?".":f}return m}case"fileDirname":return w.$nc(s(c.VariableKind.FileDirname));case"fileExtname":return w.$pc(s(c.VariableKind.FileExtname));case"fileBasename":return w.$oc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const m=w.$oc(s(c.VariableKind.FileBasenameNoExtension));return m.slice(0,m.length-w.$pc(m).length)}case"fileDirnameBasename":return w.$oc(w.$nc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const m=this.a.getExecPath();return m||d}case"execInstallFolder":{const m=this.a.getAppRoot();return m||d}case"pathSeparator":case"/":return w.sep;default:try{const m=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,m,a,void 0)}catch{return d}}}}p(E,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$hQ(E,(0,p.localize)(14,null,d))}return d}}e.$wQ=v}),define(Ce[117],Ie([1,0,3,114]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$dE=void 0,e.$eE=c,e.$fE=u,e.$gE=E,e.$dE=(0,w.$Ci)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var M;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(M||(e.GroupsArrangement=M={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(d){const r=d;return(0,C.$2F)(r?.editor)&&(0,C.$2F)(r?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var v;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function u(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ce[245],Ie([1,0,3,117]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kE=e.$jE=e.$iE=e.$hE=void 0,e.$lE=P,e.$hE=(0,w.$Ci)("editorService"),e.$iE=-1,e.$jE=-2,e.$kE=-3;function P(O){const A=O;return typeof O=="number"||(0,C.$fE)(A)}}),define(Ce[246],Ie([1,0,3,106]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0,e.$jM=(0,w.$Di)(C.$Ji)}),define(Ce[118],Ie([1,0,19,4,20,5,11]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=e.$Ebc=e.$Dbc=e.$Cbc=e.$Bbc=void 0,P=qe(P);class M{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Bbc=M;class p{static isHostExtension(h,i,s){if(i.getExtensionDescription(h))return!1;const n=s.getExtensionDescription(h);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(h,i){this.j=h,this.c=new C.$je,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new w.$pn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=o(this.e,i),this.e=this.e.concat(h);const s=p.l(this.e);return this.e=o(this.e,s.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,s)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,l){this.addNode(f),this.addNode(l),this.c.has(f)?this.c.get(f).push(l):this.c.set(f,[l])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,l){const $=i.getArcs(f);for(let I=0;I<$.length;I++)if(!l.has($[I]))return!1;return!0}getNodes(){return this.e}},s=new w.$pn;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const l of f.extensionDependencies)i.addArc(w.$nn.toKey(f.identifier),w.$nn.toKey(l));const n=new Set;i.getNodes().filter(f=>i.getArcs(f).length===0).forEach(f=>n.add(f));const t=i.getNodes().filter(f=>!n.has(f));let m;do{m=!1;for(let f=0;f<t.length;f++){const l=t[f];i.hasOnlyGoodArcs(l,n)&&(t.splice(f,1),f--,n.add(l),m=!0)}}while(m);return t.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Cbc=p;class c{constructor(h,i){this.versionId=h,this.extensions=i}}e.$Dbc=c;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new v(this,i)}deltaExtensions(h,i,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$Ebc=R;class v extends O.$Vc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$Fbc=v;class u{constructor(h){this.name=h;const i=(0,A.$vh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};h.resolve((0,O.$Tc)(n))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const i=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(i!==s)return i-s;const n=P.$hc.basename(a.extensionLocation.path),t=P.$hc.basename(h.extensionLocation.path);return n<t?-1:n>t?1:0}function o(a,h){const i=new w.$on(h);return a.filter(s=>!i.has(s.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$vn=A,e.$wn=M;var C;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(C||(e.UIKind=C={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(c){const R=w.$Le.alloc(1);switch(c){case O.Initialized:R.writeUInt8(1,0);break;case O.Ready:R.writeUInt8(2,0);break;case O.Terminate:R.writeUInt8(3,0);break}return R}function M(c,R){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return R===O.Initialized;case 2:return R===O.Ready;case 3:return R===O.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[67],Ie([1,0,3,4,112,12,27,84,63,64,26,2,5,187]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=e.$KP=e.$JP=void 0,e.$LP=o;let d=class extends u.$Vc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new C.$je),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$je),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:c.$vp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(s=>{(0,O.$$j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,s){const n=this.getTelemetryDetails(),t=new r(i,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),m=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...m,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(h,i,s){this.f=h,this.g=i,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:i["common.uikind"]="web";break;case M.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$en)((0,c.$Bp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((s,n)=>{const t=s.filter(m=>!m.isDisposed);t.length===0?this.r.delete(n):this.r.set(n,t)}),this.r.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const n=this.r.get(h.value)?.filter(m=>!m.isDisposed);if(!n)return this.r.delete(h.value),!1;let t=!1;for(const m of n)m.ignoreUnhandledExtHostErrors||(m.logError(i),t=!0);return t}};e.$JP=d,e.$JP=d=He([Ve(0,A.$IP),Ve(1,O.$0j)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,s,n,t,m,f){this.g=s,this.h=n,this.i=t,this.j=m,this.a=new C.$je,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,c.$Ep)(i,[]),this.c&&(i=(0,R.$co)(i,this.c)),this.b||(i=(0,R.$co)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},n=(0,c.$Ep)(s,[]),t=new Error(n.message,{cause:n.cause});t.stack=n.stack,t.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(t,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$KP=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$MP=(0,w.$Ci)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,218,111,19,3]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7G=e.ActivationKind=e.$4G=e.$3G=e.$ZG=e.ExtensionHostStartup=e.$YG=e.$XG=e.$WG=e.$VG=void 0,e.$1G=u,e.$2G=E,e.$5G=a,e.$6G=h,e.$VG=Object.freeze({identifier:new A.$nn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$WG="extensions.webWorker",e.$XG=(0,M.$Ci)("extensionService");class p{constructor(n){this.dependency=n}}e.$YG=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(n,t,m){this.c=n,this.d=t.slice(0),this.e=m.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$GG.createActivationEventsMap(this.d)}}set(n,t,m){if(this.c>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this.c})`);const f=[],l=[],$=[],I=[],D=v(this.d),y=v(t),S=(T,q)=>T.extensionLocation.toString()===q.extensionLocation.toString()||T.isBuiltin===q.isBuiltin||T.isUserBuiltin===q.isUserBuiltin||T.isUnderDevelopment===q.isUnderDevelopment;for(const T of this.d){const q=y.get(T.identifier);if(!q){f.push(T.identifier),D.delete(T.identifier);continue}if(!S(T,q)){f.push(T.identifier),D.delete(T.identifier);continue}}for(const T of t){const q=D.get(T.identifier);if(!q){l.push(T);continue}if(!S(q,T)){f.push(q.identifier),D.delete(q.identifier);continue}}const k=new A.$on(this.e),g=new A.$on(m);for(const T of this.e)g.has(T)||$.push(T);for(const T of m)k.has(T)||I.push(T);const b=O.$GG.createActivationEventsMap(l),L={versionId:n,toRemove:f,toAdd:l,addActivationEvents:b,myToRemove:$,myToAdd:I};return this.delta(L),L}delta(n){if(this.c>=n.versionId)return null;const{toRemove:t,toAdd:m,myToRemove:f,myToAdd:l}=n,$=new A.$on(t),I=new A.$on(f);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of m)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,n}containsExtension(n){for(const t of this.e)if(A.$nn.equals(t,n))return!0;return!1}containsActivationEvent(n){return this.f||(this.f=this.g()),this.f.has(n)}g(){const n=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const m=O.$GG.readActivationEvents(t);for(const f of m)n.add(f)}return n}}e.$ZG=R;function v(s){const n=new A.$pn;for(const t of s)n.set(t.identifier,t);return n}function u(s,n){return s.enabledApiProposals?s.enabledApiProposals.includes(n):!1}function E(s,n){if(!u(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(n,t,m,f){this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=f}}e.$3G=d;class r{constructor(n,t){this.description=n,this.value=t}}e.$4G=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.$Kp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,n){const t=(0,P.$Ip)(s.manifest.publisher,s.manifest.name);return{id:t,identifier:new A.$nn(t),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class i{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,t){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$7G=i}),define(Ce[247],Ie([1,0,14,118,19,25,12,11]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=e.$Onc=e.$Nnc=e.$Mnc=e.$Lnc=void 0,w=qe(w);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(a,h,i,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s}}e.$Lnc=p;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Mnc=c;class R{constructor(a,h,i,s,n,t){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=i,this.module=s,this.exports=n,this.subscriptions=t}}e.$Nnc=R;class v extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Onc=v;class u extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Pnc=u;class E extends R{constructor(a){super(!0,a,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,i,s){this.g=s,this.a=a,this.b=h,this.c=i,this.d=new P.$pn,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(a){const h=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const n=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(n));return this.c.onExtensionActivationError(a.id,n,new O.$YG(a.id.value)),t}const i=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const n of s){if(this.m(n))continue;const t=this.d.get(n);if(t){i.push(t);continue}if(this.l(n)){i.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:a.reason}));continue}const m=this.a.getExtensionDescription(n);if(m){if(!m.main&&!m.browser)continue;i.push(this.j({id:m.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,l=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${n}'`),$=this.k(a,h.displayName,[],new E(l));return this.c.onExtensionActivationError(h.identifier,l,new O.$YG(n)),$}return this.k(a,h.displayName,i,null)}k(a,h,i,s){const n=new r(a.id,h,a.reason,i,s,this.c,this.g);return this.d.set(a.id,n),n}l(a){return C.$Cbc.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$Qnc=d,e.$Qnc=d=He([Ve(3,A.$9j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,i,s,n,t,m){this.c=a,this.d=h,this.f=i,this.g=s,this.h=n,this.j=t,this.k=m,this.a=new M.$Bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new E(h),this.b&&w.$5(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=He([Ve(6,A.$9j)],r)}),define(Ce[248],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[119],Ie([1,0,204,14,36,110,78,31,19,248,108,111]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=void 0,w=qe(w),P=ri(P);const u=M.$mo.as(A.$no.JSONContribution);class E{constructor(n,t,m){this.a=n,this.b=t,this.c=m}d(n,t){this.a({type:n,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(n){this.d(P.default.Error,n)}warn(n){this.d(P.default.Warning,n)}info(n){this.d(P.default.Info,n)}}e.$PG=E;class d{static a(n){const t=new p.$on;for(let m=0,f=n.length;m<f;m++)t.add(n[m].description.identifier);return t}static compute(n,t){if(!n||!n.length)return new d(t,[]);if(!t||!t.length)return new d([],n);const m=this.a(n),f=this.a(t),l=t.filter(I=>!m.has(I.description.identifier)),$=n.filter(I=>!f.has(I.description.identifier));return new d(l,$)}constructor(n,t){this.added=n,this.removed=t}}e.$QG=d;class r{constructor(n,t){this.name=n,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(n){if(this.a!==null)throw new Error("Handler already set!");return this.a=n,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(n){this.c=d.compute(this.b,n),this.b=n,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(n){(0,C.$2)(n)}}}e.$RG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$SG={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$mn},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:w.localize(42,null)},{label:"*",description:w.localize(43,null),body:"*"}]}},badges:{type:"array",description:w.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(45,null)},href:{type:"string",description:w.localize(46,null)},description:{type:"string",description:w.localize(47,null)}}}},markdown:{type:"string",description:w.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$4o}},extensionPack:{description:w.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$4o}},extensionKind:{description:w.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(53,null)},{body:["workspace"],description:w.localize(54,null)},{body:["ui","workspace"],description:w.localize(55,null)},{body:["workspace","ui"],description:w.localize(56,null)},{body:[],description:w.localize(57,null)}]},capabilities:{description:w.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(61,null),w.localize(62,null),w.localize(63,null)]},description:{type:"string",markdownDescription:w.localize(64,null)}}},untrustedWorkspaces:{description:w.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(67,null),w.localize(68,null),w.localize(69,null)]},restrictedConfigurations:{description:w.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(71,null)}}}}},sponsor:{description:w.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(74,null),type:"string"},"vscode:uninstall":{description:w.localize(75,null),type:"string"}}},icon:{type:"string",description:w.localize(76,null)},l10n:{type:"string",description:w.localize(77,null)},pricing:{type:"string",markdownDescription:w.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(n){if(this.a.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const t=new r(n.extensionPoint,n.defaultExtensionKind);return this.a.set(n.extensionPoint,t),n.activationEventsGenerator&&v.$GG.register(n.extensionPoint,n.activationEventsGenerator),e.$SG.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,u.registerSchema(a,e.$SG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$TG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};M.$mo.add(i.ExtensionsRegistry,new h),e.$UG=M.$mo.as(i.ExtensionsRegistry),u.registerSchema(a,e.$SG),u.registerSchema(R.$qk,{properties:{extensionEnabledApiProposals:{description:w.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(Ce[249],Ie([1,0,4,40,5,13,196,19,3,12,25,119]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.$8G=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$8G=(0,p.$Ci)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$9G=v.$UG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.e=o,this.f=a,this.a=new P.$Uc,this.b=new Map,this.c=new Set,this.d=this.a.add(new w.$je),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$9G.setHandler(h=>{this.c.clear();for(const s of h){if(!(0,R.$1G)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const n of C.Iterable.wrap(s.value)){if(this.c.has(n.vendor)){s.collector.error((0,A.localize)(3,null,n.vendor));continue}if((0,O.$af)(n.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){s.collector.error((0,A.localize)(5,null));continue}this.c.add(n.vendor)}}const i=[];for(const[s,n]of this.b)this.c.has(n.metadata.vendor)||(this.b.delete(s),i.push(s));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const a=[];for(const[h,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(s=>M.$nn.equals(s,o.extension)))&&a.push(h);return this.f.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.f.trace("[LM] registering language model chat",o,a.metadata),!this.c.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,a),this.d.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.$Tc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,i,s,n){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideChatResponse(h,a,i,s,n)}computeTokenLength(o,a,h){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(a,h)}};e.$0G=d,e.$0G=d=He([Ve(0,R.$XG),Ve(1,c.$9j)],d)}),define(Ce[250],Ie([1,0,199,15,26,119,32,4]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AI=void 0,w=qe(w),C=qe(C),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var c;(function(u){function E(d,r,o){if(!d)return;const a=C.$cg(d.type)?d.type:void 0;if(!a||a.length===0){o.error(w.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const i of d.required)C.$cg(i)&&h.push(i);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?P.$_n(d.properties):{},when:d.when?A.$Aj.deserialize(d.when):void 0}}u.from=E})(c||(c={}));const R=O.$UG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const d of u)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:p}});class v{constructor(){this.d=new M.$je,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{R.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of o.added){const h=a.value;for(const i of h){const s=c.from(i,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$_n(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$AI=new v}),define(Ce[251],Ie([1,0,200,15,24,26,32,250,42]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$KI=e.JsonSchemaVersion=e.ExecutionEngine=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$EI=e.ShellQuoting=e.$DI=e.$CI=e.$BI=void 0,w=qe(w),C=qe(C),P=qe(P),O=qe(O),e.$BI="settings",e.$CI=new A.$Tj("taskRunning",!1,w.localize(0,null)),e.$DI=w.localize2(2,"Tasks");var c;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$EI="$customized",function(N){function V(ce){if(!ce)return N.Strong;switch(ce.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=V}(c||(e.ShellQuoting=c={}));var R;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var v;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(v||(e.RevealKind=v={})),function(N){function V(ce){switch(ce.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=V}(v||(e.RevealKind=v={}));var u;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(N){function V(ce){switch(ce.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=V}(u||(e.RevealProblemKind=u={}));var E;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(E||(e.PanelKind=E={})),function(N){function V(ce){switch(ce.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=V}(E||(e.PanelKind=E={}));var d;(function(N){N.defaults={echo:!0,reveal:v.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(N){function V(ge){switch(ge.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=V;function ce(ge){switch(ge){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=ce}(r||(e.RuntimeType=r={}));var o;(function(N){function V(ce){return C.$cg(ce)?ce:ce.value}N.value=V})(o||(e.CommandString=o={}));var a;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function V(ge){return ge===N.Clean._id||ge===N.Build._id||ge===N.Rebuild._id||ge===N.Test._id}N.is=V;function ce(ge){if(ge!==void 0)return C.$cg(ge)?V(ge)?{_id:ge,isDefault:!1}:void 0:ge}N.from=ce})(a||(e.TaskGroup=a={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function V(ce){switch(ce){case N.User:return p.ConfigurationTarget.USER;case N.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=V})(i||(e.TaskSourceKind=i={}));var s;(function(N){N.parallel="parallel",N.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var t;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class m{constructor(V,ce,ge,ie,me,se){this._label="",this._id=V,ce&&(this._label=ce),ge&&(this.type=ge),this.runOptions=ie,this.configurationProperties=me,this._source=se}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,ce=!1){if(V===void 0)return!1;if(C.$cg(V))return V===this._label||V===this.configurationProperties.identifier||ce&&V===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$FI=m;class f extends m{constructor(V,ce,ge,ie,me,se,de,be){super(V,ge,void 0,de,be,ce),this.command={},this._source=ce,this.hasDefinedMatchers=se,me&&(this.command=me)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let ce;switch(this.command?this.command.runtime:void 0){case r.Shell:ce="shell";break;case r.Process:ce="process";break;case r.CustomExecution:ce="customExecution";break;case void 0:ce="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ce,_key:this._id,id:this._id}}}static is(V){return V instanceof f}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$BI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let ce=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ce+=this._source.kind);const ge={type:e.$EI,folder:V,id:ce};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ah(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new f(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$GI=f;class l extends m{constructor(V,ce,ge,ie,me,se,de){super(V,ge,ie,se,de,ce),this._source=ce,this.configures=me}static is(V){return V instanceof l}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ah(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$BI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let ce=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(ce+=this._source.kind);const ge={type:e.$EI,folder:V,id:ce};return JSON.stringify(ge)}}e.$HI=l;class $ extends m{constructor(V,ce,ge,ie,me,se,de,be,re){super(V,ge,ie,be,re,ce),this.defines=me,this.hasDefinedMatchers=de,this.command=se,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof $}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new $(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$II=$;class I extends m{constructor(V,ce,ge,ie,me,se){super(V,ge,ie,me,se,ce),this._source=ce}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new I(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$JI=I;var D;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(N){N._default=N.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class S{constructor(V){this.c=new Map;for(let ce=0;ce<V.length;ce++)this.c.set(V[ce].uri.toString(),ce)}compare(V,ce){const ge=V.getWorkspaceFolder(),ie=ce.getWorkspaceFolder();if(ge&&ie){let me=this.c.get(ge.uri.toString());me=me===void 0?0:me+1;let se=this.c.get(ie.uri.toString());return se=se===void 0?0:se+1,me===se?V._label.localeCompare(ce._label):me-se}else return!ge&&ie?-1:ge&&!ie?1:0}}e.$KI=S;var k;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(k||(e.TaskEventKind=k={}));var g;(function(N){N.SingleRun="singleRun",N.Background="background"})(g||(e.TaskRunType=g={}));var b;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(N){function V(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?g.Background:g.SingleRun,group:be.configurationProperties.group,__task:be}}function ce(be,re,Pe){return{...V(be),kind:k.Start,terminalId:re,resolvedVariables:Pe}}N.start=ce;function ge(be,re,Pe){return{...V(be),kind:k.ProcessStarted,terminalId:re,processId:Pe}}N.processStarted=ge;function ie(be,re,Pe){return{...V(be),kind:k.ProcessEnded,terminalId:re,exitCode:Pe}}N.processEnded=ie;function me(be,re,Pe){return{...V(be),kind:k.Terminated,exitReason:Pe,terminalId:re}}N.terminated=me;function se(be,re,Pe){return{...V(re),kind:be,terminalId:Pe}}N.general=se;function de(){return{kind:k.Changed}}N.changed=de})(L||(e.TaskEvent=L={}));var T;(function(N){function V(ge){const ie=Object.keys(ge).sort();let me="";for(const se of ie){let de=ge[se];de instanceof Object?de=V(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),me+=se+","+de+","}return me}function ce(ge){const me={_key:V(ge),type:ge.taskType};return Object.assign(me,ge),me}N.create=ce})(T||(e.KeyedTaskIdentifier=T={}));var q;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(q||(e.TaskSettingId=q={}));var G;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var W;(function(N){function V(ce,ge){const ie=M.$AI.get(ce.type);if(ie===void 0){const be=O.$_n(ce);return delete be._key,T.create(be)}const me=Object.create(null);me.type=ie.taskType;const se=new Set;ie.required.forEach(be=>se.add(be));const de=ie.properties;for(const be of Object.keys(de)){const re=ce[be];if(re!=null)me[be]=re;else if(se.has(be)){const Pe=de[be];if(Pe.default!==void 0)me[be]=O.$_n(Pe.default);else switch(Pe.type){case"boolean":me[be]=!1;break;case"number":case"integer":me[be]=0;break;case"string":me[be]="";break;default:ge.error(w.localize(1,null,JSON.stringify(ce,void 0,0),be));return}}}return T.create(me)}N.createTaskIdentifier=V})(W||(e.TaskDefinition=W={}))}),define(Ce[252],Ie([1,0,14]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,M)=>{this.b=A,this.d=M,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$2)(A))}then(A,M){return this.j().then(A,M)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Gbc=C;class P extends C{constructor(){super(),this.h=!0,this.i=new w.$6}}e.$Hbc=P}),define(Ce[39],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Kw=void 0,e.$Lw=P,e.$Mw=O;class w{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++w.count}}e.$Kw=w;const C=[];function P(M){const p=new w(M);return C[p.nid]=p,p}function O(M){return C[M].sid}class A{constructor(p){this.value=p}}e.$Nw=A}),define(Ce[6],Ie([1,0,39]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$XM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var M;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(M||(e.WebviewMessageArrayBufferViewType=M={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var R;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class v{static{this.a=0}static mixin(o){return o._id=v.a++,o}}e.$XM=v;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$YM={MainThreadAuthentication:(0,w.$Lw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Lw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,w.$Lw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,w.$Lw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,w.$Lw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$Lw)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$Lw)("MainThreadClipboard"),MainThreadCommands:(0,w.$Lw)("MainThreadCommands"),MainThreadComments:(0,w.$Lw)("MainThreadComments"),MainThreadConfiguration:(0,w.$Lw)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Lw)("MainThreadConsole"),MainThreadDebugService:(0,w.$Lw)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Lw)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Lw)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Lw)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Lw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Lw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Lw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Lw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Lw)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Lw)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Lw)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Lw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$Lw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Lw)("MainThreadLanguages"),MainThreadLogger:(0,w.$Lw)("MainThreadLogger"),MainThreadMessageService:(0,w.$Lw)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Lw)("MainThreadOutputService"),MainThreadProgress:(0,w.$Lw)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Lw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Lw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Lw)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Lw)("MainThreadSecretState"),MainThreadStorage:(0,w.$Lw)("MainThreadStorage"),MainThreadSpeech:(0,w.$Lw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$Lw)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Lw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,w.$Lw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,w.$Lw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Lw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Lw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Lw)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Lw)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Lw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Lw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Lw)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Lw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$Lw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$Lw)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Lw)("MainThreadSCM"),MainThreadSearch:(0,w.$Lw)("MainThreadSearch"),MainThreadShare:(0,w.$Lw)("MainThreadShare"),MainThreadTask:(0,w.$Lw)("MainThreadTask"),MainThreadWindow:(0,w.$Lw)("MainThreadWindow"),MainThreadLabelService:(0,w.$Lw)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Lw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Lw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Lw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Lw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Lw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Lw)("MainThreadInteractive"),MainThreadTheming:(0,w.$Lw)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Lw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Lw)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Lw)("MainThreadTimeline"),MainThreadTesting:(0,w.$Lw)("MainThreadTesting"),MainThreadLocalization:(0,w.$Lw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$Lw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$Lw)("MainThreadAiEmbeddingVector")},e.$ZM={ExtHostCommands:(0,w.$Lw)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Lw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Lw)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Lw)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Lw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Lw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Lw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Lw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Lw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Lw)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Lw)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Lw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Lw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Lw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Lw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Lw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Lw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Lw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Lw)("ExtHostStatusBar"),ExtHostShare:(0,w.$Lw)("ExtHostShare"),ExtHostExtensionService:(0,w.$Lw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Lw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Lw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,w.$Lw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,w.$Lw)("ExtHostSCM"),ExtHostSearch:(0,w.$Lw)("ExtHostSearch"),ExtHostTask:(0,w.$Lw)("ExtHostTask"),ExtHostWorkspace:(0,w.$Lw)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Lw)("ExtHostWindow"),ExtHostWebviews:(0,w.$Lw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Lw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Lw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Lw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Lw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Lw)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Lw)("ExtHostProgress"),ExtHostComments:(0,w.$Lw)("ExtHostComments"),ExtHostSecretState:(0,w.$Lw)("ExtHostSecretState"),ExtHostStorage:(0,w.$Lw)("ExtHostStorage"),ExtHostUrls:(0,w.$Lw)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Lw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Lw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Lw)("ExtHostOutputService"),ExtHostLabelService:(0,w.$Lw)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Lw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Lw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Lw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Lw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Lw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Lw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Lw)("ExtHostInteractive"),ExtHostChatAgents2:(0,w.$Lw)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$Lw)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$Lw)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$Lw)("ExtHostSpeech"),ExtHostEmbeddings:(0,w.$Lw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,w.$Lw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$Lw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$Lw)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Lw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Lw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Lw)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Lw)("ExtHostTimeline"),ExtHostTesting:(0,w.$Lw)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Lw)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Lw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,6,17]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=e.$$mc=void 0,P=qe(P),e.$$mc=(0,w.$Ci)("IExtHostApiDeprecationService");let A=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(P.$YM.MainThreadTelemetry)}report(p,c,R){const v=this.d(p,c);this.a.has(v)||(this.a.add(v),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$_mc=A,e.$_mc=A=He([Ve(0,O.$sP),Ve(1,C.$9j)],A),e.$anc=Object.freeze(new class{report(M,p,c){}})}),define(Ce[253],Ie([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class C{constructor(O){const A=O.getProxy(w.$YM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(M){return A.$writeText(M)}})}}e.$nnc=C}),define(Ce[254],Ie([1,0,26,6,27,17]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ipc=void 0;let A=class{constructor(R,v){this.a=R.getProxy(C.$YM.MainThreadConsole),this.b=v.consoleForward.includeStack,this.c=v.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,v){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,v,E,arguments)}})}e(R,v,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:v,arguments:p(E,this.b)}),this.c&&this.f(R,u,E)}};e.$ipc=A,e.$ipc=A=He([Ve(0,O.$sP),Ve(1,P.$IP)],A);const M=1e5;function p(c,R){const v=[];if(c.length)for(let u=0;u<c.length;u++){let E=c[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}v.push(E)}if(R){const u=new Error().stack;u&&v.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$eo)(v);return u.length>M?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[255],Ie([1,0,2,6,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class O{constructor(M){this.a=M.getProxy(C.$YM.MainThreadDialogs)}showOpenDialog(M,p){return p?.allowUIResources&&(0,P.$2G)(M,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(M){return this.a.$showSaveDialog(M).then(p=>p?w.URI.revive(p):void 0)}}e.$poc=O}),define(Ce[256],Ie([1,0,22,4,5,6]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0;class A{constructor(p){this.b=new Map,this.c=new C.$je,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$YM.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,R){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const v=this.e++;return this.a.$registerEmbeddingProvider(v,c),this.b.set(v,{id:c,provider:R}),(0,P.$Tc)(()=>{this.a.$unregisterEmbeddingProvider(v),this.b.delete(v)})}async computeEmbeddings(p,c,R){R??=w.CancellationToken.None;let v=!1;typeof c=="string"&&(c=[c],v=!0);const u=await this.a.$computeEmbeddings(p,c,R);if(u.length!==c.length)throw new Error;if(v){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,c,R){const v=this.b.get(p);if(!v)return[];const u=await v.provider.provideEmbeddings(c,R);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$soc=A}),define(Ce[257],Ie([1,0,5,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(C.$YM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const M=this.b++;return this.a.$registerResourceLabelFormatter(M,A),(0,w.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(M)})}}e.$Joc=P}),define(Ce[86],Ie([1,0,21,13,2,3,12,6,27,17]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=e.$5nc=void 0;let R=class{constructor(u,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(M.$YM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$g}getMessage(u,E){const{message:d,args:r,comment:o}=E;if(this.c)return(0,C.$cf)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(u)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,C.$cf)(h??d,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);E=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${r.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:d})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(E)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$5nc=R,e.$5nc=R=He([Ve(0,p.$IP),Ve(1,c.$sP),Ve(2,A.$9j)],R),e.$6nc=(0,O.$Ci)("IExtHostLocalizationService")}),define(Ce[258],Ie([1,0,12,6,27,17,2,49]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;let p=class extends w.$hk{constructor(v,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,M.$_h)(E))),this.r=v.getProxy(C.$YM.MainThreadLogger)}$setLogLevel(v,u){u?this.setLogLevel(A.URI.revive(u),v):this.setLogLevel(v)}setVisibility(v,u){super.setVisibility(v,u),this.r.$setVisibility(v,u)}s(v,u,E){return new c(this.r,v,u,E)}};e.$hpc=p,e.$hpc=p=He([Ve(0,O.$sP),Ve(1,P.$IP)],p);class c extends w.$ck{constructor(v,u,E,d){super(d?.logLevel==="always"),this.r=v,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(v,u){const E=[[v,u]];this.m?this.u(E):this.n.push(...E)}u(v){this.r.$log(this.s,v)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,6,3,5,17,23]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=e.$7nc=void 0,e.$7nc=(0,C.$Ci)("IExtHostManagedSockets");let M=class{constructor(v){this.b=0,this.c=null,this.d=new Map,this.a=v.getProxy(w.$YM.MainThreadManagedSockets)}setFactory(v,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(v,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(v){if(!this.c||this.c.socketFactoryId!==v)throw new Error(`No socket factory with id ${v}`);const u=++this.b,E=await this.c.makeConnection(),d=new P.$Uc;return this.d.set(u,new c(u,E,d)),d.add((0,P.$Tc)(()=>this.d.delete(u))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),d.dispose()})),d.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$Le.wrap(r)))),u}$remoteSocketWrite(v,u){this.d.get(v)?.actual.send(u.buffer)}$remoteSocketEnd(v){const u=this.d.get(v);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(v){await this.d.get(v)?.actual.drain?.()}};e.$8nc=M,e.$8nc=M=He([Ve(0,O.$sP)],M);class p{constructor(v,u){this.socketFactoryId=v,this.makeConnection=u}}class c extends P.$Vc{constructor(v,u,E){super(),this.socketId=v,this.actual=u,this.B(E)}}}),define(Ce[259],Ie([1,0,6,12,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;function O(M){return M&&M.title}let A=class{constructor(p,c){this.b=c,this.a=p.getProxy(w.$YM.MainThreadMessageService)}showMessage(p,c,R,v,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof v=="string"||O(v)?d=[v,...u]:(E.modal=v?.modal,E.useCustom=v?.useCustom,E.detail=v?.detail,d=u),E.useCustom&&(0,P.$2G)(p,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:s}=h;r.push({title:i,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,R,E,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$Loc=A,e.$Loc=A=He([Ve(1,C.$9j)],A)}),define(Ce[260],Ie([1,0,5,15,2,25,6]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class M{constructor(c){this.b=new Map,this.a=c.getProxy(A.$YM.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,R,v){if((0,O.$2G)(c,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,v),this.a.$registerProfileContentHandler(R,v.name,v.description,c.identifier.value),(0,w.$Tc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(c,R,v,u){const E=this.b.get(c);if(!E)throw new Error(`Unknown handler with id: ${c}`);return E.saveProfile(R,v,u)}async $readProfile(c,R,v){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,C.$cg)(R)?R:P.URI.revive(R),v)}}e.$Uoc=M}),define(Ce[88],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0;class O{constructor(M){this.b=new C.$je,this.onDidChangePassword=this.b.event,this.a=M.getProxy(w.$YM.MainThreadSecretState)}async $onDidChangePassword(M){this.b.fire(M)}get(M,p){return this.a.$getPassword(M,p)}store(M,p,c){return this.a.$setPassword(M,p,c)}delete(M,p){return this.a.$deletePassword(M,p)}}e.$2nc=O,e.$3nc=(0,P.$Ci)("IExtHostSecretState")}),define(Ce[261],Ie([1,0,22,5,6]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0;class O{static{this.a=1}constructor(M){this.c=new Map,this.d=new Map,this.f=new Map,this.b=M.getProxy(P.$YM.MainThreadSpeech)}async $createSpeechToTextSession(M,p,c){const R=this.c.get(M);if(!R)return;const v=new C.$Uc,u=new w.$ue;this.d.set(p,u);const E=await R.provideSpeechToTextSession(u.token,c?{language:c}:void 0);E&&(v.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $cancelSpeechToTextSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}async $createTextToSpeechSession(M,p,c){const R=this.c.get(M);if(!R)return;const v=new C.$Uc,u=new w.$ue;this.d.set(p,u);const E=await R.provideTextToSpeechSession(u.token,c?{language:c}:void 0);E&&(this.f.set(p,E),v.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $synthesizeSpeech(M,p){this.f.get(M)?.synthesize(p)}async $cancelTextToSpeechSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M),this.f.delete(M)}async $createKeywordRecognitionSession(M,p){const c=this.c.get(M);if(!c)return;const R=new C.$Uc,v=new w.$ue;this.d.set(p,v);const u=await c.provideKeywordRecognitionSession(v.token);u&&(R.add(u.onDidChange(E=>{v.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(v.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}registerProvider(M,p,c){const R=O.a++;return this.c.set(R,c),this.b.$registerProvider(R,p,{extension:M,displayName:M.value}),(0,C.$Tc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$2oc=O}),define(Ce[89],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=e.$Rnc=void 0;class O{constructor(M,p){this.c=p,this.b=new C.$je,this.onDidChangeStorage=this.b.event,this.a=M.getProxy(w.$YM.MainThreadStorage)}registerExtensionStorageKeysToSync(M,p){this.a.$registerExtensionStorageKeysToSync(M,p)}async initializeExtensionStorage(M,p,c){const R=await this.a.$initializeExtensionStorage(M,p);let v;return R&&(v=this.d(M,p,R)),v||c}setValue(M,p,c){return this.a.$setValue(M,p,c)}$acceptValue(M,p,c){const R=this.d(M,p,c);R&&this.b.fire({shared:M,key:p,value:R})}d(M,p,c){try{return JSON.parse(c)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${M}): ${R}`)}}}e.$Rnc=O,e.$Snc=(0,P.$Ci)("IExtHostStorage")}),define(Ce[262],Ie([1,0,5,16,2,6]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;class A{static{this.a=new Set([C.Schemas.http,C.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$YM.MainThreadUriOpeners)}registerExternalUriOpener(p,c,R,v){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=v.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,R),this.b.$registerUriOpener(c,v.schemes,p,v.label),(0,w.$Tc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener with id: ${p}`);const u=P.URI.revive(c);return v.canOpenExternalUri(u,R)}async $openUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener id: '${p}'`);return v.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},R)}}e.$bpc=A}),define(Ce[263],Ie([1,0,6,2,5,14,19]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class M{static{this.a=0}constructor(c){this.c=new A.$on,this.d=new Map,this.b=c.getProxy(w.$YM.MainThreadUrls)}registerUriHandler(c,R){const v=c.identifier;if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const u=M.a++;return this.c.add(v),this.d.set(u,R),this.b.$registerUriHandler(u,v,c.displayName||c.name),(0,P.$Tc)(()=>{this.c.delete(v),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,R){const v=this.d.get(c);if(!v)return Promise.resolve(void 0);try{v.handleUri(C.URI.revive(R))}catch(u){(0,O.$2)(u)}return Promise.resolve(void 0)}async createAppUri(c){return C.URI.revive(await this.b.$createAppUri(c))}}e.$cpc=M}),define(Ce[264],Ie([1,0,23,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=O,e.$Gsb=M,C=qe(C);class P{constructor(){this.buffers=[]}add(c){let R=this.buffers.indexOf(c);return R<0&&(R=this.buffers.length,this.buffers.push(c)),R}}function O(p,c){if(c.serializeBuffersForPostMessage){const R=new P,u=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=R.buffers.map(d=>{const r=new Uint8Array(d);return w.$Le.wrap(r)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return C.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return C.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return C.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return C.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return C.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return C.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return C.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return C.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return C.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return C.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return C.WebviewMessageArrayBufferViewType.BigUint64Array}}function M(p,c){const R=c.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),v=c.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=R[o];if(r.view)switch(r.view.type){case C.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse(p,v),arrayBuffers:R}}}),define(Ce[68],Ie([1,0,4,5,16,26,2,207,264,83,6]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Cnc=void 0,e.$Dnc=u,e.$Fnc=r,e.$Gnc=o,O=qe(O),R=qe(R);class v{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,n,t,m,f,l,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new w.$je,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$je,this._onDidDispose=this.#h.event,this.#e=s,this.#t=n,this.#o=t,this.#n=m,this.#s=f,this.#r=l,this.#l=u(l),this.#d=E(l),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,c.$iCb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let n=s.toString();return n.endsWith("/")||(n+="/"),n+" "+c.$hCb}return c.$hCb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),O.$do(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const n=(0,p.$Fsb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,n.message,...n.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const n=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,l,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$iCb)(y,{isRemote:n,authority:t}).toString();return`${f}${S}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,l,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$iCb)(y,{isRemote:n,authority:t}).toString();return`${f}${S}${D}`})}}e.$Cnc=v;function u(i){try{const s=(0,M.$Tp)((0,M.$Sp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function E(i){try{const s=(0,M.$Tp)((0,M.$Sp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends C.$Vc{constructor(s,n,t,m,f){super(),this.c=n,this.f=t,this.g=m,this.h=f,this.b=new Map,this.a=s.getProxy(R.$YM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,n,t){const m=this.j(s);if(m){const{message:f}=(0,p.$Gsb)(n,t.value);m._onMessageEmitter.fire(f)}}$onMissingCsp(s,n){this.g.warn(`${n} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,n,t){const m=new v(s,this.a,a(n),this.c,this.f,t,this.h);this.b.set(s,m);const f=m._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return m}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$Enc=d;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,s,n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots||h(i,s)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>A.URI.from(s))}}function h(i,s){return[...(s?.getWorkspaceFolders()||[]).map(n=>n.uri),i.extensionLocation]}}),define(Ce[120],Ie([1,0,4,16,13,2,3,17,6]),function(oe,e,w,C,P,O,A,M,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;let R=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new w.$je,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(p.$YM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let d;if(typeof u=="string"){d=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$af)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,E)}async asExternalUri(u,E){if((0,P.$af)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,E);return O.URI.from(d)}};e.$epc=R,e.$epc=R=c=He([Ve(0,M.$sP)],R),e.$fpc=(0,A.$Ci)("IExtHostWindow")}),define(Ce[265],Ie([1,0,254,27,17]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;let O=class extends w.$ipc{constructor(M,p){super(M,p)}f(M,p,c){p.apply(console,c)}};e.$src=O,e.$src=O=He([Ve(0,P.$sP),Ve(1,C.$IP)],O)}),define(Ce[266],Ie([1,0,11,23,22,28,14,4,5,38,160,252,39]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ibc=h,e.$Jbc=i,A=qe(A);function d(L,T){try{return JSON.stringify(L,T)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(T,q){this.jsonString=T,this.referencedBuffers=q}}function h(L,T=null,q=!1){const G=[];return{jsonString:(q?d:JSON.stringify)(L,(N,V)=>{if(typeof V>"u")return o;if(typeof V=="object"){if(V instanceof C.$Le){const ce=G.push(V)-1;return{[r]:ce}}if(T)return T(N,V)}return V}),referencedBuffers:G}}function i(L,T,q){return JSON.parse(L,(G,W)=>{if(W){const N=W[r];if(typeof N=="number")return T[N];if(q&&W.$mid===c.MarshalledId.Uri)return q.transformIncoming(W)}return W})}function s(L,T){return JSON.stringify(L,T)}function n(L){return L?(T,q)=>q&&q.$mid===c.MarshalledId.Uri?L.transformOutgoing(q):q:null}var t;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var m;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const f=()=>{},l=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class I extends p.$Vc{static{E=l}static{this.a=3*1e3}constructor(T,q=null,G=null){super(),this[E]=!0,this.b=this.B(new M.$je),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=q,this.g=G,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,N=u.$Kw.count;W<N;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=m.Responsive,this.z=0,this.C=0,this.D=this.B(new w.$Oh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const q=this.w[T];delete this.w[T],q.resolveErr(A.$7())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(m.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(m.Unresponsive):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,R.$Jn)(T,this.g):T}getProxy(T){const{nid:q,sid:G}=T;return this.s[q]||(this.s[q]=this.J(q,G)),this.s[q]}J(T,q){const G={get:(W,N)=>(typeof N=="string"&&!W[N]&&N.charCodeAt(0)===O.CharCode.DollarSign&&(W[N]=(...V)=>this.U(T,N,V)),N===$?q:W[N])};return new Proxy(Object.create(null),G)}set(T,q){return this.m[T.nid]=q,q}assertRegistered(T){for(let q=0,G=T.length;q<G;q++){const W=T[q];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(T){if(this.j)return;const q=T.byteLength,G=y.read(T,0),W=G.readUInt8(),N=G.readUInt32();switch(W){case g.RequestJSONArgs:case g.RequestJSONArgsWithCancellation:{let{rpcId:V,method:ce,args:ge}=k.deserializeRequestJSONArgs(G);this.g&&(ge=(0,R.$Jn)(ge,this.g)),this.M(q,N,V,ce,ge,W===g.RequestJSONArgsWithCancellation);break}case g.RequestMixedArgs:case g.RequestMixedArgsWithCancellation:{let{rpcId:V,method:ce,args:ge}=k.deserializeRequestMixedArgs(G);this.g&&(ge=(0,R.$Jn)(ge,this.g)),this.M(q,N,V,ce,ge,W===g.RequestMixedArgsWithCancellation);break}case g.Acknowledged:{this.f?.logIncoming(q,N,t.LocalSide,"ack"),this.G(N);break}case g.Cancel:{this.N(q,N);break}case g.ReplyOKEmpty:{this.O(q,N,void 0);break}case g.ReplyOKJSON:{let V=k.deserializeReplyOKJSON(G);this.g&&(V=(0,R.$Jn)(V,this.g)),this.O(q,N,V);break}case g.ReplyOKJSONWithBuffers:{const V=k.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(q,N,V);break}case g.ReplyOKVSBuffer:{const V=k.deserializeReplyOKVSBuffer(G);this.O(q,N,V);break}case g.ReplyErrError:{let V=k.deserializeReplyErrError(G);this.g&&(V=(0,R.$Jn)(V,this.g)),this.P(q,N,V);break}case g.ReplyErrEmpty:{this.P(q,N,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,q,G,W,N,V){this.f?.logIncoming(T,q,t.OtherSide,`receiveRequest ${(0,u.$Mw)(G)}.${W}(`,N);const ce=String(q);let ge,ie;if(V){const se=new P.$ue;N.push(se.token),ge=this.Q(G,W,N),ie=()=>se.cancel()}else ge=this.Q(G,W,N),ie=f;this.u[ce]=ie;const me=k.serializeAcknowledged(q);this.f?.logOutgoing(me.byteLength,q,t.OtherSide,"ack"),this.c.send(me),ge.then(se=>{delete this.u[ce];const de=k.serializeReplyOK(q,se,this.h);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"reply:",se),this.c.send(de)},se=>{delete this.u[ce];const de=k.serializeReplyErr(q,se);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"replyErr:",se),this.c.send(de)})}N(T,q){this.f?.logIncoming(T,q,t.OtherSide,"receiveCancel");const G=String(q);this.u[G]?.()}O(T,q,G){this.f?.logIncoming(T,q,t.LocalSide,"receiveReply:",G);const W=String(q);if(!this.w.hasOwnProperty(W))return;const N=this.w[W];delete this.w[W],N.resolveOk(G)}P(T,q,G){this.f?.logIncoming(T,q,t.LocalSide,"receiveReplyErr:",G);const W=String(q);if(!this.w.hasOwnProperty(W))return;const N=this.w[W];delete this.w[W];let V;G&&(G.$isError?(V=new Error,V.name=G.name,V.message=G.message,V.stack=G.stack):V=G),N.resolveErr(V)}Q(T,q,G){try{return Promise.resolve(this.S(T,q,G))}catch(W){return Promise.reject(W)}}S(T,q,G){const W=this.m[T];if(!W)throw new Error("Unknown actor "+(0,u.$Mw)(T));const N=W[q];if(typeof N!="function")throw new Error("Unknown method "+q+" on actor "+(0,u.$Mw)(T));return N.apply(W,G)}U(T,q,G){if(this.j)return new v.$Hbc;let W=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$7());const N=k.serializeRequestArguments(G,this.h),V=++this.t,ce=String(V),ge=new v.$Gbc,ie=new p.$Uc;W&&ie.add(W.onCancellationRequested(()=>{const se=k.serializeCancel(V);this.f?.logOutgoing(se.byteLength,V,t.LocalSide,"cancel"),this.c.send(k.serializeCancel(V))})),this.w[ce]=new D(ge,ie),this.F(V);const me=k.serializeRequest(V,T,q,N,!!W);return this.f?.logOutgoing(me.byteLength,V,t.LocalSide,`request: ${(0,u.$Mw)(T)}.${q}(`,G),this.c.send(me),ge}}e.$Kbc=I;class D{constructor(T,q){this.a=T,this.b=q}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class y{static alloc(T,q,G){const W=new y(C.$Le.alloc(G+1+4),0);return W.writeUInt8(T),W.writeUInt32(q),W}static read(T,q){return new y(T,q)}get buffer(){return this.a}constructor(T,q){this.a=T,this.b=q}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+T);return this.b+=T,q}static sizeMixedArray(T){let q=0;q+=1;for(let G=0,W=T.length;G<W;G++){const N=T[G];switch(q+=1,N.type){case b.String:q+=this.sizeLongString(N.value);break;case b.VSBuffer:q+=this.sizeVSBuffer(N.value);break;case b.SerializedObjectWithBuffers:q+=this.sizeUInt32,q+=this.sizeLongString(N.value);for(let V=0;V<N.buffers.length;++V)q+=this.sizeVSBuffer(N.buffers[V]);break;case b.Undefined:break}}return q}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let q=0,G=T.length;q<G;q++){const W=T[q];switch(W.type){case b.String:this.writeUInt8(b.String),this.writeLongString(W.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(W.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let N=0;N<W.buffers.length;++N)this.writeBuffer(W.buffers[N]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const q=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case b.String:q[G]=this.readLongString();break;case b.VSBuffer:q[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const N=this.readUInt32(),V=this.readLongString(),ce=[];for(let ge=0;ge<N;++ge)ce.push(this.readVSBuffer());q[G]=new u.$Nw(i(V,ce,null));break}case b.Undefined:q[G]=void 0;break}return q}}var S;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(S||(S={}));class k{static a(T){for(let q=0,G=T.length;q<G;q++)if(T[q]instanceof C.$Le||T[q]instanceof u.$Nw||typeof T[q]>"u")return!0;return!1}static serializeRequestArguments(T,q){if(this.a(T)){const G=[];for(let W=0,N=T.length;W<N;W++){const V=T[W];if(V instanceof C.$Le)G[W]={type:b.VSBuffer,value:V};else if(typeof V>"u")G[W]={type:b.Undefined};else if(V instanceof u.$Nw){const{jsonString:ce,referencedBuffers:ge}=h(V.value,q);G[W]={type:b.SerializedObjectWithBuffers,value:C.$Le.fromString(ce),buffers:ge}}else G[W]={type:b.String,value:C.$Le.fromString(s(V,q))}}return{type:S.Mixed,args:G}}return{type:S.Simple,args:s(T,q)}}static serializeRequest(T,q,G,W,N){switch(W.type){case S.Simple:return this.b(T,q,G,W.args,N);case S.Mixed:return this.c(T,q,G,W.args,N)}}static b(T,q,G,W,N){const V=C.$Le.fromString(G),ce=C.$Le.fromString(W);let ge=0;ge+=y.sizeUInt8(),ge+=y.sizeShortString(V),ge+=y.sizeLongString(ce);const ie=y.alloc(N?g.RequestJSONArgsWithCancellation:g.RequestJSONArgs,T,ge);return ie.writeUInt8(q),ie.writeShortString(V),ie.writeLongString(ce),ie.buffer}static deserializeRequestJSONArgs(T){const q=T.readUInt8(),G=T.readShortString(),W=T.readLongString();return{rpcId:q,method:G,args:JSON.parse(W)}}static c(T,q,G,W,N){const V=C.$Le.fromString(G);let ce=0;ce+=y.sizeUInt8(),ce+=y.sizeShortString(V),ce+=y.sizeMixedArray(W);const ge=y.alloc(N?g.RequestMixedArgsWithCancellation:g.RequestMixedArgs,T,ce);return ge.writeUInt8(q),ge.writeShortString(V),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(T){const q=T.readUInt8(),G=T.readShortString(),W=T.readMixedArray(),N=new Array(W.length);for(let V=0,ce=W.length;V<ce;V++){const ge=W[V];typeof ge=="string"?N[V]=JSON.parse(ge):N[V]=ge}return{rpcId:q,method:G,args:N}}static serializeAcknowledged(T){return y.alloc(g.Acknowledged,T,0).buffer}static serializeCancel(T){return y.alloc(g.Cancel,T,0).buffer}static serializeReplyOK(T,q,G){if(typeof q>"u")return this.d(T);if(q instanceof C.$Le)return this.e(T,q);if(q instanceof u.$Nw){const{jsonString:W,referencedBuffers:N}=h(q.value,G,!0);return this.g(T,W,N)}else return this.f(T,d(q,G))}static d(T){return y.alloc(g.ReplyOKEmpty,T,0).buffer}static e(T,q){let G=0;G+=y.sizeVSBuffer(q);const W=y.alloc(g.ReplyOKVSBuffer,T,G);return W.writeVSBuffer(q),W.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,q){const G=C.$Le.fromString(q);let W=0;W+=y.sizeLongString(G);const N=y.alloc(g.ReplyOKJSON,T,W);return N.writeLongString(G),N.buffer}static g(T,q,G){const W=C.$Le.fromString(q);let N=0;N+=y.sizeUInt32,N+=y.sizeLongString(W);for(const ce of G)N+=y.sizeVSBuffer(ce);const V=y.alloc(g.ReplyOKJSONWithBuffers,T,N);V.writeUInt32(G.length),V.writeLongString(W);for(const ce of G)V.writeBuffer(ce);return V.buffer}static deserializeReplyOKJSON(T){const q=T.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(T,q){const G=T.readUInt32(),W=T.readLongString(),N=[];for(let V=0;V<G;++V)N.push(T.readVSBuffer());return new u.$Nw(i(W,N,q))}static serializeReplyErr(T,q){const G=q?d(A.$4(q),null):void 0;if(typeof G!="string")return this.h(T);const W=C.$Le.fromString(G);let N=0;N+=y.sizeLongString(W);const V=y.alloc(g.ReplyErrError,T,N);return V.writeLongString(W),V.buffer}static deserializeReplyErrError(T){const q=T.readLongString();return JSON.parse(q)}static h(T){return y.alloc(g.ReplyErrEmpty,T,0).buffer}}var g;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var b;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(b||(b={}))}),define(Ce[267],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0;const w=function(O){const A=M=>{globalThis.removeEventListener("message",A);const p=M.data;Object.defineProperties(globalThis,{postMessage:{value(c,R){p.postMessage(c,R)}},onmessage:{get(){return p.onmessage},set(c){p.onmessage=c}}}),p.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class C extends EventTarget{constructor(O,A,M){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${w})('${A}'))`,c=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(c),v=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:v.port2,url:R,options:M};O(E,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(d){v.port1.onmessage=d}},onmessageerror:{get(){return v.port1.onmessageerror},set(d){v.port1.onmessageerror=d}}}),v.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),v.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),v.port1.start()}}e.$urc=C}),define(Ce[268],Ie([1,0,23,29,16,61,3]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$IK=void 0,e.$JK=R,e.$KK=v,e.$IK=(0,A.$Ci)("notebookDocumentService");const M=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${M.join("")}]+`),c=7;function R(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const r=parseInt(E.fragment.substring(0,d).replace(p,""),c),o=(0,w.$5e)(E.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:o,fragment:null})}}function v(E,d){const r=d.toString(c),a=`${r.length<M.length?M[r.length-1]:"z"}${r}s${(0,w.$6e)(w.$Le.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class u{constructor(){this.a=new C.$Bc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=R(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$LK=u,(0,O.$Is)(e.$IK,u,O.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,268]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.$3K=e.CellStatusbarAlignment=e.$2K=e.NotebookEditorPriority=e.$YK=e.$XK=e.$VK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$UK=e.$TK=e.$SK=e.$RK=e.CellKind=e.$QK=e.$PK=e.$OK=void 0,e.$WK=m,e.$ZK=l,e.$1K=$,e.$4K=y,e.$5K=k,C=qe(C),e.$OK="workbench.editor.notebook",e.$PK="workbench.editor.notebookTextDiffEditor",e.$QK="workbench.editor.interactive";var v;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(v||(e.CellKind=v={})),e.$RK=["application/json","application/javascript","text/html","image/svg+xml",O.$2s.latex,O.$2s.markdown,"image/png","image/jpeg",O.$2s.text],e.$SK=[O.$2s.latex,O.$2s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$2s.text],e.$TK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$UK="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(V){V.scheme=A.Schemas.vscodeNotebookCell;function ce(be,re){return(0,R.$KK)(be,re)}V.generate=ce;function ge(be){return(0,R.$JK)(be)}V.parse=ge;function ie(be,re){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}V.generateCellOutputUri=ie;function me(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Le=re[2];return{outputId:Pe,notebook:be.with({scheme:Le||A.Schemas.file,fragment:null})}}V.parseCellOutputUri=me;function se(be,re,Pe){return V.generate(be,re).with({scheme:Pe})}V.generateCellPropertyUri=se;function de(be,re){if(be.scheme===re)return V.parse(be.with({scheme:V.scheme}))}V.parseCellPropertyUri=de})(s||(e.CellUri=s={}));const n=V=>p.$i?V.replace(/\//g,"\\"):V;class t{constructor(ce=[],ge=e.$RK){this.e=ge,this.d=[...new Set(ce)].map(ie=>({pattern:ie,matches:C.$wk(n(ie))}))}sort(ce){const ge=new Map(P.Iterable.map(ce,me=>[me,n(me)]));let ie=[];for(const{matches:me}of this.d)for(const[se,de]of ge)if(me(de)){ie.push(se),ge.delete(se);break}return ge.size&&(ie=ie.concat([...ge.keys()].sort((me,se)=>this.e.indexOf(me)-this.e.indexOf(se)))),ie}prioritize(ce,ge){const ie=this.f(ce);if(ie===-1){this.d.unshift({pattern:ce,matches:C.$wk(n(ce))});return}const me=new Set(ge.map(de=>this.f(de,ie)));me.delete(-1);const se=Array.from(me).sort();this.d.splice(ie+1,0,...se.map(de=>this.d[de]));for(let de=se.length-1;de>=0;de--)this.d.splice(se[de],1)}toArray(){return this.d.map(ce=>ce.pattern)}f(ce,ge=this.d.length){const ie=n(ce);for(let me=0;me<ge;me++)if(this.d[me].matches(ie))return me;return-1}}e.$VK=t;function m(V,ce,ge,ie=(me,se)=>me===se){const me=[];function se(re,Pe,Le){if(Pe===0&&Le.length===0)return;const Y=me[me.length-1];Y&&Y.start+Y.deleteCount===re?(Y.deleteCount+=Pe,Y.toInsert.push(...Le)):me.push({start:re,deleteCount:Pe,toInsert:Le})}let de=0,be=0;for(;;){if(de===V.length){se(de,0,ce.slice(be));break}if(be===ce.length){se(de,V.length-de,[]);break}const re=V[de],Pe=ce[be];if(ie(re,Pe)){de+=1,be+=1;continue}ge(Pe)?(se(de,1,[]),de+=1):(se(de,0,[Pe]),be+=1)}return me}e.$XK=new c.$Tj("notebookEditorCursorAtBoundary","none"),e.$YK=new c.$Tj("notebookEditorCursorAtLineBoundary","none");var f;(function(V){V.default="default",V.option="option"})(f||(e.NotebookEditorPriority=f={}));function l(V){const ce=V;return!!((typeof ce.include=="string"||C.$xk(ce.include))&&(typeof ce.exclude=="string"||C.$xk(ce.exclude)))}function $(V,ce,ge){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ce)>=0||V.viewType===ce)return!0;if(V.filenamePattern){const ie=l(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,me=l(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(C.$vk(ie,(0,M.$oc)(ge.fsPath).toLowerCase()))return!(me&&C.$vk(me,(0,M.$oc)(ge.fsPath).toLowerCase()))}return!1}e.$2K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(ce){return`${D.d}${ce}`}static parse(ce){if(ce.startsWith(D.d))return ce.substring(D.d.length)}}e.$3K=D;function y(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const S=new TextDecoder;function k(V){const ce=[];let ge=!1;for(const de of V)(ce.length===0||ge)&&(ce.push(de),ge=!0);let ie=L(ce);const me=w.$Le.concat(ce.map(de=>w.$Le.wrap(de))),se=N(me);return ie=ie||se.byteLength!==me.byteLength,{data:se,didCompression:ie}}e.$6K="\x1B[A";const g=e.$6K.split("").map(V=>V.charCodeAt(0)),b=10;function L(V){let ce=!1;return V.forEach((ge,ie)=>{if(ie===0||ge.length<e.$6K.length)return;const me=V[ie-1],se=ge.subarray(0,e.$6K.length);if(se[0]===g[0]&&se[1]===g[1]&&se[2]===g[2]){const de=me.lastIndexOf(b);if(de===-1)return;ce=!0,V[ie-1]=me.subarray(0,de),V[ie]=ge.subarray(e.$6K.length)}}),ce}function T(V){let ce=V;do V=ce,ce=V.replace(/[^\n]\x08/gm,"");while(ce.length<V.length);return V}function q(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ce=V.match(/^(.*)\r+/m)[1];let ge=V.match(/\r+(.*)$/m)[1];ge=ge+ce.slice(ge.length,ce.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ge)}return V}const G=8,W=13;function N(V){return!V.buffer.includes(G)&&!V.buffer.includes(W)?V:w.$Le.fromString(q(T(S.decode(V.buffer))))}}),define(Ce[7],Ie([1,0,18,14,60,29,73,13,15,2,37,19,30,109,90]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d){"use strict";var r,o,a,h,i,s,n,t,m,f,l,$,I,D,y,S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$hP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.LanguageModelChatMessageRole=e.ChatLocation=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$WO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$JO=e.$IO=e.$HO=e.$GO=e.$EO=e.$DO=e.$CO=e.$BO=e.TestRunProfileKind=e.TestResultState=e.$AO=e.$zO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$yO=e.NotebookVariablesRequestKind=e.$xO=e.$wO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$vO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.ColorThemeKind=e.$pO=e.$oO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$nO=e.$mO=e.DebugConsoleMode=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$gO=e.$fO=e.FileChangeType=e.$eO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$dO=e.$cO=e.$bO=e.$aO=e.InlineCompletionTriggerKind=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$ZN=e.ConfigurationTarget=e.$YN=e.$XN=e.$WN=e.$VN=e.DocumentPasteTriggerKind=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$ON=e.ViewBadge=e.ProgressLocation=e.$NN=e.$MN=e.TaskScope=e.ShellQuoting=e.$LN=e.$KN=e.$JN=e.TaskPanelKind=e.TaskRevealKind=e.$IN=e.TerminalLocation=e.$HN=e.$GN=e.$FN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$EN=e.$DN=e.$CN=e.$BN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$zN=e.$yN=e.$xN=e.$wN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$vN=e.$uN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.LanguageStatusSeverity=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.CodeActionTriggerKind=e.$iN=e.$hN=e.SymbolTag=e.SymbolKind=e.$gN=e.$fN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.DiagnosticSeverity=e.DiagnosticTag=e.$_M=e.$$M=e.FileEditType=e.$0M=e.$9M=e.$8M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$AN=Ze,e.$1N=Oi,e.$FO=Sn;function g(U){return Object.assign(U,{apply:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const Se=te.length===1?[]:te[1];return Reflect.construct(U,Se,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(U,[]);{const[Se,...Je]=te;return Reflect.construct(U,Je,Se.constructor)}}})}var b;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var L;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let T=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$1M=T,e.$1M=T=r=He([g],T);let q=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const Je=F[Se];Je.isBefore(te)&&(te=Je)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let Se=1;Se<F.length;Se++){const Je=F[Se];Je.isAfter(te)&&(te=Je)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:Se}=F;return typeof te=="number"&&typeof Se=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,C.$8)("line must be non-negative");if(te<0)throw(0,C.$8)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,C.$8)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&te===0?this:new o(this.line+Se,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,C.$8)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),Se===this.line&&te===this.character?this:new o(Se,te)}toJSON(){return{line:this.line,character:this.character}}};e.$2M=q,e.$2M=q=o=He([g],q);let G=a=class{static isRange(F){return F instanceof a?!0:F?q.isPosition(F.start)&&q.isPosition(F.end):!1}static of(F){if(F instanceof a)return F;if(this.isRange(F))return new a(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,Se,Je){let et,ft;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new q(F,te),ft=new q(Se,Je)):q.isPosition(F)&&q.isPosition(te)&&(et=q.of(F),ft=q.of(te)),!et||!ft)throw new Error("Invalid arguments");et.isBefore(ft)?(this.c=et,this.e=ft):(this.c=ft,this.e=et)}contains(F){return a.isRange(F)?this.contains(F.start)&&this.contains(F.end):q.isPosition(F)?!(q.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=q.Max(F.start,this.c),Se=q.Min(F.end,this.e);if(!te.isAfter(Se))return new a(te,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=q.Min(F.start,this.c),Se=q.Max(F.end,this.end);return new a(te,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,C.$8)();let Se;return F?q.isPosition(F)?Se=F:(Se=F.start||this.start,te=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&te.isEqual(this.end)?this:new a(Se,te)}toJSON(){return[this.start,this.end]}};e.$3M=G,e.$3M=G=a=He([g],G);let W=h=class extends G{static isSelection(F){return F instanceof h?!0:F?G.isRange(F)&&q.isPosition(F.anchor)&&q.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,Se,Je){let et,ft;if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"?(et=new q(F,te),ft=new q(Se,Je)):q.isPosition(F)&&q.isPosition(te)&&(et=q.of(F),ft=q.of(te)),!et||!ft)throw new Error("Invalid arguments");super(et,ft),this.f=et,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$4M=W,e.$4M=W=h=He([g],W);const N=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,C.$8)("connectionToken")};class V{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,Se){if(typeof F!="string"||F.length===0)throw(0,C.$8)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.$8)("port");typeof Se<"u"&&N(Se),this.host=F,this.port=Math.round(te),this.connectionToken=Se}}e.$5M=V;class ce{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&N(te)}}e.$6M=ce;class ge extends Error{static NotAvailable(F,te){return new ge(F,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ge(F,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=te,this._detail=Se,Object.setPrototypeOf(this,ge.prototype)}}e.$7M=ge;var ie;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ie||(e.EndOfLine=ie={}));var me;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let se=i=class{static isTextEdit(F){return F instanceof i?!0:F?G.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new G(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new G(new q(0,0),new q(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!G.isRange(F))throw(0,C.$8)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,C.$8)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,C.$8)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$8M=se,e.$8M=se=i=He([g],se);let de=s=class{static isNotebookCellEdit(F){return F instanceof s?!0:F?yi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new s(F,te)}static insertCells(F,te){return new s(new yi(F,F),te)}static deleteCells(F){return new s(F,[])}static updateCellMetadata(F,te){const Se=new s(new yi(F,F),[]);return Se.newCellMetadata=te,Se}static updateNotebookMetadata(F){const te=new s(new yi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$9M=de,e.$9M=de=s=He([g],de);class be{static isSnippetTextEdit(F){return F instanceof be?!0:F?G.isRange(F.range)&&Le.isSnippetString(F.snippet):!1}static replace(F,te){return new be(F,te)}static insert(F,te){return be.replace(new G(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$0M=be;var re;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,Se,Je){this.c.push({_type:re.File,from:F,to:te,options:Se,metadata:Je})}createFile(F,te,Se){this.c.push({_type:re.File,from:void 0,to:F,options:te,metadata:Se})}deleteFile(F,te,Se){this.c.push({_type:re.File,from:F,to:void 0,options:te,metadata:Se})}e(F,te,Se){this.c.push({_type:re.Cell,metadata:Se,uri:F,edit:{editType:d.CellEditType.DocumentMetadata,metadata:te},notebookMetadata:te})}f(F,te,Se,Je){const et=te.start,ft=te.end;(et!==ft||Se.length>0)&&this.c.push({_type:re.CellReplace,uri:F,index:et,count:ft-et,cells:Se,metadata:Je})}g(F,te,Se,Je){this.c.push({_type:re.Cell,metadata:Je,uri:F,edit:{editType:d.CellEditType.Metadata,index:te,metadata:Se}})}replace(F,te,Se,Je){this.c.push({_type:re.Text,uri:F,edit:new se(te,Se),metadata:Je})}insert(F,te,Se,Je){this.replace(F,new G(te,te),Se,Je)}delete(F,te,Se){this.replace(F,te,"",Se)}has(F){return this.c.some(te=>te._type===re.Text&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const Se of te){if(!Se)continue;let Je,et;Array.isArray(Se)?(Je=Se[0],et=Se[1]):Je=Se,de.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(F,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(F,Je.newNotebookMetadata,et):this.f(F,Je.range,Je.newCells,et):be.isSnippetTextEdit(Je)?this.c.push({_type:re.Snippet,uri:F,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:re.Text,uri:F,edit:Je,metadata:et})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Je.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,w.$Jb)(this.c)}}get(F){const te=[];for(const Se of this.c)Se._type===re.Text&&Se.uri.toString()===F.toString()&&te.push(Se.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===re.Text){let Se=F.get(te.uri);Se||(Se=[te.uri,[]],F.set(te.uri,Se)),Se[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$$M=Pe,e.$$M=Pe=He([g],Pe);let Le=n=class{static isSnippetString(F){return F instanceof n?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=n.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const Se=new n;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=n.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const Se=F.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const Se=new n;Se.e=this.e,te(Se),this.e=Se.e,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$_M=Le,e.$_M=Le=n=He([g],Le);var Y;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var B;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(B||(e.DiagnosticSeverity=B={}));let _=t=class{static isLocation(F){return F instanceof t?!0:F?G.isRange(F.range)&&c.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(G.isRange(te))this.range=G.of(te);else if(q.isPosition(te))this.range=new G(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$aN=_,e.$aN=_=t=He([g],_);let we=class{static is(F){return F?typeof F.message=="string"&&F.location&&G.isRange(F.location.range)&&c.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$bN=we,e.$bN=we=He([g],we);let ae=class{constructor(F,te,Se=B.Error){if(!G.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=Se}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,w.$vb)(F.tags,te.tags)&&(0,w.$vb)(F.relatedInformation,te.relatedInformation,we.isEqual)}};e.$cN=ae,e.$cN=ae=He([g],ae);let ve=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$dN=ve,e.$dN=ve=He([g],ve);let le=class extends ve{constructor(F,te,Se,Je){super(F,te),this.canIncreaseHover=Se,this.canDecreaseHover=Je}};e.$eN=le,e.$eN=le=He([g],le);var X;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var Z;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Z||(e.DocumentHighlightKind=Z={}));let pe=class{constructor(F,te=Z.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:Z[this.kind]}}};e.$fN=pe,e.$fN=pe=He([g],pe);let $e=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$gN=$e,e.$gN=$e=He([g],$e);var Me;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Me||(e.SymbolKind=Me={}));var je;(function(U){U[U.Deprecated=1]="Deprecated"})(je||(e.SymbolTag=je={}));let ke=m=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,Se,Je,et){this.name=F,this.kind=te,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),Je instanceof _?this.location=Je:Se instanceof G&&(this.location=new _(Je,Se)),m.validate(this)}toJSON(){return{name:this.name,kind:Me[this.kind],location:this.location,containerName:this.containerName}}};e.$hN=ke,e.$hN=ke=m=He([g],ke);let Re=f=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(f.validate)}constructor(F,te,Se,Je,et){this.name=F,this.detail=te,this.kind=Se,this.range=Je,this.selectionRange=et,this.children=[],f.validate(this)}};e.$iN=Re,e.$iN=Re=f=He([g],Re);var Oe;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let z=class{constructor(F,te){this.title=F,this.kind=te}};e.$jN=z,e.$jN=z=He([g],z);let j=class{static{l=this}static{this.c="."}constructor(F){this.value=F}append(F){return new l(this.value?this.value+l.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+l.c)}};e.$kN=j,e.$kN=j=l=He([g],j),j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorMove=j.Refactor.append("move"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll"),j.Notebook=j.Empty.append("notebook");let K=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$lN=K,e.$lN=K=He([g],K);class J{constructor(F,te,Se,Je,et,ft){this.kind=F,this.name=te,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ft}}e.$mN=J;class ne{constructor(F,te){this.fromRanges=te,this.from=F}}e.$nN=ne;class fe{constructor(F,te){this.fromRanges=te,this.to=F}}e.$oN=fe;var Ae;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let ze=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$pN=ze,e.$pN=ze=He([g],ze);let Ke=$=class{#e;static isMarkdownString(F){return F instanceof $?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new P.$Zk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$qN=Ke,e.$qN=Ke=$=He([g],Ke);let _e=class{constructor(F,te){this.label=F,this.documentation=te}};e.$rN=_e,e.$rN=_e=He([g],_e);let it=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$sN=it,e.$sN=it=He([g],it);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$tN=nt,e.$tN=nt=He([g],nt);var tt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let $t=class{constructor(F){this.value=F}};e.$uN=$t,e.$uN=$t=He([g],$t);let lt=class{constructor(F,te,Se){this.position=F,this.label=te,this.kind=Se}};e.$vN=lt,e.$vN=lt=He([g],lt);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var gt;(function(U){U[U.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let mt=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$wN=mt,e.$wN=mt=He([g],mt);let Be=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$xN=Be,e.$xN=Be=He([g],Be);let Ue=class{constructor(F,te,Se){this.insertText=F,this.range=te,this.command=Se}};e.$yN=Ue,e.$yN=Ue=He([g],Ue);let H=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$zN=H,e.$zN=H=He([g],H);var x;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var De;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Xe;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function Ze(U,F){return`${v.$nn.toKey(U)}.${F}`}var dt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(dt||(e.TextEditorLineNumbersStyle=dt={}));var pt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var Lt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Lt||(e.TextEditorRevealType=Lt={}));var zt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var xt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var li;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(li||(e.DecorationRangeBehavior=li={})),function(U){function F(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(zt||(e.TextEditorSelectionChangeKind=zt={}));var xe;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(U){function F(te){switch(te){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(xe||(e.SyntaxTokenType=xe={}));let It=class{constructor(F,te){if(te&&!c.URI.isUri(te))throw(0,C.$8)("target");if(!G.isRange(F)||F.isEmpty)throw(0,C.$8)("range");this.range=F,this.target=te}};e.$BN=It,e.$BN=It=He([g],It);let Gt=class{constructor(F,te,Se,Je){this.red=F,this.green=te,this.blue=Se,this.alpha=Je}};e.$CN=Gt,e.$CN=Gt=He([g],Gt);let ht=class{constructor(F,te){if(te&&!(te instanceof Gt))throw(0,C.$8)("color");if(!G.isRange(F)||F.isEmpty)throw(0,C.$8)("range");this.range=F,this.color=te}};e.$DN=ht,e.$DN=ht=He([g],ht);let bt=class{constructor(F){if(!F||typeof F!="string")throw(0,C.$8)("label");this.label=F}};e.$EN=bt,e.$EN=bt=He([g],bt);var hi;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var _t;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var Ut;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Ut||(e.TerminalExitReason=Ut={}));var wt;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Bt{constructor(F,te,Se){if(this.startIndex=F,this.length=te,this.tooltip=Se,typeof F!="number"||F<0)throw(0,C.$8)("startIndex");if(typeof te!="number"||te<1)throw(0,C.$8)("length");if(Se!==void 0&&typeof Se!="string")throw(0,C.$8)("tooltip")}}e.$FN=Bt;class Jt{constructor(F){this.uri=F}}e.$GN=Jt;class Qt{constructor(F){this.terminalCommand=F}}e.$HN=Qt;var Qe;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class pi{constructor(F){if(this.options=F,typeof F!="object")throw(0,C.$8)("options")}}e.$IN=pi;var ei;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ei||(e.TaskRevealKind=ei={}));var si;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(si||(e.TaskPanelKind=si={}));let St=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(F){switch(F){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,C.$8)("name");this.c=F}get id(){return this.c}};e.$JN=St,e.$JN=St=I=He([g],St);function Kt(U){let F="";for(let te=0;te<U.length;te++)F+=U[te].replace(/,/g,",,")+",";return F}let At=class{constructor(F,te,Se){if(typeof F!="string")throw(0,C.$8)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Se):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,C.$8)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return Kt(F)}};e.$KN=At,e.$KN=At=He([g],At);let Nt=class{constructor(F,te,Se){if(this.f=[],Array.isArray(te)){if(!F)throw(0,C.$8)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,C.$8)("command");this.e=F,this.f=te,this.g=Se}else{if(typeof F!="string")throw(0,C.$8)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,C.$8)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,C.$8)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return Kt(F)}};e.$LN=Nt,e.$LN=Nt=He([g],Nt);var ti;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ii;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(ii||(e.TaskScope=ii={}));class oi{constructor(F){this.c=F}computeId(){return"customExecution"+(0,R.$Yg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$MN=oi;let Wt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,Se,Je,et,ft){this.k=!1,this.l=this.definition=F;let yt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Se,this.execution=Je,yt=et,this.k=!0):te===ii.Global||te===ii.Workspace?(this.target=te,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,yt=ft):(this.target=te,this.o=this.name=Se,this.w=this.source=Je,this.execution=et,yt=ft),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$Yg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,C.$8)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,C.$8)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(D.g===te||D.e===te||D.f===te||D.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,C.$8)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$NN=Wt,e.$NN=Wt=D=He([g],Wt);var Ht;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Ht||(e.ProgressLocation=Ht={}));var di;(function(U){function F(te){const Se=te;return(0,p.$gg)(Se.value)?Se.tooltip&&!(0,p.$cg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=F})(di||(e.ViewBadge=di={}));let Ft=y=class{static isTreeItem(F,te){const Se=F;if(Se.checkboxState!==void 0){const Je=(0,p.$gg)(Se.checkboxState)?Se.checkboxState:(0,p.$eg)(Se.checkboxState)&&(0,p.$gg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,et=!(0,p.$gg)(Se.checkboxState)&&(0,p.$eg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ct.Checked&&Je!==Ct.Unchecked||et!==void 0&&!(0,p.$cg)(et))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof y)return!0;if(Se.label!==void 0&&!(0,p.$cg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$cg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$cg)(Se.iconPath)&&!c.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$cg)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,p.$cg)(Je.light)&&!c.URI.isUri(Je.light)&&!(0,p.$cg)(Je.dark)&&!c.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$cg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!c.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$cg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$cg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,te=vt.None){this.collapsibleState=te,c.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$ON=Ft,e.$ON=Ft=y=He([g],Ft);var vt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Ct;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let Tt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$PN=Tt,e.$PN=Tt=He([g],Tt);class kt extends Tt{}e.$QN=kt;class Xt extends kt{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$RN=Xt;class qt{constructor(F,te,Se,Je){this.name=F,this.uri=te,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$SN=qt;let $i=class{#e=new Map;constructor(F){for(const[te,Se]of F??[]){const Je=this.#e.get(this.#t(te));Je?Je.push(Se):this.#e.set(this.#t(te),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[Se,Je]of this.#e)for(const et of Je)F.call(te,et,Se,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const Se of te)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$TN=$i,e.$TN=$i=He([g],$i);let fi=class{constructor(F,te,Se){this.insertText=F,this.title=te,this.kind=Se}};e.$UN=fi,e.$UN=fi=He([g],fi);var Ri;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Mt{static{this.c="."}constructor(F){this.value=F}append(...F){return new Mt((this.value?[this.value,...F]:F).join(Mt.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Mt.c)}}e.$VN=Mt,Mt.Empty=new Mt("");class Ti{constructor(F,te,Se){this.title=te,this.insertText=F,this.kind=Se}}e.$WN=Ti;let ai=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$XN=ai,e.$XN=ai=He([g],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(F){this.id=F}};e.$YN=Rt,e.$YN=Rt=He([g],Rt);var Di;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let Si=class{get base(){return this.c}set base(F){this.c=F,this.e=c.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!c.URI.isUri(F)&&!c.URI.isUri(F.uri)))throw(0,C.$8)("base");if(typeof te!="string")throw(0,C.$8)("pattern");typeof F=="string"?this.baseUri=c.URI.file(F):c.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$ZN=Si,e.$ZN=Si=He([g],Si);const vi=new WeakMap;function Oi(U,F){vi.set(U,F)}let gi=class{constructor(F,te,Se,Je,et){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=vi.get(this)??(0,R.$Yg)()),this.c}};e.$2N=gi,e.$2N=gi=He([g],gi);let Vt=class extends gi{constructor(F,te,Se,Je,et,ft){if(super(te,Se,Je,et,ft),F===null)throw(0,C.$8)("location");this.location=F}};e.$3N=Vt,e.$3N=Vt=He([g],Vt);let ye=class extends gi{constructor(F,te,Se,Je,et,ft){super(te,Se,Je,et,ft),this.functionName=F}};e.$4N=ye,e.$4N=ye=He([g],ye);let Te=class extends gi{constructor(F,te,Se,Je,et,ft,yt,Zt){if(super(Je,et,ft,yt,Zt),!te)throw(0,C.$8)("dataId");this.label=F,this.dataId=te,this.canPersist=Se}};e.$5N=Te,e.$5N=Te=He([g],Te);let ue=class{constructor(F,te,Se){this.command=F,this.args=te||[],this.options=Se}};e.$6N=ue,e.$6N=ue=He([g],ue);let Q=class{constructor(F,te){this.port=F,this.host=te}};e.$7N=Q,e.$7N=Q=He([g],Q);let Ee=class{constructor(F){this.path=F}};e.$8N=Ee,e.$8N=Ee=He([g],Ee);let We=class{constructor(F){this.implementation=F}};e.$9N=We,e.$9N=We=He([g],We);class Ye{constructor(F,te,Se){this.session=F,this.threadId=te,this.frameId=Se}}e.$0N=Ye;class Ge{constructor(F,te){this.session=F,this.threadId=te}}e.$$N=Ge;let ut=class{constructor(F,te){this.range=F,this.expression=te}};e.$_N=ut,e.$_N=ut=He([g],ut);var Pt;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Yt=class{constructor(F,te){this.range=F,this.text=te}};e.$aO=Yt,e.$aO=Yt=He([g],Yt);let ci=class{constructor(F,te,Se=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=Se}};e.$bO=ci,e.$bO=ci=He([g],ci);let jt=class{constructor(F,te){this.range=F,this.expression=te}};e.$cO=jt,e.$cO=jt=He([g],jt);let ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$dO=ni,e.$dO=ni=He([g],ni);var Ui;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Ui||(e.NewSymbolNameTag=Ui={}));var Zi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Zi||(e.NewSymbolNameTriggerKind=Zi={}));class Bi{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$eO=Bi;var Ni;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ni||(e.FileChangeType=Ni={}));let Wi=S=class extends Error{static FileExists(F){return new S(F,u.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(F){return new S(F,u.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(F){return new S(F,u.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(F){return new S(F,u.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(F){return new S(F,u.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(F){return new S(F,u.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}constructor(F,te=u.FileSystemProviderErrorCode.Unknown,Se){super(c.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,u.$ll)(this,te),Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$fO=Wi,e.$fO=Wi=S=He([g],Wi);let Vi=class{constructor(F,te,Se){this.start=F,this.end=te,this.kind=Se}};e.$gO=Vi,e.$gO=Vi=He([g],Vi);var ki;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Li;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var en;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class pn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$hO=pn;function tn(U){return typeof U>"u"||(0,p.$dg)(U)}class Gi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,Se=F.tokenTypes.length;te<Se;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,Se=F.tokenModifiers.length;te<Se;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,Se,Je,et){if(typeof F=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(F,te,Se,Je,et);if(G.isRange(F)&&typeof te=="string"&&tn(Se))return this.o(F,te,Se);throw(0,C.$8)()}o(F,te,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Je=F.start.line,et=F.start.character,ft=F.end.character-F.start.character,yt=this.k.get(te);let Zt=0;if(Se)for(const mi of Se){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);Zt|=1<<wi>>>0}this.q(Je,et,ft,yt,Zt)}q(F,te,Se,Je,et){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Zt=this.g.length/5|0;let mi=0,wi=0;for(let Ei=0;Ei<Zt;Ei++){let Pi=this.g[5*Ei],Xi=this.g[5*Ei+1];Pi===0?(Pi=mi,Xi+=wi):Pi+=mi,this.g[5*Ei]=Pi,this.g[5*Ei+1]=Xi,mi=Pi,wi=Xi}}let ft=F,yt=te;this.f&&this.j>0&&(ft-=this.c,ft===0&&(yt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=et,this.c=F,this.e=te}static r(F){const te=[],Se=F.length/5|0;for(let yt=0;yt<Se;yt++)te[yt]=yt;te.sort((yt,Zt)=>{const mi=F[5*yt],wi=F[5*Zt];if(mi===wi){const Ei=F[5*yt+1],Pi=F[5*Zt+1];return Ei-Pi}return mi-wi});const Je=new Uint32Array(F.length);let et=0,ft=0;for(let yt=0;yt<Se;yt++){const Zt=5*te[yt],mi=F[Zt+0],wi=F[Zt+1],Ei=F[Zt+2],Pi=F[Zt+3],Xi=F[Zt+4],Un=mi-et,kr=Un===0?wi-ft:wi,Yi=5*yt;Je[Yi+0]=Un,Je[Yi+1]=kr,Je[Yi+2]=Ei,Je[Yi+3]=Pi,Je[Yi+4]=Xi,et=mi,ft=wi}return Je}build(F){return this.f?new Ci(new Uint32Array(this.g),F):new Ci(Gi.r(this.g),F)}}e.$iO=Gi;class Ci{constructor(F,te){this.resultId=te,this.data=F}}e.$jO=Ci;class $n{constructor(F,te,Se){this.start=F,this.deleteCount=te,this.data=Se}}e.$kO=$n;class bn{constructor(F,te){this.resultId=te,this.edits=F}}e.$lO=bn;var nn;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Ki{constructor(F){this.name=F}}e.$mO=Ki;let Fi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$nO=Fi,e.$nO=Fi=He([g],Fi);var Fe;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Fe||(e.QuickPickItemKind=Fe={}));var bi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Hi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class ot{static validate(F){if(typeof F.badge=="string"){let te=(0,M.$Nf)(F.badge,0);if(te<F.badge.length&&(te+=(0,M.$Nf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ai.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,Se){this.badge=F,this.tooltip=te,this.color=Se}}e.$oO=ot;let Et=class{constructor(F){this.kind=F}};e.$pO=Et,e.$pO=Et=He([g],Et);var rn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class yi{static isNotebookRange(F){return F instanceof yi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,C.$8)("start must be positive");if(te<0)throw(0,C.$8)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,Se=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(Se=F.end),te===this.c&&Se===this.e?this:new yi(te,Se)}}e.$qO=yi;class Mi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>Mi.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,Se,Je,et,ft,yt){this.kind=F,this.value=te,this.languageId=Se,this.mime=Je,this.outputs=et??[],this.metadata=ft,this.executionSummary=yt,Mi.validate(this)}}e.$rO=Mi;class wn{constructor(F){this.cells=F}}e.$sO=wn;class ui{static isNotebookCellOutputItem(F){return F instanceof ui?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ui.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ui.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ui.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ui(F,te)}static#e=new TextEncoder;static text(F,te=A.$2s.text){const Se=ui.#e.encode(String(F));return new ui(Se,te)}static json(F,te="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return ui.text(Se,te)}constructor(F,te){this.data=F,this.mime=te;const Se=(0,A.$6s)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$tO=ui;class ji{static isNotebookCellOutput(F){return F instanceof ji?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const Se=new Set,Je=new Set;for(let et=0;et<F.length;et++){const ft=F[et],yt=(0,A.$6s)(ft.mime);if(!Se.has(yt)||(0,d.$4K)(yt)){Se.add(yt);continue}Je.add(et),te&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return Je.size===0?F:F.filter((et,ft)=>!Je.has(ft))}constructor(F,te,Se){this.items=ji.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,R.$Yg)(),this.metadata=te??Se)}}e.$uO=ji;var sn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ji;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var an;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(F,te){this.text=F,this.alignment=te}}e.$vO=vn;var cn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class yn{constructor(F,te=[]){this.uri=F,this.provides=(0,w.$3b)(te)}}e.$wO=yn;class En{constructor(F){this.label=F}}e.$xO=En;var ln;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Qi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$yO=Qi,e.$yO=Qi=He([g],Qi);var hn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ee{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$zO=ee;class he{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$AO=he;var Ne;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Ne||(e.TestResultState=Ne={}));var at;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let Dt=class{constructor(F=void 0,te=void 0,Se=void 0,Je=!1,et=!0){this.include=F,this.exclude=te,this.profile=Se,this.continuous=Je,this.preserveFocus=et}};e.$BO=Dt,e.$BO=Dt=He([g],Dt);let Ot=k=class{static diff(F,te,Se){const Je=new k(F);return Je.expectedOutput=te,Je.actualOutput=Se,Je}constructor(F){this.message=F}};e.$CO=Ot,e.$CO=Ot=k=He([g],Ot);let Ii=class{constructor(F){this.id=F}};e.$DO=Ii,e.$DO=Ii=He([g],Ii);class zi{constructor(F,te){this.covered=F,this.total=te,Sn(this)}}e.$EO=zi;function Sn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Dn{static fromDetails(F,te){const Se=new zi(0,0),Je=new zi(0,0),et=new zi(0,0);for(const yt of te)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const Zt of yt.branches)Je.total+=1,Je.covered+=Zt.executed?1:0}else et.total+=1,et.covered+=yt.executed?1:0;const ft=new Dn(F,Se,Je.total>0?Je:void 0,et.total>0?et:void 0);return ft.detailedCoverage=te,ft}constructor(F,te,Se,Je,et){this.uri=F,this.statementCoverage=te,this.branchCoverage=Se,this.declarationCoverage=Je,this.testItem=et}}e.$GO=Dn;class Vn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se=[]){this.executed=F,this.location=te,this.branches=Se}}e.$HO=Vn;class qn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.executed=F,this.location=te,this.label=Se}}e.$IO=qn;class Gn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,Se){this.name=F,this.executed=te,this.location=Se}}e.$JO=Gn;var kn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(F,te,Se,Je,et,ft){this.kind=F,this.name=te,this.detail=Se,this.uri=Je,this.range=et,this.selectionRange=ft}}e.$KO=Kn;class Hn{constructor(F){this.uri=F}}e.$LO=Hn;class Jn{constructor(F,te){this.original=F,this.modified=te}}e.$MO=Jn;class Qn{constructor(F,te,Se,Je){this.base=F,this.input1=te,this.input2=Se,this.result=Je}}e.$NO=Qn;class Xn{constructor(F,te){this.uri=F,this.viewType=te}}e.$OO=Xn;class Yn{constructor(F){this.viewType=F}}e.$PO=Yn;class Zn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$QO=Zn;class xn{constructor(F,te,Se){this.original=F,this.modified=te,this.notebookType=Se}}e.$RO=xn;class _n{constructor(){}}e.$SO=_n;class er{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$TO=er;class tr{constructor(){}}e.$UO=tr;class ir{constructor(F){this.textDiffs=F}}e.$VO=ir;var Pn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(F,te,Se){this.id=F,this.label=te,this.values=Se}}e.$WO=nr;var Tn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}));var Mn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Mn||(e.ChatResultFeedbackKind=Mn={}));class rr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ke(F):F}}e.$XO=rr;class sr{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ke(F):F,this.vulnerabilities=te}}e.$YO=sr;class or{constructor(F,te){this.participant=F,this.command=te}}e.$ZO=or;class ar{constructor(F,te,Se){this.title=F,this.message=te,this.data=Se}}e.$1O=ar;class cr{constructor(F,te){this.value=F,this.baseUri=te}}e.$2O=cr;class ur{constructor(F,te){this.value=F,this.title=te}}e.$3O=ur;class lr{constructor(F){this.value=F}}e.$4O=lr;class hr{constructor(F,te){this.value=F,this.task=te}}e.$5O=hr;class dr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Ke(F):F}}e.$6O=dr;class fr{constructor(F){this.value=F}}e.$7O=fr;class gr{constructor(F,te){this.value=F,this.iconPath=te}}e.$8O=gr;class mr{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$9O=mr;class pr{constructor(F,te,Se,Je){this.prompt=F,this.command=te,this.references=Se,this.participant=Je}}e.$0O=pr;class $r{constructor(F,te,Se,Je){this.response=F,this.result=te,this.participant=Se,this.command=Je}}e.$$O=$r;var On;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(On||(e.ChatLocation=On={}));var gn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(F,te,Se){this.name=F,this.content=te,this.isError=Se??!1}}e.$_O=br;class mn{static User(F,te){const Se=new mn(gn.User,typeof F=="string"?F:"",te);return Se.content2=F,Se}static Assistant(F,te){return new mn(gn.Assistant,F,te)}constructor(F,te,Se){this.role=F,this.content=te,this.content2=te,this.name=Se}}e.$aP=mn;class wr{constructor(F,te){this.name=F,this.parameters=te}}e.$bP=wr;class vr{constructor(F){this.value=F}}e.$cP=vr;class yr{constructor(F){this.content=F}}e.$dP=yr;class Er{constructor(F,te){this.content=F,this.name=te}}e.$eP=Er;class Dr{constructor(F,te){this.content=F,this.name=te}}e.$fP=Dr;class Ai extends Error{static NotFound(F){return new Ai(F,Ai.NotFound.name)}static NoPermissions(F){return new Ai(F,Ai.NoPermissions.name)}static Blocked(F){return new Ai(F,Ai.Blocked.name)}constructor(F,te,Se){super(F,{cause:Se}),this.name="LanguageModelError",this.code=te??""}}e.$gP=Ai;var Nn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Ln;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Fn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var jn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Sr{constructor(F,te){this.text=F,this.range=te}}e.$hP=Sr;var zn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(Ce[269],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$YM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,M,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(A);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(M,p)??[]}getRelatedInformation(A,M,p){return this.c.$getAiRelatedInformation(M,p)}registerRelatedInformationProvider(A,M,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,M),new C.$1M(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$0mc=P}),define(Ce[91],Ie([1,0,4,6,7,19,116,3,17]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,M.$Ci)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new w.$je,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=u.getProxy(C.$YM.MainThreadAuthentication)}async getSession(u,E,d,r={}){const o=O.$nn.toKey(u.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${E} ${a}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,d,o,h,r)})}async getSessions(u,E,d){const r=O.$nn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(E);const a=u.displayName||u.name;return this.a.$getSessions(E,d,r,a)})}async removeSession(u,E){const d=this.b.get(u);return d?d.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,d,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(u,a));return this.a.$registerAuthenticationProvider(u,E,r?.supportsMultipleAccounts??!1),new P.$1M(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,d){const r=this.b.get(u);if(r)return await r.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const d=this.b.get(u);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E){const d=this.b.get(u);if(d)return await d.provider.getSessions(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$1L)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$jnc=c,e.$jnc=c=He([Ve(0,p.$sP)],c);class R{constructor(){this.a=new Map}getOrCreate(u,E){const d=this.a.get(u);if(d)return d;const r=E().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[121],Ie([1,0,2,6,7,3,17,12,18,13,20,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(C.$YM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=u.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const s=(0,p.$3b)(i);if(s.length<=u.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const n=s.map(f=>({uri:f,rank:(0,c.$gf)(f.path,"/")})),t=(0,p.$Ab)(n,(f,l)=>f.rank-l.rank||(0,c.$wf)(f.uri.path,l.uri.path)),m=[];e:for(const f of t){let l;for(const $ of f){const I=(0,R.$nc)($.uri.path);if(l!==I&&(l=I,m.push($.uri)>=u.d))break e}}this.g.$onDidChange(a,m)});return new P.$1M(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async n=>{try{const{uri:t,id:m}=n,f=await Promise.resolve(i.provideFileDecoration(w.URI.revive(t),a));if(!f)return;try{P.$oO.validate(f),f.badge&&typeof f.badge!="string"&&(0,v.$2G)(s,"codiconDecoration"),h[m]=[f.propagate,f.tooltip,f.badge,f.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),h}};e.$noc=E,e.$noc=E=u=He([Ve(0,A.$sP),Ve(1,M.$9j)],E),e.$ooc=(0,O.$Ci)("IExtHostDecorations")}),define(Ce[270],Ie([1,0,14,2,7,6,16,22,13]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class c{static{this.a=0}constructor(v,u,E){this.d=u,this.e=E,this.b=new Map,this.c=v.getProxy(O.$YM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,u){if(Object.keys(A.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const E=c.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,v);let d;if(typeof u.onDidChange=="function"){let r;d=u.onDidChange(async o=>{if(o.scheme!==v){this.e.warn(`Provider for scheme '${v}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(E,o).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(o);if(!i)return;const s=(0,p.$qf)(h);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(w.$2).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.$1M(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(v,u){const E=this.b.get(v);return E?Promise.resolve(E.provideTextDocumentContent(C.URI.revive(u),M.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$qoc=c}),define(Ce[122],Ie([1,0,62,16,13,325,210,7,18]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=void 0,e.$uP=R;const c=new Map;function R(d,r){r?c.set(d,r):c.delete(d)}function v(d){return c.get(d)}class u extends O.$fw{constructor(r,o,a,h,i,s,n){super(o,a,h,i),this.c=r,this.m=s,this.q=n,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$vb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===C.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?M.EndOfLine.LF:M.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,w.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,w.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,i=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let n=h+1;n<i;n++)s.push(this.f[n]);return s.push(this.f[i].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof M.$2M?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new M.$2M(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof M.$3M))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new M.$3M(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof M.$2M))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const i=this.f[o].length;a<0?(a=0,h=!0):a>i&&(a=i,h=!0)}return h?new M.$2M(o,a):r}y(r,o){const a=this.x(r);if(!o)o=v(this.m);else if((0,P.$pf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,A.$ht)(a.character+1,(0,A.$ft)(o),this.f[a.line],0);if(h)return new M.$3M(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$vP=u;class E{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new M.$3M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new M.$3M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$wP=E}),define(Ce[271],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$YM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,M,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(A);if(!c)throw new Error("Embedding vector provider not found");const R=await c.provideEmbeddingVector(M,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,M,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(M,c),new C.$1M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$toc=P}),define(Ce[69],Ie([1,0,6,30,7,23,3,17,51,5,11,24,16]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=void 0,C=qe(C);let d=E=class{constructor(o,a){this.b=new Map,this.c=new R.$Lh,this.a=o.getProxy(w.$YM.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let s;const n=h.b.get(i.scheme);return n?(await h.a.$ensureActivation(i.scheme),s=await n.impl.stat(i)):s=await h.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===C.FilePermission.Readonly?1:void 0}}catch(s){E.e(s)}},async readDirectory(i){try{const s=h.b.get(i.scheme);return s?(await h.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(s){return E.e(s)}},async createDirectory(i){try{const s=h.b.get(i.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(s.impl,s.extUri,i)):await h.a.$mkdir(i)}catch(s){return E.e(s)}},async readFile(i){try{const s=h.b.get(i.scheme);return s?(await h.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(s){return E.e(s)}},async writeFile(i,s){try{const n=h.b.get(i.scheme);return n&&!n.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(n.impl,n.extUri,n.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(n.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,O.$Le.wrap(s))}catch(n){return E.e(n)}},async delete(i,s){try{const n=h.b.get(i.scheme);return n&&!n.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(i.scheme),await n.impl.delete(i,{recursive:!1,...s})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(n){return E.e(n)}},async rename(i,s,n){try{return await h.a.$rename(i,s,{overwrite:!1,...n})}catch(t){return E.e(t)}},async copy(i,s,n){try{return await h.a.$copy(i,s,{overwrite:!1,...n})}catch(t){return E.e(t)}},isWritableFileSystem(i){const s=a.getCapabilities(i);if(typeof s=="number")return!(s&C.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const i=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&C.FileType.Directory))throw P.$fO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(C.$ml(s)!==C.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(a.basename(h)),h=a.dirname(h)}for(let s=i.length-1;s>=0;s--){h=a.joinPath(h,i[s]);try{await o.createDirectory(h)}catch(n){if(C.$ml(n)!==C.FileSystemProviderErrorCode.FileExists)throw n}}}static e(o){if(o instanceof P.$fO)throw o;if(o instanceof C.$il)switch(o.code){case C.FileSystemProviderErrorCode.FileExists:throw P.$fO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$fO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$fO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$fO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$fO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$fO.Unavailable(o.message);default:throw new P.$fO(o.message,o.name)}if(!(o instanceof Error))throw new P.$fO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$fO.Unavailable(o.message);switch(o.name){case C.FileSystemProviderErrorCode.FileExists:throw P.$fO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$fO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$fO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$fO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$fO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$fO.Unavailable(o.message);default:throw new P.$fO(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?v.$6g:v.$8g,isReadonly:!!h?.isReadonly}),(0,c.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??v.$6g}};e.$ync=d,e.$ync=d=E=He([Ve(0,M.$sP),Ve(1,p.$cnc)],d),e.$znc=(0,A.$Ci)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,69,2]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=e.$Anc=void 0,e.$Anc=(0,w.$Ci)("IExtensionStoragePaths");let M=class{constructor(c,R,v){this.d=R,this.f=v,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return A.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,R=await this.g(c);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(v){this.d.error("[ExtHostStorage]",v);return}}workspaceValue(c){if(this.c)return A.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return A.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Bnc=M,e.$Bnc=M=He([Ve(0,C.$IP),Ve(1,P.$9j),Ve(2,O.$znc)],M)}),define(Ce[272],Ie([1,0,7,17,4]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0;let O=class{constructor(M){this.a=new w.$pO(w.ColorThemeKind.Dark),this.b=new P.$je}get activeColorTheme(){return this.a}$onColorThemeChange(M){let p;switch(M){case"light":p=w.ColorThemeKind.Light;break;case"hcDark":p=w.ColorThemeKind.HighContrast;break;case"hcLight":p=w.ColorThemeKind.HighContrastLight;break;default:p=w.ColorThemeKind.Dark}this.a=new w.$pO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0oc=O,e.$0oc=O=He([Ve(0,C.$sP)],O)}),define(Ce[93],Ie([1,0,22,4,5,190,3,12,223,6,27,17,7]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Eb=e.$2Eb=e.TunnelDtoConverter=void 0,O=qe(O),u=qe(u);class E extends p.$Ew{}var d;(function(o){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=a;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$2Eb=(0,A.$Ci)("IExtHostTunnelService");let r=class extends P.$Vc{constructor(a,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$je,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$YM.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,a.displayName);if(i){const s=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,i),new u.$1M(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,h,i,s,n){const t=[];for(const f of a){const l=this.r.get(f);if(!l)return[];t.push(...await Promise.all(h.map(async $=>{let I;try{I=await l.provider.providePortAttributes({port:$,pid:i,commandLine:s},n)}catch{I=await l.provider.providePortAttributes($,i,s,n)}return{providedAttributes:I,port:$}})))}const m=t.filter(f=>!!f.providedAttributes);return m.length>0?m.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,n)=>await a.provideTunnel(s,n,w.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const n=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(n)}}else this.b=void 0;return(0,P.$Tc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(h&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const n=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:n}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),i=a.filter((s,n)=>h[n]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$3Eb=r,e.$3Eb=r=He([Ve(0,v.$sP),Ve(1,R.$IP),Ve(2,M.$9j)],r)}),define(Ce[10],Ie([1,0,18,23,147,273,60,29,136,49,73,26,142,24,35,15,2,105,33,151,94,52,107,77,115,114,234,249,81,90,55,56,245,7]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l,$,I,D,y,S,k,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$pP=de,e.$qP=re,e.$rP=Pe,A=qe(A),h=qe(h),i=qe(i),s=qe(s),I=qe(I),y=qe(y),b=qe(b);var L;(function(ye){function Te(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ge}=Q,ut=new b.$2M(Ee-1,We-1),Pt=new b.$2M(Ye-1,Ge-1);return new b.$4M(ut,Pt)}ye.to=Te;function ue(Q){const{anchor:Ee,active:We}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=ue})(L||(e.Selection=L={}));var T;(function(ye){function Te(Q){if(!Q)return;const{start:Ee,end:We}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Te;function ue(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ye,endColumn:Ge}=Q;return new b.$3M(Ee-1,We-1,Ye-1,Ge-1)}ye.to=ue})(T||(e.Range=T={}));var q;(function(ye){function Te(Q){return{uri:Q.uri,range:T.from(Q.range)}}ye.from=Te;function ue(Q){return new b.$aN(o.URI.revive(Q.uri),T.to(Q.range))}ye.to=ue})(q||(e.Location=q={}));var G;(function(ye){function Te(ue){switch(ue){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}ye.to=Te})(G||(e.TokenType=G={}));var W;(function(ye){function Te(Q){return new b.$2M(Q.lineNumber-1,Q.column-1)}ye.to=Te;function ue(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=ue})(W||(e.Position=W={}));var N;(function(ye){function Te(Ee,We,Ye){return(0,w.$Ib)((0,w.$3b)(Ee).map(Ge=>ue(Ge,We,Ye)))}ye.from=Te;function ue(Ee,We,Ye){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ye?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,We),pattern:Ze.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(N||(e.DocumentSelector=N={}));var V;(function(ye){function Te(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}ye.from=Te;function ue(Q){switch(Q){case t.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ye.to=ue})(V||(e.DiagnosticTag=V={}));var ce;(function(ye){function Te(Q){let Ee;return Q.code&&((0,r.$cg)(Q.code)||(0,r.$gg)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...T.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:ie.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(ge.from),tags:Array.isArray(Q.tags)?(0,w.$Ib)(Q.tags.map(V.from)):void 0}}ye.from=Te;function ue(Q){const Ee=new b.$cN(T.to(Q),Q.message,ie.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,r.$cg)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(ge.to),Ee.tags=Q.tags&&(0,w.$Ib)(Q.tags.map(V.to)),Ee}ye.to=ue})(ce||(e.Diagnostic=ce={}));var ge;(function(ye){function Te(Q){return{...T.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Te;function ue(Q){return new b.$bN(new b.$aN(Q.resource,T.to(Q)),Q.message)}ye.to=ue})(ge||(e.DiagnosticRelatedInformation=ge={}));var ie;(function(ye){function Te(Q){switch(Q){case b.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ye.from=Te;function ue(Q){switch(Q){case t.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=ue})(ie||(e.DiagnosticSeverity=ie={}));var me;(function(ye){function Te(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?g.$jE:g.$iE}ye.from=Te;function ue(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ue})(me||(e.ViewColumn=me={}));function se(ye){return typeof ye.range<"u"}function de(ye){return ye.length===0?!0:!!se(ye[0])}var be;(function(ye){function Te(Ge){return Ge.map(ye.from)}ye.fromMany=Te;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let ut;if(ue(Ge)){const{language:jt,value:ni}=Ge;ut={value:"```"+jt+`
`+ni+"\n```\n"}}else b.$qN.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const Yt=jt=>{try{let ni=o.URI.parse(jt,!0);ni=ni.with({query:Ee(ni.query,Pt)}),Pt[jt]=ni}catch{}return""},ci=new p.marked.Renderer;return ci.link=Yt,ci.image=jt=>typeof jt=="string"?Yt(A.$8k(jt).href):"",(0,p.marked)(ut.value,{renderer:ci}),ut}ye.from=Q;function Ee(Ge,ut){if(!Ge)return Ge;let Pt;try{Pt=(0,c.$$h)(Ge)}catch{}if(!Pt)return Ge;let Yt=!1;return Pt=(0,v.$bo)(Pt,ci=>{if(o.URI.isUri(ci)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[jt]=ci,Yt=!0,jt}else return}),Yt?JSON.stringify(Pt):Ge}function We(Ge){const ut=new b.$qN(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,ut}ye.to=We;function Ye(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ye})(be||(e.MarkdownString=be={}));function re(ye){return de(ye)?ye.map(Te=>({range:T.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?be.fromMany(Te.hoverMessage):Te.hoverMessage?be.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):ye.map(Te=>({range:T.from(Te)}))}function Pe(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Le;(function(ye){function Te(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?Pe(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ye.from=Te})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var Y;(function(ye){function Te(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Le.from(ue.before):void 0,after:ue.after?Le.from(ue.after):void 0}}ye.from=Te})(Y||(e.ThemableDecorationRenderOptions=Y={}));var B;(function(ye){function Te(ue){if(typeof ue>"u")return ue;switch(ue){case b.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Te})(B||(e.DecorationRangeBehavior=B={}));var _;(function(ye){function Te(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?B.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?Y.from(ue.light):void 0,dark:ue.dark?Y.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Le.from(ue.before):void 0,after:ue.after?Le.from(ue.after):void 0}}ye.from=Te})(_||(e.DecorationRenderOptions=_={}));var we;(function(ye){function Te(Q){return{text:Q.newText,eol:Q.newEol&&Ue.from(Q.newEol),range:T.from(Q.range)}}ye.from=Te;function ue(Q){const Ee=new b.$8M(T.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:Ue.to(Q.eol),Ee}ye.to=ue})(we||(e.TextEdit=we={}));var ae;(function(ye){function Te(Q,Ee){const We={edits:[]};if(Q instanceof b.$$M){const Ye=new M.$Cc;for(const Ge of Q._allEntries())Ge._type===b.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Ye.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===b.FileEditType.File){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,C.$6e)(C.$Le.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:we.from(Ge.edit),versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:T.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(It.from)}})}return We}ye.from=Te;function ue(Q){const Ee=new b.$$M,We=new M.$Bc;for(const Ye of Q.edits)if(Ye.textEdit){const Ge=Ye,ut=o.URI.revive(Ge.resource),Pt=T.to(Ge.textEdit.range),Yt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let jt;ci?jt=b.$0M.replace(Pt,new b.$_M(Yt)):jt=b.$8M.replace(Pt,Yt);const ni=We.get(ut);ni?ni.push(jt):We.set(ut,[jt])}else Ee.renameFile(o.URI.revive(Ye.oldResource),o.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ge]of We)Ee.set(Ye,Ge);return Ee}ye.to=ue})(ae||(e.WorkspaceEdit=ae={}));var ve;(function(ye){const Te=Object.create(null);Te[b.SymbolKind.File]=s.SymbolKind.File,Te[b.SymbolKind.Module]=s.SymbolKind.Module,Te[b.SymbolKind.Namespace]=s.SymbolKind.Namespace,Te[b.SymbolKind.Package]=s.SymbolKind.Package,Te[b.SymbolKind.Class]=s.SymbolKind.Class,Te[b.SymbolKind.Method]=s.SymbolKind.Method,Te[b.SymbolKind.Property]=s.SymbolKind.Property,Te[b.SymbolKind.Field]=s.SymbolKind.Field,Te[b.SymbolKind.Constructor]=s.SymbolKind.Constructor,Te[b.SymbolKind.Enum]=s.SymbolKind.Enum,Te[b.SymbolKind.Interface]=s.SymbolKind.Interface,Te[b.SymbolKind.Function]=s.SymbolKind.Function,Te[b.SymbolKind.Variable]=s.SymbolKind.Variable,Te[b.SymbolKind.Constant]=s.SymbolKind.Constant,Te[b.SymbolKind.String]=s.SymbolKind.String,Te[b.SymbolKind.Number]=s.SymbolKind.Number,Te[b.SymbolKind.Boolean]=s.SymbolKind.Boolean,Te[b.SymbolKind.Array]=s.SymbolKind.Array,Te[b.SymbolKind.Object]=s.SymbolKind.Object,Te[b.SymbolKind.Key]=s.SymbolKind.Key,Te[b.SymbolKind.Null]=s.SymbolKind.Null,Te[b.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Te[b.SymbolKind.Struct]=s.SymbolKind.Struct,Te[b.SymbolKind.Event]=s.SymbolKind.Event,Te[b.SymbolKind.Operator]=s.SymbolKind.Operator,Te[b.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ue(Ee){return typeof Te[Ee]=="number"?Te[Ee]:s.SymbolKind.Property}ye.from=ue;function Q(Ee){for(const We in Te)if(Te[We]===Ee)return Number(We);return b.SymbolKind.Property}ye.to=Q})(ve||(e.SymbolKind=ve={}));var le;(function(ye){function Te(Q){switch(Q){case b.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ye.from=Te;function ue(Q){switch(Q){case s.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ye.to=ue})(le||(e.SymbolTag=le={}));var X;(function(ye){function Te(Q){return{name:Q.name,kind:ve.from(Q.kind),tags:Q.tags&&Q.tags.map(le.from),containerName:Q.containerName,location:je.from(Q.location)}}ye.from=Te;function ue(Q){const Ee=new b.$hN(Q.name,ve.to(Q.kind),Q.containerName,je.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(le.to),Ee}ye.to=ue})(X||(e.WorkspaceSymbol=X={}));var Z;(function(ye){function Te(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),kind:ve.from(Q.kind),tags:Q.tags?.map(le.from)??[]};return Q.children&&(Ee.children=Q.children.map(Te)),Ee}ye.from=Te;function ue(Q){const Ee=new b.$iN(Q.name,Q.detail,ve.to(Q.kind),T.to(Q.range),T.to(Q.selectionRange));return(0,w.$Mb)(Q.tags)&&(Ee.tags=Q.tags.map(le.to)),Q.children&&(Ee.children=Q.children.map(ue)),Ee}ye.to=ue})(Z||(e.DocumentSymbol=Z={}));var pe;(function(ye){function Te(Q){const Ee=new b.$mN(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function ue(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:Q.name,detail:Q.detail,kind:ve.from(Q.kind),uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(le.from)}}ye.from=ue})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(ye){function Te(ue){return new b.$nN(pe.to(ue.from),ue.fromRanges.map(Q=>T.to(Q)))}ye.to=Te})($e||(e.CallHierarchyIncomingCall=$e={}));var Me;(function(ye){function Te(ue){return new b.$oN(pe.to(ue.to),ue.fromRanges.map(Q=>T.to(Q)))}ye.to=Te})(Me||(e.CallHierarchyOutgoingCall=Me={}));var je;(function(ye){function Te(Q){return{range:Q.range&&T.from(Q.range),uri:Q.uri}}ye.from=Te;function ue(Q){return new b.$aN(o.URI.revive(Q.uri),T.to(Q.range))}ye.to=ue})(je||(e.location=je={}));var ke;(function(ye){function Te(Q){const Ee=Q,We=Q;return{originSelectionRange:Ee.originSelectionRange?T.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:T.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?T.from(Ee.targetSelectionRange):void 0}}ye.from=Te;function ue(Q){return{targetUri:o.URI.revive(Q.uri),targetRange:T.to(Q.range),targetSelectionRange:Q.targetSelectionRange?T.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?T.to(Q.originSelectionRange):void 0}}ye.to=ue})(ke||(e.DefinitionLink=ke={}));var Re;(function(ye){function Te(Q){return{range:T.from(Q.range),contents:be.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}ye.from=Te;function ue(Q){const Ee=Q.contents.map(be.to),We=T.to(Q.range),Ye=Q.canIncreaseVerbosity,Ge=Q.canDecreaseVerbosity;return new b.$eN(Ee,We,Ye,Ge)}ye.to=ue})(Re||(e.Hover=Re={}));var Oe;(function(ye){function Te(Q){return{range:T.from(Q.range),expression:Q.expression}}ye.from=Te;function ue(Q){return new b.$_N(T.to(Q.range),Q.expression)}ye.to=ue})(Oe||(e.EvaluatableExpression=Oe={}));var z;(function(ye){function Te(Q){if(Q instanceof b.$aO)return{type:"text",range:T.from(Q.range),text:Q.text};if(Q instanceof b.$bO)return{type:"variable",range:T.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.$cO)return{type:"expression",range:T.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Te;function ue(Q){switch(Q.type){case"text":return{range:T.to(Q.range),text:Q.text};case"variable":return{range:T.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:T.to(Q.range),expression:Q.expression}}}ye.to=ue})(z||(e.InlineValue=z={}));var j;(function(ye){function Te(Q){return{frameId:Q.frameId,stoppedLocation:T.from(Q.stoppedLocation)}}ye.from=Te;function ue(Q){return new b.$dO(Q.frameId,T.to(Q.stoppedLocation))}ye.to=ue})(j||(e.InlineValueContext=j={}));var K;(function(ye){function Te(Q){return{range:T.from(Q.range),kind:Q.kind}}ye.from=Te;function ue(Q){return new b.$fN(T.to(Q.range),Q.kind)}ye.to=ue})(K||(e.DocumentHighlight=K={}));var J;(function(ye){function Te(Q){return{uri:Q.uri,highlights:Q.highlights.map(K.from)}}ye.from=Te;function ue(Q){return new b.$gN(o.URI.revive(Q.uri),Q.highlights.map(K.to))}ye.to=ue})(J||(e.MultiDocumentHighlight=J={}));var ne;(function(ye){function Te(ue){switch(ue){case s.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ye.to=Te})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ye){function Te(ue){return{triggerKind:ne.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ye.to=Te})(fe||(e.CompletionContext=fe={}));var Ae;(function(ye){function Te(Q){switch(Q){case b.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ye.from=Te;function ue(Q){switch(Q){case s.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ye.to=ue})(Ae||(e.CompletionItemTag=Ae={}));var ze;(function(ye){const Te=new Map([[b.CompletionItemKind.Method,s.CompletionItemKind.Method],[b.CompletionItemKind.Function,s.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,s.CompletionItemKind.Field],[b.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[b.CompletionItemKind.Class,s.CompletionItemKind.Class],[b.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[b.CompletionItemKind.Module,s.CompletionItemKind.Module],[b.CompletionItemKind.Property,s.CompletionItemKind.Property],[b.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[b.CompletionItemKind.Value,s.CompletionItemKind.Value],[b.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,s.CompletionItemKind.Text],[b.CompletionItemKind.Color,s.CompletionItemKind.Color],[b.CompletionItemKind.File,s.CompletionItemKind.File],[b.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[b.CompletionItemKind.Event,s.CompletionItemKind.Event],[b.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[b.CompletionItemKind.User,s.CompletionItemKind.User]]);function ue(We){return Te.get(We)??s.CompletionItemKind.Property}ye.from=ue;const Q=new Map([[s.CompletionItemKind.Method,b.CompletionItemKind.Method],[s.CompletionItemKind.Function,b.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,b.CompletionItemKind.Field],[s.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[s.CompletionItemKind.Class,b.CompletionItemKind.Class],[s.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[s.CompletionItemKind.Module,b.CompletionItemKind.Module],[s.CompletionItemKind.Property,b.CompletionItemKind.Property],[s.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[s.CompletionItemKind.Value,b.CompletionItemKind.Value],[s.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,b.CompletionItemKind.Text],[s.CompletionItemKind.Color,b.CompletionItemKind.Color],[s.CompletionItemKind.File,b.CompletionItemKind.File],[s.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[s.CompletionItemKind.Event,b.CompletionItemKind.Event],[s.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,b.CompletionItemKind.User],[s.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(We){return Q.get(We)??b.CompletionItemKind.Property}ye.to=Ee})(ze||(e.CompletionItemKind=ze={}));var Ke;(function(ye){function Te(ue,Q){const Ee=new b.$wN(ue.label);return Ee.insertText=ue.insertText,Ee.kind=ze.to(ue.kind),Ee.tags=ue.tags?.map(Ae.to),Ee.detail=ue.detail,Ee.documentation=A.$2k(ue.documentation)?be.to(ue.documentation):ue.documentation,Ee.sortText=ue.sortText,Ee.filterText=ue.filterText,Ee.preselect=ue.preselect,Ee.commitCharacters=ue.commitCharacters,h.$Ft.isIRange(ue.range)?Ee.range=T.to(ue.range):typeof ue.range=="object"&&(Ee.range={inserting:T.to(ue.range.insert),replacing:T.to(ue.range.replace)}),Ee.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ue.insertTextRules<"u"&&ue.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$_M(ue.insertText):(Ee.insertText=ue.insertText,Ee.textEdit=Ee.range instanceof b.$3M?new b.$8M(Ee.range,Ee.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ue.additionalTextEdits.map(We=>we.to(We))),Ee.command=Q&&ue.command?Q.fromInternal(ue.command):void 0,Ee}ye.to=Te})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Te(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:be.fromStrict(Q.documentation)}}ye.from=Te;function ue(Q){return{label:Q.label,documentation:A.$2k(Q.documentation)?be.to(Q.documentation):Q.documentation}}ye.to=ue})(_e||(e.ParameterInformation=_e={}));var it;(function(ye){function Te(Q){return{label:Q.label,documentation:be.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.from):[],activeParameter:Q.activeParameter}}ye.from=Te;function ue(Q){return{label:Q.label,documentation:A.$2k(Q.documentation)?be.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(_e.to):[],activeParameter:Q.activeParameter}}ye.to=ue})(it||(e.SignatureInformation=it={}));var nt;(function(ye){function Te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(it.from):[]}}ye.from=Te;function ue(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(it.to):[]}}ye.to=ue})(nt||(e.SignatureHelp=nt={}));var tt;(function(ye){function Te(ue,Q){const Ee=new b.$vN(W.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(rt.to.bind(void 0,ue)),Q.kind&&$t.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(we.to),Ee.tooltip=A.$2k(Q.tooltip)?be.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}ye.to=Te})(tt||(e.InlayHint=tt={}));var rt;(function(ye){function Te(ue,Q){const Ee=new b.$uN(Q.label);return Ee.tooltip=A.$2k(Q.tooltip)?be.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ee.command=ue.fromInternal(Q.command)),Q.location&&(Ee.location=je.to(Q.location)),Ee}ye.to=Te})(rt||(e.InlayHintLabelPart=rt={}));var $t;(function(ye){function Te(Q){return Q}ye.from=Te;function ue(Q){return Q}ye.to=ue})($t||(e.InlayHintKind=$t={}));var lt;(function(ye){function Te(Q){return{range:T.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Te;function ue(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?o.URI.parse(Q.url,!0):o.URI.revive(Q.url)}catch{}const We=new b.$BN(T.to(Q.range),Ee);return We.tooltip=Q.tooltip,We}ye.to=ue})(lt||(e.DocumentLink=lt={}));var st;(function(ye){function Te(Q){const Ee=new b.$EN(Q.label);return Q.textEdit&&(Ee.textEdit=we.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(We=>we.to(We))),Ee}ye.to=Te;function ue(Q){return{label:Q.label,textEdit:Q.textEdit?we.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>we.from(Ee)):void 0}}ye.from=ue})(st||(e.ColorPresentation=st={}));var ct;(function(ye){function Te(Q){return new b.$CN(Q[0],Q[1],Q[2],Q[3])}ye.to=Te;function ue(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=ue})(ct||(e.Color=ct={}));var gt;(function(ye){function Te(Q){return{range:T.from(Q.range)}}ye.from=Te;function ue(Q){return new b.$lN(T.to(Q.range))}ye.to=ue})(gt||(e.SelectionRange=gt={}));var mt;(function(ye){function Te(ue){switch(ue){case l.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ye.to=Te})(mt||(e.TextDocumentSaveReason=mt={}));var Be;(function(ye){function Te(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}ye.from=Te;function ue(Q){switch(Q){case a.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ye.to=ue})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ue;(function(ye){function Te(Q){if(Q===b.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(Q===b.EndOfLine.LF)return n.EndOfLineSequence.LF}ye.from=Te;function ue(Q){if(Q===n.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(Q===n.EndOfLineSequence.LF)return b.EndOfLine.LF}ye.to=ue})(Ue||(e.EndOfLine=Ue={}));var H;(function(ye){function Te(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case b.ProgressLocation.SourceControl:return m.ProgressLocation.Scm;case b.ProgressLocation.Window:return m.ProgressLocation.Window;case b.ProgressLocation.Notification:return m.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Te})(H||(e.ProgressLocation=H={}));var x;(function(ye){function Te(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=De.from(Q.kind)),Ee}ye.from=Te;function ue(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=De.to(Q.kind)),Ee}ye.to=ue})(x||(e.FoldingRange=x={}));var De;(function(ye){function Te(Q){if(Q)switch(Q){case b.FoldingRangeKind.Comment:return s.$Fu.Comment;case b.FoldingRangeKind.Imports:return s.$Fu.Imports;case b.FoldingRangeKind.Region:return s.$Fu.Region}}ye.from=Te;function ue(Q){if(Q)switch(Q.value){case s.$Fu.Comment.value:return b.FoldingRangeKind.Comment;case s.$Fu.Imports.value:return b.FoldingRangeKind.Imports;case s.$Fu.Region.value:return b.FoldingRangeKind.Region}}ye.to=ue})(De||(e.FoldingRangeKind=De={}));var Xe;(function(ye){function Te(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?T.from(ue.selection):void 0,override:typeof ue.override=="boolean"?l.$MF.id:void 0}}ye.from=Te})(Xe||(e.TextEditorOpenOptions=Xe={}));var Ze;(function(ye){function Te(We){return We instanceof b.$ZN?We.toJSON():typeof We=="string"?We:ue(We)||Q(We)?new b.$ZN(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Te;function ue(We){const Ye=We;return Ye?o.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new b.$ZN(o.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(Ze||(e.GlobPattern=Ze={}));var dt;(function(ye){function Te(ue){if(ue){if(Array.isArray(ue))return ue.map(Te);if(typeof ue=="string")return ue;{const Q=ue;return{language:Q.language,scheme:Q.scheme,pattern:Ze.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Te})(dt||(e.LanguageSelector=dt={}));var pt;(function(ye){function Te(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&o.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof b.$3M)))}ye.is=Te;function ue(Q){return{documents:Q.documents.map(Ee=>Ee.map(We=>({uri:o.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>T.from(Ye))})))}}ye.from=ue})(pt||(e.MappedEditsContext=pt={}));var Lt;(function(ye){function Te(Q){return{start:Q.start,end:Q.end}}ye.from=Te;function ue(Q){return new b.$qO(Q.start,Q.end)}ye.to=ue})(Lt||(e.NotebookRange=Lt={}));var zt;(function(ye){function Te(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Te;function ue(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=ue})(zt||(e.NotebookCellExecutionSummary=zt={}));var xt;(function(ye){function Te(ue){if(ue===y.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ue===y.NotebookCellExecutionState.Pending)return;if(ue===y.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}ye.to=Te})(xt||(e.NotebookCellExecutionState=xt={}));var li;(function(ye){function Te(Q){switch(Q){case b.NotebookCellKind.Markup:return y.CellKind.Markup;case b.NotebookCellKind.Code:default:return y.CellKind.Code}}ye.from=Te;function ue(Q){switch(Q){case y.CellKind.Markup:return b.NotebookCellKind.Markup;case y.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=ue})(li||(e.NotebookCellKind=li={}));var xe;(function(ye){function Te(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const We of Q.cells)b.$rO.validate(We),Ee.cells.push(It.from(We));return Ee}ye.from=Te;function ue(Q){const Ee=new b.$sO(Q.cells.map(It.to));return(0,r.$pg)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}ye.to=ue})(xe||(e.NotebookData=xe={}));var It;(function(ye){function Te(Q){return{cellKind:li.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:zt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(ht.from):[]}}ye.from=Te;function ue(Q){return new b.$rO(li.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(ht.to):void 0,Q.metadata,Q.internalMetadata?zt.to(Q.internalMetadata):void 0)}ye.to=ue})(It||(e.NotebookCellData=It={}));var Gt;(function(ye){function Te(Q){return{mime:Q.mime,valueBytes:C.$Le.wrap(Q.data)}}ye.from=Te;function ue(Q){return new b.$tO(Q.valueBytes.buffer,Q.mime)}ye.to=ue})(Gt||(e.NotebookCellOutputItem=Gt={}));var ht;(function(ye){function Te(Q){return{outputId:Q.id,items:Q.items.map(Gt.from),metadata:Q.metadata}}ye.from=Te;function ue(Q){const Ee=Q.items.map(Gt.to);return new b.$uO(Ee,Q.outputId,Q.metadata)}ye.to=ue})(ht||(e.NotebookCellOutput=ht={}));var bt;(function(ye){function Te(Ee){return Q(Ee)?{include:Ze.from(Ee.include)??void 0,exclude:Ze.from(Ee.exclude)??void 0}:Ze.from(Ee)??void 0}ye.from=Te;function ue(Ee){return Q(Ee)?{include:Ze.to(Ee.include),exclude:Ze.to(Ee.exclude)}:Ze.to(Ee)}ye.to=ue;function Q(Ee){const We=Ee;return We?!(0,r.$lg)(We.include)&&!(0,r.$lg)(We.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(ye){function Te(ue,Q,Ee){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===b.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:Q.toInternal(We,Ee),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ye.from=Te})(hi||(e.NotebookStatusBarItem=hi={}));var _t;(function(ye){function Te(ue,Q,Ee){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:Q.toInternal(We,Ee),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}ye.from=Te})(_t||(e.NotebookKernelSourceAction=_t={}));var Ut;(function(ye){function Te(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}ye.from=Te})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var wt;(function(ye){function Te(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Te;function ue(Q){return new b.$wO(o.URI.revive(Q.uri),Q.provides)}ye.to=ue})(wt||(e.NotebookRendererScript=wt={}));var Bt;(function(ye){function Te(Q){return{message:be.fromStrict(Q.message)||"",type:k.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:T.from(Q.location.range),uri:Q.location.uri}}}ye.from=Te;function ue(Q){const Ee=new b.$CO(typeof Q.message=="string"?Q.message:be.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?je.to(Q.location):void 0,Ee}ye.to=ue})(Bt||(e.TestMessage=Bt={}));var Jt;(function(ye){ye.namespace=k.$RI,ye.denamespace=k.$SI})(Jt||(e.TestTag=Jt={}));var Qt;(function(ye){function Te(Q){const Ee=(0,f.$oP)(Q).controllerId;return{extId:S.$MI.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:o.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(We=>Jt.namespace(Ee,We.id)),range:h.$Ft.lift(T.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&be.fromStrict(Q.error)||null}}ye.from=Te;function ue(Q){return{parent:void 0,error:void 0,id:S.$MI.fromString(Q.extId).localId,label:Q.label,uri:o.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:We}=Jt.denamespace(Ee);return new b.$DO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:T.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=ue})(Qt||(e.TestItem=Qt={})),function(ye){function Te(Q){return{id:Q.id}}ye.from=Te;function ue(Q){return new b.$DO(Q.id)}ye.to=ue}(Jt||(e.TestTag=Jt={}));var Qe;(function(ye){const Te=(Q,Ee)=>{const We=Q.value;if(!We)return;const Ye={...Qt.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(Bt.to)})),children:[]};if(Q.children)for(const Ge of Q.children.values()){const ut=Te(Ge,Ye);ut&&Ye.children.push(ut)}return Ye};function ue(Q){const Ee=new u.$LI;for(const Ge of Q.items)Ee.insert(S.$MI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ye=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ye.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:Q.completedAt,results:Ye.map(Ge=>Te(Ge)).filter(r.$kg)}}ye.to=ue})(Qe||(e.TestResults=Qe={}));var pi;(function(ye){function Te(We){return{covered:We.covered,total:We.total}}function ue(We){return"line"in We?W.from(We):T.from(We)}function Q(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ue(We.location),type:k.DetailType.Statement,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ue(Ye.location),label:Ye.label})):void 0}:{type:k.DetailType.Declaration,name:We.name,count:We.executed,location:ue(We.location)}}ye.fromDetails=Q;function Ee(We,Ye,Ge){return b.$FO(Ge.statementCoverage),b.$FO(Ge.branchCoverage),b.$FO(Ge.declarationCoverage),{id:Ye,uri:Ge.uri,statement:Te(Ge.statementCoverage),branch:Ge.branchCoverage&&Te(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Te(Ge.declarationCoverage),testId:Ge instanceof b.$GO&&Ge.testItem?S.$MI.fromExtHostTestItem(Ge.testItem,We).toString():void 0}}ye.fromFile=Ee})(pi||(e.TestCoverage=pi={}));var ei;(function(ye){function Te(ue){switch(ue){case s.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ye.to=Te})(ei||(e.CodeActionTriggerKind=ei={}));var si;(function(ye){function Te(Q){const Ee=new b.$KO(ve.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),T.to(Q.range),T.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}ye.to=Te;function ue(Q,Ee,We){if(Ee=Ee??Q._sessionId,We=We??Q._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:ve.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:T.from(Q.range),selectionRange:T.from(Q.selectionRange),tags:Q.tags?.map(le.from)}}ye.from=ue})(si||(e.TypeHierarchyItem=si={}));var St;(function(ye){function Te(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}ye.from=Te})(St||(e.ViewBadge=St={}));var Kt;(function(ye){function Te(We,Ye,Ge){const ut=Ye.fileData;return ut?new b.$RN(new b.$SN(ut.name,o.URI.revive(ut.uri),ut.id,(0,O.$eb)(()=>Ge(ut.id)))):We===R.$2s.uriList&&Ye.uriListData?new b.$QN(Ee(Ye.uriListData)):new b.$QN(Ye.asString)}ye.to=Te;async function ue(We,Ye){const Ge=await Ye.asString();if(We===R.$2s.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const ut=Ye.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ye.from=ue;function Q(We){return P.$ju.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return o.URI.parse(Ye)}catch{}return Ye})}function Ee(We){return P.$ju.create(We.map(Ye=>typeof Ye=="string"?Ye:o.URI.revive(Ye)))}})(Kt||(e.DataTransferItem=Kt={}));var At;(function(ye){function Te(Q,Ee){const We=Q.items.map(([Ye,Ge])=>[Ye,Kt.to(Ye,Ge,Ee)]);return new b.$TN(We)}ye.toDataTransfer=Te;async function ue(Q){const Ee={items:[]},We=[];for(const[Ye,Ge]of Q)We.push((async()=>{Ee.items.push([Ye,await Kt.from(Ye,Ge)])})());return await Promise.all(We),Ee}ye.from=ue})(At||(e.DataTransfer=At={}));var Nt;(function(ye){function Te(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}ye.from=Te;function ue(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}ye.to=ue})(Nt||(e.ChatFollowup=Nt={}));var ti;(function(ye){function Te(Q){switch(Q){case I.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case I.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case I.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ye.to=Te;function ue(Q){switch(Q){case b.LanguageModelChatMessageRole.System:return I.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return I.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return I.ChatMessageRole.Assistant}return I.ChatMessageRole.User}ye.from=ue})(ti||(e.LanguageModelChatMessageRole=ti={}));var ii;(function(ye){function Te(Q){let Ee="",We;Q.content.type==="text"?Ee=Q.content.value:We=new b.$_O(Q.content.name,Q.content.value,Q.content.isError);const Ye=ti.to(Q.role),Ge=new b.$aP(Ye,Ee,Q.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Te;function ue(Q){const Ee=ti.from(Q.role),We=Q.name;let Ye;return Q.content2 instanceof b.$_O?Ye={type:"function_result",name:Q.content2.name,value:Q.content2.content,isError:Q.content2.isError}:Ye={type:"text",value:Q.content},{role:Ee,name:We,content:Ye}}ye.from=ue})(ii||(e.LanguageModelChatMessage=ii={}));var oi;(function(ye){function Te(Q){return{kind:"markdownContent",content:be.from(Q.value)}}ye.from=Te;function ue(Q){return new b.$XO(be.to(Q.content))}ye.to=ue})(oi||(e.ChatResponseMarkdownPart=oi={}));var Wt;(function(ye){function Te(Q){return{kind:"markdownVuln",content:be.from(Q.value),vulnerabilities:Q.vulnerabilities}}ye.from=Te;function ue(Q){return new b.$YO(be.to(Q.content),Q.vulnerabilities)}ye.to=ue})(Wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Wt={}));var Ht;(function(ye){function Te(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}ye.from=Te;function ue(Q){return new b.$ZO(Q.agentId,Q.command)}ye.to=ue})(Ht||(e.ChatResponseDetectedParticipantPart=Ht={}));var di;(function(ye){function Te(ue){return{kind:"confirmation",title:ue.title,message:ue.message,data:ue.data}}ye.from=Te})(di||(e.ChatResponseConfirmationPart=di={}));var Ft;(function(ye){function Te(Q){const{value:Ee,baseUri:We}=Q;function Ye(Ge,ut){return Ge.map(Pt=>{const Yt=o.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:Yt,children:Pt.children&&Ye(Pt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,E.$ah)(We),uri:We,children:Ye(Ee,We)}}}ye.from=Te;function ue(Q){const Ee=(0,c.$_h)(Q.treeData);function We(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&We(Pt.children)}))}const Ye=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new b.$2O(Ge,Ye)}ye.to=ue})(Ft||(e.ChatResponseFilesPart=Ft={}));var vt;(function(ye){function Te(Q){const Ee=We=>o.URI.isUri(We);return{kind:"inlineReference",name:Q.title,inlineReference:Ee(Q.value)?Q.value:q.from(Q.value)}}ye.from=Te;function ue(Q){const Ee=(0,c.$_h)(Q);return new b.$3O(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:q.to(Ee.inlineReference),Q.name)}ye.to=ue})(vt||(e.ChatResponseAnchorPart=vt={}));var Ct;(function(ye){function Te(Q){return{kind:"progressMessage",content:be.from(Q.value)}}ye.from=Te;function ue(Q){return new b.$4O(Q.content.value)}ye.to=ue})(Ct||(e.ChatResponseProgressPart=Ct={}));var Tt;(function(ye){function Te(Q){return{kind:"warning",content:be.from(Q.value)}}ye.from=Te;function ue(Q){return new b.$6O(Q.content.value)}ye.to=ue})(Tt||(e.ChatResponseWarningPart=Tt={}));var kt;(function(ye){function Te(ue){return{kind:"progressTask",content:be.from(ue.value)}}ye.from=Te})(kt||(e.ChatTask=kt={}));var Xt;(function(ye){function Te(ue){return{kind:"progressTaskResult",content:typeof ue=="string"?be.from(ue):void 0}}ye.from=Te})(Xt||(e.ChatTaskResult=Xt={}));var qt;(function(ye){function Te(Q,Ee,We){return{kind:"command",command:Ee.toInternal(Q.value,We)??{command:Q.value.command,title:Q.value.title}}}ye.from=Te;function ue(Q,Ee){return new b.$7O(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}ye.to=ue})(qt||(e.ChatResponseCommandButtonPart=qt={}));var $i;(function(ye){function Te(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Ee=>we.from(Ee))}}ye.from=Te;function ue(Q){return new b.$9O(o.URI.revive(Q.uri),Q.edits.map(Ee=>we.to(Ee)))}ye.to=ue})($i||(e.ChatResponseTextEditPart=$i={}));var fi;(function(ye){function Te(Q){const Ee=d.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:o.URI.isUri(Q.iconPath)?{light:o.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&o.URI.isUri(Q.iconPath.light)&&o.URI.isUri(Q.iconPath.dark)?{light:o.URI.revive(Q.iconPath.light),dark:o.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:o.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:q.from(Q.value.value)},iconPath:Ee}:{kind:"reference",reference:o.URI.isUri(Q.value)?Q.value:q.from(Q.value),iconPath:Ee}}ye.from=Te;function ue(Q){const Ee=(0,c.$_h)(Q),We=Ye=>o.URI.isUri(Ye)?Ye:q.to(Ye);return new b.$8O("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=ue})(fi||(e.ChatResponseReferencePart=fi={}));var Ri;(function(ye){function Te(Ee,We,Ye){return Ee instanceof b.$XO?oi.from(Ee):Ee instanceof b.$3O?vt.from(Ee):Ee instanceof b.$8O?fi.from(Ee):Ee instanceof b.$4O?Ct.from(Ee):Ee instanceof b.$2O?Ft.from(Ee):Ee instanceof b.$7O?qt.from(Ee,We,Ye):Ee instanceof b.$9O?$i.from(Ee):Ee instanceof b.$YO?Wt.from(Ee):Ee instanceof b.$ZO?Ht.from(Ee):Ee instanceof b.$6O?Tt.from(Ee):{kind:"markdownContent",content:be.from("")}}ye.from=Te;function ue(Ee,We){switch(Ee.kind){case"reference":return fi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,We)}}ye.to=ue;function Q(Ee,We){switch(Ee.kind){case"markdownContent":return oi.to(Ee);case"inlineReference":return vt.to(Ee);case"progressMessage":return;case"treeData":return Ft.to(Ee);case"command":return qt.to(Ee,We)}}ye.toContent=Q})(Ri||(e.ChatResponsePart=Ri={}));var Mt;(function(ye){function Te(ue){return{prompt:ue.message,command:ue.command,attempt:ue.attempt??0,enableCommandDetection:ue.enableCommandDetection??!0,references:ue.variables.variables.map(ai.to),location:Ti.to(ue.location),acceptedConfirmationData:ue.acceptedConfirmationData,rejectedConfirmationData:ue.rejectedConfirmationData}}ye.to=Te})(Mt||(e.ChatAgentRequest=Mt={}));var Ti;(function(ye){function Te(Q){switch(Q){case $.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ye.to=Te;function ue(Q){switch(Q){case b.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=ue})(Ti||(e.ChatLocation=Ti={}));var ai;(function(ye){function Te(ue){const Q=ue.value;if(!Q)throw new Error("Invalid value reference");return{id:ue.id,name:ue.name,range:ue.range&&[ue.range.start,ue.range.endExclusive],value:(0,o.$wc)(Q)?o.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,o.$wc)(Q.uri)?q.to((0,c.$_h)(Q)):Q,modelDescription:ue.modelDescription}}ye.to=Te})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(ye){function Te(ue,Q,Ee){return{id:ue.id,label:ue.label,fullName:ue.fullName,icon:ue.icon?.id,value:ue.values[0].value,insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation,command:Q.toInternal(ue.command,Ee)}}ye.from=Te})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Di;(function(ye){function Te(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}ye.to=Te})(Di||(e.ChatAgentResult=Di={}));var Si;(function(ye){function Te(ue,Q,Ee){if(Q.action.kind==="vote")return;const We=Di.to(ue);if(Q.action.kind==="command"){const Ye=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Nt.to(Q.action.followup)},result:We}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:We}:{action:Q.action,result:We}}ye.to=Te})(Si||(e.ChatAgentUserActionEvent=Si={}));var vi;(function(ye){function Te(ue,Q,Ee){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:Q.toInternal(ue,Ee)}ye.from=Te})(vi||(e.TerminalQuickFix=vi={}));var Oi;(function(ye){function Te(ue){return{kind:gi.to(ue.kind)}}ye.to=Te})(Oi||(e.PartialAcceptInfo=Oi={}));var gi;(function(ye){function Te(ue){switch(ue){case s.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ye.to=Te})(gi||(e.PartialAcceptTriggerKind=gi={}));var Vt;(function(ye){function Te(ue,Q){return{id:Q,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ue.contextValue}}ye.from=Te})(Vt||(e.DebugTreeItem=Vt={}))}),define(Ce[274],Ie([1,0,6,17,10,39]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;let A=class{constructor(p,c){this.a=p.getProxy(w.$YM.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>c.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,R){const v=new O.$Nw(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(v,void 0,R?.isRefactoring??!1)}};e.$knc=A,e.$knc=A=He([Ve(0,C.$sP)],A)}),define(Ce[275],Ie([1,0,18,11,48,4,40,5,70,15,2,19,6,10,7,235,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0,E=qe(E),d=qe(d);class a{constructor(n,t,m,f,l){this.j=n,this.k=t,this.l=m,this.m=f,this.n=l,this.b=p.$de.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(f){if(n.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,f),l}};const n=this;this.b.reset();const m=(f,l)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),l){const $=this.l.$handleProgressChunk(this.k.requestId,f),I={report:D=>{$?.then(y=>{y&&(d.$qN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),y))})}};Promise.all([$,l?.(I)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){t(this.markdown);const l=new d.$XO(f),$=E.ChatResponseMarkdownPart.from(l);return m($),this},markdownWithVulnerabilities(f,l){t(this.markdown),l&&(0,o.$2G)(n.j,"chatParticipantAdditions");const $=new d.$YO(f,l),I=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return m(I),this},filetree(f,l){t(this.filetree);const $=new d.$2O(f,l),I=E.ChatResponseFilesPart.from($);return m(I),this},anchor(f,l){t(this.anchor);const $=new d.$3O(f,l),I=E.ChatResponseAnchorPart.from($);return m(I),this},button(f){t(this.anchor);const l=new d.$7O(f),$=E.ChatResponseCommandButtonPart.from(l,n.m,n.n);return m($),this},progress(f,l){t(this.progress);const $=new d.$5O(f,l),I=l?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return m(I,l),this},warning(f){t(this.progress),(0,o.$2G)(n.j,"chatParticipantAdditions");const l=new d.$6O(f),$=E.ChatResponseWarningPart.from(l);return m($),this},reference(f,l){if(t(this.reference),"variableName"in f&&(0,o.$2G)(n.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const $=n.k.variables.variables.find(I=>I.name===f.variableName);if($){let I;if($.references?.length)I=$.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new d.$8O(f,l);I=[E.ChatResponseReferencePart.from(D)]}return I.forEach(D=>m(D)),this}}else{const $=new d.$8O(f,l),I=E.ChatResponseReferencePart.from($);m(I)}return this},textEdit(f,l){t(this.textEdit),(0,o.$2G)(n.j,"chatParticipantAdditions");const $=new d.$9O(f,l),I=E.ChatResponseTextEditPart.from($);return m(I),this},detectedParticipant(f,l){t(this.detectedParticipant),(0,o.$2G)(n.j,"chatParticipantAdditions");const $=new d.$ZO(f,l),I=E.ChatResponseDetectedParticipantPart.from($);return m(I),this},confirmation(f,l,$){t(this.confirmation),(0,o.$2G)(n.j,"chatParticipantAdditions");const I=new d.$1O(f,l,$),D=E.ChatResponseConfirmationPart.from(I);return m(D),this},push(f){if(t(this.push),(f instanceof d.$9O||f instanceof d.$YO||f instanceof d.$ZO||f instanceof d.$6O||f instanceof d.$1O)&&(0,o.$2G)(n.j,"chatParticipantAdditions"),f instanceof d.$8O)this.reference(f.value,f.iconPath);else{const l=E.ChatResponsePart.from(f,n.m,n.n);m(l)}return this}}}return this.g}}class h extends M.$Vc{static{this.b=0}constructor(n,t,m,f){super(),this.n=t,this.s=m,this.t=f,this.c=new Map,this.j=this.B(new M.$5c),this.m=this.B(new M.$5c),this.g=n.getProxy(u.$YM.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,t,m){const f=h.b++,l=new i(n,this.t,t,this.g,f,m);return this.c.set(f,l),l.isAgentEnabled()&&this.g.$registerAgent(f,n.identifier,t,{},void 0),l.apiAgent}createDynamicChatAgent(n,t,m,f){const l=h.b++,$=new i(n,this.t,t,this.g,l,f);return this.c.set(l,$),this.g.$registerAgent(l,n.identifier,t,{isSticky:!0},m),$.apiAgent}async $invokeAgent(n,t,m,f){const l=this.c.get(n);if(!l)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new M.$Uc,this.j.set(t.sessionId,$));const I=new a(l.extension,t,this.g,this.s.converter,$);try{const D=await this.u(t.agentId,m),y=l.invoke(E.ChatAgentRequest.to(t),{history:D},I.apiObject,f);return await(0,C.$qh)(Promise.resolve(y).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(g){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${b}`,l.extension),{errorDetails:{message:b},timings:I.timings}}let k;return S?.errorDetails&&(k={...S.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,o.$2G)(l.extension,"chatParticipantPrivate"),{errorDetails:k,timings:I.timings,metadata:S?.metadata}}),f)}catch(D){return this.n.error(D,l.extension),D instanceof d.$gP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.$nj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(n,t){const m=[];for(const f of t.history){const l=E.ChatAgentResult.to(f.result),$=n===f.request.agentId?l:{...l,metadata:void 0};m.push(new d.$0O(f.request.message,f.request.command,f.request.variables.variables.map(E.ChatAgentValueReference.to),f.request.agentId));const I=(0,w.$Ib)(f.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));m.push(new d.$$O(I,$,f.request.agentId,f.request.command))}return m}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,t,m,f,l){const $=this.c.get(t);if(!$)return Promise.resolve([]);const I=await this.u($.id,f),D=E.ChatAgentResult.to(m);return(await $.provideFollowups(D,{history:I},l)).filter(y=>{const S=!y.participant||A.Iterable.some(this.c.values(),k=>k.id===y.participant&&v.$nn.equals(k.extension.identifier,$.extension.identifier));return S||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),S}).map(y=>E.ChatFollowup.from(y,n))}$acceptFeedback(n,t,m,f){const l=this.c.get(n);if(!l)return;const $=E.ChatAgentResult.to(t);let I;switch(m){case r.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(f?{result:$,kind:I,reportIssue:f}:{result:$,kind:I}))}$acceptAction(n,t,m){const f=this.c.get(n);if(!f||m.action.kind==="vote")return;const l=E.ChatAgentUserActionEvent.to(t,m,this.s.converter);l&&f.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(n,t,m){const f=this.c.get(n);if(!f)return[];let l=this.m.get(n);return l?l.clear():(l=new M.$Uc,this.m.set(n,l)),(await f.invokeCompletionProvider(t,m)).map(I=>E.ChatAgentCompletionItem.from(I,this.s.converter,l))}async $provideWelcomeMessage(n,t,m){const f=this.c.get(n);if(f)return await f.provideWelcomeMessage(E.ChatLocation.to(t),m)}async $provideSampleQuestions(n,t,m){const f=this.c.get(n);if(f)return(await f.provideSampleQuestions(E.ChatLocation.to(t),m)).map(l=>E.ChatFollowup.from(l,void 0))}}e.$lnc=h;class i{constructor(n,t,m,f,l,$){this.extension=n,this.w=t,this.id=m,this.x=f,this.y=l,this.z=$,this.m=new O.$je,this.n=new O.$je}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,t){return this.q?await this.q.provider.provideCompletionItems(n,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$1G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,t,m){if(!this.b)return[];const f=await this.b.provideFollowups(n,t,m);return f?f.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(n,t){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(n,t);return m?m.map(f=>typeof f=="string"?f:E.MarkdownString.from(f)):[]}async provideSampleQuestions(n,t){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(n,t);return m||[]}get apiAgent(){let n=!1,t=!1;const m=()=>{n||t||(t=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$XN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(l){f.c=l,m()},get requestHandler(){return f.z},set requestHandler(l){(0,c.$mg)(typeof l=="function","Invalid request handler"),f.z=l},get followupProvider(){return f.b},set followupProvider(l){f.b=l,m()},get isDefault(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.d=l,m()},get helpTextPrefix(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.g=l,m()},get helpTextVariablesPrefix(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.j=l,m()},get helpTextPostfix(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.k=l,m()},get isSecondary(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.l=l,m()},get supportIssueReporting(){return(0,o.$2G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(l){(0,o.$2G)(f.extension,"chatParticipantPrivate"),f.o=l,m()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(l){if((0,o.$2G)(f.extension,"chatParticipantAdditions"),f.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,l.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$2G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(l){(0,o.$2G)(f.extension,"defaultChatParticipant"),f.s=l,m()},get welcomeMessageProvider(){return(0,o.$2G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$1G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){f.t=l,m()},get requester(){return f.t},set supportsSlowReferences(l){(0,o.$2G)(f.extension,"chatParticipantPrivate"),f.u=l,m()},get supportsSlowReferences(){return(0,o.$2G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){n=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(n,t,m,f){return this.z(n,t,m,f)}}}),define(Ce[276],Ie([1,0,14,5,35,6,10,7,25]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0,A=qe(A),M=qe(M);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(O.$YM.MainThreadChatVariables)}async $resolveVariable(u,E,d,r){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,p.$2G)(o.extension,"chatParticipantAdditions");const a=new R(E,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,w.$3)(a)}}registerVariableResolver(u,E,d,r,o,a,h,i,s){const n=c.a++,t=s?P.ThemeIcon.fromId(s):void 0;return this.b.set(n,{extension:u,data:{id:E,name:d,description:r,modelDescription:o,icon:t},resolver:h}),this.c.$registerVariable(n,{id:E,name:d,description:r,modelDescription:o,isSlow:a,fullName:i,icon:t}),(0,C.$Tc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$mnc=c;class R{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const u=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const o=new M.$4O(r),a=A.ChatResponseProgressPart.from(o);return d(a),this},reference(r){E(this.reference);const o=new M.$8O(r),a=A.ChatResponseReferencePart.from(o);return d(a),this},push(r){return E(this.push),r instanceof M.$8O?d(A.ChatResponseReferencePart.from(r)):r instanceof M.$4O&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ce[277],Ie([1,0,11,72,4,5,38,2,94,19,10,7,6,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=d,p=qe(p),R=qe(R),v=qe(v);function d(r,o,a){const h=r.getProxy(u.$YM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$pn,o.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===A.MarshalledId.CommentController){const S=this.b.get(y.handle);return S?S.value:y}else if(y&&y.$mid===A.MarshalledId.CommentThread){const S=y,k=this.b.get(S.commentControlHandle);if(!k)return S;const g=k.getCommentThread(S.commentThreadHandle);return g?g.value:S}else if(y&&(y.$mid===A.MarshalledId.CommentThreadReply||y.$mid===A.MarshalledId.CommentThreadInstance)){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);return k?y.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:y.text}:y}else if(y&&y.$mid===A.MarshalledId.CommentNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.commentUniqueId,b=k.getCommentByUniqueId(g);return b||y}else if(y&&y.$mid===A.MarshalledId.CommentThreadNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.text,b=y.commentUniqueId,L=k.getCommentByUniqueId(b);return L?(typeof L.body=="string"?L.body=g:L.body=new v.$qN(g),L):y}return y}})}createCommentController(y,S,k){const g=i.a++,b=new n(y,g,S,k);this.b.set(b.handle,b);const L=this.c.get(y.identifier)||[];return L.push(b),this.c.set(y.identifier,L),b.value}async $createCommentThreadTemplate(y,S,k,g){const b=this.b.get(y);b&&b.$createCommentThreadTemplate(S,k,g)}async $setActiveComment(y,S){const k=this.b.get(y);k&&k.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(y,S,k){const g=this.b.get(y);g&&g.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(y,S){this.b.get(y)?.$deleteCommentThread(S)}async $provideCommentingRanges(y,S,k){const g=this.b.get(y);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=await a.ensureDocumentData(M.URI.revive(S));return(0,w.$uh)(async()=>{const L=await g.commentingRangeProvider.provideCommentingRanges(b.document,k);let T;return Array.isArray(L)?T={ranges:L,fileComments:!1}:L?T={ranges:L.ranges||[],fileComments:L.fileComments||!1}:T=L??void 0,T}).then(L=>{let T;return L&&(T={ranges:L.ranges.map(q=>R.Range.from(q)),fileComments:L.fileComments}),T})}$toggleReaction(y,S,k,g,b){const L=this.b.get(y);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,w.$uh)(()=>{const T=L.getCommentThread(S);if(T){const q=T.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&q&&L.reactionHandler)return L.reactionHandler(q,f(b))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,E.$2G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,S,k,g,b,L,T,q,G){this.m=S,this.n=k,this.o=g,this.p=b,this.q=L,this.extensionDescription=T,this.r=q,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$je,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${y}.${this.handle}`),h.$createCommentThread(S,this.handle,this.n,this.o,R.Range.from(this.p),T.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{h.$deleteCommentThread(S,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(N){W.range=N},get comments(){return W.comments},set comments(N){W.comments=N},get collapsibleState(){return W.collapsibleState},set collapsibleState(N){W.collapsibleState=N},get canReply(){return W.canReply},set canReply(N){W.canReply=N},get contextValue(){return W.contextValue},set contextValue(N){W.contextValue=N},get label(){return W.label},set label(N){W.label=N},get state(){return W.state},set state(N){W.state=N},reveal:N=>W.reveal(N),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const y=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};y("range")&&(S.range=R.Range.from(this.p)),y("label")&&(S.label=this.label),y("contextValue")&&(S.contextValue=this.contextValue??null),y("comments")&&(S.comments=this.q.map(k=>t(this,k,this.k,this.extensionDescription))),y("collapsibleState")&&(S.collapseState=l(this.g)),y("canReply")&&(S.canReply=this.canReply),y("state")&&(S.state=$(this.h)),y("applicability")&&(S.applicability=I(this.h)),y("isTemplate")&&(S.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(y){for(const S of this.k){const k=S[0],g=S[1];if(y===g)return k}}async reveal(y){return(0,E.$2G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}He([(0,C.$8h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,E.$2G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$2G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$2G)(this.h,"activeComment"),this.f}constructor(y,S,k,g){this.h=y,this.i=S,this.j=k,this.k=g,this.a=new Map,h.$registerCommentController(this.handle,k,g,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(L){b.options=L},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(L){b.commentingRangeProvider=L},get reactionHandler(){return b.reactionHandler},set reactionHandler(L){b.reactionHandler=L},get activeCommentThread(){return b.activeCommentThread},createCommentThread(L,T,q){return b.createCommentThread(L,T,q).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(y,S,k){S===void 0&&(0,E.$2G)(this.h,"fileComments");const g=new s(this.id,this.handle,void 0,y,S,k,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const S=this.a.get(y.commentThreadHandle);S&&(this.e=y.uniqueIdInThread?S.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(y,S,k){const g=new s(this.id,this.handle,void 0,M.URI.revive(y),R.Range.to(S),[],this.h,!0,k);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(y,S){const k=this.a.get(y);k&&(k.range=R.Range.to(S))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function t(D,y,S,k){let g=S.get(y);return g||(g=++D.commentHandle,S.set(y,g)),y.state!==void 0&&(0,E.$2G)(k,"commentsDraftState"),y.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$2G)(k,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:g,body:typeof y.body=="string"?y.body:R.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(b=>m(b)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function m(D){return{label:D.label,iconPath:D.iconPath?R.$rP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?M.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case v.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case v.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case v.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case v.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function I(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case v.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case v.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ce[278],Ie([1,0,22,76,5,16,24,2,10,68,80,6,7]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0,p=qe(p),v=qe(v),u=qe(u);class E{constructor(m,f){this.document=m,this.b=f,this.a=1,this.c=new R.$9mc("custom documents")}addEdit(m){return this.c.add([m])}async undo(m,f){await this.f(m).undo(),f||this.disposeBackup()}async redo(m,f){await this.f(m).redo(),f||this.disposeBackup()}disposeEdits(m){for(const f of m)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const m=n(this.document.uri)+this.a++;return(0,A.$dh)(this.b,m)}updateBackup(m){this.d?.delete(),this.d=m}disposeBackup(){this.d?.delete(),this.d=void 0}f(m){const f=this.c.get(m,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(m,f){return this.a.get(this.b(m,f))}add(m,f,l){const $=this.b(m,f.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${m} resource:${f.uri}`);const I=new E(f,l);return this.a.set($,I),I}delete(m,f){const l=this.b(m,f.uri);this.a.delete(l)}b(m,f){return`${m}@@@${f}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(m,f,l){return this.b(m,{type:r.Text,extension:f,provider:l})}addCustomProvider(m,f,l){return this.b(m,{type:r.Custom,extension:f,provider:l})}get(m){return this.a.get(m)}b(m,f){if(this.a.has(m))throw new Error(`Provider for viewType:${m} already registered`);return this.a.set(m,f),new u.$1M(()=>this.a.delete(m))}}class a{constructor(m,f,l,$,I){this.d=f,this.f=l,this.g=$,this.h=I,this.b=new o,this.c=new d,this.a=m.getProxy(v.$YM.MainThreadCustomEditors)}registerCustomEditorProvider(m,f,l,$){const I=new P.$Uc;return i(l)?(I.add(this.b.addTextProvider(f,m,l)),this.a.$registerTextEditorProvider((0,c.$Fnc)(m),f,$.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$Dnc)(m))):(I.add(this.b.addCustomProvider(f,m,l)),h(l)&&I.add(l.onDidChangeCustomDocument(D=>{const y=this.i(f,D.document.uri);if(s(D)){const S=y.addEdit(D);this.a.$onDidEdit(D.document.uri,f,S,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$Fnc)(m),f,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,c.$Dnc)(m))),u.$1M.from(I,new u.$1M(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(m,f,l,$,I){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=M.URI.revive(m),S=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:$?.buffer},I);let k;return h(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,S,k),{editable:h(D.provider)}}async $disposeCustomDocument(m,f){const l=this.b.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const $=M.URI.revive(m),{document:I}=this.i(f,$);this.c.delete(f,I),I.dispose()}async $resolveCustomEditor(m,f,l,$,I,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const S=p.ViewColumn.to(I),k=this.g.createNewWebview(f,$.contentOptions,y.extension),g=this.h.createNewWebviewPanel(f,l,$.title,S,$.options,k,$.active),b=M.URI.revive(m);switch(y.type){case r.Custom:{const{document:L}=this.i(l,b);return y.provider.resolveCustomEditor(L,g,D)}case r.Text:{const L=this.d.getDocument(b);return y.provider.resolveCustomTextEditor(L,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(m,f,l){this.i(f,m).disposeEdits(l)}async $onMoveCustomEditor(m,f,l){const $=this.b.get(l);if(!$)throw new Error(`No provider found for '${l}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const I=this.h.getWebviewPanel(m);if(!I)throw new Error("No webview found");const D=M.URI.revive(f),y=this.d.getDocument(D);await $.provider.moveCustomTextEditor(y,I,w.CancellationToken.None)}async $undo(m,f,l,$){return this.i(f,m).undo(l,$)}async $redo(m,f,l,$){return this.i(f,m).redo(l,$)}async $revert(m,f,l){const $=this.i(f,m);await this.j(f).revertCustomDocument($.document,l),$.disposeBackup()}async $onSave(m,f,l){const $=this.i(f,m);await this.j(f).saveCustomDocument($.document,l),$.disposeBackup()}async $onSaveAs(m,f,l,$){const I=this.i(f,m);return this.j(f).saveCustomDocumentAs(I.document,M.URI.revive(l),$)}async $backup(m,f,l){const $=this.i(f,m),D=await this.j(f).backupCustomDocument($.document,{destination:$.getNewBackupUri()},l);return $.updateBackup(D),D.id}i(m,f){const l=this.c.get(m,M.URI.revive(f));if(!l)throw new Error("No custom document found");return l}j(m){const l=this.b.get(m)?.provider;if(!l||!h(l))throw new Error("Custom document is not editable");return l}}e.$Inc=a;function h(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function n(t){const m=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,C.$qj)(m)+""}}),define(Ce[279],Ie([1,0,180,107,2,6,7,10,4,12,29,51]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=void 0,M=qe(M);class E{#e;#t;#i;constructor(o,a,h,i,s,n,t,m){this.d=o,this.e=a,this.f=h,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,h),this.#i=new R.$Bc(f=>n.getComparisonKey(f)),this.#e=t,this.#t=m}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let n;o=[...o].sort(E.k);for(const t of o){const[m,f]=t;if((!n||m.toString()!==n.toString())&&(n&&this.#i.get(n).length===0&&this.#i.delete(n),n=m,h.push(m),this.#i.set(m,[])),f)this.#i.get(m)?.push(...f);else{const l=this.#i.get(m);l&&(l.length=0)}}}if(this.#t.fire(h),!this.#e)return;const i=[];let s=0;for(const n of h){let t=[];const m=this.#i.get(n);if(m)if(m.length>this.g){t=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const $ of m)if($.severity===f[l]&&t.push({...M.Diagnostic.from($),modelVersionId:this.h(n)})===this.g)break e;t.push({severity:C.MarkerSeverity.Info,message:(0,w.localize)(0,null,m.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=m.map(f=>({...M.Diagnostic.from(f),modelVersionId:this.h(n)}));if(i.push([n,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,i]of this)o.call(a,h,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$dnc=E;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const a=new R.$Bc;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,i){this.j=a,this.k=h,this.l=i,this.g=new Map,this.h=new p.$ne({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=o.getProxy(O.$YM.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:i,h:s,j:n,k:t,l:m}=this,f=new class{$changeMany(I,D){i.$changeMany(I,D),n.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,D.length===0?"CLEARING":D)}$clear(I){i.$clear(I),n.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){i.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+u.c++,l=a;else if(!h.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+u.c++;while(h.has(l))}return new class extends E{constructor(){super(a,l,u.e,u.d,I=>m.getDocument(I)?.version,t.extUri,f,s),h.set(l,this)}dispose(){super.dispose(),h.delete(l)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const i of this.g.values())i.forEach((s,n)=>{let t=a.get(s.toString());typeof t>"u"&&(t=h.length,a.set(s.toString(),t),h.push([s,[]])),h[t][1]=h[t][1].concat(...n)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(P.URI.revive(a),h.map(M.Diagnostic.to))}};e.$enc=d,e.$enc=d=u=He([Ve(1,c.$9j),Ve(2,v.$cnc)],d)}),define(Ce[280],Ie([1,0,2,14,7,10,212,39]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class p{constructor(R,v,u,E={timeout:1500,errors:3}){this.c=R,this.d=v,this.f=u,this.g=E,this.a=new A.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(v,u,E)=>{const r={dispose:this.a.push([v,u,R])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(R,v){const u=w.URI.revive(R);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(E)break;const a=this.d.getDocument(u),h=await this.h(o,{document:a,reason:O.TextDocumentSaveReason.to(v)});r.push(h)}}finally{clearTimeout(d)}return r}h([R,v,u],E){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,R,v,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,v,u,E){const d=[],r=Date.now(),{document:o,reason:a}=E,{version:h}=o,i=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,C.$9)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{v.apply(u,[i])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,n)=>{const t=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(d).then(m=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),s(m)}).catch(m=>{clearTimeout(t),n(m)})}).then(s=>{const n={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(m=>m instanceof P.$8M))for(const{newText:m,newEol:f,range:l}of t)n.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:l&&O.Range.from(l),text:m,eol:f&&O.EndOfLine.from(f)}});if(n.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new M.$Nw(n)):Promise.reject(new Error("concurrent_edits"))})}}e.$roc=p}),define(Ce[281],Ie([1,0,4,5,2,6,122,10,15,26,7]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0,M=qe(M);class v{constructor(E,d){this.a=new w.$je,this.b=new w.$je,this.c=new w.$je,this.d=new w.$je,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$Uc,this.h=new Map,this.f=E.getProxy(O.$YM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(o=>{this.h.delete(E.toString());const a=P.URI.revive(o);return(0,p.$ng)(this.g.getDocument(a))},o=>(this.h.delete(E.toString()),Promise.reject(o))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(E){const d=P.URI.revive(E),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,r){const o=P.URI.revive(E),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=R.TextDocumentChangeReason.Undo:d.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,c.$ao)({document:a.document,contentChanges:d.changes.map(i=>({range:M.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$uP)(E,d)}}e.$fnc=v}),define(Ce[71],Ie([1,0,282,4,15,2,3,6,17,10,7]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=e.$Jnc=void 0,c=qe(c),e.$Jnc=(0,A.$Ci)("IExtHostEditorTabs");class v{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case M.TabInputKind.TextInput:return new R.$LO(O.URI.revive(this.b.input.uri));case M.TabInputKind.TextDiffInput:return new R.$MO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case M.TabInputKind.TextMergeInput:return new R.$NO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case M.TabInputKind.CustomEditorInput:return new R.$OO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case M.TabInputKind.WebviewEditorInput:return new R.$PO(this.b.input.viewType);case M.TabInputKind.NotebookInput:return new R.$QO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case M.TabInputKind.NotebookDiffInput:return new R.$RO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case M.TabInputKind.TerminalEditorInput:return new R.$SO;case M.TabInputKind.InteractiveEditorInput:return new R.$TO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case M.TabInputKind.ChatEditorInput:return new R.$UO;case M.TabInputKind.MultiDiffEditorInput:return new R.$VO(this.b.input.diffEditors.map(o=>new R.$MO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new v(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===M.TabModelOperationKind.TAB_OPEN){const h=new v(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===M.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===M.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(o){this.b=new C.$je,this.c=new C.$je,this.e=[],this.a=o.getProxy(M.$YM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,P.$ng)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,i)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),i=(0,w.$L)(a,h),s=this.e.filter(f=>i.removed.includes(f.groupId)).map(f=>f.apiObject),n=[],t=[];this.e=o.map(f=>{const l=new u(f,()=>this.d);return i.added.includes(l.groupId)?n.push(l.apiObject):t.push(l.apiObject),l});const m=(0,P.$ng)(o.find(f=>f.isActive===!0)?.groupId);m!==void 0&&this.d!==m&&(this.d=m),this.c.fire(Object.freeze({opened:n,closed:s,changed:t}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(i=>i.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case M.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case M.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case M.TabModelOperationKind.TAB_MOVE:case M.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const i of o){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const i of o){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$Knc=E,e.$Knc=E=He([Ve(0,p.$sP)],E);function d(r){return r.tabs!==void 0}}),define(Ce[283],Ie([1,0,2,6,30,5,7,10,326,13,28,23,25,60]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0,P=qe(P),M=qe(M);class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let i,s,n=p.State.LastKnownState,t=p.State.LastKnownState;for(const m of a){let f=i?(0,c.$Ff)(i,m):0;for(f===0?s=p.State.Start:s=t;f<m.length;f++)f+1===m.length?(n=t,t=p.State.BeforeColon):t+=1,h.push([s,m.toUpperCase().charCodeAt(f),t]),h.push([s,m.toLowerCase().charCodeAt(f),t]),s=t;i=m,t=n}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$D3(h)}}provideDocumentLinks(a){this.c();const h=[],i=p.$E3.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of i){const n=M.DocumentLink.to(s);n.target&&h.push(n)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(C.$YM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,i,s={}){if(r.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const n=this.h++;this.b.add(h),this.d.add(h),this.c.set(n,i);let t=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(t+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(t+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(t+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$2G)(a,"fsChunks"),t+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let m;s.isReadonly&&(0,E.$2k)(s.isReadonly)&&s.isReadonly.value!==""&&(m={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(n,h,t,m).catch(l=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(l)});const f=i.onDidChangeFile(l=>{const $=[];for(const I of l){const{uri:D,type:y}=I;if(D.scheme!==h)continue;let S;switch(y){case A.FileChangeType.Changed:S=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:S=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:S=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:S})}this.a.$onFileSystemChange(n,$)});return(0,O.$Tc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:i,mtime:s,size:n,permissions:t}=a;return{type:h,ctime:i,mtime:s,size:n,permissions:t}}$stat(a,h){return Promise.resolve(this.l(a).stat(w.URI.revive(h))).then(i=>r.k(i))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(w.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(w.URI.revive(h))).then(i=>v.$Le.wrap(i))}$writeFile(a,h,i,s){return Promise.resolve(this.l(a).writeFile(w.URI.revive(h),i.buffer,s))}$delete(a,h,i){return Promise.resolve(this.l(a).delete(w.URI.revive(h),i))}$rename(a,h,i,s){return Promise.resolve(this.l(a).rename(w.URI.revive(h),w.URI.revive(i),s))}$copy(a,h,i,s){const n=this.l(a);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(w.URI.revive(h),w.URI.revive(i),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(w.URI.revive(h)))}$watch(a,h,i,s){const n=this.l(a).watch(w.URI.revive(i),s);this.f.set(h,n)}$unwatch(a,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(a,h,i){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(w.URI.revive(h),i))}$close(a,h){const i=this.l(a);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(a,h,i,s){const n=this.l(a);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const t=v.$Le.alloc(s);return Promise.resolve(n.read(h,i,t.buffer,0,s)).then(m=>t.slice(0,m))}$write(a,h,i,s){const n=this.l(a);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(h,i,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$uoc=r}),define(Ce[284],Ie([1,0,4,41,2,6,10,7,30,47]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,i){this.a=Math.random(),this.b=new w.$je,this.c=new w.$je,this.d=new w.$je,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const s=(0,C.$wk)(h),n=typeof h=="string",t=i?.correlate,m=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(t&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const l of f.created){const $=P.URI.revive(l);s($.fsPath)&&(!n||r.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const l of f.changed){const $=P.URI.revive(l);s($.fsPath)&&(!n||r.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const l of f.deleted){const $=P.URI.revive(l);s($.fsPath)&&(!n||r.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=M.$1M.from(this.i(d,o,h,i,i?.correlate),this.b,this.c,this.d,m)}i(d,r,o,a,h){const i=M.$1M.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return i;const s=d.getProxy(O.$YM.MainThreadFileSystemEventService);let n=!1;(o.pattern.includes(C.$sk)||o.pattern.includes(C.$tk))&&(n=!0);let t;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(t=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(t&=~p.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(t&=~p.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(t&=~p.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:n,excludes:a?.excludes??[],filter:t},!!h),M.$1M.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class v{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$W(()=>this.a.created.map(P.URI.revive)),this.c=new c.$W(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$W(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new w.$je,this.b=new w.$je,this.c=new w.$je,this.d=new w.$je,this.g=new w.$le,this.h=new w.$le,this.i=new w.$le,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new R(this.j,d,r,this.a.event,A.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new v(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const i=function(n){o.call(a,n)};return i.extension=d,r.event(i,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},o,a);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},o,a);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,i=[];if(await d.fireAsync(r,a,async(n,t)=>{const m=Date.now(),f=await Promise.resolve(n);f instanceof M.$$M&&(i.push([t.extension,f]),h.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-m>o&&this.k.warn("SLOW file-participant",t.extension.identifier)}),a.isCancellationRequested||i.length===0)return;const s={edits:[]};for(const[,n]of i){const{edits:t}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:m=>this.l.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(t)}return{edit:s,extensionNames:Array.from(h)}}}e.$voc=u}),define(Ce[285],Ie([1,0,18,11,22,14,97,5,26,70,13,15,2,33,327,94,104,182,19,10,7,25,80,6]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0,r=qe(r),i=qe(i),m=qe(m);class f{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const K=this.d.getDocument(z),J=await this.e.provideDocumentSymbols(K,j);if(!(0,w.$Lb)(J))return J[0]instanceof s.$iN?J.map(i.DocumentSymbol.from):f.f(J)}static f(z){z=z.slice(0).sort((J,ne)=>{let fe=J.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(J.location.range.end)),fe});const j=[],K=[];for(const J of z){const ne={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(K.length===0){K.push(ne),j.push(ne);break}const fe=K[K.length-1];if(E.$Ft.containsRange(fe.range,ne.range)&&!E.$Ft.equalsRange(fe.range,ne.range)){fe.children?.push(ne),K.push(ne);break}K.pop()}}return j}}class l{constructor(z,j,K,J,ne,fe){this.f=z,this.g=j,this.h=K,this.j=J,this.k=ne,this.l=fe,this.d=new t.$9mc("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const K=this.f.getDocument(z),J=await this.h.provideCodeLenses(K,j);if(!J||j.isCancellationRequested)return;const ne=this.d.add(J),fe=new M.$Uc;this.e.set(ne,fe);const Ae={cacheId:ne,lenses:[]};for(let ze=0;ze<J.length;ze++)Ae.lenses.push({cacheId:[ne,ze],range:i.Range.from(J[ze].range),command:this.g.toInternal(J[ze].command,fe)});return Ae}async resolveCodeLens(z,j){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let J;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?J=K:J=await this.h.resolveCodeLens(K,j),J||(J=K),j.isCancellationRequested)return;const ne=z.cacheId&&this.e.get(z.cacheId[0]);if(ne){if(!J.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return z.command=this.g.toInternal(J.command,ne),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function $(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class I{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideDefinition(J,ne,K);return $(fe)}}class D{constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideDeclaration(J,ne,K);return $(fe)}}class y{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideImplementation(J,ne,K);return $(fe)}}class S{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideTypeDefinition(J,ne,K);return $(fe)}}class k{static{this.f=10}constructor(z,j){this.g=z,this.h=j,this.d=0,this.e=new Map}async provideHover(z,j,K,J){const ne=this.g.getDocument(z),fe=i.Position.to(j);let Ae;if(K&&K.verbosityRequest){const it=K.verbosityRequest.previousHover.id,nt=this.e.get(it);if(!nt)throw new Error(`Hover with id ${it} not found`);const tt={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ae=await this.h.provideHover(ne,fe,J,tt)}else Ae=await this.h.provideHover(ne,fe,J);if(!Ae||(0,w.$Lb)(Ae.contents))return;Ae.range||(Ae.range=ne.getWordRangeAtPosition(fe)),Ae.range||(Ae.range=new s.$3M(fe,fe));const ze=i.Hover.from(Ae),Ke=this.d;if(this.e.size===k.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Ke,Ae),this.d+=1,{...ze,id:Ke}}releaseHover(z){this.e.delete(z)}}class g{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideEvaluatableExpression(J,ne,K);if(fe)return i.EvaluatableExpression.from(fe)}}class b{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,K,J){const ne=this.d.getDocument(z),fe=await this.e.provideInlineValues(ne,i.Range.to(j),i.InlineValueContext.to(K),J);if(Array.isArray(fe))return fe.map(Ae=>i.InlineValue.from(Ae))}}class L{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideDocumentHighlights(J,ne,K);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class T{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,K,J){const ne=this.d.getDocument(z),fe=K.map(Ke=>this.d.getDocument(Ke)),Ae=i.Position.to(j),ze=await this.e.provideMultiDocumentHighlights(ne,Ae,fe,J);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class q{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,K){const J=this.d.getDocument(z),ne=i.Position.to(j),fe=await this.e.provideLinkedEditingRanges(J,ne,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,w.$Ib)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,K,J){const ne=this.d.getDocument(z),fe=i.Position.to(j),Ae=await this.e.provideReferences(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(i.location.from)}}class W{static{this.d=1e3}constructor(z,j,K,J,ne,fe,Ae){this.g=z,this.h=j,this.j=K,this.k=J,this.l=ne,this.m=fe,this.n=Ae,this.e=new t.$9mc("CodeAction"),this.f=new Map}async provideCodeActions(z,j,K,J){const ne=this.g.getDocument(z),fe=d.$Ht.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ae=[];for(const tt of this.j.getDiagnostics(z))if(fe.intersection(tt.range)&&Ae.push(tt)>W.d)break;const ze={diagnostics:Ae,only:K.only?new s.$kN(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ne,fe,ze,J);if(!(0,w.$Mb)(Ke)||J.isCancellationRequested)return;const _e=this.e.add(Ke),it=new M.$Uc;this.f.set(_e,it);const nt=[];for(let tt=0;tt<Ke.length;tt++){const rt=Ke[tt];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=rt.ranges??[];nt.push({cacheId:[_e,tt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,n.$1G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,n.$1G)(this.m,"codeActionRanges")?(0,w.$Ib)($t.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(z,j){const[K,J]=z,ne=this.e.get(K,J);if(!ne||W.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,j)??ne;let Ae;fe.edit&&(Ae=i.WorkspaceEdit.from(fe.edit,void 0));let ze;if(fe.command){const Ke=this.f.get(K);Ke&&(ze=this.h.toInternal(fe.command,Ke))}return{edit:Ae,command:ze}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class N{constructor(z,j,K,J,ne){this.e=z,this.f=j,this.g=K,this.h=J,this.j=ne,this.d=new t.$9mc("DocumentPasteEdit")}async prepareDocumentPaste(z,j,K,J){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(z),fe=j.map(Ke=>i.Range.to(Ke)),Ae=i.DataTransfer.toDataTransfer(K,()=>{throw new O.$_});if(await this.g.prepareDocumentPaste(ne,fe,Ae,J),J.isCancellationRequested)return;const ze=Array.from(Ae).filter(([,Ke])=>!(Ke instanceof s.$QN));return i.DataTransfer.from(ze)}async providePasteEdits(z,j,K,J,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(j),ze=K.map(nt=>i.Range.to(nt)),Ke=i.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolvePasteFileData(this.h,z,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ae,ze,Ke,{only:ne.only?new s.$VN(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,j){const[K,J]=z,ne=this.d.get(K,J);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,j)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class V{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,K){const J=this.d.getDocument(z),ne=await this.e.provideDocumentFormattingEdits(J,j,K);if(Array.isArray(ne))return ne.map(i.TextEdit.from)}}class ce{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,K,J){const ne=this.d.getDocument(z),fe=i.Range.to(j),Ae=await this.e.provideDocumentRangeFormattingEdits(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,K,J){(0,v.$mg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(z),fe=j.map(i.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ne,fe,K,J);if(Array.isArray(Ae))return Ae.map(i.TextEdit.from)}}class ge{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,K,J,ne){const fe=this.d.getDocument(z),Ae=i.Position.to(j),ze=await this.e.provideOnTypeFormattingEdits(fe,Ae,K,J,ne);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class ie{constructor(z,j){this.e=z,this.f=j,this.d=new t.$9mc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const K=await this.e.provideWorkspaceSymbols(z,j);if(!(0,w.$Mb)(K))return{symbols:[]};const J=this.d.add(K),ne={cacheId:J,symbols:[]};for(let fe=0;fe<K.length;fe++){const Ae=K[fe];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ne.symbols.push({...i.WorkspaceSymbol.from(Ae),cacheId:[J,fe]})}return ne}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const J=await this.e.resolveWorkspaceSymbol(K,j);return J&&(0,p.$co)(z,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class me{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideRenameEdits(z,j,K,J){const ne=this.d.getDocument(z),fe=i.Position.to(j);try{const Ae=await this.e.provideRenameEdits(ne,fe,K,J);return Ae?i.WorkspaceEdit.from(Ae):void 0}catch(Ae){const ze=me.g(Ae);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(z,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(z),ne=i.Position.to(j);try{const fe=await this.e.prepareRename(J,ne,K);let Ae,ze;if(s.$3M.isRange(fe)?(Ae=fe,ze=J.getText(fe)):(0,v.$eg)(fe)&&(Ae=fe.range,ze=fe.placeholder),!Ae||!ze)return;if(Ae.start.line>ne.line||Ae.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ae),text:ze}}catch(fe){const Ae=me.g(fe);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(fe)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class se{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(z,j,K){this.e=z,this.f=j,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,j,K,J){const ne=this.e.getDocument(z),fe=i.Range.to(j);try{const Ae=se.d[K],ze=await this.f.provideNewSymbolNames(ne,fe,Ae,J);return ze?ze.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ae){this.g.error(se.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class de{constructor(z,j){this.resultId=z,this.tokens=j}}class be{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,K){const J=this.f.getDocument(z),ne=j!==0?this.d.get(j):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ne.resultId,K):await this.g.provideDocumentSemanticTokens(J,K);return ne&&this.d.delete(j),fe?(fe=be.h(fe),this.o(be.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return be.j(z)?be.k(z)?z:new s.$jO(new Uint32Array(z.data),z.resultId):be.l(z)?be.m(z)?z:new s.$lO(z.edits.map(j=>new s.$kO(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!be.j(j)||!z||!z.tokens)return j;const K=z.tokens,J=K.length,ne=j.data,fe=ne.length;let Ae=0;const ze=Math.min(J,fe);for(;Ae<ze&&K[Ae]===ne[Ae];)Ae++;if(Ae===J&&Ae===fe)return new s.$lO([],j.resultId);let Ke=0;const _e=ze-Ae;for(;Ke<_e&&K[J-Ke-1]===ne[fe-Ke-1];)Ke++;return new s.$lO([{start:Ae,deleteCount:J-Ae-Ke,data:ne.subarray(Ae,fe-Ke)}],j.resultId)}o(z,j){if(be.j(z)){const K=this.e++;return this.d.set(K,new de(z.resultId,z.data)),(0,o.$Ecb)({id:K,type:"full",data:z.data})}if(be.l(z)){const K=this.e++;return be.j(j)?this.d.set(K,new de(j.resultId,j.data)):this.d.set(K,new de(z.resultId)),(0,o.$Ecb)({id:K,type:"delta",deltas:(z.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class re{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,K){const J=this.d.getDocument(z),ne=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(j),K);return ne?this.f(ne):null}f(z){return(0,o.$Ecb)({id:0,type:"full",data:z.data})}}class Pe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,K,J,ne){this.f=z,this.g=j,this.h=K,this.j=J,this.k=ne,this.d=new t.$9mc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,K,J){const ne=this.f.getDocument(z),fe=i.Position.to(j),Ae=ne.getWordRangeAtPosition(fe)||new s.$3M(fe,fe),ze=Ae.with({end:fe}),Ke=new c.$de,_e=await this.h.provideCompletionItems(ne,fe,J,i.CompletionContext.to(K));if(!_e||J.isCancellationRequested)return;const it=Array.isArray(_e)?new s.$xN(_e):_e,nt=Pe.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),tt=new M.$Uc;this.e.set(nt,tt);const rt=[],$t={x:nt,[m.ISuggestResultDtoField.completions]:rt,[m.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ae),insert:i.Range.from(ze)},[m.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[m.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let lt=0;lt<it.items.length;lt++){const st=it.items[lt],ct=this.l(st,[nt,lt],ze,Ae);rt.push(ct)}return $t}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const J=this.l(K,z),ne=await this.h.resolveCompletionItem(K,j);if(!ne)return;const fe=this.l(ne,z);return(J[m.ISuggestDataDtoField.insertText]!==fe[m.ISuggestDataDtoField.insertText]||J[m.ISuggestDataDtoField.insertTextRules]!==fe[m.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J[m.ISuggestDataDtoField.commandIdent]!==fe[m.ISuggestDataDtoField.commandIdent]||J[m.ISuggestDataDtoField.commandId]!==fe[m.ISuggestDataDtoField.commandId]||!(0,p.$do)(J[m.ISuggestDataDtoField.commandArguments],fe[m.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,[m.ISuggestDataDtoField.documentation]:fe[m.ISuggestDataDtoField.documentation],[m.ISuggestDataDtoField.detail]:fe[m.ISuggestDataDtoField.detail],[m.ISuggestDataDtoField.additionalTextEdits]:fe[m.ISuggestDataDtoField.additionalTextEdits],[m.ISuggestDataDtoField.insertText]:fe[m.ISuggestDataDtoField.insertText],[m.ISuggestDataDtoField.insertTextRules]:fe[m.ISuggestDataDtoField.insertTextRules],[m.ISuggestDataDtoField.commandIdent]:fe[m.ISuggestDataDtoField.commandIdent],[m.ISuggestDataDtoField.commandId]:fe[m.ISuggestDataDtoField.commandId],[m.ISuggestDataDtoField.commandArguments]:fe[m.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,K,J){const ne=this.e.get(j[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(z.command,ne),Ae={x:j,[m.ISuggestDataDtoField.label]:z.label,[m.ISuggestDataDtoField.kind]:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,[m.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(i.CompletionItemTag.from),[m.ISuggestDataDtoField.detail]:z.detail,[m.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),[m.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[m.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[m.ISuggestDataDtoField.preselect]:z.preselect||void 0,[m.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[m.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[m.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),[m.ISuggestDataDtoField.commandIdent]:fe?.$ident,[m.ISuggestDataDtoField.commandId]:fe?.id,[m.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[m.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ae[m.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof s.$_M&&(Ae[m.ISuggestDataDtoField.insertText]=z.insertText.value,Ae[m.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return z.textEdit?ze=z.textEdit.range:z.range&&(ze=z.range),s.$3M.isRange(ze)?Ae[m.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!K?.isEqual(ze.inserting)||!J?.isEqual(ze.replacing))&&(Ae[m.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ae}}class Le{async provideInlineCompletions(z,j,K,J){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,K){}handlePartialAccept(z,j,K,J){}}class Y extends Le{constructor(z,j,K,J){super(),this.f=z,this.g=j,this.h=K,this.j=J,this.d=new _,this.e=(0,n.$1G)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$1G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,K,J){const ne=this.g.getDocument(z),fe=i.Position.to(j),Ae=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const ze=Array.isArray(Ae)?Ae:Ae.items,Ke=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],_e=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:ze}),items:ze.map((tt,rt)=>{let $t;tt.command&&(it||(it=new M.$Uc),$t=this.j.toInternal(tt.command,it));const lt=tt.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:$t,idx:rt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(it||(it=new M.$Uc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,K){const J=this.d.get(z)?.items[j];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,K)}handlePartialAccept(z,j,K,J){const ne=this.d.get(z)?.items[j];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,K),this.h.handleDidPartiallyAcceptCompletionItem(ne,i.PartialAcceptInfo.to(J)))}}class B{async provideInlineEdits(z,j,K){const J=this.f.getDocument(z),ne=await this.g.provideInlineEdit(J,{triggerKind:this.e[j.triggerKind]},K);if(!ne||K.isCancellationRequested)return;let fe;const Ae=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let ze;ne.accepted&&(fe||(fe=new M.$Uc),ze=this.h.toInternal(ne.accepted,fe));let Ke;return ne.rejected&&(fe||(fe=new M.$Uc),Ke=this.h.toInternal(ne.rejected,fe)),{pid:Ae,text:ne.text,range:i.Range.from(ne.range),accepted:ze,rejected:Ke}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,K,J){this.f=j,this.g=K,this.h=J,this.d=new _,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class we{constructor(z,j){this.e=z,this.f=j,this.d=new t.$9mc("SignatureHelp")}async provideSignatureHelp(z,j,K,J){const ne=this.e.getDocument(z),fe=i.Position.to(j),Ae=this.g(K),ze=await this.f.provideSignatureHelp(ne,fe,J,Ae);if(ze){const Ke=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Ke}}}g(z){let j;if(z.activeSignatureHelp){const K=i.SignatureHelp.to(z.activeSignatureHelp),J=this.d.get(z.activeSignatureHelp.id,0);J?(j=J,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class ae{constructor(z,j,K,J,ne){this.f=z,this.g=j,this.h=K,this.j=J,this.k=ne,this.d=new t.$9mc("InlayHints"),this.e=new Map}async provideInlayHints(z,j,K){const J=this.f.getDocument(z),ne=i.Range.to(j),fe=await this.h.provideInlayHints(J,ne,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(fe);this.e.set(Ae,new M.$Uc);const ze={hints:[],cacheId:Ae};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ne)&&ze.hints.push(this.m(fe[Ke],[Ae,Ke]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),ze}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const J=await this.h.resolveInlayHint(K,j);if(J&&this.l(J))return this.m(J,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const J={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")J.label=z.label;else{const ne=[];J.label=ne;for(const fe of z.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};s.$aN.isLocation(fe.location)&&(Ae.location=i.location.from(fe.location)),fe.command&&(Ae.command=this.g.toInternal(fe.command,K)),ne.push(Ae)}}return J}}class ve{constructor(z,j){this.e=z,this.f=j,this.d=new t.$9mc("DocumentLink")}async provideLinks(z,j){const K=this.e.getDocument(z),J=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(J)||J.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ve.g).map(i.DocumentLink.from)};{const ne=this.d.add(J),fe={links:[],cacheId:ne};for(let Ae=0;Ae<J.length;Ae++){if(!ve.g(J[Ae]))continue;const ze=i.DocumentLink.from(J[Ae]);ze.cacheId=[ne,Ae],fe.links.push(ze)}return fe}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const J=await this.f.resolveDocumentLink(K,j);if(!(!J||!ve.g(J)))return i.DocumentLink.from(J)}releaseLinks(z){this.d.delete(z)}}class le{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const K=this.d.getDocument(z),J=await this.e.provideDocumentColors(K,j);return Array.isArray(J)?J.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(z,j,K){const J=this.d.getDocument(z),ne=i.Range.to(j.range),fe=i.Color.to(j.color),Ae=await this.e.provideColorPresentations(fe,{document:J,range:ne},K);if(Array.isArray(Ae))return Ae.map(i.ColorPresentation.from)}}class X{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,K){const J=this.d.getDocument(z),ne=await this.e.provideFoldingRanges(J,j,K);if(Array.isArray(ne))return ne.map(i.FoldingRange.from)}}class Z{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideSelectionRanges(z,j,K){const J=this.d.getDocument(z),ne=j.map(i.Position.to),fe=await this.e.provideSelectionRanges(J,ne,K);if(!(0,w.$Mb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let ze=0;ze<ne.length;ze++){const Ke=[];Ae.push(Ke);let _e=ne[ze],it=fe[ze];for(;;){if(!it.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(i.SelectionRange.from(it)),!it.parent)break;_e=it.range,it=it.parent}}return Ae}}class pe{constructor(z,j){this.f=z,this.g=j,this.d=new A.$xP(""),this.e=new Map}async prepareSession(z,j,K){const J=this.f.getDocument(z),ne=i.Position.to(j),fe=await this.g.prepareCallHierarchy(J,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ae,ze)):[this.h(Ae,fe)]}async provideCallsTo(z,j,K){const J=this.j(z,j);if(!J)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(J,K);if(ne)return ne.map(fe=>({from:this.h(z,fe.from),fromRanges:fe.fromRanges.map(Ae=>i.Range.from(Ae))}))}async provideCallsFrom(z,j,K){const J=this.j(z,j);if(!J)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(J,K);if(ne)return ne.map(fe=>({to:this.h(z,fe.to),fromRanges:fe.fromRanges.map(Ae=>i.Range.from(Ae))}))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),J=i.CallHierarchyItem.from(j,z,K.size.toString(36));return K.set(J._itemId,j),J}j(z,j){return this.e.get(z)?.get(j)}}class $e{constructor(z,j){this.f=z,this.g=j,this.d=new A.$xP(""),this.e=new Map}async prepareSession(z,j,K){const J=this.f.getDocument(z),ne=i.Position.to(j),fe=await this.g.prepareTypeHierarchy(J,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(ze=>this.h(Ae,ze)):[this.h(Ae,fe)]}async provideSupertypes(z,j,K){const J=this.j(z,j);if(!J)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(J,K);if(ne)return ne.map(fe=>this.h(z,fe))}async provideSubtypes(z,j,K){const J=this.j(z,j);if(!J)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(J,K);if(ne)return ne.map(fe=>this.h(z,fe))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),J=i.TypeHierarchyItem.from(j,z,K.size.toString(36));return K.set(J._itemId,j),J}j(z,j){return this.e.get(z)?.get(j)}}class Me{constructor(z,j,K,J,ne){this.e=z,this.f=j,this.g=K,this.h=J,this.j=ne,this.d=new t.$9mc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,j,K,J,ne){const fe=this.f.getDocument(j),Ae=i.Position.to(K),ze=i.DataTransfer.toDataTransfer(J,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Ae,ze,ne);if(!Ke)return;const _e=(0,w.$3b)(Ke),it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,j){const[K,J]=z,ne=this.d.get(K,J);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,j)??ne;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class je{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,K,J){const ne=u.URI.revive(z),fe=this.d.getDocument(ne),Ae=K.documents.map(_e=>_e.map(it=>({uri:u.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(nt=>i.Range.to(nt))}))),ze={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,j,ze,J);return Ke?i.WorkspaceEdit.from(Ke):null}}class ke{constructor(z,j){this.adapter=z,this.extension=j}}class Re{static{this.d=0}constructor(z,j,K,J,ne,fe,Ae,ze){this.g=j,this.h=K,this.j=J,this.k=ne,this.l=fe,this.m=Ae,this.n=ze,this.f=new Map,this.e=z.getProxy(m.$YM.MainThreadLanguageFeatures)}o(z,j){return i.DocumentSelector.from(z,this.g,j)}p(z){return new s.$1M(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Re.d++}async s(z,j,K,J,ne,fe=!1){const Ae=this.f.get(z);if(!Ae||!(Ae.adapter instanceof j))return J;const ze=Date.now();fe||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Ae.adapter,Ae.extension);return Promise.resolve(Ke).catch(_e=>{(0,O.$5)(_e)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ae.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(ne)?(0,C.$rh)(Ke,ne):Ke}t(z,j){const K=this.q();return this.f.set(K,new ke(z,j)),K}static u(z){return z.displayName||z.name}static w(z){return z.identifier.value}registerDocumentSymbolProvider(z,j,K,J){const ne=this.t(new f(this.h,K),z),fe=J&&J.label||Re.u(z);return this.e.$registerDocumentSymbolProvider(ne,this.o(j,z),fe),this.p(ne)}$provideDocumentSymbols(z,j,K){return this.s(z,f,J=>J.provideDocumentSymbols(u.URI.revive(j),K),void 0,K)}registerCodeLensProvider(z,j,K){const J=this.q(),ne=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ke(new l(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(J,this.o(j,z),ne);let fe=this.p(J);if(ne!==void 0){const Ae=K.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(ne));fe=s.$1M.from(fe,Ae)}return fe}$provideCodeLenses(z,j,K){return this.s(z,l,J=>J.provideCodeLenses(u.URI.revive(j),K),void 0,K)}$resolveCodeLens(z,j,K){return this.s(z,l,J=>J.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,l,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,K){const J=this.t(new I(this.h,K),z);return this.e.$registerDefinitionSupport(J,this.o(j,z)),this.p(J)}$provideDefinition(z,j,K,J){return this.s(z,I,ne=>ne.provideDefinition(u.URI.revive(j),K,J),[],J)}registerDeclarationProvider(z,j,K){const J=this.t(new D(this.h,K),z);return this.e.$registerDeclarationSupport(J,this.o(j,z)),this.p(J)}$provideDeclaration(z,j,K,J){return this.s(z,D,ne=>ne.provideDeclaration(u.URI.revive(j),K,J),[],J)}registerImplementationProvider(z,j,K){const J=this.t(new y(this.h,K),z);return this.e.$registerImplementationSupport(J,this.o(j,z)),this.p(J)}$provideImplementation(z,j,K,J){return this.s(z,y,ne=>ne.provideImplementation(u.URI.revive(j),K,J),[],J)}registerTypeDefinitionProvider(z,j,K){const J=this.t(new S(this.h,K),z);return this.e.$registerTypeDefinitionSupport(J,this.o(j,z)),this.p(J)}$provideTypeDefinition(z,j,K,J){return this.s(z,S,ne=>ne.provideTypeDefinition(u.URI.revive(j),K,J),[],J)}registerHoverProvider(z,j,K,J){const ne=this.t(new k(this.h,K),z);return this.e.$registerHoverProvider(ne,this.o(j,z)),this.p(ne)}$provideHover(z,j,K,J,ne){return this.s(z,k,fe=>fe.provideHover(u.URI.revive(j),K,J,ne),void 0,ne)}$releaseHover(z,j){this.s(z,k,K=>Promise.resolve(K.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(z,j,K,J){const ne=this.t(new g(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(j,z)),this.p(ne)}$provideEvaluatableExpression(z,j,K,J){return this.s(z,g,ne=>ne.provideEvaluatableExpression(u.URI.revive(j),K,J),void 0,J)}registerInlineValuesProvider(z,j,K,J){const ne=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new b(this.h,K),z);this.e.$registerInlineValuesProvider(fe,this.o(j,z),ne);let Ae=this.p(fe);if(ne!==void 0){const ze=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Ae=s.$1M.from(Ae,ze)}return Ae}$provideInlineValues(z,j,K,J,ne){return this.s(z,b,fe=>fe.provideInlineValues(u.URI.revive(j),K,J,ne),void 0,ne)}registerDocumentHighlightProvider(z,j,K){const J=this.t(new L(this.h,K),z);return this.e.$registerDocumentHighlightProvider(J,this.o(j,z)),this.p(J)}registerMultiDocumentHighlightProvider(z,j,K){const J=this.t(new T(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(j,z)),this.p(J)}$provideDocumentHighlights(z,j,K,J){return this.s(z,L,ne=>ne.provideDocumentHighlights(u.URI.revive(j),K,J),void 0,J)}$provideMultiDocumentHighlights(z,j,K,J,ne){return this.s(z,T,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(j),K,J.map(Ae=>u.URI.revive(Ae)),ne),void 0,ne)}registerLinkedEditingRangeProvider(z,j,K){const J=this.t(new q(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(J,this.o(j,z)),this.p(J)}$provideLinkedEditingRanges(z,j,K,J){return this.s(z,q,async ne=>{const fe=await ne.provideLinkedEditingRanges(u.URI.revive(j),K,J);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Re.y(fe.wordPattern):void 0}},void 0,J)}registerReferenceProvider(z,j,K){const J=this.t(new G(this.h,K),z);return this.e.$registerReferenceSupport(J,this.o(j,z)),this.p(J)}$provideReferences(z,j,K,J,ne){return this.s(z,G,fe=>fe.provideReferences(u.URI.revive(j),K,J,ne),void 0,ne)}registerCodeActionProvider(z,j,K,J){const ne=new M.$Uc,fe=this.t(new W(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerCodeActionSupport(fe,this.o(j,z),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ne)}))},Re.u(z),Re.w(z),!!K.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(z,j,K,J,ne){return this.s(z,W,fe=>fe.provideCodeActions(u.URI.revive(j),K,J,ne),void 0,ne)}$resolveCodeAction(z,j,K){return this.s(z,W,J=>J.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(z,j){this.s(z,W,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,K){const J=this.t(new V(this.h,K),z);return this.e.$registerDocumentFormattingSupport(J,this.o(j,z),z.identifier,z.displayName||z.name),this.p(J)}$provideDocumentFormattingEdits(z,j,K,J){return this.s(z,V,ne=>ne.provideDocumentFormattingEdits(u.URI.revive(j),K,J),void 0,J)}registerDocumentRangeFormattingEditProvider(z,j,K){const J=typeof K.provideDocumentRangesFormattingEdits=="function",ne=this.t(new ce(this.h,K),z);return this.e.$registerRangeFormattingSupport(ne,this.o(j,z),z.identifier,z.displayName||z.name,J),this.p(ne)}$provideDocumentRangeFormattingEdits(z,j,K,J,ne){return this.s(z,ce,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(j),K,J,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(z,j,K,J,ne){return this.s(z,ce,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(j),K,J,ne),void 0,ne)}registerOnTypeFormattingEditProvider(z,j,K,J){const ne=this.t(new ge(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(ne,this.o(j,z),J,z.identifier),this.p(ne)}$provideOnTypeFormattingEdits(z,j,K,J,ne,fe){return this.s(z,ge,Ae=>Ae.provideOnTypeFormattingEdits(u.URI.revive(j),K,J,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(z,j){const K=this.t(new ie(j,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,j,K){return this.s(z,ie,J=>J.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,j,K){return this.s(z,ie,J=>J.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,ie,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,K){const J=this.t(new me(this.h,K,this.l),z);return this.e.$registerRenameSupport(J,this.o(j,z),me.supportsResolving(K)),this.p(J)}$provideRenameEdits(z,j,K,J,ne){return this.s(z,me,fe=>fe.provideRenameEdits(u.URI.revive(j),K,J,ne),void 0,ne)}$resolveRenameLocation(z,j,K,J){return this.s(z,me,ne=>ne.resolveRenameLocation(u.URI.revive(j),K,J),void 0,J)}registerNewSymbolNamesProvider(z,j,K){const J=this.t(new se(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(J,this.o(j,z)),this.p(J)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this.s(z,se,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,j,K,J,ne){return this.s(z,se,fe=>fe.provideNewSymbolNames(u.URI.revive(j),K,J,ne),void 0,ne)}registerDocumentSemanticTokensProvider(z,j,K,J){const ne=this.t(new be(this.h,K),z),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(j,z),J,fe);let Ae=this.p(ne);if(fe){const ze=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Ae=s.$1M.from(Ae,ze)}return Ae}$provideDocumentSemanticTokens(z,j,K,J){return this.s(z,be,ne=>ne.provideDocumentSemanticTokens(u.URI.revive(j),K,J),null,J)}$releaseDocumentSemanticTokens(z,j){this.s(z,be,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,K,J){const ne=this.t(new re(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(j,z),J),this.p(ne)}$provideDocumentRangeSemanticTokens(z,j,K,J){return this.s(z,re,ne=>ne.provideDocumentRangeSemanticTokens(u.URI.revive(j),K,J),null,J)}registerCompletionItemProvider(z,j,K,J){const ne=this.t(new Pe(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(ne,this.o(j,z),J,Pe.supportsResolving(K),z.identifier),this.p(ne)}$provideCompletionItems(z,j,K,J,ne){return this.s(z,Pe,fe=>fe.provideCompletionItems(u.URI.revive(j),K,J,ne),void 0,ne)}$resolveCompletionItem(z,j,K){return this.s(z,Pe,J=>J.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(z,j){this.s(z,Pe,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,K,J){const ne=new Y(z,this.h,K,this.j.converter),fe=this.t(ne,z);return this.e.$registerInlineCompletionsSupport(fe,this.o(j,z),ne.supportsHandleEvents,h.$nn.toKey(z.identifier.value),J?.yieldTo?.map(Ae=>h.$nn.toKey(Ae))||[]),this.p(fe)}$provideInlineCompletions(z,j,K,J,ne){return this.s(z,Le,fe=>fe.provideInlineCompletions(u.URI.revive(j),K,J,ne),void 0,ne)}$handleInlineCompletionDidShow(z,j,K,J){this.s(z,Le,async ne=>{ne.handleDidShowCompletionItem(j,K,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,K,J,ne){this.s(z,Le,async fe=>{fe.handlePartialAccept(j,K,J,ne)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,Le,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,K){const J=new B(z,this.h,K,this.j.converter),ne=this.t(J,z);return this.e.$registerInlineEditProvider(ne,this.o(j,z),z.identifier),this.p(ne)}$provideInlineEdit(z,j,K,J){return this.s(z,B,ne=>ne.provideInlineEdits(u.URI.revive(j),K,J),void 0,J)}$freeInlineEdit(z,j){this.s(z,B,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,K,J){const ne=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,fe=this.t(new we(this.h,K),z);return this.e.$registerSignatureHelpProvider(fe,this.o(j,z),ne),this.p(fe)}$provideSignatureHelp(z,j,K,J,ne){return this.s(z,we,fe=>fe.provideSignatureHelp(u.URI.revive(j),K,J,ne),void 0,ne)}$releaseSignatureHelp(z,j){this.s(z,we,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,K){const J=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ae(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(ne,this.o(j,z),typeof K.resolveInlayHint=="function",J,Re.u(z));let fe=this.p(ne);if(J!==void 0){const Ae=K.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(J));fe=s.$1M.from(fe,Ae)}return fe}$provideInlayHints(z,j,K,J){return this.s(z,ae,ne=>ne.provideInlayHints(u.URI.revive(j),K,J),void 0,J)}$resolveInlayHint(z,j,K){return this.s(z,ae,J=>J.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(z,j){this.s(z,ae,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,K){const J=this.t(new ve(this.h,K),z);return this.e.$registerDocumentLinkProvider(J,this.o(j,z),typeof K.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(z,j,K){return this.s(z,ve,J=>J.provideLinks(u.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(z,j,K){return this.s(z,ve,J=>J.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,ve,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,K){const J=this.t(new le(this.h,K),z);return this.e.$registerDocumentColorProvider(J,this.o(j,z)),this.p(J)}$provideDocumentColors(z,j,K){return this.s(z,le,J=>J.provideColors(u.URI.revive(j),K),[],K)}$provideColorPresentations(z,j,K,J){return this.s(z,le,ne=>ne.provideColorPresentations(u.URI.revive(j),K,J),void 0,J)}registerFoldingRangeProvider(z,j,K){const J=this.q(),ne=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ke(new X(this.h,K),z)),this.e.$registerFoldingRangeProvider(J,this.o(j,z),z.identifier,ne);let fe=this.p(J);if(ne!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=s.$1M.from(fe,Ae)}return fe}$provideFoldingRanges(z,j,K,J){return this.s(z,X,ne=>ne.provideFoldingRanges(u.URI.revive(j),K,J),void 0,J)}registerSelectionRangeProvider(z,j,K){const J=this.t(new Z(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(J,this.o(j,z)),this.p(J)}$provideSelectionRanges(z,j,K,J){return this.s(z,Z,ne=>ne.provideSelectionRanges(u.URI.revive(j),K,J),[],J)}registerCallHierarchyProvider(z,j,K){const J=this.t(new pe(this.h,K),z);return this.e.$registerCallHierarchyProvider(J,this.o(j,z)),this.p(J)}$prepareCallHierarchy(z,j,K,J){return this.s(z,pe,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(j),K,J)),void 0,J)}$provideCallHierarchyIncomingCalls(z,j,K,J){return this.s(z,pe,ne=>ne.provideCallsTo(j,K,J),void 0,J)}$provideCallHierarchyOutgoingCalls(z,j,K,J){return this.s(z,pe,ne=>ne.provideCallsFrom(j,K,J),void 0,J)}$releaseCallHierarchy(z,j){this.s(z,pe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,K){const J=this.t(new $e(this.h,K),z);return this.e.$registerTypeHierarchyProvider(J,this.o(j,z)),this.p(J)}$prepareTypeHierarchy(z,j,K,J){return this.s(z,$e,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(j),K,J)),void 0,J)}$provideTypeHierarchySupertypes(z,j,K,J){return this.s(z,$e,ne=>ne.provideSupertypes(j,K,J),void 0,J)}$provideTypeHierarchySubtypes(z,j,K,J){return this.s(z,$e,ne=>ne.provideSubtypes(j,K,J),void 0,J)}$releaseTypeHierarchy(z,j){this.s(z,$e,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,K,J){const ne=this.q();return this.f.set(ne,new ke(new Me(this.e,this.h,K,ne,z),z)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(j,z),(0,n.$1G)(z,"documentPaste")&&J?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(z,j,K,J,ne,fe){return this.s(z,Me,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(j,u.URI.revive(K),J,ne,fe)),void 0,void 0)}$resolveDropEdit(z,j,K){return this.s(z,Me,J=>J.resolveDropEdit(j,K),{},void 0)}$releaseDropEdits(z,j){this.s(z,Me,K=>Promise.resolve(K.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(z,j,K){const J=this.t(new je(this.h,K),z);return this.e.$registerMappedEditsProvider(J,this.o(j,z)),this.p(J)}$provideMappedEdits(z,j,K,J,ne){return this.s(z,je,fe=>Promise.resolve(fe.provideMappedEdits(j,K,J,ne)),null,ne)}registerDocumentPasteEditProvider(z,j,K,J){const ne=this.q();return this.f.set(ne,new ke(new N(this.e,this.h,K,ne,z),z)),this.e.$registerPasteEditProvider(ne,this.o(j,z),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(z,j,K,J,ne){return this.s(z,N,fe=>fe.prepareDocumentPaste(u.URI.revive(j),K,J,ne),void 0,ne)}$providePasteEdits(z,j,K,J,ne,fe,Ae){return this.s(z,N,ze=>ze.providePasteEdits(j,u.URI.revive(K),J,ne,fe,Ae),void 0,Ae)}$resolvePasteEdit(z,j,K){return this.s(z,N,J=>J.resolvePasteEdit(j,K),{},void 0)}$releasePasteEdits(z,j){this.s(z,N,K=>Promise.resolve(K.releasePasteEdits(j)),void 0,void 0)}static y(z){return{pattern:z.source,flags:z.flags}}static z(z){return{decreaseIndentPattern:Re.y(z.decreaseIndentPattern),increaseIndentPattern:Re.y(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Re.y(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Re.y(z.unIndentedLinePattern):void 0}}static B(z){return{beforeText:Re.y(z.beforeText),afterText:z.afterText?Re.y(z.afterText):void 0,previousLineText:z.previousLineText?Re.y(z.previousLineText):void 0,action:z.action}}static C(z){return z.map(Re.B)}static D(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>s.SyntaxTokenType.toString(j)):void 0}}static E(z){return z.map(Re.D)}setLanguageConfiguration(z,j,K){const{wordPattern:J}=K;if(J&&(0,R.$pf)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(j,J):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ne=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,j,fe),this.p(ne)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$gnc=Re}),define(Ce[95],Ie([1,0,11,22,14,4,40,5,183,19,3,12,77,6,91,17,10,7,116,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Znc=void 0,o=qe(o),a=qe(a),e.$Znc=(0,R.$Ci)("IExtHostLanguageModels");class n{constructor(l,$){this.option=l,this.stream=new w.$6h,this.stream=$??new w.$6h}}class t{constructor(){this.a=new Map,this.b=new w.$6h,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable,text:w.$3h.map(l.b.asyncIterable,$=>{if($ instanceof a.$cP)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let $=this.a.get(l.index);$||(this.a.size===0?$=new n(l.index,this.b):$=new n(l.index),this.a.set(l.index,$));let I;l.part.type==="text"?I=new a.$cP(l.part.value):I=new a.$bP(l.part.name,l.part.parameters),$.stream.emitOne(I)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const $ of this.f())$.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let m=class{static{s=this}static{this.a=1}constructor(l,$,I){this.j=$,this.k=I,this.c=new O.$je,this.d=new O.$je,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$pn,this.i=new Map,this.r=new Set,this.b=l.getProxy(E.$YM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,$,I,D){const y=s.a++;this.f.set(y,{extension:l.identifier,provider:I,languageModelId:$});let S;D.auth&&(S={providerLabel:l.displayName||l.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$nn.toKey(l.identifier)}/${y}/${$}`,{extension:l.identifier,id:$,vendor:D.vendor??c.$nn.toKey(l.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:S,targetExtensions:D.extensions});const k=I.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:b,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade($,new c.$nn(g),b,L)});return(0,M.$Tc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),k?.dispose()})}async $provideLanguageModelResponse(l,$,I,D,y,S){const k=this.f.get(l);if(!k)return;const g=new u.$pw(async b=>{if(S.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(b.part instanceof a.$bP?L={type:"function_use",name:b.part.name,parameters:b.part.parameters}:b.part instanceof a.$cP&&(L={type:"text",value:b.part.value}),!L){this.j.warn(`[CHAT](${k.extension.value}) UNKNOWN part ${JSON.stringify(b)}`);return}this.b.$handleProgressChunk($,{index:b.index,part:L})});if(k.provider.provideLanguageModelResponse2)return k.provider.provideLanguageModelResponse2(D.map(o.LanguageModelChatMessage.to),y,c.$nn.toKey(I),g,S);{const b=new u.$pw(async L=>{g.report({index:L.index,part:new a.$cP(L.part)})});return k.provider.provideLanguageModelResponse(D.map(o.LanguageModelChatMessage.to),y?.modelOptions??{},c.$nn.toKey(I),b,S)}}$provideTokenLength(l,$,I){const D=this.f.get(l);return D?Promise.resolve(D.provider.provideTokenCount($,I)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:$,metadata:I}of l.added)this.g.set($,{metadata:I,apiObjects:new c.$pn});if(l.removed)for(const $ of l.removed){this.g.delete($);for(const[I,D]of this.i)D.languageModelId===$&&(D.res.reject(new P.$6),this.i.delete(I))}l.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,$){const I=await this.b.$selectChatModels({...$,extension:l.identifier}),D=[],y=this;for(const S of I){const k=this.g.get(S);if(!k)continue;this.o(l.identifier,k.metadata)&&await this.p(k.metadata);let g=k.apiObjects.get(l.identifier);g||(g={id:S,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(b,L){if(!y.g.has(S))throw a.$gP.NotFound(S);return y.q(S,b,L??C.CancellationToken.None)},sendRequest(b,L,T){if(!y.g.has(S))throw a.$gP.NotFound(S);return y.l(l,S,b,L??{},T??C.CancellationToken.None)}},Object.freeze(g),k.apiObjects.set(l.identifier,g)),D.push(g)}return D}async l(l,$,I,D,y){const S=this.m(l,I),k=l.identifier,g=this.g.get($)?.metadata;if(!g||!this.g.has($))throw a.$gP.NotFound(`Language model '${$}' is unknown.`);if(this.o(k,g)&&(!await this.n(l,{identifier:g.extension,displayName:g.auth.providerLabel},D.justification,!1)||!this.h.get(k)?.has(g.extension)))throw a.$gP.NoPermissions(`Language model '${$}' cannot be used by '${k.value}'.`);const b=Math.random()*1e6|0,L=this.b.$fetchResponse(k,$,b,S,D,y),T=new w.$Bh,q=new t;this.i.set(b,{languageModelId:$,res:q});let G;if(L.catch(W=>{T.isOpen()?q.reject(W):G=W}).finally(()=>{this.i.delete(b),q.resolve(),T.open()}),await T.wait(),G)throw G.name===a.$gP.name?G:new a.$gP(`Language model '${$}' errored, check cause for more details`,"Unknown",G);return q.apiObject}m(l,$){const I=[];for(const D of $)D.role===a.LanguageModelChatMessageRole.System&&(0,i.$2G)(l,"languageModelSystem"),D.content2 instanceof a.$_O&&(0,i.$2G)(l,"lmTools"),I.push(o.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(l,$){const I=this.i.get(l);I&&I.res.handleFragment($)}async n(l,$,I,D){const y=h.$1L+$.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0;if(D)return!1;try{const k=I?(0,p.localize)(0,null,$.displayName,I):void 0;return await this.k.getSession(l,y,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(l,$){return!!$.auth&&!c.$nn.equals($.extension,l)}async p(l){if(l.auth)for(const $ of this.r)try{await this.n($,{identifier:l.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(l,$,I){if(!this.g.get(l))throw a.$gP.NotFound(`Language model '${l}' is unknown.`);const y=A.Iterable.find(this.f.values(),S=>S.languageModelId===l);return y?y.provider.provideTokenCount($,I):this.b.$countTokens(l,typeof $=="string"?$:o.LanguageModelChatMessage.from($),I)}$updateModelAccesslist(l){const $=new Array;for(const{from:I,to:D,enabled:y}of l){const S=this.h.get(I)??new c.$on;if(S.has(D)!==y){y?S.add(D):S.delete(D),this.h.set(I,S);const g={from:I,to:D};$.push(g),this.c.fire(g)}}}createLanguageModelAccessInformation(l){this.r.add(l);const $=this,I=O.Event.signal(O.Event.filter(this.c.event,y=>c.$nn.equals(y.from,l.identifier))),D=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(I,D)},canSendRequest(y){let S;e:for(const[g,b]of $.g)for(const L of b.apiObjects.values())if(L===y){S=b.metadata;break e}if(!S)return;if(!$.o(l.identifier,S))return!0;const k=$.h.get(l.identifier);if(k)return k.has(S.extension)}}}};e.$1nc=m,e.$1nc=m=s=He([Ve(0,r.$sP),Ve(1,v.$9j),Ve(2,d.$inc)],m)});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[286],Ie([1,0,6,10,7,36,11,5,25]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0,C=qe(C),O=ri(O);class c{constructor(v,u,E,d){this.c=u,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=v.getProxy(w.$YM.MainThreadLanguages)}$acceptLanguageIds(v){this.b=v}async getLanguages(){return this.b.slice(0)}async changeLanguage(v,u){await this.a.$changeLanguage(v,u);const E=this.c.getDocumentData(v);if(!E)throw new Error(`document '${v.toString()}' NOT found`);return E.document}async tokenAtPosition(v,u){const E=v.version,d=C.Position.from(u),r=await this.a.$tokensAtPosition(v.uri,d),o={type:P.StandardTokenType.Other,range:v.getWordRangeAtPosition(u)??new P.$3M(u.line,u.character,u.line,u.character)};if(!r)return o;const a={range:C.Range.to(r.range),type:C.TokenType.to(r.type)};return!a.range.contains(u)||E!==v.version?o:a}createLanguageStatusItem(v,u,E){const d=this.f++,r=this.a,o=this.g,a=`${v.identifier.value}/${u}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(a);const h={selector:E,id:u,name:v.displayName??v.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new M.$Uc,n=()=>{if(i?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${u}) from ${v.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Eh)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??v.displayName??v.name,source:v.displayName??v.name,selector:C.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?O.default.Error:h.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},t={dispose(){s.dispose(),i?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(m){h.name=m,n()},get selector(){return h.selector},set selector(m){h.selector=m,n()},get text(){return h.text},set text(m){h.text=m,n()},set text2(m){(0,p.$2G)(v,"languageStatusText"),h.text=m,n()},get text2(){return(0,p.$2G)(v,"languageStatusText"),h.text},get detail(){return h.detail},set detail(m){h.detail=m,n()},get severity(){return h.severity},set severity(m){h.severity=m,n()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(m){h.accessibilityInformation=m,n()},get command(){return h.command},set command(m){h.command=m,n()},get busy(){return h.busy},set busy(m){h.busy=m,n()}};return n(),t}}e.$Koc=c}),define(Ce[287],Ie([1,0,16,2,10,7,90]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,P=qe(P),A=qe(A);class M{constructor(v,u,E,d){this.start=v,this.deletedCount=u,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new O.$qO(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1}}constructor(v,u,E){this.notebook=v,this.h=u,this.j=E,this.handle=E.handle,this.uri=C.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const v=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return v.g},set mime(d){v.g=d},get outputs(){return v.a.slice(0)},get metadata(){return v.b},get executionSummary(){return v.d}};this.f=Object.freeze(E)}return this.f}setOutputs(v){this.a=v.map(P.NotebookCellOutput.to)}setOutputItems(v,u,E){const d=E.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===v);if(r&&(u||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>A.$4K(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let i;o.has(h.mime)?i=o.get(h.mime):(i=[],o.set(h.mime,i),a.push(h.mime)),i.push(h.data)}),r.items.length=0,a.forEach(h=>{const i=A.$5K(o.get(h));r.items.push({mime:h,data:i.data.buffer})})}}setMetadata(v){this.b=Object.freeze(v)}setInternalMetadata(v){this.e=v,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.$woc=p;class c{static{this.a=0}constructor(v,u,E,d,r){this.k=v,this.l=u,this.m=E,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const v=this,u={get uri(){return v.uri},get version(){return v.g},get notebookType(){return v.d},get isDirty(){return v.h},get isUntitled(){return v.uri.scheme===w.Schemas.untitled},get isClosed(){return v.j},get metadata(){return v.f},get cellCount(){return v.b.length},cellAt(E){return E=v.n(E),v.b[E].apiCell},getCells(E){return(E?v.p(E):v.b).map(r=>r.apiCell)},save(){return v.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(v){v.metadata&&(this.f=Object.freeze({...this.f,...v.metadata}))}acceptDirty(v){this.h=v}acceptModelChanged(v,u,E){this.g=v.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const a of v.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],i=o.get(h.cell);if(i===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[i]={...d.cellChanges[i],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(v){return v=v|0,v<0?0:v>=this.b.length?this.b.length-1:v}o(v){let u=v.start|0,E=v.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),v.with({start:u,end:E})}p(v){v=this.o(v);const u=[];for(let E=v.start;E<v.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(v,u,E){if(this.j)return;const d=[],r=[],o=[];if(v.reverse().forEach(a=>{const i=a[2].map(t=>{const m=new p(this,this.l,t);return u||r.push(p.asModelAddData(t)),m}),s=new M(a[0],a[1],[],i),n=this.b.splice(a[0],a[1],...i);for(const t of n)o.push(t.uri),s.deletedItems.push(t.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),E)for(const a of d)E.push(a.asApiEvent())}s(v,u,E,d){const r=this.b.splice(v,u);this.b.splice(E,0,...r);const o=[new M(v,u,r.map(a=>a.apiCell),[]),new M(E,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(v,u){this.b[v].setOutputs(u)}u(v,u,E,d){this.b[v].setOutputItems(u,E,d)}v(v,u){const E=this.b[v];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(v,u){const E=this.b[v];E.apiCell.mime=u}x(v,u){this.b[v].setMetadata(u)}y(v,u){this.b[v].setInternalMetadata(u)}getCellFromApiCell(v){return this.b.find(u=>u.apiCell===v)}getCellFromIndex(v){return this.b[v]}getCell(v){return this.b.find(u=>u.handle===v)}getCellIndex(v){return this.b.indexOf(v)}}e.$xoc=c}),define(Ce[288],Ie([1,0,4,2,10,7,39]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class M{constructor(c,R,v,u={timeout:1500,errors:3}){this.b=c,this.c=R,this.d=v,this.f=u,this.a=new w.$le}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(R,v,u)=>{const E=function(r){R.call(v,r)};return E.extension=c,this.a.event(E,void 0,u)}}async $participateInSave(c,R,v){const u=C.URI.revive(c),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(R)},v,async(o,a)=>{const h=Date.now(),i=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!v.isCancellationRequested&&i&&(i instanceof O.$$M?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),v.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new A.$Nw(r))}}e.$Moc=M}),define(Ce[123],Ie([1,0,14,10,7]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0,C=qe(C),P=qe(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(M,p,c,R,v,u){this.id=M,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=v,this.b=R,this.c=u}get apiEditor(){if(!this.e){const M=this;this.e={get notebook(){return M.notebookData.apiNotebook},get selection(){return M.a[0]},set selection(p){this.selections=[p]},get selections(){return M.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$qO.isNotebookRange))throw(0,w.$8)("selections");M.a=p,M.g(p)},get visibleRanges(){return M.b},revealRange(p,c){M.f.$tryRevealRange(M.id,C.NotebookRange.from(p),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return M.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(M){this.d=M}_acceptVisibleRanges(M){this.b=M}_acceptSelections(M){this.a=M}g(M){this.f.$trySetSelections(this.id,M.map(C.NotebookRange.from))}_acceptViewColumn(M){this.c=M}}e.$yoc=O}),define(Ce[289],Ie([1,0,4,12,10]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0,P=qe(P);let O=class{constructor(M,p){this.c=M,this.d=p,this.a=new w.$je,this.b=new w.$je,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(M,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",M,p);const c=this.d.getEditorById(M);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(M){for(const p in M)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(M[p]))}};e.$Ooc=O,e.$Ooc=O=He([Ve(0,C.$9j)],O)}),define(Ce[290],Ie([1,0,4,6,123]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0;class O{constructor(M,p){this.c=p,this.a=new Map,this.b=M.getProxy(C.$YM.MainThreadNotebookRenderers)}$postRendererMessage(M,p,c){const R=this.c.getEditorById(M);this.a.get(p)?.fire({editor:R.apiEditor,message:c})}createRendererMessaging(M,p){if(!M.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,v,u)=>this.d(p).event(R,v,u),postMessage:(R,v)=>{P.$yoc.apiEditorsToExtHost.has(R)&&([R,v]=[v,R]);const u=v&&P.$yoc.apiEditorsToExtHost.get(v);return this.b.$postMessage(u?.id,p,R)}}}d(M){let p=this.a.get(M);return p||(p=new w.$je({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(M)}}),this.a.set(M,p),p)}}e.$Roc=O}),define(Ce[291],Ie([1,0,10,77,22,72,14]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class M{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,u,E){const d=this.b++,{title:r,location:o,cancellable:a}=u,h={label:v.displayName||v.name,id:v.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(o),title:r,source:h,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.$3),this.d(d,E,!!a)}d(v,u,E){let d;E&&(d=new P.$ue,this.c.set(v,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=u(new c(this.a,v),E&&d?d.token:P.CancellationToken.None)}catch(a){throw r(v),a}return o.then(a=>r(v),a=>r(v)),o}$acceptProgressCanceled(v){const u=this.c.get(v);u&&(u.cancel(),this.c.delete(v))}}e.$Voc=M;function p(R,v){return R.message=v.message,typeof v.increment=="number"&&(typeof R.increment=="number"?R.increment+=v.increment:R.increment=v.increment),R}class c extends C.$pw{constructor(v,u){super(E=>this.throttledReport(E)),this.c=v,this.d=u}throttledReport(v){this.c.$progressReport(this.d,v)}}He([(0,O.$9h)(100,(R,v)=>p(R,v),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Ce[292],Ie([1,0,2,6,11,10]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class A{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(C.$YM.MainThreadQuickDiff)}$provideOriginalResource(p,c,R){const v=w.URI.revive(c),u=this.c.get(p);return u?(0,P.$uh)(()=>u.provideOriginalResource(v,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,R,v){const u=A.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(p,this.d),R,v),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Woc=A});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[293],Ie([1,0,22,4,5,6,2,7,14,18,36,35,25,10]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=d,R=ri(R);function d(r,o,a){const h=r.getProxy(O.$YM.MainThreadQuickOpen);class i{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,S,k=w.CancellationToken.None){this.c=void 0;const g=Promise.resolve(y),b=++this.f,L=h.$show(b,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},k),T={},q=L.then(()=>T);return Promise.race([q,g]).then(G=>{if(G===T)return;const W=(0,u.$1G)(D,"quickPickItemTooltip");return g.then(N=>{const V=[];for(let ce=0;ce<N.length;ce++){const ge=N[ce];if(typeof ge=="string")V.push({label:ge,handle:ce});else if(ge.kind===M.QuickPickItemKind.Separator)V.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ie=ge.iconPath?f(ge.iconPath):void 0;V.push({label:ge.label,iconPath:ie?.iconPath,iconClass:ie?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?E.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ce})}}return S&&typeof S.onDidSelectItem=="function"&&(this.c=ce=>{S.onDidSelectItem(N[ce])}),h.$setItems(b,V),L.then(ce=>{if(typeof ce=="number")return N[ce];if(Array.isArray(ce))return ce.map(ge=>N[ge])})})}).then(void 0,G=>{if(!(0,p.$5)(G))return h.$setError(b,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=w.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",y).then(void 0,S=>{if(!(0,p.$5)(S))return Promise.reject(S)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let S;switch(y.severity){case M.InputBoxValidationSeverity.Info:S=R.default.Info;break;case M.InputBoxValidationSeverity.Warning:S=R.default.Warning;break;case M.InputBoxValidationSeverity.Error:S=R.default.Error;break;default:S=y.message?R.default.Error:R.default.Ignore;break}return{content:y.message,severity:S}}async showWorkspaceFolderPick(D,y=w.CancellationToken.None){const S=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!S)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(g=>g.uri.toString()===S.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new $(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const S=this.e.get(D);S instanceof l&&S._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const S=this.e.get(D);S instanceof l&&S._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,S){const k=this.e.get(D);k instanceof l&&k._fireDidTriggerItemButton(y,S)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$je,this.q=new C.$je,this.r=new C.$je,this.s=new C.$je,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,S)=>{const k=y===M.$nO.Back?-1:S;this.o.set(k,y)}),this.z({buttons:D.map((y,S)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===M.$nO.Back?-1:S}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const S=D[y];this.u[y]=S===void 0?null:S}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function n(I){if(I instanceof M.$XN)return{id:I.id};const D=m(I),y=t(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof y=="string"?A.URI.file(y):y}}function t(I){return typeof I=="object"&&"light"in I?I.light:I}function m(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const D=n(I);let y,S;return"id"in D?S=v.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:S}}class l extends s{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$je,this.L=[],this.M=new C.$je,this.N=new C.$je,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,g)=>{this.C.set(g,k),this.D.set(k,g)});const y=(0,u.$1G)(this.O,"quickPickItemTooltip"),S=[];for(let k=0;k<D.length;k++){const g=D[k];if(g.kind===M.QuickPickItemKind.Separator)S.push({type:"separator",label:g.label});else{g.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=g.iconPath?f(g.iconPath):void 0;S.push({handle:k,label:g.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:y?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((L,T)=>({...f(L.iconPath),tooltip:L.tooltip,handle:T}))})}}this.z({items:S})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Ib)(D.map(S=>this.C.get(S)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Ib)(D.map(S=>this.C.get(S)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const S=this.C.get(D);if(!S||!S.buttons||!S.buttons.length)return;const k=S.buttons[y];k&&this.N.fire({button:k,item:S})}}class $ extends s{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(o,a)}}),define(Ce[294],Ie([1,0,2,4,72,5,11,6,18,159,12,19,38,35,10,25,16,21]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0;function i(L){return L instanceof w.URI}function s(L,T){return L.scheme===o.Schemas.file&&T.scheme===o.Schemas.file&&a.$k?L.toString()===T.toString():L.toString().toLowerCase()===T.toString().toLowerCase()}function n(L){if(L)return typeof L.iconPath=="string"?w.URI.file(L.iconPath):w.URI.isUri(L.iconPath)||E.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function t(L){if(L.icon){if(w.URI.isUri(L.icon))return L.icon;if(E.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const T=L.icon;return{light:T.light,dark:T.dark}}}else return}function m(L,T){if(!L.iconPath&&!T.iconPath)return 0;if(L.iconPath){if(!T.iconPath)return 1}else return-1;const q=typeof L.iconPath=="string"?L.iconPath:w.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,G=typeof T.iconPath=="string"?T.iconPath:w.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,c.$Br)(q,G)}function f(L,T){let q=0;if(L.strikeThrough!==T.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==T.faded)return L.faded?1:-1;if(L.tooltip!==T.tooltip)return(L.tooltip||"").localeCompare(T.tooltip||"");if(q=m(L,T),q!==0)return q;if(L.light&&T.light)q=m(L.light,T.light);else{if(L.light)return 1;if(T.light)return-1}if(q!==0)return q;if(L.dark&&T.dark)q=m(L.dark,T.dark);else{if(L.dark)return 1;if(T.dark)return-1}return q}function l(L,T){if(L.command!==T.command)return L.command<T.command?-1:1;if(L.title!==T.title)return L.title<T.title?-1:1;if(L.tooltip!==T.tooltip){if(L.tooltip!==void 0&&T.tooltip!==void 0)return L.tooltip<T.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(L.arguments===T.arguments)return 0;if(L.arguments)if(T.arguments){if(L.arguments.length!==T.arguments.length)return L.arguments.length-T.arguments.length}else return 1;else return-1;for(let q=0;q<L.arguments.length;q++){const G=L.arguments[q],W=T.arguments[q];if(G!==W&&!(i(G)&&i(W)&&s(G,W)))return G<W?-1:1}return 0}function $(L,T){let q=(0,c.$Br)(L.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(q!==0)return q;if(L.command&&T.command)q=l(L.command,T.command);else{if(L.command)return 1;if(T.command)return-1}if(q!==0)return q;if(L.decorations&&T.decorations)q=f(L.decorations,T.decorations);else{if(L.decorations)return 1;if(T.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)q=(0,c.$Br)(L.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)q=(0,c.$Br)(L.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return q}function I(L,T){for(let q=0;q<L.length;q++)if(L[q]!==T[q])return!1;return!0}function D(L,T){return L.command===T.command&&L.title===T.title&&L.tooltip===T.tooltip&&(L.arguments&&T.arguments?I(L.arguments,T.arguments):L.arguments===T.arguments)}function y(L,T){return(0,p.$vb)(L,T,D)}class S{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,r.$2G)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,r.$2G)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,r.$2G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,q,G,W,N){this.k=T,this.l=W,this.m=N,this.d="",this.e=new C.$je,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=G}showValidationMessage(T,q){(0,r.$2G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,q)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Yoc=S;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,q,G,W,N,V,ce){this.q=T,this.s=q,this.t=G,this.u=W,this.v=N,this.multiDiffEditorEnableViewChanges=V,this.w=ce,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$je,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$je,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,q){const G=this.h.get(T);return G?(0,A.$uh)(()=>this.s.executeCommand(G.command,...G.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort($),G=(0,p.$Eb)(this.o,T,$).map(V=>{const ce=V.toInsert.map(ge=>{const ie=this.e++;this.g.set(ie,ge);const me=ge.resourceUri;let se;if(ge.command)if(ge.command.command==="vscode.open"||ge.command.command==="vscode.diff"||ge.command.command==="vscode.changes"){const X=new O.$Uc;se=this.s.converter.toInternal(ge.command,X),this.j.set(ie,X)}else this.h.set(ie,ge.command);const de=(0,r.$1G)(this.w,"scmMultiDiffEditor"),be=de?ge.multiDiffEditorOriginalUri:void 0,re=de?ge.multiFileDiffEditorModifiedUri:void 0,Pe=n(ge.decorations),Le=ge.decorations&&n(ge.decorations.light)||Pe,Y=ge.decorations&&n(ge.decorations.dark)||Pe,B=[Le,Y],_=ge.decorations&&ge.decorations.tooltip||"",we=ge.decorations&&!!ge.decorations.strikeThrough,ae=ge.decorations&&!!ge.decorations.faded,ve=ge.contextValue||"";return{rawResource:[ie,me,B,_,we,ae,ve,se,be,re],handle:ie}});return{start:V.start,deleteCount:V.deleteCount,toInsert:ce}}),W=G.map(({start:V,deleteCount:ce,toInsert:ge})=>[V,ce,ge.map(ie=>ie.rawResource)]),N=G.reverse();for(const{start:V,deleteCount:ce,toInsert:ge}of N){const ie=ge.map(se=>se.handle),me=this.n.splice(V,ce,...ie);for(const se of me)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=T,W}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let q;(0,r.$1G)(this.x,"quickDiffProvider")&&(q=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:q})}get historyProvider(){return(0,r.$2G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,r.$2G)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new O.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new O.$Uc,this.o=T;const q=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:q})}get actionButton(){return(0,r.$2G)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,r.$2G)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=T;const q=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(G=>G.map(W=>this.y.converter.toInternal(W,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:q??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&y(this.t,T))return;this.s.value=new O.$Uc,this.t=T;const q=(T||[]).map(G=>this.y.converter.toInternal(G,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:q})}get selected(){return this.u}constructor(T,q,G,W,N,V,ce){this.x=T,this.y=W,this.z=N,this.A=V,this.B=ce,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new C.$je,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.C=new Map,this.D=new Set,this.#e=G;const ge=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:ce?`rootUri=${encodeURIComponent(ce.toString())}`:void 0});this.f=new S(T,q,this.#e,this.w,ge),this.#e.$registerSourceControl(this.w,N,V,ce,ge)}createResourceGroup(T,q,G){const W=(0,r.$1G)(this.x,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,N=new k(this.#e,this.y,this.w,T,q,W,this.x),V=C.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,V),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const T=[],q=[];for(const[G,W]of this.C){W.dispose();const N=G.onDidUpdateResourceStates(()=>{this.D.add(G),this.eventuallyUpdateResourceStates()});C.Event.once(G.onDidDispose)(()=>{this.D.delete(G),N.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.w,G.handle)}),T.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const V=G._takeResourceStateSnapshot();V.length>0&&q.push([G.handle,V]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.w,T,q),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(q=>{const G=q._takeResourceStateSnapshot();G.length!==0&&T.push([q.handle,G])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}He([(0,P.$8h)(100)],g.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$8h)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,q,G,W){this.l=q,this.m=G,this.n=W,this.g=new Map,this.h=new v.$pn,this.j=new C.$je,this.e=T.getProxy(M.$YM.MainThreadSCM),this.f=T.getProxy(M.$YM.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===u.MarshalledId.ScmResource){const V=this.g.get(N.sourceControlHandle);if(!V)return N;const ce=V.getResourceGroup(N.groupHandle);return ce?ce.getResourceState(N.handle):N}else if(N&&N.$mid===u.MarshalledId.ScmResourceGroup){const V=this.g.get(N.sourceControlHandle);return V?V.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===u.MarshalledId.ScmProvider){const V=this.g.get(N.handle);return V||N}return N}})}createSourceControl(T,q,G,W){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,q,G,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const N=h.d++,V=new g(T,this.m,this.e,this.l,q,G,W);this.g.set(N,V);const ce=this.h.get(T.identifier)||[];return ce.push(V),this.h.set(T.identifier,ce),V}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const q=this.h.get(T.identifier),G=q&&q[q.length-1];return G&&G.inputBox}$provideOriginalResource(T,q,G){const W=w.URI.revive(q);this.n.trace("ExtHostSCM#$provideOriginalResource",T,W.toString());const N=this.g.get(T);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$uh)(()=>N.quickDiffProvider.provideOriginalResource(W,G)).then(V=>V||null)}$onInputBoxValueChange(T,q){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const G=this.g.get(T);return G&&G.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(T,q,G,W){this.n.trace("ExtHostSCM#$executeResourceCommand",T,q,G);const N=this.g.get(T);if(!N)return Promise.resolve(void 0);const V=N.getResourceGroup(q);return V?V.$executeResourceCommand(G,W):Promise.resolve(void 0)}$validateInput(T,q,G){this.n.trace("ExtHostSCM#$validateInput",T);const W=this.g.get(T);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,A.$uh)(()=>W.inputBox.validateInput(q,G)).then(N=>{if(!N)return Promise.resolve(void 0);const V=d.MarkdownString.fromStrict(N.message);return V?Promise.resolve([V,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,q,G,W){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,G,W)??void 0}async $provideHistoryItems(T,q,G,W){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(q,G,W))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemSummary(T,q,G,W){const N=this.g.get(T)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const V=await N.provideHistoryItemSummary(q,G,W);return V?{...V,icon:t(V)}:void 0}async $provideHistoryItemChanges(T,q,G,W){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(q,G,W)??void 0}};e.$Zoc=b,e.$Zoc=b=h=He([Ve(3,R.$9j)],b)}),define(Ce[295],Ie([1,0,6,10,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0;class O{static{this.a=0}constructor(M,p){this.d=p,this.c=new Map,this.b=M.getProxy(w.$YM.MainThreadShare)}async $provideShare(M,p,c){return await this.c.get(M)?.provideShare({selection:C.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(M,p){const c=O.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,C.DocumentSelector.from(M,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$1oc=O}),define(Ce[296],Ie([1,0,7,6,186,5,10,15]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$3oc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$YN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$YN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,d,r,o,a=w.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new O.$Uc,this.#e=u,this.#t=E,o&&r){this.c=(0,w.$AN)(r.identifier,o);const i=d.get(this.c);i&&(a=i.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,h=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(u){if((0,M.$gg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,r,this.r?.internal,d,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$3oc=p;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new w.$1M(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(u,E){this.e=new Map,this.a=u.getProxy(C.$YM.MainThreadStatusBar),this.b=E,this.c=new c(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,d,r){return new p(this.a,this.b,this.e,u,E,d,r)}setStatusBarMessage(u,E){const d=this.c.setMessage(u);let r;return typeof E=="number"?r=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new w.$1M(()=>{d.dispose(),clearTimeout(r)})}}e.$4oc=R}),define(Ce[124],Ie([1,0,33,115,55,82,56,10,2]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=e.$FP=e.$EP=void 0,w=qe(w),M=qe(M);const c=(i,s,n,t)=>{let m=s;return{enumerable:!0,configurable:!1,get(){return m},set(f){if(!n(m,f)){const l=m;m=f,i.listener?.(t(f,l))}}}},R=(i,s)=>i===s,v={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,s)=>!(i.length!==s.length||i.some(n=>!s.find(t=>n.id===t.id)))},u=i=>s=>({op:O.TestItemEventOp.SetProp,update:i(s)}),E=(i,s)=>({range:(()=>{let n;const t=u(m=>({range:w.$Ft.lift(M.Range.from(m))}));return{enumerable:!0,configurable:!1,get(){return n},set(m){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),v.range(n,m)||(n=m,i.listener?.(t(m)))}}})(),label:c(i,s,v.label,u(n=>({label:n}))),description:c(i,void 0,v.description,u(n=>({description:n}))),sortText:c(i,void 0,v.sortText,u(n=>({sortText:n}))),canResolveChildren:c(i,!1,v.canResolveChildren,n=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:c(i,!1,v.busy,u(n=>({busy:n}))),error:c(i,void 0,v.error,u(n=>({error:M.MarkdownString.fromStrict(n)||null}))),tags:c(i,[],v.tags,(n,t)=>({op:O.TestItemEventOp.SetTags,new:n.map(M.TestTag.from),old:t.map(M.TestTag.from)}))}),d=i=>{const s=P.$MI.fromString(i.extId),n=new o(s.controllerId,s.localId,i.label,p.URI.revive(i.uri)||void 0);return n.range=M.Range.to(i.range||void 0),n.description=i.description||void 0,n.sortText=i.sortText||void 0,n.tags=i.tags.map(t=>M.TestTag.to({id:(0,A.$SI)(t).tagId})),n},r=i=>{let s;for(const n of i.tests){const t=d(n.item);(0,C.$oP)(t).parent=s,s=t}return s};e.$EP=r;class o{constructor(s,n,t,m){if(n.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const f=(0,C.$nP)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:m,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,O.$mP)(f,C.$oP,o),enumerable:!0,writable:!1},...E(f,t)})}}e.$FP=o;class a extends o{constructor(s,n){super(s,s,n,void 0),this._isRoot=!0}}e.$GP=a;class h extends O.$iP{constructor(s,n,t){super({controllerId:s,getDocumentVersion:m=>m&&t.getDocument(m)?.version,getApiFor:C.$oP,getChildren:m=>m.children,root:new a(s,n),toITestItem:M.TestItem.from})}}e.$HP=h}),define(Ce[34],Ie([1,0,15,7,10,26,6,18,12,49,33,101,2,5,3,17,124,23,39,48,70,64,67,37]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=void 0,C=qe(C),P=qe(P);let f=class{#e;#t;#i;constructor(S,k,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$YM.MainThreadCommands),this.d=k,this.#i=g,this.#t=S.getProxy(A.$YM.MainThreadTelemetry),this.converter=new l(this,b=>{const L=this.c.get(b);return L?.result===I.Void?L:void 0},k),this.f=[{processArgument(b){return(0,c.$_h)(b)}},{processArgument(b){return(0,O.$bo)(b,function(L){if(R.$Ft.isIRange(L))return P.Range.to(L);if(v.$Et.isIPosition(L))return P.Position.to(L);if(R.$Ft.isIRange(L.range)&&u.URI.isUri(L.uri))return P.location.to(L);if(L instanceof a.$Le)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const k=this.registerCommand(!1,S.id,async(...g)=>{const b=S.args.map((T,q)=>{if(!T.validate(g[q]))throw new Error(`Invalid argument '${T.name}' when running '${S.id}', received: ${typeof g[q]=="object"?JSON.stringify(g[q],null,"	"):g[q]} `);return T.convert(g[q])}),L=await this.executeCommand(S.internalId,...b);return S.result.convert(L,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new C.$1M(()=>{k.dispose(),this.c.delete(S.id)})}registerCommand(S,k,g,b,L,T){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:g,thisArg:b,metadata:L,extension:T}),S&&this.#e.$registerCommand(k),new C.$1M(()=>{this.b.delete(k)&&S&&this.#e.$unregisterCommand(k)})}executeCommand(S,...k){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,k,!0)}async g(S,k,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,k,!1);{let b=!1;const L=(0,O.$bo)(k,function(T){if(T instanceof C.$2M)return P.Position.from(T);if(T instanceof C.$3M)return P.Range.from(T);if(T instanceof C.$aN)return P.location.from(T);if(C.$qO.isNotebookRange(T))return P.NotebookRange.from(T);if(T instanceof ArrayBuffer)return b=!0,a.$Le.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return b=!0,a.$Le.wrap(T);if(T instanceof a.$Le)return b=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(S,b?new h.$Nw(L):L,g);return(0,c.$_h)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(S,k,!1);throw T}}}async h(S,k,g){const b=this.b.get(S);if(!b)throw new Error("Unknown command");const{callback:L,thisArg:T,metadata:q}=b;if(q?.args)for(let W=0;W<q.args.length;W++)try{(0,w.$tg)(k[W],q.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${q.args[W].name}' - ${q.args[W].description}`)}const G=s.$de.create();try{return await L.apply(T,k)}catch(W){if(S===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...k);N&&(S=N.command)}if(this.d.error(W,S,b.extension?.identifier),!g)throw W;if(b.extension?.identifier){const N=this.#i.onExtensionError(b.extension.identifier,W);this.d.trace("forwarded error to extension?",N,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$nj)(W)),this.id=S,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,S,G.elapsed())}}j(S,k,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new n.$qp(k),duration:g})}$executeContributedCommand(S,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?(k=k.map(b=>this.f.reduce((L,T)=>T.processArgument(L,g.extension?.identifier),b)),this.h(S,k,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(k=>(S&&(k=k.filter(g=>g[0]!=="_")),k))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[k,g]of this.b){const{metadata:b}=g;b&&(S[k]=b)}return Promise.resolve(S)}};e.$NP=f,e.$NP=f=He([Ve(0,r.$sP),Ve(1,p.$9j),Ve(2,t.$MP)],f),e.$OP=(0,d.$Ci)("IExtHostCommands");class l{constructor(S,k,g){this.d=S,this.f=k,this.g=g,this.delegatingCommandId=`__vsc${(0,m.$Yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,k){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const b=this.f(S.command);if(b)g.id=b.internalId,g.arguments=b.args.map((L,T)=>L.convert(S.arguments&&S.arguments[T]));else if((0,M.$Mb)(S.arguments)){const L=`${S.command} /${++this.c}`;this.b.set(L,S),k.add((0,E.$Tc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),g.$ident=L,g.id=this.delegatingCommandId,g.arguments=[L],this.g.trace("CommandsConverter#CREATE",S.command,L)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const k=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$PP=l;class ${static{this.Uri=new $("uri","Uri of a text document",S=>u.URI.isUri(S),S=>S)}static{this.Position=new $("position","A position in a text document",S=>C.$2M.isPosition(S),P.Position.from)}static{this.Range=new $("range","A range in a text document",S=>C.$3M.isRange(S),P.Range.from)}static{this.Selection=new $("selection","A selection in a text document",S=>C.$4M.isSelection(S),P.Selection.from)}static{this.Number=new $("number","",S=>typeof S=="number",S=>S)}static{this.String=new $("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=$.Arr($.String)}static Arr(S){return new $(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,k=>Array.isArray(k)&&k.every(g=>S.validate(g)),k=>k.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",S=>S instanceof C.$mN,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",S=>S instanceof C.$KO,P.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",S=>S instanceof o.$FP,P.TestItem.from)}constructor(S,k,g,b){this.name=S,this.description=k,this.validate=g,this.convert=b}optional(){return new $(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,k){return new $(S??this.name,k??this.description,this.validate,this.convert)}}e.$QP=$;class I{static{this.Void=new I("no result",S=>S)}constructor(S,k){this.description=S,this.convert=k}}e.$RP=I;class D{constructor(S,k,g,b,L){this.id=S,this.internalId=k,this.description=g,this.args=b,this.result=L}}e.$SP=D}),define(Ce[297],Ie([1,0,18,16,2,94,104,32,34,10,7]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0,O=qe(O),c=qe(c),R=qe(R);const v=[new p.$SP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of DocumentHighlight-instances.",E(c.DocumentHighlight.to))),new p.$SP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$QP.Uri],new p.$RP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,w.$Lb)(r))return;class a extends R.$hN{static to(i){const s=new a(i.name,c.SymbolKind.to(i.kind),i.containerName||"",new R.$aN(o[0],c.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=c.Range.to(i.selectionRange),s.children=i.children?i.children.map(a.to):[],s}}return r.map(a.to)})),new p.$SP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$QP.Uri,new p.$QP("options","Formatting options",r=>!0,r=>r)],new p.$RP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$SP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$QP.Uri,p.$QP.Range,new p.$QP("options","Formatting options",r=>!0,r=>r)],new p.$RP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$SP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$QP.Uri,p.$QP.Position,new p.$QP("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$QP("options","Formatting options",r=>!0,r=>r)],new p.$RP("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$SP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$SP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$SP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$SP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$SP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Location-instances.",E(c.location.to))),new p.$SP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of Hover-instances.",E(c.Hover.to))),new p.$SP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$QP.Uri,new p.$QP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>R.$2M.isPosition(o)),r=>r.map(c.Position.from))],new p.$RP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new R.$lN(c.Range.to(h),a);return a}))),new p.$SP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$QP.String.with("query","Search string")],new p.$RP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new p.$SP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new p.$SP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$QP.CallHierarchyItem],new p.$RP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new p.$SP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$QP.CallHierarchyItem],new p.$RP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new p.$SP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new p.$SP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$QP.Uri,p.$QP.Position,p.$QP.String.with("newName","The new symbol name")],new p.$RP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new p.$SP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$QP.Uri,p.$QP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$RP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new p.$SP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$QP.Uri],new p.$RP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$hO(r.tokenTypes,r.tokenModifiers)})),new p.$SP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$QP.Uri],new p.$RP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Fcb)(r);if(o.type==="full")return new R.$jO(o.data,void 0)})),new p.$SP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$QP.Uri,p.$QP.Range.optional()],new p.$RP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$hO(r.tokenTypes,r.tokenModifiers)})),new p.$SP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$QP.Uri,p.$QP.Range],new p.$RP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Fcb)(r);if(o.type==="full")return new R.$jO(o.data,void 0)})),new p.$SP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$QP.Uri,p.$QP.Position,p.$QP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$QP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$RP("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new R.$xN([]);const h=r.suggestions.map(i=>c.CompletionItem.to(i,a));return new R.$xN(h,r.incomplete)})),new p.$SP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$QP.Uri,p.$QP.Position,p.$QP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$RP("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new p.$SP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$QP.Uri,p.$QP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$RP("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>E(h=>new R.$pN(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new p.$SP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$QP.Uri,new p.$QP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>R.$3M.isRange(r),r=>R.$4M.isSelection(r)?c.Selection.from(r):c.Range.from(r)),p.$QP.String.with("kind","Code action kind to return code actions for").optional(),p.$QP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$RP("A promise that resolves to an array of Command-instances.",(r,o,a)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const i=new R.$jN(h.title,h.kind?new R.$kN(h.kind):void 0);return h.edit&&(i.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(i.command=a.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(r))),new p.$SP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$QP.Uri],new p.$RP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new R.$DN(c.Range.to(o.range),c.Color.to(o.color))):[])),new p.$SP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$QP("color","The color to show and insert",r=>r instanceof R.$CN,c.Color.from),new p.$QP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new p.$RP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new p.$SP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$QP.Uri,p.$QP.Range],new p.$RP("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new p.$SP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$QP.Uri],new p.$RP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new p.$SP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$RP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new p.$SP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$QP.Uri,p.$QP.Range,new p.$QP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof R.$3M,r=>c.InlineValueContext.from(r))],new p.$RP("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new p.$SP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$QP("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,C.$Mg)(r,C.Schemas.http,C.Schemas.https),r=>r),new p.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),p.$QP.String.with("label","").optional()],p.$RP.Void),new p.$SP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$QP.Uri.with("resource","Resource to open"),p.$QP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],p.$RP.Void),new p.$SP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$QP.Uri.with("left","Left-hand side resource of the diff editor"),p.$QP.Uri.with("right","Right-hand side resource of the diff editor"),p.$QP.String.with("title","Human readable title for the diff editor").optional(),new p.$QP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],p.$RP.Void),new p.$SP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$QP.String.with("title","Human readable title for the changes editor"),new p.$QP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,i]=o;if(!P.URI.isUri(a)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$RP.Void),new p.$SP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$QP.Uri,p.$QP.Position],new p.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$SP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$QP.TypeHierarchyItem],new p.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$SP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$QP.TypeHierarchyItem],new p.$RP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$SP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$QP.TestItem],p.$RP.Void),new p.$SP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$QP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$RP.Void),new p.$SP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$QP.String.with("name","The context key name"),new p.$QP("value","The context key value",()=>!0,r=>r)],p.$RP.Void),new p.$SP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$QP.Uri,p.$QP.StringArray,new p.$QP("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new p.$RP("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new p.$SP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$QP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:R.$4M.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],p.$RP.Void)];class u{static register(o){v.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",M.$Bj)}}e.$hnc=u;function E(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)O.$Bu(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(Ce[298],Ie([1,0,2,34]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;class P{constructor(A,M,p,c,R){this.a=M,this.b=p,this.c=c;const v=new C.$SP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$QP("showOptions","Show Options",u=>!0,u=>u),new C.$QP("resource","Interactive resource Uri",u=>!0,u=>u),new C.$QP("controllerId","Notebook controller Id",u=>!0,u=>u),new C.$QP("title","Interactive editor title",u=>!0,u=>u)],new C.$RP("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(v)}$willAddInteractiveDocument(A,M,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:M,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,M){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Ioc=P}),define(Ce[299],Ie([1,0,18,11,22,4,5,29,2,19,12,6,34,10,7,83,238,25,39,239]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=void 0,e.$Qoc=$,E=qe(E);let s=class{constructor(D,y,S,k,g){this.m=y,this.n=S,this.o=k,this.q=g,this.b=new M.$Bc,this.c=new M.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$je,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(v.$YM.MainThreadNotebookKernels);const b=new u.$SP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$QP("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const q=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:q}}else if(T&&"notebookEditor"in T){const q=this.n.getIdByEditor(T.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return T})],u.$RP.Void),L=new u.$SP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$QP.Uri],new u.$RP("A promise that resolves to an array of variables",(T,q)=>T.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(L)}createNotebookController(D,y,S,k,g,b){for(const re of this.j.values())if(re.controller.id===y&&c.$nn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const L=this.k++,T=this;this.q.trace(`NotebookController[${L}], CREATED by ${D.identifier.value}, ${y}`);const q=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${D.identifier}'`);let G=!1;const W=new O.$je,N=new O.$je,V={id:$(D.identifier,y),notebookType:S,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let ce=g??q,ge,ie;this.a.$addKernel(L,V).catch(re=>{console.log(re),G=!0});let me=0;const se=()=>{if(G)return;const re=++me;Promise.resolve().then(()=>{re===me&&this.a.$updateKernel(L,V)})},de=new M.$Bc,be={get id(){return y},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return V.label},set label(re){V.label=re??D.displayName??D.name,se()},get detail(){return V.detail??""},set detail(re){V.detail=re,se()},get description(){return V.description??""},set description(re){V.description=re,se()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(re){V.supportedLanguages=re,se()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(re){V.supportsExecutionOrder=re,se()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ce},set executeHandler(re){ce=re??q},get interruptHandler(){return ge},set interruptHandler(re){ge=re,V.supportsInterrupt=!!re,se()},set variableProvider(re){(0,a.$2G)(D,"notebookVariableProvider"),ie=re,V.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>T.a.$variablesUpdated(Pe.uri)),se()},get variableProvider(){return ie},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.notebook.uri))throw T.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return T._createNotebookCellExecution(re,$(D.identifier,this.id))},createNotebookExecution(re){if((0,a.$2G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.uri))throw T.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return T._createNotebookExecution(re,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${L}], DISPOSED`),G=!0,this.j.delete(L),W.dispose(),N.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(re,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,a.$2G)(D,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(L,re.uri,Pe)},onDidReceiveMessage:N.event,postMessage(re,Pe){return(0,a.$2G)(D,"notebookMessaging"),T.a.$postMessage(L,Pe&&T.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,a.$2G)(D,"notebookMessaging"),(0,r.$iCb)(re,T.m.remote)}};return this.j.set(L,{extensionId:D.identifier,controller:be,onDidReceiveMessage:N,onDidChangeSelection:W,associatedNotebooks:de}),be}getIdByController(D){for(const[y,S]of this.j)if(S.controller===D)return $(S.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const S=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(S,y);const g={dispose:()=>{this.f.delete(S),k.a.$removeKernelDetectionTask(S)}};return this.f.set(S,g),g}registerKernelSourceActionProvider(D,y,S){const k=this.i++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,b=this;this.h.set(k,S),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,y);let L;return g!==void 0&&(L=S.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.h.delete(k),b.a.$removeKernelSourceActionProvider(k,k),L?.dispose()}}}async $provideKernelSourceActions(D,y){const S=this.h.get(D);if(S){const k=new A.$Uc;return(await S.provideNotebookKernelSourceActions(y)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,y,S){const k=this.j.get(D);if(k){const g=this.n.getNotebookDocument(p.URI.revive(y));S?k.associatedNotebooks.set(g.uri,!0):k.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,g.uri.toString(),S),k.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y)),b=[];for(const L of S){const T=g.getCell(L);T&&b.push(T.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,g.uri.toString(),b.length),await k.controller.executeHandler.call(k.controller,b,g.apiNotebook,k.controller)}catch(L){this.q.error(`NotebookController[${D}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,g.apiNotebook);else for(const b of S){const L=g.getCell(b);L&&this.b.get(L.uri)?.cancel()}if(k.controller.interruptHandler){const b=this.c.get(g.uri);this.c.delete(g.uri),S.length&&Array.isArray(b)&&b.length&&b.forEach(L=>L.dispose())}}async $provideVariables(D,y,S,k,g,b,L){const T=this.j.get(D);if(!T)return;const q=this.n.getNotebookDocument(p.URI.revive(S)),G=T.controller.variableProvider;if(!G)return;let W;if(k!==void 0){if(W=this.s[k],!W)return}else this.s={};const N=g==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,V=G.provideVariables(q.apiNotebook,W,N,b,L);let ce=0;for await(const ge of V){if(L.isCancellationRequested)return;const ie={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[ie.id]=ge.variable,this.a.$receiveVariable(y,ie),ce++>=i.$6jb)return}}$acceptKernelMessageFromRenderer(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getEditorById(y);k.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(D,y,S){const g=this.n.getNotebookDocument(p.URI.revive(D)).getCell(y);if(g){const b=S?E.NotebookCellExecutionState.to(S):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:g.apiCell,state:b})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const g=new t(y,k,this.a);this.b.set(k.uri,g);const b=g.onDidChangeState(()=>{g.state===n.Resolved&&(g.dispose(),b.dispose(),this.b.delete(k.uri))});return g.asApiObject()}_createNotebookExecution(D,y){const S=this.n.getNotebookDocument(D.uri),k=D.getCells().find(L=>{const T=S.getCellFromApiCell(L);return T&&this.b.has(T.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new f(y,S,this.a),b=g.onDidChangeState(()=>{g.state===m.Resolved&&(g.dispose(),b.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,b]),g.asApiObject()}};e.$Poc=s,e.$Poc=s=He([Ve(4,R.$9j)],s);var n;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(n||(n={}));class t extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.m=y,this.n=S,this.b=t.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$ue),this.h=new l(10,k=>this.s(k)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Nw(y))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const S=d.$uO.ensureUniqueMimeTypes(y.items,!0);return S===y.items?E.NotebookCellOutput.from(y):E.NotebookCellOutput.from({items:S,id:y.id,metadata:y.metadata})})}async z(D,y,S){const k=this.w(y),g=this.y((0,w.$3b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:S,outputs:g})}async C(D,y,S){return D=d.$uO.ensureUniqueMimeTypes((0,w.$3b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:y.id,append:S})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(S){D.j=S,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(S){if(D.f===n.Resolved||D.f===n.Started)throw new Error("Cannot call start again");D.f=n.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,k,g){if(D.f===n.Resolved)throw new Error("Cannot call resolve twice");D.f=n.Resolved,D.c.fire(),D.h.flush();const b=g?{message:g.message,stack:g.stack,location:g?.location?{startLineNumber:g.location.start.line,startColumn:g.location.start.character,endLineNumber:g.location.end.line,endColumn:g.location.end.character}:void 0,uri:g.uri}:void 0;D.n.$completeExecution(D.b,new h.$Nw({runEndTime:k,lastRunSuccess:S,error:b}))},clearOutput(S){return D.t(),D.z([],S,!1)},appendOutput(S,k){return D.t(),D.z(S,k,!0)},replaceOutput(S,k){return D.t(),D.z(S,k,!1)},appendOutputItems(S,k){return D.t(),D.C(S,k,!0)},replaceOutputItems(S,k){return D.t(),D.C(S,k,!1)}})}}var m;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(m||(m={}));class f extends A.$Vc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.h=y,this.j=S,this.b=f.a++,this.c=new O.$je,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new P.$ue),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===m.Resolved||this.f===m.Started)throw new Error("Cannot call start again");this.f=m.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===m.Resolved)throw new Error("Cannot call resolve twice");this.f=m.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new C.$Zh,this.b=Date.now(),(0,C.$Dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function $(I,D){return`${I.value}/${D}`}}),define(Ce[57],Ie([1,0,4,6,3,2,17,5,7,188,14,219,22,37,220,221,35,11,10,34,38]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=e.$Xnc=e.$Wnc=e.$Vnc=void 0,e.$Vnc=(0,P.$Ci)("IExtHostTerminalService");class n extends M.$Vc{constructor(g,b,L,T){super(),this.u=g,this._id=b,this.w=L,this.y=T,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new w.$je),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const q=this;this.value={get name(){return q.y||""},get processId(){return q.b},get creationOptions(){return q.w},get exitStatus(){return q.j},get state(){return q.m},get selection(){return q.n},get shellIntegration(){return q.shellIntegration},sendText(G,W=!0){q.C(),q.u.$sendText(q._id,G,W)},show(G){q.C(),q.u.$show(q._id,G)},hide(){q.C(),q.u.$hide(q._id)},dispose(){q.a||(q.a=!0,q.u.$dispose(q._id))},get dimensions(){if(!(q.f===void 0||q.h===void 0))return{columns:q.f,rows:q.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??b?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:o.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(g.location,b?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,b,L,T,q){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:T,color:o.ThemeColor.isThemeColor(q)?q.id:void 0,location:b?.location||this.z(g,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,b){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in g?{viewColumn:h.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,b){this.j=Object.freeze({code:g,reason:b})}setDimensions(g,b){return g===this.f&&b===this.h||g===0||b===0?!1:(this.f=g,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(b=>{b!==g&&(this.b=Promise.resolve(g))})}}e.$Wnc=n;class t{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new w.$je,this.onProcessData=this.a.event,this.b=new w.$je,this.d=new w.$je,this.onDidChangeProperty=this.d.event,this.f=new w.$je,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,b){this.g.setDimensions?.({columns:g,rows:b})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,f=class extends M.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,b,L){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new M.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$je,this.onDidCloseTerminal=this.H.event,this.I=new w.$je,this.onDidOpenTerminal=this.I.event,this.J=new w.$je,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$je,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$je,this.onDidChangeTerminalState=this.M.event,this.N=new w.$je,this.onDidChangeShell=this.N.event,this.O=new w.$je({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$je({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(C.$YM.MainThreadTerminalService),this.y=new r.$Gwb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:T=>{const q=G=>{const W=G;return this.getTerminalById(W.instanceId)?.value};switch(T?.$mid){case s.MarshalledId.TerminalContext:return q(T);default:{if(Array.isArray(T))for(let G=0;G<T.length&&T[G].$mid===s.MarshalledId.TerminalContext;G++)T[G]=q(T[G]);return T}}}}),this.B({dispose:()=>{for(const[T,q]of this.g)q.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,b){const L=new n(this.a,(0,E.$Yg)(),g,g.name),T=new t(g.pty);return L.createExtensionTerminal(g.location,b,this.R(g,b).resolvedExtHostIdentifier,D(g.iconPath),y(g.color)).then(q=>{const G=this.S(q,T);this.h[q]=G}),this.f.push(L),L.value}R(g,b){if(b=b||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const L=g.location.parentTerminal;if(L){const T=this.f.find(q=>q.value===L);T&&(b.resolvedExtHostIdentifier=T._id)}}else g.location&&typeof g.location!="object"?b.location=g.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(g,b){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const T=new t(b),q=this.S(g,T);this.h[g]=q}async $acceptActiveTerminalChanged(g){const b=this.b;if(g===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(g);L&&(this.b=L,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,b){const L=this.getTerminalById(g);L&&this.O.fire({terminal:L.value,data:b})}async $acceptTerminalDimensions(g,b,L){const T=this.getTerminalById(g);T&&T.setDimensions(b,L)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(g,b){const L=this.getTerminalById(g);L&&this.P.fire({terminal:L.value,...b})}async $acceptTerminalMaximumDimensions(g,b,L){this.g.get(g)?.resize(b,L)}async $acceptTerminalTitleChange(g,b){const L=this.getTerminalById(g);L&&(L.name=b)}async $acceptTerminalClosed(g,b,L){const T=this.X(this.f,g);if(T!==null){const q=this.f.splice(T,1)[0];q.setExitStatus(b,L),this.H.fire(q.value)}}$acceptTerminalOpened(g,b,L,T){if(b){const W=this.X(this.f,b);if(W!==null){this.f[W]._id=g,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const q={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:O.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},G=new n(this.a,g,q,L);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,b){this.getTerminalById(g)?._setProcessId(b)}async $startExtensionTerminal(g,b){const L=this.getTerminalById(g);if(!L)return{message:(0,c.localize)(0,null,g)};L.isOpen||await new Promise(q=>{const G=this.onDidOpenTerminal(async W=>{W===L.value&&(G.dispose(),q())})});const T=this.g.get(g);T?T.startSendingEvents(b):this.j[g]={initialDimensions:b}}S(g,b){const L=new M.$Uc;L.add(b.onProcessReady(q=>this.a.$sendProcessReady(g,q.pid,q.cwd,q.windowsPty))),L.add(b.onDidChangeProperty(q=>this.a.$sendProcessProperty(g,q))),this.y.startBuffering(g,b.onProcessData),L.add(b.onProcessExit(q=>this.U(g,q))),this.g.set(g,b);const T=this.j[g];return T&&b instanceof t&&(b.startSendingEvents(T.initialDimensions),delete this.j[g]),L}$acceptProcessAckDataEvent(g,b){this.g.get(g)?.acknowledgeDataEvent(b)}$acceptProcessInput(g,b){this.g.get(g)?.input(b)}$acceptTerminalInteraction(g){const b=this.getTerminalById(g);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(g,b){this.getTerminalById(g)?.setSelection(b)}$acceptProcessResize(g,b,L){try{this.g.get(g)?.resize(b,L)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(g,b){this.g.get(g)?.shutdown(b)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$1M(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,b,L){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,L),this.a.$registerProfileProvider(b,g.identifier.value),new p.$1M(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(g,b,L){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,L),this.a.$registerQuickFixProvider(g,b),new p.$1M(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,b){const L=new u.$ue().token;if(L.isCancellationRequested)return;const T=this.D.get(g);if(!T)return;const q=await T.provideTerminalQuickFixes(b,L);if(q===null||Array.isArray(q)&&q.length===0)return;const G=new M.$Uc;if(this.w.value=G,!Array.isArray(q))return q?h.TerminalQuickFix.from(q,this.Q.converter,G):void 0;const W=[];for(const N of q){const V=h.TerminalQuickFix.from(N,this.Q.converter,G);V&&W.push(V)}return W}async $createContributedProfileTerminal(g,b){const L=new u.$ue().token;let T=await this.C.get(g)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,b);return}this.createTerminalFromOptions(T.options,b)}}async $provideLinks(g,b){const L=this.getTerminalById(g);if(!L)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const q=new u.$ue;this.G.set(g,q);const G=[],W={terminal:L.value,line:b},N=[];for(const ge of this.z)N.push(a.Promises.withAsyncBody(async ie=>{q.token.onCancellationRequested(()=>ie({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(W,q.token)||[];q.token.isCancellationRequested||ie({provider:ge,links:me})}));const V=await Promise.all(N);if(q.token.isCancellationRequested)return[];const ce=new Map;for(const ge of V)ge&&ge.links.length>0&&G.push(...ge.links.map(ie=>{const me={id:m++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return ce.set(me.id,{provider:ge.provider,link:ie}),me}));return this.F.set(g,ce),G}$activateLink(g,b){const L=this.F.get(g)?.get(b);L&&L.provider.handleTerminalLink(L.link)}U(g,b){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const L=this.h[g];L&&(L.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,b)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const b=this.f.findIndex(L=>L.value===g);return b>=0?b:null}W(g,b){const L=this.X(g,b);return L!==null?g[L]:null}X(g,b){const L=g.findIndex(T=>T._id===b);return L>=0?L:null}getEnvironmentVariableCollection(g){let b=this.n.get(g.identifier.value);return b||(b=this.B(new l),this.Z(g.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(g,b){const L=(0,v.$ws)(b.map),T=(0,v.$xs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(g,b.persistent,L.length===0?void 0:L,T)}$initEnvironmentVariableCollections(g){g.forEach(b=>{const L=b[0],T=this.B(new l(b[1]));this.Z(L,T)})}$acceptDefaultProfile(g,b){const L=this.s;this.s=g,this.u=b,L?.path!==g.path&&this.N.fire(g.path)}Z(g,b){this.n.set(g,b),this.B(b.onDidChangeCollection(()=>{this.Y(g,b)}))}};e.$Xnc=f,e.$Xnc=f=He([Ve(1,i.$OP),Ve(2,A.$sP)],f);class l extends M.$Vc{get persistent(){return this.b}set persistent(g){this.b=g,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(g){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new w.$je,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const b=this.j(g);let L=this.a.get(b);return L||(L=new $(this,g),this.a.set(b,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(g,b,L,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:T})}append(g,b,L,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:T})}prepend(g,b,L,T){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:T})}g(g,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(g,b.scope),T=this.map.get(L),q=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==b.value||T.type!==b.type||T.options?.applyAtProcessCreation!==q.applyAtProcessCreation||T.options?.applyAtShellIntegration!==q.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h(g,b.scope),W={variable:g,...b,options:q};this.map.set(G,W),this.f.fire()}}get(g,b){const L=this.h(g,b),T=this.map.get(L);return T?S(T):void 0}h(g,b){const L=this.j(b);return L.length?`${g}:::${L}`:g}j(g){return this.m(g?.workspaceFolder)??""}m(g){return g?g.uri.toString():void 0}getVariableMap(g){const b=new Map;for(const[L,T]of this.map)this.j(T.scope)===this.j(g)&&b.set(T.variable,S(T));return b}delete(g,b){const L=this.h(g,b);this.map.delete(L),this.f.fire()}clear(g){if(g?.workspaceFolder){for(const[b,L]of this.map)L.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(b);this.n(g)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(g,b){const L=this.j(b),T=this.descriptionMap.get(L);if(!T||T.description!==g){let q;typeof g=="string"?q=g:q=g?.value.split(`

`)[0];const G={description:q,scope:b};this.descriptionMap.set(L,G),this.f.fire()}}getDescription(g){const b=this.j(g);return this.descriptionMap.get(b)?.description}n(g){const b=this.j(g);this.descriptionMap.delete(b)}}class ${get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,b){this.b=g,this.d=b,this.a=new w.$je}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,b,L){this.b.replace(g,b,L,this.d)}append(g,b,L){this.b.append(g,b,L,this.d)}prepend(g,b,L){this.b.prepend(g,b,L,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,b){this.b.getVariableMap(this.d).forEach((L,T)=>g.call(b,T,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends f{constructor(g,b){super(!1,g,b)}createTerminal(g,b,L){throw new R.$ab}createTerminalFromOptions(g,b){throw new R.$ab}};e.$Ync=I,e.$Ync=I=He([Ve(0,i.$OP),Ve(1,A.$sP)],I);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function y(k){return o.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const g={...k};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[125],Ie([1,0,7,5,3,6,17,57,4,2,11]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9oc=e.$8oc=void 0,e.$8oc=(0,P.$Ci)("IExtHostTerminalShellIntegration");let v=class extends C.$Vc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new p.$je,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$je,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$je,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$YM.MainThreadTerminalShellIntegration),this.B((0,C.$Tc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let i=this.b.get(o);i||(i=new u(a.value,this.f),this.b.set(o,i),i.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),i.store.add(i.onDidRequestEndExecution(s=>this.g.fire(s))),i.store.add(i.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(o,a,h,i,s){this.b.has(o)||this.$shellIntegrationChange(o);const n={value:a,confidence:h,isTrusted:i};this.b.get(o)?.startShellExecution(n,s)}$shellExecutionEnd(o,a,h,i,s){const n={value:a,confidence:h,isTrusted:i};this.b.get(o)?.endShellExecution(n,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$wc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$9oc=v,e.$9oc=v=He([Ve(0,A.$sP),Ve(1,M.$Vnc)],v);class u extends C.$Vc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new C.$Uc),this.f=this.B(new p.$je),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$je),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$je),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,s){let n=i;s&&(n+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(n);const t={value:n,confidence:w.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},m=h.startShellExecution(t,h.c,!0).value;return h.b=!0,m}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new E(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$3h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends C.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Bh);const o=this.a;return new R.$3h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[126],Ie([1,0,62,14,97,10,7]),function(oe,e,w,C,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=e.$AP=e.$zP=void 0,O=qe(O);class M{static{this.c=new P.$xP("TextEditorDecorationType")}constructor(u,E,d){const r=M.c.nextId();u.$registerTextEditorDecorationType(E.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$zP=M;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let d=null;if(u instanceof A.$2M)d=new A.$3M(u,u);else if(u instanceof A.$3M)d=u;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(u,E){this.k(),this.l(new A.$3M(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$3M)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,d){const r=this.c.validateRange(u);this.g.push({range:r,text:E,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,C.$8)("endOfLine");this.h=u}}class c{constructor(u,E,d,r){this.c=u,this.d=E,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let d=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(d=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,E.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(d=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,E.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(d=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,E.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,E.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$AP=c;class R{constructor(u,E,d,r,o,a,h,i){this.id=u,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=i;const s=this;this.value=Object.freeze({get document(){return r.value},set document(n){throw new C.$0("document")},get selection(){return s.c&&s.c[0]},set selection(n){if(!(n instanceof A.$4M))throw(0,C.$8)("selection");s.c=[n],s.l()},get selections(){return s.c},set selections(n){if(!Array.isArray(n)||n.some(t=>!(t instanceof A.$4M)))throw(0,C.$8)("selections");s.c=n,s.l()},get visibleRanges(){return s.e},set visibleRanges(n){throw new C.$0("visibleRanges")},get options(){return s.d.value},set options(n){s.g||s.d.assign(n)},get viewColumn(){return s.f},set viewColumn(n){throw new C.$0("viewColumn")},edit(n,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const m=new p(r.value,t);return n(m),s.m(m)},insertSnippet(n,t,m={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!t||Array.isArray(t)&&t.length===0)f=s.c.map(l=>O.Range.from(l));else if(t instanceof A.$2M){const{lineNumber:l,column:$}=O.Position.from(t);f=[{startLineNumber:l,startColumn:$,endLineNumber:l,endColumn:$}]}else if(t instanceof A.$3M)f=[O.Range.from(t)];else{f=[];for(const l of t)if(l instanceof A.$3M)f.push(O.Range.from(l));else{const{lineNumber:$,column:I}=O.Position.from(l);f.push({startLineNumber:$,startColumn:I,endLineNumber:$,endColumn:I})}}return E.$tryInsertSnippet(u,r.value.version,n.value,f,m)},setDecorations(n,t){const m=t.length===0;m&&!s.h.has(n.key)||(m?s.h.delete(n.key):s.h.add(n.key),s.n(()=>{if(O.$pP(t))return E.$trySetDecorations(u,n.key,O.$qP(t));{const f=new Array(4*t.length);for(let l=0,$=t.length;l<$;l++){const I=t[l];f[4*l]=I.start.line+1,f[4*l+1]=I.start.character+1,f[4*l+2]=I.end.line+1,f[4*l+3]=I.end.character+1}return E.$trySetDecorationsFast(u,n.key,f)}}))},revealRange(n,t){s.n(()=>E.$tryRevealRange(u,O.Range.from(n),t||A.TextEditorRevealType.Default))},show(n){E.$tryShowEditor(u,O.ViewColumn.from(n))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?O.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$BP=R}),define(Ce[58],Ie([1,0,62,4,5,2,3,6,122,17,126,10,12,29,16,40,47]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=void 0,w=qe(w),v=qe(v);class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,n){this.h=s,this.i=n,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new C.$je,this.e=new C.$je,this.f=new C.$je,this.g=new C.$je,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const n=[],t=[],m=[];if(s.removedDocuments)for(const f of s.removedDocuments){const l=O.URI.revive(f),$=this.c.get(l);$?.unref()&&(this.c.delete(l),n.push($.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const l=O.URI.revive(f.uri);let $=this.c.get(l);if($&&l.scheme!==d.Schemas.vscodeNotebookCell&&l.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);$||($=new a(new p.$vP(this.h.getProxy(M.$YM.MainThreadDocuments),l,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(l,$),t.push($.value)),$.ref()}if(s.removedEditors)for(const f of s.removedEditors){const l=this.b.get(f);this.b.delete(f),l&&m.push(l)}if(s.addedEditors)for(const f of s.addedEditors){const l=O.URI.revive(f.documentUri);w.ok(this.c.has(l),`document '${l}' does not exist`),w.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const $=this.c.get(l).value,I=new R.$BP(f.id,this.h.getProxy(M.$YM.MainThreadTextEditors),this.i,new o.$W(()=>$.document),f.selections.map(v.Selection.to),f.options,f.visibleRanges.map(D=>v.Range.to(D)),typeof f.editorPosition=="number"?v.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,I)}s.newActiveEditor!==void 0&&(w.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,P.$Qc)(n),(0,P.$Qc)(m),s.removedDocuments&&this.e.fire(n),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const n=this.b.get(this.a);return s?n:n?.value}allEditors(){return[...this.b.values()]}};e.$CP=h,e.$CP=h=He([Ve(0,c.$sP),Ve(1,u.$9j)],h),e.$DP=(0,A.$Ci)("IExtHostDocumentsAndEditors")}),define(Ce[96],Ie([1,0,11,23,22,4,273,76,5,38,15,37,3,12,6,34,58,17,124,10,7,241,55,82,56,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=e.$goc=e.$foc=e.$eoc=e.$doc=void 0,i=qe(i);let $=0;const I=new WeakMap;e.$doc=(0,u.$Ci)("IExtHostTesting");let D=class extends p.$Vc{constructor(ie,me,se,de){super(),this.C=me,this.D=se,this.F=de,this.f=this.B(new O.$je),this.g=new Map,this.w=this.B(new O.$je),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=ie.getProxy(d.$YM.MainThreadTesting),this.m=new G(this.h),this.j=new g(this.h,me),se.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case c.MarshalledId.TestItemContext:{const re=be,Pe=re.tests[re.tests.length-1].item.extId;return this.g.get(t.$MI.root(Pe))?.collection.tree.get(Pe)?.actual??(0,h.$EP)(be)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Pe}=be,Le=re.item.extId;return{test:this.g.get(t.$MI.root(Le))?.collection.tree.get(Le)?.actual??(0,h.$EP)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:i.TestMessage.to(Pe)}}default:return be}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await se.executeCommand(n.TestCommandId.GetExplorerSelection),re=Pe=>{const Le=this.g.get(t.$MI.root(Pe));if(Le)return t.$MI.isRoot(Pe)?Le.controller:Le.collection.tree.get(Pe)?.actual};return{include:be?.include.map(re).filter(R.$kg)||[],exclude:be?.exclude.map(re).filter(R.$kg)||[]}})}createTestController(ie,me,se,de){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const be=new p.$Uc,re=be.add(new h.$HP(me,se,this.F));re.root.label=se;const Pe=new Map,Le=new Set,Y=this.h,B={items:re.root.children,get label(){return se},set label(we){se=we,re.root.label=we,Y.$updateController(me,{label:se})},get refreshHandler(){return de},set refreshHandler(we){de=we,Y.$updateController(me,{canRefresh:!!we})},get id(){return me},createRunProfile:(we,ae,ve,le,X,Z)=>{let pe=(0,M.$qj)(we);for(;Pe.has(pe);)pe++;return new N(this.h,Pe,Le,this.w.event,me,pe,we,ae,ve,le,X,Z)},createTestItem(we,ae,ve){return new h.$FP(me,we,ae,ve)},createTestRun:(we,ae,ve=!0)=>this.j.createTestRun(ie,me,re,we,ae,ve),invalidateTestResults:we=>{if(we===void 0)this.h.$markTestRetired(void 0);else{const ae=we instanceof Array?we:[we];this.h.$markTestRetired(ae.map(ve=>t.$MI.fromExtHostTestItem(ve,me).toString()))}},set resolveHandler(we){re.resolveHandler=we},get resolveHandler(){return re.resolveHandler},dispose:()=>{be.dispose()}};Y.$registerTestController(me,se,!!de),be.add((0,p.$Tc)(()=>Y.$unregisterTestController(me)));const _={controller:B,collection:re,profiles:Pe,extension:ie,activeProfiles:Le};return this.g.set(me,_),be.add((0,p.$Tc)(()=>this.g.delete(me))),be.add(re.onDidGenerateDiff(we=>Y.$publishDiff(me,we.map(f.TestsDiffOp.serialize)))),B}createTestObserver(){return this.m.checkout()}async runTests(ie,me=P.CancellationToken.None){const se=b(ie);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const de=this.g.get(se.controllerId);if(!de)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:ie.preserveFocus??!0,group:V[se.kind],targets:[{testIds:ie.include?.map(be=>t.$MI.fromExtHostTestItem(be,de.collection.root.id).toString())??[de.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:ie.exclude?.map(be=>be.id)},me)}registerTestFollowupProvider(ie){return this.y.add(ie),{dispose:()=>{this.y.delete(ie)}}}$syncTests(){for(const{collection:ie}of this.g.values())ie.flushDiff();return Promise.resolve()}async $getCoverageDetails(ie,me){return(await this.j.getCoverageDetails(ie,me))?.map(i.TestCoverage.fromDetails)}async $disposeRun(ie){this.j.disposeTestRun(ie)}$configureRunProfile(ie,me){this.g.get(ie)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(ie){const me=new Map;for(const[se,de]of Object.entries(ie)){const be=this.g.get(se);if(!be)continue;const re=new Map,Pe=de.filter(Y=>!be.activeProfiles.has(Y)),Le=[...be.activeProfiles].filter(Y=>!de.includes(Y));for(const Y of Pe)re.set(Y,!0),be.activeProfiles.add(Y);for(const Y of Le)re.set(Y,!1),be.activeProfiles.delete(Y);re.size&&me.set(se,re)}this.w.fire(me)}async $refreshTests(ie,me){await this.g.get(ie)?.controller.refreshHandler?.(me)}$publishTestResults(ie){this.results=Object.freeze(ie.map(me=>{const se=i.TestResults.to(me);return I.set(se,me.id),se}).concat(this.results).sort((me,se)=>se.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(ie,me){const se=this.g.get(t.$MI.fromString(ie).controllerId)?.collection;se&&(await se.expand(ie,me<0?1/0:me),se.flushDiff())}$acceptDiff(ie){this.m.applyDiff(ie.map(me=>f.TestsDiffOp.deserialize({asCanonicalUri:se=>se},me)))}async $runControllerTests(ie,me){return Promise.all(ie.map(se=>this.G(se,!1,me)))}async $startContinuousRun(ie,me){const se=new P.$ue(me),de=await Promise.all(ie.map(be=>this.G(be,!0,se.token)));return!me.isCancellationRequested&&!de.some(be=>be.error)&&await new Promise(be=>me.onCancellationRequested(be)),se.dispose(!0),de}async $provideTestFollowups(ie,me){const se=this.results.find(re=>I.get(re)===ie.resultId),de=se&&ce(t.$MI.fromString(ie.extId),se?.results);if(!de)return[];let be=[];return await Promise.all([...this.y].map(async re=>{try{const Pe=await re.provideFollowup(se,de,ie.taskIndex,ie.messageIndex,me);Pe&&(be=be.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),me.isCancellationRequested?[]:be.map(re=>{const Pe=$++;return this.z.set(Pe,re),{title:re.title,id:Pe}})}$disposeTestFollowups(ie){for(const me of ie)this.z.delete(me)}$executeTestFollowup(ie){const me=this.z.get(ie);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(ie){ie===void 0?this.j.cancelAllRuns():this.j.cancelRunById(ie)}getMetadataForRun(ie){for(const me of this.j.trackers){const se=me.getTaskIdForRun(ie);return se?{taskId:se,runId:me.id}:void 0}}async G(ie,me,se){const de=this.g.get(ie.controllerId);if(!de)return{};const{collection:be,profiles:re,extension:Pe}=de,Le=re.get(ie.profileId);if(!Le)return{};const Y=ie.testIds.map(ae=>be.tree.get(ae)).filter(R.$kg),B=ie.excludeExtIds.map(ae=>de.collection.tree.get(ae)).filter(R.$kg).filter(ae=>Y.some(ve=>ve.fullId.compare(ae.fullId)===t.TestPosition.IsChild));if(!Y.length)return{};const _=new s.$BO(Y.some(ae=>ae.actual instanceof h.$GP)?void 0:Y.map(ae=>ae.actual),B.map(ae=>ae.actual),Le,me),we=(0,f.$PI)(ie)&&this.j.prepareForMainThreadTestRun(Pe,_,L.fromInternal(ie,de.collection),Le,se);try{return await Le.runHandler(_,se),{}}catch(ae){return{error:String(ae)}}finally{we&&we.hasRunningTasks&&!se.isCancellationRequested&&await O.Event.toPromise(we.onEnd)}}};e.$eoc=D,e.$eoc=D=He([Ve(0,a.$sP),Ve(1,E.$9j),Ve(2,r.$OP),Ve(3,o.$DP)],D);const y=1e4;var S;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(S||(S={}));class k extends p.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(ie,me,se,de,be,re){super(),this.z=ie,this.C=me,this.D=se,this.F=de,this.G=be,this.c=S.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$je),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$ue(re));const Pe=this.B(new w.$Oh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>Pe.schedule()));const Le=new O.$je;this.w=Le.event,this.B((0,p.$Tc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(ie){for(const[me,{run:se}]of this.g)if(se===ie)return me}cancel(){this.c===S.Running?(this.j.cancel(),this.c=S.Cancelling):this.c===S.Cancelling&&this.H()}getCoverageDetails(ie,me){const[,se]=t.$MI.fromString(ie).path,de=this.y.get(ie);if(!de)return[];const be=this.g.get(se);if(!be)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(be.run,de,me)??[]}createRun(ie){const me=this.z.id,se=this.z.controllerId,de=(0,v.$Yg)(),be=B=>(_,...we)=>{if(Pe){this.D.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.J(_),B(_,...we)},re=(B,_)=>{const we=_ instanceof Array?_.map(i.TestMessage.from):[i.TestMessage.from(_)];if(B.uri&&B.range){const ae={range:i.Range.from(B.range),uri:B.uri};for(const ve of we)ve.location=ve.location||ae}this.C.$appendTestMessagesInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),we)};let Pe=!1;const Le=new Map,Y={isPersisted:this.z.isPersisted,token:this.j.token,name:ie,onDidDispose:this.w,addCoverage:B=>{if(Pe)return;const _=B instanceof s.$GO?B.testItem:void 0;let we;_&&((0,l.$2G)(this.G,"attributableCoverage"),this.J(_),we=Le.get(_),we===void 0&&(we=Le.size,Le.set(_,we)));const ae=B.uri.toString(),ve=new t.$MI(we!==void 0?[me,de,ae,String(we)]:[me,de,ae]).toString();this.y.set(ve,B),this.C.$appendCoverage(me,de,i.TestCoverage.fromFile(se,ve,B))},enqueued:be(B=>{this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Queued)}),skipped:be(B=>{this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Skipped)}),started:be(B=>{this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Running)}),errored:be((B,_,we)=>{re(B,_),this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Errored,we)}),failed:be((B,_,we)=>{re(B,_),this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,se).toString(),f.TestResultState.Failed,we)}),passed:be((B,_)=>{this.C.$updateTestStateInRun(me,de,t.$MI.fromExtHostTestItem(B,this.z.controllerId).toString(),f.TestResultState.Passed,_)}),appendOutput:(B,_,we)=>{Pe||(we&&this.J(we),this.C.$appendOutputToRun(me,de,C.$Le.fromString(B),_&&i.location.from(_),we&&t.$MI.fromExtHostTestItem(we,se).toString()))},end:()=>{Pe||(Pe=!0,Le.clear(),this.C.$finishedTestRunTask(me,de),--this.f||this.I())}};return this.f++,this.g.set(de,{run:Y}),this.C.$startedTestRunTask(me,{id:de,name:ie,running:!0}),Y}H(){for(const{run:ie}of this.g.values())ie.end()}I(){this.c!==S.Ended&&(this.c=S.Ended,this.m.fire())}J(ie){if(!(ie instanceof h.$FP))throw new m.$kP(ie.id);if(this.h.has(t.$MI.fromExtHostTestItem(ie,this.z.controllerId).toString()))return;const me=[],se=this.z.colllection.root;for(;;){const de=i.TestItem.from(ie);if(me.unshift(de),this.h.has(de.extId)||(this.h.add(de.extId),ie===se))break;ie=ie.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(ie,me){this.g=ie,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(ie,me){const se=t.$MI.root(ie);return this.f.get(se)?.getCoverageDetails(ie,me)||[]}disposeTestRun(ie){this.f.get(ie)?.dispose(),this.f.delete(ie);for(const[me,{id:se}]of this.c)se===ie&&this.c.delete(me)}prepareForMainThreadTestRun(ie,me,se,de,be){return this.j(me,se,de,ie,be)}cancelRunById(ie){this.f.get(ie)?.cancel()}cancelAllRuns(){for(const ie of this.c.values())ie.cancel()}createTestRun(ie,me,se,de,be,re){const Pe=this.c.get(de);if(Pe)return Pe.createRun(be);const Le=L.fromPublic(me,se,de,re),Y=b(de);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!de.continuous,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:de.exclude?.map(_=>t.$MI.fromExtHostTestItem(_,se.root.id).toString())??[],id:Le.id,include:de.include?.map(_=>t.$MI.fromExtHostTestItem(_,se.root.id).toString())??[se.root.id],preserveFocus:de.preserveFocus??!0,persist:re});const B=this.j(de,Le,de.profile,ie);return O.Event.once(B.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),B.createRun(be)}j(ie,me,se,de,be){const re=new k(me,this.g,this.h,se,de,be);return this.c.set(ie,re),this.f.set(re.id,re),re}}e.$foc=g;const b=ge=>{if(ge.profile){if(!(ge.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class L{static fromPublic(ie,me,se,de){return new L(ie,(0,v.$Yg)(),de,me)}static fromInternal(ie,me){return new L(ie.controllerId,ie.runId,!0,me)}constructor(ie,me,se,de){this.controllerId=ie,this.id=me,this.isPersisted=se,this.colllection=de}}e.$goc=L;class T{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(ie){this.j=ie,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(ie){this.c.add(ie)}update(ie){Object.assign(ie.revived,i.TestItem.toPlain(ie.item)),this.c.has(ie)||this.f.add(ie)}remove(ie){if(this.c.has(ie)){this.c.delete(ie);return}this.f.delete(ie);const me=t.$MI.parentId(ie.item.extId);if(me&&this.h.has(me.toString())){this.h.add(ie.item.extId);return}this.g.add(ie)}getChangeEvent(){const{c:ie,f:me,g:se}=this;return{get added(){return[...ie].map(de=>de.revived)},get updated(){return[...me].map(de=>de.revived)},get removed(){return[...se].map(de=>de.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class q extends f.$VI{constructor(){super(...arguments),this.y=new O.$je,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(ie){return this.f.get(ie)}getMirroredTestDataByReference(ie){return this.f.get(ie.id)}x(ie,me){return{...ie,revived:i.TestItem.toPlain(ie.item),depth:me?me.depth+1:0,children:new Set}}w(){return new T(this.y)}}class G{constructor(ie){this.f=ie}checkout(){this.c||(this.c=this.g());const ie=this.c;return ie.observers++,{onDidChangeTest:ie.tests.onDidChangeTests,get tests(){return[...ie.tests.rootTests].map(me=>me.revived)},dispose:(0,A.$eb)(()=>{--ie.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(ie){return this.c?.tests.getMirroredTestDataByReference(ie)}applyDiff(ie){this.c?.tests.apply(ie)}g(){const ie=new q({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:ie}}}const W=(ge,ie,me,se)=>{me?Object.assign(me,se):ie.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(ie){ie!==this.f&&(this.f=ie,W(this,this.#e,this.#n,{label:ie}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(ie){ie!==this.g&&(this.g=ie,W(this,this.#e,this.#n,{supportsContinuousRun:ie}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(ie){ie!==this.isDefault&&(ie?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:ie}))}get tag(){return this._tag}set tag(ie){ie?.id!==this._tag?.id&&(this._tag=ie,W(this,this.#e,this.#n,{tag:ie?i.TestTag.namespace(this.controllerId,ie.id):null}))}get configureHandler(){return this.c}set configureHandler(ie){ie!==this.c&&(this.c=ie,W(this,this.#e,this.#n,{hasConfigurationHandler:!!ie}))}get onDidChangeDefault(){return O.Event.chain(this.#i,ie=>ie.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(R.$kg))}constructor(ie,me,se,de,be,re,Pe,Le,Y,B=!1,_=void 0,we=!1){this.controllerId=be,this.profileId=re,this.f=Pe,this.kind=Le,this.runHandler=Y,this._tag=_,this.g=we,this.#e=ie,this.#s=me,this.#t=se,this.#i=de,me.set(re,this);const ae=V[Le];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);B&&se.add(re),this.#n={profileId:re,controllerId:be,tag:_?i.TestTag.namespace(this.controllerId,_.id):null,label:Pe,group:ae,isDefault:B,hasConfigurationHandler:!1,supportsContinuousRun:we},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$hoc=N;const V={[s.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[s.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[s.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function ce(ge,ie){for(let me=0;me<ge.path.length;me++){const se=ie.find(de=>de.id===ge.path[me]);if(!se)return;if(me===ge.path.length-1)return se;ie=se.children}}}),define(Ce[300],Ie([1,0,18,4,5,6,126,10,7]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0,w=qe(w),M=qe(M);class c extends P.$Vc{constructor(v,u){super(),this.m=u,this.a=new C.$je,this.b=new C.$je,this.c=new C.$je,this.f=new C.$je,this.g=new C.$je,this.h=new C.$je,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=v.getProxy(O.$YM.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(v){const u=this.m.allEditors();return v?u:u.map(E=>E.value)}async showTextDocument(v,u,E){let d;typeof u=="number"?d={position:M.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?d={position:M.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?M.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(v.uri,d),o=r&&this.m.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}createTextEditorDecorationType(v,u){return new A.$zP(this.j,v,u).value}$acceptEditorPropertiesChanged(v,u){const E=this.m.getEditor(v);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(M.Selection.to);E._acceptSelections(d)}if(u.visibleRanges){const d=w.$Ib(u.visibleRanges.map(M.Range.to));E._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:M.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(M.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:d})}if(u.visibleRanges){const d=w.$Ib(u.visibleRanges.map(M.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(v){for(const u in v){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const d=M.ViewColumn.to(v[u]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(v){return Promise.resolve(this.j.$getDiffInformation(v))}}e.$onc=c}),define(Ce[301],Ie([1,0,2,3,6,5,7,10,19,38,15]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=e.$$oc=void 0,e.$$oc=(0,C.$Ci)("IExtHostTimeline");class v{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$YM.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&p.$nn.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(u(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(w.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new O.$Uc,i=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:r.id}),this));const n=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(t,m,f){m?.resetCache&&(h.clear(),n.get(r.id)?.clear());const l=await r.provideTimeline(t,m,f);if(l==null)return;const $=i(t,m);return{...l,source:r.id,items:l.items.map($)}},dispose(){for(const t of n.values())t.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let i;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const n=u(a);i=s.get(n),i===void 0&&(i=new Map,s.set(n,i))}return s=>{const{iconPath:n,...t}=s,m=`${d}|${s.id??s.timestamp}`;i?.set(m,s);let f,l,$;s.iconPath&&(n instanceof A.$XN?$={id:n.id,color:n.color}:w.URI.isUri(n)?(f=n,l=n):{light:f,dark:l}=n);let I;return A.$qN.isMarkdownString(t.tooltip)?I=M.MarkdownString.from(t.tooltip):(0,R.$cg)(t.tooltip)?I=t.tooltip:A.$qN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=M.MarkdownString.from(t.detail)):(0,R.$cg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=t.detail),{...t,id:t.id??void 0,handle:m,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:l,themeIcon:$,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Tc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$_oc=v;function u(E){return E?.toString()}}),define(Ce[302],Ie([1,0,189,24,2,4,5,232,11,7,15,18,10,60,22,153,25]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0,c=qe(c);function a(s,n){if((0,R.$cg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class h extends A.$Vc{constructor(n,t,m){super(),this.f=n,this.g=t,this.h=m,this.a=new Map,this.b=new r.$I$;function f(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>f(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map($=>f($)?this.r($):$):l})}registerTreeDataProvider(n,t,m){const f=this.createTreeView(n,{treeDataProvider:t},m);return{dispose:()=>f.dispose()}}createTreeView(n,t,m){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,I=!!t.dragAndDropController?.handleDrop,D=this.m(n,t,m),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:f,dragMimeTypes:l,hasHandleDrag:$,hasHandleDrop:I,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},S=this.f.$registerTreeViewDataProvider(n,y),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$2G)(m,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$2G)(m,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,E.$2k)(g)&&(0,o.$2G)(m,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&c.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,b)=>D.reveal(g,b),dispose:async()=>{await S,this.a.delete(n),D.dispose()}};return this.B(k),k}$getChildren(n,t){const m=this.a.get(n);return m?m.getChildren(t):Promise.reject(new M.$kG(n))}async $handleDrop(n,t,m,f,l,$,I,D){const y=this.a.get(n);if(!y)return Promise.reject(new M.$kG(n));const S=u.DataTransfer.toDataTransfer(m,async k=>(await this.f.$resolveDropFileData(n,t,k)).buffer);return I===n&&D&&await this.j(S,y,D,l,$),y.onDrop(S,f,l)}async j(n,t,m,f,l){const $=this.b.removeDragOperationTransfer(l);if($)(await $)?.forEach((I,D)=>{I&&n.set(D,I)});else if(l&&t.handleDrag){const I=t.handleDrag(m,n,f);this.b.addDragOperationTransfer(l,I),await I}return n}async $handleDrag(n,t,m,f){const l=this.a.get(n);if(!l)return Promise.reject(new M.$kG(n));const $=await this.j(new c.$TN,l,t,f,m);if(!(!$||f.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(n){const t=this.a.get(n);if(!t)throw new M.$kG(n);return t.hasResolve}$resolve(n,t,m){const f=this.a.get(n);if(!f)throw new M.$kG(n);return f.resolveTreeItem(t,m)}$setExpanded(n,t,m){const f=this.a.get(n);if(!f)throw new M.$kG(n);f.setExpanded(t,m)}$setSelectionAndFocus(n,t,m){const f=this.a.get(n);if(!f)throw new M.$kG(n);f.setSelectionAndFocus(t,m)}$setVisible(n,t){const m=this.a.get(n);if(!m){if(!t)return;throw new M.$kG(n)}m.setVisible(t)}$changeCheckboxState(n,t){const m=this.a.get(n);if(!m)throw new M.$kG(n);m.setCheckboxState(t)}m(n,t,m){const f=this.B(new i(n,t,this.f,this.g.converter,this.h,m));return this.a.set(n,f),f}r(n){const t=this.a.get(n.$treeViewId);return t&&"$treeItemHandle"in n?t.getExtensionElement(n.$treeItemHandle):t&&"$focusedTreeItem"in n&&n.$focusedTreeItem?t.focusedElement:null}}e.$apc=h;class i extends A.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(n=>this.getExtensionElement(n)).filter(n=>!(0,R.$lg)(n))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(n,t,m,f,l,$){if(super(),this.I=n,this.J=m,this.L=f,this.M=l,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$je),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$je),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$je),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$je),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$je),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$je),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$je),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ue,$.contributes&&$.contributes.views)for(const S in $.contributes.views)for(const k of $.contributes.views[S])k.id===n&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(S=>{Array.isArray(S)&&S.length===0||this.F.fire({message:!1,element:S})}));let I,D;const y=O.Event.debounce(this.F.event,(S,k)=>(S||(S={message:!1,elements:[]}),k.element!==!1&&(I||(I=new Promise(g=>D=g),this.G=this.G.then(()=>I)),Array.isArray(k.element)?S.elements.push(...k.element):S.elements.push(k.element)),k.message&&(S.message=!0),S),200,!0);this.B(y(({message:S,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const g=D;return I=null,this.$(k).then(()=>g())})),S&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(n){const t=n?this.getExtensionElement(n):void 0;if(n&&!t)return this.M.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let m=this.X(n);return m||(m=await this.Y(t)),m?m.map(f=>f.item):void 0}getExtensionElement(n){return this.j.get(n)}reveal(n,t){t=t||{select:!0,focus:!1};const m=(0,R.$lg)(t.select)?!0:t.select,f=(0,R.$lg)(t.focus)?!1:t.focus,l=(0,R.$lg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.G.then(()=>this.S(n)).then($=>this.W(n,$[$.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:$.map(D=>D.item)},{select:m,focus:f,expand:l})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:m,focus:f,expand:l})}get message(){return this.O}set message(n){this.O=n,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(n){this.P=n,this.J.$setTitle(this.I,n,this.Q)}get description(){return this.Q}set description(n){this.Q=n,this.J.$setTitle(this.I,this.P,n)}get badge(){return this.R}set badge(n){this.R?.value===n?.value&&this.R?.tooltip===n?.tooltip||(this.R=u.ViewBadge.from(n),this.J.$setBadge(this.I,n))}setExpanded(n,t){const m=this.getExtensionElement(n);m&&(t?this.u.fire(Object.freeze({element:m})):this.w.fire(Object.freeze({element:m})))}setSelectionAndFocus(n,t){const m=!(0,v.$vb)(this.s,n);this.s=n;const f=this.t!==t;this.t=t,m&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.r&&(this.r=n,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(n){const t=(await Promise.all(n.map(async m=>{const f=this.getExtensionElement(m.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(m=>m!==void 0);t.forEach(m=>{m.treeItem.checkboxState=m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(m=>[m.extensionItem,m.newState])})}async handleDrag(n,t,m){const f=[];for(const l of n){const $=this.getExtensionElement(l);$&&f.push($)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,t,m),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,t,m){const f=t?this.getExtensionElement(t):void 0;if(!(!f&&t||!this.g?.handleDrop))return(0,p.$uh)(()=>this.g?.handleDrop?this.g.handleDrop(f,n,m):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,t){if(!this.f.resolveTreeItem)return;const m=this.j.get(n);if(m){const f=this.m.get(m);if(f){const l=await this.f.resolveTreeItem(f.extensionItem,m,t)??f.extensionItem;return this.hb(l),f.item.tooltip=this.eb(l.tooltip),f.item.command=this.fb(f.disposableStore,l.command),f.item}}}S(n){return this.U(n).then(t=>t?this.S(t).then(m=>this.W(t,m[m.length-1]).then(f=>(m.push(f),m))):Promise.resolve([]))}U(n){const t=this.m.get(n);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$uh)(()=>this.f.getParent(n))}W(n,t){const m=this.m.get(n);return m?Promise.resolve(m):(0,p.$uh)(()=>this.f.getTreeItem(n)).then(f=>this.kb(n,f,t,!0)).then(f=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(f);if(l){const $=this.m.get(l);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(n){if(n){let t;if(typeof n=="string"){const m=this.getExtensionElement(n);t=m?this.m.get(m):void 0}else t=n;return t&&t.children||void 0}return this.h}async Y(n){this.rb(n);const t=new d.$ue(this.Z.token);try{const m=n?this.m.get(n):void 0,f=await this.f.getChildren(n);if(t.token.isCancellationRequested)return;const l=(0,v.$Ib)(f||[]),$=await Promise.all((0,v.$Ib)(l).map(D=>this.f.getTreeItem(D)));if(t.token.isCancellationRequested)return;const I=$.map((D,y)=>D?this.db(l[y],D,m):null);return(0,v.$Ib)(I)}finally{t.dispose()}}$(n){if(n.some(m=>!m))return this.Z.dispose(!0),this.Z=new d.$ue,this.tb(),this.J.$refresh(this.I);{const m=this.ab(n);if(m.length)return this.bb(m)}return Promise.resolve(void 0)}ab(n){const t=new Set,m=n.map(l=>this.m.get(l));for(const l of m)if(l&&!t.has(l.item.handle)){let $=l;for(;$&&$.parent&&m.findIndex(I=>$&&$.parent&&I&&I.item.handle===$.parent.item.handle)===-1;){const I=this.j.get($.parent.item.handle);$=I?this.m.get(I):void 0}$&&!$.parent&&t.add(l.item.handle)}const f=[];return t.forEach(l=>{const $=this.j.get(l);if($){const I=this.m.get($);I&&(!I.parent||!t.has(I.parent.item.handle))&&f.push(l)}}),f}bb(n){const t={};return Promise.all(n.map(m=>this.cb(m).then(f=>{f&&(t[m]=f.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(n){const t=this.getExtensionElement(n);if(t){const m=this.m.get(t);if(m)return this.rb(t),(0,p.$uh)(()=>this.f.getTreeItem(t)).then(f=>{if(f){const l=this.ib(t,f,m.parent);return this.pb(t,l,m,m.parent),m.dispose(),l}return null})}return Promise.resolve(null)}db(n,t,m){const f=this.ib(n,t,m);if(t.id&&this.j.has(f.item.handle))throw new Error((0,w.localize)(0,null,t.id));return this.ob(n,f),this.qb(f,m),f}eb(n){return c.$qN.isMarkdownString(n)?u.MarkdownString.from(n):n}fb(n,t){return t?{...this.L.toInternal(t,n),originalId:t.command}:void 0}gb(n){if(n.checkboxState===void 0)return;let t,m,f;return typeof n.checkboxState=="number"?t=n.checkboxState:(t=n.checkboxState.state,m=n.checkboxState.tooltip,f=n.checkboxState.accessibilityInformation),{isChecked:t===c.TreeItemCheckboxState.Checked,tooltip:m,accessibilityInformation:f}}hb(n){if(!c.$ON.isTreeItem(n,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(n,t,m){this.hb(t);const f=this.B(new A.$Uc),l=this.kb(n,t,m),$=this.lb(t);return{item:{handle:l,parentHandle:m?m.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(f,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,R.$lg)(t.collapsibleState)?c.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:m,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(n){return n.iconPath instanceof c.$XN?n.iconPath:void 0}kb(n,{id:t,label:m,resourceUri:f},l,$){if(t)return`${i.b}/${t}`;const I=a(m,this.N),D=l?l.item.handle:i.a;let y=I?I.label:f?(0,C.$ah)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const S=this.m.has(n)?this.m.get(n).item.handle:void 0,k=this.X(l)||[];let g,b=0;do{if(g=`${D}/${b}:${y}`,$||!this.j.has(g)||S===g)break;b++}while(b<=k.length);return g}lb(n){if(n.iconPath&&!(n.iconPath instanceof c.$XN))return typeof n.iconPath=="string"||P.URI.isUri(n.iconPath)?this.nb(n.iconPath):this.nb(n.iconPath.light)}mb(n){if(n.iconPath&&!(n.iconPath instanceof c.$XN)&&n.iconPath.dark)return this.nb(n.iconPath.dark)}nb(n){return P.URI.isUri(n)?n:P.URI.file(n)}ob(n,t){this.j.set(t.item.handle,n),this.m.set(n,t)}pb(n,t,m,f){this.j.delete(t.item.handle),this.m.delete(n),t.item.handle!==m.item.handle&&this.j.delete(m.item.handle),this.ob(n,t);const l=this.X(f)||[],$=l.filter(I=>I.item.handle===m.item.handle)[0];$&&l.splice(l.indexOf($),1,t)}qb(n,t){t?(t.children||(t.children=[]),t.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}rb(n){if(n){const t=this.m.get(n);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}t.children=void 0}}else this.tb()}sb(n){const t=this.m.get(n);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}this.m.delete(n),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(n=>n.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[303],Ie([1,0,4,5,2,37,10,68,6,7]),function(oe,e,w,C,P,O,A,M,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,A=qe(A),p=qe(p),c=qe(c);class R extends C.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new w.$je),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$je),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class v extends C.$Vc{static c(){return(0,O.$Yg)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$YM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const i=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},n=(0,M.$Dnc)(d),t=v.c();this.f.$createWebviewPanel((0,M.$Fnc)(d),t,r,{title:o,panelOptions:u(h),webviewOptions:(0,M.$Gnc)(d,this.m,h),serializeBuffersForPostMessage:n},s);const m=this.j.createNewWebview(t,h,d);return this.createNewWebviewPanel(t,r,o,i,h,m,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],i=d[a];return h.active?1:i.active?-1:+h.visible-+i.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,M.$Dnc)(d)}),new c.$1M(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:s}=h,n=this.j.createNewWebview(d,o.webviewOptions,s),t=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,n,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,r,o,a,h,i,s){const n=new R(d,this.f,i,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,n),n}getWebviewPanel(d){return this.g.get(d)}}e.$Hnc=v;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[304],Ie([1,0,4,5,68,10,6,7]),function(oe,e,w,C,P,O,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0,A=qe(A),M=qe(M);class p extends C.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(v,u,E,d,r,o){super(),this.#s=!1,this.#u=this.B(new w.$je),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new w.$je),this.onDidDispose=this.#l.event,this.#i=E,this.#a=d,this.#e=v,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(v){this.a(),this.#a!==v&&(this.#a=v,this.#t.$setWebviewViewTitle(this.#e,v))}get description(){return this.a(),this.#o}set description(v){this.a(),this.#o!==v&&(this.#o=v,this.#t.$setWebviewViewDescription(this.#e,v))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(v){v===this.#r||this.#s||(this.#r=v,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(v){this.a(),!(v?.value===this.#c?.value&&v?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(v),this.#t.$setWebviewViewBadge(this.#e,v))}show(v){this.a(),this.#t.$show(this.#e,!!v)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(v,u){this.d=u,this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$YM.MainThreadWebviewViews)}registerWebviewViewProvider(v,u,E,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:v}),this.a.$registerWebviewViewProvider((0,P.$Fnc)(v),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Dnc)(v)}),new M.$1M(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(v,u,E,d,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:a,extension:h}=o,i=this.d.createNewWebview(v,{},h),s=new p(v,this.a,u,E,i,!0);this.c.set(v,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(v,u){this.e(v)._setVisible(u)}async $disposeWebviewView(v){const u=this.e(v);this.c.delete(v),u.dispose(),this.d.deleteWebview(v)}e(v){const u=this.c.get(v);if(!u)throw new Error("No webview found");return u}}e.$dpc=c}),define(Ce[305],Ie([1,0,4,31,32,3]),function(oe,e,w,C,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.OutputChannelUpdateMode=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0,e.$7L="text/x-code-output",e.$8L="output",e.$9L="Log",e.$0L="text/x-code-log-output",e.$$L="log",e.$_L="workbench.panel.output",e.$aM=new P.$Tj("inOutput",!1),e.$bM=new P.$Tj("activeLogOutput",!1),e.$cM=new P.$Tj("activeLogOutput.levelSettable",!1),e.$dM=new P.$Tj("activeLogOutput.level",""),e.$eM=new P.$Tj("activeLogOutput.levelIsDefault",!1),e.$fM=new P.$Tj("outputView.scrollLock",!1),e.$gM=(0,O.$Ci)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$hM={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new w.$je,this.onDidRegisterChannel=this.b.event,this.c=new w.$je,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(R=>c.push(R)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}C.$mo.add(e.$hM.OutputChannels,new M),e.$iM=new P.$Tj("activeOutputChannel","")}),define(Ce[127],Ie([1,0,6,3,17,19,12,305,69,27,51,157,23,15,30,4,5]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Soc=void 0;class a extends A.$ck{get disposed(){return this.n}constructor(n,t,m,f,l){super(),this.id=n,this.name=t,this.r=m,this.s=f,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(m.getLevel()),this.B(m.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.m;this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Clear,n)}replace(n){const t=this.m;this.info(n),this.s.$update(this.id,M.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(n,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof n=="boolean"?n:t))}hide(){this.s.$close(this.id)}g(n,t){this.m+=u.$Le.fromString(t).byteLength,(0,A.log)(this.r,n,t),this.visible&&(this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(n){this.append(n)}}let i=class{constructor(n,t,m,f,l,$){this.i=t,this.j=m,this.k=f,this.l=l,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=n.getProxy(w.$YM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,v.$Zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.h=n;for(const[t,m]of this.g)m.visible=t===this.h}createOutputChannel(n,t,m){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const f=typeof t=="object"&&t.log,l=(0,E.$cg)(t)?t:void 0;if((0,E.$cg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const I=this.i.environment.extensionLogLevel?.find(([y])=>O.$nn.equals(m.identifier,y))?.[1];I&&($=(0,A.$nk)(I));const D=f?this.o(n,$,m):this.n(n,l,m);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(n,$??this.m.getLevel(),D):this.q(n,D)}async n(n,t,m){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,l=this.k.extUri.joinPath(f,`${this.f++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(n,l,t,m.identifier.value);return new a(I,n,$,this.a,m)}async o(n,t,m){const f=await this.p(m),l=n.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(f,`${l}.log`),I=`${m.identifier.value}.${l}`,D=this.l.createLogger($,{id:I,name:n,logLevel:t,extensionId:m.identifier.value});return new h(I,n,D,this.a,m)}p(n){let t=this.d.get(n.identifier.value);if(!t){const m=this.k.extUri.joinPath(this.i.logsLocation,n.identifier.value);this.d.set(n.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(m)}catch(f){if((0,d.$ml)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return m})())}return t}q(n,t){let m=!1;const f=()=>{if(m)throw new Error("Channel has been closed")};return{get name(){return n},append(l){f(),t.then($=>$.append(l))},appendLine(l){f(),t.then($=>$.appendLine(l))},clear(){f(),t.then(l=>l.clear())},replace(l){f(),t.then($=>$.replace(l))},show(l,$){f(),t.then(I=>I.show(l,$))},hide(){f(),t.then(l=>l.hide())},dispose(){m=!0,t.then(l=>l.dispose())}}}r(n,t,m){const f=new o.$Uc,l=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},$=f.add(new r.$je);function I(D){t=D,$.fire(D)}return m.then(D=>{f.add(D),D.logLevel!==t&&I(D.logLevel),f.add(D.onDidChangeLogLevel(y=>I(y)))}),{...this.q(n,m),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(D,...y){l(),m.then(S=>S.trace(D,...y))},debug(D,...y){l(),m.then(S=>S.debug(D,...y))},info(D,...y){l(),m.then(S=>S.info(D,...y))},warn(D,...y){l(),m.then(S=>S.warn(D,...y))},error(D,...y){l(),m.then(S=>S.error(D,...y))},dispose(){f.dispose()}}}};e.$Soc=i,e.$Soc=i=He([Ve(0,P.$sP),Ve(1,c.$IP),Ve(2,p.$znc),Ve(3,R.$cnc),Ve(4,A.$0j),Ve(5,A.$9j)],i),e.$Toc=(0,C.$Ci)("IExtHostOutputService")}),define(Ce[128],Ie([1,0,3,11]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=void 0,e.$Sm=(0,w.$Ci)("remoteAgentService"),e.$Tm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let M=0;M<this.maxSampleCount;M++){const p=await P.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,C.$Dh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((M,p)=>M+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((M,p)=>M+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[306],Ie([1,0,192,54,31,50,42,5,4,128,21,26,11,113]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hb=e.$1hb=e.$Zhb=e.$Yhb=e.$Xhb=e.$Whb=e.$Vhb=e.$Uhb=e.$Thb=e.$Shb=void 0,e.$Shb=Object.freeze({id:"application",order:100,title:(0,w.localize)(0,null),type:"object"}),e.$Thb=Object.freeze({id:"workbench",order:7,title:(0,w.localize)(1,null),type:"object"}),e.$Uhb=Object.freeze({id:"security",scope:C.ConfigurationScope.APPLICATION,title:(0,w.localize)(2,null),type:"object",order:7}),e.$Vhb=Object.freeze({id:"problems",title:(0,w.localize)(3,null),type:"object",order:101}),e.$Whb=Object.freeze({id:"window",order:8,title:(0,w.localize)(4,null),type:"object"}),e.$Xhb={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$je,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const r=new d;P.$mo.add(e.$Xhb.ConfigurationMigration,r);let o=class extends M.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,n){super(),this.a=s,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const m of t.added)await this.f(m,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(s){await this.f(void 0,s);for(const n of this.b.getWorkspace().folders)await this.f(n,s)}async f(s,n){await Promise.all([n.map(t=>this.g(t,s?.uri))])}async g(s,n){const t=this.a.inspect(s.key,{resource:n}),m=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[f,l]of m){const $=t[f];if(!$)continue;const I=[];if($.value!==void 0){const D=await this.h(s,f,$.value,n,void 0);for(const y of D??[])I.push([y,[]])}for(const{identifiers:D,value:y}of $.overrides??[])if(y!==void 0){const S=await this.h(s,f,y,n,D);for(const k of S??[])I.push([k,D])}I.length&&await Promise.allSettled(I.map(async([[D,y],S])=>this.a.updateValue(D,y.value,{resource:n,overrideIdentifiers:S},l)))}}async h(s,n,t,m,f){const l=I=>{const y=this.a.inspect(I,{resource:m})[n];if(y)return f?y.overrides?.find(({identifiers:S})=>(0,v.$do)(S,f))?.value:y.value},$=await s.migrateFn(t,l);return Array.isArray($)?$:[[s.key,$]]}};e.$Yhb=o,e.$Yhb=o=He([Ve(0,A.$9i),Ve(1,O.$Li)],o);let a=class extends M.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$Zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;P.$mo.as(C.$ro.Configuration).registerConfiguration({...e.$Uhb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,w.localize)(5,null)},default:[],markdownDescription:(0,w.localize)(6,null),scope:C.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,w.localize)(7,null),scope:C.ConfigurationScope.MACHINE}}})}};e.$Zhb=a,e.$Zhb=a=He([Ve(0,c.$Sm)],a),e.$1hb="window.newWindowProfile";let h=class extends M.$Vc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,n){super(),this.c=s,this.f=n,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(n.onDidChangeConfiguration(t=>{t.source!==A.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$1hb)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=P.$mo.as(C.$ro.Configuration),n={...e.$Whb,properties:{[e.$1hb]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,w.localize)(8,null)],description:(0,w.localize)(9,null),scope:C.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[n],remove:[this.a]}):s.registerConfiguration(n),this.a=n}h(){const s=this.f.getValue(e.$1hb);this.b=s?this.c.profiles.find(n=>n.name===s):void 0}j(){const s=this.f.getValue(e.$1hb);if(!s)return;const n=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;s!==n?.name&&this.f.updateValue(e.$1hb,n?.name)}};e.$2hb=h,e.$2hb=h=He([Ve(0,E.$Il),Ve(1,A.$9i)],h)}),define(Ce[307],Ie([1,0,41,16,20,24,203,306,54,3,31]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$4hb=e.$3hb=void 0,e.$5hb=r,e.$6hb=o,w=qe(w),e.$3hb=(0,c.$Ci)("editorResolverService"),e.$4hb="workbench.editorAssociations";const v=R.$mo.as(p.$ro.Configuration),u={...M.$Thb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};v.registerConfiguration(u);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function o(a,h){if(new Set([C.Schemas.extension,C.Schemas.webviewPanel,C.Schemas.vscodeWorkspaceTrust,C.Schemas.vscodeSettings]).has(h.scheme))return!1;const n=typeof a=="string"&&a.indexOf(P.$hc.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$ah)(h);return w.$vk(typeof a=="string"?a.toLowerCase():a,n.toLowerCase())}}),define(Ce[308],Ie([1,0,53,16,20,21,24,2,3,226,50,246,128]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,p.$Ci)("pathService");let d=E=class{constructor(o,a,h,i){this.d=o,this.e=a,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(o,i,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===C.Schemas.file||o.scheme===C.Schemas.vscodeRemote?(0,w.$zg)(h??(0,A.$ah)(o),a===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return C.Schemas.vscodeRemote;const h=(0,c.$xM)(a.getWorkspace());if(h)return h;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:C.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?P.$gc:P.$hc)}async fileURI(o){let a="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(a=o.substring(2),o="/"):(a=o.substring(2,i),o=o.substring(i)||"/")}return M.URI.from({scheme:C.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$BM=d,e.$BM=d=E=He([Ve(1,u.$Sm),Ve(2,v.$jM),Ve(3,R.$Li)],d)}),define(Ce[129],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$cL=e.$bL=void 0;class w{constructor(A,M){this.line=A,this.character=M}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,M){return new w(0,0)}with(A){return new w(0,0)}}e.$bL=w;class C{constructor(A,M,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,M),this.end=new w(p,c)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new C(0,0,0,0)}with(A){return new C(0,0,0,0)}}e.$cL=C;var P;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ce[43],Ie([1,0,18,41,26,53,13,3,20,14,129,11]),function(oe,e,w,C,P,O,A,M,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$AL=e.$tL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$qL=e.$pL=e.$oL=e.$nL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.TextSearchCompleteMessageType=void 0,e.$kL=a,e.$lL=h,e.$mL=i,e.$rL=D,e.$sL=y,e.$uL=g,e.$vL=b,e.$wL=L,e.$xL=T,e.$yL=q,e.$zL=G,e.$BL=N,e.$DL=ge,e.$EL=ie,C=qe(C),P=qe(P),O=qe(O),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$dL="workbench.view.search",e.$eL="workbench.panel.search",e.$fL="workbench.view.search",e.$gL="search-result",e.$hL="search.exclude",e.$iL=2e4;const u="\u27EA ",E=" characters skipped \u27EB",d=(u.length+E.length+5)*2;e.$jL=(0,M.$Ci)("searchService");var r;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(se){return!!se.preview}function h(se){return!!se.resource}function i(se){return!!se.message}var s;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class n{constructor(de){this.resource=de,this.results=[]}}e.$nL=n;class t{constructor(de,be,re,Pe){this.ranges=be,this.webviewIndex=Pe;const Le=Array.isArray(be)?be:[be];if(re&&re.matchLines===1&&m(Le)){de=(0,A.$8f)(de,re.matchLines);let Y="",B=0,_=0;const we=Math.floor(re.charsPerLine/5),ae=[];for(const ve of Le){const le=Math.max(ve.startColumn-we,0),X=ve.startColumn+re.charsPerLine;if(le>_+we+d){const Z=u+(le-_)+E;Y+=Z+de.slice(le,X),B+=le-(_+Z.length)}else Y+=de.slice(_,X);ae.push(new l(0,ve.startColumn-B,ve.endColumn-B)),_=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const Y=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:de,matches:(0,w.$2b)(be,B=>new f(B.startLineNumber-Y,B.startColumn,B.endLineNumber-Y,B.endColumn))}}}}e.$oL=t;function m(se){const de=se[0].startLineNumber;for(const be of se)if(be.startLineNumber!==de||be.endLineNumber!==de)return!1;return!0}class f{constructor(de,be,re,Pe){this.startLineNumber=de,this.startColumn=be,this.endLineNumber=re,this.endColumn=Pe}}e.$pL=f;class l extends f{constructor(de,be,re){super(de,be,de,re)}}e.$qL=l;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var I;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(se,de=!0){const be=se&&se.files&&se.files.exclude,re=de&&se&&se.search&&se.search.exclude;if(!be&&!re)return;if(!be||!re)return be||re;let Pe=Object.create(null);return Pe=P.$co(Pe,P.$_n(be)),Pe=P.$co(Pe,P.$_n(re),!0),Pe}function y(se,de){return se.excludePattern&&C.$vk(se.excludePattern,de)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&C.$vk(se.includePattern,de)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(be=>{const re=be.folder.fsPath;if(O.$Bg(de,re)){const Pe=p.$mc(re,de);return!be.includePattern||!!C.$vk(be.includePattern,Pe)}else return!1}):!1:!0}var S;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class k extends Error{constructor(de,be){super(de),this.code=be}}e.$tL=k;function g(se){const de=se.message;if((0,c.$5)(se))return new k(de,S.canceled);try{const be=JSON.parse(de);return new k(be.message,be.code)}catch{return new k(de,S.other)}}function b(se){const de={message:se.message,code:se.code};return new Error(JSON.stringify(de))}function L(se){return se.type==="error"?!0:se.type==="success"}function T(se){return se.type==="success"}function q(se){return!!se.path}function G(se,de,be=!0){const re=se.searchPath?se.searchPath:se.relativePath;return be?(0,A.$5f)(re,de):C.$vk(de,re)}class W{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$AL=W;function N(se,de){const be={...se||{},...de||{}};return Object.keys(be).filter(re=>{const Pe=be[re];return typeof Pe=="boolean"&&Pe})}class V{constructor(de,be){this.c=null,this.a={...de.excludePattern||{},...be.excludePattern||{}},this.b=C.$wk(this.a);let re=de.includePattern;be.includePattern&&(re?re={...re,...be.includePattern}:re=be.includePattern),re&&(this.c=C.$wk(re))}matchesExcludesSync(de,be,re){return!!(this.b&&this.b(de,be,re))}includedInQuerySync(de,be,re){return!(this.b&&this.b(de,be,re)||this.c&&!this.c(de,be,re))}includedInQuery(de,be,re){const Pe=this.b(de,be,re),Le=()=>this.c?!!this.c(de,be,re):!0;return(0,v.$oh)(Pe)?Pe.then(Y=>Y?!1:Le()):Le()}hasSiblingExcludeClauses(){return ce(this.a)}}e.$CL=V;function ce(se){for(const de in se)if(typeof se[de]!="boolean")return!0;return!1}function ge(se){if(!se)return;let de;return be=>(de||(de=(se()||Promise.resolve([])).then(re=>re?me(re):{})),de.then(re=>!!re[be]))}function ie(se){if(!se)return;let de;return be=>{if(!de){const re=se();de=re?me(re):{}}return!!de[be]}}function me(se){const de={};for(const be of se)de[be]=!0;return de}}),define(Ce[44],Ie([1,0,18,11,22,4,5,59,16,138,24,13,2,191,30,3,12,214,50,51,27,17,10,7,66,43,6,49]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;function D(q,G,W){return new R.$5g(N=>g(N,W)).isEqual(q,G)}function y(q,G,W){return D(q.uri,G.uri,W)?0:(0,v.$wf)(q.uri.toString(),G.uri.toString())}function S(q,G,W){return q.index!==G.index?q.index<G.index?-1:1:D(q.uri,G.uri,W)?(0,v.$wf)(q.name,G.name):(0,v.$wf)(q.uri.toString(),G.uri.toString())}function k(q,G,W,N){const V=q.slice(0).sort((ge,ie)=>W(ge,ie,N)),ce=G.slice(0).sort((ge,ie)=>W(ge,ie,N));return(0,w.$Fb)(V,ce,(ge,ie)=>W(ge,ie,N))}function g(q,G){const W=G.getCapabilities(q.scheme);return!(W&&W&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends h.$Vi{static toExtHostWorkspace(G,W,N,V){if(!G)return{workspace:null,added:[],removed:[]};const{id:ce,name:ge,folders:ie,configuration:me,transient:se,isUntitled:de}=G,be=[],re=W;W?ie.forEach((B,_)=>{const we=u.URI.revive(B.uri),ae=b.o(N||W,we,V);ae?(ae.name=B.name,ae.index=B.index,be.push(ae)):be.push({uri:we,name:B.name,index:_})}):be.push(...ie.map(({uri:B,name:_,index:we})=>({uri:u.URI.revive(B),name:_,index:we}))),be.sort((B,_)=>B.index<_.index?-1:1);const Pe=new b(ce,ge,be,!!se,me?u.URI.revive(me):null,!!de,B=>g(B,V)),{added:Le,removed:Y}=k(re?re.workspaceFolders:[],Pe.workspaceFolders,y,V);return{workspace:Pe,added:Le,removed:Y}}static o(G,W,N){for(let V=0;V<G.folders.length;V++){const ce=G.workspaceFolders[V];if(D(ce.uri,W,N))return ce}}constructor(G,W,N,V,ce,ge,ie){super(G,N.map(me=>new h.$Wi(me)),V,ce,ie),this.t=W,this.u=ge,this.q=[],this.s=M.$Ii.forUris(ie),N.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,W){return W&&this.s.get(G)&&(G=(0,R.$ch)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let L=class{constructor(G,W,N,V,ce){this.c=new O.$je,this.onDidChangeWorkspace=this.c.event,this.g=new O.$je,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$le,this.C=new Map,this.h=V,this.s=N,this.t=ce,this.j=new c.$Jm,this.k=new C.$Bh,this.o=G.getProxy($.$YM.MainThreadWorkspace),this.q=G.getProxy($.$YM.MainThreadMessageService);const ge=W.workspace;this.l=ge?new b(ge.id,ge.name,[],!!ge.transient,ge.configuration?u.URI.revive(ge.configuration):null,!!ge.isUntitled,ie=>g(ie,N)):void 0}$initializeWorkspace(G,W){this.v=W,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,R.$ah)((0,R.$ch)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,W,N,...V){const ce=[];if(Array.isArray(V)&&V.forEach(de=>{u.URI.isUri(de.uri)&&!ce.some(be=>D(be.uri,de.uri,this.s))&&ce.push({uri:de.uri,name:de.name||(0,R.$_g)(de.uri)})}),this.n||[W,N].some(de=>typeof de!="number"||de<0)||N===0&&ce.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(W+N>ge.length)return!1;const ie=ge.slice(0);ie.splice(W,N,...ce.map(de=>({uri:de.uri,name:de.name||(0,R.$_g)(de.uri),index:void 0})));for(let de=0;de<ie.length;de++){const be=ie[de];if(ie.some((re,Pe)=>Pe!==de&&D(be.uri,re.uri,this.s)))return!1}ie.forEach((de,be)=>de.index=be);const{added:me,removed:se}=k(ge,ie,S,this.s);if(me.length===0&&se.length===0)return!1;if(this.o){const de=G.displayName||G.name;this.o.$updateWorkspaceFolders(de,W,N,ce).then(void 0,be=>{this.n=void 0;const re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(a.Severity.Error,(0,E.localize)(0,null,de,be.toString()),re,[])})}return this.y(ie),!0}getWorkspaceFolder(G,W){if(this.x)return this.x.getWorkspaceFolder(G,W)}async getWorkspaceFolder2(G,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,W)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,W){let N,V="";if(typeof G=="string"?(N=u.URI.file(G),V=G):typeof G<"u"&&(N=G,V=G.fsPath),!N)return V;const ce=this.getWorkspaceFolder(N,!0);if(!ce)return V;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ge=(0,R.$fh)(ce.uri,N);return W&&ce.name&&(ge=`${ce.name}/${ge}`),ge}y(G){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:W,added:N,removed:V}=b.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:V}))}findFiles(G,W,N,V,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let ge="",ie=!0;return W===null?ie=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this.z(G,void 0,{exclude:ge,maxResults:N,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ce)}findFiles2(G,W={},N,V=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,G,W,V)}async z(G,W,N,V=P.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const ce=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ge={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:ce,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ie;if(G){const{includePattern:me,folder:se}=T(t.GlobPattern.from(G));ie=se,ge.includePattern=me}else{const{includePattern:me,folder:se}=T(t.GlobPattern.from(W));ie=se,ge.filePattern=me}return this.o.$startFileSearch(ie??null,ge,V).then(me=>Array.isArray(me)?me.map(se=>u.URI.revive(se)):[])}async findTextInFiles(G,W,N,V,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),ie=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:me,folder:se}=T(t.GlobPattern.from(W.include)),de=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,be={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:ie,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:me,excludePattern:de},re=!1;if(this.u[ge]=Pe=>{if(re)return;const Le=u.URI.revive(Pe.resource);Pe.results.forEach(Y=>{const B=(0,I.$_h)(Y);(0,l.$kL)(B)?N({uri:Le,preview:{text:B.preview.text,matches:(0,w.$2b)(B.preview.matches,_=>new m.$3M(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,w.$2b)(B.ranges,_=>new m.$3M(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):N({uri:Le,text:B.text,lineNumber:B.lineNumber})})},ce.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(G,se??null,be,ge,ce);return delete this.u[ge],Pe||{}}catch(Pe){throw delete this.u[ge],Pe}}$handleTextSearchResult(G,W){this.u[W]?.(G)}async save(G){const W=await this.o.$save(G,{saveAs:!1});return u.URI.revive(W)}async saveAs(G){const W=await this.o.$save(G,{saveAs:!0});return u.URI.revive(W)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,W){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,W);const N=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,N),(0,A.$Tc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(G,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const N=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const V=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!V),!V)return;const ce=await V.provideEditSessionIdentity(N,W);if(this.h.info("Provider returned edit session identifier: ",ce),!!ce)return ce}async $provideEditSessionIdentityMatch(G,W,N,V){this.h.info("Getting edit session identifier for workspaceFolder",G);const ce=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!ce){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ce);const ge=this.w.get(ce.uri.scheme);if(this.h.info(`Provider for scheme ${ce.uri.scheme} is defined: `,!!ge),!ge)return;const ie=await ge.provideEditSessionIdentityMatch?.(W,N,V);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(G){return(W,N,V)=>{const ce=function(ie){W.call(N,ie)};return ce.extension=G,this.B.event(ce,void 0,V)}}async $onWillCreateEditSessionIdentity(G,W,N){const V=await this.resolveWorkspaceFolder(u.URI.revive(G));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},W,async(ce,ge)=>{const ie=Date.now();await Promise.resolve(ce),Date.now()-ie>N&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(G,W){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,W);const N=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerCanonicalUriProvider(V,N),(0,A.$Tc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(G,W,N){const V=this.C.get(G.scheme);if(!V)return;const ce=await V.provideCanonicalUri?.(u.URI.revive(G),W,N);if(ce)return ce}async $provideCanonicalUri(G,W,N){return this.provideCanonicalUri(u.URI.revive(G),{targetScheme:W},N)}};e.$tnc=L,e.$tnc=L=He([Ve(0,n.$sP),Ve(1,s.$IP),Ve(2,i.$cnc),Ve(3,o.$9j),Ve(4,f.$rnc)],L),e.$unc=(0,r.$Ci)("IExtHostWorkspace");function T(q){let G,W;return q&&(typeof q=="string"?G=q:(G=q.pattern,W=u.URI.revive(q.baseUri))),{includePattern:G,folder:W}}}),define(Ce[45],Ie([1,0,26,4,44,6,7,42,215,54,15,11,3,17,12,2]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=e.$vnc=void 0;function o(f,l){if(l){const $=l.split(".");let I=f;for(let D=0;I&&D<$.length;D++)I=I[$[D]];return I}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function n(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let t=class{constructor(l,$,I){this.a=l.getProxy(O.$YM.MainThreadConfiguration),this.c=$,this.b=I,this.d=new v.$Bh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new m(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,$){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(l,$))}};e.$vnc=t,e.$vnc=t=He([Ve(0,E.$sP),Ve(1,P.$unc),Ve(2,d.$9j)],t);class m{constructor(l,$,I,D){this.a=new C.$je,this.b=l,this.f=D,this.c=$,this.e=p.$Ko.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,$){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ko.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j($,I))}getConfiguration(l,$,I){const D=n($)||{},y=this.g(l?o(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,I?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?M.ConfigurationTarget.USER:M.ConfigurationTarget.WORKSPACE;switch(g){case A.ConfigurationTarget.Global:return M.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return M.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return M.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(g){return typeof o(y,g)<"u"},get:(g,b)=>{this.h(l?`${l}.${g}`:g,D,I?.identifier);let L=o(y,g);if(typeof L>"u")L=b;else{let T;const q=(G,W)=>{if((0,R.$eg)(G)){let N;const V=()=>{T=T||(0,w.$_n)(y),N=N||o(T,W)};return new Proxy(G,{get:(ce,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return V(),()=>N;if(T)return N=N||o(T,W),N[ge];const ie=ce[ge];return typeof ge=="string"?q(ie,`${W}.${ge}`):ie},set:(ce,ge,ie)=>(V(),N&&(N[ge]=ie),!0),deleteProperty:(ce,ge)=>(V(),N&&delete N[ge],!0),defineProperty:(ce,ge,ie)=>(V(),N&&Object.defineProperty(N,ge,ie),!0)})}return Array.isArray(G)?(0,w.$_n)(G):G};L=q(L,g)}return L},update:(g,b,L,T)=>{g=l?`${l}.${g}`:g;const q=S(L);return b!==void 0?this.b.$updateConfigurationOption(q,g,b,D,T):this.b.$removeConfigurationOption(q,g,D,T)},inspect:g=>{g=l?`${l}.${g}`:g;const b=this.e.inspect(g,D,this.c.workspace);if(b)return{key:g,defaultValue:(0,w.$_n)(b.policy?.value??b.default?.value),globalValue:(0,w.$_n)(b.user?.value??b.application?.value),workspaceValue:(0,w.$_n)(b.workspace?.value),workspaceFolderValue:(0,w.$_n)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.$_n)(b.default?.override),globalLanguageValue:(0,w.$_n)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.$_n)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.$_n)(b.workspaceFolder?.override),languageIds:(0,w.$_n)(b.overrideIdentifiers)}}};return typeof y=="object"&&(0,w.$co)(k,y,!1),Object.freeze(k)}g(l){const $=I=>(0,R.$eg)(I)?new Proxy(I,{get:(D,y)=>$(D[y]),set:(D,y,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return $(l)}h(l,$,I){const D=c.$Bo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=I?`[${I.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,$){const I=new p.$Mo(l,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>I.affectsConfiguration(D,n(y))})}k(l){return l.reduce(($,I)=>($.set(I[0],I[1]),$),new Map)}}e.$wnc=m,e.$xnc=(0,u.$Ci)("IExtHostConfiguration")}),define(Ce[130],Ie([1,0,2,11,4,6,7,44,58,45,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=e.$6oc=e.$5oc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),o=qe(o);var n;(function(T){function q(W){if(W!=null)return W}T.from=q;function G(W){if(W!=null)return W}T.to=G})(n||(n={}));var t;(function(T){function q(W){if(W!=null)return W}T.from=q;function G(W){if(W!=null)return W}T.to=G})(t||(t={}));var m;(function(T){function q(W){if(W!=null)return W}T.from=q;function G(W){if(W!=null)return W}T.to=G})(m||(m={}));var f;(function(T){function q(N){if(N){const V=N;return V&&!!V.process}else return!1}T.is=q;function G(N){if(N==null)return;const V={process:N.process,args:N.args};return N.options&&(V.options=m.from(N.options)),V}T.from=G;function W(N){if(N!=null)return new A.$KN(N.process,N.args,N.options)}T.to=W})(f||(f={}));var l;(function(T){function q(W){if(W!=null)return W}T.from=q;function G(W){if(W!=null)return W}T.to=G})(l||(l={}));var $;(function(T){function q(N){if(N){const V=N;return V&&(!!V.commandLine||!!V.command)}else return!1}T.is=q;function G(N){if(N==null)return;const V={};return N.commandLine!==void 0?V.commandLine=N.commandLine:(V.command=N.command,V.args=N.args),N.options&&(V.options=l.from(N.options)),V}T.from=G;function W(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$LN(N.commandLine,N.options):new A.$LN(N.command,N.args?N.args:[],N.options)}T.to=W})($||($={}));var I;(function(T){function q(N){if(N){const V=N;return V&&V.customExecution==="customExecution"}else return!1}T.is=q;function G(N){return{customExecution:"customExecution"}}T.from=G;function W(N,V){return V.get(N)}T.to=W})(I||(e.CustomExecutionDTO=I={}));var D;(function(T){function q(G,W){let N;return G.scope!==void 0&&typeof G.scope!="number"?N=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?N=W.workspaceFile:N=i.$BI),{id:G._id,workspaceFolder:N}}T.from=q})(D||(e.TaskHandleDTO=D={}));var y;(function(T){function q(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}T.from=q})(y||(y={}));var S;(function(T){function q(N,V){if(N==null)return[];const ce=[];for(const ge of N){const ie=G(ge,V);ie&&ce.push(ie)}return ce}T.fromMany=q;function G(N,V){if(N==null)return;let ce;N.execution instanceof A.$KN?ce=f.from(N.execution):N.execution instanceof A.$LN?ce=$.from(N.execution):N.execution&&N.execution instanceof A.$MN&&(ce=I.from(N.execution));const ge=n.from(N.definition);let ie;return N.scope?typeof N.scope=="number"?ie=N.scope:ie=N.scope.uri:ie=A.TaskScope.Workspace,!ge||!ie?void 0:{_id:N._id,definition:ge,name:N.name,source:{extensionId:V.identifier.value,label:N.source,scope:ie},execution:ce,isBackground:N.isBackground,group:y.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}T.from=G;async function W(N,V,ce){if(N==null)return;let ge;f.is(N.execution)?ge=f.to(N.execution):$.is(N.execution)?ge=$.to(N.execution):I.is(N.execution)&&(ge=I.to(N._id,ce));const ie=n.to(N.definition);let me;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?me=N.source.scope:me=await V.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):me=A.TaskScope.Workspace),!ie||!me)return;const se=new A.$NN(ie,me,N.name,N.source.label,ge,N.problemMatchers);return N.isBackground!==void 0&&(se.isBackground=N.isBackground),N.group!==void 0&&(se.group=A.$JN.from(N.group._id),se.group&&N.group.isDefault&&(se.group=new A.$JN(se.group.id,se.group.label),N.group.isDefault===!0&&(se.group.isDefault=N.group.isDefault))),N.presentationOptions&&(se.presentationOptions=t.to(N.presentationOptions)),N._id&&(se._id=N._id),N.detail&&(se.detail=N.detail),se}T.to=W})(S||(e.TaskDTO=S={}));var k;(function(T){function q(W){return W}T.from=q;function G(W){if(W)return Object.assign(Object.create(null),W)}T.to=G})(k||(k={}));class g{#e;constructor(q,G,W){this._id=G,this.a=W,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let b=class{constructor(q,G,W,N,V,ce,ge,ie){this.q=new P.$je,this.r=new P.$je,this.s=new P.$je,this.u=new P.$je,this.a=q.getProxy(O.$YM.MainThreadTask),this.b=W,this.c=N,this.d=V,this.e=ce,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,G,W){if(!W)return new A.$1M(()=>{});const N=this.x();return this.j.set(N,{type:G,provider:W,extension:q}),this.a.$registerTaskProvider(N,G),new A.$1M(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(q,G){this.a.$registerTaskSystem(q,G)}fetchTasks(q){return this.a.$fetchTasks(k.from(q)).then(async G=>{const W=[];for(const N of G){const V=await S.to(N,this.b,this.m);V&&W.push(V)}return W})}get taskExecutions(){const q=[];return this.k.forEach(G=>q.push(G)),q}terminateTask(q){if(!(q instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,G,W){const N=this.m.get(q.id);N&&(this.o.set(q.id,N),this.e.attachPtyToTerminal(G,await N.callback(W))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const G=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const G=await this.z(q.id);this.s.fire({execution:G,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const G=await this.z(q.id);this.u.fire({execution:G,exitCode:q.exitCode})}$provideTasks(q,G){const W=this.j.get(q);if(!W)return Promise.reject(new Error("no handler found"));const N=[],V=(0,C.$uh)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(ce=>this.v(G,N,W,ce));return new Promise(ce=>{V.then(ge=>{Promise.all(N).then(()=>{ce(ge)})})})}async $resolveTask(q,G){const W=this.j.get(q);if(!W)return Promise.reject(new Error("no handler found"));if(G.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${W.type}].`);const N=await S.to(G,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const V=await W.provider.resolveTask(N,R.CancellationToken.None);if(!V)return;this.A(V,W);const ce=S.from(V,W.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(ce.execution)&&await this.y(ce,V,!0),await this.w(ce)}x(){return this.h++}async y(q,G,W){const N=await this.a.$createTaskId(q);!W&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,G.execution)),this.m.set(N,G.execution)}async z(q,G){if(typeof q=="string"){const V=this.l.get(q);if(!V)throw new s.$cb("Unexpected: The specified task is missing an execution");return V}const W=this.l.get(q.id);if(W)return W;let N;return G?N=Promise.resolve(new g(this,q.id,G)):N=S.to(q.task,this.b,this.m).then(V=>{if(!V)throw new s.$cb("Unexpected: Task does not exist.");return new g(this,q.id,V)}),this.l.set(q.id,N),N.then(V=>(this.k.set(q.id,V),V))}A(q,G){q._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const W=this.n.values();let N=W.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=W.next()}};e.$5oc=b,e.$5oc=b=He([Ve(0,u.$sP),Ve(1,E.$IP),Ve(2,M.$unc),Ve(3,p.$DP),Ve(4,c.$xnc),Ve(5,v.$Vnc),Ve(6,a.$9j),Ve(7,h.$$mc)],b);let L=class extends b{constructor(q,G,W,N,V,ce,ge,ie){super(q,G,W,N,V,ce,ge,ie),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(q,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const W=S.from(G,q);if(W===void 0)throw new Error("Task is not valid");if(I.is(W.execution))await this.y(W,G,!1);else throw new s.$ab;const N=await this.z(await this.a.$getTaskExecution(W),G);return this.a.$executeTask(W).catch(V=>{throw new Error(V)}),N}v(q,G,W,N){const V=[];if(N)for(const ce of N){if(this.A(ce,W),!ce.definition||!q[ce.definition.type]){const ie=ce.source?ce.source:"No task source";this.f.warn(`The task [${ie}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=S.from(ce,W.extension);ge&&I.is(ge.execution)?(V.push(ge),G.push(this.y(ge,ce,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:W.extension}}async w(q){if(I.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,G,W){}};e.$6oc=L,e.$6oc=L=He([Ve(0,u.$sP),Ve(1,E.$IP),Ve(2,M.$unc),Ve(3,p.$DP),Ve(4,c.$xnc),Ve(5,v.$Vnc),Ve(6,a.$9j),Ve(7,h.$$mc)],L),e.$7oc=(0,d.$Ci)("IExtHostTask")}),define(Ce[309],Ie([1,0,43,33]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LL=void 0,e.$KL=P,e.$ML=O;function P(A){return"cellResults"in A}e.$LL="rawCell#";function O(A,M){let p=-1;const c=[];let R=[];return A.forEach(u=>{u.range.startLineNumber!==p&&R.length>0&&(c.push([...R]),R=[]),R.push(u),p=u.range.endLineNumber}),R.length>0&&c.push([...R]),c.map(u=>{const E=[],d=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=d;o<=r;o++)E.push(M.getLineContent(o));return new w.$oL(E.join(`
`)+`
`,u.map(o=>new C.$Ft(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[310],Ie([1,0,185,23,4,5,29,38,13,15,2,30,80,6,34,10,7,39,287,123,26,16,43,240,309,307]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0,v=qe(v),r=qe(r),o=qe(o);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,S,k,g,b,L){this.q=S,this.r=k,this.s=g,this.t=b,this.u=L,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new P.$je,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$je,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$je,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$je,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$9mc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$YM.MainThreadNotebook),this.c=D.getProxy(E.$YM.MainThreadNotebookDocuments),this.d=D.getProxy(E.$YM.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===M.MarshalledId.NotebookCellActionContext){const q=T.notebookEditor?.notebookUri,G=T.cell.handle,N=this.g.get(q)?.getCell(G);if(N)return N.apiCell}if(T&&T.$mid===M.MarshalledId.NotebookActionContext){const q=T.uri,G=this.g.get(q);if(G)return G.apiNotebook}return T}}),$.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,S]of this.h)if(S.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const S=this.g.get(D);if(!S&&!y)throw new Error(`NO notebook document for '${D}'`);return S}static w(D,y){if(!y)return;const S=y.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(y.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:S,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,y,S){const k=$.a++,g=typeof S.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(k,S),this.b.$registerNotebookCellStatusBarItemProvider(k,g,y);let b;return g!==void 0&&(b=S.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(g))),new o.$1M(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,g),b?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return R.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const S=await this.c.$tryOpenNotebook(D),k=this.g.get(R.URI.revive(S));return(0,c.$ng)(k?.apiNotebook)}async showNotebookDocument(D,y){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let S;typeof y=="object"?S={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:S={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,S),g=k&&this.h.get(k)?.apiEditor;if(g)return g;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,S,k){const g=this.f.get(D),b=R.URI.revive(y),L=this.g.get(b);if(!L||!g)return;const T=L.getCellFromIndex(S);if(!T)return;const q=await g.provideCellStatusBarItems(T.apiCell,k);if(!q)return;const G=new O.$Uc,W=this.p.add([G]),V=(Array.isArray(q)?q:[q]).map(ce=>r.NotebookStatusBarItem.from(ce,this.i,G));return{cacheId:W,items:V}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,S,k,g){if((0,p.$af)(y))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:y,serializer:S,options:k}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},y,r.NotebookDocumentContentOptions.from(k),$.w(D,g)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.deserializeNotebook(y.buffer,S);return new a.$Nw(r.NotebookData.from(g))}async $notebookToData(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.serializeNotebook(r.NotebookData.to(y.value),S);return C.$Le.wrap(g)}async $saveNotebook(D,y,S,k,g){const b=R.URI.revive(y),L=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${S}, ${b.toString()})`),!L)throw new Error("NO serializer found");const T=this.g.get(b);if(!T)throw new Error("Document NOT found");if(T.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new v.$rl((0,w.localize)(0,null,this.A(b)),v.FileOperationResult.FILE_PERMISSION_DENIED);const q={metadata:(0,s.$ho)(T.apiNotebook.metadata,ce=>!(L.options?.transientDocumentMetadata??{})[ce]),cells:[]};for(const ce of T.apiNotebook.getCells()){const ge=new o.$rO(ce.kind,ce.document.getText(),ce.document.languageId,ce.mime,L.options?.transientOutputs?[]:[...ce.outputs],ce.metadata,ce.executionSummary);ge.metadata=(0,s.$ho)(ce.metadata,ie=>!(L.options?.transientCellMetadata??{})[ie]),q.cells.push(ge)}if(await this.z(b,k),g.isCancellationRequested)throw new Error("canceled");const G=await L.serializer.serializeNotebook(q,g);if(g.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${S} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${S} ${b.toString()}`);const W=this.s.getFileSystemProviderExtUri(b.scheme),N=await this.s.value.stat(b),V={name:W.basename(b),isFile:(N.type&v.FileType.File)!==0,isDirectory:(N.type&v.FileType.Directory)!==0,isSymbolicLink:(N.type&v.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&v.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((N.permissions??0)&v.FilePermission.Locked),etag:v.$Cl({mtime:N.mtime,size:N.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${S}, ${b.toString()})`),V}async $searchInNotebooks(D,y,S,k,g){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const L=new A.$Cc;await(async(N,V,ce)=>{await Promise.all(N.map(async ge=>await Promise.all(ge.filenamePatterns.map(ie=>{const me={_reason:ce._reason,folderQueries:ce.folderQueries,includePattern:ce.includePattern,excludePattern:ce.excludePattern,maxResults:ce.maxResults,type:t.QueryType.File,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(me,V,se=>{se.forEach(de=>{L.has(de)||k.some(re=>ge.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,l.$6hb)(Pe,de)))||L.add(de)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(S,g,y);const q=new A.$Bc;let G=!1;const W=Array.from(L).map(async N=>{const V=[];try{if(g.isCancellationRequested)return;if(y.maxResults&&[...q.values()].reduce((me,se)=>me+se.cellResults.length,0)>y.maxResults){G=!0;return}const ce=[],ge=this.g.get(N);if(ge)ge.apiNotebook.getCells().forEach(se=>ce.push({input:se.document.getText(),outputs:se.outputs.flatMap(de=>de.items.map(be=>be.data.toString()))}));else{const me=await this.s.value.readFile(N),se=C.$Le.fromString(me.toString()),de=await b.deserializeNotebook(se.buffer,g);if(g.isCancellationRequested)return;r.NotebookData.from(de).cells.forEach(re=>ce.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Le=>Le.valueBytes.toString()))}))}if(g.isCancellationRequested)return;ce.forEach((me,se)=>{const de=y.contentPattern.pattern,be=new m.$uYb(me.input,void 0,me.outputs),re=be.findInInputs(de),Pe=be.findInOutputs(de),Le=Pe.flatMap(Y=>(0,f.$ML)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(re.length>0||Pe.length>0){const Y={index:se,contentResults:(0,f.$ML)(re,be.inputTextBuffer),webviewResults:Le};V.push(Y)}});const ie={resource:N,cellResults:V};q.set(N,ie);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...q.values()]}}async z(D,y){const S=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==v.$Bl&&typeof S.mtime=="number"&&typeof S.size=="number"&&y.mtime<S.mtime&&y.etag!==v.$Cl({mtime:y.mtime,size:S.size}))throw new v.$rl((0,w.localize)(1,null),v.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===n.Schemas.file?D.fsPath:D.toString()}B(D,y,S){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const k=new i.$yoc(y,this.d,D,S.visibleRanges.map(r.NotebookRange.to),S.selections.map(r.NotebookRange.to),typeof S.viewColumn=="number"?r.ViewColumn.to(S.viewColumn):void 0);this.h.set(y,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const S of D.value.removedDocuments){const k=R.URI.revive(S),g=this.g.get(k);g&&(g.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(g.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===k.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const S=[];for(const k of D.value.addedDocuments){const g=R.URI.revive(k.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const b=new h.$xoc(this.c,this.q,this.r,g,k);S.push(...k.cells.map(L=>h.$woc.asModelAddData(L))),this.g.get(g)?.dispose(),this.g.set(g,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const S of D.value.addedEditors){if(this.h.has(S.id))return;const k=R.URI.revive(S.documentUri),g=this.g.get(k);g&&this.B(g,S.id,S)}const y=[];if(D.value.removedEditors)for(const S of D.value.removedEditors){const k=this.h.get(S);k&&(this.h.delete(S),this.k?.id===k.id&&(this.k=void 0),y.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const S=new Set;this.l.forEach(k=>S.add(k.id));for(const k of this.h.values()){const g=S.has(k.id);k._acceptVisibility(g)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=d.$QP.String.with("notebookType","A notebook type"),S=new d.$SP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new d.$QP("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>C.$Le.wrap(g))],new d.$RP("Notebook Data",g=>r.NotebookData.to(g.value))),k=new d.$SP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new d.$QP("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new a.$Nw(r.NotebookData.from(g)))],new d.$RP("Bytes",g=>g.buffer));D.registerApiCommand(S),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Hoc=$}),define(Ce[311],Ie([1,0,20,22,48,41,24,70,43]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0,w=qe(w),O=qe(O),A=qe(A);class c{constructor(u,E,d){this.k=u,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$wk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$wk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,u(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),i=w.$oc(h);this.j&&this.j(h,i)||this.v(o,{base:a,basename:i})}),Promise.all(E.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,P.$nj)(a)))})})}async p(u,E){const d=new C.$ue,r=this.q(u),o=this.r(),a=new p.$CL(this.k,u),h=!a.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=M.$de.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),n=i.elapsed(),t=M.$de.create();return this.g&&!this.e||(s&&s.forEach(m=>{const f=w.$hc.relative(u.folder.path,m.path);if(h){const l=w.$oc(m.path);this.v(E,{base:u.folder,relativePath:f,basename:l});return}this.s(o,u.folder,f,E)}),this.g&&!this.e)?null:(this.u(o,a,E),{providerTime:n,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const E=(0,p.$BL)(this.k.includePattern,u.includePattern),d=(0,p.$BL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,d,r){if(d===this.a){const a=w.$oc(this.a);this.v(r,{base:E,relativePath:this.a,basename:a})}function o(a){const h=w.$oc(a),i=w.$nc(a);let s=u[i];s||(s=u[i]=[],o(i)),s.push({base:E,relativePath:a,basename:h})}o(d)}u({rootEntries:u,pathToEntries:E},d,r){const o=this,a=this.a;function h(i){const s=(0,p.$EL)(()=>i.map(n=>n.basename));for(let n=0,t=i.length;n<t;n++){const m=i[n],{relativePath:f,basename:l}=m;if(d.matchesExcludesSync(f,l,a!==l?s:void 0))continue;const $=E[f];if($)h($);else{if(f===a)continue;o.v(r,m)}if(o.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,d,r){const o=this.c(u.cacheKey),a=new c(u,E,o&&o.token);let h=0;const i=s=>{h+=s.length,d(s.map(n=>this.d(n)))};return this.e(a,R.a,i,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new C.$ue),this.b.get(u)}d(u){return u.relativePath?{resource:A.$dh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,d,r){const o=r.onCancellationRequested(()=>{u.cancel()}),a=i=>{i&&(h.push(i),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return u.search(a).then(i=>(h.length&&d(h),o.dispose(),i),i=>(h.length&&d(h),o.dispose(),Promise.reject(i)))}}e.$zoc=R}),define(Ce[312],Ie([1,0,18,282,41,103,29,16,20,24,13,15,2,102,205,42,12,50,117,308,43]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=void 0,e.$DM=y,w=qe(w),C=qe(C),P=qe(P),p=qe(p),R=qe(R),d=qe(d);let n=class{constructor(k,g,b,L,T){this.a=k,this.b=g,this.c=b,this.d=L,this.e=T}text(k,g,b={}){k=this.f(k,b);const L=this.a.getValue(),T=g&&g.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(g?.map(a.$Xi),b),type:s.QueryType.Text,contentPattern:k,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:L.search.usePCRE2||T||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(k,g){const b=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const L={...k,wordSeparators:b.editor.wordSeparators};return this.j(k,g)&&(L.isCaseSensitive=!0),this.k(k)&&(L.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),L}file(k,g={}){return{...this.h(k,g),type:s.QueryType.File,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey,shouldGlobMatchFilePattern:g.shouldGlobSearch}}g(k,g){return k?(k=Array.isArray(k)?k.map($):$(k),g?this.parseSearchPaths(k):{pattern:m(...Array.isArray(k)?k:[k])}):{}}h(k=[],g={}){const b=this.g(g.includePattern,g.expandPatterns),L=this.g(g.excludePattern,g.expandPatterns),T=k.length>1,q=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(N=>this.q(N,g,L)):k.map(N=>this.r(N,g,L,T))).filter(N=>!!N),G={_reason:g._reason,folderQueries:q,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:L.pattern,includePattern:b.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const N=w.$Ib(this.c.groups.flatMap(ge=>ge.editors.map(ie=>ie.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const V=N.filter(ge=>(0,s.$sL)(G,ge.fsPath)),ce=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ce)),{...G,...ce}}const W=g.extraFileResources&&g.extraFileResources.filter(N=>(0,s.$sL)(G,N.fsPath));return G.extraFileResources=W&&W.length?W:void 0,G}i(k){const g=[],b=new A.$Bc,L={};let T=!1;return k.forEach(q=>{if(q.scheme===M.Schemas.walkThrough)return;if((0,c.$hh)(q)){const W=this.b.getWorkspaceFolder(q)?.uri??q.with({path:p.$nc(q.fsPath)});let N=b.get(W);N||(T=!0,N={folder:W,includePattern:{}},g.push(N),b.set(W,N));const V=p.$mc(W.fsPath,q.fsPath);(0,v.$ng)(N.includePattern)[V.replace(/\\/g,"/")]=!0}else q.fsPath&&(T=!0,L[q.fsPath]=!0)}),{folderQueries:g,includePattern:L,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(k,g){if(g.isSmartCase){if(k.isRegExp){if(R.$6f(k.pattern,!0))return!0}else if(R.$6f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$8C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const g=ce=>p.$jc(ce)||/^\.\.?([\/\\]|$)/.test(ce),L=(Array.isArray(k)?k:f(k)).map(ce=>{const ge=this.e.resolvedUserHome;return ge?(0,O.$Sw)(ce,ge.scheme===M.Schemas.file?ge.fsPath:ge.path):ce}),T=C.$K(L,ce=>g(ce)?"searchPaths":"exprSegments"),q=(T.exprSegments||[]).map(ce=>R.$lf(ce,"/")).map(ce=>R.$lf(ce,"\\")).map(ce=>(ce[0]==="."&&(ce="*"+ce),l(ce))),G={},W=this.m(T.searchPaths||[]);W&&W.length&&(G.searchPaths=W);const N=q.flat(),V=m(...N);return V&&(G.pattern=V),G}l(k,g){return g.disregardExcludeSettings?void 0:(0,s.$rL)(k,!g.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const g=k.flatMap(L=>{let{pathPortion:T,globPortion:q}=t(L);return q&&(q=I(q)),this.n(T).flatMap(W=>this.o(W,q))}),b=new Map;return g.forEach(L=>{const T=L.searchPath.toString(),q=b.get(T);q?L.pattern&&(q.pattern=q.pattern||{},q.pattern[L.pattern]=!0):b.set(T,{searchPath:L.searchPath,pattern:L.pattern?m(L.pattern):void 0})}),Array.from(b.values())}n(k){if(p.$jc(k)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==M.Schemas.file?[{searchPath:g[0].uri.with({path:k})}]:[{searchPath:u.URI.file(p.$ic(k))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const g=this.b.getWorkspace().folders[0].uri;if(k=$(k),k.startsWith("../")||k===".."){const L=p.$hc.resolve(g.path,k);return[{searchPath:g.with({path:L})}]}const b=I(k);return[{searchPath:g,pattern:b}]}else{if(k==="./"||k===".\\")return[];{const g=k.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(T=>{const q=g.match(new RegExp(`^${R.$ff(T.name)}(?:/(.*)|$)`));return q?{match:q,folder:T}:null}).filter(v.$kg);if(L.length)return L.map(T=>{const q=T.match[1];return{searchPath:T.folder.uri,pattern:q&&I(q)}});{const T=k.match(/\.[\/\\](.+)[\/\\]?/),q=T?T[1]:k,G=d.localize(0,null,q);throw new Error(G)}}}}o(k,g){const b=k.pattern&&g?`${k.pattern}/${g}`:k.pattern||g,L=[{searchPath:k.searchPath,pattern:b}];return b&&!b.endsWith("**")&&L.push({searchPath:k.searchPath,pattern:b+"/**"}),L}q(k,g,b){const L=this.r((0,a.$Xi)(k.searchPath),g,b,!1);return L?{...L,includePattern:k.pattern}:null}r(k,g,b,L){let T;const q=u.URI.isUri(k)?k:k.uri;if(b.searchPaths){const ce=b.searchPaths.filter(ge=>(0,c.$9g)(ge.searchPath,q))[0];if(ce&&!ce.pattern)return null;ce&&(T=ce.pattern)}const G=this.a.getValue({resource:q}),N={...this.l(G,g)||{},...T||{}},V=u.URI.isUri(k)?(0,c.$ah)(k):k.name;return{folder:q,folderName:L?V:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!G.search.followSymlinks}}};e.$CM=n,e.$CM=n=He([Ve(0,r.$9i),Ve(1,a.$Li),Ve(2,h.$dE),Ve(3,o.$9j),Ve(4,i.$AM)],n);function t(S){const k=S.match(/[\*\{\}\(\)\[\]\?]/);if(k){const g=k.index,b=S.substr(0,g).match(/[/|\\][^/\\]*$/);if(b){let L=S.substr(0,b.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:S.substr((b.index||0)+1)}}}return{pathPortion:S}}function m(...S){return S.length?S.reduce((k,g)=>(k[g]=!0,k),Object.create(null)):void 0}function f(S){return P.$uk(S,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(S){return[`**/${S}/**`,`**/${S}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function $(S){return S.replace(/\\/g,"/")}function I(S){return $(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(S){return S.replace(/([?*[\]])/g,"[$1]")}function y(S,k){S=w.$Nb(S,L=>L.toString());const g=[],b=k.getWorkspace();return S&&S.forEach(L=>{let T;if(k.getWorkbenchState()===a.WorkbenchState.FOLDER)T=(0,c.$fh)(b.folders[0].uri,L),T&&T!=="."&&(T="./"+T);else{const q=k.getWorkspaceFolder(L);if(q){const G=q.name;if(b.folders.filter(N=>N.name===G).length===1){const N=(0,c.$fh)(q.uri,L);N===""?T=`./${q.name}`:T=`./${q.name}/${N}`}else T=L.fsPath}}T&&g.push(D(T))}),g}}),define(Ce[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mxb=u,e.$nxb=r,w=qe(w),O=qe(O);const v=7e3;function u(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],s=[];for(const $ of h)if(/^workspaceContains:/.test($)){const I=$.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):i.push(I)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:n,resolve:t}=(0,R.$vh)(),m=$=>t({activationEvent:$}),f=Promise.all(i.map($=>E(o,$,m))).then(()=>{}),l=d(o,a.identifier,s,m);return Promise.all([f,l]).then(()=>{t(void 0)}),n}async function E(o,a,h){for(const i of o.folders)if(await o.exists(w.$dh(C.URI.revive(i),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,i){if(h.length===0)return Promise.resolve(void 0);const s=new P.$ue,n=o.checkExists(o.folders,h,s.token),t=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},v);let m=!1;try{m=await n}catch(f){O.$5(f)||O.$2(f)}s.dispose(),clearTimeout(t),m&&i(`workspaceContains:${h.join(",")}`)}function r(o,a,h,i){const s=o.get(A.$Bi),n=o.get(p.$jL),m=s.createInstance(M.$CM).file(a.map(f=>(0,c.$Xi)(C.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return n.fileSearch(m,i).then(f=>!!f.limitHit,f=>O.$5(f)?!1:Promise.reject(f))}}),define(Ce[46],Ie([1,0,181,20,65,24,11,5,59,2,12,6,45,247,89,44,25,118,14,19,23,229,7,109,3,27,92,17,75,93,57,95,4,313,88,231,16,86,70,21,87]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l,$,I,D,y,S,k,g,b,L,T,q,G,W,N,V){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=e.$$nc=e.$0nc=e.$9nc=void 0,w=qe(w),C=qe(C),P=qe(P),h=qe(h),e.$9nc=(0,f.$Ci)("IHostUtils");let ge=ce=class extends M.$Vc{constructor(Y,B,_,we,ae,ve,le,X,Z,pe,$e,Me,je){super(),this.Y=Me,this.Z=je,this.a=this.B(new g.$je),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=_,this.f=le,this.j=we,this.m=ae,this.s=ve,this.t=Z,this.u=pe,this.w=$e,this.y=this.g.getProxy(v.$YM.MainThreadWorkspace),this.z=this.g.getProxy(v.$YM.MainThreadTelemetry),this.C=this.g.getProxy(v.$YM.MainThreadExtensionService),this.D=new A.$Bh,this.F=new A.$Bh,this.G=new A.$Bh,this.H=new A.$Bh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new a.$Cbc(this.I,this.f.extensions.allExtensions);const ke=new i.$on(this.f.extensions.myExtensions);this.J=new a.$Cbc(this.I,be(this.L,ke)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$Rnc(this.g,this.s),this.N=new L.$2nc(this.g),this.O=X,this.h=Y.createChild(new D.$Ai([d.$Snc,this.M],[L.$3nc,this.N])),this.P=this.B(new E.$Qnc(this.J,this.L,{onExtensionActivationError:(Re,Oe,z)=>{this.C.$onExtensionActivationError(Re,h.$4(Oe),z)},actualActivateExtension:async(Re,Oe)=>{if(a.$Cbc.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Oe),new E.$Pnc;const z=this.J.getExtensionDescription(Re);return this.fb(z,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$2(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const _=this.$();Promise.race([(0,A.$Dh)(5e3),_]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new i.$nn(B.identifier.value),extensionLocation:c.URI.revive(B.extensionLocation)}}ab(Y,B){return this.P.activateByEvent(Y,B)}bb(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.bb(Y,B).then(()=>{const _=this.P.getActivatedExtension(Y);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===q.Schemas.file&&this.c.fsRealpath){const B=Y.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const _=await this.R.get(B);return c.URI.file(_)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new re(Y))),this.Q}async db(Y){const B=p.$Ii.forUris(_=>O.$7g.ignorePathCasing(_));return await Promise.all(Y.map(async _=>{if(this.wb(_)){const we=await this.cb(_.extensionLocation);B.set(we,_)}})),B}eb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const _=this.P.getActivatedExtension(Y);if(!_)return B;try{typeof _.module.deactivate=="function"&&(B=Promise.resolve(_.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(we)}try{(0,M.$Qc)(_.subscriptions)}catch(we){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(we)}return B}async fb(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,B).then(_=>{const we=_.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,B),this.gb(Y,B,"success",we),_},_=>{throw this.gb(Y,B,"failure"),_})}gb(Y,B,_,we){const ae=me(Y,B);this.z.$publicLog2("extensionActivationTimes",{...ae,...we||{},outcome:_})}hb(Y,B){const _=me(Y,B);this.z.$publicLog2("activatePlugin",_);const we=this.wb(Y);if(!we)return Promise.resolve(new E.$Onc(E.$Lnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ae=new E.$Mnc(B.startup);return Promise.all([this.xb(Y,(0,O.$dh)(Y.extensionLocation,we),ae),this.ib(Y)]).then(ve=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),ce.jb(this.s,Y.identifier,ve[0],ve[1],ae))).then(ve=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),ve))}ib(Y){const B=this.Z.createLanguageModelAccessInformation(Y),_=new n.$Unc(Y,this.M),we=new n.$Tnc(Y.identifier.value,!1,this.M),ae=new T.$4nc(Y,this.N),ve=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([_.whenReady,we.whenReady,this.O.whenReady]).then(()=>{const X=this;let Z,pe;const $e=(0,o.$1G)(Y,"ipc")?this.f.messagePorts?.get(i.$nn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:_,workspaceState:we,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return B},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Me){return C.$kc(Y.extensionLocation.fsPath,Me)},get storagePath(){return X.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return X.O.globalValue(Y).fsPath},get logPath(){return C.$kc(X.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(X.f.logsLocation,Y.identifier.value)},get storageUri(){return X.O.workspaceValue(Y)},get globalStorageUri(){return X.O.globalValue(Y)},get extensionMode(){return ve},get extension(){return Z===void 0&&(Z=new de(X,Y.identifier,Y,le,!1)),Z},get extensionRuntime(){return(0,o.$2G)(Y,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!pe){if(!$e)return;const Me=g.Event.buffer(g.Event.fromDOMEventEmitter($e,"message",je=>je.data));$e.start(),pe={onDidReceiveMessage:Me,postMessage:$e.postMessage.bind($e)}}return pe}})})}static jb(Y,B,_,we,ae){return _=_||{activate:void 0,deactivate:void 0},this.kb(Y,B,_,we,ae).then(ve=>new E.$Nnc(!1,null,ae.build(),_,ve,we.subscriptions))}static kb(Y,B,_,we,ae){if(typeof _.activate=="function")try{ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ve=typeof global=="object"?global:self,le=_.activate.apply(ve,[we]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(le).then(X=>(ae.activateResolveStop(),X))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(_)}lb(Y,B){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,_=>{this.s.error(_)})}mb(Y,B=0){const we=Date.now();(0,N.$B)(()=>{for(let ae=B;ae<Y.length;ae+=1){const ve=Y[ae];for(const le of ve.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-we>50){this.mb(Y,ae);break}else this.lb(ve,le)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),_=this.J.getAllExtensionDescriptions();if(B)this.mb(_);else for(const we of _)if(we.activationEvents)for(const ae of we.activationEvents)ae==="onStartupFinished"&&this.lb(we,ae)})}ob(){const Y=this.ab("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.pb(ve.added)));const B=this.j.workspace?this.j.workspace.folders:[],_=this.pb(B),we=this.rb(),ae=Promise.all([we,Y,_]).then(()=>{});return Promise.race([ae,(0,A.$Dh)(1e4)]).then(()=>{this.nb()}),ae}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(Y,B))).then(()=>{})}async qb(Y,B){if(this.isActivated(B.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:Y.map(ve=>ve.uri),forceUsingSearch:_||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,le,X)=>this.y.$checkExists(ve,le,X)},ae=await(0,b.$mxb)(we,B);if(ae)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ae.activationEvent}).then(void 0,ve=>this.s.error(ve))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(w.localize(0,null));const _=await this.xb(null,B,new E.$Mnc(!1));if(!_||typeof _.run!="function")throw new Error(w.localize(1,null,B.toString()));return new Promise((we,ae)=>{const ve=(Z,pe)=>{Z?(N.$t&&this.s.error("Test runner called back with error",Z),ae(Z)):(N.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof pe=="number"&&pe>0?1:0))},le=(0,O.$4g)(B),X=_.run(le,ve);X&&X.then&&X.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),we(0)}).catch(Z=>{N.$t&&this.s.error("Test runner finished with error",Z),ae(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Dh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.S[Y]=B,(0,M.$Tc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.ub(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const B=Y.indexOf("+");if(B===-1)throw new t.$7M("Not an authority that can be resolved!",m.RemoteAuthorityResolverErrorCode.InvalidAuthority);const _=Y.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.S[_]}}async $resolveAuthority(Y,B){const _=W.$de.create(!1),we=()=>`[resolveAuthority(${(0,m.$Rl)(Y)},${B})][${_.elapsed()}ms] `,ae=j=>this.s.info(`${we()}${j}`),ve=j=>this.s.warn(`${we()}${j}`),le=(j,K=void 0)=>this.s.error(`${we()}${j}`,K),X=j=>{if(j instanceof t.$7M)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Z=async j=>{ae(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:J}=await this.ub(j);if(!K)throw le(`no resolver for ${J}`),new t.$7M(`No remote extension installed to resolve ${J}.`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:J,remoteAuthority:j}},pe=Y.split(/@|%40/g).reverse();ae(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(Z)).catch(async j=>{if(!(j instanceof t.$7M)||j._code!==m.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return ve(`resolving nested authorities failed: ${j.message}`),[await Z(Y)]})}catch(j){return X(j)}const Me=new A.$Nh;Me.cancelAndSet(()=>ae("waiting..."),1e3);let je,ke;for(const[j,{authorityPrefix:K,resolver:J,remoteAuthority:ne}]of $e.entries())try{if(j===$e.length-1)ae("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),je=await J.resolve(ne,{resolveAttempt:B,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$6M.isManagedResolvedAuthority(je)?je:void 0));else{if(ae(`invoking resolveExecServer() for ${ne}`),P.mark(`code/extHost/willResolveExecServer/${K}`),ke=await J.resolveExecServer?.(ne,{resolveAttempt:B,execServer:ke}),!ke)throw new t.$7M(`Exec server was not available for ${ne}`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),le("returned an error",fe),Me.dispose(),X(fe)}Me.dispose();const Re={environmentTunnels:je.environmentTunnels,features:je.tunnelFeatures?{elevation:je.tunnelFeatures.elevation,privacyOptions:je.tunnelFeatures.privacyOptions,protocol:je.tunnelFeatures.protocol===void 0?!0:je.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:je.extensionHostEnv,isTrusted:je.isTrusted,authenticationSession:je.authenticationSessionForInitializingExtensions?{id:je.authenticationSessionForInitializingExtensions.id,providerId:je.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$6M.isManagedResolvedAuthority(je)?"managed authority":`${je.host}:${je.port}`}`);let z;if(t.$6M.isManagedResolvedAuthority(je)){const j=B;this.Y.setFactory(j,je.makeConnection),z={authority:Y,connectTo:new m.$Ol(j),connectionToken:je.connectionToken}}else z={authority:Y,connectTo:new m.$Pl(je.host,je.port),connectionToken:je.connectionToken};return{type:"ok",value:{authority:z,options:Oe,tunnelInformation:Re}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,m.$Rl)(Y)})`);const{resolver:_}=await this.ub(Y);if(!_)return null;const we=c.URI.revive(B);if(typeof _.getCanonicalURI>"u")return we;const ae=await(0,A.$uh)(()=>_.getCanonicalURI(we));return ae||we}async $startExtensionHost(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:B,myExtensions:_}=ie(this.I,this.L,this.J,Y),we=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Y,B){return B===o.ActivationKind.Immediate?this.D.wait().then(_=>this.ab(Y,!1)):this.G.wait().then(_=>this.ab(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ve=>ve.extensionLocation=c.URI.revive(ve.extensionLocation));const{globalRegistry:B,myExtensions:_}=ie(this.I,this.L,this.J,Y),we=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=s.$Le.alloc(Y),_=Math.random()%256;for(let we=0;we<Y;we++)B.writeUInt8(_,we);return B}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$0nc=ge,e.$0nc=ge=ce=He([Ve(0,f.$Bi),Ve(1,e.$9nc),Ve(2,I.$sP),Ve(3,r.$unc),Ve(4,u.$xnc),Ve(5,R.$9j),Ve(6,l.$IP),Ve(7,$.$Anc),Ve(8,y.$2Eb),Ve(9,S.$Vnc),Ve(10,G.$6nc),Ve(11,V.$7nc),Ve(12,k.$Znc)],ge);function ie(Le,Y,B,_){Le.addActivationEvents(_.addActivationEvents);const we=new a.$Cbc(Le,Y.getAllExtensionDescriptions());we.deltaExtensions(_.toAdd,_.toRemove);const ae=new i.$on(B.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of _.myToRemove)ae.delete(le);for(const le of _.myToAdd)ae.add(le);const ve=be(we,ae);return{globalRegistry:we,myExtensions:ve}}function me(Le,Y){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$$nc=(0,f.$Ci)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Y,B,_,we,ae){this.#e=Y,this.#t=B,this.#i=_.identifier,this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=C.$ic((0,O.$4g)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=we,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$_nc=de;function be(Le,Y){return Le.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class re{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$aoc=re;class Pe{constructor(Y){this.a=new i.$pn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Ce[314],Ie([1,0,65,2,6,45,25,19,17,27,3,46,12,13]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0,w=qe(w);let r=class{constructor(s,n,t,m,f,l,$){this.c=s,this.d=n,this.e=t,this.f=m,this.g=f,this.h=l,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new a(this.c,n,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,n,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const n of s.nodeModuleName)this.a.set(n,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(n=>s.alternativeModuleName(n))}};e.$kpc=r,e.$kpc=r=He([Ve(2,R.$Bi),Ve(3,O.$xnc),Ve(4,v.$$nc),Ve(5,c.$IP),Ve(6,u.$9j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const n=(0,E.$ff)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",m=`@${t}+\\/${t}+|${t}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${f}\\/)(${m})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const n=this.b.exec(this.c(s));if(!n)return;const[,t,m,f]=n,l=d.a.get(m);if(l!==void 0)return console.warn(`${m} as been renamed to ${l}, please update your imports`),t+l+f}c(s){return s.replace(/\\/g,"/")}};o=d=He([Ve(0,c.$IP)],o);class a{constructor(s,n,t,m,f){this.c=s,this.d=n,this.e=t,this.f=m,this.g=f,this.nodeModuleName="vscode",this.a=new M.$pn}load(s,n){const t=this.d.findSubstr(n);if(t){let m=this.a.get(t.identifier);return m||(m=this.c(t,this.e,this.f),this.a.set(t.identifier,m)),m}if(!this.b){let m="";this.d.forEach((f,l)=>m+=`	${l} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${m}`),this.b=this.c(A.$VG,this.e,this.f)}return this.b}}let h=class{constructor(s,n,t){this.e=s,this.f=n,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$YM.MainThreadTelemetry);const m=t.getProxy(P.$YM.MainThreadWindow);this.c=(f,l)=>{const $=C.URI.parse(f);return l?this.g(f,l):$.scheme==="http"||$.scheme==="https"?m.$openUri($,f,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?m.$openUri($,f,{}):this.g(f,l)}}load(s,n,t){const m=this.e.findSubstr(n);return m&&(this.a=m.identifier.value,this.h()),this.b=t(s),this.c}g(s,n){return this.i(),this.b(s,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([Ve(2,p.$sP)],h)}),define(Ce[131],Ie([1,0,47,5,20,79,3,58,71,46,7,44,244,45]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=void 0,P=qe(P),O=qe(O),e.$boc=(0,A.$Ci)("IExtHostVariableResolverProvider");class d extends u.$wQ{constructor(a,h,i,s,n,t,m){function f(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const $=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$MO||$.input instanceof R.$RO)return $.input.modified;if($.input instanceof R.$LO||$.input instanceof R.$QO||$.input instanceof R.$OO)return $.input.uri}}}super({getFolderUri:l=>{const $=t.folders.filter(I=>I.name===l);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,$)=>n.getConfiguration(void 0,l).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=f();if(l)return P.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const l=f();if(l){const $=h.getWorkspaceFolder(l);if($)return P.$ic($.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,m?Promise.resolve(m):void 0,Promise.resolve(O.env))}}let r=class extends C.$Vc{constructor(a,h,i,s,n){super(),this.b=a,this.c=h,this.g=i,this.h=s,this.j=n,this.a=new w.$W(async()=>{const t=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$coc=r,e.$coc=r=He([Ve(0,c.$$nc),Ve(1,v.$unc),Ve(2,M.$DP),Ve(3,E.$xnc),Ve(4,p.$Jnc)],r)}),define(Ce[132],Ie([1,0,11,4,2,5,19,3,6,71,46,17,7,44,236,81,237,45,131,35,34,10,18,96]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=e.$loc=e.$koc=e.$joc=e.$ioc=void 0,n=qe(n),e.$ioc=(0,M.$Ci)("IExtHostDebugService");let f=class extends O.$Vc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,g,b,L,T,q,G,W){super(),this.Y=g,this.Z=b,this.$=L,this.ab=T,this.bb=q,this.cb=G,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new C.$je),this.z=this.B(new C.$je),this.C=this.B(new C.$je),this.F=this.B(new C.$je),this.u=k.getProxy(p.$YM.MainThreadDebugService),this.I=this.B(new C.$je),this.L=this.B(new C.$je),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(N=>{this.B(N.onDidChange(V=>{this.fb(N)})),this.fb(N)})}async $getVisualizerTreeItem(k,g){const b=this.gb(g);if(!b)return;const L=await this.Q.get(k)?.getTreeItem?.(b);return L?this.eb(k,L):void 0}registerDebugVisualizationTree(k,g,b){const L=A.$nn.toKey(k.identifier),T=this.ub(L,g);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.Q.set(T,b),this.u.$registerDebugVisualizerTree(T,!!b.editItem),(0,O.$Tc)(()=>{this.u.$unregisterDebugVisualizerTree(T),this.Q.delete(g)})}async $getVisualizerTreeItemChildren(k,g){const b=this.S.get(g)?.item;return b?(await this.Q.get(k)?.getChildren?.(b))?.map(T=>this.eb(k,T))||[]:[]}async $editVisualizerTreeItem(k,g){const b=this.S.get(k);if(!b)return;const L=await this.Q.get(b.provider)?.editItem?.(b.item,g);return this.eb(b.provider,L||b.item)}$disposeVisualizedTree(k){const g=this.S.get(k);if(!g)return;const b=[g.children];for(const L of b)if(L)for(const T of L)b.push(this.S.get(T)?.children),this.S.delete(T)}eb(k,g){let b=this.R.get(g);return b||(b=this.O++,this.R.set(g,b),this.S.set(b,{provider:k,item:g})),n.DebugTreeItem.from(g,b)}asDebugSourceUri(k,g){const b=k;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let L=`debug:${encodeURIComponent(b.path||"")}`,T="?";return g&&(L+=`${T}session=${encodeURIComponent(g.id)}`,T="&"),L+=`${T}ref=${b.sourceReference}`,P.URI.parse(L)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const g=[];for(const b of k.getAllExtensionDescriptions())if(b.contributes){const L=b.contributes.debuggers;if(L&&L.length>0)for(const T of L)(0,o.$RH)(T)&&g.push(T.type)}this.u.$registerDebugTypes(g)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(g=>k.push(g)),k}async $resolveDebugVisualizer(k,g){const b=this.W.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);let{v:L,provider:T,extensionId:q}=b;if(L.visualization||(L=await T.resolveDebugVisualization?.(L,g)||L,b.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${T}'`);return this.vb(q,L.visualization)}async $executeDebugVisualizerCommand(k){const g=this.W.get(k);if(!g)throw new Error(`No debug visualizer found with id '${k}'`);const b=g.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(k){const g=this.w.get(k.sessionId);return g&&{session:g.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,g,b,L){const T=this.gb(b),q=this.ub(k,g),G=this.P.get(q);if(!T||!G)return[];const W=await G.provideDebugVisualization(T,L);return W?W.map(N=>{const V=++this.X;this.W.set(V,{v:N,provider:G,extensionId:k});const ce=N.iconPath?this.wb(N.iconPath):void 0;return{id:V,name:N.name,iconClass:ce?.iconClass,iconPath:ce?.iconPath,visualization:this.vb(k,N.visualization)}}):[]}$disposeDebugVisualizers(k){for(const g of k)this.W.delete(g)}registerDebugVisualizationProvider(k,g,b){if(!k.contributes?.debugVisualizers?.some(q=>q.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const L=A.$nn.toKey(k.identifier),T=this.ub(L,g);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.P.set(T,b),this.u.$registerDebugVisualizer(L,g),(0,O.$Tc)(()=>{this.u.$unregisterDebugVisualizer(L,g),this.P.delete(g)})}addBreakpoints(k){const g=k.filter(T=>{const q=T.id;return this.H.has(q)?!1:(this.H.set(q,T),!0)});this.rb(g,[],[]);const b=[],L=new Map;for(const T of g)if(T instanceof u.$3N){let q=L.get(T.location.uri.toString());q||(q={type:"sourceMulti",uri:T.location.uri,lines:[]},L.set(T.location.uri.toString(),q),b.push(q)),q.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character,mode:T.mode})}else T instanceof u.$4N&&b.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName,mode:T.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(k){const g=k.filter(q=>this.H.delete(q.id));this.rb([],g,[]);const b=g.filter(q=>q instanceof u.$3N).map(q=>q.id),L=g.filter(q=>q instanceof u.$4N).map(q=>q.id),T=g.filter(q=>q instanceof u.$5N).map(q=>q.id);return this.u.$unregisterBreakpoints(b,L,T)}startDebugging(k,g,b){const L=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(k?k.uri:void 0,g,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,g,b){if(!g)return new u.$1M(()=>{});const L=this.f++;return this.g.push({type:k,handle:L,provider:g}),this.u.$registerDebugConfigurationProvider(k,b,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,L),new u.$1M(()=>{this.g=this.g.filter(T=>T.provider!==g),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(k,g,b){if(!b)return new u.$1M(()=>{});if(!this.nb(k,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.kb(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:g,handle:L,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(g,L),new u.$1M(()=>{this.j=this.j.filter(T=>T.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(k,g){if(!g)return new u.$1M(()=>{});const b=this.m++;return this.n.push({type:k,handle:b,factory:g}),new u.$1M(()=>{this.n=this.n.filter(L=>L.factory!==g)})}async $runInTerminal(k,g){return Promise.resolve(void 0)}async $substituteVariables(k,g){let b;const L=await this.tb(k);return L&&(b={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,g)}hb(k,g){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,g){const b=this,L=await this.sb(g);return this.pb(this.kb(L.type),L).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const q=this.jb(T),G=this.hb(q,L);if(!G)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const W=G;return this.M.set(k,W),this.ob(L).then(N=>(N&&this.N.set(k,N),W.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const ce=V,ge={type:"response",seq:0,command:ce.command,request_seq:ce.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ie=await this.U.sign(ce.arguments.value);ge.body={signature:ie},W.sendResponse(ge)}else throw new Error("no signer")}catch(ie){ge.success=!1,ge.message=ie.message,W.sendResponse(ge)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(V),V=(0,o.$WH)(V,!0),b.u.$acceptDAMessage(k,V)}),W.onError(V=>{N&&N.onError&&N.onError(V),this.u.$acceptDAError(k,V.name,V.message,V.stack)}),W.onExit(V=>{N&&N.onExit&&N.onExit(V??void 0,void 0),this.u.$acceptDAExit(k,V??void 0,void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),W.startSession()))})}$sendDAMessage(k,g){g=(0,o.$VH)(g,!1);const b=this.N.get(k);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(g),this.M.get(k)?.sendMessage(g)}$stopDASession(k){const g=this.N.get(k);this.N.delete(k),g&&g.onWillStopSession&&g.onWillStopSession();const b=this.M.get(k);return this.M.delete(k),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const g=[],b=[],L=[];if(k.added)for(const T of k.added){const q=T.id;if(q&&!this.H.has(q)){let G;if(T.type==="function")G=new u.$4N(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode);else if(T.type==="data")G=new u.$5N(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage,T.mode);else{const W=P.URI.revive(T.uri);G=new u.$3N(new u.$aN(W,new u.$2M(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode)}(0,u.$1N)(G,q),this.H.set(q,G),g.push(G)}}if(k.removed)for(const T of k.removed){const q=this.H.get(T);q&&(this.H.delete(T),b.push(q))}if(k.changed){for(const T of k.changed)if(T.id){const q=this.H.get(T.id);if(q){if(q instanceof u.$4N&&T.type==="function"){const G=q;G.enabled=T.enabled,G.condition=T.condition,G.hitCondition=T.hitCondition,G.logMessage=T.logMessage,G.functionName=T.functionName}else if(q instanceof u.$3N&&T.type==="source"){const G=q;G.enabled=T.enabled,G.condition=T.condition,G.hitCondition=T.hitCondition,G.logMessage=T.logMessage,G.location=new u.$aN(P.URI.revive(T.uri),new u.$2M(T.line,T.character))}L.push(q)}}}this.rb(g,b,L)}async $acceptStackFrameFocus(k){let g;if(k){const b=await this.sb(k.sessionId);k.kind==="thread"?g=new u.$$N(b.api,k.threadId):g=new u.$0N(b.api,k.threadId,k.frameId)}this.J=g,this.L.fire(this.J)}$provideDebugConfigurations(k,g,b){return(0,w.$uh)(async()=>{const L=this.mb(k);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.tb(g);return L.provideDebugConfigurations(T,b)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(k,g,b,L){return(0,w.$uh)(async()=>{const T=this.mb(k);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const q=await this.tb(g);return T.resolveDebugConfiguration(q,b,L)})}$resolveDebugConfigurationWithSubstitutedVariables(k,g,b,L){return(0,w.$uh)(async()=>{const T=this.mb(k);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const q=await this.tb(g);return T.resolveDebugConfigurationWithSubstitutedVariables(q,b,L)})}async $provideDebugAdapter(k,g){const b=this.lb(k);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb(g);return this.pb(b,L).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(T)})}async $acceptDebugSessionStarted(k){const g=await this.sb(k);this.y.fire(g.api)}async $acceptDebugSessionTerminated(k){const g=await this.sb(k);g&&(this.z.fire(g.api),this.w.delete(g.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,g){(await this.sb(k))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(k,g){const L={session:(await this.sb(k)).api,event:g.event,body:g.body};this.F.fire(L)}jb(k){if(k instanceof u.$6N)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof u.$7N)return{type:"server",port:k.port,host:k.host};if(k instanceof u.$8N)return{type:"pipeServer",path:k.path};if(k instanceof u.$9N)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const g=this.j.filter(b=>b.type===k);if(g.length>0)return g[0].factory}lb(k){const g=this.j.filter(b=>b.handle===k);if(g.length>0)return g[0].factory}mb(k){const g=this.g.filter(b=>b.handle===k);if(g.length>0)return g[0].provider}nb(k,g){if(k.contributes){const b=k.contributes.debuggers;if(b&&b.length>0){for(const L of b)if(L.label&&L.type&&L.type===g)return!0}}return!1}ob(k){const b=k.configuration.type,L=this.n.filter(T=>T.type===b||T.type==="*").map(T=>(0,w.$uh)(()=>T.factory.createDebugAdapterTracker(k.api)).then(q=>q,q=>null));return Promise.race([Promise.all(L).then(T=>{const q=(0,t.$Ib)(T);if(q.length>0)return new I(q)}),new Promise(T=>setTimeout(()=>T(void 0),1e3))]).catch(T=>{})}async pb(k,g){const b=g.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.$7N(b));if(k){const T=await this.Z.getExtensionRegistry();return(0,w.$uh)(()=>k.createDebugAdapterDescriptor(g.api,this.qb(g,T))).then(q=>{if(q)return q})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(g,L))}qb(k,g){}rb(k,g,b){(k.length>0||g.length>0||b.length>0)&&this.I.fire(Object.freeze({added:k,removed:g,changed:b}))}async sb(k){if(k)if(typeof k=="string"){const g=this.w.get(k);if(g)return g}else{let g=this.w.get(k.id);if(!g){const b=await this.tb(k.folderUri),L=k.parent?this.w.get(k.parent):void 0;g=new l(this.u,k.id,k.type,k.name,b,k.configuration,L?.api),this.w.set(g.id,g),this.u.$sessionCached(g.id)}return g}throw new Error("cannot find session")}tb(k){if(k){const g=P.URI.revive(k);return this.Y.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}ub(k,g){return`${k}\0${g}`}vb(k,g){if(g){if("title"in g&&"command"in g)return{type:r.DebugVisualizationType.Command};if("treeId"in g)return{type:r.DebugVisualizationType.Tree,id:`${k}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const g=this.xb(k);let b,L;return"id"in g?L=i.ThemeIcon.asClassName(g):b=g,{iconPath:b,iconClass:L}}xb(k){if(k instanceof u.$XN)return{id:k.id};const g=typeof k=="object"&&"dark"in k?k.dark:k,b=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof g=="string"?P.URI.file(g):g,light:typeof b=="string"?P.URI.file(b):b}}};e.$joc=f,e.$joc=f=He([Ve(0,v.$sP),Ve(1,E.$unc),Ve(2,R.$$nc),Ve(3,a.$xnc),Ve(4,c.$Jnc),Ve(5,h.$boc),Ve(6,s.$OP),Ve(7,m.$doc)],f);class l{constructor(k,g,b,L,T,q,G){this.f=k,this.g=g,this.h=b,this.j=L,this.k=T,this.l=q,this.m=G}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(g){k.j=g,k.f.$setDebugSessionName(k.g,g)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(g,b){return k.f.$customDebugAdapterRequest(k.g,g,b)},getDebugProtocolBreakpoint(g){return k.f.$getDebugProtocolBreakpoint(k.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$koc=l;class ${constructor(k){this.value=Object.freeze({append(g){k.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$loc=$;class I{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(g=>g.onError?g.onError(k):void 0)}onExit(k,g){this.d.forEach(b=>b.onExit?b.onExit(k,g):void 0)}}class D extends d.$Ssb{constructor(k){super(),this.h=k,k.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends f{constructor(k,g,b,L,T,q,G,W){super(k,g,b,L,T,q,G,W)}};e.$moc=y,e.$moc=y=He([Ve(0,v.$sP),Ve(1,E.$unc),Ve(2,R.$$nc),Ve(3,a.$xnc),Ve(4,c.$Jnc),Ve(5,h.$boc),Ve(6,s.$OP),Ve(7,m.$doc)],y)}),define(Ce[315],Ie([1,0,14,65,2,6,266,12,61,75,27,211,17,66,46,67]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=e.$lpc=void 0,w=qe(w),C=qe(C);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(M.$9j),t=i.get(u.$sP).getProxy(O.$YM.MainThreadErrors);w.setUnexpectedErrorHandler(m=>{s.error(m);const f=w.$4(m);t.$onUnexpectedError(f)})}static async installFullHandler(i){const s=i.get(M.$9j),n=i.get(u.$sP),t=i.get(d.$$nc),m=i.get(r.$MP),f=n.getProxy(O.$YM.MainThreadExtensionService),l=n.getProxy(O.$YM.MainThreadErrors),$=await t.getExtensionPathIndex(),I=new WeakMap;function D(k,g){if(I.has(k))return I.get(k).stack;let b="",L,T;for(const G of g)b+=`
	at ${G.toString()}`,T=G.getFileName(),!L&&T&&(L=$.findSubstr(P.URI.file(T)));const q=`${k.name||"Error"}: ${k.message||""}${b}`;return I.set(k,{extensionIdentifier:L?.identifier,stack:q}),q}const y=Symbol("prepareStackTrace wrapped");let S=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(k){if(k===D||!k||k[y]){S=k||D;return}S=function(g,b){return D(g,b),k.call(Error,g,b)},Object.assign(S,{[y]:!0})}}),w.setUnexpectedErrorHandler(k=>{s.error(k);const g=w.$4(k),b=I.get(k);if(!b?.extensionIdentifier){l.$onUnexpectedError(g);return}f.$onExtensionRuntimeError(b.extensionIdentifier,g);const L=m.onExtensionError(b.extensionIdentifier,k);s.trace("forwarded error to extension?",L,b)})}}e.$lpc=o;class a{constructor(i,s,n,t,m){this.a=n,this.b=new A.$Kbc(i,null,t),s=a.e(s,this.b);const f=new c.$Ai(...(0,p.$Js)());f.set(R.$IP,{_serviceBrand:void 0,...s,messagePorts:m}),f.set(u.$sP,new u.$tP(this.b)),f.set(E.$rnc,new E.$snc(t)),f.set(d.$9nc,n);const l=new v.$nr(f,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction($=>$.get(M.$9j)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction($=>$.get(d.$$nc)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(O.$YM.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=P.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const n=i.environment.extensionDevelopmentLocationURI;return n&&(i.environment.extensionDevelopmentLocationURI=n.map(t=>P.URI.revive(s.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$mpc=a}),define(Ce[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Boc=e.$Aoc=void 0,e.$Coc=r,M=qe(M),p=qe(p);class v{constructor(h,i,s){this.d=h,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const s=this.g.folderQueries||[],n=new P.$ue(i);return new Promise((t,m)=>{this.a=new E(h);let f=!1;const l=($,I)=>{if(!f&&!this.b){const D=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,n.cancel(),$=this.j($,this.g.maxResults-this.c));const y=this.h($);this.c+=y,(y>0||!r($))&&this.a.add($,I)}};Promise.all(s.map(($,I)=>this.k($,D=>l(D,I),n.token))).then($=>{n.dispose(),this.a.flush();const I=$.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||I,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{n.dispose();const I=(0,O.$nj)($);m(new Error(I))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],n=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,i),preview:{matches:n.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,s){const n=new R.$CL(this.g,h),t=[],m={report:$=>{if(!this.l($))return;const I=h.folder.scheme===A.Schemas.file?(0,R.$DL)(()=>this.e.readdir(p.$ch($.uri))):void 0,D=p.$fh(h.folder,$.uri);if(D){const y=n.includedInQuery(D,M.$oc(D),I);(0,C.$oh)(y)?t.push(y.then(S=>{S&&i($)})):y&&i($)}}},f=this.n(h);let l;return this.d.query.type===R.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,m,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,m,s),t.length&&await Promise.all(t),l}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,R.$BL)(this.g.includePattern,h.includePattern),s=(0,R.$BL)(this.g.excludePattern,h.excludePattern),n={folder:c.URI.from(h.folder),excludes:s,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$iL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(n.usePCRE2=this.g.usePCRE2),n}}e.$Aoc=v;function u(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!p.$9g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$Boc=E;function d(a){return r(a)?{preview:{matches:(0,w.$2b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,w.$2b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Doc=o}),define(Ce[133],Ie([1,0,5,6,3,311,17,66,12,2,316]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=e.$Eoc=void 0,e.$Goc=u,e.$Eoc=(0,P.$Ci)("IExtHostSearch");let v=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(C.$YM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$zoc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,w.$Tc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const i=u(a),s=this.j.get(r);if(s)return this.l.fileSearch(i,s,n=>{this.c.$handleFileMatch(r,o,n.map(t=>t.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const s=u(a);return this.t(s,i).search(t=>this.c.$handleTextMatch(r,o,t),h)}$provideAITextSearchResults(r,o,a,h){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const s=u(a);return this.v(s,i).search(t=>this.c.$handleTextMatch(r,o,t),h)}$enableExtensionHostSearch(){}t(r,o){return new R.$Aoc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new R.$Aoc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$Foc=v,e.$Foc=v=He([Ve(0,A.$sP),Ve(1,M.$rnc),Ve(2,p.$9j)],v);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function E(d){return{...d,folder:c.URI.revive(d.folder)}}});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[317],Ie([1,0,22,14,4,5,16,36,2,105,164,150,52,19,30,12,63,64,225,6,269,297,85,91,274,275,276,253,242,34,277,45,278,132,121,279,255,270,280,281,58,71,256,271,46,283,69,284,51,27,298,257,285,95,286,86,87,259,310,288,230,289,299,290,127,260,291,292,293,17,294,133,88,295,261,296,89,92,130,67,57,125,96,300,272,301,302,93,10,7,262,66,263,68,303,304,120,44,81,84,25,129]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l,$,I,D,y,S,k,g,b,L,T,q,G,W,N,V,ce,ge,ie,me,se,de,be,re,Pe,Le,Y,B,_,we,ae,ve,le,X,Z,pe,$e,Me,je,ke,Re,Oe,z,j,K,J,ne,fe,Ae,ze,Ke,_e,it,nt,tt,rt,$t,lt,st,ct,gt,mt,Be,Ue,H,x,De,Xe,Ze,dt,pt,Lt,zt,xt,li,xe,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=Gt,C=qe(C),M=ri(M),v=qe(v),d=qe(d),Ue=qe(Ue),H=qe(H);function Gt(ht){const bt=ht.get(Pe.$IP),hi=ht.get(re.$cnc),_t=ht.get(de.$znc),Ut=ht.get(me.$$nc),wt=ht.get(zt.$unc),Bt=ht.get(tt.$MP),Jt=ht.get(k.$xnc),Qt=ht.get(De.$rnc),Qe=ht.get(K.$sP),pi=ht.get(_e.$Snc),ei=ht.get(it.$Anc),si=ht.get(r.$0j),St=ht.get(r.$9j),Kt=ht.get(Be.$2Eb),At=ht.get(t.$$mc),Nt=ht.get(Lt.$fpc),ti=ht.get(fe.$3nc),ii=ht.get(ce.$Jnc),oi=ht.get(ve.$7nc),Wt=ht.get(m.$inc),Ht=ht.get(_.$Znc);Qe.set(i.$ZM.ExtHostFileSystemInfo,hi),Qe.set(i.$ZM.ExtHostLogLevelServiceShape,si),Qe.set(i.$ZM.ExtHostWorkspace,wt),Qe.set(i.$ZM.ExtHostConfiguration,Jt),Qe.set(i.$ZM.ExtHostExtensionService,Ut),Qe.set(i.$ZM.ExtHostStorage,pi),Qe.set(i.$ZM.ExtHostTunnelService,Kt),Qe.set(i.$ZM.ExtHostWindow,Nt),Qe.set(i.$ZM.ExtHostSecretState,ti),Qe.set(i.$ZM.ExtHostTelemetry,Bt),Qe.set(i.$ZM.ExtHostEditorTabs,ii),Qe.set(i.$ZM.ExtHostManagedSockets,oi),Qe.set(i.$ZM.ExtHostAuthentication,Wt),Qe.set(i.$ZM.ExtHostChatProvider,Ht);const di=Qe.set(i.$ZM.ExtHostDecorations,ht.get(L.$ooc)),Ft=Qe.set(i.$ZM.ExtHostDocumentsAndEditors,ht.get(V.$DP)),vt=Qe.set(i.$ZM.ExtHostCommands,ht.get(y.$OP)),Ct=Qe.set(i.$ZM.ExtHostTerminalService,ht.get(rt.$Vnc)),Tt=Qe.set(i.$ZM.ExtHostTerminalShellIntegration,ht.get($t.$8oc)),kt=Qe.set(i.$ZM.ExtHostDebugService,ht.get(b.$ioc)),Xt=Qe.set(i.$ZM.ExtHostSearch,ht.get(ne.$Eoc)),qt=Qe.set(i.$ZM.ExtHostTask,ht.get(nt.$7oc)),$i=Qe.set(i.$ZM.ExtHostOutputService,ht.get(ke.$Toc)),fi=Qe.set(i.$ZM.ExtHostLocalization,ht.get(ae.$6nc)),Ri=Qe.set(i.$ZM.ExtHostUrls,new Xe.$cpc(Qe)),Mt=Qe.set(i.$ZM.ExtHostDocuments,new N.$fnc(Qe,Ft)),Ti=Qe.set(i.$ZM.ExtHostDocumentContentProviders,new G.$qoc(Qe,Ft,St)),ai=Qe.set(i.$ZM.ExtHostDocumentSaveParticipant,new W.$roc(St,Mt,Qe.getProxy(i.$YM.MainThreadBulkEdits))),Rt=Qe.set(i.$ZM.ExtHostNotebook,new X.$Hoc(Qe,vt,Ft,Mt,_t,Xt,St)),Di=Qe.set(i.$ZM.ExtHostNotebookDocuments,new pe.$Noc(Rt)),Si=Qe.set(i.$ZM.ExtHostNotebookEditors,new $e.$Ooc(St,Rt)),vi=Qe.set(i.$ZM.ExtHostNotebookKernels,new Me.$Poc(Qe,bt,Rt,vt,St)),Oi=Qe.set(i.$ZM.ExtHostNotebookRenderers,new je.$Roc(Qe,Rt)),gi=Qe.set(i.$ZM.ExtHostNotebookDocumentSaveParticipant,new Z.$Moc(St,Rt,Qe.getProxy(i.$YM.MainThreadBulkEdits))),Vt=Qe.set(i.$ZM.ExtHostEditors,new st.$onc(Qe,Ft)),ye=Qe.set(i.$ZM.ExtHostTreeViews,new mt.$apc(Qe.getProxy(i.$YM.MainThreadTreeViews),vt,St)),Te=Qe.set(i.$ZM.ExtHostEditorInsets,new D.$pnc(Qe.getProxy(i.$YM.MainThreadEditorInsets),Vt,bt.remote)),ue=Qe.set(i.$ZM.ExtHostDiagnostics,new T.$enc(Qe,St,hi,Ft)),Q=Qe.set(i.$ZM.ExtHostLanguages,new we.$Koc(Qe,Mt,vt.converter,Qt)),Ee=Qe.set(i.$ZM.ExtHostLanguageFeatures,new B.$gnc(Qe,Qt,Mt,vt,ue,St,At,Bt)),We=Qe.set(i.$ZM.ExtHostFileSystem,new se.$uoc(Qe,Ee)),Ye=Qe.set(i.$ZM.ExtHostFileSystemEventService,new be.$voc(Qe,St,Ft)),Ge=Qe.set(i.$ZM.ExtHostQuickOpen,(0,j.$Xoc)(Qe,wt,vt)),ut=Qe.set(i.$ZM.ExtHostSCM,new J.$Zoc(Qe,vt,Mt,St)),Pt=Qe.set(i.$ZM.ExtHostQuickDiff,new z.$Woc(Qe,Qt)),Yt=Qe.set(i.$ZM.ExtHostShare,new Ae.$1oc(Qe,Qt)),ci=Qe.set(i.$ZM.ExtHostComments,(0,S.$qnc)(Qe,vt,Mt)),jt=Qe.set(i.$ZM.ExtHostProgress,new Oe.$Voc(Qe.getProxy(i.$YM.MainThreadProgress))),ni=Qe.set(i.$ZM.ExtHostLabelService,new Y.$Joc(Qe)),Ui=Qe.set(i.$ZM.ExtHostTheming,new ct.$0oc(Qe)),Zi=Qe.set(i.$ZM.ExtHostTimeline,new gt.$_oc(Qe,vt)),Bi=Qe.set(i.$ZM.ExtHostWebviews,new Ze.$Enc(Qe,bt.remote,wt,St,At)),Ni=Qe.set(i.$ZM.ExtHostWebviewPanels,new dt.$Hnc(Qe,Bi,wt)),Wi=Qe.set(i.$ZM.ExtHostCustomEditors,new g.$Inc(Qe,Mt,ei,Bi,Ni)),Vi=Qe.set(i.$ZM.ExtHostWebviewViews,new pt.$dpc(Qe,Bi)),ki=Qe.set(i.$ZM.ExtHostTesting,ht.get(lt.$doc)),xi=Qe.set(i.$ZM.ExtHostUriOpeners,new x.$bpc(Qe)),_i=Qe.set(i.$ZM.ExtHostProfileContentHandlers,new Re.$Uoc(Qe));Qe.set(i.$ZM.ExtHostInteractive,new Le.$Ioc(Qe,Rt,Ft,vt,St));const Li=Qe.set(i.$ZM.ExtHostChatAgents2,new l.$lnc(Qe,St,vt,bt.quality)),en=Qe.set(i.$ZM.ExtHostChatVariables,new $.$mnc(Qe)),qi=Qe.set(i.$ZM.ExtHostAiRelatedInformation,new s.$0mc(Qe)),pn=Qe.set(i.$ZM.ExtHostAiEmbeddingVector,new ie.$toc(Qe)),tn=Qe.set(i.$ZM.ExtHostStatusBar,new Ke.$4oc(Qe,vt.converter)),Gi=Qe.set(i.$ZM.ExtHostSpeech,new ze.$2oc(Qe)),Ci=Qe.set(i.$ZM.ExtHostEmbeddings,new ge.$soc(Qe)),$n=Object.values(i.$ZM);Qe.assertRegistered($n);const bn=new f.$knc(Qe,Ft),nn=new I.$nnc(Qe),Ki=new le.$Loc(Qe,St),Fi=new q.$poc(Qe);return n.$hnc.register(vt),function(Fe,bi,Hi){function ot(ee){return(he,Ne,at)=>{const Dt=ee(Ot=>{try{he.call(Ne,Ot)}catch(Ii){C.$3(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),Bt.onExtensionError(Fe.identifier,Ii)}});return at?.push(Dt),Dt}}const Et=function(){let ee=!Fe.isUnderDevelopment;function he(){ee||(St.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Ne(at){if(Array.isArray(at))at.forEach(Ne);else if(typeof at=="string")he();else{const Dt=at;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,xe.$2G)(Fe,"documentFiltersExclusive")}return at}}(),rn={getSession(ee,he,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,xe.$2G)(Fe,"authLearnMore"),Wt.getSession(Fe,ee,he,Ne)},getSessions(ee,he){return(0,xe.$2G)(Fe,"authGetSessions"),Wt.getSessions(Fe,ee,he)},async hasSession(ee,he){return(0,xe.$2G)(Fe,"authSession"),!!await Wt.getSession(Fe,ee,he,{silent:!0})},get onDidChangeSessions(){return ot(Wt.onDidChangeSessions)},registerAuthenticationProvider(ee,he,Ne,at){return Wt.registerAuthenticationProvider(ee,he,Ne,at)}},yi={registerCommand(ee,he,Ne){return vt.registerCommand(!0,ee,he,Ne,void 0,Fe)},registerTextEditorCommand(ee,he,Ne){return vt.registerCommand(!0,ee,(...at)=>{const Dt=Vt.getActiveTextEditor();if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Dt.edit(Ot=>{he.apply(Ne,[Dt,Ot,...at])}).then(Ot=>{Ot||St.warn("Edits from command "+ee+" were not applied.")},Ot=>{St.warn("An error occurred while running command "+ee,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ee,he,Ne)=>((0,xe.$2G)(Fe,"diffCommand"),vt.registerCommand(!0,ee,async(...at)=>{const Dt=Ft.activeEditor(!0);if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ot=await Vt.getDiffInformation(Dt.id);he.apply(Ne,[Ot,...at])},void 0,void 0,Fe)),executeCommand(ee,...he){return vt.executeCommand(ee,...he)},getCommands(ee=!1){return vt.getCommands(ee)}},Mi={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return ot(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$2G)(Fe,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$2G)(Fe,"telemetry"),ot(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$LP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,he){return tt.$KP.validateSender(ee),Bt.instantiateLogger(Fe,ee,he)},openExternal(ee,he){return Nt.openUri(ee,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===bt.environment.appUriScheme)return Ri.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!bt.remote.authority})}catch(he){if((0,A.$Lg)(ee,A.Schemas.http)||(0,A.$Lg)(ee,A.Schemas.https))return ee;throw he}},get remoteName(){return(0,o.$en)(bt.remote.authority)},get remoteAuthority(){return(0,xe.$2G)(Fe,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ot(St.onDidChangeLogLevel)},get appQuality(){return(0,xe.$2G)(Fe,"resolvers"),bt.quality},get appCommit(){return(0,xe.$2G)(Fe,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Mi);const wn={createTestController(ee,he,Ne){return ki.createTestController(Fe,ee,he,Ne)},createTestObserver(){return(0,xe.$2G)(Fe,"testObserver"),ki.createTestObserver()},runTests(ee){return(0,xe.$2G)(Fe,"testObserver"),ki.runTests(ee)},registerTestFollowupProvider(ee){return(0,xe.$2G)(Fe,"testObserver"),ki.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,xe.$2G)(Fe,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,xe.$2G)(Fe,"testObserver"),ki.results}},ui=bt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,ji={getExtension(ee,he){(0,xe.$1G)(Fe,"extensionsAny")||(he=!1);const Ne=bi.mine.getExtensionDescription(ee);if(Ne)return new me.$_nc(Ut,Fe.identifier,Ne,ui,!1);if(he){const at=bi.all.getExtensionDescription(ee);if(at)return new me.$_nc(Ut,Fe.identifier,at,ui,!0)}},get all(){const ee=[];for(const he of bi.mine.getAllExtensionDescriptions())ee.push(new me.$_nc(Ut,Fe.identifier,he,ui,!1));return ee},get allAcrossExtensionHosts(){(0,xe.$2G)(Fe,"extensionsAny");const ee=new E.$on(bi.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),he=[];for(const Ne of bi.all.getAllExtensionDescriptions()){const at=!ee.has(Ne.identifier);he.push(new me.$_nc(Ut,Fe.identifier,Ne,ui,at))}return he},get onDidChange(){return(0,xe.$1G)(Fe,"extensionsAny")?ot(P.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ot(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return ue.createDiagnosticCollection(Fe.identifier,ee)},get onDidChangeDiagnostics(){return ot(ue.onDidChangeDiagnostics)},getDiagnostics:ee=>ue.getDiagnostics(ee),getLanguages(){return Q.getLanguages()},setTextDocumentLanguage(ee,he){return Q.changeLanguage(ee.uri,he)},match(ee,he){const Ne=Ue.LanguageSelector.from(ee);let at;return(0,R.$nu)(Ne)&&(at=Rt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Ot=>Ot.document===he))?.apiNotebook),(0,R.$mu)(Ne,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ee,he,Ne){return Ee.registerCodeActionProvider(Fe,Et(ee),he,Ne)},registerDocumentPasteEditProvider(ee,he,Ne){return(0,xe.$2G)(Fe,"documentPaste"),Ee.registerDocumentPasteEditProvider(Fe,Et(ee),he,Ne)},registerCodeLensProvider(ee,he){return Ee.registerCodeLensProvider(Fe,Et(ee),he)},registerDefinitionProvider(ee,he){return Ee.registerDefinitionProvider(Fe,Et(ee),he)},registerDeclarationProvider(ee,he){return Ee.registerDeclarationProvider(Fe,Et(ee),he)},registerImplementationProvider(ee,he){return Ee.registerImplementationProvider(Fe,Et(ee),he)},registerTypeDefinitionProvider(ee,he){return Ee.registerTypeDefinitionProvider(Fe,Et(ee),he)},registerHoverProvider(ee,he){return Ee.registerHoverProvider(Fe,Et(ee),he,Fe.identifier)},registerEvaluatableExpressionProvider(ee,he){return Ee.registerEvaluatableExpressionProvider(Fe,Et(ee),he,Fe.identifier)},registerInlineValuesProvider(ee,he){return Ee.registerInlineValuesProvider(Fe,Et(ee),he,Fe.identifier)},registerDocumentHighlightProvider(ee,he){return Ee.registerDocumentHighlightProvider(Fe,Et(ee),he)},registerMultiDocumentHighlightProvider(ee,he){return Ee.registerMultiDocumentHighlightProvider(Fe,Et(ee),he)},registerLinkedEditingRangeProvider(ee,he){return Ee.registerLinkedEditingRangeProvider(Fe,Et(ee),he)},registerReferenceProvider(ee,he){return Ee.registerReferenceProvider(Fe,Et(ee),he)},registerRenameProvider(ee,he){return Ee.registerRenameProvider(Fe,Et(ee),he)},registerNewSymbolNamesProvider(ee,he){return(0,xe.$2G)(Fe,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Fe,Et(ee),he)},registerDocumentSymbolProvider(ee,he,Ne){return Ee.registerDocumentSymbolProvider(Fe,Et(ee),he,Ne)},registerWorkspaceSymbolProvider(ee){return Ee.registerWorkspaceSymbolProvider(Fe,ee)},registerDocumentFormattingEditProvider(ee,he){return Ee.registerDocumentFormattingEditProvider(Fe,Et(ee),he)},registerDocumentRangeFormattingEditProvider(ee,he){return Ee.registerDocumentRangeFormattingEditProvider(Fe,Et(ee),he)},registerOnTypeFormattingEditProvider(ee,he,Ne,...at){return Ee.registerOnTypeFormattingEditProvider(Fe,Et(ee),he,[Ne].concat(at))},registerDocumentSemanticTokensProvider(ee,he,Ne){return Ee.registerDocumentSemanticTokensProvider(Fe,Et(ee),he,Ne)},registerDocumentRangeSemanticTokensProvider(ee,he,Ne){return Ee.registerDocumentRangeSemanticTokensProvider(Fe,Et(ee),he,Ne)},registerSignatureHelpProvider(ee,he,Ne,...at){return typeof Ne=="object"?Ee.registerSignatureHelpProvider(Fe,Et(ee),he,Ne):Ee.registerSignatureHelpProvider(Fe,Et(ee),he,typeof Ne>"u"?[]:[Ne,...at])},registerCompletionItemProvider(ee,he,...Ne){return Ee.registerCompletionItemProvider(Fe,Et(ee),he,Ne)},registerInlineCompletionItemProvider(ee,he,Ne){return he.handleDidShowCompletionItem&&(0,xe.$2G)(Fe,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,xe.$2G)(Fe,"inlineCompletionsAdditions"),Ne&&(0,xe.$2G)(Fe,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Fe,Et(ee),he,Ne)},registerInlineEditProvider(ee,he){return(0,xe.$2G)(Fe,"inlineEdit"),Ee.registerInlineEditProvider(Fe,Et(ee),he)},registerDocumentLinkProvider(ee,he){return Ee.registerDocumentLinkProvider(Fe,Et(ee),he)},registerColorProvider(ee,he){return Ee.registerColorProvider(Fe,Et(ee),he)},registerFoldingRangeProvider(ee,he){return Ee.registerFoldingRangeProvider(Fe,Et(ee),he)},registerSelectionRangeProvider(ee,he){return Ee.registerSelectionRangeProvider(Fe,ee,he)},registerCallHierarchyProvider(ee,he){return Ee.registerCallHierarchyProvider(Fe,ee,he)},registerTypeHierarchyProvider(ee,he){return Ee.registerTypeHierarchyProvider(Fe,ee,he)},setLanguageConfiguration:(ee,he)=>Ee.setLanguageConfiguration(Fe,ee,he),getTokenInformationAtPosition(ee,he){return(0,xe.$2G)(Fe,"tokenInformation"),Q.tokenAtPosition(ee,he)},registerInlayHintsProvider(ee,he){return Ee.registerInlayHintsProvider(Fe,ee,he)},createLanguageStatusItem(ee,he){return Q.createLanguageStatusItem(Fe,ee,he)},registerDocumentDropEditProvider(ee,he,Ne){return Ee.registerDocumentOnDropEditProvider(Fe,ee,he,(0,xe.$1G)(Fe,"documentPaste")?Ne:void 0)}},on={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(ee,he,Ne){p.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ee)?Promise.resolve(Ji.openTextDocument(ee)):Promise.resolve(ee));return Vt.showTextDocument(at,he,Ne)},createTextEditorDecorationType(ee){return Vt.createTextEditorDecorationType(Fe,ee)},onDidChangeActiveTextEditor(ee,he,Ne){return ot(Vt.onDidChangeActiveTextEditor)(ee,he,Ne)},onDidChangeVisibleTextEditors(ee,he,Ne){return ot(Vt.onDidChangeVisibleTextEditors)(ee,he,Ne)},onDidChangeTextEditorSelection(ee,he,Ne){return ot(Vt.onDidChangeTextEditorSelection)(ee,he,Ne)},onDidChangeTextEditorOptions(ee,he,Ne){return ot(Vt.onDidChangeTextEditorOptions)(ee,he,Ne)},onDidChangeTextEditorVisibleRanges(ee,he,Ne){return ot(Vt.onDidChangeTextEditorVisibleRanges)(ee,he,Ne)},onDidChangeTextEditorViewColumn(ee,he,Ne){return ot(Vt.onDidChangeTextEditorViewColumn)(ee,he,Ne)},onDidCloseTerminal(ee,he,Ne){return ot(Ct.onDidCloseTerminal)(ee,he,Ne)},onDidOpenTerminal(ee,he,Ne){return ot(Ct.onDidOpenTerminal)(ee,he,Ne)},onDidChangeActiveTerminal(ee,he,Ne){return ot(Ct.onDidChangeActiveTerminal)(ee,he,Ne)},onDidChangeTerminalDimensions(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalDimensions"),ot(Ct.onDidChangeTerminalDimensions)(ee,he,Ne)},onDidChangeTerminalState(ee,he,Ne){return ot(Ct.onDidChangeTerminalState)(ee,he,Ne)},onDidWriteTerminalData(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalDataWriteEvent"),ot(Ct.onDidWriteTerminalData)(ee,he,Ne)},onDidExecuteTerminalCommand(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalExecuteCommandEvent"),ot(Ct.onDidExecuteTerminalCommand)(ee,he,Ne)},onDidChangeTerminalShellIntegration(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalShellIntegration"),ot(Tt.onDidChangeTerminalShellIntegration)(ee,he,Ne)},onDidStartTerminalShellExecution(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalShellIntegration"),ot(Tt.onDidStartTerminalShellExecution)(ee,he,Ne)},onDidEndTerminalShellExecution(ee,he,Ne){return(0,xe.$2G)(Fe,"terminalShellIntegration"),ot(Tt.onDidEndTerminalShellExecution)(ee,he,Ne)},get state(){return Nt.getState()},onDidChangeWindowState(ee,he,Ne){return ot(Nt.onDidChangeWindowState)(ee,he,Ne)},showInformationMessage(ee,...he){return Ki.showMessage(Fe,M.default.Info,ee,he[0],he.slice(1))},showWarningMessage(ee,...he){return Ki.showMessage(Fe,M.default.Warning,ee,he[0],he.slice(1))},showErrorMessage(ee,...he){return Ki.showMessage(Fe,M.default.Error,ee,he[0],he.slice(1))},showQuickPick(ee,he,Ne){return Ge.showQuickPick(Fe,ee,he,Ne)},showWorkspaceFolderPick(ee){return Ge.showWorkspaceFolderPick(ee)},showInputBox(ee,he){return Ge.showInput(ee,he)},showOpenDialog(ee){return Fi.showOpenDialog(Fe,ee)},showSaveDialog(ee){return Fi.showSaveDialog(ee)},createStatusBarItem(ee,he,Ne){let at,Dt,Ot;return typeof ee=="string"?(at=ee,Dt=he,Ot=Ne):(Dt=ee,Ot=he),tn.createStatusBarEntry(Fe,at,Dt,Ot)},setStatusBarMessage(ee,he){return tn.setStatusBarMessage(ee,he)},withScmProgress(ee){return At.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),jt.withProgress(Fe,{location:H.ProgressLocation.SourceControl},(he,Ne)=>ee({report(at){}}))},withProgress(ee,he){return jt.withProgress(Fe,ee,he)},createOutputChannel(ee,he){return $i.createOutputChannel(ee,he,Fe)},createWebviewPanel(ee,he,Ne,at){return Ni.createWebviewPanel(Fe,ee,he,Ne,at)},createWebviewTextEditorInset(ee,he,Ne,at){return(0,xe.$2G)(Fe,"editorInsets"),Te.createWebviewEditorInset(ee,he,Ne,at,Fe)},createTerminal(ee,he,Ne){return typeof ee=="object"?"pty"in ee?Ct.createExtensionTerminal(ee):Ct.createTerminalFromOptions(ee):Ct.createTerminal(ee,he,Ne)},registerTerminalLinkProvider(ee){return Ct.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,he){return Ct.registerProfileProvider(Fe,ee,he)},registerTerminalQuickFixProvider(ee,he){return(0,xe.$2G)(Fe,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(ee,Fe.identifier.value,he)},registerTreeDataProvider(ee,he){return ye.registerTreeDataProvider(ee,he,Fe)},createTreeView(ee,he){return ye.createTreeView(ee,he,Fe)},registerWebviewPanelSerializer:(ee,he)=>Ni.registerWebviewPanelSerializer(Fe,ee,he),registerCustomEditorProvider:(ee,he,Ne={})=>Wi.registerCustomEditorProvider(Fe,ee,he,Ne),registerFileDecorationProvider(ee){return di.registerFileDecorationProvider(ee,Fe)},registerUriHandler(ee){return Ri.registerUriHandler(Fe,ee)},createQuickPick(){return Ge.createQuickPick(Fe)},createInputBox(){return Ge.createInputBox(Fe)},get activeColorTheme(){return Ui.activeColorTheme},onDidChangeActiveColorTheme(ee,he,Ne){return ot(Ui.onDidChangeActiveColorTheme)(ee,he,Ne)},registerWebviewViewProvider(ee,he,Ne){return Vi.registerWebviewViewProvider(Fe,ee,he,Ne?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,he,Ne){return ot(Rt.onDidChangeActiveNotebookEditor)(ee,he,Ne)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,he,Ne){return ot(Si.onDidChangeNotebookEditorSelection)(ee,he,Ne)},onDidChangeNotebookEditorVisibleRanges(ee,he,Ne){return ot(Si.onDidChangeNotebookEditorVisibleRanges)(ee,he,Ne)},showNotebookDocument(ee,he){return Rt.showNotebookDocument(ee,he)},registerExternalUriOpener(ee,he,Ne){return(0,xe.$2G)(Fe,"externalUriOpener"),xi.registerExternalUriOpener(Fe.identifier,ee,he,Ne)},registerProfileContentHandler(ee,he){return(0,xe.$2G)(Fe,"profileContentHandlers"),_i.registerProfileContentHandler(Fe,ee,he)},registerQuickDiffProvider(ee,he,Ne,at){return(0,xe.$2G)(Fe,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ee),he,Ne,at)},get tabGroups(){return ii.tabGroups},registerShareProvider(ee,he){return(0,xe.$2G)(Fe,"shareProvider"),Yt.registerShareProvider(Et(ee),he)}},Ji={get rootPath(){return At.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new C.$0("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new C.$0("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new C.$0("workspaceFile")},updateWorkspaceFolders:(ee,he,...Ne)=>wt.updateWorkspaceFolders(Fe,ee,he||0,...Ne),onDidChangeWorkspaceFolders:function(ee,he,Ne){return ot(wt.onDidChangeWorkspace)(ee,he,Ne)},asRelativePath:(ee,he)=>wt.getRelativePath(ee,he),findFiles:(ee,he,Ne,at)=>wt.findFiles(ee,he,Ne,Fe.identifier,at),findFiles2:(ee,he,Ne)=>((0,xe.$2G)(Fe,"findFiles2"),wt.findFiles2(ee,he,Fe.identifier,Ne)),findTextInFiles:(ee,he,Ne,at)=>{(0,xe.$2G)(Fe,"findTextInFiles");let Dt,Ot;return typeof he=="object"?(Dt=he,Ot=Ne):(Dt={},Ot=he,at=Ne),wt.findTextInFiles(ee,Dt||{},Ot,Fe.identifier,at)},save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,he){return bn.applyWorkspaceEdit(ee,Fe,he)},createFileSystemWatcher:(ee,he,Ne,at)=>{let Dt;return typeof he=="boolean"?Dt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,xe.$2G)(Fe,"createFileSystemWatcher"),Dt={...he,correlate:!0}),Ye.createFileSystemWatcher(wt,Fe,ee,Dt)},get textDocuments(){return Mt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new C.$0("textDocuments")},openTextDocument(ee){let he;const Ne=ee;if(typeof ee=="string")he=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))he=Promise.resolve(ee);else if(!Ne||typeof Ne=="object")he=Mt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Mt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ee,he,Ne)=>ot(Mt.onDidAddDocument)(ee,he,Ne),onDidCloseTextDocument:(ee,he,Ne)=>ot(Mt.onDidRemoveDocument)(ee,he,Ne),onDidChangeTextDocument:(ee,he,Ne)=>ot(Mt.onDidChangeDocument)(ee,he,Ne),onDidSaveTextDocument:(ee,he,Ne)=>ot(Mt.onDidSaveDocument)(ee,he,Ne),onWillSaveTextDocument:(ee,he,Ne)=>ot(ai.getOnWillSaveTextDocumentEvent(Fe))(ee,he,Ne),get notebookDocuments(){return Rt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,he){let Ne;if(p.URI.isUri(ee))Ne=ee,await Rt.openNotebookDocument(ee);else if(typeof ee=="string")Ne=p.URI.revive(await Rt.createNotebookDocument({viewType:ee,content:he}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ee,he,Ne){return ot(Di.onDidSaveNotebookDocument)(ee,he,Ne)},onDidChangeNotebookDocument(ee,he,Ne){return ot(Di.onDidChangeNotebookDocument)(ee,he,Ne)},onWillSaveNotebookDocument(ee,he,Ne){return ot(gi.getOnWillSaveNotebookDocumentEvent(Fe))(ee,he,Ne)},get onDidOpenNotebookDocument(){return ot(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,he,Ne,at){return Rt.registerNotebookSerializer(Fe,ee,he,Ne,(0,xe.$1G)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,he,Ne)=>ot(Hi.onDidChangeConfiguration)(ee,he,Ne),getConfiguration(ee,he){return he=arguments.length===1?void 0:he,Hi.getConfiguration(ee,he,Fe)},registerTextDocumentContentProvider(ee,he){return Ti.registerTextDocumentContentProvider(ee,he)},registerTaskProvider:(ee,he)=>(At.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Fe,ee,he)),registerFileSystemProvider(ee,he,Ne){return(0,O.$Sc)(We.registerFileSystemProvider(Fe,ee,he,Ne),_t.addFileSystemProvider(ee,he,Ne))},get fs(){return _t.value},registerFileSearchProvider:(ee,he)=>((0,xe.$2G)(Fe,"fileSearchProvider"),Xt.registerFileSearchProvider(ee,he)),registerTextSearchProvider:(ee,he)=>((0,xe.$2G)(Fe,"textSearchProvider"),Xt.registerTextSearchProvider(ee,he)),registerAITextSearchProvider:(ee,he)=>((0,xe.$2G)(Fe,"aiTextSearchProvider"),(0,xe.$2G)(Fe,"textSearchProvider"),Xt.registerAITextSearchProvider(ee,he)),registerRemoteAuthorityResolver:(ee,he)=>((0,xe.$2G)(Fe,"resolvers"),Ut.registerRemoteAuthorityResolver(ee,he)),registerResourceLabelFormatter:ee=>((0,xe.$2G)(Fe,"resolvers"),ni.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,xe.$2G)(Fe,"resolvers"),Ut.getRemoteExecServer(ee)),onDidCreateFiles:(ee,he,Ne)=>ot(Ye.onDidCreateFile)(ee,he,Ne),onDidDeleteFiles:(ee,he,Ne)=>ot(Ye.onDidDeleteFile)(ee,he,Ne),onDidRenameFiles:(ee,he,Ne)=>ot(Ye.onDidRenameFile)(ee,he,Ne),onWillCreateFiles:(ee,he,Ne)=>ot(Ye.getOnWillCreateFileEvent(Fe))(ee,he,Ne),onWillDeleteFiles:(ee,he,Ne)=>ot(Ye.getOnWillDeleteFileEvent(Fe))(ee,he,Ne),onWillRenameFiles:(ee,he,Ne)=>ot(Ye.getOnWillRenameFileEvent(Fe))(ee,he,Ne),openTunnel:ee=>((0,xe.$2G)(Fe,"tunnels"),Kt.openTunnel(Fe,ee).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,xe.$2G)(Fe,"tunnels"),Kt.getTunnels()},onDidChangeTunnels:(ee,he,Ne)=>((0,xe.$2G)(Fe,"tunnels"),ot(Kt.onDidChangeTunnels)(ee,he,Ne)),registerPortAttributesProvider:(ee,he)=>((0,xe.$2G)(Fe,"portsAttributes"),Kt.registerPortsAttributesProvider(ee,he)),registerTunnelProvider:(ee,he)=>((0,xe.$2G)(Fe,"tunnelFactory"),Kt.registerTunnelProvider(ee,he)),registerTimelineProvider:(ee,he)=>((0,xe.$2G)(Fe,"timeline"),Zi.registerTimelineProvider(ee,he,Fe.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,xe.$2G)(Fe,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,he,Ne)=>ot(wt.onDidGrantWorkspaceTrust)(ee,he,Ne),registerEditSessionIdentityProvider:(ee,he)=>((0,xe.$2G)(Fe,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,he)),onWillCreateEditSessionIdentity:(ee,he,Ne)=>((0,xe.$2G)(Fe,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Fe))(ee,he,Ne)),registerCanonicalUriProvider:(ee,he)=>((0,xe.$2G)(Fe,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,he)),getCanonicalUri:(ee,he,Ne)=>((0,xe.$2G)(Fe,"canonicalUriProvider"),wt.provideCanonicalUri(ee,he,Ne))},an={get inputBox(){return At.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Fe)},createSourceControl(ee,he,Ne){return ut.createSourceControl(Fe,ee,he,Ne)}},vn={createCommentController(ee,he){return ci.createCommentController(Fe,ee,he)}},cn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(ee,he){return(0,xe.$2G)(Fe,"debugVisualization"),kt.registerDebugVisualizationProvider(Fe,ee,he)},registerDebugVisualizationTreeProvider(ee,he){return(0,xe.$2G)(Fe,"debugVisualization"),kt.registerDebugVisualizationTree(Fe,ee,he)},onDidStartDebugSession(ee,he,Ne){return ot(kt.onDidStartDebugSession)(ee,he,Ne)},onDidTerminateDebugSession(ee,he,Ne){return ot(kt.onDidTerminateDebugSession)(ee,he,Ne)},onDidChangeActiveDebugSession(ee,he,Ne){return ot(kt.onDidChangeActiveDebugSession)(ee,he,Ne)},onDidReceiveDebugSessionCustomEvent(ee,he,Ne){return ot(kt.onDidReceiveDebugSessionCustomEvent)(ee,he,Ne)},onDidChangeBreakpoints(ee,he,Ne){return ot(kt.onDidChangeBreakpoints)(ee,he,Ne)},onDidChangeActiveStackItem(ee,he,Ne){return ot(kt.onDidChangeActiveStackItem)(ee,he,Ne)},registerDebugConfigurationProvider(ee,he,Ne){return kt.registerDebugConfigurationProvider(ee,he,Ne||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,he){return kt.registerDebugAdapterDescriptorFactory(Fe,ee,he)},registerDebugAdapterTrackerFactory(ee,he){return kt.registerDebugAdapterTrackerFactory(ee,he)},startDebugging(ee,he,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?kt.startDebugging(ee,he,{parentSession:Ne}):kt.startDebugging(ee,he,Ne||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,he){return kt.asDebugSourceUri(ee,he)}},un={registerTaskProvider:(ee,he)=>qt.registerTaskProvider(Fe,ee,he),fetchTasks:ee=>qt.fetchTasks(ee),executeTask:ee=>qt.executeTask(Fe,ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ee,he,Ne)=>ot(qt.onDidStartTask)(ee,he,Ne),onDidEndTask:(ee,he,Ne)=>ot(qt.onDidEndTask)(ee,he,Ne),onDidStartTaskProcess:(ee,he,Ne)=>ot(qt.onDidStartTaskProcess)(ee,he,Ne),onDidEndTaskProcess:(ee,he,Ne)=>ot(qt.onDidEndTaskProcess)(ee,he,Ne)},yn={createNotebookController(ee,he,Ne,at,Dt){return vi.createNotebookController(Fe,ee,he,Ne,at,(0,xe.$1G)(Fe,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,he)=>Rt.registerNotebookCellStatusBarItemProvider(Fe,ee,he),createRendererMessaging(ee){return Oi.createRendererMessaging(Fe,ee)},createNotebookControllerDetectionTask(ee){return(0,xe.$2G)(Fe,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Fe,ee)},registerKernelSourceActionProvider(ee,he){return(0,xe.$2G)(Fe,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Fe,ee,he)},onDidChangeNotebookCellExecutionState(ee,he,Ne){return(0,xe.$2G)(Fe,"notebookCellExecutionState"),ot(vi.onDidChangeNotebookCellExecutionState)(ee,he,Ne)}},En={t(...ee){if(typeof ee[0]=="string"){const he=ee.shift(),Ne=!ee||typeof ee[0]!="object"?ee:ee[0];return fi.getMessage(Fe.identifier.value,{message:he,args:Ne})}return fi.getMessage(Fe.identifier.value,ee[0])},get bundle(){return fi.getBundle(Fe.identifier.value)},get uri(){return fi.getBundleUri(Fe.identifier.value)}},ln={_version:1,transferActiveChat(ee){return(0,xe.$2G)(Fe,"interactive"),Li.transferActiveChat(ee)}},Qi={getRelatedInformation(ee,he){return(0,xe.$2G)(Fe,"aiRelatedInformation"),qi.getRelatedInformation(Fe,ee,he)},registerRelatedInformationProvider(ee,he){return(0,xe.$2G)(Fe,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Fe,ee,he)},registerEmbeddingVectorProvider(ee,he){return(0,xe.$2G)(Fe,"aiRelatedInformation"),pn.registerEmbeddingVectorProvider(Fe,ee,he)}},hn={_version:1,registerChatResponseProvider(ee,he,Ne){return(0,xe.$2G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ee,he,Ne)},registerChatVariableResolver(ee,he,Ne,at,Dt,Ot,Ii,zi){return(0,xe.$2G)(Fe,"chatVariableResolver"),en.registerVariableResolver(Fe,ee,he,Ne,at,Dt,Ot,Ii,zi?.id)},registerMappedEditsProvider(ee,he){return(0,xe.$2G)(Fe,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Fe,ee,he)},createChatParticipant(ee,he){return Li.createChatAgent(Fe,ee,he)},createDynamicChatParticipant(ee,he,Ne){return(0,xe.$2G)(Fe,"chatParticipantPrivate"),Li.createDynamicChatAgent(Fe,ee,he,Ne)}},dn={selectChatModels:ee=>bt.quality==="stable"?(console.warn(`[${E.$nn.toKey(Fe.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Ht.selectLanguageModels(Fe,ee??{}),onDidChangeChatModels:(ee,he,Ne)=>bt.quality==="stable"?(console.warn(`[${E.$nn.toKey(Fe.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),P.Event.None(ee,he,Ne)):Ht.onDidChangeProviders(ee,he,Ne),registerChatModelProvider:(ee,he,Ne)=>((0,xe.$2G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ee,he,Ne)),get embeddingModels(){return(0,xe.$2G)(Fe,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,he,Ne)=>((0,xe.$2G)(Fe,"embeddings"),Ci.onDidChange(ee,he,Ne)),registerEmbeddingsProvider(ee,he){return(0,xe.$2G)(Fe,"embeddings"),Ci.registerEmbeddingsProvider(Fe,ee,he)},async computeEmbeddings(ee,he,Ne){return(0,xe.$2G)(Fe,"embeddings"),Ci.computeEmbeddings(ee,he,Ne)}},fn={registerSpeechProvider(ee,he){return(0,xe.$2G)(Fe,"speech"),Gi.registerProvider(Fe.identifier,ee,he)}};return{version:bt.version,ai:Qi,authentication:rn,commands:yi,comments:vn,chat:hn,debug:cn,env:Mi,extensions:ji,interactive:ln,l10n:En,languages:sn,lm:dn,notebooks:yn,scm:an,speech:fn,tasks:un,tests:wn,window:on,workspace:Ji,Breakpoint:H.$2N,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatResultFeedbackKind:H.ChatResultFeedbackKind,ChatVariableLevel:H.ChatVariableLevel,ChatCompletionItem:H.$WO,CallHierarchyIncomingCall:H.$nN,CallHierarchyItem:H.$mN,CallHierarchyOutgoingCall:H.$oN,CancellationError:C.$6,CancellationTokenSource:w.$ue,CandidatePortSource:i.CandidatePortSource,CodeAction:H.$jN,CodeActionKind:H.$kN,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$pN,Color:H.$CN,ColorInformation:H.$DN,ColorPresentation:H.$EN,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CommentThreadApplicability:H.CommentThreadApplicability,CompletionItem:H.$wN,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$xN,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$MN,DebugAdapterExecutable:H.$6N,DebugAdapterInlineImplementation:H.$9N,DebugAdapterNamedPipeServer:H.$8N,DebugAdapterServer:H.$7N,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DebugVisualization:H.$mO,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$cN,DiagnosticRelatedInformation:H.$bN,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$1M,DocumentHighlight:H.$fN,DocumentHighlightKind:H.DocumentHighlightKind,MultiDocumentHighlight:H.$gN,DocumentLink:H.$BN,DocumentSymbol:H.$iN,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$_N,InlineValueText:H.$aO,InlineValueVariableLookup:H.$bO,InlineValueEvaluatableExpression:H.$cO,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:P.$je,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$oO,FileDecoration2:H.$oO,FileSystemError:H.$fO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:H.$gO,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$4N,InlineCompletionItem:H.$yN,InlineCompletionList:H.$zN,Hover:H.$dN,VerboseHover:H.$eN,HoverVerbosityAction:H.HoverVerbosityAction,IndentAction:v.IndentAction,Location:H.$aN,MarkdownString:H.$qN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:H.$rN,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$2M,ProcessExecution:H.$KN,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$nO,Range:H.$3M,RelativePattern:H.$ZN,Selection:H.$4M,SelectionRange:H.$lN,SemanticTokens:H.$jO,SemanticTokensBuilder:H.$iO,SemanticTokensEdit:H.$kO,SemanticTokensEdits:H.$lO,SemanticTokensLegend:H.$hO,ShellExecution:H.$LN,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$tN,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$sN,SnippetString:H.$_M,SourceBreakpoint:H.$3N,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$hN,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$NN,TaskGroup:H.$JN,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$FN,TerminalQuickFixTerminalCommand:H.$HN,TerminalQuickFixOpener:H.$GN,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$IN,TerminalExitReason:H.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:H.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$8M,SnippetTextEdit:H.$0M,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,SyntaxTokenType:H.SyntaxTokenType,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$YN,ThemeIcon:H.$XN,TreeItem:H.$ON,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$KO,UIKind:li.UIKind,Uri:p.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$$M,DocumentPasteTriggerKind:H.DocumentPasteTriggerKind,DocumentDropEdit:H.$UN,DocumentDropOrPasteEditKind:H.$VN,DocumentPasteEdit:H.$WN,InlayHint:H.$vN,InlayHintLabelPart:H.$uN,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$7M,ResolvedAuthority:H.$5M,ManagedResolvedAuthority:H.$6M,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$yO,NotebookRange:H.$qO,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$rO,NotebookData:H.$sO,NotebookRendererScript:H.$wO,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$uO,NotebookCellOutputItem:H.$tO,NotebookCellStatusBarItem:H.$vO,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$9M,NotebookKernelSourceAction:H.$xO,NotebookVariablesRequestKind:H.NotebookVariablesRequestKind,PortAttributes:H.$AO,LinkedEditingRanges:H.$zO,TestResultState:H.TestResultState,TestRunRequest:H.$BO,TestMessage:H.$CO,TestTag:H.$DO,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:It.TextSearchCompleteMessageType,DataTransfer:H.$TN,DataTransferItem:H.$PN,TestCoverageCount:H.$EO,FileCoverage:H.$GO,FileCoverage2:H.$GO,StatementCoverage:H.$HO,BranchCoverage:H.$IO,DeclarationCoverage:H.$JO,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$LO,TabInputTextDiff:H.$MO,TabInputTextMerge:H.$NO,TabInputCustom:H.$OO,TabInputNotebook:H.$QO,TabInputNotebookDiff:H.$RO,TabInputWebview:H.$PO,TabInputTerminal:H.$SO,TabInputInteractiveWindow:H.$TO,TabInputChat:H.$UO,TabInputTextMultiDiff:H.$VO,TelemetryTrustedValue:a.$qp,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,ChatCopyKind:H.ChatCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,DebugStackFrame:H.$0N,DebugThread:H.$$N,RelatedInformationType:H.RelatedInformationType,SpeechToTextStatus:H.SpeechToTextStatus,TextToSpeechStatus:H.TextToSpeechStatus,PartialAcceptTriggerKind:H.PartialAcceptTriggerKind,KeywordRecognitionStatus:H.KeywordRecognitionStatus,ChatResponseMarkdownPart:H.$XO,ChatResponseFileTreePart:H.$2O,ChatResponseAnchorPart:H.$3O,ChatResponseProgressPart:H.$4O,ChatResponseProgressPart2:H.$5O,ChatResponseReferencePart:H.$8O,ChatResponseWarningPart:H.$6O,ChatResponseTextEditPart:H.$9O,ChatResponseMarkdownWithVulnerabilitiesPart:H.$YO,ChatResponseCommandButtonPart:H.$7O,ChatResponseDetectedParticipantPart:H.$ZO,ChatResponseConfirmationPart:H.$1O,ChatRequestTurn:H.$0O,ChatResponseTurn:H.$$O,ChatLocation:H.ChatLocation,LanguageModelChatMessageRole:H.LanguageModelChatMessageRole,LanguageModelChatMessage:H.$aP,LanguageModelChatMessageFunctionResultPart:H.$_O,LanguageModelChatResponseTextPart:H.$cP,LanguageModelChatResponseFunctionUsePart:H.$bP,LanguageModelChatMessage2:H.$aP,LanguageModelChatSystemMessage:H.$dP,LanguageModelChatUserMessage:H.$eP,LanguageModelChatAssistantMessage:H.$fP,LanguageModelError:H.$gP,NewSymbolName:H.$eO,NewSymbolNameTag:H.NewSymbolNameTag,NewSymbolNameTriggerKind:H.NewSymbolNameTriggerKind,InlineEdit:H.$hP,InlineEditTriggerKind:H.InlineEditTriggerKind}}}}),define(Ce[318],Ie([1,0,61,127,44,121,45,34,58,57,130,132,133,89,93,85,120,69,51,88,67,71,258,12,131,86,87,91,95,125,96]),function(oe,e,w,C,P,O,A,M,p,c,R,v,u,E,d,r,o,a,h,i,s,n,t,m,f,l,$,I,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$Is)(l.$6nc,l.$5nc,w.InstantiationType.Delayed),(0,w.$Is)(m.$0j,t.$hpc,w.InstantiationType.Delayed),(0,w.$Is)(r.$$mc,r.$_mc,w.InstantiationType.Delayed),(0,w.$Is)(M.$OP,M.$NP,w.InstantiationType.Eager),(0,w.$Is)(I.$inc,I.$jnc,w.InstantiationType.Eager),(0,w.$Is)(D.$Znc,D.$1nc,w.InstantiationType.Eager),(0,w.$Is)(A.$xnc,A.$vnc,w.InstantiationType.Eager),(0,w.$Is)(a.$znc,a.$ync,w.InstantiationType.Eager),(0,w.$Is)(S.$doc,S.$eoc,w.InstantiationType.Eager),(0,w.$Is)(v.$ioc,v.$moc,w.InstantiationType.Eager),(0,w.$Is)(O.$ooc,O.$noc,w.InstantiationType.Eager),(0,w.$Is)(p.$DP,p.$CP,w.InstantiationType.Eager),(0,w.$Is)($.$7nc,$.$8nc,w.InstantiationType.Eager),(0,w.$Is)(h.$cnc,h.$bnc,w.InstantiationType.Eager),(0,w.$Is)(C.$Toc,C.$Soc,w.InstantiationType.Delayed),(0,w.$Is)(u.$Eoc,u.$Foc,w.InstantiationType.Eager),(0,w.$Is)(E.$Snc,E.$Rnc,w.InstantiationType.Eager),(0,w.$Is)(R.$7oc,R.$6oc,w.InstantiationType.Eager),(0,w.$Is)(c.$Vnc,c.$Ync,w.InstantiationType.Eager),(0,w.$Is)(y.$8oc,y.$9oc,w.InstantiationType.Eager),(0,w.$Is)(d.$2Eb,d.$3Eb,w.InstantiationType.Eager),(0,w.$Is)(o.$fpc,o.$epc,w.InstantiationType.Eager),(0,w.$Is)(P.$unc,P.$tnc,w.InstantiationType.Eager),(0,w.$Is)(i.$3nc,i.$2nc,w.InstantiationType.Eager),(0,w.$Is)(s.$MP,s.$JP,w.InstantiationType.Eager),(0,w.$Is)(n.$Jnc,n.$Knc,w.InstantiationType.Eager),(0,w.$Is)(f.$boc,f.$coc,w.InstantiationType.Eager)}),define(Ce[319],Ie([1,0,317,46,2,314,7,11,265]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=void 0;class c extends O.$kpc{j(){}getModule(E,d){for(const r of this.b){const o=r(E);if(o){E=o;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.$0nc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$src);const E=this.h.invokeFunction(w.$gpc);this.r=this.h.createInstance(c,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,r){d=d.with({path:v(d.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),s=`${d.toString(!0)}#vscode-extension`,n=`${i}
//# sourceURL=${s}`;let t;try{t=new Function("module","exports","require",n)}catch($){throw console.error(o?`Loading code for extension ${o} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const m={},f={exports:m},l=$=>{const I=this.r.getModule($,d);if(I===void 0)throw new Error(`Cannot load module '${$}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(f,m,l),f.exports!==m?f.exports:m}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,M.$Dh)(10)}}e.$trc=R;function v(u,E){return u.endsWith(E)?u:u+E}}),define(Ce[320],Ie([1,0,74,61,12,46,228,92,319]),function(oe,e,w,C,P,O,A,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Is)(P.$9j,new w.$zi(A.$jpc,[!0],!0)),(0,C.$Is)(O.$$nc,p.$trc,C.InstantiationType.Eager),(0,C.$Is)(M.$Anc,M.$Bnc,C.InstantiationType.Eager)}),define(Ce[328],Ie([1,0,23,4,84,315,267,20,65,16,2,318,320]),function(oe,e,w,C,P,O,A,M,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=n,M=qe(M),p=qe(p);const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function r(t){self.fetch=async function(m,f){return m instanceof Request||E(String(m))&&(m=(await t(R.URI.parse(String(m)))).toString(!0)),d(m,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,f,l,$,I){(async()=>(E(f.toString())&&(f=(await t(R.URI.parse(f.toString()))).toString(!0)),super.open(m,f,l??!0,$,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(m,f){if(/^file:/i.test(m.toString()))m=c.$Wg.uriToBrowserUri(R.URI.parse(m.toString())).toString(!0);else if(/^vscode-remote:/i.test(m.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(S){function k(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const g=fetch.bind(self);self.fetch=function(L,T){return L instanceof Request?g(L,T):g(k(L),T)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,T,q,G,W){return super.open(L,k(T),q??!0,G,W)}};const b=importScripts.bind(self);self.importScripts=(...L)=>{b(...L.map(k))},b(S)}.toString()}('${m}'))`;f=f||{},f.name=`${name} -> ${f.name||M.$oc(m.toString())}`;const I=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(I);return new t(D,f)}}else self.Worker=class extends A.$urc{constructor(t,m){super(u,t,{name:M.$oc(t.toString()),...m})}};const o=new class{constructor(){this.pid=void 0}exit(t){v()}};class a{constructor(){const m=new MessageChannel,f=new C.$je;let l=!1;u(m.port2,[m.port2]),m.port1.onmessage=$=>{const{data:I}=$;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=w.$Le.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.$wn)(D,P.MessageType.Terminate)){l=!0,i("received terminate message from renderer");return}f.fire(D)},this.protocol={onMessage:f.event,send:$=>{if(!l){const I=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);m.port1.postMessage(I,[I])}}}}}function h(t){return new Promise(m=>{const f=t.onMessage(l=>{f.dispose();const $=JSON.parse(l.toString());t.send((0,P.$vn)(P.MessageType.Initialized)),m({protocol:t,initData:$})});t.send((0,P.$vn)(P.MessageType.Ready))})}let i=t=>v();function s(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function n(){p.mark("code/extHost/willConnectToRenderer");const t=new a;return{onmessage(m){s(m)&&h(t.protocol).then(f=>{p.mark("code/extHost/didWaitForInitData");const l=new O.$mpc(f.protocol,f.initData,o,null,m.data);r($=>l.asBrowserUri($)),i=$=>l.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/6facfe23b300eb448c35d07291cad7ad98625302/core/vs/workbench/api/worker/extensionHostWorker.js.map
